var tipuesearch = {"pages": [
     {"title": "introduction", "text": "   <p><img src=\"castle_game_engine_icon.png\"   alt=\"Castle Game Engine icon\"   align=\"right\"/>  <p><i>Castle Game Engine</i> <a  href=\"https://castle-engine.sourceforge.io/\">https://castle-engine.sourceforge.io/</a> is a cool 3D and 2D open-source game engine for Object Pascal.  <p>This is the engine API reference. It lists all available units, classes, and documents everything.  <p>See our website for more documentation: </p>  <ul class=\"paragraph_spacing\">   <li><p>Getting started: <a  href=\"https://castle-engine.sourceforge.io/documentation.php\">https://castle-engine.sourceforge.io/documentation.php</a></p></li>   <li><p>Manual: <a  href=\"https://castle-engine.sourceforge.io/manual_intro.php\">https://castle-engine.sourceforge.io/manual_intro.php</a></p></li> </ul>  <p>  <p>Support the engine development on Patreon: <a  href=\"https://www.patreon.com/castleengine\">https://www.patreon.com/castleengine</a>  Introduction", "tags": "", "loc": "introduction.html"},
     {"title": "Castle2DSceneManager", "text": " ", "tags": "", "loc": "Castle2DSceneManager.html"},
     {"title": "Castle2DSceneManager.T2DSceneManager", "text": "  <p>Features:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>The default <b>camera position, direction, up</b> is suitable for 2D worlds that span horizontally in X, span vertically in Y, and are more-or-less flat around the Z = 0 plane.  <p>More precisely, the camera is positioned at the point <code>(0, 0, <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html#DefaultCameraZ\">DefaultCameraZ</a>)</code>, and looks along the -Z direction, with &quot;up&quot; vector in +Y. </p></li>   <li><p>The <b>camera does not give the user any automatic way to move in the world</b>. Because you typically want to code from scratch all your own movement for 2D.  <p>More precisely, the <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a> is <a class=\"normal\" href=\"CastleCameras.html#ntNone\">ntNone</a> by default. </p></li>   <li><p>Sets <b>2D projection</b>. By default our visible X range is <code>[0..scene manager width in pixels]</code>, visible Y is <code>[0..scene manager height in pixels]</code>. See the <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html#ProjectionOriginCenter\">ProjectionOriginCenter</a> for other options.  <p>Such projection is set regardless of the X3D viewpoint nodes present in the <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">MainScene</a>. This is in contrast to the ancestor <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>, that sets projection using a flexible algorithm that takes into account X3D viewpoint nodes, <a class=\"normal\" href=\"X3DNodes.TViewpointNode.html\">TViewpointNode</a>, in <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a>. </p></li>   <li><p>Sets Transparent = <code>True</code> by default, which means that <b>background underneath the scene manager is visible</b>. Useful for 2D games where you often have an image or another background underneath, like <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> or <a class=\"normal\" href=\"CastleControls.TCastleSimpleBackground.html\">TCastleSimpleBackground</a>. </p></li> </ul>  <p> ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html"},
     {"title": "Castle2DSceneManager.T2DSceneManager.DefaultProjectionSpan", "text": " ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#DefaultProjectionSpan"},
     {"title": "Castle2DSceneManager.T2DSceneManager.DefaultCameraZ", "text": " ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#DefaultCameraZ"},
     {"title": "Castle2DSceneManager.T2DSceneManager.CalculateProjection", "text": "    ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#CalculateProjection"},
     {"title": "Castle2DSceneManager.T2DSceneManager.Create", "text": "    ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#Create"},
     {"title": "Castle2DSceneManager.T2DSceneManager.AssignDefaultCamera", "text": "    ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#AssignDefaultCamera"},
     {"title": "Castle2DSceneManager.T2DSceneManager.ProjectionAutoSize", "text": " <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html#ProjectionHeight\">ProjectionHeight</a> and <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html#ProjectionWidth\">ProjectionWidth</a> are ignored then.  <p>When <code>ProjectionAutoSize</code> is <code>False</code>, <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html#ProjectionHeight\">ProjectionHeight</a> and <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html#ProjectionWidth\">ProjectionWidth</a> are used to determine the world visible in our viewport. If one of them is zero, the other is automatically adjusted to follow aspect ratio of viewport size. If both of them are zero, projection is automatically calculated just as if <code>ProjectionAutoSize</code> was <code>True</code>.  <p>In all cases, <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html#CurrentProjectionWidth\">CurrentProjectionWidth</a> and <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html#CurrentProjectionHeight\">CurrentProjectionHeight</a> can be checked to see actual projection dimensions. ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#ProjectionAutoSize"},
     {"title": "Castle2DSceneManager.T2DSceneManager.ProjectionHeight", "text": " ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#ProjectionHeight"},
     {"title": "Castle2DSceneManager.T2DSceneManager.ProjectionWidth", "text": " ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#ProjectionWidth"},
     {"title": "Castle2DSceneManager.T2DSceneManager.CurrentProjectionWidth", "text": " ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#CurrentProjectionWidth"},
     {"title": "Castle2DSceneManager.T2DSceneManager.CurrentProjectionHeight", "text": " ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#CurrentProjectionHeight"},
     {"title": "Castle2DSceneManager.T2DSceneManager.ProjectionSpan", "text": "  <p>Higher values allow to see more. The objects are visible in Z range <code>[Camera.Position.Z - <code>ProjectionSpan</code> .. Camera.Position.Z + <code>ProjectionSpan</code>]</code>.  <p>Lower values improve depth buffer precision. ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#ProjectionSpan"},
     {"title": "Castle2DSceneManager.T2DSceneManager.ProjectionOriginCenter", "text": "  <p>If <code>False</code>, the (0,0) is in the left-bottom corner, which matches the typical 2D drawing coordinates used throughout our engine. In other words, if the camera is at position (0,0,whatever), then the (0,0) position in 2D is in the left-bottom corner of the scene manager rectangle.  <p>If <code>True</code>, the (0,0) is in the middle of the viewport. In other words, if the camera is at position (0,0,whatever), then the (0,0) position is in the center of the scene manager rectangle.  <p>Both values of <code>ProjectionOriginCenter</code> make sense, it depends on the game type and how you prefer to think in 2D coordinates. And how do you want the result to behave when aspect ratio changes:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>With <code>ProjectionOriginCenter</code> = <code>True</code>, things will stay &quot;glued&quot; to the center.</p></li>   <li><p>With <code>ProjectionOriginCenter</code> = <code>False</code>, things will stay &quot;glued&quot; to the left-bottom corner.</p></li> </ul>  <p> ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#ProjectionOriginCenter"},
     {"title": "Castle2DSceneManager.T2DSceneManager.Transparent", "text": " ", "tags": "", "loc": "Castle2DSceneManager.T2DSceneManager.html#Transparent"},
     {"title": "Castle2DSceneManager.T2DScene", "text": " Sets BlendingSort := <a class=\"normal\" href=\"CastleScene.html#bs2D\">bs2D</a>, good when your transparent objects have proper order along the Z axis (useful e.g. for Spine animations). ", "tags": "", "loc": "Castle2DSceneManager.T2DScene.html"},
     {"title": "Castle2DSceneManager.T2DScene.Create", "text": "    ", "tags": "", "loc": "Castle2DSceneManager.T2DScene.html#Create"},
     {"title": "Castle2DSceneManager.T2DScene.Clone", "text": " Note that this <b>does not copy other scene attributes</b>, like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">ProcessEvents</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">Spatial</a> or rendering attributes in <a class=\"normal\" href=\"CastleScene.TCastleScene.html#Attributes\">Attributes</a>.    ", "tags": "", "loc": "Castle2DSceneManager.T2DScene.html#Clone"},
     {"title": "Castle3D", "text": " ", "tags": "", "loc": "Castle3D.html"},
     {"title": "Castle3D.T3DOrient", "text": " ", "tags": "", "loc": "Castle3D.T3DOrient.html"},
     {"title": "Castle3D.T3DOrient.ChangedTransform", "text": "    ", "tags": "", "loc": "Castle3D.T3DOrient.html#ChangedTransform"},
     {"title": "Castle3D.T3DOrient.Update", "text": "    ", "tags": "", "loc": "Castle3D.T3DOrient.html#Update"},
     {"title": "Castle3D.T3DOrient.Create", "text": "    ", "tags": "", "loc": "Castle3D.T3DOrient.html#Create"},
     {"title": "Castle3D.T3DOrient.Camera", "text": " ", "tags": "", "loc": "Castle3D.T3DOrient.html#Camera"},
     {"title": "Castle3D.T3DMoving", "text": " Good for elevators, doors and such.  <p>Other 3D objects may be pushed, if <a class=\"normal\" href=\"Castle3D.T3DMoving.html#Pushes\">Pushes</a>. There are two methods of pushing available, see <a class=\"normal\" href=\"Castle3D.T3DMoving.html#PushesEverythingInside\">PushesEverythingInside</a>. Only the 3D objects with <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#CollidesWithMoving\">TCastleTransform.CollidesWithMoving</a> are ever pushed by this object (the rest of 3D world is treated as static, does not interact with elevators / doors or such).  <p>You can also stop/reverse the move to prevent some collisions from occuring at all. This way you can e.g. prevent the door from automatically closing, if someone/something blocks the way. You do this by overriding <a class=\"normal\" href=\"Castle3D.T3DMoving.html#BeforeTimeIncrease\">BeforeTimeIncrease</a>. See TDoomLevelDoor.BeforeTimeIncrease in &quot;The Castle&quot; for example how to do this. ", "tags": "", "loc": "Castle3D.T3DMoving.html"},
     {"title": "Castle3D.T3DMoving.GetTranslationFromTime", "text": "    ", "tags": "", "loc": "Castle3D.T3DMoving.html#GetTranslationFromTime"},
     {"title": "Castle3D.T3DMoving.BeforeTimeIncrease", "text": " Called at the beginning of our <a class=\"normal\" href=\"Castle3D.T3DMoving.html#Update\">Update</a>, <i>right before</i> <a class=\"normal\" href=\"Castle3D.T3DMoving.html#AnimationTime\">AnimationTime</a> changes to NewAnimationTime.  <p>Useful for taking care of collision detection issues, as our assumption always is that &quot;nothing collides&quot;. Which means that if you don't want your <a class=\"normal\" href=\"Castle3D.T3DMoving.html\">T3DMoving</a> to collide with e.g. player or creatures or items, then you should prevent the collision <i>before it happens</i>. This is the place to do it.    ", "tags": "", "loc": "Castle3D.T3DMoving.html#BeforeTimeIncrease"},
     {"title": "Castle3D.T3DMoving.Create", "text": "    ", "tags": "", "loc": "Castle3D.T3DMoving.html#Create"},
     {"title": "Castle3D.T3DMoving.Update", "text": "    ", "tags": "", "loc": "Castle3D.T3DMoving.html#Update"},
     {"title": "Castle3D.T3DMoving.AnimationTime", "text": " ", "tags": "", "loc": "Castle3D.T3DMoving.html#AnimationTime"},
     {"title": "Castle3D.T3DMoving.Pushes", "text": " Only the 3D objects with <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#CollidesWithMoving\">TCastleTransform.CollidesWithMoving</a> are ever pushed by this object (the rest of 3D world is treated as static, does not interact with elevators / doors or such).  <p>Only relevant if <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetCollides\">GetCollides</a>. Non-colliding objects never push others. ", "tags": "", "loc": "Castle3D.T3DMoving.html#Pushes"},
     {"title": "Castle3D.T3DMoving.PushesEverythingInside", "text": " There two methods:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><code>PushesEverythingInside</code> = <code>True</code>: We move every 3D object that is inside our bounding box and has <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#CollidesWithMoving\">CollidesWithMoving</a>=<code>True</code>. This is sensible if we can reasonably assume that things inside our box are standing. For example if this is a (vertical or horizontal) elevator, then creatures/items are usually standing/lying inside, and naturally move with the same speed (and direction) as the elevator.</p></li>   <li value=\"2\"><p>When <code>PushesEverythingInside</code> = <code>False</code>: We check precise collision between 3D objects with <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#CollidesWithMoving\">CollidesWithMoving</a>=<code>True</code> and our triangle mesh. We use <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#BoxCollision\">TCastleTransform.BoxCollision</a> / TCastleTransform.SphereCollsion that can check collisions with <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> precisely.</p></li> </ol>  <p>  <p>Neither method is really perfect.  <p><code>PushesEverythingInside</code> = <code>False</code> seems like a more precise check, as it actually compares the triangle mesh, taking into account the interior of (this) moving 3D object. <code>PushesEverythingInside</code> = <code>True</code> just approximates the moving 3D object by it's bounding box.  <p>On the other hand, <code>PushesEverythingInside</code> = <code>True</code> makes the elevator more &quot;sticky&quot;. With <code>PushesEverythingInside</code> = <code>False</code>, when player hits the floor, it takes them some time to raise up. This creates a &quot;bouncing camera&quot; effect when the elevator goes up quickly: player constantly falls to the ground, tries to get up, but elevator moves up and player falls to it's ground again. When the elevator goes down, the player/creature constantly falls down on it because of gravity, which again causes artifacts as gravity may work significantly slower/faster than elavator moving speed. When the elevator is a horizontal moving platform, it will &quot;slip&quot; from under the player/creature, leaving the poor fella suddenly hanging in the air, and falling down because of gravity in the next second.  <p>In practice: <code>PushesEverythingInside</code> should be <code>True</code> for small containers, when you can reasonably assume that things (creatures, player, items) stand inside, and when you intend to use it for transport of 3D stuff. For very large moving stuff, that possibly interacts with flying players/creatures in some creative way, <code>PushesEverythingInside</code> may be <code>False</code>. ", "tags": "", "loc": "Castle3D.T3DMoving.html#PushesEverythingInside"},
     {"title": "Castle3D.T3DLinearMoving", "text": " Moves with a constant speed from (0, 0, 0) to <a class=\"normal\" href=\"Castle3D.T3DLinearMoving.html#TranslationEnd\">TranslationEnd</a>. They are called <i>begin position</i> and <i>end position</i>.  <p>This is a simplified, more comfortable descendant of <a class=\"normal\" href=\"Castle3D.T3DMoving.html\">T3DMoving</a>. You get easy to use <a class=\"normal\" href=\"Castle3D.T3DLinearMoving.html#GoBeginPosition\">GoBeginPosition</a>, <a class=\"normal\" href=\"Castle3D.T3DLinearMoving.html#GoEndPosition\">GoEndPosition</a> properties, you can easily set sounds by <a class=\"normal\" href=\"Castle3D.T3DLinearMoving.html#SoundGoBeginPosition\">SoundGoBeginPosition</a> and <a class=\"normal\" href=\"Castle3D.T3DLinearMoving.html#SoundGoEndPosition\">SoundGoEndPosition</a> and such. ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html"},
     {"title": "Castle3D.T3DLinearMoving.MoveTime", "text": " ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#MoveTime"},
     {"title": "Castle3D.T3DLinearMoving.TranslationEnd", "text": " ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#TranslationEnd"},
     {"title": "Castle3D.T3DLinearMoving.Create", "text": "    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#Create"},
     {"title": "Castle3D.T3DLinearMoving.Destroy", "text": "    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#Destroy"},
     {"title": "Castle3D.T3DLinearMoving.CompletelyEndPosition", "text": "    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#CompletelyEndPosition"},
     {"title": "Castle3D.T3DLinearMoving.CompletelyBeginPosition", "text": "    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#CompletelyBeginPosition"},
     {"title": "Castle3D.T3DLinearMoving.GoBeginPosition", "text": " CompletelyEndPosion).    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#GoBeginPosition"},
     {"title": "Castle3D.T3DLinearMoving.GoEndPosition", "text": " CompletelyBeginPosion).    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#GoEndPosition"},
     {"title": "Castle3D.T3DLinearMoving.RevertGoEndPosition", "text": " Call this only when currently <a class=\"normal\" href=\"Castle3D.T3DLinearMoving.html#EndPosition\">EndPosition</a> is <code>False</code> and we were in the middle of going to <i>begin position</i>.  <p>As an example, this is what happens when door on DOOM level gets blocked. In the middle of closing (which ig going to <i>begin position</i>) it will realize that something blocks it, and open back (go back to <i>end position</i>).    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#RevertGoEndPosition"},
     {"title": "Castle3D.T3DLinearMoving.RevertGoBeginPosition", "text": "    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#RevertGoBeginPosition"},
     {"title": "Castle3D.T3DLinearMoving.GoOtherPosition", "text": " Which means that if we're completely in <i>end position</i> or in the middle of move to <i>end position</i>, this goes back to <i>begin position</i>. And if we're in <i>begin position</i>, this goes back to <i>end position</i>.    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#GoOtherPosition"},
     {"title": "Castle3D.T3DLinearMoving.GetTranslationFromTime", "text": "    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#GetTranslationFromTime"},
     {"title": "Castle3D.T3DLinearMoving.Update", "text": "    ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#Update"},
     {"title": "Castle3D.T3DLinearMoving.EndPosition", "text": " If <code>False</code>, then this object is in <i>begin position</i> or going to it. See also CompletelyEndPosion and <a class=\"normal\" href=\"Castle3D.T3DLinearMoving.html#CompletelyBeginPosition\">CompletelyBeginPosition</a>.  <p>Initially this is <code>False</code>, and <a class=\"normal\" href=\"Castle3D.T3DLinearMoving.html#EndPositionStateChangeTime\">EndPositionStateChangeTime</a> is set such that we're sure that we're in CompletelyBeginPosion, ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#EndPosition"},
     {"title": "Castle3D.T3DLinearMoving.EndPositionStateChangeTime", "text": " ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#EndPositionStateChangeTime"},
     {"title": "Castle3D.T3DLinearMoving.SoundGoBeginPosition", "text": " ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#SoundGoBeginPosition"},
     {"title": "Castle3D.T3DLinearMoving.SoundGoEndPosition", "text": " ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#SoundGoEndPosition"},
     {"title": "Castle3D.T3DLinearMoving.SoundGoBeginPositionLooping", "text": " ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#SoundGoBeginPositionLooping"},
     {"title": "Castle3D.T3DLinearMoving.SoundGoEndPositionLooping", "text": " ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#SoundGoEndPositionLooping"},
     {"title": "Castle3D.T3DLinearMoving.SoundTracksCurrentPosition", "text": "  <p>Otherwise (default) sound is initially made at initial 3D position of this object, and then the sound position doesn't change (even if the position of the object changes). ", "tags": "", "loc": "Castle3D.T3DLinearMoving.html#SoundTracksCurrentPosition"},
     {"title": "Castle3D.TAlive", "text": " Basis for players, creatures and everything else that has some position, direction and that can be killed.  <p>Note that the <code>TAlive</code> doesn't remove dead objects, doesn't make any dead animations or such. <code>TAlive</code> class merely keeps track of <a class=\"normal\" href=\"Castle3D.TAlive.html#Life\">Life</a>, <a class=\"normal\" href=\"Castle3D.TAlive.html#Dead\">Dead</a> and such properties, and allows you to call <a class=\"normal\" href=\"Castle3D.TAlive.html#Hurt\">Hurt</a> doing eventual knockback. If your own code doesn't call <a class=\"normal\" href=\"Castle3D.TAlive.html#Hurt\">Hurt</a>, or even doesn't look at <a class=\"normal\" href=\"Castle3D.TAlive.html#Life\">Life</a> value, then they have no implication for given 3D object, so it may be indestructible just like other 3D objects. ", "tags": "", "loc": "Castle3D.TAlive.html"},
     {"title": "Castle3D.TAlive.DefaultKnockBackSpeed", "text": " ", "tags": "", "loc": "Castle3D.TAlive.html#DefaultKnockBackSpeed"},
     {"title": "Castle3D.TAlive.SetLife", "text": "    ", "tags": "", "loc": "Castle3D.TAlive.html#SetLife"},
     {"title": "Castle3D.TAlive.CancelKnockback", "text": "    ", "tags": "", "loc": "Castle3D.TAlive.html#CancelKnockback"},
     {"title": "Castle3D.TAlive.Create", "text": "    ", "tags": "", "loc": "Castle3D.TAlive.html#Create"},
     {"title": "Castle3D.TAlive.Dead", "text": "    ", "tags": "", "loc": "Castle3D.TAlive.html#Dead"},
     {"title": "Castle3D.TAlive.Hurt", "text": " If all you want to do is to decrease Life, you can also just set <a class=\"normal\" href=\"Castle3D.TAlive.html#Life\">Life</a> property. Unless your code depends on <a class=\"normal\" href=\"Castle3D.TAlive.html#LastHurtDirection\">LastHurtDirection</a> being always updated (only <a class=\"normal\" href=\"CastleCreatures.TCreature.html\">TCreature</a> in <a class=\"normal\" href=\"CastleCreatures.html\">CastleCreatures</a> unit depends on it now).  <p>HurtDirection should be a normalized vector indicating direction in which the attack came.  <p>AKnockbackDistance, if non-zero, indicates to push creature by given length in the direction given by HurtDirection. Ignored if HurtDirection is zero.  <p>Attacker is the other alive creature that caused this damage. It may be <code>Nil</code> if no other <a class=\"normal\" href=\"Castle3D.TAlive.html\">TAlive</a> is directly responsible for this damage. This may be useful for various purposes, for example the victim may become aware of attacker presence when it's attacked.    ", "tags": "", "loc": "Castle3D.TAlive.html#Hurt"},
     {"title": "Castle3D.TAlive.Update", "text": "    ", "tags": "", "loc": "Castle3D.TAlive.html#Update"},
     {"title": "Castle3D.TAlive.LastHurtDirection", "text": " Zero if there was no specific direction of last attack, otherwise a normalized (length 1) vector. ", "tags": "", "loc": "Castle3D.TAlive.html#LastHurtDirection"},
     {"title": "Castle3D.TAlive.LifeTime", "text": " ", "tags": "", "loc": "Castle3D.TAlive.html#LifeTime"},
     {"title": "Castle3D.TAlive.DieTime", "text": " ", "tags": "", "loc": "Castle3D.TAlive.html#DieTime"},
     {"title": "Castle3D.TAlive.Life", "text": " We're dead when this is &lt;= 0. ", "tags": "", "loc": "Castle3D.TAlive.html#Life"},
     {"title": "Castle3D.TAlive.MaxLife", "text": " Used as default value for Life when sensible. Can be also used for information (to display on player HUDs and such).  <p>It's not really a limit, that is you can set Life to something larger than <code>MaxLife</code> if you want. It's normal in some games, where you can get some &quot;magic life boost&quot; that makes your health temporarily larger than normal. Whether it's sensible in your game (and whether your HUD will display it sensibly) is up to you. ", "tags": "", "loc": "Castle3D.TAlive.html#MaxLife"},
     {"title": "Castle3D.TAlive.KnockBackSpeed", "text": " ", "tags": "", "loc": "Castle3D.TAlive.html#KnockBackSpeed"},
     {"title": "Castle3D.MaxSingle", "text": " ", "tags": "", "loc": "Castle3D.html#MaxSingle"},
     {"title": "Castle3D.DefaultFallMinHeightToDamage", "text": "  <p>Note that FallMinHeightToSound is usually better to be larger for player, to avoid making &quot;fall&quot; sound when player merely jumps or walks down a steep hill. No such need for creature.  <p> ", "tags": "", "loc": "Castle3D.html#DefaultFallMinHeightToDamage"},
     {"title": "Castle3D.DefaultFallDamageScaleMin", "text": " ", "tags": "", "loc": "Castle3D.html#DefaultFallDamageScaleMin"},
     {"title": "Castle3D.DefaultFallDamageScaleMax", "text": " ", "tags": "", "loc": "Castle3D.html#DefaultFallDamageScaleMax"},
     {"title": "Castle3D.DefaultCreatureFallMinHeightToSound", "text": " ", "tags": "", "loc": "Castle3D.html#DefaultCreatureFallMinHeightToSound"},
     {"title": "Castle3D.DefaultPlayerFallMinHeightToSound", "text": " ", "tags": "", "loc": "Castle3D.html#DefaultPlayerFallMinHeightToSound"},
     {"title": "Castle3D.DefaultCreatureFallSoundName", "text": " ", "tags": "", "loc": "Castle3D.html#DefaultCreatureFallSoundName"},
     {"title": "Castle3D.DefaultPlayerFallSoundName", "text": " ", "tags": "", "loc": "Castle3D.html#DefaultPlayerFallSoundName"},
     {"title": "Castle3D.vcVisibleGeometry", "text": " ", "tags": "", "loc": "Castle3D.html#vcVisibleGeometry"},
     {"title": "Castle3D.vcVisibleNonGeometry", "text": " ", "tags": "", "loc": "Castle3D.html#vcVisibleNonGeometry"},
     {"title": "Castle3D.prShadowVolume", "text": " ", "tags": "", "loc": "Castle3D.html#prShadowVolume"},
     {"title": "Castle3D.prSpatial", "text": " ", "tags": "", "loc": "Castle3D.html#prSpatial"},
     {"title": "Castle3D.prScreenEffects", "text": " ", "tags": "", "loc": "Castle3D.html#prScreenEffects"},
     {"title": "Castle3D.prRender", "text": " ", "tags": "", "loc": "Castle3D.html#prRender"},
     {"title": "Castle3D.prBackground", "text": " ", "tags": "", "loc": "Castle3D.html#prBackground"},
     {"title": "Castle3D.prBoundingBox", "text": " ", "tags": "", "loc": "Castle3D.html#prBoundingBox"},
     {"title": "Castle3D.rtNone", "text": " ", "tags": "", "loc": "Castle3D.html#rtNone"},
     {"title": "Castle3D.rtRemove", "text": " ", "tags": "", "loc": "Castle3D.html#rtRemove"},
     {"title": "Castle3D.rtRemoveAndFree", "text": " ", "tags": "", "loc": "Castle3D.html#rtRemoveAndFree"},
     {"title": "Castle3D.otUpYDirectionMinusZ", "text": " ", "tags": "", "loc": "Castle3D.html#otUpYDirectionMinusZ"},
     {"title": "Castle3D.otUpZDirectionMinusY", "text": " ", "tags": "", "loc": "Castle3D.html#otUpZDirectionMinusY"},
     {"title": "Castle3D.otUpZDirectionX", "text": " ", "tags": "", "loc": "Castle3D.html#otUpZDirectionX"},
     {"title": "Castle3D.T3D", "text": " ", "tags": "", "loc": "Castle3D.html#T3D"},
     {"title": "Castle3D.T3DList", "text": " ", "tags": "", "loc": "Castle3D.html#T3DList"},
     {"title": "Castle3D.T3DCustomTranslated", "text": " ", "tags": "", "loc": "Castle3D.html#T3DCustomTranslated"},
     {"title": "Castle3D.T3DTranslated", "text": " ", "tags": "", "loc": "Castle3D.html#T3DTranslated"},
     {"title": "Castle3D.T3DCustomTransform", "text": " ", "tags": "", "loc": "Castle3D.html#T3DCustomTransform"},
     {"title": "Castle3D.T3DTransform", "text": " ", "tags": "", "loc": "Castle3D.html#T3DTransform"},
     {"title": "Castle3D.T3DListCore", "text": " ", "tags": "", "loc": "Castle3D.html#T3DListCore"},
     {"title": "Castle3D.T3DWorld", "text": " ", "tags": "", "loc": "Castle3D.html#T3DWorld"},
     {"title": "Castle3D.TCollisionDetails", "text": " ", "tags": "", "loc": "Castle3D.html#TCollisionDetails"},
     {"title": "Castle3D.TRayCollision", "text": " ", "tags": "", "loc": "Castle3D.html#TRayCollision"},
     {"title": "Castle3D.TRayCollisionNode", "text": " ", "tags": "", "loc": "Castle3D.html#TRayCollisionNode"},
     {"title": "Castle3D.PRayCollisionNode", "text": " ", "tags": "", "loc": "Castle3D.html#PRayCollisionNode"},
     {"title": "Castle3D.TRemoveType", "text": " ", "tags": "", "loc": "Castle3D.html#TRemoveType"},
     {"title": "Castle3D.TPrepareResourcesOption", "text": " ", "tags": "", "loc": "Castle3D.html#TPrepareResourcesOption"},
     {"title": "Castle3D.TPrepareResourcesOptions", "text": " ", "tags": "", "loc": "Castle3D.html#TPrepareResourcesOptions"},
     {"title": "Castle3D.TAbstractLightInstancesList", "text": " ", "tags": "", "loc": "Castle3D.html#TAbstractLightInstancesList"},
     {"title": "Castle3D.TRenderFromViewFunction", "text": " ", "tags": "", "loc": "Castle3D.html#TRenderFromViewFunction"},
     {"title": "Castle3D.TRenderingPass", "text": " ", "tags": "", "loc": "Castle3D.html#TRenderingPass"},
     {"title": "Castle3D.TRenderParams", "text": " ", "tags": "", "loc": "Castle3D.html#TRenderParams"},
     {"title": "Castle3D.TBaseShadowVolumeRenderer", "text": " ", "tags": "", "loc": "Castle3D.html#TBaseShadowVolumeRenderer"},
     {"title": "Castle3D.TVisibleChange", "text": " ", "tags": "", "loc": "Castle3D.html#TVisibleChange"},
     {"title": "Castle3D.TVisibleChanges", "text": " ", "tags": "", "loc": "Castle3D.html#TVisibleChanges"},
     {"title": "Castle3D.TRenderStatistics", "text": " ", "tags": "", "loc": "Castle3D.html#TRenderStatistics"},
     {"title": "Castle3D.TRigidBody", "text": " ", "tags": "", "loc": "Castle3D.html#TRigidBody"},
     {"title": "Castle3D.TCollider", "text": " ", "tags": "", "loc": "Castle3D.html#TCollider"},
     {"title": "Castle3D.TSphereCollider", "text": " ", "tags": "", "loc": "Castle3D.html#TSphereCollider"},
     {"title": "Castle3D.TBoxCollider", "text": " ", "tags": "", "loc": "Castle3D.html#TBoxCollider"},
     {"title": "Castle3D.TPlaneCollider", "text": " ", "tags": "", "loc": "Castle3D.html#TPlaneCollider"},
     {"title": "Castle3D.T3DAlive", "text": " ", "tags": "", "loc": "Castle3D.html#T3DAlive"},
     {"title": "Castle3D.T3DExistsEvent", "text": "    ", "tags": "", "loc": "Castle3D.html#T3DExistsEvent"},
     {"title": "Castle3D.RenderDebug3D", "text": "  ", "tags": "", "loc": "Castle3D.html#RenderDebug3D"},
     {"title": "Castle3D.RenderDebugCaptions", "text": " ", "tags": "", "loc": "Castle3D.html#RenderDebugCaptions"},
     {"title": "Castle3D.LogShadowVolumes", "text": "  <p>Meaningful only if you initialized log (see <a class=\"normal\" href=\"CastleLog.html\">CastleLog</a> unit) by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a> first. ", "tags": "", "loc": "Castle3D.html#LogShadowVolumes"},
     {"title": "CastleAds", "text": " ", "tags": "", "loc": "CastleAds.html"},
     {"title": "CastleAds.TAds", "text": " Right now only on Android (does nothing on other platforms, as <a class=\"normal\" href=\"CastleMessaging.html\">CastleMessaging</a> does nothing on non-Android platforms).  <p>Usage:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Create an instance of this class (only a single instance allowed).</p></li>   <li value=\"2\"><p>Initialize at least one ad network using one of the <code>InitializeXxx</code> methods. Usually you want to call the initialization from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>.</p></li>   <li value=\"3\"><p>Use remaining methods of this class to show / hide ads, like <a class=\"normal\" href=\"CastleAds.TAds.html#ShowFullScreenAd\">ShowFullScreenAd</a>, <a class=\"normal\" href=\"CastleAds.TAds.html#ShowBanner\">ShowBanner</a>, <a class=\"normal\" href=\"CastleAds.TAds.html#HideBanner\">HideBanner</a>.</p></li>   <li value=\"4\"><p>To include the necessary integration code in your Android project, declare your Android project type as &quot;integrated&quot; with the appropriate services (admob, chartboost, startapp, heyzap...) inside CastleEngineManifest.xml . See <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> .</p></li> </ol>  <p> ", "tags": "", "loc": "CastleAds.TAds.html"},
     {"title": "CastleAds.TAds.FullScreenAdClosed", "text": "    ", "tags": "", "loc": "CastleAds.TAds.html#FullScreenAdClosed"},
     {"title": "CastleAds.TAds.Create", "text": "    ", "tags": "", "loc": "CastleAds.TAds.html#Create"},
     {"title": "CastleAds.TAds.Destroy", "text": "    ", "tags": "", "loc": "CastleAds.TAds.html#Destroy"},
     {"title": "CastleAds.TAds.InitializeAdMob", "text": " You need to create the unit ids on AdMob website (or use <a class=\"normal\" href=\"CastleAds.html#TestAdMobBannerUnitId\">TestAdMobBannerUnitId</a>, <a class=\"normal\" href=\"CastleAds.html#TestAdMobInterstitialUnitId\">TestAdMobInterstitialUnitId</a> for testing).  <p>TestDeviceIds may be empty, or it may contain a list of devices where you always want to see test ads &mdash; even with real (non-test) ad units. This is useful when you test ads in your application (with real ad units, on a real phone). Paste here the list of your devices (see <a  href=\"https://developers.google.com/mobile-ads-sdk/docs/admob/android/quick-start\">https://developers.google.com/mobile-ads-sdk/docs/admob/android/quick-start</a> , you can see your device ids in &quot;adb logcat&quot; output) in order to avoid getting banned for clicking on your own ads.  <p>Usually called from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>.    ", "tags": "", "loc": "CastleAds.TAds.html#InitializeAdMob"},
     {"title": "CastleAds.TAds.InitializeStartapp", "text": " You need to register your game on <a  href=\"http://startapp.com/\">http://startapp.com/</a> to get app id.  <p>Usually called from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>.    ", "tags": "", "loc": "CastleAds.TAds.html#InitializeStartapp"},
     {"title": "CastleAds.TAds.InitializeChartboost", "text": " You need to register your game on <a  href=\"http://chartboost.com/\">http://chartboost.com/</a> to get app id and signature.  <p>Usually called from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>.    ", "tags": "", "loc": "CastleAds.TAds.html#InitializeChartboost"},
     {"title": "CastleAds.TAds.InitializeHeyzap", "text": " You need to register your game on <a  href=\"https://www.heyzap.com/\">https://www.heyzap.com/</a> to get publisher id.  <p>Usually called from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>.    ", "tags": "", "loc": "CastleAds.TAds.html#InitializeHeyzap"},
     {"title": "CastleAds.TAds.ShowFullScreenAd", "text": "  <p>Not all ad networks support (or differentiate between) all full-screen ad types possible in <a class=\"normal\" href=\"CastleAds.html#TFullScreenAdType\">TFullScreenAdType</a> enumeration. So we eventually show other sensible ad type instead.  <p>If WaitUntilLoaded, then we wait until the ad contents are fetched (be sure to show some &quot;loading&quot; state to user, as it may take a while in case of a slow network). If not WaitUntilLoaded, then we immediately resign if ad is not loaded yet. Not all ad implementations support this setting reliably, so this is only a suggestion.  <p>In any case, after this method is called, we make sure to call callback <a class=\"normal\" href=\"CastleAds.TAds.html#OnFullScreenAdClosed\">OnFullScreenAdClosed</a> sometime.    ", "tags": "", "loc": "CastleAds.TAds.html#ShowFullScreenAd"},
     {"title": "CastleAds.TAds.ShowBanner", "text": " Banners are not supported by all ad networks (only AdMob and Heyzap now), in case they are unsupported this call is silently ignored.    ", "tags": "", "loc": "CastleAds.TAds.html#ShowBanner"},
     {"title": "CastleAds.TAds.HideBanner", "text": " Banners are not supported by all ad networks (only AdMob and Heyzap now), in case they are unsupported this call is silently ignored.    ", "tags": "", "loc": "CastleAds.TAds.html#HideBanner"},
     {"title": "CastleAds.TAds.StartTestActivity", "text": " This is for now supported only by <a class=\"normal\" href=\"CastleAds.html#anHeyzap\">anHeyzap</a>.    ", "tags": "", "loc": "CastleAds.TAds.html#StartTestActivity"},
     {"title": "CastleAds.TAds.OnFullScreenAdClosed", "text": " ", "tags": "", "loc": "CastleAds.TAds.html#OnFullScreenAdClosed"},
     {"title": "CastleAds.TAds.BannerSize", "text": " ", "tags": "", "loc": "CastleAds.TAds.html#BannerSize"},
     {"title": "CastleAds.TestAdMobBannerUnitId", "text": " You can use it with <a class=\"normal\" href=\"CastleAds.TAds.html#InitializeAdMob\">TAds.InitializeAdMob</a> for testing purposes (but eventually you want to create your own, to show non-testing ads!).  <p>From <a  href=\"https://developers.google.com/mobile-ads-sdk/docs/admob/android/quick-start\">https://developers.google.com/mobile-ads-sdk/docs/admob/android/quick-start</a> ", "tags": "", "loc": "CastleAds.html#TestAdMobBannerUnitId"},
     {"title": "CastleAds.TestAdMobInterstitialUnitId", "text": " You can use it with <a class=\"normal\" href=\"CastleAds.TAds.html#InitializeAdMob\">TAds.InitializeAdMob</a> for testing purposes (but eventually you want to create your own, to show non-testing ads!).  <p>From <a  href=\"http://stackoverflow.com/questions/12553929/is-there-any-admob-dummy-id\">http://stackoverflow.com/questions/12553929/is-there-any-admob-dummy-id</a> and <a  href=\"https://github.com/googleads/googleads-mobile-android-examples/blob/master/admob/InterstitialExample/app/src/main/res/values/strings.xml\">https://github.com/googleads/googleads-mobile-android-examples/blob/master/admob/InterstitialExample/app/src/main/res/values/strings.xml</a> ", "tags": "", "loc": "CastleAds.html#TestAdMobInterstitialUnitId"},
     {"title": "CastleAds.TAdNetwork", "text": "  anAdMob    anChartboost    anStartApp    anHeyzap   ", "tags": "", "loc": "CastleAds.html#TAdNetwork"},
     {"title": "CastleAds.TFullScreenAdType", "text": "  atInterstitialStatic    atInterstitialVideo    atReward   ", "tags": "", "loc": "CastleAds.html#TFullScreenAdType"},
     {"title": "CastleAds.TAdClosedEvent", "text": "    ", "tags": "", "loc": "CastleAds.html#TAdClosedEvent"},
     {"title": "CastleAnalytics", "text": " ", "tags": "", "loc": "CastleAnalytics.html"},
     {"title": "CastleAnalytics.TAnalytics", "text": "  <p>On Android or iOS. You will need to also add appropriate &quot;service&quot; to your application, like <code>game_analytics</code> or <code>google_analytics</code> to have the integration code automatically included. See Android services ( <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> ) and iOS services ( <a  href=\"https://github.com/castle-engine/castle-engine/wiki/iOS-Services\">https://github.com/castle-engine/castle-engine/wiki/iOS-Services</a> ) and CastleEngineManifest.xml docs ( <a  href=\"https://github.com/castle-engine/castle-engine/wiki/CastleEngineManifest.xml-examples\">https://github.com/castle-engine/castle-engine/wiki/CastleEngineManifest.xml-examples</a> ).  <p>Usage:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Create an instance of this class (only a single instance allowed).</p></li>   <li value=\"2\"><p>Initialize at least one analytics backend using the <a class=\"normal\" href=\"CastleAnalytics.TAnalytics.html#InitializeGoogleAnalytics\">InitializeGoogleAnalytics</a> or <a class=\"normal\" href=\"CastleAnalytics.TAnalytics.html#InitializeGameAnalytics\">InitializeGameAnalytics</a> method.</p></li>   <li value=\"3\"><p>Use the remaining methods, like <a class=\"normal\" href=\"CastleAnalytics.TAnalytics.html#Event\">Event</a>, to report events in your app.</p></li> </ol>  <p> ", "tags": "", "loc": "CastleAnalytics.TAnalytics.html"},
     {"title": "CastleAnalytics.TAnalytics.Create", "text": "    ", "tags": "", "loc": "CastleAnalytics.TAnalytics.html#Create"},
     {"title": "CastleAnalytics.TAnalytics.Destroy", "text": "    ", "tags": "", "loc": "CastleAnalytics.TAnalytics.html#Destroy"},
     {"title": "CastleAnalytics.TAnalytics.InitializeGoogleAnalytics", "text": " Usually called from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>.    ", "tags": "", "loc": "CastleAnalytics.TAnalytics.html#InitializeGoogleAnalytics"},
     {"title": "CastleAnalytics.TAnalytics.InitializeGameAnalytics", "text": " Usually called from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>.    ", "tags": "", "loc": "CastleAnalytics.TAnalytics.html#InitializeGameAnalytics"},
     {"title": "CastleAnalytics.TAnalytics.ScreenView", "text": " when user switches between UI states.  <p>    EInvalidChar If the screen name contains invalid characters. Use only ASCII letters, digits, hyphens, underscores.", "tags": "", "loc": "CastleAnalytics.TAnalytics.html#ScreenView"},
     {"title": "CastleAnalytics.TAnalytics.Event", "text": "  <p>    EInvalidChar If some string contains invalid characters. Use only ASCII letters, digits, hyphens, underscores for the category and other strings.", "tags": "", "loc": "CastleAnalytics.TAnalytics.html#Event"},
     {"title": "CastleAnalytics.TAnalytics.Event", "text": " DimensionIndex must be &gt; 0.  <p>See <a  href=\"https://developers.google.com/analytics/devguides/collection/android/v4/customdimsmets#overview\">https://developers.google.com/analytics/devguides/collection/android/v4/customdimsmets#overview</a> about what is a custom dimension for Google Analytics (you need to create the dimension index first in Google Analytics console).  <p>For Game Analytics, this is just used as an extra subcategory. Do not create too many different DimensionIndex + DimensionValue combinations, as each combination creates a new unique event id, and these are limited, see <a  href=\"http://www.gameanalytics.com/docs/custom-events\">http://www.gameanalytics.com/docs/custom-events</a> .  <p>    EInvalidChar If some string contains invalid characters. Use only ASCII letters, digits, hyphens, underscores for the category and other strings.", "tags": "", "loc": "CastleAnalytics.TAnalytics.html#Event"},
     {"title": "CastleAnalytics.TAnalytics.Timing", "text": "  <p>    EInvalidChar If some string contains invalid characters. Use only ASCII letters, digits, hyphens, underscores for the category and other strings.", "tags": "", "loc": "CastleAnalytics.TAnalytics.html#Timing"},
     {"title": "CastleAnalytics.TAnalytics.Progress", "text": "  <p>    EInvalidChar If some string contains invalid characters. Use only ASCII letters, digits, hyphens, underscores for the world and other strings.", "tags": "", "loc": "CastleAnalytics.TAnalytics.html#Progress"},
     {"title": "CastleAnalytics.TAnalyticsProgress", "text": "  apStart    apFail    apComplete   ", "tags": "", "loc": "CastleAnalytics.html#TAnalyticsProgress"},
     {"title": "CastleApplicationProperties", "text": " ", "tags": "", "loc": "CastleApplicationProperties.html"},
     {"title": "CastleApplicationProperties.TGLContextEventList", "text": " ", "tags": "", "loc": "CastleApplicationProperties.TGLContextEventList.html"},
     {"title": "CastleApplicationProperties.TGLContextEventList.ExecuteForward", "text": "    ", "tags": "", "loc": "CastleApplicationProperties.TGLContextEventList.html#ExecuteForward"},
     {"title": "CastleApplicationProperties.TGLContextEventList.ExecuteBackward", "text": "    ", "tags": "", "loc": "CastleApplicationProperties.TGLContextEventList.html#ExecuteBackward"},
     {"title": "CastleApplicationProperties.TWarningEventList", "text": " ", "tags": "", "loc": "CastleApplicationProperties.TWarningEventList.html"},
     {"title": "CastleApplicationProperties.TWarningEventList.ExecuteAll", "text": "    ", "tags": "", "loc": "CastleApplicationProperties.TWarningEventList.html#ExecuteAll"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties", "text": "  <p>These members work regardless if you use <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> or <a class=\"normal\" href=\"CastleControl.html\">CastleControl</a>. For more fine-grained application control, see <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html\">TCastleApplication</a> (in case you use <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a>) or Lazarus (LCL) TApplication (in case you use <a class=\"normal\" href=\"CastleControl.html\">CastleControl</a>). ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.Create", "text": "    ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#Create"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.Destroy", "text": "    ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#Destroy"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.WriteWarningOnConsole", "text": " Eventually, on GUI Windows programs, it will make a dialog box. This is handled by <a class=\"normal\" href=\"CastleUtils.html#WarningWrite\">WarningWrite</a> procedure.    ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#WriteWarningOnConsole"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.ApplicationName", "text": " Used e.g. by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a> to name the log file.  <p>When compiled with FPC, this returns and sets the same thing as standard SysUtils.ApplicationName. When setting this, we automatically set SysUtils.OnGetApplicationName. ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#ApplicationName"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.Version", "text": " It may be used e.g. by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a> and <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#ParseStandardParameters\">TCastleApplication.ParseStandardParameters</a>. ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#Version"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.TouchDevice", "text": "  <p>A &quot;touch device&quot; means that:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>We cannot track <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#MousePosition\">TUIContainer.MousePosition</a> when nothing is pressed (<a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#MousePressed\">TUIContainer.MousePressed</a> is []) on a touch device.</p></li>   <li><p>The only &quot;mouse button&quot; you will ever see pressed on a touch device is <a class=\"normal\" href=\"CastleKeysMouse.html#mbLeft\">mbLeft</a>.</p></li>   <li><p>On the other hand, touch devices support multitouch, exposed by <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Touches\">TUIContainer.Touches</a> and <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#TouchesCount\">TUIContainer.TouchesCount</a>. On touch devices, <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#TouchesCount\">TUIContainer.TouchesCount</a> can range from 0 to a few (modern touch devices support up to 5 simultaneous touches).  <p>On non-touch devices, <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#TouchesCount\">TUIContainer.TouchesCount</a> is always 1.</p></li> </ul>  <p>  <p>As a debugging feature, you can set this to <code>True</code> to simulate touch devices on a desktop. The idea is that when an application shows a different input behaviour on touch devices, it should always condition it depending on this boolean property. So an application may do this:  <p></p>  <pre class=\"longcode\"> Window.AutomaticTouchInterface := ApplicationProperties.TouchDevice; Window.ScenaManager.WalkCamera.MouseLook := <span class=\"pascal_keyword\">not</span> ApplicationProperties.TouchDevice;</pre>  <p>  <p>And to test on desktop whether everything behaves OK on mobile, you can just earlier call this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">if</span> FakeTouchDeviceOnDesktop <span class=\"pascal_keyword\">then</span>   ApplicationProperties.TouchDevice := true;</pre>  <p> ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#TouchDevice"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.OnGLContextOpen", "text": " Use when you want to be notified about OpenGL context availability, but cannot refer to a particular instance of <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a> or <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a>.  <p>Note that we may have many OpenGL contexts (many <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> or <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a> instances) open simultaneously. They all share OpenGL resources. <code>OnGLContextOpen</code> is called when first OpenGL context is open, that is: no previous context was open. <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#OnGLContextClose\">OnGLContextClose</a> is called when last OpenGL context is closed, that is: no more contexts remain open. Note that this implies that they may be called many times: e.g. if you open one window, then close it, then open another window then close it.  <p>Callbacks on <code>OnGLContextOpen</code> are called from first to last. Callbacks on <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#OnGLContextClose\">OnGLContextClose</a> are called in reverse order, so <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#OnGLContextClose\">OnGLContextClose</a>[0] is called last.  <p> ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#OnGLContextOpen"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.OnGLContextOpenObject", "text": " ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#OnGLContextOpenObject"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.OnGLContextClose", "text": " ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#OnGLContextClose"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.OnGLContextCloseObject", "text": " ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#OnGLContextCloseObject"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.IsGLContextOpen", "text": " IOW, we are between the first <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#OnGLContextOpen\">OnGLContextOpen</a> and last <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#OnGLContextClose\">OnGLContextClose</a>. ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#IsGLContextOpen"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.OnUpdate", "text": "  <p>You can use this just like <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnUpdate\">TCastleControlCustom.OnUpdate</a> or <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnUpdate\">TCastleWindowCustom.OnUpdate</a> or <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnUpdate\">TCastleApplication.OnUpdate</a>, but in situations where you cannot access an instance of control/window and you want to work both with Lazarus <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a> and our custom <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html\">TCastleApplication</a>. ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#OnUpdate"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.OnInitializeJavaActivity", "text": " Called every time a Java activity is created.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>For the first time, it's called right before <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>.</p></li>   <li><p>Later this is called when Java activity died (and is restarting now), but the native code thread survived. So all native code memory is already cool (no need to call <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>), but we need to reinitialize Java part.  <p>Note that this is different from <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">TCastleWindowCustom.OnOpen</a>. We lose OpenGL context often, actually every time user switches to another app, without having neither Java nor native threads killed. </p></li> </ul>  <p>  <p>For non-Android applications, this is simply always called exactly once, exactly before calling <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>. ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#OnInitializeJavaActivity"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.OnPause", "text": " <i>For now</i> not called on non-Android, but this may change &mdash; consider these events somewhat internal for the time being.  ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#OnPause"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.OnResume", "text": " ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#OnResume"},
     {"title": "CastleApplicationProperties.TCastleApplicationProperties.OnWarning", "text": " ", "tags": "", "loc": "CastleApplicationProperties.TCastleApplicationProperties.html#OnWarning"},
     {"title": "CastleApplicationProperties.ApplicationProperties", "text": "    ", "tags": "", "loc": "CastleApplicationProperties.html#ApplicationProperties"},
     {"title": "CastleApplicationProperties.TGLContextEvent", "text": "    ", "tags": "", "loc": "CastleApplicationProperties.html#TGLContextEvent"},
     {"title": "CastleApplicationProperties.TWarningEvent", "text": "    ", "tags": "", "loc": "CastleApplicationProperties.html#TWarningEvent"},
     {"title": "CastleArraysGenerator", "text": " ", "tags": "", "loc": "CastleArraysGenerator.html"},
     {"title": "CastleArraysGenerator.TArraysGenerator", "text": " This is the basis of our renderer: generate a <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html\">TGeometryArrays</a> for a shape, then <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html\">TGLRenderer</a> will pass <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html\">TGeometryArrays</a> to OpenGL.  <p>Geometry must be based on coordinates when using this, that is TAbstractGeometryNode.Coord must return <code>True</code>. ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html"},
     {"title": "CastleArraysGenerator.TArraysGenerator.IndexesFromCoordIndex", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#IndexesFromCoordIndex"},
     {"title": "CastleArraysGenerator.TArraysGenerator.ArrayIndexNum", "text": " Suitable always to index Arrays.Position / Color / Normal and other <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Arrays\">Arrays</a> attribute <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Arrays\">arrays</a>. Calculated in each TAbstractCoordinateGenerator.GenerateVertex, always call &quot;inherited&quot; first fro <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateVertex\">GenerateVertex</a> overrides.  <p>There are three cases:  <p>1. When <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a> &lt;&gt; nil (so we have indexed node) and Arrays.Indexes &lt;&gt; nil (so we can render it by indexes, because AllowIndexed = true) then it's an index to node coordinates. It's equivalent to <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a>[IndexNum], and it can be used to index node's <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Coord\">Coord</a> as well as Arrays.Position (since they are ordered the same in this case).  <p>2. When <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a> &lt;&gt; nil (so we have indexed node) and Arrays.Indexes = nil (so we cannot render it by indexes, because AllowIndexed = false) then it's a number of vertex, that is it's incremented in each TAbstractCoordinateGenerator.GenerateVertex call.  <p>In this case <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#IndexesFromCoordIndex\">IndexesFromCoordIndex</a> &lt;&gt; nil, and <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Arrays\">Arrays</a> attributes have the same count as IndexesFromCoordIndex.Count. <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateVertex\">GenerateVertex</a> must be called in exactly the same order as <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#IndexesFromCoordIndex\">IndexesFromCoordIndex</a> were generated for this.  <p>3. When <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a> = nil (so we don't have an indexed node, also Arrays.Indexes = <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#IndexesFromCoordIndex\">IndexesFromCoordIndex</a> = nil always in this case) then it's an index to attributes. This is the trivial case, as <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Arrays\">Arrays</a> attributes are then ordered just like node's <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Coord\">Coord</a>. It's equal to IndexNum then. ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#ArrayIndexNum"},
     {"title": "CastleArraysGenerator.TArraysGenerator.Arrays", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#Arrays"},
     {"title": "CastleArraysGenerator.TArraysGenerator.TexCoordsNeeded", "text": "  ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#TexCoordsNeeded"},
     {"title": "CastleArraysGenerator.TArraysGenerator.MaterialOpacity", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#MaterialOpacity"},
     {"title": "CastleArraysGenerator.TArraysGenerator.FogVolumetric", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#FogVolumetric"},
     {"title": "CastleArraysGenerator.TArraysGenerator.FogVolumetricDirection", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#FogVolumetricDirection"},
     {"title": "CastleArraysGenerator.TArraysGenerator.FogVolumetricVisibilityStart", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#FogVolumetricVisibilityStart"},
     {"title": "CastleArraysGenerator.TArraysGenerator.ShapeBumpMappingUsed", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#ShapeBumpMappingUsed"},
     {"title": "CastleArraysGenerator.TArraysGenerator.ShapeBumpMappingTextureCoordinatesId", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#ShapeBumpMappingTextureCoordinatesId"},
     {"title": "CastleArraysGenerator.TArraysGenerator.OnRadianceTransfer", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#OnRadianceTransfer"},
     {"title": "CastleArraysGenerator.TArraysGenerator.OnVertexColor", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#OnVertexColor"},
     {"title": "CastleArraysGenerator.TArraysGenerator.FacesNeeded", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#FacesNeeded"},
     {"title": "CastleArraysGenerator.TArraysGenerator.WarningShadingProblems", "text": "    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#WarningShadingProblems"},
     {"title": "CastleArraysGenerator.TArraysGenerator.GenerateVertex", "text": " Given IndexNum indexes <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Coord\">Coord</a>, or (if <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a> is assigned) indexes <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a> (and <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a> then indexes actual <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Coord\">Coord</a>).    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#GenerateVertex"},
     {"title": "CastleArraysGenerator.TArraysGenerator.GetVertex", "text": " Returned vertex is in local coordinate space (use State.Transform if you want to get global coordinates).    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#GetVertex"},
     {"title": "CastleArraysGenerator.TArraysGenerator.CoordCount", "text": " You can pass index between 0 and <code>CoordCount</code> - 1 to various methods taking an index, like <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateVertex\">GenerateVertex</a>.    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#CoordCount"},
     {"title": "CastleArraysGenerator.TArraysGenerator.GenerateCoordinate", "text": " These are all called only when <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Coord\">Coord</a> is assigned.  <p><code>GenerateCoordinate</code> can be overridden only by the class that actually knows how to deconstruct (triangulate etc.) this node. It must call <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateVertex\">GenerateVertex</a> (or call <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateCoordsRange\">GenerateCoordsRange</a>, that has to be then overridden to call <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateVertex\">GenerateVertex</a> after inherited).  <p><a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateCoordinateBegin\">GenerateCoordinateBegin</a>, <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateCoordinateEnd\">GenerateCoordinateEnd</a> will be called before / after <code>GenerateCoordinate</code>. It's useful to override them for intermediate classes in this file, that cannot triangulate, but still want to add something before / after <code>GenerateCoordinate</code>. When overriding <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateCoordinateBegin\">GenerateCoordinateBegin</a>, always call inherited at the begin. When overriding <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateCoordinateEnd\">GenerateCoordinateEnd</a>, always call inherited at the end.     ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#GenerateCoordinate"},
     {"title": "CastleArraysGenerator.TArraysGenerator.GenerateCoordinateBegin", "text": "    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#GenerateCoordinateBegin"},
     {"title": "CastleArraysGenerator.TArraysGenerator.GenerateCoordinateEnd", "text": "    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#GenerateCoordinateEnd"},
     {"title": "CastleArraysGenerator.TArraysGenerator.GenerateCoordsRange", "text": " This is not called, not used, anywhere in this base TAbstractCoordinateGenerator class. In descendants, it may be useful to use this, like Geometry.InternalMakeCoordRanges(State, @<code>GenerateCoordsRange</code>).  <p><code>GenerateCoordsRange</code> is supposed to generate the parts of the mesh between BeginIndex and EndIndex - 1 vertices. BeginIndex and EndIndex are indexes to <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a> array, if <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a> is assigned, or just indexes to <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Coord\">Coord</a>.    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#GenerateCoordsRange"},
     {"title": "CastleArraysGenerator.TArraysGenerator.PrepareIndexesPrimitives", "text": " This is also the place to set Arrays.Primitive and Arrays.Counts.    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#PrepareIndexesPrimitives"},
     {"title": "CastleArraysGenerator.TArraysGenerator.PrepareAttributes", "text": " Descendants can override this to do stuff like Arrays.AddColor or Arrays.AddAttribute('foo'). Descendants can also set AllowIndexed to <code>False</code>, if we can't use indexed rendering (because e.g. we have colors per-face, which means that the same vertex position may have different colors, which means it has to be duplicated in <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Arrays\">arrays</a> anyway, so there's no point in indexing).    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#PrepareAttributes"},
     {"title": "CastleArraysGenerator.TArraysGenerator.Create", "text": "    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#Create"},
     {"title": "CastleArraysGenerator.TArraysGenerator.GenerateArrays", "text": "    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#GenerateArrays"},
     {"title": "CastleArraysGenerator.TArraysGenerator.BumpMappingAllowed", "text": "    ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#BumpMappingAllowed"},
     {"title": "CastleArraysGenerator.TArraysGenerator.Shape", "text": "  ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#Shape"},
     {"title": "CastleArraysGenerator.TArraysGenerator.State", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#State"},
     {"title": "CastleArraysGenerator.TArraysGenerator.Geometry", "text": " ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#Geometry"},
     {"title": "CastleArraysGenerator.TArraysGenerator.Coord", "text": " Usually coming from (<code>coord</code> as Coordinate).points field. If <code>Nil</code> then nothing will be rendered.  <p>In our constructor we initialize <code>Coord</code> and <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#CoordIndex\">CoordIndex</a> from Geometry, using TAbstractGeometryNode.Coord and TAbstractGeometryNode.CoordIndex values. ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#Coord"},
     {"title": "CastleArraysGenerator.TArraysGenerator.CoordIndex", "text": "  <p>If <code>Nil</code>, then <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateVertex\">GenerateVertex</a> (and all other routines taking some index) will just directly index <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#Coord\">Coord</a> (this is useful for non-indexed geometry, like TriangleSet instead of IndexedTriangleSet). ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#CoordIndex"},
     {"title": "CastleArraysGenerator.TArraysGenerator.CurrentRangeNumber", "text": " Read this only while in <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateCoordsRange\">GenerateCoordsRange</a>. In fact, this is just set by <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateCoordsRange\">GenerateCoordsRange</a> in this class (so call <code>inherited</code> first when overriding it).  <p>It's comfortable e.g. when you need RangeNumber inside <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateVertex\">GenerateVertex</a>, and you know that <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateVertex\">GenerateVertex</a> will be called only from <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#GenerateCoordsRange\">GenerateCoordsRange</a>. ", "tags": "", "loc": "CastleArraysGenerator.TArraysGenerator.html#CurrentRangeNumber"},
     {"title": "CastleArraysGenerator.GetArraysGenerator", "text": " Returns <code>Nil</code> if not suitable generator for this node, which means that this node cannot be rendered through <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html\">TGeometryArrays</a>.    ", "tags": "", "loc": "CastleArraysGenerator.html#GetArraysGenerator"},
     {"title": "CastleArraysGenerator.TRadianceTransferFunction", "text": "    ", "tags": "", "loc": "CastleArraysGenerator.html#TRadianceTransferFunction"},
     {"title": "CastleArraysGenerator.TVertexColorFunction", "text": " Passed here VertexPosition is in local coordinates (that is, local of this object, multiply by State.Transform to get scene coords). VertexIndex is the direct index to Node.Coordinates.    ", "tags": "", "loc": "CastleArraysGenerator.html#TVertexColorFunction"},
     {"title": "CastleArraysGenerator.TArraysGeneratorClass", "text": " ", "tags": "", "loc": "CastleArraysGenerator.html#TArraysGeneratorClass"},
     {"title": "CastleBackground", "text": " ", "tags": "", "loc": "CastleBackground.html"},
     {"title": "CastleBackground.TBackground", "text": " Background defined here has the same features as VRML/X3D Background:  <p></p>  <ul class=\"compact_spacing\">   <li><p>skybox - a cube with each face potentially textured (textures may have alpha channel)</p></li>   <li><p>a ground sphere around this, with color rings for ground colors</p></li>   <li><p>a sky sphere around this, with color rings for sky colors</p></li> </ul>  <p>  <p>Engine users should not use this class directly. Instead <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> automatically uses this to render the background defined by <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a>. ", "tags": "", "loc": "CastleBackground.TBackground.html"},
     {"title": "CastleBackground.TBackground.NearFarToSkySphereRadius", "text": "  <p>Background spheres (for sky and ground) are rendered at given radius. And inside these spheres, we have a cube (to apply background textures). Both spheres and cube must fit nicely within your projection near/far to avoid any artifacts.  <p>We first check is Proposed a good result value (it satisfies the conditions, with some safety margin). If yes, then we return exactly the Proposed value. Otherwise, we calculate new value as an average in our range. This way, if you already had sky sphere radius calculated (and prepared some OpenGL resources for it), and projection near/far changes very slightly (e.g. because bounding box slightly changed), then you don't have to recreate background &mdash; if the old sky sphere radius is still OK, then the old background resources are still OK.  <p>Just pass Proposed = 0 (or anything else that is always outside the range) if you don't need this feature.    ", "tags": "", "loc": "CastleBackground.TBackground.html#NearFarToSkySphereRadius"},
     {"title": "CastleBackground.TBackground.Create", "text": "    ", "tags": "", "loc": "CastleBackground.TBackground.html#Create"},
     {"title": "CastleBackground.TBackground.Destroy", "text": "    ", "tags": "", "loc": "CastleBackground.TBackground.html#Destroy"},
     {"title": "CastleBackground.TBackground.Update", "text": "    ", "tags": "", "loc": "CastleBackground.TBackground.html#Update"},
     {"title": "CastleBackground.TBackground.Render", "text": "    ", "tags": "", "loc": "CastleBackground.TBackground.html#Render"},
     {"title": "CastleBackground.TBackground.UpdateTransform", "text": "    ", "tags": "", "loc": "CastleBackground.TBackground.html#UpdateTransform"},
     {"title": "CastleBackground.TBackground.FreeResources", "text": "    ", "tags": "", "loc": "CastleBackground.TBackground.html#FreeResources"},
     {"title": "CastleBoxes", "text": " ", "tags": "", "loc": "CastleBoxes.html"},
     {"title": "CastleBoxes.EBox3DEmpty", "text": " ", "tags": "", "loc": "CastleBoxes.EBox3DEmpty.html"},
     {"title": "CastleBoxes.TBox3D", "text": " Rectangular prism with all sides parallel to basic planes X = 0, Y = 0 and Z = 0. This is sometimes called AABB, &quot;axis-aligned bounding box&quot;. Many geometric operations are fast and easy on this type.  <p>The actual box dimensions are stored inside the <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Data\">Data</a> field, as two 3D points. First point has always all the smaller coords, second point has all the larger coords. I.e. always  <p></p>  <pre class=\"preformatted\"> Data[0].Data[0] &lt;= Data[1].Data[0] and Data[0].Data[1] &lt;= Data[1].Data[1] and Data[0].Data[2] &lt;= Data[1].Data[2]</pre>  <p>  <p>The only exception is the special value <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Empty\">TBox3D.Empty</a>.  <p>Note that the box may still have all sizes equal 0. Consider a 3D model with only a single 3D point &mdash; it's not empty, but all the sizes must be 0. ", "tags": "", "loc": "CastleBoxes.TBox3D.html"},
     {"title": "CastleBoxes.TBox3D.Data", "text": " ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Data"},
     {"title": "CastleBoxes.TBox3D.Empty", "text": " This is different than just bounding box with zero sizes, as bounding box with zero sizes still has some position. Empty bounding box doesn't contain any portion of 3D space.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Empty"},
     {"title": "CastleBoxes.TBox3D.IsEmpty", "text": " You can think of this function as &quot;compare Box with <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Empty\">TBox3D.Empty</a>&quot;.  <p>But actually it works a little faster, by utilizing the assumption that <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Empty\">TBox3D.Empty</a> is the only allowed value that breaks <code>Data[0].Data[0] &lt;= Data[1].Data[0]</code> rule.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#IsEmpty"},
     {"title": "CastleBoxes.TBox3D.IsEmptyOrZero", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#IsEmptyOrZero"},
     {"title": "CastleBoxes.TBox3D.CheckNonEmpty", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#CheckNonEmpty"},
     {"title": "CastleBoxes.TBox3D.Middle", "text": "     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#Middle"},
     {"title": "CastleBoxes.TBox3D.Center", "text": " Name consistent with e.g. <a class=\"normal\" href=\"X3DNodes.TAbstractX3DGroupingNode.html#BboxCenter\">TAbstractX3DGroupingNode.BboxCenter</a>.     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#Center"},
     {"title": "CastleBoxes.TBox3D.AverageSize", "text": "     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#AverageSize"},
     {"title": "CastleBoxes.TBox3D.MaxSize", "text": "     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#MaxSize"},
     {"title": "CastleBoxes.TBox3D.MinSize", "text": "     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#MinSize"},
     {"title": "CastleBoxes.TBox3D.SizeX", "text": "     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#SizeX"},
     {"title": "CastleBoxes.TBox3D.SizeY", "text": "     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#SizeY"},
     {"title": "CastleBoxes.TBox3D.SizeZ", "text": "     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#SizeZ"},
     {"title": "CastleBoxes.TBox3D.AverageSize", "text": "   AllowZero Decides what to do when box is not empty but the result would be zero, which means that the box is infinitely thin in all axes. If <code>True</code>, then result is just 0, otherwise it's EmptyBoxSize.  AllowZero Decides what to do when box is not empty but the result would be zero, which means that the box is infinitely thin in all axes. If <code>True</code>, then result is just 0, otherwise it's EmptyBoxSize.", "tags": "", "loc": "CastleBoxes.TBox3D.html#AverageSize"},
     {"title": "CastleBoxes.TBox3D.MaxSize", "text": "   AllowZero Decides what to do when box is not empty but the result would be zero, which means that the box is infinitely thin in all axes. If <code>True</code>, then result is just 0, otherwise it's EmptyBoxSize.  AllowZero Decides what to do when box is not empty but the result would be zero, which means that the box is infinitely thin in all axes. If <code>True</code>, then result is just 0, otherwise it's EmptyBoxSize.", "tags": "", "loc": "CastleBoxes.TBox3D.html#MaxSize"},
     {"title": "CastleBoxes.TBox3D.Area", "text": "   AllowZero Decides what to do when box is not empty but the result would be zero, which means that the box is infinitely thin in all axes. If <code>True</code>, then result is just 0, otherwise it's EmptyBoxSize.  AllowZero Decides what to do when box is not empty but the result would be zero, which means that the box is infinitely thin in all axes. If <code>True</code>, then result is just 0, otherwise it's EmptyBoxSize.", "tags": "", "loc": "CastleBoxes.TBox3D.html#Area"},
     {"title": "CastleBoxes.TBox3D.ExpandMe", "text": " So you get Box with all sizes increased by 2 * AExpand.  <p>Box must not be empty. Note that AExpand may be negative, but then you must be sure that it doesn't make Box empty.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#ExpandMe"},
     {"title": "CastleBoxes.TBox3D.ExpandMe", "text": " So you get Box with all sizes increased by 2 * AExpand.  <p>Box must not be empty. Note that AExpand may be negative, but then you must be sure that it doesn't make Box empty.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#ExpandMe"},
     {"title": "CastleBoxes.TBox3D.Grow", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Grow"},
     {"title": "CastleBoxes.TBox3D.Grow", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Grow"},
     {"title": "CastleBoxes.TBox3D.Expand", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Expand"},
     {"title": "CastleBoxes.TBox3D.Expand", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Expand"},
     {"title": "CastleBoxes.TBox3D.Contains", "text": " Always false if Box is empty (obviously, no point is inside an empty box).  <p>    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Contains"},
     {"title": "CastleBoxes.TBox3D.PointInside", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#PointInside"},
     {"title": "CastleBoxes.TBox3D.Contains2D", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Contains2D"},
     {"title": "CastleBoxes.TBox3D.PointInside2D", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#PointInside2D"},
     {"title": "CastleBoxes.TBox3D.Contains2D", "text": " 2D projection (of point and box) is obtained by rejecting the IgnoreIndex coordinate (must be 0, 1 or 2).    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Contains2D"},
     {"title": "CastleBoxes.TBox3D.PointInside2D", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#PointInside2D"},
     {"title": "CastleBoxes.TBox3D.Include", "text": " This calculates the smallest box that encloses both the current box, and Box2. Doing <code>MyBox.Include(AnotherBox)</code> is equivalent to doing <code>MyBox := MyBox + AnotherBox</code>.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Include"},
     {"title": "CastleBoxes.TBox3D.Include", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Include"},
     {"title": "CastleBoxes.TBox3D.Sizes", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Sizes"},
     {"title": "CastleBoxes.TBox3D.Size", "text": " Name consistent with <a class=\"normal\" href=\"X3DNodes.TBoxNode.html#Size\">TBoxNode.Size</a>.     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#Size"},
     {"title": "CastleBoxes.TBox3D.Corners", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Corners"},
     {"title": "CastleBoxes.TBox3D.GetAllPoints", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#GetAllPoints"},
     {"title": "CastleBoxes.TBox3D.Transform", "text": " Since this is still an axis-aligned box, rotating etc. of the box usually makes larger box.  <p>Note that this is very optimized for Matrix with no projection (where last row of the last matrix = [0, 0, 0, 1]). It still works for all matrices (eventually fallbacks to simple &quot;transform 8 <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Corners\">corners</a> and get box enclosing them&quot; method).  <p>    ETransformedResultInvalid When the Matrix will transform some point to a direction (vector with 4th component equal zero). In this case we just cannot interpret the result as a 3D point, so we also cannot interpret the final result as a box.", "tags": "", "loc": "CastleBoxes.TBox3D.html#Transform"},
     {"title": "CastleBoxes.TBox3D.Translate", "text": " Does nothing if Box is empty.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Translate"},
     {"title": "CastleBoxes.TBox3D.AntiTranslate", "text": " Does nothing if Box is empty.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#AntiTranslate"},
     {"title": "CastleBoxes.TBox3D.ToNiceStr", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#ToNiceStr"},
     {"title": "CastleBoxes.TBox3D.ToRawStr", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#ToRawStr"},
     {"title": "CastleBoxes.TBox3D.ToString", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#ToString"},
     {"title": "CastleBoxes.TBox3D.ToRawString", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#ToRawString"},
     {"title": "CastleBoxes.TBox3D.ClampVar", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#ClampVar"},
     {"title": "CastleBoxes.TBox3D.TryRayClosestIntersection", "text": "  <p>The box is treated just like a set of 6 rectangles in 3D. This means that the intersection will always be placed on one of the box sides, even if RayOrigin starts inside the box. See TryBoxRayEntrance for the other version.  <p>Returns also IntersectionDistance, which is the distance to the Intersection relative to RayDirection (i.e. Intersection is always = RayOrigin + IntersectionDistance * RayDirection).  <p>    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#TryRayClosestIntersection"},
     {"title": "CastleBoxes.TBox3D.TryRayClosestIntersection", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#TryRayClosestIntersection"},
     {"title": "CastleBoxes.TBox3D.TryRayClosestIntersection", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#TryRayClosestIntersection"},
     {"title": "CastleBoxes.TBox3D.TryRayEntrance", "text": "  <p>If RayOrigin is inside the box, TryBoxRayEntrance simply returns RayOrigin. If RayOrigin is outside of the box, the answer is the same as with TryBoxRayClosestIntersection.  <p>    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#TryRayEntrance"},
     {"title": "CastleBoxes.TBox3D.TryRayEntrance", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#TryRayEntrance"},
     {"title": "CastleBoxes.TBox3D.SegmentCollision", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#SegmentCollision"},
     {"title": "CastleBoxes.TBox3D.PlaneCollision", "text": " Returns detailed result as <a class=\"normal\" href=\"CastleBoxes.html#TPlaneCollision\">TPlaneCollision</a>.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#PlaneCollision"},
     {"title": "CastleBoxes.TBox3D.PlaneCollisionInside", "text": "  <p>Inside/outside are defined as for <a class=\"normal\" href=\"CastleBoxes.html#TPlaneCollision\">TPlaneCollision</a>: Outside is where plane direction (normal) points. Inside is where the <i>inverted</i> plane direction (normal) points.  <p>They work exactly like Box3DPlaneCollision, except they returns <code>True</code> when box is inside/outside (when Box3DPlaneCollision returned <a class=\"normal\" href=\"CastleBoxes.html#pcInside\">pcInside</a>/<a class=\"normal\" href=\"CastleBoxes.html#pcOutside\">pcOutside</a>), and <code>False</code> otherwise.  <p>For example Box3DPlaneCollisionInside doesn't differentiate between case when box is empty, of partially intersects the plane, and is on the outside. But it works (very slightly) faster.  <p>    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#PlaneCollisionInside"},
     {"title": "CastleBoxes.TBox3D.PlaneCollisionOutside", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#PlaneCollisionOutside"},
     {"title": "CastleBoxes.TBox3D.IsTriangleCollision", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#IsTriangleCollision"},
     {"title": "CastleBoxes.TBox3D.BoundingSphere", "text": " When Box is empty we return SphereRadiusSqr = 0 and undefined SphereCenter.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#BoundingSphere"},
     {"title": "CastleBoxes.TBox3D.Collision", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Collision"},
     {"title": "CastleBoxes.TBox3D.Radius", "text": " Sphere center is assumed to be in (0, 0, 0). 0 if box is empty.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Radius"},
     {"title": "CastleBoxes.TBox3D.Radius2D", "text": " 2D box projection is obtained by rejecting the IgnoreIndex coordinate (must be 0, 1 or 2). Circle center is assumed to be in (0, 0). 0 if box is empty.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Radius2D"},
     {"title": "CastleBoxes.TBox3D.SphereSimpleCollision", "text": "  <p>This considers a Box enlarged by SphereRadius in each direction. Then checks whether SphereCenter is inside such enlarged Box. So this check will incorrectly report collision while in fact there's no collision in the case when the sphere center is near the corner of the Box.  <p>So this check is not 100% correct. But often this is good enough &mdash; in games, if you know that the SphereRadius is going to be relatively small compared to the Box, this may be perfectly acceptable. And it's fast.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#SphereSimpleCollision"},
     {"title": "CastleBoxes.TBox3D.SphereCollision", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#SphereCollision"},
     {"title": "CastleBoxes.TBox3D.SphereCollision2D", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#SphereCollision2D"},
     {"title": "CastleBoxes.TBox3D.MaximumPlane", "text": "  <p>For example, if Direction = -Z = (0, 0, -1), then this will return the bottom plane of this box. For Direction = (1, 1, 1), this will return a plane intersecting the Data[1] (maximum) point, with slope = (1, 1, 1). The resulting plane always intersects at least one of the 8 <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Corners\">corners</a> of the box.  <p>    EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#MaximumPlane"},
     {"title": "CastleBoxes.TBox3D.MinimumPlane", "text": "  <p>For example, if Direction = +Z = (0, 0, 1), then this will return the bottom plane of this box. For Direction = (1, 1, 1), this will return a plane intersecting the Data[0] (minimum) point, with slope = (1, 1, 1). The resulting plane always intersects at least one of the 8 <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Corners\">corners</a> of the box.  <p>    EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#MinimumPlane"},
     {"title": "CastleBoxes.TBox3D.MaximumCorner", "text": "     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#MaximumCorner"},
     {"title": "CastleBoxes.TBox3D.MinimumCorner", "text": "     EBox3DEmpty If the Box is empty.", "tags": "", "loc": "CastleBoxes.TBox3D.html#MinimumCorner"},
     {"title": "CastleBoxes.TBox3D.PointDistances", "text": " MinDistance is the distance to the closest point of the box, MaxDistance is the distance to the farthest point of the box.  <p>Note that always MinDistance &lt;= MaxDistance. Note that both distances are always &gt;= 0.  <p>When the point is inside the box, it works correct too: minimum distance is zero in this case.  <p>  <p>TODO: calculation of MinDistance is not perfect now. We assume that the closest/farthest point of the box is one of the 8 box <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Corners\">corners</a>. Which may not be true in case of the closest point, because it may lie in the middle of some box face (imagine a sphere with increasing radius reaching from a point to a box). So our minimum may be a *little* too large.    EBox3DEmpty When used with an empty box.", "tags": "", "loc": "CastleBoxes.TBox3D.html#PointDistances"},
     {"title": "CastleBoxes.TBox3D.DirectionDistances", "text": " The idea is that you have a 3D plane orthogonal to direction Dir and passing through Point. You can move this plane, but you have to keep it's direction constant. MinDistance is the minimal distance along the Dir that you can move this plane, such that it touches the box. MaxDistance is the maximum such distance.  <p>Note that always MinDistance &lt;= MaxDistance. Note that one distance (MinDistance) or both distances may be negative.  <p>As a practical example: imagine a DirectionalLight (light rays are parallel) that has a location. Now MinDistance and MaxDistance give ranges of depth where the Box is, as seen from the light source.  <p>    EBox3DEmpty When used with an empty box.", "tags": "", "loc": "CastleBoxes.TBox3D.html#DirectionDistances"},
     {"title": "CastleBoxes.TBox3D.PointDistance", "text": " Always zero when the point is inside the box.  <p>    EBox3DEmpty When used with an empty box.", "tags": "", "loc": "CastleBoxes.TBox3D.html#PointDistance"},
     {"title": "CastleBoxes.TBox3D.PointMaxDistance", "text": " Returns EmptyBoxDistance when box is empty.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#PointMaxDistance"},
     {"title": "CastleBoxes.TBox3D.Equal", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Equal"},
     {"title": "CastleBoxes.TBox3D.Equal", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Equal"},
     {"title": "CastleBoxes.TBox3D.Diagonal", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Diagonal"},
     {"title": "CastleBoxes.TBox3D.RectangleXY", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#RectangleXY"},
     {"title": "CastleBoxes.TBox3D.RectangleXZ", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#RectangleXZ"},
     {"title": "CastleBoxes.TBox3D.OrthoProject", "text": " <b>Assumes that Dir, Side and Up vectors are already orthogonal and normalized.</b>    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#OrthoProject"},
     {"title": "CastleBoxes.TBox3D.CompareBackToFront3D", "text": " Follows the algorithm documented at <a class=\"normal\" href=\"CastleBoxes.html#bs3D\">TBlendingSort.bs3D</a>. Returns -1 if A &lt; B, 1 if A &gt; B, 0 if A = B.  <p>Using this with a typical sorting function will result in boxes back-to-front ordering, which means that the farthest box will be first.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#CompareBackToFront3D"},
     {"title": "CastleBoxes.TBox3D.CompareBackToFront2D", "text": " Follows the algorithm documented at <a class=\"normal\" href=\"CastleBoxes.html#bs2D\">TBlendingSort.bs2D</a>. Returns -1 if A &lt; B, 1 if A &gt; B, 0 if A = B.  <p>Using this with a typical sorting function will result in boxes back-to-front ordering, which means that the farthest box will be first.    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#CompareBackToFront2D"},
     {"title": "CastleBoxes.TBox3D.+", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#+"},
     {"title": "CastleBoxes.TBox3D.+", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#+"},
     {"title": "CastleBoxes.TBox3D.+", "text": "    ", "tags": "", "loc": "CastleBoxes.TBox3D.html#+"},
     {"title": "CastleBoxes.TBox3D.Min", "text": " Use only if not <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#IsEmpty\">IsEmpty</a>, in which case this is just a shortcut for <code>Data[0]</code>. ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Min"},
     {"title": "CastleBoxes.TBox3D.Max", "text": " Use only if not <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#IsEmpty\">IsEmpty</a>, in which case this is just a shortcut for <code>Data[1]</code>. ", "tags": "", "loc": "CastleBoxes.TBox3D.html#Max"},
     {"title": "CastleBoxes.EmptyBox3D", "text": " This is different than just bounding box with zero sizes, as bounding box with zero sizes still has some position. Empty bounding box doesn't contain any portion of 3D space. ", "tags": "", "loc": "CastleBoxes.html#EmptyBox3D"},
     {"title": "CastleBoxes.Box3D", "text": "    ", "tags": "", "loc": "CastleBoxes.html#Box3D"},
     {"title": "CastleBoxes.Box3DAroundPoint", "text": " When any Size component is &lt; 0, we return an empty box (<a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Empty\">TBox3D.Empty</a>). This is consistent with X3D bboxCenter/Size definition e.g. at X3D Group node, see <a  href=\"http://www.web3d.org/documents/specifications/19775-1/V3.2/Part01/components/group.html#Group\">http://www.web3d.org/documents/specifications/19775-1/V3.2/Part01/components/group.html#Group</a>     ", "tags": "", "loc": "CastleBoxes.html#Box3DAroundPoint"},
     {"title": "CastleBoxes.Box3DAroundPoint", "text": "    ", "tags": "", "loc": "CastleBoxes.html#Box3DAroundPoint"},
     {"title": "CastleBoxes.CalculateBoundingBox", "text": " This calculates the smallest possible box enclosing all given points. For VertsCount = 0 this returns <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Empty\">TBox3D.Empty</a>.  <p>Overloaded version with Transform parameter transforms each point by given matrix.  <p>Overloaded version with GetVertex as a function uses GetVertex to query for indexes from [0 .. VertsCount - 1] range.  <p>As usual, VertsStride = 0 means VertsStride = SizeOf(<a class=\"normal\" href=\"CastleVectors.html#TVector3\">TVector3</a>).  <p>    ", "tags": "", "loc": "CastleBoxes.html#CalculateBoundingBox"},
     {"title": "CastleBoxes.CalculateBoundingBox", "text": "    ", "tags": "", "loc": "CastleBoxes.html#CalculateBoundingBox"},
     {"title": "CastleBoxes.CalculateBoundingBox", "text": "    ", "tags": "", "loc": "CastleBoxes.html#CalculateBoundingBox"},
     {"title": "CastleBoxes.CalculateBoundingBox", "text": "    ", "tags": "", "loc": "CastleBoxes.html#CalculateBoundingBox"},
     {"title": "CastleBoxes.CalculateBoundingBox", "text": "    ", "tags": "", "loc": "CastleBoxes.html#CalculateBoundingBox"},
     {"title": "CastleBoxes.CalculateBoundingBoxFromIndices", "text": "  <p>This is much like <a class=\"normal\" href=\"CastleBoxes.html#CalculateBoundingBox\">CalculateBoundingBox</a>, except there are two functions: For each number in [0 .. VertsIndicesCount - 1] range, GetVertIndex returns an index. If this index is &gt;= 0 then it's used to query GetVertex function to get actual vertex position.  <p>Indexes &lt; 0 are ignored, this is sometimes comfortable. E.g. for X3D models, you often have a list of indexes with -1 in between marking end of faces.  <p>Returns smallest box enclosing all vertexes.  <p>Overloaded version with Transform parameter transforms each point by given matrix.  <p>    ", "tags": "", "loc": "CastleBoxes.html#CalculateBoundingBoxFromIndices"},
     {"title": "CastleBoxes.CalculateBoundingBoxFromIndices", "text": "    ", "tags": "", "loc": "CastleBoxes.html#CalculateBoundingBoxFromIndices"},
     {"title": "CastleBoxes.TriangleBoundingBox", "text": "    ", "tags": "", "loc": "CastleBoxes.html#TriangleBoundingBox"},
     {"title": "CastleBoxes.IsCenteredBox3DPlaneCollision", "text": "  <p>Note that you can't express empty <a class=\"normal\" href=\"CastleBoxes.html#Box3D\">box3d</a> here: all BoxHalfSize items must be &gt;= 0. The case when size = 0 is considered like infintely small box in some dimension (e.g. if all three sizes are = 0 then the box becomes a point).    ", "tags": "", "loc": "CastleBoxes.html#IsCenteredBox3DPlaneCollision"},
     {"title": "CastleBoxes.BoundingBox3DFromSphere", "text": "    ", "tags": "", "loc": "CastleBoxes.html#BoundingBox3DFromSphere"},
     {"title": "CastleBoxes.TGetIndexFromIndexNumFunc", "text": "    ", "tags": "", "loc": "CastleBoxes.html#TGetIndexFromIndexNumFunc"},
     {"title": "CastleBoxes.TPlaneCollision", "text": "  <p><a class=\"normal\" href=\"CastleBoxes.html#pcNone\">pcNone</a> occurs only when the &quot;other object&quot; is empty (<a class=\"normal\" href=\"CastleBoxes.TBox3D.html#IsEmpty\">TBox3D.IsEmpty</a>, in case of box). Other values mean that the other object is not empty.  <p><a class=\"normal\" href=\"CastleBoxes.html#pcOutside\">pcOutside</a> means that the whole object is on the side of the plane pointed by plane direction (normal) vector. More formally, every point P inserted into the plane equation will yield (P*PlaneNormal + PlaneD) &gt; 0.  <p><a class=\"normal\" href=\"CastleBoxes.html#pcInside\">pcInside</a> is the reverse of <a class=\"normal\" href=\"CastleBoxes.html#pcOutside\">pcOutside</a>: the other object is on the side of plane pointed by inverted plane normal. Every point inserted into plane equation will yield &lt; 0.  <p><a class=\"normal\" href=\"CastleBoxes.html#pcIntersecting\">pcIntersecting</a> is, well, the remaining case. It means that there's for sure some point P of other object that, when inserted into plane equation, will yield = 0.  pcIntersecting    pcOutside    pcInside    pcNone   ", "tags": "", "loc": "CastleBoxes.html#TPlaneCollision"},
     {"title": "CastleBoxes.TBoxCorners", "text": " ", "tags": "", "loc": "CastleBoxes.html#TBoxCorners"},
     {"title": "CastleBoxes.TBlendingSort", "text": "   bsNone Do not sort.  Using this for <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#BlendingSort\">Scene.Attributes.BlendingSort</a> is fastest, but will cause artifacts if multiple partially-transparent objects may be visible on top of each other.  bs2D Sort objects by their Z coordinate.  Using this for <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#BlendingSort\">Scene.Attributes.BlendingSort</a> is very useful for 2D worlds, with flat 2D objects that have zero (or near-zero) size in the Z axis, and they are moved in the Z axis to specify which is on top for another.  <p>More precisely, we take the minimum bounding box Z coordinate of two objects. (We don't bother calculating the middle Z coordinate, as we assume that the bounding box is infinitely small along the Z axis.) The one with <i>larger</i> Z coordinate is considered to be <i>closer</i>, this is consistent with the right-handed coordinate system.  <p>Note that the actual camera position doesn't matter for this sorting. So the 2D object will look OK, <i>even if viewed from an angle, even if viewed from the other side</i>.  bs3D Sort objects by the (3D) distance to the camera.  Using this for <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#BlendingSort\">Scene.Attributes.BlendingSort</a> is the best sorting method for 3D scenes with many partially-transparent objects.  <p>The distance is measured from the middle of the bounding box to the camera posotion. ", "tags": "", "loc": "CastleBoxes.html#TBlendingSort"},
     {"title": "CastleBoxes.TBox3DBool", "text": " ", "tags": "", "loc": "CastleBoxes.html#TBox3DBool"},
     {"title": "CastleBoxes.PBox3D", "text": " ", "tags": "", "loc": "CastleBoxes.html#PBox3D"},
     {"title": "CastleBoxes.TBox3DList", "text": " ", "tags": "", "loc": "CastleBoxes.html#TBox3DList"},
     {"title": "CastleCameras", "text": " ", "tags": "", "loc": "CastleCameras.html"},
     {"title": "CastleCameras.TCamera", "text": " You control camera parameters and provide user input to this class by various methods and properties. You can investigate the current camera configuration by many methods, the most final is the <a class=\"normal\" href=\"CastleCameras.TCamera.html#Matrix\">Matrix</a> method that generates a simple 4x4 camera matrix.  <p>This class is not tied to any OpenGL specifics, any VRML specifics, and <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> etc. &mdash; this class is fully flexible and may be used in any 3D program, whether using <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a>, OpenGL etc. or not.  <p>Various <code>TCamera</code> descendants implement various navigation methods, for example <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> allows the user to rotate and scale the model (imagine that you're holding a 3D model in your hands and you look at it from various sides) and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> implements typical navigation in the style of first-person shooter games.  <p>The most comfortable way to use a camera is with a scene manager (<a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>). You can create your camera instance, call it's <code>Init</code> method (this is initializes most important properties), and assign it to TCastleSceneManager.Camera property. This way SceneManager will pass all necessary window events to the camera, and when drawing SceneManager will load camera matrix like <code><a class=\"normal\" href=\"CastleGLUtils.html#glLoadMatrix\">glLoadMatrix</a>(Camera.Matrix);</code>. In fact, if you do not assign anything to TCastleSceneManager.Camera property, then the default camera will be created for you. So <i>when using <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>, you do not have to do anything to use a camera</i> &mdash; default camera will be created and automatically used for you. ", "tags": "", "loc": "CastleCameras.TCamera.html"},
     {"title": "CastleCameras.TCamera.MouseDraggingStarted", "text": " Checking <code>MouseDraggingStarted</code> means that we handle only dragging that was initialized on viewport (since the viewport passed events to camera). <code>MouseDraggingStarted</code> -1 means none, otherwise it's the finder index (to support multitouch). ", "tags": "", "loc": "CastleCameras.TCamera.html#MouseDraggingStarted"},
     {"title": "CastleCameras.TCamera.MouseDraggingStart", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#MouseDraggingStart"},
     {"title": "CastleCameras.TCamera.DefaultRadius", "text": " Matches the default VRML/X3D NavigationInfo.avatarSize[0]. ", "tags": "", "loc": "CastleCameras.TCamera.html#DefaultRadius"},
     {"title": "CastleCameras.TCamera.DefaultInput", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#DefaultInput"},
     {"title": "CastleCameras.TCamera.DefaultHeadBobbingTime", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#DefaultHeadBobbingTime"},
     {"title": "CastleCameras.TCamera.DefaultHeadBobbing", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#DefaultHeadBobbing"},
     {"title": "CastleCameras.TCamera.DefaultCrouchHeight", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#DefaultCrouchHeight"},
     {"title": "CastleCameras.TCamera.BeginVisibleChangeSchedule", "text": "  <p>This mechanism allows to defer calling <a class=\"normal\" href=\"CastleCameras.TCamera.html#VisibleChange\">VisibleChange</a>. Idea: <code>BeginVisibleChangeSchedule</code> increases internal VisibleChangeSchedule counter, <a class=\"normal\" href=\"CastleCameras.TCamera.html#EndVisibleChangeSchedule\">EndVisibleChangeSchedule</a> decreases it and calls actual <a class=\"normal\" href=\"CastleCameras.TCamera.html#VisibleChange\">VisibleChange</a> if counter is zero and some <a class=\"normal\" href=\"CastleCameras.TCamera.html#ScheduleVisibleChange\">ScheduleVisibleChange</a> was called in between.  <p>When <a class=\"normal\" href=\"CastleCameras.TCamera.html#ScheduleVisibleChange\">ScheduleVisibleChange</a> is called when counter is zero, <a class=\"normal\" href=\"CastleCameras.TCamera.html#VisibleChange\">VisibleChange</a> is called immediately, so it's safe to always use <a class=\"normal\" href=\"CastleCameras.TCamera.html#ScheduleVisibleChange\">ScheduleVisibleChange</a> instead of direct <a class=\"normal\" href=\"CastleCameras.TCamera.html#VisibleChange\">VisibleChange</a> in this class.    ", "tags": "", "loc": "CastleCameras.TCamera.html#BeginVisibleChangeSchedule"},
     {"title": "CastleCameras.TCamera.ScheduleVisibleChange", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#ScheduleVisibleChange"},
     {"title": "CastleCameras.TCamera.EndVisibleChangeSchedule", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#EndVisibleChangeSchedule"},
     {"title": "CastleCameras.TCamera.SetInput", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#SetInput"},
     {"title": "CastleCameras.TCamera.SetEnableDragging", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#SetEnableDragging"},
     {"title": "CastleCameras.TCamera.GetIgnoreAllInputs", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#GetIgnoreAllInputs"},
     {"title": "CastleCameras.TCamera.SetIgnoreAllInputs", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#SetIgnoreAllInputs"},
     {"title": "CastleCameras.TCamera.SetProjectionMatrix", "text": " <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a> descendants may override this. In normal circumstances, you should not call it anywhere (it's automatically called by the scene manager).    ", "tags": "", "loc": "CastleCameras.TCamera.html#SetProjectionMatrix"},
     {"title": "CastleCameras.TCamera.SetRadius", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#SetRadius"},
     {"title": "CastleCameras.TCamera.GetPositionInternal", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#GetPositionInternal"},
     {"title": "CastleCameras.TCamera.SetPosition", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#SetPosition"},
     {"title": "CastleCameras.TCamera.ReallyEnableMouseDragging", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#ReallyEnableMouseDragging"},
     {"title": "CastleCameras.TCamera.Create", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#Create"},
     {"title": "CastleCameras.TCamera.Assign", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#Assign"},
     {"title": "CastleCameras.TCamera.VisibleChange", "text": " In the simplest case, this is used by the controls manager to know when we need to redraw the control.  <p>In case of the <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a> class, we assume that changes to the <a class=\"normal\" href=\"CastleCameras.TCamera.html#Matrix\">TCamera.Matrix</a>, and other properties (for example even changes to TWalkCamera.MoveSpeed), are &quot;visible&quot;, and they also result in this event.    ", "tags": "", "loc": "CastleCameras.TCamera.html#VisibleChange"},
     {"title": "CastleCameras.TCamera.Matrix", "text": " You should multiply every 3D point of your scene by this matrix, which usually simply means that you should do <code><a class=\"normal\" href=\"CastleGLUtils.html#glLoadMatrix\">glLoadMatrix</a></code> or <code><a class=\"normal\" href=\"CastleGLUtils.html#glMultMatrix\">glMultMatrix</a></code> of this matrix.    ", "tags": "", "loc": "CastleCameras.TCamera.html#Matrix"},
     {"title": "CastleCameras.TCamera.RotationMatrix", "text": " This is useful for rendering skybox in 3D programs (e.g. for VRML/X3D Background node) and generally to transform directions between world and camera space.  <p>It's guaranteed that this is actually only 3x3 matrix, the 4th row and 4th column are all zero except the lowest right item which is 1.0.    ", "tags": "", "loc": "CastleCameras.TCamera.html#RotationMatrix"},
     {"title": "CastleCameras.TCamera.GetView", "text": "  <p>Returned Dir and Up must be orthogonal. Returned Dir and Up and <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> are already normalized.    ", "tags": "", "loc": "CastleCameras.TCamera.html#GetView"},
     {"title": "CastleCameras.TCamera.GetView", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#GetView"},
     {"title": "CastleCameras.TCamera.SetView", "text": "  <p>Direction, Up and <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> do not have to be normalized, we will normalize them internally if necessary. But make sure they are non-zero.  <p>We will automatically fix Direction and Up to be orthogonal, if necessary: when AdjustUp = <code>True</code> (the default) we will adjust the up vector (preserving the given direction value), otherwise we will adjust the direction (preserving the given up value).    ", "tags": "", "loc": "CastleCameras.TCamera.html#SetView"},
     {"title": "CastleCameras.TCamera.SetView", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#SetView"},
     {"title": "CastleCameras.TCamera.GetPosition", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#GetPosition"},
     {"title": "CastleCameras.TCamera.Ray", "text": " Uses current Container, which means that you have to add this camera to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a> before using this method.  <p>Projection (read-only here) describe your projection, required for calculating the ray properly. Resulting RayDirection is always normalized.  <p>WindowPosition is given in the same style as <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#MousePosition\">TUIContainer.MousePosition</a>: (0, 0) is bottom-left.    ", "tags": "", "loc": "CastleCameras.TCamera.html#Ray"},
     {"title": "CastleCameras.TCamera.MouseRay", "text": " Uses current Container (both to get it's size and to get current mouse position), which means that you have to add this camera to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a> before using this method.  <p>     ", "tags": "", "loc": "CastleCameras.TCamera.html#MouseRay"},
     {"title": "CastleCameras.TCamera.CustomRay", "text": " This doesn't look at our container sizes at all.  <p>Projection (read-only here) describe projection, required for calculating the ray properly.  <p>Resulting RayDirection is always normalized.  <p>WindowPosition is given in the same style as <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#MousePosition\">TUIContainer.MousePosition</a>: (0, 0) is bottom-left.    ", "tags": "", "loc": "CastleCameras.TCamera.html#CustomRay"},
     {"title": "CastleCameras.TCamera.Update", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#Update"},
     {"title": "CastleCameras.TCamera.Press", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#Press"},
     {"title": "CastleCameras.TCamera.Release", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#Release"},
     {"title": "CastleCameras.TCamera.AnimateTo", "text": " This will gradually change our settings (only the most important settings, that determine actual camera view, i.e. <a class=\"normal\" href=\"CastleCameras.TCamera.html#Matrix\">Matrix</a> result) into another camera.  <p>Current OtherCamera settings will be internally copied during this call. So you can even free OtherCamera instance immediately after calling this.  <p>When we're during camera animation, <a class=\"normal\" href=\"CastleCameras.TCamera.html#Update\">Update</a> doesn't do other stuff (e.g. gravity for <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> doesn't work, rotating for <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> doesn't work). This also means that the key/mouse controls of the camera do not work. Instead, we remember the source and target position (at the time <a class=\"normal\" href=\"CastleCameras.TCamera.html#AnimateTo\">AnimateTo</a> was called) of the camera, and smoothly interpolate camera parameters to match the target.  <p>Once the animation stops, <a class=\"normal\" href=\"CastleCameras.TCamera.html#Update\">Update</a> goes back to normal: gravity in <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> works again, rotating in <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> works again etc.  <p>Calling <a class=\"normal\" href=\"CastleCameras.TCamera.html#AnimateTo\">AnimateTo</a> while the previous animation didn't finish yet is OK. This simply cancels the previous animation, and starts the new animation from the current position.  <p><i>Descendants implementors notes:</i> In this class, almost everything is handled (through <a class=\"normal\" href=\"CastleCameras.TCamera.html#GetView\">GetView</a> / <a class=\"normal\" href=\"CastleCameras.TCamera.html#SetView\">SetView</a>). In descendants you have to only ignore key/mouse/Update events when IsAnimation is <code>True</code>. (Although each Update would override the view anyway, but for stability it's best to explicitly ignore them &mdash; you never know how often Update will be called.)  <p>    ", "tags": "", "loc": "CastleCameras.TCamera.html#AnimateTo"},
     {"title": "CastleCameras.TCamera.AnimateTo", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#AnimateTo"},
     {"title": "CastleCameras.TCamera.Animation", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#Animation"},
     {"title": "CastleCameras.TCamera.SetInitialView", "text": "  <p>AInitialDirection and AInitialUp will be automatically normalized. Corresponding properties (<a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialDirection\">InitialDirection</a> and <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialUp\">InitialUp</a>) will always contain normalized values.  <p>AInitialUp will be also automatically corrected to be orthogonal to AInitialDirection. We will correct AInitialUp to make it orthogonal, but still preserving the plane they were indicating together with AInitialDirection. Do not ever give here AInitialUp that is parallel to AInitialDirection.  <p>If TransformCurrentCamera = <code>True</code>, then they will also try to change current camera relative to the initial vectors changes. This implements VRML/X3D desired behavior that &quot;viewer position/orientation is conceptually a child of viewpoint position/orientation, and when viewpoint position/orientation changes, viewer should also change&quot;.    ", "tags": "", "loc": "CastleCameras.TCamera.html#SetInitialView"},
     {"title": "CastleCameras.TCamera.GoToInitial", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#GoToInitial"},
     {"title": "CastleCameras.TCamera.GetNavigationType", "text": "    ", "tags": "", "loc": "CastleCameras.TCamera.html#GetNavigationType"},
     {"title": "CastleCameras.TCamera.CorrectPreferredHeight", "text": "  <p>Exactly what and why is done: if you do any kind of collision detection with some Radius, then you should make sure that RealPreferredHeight is always &gt;= of your Radius, otherwise strange effects may happen when crouching or when head bobbing forces camera to go down.  <p>Exactly, the required equation is  <p></p>  <pre class=\"preformatted\"> MinimumRealPreferredHeight :=   PreferredHeight * CrouchHeight * (1 - HeadBobbing);</pre>  <p>  <p>and always must be  <p></p>  <pre class=\"preformatted\"> MinimumRealPreferredHeight &gt;= RealPreferredHeight</pre>  <p>  <p>Reasoning: otherwise this class would &quot;want camera to fall down&quot; (because we will always be higher than RealPreferredHeight) but your OnMoveAllowed would not allow it (because Radius would not allow it). Note that this class doesn't keep value of your Radius, because collision detection is (by design) never done by this class &mdash; it's always delegated to OnHeight and OnMoveAllowed. Also, it's not exactly forced <i>how</i> you should force this condition to hold. Sometimes the good solution is to adjust Radius, not to adjust <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a>.  <p>Anyway, this method will make sure that this condition holds by eventually adjusting (making larger) <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a>. Note that for Radius = 0.0 this will always leave <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a> as it is.    ", "tags": "", "loc": "CastleCameras.TCamera.html#CorrectPreferredHeight"},
     {"title": "CastleCameras.TCamera.IgnoreAllInputs", "text": " <code><code>IgnoreAllInputs</code> := true</code> is equivalent to <code>Input := []</code>, <code><code>IgnoreAllInputs</code> := false</code> is equivalent to <code>Input := <a class=\"normal\" href=\"CastleCameras.TCamera.html#DefaultInput\">DefaultInput</a></code>.  ", "tags": "", "loc": "CastleCameras.TCamera.html#IgnoreAllInputs"},
     {"title": "CastleCameras.TCamera.Frustum", "text": " This is recalculated whenever one of these two properties change. Be sure to set <a class=\"normal\" href=\"CastleCameras.TCamera.html#ProjectionMatrix\">ProjectionMatrix</a> before using this. ", "tags": "", "loc": "CastleCameras.TCamera.html#Frustum"},
     {"title": "CastleCameras.TCamera.ProjectionMatrix", "text": " Camera needs to know this to calculate <a class=\"normal\" href=\"CastleCameras.TCamera.html#Frustum\">Frustum</a>, which in turn allows rendering code to use frustum culling.  <p>In normal circumstances, if you use our <i>scene manager</i> and viewport (<a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html\">TCastleAbstractViewport</a>) for rendering, this is automatically correctly set for you. ", "tags": "", "loc": "CastleCameras.TCamera.html#ProjectionMatrix"},
     {"title": "CastleCameras.TCamera.Radius", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Collision detection routines use this.</p></li>   <li><p>It determines the projection near plane (that must be slightly smaller than this radius) for 3D rendering.</p></li>   <li><p> Walk camera uses this for automatically correcting <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a>, otherwise weird things could happen if your avatar height is too small compared to camera radius. See <a class=\"normal\" href=\"CastleCameras.TCamera.html#CorrectPreferredHeight\">CorrectPreferredHeight</a>.  <p>Especially useful if you let user change <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a> at runtime by Input_IncreasePreferredHeight, Input_DecreasePreferredHeight.  <p>This is actually the whole use of <a class=\"normal\" href=\"CastleCameras.TCamera.html#Radius\">Radius</a> inside <a class=\"normal\" href=\"CastleCameras.html\">CastleCameras</a> unit and classes. But the code all around the engine also looks for this <a class=\"normal\" href=\"CastleCameras.TCamera.html#Radius\">Radius</a>, and the camera is a natural place to keep this information.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleCameras.TCamera.html#Radius"},
     {"title": "CastleCameras.TCamera.Position", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#Position"},
     {"title": "CastleCameras.TCamera.GravityUp", "text": " Always normalized (when setting this property, we take care to normalize the provided vector).  <p>This determines in which direction <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">TWalkCamera.Gravity</a> works.  <p>This is also the &quot;normal&quot; value for both <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">TWalkCamera.Up</a> and <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialUp\">InitialUp</a> &mdash; one that means that player is looking straight foward. This is used for features like PreferGravityUpForRotations and/or PreferGravityUpForMoving.  <p>The default value of this vector is (0, 1, 0) (same as the default <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">TWalkCamera.Up</a> and <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialUp\">InitialUp</a> vectors). ", "tags": "", "loc": "CastleCameras.TCamera.html#GravityUp"},
     {"title": "CastleCameras.TCamera.InitialPosition", "text": "  <p><a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialDirection\">InitialDirection</a> and <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialUp\">InitialUp</a> must be always normalized, and orthogonal.  <p>Default value of <code>InitialPosition</code> is (0, 0, 0), <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialDirection\">InitialDirection</a> is <a class=\"normal\" href=\"CastleCameras.html#DefaultCameraDirection\">DefaultCameraDirection</a> = (0, -1, 0), <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialUp\">InitialUp</a> is <a class=\"normal\" href=\"CastleCameras.html#DefaultCameraUp\">DefaultCameraUp</a> = (0, 1, 0).  <p> ", "tags": "", "loc": "CastleCameras.TCamera.html#InitialPosition"},
     {"title": "CastleCameras.TCamera.InitialDirection", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#InitialDirection"},
     {"title": "CastleCameras.TCamera.InitialUp", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#InitialUp"},
     {"title": "CastleCameras.TCamera.EnableDragging", "text": " This is an additional condition to enable mouse dragging, above the existing <a class=\"normal\" href=\"CastleCameras.html#ciMouseDragging\">ciMouseDragging</a> in Input. It is set internally by scene manager, to prevent camera navigation by dragging when we already drag a 3D item (like X3D TouchSensor). ", "tags": "", "loc": "CastleCameras.TCamera.html#EnableDragging"},
     {"title": "CastleCameras.TCamera.PreferredHeight", "text": " The <a class=\"normal\" href=\"CastleCameras.TCamera.html#Position\">Position</a> tries to stay <code>PreferredHeight</code> above the ground. Temporarily it may still be lower (e.g. player can shortly &quot;duck&quot; when he falls from high).  <p>This must always be &gt;= 0. You should set this to something greater than zero to get sensible behavior of some things related to <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">TWalkCamera.Gravity</a>, and also you should set OnHeight.  <p>See <a class=\"normal\" href=\"CastleCameras.TCamera.html#CorrectPreferredHeight\">CorrectPreferredHeight</a> for important property of <code>PreferredHeight</code> that you should keep. ", "tags": "", "loc": "CastleCameras.TCamera.html#PreferredHeight"},
     {"title": "CastleCameras.TCamera.CrouchHeight", "text": " This is always mutiplied to <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a>. This should always be &lt;= 1 (<code>CrouchHeight</code> = 1 effectively disables crouching, although it's better to do this by calling MakeClear on Input_Crouch). ", "tags": "", "loc": "CastleCameras.TCamera.html#CrouchHeight"},
     {"title": "CastleCameras.TCamera.HeadBobbing", "text": "  <p>This property mutiplied by <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a> says how much head bobbing can move you along <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a>. Set this to 0 to disable head bobbing. This must always be &lt; 1.0. For sensible effects, this should be rather close to 0.0, for example 0.02.  <p>This is meaningfull only when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">TWalkCamera.Gravity</a> works. ", "tags": "", "loc": "CastleCameras.TCamera.html#HeadBobbing"},
     {"title": "CastleCameras.TCamera.HeadBobbingTime", "text": " In the time of <code>HeadBobbingTime</code> seconds, we do full head bobbing sequence (camera swing up, then down again).  <p>Note that if you do a footsteps sound in your game (see <a class=\"normal\" href=\"CastleSoundEngine.html#stPlayerFootstepsDefault\">stPlayerFootstepsDefault</a> or <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperty.html#FootstepsSound\">TMaterialProperty.FootstepsSound</a>) then you will want this property to match your footsteps sound length, things feel and sound natural then. Also, often it sounds better to record two footsteps inside a single sound file, in which case the footstep sound length should be twice as long as this property. For example, record 2 steps inside a 1-second long footstep sound, and set this property to 0.5 a second (which is a default in fact). ", "tags": "", "loc": "CastleCameras.TCamera.html#HeadBobbingTime"},
     {"title": "CastleCameras.TCamera.MoveHorizontalSpeed", "text": " <code>MoveHorizontalSpeed</code> is only for horizontal movement, <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveVerticalSpeed\">MoveVerticalSpeed</a> is only for vertical, and <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveSpeed\">MoveSpeed</a> simply affects both types of movement. Effectively, we always scale the speed of movement by either <code><code>MoveHorizontalSpeed</code> * <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveSpeed\">MoveSpeed</a></code> or <code><a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveVerticalSpeed\">MoveVerticalSpeed</a> * <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveSpeed\">MoveSpeed</a></code>.  <p>We move by distance <code><a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveSpeed\">MoveSpeed</a> * <code>MoveHorizontalSpeed</code> (or <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveVerticalSpeed\">MoveVerticalSpeed</a>)</code> during one second. So if you leave <code>MoveHorizontalSpeed</code> = <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveVerticalSpeed\">MoveVerticalSpeed</a> = 1 (as default), <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveSpeed\">MoveSpeed</a> expresses the speed in nice units / per second.  <p>Default values for all these speed properties is 1.0, so you simply move by 1 unit per second.  <p> ", "tags": "", "loc": "CastleCameras.TCamera.html#MoveHorizontalSpeed"},
     {"title": "CastleCameras.TCamera.MoveVerticalSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#MoveVerticalSpeed"},
     {"title": "CastleCameras.TCamera.MoveSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TCamera.html#MoveSpeed"},
     {"title": "CastleCameras.TCamera.ClimbHeight", "text": " This is checked in each single horizontal move when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">TWalkCamera.Gravity</a> works. Must be &gt;= 0. Value 0 means there is no limit (and makes a small speedup).  <p>This is reliable to prevent user from climbing stairs and such, when vertical walls are really vertical (not just steep-almost-vertical).  <p>It's not 100% reliable to prevent player from climbing steep hills. That's because, depending on how often an event processing occurs, you actually climb using less or more steps. So even a very steep hill can be always climbed on a computer with very fast speed, because with large FPS you effectively climb it using a lot of very small steps (assuming that FPS limit is not enabled, that is <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#LimitFPS\">CastleWindow.TCastleApplication.LimitFPS</a> or <a class=\"normal\" href=\"CastleControl.html#LimitFPS\">CastleControl.LimitFPS</a> is zero).  <p>Remember that user can still try jumping to climb on high obstactes. See <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#JumpMaxHeight\">TWalkCamera.JumpMaxHeight</a> for a way to control jumping.  <p>For a 100% reliable way to prevent user from reaching some point, that does not rely on specific camera/gravity settings, you should build actual walls in 3D (invisible walls can be created by Collision.proxy in VRML/X3D). ", "tags": "", "loc": "CastleCameras.TCamera.html#ClimbHeight"},
     {"title": "CastleCameras.TCamera.ModelBox", "text": " It is crucial to set this to make <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> behave OK.  <p>Initially this is <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Empty\">TBox3D.Empty</a>. ", "tags": "", "loc": "CastleCameras.TCamera.html#ModelBox"},
     {"title": "CastleCameras.TCamera.Input", "text": " See documentation of <a class=\"normal\" href=\"CastleCameras.html#TCameraInput\">TCameraInput</a> type for possible values and their meaning.  <p>To disable any user interaction with camera (for example, to implement X3D &quot;NONE&quot; navigation type) you can simply set this to empty. ", "tags": "", "loc": "CastleCameras.TCamera.html#Input"},
     {"title": "CastleCameras.TExamineCamera", "text": " The model is moved by <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html#Translation\">Translation</a>, rotated by <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html#Rotations\">Rotations</a> and scaled by <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html#ScaleFactor\">ScaleFactor</a>. ", "tags": "", "loc": "CastleCameras.TExamineCamera.html"},
     {"title": "CastleCameras.TExamineCamera.DefaultRotationAccelerationSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#DefaultRotationAccelerationSpeed"},
     {"title": "CastleCameras.TExamineCamera.DefaultRotationSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#DefaultRotationSpeed"},
     {"title": "CastleCameras.TExamineCamera.GetPositionInternal", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#GetPositionInternal"},
     {"title": "CastleCameras.TExamineCamera.SetPosition", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#SetPosition"},
     {"title": "CastleCameras.TExamineCamera.Create", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Create"},
     {"title": "CastleCameras.TExamineCamera.Destroy", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Destroy"},
     {"title": "CastleCameras.TExamineCamera.Matrix", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Matrix"},
     {"title": "CastleCameras.TExamineCamera.MatrixInverse", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#MatrixInverse"},
     {"title": "CastleCameras.TExamineCamera.RotationMatrix", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#RotationMatrix"},
     {"title": "CastleCameras.TExamineCamera.Update", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Update"},
     {"title": "CastleCameras.TExamineCamera.AllowSuspendForInput", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#AllowSuspendForInput"},
     {"title": "CastleCameras.TExamineCamera.Press", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Press"},
     {"title": "CastleCameras.TExamineCamera.Motion", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Motion"},
     {"title": "CastleCameras.TExamineCamera.SensorTranslation", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#SensorTranslation"},
     {"title": "CastleCameras.TExamineCamera.SensorRotation", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#SensorRotation"},
     {"title": "CastleCameras.TExamineCamera.Init", "text": "  <p>In other words, this is just a shortcut to setting <a class=\"normal\" href=\"CastleCameras.TCamera.html#ModelBox\">ModelBox</a>, setting suitable initial view by <a class=\"normal\" href=\"CastleCameras.TCamera.html#SetInitialView\">SetInitialView</a>, and then going to initial view by <a class=\"normal\" href=\"CastleCameras.TCamera.html#GoToInitial\">GoToInitial</a>.    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Init"},
     {"title": "CastleCameras.TExamineCamera.StopRotating", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#StopRotating"},
     {"title": "CastleCameras.TExamineCamera.Scale", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Scale"},
     {"title": "CastleCameras.TExamineCamera.Move", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Move"},
     {"title": "CastleCameras.TExamineCamera.GetView", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#GetView"},
     {"title": "CastleCameras.TExamineCamera.SetView", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#SetView"},
     {"title": "CastleCameras.TExamineCamera.VisibleChange", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#VisibleChange"},
     {"title": "CastleCameras.TExamineCamera.GetNavigationType", "text": "    ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#GetNavigationType"},
     {"title": "CastleCameras.TExamineCamera.Rotations", "text": " Rotation is done around <a class=\"normal\" href=\"CastleCameras.TCamera.html#ModelBox\">ModelBox</a> middle (with <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html#Translation\">Translation</a> added). ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Rotations"},
     {"title": "CastleCameras.TExamineCamera.RotationsAnim", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#RotationsAnim"},
     {"title": "CastleCameras.TExamineCamera.DragMoveSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#DragMoveSpeed"},
     {"title": "CastleCameras.TExamineCamera.KeysMoveSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#KeysMoveSpeed"},
     {"title": "CastleCameras.TExamineCamera.MoveAmount", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#MoveAmount"},
     {"title": "CastleCameras.TExamineCamera.Translation", "text": " By default, zero. ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Translation"},
     {"title": "CastleCameras.TExamineCamera.Turntable", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Turntable"},
     {"title": "CastleCameras.TExamineCamera.ScaleFactor", "text": " <i>This property may never be zero (or close to zero).</i> ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#ScaleFactor"},
     {"title": "CastleCameras.TExamineCamera.Inputs_Move", "text": " Index the array (2nd index true means increase) instead of having to use the full identifier.  ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Inputs_Move"},
     {"title": "CastleCameras.TExamineCamera.Inputs_Rotate", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Inputs_Rotate"},
     {"title": "CastleCameras.TExamineCamera.Input_MoveXInc", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_MoveXInc"},
     {"title": "CastleCameras.TExamineCamera.Input_MoveXDec", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_MoveXDec"},
     {"title": "CastleCameras.TExamineCamera.Input_MoveYInc", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_MoveYInc"},
     {"title": "CastleCameras.TExamineCamera.Input_MoveYDec", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_MoveYDec"},
     {"title": "CastleCameras.TExamineCamera.Input_MoveZInc", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_MoveZInc"},
     {"title": "CastleCameras.TExamineCamera.Input_MoveZDec", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_MoveZDec"},
     {"title": "CastleCameras.TExamineCamera.Input_RotateXInc", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_RotateXInc"},
     {"title": "CastleCameras.TExamineCamera.Input_RotateXDec", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_RotateXDec"},
     {"title": "CastleCameras.TExamineCamera.Input_RotateYInc", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_RotateYInc"},
     {"title": "CastleCameras.TExamineCamera.Input_RotateYDec", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_RotateYDec"},
     {"title": "CastleCameras.TExamineCamera.Input_RotateZInc", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_RotateZInc"},
     {"title": "CastleCameras.TExamineCamera.Input_RotateZDec", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_RotateZDec"},
     {"title": "CastleCameras.TExamineCamera.Input_ScaleLarger", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_ScaleLarger"},
     {"title": "CastleCameras.TExamineCamera.Input_ScaleSmaller", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_ScaleSmaller"},
     {"title": "CastleCameras.TExamineCamera.Input_Home", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_Home"},
     {"title": "CastleCameras.TExamineCamera.Input_StopRotating", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#Input_StopRotating"},
     {"title": "CastleCameras.TExamineCamera.MouseNavigation", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#MouseNavigation"},
     {"title": "CastleCameras.TExamineCamera.RotationAccelerate", "text": " When <code>False</code>, you have to hold rotation keys to rotate. ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#RotationAccelerate"},
     {"title": "CastleCameras.TExamineCamera.RotationAccelerationSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#RotationAccelerationSpeed"},
     {"title": "CastleCameras.TExamineCamera.RotationSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TExamineCamera.html#RotationSpeed"},
     {"title": "CastleCameras.TWalkCamera", "text": " Camera is defined by it's position, looking direction and up vector, user can rotate and move camera using various keys. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html"},
     {"title": "CastleCameras.TWalkCamera.DefaultFallSpeedStart", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultFallSpeedStart"},
     {"title": "CastleCameras.TWalkCamera.DefaultGrowSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultGrowSpeed"},
     {"title": "CastleCameras.TWalkCamera.DefaultJumpMaxHeight", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultJumpMaxHeight"},
     {"title": "CastleCameras.TWalkCamera.DefaultMinAngleRadFromGravityUp", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultMinAngleRadFromGravityUp"},
     {"title": "CastleCameras.TWalkCamera.DefaultRotationHorizontalSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultRotationHorizontalSpeed"},
     {"title": "CastleCameras.TWalkCamera.DefaultRotationVerticalSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultRotationVerticalSpeed"},
     {"title": "CastleCameras.TWalkCamera.DefaultFallSpeedIncrease", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultFallSpeedIncrease"},
     {"title": "CastleCameras.TWalkCamera.DefaultMouseLookHorizontalSensitivity", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultMouseLookHorizontalSensitivity"},
     {"title": "CastleCameras.TWalkCamera.DefaultMouseLookVerticalSensitivity", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultMouseLookVerticalSensitivity"},
     {"title": "CastleCameras.TWalkCamera.DefaultJumpHorizontalSpeedMultiply", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultJumpHorizontalSpeedMultiply"},
     {"title": "CastleCameras.TWalkCamera.DefaultJumpTime", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultJumpTime"},
     {"title": "CastleCameras.TWalkCamera.DefaultMouseDraggingHorizontalRotationSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultMouseDraggingHorizontalRotationSpeed"},
     {"title": "CastleCameras.TWalkCamera.DefaultMouseDraggingVerticalRotationSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DefaultMouseDraggingVerticalRotationSpeed"},
     {"title": "CastleCameras.TWalkCamera.Height", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Height"},
     {"title": "CastleCameras.TWalkCamera.GetPositionInternal", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#GetPositionInternal"},
     {"title": "CastleCameras.TWalkCamera.SetPosition", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#SetPosition"},
     {"title": "CastleCameras.TWalkCamera.ReallyEnableMouseDragging", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#ReallyEnableMouseDragging"},
     {"title": "CastleCameras.TWalkCamera.Create", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Create"},
     {"title": "CastleCameras.TWalkCamera.Destroy", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Destroy"},
     {"title": "CastleCameras.TWalkCamera.Matrix", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Matrix"},
     {"title": "CastleCameras.TWalkCamera.RotationMatrix", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#RotationMatrix"},
     {"title": "CastleCameras.TWalkCamera.Update", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Update"},
     {"title": "CastleCameras.TWalkCamera.AllowSuspendForInput", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#AllowSuspendForInput"},
     {"title": "CastleCameras.TWalkCamera.Press", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Press"},
     {"title": "CastleCameras.TWalkCamera.SensorTranslation", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#SensorTranslation"},
     {"title": "CastleCameras.TWalkCamera.SensorRotation", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#SensorRotation"},
     {"title": "CastleCameras.TWalkCamera.DoMoveAllowed", "text": "  <p>ProposedNewPos is the position where the user wants to move (current user position is always stored in Position, so you can calculate move direction by ProposedNewPos - Position).  <p>This is the place to &quot;plug in&quot; your collision detection into camera.  <p>Returns false if no move is allowed. Otherwise returns true and sets NewPos to the position where user should be moved. E.g. if you're doing a simple test for collisions (with yes/no results), you will always want to set NewPos to ProposedNewPos when returning true. But you can also do more sophisticated calculations and sometimes not allow user to move to ProposedNewPos, but allow him to move instead to some other close position. E.g. look what's happening in quake (or just any first-person 3d game) when you're trying to walk &quot;into the wall&quot; at angle like 30 degrees: you're blocked, i.e. you obviously can't walk into the wall, but your position changes a bit and you're slowly moving alongside the wall. That's how you can use NewPos: you can return true and set NewPos to something that is not exactly ProposedNewPos (but is close to ProposedNewPos).  <p>Note that it's allowed to modify NewPos when returning false. This is meaningless, but may be comfortable for implementor of <code>DoMoveAllowed</code>.  <p>BecauseOfGravity says whether this move is caused by gravity dragging the camera down. Can happen only if <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">Gravity</a> is <code>True</code>. You can use BecauseOfGravity to control <code>DoMoveAllowed</code> behavior &mdash; e.g. view3dscene will not allow camera to move lower that some minimal plane when BecauseOfGravity (because this would mean that camera falls down infinitely), on the other hand when BecauseOfGravity is <code>False</code> moving outside bounding box is allowed (to allow camera to look at the scene from &quot;the outside&quot;).  <p>Basic implementation of <code>DoMoveAllowed</code> in this class: If <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnMoveAllowed\">OnMoveAllowed</a> = nil then returns true and sets NewPos to ProposedNewPos (so move is always allowed). Else calls <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnMoveAllowed\">OnMoveAllowed</a>.    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DoMoveAllowed"},
     {"title": "CastleCameras.TWalkCamera.DirectionInGravityPlane", "text": " This way it returns <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> projected on the gravity horizontal plane, which neutralizes such things like raising / bowing your head. Result is always normalized (length 1).  <p>Note that when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> and <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> are parallel, this just returns current <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> &mdash; because in such case we can't project <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> on the horizontal plane.    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#DirectionInGravityPlane"},
     {"title": "CastleCameras.TWalkCamera.Init", "text": " Sets initial camera properties (<a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialPosition\">InitialPosition</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialDirection\">InitialDirection</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialUp\">InitialUp</a>), sets current camera properties to them (Position := <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialPosition\">InitialPosition</a> and so on).  <p>Given here AInitialDirection, AInitialUp, AGravityUp will be normalized, and AInitialUp will be adjusted to be orthogonal to AInitialDirection (see <a class=\"normal\" href=\"CastleCameras.TCamera.html#SetInitialView\">SetInitialView</a>).  <p>Sets also <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a> and Radius. <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a> may be adjusted to be sensible (by calling <a class=\"normal\" href=\"CastleCameras.TCamera.html#CorrectPreferredHeight\">CorrectPreferredHeight</a>(ARadius)). You can pass ARadius = 0.0 if you really don't want this <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a> adjustment.    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Init"},
     {"title": "CastleCameras.TWalkCamera.Init", "text": " Sets InitialCameraXxx properties to make it look right, sets current CameraXxx properties to InitialCameraXxx. Sets <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> to the same thing as <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialUp\">InitialUp</a>. Sets also <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a> to make it behave &quot;sensibly&quot;.    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Init"},
     {"title": "CastleCameras.TWalkCamera.Motion", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Motion"},
     {"title": "CastleCameras.TWalkCamera.CancelFalling", "text": " It's much like forcing the opinion that &quot;camera is not falling down right now&quot;.  <p>Of course, if in the nearest Update we will find out (using <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnHeight\">OnHeight</a>) that camera is too high above the ground, then we will start falling down again, setting Falling back to true. (but then we will start falling down from the beginning, starting at given <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Position\">Position</a> and with initial falling down speed).  <p>This is useful to call if you just changed <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Position\">Position</a> because e.g. the player teleported somewhere (or e.g. game levels changed). In this case you just want to forget the fact that camera was falling down &mdash; no consequences (like lowering player's health, fadeout etc.).    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#CancelFalling"},
     {"title": "CastleCameras.TWalkCamera.MaxJumpDistance", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MaxJumpDistance"},
     {"title": "CastleCameras.TWalkCamera.RealPreferredHeight", "text": " It can be useful for collision detection between camera and something.    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#RealPreferredHeight"},
     {"title": "CastleCameras.TWalkCamera.FallOnTheGround", "text": " Nice to use when player died, and you want to show that it's body falled on the ground. This works by gradually changing <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">Up</a> such that it gets orthogonal to <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a>.    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#FallOnTheGround"},
     {"title": "CastleCameras.TWalkCamera.GetView", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#GetView"},
     {"title": "CastleCameras.TWalkCamera.SetView", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#SetView"},
     {"title": "CastleCameras.TWalkCamera.SetView", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#SetView"},
     {"title": "CastleCameras.TWalkCamera.GetNavigationType", "text": "    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#GetNavigationType"},
     {"title": "CastleCameras.TWalkCamera.UpPrefer", "text": " If necessary, the up vector provided here will be fixed to be orthogonal to direction. See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#UpPrefer\">TCastleTransform.UpPrefer</a> for detailed documentation what this does.    ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#UpPrefer"},
     {"title": "CastleCameras.TWalkCamera.OnMoveAllowed", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#OnMoveAllowed"},
     {"title": "CastleCameras.TWalkCamera.Position", "text": "  <p>Initially (after creating this object) they are equal to <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialPosition\">InitialPosition</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialDirection\">InitialDirection</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialUp\">InitialUp</a>. Also <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Init\">Init</a> and <a class=\"normal\" href=\"CastleCameras.TCamera.html#GoToInitial\">GoToInitial</a> methods reset them to these initial values.  <p>The <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">Up</a> vectors should always be normalized (have length 1). When setting them by these properties, we will normalize them automatically.  <p>Note that since engine &gt;= 2.2.0 the <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> vector should always be normalized (length 1), and so you cannot change move speed by scaling this vector. Use <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveSpeed\">MoveSpeed</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveHorizontalSpeed\">MoveHorizontalSpeed</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#MoveVerticalSpeed\">MoveVerticalSpeed</a> instead.  <p>When setting <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">Up</a> will always be automatically adjusted to be orthogonal to <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a>. And vice versa &mdash; when setting <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">Up</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> will be adjusted.  <p> ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Position"},
     {"title": "CastleCameras.TWalkCamera.Direction", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Direction"},
     {"title": "CastleCameras.TWalkCamera.Up", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Up"},
     {"title": "CastleCameras.TWalkCamera.PreferGravityUpForRotations", "text": "  <p>With <code>PreferGravityUpForRotations</code>, this affects rotations: horizontal rotations (<a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_LeftRot\">Input_LeftRot</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_RightRot\">Input_RightRot</a>) and rotations caused by <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MouseLook\">MouseLook</a>. Also vertical rotations are bounded by <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MinAngleRadFromGravityUp\">MinAngleRadFromGravityUp</a> when <code>PreferGravityUpForRotations</code>.  <p>Note that you can change it freely at runtime, and when you set <code>PreferGravityUpForRotations</code> from <code>False</code> to <code>True</code> then in nearest Update calls <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">Up</a> will be gradually fixed, so that <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">Up</a> and <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> are on the same plane. Also <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> may be adjusted to honour <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MinAngleRadFromGravityUp\">MinAngleRadFromGravityUp</a>.  <p>With <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">PreferGravityUpForMoving</a>, this affects moving: horizontal moving (forward, backward, strafe), and vertical moving (<a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_Jump\">Input_Jump</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_Crouch\">Input_Crouch</a> when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">Gravity</a> is <code>False</code>). E.g. when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">PreferGravityUpForMoving</a> then forward/backward keys are tied to horizontal plane defined by <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a>. When not <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">PreferGravityUpForMoving</a> then forward/backward try to move you just in the <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a>. Which is usually more handy when e.g. simulating flying.  <p>It's a delicate decision how to set them, because generally all the decisions are &quot;somewhat correct&quot; &mdash; they just sometimes &quot;feel incorrect&quot; for player.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> First of all, if the scene is not &quot;naturally oriented&quot; around <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a>, then you <b>may</b> set <code>PreferGravityUpForRotations</code> as <code>False</code> and you <b>should</b> leave <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">PreferGravityUpForMoving</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">Gravity</a> to <code>False</code>.  <p>By the scene &quot;naturally oriented around <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a>&quot; I mean that we have some proper <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a>, not just some guessed <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> that may be incorrect. For example when view3dscene loads a VRML model without any camera definition then it assumes that &quot;up vector&quot; is (0, 1, 0), because this is more-or-less VRML standard suggested by VRML spec. But this may be very inappopriate, for example the scene may be actually oriented with (0, 0, 1) up vector in mind.  <p>Other examples of the scenes without any &quot;naturally oriented around <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a>&quot; may be some &quot;outer space&quot; scene without any gravity.</p></li>   <li><p> With <code>PreferGravityUpForRotations</code> the &quot;feeling&quot; of <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> is stronger for user, because <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">Up</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> always define the same plane in 3D space (i.e. along with the 4th point, (0, 0, 0), for camera eye). Raising/bowing the head doesn't break this assumption.  <p>Without <code>PreferGravityUpForRotations</code>, we quickly start to do rotations in an awkward way &mdash; once you do some vertical rotation, you changed <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">Up</a>, and next horizontal rotation will be done versus new <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Up\">Up</a>.  <p>If your <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> is good, then you generally should leave <code>PreferGravityUpForRotations</code> to <code>True</code>. Unless you really <b>want</b> the player to feel movements as &quot;awkward&quot;, e.g. when you want to simulate this &quot;outer space without any gravity&quot; feeling.</p></li>   <li><p> If your <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> is good, then you generally should set <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">PreferGravityUpForMoving</a> just like Gravity.  <p>E.g. when the player is flying / swimming etc. he will probably prefer <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">PreferGravityUpForMoving</a> = <code>False</code>, because this way he will not have to press <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_Jump\">Input_Jump</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_Crouch\">Input_Crouch</a>. Simply pressing <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_Forward\">Input_Forward</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_Backward\">Input_Backward</a> and doing rotations will be enough to move freely in 3D space.  <p>When gravity works, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">PreferGravityUpForMoving</a> = <code>True</code> is better, otherwise player would unnecessarily try to jump when looking up.</p></li> </ul>  <p>  <p> ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#PreferGravityUpForRotations"},
     {"title": "CastleCameras.TWalkCamera.PreferGravityUpForMoving", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#PreferGravityUpForMoving"},
     {"title": "CastleCameras.TWalkCamera.MinAngleRadFromGravityUp", "text": " This way vertical rotations (like <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_UpRotate\">Input_UpRotate</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_DownRotate\">Input_DownRotate</a>) are &quot;bounded&quot; to not allow player to do something strange, i.e. bow your head too much and raise your head too much.  <p>This is used only when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForRotations\">PreferGravityUpForRotations</a> is <code>True</code> and when it's &lt;&gt; 0.0.  <p>This must be always between 0 and Pi/2. Value of Pi/2 will effectively disallow vertical rotations (although you should rather do this in a &quot;cleaner way&quot; by calling MakeClear on <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_UpRotate\">Input_UpRotate</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_DownRotate\">Input_DownRotate</a>). ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MinAngleRadFromGravityUp"},
     {"title": "CastleCameras.TWalkCamera.MouseLook", "text": "  <p>This also makes mouse cursor of Container hidden, and forces mouse position to the middle of the window (to avoid the situation when mouse movement is blocked by screen borders). ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MouseLook"},
     {"title": "CastleCameras.TWalkCamera.MouseLookHorizontalSensitivity", "text": " They say how much angle change is produced by moving mouse by 1 pixel. You can change this, to better adjust to user.  <p> ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MouseLookHorizontalSensitivity"},
     {"title": "CastleCameras.TWalkCamera.MouseLookVerticalSensitivity", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MouseLookVerticalSensitivity"},
     {"title": "CastleCameras.TWalkCamera.InvertVerticalMouseLook", "text": " Many players are more comfortable with such configuration, and many games implement it (usually by calling it &quot;Invert mouse&quot; for short). ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#InvertVerticalMouseLook"},
     {"title": "CastleCameras.TWalkCamera.MouseDragMode", "text": " Used only when <a class=\"normal\" href=\"CastleCameras.html#ciMouseDragging\">ciMouseDragging</a> in <a class=\"normal\" href=\"CastleCameras.TCamera.html#Input\">Input</a>. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MouseDragMode"},
     {"title": "CastleCameras.TWalkCamera.Gravity", "text": " Gravity always drags the camera down to -<a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a>.  <p>Summary of things done by gravity: </p>  <ul class=\"paragraph_spacing\">   <li><p>It uses <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnHeight\">OnHeight</a> to get camera height above the ground.</p></li>   <li><p>It allows player to jump. See <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_Jump\">Input_Jump</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#IsJumping\">IsJumping</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#JumpMaxHeight\">JumpMaxHeight</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#JumpHorizontalSpeedMultiply\">JumpHorizontalSpeedMultiply</a>.</p></li>   <li><p>It allows player to crouch. See <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_Crouch\">Input_Crouch</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#CrouchHeight\">CrouchHeight</a>.</p></li>   <li><p>It tries to keep <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Position\">Position</a> above the ground on <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a> height.</p></li>   <li><p>When current height is too small &mdash; <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Position\">Position</a> is moved up. See <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#GrowSpeed\">GrowSpeed</a>.</p></li>   <li><p>When current height is too large &mdash; we're falling down. See Falling, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnFall\">OnFall</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#FallSpeedStart\">FallSpeedStart</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#FallSpeedIncrease\">FallSpeedIncrease</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#FallingEffect\">FallingEffect</a>.</p></li>   <li><p>It does head bobbing. See <a class=\"normal\" href=\"CastleCameras.TCamera.html#HeadBobbing\">HeadBobbing</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#HeadBobbingTime\">HeadBobbingTime</a>.</p></li> </ul>  <p>  <p>While there are many properties allowing you to control gravity behavior, most of them have initial values that should be sensible in all cases. The only things that you really want to take care of are: <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnHeight\">OnHeight</a> and <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a>. Everything else should basically work auto-magically.  <p>Note that Gravity setting is independent from <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForRotations\">PreferGravityUpForRotations</a> or <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">PreferGravityUpForMoving</a> settings &mdash; PreferGravityUpXxx say how the player controls work, Gravity says what happens to player due to ... well, due to gravity. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Gravity"},
     {"title": "CastleCameras.TWalkCamera.OnHeight", "text": " This should be calculated like collision of ray from <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Position\">Position</a> in direction -<a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> with the scene. See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Height\">TCastleTransform.Height</a> for specification what returned parameters mean.  <p>Implementation of <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Height\">Height</a> in this class calls <code>OnHeight</code>, if assigned. (If not assigned, we assume no collision: <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#IsAbove\">IsAbove</a> = <code>False</code>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#AboveHeight\">AboveHeight</a> = <a class=\"normal\" href=\"Castle3D.html#MaxSingle\">MaxSingle</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#AboveGround\">AboveGround</a> = <code>Nil</code>). ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#OnHeight"},
     {"title": "CastleCameras.TWalkCamera.OnFall", "text": " Of course this is used only when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">Gravity</a> is <code>True</code> (it can also be called shortly after you changed <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">Gravity</a> from <code>True</code> to <code>False</code>, so don't simply assert here that <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">Gravity</a> is <code>True</code>).  <p>This event can be useful in games, for example to lower player's health, and/or make a visual effect (like a &quot;red out&quot; indicating pain) and/or make a sound effect (&quot;Ouch!&quot; or &quot;Thud!&quot; or such sounds). You can look at FallHeight parameter, given to the callback, e.g. to gauge how much health decreases. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#OnFall"},
     {"title": "CastleCameras.TWalkCamera.FallSpeedStart", "text": " Of course this is used only when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">Gravity</a> is true.  <p>Note that while falling down, the camera will actually fall with greater and greated speed (this adds more realism to the gravity effect...). Note that this is always relative to <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> length. <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a> determines moving speed &mdash; and so it determines also falling speed. The default <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#DefaultFallSpeedStart\">DefaultFallSpeedStart</a> is chosen to be something sensible, to usually get nice effect of falling.  <p>You can change it at any time, but note that if you change this while Falling is <code>True</code>, then you will not change the &quot;current falling down speed&quot;. You will change only the falling down speed used the next time. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#FallSpeedStart"},
     {"title": "CastleCameras.TWalkCamera.FallSpeedIncrease", "text": " Set this to 1.0 to fall down with constant speed (taken from <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#FallSpeedStart\">FallSpeedStart</a>). ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#FallSpeedIncrease"},
     {"title": "CastleCameras.TWalkCamera.Falling", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Falling"},
     {"title": "CastleCameras.TWalkCamera.FallingEffect", "text": " This adds temporary camera rotations simulating that you rotate randomly and helplessly when falling down.  <p>Of course this is meaningfull only when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">Gravity</a> works.  <p>Note that changing it from <code>True</code> to <code>False</code> doesn't immediately &quot;cancel out&quot; this effect if it's currently in progress. It only prevents this effect from starting again. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#FallingEffect"},
     {"title": "CastleCameras.TWalkCamera.GrowSpeed", "text": " camera position increases along the <a class=\"normal\" href=\"CastleCameras.TCamera.html#GravityUp\">GravityUp</a> so that camera height above the ground is closer to <a class=\"normal\" href=\"CastleCameras.TCamera.html#PreferredHeight\">PreferredHeight</a>. This property (together with length of <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Direction\">Direction</a>, that always determines every moving speed) determines the speed of this growth. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#GrowSpeed"},
     {"title": "CastleCameras.TWalkCamera.JumpMaxHeight", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#JumpMaxHeight"},
     {"title": "CastleCameras.TWalkCamera.IsJumping", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#IsJumping"},
     {"title": "CastleCameras.TWalkCamera.JumpHorizontalSpeedMultiply", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#JumpHorizontalSpeedMultiply"},
     {"title": "CastleCameras.TWalkCamera.JumpTime", "text": " This is the time, in seconds, in takes to reach <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MaxJumpDistance\">MaxJumpDistance</a> height when jumping. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#JumpTime"},
     {"title": "CastleCameras.TWalkCamera.IsCrouching", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#IsCrouching"},
     {"title": "CastleCameras.TWalkCamera.FallingOnTheGround", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#FallingOnTheGround"},
     {"title": "CastleCameras.TWalkCamera.IsOnTheGround", "text": " This is set in every Update.  <p>You can use this e.g. to make some effects when player is on some special ground (standing or walking), e.g. hurt player when he's standing on some toxical ground.  <p> ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#IsOnTheGround"},
     {"title": "CastleCameras.TWalkCamera.IsWalkingOnTheGround", "text": " In other words, this is like &quot;<a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#IsOnTheGround\">IsOnTheGround</a> and (s)he's walking&quot;. This is set in every Update.  <p>The intention is that you can use this to make some &quot;footsteps&quot; sound for the player. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#IsWalkingOnTheGround"},
     {"title": "CastleCameras.TWalkCamera.IsAbove", "text": " Updated by using <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Height\">Height</a> call. For normal <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a> descendants, this means using <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnHeight\">OnHeight</a> callback.  <p>These are updated only when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Height\">Height</a> is continously called, which in practice means: only when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">Gravity</a> is <code>True</code>.  <p>We do not (and, currently, cannot) track here if <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#AboveGround\">AboveGround</a> pointer will be eventually released (which may happen if you release your 3D scene, or rebuild scene causing octree rebuild). This is not a problem for camera class, since we do not use this pointer for anything. But if you use this pointer, then you may want to take care to eventually set it to <code>Nil</code> when your octree or such is released.  <p> ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#IsAbove"},
     {"title": "CastleCameras.TWalkCamera.AboveHeight", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#AboveHeight"},
     {"title": "CastleCameras.TWalkCamera.AboveGround", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#AboveGround"},
     {"title": "CastleCameras.TWalkCamera.Input_Forward", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_Forward"},
     {"title": "CastleCameras.TWalkCamera.Input_Backward", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_Backward"},
     {"title": "CastleCameras.TWalkCamera.Input_LeftRot", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_LeftRot"},
     {"title": "CastleCameras.TWalkCamera.Input_RightRot", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_RightRot"},
     {"title": "CastleCameras.TWalkCamera.Input_LeftStrafe", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_LeftStrafe"},
     {"title": "CastleCameras.TWalkCamera.Input_RightStrafe", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_RightStrafe"},
     {"title": "CastleCameras.TWalkCamera.Input_UpRotate", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_UpRotate"},
     {"title": "CastleCameras.TWalkCamera.Input_DownRotate", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_DownRotate"},
     {"title": "CastleCameras.TWalkCamera.Input_IncreasePreferredHeight", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_IncreasePreferredHeight"},
     {"title": "CastleCameras.TWalkCamera.Input_DecreasePreferredHeight", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_DecreasePreferredHeight"},
     {"title": "CastleCameras.TWalkCamera.Input_GravityUp", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_GravityUp"},
     {"title": "CastleCameras.TWalkCamera.Input_Run", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_Run"},
     {"title": "CastleCameras.TWalkCamera.Input_MoveSpeedInc", "text": "  ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_MoveSpeedInc"},
     {"title": "CastleCameras.TWalkCamera.Input_MoveSpeedDec", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_MoveSpeedDec"},
     {"title": "CastleCameras.TWalkCamera.Input_Jump", "text": "  ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_Jump"},
     {"title": "CastleCameras.TWalkCamera.Input_Crouch", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#Input_Crouch"},
     {"title": "CastleCameras.TWalkCamera.MoveForward", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MoveForward"},
     {"title": "CastleCameras.TWalkCamera.MoveBackward", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MoveBackward"},
     {"title": "CastleCameras.TWalkCamera.AllowSlowerRotations", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#AllowSlowerRotations"},
     {"title": "CastleCameras.TWalkCamera.CheckModsDown", "text": "  <p>If <code>True</code> then all keys work only when no modifiers or only shift are pressed. Additionally when Ctrl is pressed (and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#AllowSlowerRotations\">AllowSlowerRotations</a>) then rotation keys work 10x slower. Also Increase/DecreasePreferredHeight work only when Ctrl pressed. Other keys with other modifiers don't work. We allow shift, because to press character &quot;+&quot; on non-numpad keyboard (useful on laptops, where numpad is difficult) you probably need to press shift.  <p>If <code>False</code> then all keys work as usual, no matter what modifiers are pressed. And rotation keys never work 10x slower (<a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#AllowSlowerRotations\">AllowSlowerRotations</a> is ignored), also Increase/DecreasePreferredHeight are ignored. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#CheckModsDown"},
     {"title": "CastleCameras.TWalkCamera.RotationHorizontalSpeed", "text": "  ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#RotationHorizontalSpeed"},
     {"title": "CastleCameras.TWalkCamera.RotationVerticalSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#RotationVerticalSpeed"},
     {"title": "CastleCameras.TWalkCamera.MouseDraggingHorizontalRotationSpeed", "text": " Relevant only if <a class=\"normal\" href=\"CastleCameras.html#ciMouseDragging\">ciMouseDragging</a> in <a class=\"normal\" href=\"CastleCameras.TCamera.html#Input\">Input</a>, and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MouseDragMode\">MouseDragMode</a> is <a class=\"normal\" href=\"CastleCameras.html#mdRotate\">mdRotate</a>. Separate for horizontal and vertical, this way you can e.g. limit (or disable) vertical rotations, useful for games where you mostly look horizontally and accidentally looking up/down is more confusing than useful.  ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MouseDraggingHorizontalRotationSpeed"},
     {"title": "CastleCameras.TWalkCamera.MouseDraggingVerticalRotationSpeed", "text": " ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#MouseDraggingVerticalRotationSpeed"},
     {"title": "CastleCameras.TWalkCamera.RotationHorizontalPivot", "text": " This is a poor-mans way to implement some 3rd camera game. Note that when non-zero this may (for now) move the camera without actually checking <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnMoveAllowed\">OnMoveAllowed</a>. ", "tags": "", "loc": "CastleCameras.TWalkCamera.html#RotationHorizontalPivot"},
     {"title": "CastleCameras.DefaultCameraDirection", "text": " These match X3D default camera values.  ", "tags": "", "loc": "CastleCameras.html#DefaultCameraDirection"},
     {"title": "CastleCameras.DefaultCameraUp", "text": " ", "tags": "", "loc": "CastleCameras.html#DefaultCameraUp"},
     {"title": "CastleCameras.CorrectPreferredHeight", "text": " This is a global version, sometimes may be useful.    ", "tags": "", "loc": "CastleCameras.html#CorrectPreferredHeight"},
     {"title": "CastleCameras.OrientationFromDirectionUp", "text": "  <p>Orientation vector expresses Direction and Up as a rotation. First three components of the resulting vector are the Axis (normalized) and the 4th component is the Angle (in radians). If you would rotate the standard direction and up (see <a class=\"normal\" href=\"CastleCameras.html#DefaultCameraDirection\">DefaultCameraDirection</a>, <a class=\"normal\" href=\"CastleCameras.html#DefaultCameraUp\">DefaultCameraUp</a>) around Axis by the Angle, then you would get Direction and Up back.  <p>There is an overloaded version where you can pass your custom DefaultDirection, DefaultUp to be used instead of default <a class=\"normal\" href=\"CastleCameras.html#DefaultCameraDirection\">DefaultCameraDirection</a>, <a class=\"normal\" href=\"CastleCameras.html#DefaultCameraUp\">DefaultCameraUp</a>.  <p>Given here Direction and Up must be orthogonal and non-zero. Their lengths are not relevant (that is, you don't need to normalize them before passing here).  <p>    ", "tags": "", "loc": "CastleCameras.html#OrientationFromDirectionUp"},
     {"title": "CastleCameras.OrientationFromDirectionUp", "text": "    ", "tags": "", "loc": "CastleCameras.html#OrientationFromDirectionUp"},
     {"title": "CastleCameras.OrientationFromDirectionUp", "text": "    ", "tags": "", "loc": "CastleCameras.html#OrientationFromDirectionUp"},
     {"title": "CastleCameras.OrientationToDirection", "text": "    ", "tags": "", "loc": "CastleCameras.html#OrientationToDirection"},
     {"title": "CastleCameras.OrientationToUp", "text": "    ", "tags": "", "loc": "CastleCameras.html#OrientationToUp"},
     {"title": "CastleCameras.CamDirUp2Orient", "text": "    ", "tags": "", "loc": "CastleCameras.html#CamDirUp2Orient"},
     {"title": "CastleCameras.CamDirUp2Orient", "text": "    ", "tags": "", "loc": "CastleCameras.html#CamDirUp2Orient"},
     {"title": "CastleCameras.OrientationQuaternionFromDirectionUp", "text": " Just like <a class=\"normal\" href=\"CastleCameras.html#OrientationFromDirectionUp\">OrientationFromDirectionUp</a>, but the result is a quaternion, not an axis-angle vector.     ", "tags": "", "loc": "CastleCameras.html#OrientationQuaternionFromDirectionUp"},
     {"title": "CastleCameras.OrientationQuaternionFromDirectionUp", "text": "    ", "tags": "", "loc": "CastleCameras.html#OrientationQuaternionFromDirectionUp"},
     {"title": "CastleCameras.CamDirUp2OrientQuat", "text": "    ", "tags": "", "loc": "CastleCameras.html#CamDirUp2OrientQuat"},
     {"title": "CastleCameras.CameraViewpointForWholeScene", "text": "  <p>WantedDirection and WantedUp indicate desired look direction/up axis (0, 1 or 2 for X, Y or Z). WantedDirectionPositive and WantedUpPositive indicate if we want the positive axis. Obviously look direction and up cannot be parallel, so WantedDirection must be different than WantedUp.  <p>Returned Direction, Up, GravityUp are normalized.    ", "tags": "", "loc": "CastleCameras.html#CameraViewpointForWholeScene"},
     {"title": "CastleCameras.Register", "text": "    ", "tags": "", "loc": "CastleCameras.html#Register"},
     {"title": "CastleCameras.TCameraInput", "text": "  ciNormal Normal input types.  This includes all inputs available as Input_Xxx properties in <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a> descendants. They are all fully configurable (as <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> class), they may be mouse button presses, mouse wheel clicks, or key presses. You can always clear some shortcut (like <code>WalkCamera.Input_Forward.MakeClear</code>) to disable a specific shortcut. Excluding <code>ciNormal</code> from <a class=\"normal\" href=\"CastleCameras.TCamera.html#Input\">TCamera.Input</a> is an easy way to disable <i>all</i> shortcuts.  ciMouseDragging Mouse and touch dragging.  Both <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> implement their own, special reactions to mouse dragging, that allows to navigate / rotate while pressing specific mouse buttons.  <p>Note that mouse dragging is automatically disabled when <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MouseLook\">TWalkCamera.MouseLook</a> is used.  ci3dMouse Navigation using 3D mouse devices, like the ones from 3dconnexion.  ", "tags": "", "loc": "CastleCameras.html#TCameraInput"},
     {"title": "CastleCameras.TCameraInputs", "text": " ", "tags": "", "loc": "CastleCameras.html#TCameraInputs"},
     {"title": "CastleCameras.TNavigationType", "text": "  ntExamine Examine mode, comfortable to rotate the scene like an item held in your hand.  Uses <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a>.  ntTurntable Turntable mode, similar to examine mode, but with a bit different interpretation of moves.  Uses <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a>.  ntWalk Walk mode, comfortable to walk around the scene with gravity.  Uses <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a>.  ntFly Fly mode, comfortable to move around around the scene without gravity.  Uses <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a>.  ntNone Disable user navigation on the scene.  Uses <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a>. ", "tags": "", "loc": "CastleCameras.html#TNavigationType"},
     {"title": "CastleCameras.TCameraClass", "text": " ", "tags": "", "loc": "CastleCameras.html#TCameraClass"},
     {"title": "CastleCameras.T3BoolInputs", "text": " ", "tags": "", "loc": "CastleCameras.html#T3BoolInputs"},
     {"title": "CastleCameras.TMouseDragMode", "text": "  mdWalk Moves avatar continously in the direction of mouse drag (default for <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MouseDragMode\">TWalkCamera.MouseDragMode</a>).   mdRotate Rotates the head when mouse is moved.   mdNone Ignores the dragging.  ", "tags": "", "loc": "CastleCameras.html#TMouseDragMode"},
     {"title": "CastleCameras.TMoveAllowedFunc", "text": "    ", "tags": "", "loc": "CastleCameras.html#TMoveAllowedFunc"},
     {"title": "CastleCameras.TFallNotifyFunc", "text": "    ", "tags": "", "loc": "CastleCameras.html#TFallNotifyFunc"},
     {"title": "CastleCameras.THeightEvent", "text": "    ", "tags": "", "loc": "CastleCameras.html#THeightEvent"},
     {"title": "CastleCameras.TUniversalCamera", "text": " ", "tags": "", "loc": "CastleCameras.html#TUniversalCamera"},
     {"title": "CastleClassUtils", "text": " Many utilities for classes that are defined in the Classes unit, and some classes of our my own.  <p>Some notes about TStream descendants : </p>  <ul class=\"paragraph_spacing\">   <li><p> I call a stream &quot;purely sequential&quot; (or just &quot;sequential&quot;) if it allows only reading and/or writing of data and does not allow free &quot;Seek&quot; calls, in particular &mdash; it does not allow Seek to move back in a stream.</p></li>   <li><p> I call a stream &quot;growing&quot; if it's read-only and it's purely sequential and it's Size property may be useless. In other words, when you read a &quot;growing&quot; stream, you don't know when it ends, until you reach the end. You just have to read data until Read returns 0.</p></li>   <li><p>Remember that to reliably detect end of the stream when you use TStream.Read, you have to test is ReadCount = 0. Merely testing that ReadCount &lt; less than you requested is not enough, e.g. seen for THandleStream when handle is StdIn.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleClassUtils.html"},
     {"title": "CastleClassUtils.TStringListCaseSens", "text": " ", "tags": "", "loc": "CastleClassUtils.TStringListCaseSens.html"},
     {"title": "CastleClassUtils.TStringListCaseSens.Create", "text": "    ", "tags": "", "loc": "CastleClassUtils.TStringListCaseSens.html#Create"},
     {"title": "CastleClassUtils.TStringListCaseSens.CaseSensitive", "text": " ", "tags": "", "loc": "CastleClassUtils.TStringListCaseSens.html#CaseSensitive"},
     {"title": "CastleClassUtils.EStreamNotImplemented", "text": " ", "tags": "", "loc": "CastleClassUtils.EStreamNotImplemented.html"},
     {"title": "CastleClassUtils.EStreamNotImplementedWrite", "text": " ", "tags": "", "loc": "CastleClassUtils.EStreamNotImplementedWrite.html"},
     {"title": "CastleClassUtils.EStreamNotImplementedSeek", "text": " ", "tags": "", "loc": "CastleClassUtils.EStreamNotImplementedSeek.html"},
     {"title": "CastleClassUtils.EStreamNotImplementedSetSize", "text": " ", "tags": "", "loc": "CastleClassUtils.EStreamNotImplementedSetSize.html"},
     {"title": "CastleClassUtils.TPeekCharStream", "text": " This is a purely sequential read-only stream. This means that calling <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html#Write\">Write</a>, <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html#Seek\">Seek</a> (changing Position) or setting <code>Size</code> will always cause an exception with appropriate descendant of <a class=\"normal\" href=\"CastleClassUtils.EStreamNotImplemented.html\">EStreamNotImplemented</a>.  <p>Getting <code>Size</code> and <code>Position</code> is allowed. Getting <code>Size</code> is simply implemented by getting SourceStream.Size (so it works if the underlying source stream supports getting Size). Getting <code>Position</code> always works correctly, as it's just the number of characters <i>read</i> from this stream. The fact that we may read ahead in the underlying source stream (for buffering, for peeking) is completely hidden.  <p>We do not assume anything about the underlying source stream, in particular the underlying source stream may also be purely sequential (so we can only read from it, and we cannot predict when it ends).  <p>The main advantage of using this class is that you get <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html#PeekChar\">PeekChar</a> routine: you can always peek ahead one character in the stream, without reading it (i.e. next time you will call Read or ReadBuffer you will still get that char). And it works for all source streams, including the ones where seeking is not allowed (so Seek(-1, soCurrent) would not work).  <p>Another advantage is the <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html#Line\">Line</a> and <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html#Column\">Column</a> information. ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html"},
     {"title": "CastleClassUtils.TPeekCharStream.GetSize", "text": "   SourceStream.Size ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#GetSize"},
     {"title": "CastleClassUtils.TPeekCharStream.SetSize", "text": " (All other versions of <code>SetSize</code> also call this.)     EStreamNotImplementedSetSize Always.", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#SetSize"},
     {"title": "CastleClassUtils.TPeekCharStream.UpdateLineColumn", "text": "    ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#UpdateLineColumn"},
     {"title": "CastleClassUtils.TPeekCharStream.UpdateLineColumn", "text": "    ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#UpdateLineColumn"},
     {"title": "CastleClassUtils.TPeekCharStream.Create", "text": "    ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#Create"},
     {"title": "CastleClassUtils.TPeekCharStream.Destroy", "text": "    ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#Destroy"},
     {"title": "CastleClassUtils.TPeekCharStream.Seek", "text": " (SetPosition and all other versions of Seek also call this.)     EStreamNotImplementedSeek Always.", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#Seek"},
     {"title": "CastleClassUtils.TPeekCharStream.Write", "text": " (WriteBuffer also calls this.)     EStreamNotImplementedWrite Always.", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#Write"},
     {"title": "CastleClassUtils.TPeekCharStream.PeekChar", "text": " Returns the next character without making it &quot;already read&quot;, so the next call to Read or ReadBuffer will return this char. Subsequent calls to <code>PeekChar</code> (without any Read/ReadBuffer between) will also return the same character.  <p>Returns -1 if stream ended, otherwise returns Ord or given char.  <p>This may call SourceStream.Read, and any exceptions that may be raised in SourceStream.Read are propagated higher from this method.    ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#PeekChar"},
     {"title": "CastleClassUtils.TPeekCharStream.ReadChar", "text": " A shortcut for Read(c, 1), but it returns -1 if end of stream is reached. So it's consistent with <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html#PeekChar\">PeekChar</a>. Sometimes it's also more comfortable, and it's a little faster.    ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#ReadChar"},
     {"title": "CastleClassUtils.TPeekCharStream.ReadUpto", "text": " The ending character is not &quot;consumed&quot; from the stream. The Result is guaranteed to not contain any char from EndingChars.    ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#ReadUpto"},
     {"title": "CastleClassUtils.TPeekCharStream.SourceStream", "text": " ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#SourceStream"},
     {"title": "CastleClassUtils.TPeekCharStream.OwnsSourceStream", "text": " ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#OwnsSourceStream"},
     {"title": "CastleClassUtils.TPeekCharStream.Line", "text": " ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#Line"},
     {"title": "CastleClassUtils.TPeekCharStream.Column", "text": " ", "tags": "", "loc": "CastleClassUtils.TPeekCharStream.html#Column"},
     {"title": "CastleClassUtils.TSimplePeekCharStream", "text": " This is a simplest non-abstract implementation of the <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html\">TPeekCharStream</a> class. ", "tags": "", "loc": "CastleClassUtils.TSimplePeekCharStream.html"},
     {"title": "CastleClassUtils.TSimplePeekCharStream.GetPosition", "text": "    ", "tags": "", "loc": "CastleClassUtils.TSimplePeekCharStream.html#GetPosition"},
     {"title": "CastleClassUtils.TSimplePeekCharStream.Read", "text": "    ", "tags": "", "loc": "CastleClassUtils.TSimplePeekCharStream.html#Read"},
     {"title": "CastleClassUtils.TSimplePeekCharStream.PeekChar", "text": "    ", "tags": "", "loc": "CastleClassUtils.TSimplePeekCharStream.html#PeekChar"},
     {"title": "CastleClassUtils.TSimplePeekCharStream.ReadChar", "text": "    ", "tags": "", "loc": "CastleClassUtils.TSimplePeekCharStream.html#ReadChar"},
     {"title": "CastleClassUtils.TBufferedReadStream", "text": " This implements abstract <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html\">TPeekCharStream</a> class, so this is a purely sequential read-only stream that reads from underlying <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html#SourceStream\">SourceStream</a> and you can use <a class=\"normal\" href=\"CastleClassUtils.TBufferedReadStream.html#PeekChar\">PeekChar</a> and <a class=\"normal\" href=\"CastleClassUtils.TBufferedReadStream.html#ReadChar\">ReadChar</a> and <a class=\"normal\" href=\"CastleClassUtils.TBufferedReadStream.html#ReadUpto\">ReadUpto</a> routines.  <p>This stream will buffer incoming data from <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html#SourceStream\">SourceStream</a>. This means that reading by a very small chunks (like e.g. byte-by-byte) does not hurt performance. ", "tags": "", "loc": "CastleClassUtils.TBufferedReadStream.html"},
     {"title": "CastleClassUtils.TBufferedReadStream.GetPosition", "text": "    ", "tags": "", "loc": "CastleClassUtils.TBufferedReadStream.html#GetPosition"},
     {"title": "CastleClassUtils.TBufferedReadStream.Create", "text": "    ", "tags": "", "loc": "CastleClassUtils.TBufferedReadStream.html#Create"},
     {"title": "CastleClassUtils.TBufferedReadStream.Destroy", "text": "    ", "tags": "", "loc": "CastleClassUtils.TBufferedReadStream.html#Destroy"},
     {"title": "CastleClassUtils.TBufferedReadStream.Read", "text": "    ", "tags": "", "loc": "CastleClassUtils.TBufferedReadStream.html#Read"},
     {"title": "CastleClassUtils.TBufferedReadStream.PeekChar", "text": "    ", "tags": "", "loc": "CastleClassUtils.TBufferedReadStream.html#PeekChar"},
     {"title": "CastleClassUtils.TBufferedReadStream.ReadChar", "text": "    ", "tags": "", "loc": "CastleClassUtils.TBufferedReadStream.html#ReadChar"},
     {"title": "CastleClassUtils.TBufferedReadStream.ReadUpto", "text": "    ", "tags": "", "loc": "CastleClassUtils.TBufferedReadStream.html#ReadUpto"},
     {"title": "CastleClassUtils.TBufferedReadStream.BufferSize", "text": " ", "tags": "", "loc": "CastleClassUtils.TBufferedReadStream.html#BufferSize"},
     {"title": "CastleClassUtils.TCastleObjectStack", "text": " ", "tags": "", "loc": "CastleClassUtils.TCastleObjectStack.html"},
     {"title": "CastleClassUtils.TCastleObjectStack.Capacity", "text": " ", "tags": "", "loc": "CastleClassUtils.TCastleObjectStack.html#Capacity"},
     {"title": "CastleClassUtils.TCastleObjectQueue", "text": " ", "tags": "", "loc": "CastleClassUtils.TCastleObjectQueue.html"},
     {"title": "CastleClassUtils.TCastleObjectQueue.Capacity", "text": " ", "tags": "", "loc": "CastleClassUtils.TCastleObjectQueue.html#Capacity"},
     {"title": "CastleClassUtils.TCastleObjectList", "text": " ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html"},
     {"title": "CastleClassUtils.TCastleObjectList.CreateFromArray", "text": "  <p>Since in ObjectPascal you can create open array parameter on the fly, this constructor is often comfortable to use, for example you can write <code>List := TCastleObjectList.Create(..., [Item1, Item2]);</code>.    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#CreateFromArray"},
     {"title": "CastleClassUtils.TCastleObjectList.AddRange", "text": "    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#AddRange"},
     {"title": "CastleClassUtils.TCastleObjectList.AddArray", "text": "    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#AddArray"},
     {"title": "CastleClassUtils.TCastleObjectList.AddRange", "text": "    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#AddRange"},
     {"title": "CastleClassUtils.TCastleObjectList.AddList", "text": "    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#AddList"},
     {"title": "CastleClassUtils.TCastleObjectList.MakeSingle", "text": " In case no descendant of ReplaceClass was found, we'll we add NewItem to the list (depending on AddEnd value: at the beginning or at the end of the list).  <p>If NewItem is <code>Nil</code>, this simply removes the first found descendant of ReplaceClass.  <p>Returns the replaced (or removed) old item. It is removed from the list just like the Extract method, so it's never freed. Or <code>Nil</code>, if none was found (or there was <code>Nil</code> inside the list).  <p>The typical use scenario for this method is when NewItem is also a descendant from ReplaceClass, and you always keep at most one ReplaceClass descendant on the list. For example, you have UI controls list (like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a>), and you want your NewItem to be the only instance of <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html\">TCastleOnScreenMenu</a> class inside. Moreover, in case order on the list is important (for example on <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> order corresponds to screen depth &mdash; what control is under / above each other), you want to place NewItem at the same position as previous <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html\">TCastleOnScreenMenu</a> instance, if any.    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#MakeSingle"},
     {"title": "CastleClassUtils.TCastleObjectList.Extract", "text": " This is similar TObjectList.Extract, except it takes an index.    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#Extract"},
     {"title": "CastleClassUtils.TCastleObjectList.Extract", "text": " Returns the removed item. Or <code>Nil</code>, if none was found (or there was <code>Nil</code> inside the list and it got removed).    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#Extract"},
     {"title": "CastleClassUtils.TCastleObjectList.RemoveAll", "text": " Shifts all other pointers to the left. Returns how many instances were removed (that is, how much Count was decreased).    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#RemoveAll"},
     {"title": "CastleClassUtils.TCastleObjectList.IsFirst", "text": "    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#IsFirst"},
     {"title": "CastleClassUtils.TCastleObjectList.IsLast", "text": "    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#IsLast"},
     {"title": "CastleClassUtils.TCastleObjectList.InsertIfNotExists", "text": "    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#InsertIfNotExists"},
     {"title": "CastleClassUtils.TCastleObjectList.AddIfNotExists", "text": "    ", "tags": "", "loc": "CastleClassUtils.TCastleObjectList.html#AddIfNotExists"},
     {"title": "CastleClassUtils.TNotifyEventList", "text": " ", "tags": "", "loc": "CastleClassUtils.TNotifyEventList.html"},
     {"title": "CastleClassUtils.TNotifyEventList.ExecuteAll", "text": "    ", "tags": "", "loc": "CastleClassUtils.TNotifyEventList.html#ExecuteAll"},
     {"title": "CastleClassUtils.TNotifyEventList.ExecuteForward", "text": "    ", "tags": "", "loc": "CastleClassUtils.TNotifyEventList.html#ExecuteForward"},
     {"title": "CastleClassUtils.TNotifyEventList.ExecuteBackward", "text": "    ", "tags": "", "loc": "CastleClassUtils.TNotifyEventList.html#ExecuteBackward"},
     {"title": "CastleClassUtils.DefaultReadBufferSize", "text": " ", "tags": "", "loc": "CastleClassUtils.html#DefaultReadBufferSize"},
     {"title": "CastleClassUtils.StringsAdd", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StringsAdd"},
     {"title": "CastleClassUtils.AddStrArrayToStrings", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#AddStrArrayToStrings"},
     {"title": "CastleClassUtils.Strings_AddSplittedString", "text": " Splitting is done by Splitter, i.e. if N is the number of occurrences of Splitter inside S, then it always adds N + 1 strings to Strings. Yes, this means that if S starts with Splitter then the first part is equal to ''. And if S ends with Splitter then the last oart is equal to ''.    ", "tags": "", "loc": "CastleClassUtils.html#Strings_AddSplittedString"},
     {"title": "CastleClassUtils.Strings_AddCastleEngineProgramHelpSuffix", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#Strings_AddCastleEngineProgramHelpSuffix"},
     {"title": "CastleClassUtils.Strings_SetText", "text": " See [<a  href=\"http://www.freepascal.org/mantis/view.php?id=6699\">http://www.freepascal.org/mantis/view.php?id=6699</a>]    ", "tags": "", "loc": "CastleClassUtils.html#Strings_SetText"},
     {"title": "CastleClassUtils.Strings_Trim", "text": " Removes the last strings if necessary.    ", "tags": "", "loc": "CastleClassUtils.html#Strings_Trim"},
     {"title": "CastleClassUtils.StreamWriteLongWord", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamWriteLongWord"},
     {"title": "CastleClassUtils.StreamReadLongWord", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadLongWord"},
     {"title": "CastleClassUtils.StreamWriteByte", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamWriteByte"},
     {"title": "CastleClassUtils.StreamReadByte", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadByte"},
     {"title": "CastleClassUtils.WriteStr", "text": " This isn't a procedure to encode a string within a binary stream, this only writes string contents (Length(S) bytes) into the stream. Versions with &quot;ln&quot; append newline. Versions without Stream parameter write to <a class=\"normal\" href=\"CastleClassUtils.html#StdOutStream\">StdOutStream</a>.     ", "tags": "", "loc": "CastleClassUtils.html#WriteStr"},
     {"title": "CastleClassUtils.WritelnStr", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#WritelnStr"},
     {"title": "CastleClassUtils.WriteStr", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#WriteStr"},
     {"title": "CastleClassUtils.WritelnStr", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#WritelnStr"},
     {"title": "CastleClassUtils.StreamReadChar", "text": "     EReadError If end of stream.", "tags": "", "loc": "CastleClassUtils.html#StreamReadChar"},
     {"title": "CastleClassUtils.StreamReadZeroEndString", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadZeroEndString"},
     {"title": "CastleClassUtils.StreamReadUpto_NotEOS", "text": " Returns read contents, without final character (the one in EndingChars set).  <p>If you use a version with BackEndingChar parameter and pass BackEndingChar = <code>True</code>, then the ending character will be returned back to stream (we will start reading from it next time). Note that &quot;returning the character&quot; is done by Seek(-1, soFromCurrent), which may not be possible on some streams. Wrap a stream in <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html\">TPeekCharStream</a> instead, and use <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html#ReadUpto\">TPeekCharStream.ReadUpto</a>, to be able to &quot;return back&quot; a character reliably.  <p>Independently from BackEndingChar, if you use a version with EndingChar parameter, it will be set to the ending character.  <p>     EReadError If the stream will end before encountering one of EndingChars.", "tags": "", "loc": "CastleClassUtils.html#StreamReadUpto_NotEOS"},
     {"title": "CastleClassUtils.StreamReadUpto_NotEOS", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadUpto_NotEOS"},
     {"title": "CastleClassUtils.StreamReadUpto_NotEOS", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadUpto_NotEOS"},
     {"title": "CastleClassUtils.StreamReadUpto_NotEOS", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadUpto_NotEOS"},
     {"title": "CastleClassUtils.StreamReadUpto_EOS", "text": "  <p>Compared to <a class=\"normal\" href=\"CastleClassUtils.html#StreamReadUpto_NotEOS\">StreamReadUpto_NotEOS</a>, this treats &quot;end of stream&quot; as a normal situation, and doesn't raise any exception on it. It sets EndingChar to -1 on end of stream. When EndingChar is not -1, you know you can safely cast it to normal 8-bit character.  <p>Everything else works like with <a class=\"normal\" href=\"CastleClassUtils.html#StreamReadUpto_NotEOS\">StreamReadUpto_NotEOS</a>.     ", "tags": "", "loc": "CastleClassUtils.html#StreamReadUpto_EOS"},
     {"title": "CastleClassUtils.StreamReadUpto_EOS", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadUpto_EOS"},
     {"title": "CastleClassUtils.StreamReadUpto_EOS", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadUpto_EOS"},
     {"title": "CastleClassUtils.StreamReadUpto_EOS", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadUpto_EOS"},
     {"title": "CastleClassUtils.ReadGrowingStream", "text": " A &quot;growing stream&quot; is a stream that we can only read sequentially, no seeks allowed, and size is unknown until we hit the end.  <p>The only operation we do on GrowingStream is GrowingStream.Read and the only operation on DestStream is DestStream.WriteBuffer. So DestStream usually must be able to grow dynamically to accomodate any GrowingStream input size.  <p>This procedure ends when GrowingStream ends. If ResetDestStreamPosition then at the end we do DestStream.Position := 0 (since it is usually useful and it would be easy for you to forget about it).    ", "tags": "", "loc": "CastleClassUtils.html#ReadGrowingStream"},
     {"title": "CastleClassUtils.ReadGrowingStreamToString", "text": " A &quot;growing stream&quot; is a stream that we can only read sequentially, no seeks allowed, and size is unknown until we hit the end.    ", "tags": "", "loc": "CastleClassUtils.html#ReadGrowingStreamToString"},
     {"title": "CastleClassUtils.StreamWriteString", "text": " Records string length (4 bytes), then the string contents (Length(S) bytes).     ", "tags": "", "loc": "CastleClassUtils.html#StreamWriteString"},
     {"title": "CastleClassUtils.StreamReadString", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#StreamReadString"},
     {"title": "CastleClassUtils.StreamToString", "text": " Changes Stream.Position to 0 and then reads Stream.Size bytes, so be sure that Stream.Size is usable.    ", "tags": "", "loc": "CastleClassUtils.html#StreamToString"},
     {"title": "CastleClassUtils.MemoryStreamLoadFromString", "text": " If Rewind then the position is reset to the beginning, otherwise it stays at the end.    ", "tags": "", "loc": "CastleClassUtils.html#MemoryStreamLoadFromString"},
     {"title": "CastleClassUtils.MemoryStreamLoadFromString", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#MemoryStreamLoadFromString"},
     {"title": "CastleClassUtils.CreateIfNeeded", "text": " If Component = nil then it will do <code>Component := ComponentClass.Create(Owner)</code>.    ", "tags": "", "loc": "CastleClassUtils.html#CreateIfNeeded"},
     {"title": "CastleClassUtils.DumpStackToString", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#DumpStackToString"},
     {"title": "CastleClassUtils.DumpExceptionBackTraceToString", "text": "    ", "tags": "", "loc": "CastleClassUtils.html#DumpExceptionBackTraceToString"},
     {"title": "CastleClassUtils.StdInStream", "text": "  <p>Tip: to read the standard input as a text file, you can use <a class=\"normal\" href=\"CastleDownload.TTextReader.html\">TTextReader</a> and <a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a>:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   StdInReader: TTextReader; <span class=\"pascal_keyword\">begin</span>   StdInReader := TTextReader.Create(StdInStream, false);   <span class=\"pascal_keyword\">try</span>     <span class=\"pascal_keyword\">while</span> <span class=\"pascal_keyword\">not</span> StdInReader.Eof <span class=\"pascal_keyword\">do</span>       DoSomethingWithInputLine(StdInReader.Readln);   <span class=\"pascal_keyword\">finally</span> FreeAndNil(StdinReader) <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>The advantage of using <a class=\"normal\" href=\"CastleDownload.TTextReader.html\">TTextReader</a> above, compared to using the standard Pascal <code>Readln</code> procedure to read from the standard Pascal <code>Input</code> text file, is that you can easily modify the above code to read from <i>any</i> stream. So, instead of the standard input, you can easily read some stream that decompresses gzip data, or downloads data from the Internet... Actually, the overloaded constructor <a class=\"normal\" href=\"CastleDownload.TTextReader.html#Create\">TTextReader.Create</a> can accept an URL, like a <code><a  href=\"file://\">file://</a>...</code> or <code><a  href=\"http://\">http://</a>...</code>, and will internally use the stream returned by <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a> function for this URL.  <p>Notes <b>only for Windows GUI applications</b>:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> Some (or all) of the variables below may be <code>Nil</code> in a Windows GUI application.  <p>If you want to be on the safe side, then don't use these streams in the GUI application (when IsConsole = false on Windows). But (with some caveats, see below) you can sometimes use them, if they are not-nil. </p></li>   <li value=\"2\"><p> You <i>can</i> have some of the standard streams available, even in a GUI application.  <p>User can run a GUI program and explicitly redirect it's standard stream, e.g. <code>cat something | my_program.exe</code> for stdin or <code>my_program.exe &gt; output.txt</code> for stdout. Actually some shells, like Cygwin's bash, always redirect some streams under the hood.  <p>Note that the FPC (and Delphi?) RTL may not provide the standard Input/Output/ErrOutput in this case (because IsConsole = false), but we try a little harder, regardless of the IsConsole value. </p></li>   <li value=\"3\"><p> Caveat: in a GUI program under Windows you <i>cannot</i> depend on the fact that &quot;<a class=\"normal\" href=\"CastleClassUtils.html#StdOutStream\">StdOutStream</a> &lt;&gt; nil means that stdout is actually available (because user redirected stdout etc.)&quot;. A first write to the <a class=\"normal\" href=\"CastleClassUtils.html#StdOutStream\">StdOutStream</a> may cause EWriteError, so watch out for this.  <p>This is tested on Windows 2000 Prof, with FPC 2.0.0 and 2.1.1 (revision 4317). When no stdout is available, <a class=\"normal\" href=\"CastleClassUtils.html#StdOutStream\">StdOutStream</a> should be nil, because GetStdHandle(STD_OUTPUT_HANDLE) should return 0. However, GetStdHandle(STD_OUTPUT_HANDLE) doesn't return 0... It returns some invalid handle (no, not INVALID_HANDLE_VALUE either) that you can't write into (trying to write returns in ERROR_INVALID_HANDLE WinAPI error). It seems that there is no way for me to check whether GetStdHandle(STD_OUTPUT_HANDLE) returned valid handle (e.g. because the program's stdout was redirected, so stdout is perfectly available) or whether it returned something unusable.  <p>Note that GetStdHandle(STD_INPUT_HANDLE) and GetStdHandle(STD_ERROR_HANDLE) work correctly, so it should be OK to check <code>StdInStream</code> &lt;&gt; nil or <a class=\"normal\" href=\"CastleClassUtils.html#StdErrStream\">StdErrStream</a> &lt;&gt; nil. The only problematic one is GetStdHandle(STD_OUTPUT_HANDLE).</p></li> </ol>  <p> ) ", "tags": "", "loc": "CastleClassUtils.html#StdInStream"},
     {"title": "CastleClassUtils.StdOutStream", "text": "  <p>Tip: to read the standard input as a text file, you can use <a class=\"normal\" href=\"CastleDownload.TTextReader.html\">TTextReader</a> and <a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a>:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   StdInReader: TTextReader; <span class=\"pascal_keyword\">begin</span>   StdInReader := TTextReader.Create(StdInStream, false);   <span class=\"pascal_keyword\">try</span>     <span class=\"pascal_keyword\">while</span> <span class=\"pascal_keyword\">not</span> StdInReader.Eof <span class=\"pascal_keyword\">do</span>       DoSomethingWithInputLine(StdInReader.Readln);   <span class=\"pascal_keyword\">finally</span> FreeAndNil(StdinReader) <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>The advantage of using <a class=\"normal\" href=\"CastleDownload.TTextReader.html\">TTextReader</a> above, compared to using the standard Pascal <code>Readln</code> procedure to read from the standard Pascal <code>Input</code> text file, is that you can easily modify the above code to read from <i>any</i> stream. So, instead of the standard input, you can easily read some stream that decompresses gzip data, or downloads data from the Internet... Actually, the overloaded constructor <a class=\"normal\" href=\"CastleDownload.TTextReader.html#Create\">TTextReader.Create</a> can accept an URL, like a <code><a  href=\"file://\">file://</a>...</code> or <code><a  href=\"http://\">http://</a>...</code>, and will internally use the stream returned by <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a> function for this URL.  <p>Notes <b>only for Windows GUI applications</b>:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> Some (or all) of the variables below may be <code>Nil</code> in a Windows GUI application.  <p>If you want to be on the safe side, then don't use these streams in the GUI application (when IsConsole = false on Windows). But (with some caveats, see below) you can sometimes use them, if they are not-nil. </p></li>   <li value=\"2\"><p> You <i>can</i> have some of the standard streams available, even in a GUI application.  <p>User can run a GUI program and explicitly redirect it's standard stream, e.g. <code>cat something | my_program.exe</code> for stdin or <code>my_program.exe &gt; output.txt</code> for stdout. Actually some shells, like Cygwin's bash, always redirect some streams under the hood.  <p>Note that the FPC (and Delphi?) RTL may not provide the standard Input/Output/ErrOutput in this case (because IsConsole = false), but we try a little harder, regardless of the IsConsole value. </p></li>   <li value=\"3\"><p> Caveat: in a GUI program under Windows you <i>cannot</i> depend on the fact that &quot;<code>StdOutStream</code> &lt;&gt; nil means that stdout is actually available (because user redirected stdout etc.)&quot;. A first write to the <code>StdOutStream</code> may cause EWriteError, so watch out for this.  <p>This is tested on Windows 2000 Prof, with FPC 2.0.0 and 2.1.1 (revision 4317). When no stdout is available, <code>StdOutStream</code> should be nil, because GetStdHandle(STD_OUTPUT_HANDLE) should return 0. However, GetStdHandle(STD_OUTPUT_HANDLE) doesn't return 0... It returns some invalid handle (no, not INVALID_HANDLE_VALUE either) that you can't write into (trying to write returns in ERROR_INVALID_HANDLE WinAPI error). It seems that there is no way for me to check whether GetStdHandle(STD_OUTPUT_HANDLE) returned valid handle (e.g. because the program's stdout was redirected, so stdout is perfectly available) or whether it returned something unusable.  <p>Note that GetStdHandle(STD_INPUT_HANDLE) and GetStdHandle(STD_ERROR_HANDLE) work correctly, so it should be OK to check <a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a> &lt;&gt; nil or <a class=\"normal\" href=\"CastleClassUtils.html#StdErrStream\">StdErrStream</a> &lt;&gt; nil. The only problematic one is GetStdHandle(STD_OUTPUT_HANDLE).</p></li> </ol>  <p> ) ", "tags": "", "loc": "CastleClassUtils.html#StdOutStream"},
     {"title": "CastleClassUtils.StdErrStream", "text": "  <p>Tip: to read the standard input as a text file, you can use <a class=\"normal\" href=\"CastleDownload.TTextReader.html\">TTextReader</a> and <a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a>:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   StdInReader: TTextReader; <span class=\"pascal_keyword\">begin</span>   StdInReader := TTextReader.Create(StdInStream, false);   <span class=\"pascal_keyword\">try</span>     <span class=\"pascal_keyword\">while</span> <span class=\"pascal_keyword\">not</span> StdInReader.Eof <span class=\"pascal_keyword\">do</span>       DoSomethingWithInputLine(StdInReader.Readln);   <span class=\"pascal_keyword\">finally</span> FreeAndNil(StdinReader) <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>The advantage of using <a class=\"normal\" href=\"CastleDownload.TTextReader.html\">TTextReader</a> above, compared to using the standard Pascal <code>Readln</code> procedure to read from the standard Pascal <code>Input</code> text file, is that you can easily modify the above code to read from <i>any</i> stream. So, instead of the standard input, you can easily read some stream that decompresses gzip data, or downloads data from the Internet... Actually, the overloaded constructor <a class=\"normal\" href=\"CastleDownload.TTextReader.html#Create\">TTextReader.Create</a> can accept an URL, like a <code><a  href=\"file://\">file://</a>...</code> or <code><a  href=\"http://\">http://</a>...</code>, and will internally use the stream returned by <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a> function for this URL.  <p>Notes <b>only for Windows GUI applications</b>:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> Some (or all) of the variables below may be <code>Nil</code> in a Windows GUI application.  <p>If you want to be on the safe side, then don't use these streams in the GUI application (when IsConsole = false on Windows). But (with some caveats, see below) you can sometimes use them, if they are not-nil. </p></li>   <li value=\"2\"><p> You <i>can</i> have some of the standard streams available, even in a GUI application.  <p>User can run a GUI program and explicitly redirect it's standard stream, e.g. <code>cat something | my_program.exe</code> for stdin or <code>my_program.exe &gt; output.txt</code> for stdout. Actually some shells, like Cygwin's bash, always redirect some streams under the hood.  <p>Note that the FPC (and Delphi?) RTL may not provide the standard Input/Output/ErrOutput in this case (because IsConsole = false), but we try a little harder, regardless of the IsConsole value. </p></li>   <li value=\"3\"><p> Caveat: in a GUI program under Windows you <i>cannot</i> depend on the fact that &quot;<a class=\"normal\" href=\"CastleClassUtils.html#StdOutStream\">StdOutStream</a> &lt;&gt; nil means that stdout is actually available (because user redirected stdout etc.)&quot;. A first write to the <a class=\"normal\" href=\"CastleClassUtils.html#StdOutStream\">StdOutStream</a> may cause EWriteError, so watch out for this.  <p>This is tested on Windows 2000 Prof, with FPC 2.0.0 and 2.1.1 (revision 4317). When no stdout is available, <a class=\"normal\" href=\"CastleClassUtils.html#StdOutStream\">StdOutStream</a> should be nil, because GetStdHandle(STD_OUTPUT_HANDLE) should return 0. However, GetStdHandle(STD_OUTPUT_HANDLE) doesn't return 0... It returns some invalid handle (no, not INVALID_HANDLE_VALUE either) that you can't write into (trying to write returns in ERROR_INVALID_HANDLE WinAPI error). It seems that there is no way for me to check whether GetStdHandle(STD_OUTPUT_HANDLE) returned valid handle (e.g. because the program's stdout was redirected, so stdout is perfectly available) or whether it returned something unusable.  <p>Note that GetStdHandle(STD_INPUT_HANDLE) and GetStdHandle(STD_ERROR_HANDLE) work correctly, so it should be OK to check <a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a> &lt;&gt; nil or <code>StdErrStream</code> &lt;&gt; nil. The only problematic one is GetStdHandle(STD_OUTPUT_HANDLE).</p></li> </ol>  <p> ) ", "tags": "", "loc": "CastleClassUtils.html#StdErrStream"},
     {"title": "CastleColors", "text": " ", "tags": "", "loc": "CastleColors.html"},
     {"title": "CastleColors.Maroon", "text": " They follow the CSS colors constants [<a  href=\"http://www.w3.org/TR/CSS21/syndata.html#color-units\">http://www.w3.org/TR/CSS21/syndata.html#color-units</a>].  ", "tags": "", "loc": "CastleColors.html#Maroon"},
     {"title": "CastleColors.Red", "text": " ", "tags": "", "loc": "CastleColors.html#Red"},
     {"title": "CastleColors.Orange", "text": " ", "tags": "", "loc": "CastleColors.html#Orange"},
     {"title": "CastleColors.Yellow", "text": " ", "tags": "", "loc": "CastleColors.html#Yellow"},
     {"title": "CastleColors.Olive", "text": " ", "tags": "", "loc": "CastleColors.html#Olive"},
     {"title": "CastleColors.Purple", "text": " ", "tags": "", "loc": "CastleColors.html#Purple"},
     {"title": "CastleColors.Fuchsia", "text": " ", "tags": "", "loc": "CastleColors.html#Fuchsia"},
     {"title": "CastleColors.White", "text": " ", "tags": "", "loc": "CastleColors.html#White"},
     {"title": "CastleColors.Lime", "text": " ", "tags": "", "loc": "CastleColors.html#Lime"},
     {"title": "CastleColors.Green", "text": " ", "tags": "", "loc": "CastleColors.html#Green"},
     {"title": "CastleColors.Navy", "text": " ", "tags": "", "loc": "CastleColors.html#Navy"},
     {"title": "CastleColors.Blue", "text": " ", "tags": "", "loc": "CastleColors.html#Blue"},
     {"title": "CastleColors.Aqua", "text": " ", "tags": "", "loc": "CastleColors.html#Aqua"},
     {"title": "CastleColors.Teal", "text": " ", "tags": "", "loc": "CastleColors.html#Teal"},
     {"title": "CastleColors.Black", "text": " ", "tags": "", "loc": "CastleColors.html#Black"},
     {"title": "CastleColors.Silver", "text": " ", "tags": "", "loc": "CastleColors.html#Silver"},
     {"title": "CastleColors.Gray", "text": " ", "tags": "", "loc": "CastleColors.html#Gray"},
     {"title": "CastleColors.LightGreen", "text": " ", "tags": "", "loc": "CastleColors.html#LightGreen"},
     {"title": "CastleColors.LightBlue", "text": " ", "tags": "", "loc": "CastleColors.html#LightBlue"},
     {"title": "CastleColors.WhiteRGB", "text": " ", "tags": "", "loc": "CastleColors.html#WhiteRGB"},
     {"title": "CastleColors.BlackRGB", "text": " ", "tags": "", "loc": "CastleColors.html#BlackRGB"},
     {"title": "CastleColors.RedRGB", "text": " ", "tags": "", "loc": "CastleColors.html#RedRGB"},
     {"title": "CastleColors.YellowRGB", "text": " ", "tags": "", "loc": "CastleColors.html#YellowRGB"},
     {"title": "CastleColors.GreenRGB", "text": " ", "tags": "", "loc": "CastleColors.html#GreenRGB"},
     {"title": "CastleColors.BlueRGB", "text": " ", "tags": "", "loc": "CastleColors.html#BlueRGB"},
     {"title": "CastleColors.GrayRGB", "text": " ", "tags": "", "loc": "CastleColors.html#GrayRGB"},
     {"title": "CastleColors.White3Single", "text": "  ", "tags": "", "loc": "CastleColors.html#White3Single"},
     {"title": "CastleColors.Black3Single", "text": "  ", "tags": "", "loc": "CastleColors.html#Black3Single"},
     {"title": "CastleColors.Red3Single", "text": "  ", "tags": "", "loc": "CastleColors.html#Red3Single"},
     {"title": "CastleColors.Green3Single", "text": "  ", "tags": "", "loc": "CastleColors.html#Green3Single"},
     {"title": "CastleColors.Blue3Single", "text": "  ", "tags": "", "loc": "CastleColors.html#Blue3Single"},
     {"title": "CastleColors.GrayscaleValue", "text": "     ", "tags": "", "loc": "CastleColors.html#GrayscaleValue"},
     {"title": "CastleColors.GrayscaleValue", "text": "    ", "tags": "", "loc": "CastleColors.html#GrayscaleValue"},
     {"title": "CastleColors.GrayscaleValue", "text": "    ", "tags": "", "loc": "CastleColors.html#GrayscaleValue"},
     {"title": "CastleColors.GrayscaleValue", "text": "    ", "tags": "", "loc": "CastleColors.html#GrayscaleValue"},
     {"title": "CastleColors.Grayscale", "text": "    ", "tags": "", "loc": "CastleColors.html#Grayscale"},
     {"title": "CastleColors.Grayscale", "text": "    ", "tags": "", "loc": "CastleColors.html#Grayscale"},
     {"title": "CastleColors.Grayscale", "text": "    ", "tags": "", "loc": "CastleColors.html#Grayscale"},
     {"title": "CastleColors.ColorGrayscaleByte", "text": "     ", "tags": "", "loc": "CastleColors.html#ColorGrayscaleByte"},
     {"title": "CastleColors.ColorRedConvertByte", "text": " Set the other components zero.     ", "tags": "", "loc": "CastleColors.html#ColorRedConvertByte"},
     {"title": "CastleColors.ColorGreenConvertByte", "text": "    ", "tags": "", "loc": "CastleColors.html#ColorGreenConvertByte"},
     {"title": "CastleColors.ColorBlueConvertByte", "text": "    ", "tags": "", "loc": "CastleColors.html#ColorBlueConvertByte"},
     {"title": "CastleColors.ColorRedStripByte", "text": " Note that it's something entirely different than ImageConvertToChannelVar: here we preserve original channel values, and remove values on two other channels.  <p>    ", "tags": "", "loc": "CastleColors.html#ColorRedStripByte"},
     {"title": "CastleColors.ColorGreenStripByte", "text": "    ", "tags": "", "loc": "CastleColors.html#ColorGreenStripByte"},
     {"title": "CastleColors.ColorBlueStripByte", "text": "    ", "tags": "", "loc": "CastleColors.html#ColorBlueStripByte"},
     {"title": "CastleColors.HsvToRgb", "text": " For HSV, we keep components as floating-point values, with hue in 0..6 range, saturation and value in 0..1. For RGB, one version keeps components as bytes (0..255 range), and the other as floating-point values (0..1 range).     ", "tags": "", "loc": "CastleColors.html#HsvToRgb"},
     {"title": "CastleColors.RgbToHsv", "text": "    ", "tags": "", "loc": "CastleColors.html#RgbToHsv"},
     {"title": "CastleColors.RgbToHsv", "text": "    ", "tags": "", "loc": "CastleColors.html#RgbToHsv"},
     {"title": "CastleColors.HsvToRgbByte", "text": "    ", "tags": "", "loc": "CastleColors.html#HsvToRgbByte"},
     {"title": "CastleColors.LerpRgbInHsv", "text": "    ", "tags": "", "loc": "CastleColors.html#LerpRgbInHsv"},
     {"title": "CastleColors.ColorToHex", "text": " This color includes an alpha channel (as 4th component), and so the output contains the alpha value at the end (so it's 8 hex digits), unless alpha is opaque in which case it's not written (and result is 6 hex digits).    ", "tags": "", "loc": "CastleColors.html#ColorToHex"},
     {"title": "CastleColors.ColorRGBToHex", "text": " This color has no alpha channel, so it's always 6 hex digits.    ", "tags": "", "loc": "CastleColors.html#ColorRGBToHex"},
     {"title": "CastleColors.HexToColor", "text": " Handles 8 or 6 digit color (RGB or RGBA with 2 letters per component; for 6 digits, alpha is assumed to be 1.0 (opaque)).  <p>    EConvertError In case of invalid color as string.", "tags": "", "loc": "CastleColors.html#HexToColor"},
     {"title": "CastleColors.HexToColorRGB", "text": " Handles 8 or 6 digit color (RGB or RGBA with 2 letters per component; for 8 digits, alpha is ignored).  <p>    EConvertError In case of invalid color as string.", "tags": "", "loc": "CastleColors.html#HexToColorRGB"},
     {"title": "CastleColors.ColorOpacity", "text": "    ", "tags": "", "loc": "CastleColors.html#ColorOpacity"},
     {"title": "CastleColors.FadeDarkColor", "text": "    ", "tags": "", "loc": "CastleColors.html#FadeDarkColor"},
     {"title": "CastleColors.FadeColor", "text": "    ", "tags": "", "loc": "CastleColors.html#FadeColor"},
     {"title": "CastleColors.TCastleColor", "text": " ", "tags": "", "loc": "CastleColors.html#TCastleColor"},
     {"title": "CastleColors.TCastleColorRGB", "text": " ", "tags": "", "loc": "CastleColors.html#TCastleColorRGB"},
     {"title": "CastleColors.TColorModulatorByteFunc", "text": "    ", "tags": "", "loc": "CastleColors.html#TColorModulatorByteFunc"},
     {"title": "CastleCompositeImage", "text": " ", "tags": "", "loc": "CastleCompositeImage.html"},
     {"title": "CastleCompositeImage.EInvalidCompositeImage", "text": " ", "tags": "", "loc": "CastleCompositeImage.EInvalidCompositeImage.html"},
     {"title": "CastleCompositeImage.EInvalidDDS", "text": " ", "tags": "", "loc": "CastleCompositeImage.EInvalidDDS.html"},
     {"title": "CastleCompositeImage.EInvalidKTX", "text": " ", "tags": "", "loc": "CastleCompositeImage.EInvalidKTX.html"},
     {"title": "CastleCompositeImage.TCompositeImage", "text": " This supports image that can have mipmaps, can be 3D, and can be a cubemap. This is something more than our <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> (or <a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a>), which can only be a single pixel matrix (it can be 3D, but it cannot be a cubemap or have mipmaps).  <p>In essence, this is a container for a sequence of simple images in the <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#Images\">Images</a> property. The interpretation of the image sequence depends on other fields: first of all <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#CompositeType\">CompositeType</a> and <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#Mipmaps\">Mipmaps</a>.  <p>The basic usage of this class is to load a file using <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#LoadFromFile\">LoadFromFile</a> or <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#LoadFromStream\">LoadFromStream</a>.  <p>Note that you can write (change) many properties of this class. This allows you to create, or load and edit, composite files. You can even later save the composite image back to the stream (like a file) by <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#SaveToStream\">SaveToStream</a> or <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#SaveToFile\">SaveToFile</a>. Be careful though: you're responsible then to set all properties to sensible values. For example, the length (and interpretation) of <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#Images\">Images</a> list is determined by other properties of this class, so be sure to set them all to something sensible. ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html"},
     {"title": "CastleCompositeImage.TCompositeImage.AutomaticCompression", "text": " More precisely, the DxgiFormat is equal DXGI_FORMAT_UNKNOWN (see <a  href=\"https://msdn.microsoft.com/en-us/library/windows/desktop/bb173059\">https://msdn.microsoft.com/en-us/library/windows/desktop/bb173059</a>(v=vs.85).aspx ). This can happen if you used PvrTexTool and compressed to PVRTC2_* formats.  <p>To be able to read such DDS files anyway, set <code>AutomaticCompression</code> to true and set <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#AutomaticCompressionType\">AutomaticCompressionType</a> as appropriate. ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#AutomaticCompression"},
     {"title": "CastleCompositeImage.TCompositeImage.AutomaticCompressionType", "text": " ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#AutomaticCompressionType"},
     {"title": "CastleCompositeImage.TCompositeImage.Create", "text": "    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#Create"},
     {"title": "CastleCompositeImage.TCompositeImage.Destroy", "text": "    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#Destroy"},
     {"title": "CastleCompositeImage.TCompositeImage.CubeMapImage", "text": " Assumes <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#CompositeType\">CompositeType</a> = <a class=\"normal\" href=\"CastleCompositeImage.html#ctCubeMap\">ctCubeMap</a> and <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#CubeMapSides\">CubeMapSides</a> = all.  <p>Level is mipmap level. Pass 0 for base level. When not <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#Mipmaps\">Mipmaps</a>, Level must be 0.    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#CubeMapImage"},
     {"title": "CastleCompositeImage.TCompositeImage.LoadFromStream", "text": " The image type is recognized from the MimeType extension, or (if empty) from URL, so make sure that you provide at least one of these parameters.     EInvalidCompositeImage In case of any error in the file data.", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#LoadFromStream"},
     {"title": "CastleCompositeImage.TCompositeImage.LoadFromFile", "text": "    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#LoadFromFile"},
     {"title": "CastleCompositeImage.TCompositeImage.SaveToStream", "text": "    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#SaveToStream"},
     {"title": "CastleCompositeImage.TCompositeImage.SaveToFile", "text": "    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#SaveToFile"},
     {"title": "CastleCompositeImage.TCompositeImage.Close", "text": " Effectively, this releases all data loaded by <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#LoadFromStream\">LoadFromStream</a>, reverting the object to the state right after creation.    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#Close"},
     {"title": "CastleCompositeImage.TCompositeImage.Flatten3d", "text": " Useful utility for 3d (volume) textures.  <p>Normal loading of 3D composite textures creates single <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> (using Depth possibly &gt; 1) for each mipmap level. Such <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> with depth is comfortable if you want to load this 3d texture into OpenGL (as then the image data is just a continous memory area, loadable by glTexImage3d). But it's not comfortable if you want to display it using some 2D GUI. For example, it's not comfortable for image viewer like glViewImage.  <p>So this method will convert such <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instances (with Depth &gt; 1) into a sequence of <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instances all with Depth = 1. This isn't difficult, memory contents on 3d <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> may be splitted into many 2d <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instances without problems.  <p>Note that it's safe to do this before saving the image. <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#SaveToFile\">SaveToFile</a>/<a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#SaveToStream\">SaveToStream</a> methods accept both layouts of images (because, as said, memory contents actually are the same before and after splitting).  <p>Note that this may free all Images (possibly even whole Images object), disregarding <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#OwnsFirstImage\">OwnsFirstImage</a> (as it would be difficult, since it may or may not replace it with new images).    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#Flatten3d"},
     {"title": "CastleCompositeImage.TCompositeImage.DecompressTexture", "text": " This can be used to decompress textures compressed using GPU compression algorithms, see <a class=\"normal\" href=\"CastleImages.html#TTextureCompression\">TTextureCompression</a>. See <a class=\"normal\" href=\"CastleImages.TGPUCompressedImage.html#Decompress\">TGPUCompressedImage.Decompress</a>.  <p>Just like <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#Flatten3d\">Flatten3d</a>: Note that this may free all Images (possibly even whole Images object), disregarding <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#OwnsFirstImage\">OwnsFirstImage</a> (as it would be difficult, since it may or may not replace it with new images).  <p>    ECannotDecompressTexture If some image cannot be decompressed for any reason.", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#DecompressTexture"},
     {"title": "CastleCompositeImage.TCompositeImage.MatchesURL", "text": " Guesses by processing the URL with <a class=\"normal\" href=\"CastleImages.html#ProcessImageUrl\">ProcessImageUrl</a> and then looking at final filename extension.    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#MatchesURL"},
     {"title": "CastleCompositeImage.TCompositeImage.AddCubeMapImages", "text": "    ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#AddCubeMapImages"},
     {"title": "CastleCompositeImage.TCompositeImage.Images", "text": "  <p>This has always length &gt; 0 when file is successfully loaded (that is, when <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#LoadFromStream\">LoadFromStream</a> method finished without raising any exception). ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#Images"},
     {"title": "CastleCompositeImage.TCompositeImage.Width", "text": " ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#Width"},
     {"title": "CastleCompositeImage.TCompositeImage.Height", "text": " ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#Height"},
     {"title": "CastleCompositeImage.TCompositeImage.CompositeType", "text": " ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#CompositeType"},
     {"title": "CastleCompositeImage.TCompositeImage.Mipmaps", "text": " If <code>True</code>, then all <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#Images\">Images</a> are guaranteed to have sizes being power of 2. ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#Mipmaps"},
     {"title": "CastleCompositeImage.TCompositeImage.MipmapsCount", "text": " Always 1 when <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#Mipmaps\">Mipmaps</a> = <code>False</code>, this is usually comfortable. ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#MipmapsCount"},
     {"title": "CastleCompositeImage.TCompositeImage.CubeMapSides", "text": " Valid only when image is loaded and is <a class=\"normal\" href=\"CastleCompositeImage.html#ctCubeMap\">ctCubeMap</a>. ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#CubeMapSides"},
     {"title": "CastleCompositeImage.TCompositeImage.Depth", "text": " Always 1 when <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#CompositeType\">CompositeType</a> is not <a class=\"normal\" href=\"CastleCompositeImage.html#ctVolume\">ctVolume</a>, this is usually comfortable. ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#Depth"},
     {"title": "CastleCompositeImage.TCompositeImage.OwnsFirstImage", "text": " Closing happens when you call the <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#Close\">Close</a> method or destructor of this object. When this is <code>False</code>, you're responsible to storing and freeing Images[0] later yourself, or you'll get memory leaks. ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#OwnsFirstImage"},
     {"title": "CastleCompositeImage.TCompositeImage.TDDSCubeMapSide", "text": "  <p>Compared with <a class=\"normal\" href=\"CastleCompositeImage.html#TCubeMapSide\">TCubeMapSide</a> type, the meaning positive/negative Y faces is swapped.  <p>Reason: Cube map sides are named and written in DDS file in a way natural for DirectX, and DirectX has left-handed coordinate system, which means that one axis seems reverted when you want OpenGL right-handed coord system (like OpenGL, see <a  href=\"http://opengl.org/registry/specs/ARB/texture_cube_map.txt\">http://opengl.org/registry/specs/ARB/texture_cube_map.txt</a>). See [<a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_status.php#section_dds\">http://castle-engine.sourceforge.net/x3d_implementation_status.php#section_dds</a>] for more.  dcsPositiveX    dcsNegativeX    dcsPositiveY    dcsNegativeY    dcsPositiveZ    dcsNegativeZ   ", "tags": "", "loc": "CastleCompositeImage.TCompositeImage.html#TDDSCubeMapSide"},
     {"title": "CastleCompositeImage.AllCubeMapSides", "text": " ", "tags": "", "loc": "CastleCompositeImage.html#AllCubeMapSides"},
     {"title": "CastleCompositeImage.CompositeTypeToString", "text": " ", "tags": "", "loc": "CastleCompositeImage.html#CompositeTypeToString"},
     {"title": "CastleCompositeImage.TCompositeType", "text": " This doesn't take into account mipmaps (they are orthogonal to types here).  ctTexture    ctCubeMap    ctVolume   ", "tags": "", "loc": "CastleCompositeImage.html#TCompositeType"},
     {"title": "CastleCompositeImage.TCubeMapSide", "text": " Always interpreted in right-handed orientation (like for OpenGL or OpenGL ES) by our engine. Order matches the order of OpenGL constants GL_TEXTURE_CUBE_MAP_POSITIVE/NEGATIVE_X/Y/Z_ARB.  csPositiveX    csNegativeX    csPositiveY    csNegativeY    csPositiveZ    csNegativeZ   ", "tags": "", "loc": "CastleCompositeImage.html#TCubeMapSide"},
     {"title": "CastleCompositeImage.TCubeMapSides", "text": " ", "tags": "", "loc": "CastleCompositeImage.html#TCubeMapSides"},
     {"title": "CastleCompositeImage.TCubeMapImages", "text": " ", "tags": "", "loc": "CastleCompositeImage.html#TCubeMapImages"},
     {"title": "CastleConfig", "text": " ", "tags": "", "loc": "CastleConfig.html"},
     {"title": "CastleConfig.UserConfig", "text": " See <a  href=\"http://castle-engine.sourceforge.net/tutorial_user_prefs.php\">http://castle-engine.sourceforge.net/tutorial_user_prefs.php</a> .    ", "tags": "", "loc": "CastleConfig.html#UserConfig"},
     {"title": "CastleConfig.Config", "text": "    ", "tags": "", "loc": "CastleConfig.html#Config"},
     {"title": "CastleConfig.TCastleConfig", "text": " ", "tags": "", "loc": "CastleConfig.html#TCastleConfig"},
     {"title": "CastleControl", "text": " ", "tags": "", "loc": "CastleControl.html"},
     {"title": "CastleControl.TCastleControlCustom", "text": " You can use a descendant of this called <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a> to have even more comfort: <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a> gives you a ready <a class=\"normal\" href=\"CastleControl.TCastleControl.html#SceneManager\">TCastleControl.SceneManager</a> for your world.  <p>This extends TOpenGLControl, adding various features:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">Controls</a> list where you can easily add <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> instances (like <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html\">TCastleOnScreenMenu</a>, <a class=\"normal\" href=\"CastleControls.TCastleButton.html\">TCastleButton</a> and more). We will pass events to these controls, draw them etc.</p></li>   <li><p>Continously called <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnUpdate\">OnUpdate</a> event, and automatic handling of calling <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">TInputListener.Update</a> for all <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">Controls</a>. This is something different than LCL &quot;idle&quot; event, as it's guaranteed to be run continously, even when your application is clogged with events (like when using <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MouseLook\">TWalkCamera.MouseLook</a>).  <p>Note: As we need to continously call the &quot;update&quot; event (to update animations and more), we listen on the Lazarus Application &quot;idle&quot; event, and tell it that we're never &quot;done&quot; with our work. We do this only when at least one instance of <code>TCastleControlCustom</code> is created, and never at design-time. This means that your own &quot;idle&quot; events (registered through LCL TApplicationProperties.OnIdle or Application.AddOnIdleHandler) may be never executed, because really the application is never idle.  <p>If you want to reliably do some continuous work, use Castle Game Engine features to do it. There are various alternative ways:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Register an event on <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnUpdate\">OnUpdate</a> of this component,</p></li>   <li><p>Add custom <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> instance to the <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">Controls</a> list with overridden <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">TInputListener.Update</a> method,</p></li>   <li><p>Register an event on <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#OnUpdate\">ApplicationProperties.OnUpdate</a> from the <a class=\"normal\" href=\"CastleApplicationProperties.html\">CastleApplicationProperties</a> unit.</p></li> </ul>  <p>  <p>TODO: Try an alternative implementation using TTimer with Interval=1. </p></li>   <li><p>Automatically initializes Castle Game Engine stuff when context is created (<a class=\"normal\" href=\"CastleGLVersion.html#GLVersion\">GLVersion</a>, <a class=\"normal\" href=\"CastleGLUtils.html#GLFeatures\">GLFeatures</a> and more).</p></li>   <li><p>Measures application speed, see the <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Fps\">Fps</a>.</p></li>   <li><p>Tracks pressed keys <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Pressed\">Pressed</a> and mouse buttons <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#MousePressed\">MousePressed</a> and mouse position <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#MousePosition\">MousePosition</a>.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html"},
     {"title": "CastleControl.TCastleControlCustom.DestroyHandle", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#DestroyHandle"},
     {"title": "CastleControl.TCastleControlCustom.DoExit", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#DoExit"},
     {"title": "CastleControl.TCastleControlCustom.Resize", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Resize"},
     {"title": "CastleControl.TCastleControlCustom.KeyDown", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#KeyDown"},
     {"title": "CastleControl.TCastleControlCustom.KeyUp", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#KeyUp"},
     {"title": "CastleControl.TCastleControlCustom.MouseDown", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#MouseDown"},
     {"title": "CastleControl.TCastleControlCustom.MouseUp", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#MouseUp"},
     {"title": "CastleControl.TCastleControlCustom.MouseMove", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#MouseMove"},
     {"title": "CastleControl.TCastleControlCustom.DoMouseWheel", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#DoMouseWheel"},
     {"title": "CastleControl.TCastleControlCustom.DoUpdate", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#DoUpdate"},
     {"title": "CastleControl.TCastleControlCustom.Create", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Create"},
     {"title": "CastleControl.TCastleControlCustom.Destroy", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Destroy"},
     {"title": "CastleControl.TCastleControlCustom.Controls", "text": " See <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> for details.    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Controls"},
     {"title": "CastleControl.TCastleControlCustom.MakeCurrent", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#MakeCurrent"},
     {"title": "CastleControl.TCastleControlCustom.Invalidate", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Invalidate"},
     {"title": "CastleControl.TCastleControlCustom.Paint", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Paint"},
     {"title": "CastleControl.TCastleControlCustom.Pressed", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Pressed"},
     {"title": "CastleControl.TCastleControlCustom.MousePressed", "text": " See <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#MousePressed\">TUIContainer.MousePressed</a> for details.    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#MousePressed"},
     {"title": "CastleControl.TCastleControlCustom.ReleaseAllKeysAndMouse", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#ReleaseAllKeysAndMouse"},
     {"title": "CastleControl.TCastleControlCustom.Fps", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Fps"},
     {"title": "CastleControl.TCastleControlCustom.SaveScreen", "text": "     ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#SaveScreen"},
     {"title": "CastleControl.TCastleControlCustom.SaveScreen", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#SaveScreen"},
     {"title": "CastleControl.TCastleControlCustom.SaveScreen", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#SaveScreen"},
     {"title": "CastleControl.TCastleControlCustom.SaveScreenBuffer", "text": " Use only if you save the screen using low-level <a class=\"normal\" href=\"CastleGLImages.html#SaveScreen_NoFlush\">SaveScreen_NoFlush</a> function. Usually, you should save the screen using the simpler <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#SaveScreen\">SaveScreen</a> method, and then the <code>SaveScreenBuffer</code> is not useful.    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#SaveScreenBuffer"},
     {"title": "CastleControl.TCastleControlCustom.Rect", "text": " Always (Left,Bottom) are zero, and (Width,Height) correspond to container sizes.    ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Rect"},
     {"title": "CastleControl.TCastleControlCustom.GLInitialized", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#GLInitialized"},
     {"title": "CastleControl.TCastleControlCustom.MousePosition", "text": " See <a class=\"normal\" href=\"CastleUIControls.TTouch.html#Position\">TTouch.Position</a> for a documentation how this is expressed. ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#MousePosition"},
     {"title": "CastleControl.TCastleControlCustom.Align", "text": " They are picked up and shown automatically by Lazarus Object Inspector, and it has it's own logic, much much dumber than what PasDoc sees. There seems no way to hide comment there.  <p>We publish most, but not all, stuff from inherited TCustomOpenGLControl.  <p>Exceptions: - Don't publish these, as not every widgetset has them: property RedBits; property GreenBits; property BlueBits;  <p>- Don't publish these, as we have our own events for this: property <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnResize\">OnResize</a>; property OnClick; property OnKeyDown; property OnKeyPress; property OnKeyUp; property OnMouseDown; property OnMouseMove; property OnMouseUp; property OnMouseWheel; property OnMouseWheelDown; property OnMouseWheelUp; property OnPaint;  <p>- Don't use, engine handles this completely: property OnMakeCurrent; property AutoResizeViewport; ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Align"},
     {"title": "CastleControl.TCastleControlCustom.Anchors", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Anchors"},
     {"title": "CastleControl.TCastleControlCustom.BorderSpacing", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#BorderSpacing"},
     {"title": "CastleControl.TCastleControlCustom.Enabled", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Enabled"},
     {"title": "CastleControl.TCastleControlCustom.OpenGLMajorVersion", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OpenGLMajorVersion"},
     {"title": "CastleControl.TCastleControlCustom.OpenGLMinorVersion", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OpenGLMinorVersion"},
     {"title": "CastleControl.TCastleControlCustom.MultiSampling", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#MultiSampling"},
     {"title": "CastleControl.TCastleControlCustom.AlphaBits", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#AlphaBits"},
     {"title": "CastleControl.TCastleControlCustom.DepthBits", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#DepthBits"},
     {"title": "CastleControl.TCastleControlCustom.StencilBits", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#StencilBits"},
     {"title": "CastleControl.TCastleControlCustom.AUXBuffers", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#AUXBuffers"},
     {"title": "CastleControl.TCastleControlCustom.Options", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Options"},
     {"title": "CastleControl.TCastleControlCustom.OnChangeBounds", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnChangeBounds"},
     {"title": "CastleControl.TCastleControlCustom.OnConstrainedResize", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnConstrainedResize"},
     {"title": "CastleControl.TCastleControlCustom.OnDblClick", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnDblClick"},
     {"title": "CastleControl.TCastleControlCustom.OnDragDrop", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnDragDrop"},
     {"title": "CastleControl.TCastleControlCustom.OnDragOver", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnDragOver"},
     {"title": "CastleControl.TCastleControlCustom.OnEnter", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnEnter"},
     {"title": "CastleControl.TCastleControlCustom.OnExit", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnExit"},
     {"title": "CastleControl.TCastleControlCustom.OnMouseEnter", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnMouseEnter"},
     {"title": "CastleControl.TCastleControlCustom.OnMouseLeave", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnMouseLeave"},
     {"title": "CastleControl.TCastleControlCustom.OnShowHint", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnShowHint"},
     {"title": "CastleControl.TCastleControlCustom.PopupMenu", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#PopupMenu"},
     {"title": "CastleControl.TCastleControlCustom.ShowHint", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#ShowHint"},
     {"title": "CastleControl.TCastleControlCustom.Visible", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Visible"},
     {"title": "CastleControl.TCastleControlCustom.TabOrder", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#TabOrder"},
     {"title": "CastleControl.TCastleControlCustom.TabStop", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#TabStop"},
     {"title": "CastleControl.TCastleControlCustom.Container", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#Container"},
     {"title": "CastleControl.TCastleControlCustom.OnOpen", "text": " Often you do not need to use this callback (engine components will automatically create/release OpenGL resource when necessary), unless you deal with lower-level OpenGL resource managing (e.g. using <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a>). You usually will also want to implement <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnClose\">OnClose</a> callback that should release stuff you create here.  <p>Often, instead of using this callback, it's cleaner to derive new classes from <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> class or it's descendants, and override their GLContextOpen / GLContextClose methods to react to context being open/closed. Using such <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> classes is usually easier, as you add/remove them from controls whenever you want (e.g. you add them in ApplicationInitialize), and underneath they create/release/create again the OpenGL resources when necessary. ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnOpen"},
     {"title": "CastleControl.TCastleControlCustom.OnClose", "text": " This is your last chance to release OpenGL resources, like textures, shaders, display lists etc. This is a counterpart to <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnOpen\">OnOpen</a> event. ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnClose"},
     {"title": "CastleControl.TCastleControlCustom.OnBeforeRender", "text": " These two events, <code>OnBeforeRender</code> and <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnRender\">OnRender</a>, will be always called sequentially as a pair.  <p>The only difference between these two events is that time spent in <code>OnBeforeRender</code> is NOT counted as &quot;frame time&quot; by Fps.OnlyRenderFps. This is useful when you have something that needs to be done from time to time right before <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnRender\">OnRender</a> and that is very time-consuming. It such cases it is not desirable to put such time-consuming task inside <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnRender\">OnRender</a> because this would cause a sudden big change in Fps.OnlyRenderFps value. So you can avoid this by putting this in <code>OnBeforeRender</code>. ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnBeforeRender"},
     {"title": "CastleControl.TCastleControlCustom.OnRender", "text": "  <p>Called when window contents must be redrawn, e.g. after creating a window, after resizing a window, after uncovering the window etc. You can also request yourself a redraw of the window by the Invalidate method, which will cause this event to be called at nearest good time.  <p>Note that calling Invalidate while in EventRender (<code>OnRender</code>) is not ignored. It instructs to call EventRender (<code>OnRender</code>) again, as soon as possible.  <p>When you have some controls on the <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">Controls</a> list (in particular, the <a class=\"normal\" href=\"CastleControl.TCastleControl.html#SceneManager\">TCastleControl.SceneManager</a> is also on this list), the <code>OnRender</code> event is done <b>last</b>. So here you can draw on top of the existing UI controls. To draw something underneath the existing controls, create a new <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> and override it's <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a> and insert it to the controls using <code>Controls.InsertBack(MyBackgroundControl);</code>. ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnRender"},
     {"title": "CastleControl.TCastleControlCustom.OnResize", "text": " It's also guaranteed to be called right after the <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnOpen\">OnOpen</a> event.  <p>Our OpenGL context is already &quot;current&quot; when this event is called (<a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#MakeCurrent\">MakeCurrent</a> is done right before), like for other events. This is a good place to set OpenGL viewport and projection matrix.  <p>In the usual case, the SceneManager takes care of setting appropriate OpenGL projection, so you don't need to do anything here. ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnResize"},
     {"title": "CastleControl.TCastleControlCustom.OnPress", "text": " ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnPress"},
     {"title": "CastleControl.TCastleControlCustom.OnRelease", "text": "  <p>It's called right after <code>Pressed[Key]</code> changed from true to false.  <p>The <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html\">TInputPressRelease</a> structure, passed as a parameter to this event, contains the exact information what was released.  <p>Note that reporting characters for &quot;key release&quot; messages is not perfect, as various key combinations (sometimes more than one?) may lead to generating given character. We have some intelligent algorithm for this, used to make Characters table and to detect this C for <code>OnRelease</code> callback. The idea is that a character is released when the key that initially caused the press of this character is also released.  <p>This solves in a determined way problems like &quot;what happens if I press Shift, then X, then release Shift, then release X&quot;. (will &quot;X&quot; be correctly released as pressed and then released? yes. will small &quot;x&quot; be reported as released at the end? no, as it was never pressed.) ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnRelease"},
     {"title": "CastleControl.TCastleControlCustom.OnMotion", "text": "  <p>For a mouse, remember you always have the currently pressed mouse buttons in <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#MousePressed\">MousePressed</a>. When this is called, the <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#MousePosition\">MousePosition</a> property records the <i>previous</i> mouse position, while callback parameter NewMousePosition gives the <i>new</i> mouse position. ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnMotion"},
     {"title": "CastleControl.TCastleControlCustom.OnUpdate", "text": " This event is called at least as regularly as redraw, so it is continously called even when your game is overwhelmed by messages (like mouse moves) and redraws. ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#OnUpdate"},
     {"title": "CastleControl.TCastleControlCustom.AutoRedisplay", "text": " If <code>True</code> (the default), <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnRender\">OnRender</a> will called constantly.  <p>If your game may have a still screen (nothing animates), then this approach is a little unoptimal, as we use CPU and GPU for drawing, when it's not needed. In such case, you can set this property to <code>False</code>, and make sure that you call <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Invalidate\">Invalidate</a> always when you need to redraw the screen. Note that the engine components always call <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Invalidate\">Invalidate</a> when necessary, so usually you should only call it yourself if you provide a custom <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnRender\">OnRender</a> implementation. ", "tags": "", "loc": "CastleControl.TCastleControlCustom.html#AutoRedisplay"},
     {"title": "CastleControl.TControlGameSceneManager", "text": " ", "tags": "", "loc": "CastleControl.TControlGameSceneManager.html"},
     {"title": "CastleControl.TCastleControl", "text": " Add your game stuff (descending from <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a>, like <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>) to the scene manager available in <a class=\"normal\" href=\"CastleControl.TCastleControl.html#SceneManager\">SceneManager</a> property. Add your GUI stuff to the <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a> property (from ancestor <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a>).  <p>You can directly access the <a class=\"normal\" href=\"CastleControl.TCastleControl.html#SceneManager\">SceneManager</a> and configure it however you like.  <p>You have comfortable <a class=\"normal\" href=\"CastleControl.TCastleControl.html#Load\">Load</a> method that simply loads a single 3D model to your world. ", "tags": "", "loc": "CastleControl.TCastleControl.html"},
     {"title": "CastleControl.TCastleControl.Create", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControl.html#Create"},
     {"title": "CastleControl.TCastleControl.Load", "text": "  <p>This is nice for simple 3D model browsers, but usually for games you don't want to use this method &mdash; it's more flexible to create <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> yourself, and add it to scene manager yourself, see engine examples like scene_manager_basic.lpr.    ", "tags": "", "loc": "CastleControl.TCastleControl.html#Load"},
     {"title": "CastleControl.TCastleControl.Load", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControl.html#Load"},
     {"title": "CastleControl.TCastleControl.MainScene", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControl.html#MainScene"},
     {"title": "CastleControl.TCastleControl.Camera", "text": "    ", "tags": "", "loc": "CastleControl.TCastleControl.html#Camera"},
     {"title": "CastleControl.TCastleControl.SceneManager", "text": " ", "tags": "", "loc": "CastleControl.TCastleControl.html#SceneManager"},
     {"title": "CastleControl.TCastleControl.OnCameraChanged", "text": " ", "tags": "", "loc": "CastleControl.TCastleControl.html#OnCameraChanged"},
     {"title": "CastleControl.TCastleControl.ShadowVolumes", "text": " ", "tags": "", "loc": "CastleControl.TCastleControl.html#ShadowVolumes"},
     {"title": "CastleControl.TCastleControl.ShadowVolumesRender", "text": " ", "tags": "", "loc": "CastleControl.TCastleControl.html#ShadowVolumesRender"},
     {"title": "CastleControl.TControl2DSceneManager", "text": " ", "tags": "", "loc": "CastleControl.TControl2DSceneManager.html"},
     {"title": "CastleControl.TCastle2DControl", "text": " Add your game stuff, like <a class=\"normal\" href=\"Castle2DSceneManager.T2DScene.html\">T2DScene</a>, to the scene manager available in <a class=\"normal\" href=\"CastleControl.TCastle2DControl.html#SceneManager\">SceneManager</a> property. Add your GUI stuff to the <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a> property (from ancestor <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a>).  <p>You can directly access the <a class=\"normal\" href=\"CastleControl.TCastle2DControl.html#SceneManager\">SceneManager</a> and configure it however you like.  <p>The difference between this and <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a> is that this provides a scene manager descending from <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html\">T2DSceneManager</a>, which is a little more comfortable for typical 2D games. See <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html\">T2DSceneManager</a> description for details. In principle, you can use any of these control classes to develop any mix of 3D or 2D game. ", "tags": "", "loc": "CastleControl.TCastle2DControl.html"},
     {"title": "CastleControl.TCastle2DControl.Create", "text": "    ", "tags": "", "loc": "CastleControl.TCastle2DControl.html#Create"},
     {"title": "CastleControl.TCastle2DControl.SceneManager", "text": " ", "tags": "", "loc": "CastleControl.TCastle2DControl.html#SceneManager"},
     {"title": "CastleControl.DefaultLimitFPS", "text": " ", "tags": "", "loc": "CastleControl.html#DefaultLimitFPS"},
     {"title": "CastleControl.Register", "text": "    ", "tags": "", "loc": "CastleControl.html#Register"},
     {"title": "CastleControl.TControlInputPressReleaseEvent", "text": "    ", "tags": "", "loc": "CastleControl.html#TControlInputPressReleaseEvent"},
     {"title": "CastleControl.TControlInputMotionEvent", "text": "    ", "tags": "", "loc": "CastleControl.html#TControlInputMotionEvent"},
     {"title": "CastleControl.LimitFPS", "text": " Set to zero to not limit.  <p>See TCastleWindow.ProcessMessage documentation about WaitToLimitFPS parameter, and see <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#LimitFPS\">TCastleApplication.LimitFPS</a> documentation.  <p>The mechanism does mean sleeping in your process, so it's a global thing, not just a property of <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a>. However, the mechanism is activated only when some <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a> component is used, and only when LCL idle is fired (so we have no pending events, as LCL idle is &quot;lazy&quot; and fires only when process is really idle), and not at Lazarus design time.  <p>When we may be clogged with events (like when using mouse look) this has an additional meaning: it is then used to force TCastleControl.DoUpdate and (if needed) repaint at least this often. So it is not only a limit, it's more like &quot;the desired number of FPS&quot;. Although it's capped by MaxDesiredFPS (100), which is applied when <code>LimitFPS</code> &gt; MaxDesiredFPS or when <code>LimitFPS</code> = 0 (which means &quot;infinity&quot;). ", "tags": "", "loc": "CastleControl.html#LimitFPS"},
     {"title": "CastleControls", "text": " ", "tags": "", "loc": "CastleControls.html"},
     {"title": "CastleControls.TUIControlFont", "text": " Allows to customize font and font size per-control, or use defaults. ", "tags": "", "loc": "CastleControls.TUIControlFont.html"},
     {"title": "CastleControls.TUIControlFont.UIScaleChanged", "text": "    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#UIScaleChanged"},
     {"title": "CastleControls.TUIControlFont.Notification", "text": "    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#Notification"},
     {"title": "CastleControls.TUIControlFont.Create", "text": "    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#Create"},
     {"title": "CastleControls.TUIControlFont.Destroy", "text": "    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#Destroy"},
     {"title": "CastleControls.TUIControlFont.GLContextClose", "text": "    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#GLContextClose"},
     {"title": "CastleControls.TUIControlFont.TooltipExists", "text": "    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#TooltipExists"},
     {"title": "CastleControls.TUIControlFont.TooltipRender", "text": "    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#TooltipRender"},
     {"title": "CastleControls.TUIControlFont.Render", "text": "    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#Render"},
     {"title": "CastleControls.TUIControlFont.Font", "text": " Depending on various properties of this class, this method returns <a class=\"normal\" href=\"CastleControls.html#UIFont\">UIFont</a> or <a class=\"normal\" href=\"CastleControls.TUIControlFont.html#CustomFont\">CustomFont</a> or a <a class=\"normal\" href=\"CastleFonts.TCustomizedFont.html\">TCustomizedFont</a> instance that wraps (and scales) one of them.    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#Font"},
     {"title": "CastleControls.TUIControlFont.CheckFontChanged", "text": "  <p>You only need to explicitly call this in very specific circumstances, when you just changed <a class=\"normal\" href=\"CastleControls.html#UIFont\">UIFont</a> (changing <a class=\"normal\" href=\"CastleControls.TUIControlFont.html#CustomFont\">CustomFont</a> automatically calls this automatically) and you want control size to be updated immediately (for example, you need <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CalculatedHeight\">CalculatedHeight</a> to be immediately valid). Without calling this, it could be updated only at next Render call.    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#CheckFontChanged"},
     {"title": "CastleControls.TUIControlFont.FontChanged", "text": "  <p><i>Usually, you don't need to call this explicitly from the outside.</i> Changing font, like <a class=\"normal\" href=\"CastleControls.html#UIFont\">UIFont</a> or <a class=\"normal\" href=\"CastleControls.TUIControlFont.html#CustomFont\">CustomFont</a>, or any property that may affect the font is automatically applied.  <p>But there are exceptions: right now, if you call <a class=\"normal\" href=\"CastleFonts.TTextureFont.html#Load\">Load</a> on a font, it's measurements will change but some controls using it will not recalculate sizes automatically. In this case, call this method.    ", "tags": "", "loc": "CastleControls.TUIControlFont.html#FontChanged"},
     {"title": "CastleControls.TUIControlFont.OutlineColor", "text": " Default is <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>.  ", "tags": "", "loc": "CastleControls.TUIControlFont.html#OutlineColor"},
     {"title": "CastleControls.TUIControlFont.Tooltip", "text": "  <p>Note that you can override <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipExists\">TUIControl.TooltipExists</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipStyle\">TUIControl.TooltipStyle</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipRender\">TUIControl.TooltipRender</a> to customize the tooltip drawing. ", "tags": "", "loc": "CastleControls.TUIControlFont.html#Tooltip"},
     {"title": "CastleControls.TUIControlFont.CustomFont", "text": " Otherwise the global <a class=\"normal\" href=\"CastleControls.html#UIFont\">UIFont</a> will be used. ", "tags": "", "loc": "CastleControls.TUIControlFont.html#CustomFont"},
     {"title": "CastleControls.TUIControlFont.OwnsCustomFont", "text": " ", "tags": "", "loc": "CastleControls.TUIControlFont.html#OwnsCustomFont"},
     {"title": "CastleControls.TUIControlFont.FontSize", "text": " Leave at default zero to use the default size of the font (may still be scaled by <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">TUIControl.UIScale</a>, but this happens only if <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">TUIContainer.UIScaling</a> is set to something else than default <a class=\"normal\" href=\"CastleUIControls.html#usNone\">usNone</a>). Font itself is taken from <a class=\"normal\" href=\"CastleControls.TUIControlFont.html#CustomFont\">CustomFont</a> or, if not set, from <a class=\"normal\" href=\"CastleControls.html#UIFont\">UIFont</a>. ", "tags": "", "loc": "CastleControls.TUIControlFont.html#FontSize"},
     {"title": "CastleControls.TUIControlFont.SmallFont", "text": " Right now this just says to scale font by 0.5. ", "tags": "", "loc": "CastleControls.TUIControlFont.html#SmallFont"},
     {"title": "CastleControls.TUIControlFont.FontScale", "text": " This additionally scales the font defined by all other properties of this class, thus you can use it to reliably scale the font (regardless if you use <a class=\"normal\" href=\"CastleControls.TUIControlFont.html#CustomFont\">CustomFont</a> or not, regardless if you set <a class=\"normal\" href=\"CastleControls.TUIControlFont.html#FontSize\">FontSize</a> or not). ", "tags": "", "loc": "CastleControls.TUIControlFont.html#FontScale"},
     {"title": "CastleControls.TUIControlFont.Outline", "text": " Note that the current implementation is very simple, it will only look sensible for small outline values (like 1 or 2).  <p>See <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Outline\">TCastleFont.Outline</a> for more details.  <p>Specifying a non-zero outline for a label overrides the default outline settings for the current font. By default, fonts do not have an outline.  <p> ", "tags": "", "loc": "CastleControls.TUIControlFont.html#Outline"},
     {"title": "CastleControls.TUIControlFont.OutlineHighQuality", "text": " Used only if Outline &lt;&gt; 0. High quality outline looks better, but is about 2x more expensive to draw.  ", "tags": "", "loc": "CastleControls.TUIControlFont.html#OutlineHighQuality"},
     {"title": "CastleControls.TCastleButton", "text": "  <p>This is <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> descendant, so to use it just add it to the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a> list. You will also usually want to adjust position (TCastleButton.Left, TCastleButton.Bottom), <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Caption\">TCastleButton.Caption</a>, and assign <a class=\"normal\" href=\"CastleControls.TCastleButton.html#OnClick\">TCastleButton.OnClick</a> (or ovevrride <a class=\"normal\" href=\"CastleControls.TCastleButton.html#DoClick\">TCastleButton.DoClick</a>). ", "tags": "", "loc": "CastleControls.TCastleButton.html"},
     {"title": "CastleControls.TCastleButton.DefaultImageMargin", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#DefaultImageMargin"},
     {"title": "CastleControls.TCastleButton.DefaultPaddingHorizontal", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#DefaultPaddingHorizontal"},
     {"title": "CastleControls.TCastleButton.DefaultPaddingVertical", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#DefaultPaddingVertical"},
     {"title": "CastleControls.TCastleButton.DefaultLineSpacing", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#DefaultLineSpacing"},
     {"title": "CastleControls.TCastleButton.DefaultTextAlignment", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#DefaultTextAlignment"},
     {"title": "CastleControls.TCastleButton.SetPressed", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#SetPressed"},
     {"title": "CastleControls.TCastleButton.UIScaleChanged", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#UIScaleChanged"},
     {"title": "CastleControls.TCastleButton.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#Create"},
     {"title": "CastleControls.TCastleButton.Destroy", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#Destroy"},
     {"title": "CastleControls.TCastleButton.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#Render"},
     {"title": "CastleControls.TCastleButton.GLContextOpen", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#GLContextOpen"},
     {"title": "CastleControls.TCastleButton.GLContextClose", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#GLContextClose"},
     {"title": "CastleControls.TCastleButton.Press", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#Press"},
     {"title": "CastleControls.TCastleButton.Release", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#Release"},
     {"title": "CastleControls.TCastleButton.Motion", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#Motion"},
     {"title": "CastleControls.TCastleButton.Rect", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#Rect"},
     {"title": "CastleControls.TCastleButton.FontChanged", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#FontChanged"},
     {"title": "CastleControls.TCastleButton.DoClick", "text": " In this class, simply calls <a class=\"normal\" href=\"CastleControls.TCastleButton.html#OnClick\">OnClick</a> callback.    ", "tags": "", "loc": "CastleControls.TCastleButton.html#DoClick"},
     {"title": "CastleControls.TCastleButton.SetFocused", "text": "    ", "tags": "", "loc": "CastleControls.TCastleButton.html#SetFocused"},
     {"title": "CastleControls.TCastleButton.Image", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#Image"},
     {"title": "CastleControls.TCastleButton.OwnsImage", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#OwnsImage"},
     {"title": "CastleControls.TCastleButton.MinImageWidth", "text": " Even if the <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Image\">Image</a> is empty (<code>Nil</code>). This is useful when you have a row of buttons (typical for toolbar), and you want them to have the same height, and their captions to be displayed at the same level, regardless of their images sizes. ", "tags": "", "loc": "CastleControls.TCastleButton.html#MinImageWidth"},
     {"title": "CastleControls.TCastleButton.MinImageHeight", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#MinImageHeight"},
     {"title": "CastleControls.TCastleButton.TintPressed", "text": " Opaque <a class=\"normal\" href=\"CastleColors.html#White\">white</a> by default. ", "tags": "", "loc": "CastleControls.TCastleButton.html#TintPressed"},
     {"title": "CastleControls.TCastleButton.TintDisabled", "text": " Opaque <a class=\"normal\" href=\"CastleColors.html#White\">white</a> by default. ", "tags": "", "loc": "CastleControls.TCastleButton.html#TintDisabled"},
     {"title": "CastleControls.TCastleButton.TintFocused", "text": " Opaque <a class=\"normal\" href=\"CastleColors.html#White\">white</a> by default. ", "tags": "", "loc": "CastleControls.TCastleButton.html#TintFocused"},
     {"title": "CastleControls.TCastleButton.TintNormal", "text": " Opaque <a class=\"normal\" href=\"CastleColors.html#White\">white</a> by default. ", "tags": "", "loc": "CastleControls.TCastleButton.html#TintNormal"},
     {"title": "CastleControls.TCastleButton.CustomBackground", "text": " If <code>True</code>, we use properties </p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackgroundPressed\">CustomBackgroundPressed</a> (or fallback on <a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackgroundNormal\">CustomBackgroundNormal</a> if <code>Nil</code>),</p></li>   <li><p><a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackgroundDisabled\">CustomBackgroundDisabled</a> (or fallback on <a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackgroundNormal\">CustomBackgroundNormal</a> if <code>Nil</code>),</p></li>   <li><p><a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackgroundFocused\">CustomBackgroundFocused</a> (or fallback on <a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackgroundNormal\">CustomBackgroundNormal</a> if <code>Nil</code>),</p></li>   <li><p><a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackgroundNormal\">CustomBackgroundNormal</a> (or fallback on transparent background if <code>Nil</code>).</p></li> </ul>  <p>. They are rendered as 3x3 images (see <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw3x3\">TGLImageCore.Draw3x3</a>) with corners specified by <a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackgroundCorners\">CustomBackgroundCorners</a>. ", "tags": "", "loc": "CastleControls.TCastleButton.html#CustomBackground"},
     {"title": "CastleControls.TCastleButton.CustomBackgroundPressed", "text": " See <a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackground\">CustomBackground</a> for details. ", "tags": "", "loc": "CastleControls.TCastleButton.html#CustomBackgroundPressed"},
     {"title": "CastleControls.TCastleButton.OwnsCustomBackgroundPressed", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#OwnsCustomBackgroundPressed"},
     {"title": "CastleControls.TCastleButton.CustomBackgroundDisabled", "text": " See <a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackground\">CustomBackground</a> for details. ", "tags": "", "loc": "CastleControls.TCastleButton.html#CustomBackgroundDisabled"},
     {"title": "CastleControls.TCastleButton.OwnsCustomBackgroundDisabled", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#OwnsCustomBackgroundDisabled"},
     {"title": "CastleControls.TCastleButton.CustomBackgroundFocused", "text": " See <a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackground\">CustomBackground</a> for details. ", "tags": "", "loc": "CastleControls.TCastleButton.html#CustomBackgroundFocused"},
     {"title": "CastleControls.TCastleButton.OwnsCustomBackgroundFocused", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#OwnsCustomBackgroundFocused"},
     {"title": "CastleControls.TCastleButton.CustomBackgroundNormal", "text": " See <a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackground\">CustomBackground</a> for details. ", "tags": "", "loc": "CastleControls.TCastleButton.html#CustomBackgroundNormal"},
     {"title": "CastleControls.TCastleButton.OwnsCustomBackgroundNormal", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#OwnsCustomBackgroundNormal"},
     {"title": "CastleControls.TCastleButton.CustomBackgroundCorners", "text": " See <a class=\"normal\" href=\"CastleControls.TCastleButton.html#CustomBackground\">CustomBackground</a> for details. Zero by default. ", "tags": "", "loc": "CastleControls.TCastleButton.html#CustomBackgroundCorners"},
     {"title": "CastleControls.TCastleButton.CustomTextColorUse", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#CustomTextColorUse"},
     {"title": "CastleControls.TCastleButton.CustomTextColor", "text": " <a class=\"normal\" href=\"CastleColors.html#Black\">Black</a> by default, just like <code>Theme.TextColor</code>. ", "tags": "", "loc": "CastleControls.TCastleButton.html#CustomTextColor"},
     {"title": "CastleControls.TCastleButton.TextAlignment", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#TextAlignment"},
     {"title": "CastleControls.TCastleButton.LineSpacing", "text": " May also be negative to squeeze lines tighter. ", "tags": "", "loc": "CastleControls.TCastleButton.html#LineSpacing"},
     {"title": "CastleControls.TCastleButton.Html", "text": " This allows to easily change colors or use bold, italic text.  <p>See the example examples/fonts/html_text.lpr and examples/fonts/html_text_demo.html for a demo of what <code>HTML</code> tags can do. See <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">TCastleFont.PrintStrings</a> documentation for a list of support <code>HTML</code> markup.  <p>Note that to see the bold/italic font variants in the <code>HTML</code> markup, you need to set the font to be <a class=\"normal\" href=\"CastleFontFamily.TFontFamily.html\">TFontFamily</a> with bold/italic variants. See the example mentioned above, examples/fonts/html_text.lpr, for a code how to do it. ", "tags": "", "loc": "CastleControls.TCastleButton.html#Html"},
     {"title": "CastleControls.TCastleButton.Width", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#Width"},
     {"title": "CastleControls.TCastleButton.Height", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#Height"},
     {"title": "CastleControls.TCastleButton.PaddingHorizontal", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#PaddingHorizontal"},
     {"title": "CastleControls.TCastleButton.PaddingVertical", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#PaddingVertical"},
     {"title": "CastleControls.TCastleButton.AutoSize", "text": " The calculated size takes into account the <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Caption\">Caption</a> text size (with current font), and <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Image\">Image</a> size, plus some margin to make it look nice.  <p>Width is auto-calculated only when <code>AutoSize</code> and <a class=\"normal\" href=\"CastleControls.TCastleButton.html#AutoSizeWidth\">AutoSizeWidth</a> (otherwise we just use <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Width\">Width</a> property value). Likewise, Height is calculated only when <code>AutoSize</code> and <a class=\"normal\" href=\"CastleControls.TCastleButton.html#AutoSizeHeight\">AutoSizeHeight</a> (otherwise we just use <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Height\">Height</a> property value). This way you can turn off auto-sizing in only one dimension if you want (and when you don't need such flexibility, leave <a class=\"normal\" href=\"CastleControls.TCastleButton.html#AutoSizeWidth\">AutoSizeWidth</a> = <a class=\"normal\" href=\"CastleControls.TCastleButton.html#AutoSizeHeight\">AutoSizeHeight</a> = <code>True</code> and control both by simple <code>AutoSize</code>).  <p>If needed, you can query the resulting button size with the standard <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> methods like <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CalculatedWidth\">TUIControl.CalculatedWidth</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CalculatedHeight\">TUIControl.CalculatedHeight</a>. Note that they may not be available before the button is actually added to the container, and the container size is initialized (we need to know the size of container, for UI scaling to determine the font size). ", "tags": "", "loc": "CastleControls.TCastleButton.html#AutoSize"},
     {"title": "CastleControls.TCastleButton.AutoSizeWidth", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#AutoSizeWidth"},
     {"title": "CastleControls.TCastleButton.AutoSizeHeight", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#AutoSizeHeight"},
     {"title": "CastleControls.TCastleButton.MinWidth", "text": " This is useful if you want to use auto-size (to make sure that the content fits inside), but you want to force filling some space. ", "tags": "", "loc": "CastleControls.TCastleButton.html#MinWidth"},
     {"title": "CastleControls.TCastleButton.MinHeight", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#MinHeight"},
     {"title": "CastleControls.TCastleButton.OnClick", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#OnClick"},
     {"title": "CastleControls.TCastleButton.Caption", "text": " The text may be multiline (use the LineEnding or <a class=\"normal\" href=\"CastleUtils.html#NL\">NL</a> constants to mark newlines). ", "tags": "", "loc": "CastleControls.TCastleButton.html#Caption"},
     {"title": "CastleControls.TCastleButton.Toggle", "text": " Good for making a button behave like a checkbox, that is indicate a boolean state. When <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Toggle\">Toggle</a> is <code>True</code>, you can set the <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Pressed\">Pressed</a> property, and the clicks are visualized a little differently. ", "tags": "", "loc": "CastleControls.TCastleButton.html#Toggle"},
     {"title": "CastleControls.TCastleButton.Pressed", "text": " If <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Toggle\">Toggle</a> is <code>True</code>, you can read and write this property to set the pressed state.  <p>When not <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Toggle\">Toggle</a>, this property isn't really useful to you. The pressed state is automatically managed then to visualize user clicks. In this case, you can read this property, but you cannot reliably set it. ", "tags": "", "loc": "CastleControls.TCastleButton.html#Pressed"},
     {"title": "CastleControls.TCastleButton.ImageLayout", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#ImageLayout"},
     {"title": "CastleControls.TCastleButton.ImageAlphaTest", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#ImageAlphaTest"},
     {"title": "CastleControls.TCastleButton.ImageMargin", "text": " Unused if <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Image\">Image</a> not set. ", "tags": "", "loc": "CastleControls.TCastleButton.html#ImageMargin"},
     {"title": "CastleControls.TCastleButton.Enabled", "text": " ", "tags": "", "loc": "CastleControls.TCastleButton.html#Enabled"},
     {"title": "CastleControls.TCastleButton.EnableParentDragging", "text": " To do this, you need to turn on <a class=\"normal\" href=\"CastleControls.TCastleScrollView.html#EnableDragging\">TCastleScrollView.EnableDragging</a>, and set <code>EnableParentDragging</code>=<code>True</code> on all buttons inside. In effect, buttons will cancel the click operation once you start dragging, which allows the parent to handle all the <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Motion\">motion</a> events for dragging. ", "tags": "", "loc": "CastleControls.TCastleButton.html#EnableParentDragging"},
     {"title": "CastleControls.TCastlePanel", "text": " Use as a background for other controls like buttons. You can add vertical separators to separate groups of controls on the panel. ", "tags": "", "loc": "CastleControls.TCastlePanel.html"},
     {"title": "CastleControls.TCastlePanel.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastlePanel.html#Create"},
     {"title": "CastleControls.TCastlePanel.Destroy", "text": "    ", "tags": "", "loc": "CastleControls.TCastlePanel.html#Destroy"},
     {"title": "CastleControls.TCastlePanel.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastlePanel.html#Render"},
     {"title": "CastleControls.TCastlePanel.SeparatorSize", "text": "    ", "tags": "", "loc": "CastleControls.TCastlePanel.html#SeparatorSize"},
     {"title": "CastleControls.TCastlePanel.VerticalSeparators", "text": " Useful if you want to visually separate groups of contols (like a groups of buttons when you use this panel as a toolbar).  <p>Values are the horizontal positions of the separators (with respect to this panel <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Left\">Left</a>). Width of the separator is in <a class=\"normal\" href=\"CastleControls.TCastlePanel.html#SeparatorSize\">SeparatorSize</a>. ", "tags": "", "loc": "CastleControls.TCastlePanel.html#VerticalSeparators"},
     {"title": "CastleControls.TCastleImageControl", "text": " Size is automatically adjusted to the image size, if <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Stretch\">Stretch</a> is <code>False</code> (default). You should set TCastleImageControl.Left, TCastleImageControl.Bottom properties, and load your image by setting <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#URL\">TCastleImageControl.URL</a> property or straight <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Image\">TCastleImageControl.Image</a>.  <p>We automatically use alpha test or alpha blending based on loaded image alpha channel (see <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">TGLImageCore.Alpha</a>). You can influence this by <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#AlphaChannel\">AlphaChannel</a> property. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html"},
     {"title": "CastleControls.TCastleImageControl.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Create"},
     {"title": "CastleControls.TCastleImageControl.Destroy", "text": "    ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Destroy"},
     {"title": "CastleControls.TCastleImageControl.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Render"},
     {"title": "CastleControls.TCastleImageControl.GLContextOpen", "text": "    ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#GLContextOpen"},
     {"title": "CastleControls.TCastleImageControl.GLContextClose", "text": "    ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#GLContextClose"},
     {"title": "CastleControls.TCastleImageControl.Rect", "text": "    ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Rect"},
     {"title": "CastleControls.TCastleImageControl.ImageChanged", "text": "    ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#ImageChanged"},
     {"title": "CastleControls.TCastleImageControl.Image", "text": " You can set it by setting <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#URL\">URL</a>, or you can set this property directly if you loaded/created the image contents yourself.  <p>Note that by default the <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instance assigned here is owned by this component (see <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#OwnsImage\">OwnsImage</a>). So if you set this property to your custom <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instance you should leave memory management of this instance to this component. You can either create a copy by <a class=\"normal\" href=\"CastleImages.TCastleImage.html#MakeCopy\">TCastleImage.MakeCopy</a> if you want to give here only a copy, or you can change <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#OwnsImage\">OwnsImage</a> to <code>False</code>.  <p>It is allowed to modify the contents or even size of this image. Just make sure to call <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#ImageChanged\">ImageChanged</a> after the modifications are done to update the actual rendered image. The control size will be updated immediately (taking into account current <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Stretch\">Stretch</a> and related properties values). ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Image"},
     {"title": "CastleControls.TCastleImageControl.OwnsImage", "text": " See <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Image\">Image</a> documentation for details. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#OwnsImage"},
     {"title": "CastleControls.TCastleImageControl.Color", "text": " This simply multiplies the image RGBA components, just like <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Color\">TGLImageCore.Color</a>. By default this is opaque <a class=\"normal\" href=\"CastleColors.html#White\">white</a>, which means that image colors are unchanged. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Color"},
     {"title": "CastleControls.TCastleImageControl.Corners", "text": " See <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw3x3\">TGLImageCore.Draw3x3</a> for the details how drawing image with borders work. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Corners"},
     {"title": "CastleControls.TCastleImageControl.CenterX", "text": " Value from 0 to 1. Default value 0.5. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#CenterX"},
     {"title": "CastleControls.TCastleImageControl.CenterY", "text": " Value from 0 to 1. Default value 0.5. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#CenterY"},
     {"title": "CastleControls.TCastleImageControl.Rotation", "text": " Default value 0. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Rotation"},
     {"title": "CastleControls.TCastleImageControl.Clip", "text": " ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Clip"},
     {"title": "CastleControls.TCastleImageControl.ClipLine", "text": " Given a line (A, B, C) and pixel (x, y), the pixel is clipped (rejected) if <code>A * x + B * y + C &lt; 0</code>.  <p>The equation is calculated in the final scaled screen coordinates (not in the local, unscaled pixels). Adjust it to match the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ScreenRect\">ScreenRect</a> if necessary, to make it work with UI scaling. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#ClipLine"},
     {"title": "CastleControls.TCastleImageControl.URL", "text": " Setting this also sets <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Image\">Image</a>. Set this to '' to clear the image. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#URL"},
     {"title": "CastleControls.TCastleImageControl.FileName", "text": " ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#FileName"},
     {"title": "CastleControls.TCastleImageControl.AlphaChannel", "text": " By default, this is <a class=\"normal\" href=\"CastleImages.html#acAuto\">acAuto</a>, which means that image contents together with current <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Color\">Color</a> determine how the alpha of image is treated (opaque, alpha test, alpha blending). Set this to force specific treatment. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#AlphaChannel"},
     {"title": "CastleControls.TCastleImageControl.Blending", "text": " ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Blending"},
     {"title": "CastleControls.TCastleImageControl.SmoothScaling", "text": " See <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">TGLImageCore.SmoothScaling</a>. ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#SmoothScaling"},
     {"title": "CastleControls.TCastleImageControl.Stretch", "text": "  <p>If <code>Stretch</code> = <code>False</code>, then values you set for Width, Height, <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#FullSize\">FullSize</a>, <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#ProportionalScaling\">ProportionalScaling</a> properties do not matter (they are still remembered though, so you can set properties in any order). The displayed size (you can check it through <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Rect\">Rect</a> function) always corresponds to the underlying image size. The Left and Bottom properties work as usual, they allow you to move the control.  <p>If <code>Stretch</code> = <code>True</code>, then the image will be stretched to fill the requested area.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>If <code>Stretch</code> = <code>True</code> and <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#FullSize\">FullSize</a> = <code>True</code> then values of Width, Height, Left, Bottom do not matter: image always fills the whole parent (<a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Rect\">Rect</a> corresponds to the parent area).</p></li>   <li><p>If <code>Stretch</code> = <code>True</code> and <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#FullSize\">FullSize</a> = <code>False</code> then the property <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#ProportionalScaling\">ProportionalScaling</a> determines how the the image will be adjusted to fit the requested Width and Height.  <p></p>  <dl class=\"paragraph_spacing\">   <dt><a class=\"normal\" href=\"CastleControls.html#psNone\">psNone</a></dt>   <dd><p>The image will be scaled to exactly fill the requested Width and Height (without paying attention to the aspect ratio of the image).  <p>This is the case when you fully force the displayed size and position, regardless of image size. Displayed image will always exactly fill the requested area.</p></dd>   <dt><a class=\"normal\" href=\"CastleControls.html#psFit\">psFit</a></dt>   <dd><p>The image will be proportionally scaled to fit within the requested Width and Height. If the aspect ratio of image will be different than aspect ratio of Width/Height, the scaled image will be centered inside the Width/Height.</p></dd>   <dt><a class=\"normal\" href=\"CastleControls.html#psEnclose\">psEnclose</a></dt>   <dd><p>The image will be proportionally scaled to enclode the requested Width and Height. If the aspect ratio of image will be different than aspect ratio of Width/Height, the scaled image will be larger then the requested area.</p></dd> </dl>  <p> </p></li> </ul>  <p>  <p>Note that you can always look at <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Rect\">Rect</a> value to know the current calculated size and position of the image control on screen.  <p> ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Stretch"},
     {"title": "CastleControls.TCastleImageControl.Width", "text": " ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Width"},
     {"title": "CastleControls.TCastleImageControl.Height", "text": " ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Height"},
     {"title": "CastleControls.TCastleImageControl.FullSize", "text": " ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#FullSize"},
     {"title": "CastleControls.TCastleImageControl.ProportionalScaling", "text": " ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#ProportionalScaling"},
     {"title": "CastleControls.TCastleImageControl.Proportional", "text": " ", "tags": "", "loc": "CastleControls.TCastleImageControl.html#Proportional"},
     {"title": "CastleControls.TCastleTouchControl", "text": " Shows one &quot;lever&quot;, that can be moved up/down/left/right, and controls the movement while Walking or Flying.  <p>Usually, this control is created and used through the <a class=\"normal\" href=\"CastleWindowTouch.TCastleWindowTouch.html\">TCastleWindowTouch</a> properties. There is no need to directly create <code>TCastleTouchControl</code> instance in this case. ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html"},
     {"title": "CastleControls.TCastleTouchControl.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#Create"},
     {"title": "CastleControls.TCastleTouchControl.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#Render"},
     {"title": "CastleControls.TCastleTouchControl.Rect", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#Rect"},
     {"title": "CastleControls.TCastleTouchControl.Press", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#Press"},
     {"title": "CastleControls.TCastleTouchControl.Release", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#Release"},
     {"title": "CastleControls.TCastleTouchControl.Motion", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#Motion"},
     {"title": "CastleControls.TCastleTouchControl.SetTouchMode", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#SetTouchMode"},
     {"title": "CastleControls.TCastleTouchControl.GetSensorRotation", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#GetSensorRotation"},
     {"title": "CastleControls.TCastleTouchControl.GetSensorTranslation", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#GetSensorTranslation"},
     {"title": "CastleControls.TCastleTouchControl.TouchMode", "text": " ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#TouchMode"},
     {"title": "CastleControls.TCastleTouchControl.Position", "text": " Right now this simply sets the anchor using <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HasHorizontalAnchor\">TUIControl.HasHorizontalAnchor</a> and friends. Tip: Use <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">TUIContainer.UIScaling</a> to have the anchors automatically scale with screen size.  <p>The size of the control is set to be constant physical size, so it's not affected by <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">TUIContainer.UIScaling</a>, only by <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Dpi\">TUIContainer.Dpi</a>. ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#Position"},
     {"title": "CastleControls.TCastleTouchControl.Scale", "text": " ", "tags": "", "loc": "CastleControls.TCastleTouchControl.html#Scale"},
     {"title": "CastleControls.TCastleRectangleControl", "text": " ", "tags": "", "loc": "CastleControls.TCastleRectangleControl.html"},
     {"title": "CastleControls.TCastleRectangleControl.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleRectangleControl.html#Create"},
     {"title": "CastleControls.TCastleRectangleControl.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleRectangleControl.html#Render"},
     {"title": "CastleControls.TCastleRectangleControl.Press", "text": "    ", "tags": "", "loc": "CastleControls.TCastleRectangleControl.html#Press"},
     {"title": "CastleControls.TCastleRectangleControl.Release", "text": "    ", "tags": "", "loc": "CastleControls.TCastleRectangleControl.html#Release"},
     {"title": "CastleControls.TCastleRectangleControl.Motion", "text": "    ", "tags": "", "loc": "CastleControls.TCastleRectangleControl.html#Motion"},
     {"title": "CastleControls.TCastleRectangleControl.Color", "text": " By default, opaque <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. ", "tags": "", "loc": "CastleControls.TCastleRectangleControl.html#Color"},
     {"title": "CastleControls.TCastleRectangleControl.InterceptInput", "text": " More precisely, when this property is <code>True</code>, then the <a class=\"normal\" href=\"CastleControls.TCastleRectangleControl.html#Press\">Press</a>, <a class=\"normal\" href=\"CastleControls.TCastleRectangleControl.html#Release\">Release</a> and <a class=\"normal\" href=\"CastleControls.TCastleRectangleControl.html#Motion\">Motion</a> events are marked as &quot;handled&quot; by this control. ", "tags": "", "loc": "CastleControls.TCastleRectangleControl.html#InterceptInput"},
     {"title": "CastleControls.TCastleShape", "text": " ", "tags": "", "loc": "CastleControls.TCastleShape.html"},
     {"title": "CastleControls.TCastleShape.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleShape.html#Create"},
     {"title": "CastleControls.TCastleShape.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleShape.html#Render"},
     {"title": "CastleControls.TCastleShape.ShapeType", "text": " ", "tags": "", "loc": "CastleControls.TCastleShape.html#ShapeType"},
     {"title": "CastleControls.TCastleShape.Filled", "text": " ", "tags": "", "loc": "CastleControls.TCastleShape.html#Filled"},
     {"title": "CastleControls.TCastleShape.Color", "text": " By default, opaque <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. ", "tags": "", "loc": "CastleControls.TCastleShape.html#Color"},
     {"title": "CastleControls.TCastleShape.Outline", "text": " ", "tags": "", "loc": "CastleControls.TCastleShape.html#Outline"},
     {"title": "CastleControls.TCastleShape.OutlineColor", "text": " By default, opaque <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>. ", "tags": "", "loc": "CastleControls.TCastleShape.html#OutlineColor"},
     {"title": "CastleControls.TCastleShape.OutlineThick", "text": "  <p></p>  <dl class=\"paragraph_spacing\">   <dt><code>False</code> (default)</dt>   <dd><p>Draw the outline using lines, and apply <a class=\"normal\" href=\"CastleControls.TCastleShape.html#OutlineWidth\">OutlineWidth</a> by changing line width.  <p>Disadvantage: <b>outline widths thicker than 1 pixel are not guaranteed to be supported. In particular they will almost never work on mobile (OpenGLES).</b> See the LineWidth comments at <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a> procedure.  <p>Consider using other methods if you need to draw a thick shape outline in a reliable manner. To draw a rectangle with frame, it's usually better to use Draw3x3 call, with a special texture with a frame and insides.</p></dd>   <dt><code>True</code></dt>   <dd><p>Draw the outline by first drawing a larger shape with <a class=\"normal\" href=\"CastleControls.TCastleShape.html#OutlineColor\">OutlineColor</a> underneath the smaller shape with Color.  <p>Disadvantages: </p>  <ul class=\"paragraph_spacing\">   <li><p>Cannot work sensibly if <a class=\"normal\" href=\"CastleControls.TCastleShape.html#Filled\">Filled</a> is <code>False</code>, so it's disabled then. When <a class=\"normal\" href=\"CastleControls.TCastleShape.html#Filled\">Filled</a> is <code>False</code>, it's like <code>OutlineThick</code> was always also <code>False</code>.</p></li>   <li><p>The alpha blending may not be exactly what you want, since the pixels inside are overdrawn with both <a class=\"normal\" href=\"CastleControls.TCastleShape.html#OutlineColor\">OutlineColor</a> and then with Color.</p></li>   <li><p>May look a little worse in case of small <a class=\"normal\" href=\"CastleControls.TCastleShape.html#OutlineWidth\">OutlineWidth</a> and non-rectangular shapes.</p></li> </ul>  <p>  <p>Advantage: thick <a class=\"normal\" href=\"CastleControls.TCastleShape.html#OutlineWidth\">OutlineWidth</a> works reliably.</p></dd> </dl>  <p> ", "tags": "", "loc": "CastleControls.TCastleShape.html#OutlineThick"},
     {"title": "CastleControls.TCastleShape.OutlineWidth", "text": " It is affected by UI scaling.  <p>If <a class=\"normal\" href=\"CastleControls.TCastleShape.html#OutlineThick\">OutlineThick</a> is <code>False</code>, then <b>outline widths thicker than 1 pixel are not guaranteed to be supported. In particular they will almost never work on mobile (OpenGLES).</b> Change <a class=\"normal\" href=\"CastleControls.TCastleShape.html#OutlineThick\">OutlineThick</a> to <code>True</code> to have reliable thick outlines. ", "tags": "", "loc": "CastleControls.TCastleShape.html#OutlineWidth"},
     {"title": "CastleControls.TCastleSimpleBackground", "text": " This is very fast, but it unconditionally clears the whole window, and there is no blending (if your <a class=\"normal\" href=\"CastleControls.TCastleSimpleBackground.html#Color\">Color</a> has some alpha, it is just copied to the color buffer). To clear the rectangle with a color, with optional blending, use <a class=\"normal\" href=\"CastleControls.TCastleRectangleControl.html\">TCastleRectangleControl</a> instead.  <p>Note that <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> clears the background under itself by default. See TCastleSceneManager.Transparent, TCastleSceneManager.BackgroundColor . So if you use <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> that fills the whole screen, then there's no need to use this control. ", "tags": "", "loc": "CastleControls.TCastleSimpleBackground.html"},
     {"title": "CastleControls.TCastleSimpleBackground.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleSimpleBackground.html#Create"},
     {"title": "CastleControls.TCastleSimpleBackground.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleSimpleBackground.html#Render"},
     {"title": "CastleControls.TCastleSimpleBackground.Color", "text": " By default, this is <a class=\"normal\" href=\"CastleColors.html#Black\">black</a> color with opaque alpha. ", "tags": "", "loc": "CastleControls.TCastleSimpleBackground.html#Color"},
     {"title": "CastleControls.TCastleLabel", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html"},
     {"title": "CastleControls.TCastleLabel.DefaultLineSpacing", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html#DefaultLineSpacing"},
     {"title": "CastleControls.TCastleLabel.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Create"},
     {"title": "CastleControls.TCastleLabel.Destroy", "text": "    ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Destroy"},
     {"title": "CastleControls.TCastleLabel.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Render"},
     {"title": "CastleControls.TCastleLabel.Rect", "text": "    ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Rect"},
     {"title": "CastleControls.TCastleLabel.DisplayChars", "text": "    ", "tags": "", "loc": "CastleControls.TCastleLabel.html#DisplayChars"},
     {"title": "CastleControls.TCastleLabel.Color", "text": " By default it's <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Color"},
     {"title": "CastleControls.TCastleLabel.FrameColor", "text": " By default <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. ", "tags": "", "loc": "CastleControls.TCastleLabel.html#FrameColor"},
     {"title": "CastleControls.TCastleLabel.Width", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Width"},
     {"title": "CastleControls.TCastleLabel.Height", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Height"},
     {"title": "CastleControls.TCastleLabel.FullSize", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html#FullSize"},
     {"title": "CastleControls.TCastleLabel.AutoSize", "text": " The size of the label determines where does it display the <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Frame\">Frame</a>, where does it catch events, to what width is it aligned (see <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Alignment\">Alignment</a>) and so on.  <p>When this is <code>True</code> (the default) then <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Width\">Width</a>, <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Height\">Height</a>, <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#FullSize\">FullSize</a> values are ignored. ", "tags": "", "loc": "CastleControls.TCastleLabel.html#AutoSize"},
     {"title": "CastleControls.TCastleLabel.Text", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Text"},
     {"title": "CastleControls.TCastleLabel.Caption", "text": " This is just a shortcut to get/set <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Text\">Text</a> as a single string.  <p>Use LineEnding or <a class=\"normal\" href=\"CastleUtils.html#NL\">NL</a> constant when setting this to indicate a newline. The two examples below are equivalent:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_comment\">// one way</span> Label1.Text.Clear; Label1.Text.Add(<span class=\"pascal_string\">'First line'</span>); Label1.Text.Add(<span class=\"pascal_string\">'Second line'</span>);  <span class=\"pascal_comment\">// alternative way to do the same</span> Label1.Caption := <span class=\"pascal_string\">'First line'</span> + LineEnding + <span class=\"pascal_string\">'Second line'</span>;</pre>  <p> ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Caption"},
     {"title": "CastleControls.TCastleLabel.PaddingHorizontal", "text": " Total horizontal <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Padding\">padding</a> is the sum <code><code>PaddingHorizontal</code> + <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Padding\">Padding</a></code>, total vertical <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Padding\">padding</a> is the sum <code><a class=\"normal\" href=\"CastleControls.TCastleLabel.html#PaddingVertical\">PaddingVertical</a> + <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Padding\">Padding</a></code>.  ", "tags": "", "loc": "CastleControls.TCastleLabel.html#PaddingHorizontal"},
     {"title": "CastleControls.TCastleLabel.PaddingVertical", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html#PaddingVertical"},
     {"title": "CastleControls.TCastleLabel.Padding", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Padding"},
     {"title": "CastleControls.TCastleLabel.LineSpacing", "text": " May be negative to squeeze lines tighter together. ", "tags": "", "loc": "CastleControls.TCastleLabel.html#LineSpacing"},
     {"title": "CastleControls.TCastleLabel.Html", "text": " This allows to easily change colors or use bold, italic text.  <p>See the example examples/fonts/html_text.lpr and examples/fonts/html_text_demo.html for a demo of what <code>HTML</code> tags can do. See <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">TCastleFont.PrintStrings</a> documentation for a list of support <code>HTML</code> markup.  <p>Note that to see the bold/italic font variants in the <code>HTML</code> markup, you need to set the font to be <a class=\"normal\" href=\"CastleFontFamily.TFontFamily.html\">TFontFamily</a> with bold/italic variants. See the example mentioned above, examples/fonts/html_text.lpr, for a code how to do it. ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Html"},
     {"title": "CastleControls.TCastleLabel.Tags", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Tags"},
     {"title": "CastleControls.TCastleLabel.Frame", "text": " Frame uses theme image <a class=\"normal\" href=\"CastleControls.html#tiLabel\">tiLabel</a>, see <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#Images\">TCastleTheme.Images</a> if you want to customize it. ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Frame"},
     {"title": "CastleControls.TCastleLabel.MaxWidth", "text": " The text will be broken in the middle of lines, to make it fit (together with <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#PaddingHorizontal\">PaddingHorizontal</a>) inside <code>MaxWidth</code>. ", "tags": "", "loc": "CastleControls.TCastleLabel.html#MaxWidth"},
     {"title": "CastleControls.TCastleLabel.Alignment", "text": " ", "tags": "", "loc": "CastleControls.TCastleLabel.html#Alignment"},
     {"title": "CastleControls.TCastleLabel.VerticalAlignment", "text": " Usually you don't want to use this, instead leave <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#AutoSize\">AutoSize</a> = <code>True</code> and align the label to the parent using anchors, like <code>MyLabel.Anchor(<a class=\"normal\" href=\"CastleUIControls.html#vpMiddle\">vpMiddle</a>);</code> or <code>MyLabel.Anchor(<a class=\"normal\" href=\"CastleUIControls.html#vpTop\">vpTop</a>);</code>.  <p>This property is useful if you really need to manually control the size. It only matters when <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#AutoSize\">AutoSize</a> is <code>False</code>. Then it controls where the text is, with respect to it's rectangle defined by properties like <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#Height\">Height</a> or <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#FullSize\">FullSize</a>. ", "tags": "", "loc": "CastleControls.TCastleLabel.html#VerticalAlignment"},
     {"title": "CastleControls.TCastleLabel.MaxDisplayChars", "text": " This doesn't affect the label size, only the rendered text. It's nice to show the animation of text &quot;expanding&quot;, filling some area. Use <a class=\"normal\" href=\"CastleControls.TCastleLabel.html#DisplayChars\">DisplayChars</a> as the maximum sensible value for this. ", "tags": "", "loc": "CastleControls.TCastleLabel.html#MaxDisplayChars"},
     {"title": "CastleControls.TCastleCrosshair", "text": " ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html"},
     {"title": "CastleControls.TCastleCrosshair.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#Create"},
     {"title": "CastleControls.TCastleCrosshair.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#Render"},
     {"title": "CastleControls.TCastleCrosshair.Rect", "text": "    ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#Rect"},
     {"title": "CastleControls.TCastleCrosshair.Shape", "text": " ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#Shape"},
     {"title": "CastleControls.TCastleCrosshair.HasHorizontalAnchor", "text": " ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#HasHorizontalAnchor"},
     {"title": "CastleControls.TCastleCrosshair.HasVerticalAnchor", "text": " ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#HasVerticalAnchor"},
     {"title": "CastleControls.TCastleCrosshair.HorizontalAnchorSelf", "text": " ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#HorizontalAnchorSelf"},
     {"title": "CastleControls.TCastleCrosshair.HorizontalAnchorParent", "text": " ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#HorizontalAnchorParent"},
     {"title": "CastleControls.TCastleCrosshair.VerticalAnchorSelf", "text": " ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#VerticalAnchorSelf"},
     {"title": "CastleControls.TCastleCrosshair.VerticalAnchorParent", "text": " ", "tags": "", "loc": "CastleControls.TCastleCrosshair.html#VerticalAnchorParent"},
     {"title": "CastleControls.TCastleProgressBar", "text": " This is usually used through the <a class=\"normal\" href=\"CastleWindowProgress.html\">CastleWindowProgress</a> and <a class=\"normal\" href=\"CastleProgress.html\">CastleProgress</a> features. There is no need to directly create and access the <code>TCastleProgressBar</code> instance in this case. ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html"},
     {"title": "CastleControls.TCastleProgressBar.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html#Create"},
     {"title": "CastleControls.TCastleProgressBar.Destroy", "text": "    ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html#Destroy"},
     {"title": "CastleControls.TCastleProgressBar.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html#Render"},
     {"title": "CastleControls.TCastleProgressBar.GLContextOpen", "text": "    ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html#GLContextOpen"},
     {"title": "CastleControls.TCastleProgressBar.GLContextClose", "text": "    ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html#GLContextClose"},
     {"title": "CastleControls.TCastleProgressBar.Rect", "text": "    ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html#Rect"},
     {"title": "CastleControls.TCastleProgressBar.Progress", "text": " ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html#Progress"},
     {"title": "CastleControls.TCastleProgressBar.Background", "text": " May be left unassigned (<code>Nil</code>), in which case you're responsible for making sure some other control (like <a class=\"normal\" href=\"CastleControls.TCastleSimpleBackground.html\">TCastleSimpleBackground</a> or maybe 3D viewport) always covers the screen underneath.  <p>When it's assigned, it's always drawn scaled to cover the whole screen (container). It's owner by this component (it will be automatically freed when necessary). ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html#Background"},
     {"title": "CastleControls.TCastleProgressBar.YPosition", "text": " 0 means the middle of progress bar is at the bottom of the container, 1 means at the top. 0.5 indicates the middle, and it's the default.  <p>Note that extreme values (0 or 1) mean that bottom or top half of the progress bar doesn't fit on the screen, as this property positions the middle of the progress bar. ", "tags": "", "loc": "CastleControls.TCastleProgressBar.html#YPosition"},
     {"title": "CastleControls.TCastleAbstractSlider", "text": " Usually you want to use of its descendants, like <a class=\"normal\" href=\"CastleControls.TCastleFloatSlider.html\">TCastleFloatSlider</a> or <a class=\"normal\" href=\"CastleControls.TCastleIntegerSlider.html\">TCastleIntegerSlider</a>. ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html"},
     {"title": "CastleControls.TCastleAbstractSlider.DefaultWidth", "text": " ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#DefaultWidth"},
     {"title": "CastleControls.TCastleAbstractSlider.DefaultHeight", "text": " ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#DefaultHeight"},
     {"title": "CastleControls.TCastleAbstractSlider.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#Create"},
     {"title": "CastleControls.TCastleAbstractSlider.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#Render"},
     {"title": "CastleControls.TCastleAbstractSlider.Rect", "text": "    ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#Rect"},
     {"title": "CastleControls.TCastleAbstractSlider.Update", "text": "    ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#Update"},
     {"title": "CastleControls.TCastleAbstractSlider.Width", "text": " ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#Width"},
     {"title": "CastleControls.TCastleAbstractSlider.Height", "text": " ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#Height"},
     {"title": "CastleControls.TCastleAbstractSlider.SmallFont", "text": " ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#SmallFont"},
     {"title": "CastleControls.TCastleAbstractSlider.DisplayValue", "text": "  <p>The exact method to display is defined by method <a class=\"normal\" href=\"CastleControls.TCastleFloatSlider.html#ValueToStr\">TCastleFloatSlider.ValueToStr</a> or <a class=\"normal\" href=\"CastleControls.TCastleIntegerSlider.html#ValueToStr\">TCastleIntegerSlider.ValueToStr</a> (depending on descendant), so you can further customize it. ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#DisplayValue"},
     {"title": "CastleControls.TCastleAbstractSlider.Caption", "text": " Right before value, if <a class=\"normal\" href=\"CastleControls.TCastleAbstractSlider.html#DisplayValue\">DisplayValue</a>. ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#Caption"},
     {"title": "CastleControls.TCastleAbstractSlider.OnChange", "text": " ", "tags": "", "loc": "CastleControls.TCastleAbstractSlider.html#OnChange"},
     {"title": "CastleControls.TCastleFloatSlider", "text": " ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html"},
     {"title": "CastleControls.TCastleFloatSlider.DefaultMin", "text": " ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#DefaultMin"},
     {"title": "CastleControls.TCastleFloatSlider.DefaultMax", "text": " ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#DefaultMax"},
     {"title": "CastleControls.TCastleFloatSlider.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#Create"},
     {"title": "CastleControls.TCastleFloatSlider.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#Create"},
     {"title": "CastleControls.TCastleFloatSlider.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#Render"},
     {"title": "CastleControls.TCastleFloatSlider.Press", "text": "    ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#Press"},
     {"title": "CastleControls.TCastleFloatSlider.Motion", "text": "    ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#Motion"},
     {"title": "CastleControls.TCastleFloatSlider.ValueToStr", "text": "    ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#ValueToStr"},
     {"title": "CastleControls.TCastleFloatSlider.RoundAndClamp", "text": "    ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#RoundAndClamp"},
     {"title": "CastleControls.TCastleFloatSlider.Min", "text": " ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#Min"},
     {"title": "CastleControls.TCastleFloatSlider.Max", "text": " ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#Max"},
     {"title": "CastleControls.TCastleFloatSlider.Value", "text": " Usually within <a class=\"normal\" href=\"CastleControls.TCastleFloatSlider.html#Min\">Min</a> and <a class=\"normal\" href=\"CastleControls.TCastleFloatSlider.html#Max\">Max</a> range, although the general code should be ready for handle any value here (to work even during changes to <a class=\"normal\" href=\"CastleControls.TCastleFloatSlider.html#Min\">Min</a> and <a class=\"normal\" href=\"CastleControls.TCastleFloatSlider.html#Max\">Max</a> properties). ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#Value"},
     {"title": "CastleControls.TCastleFloatSlider.MultipleOf", "text": " For example, if you set this to 0.25, and slider is between 0..1, then when user clicks around 0.3 &mdash; we will pick 0.25. It user clicks around 0.4 &mdash; we will pick 0.5.  <p>This only affects values selected by user interactions (clicking, dragging). This does not process the values you set by code to <a class=\"normal\" href=\"CastleControls.TCastleFloatSlider.html#Value\">Value</a> property, though you can use <a class=\"normal\" href=\"CastleControls.TCastleFloatSlider.html#RoundAndClamp\">RoundAndClamp</a> method on your values yourself. ", "tags": "", "loc": "CastleControls.TCastleFloatSlider.html#MultipleOf"},
     {"title": "CastleControls.TCastleIntegerSlider", "text": " ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html"},
     {"title": "CastleControls.TCastleIntegerSlider.DefaultMin", "text": " ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#DefaultMin"},
     {"title": "CastleControls.TCastleIntegerSlider.DefaultMax", "text": " ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#DefaultMax"},
     {"title": "CastleControls.TCastleIntegerSlider.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#Create"},
     {"title": "CastleControls.TCastleIntegerSlider.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#Create"},
     {"title": "CastleControls.TCastleIntegerSlider.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#Render"},
     {"title": "CastleControls.TCastleIntegerSlider.Press", "text": "    ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#Press"},
     {"title": "CastleControls.TCastleIntegerSlider.Motion", "text": "    ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#Motion"},
     {"title": "CastleControls.TCastleIntegerSlider.ValueToStr", "text": "    ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#ValueToStr"},
     {"title": "CastleControls.TCastleIntegerSlider.Min", "text": " ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#Min"},
     {"title": "CastleControls.TCastleIntegerSlider.Max", "text": " ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#Max"},
     {"title": "CastleControls.TCastleIntegerSlider.Value", "text": " Usually within <a class=\"normal\" href=\"CastleControls.TCastleIntegerSlider.html#Min\">Min</a> and <a class=\"normal\" href=\"CastleControls.TCastleIntegerSlider.html#Max\">Max</a> range, although the general code should be ready for handle any value here (to work even during changes to <a class=\"normal\" href=\"CastleControls.TCastleIntegerSlider.html#Min\">Min</a> and <a class=\"normal\" href=\"CastleControls.TCastleIntegerSlider.html#Max\">Max</a> properties). ", "tags": "", "loc": "CastleControls.TCastleIntegerSlider.html#Value"},
     {"title": "CastleControls.TCastleScrollView", "text": " We automatically show a scrollbar, and handle various scrolling inputs to be functional on both desktops and mobile (we handle scrolling by keys, mouse wheel, dragging by scrollbar, dragging the whole area - see <a class=\"normal\" href=\"CastleControls.TCastleScrollView.html#EnableDragging\">EnableDragging</a>). ", "tags": "", "loc": "CastleControls.TCastleScrollView.html"},
     {"title": "CastleControls.TCastleScrollView.DefaultKeyScrollSpeed", "text": " ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#DefaultKeyScrollSpeed"},
     {"title": "CastleControls.TCastleScrollView.DefaultWheelScrollSpeed", "text": " ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#DefaultWheelScrollSpeed"},
     {"title": "CastleControls.TCastleScrollView.DefaultScrollBarWidth", "text": " ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#DefaultScrollBarWidth"},
     {"title": "CastleControls.TCastleScrollView.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#Create"},
     {"title": "CastleControls.TCastleScrollView.Destroy", "text": "    ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#Destroy"},
     {"title": "CastleControls.TCastleScrollView.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#Render"},
     {"title": "CastleControls.TCastleScrollView.RenderOverChildren", "text": "    ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#RenderOverChildren"},
     {"title": "CastleControls.TCastleScrollView.Press", "text": "    ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#Press"},
     {"title": "CastleControls.TCastleScrollView.Release", "text": "    ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#Release"},
     {"title": "CastleControls.TCastleScrollView.Motion", "text": "    ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#Motion"},
     {"title": "CastleControls.TCastleScrollView.Update", "text": "    ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#Update"},
     {"title": "CastleControls.TCastleScrollView.TintScrollBarInactive", "text": " May have some alpha, which makes scrollbar &quot;make itself more opaque&quot;, and thus noticeable, when you start dragging. By default it's opaque <a class=\"normal\" href=\"CastleColors.html#White\">white</a>, which means that no tint is shown. ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#TintScrollBarInactive"},
     {"title": "CastleControls.TCastleScrollView.ScrollArea", "text": " Make sure to add some children here, and set proper size of this control, to have a useful scrolling area. ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#ScrollArea"},
     {"title": "CastleControls.TCastleScrollView.KeyScrollSpeed", "text": " ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#KeyScrollSpeed"},
     {"title": "CastleControls.TCastleScrollView.WheelScrollSpeed", "text": " ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#WheelScrollSpeed"},
     {"title": "CastleControls.TCastleScrollView.ScrollBarWidth", "text": " ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#ScrollBarWidth"},
     {"title": "CastleControls.TCastleScrollView.EnableDragging", "text": " This is usually suitable for mobile devices. Note that this doesn't affect the dragging directly by the scrollbar, which is always enabled. ", "tags": "", "loc": "CastleControls.TCastleScrollView.html#EnableDragging"},
     {"title": "CastleControls.TCastleTimer", "text": " ", "tags": "", "loc": "CastleControls.TCastleTimer.html"},
     {"title": "CastleControls.TCastleTimer.Update", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTimer.html#Update"},
     {"title": "CastleControls.TCastleTimer.IntervalSeconds", "text": " Value of 0 means to call <a class=\"normal\" href=\"CastleControls.TCastleTimer.html#OnTimer\">OnTimer</a> in every Update event. ", "tags": "", "loc": "CastleControls.TCastleTimer.html#IntervalSeconds"},
     {"title": "CastleControls.TCastleTimer.OnTimer", "text": " ", "tags": "", "loc": "CastleControls.TCastleTimer.html#OnTimer"},
     {"title": "CastleControls.TCastleTimer.CounteractDelays", "text": " This helps to keep a constant frequency of timer events over a long time, and to keep multiple things (like multiple timer instances) perfectly synchronized with each other. But it may cause to execute a <i>lot</i> of timer events at once, in case the application hung for some time. ", "tags": "", "loc": "CastleControls.TCastleTimer.html#CounteractDelays"},
     {"title": "CastleControls.TCastleEdit", "text": " ", "tags": "", "loc": "CastleControls.TCastleEdit.html"},
     {"title": "CastleControls.TCastleEdit.DefaultWidth", "text": " ", "tags": "", "loc": "CastleControls.TCastleEdit.html#DefaultWidth"},
     {"title": "CastleControls.TCastleEdit.DefaultPadding", "text": " ", "tags": "", "loc": "CastleControls.TCastleEdit.html#DefaultPadding"},
     {"title": "CastleControls.TCastleEdit.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Create"},
     {"title": "CastleControls.TCastleEdit.Destroy", "text": "    ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Destroy"},
     {"title": "CastleControls.TCastleEdit.Render", "text": "    ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Render"},
     {"title": "CastleControls.TCastleEdit.Rect", "text": "    ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Rect"},
     {"title": "CastleControls.TCastleEdit.Press", "text": "    ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Press"},
     {"title": "CastleControls.TCastleEdit.Update", "text": "    ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Update"},
     {"title": "CastleControls.TCastleEdit.CapturesEventsAtPosition", "text": "    ", "tags": "", "loc": "CastleControls.TCastleEdit.html#CapturesEventsAtPosition"},
     {"title": "CastleControls.TCastleEdit.FocusedColor", "text": " By default it's <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>. ", "tags": "", "loc": "CastleControls.TCastleEdit.html#FocusedColor"},
     {"title": "CastleControls.TCastleEdit.UnfocusedColor", "text": " By default it's dark <a class=\"normal\" href=\"CastleColors.html#Gray\">gray</a>. ", "tags": "", "loc": "CastleControls.TCastleEdit.html#UnfocusedColor"},
     {"title": "CastleControls.TCastleEdit.BackgroundColor", "text": " Fills the area under <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Text\">Text</a> and the <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Padding\">padding</a>. By default it's <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. Note that it can be transparent, in which case it will show the <a class=\"normal\" href=\"CastleControls.html#tiEdit\">tiEdit</a> image underneath (if <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Frame\">Frame</a> is <code>True</code>), or UI control underneath (if <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Frame\">Frame</a> is <code>False</code>). ", "tags": "", "loc": "CastleControls.TCastleEdit.html#BackgroundColor"},
     {"title": "CastleControls.TCastleEdit.AllowedChars", "text": " Note that this <i>only restricts the user input</i>, it does not prevent from programmatically setting <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Text\">Text</a> to include disallowed characters. ", "tags": "", "loc": "CastleControls.TCastleEdit.html#AllowedChars"},
     {"title": "CastleControls.TCastleEdit.MaxLength", "text": " Value of 0 (default) means &quot;no limit&quot;. Note that this <i>only restricts the user input</i>, it does not prevent from programmatically setting <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Text\">Text</a> to be longer. ", "tags": "", "loc": "CastleControls.TCastleEdit.html#MaxLength"},
     {"title": "CastleControls.TCastleEdit.Width", "text": "  <p>Inside it, we will put the border frame (if <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Frame\">Frame</a> is <code>True</code>), and <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Padding\">padding</a> (see <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Padding\">Padding</a> + <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#PaddingHorizontal\">PaddingHorizontal</a>). So, similar to CSS box model called box-sizing, width includes also <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Padding\">padding</a> and border.  <p>Note that the edit control width is never auto-calculated, since there's no &quot;natural width&quot; for the edit box. In contrast, our height is always (for now) auto-calculated. ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Width"},
     {"title": "CastleControls.TCastleEdit.Text", "text": " ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Text"},
     {"title": "CastleControls.TCastleEdit.PaddingHorizontal", "text": " Total horizontal <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Padding\">padding</a> is the sum <code><code>PaddingHorizontal</code> + <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Padding\">Padding</a></code>, total vertical <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Padding\">padding</a> is the sum <code><a class=\"normal\" href=\"CastleControls.TCastleEdit.html#PaddingVertical\">PaddingVertical</a> + <a class=\"normal\" href=\"CastleControls.TCastleEdit.html#Padding\">Padding</a></code>.  ", "tags": "", "loc": "CastleControls.TCastleEdit.html#PaddingHorizontal"},
     {"title": "CastleControls.TCastleEdit.PaddingVertical", "text": " ", "tags": "", "loc": "CastleControls.TCastleEdit.html#PaddingVertical"},
     {"title": "CastleControls.TCastleEdit.Padding", "text": " ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Padding"},
     {"title": "CastleControls.TCastleEdit.Frame", "text": " Frame uses theme image <a class=\"normal\" href=\"CastleControls.html#tiEdit\">tiEdit</a>, see <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#Images\">TCastleTheme.Images</a> if you want to customize it. ", "tags": "", "loc": "CastleControls.TCastleEdit.html#Frame"},
     {"title": "CastleControls.TCastleEdit.CaptureAllInput", "text": " This is in practice only sensible if this is the only edit box currently visible on the screen. ", "tags": "", "loc": "CastleControls.TCastleEdit.html#CaptureAllInput"},
     {"title": "CastleControls.TCastleTheme", "text": " Should only be used through the single global instance <a class=\"normal\" href=\"CastleControls.html#Theme\">Theme</a>. ", "tags": "", "loc": "CastleControls.TCastleTheme.html"},
     {"title": "CastleControls.TCastleTheme.TooltipTextColor", "text": " ", "tags": "", "loc": "CastleControls.TCastleTheme.html#TooltipTextColor"},
     {"title": "CastleControls.TCastleTheme.TextColor", "text": " ", "tags": "", "loc": "CastleControls.TCastleTheme.html#TextColor"},
     {"title": "CastleControls.TCastleTheme.DisabledTextColor", "text": " ", "tags": "", "loc": "CastleControls.TCastleTheme.html#DisabledTextColor"},
     {"title": "CastleControls.TCastleTheme.MessageTextColor", "text": " ", "tags": "", "loc": "CastleControls.TCastleTheme.html#MessageTextColor"},
     {"title": "CastleControls.TCastleTheme.MessageInputTextColor", "text": " ", "tags": "", "loc": "CastleControls.TCastleTheme.html#MessageInputTextColor"},
     {"title": "CastleControls.TCastleTheme.BarEmptyColor", "text": " ", "tags": "", "loc": "CastleControls.TCastleTheme.html#BarEmptyColor"},
     {"title": "CastleControls.TCastleTheme.BarFilledColor", "text": " ", "tags": "", "loc": "CastleControls.TCastleTheme.html#BarFilledColor"},
     {"title": "CastleControls.TCastleTheme.BackgroundColor", "text": " Default is (0, 0, 0, 0.25), making things underneath darker, which helps dialog to stand out. ", "tags": "", "loc": "CastleControls.TCastleTheme.html#BackgroundColor"},
     {"title": "CastleControls.TCastleTheme.BackgroundOpaqueColor", "text": " You can only customize the RGB values, alpha is always 1, so the resulting color is always opaque. It's a dark <a class=\"normal\" href=\"CastleColors.html#Gray\">gray</a> color (0.33, 0.33, 0.33) by default. ", "tags": "", "loc": "CastleControls.TCastleTheme.html#BackgroundOpaqueColor"},
     {"title": "CastleControls.TCastleTheme.LoadingBackgroundColor", "text": " Note that you can also customize the <a class=\"normal\" href=\"CastleControls.html#tiLoading\">tiLoading</a> image. By default, <code>LoadingBackgroundColor</code> is <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>, and <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#LoadingTextColor\">LoadingTextColor</a> is <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. ", "tags": "", "loc": "CastleControls.TCastleTheme.html#LoadingBackgroundColor"},
     {"title": "CastleControls.TCastleTheme.LoadingTextColor", "text": " Note that you can also customize the <a class=\"normal\" href=\"CastleControls.html#tiLoading\">tiLoading</a> image. By default, <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#LoadingBackgroundColor\">LoadingBackgroundColor</a> is <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>, and <code>LoadingTextColor</code> is <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. ", "tags": "", "loc": "CastleControls.TCastleTheme.html#LoadingTextColor"},
     {"title": "CastleControls.TCastleTheme.InternalForceOpaqueBackground", "text": "  <p>This is internally set and unset by the <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> exception handler (you should not modify this yourself). It allows to request showing opaque color under <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MessageOK\">TCastleWindowCustom.MessageOK</a> and friends, or modal states by <a class=\"normal\" href=\"CastleWindowModes.TGLModeFrozenScreen.html\">TGLModeFrozenScreen</a>.  <p>This allows to avoid making a screenshot (<a class=\"normal\" href=\"CastleDialogStates.TStateDialog.html#BackgroundScreenshot\">TStateDialog.BackgroundScreenshot</a> may be false), which is safer when we want to show an exception (since the application may be in some dirty state, so it's better to avoid rendering user stuff). ", "tags": "", "loc": "CastleControls.TCastleTheme.html#InternalForceOpaqueBackground"},
     {"title": "CastleControls.TCastleTheme.Create", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTheme.html#Create"},
     {"title": "CastleControls.TCastleTheme.Destroy", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTheme.html#Destroy"},
     {"title": "CastleControls.TCastleTheme.Draw", "text": "  <p>  <p>  Color Color tint of the image. If you do not specify a color, <a class=\"normal\" href=\"CastleColors.html#White\">white</a> will be used, so image will be displayed as-is. Specifying a color means that image will be multiplied by it, just like for <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Color\">TGLImageCore.Color</a>. UIScale Used to properly scale <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#Corners\">corners</a>, passed to <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#ScaleCorners\">TGLImageCore.ScaleCorners</a>. This parameter does <i>not</i> scale the place where image is displayed, to do this just scale the given Rect parameter yourself.  Color Color tint of the image. If you do not specify a color, <a class=\"normal\" href=\"CastleColors.html#White\">white</a> will be used, so image will be displayed as-is. Specifying a color means that image will be multiplied by it, just like for <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Color\">TGLImageCore.Color</a>. UIScale Used to properly scale <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#Corners\">corners</a>, passed to <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#ScaleCorners\">TGLImageCore.ScaleCorners</a>. This parameter does <i>not</i> scale the place where image is displayed, to do this just scale the given Rect parameter yourself.", "tags": "", "loc": "CastleControls.TCastleTheme.html#Draw"},
     {"title": "CastleControls.TCastleTheme.Draw", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTheme.html#Draw"},
     {"title": "CastleControls.TCastleTheme.DialogsLight", "text": "    ", "tags": "", "loc": "CastleControls.TCastleTheme.html#DialogsLight"},
     {"title": "CastleControls.TCastleTheme.Images", "text": " Although they all have sensible defaults, you can also change them at any time. Simply create <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instance (e.g. by <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> function) and assign it here. Be sure to adjust also <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#OwnsImages\">OwnsImages</a> if you want the theme to automatically free the image when it's no longer used.  <p>The alpha channel of the image, if any, is automatically correctly used (for alpha test or alpha blending, see <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a>). ", "tags": "", "loc": "CastleControls.TCastleTheme.html#Images"},
     {"title": "CastleControls.TCastleTheme.OwnsImages", "text": " ", "tags": "", "loc": "CastleControls.TCastleTheme.html#OwnsImages"},
     {"title": "CastleControls.TCastleTheme.Corners", "text": " Together with assigning <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#Images\">Images</a>, adjust also this property. It is used for images rendered using <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw3x3\">TGLImageCore.Draw3x3</a>, it determines how the image is stretched. The <code>corners</code> are specified as 4D vector, order like in CSS: top, right, down, left. ", "tags": "", "loc": "CastleControls.TCastleTheme.html#Corners"},
     {"title": "CastleControls.TCastleTheme.MessageFont", "text": " Leave <code>Nil</code> to use <a class=\"normal\" href=\"CastleControls.html#UIFont\">UIFont</a>. ", "tags": "", "loc": "CastleControls.TCastleTheme.html#MessageFont"},
     {"title": "CastleControls.TCastleTheme.OwnsMessageFont", "text": " ", "tags": "", "loc": "CastleControls.TCastleTheme.html#OwnsMessageFont"},
     {"title": "CastleControls.TCastleClipboard", "text": " You usually use this through the single global instance <a class=\"normal\" href=\"CastleControls.html#Clipboard\">Clipboard</a>. The trivial interface is mostly compatible with LCL <a class=\"normal\" href=\"CastleControls.html#Clipboard\">clipboard</a>. ", "tags": "", "loc": "CastleControls.TCastleClipboard.html"},
     {"title": "CastleControls.TCastleClipboard.GetAsText", "text": "    ", "tags": "", "loc": "CastleControls.TCastleClipboard.html#GetAsText"},
     {"title": "CastleControls.TCastleClipboard.SetAsText", "text": "    ", "tags": "", "loc": "CastleControls.TCastleClipboard.html#SetAsText"},
     {"title": "CastleControls.TCastleClipboard.AsText", "text": " ", "tags": "", "loc": "CastleControls.TCastleClipboard.html#AsText"},
     {"title": "CastleControls.Theme", "text": "    ", "tags": "", "loc": "CastleControls.html#Theme"},
     {"title": "CastleControls.GetUIFont", "text": "  <p>By default, this is a modern sans-serif font hardcoded into the engine. It will be automatically created and freed if needed. This is comfortable for simple applications, you can just start &quot;drawing text&quot; without initializing anything.  <p>You can assign your own font here, to make this the default font used by all 2D controls.  <p>Note that assigning font here <i>does not</i> make it automatically freed (this would cause more trouble than comfort). To make sure your own fonts are always freed, set the font &quot;owner&quot; at creation, e.g. the example below sets the <code>Application</code> as owner:  <p></p>  <pre class=\"longcode\"> MyFont := TTextureFont.Create(Application); MyFont.Load(TextureFont_Xxxx); UIFont := MyFont;</pre>  <p>  <p>    ", "tags": "", "loc": "CastleControls.html#GetUIFont"},
     {"title": "CastleControls.SetUIFont", "text": "    ", "tags": "", "loc": "CastleControls.html#SetUIFont"},
     {"title": "CastleControls.GetUIFontSmall", "text": "    ", "tags": "", "loc": "CastleControls.html#GetUIFontSmall"},
     {"title": "CastleControls.SetUIFontSmall", "text": "    ", "tags": "", "loc": "CastleControls.html#SetUIFontSmall"},
     {"title": "CastleControls.Clipboard", "text": " Automatically created / destroyed by this unit.    ", "tags": "", "loc": "CastleControls.html#Clipboard"},
     {"title": "CastleControls.RegisterClipboard", "text": " The instance given here becomes owned by this unit (we will free it automatically).    ", "tags": "", "loc": "CastleControls.html#RegisterClipboard"},
     {"title": "CastleControls.Register", "text": "    ", "tags": "", "loc": "CastleControls.html#Register"},
     {"title": "CastleControls.TThemeImage", "text": "  tiPanel    tiPanelSeparator    tiProgressBar    tiProgressFill    tiButtonPressed    tiButtonDisabled    tiButtonFocused    tiButtonNormal    tiWindow    tiScrollbarFrame    tiScrollbarSlider    tiSlider    tiSliderPosition    tiLabel    tiActiveFrame    tiTooltip    tiTouchCtlInner    tiTouchCtlOuter    tiTouchCtlFlyInner    tiTouchCtlFlyOuter    tiCrosshair1    tiCrosshair2    tiLoading Image displayed when the application is initializing, during <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">Application.OnInitialize</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">Window.OnOpen</a>.  And <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextOpen\">TUIControl.GLContextOpen</a> for all initially present UI controls. This &quot;loading image&quot; is loaded and displayed first, so that user does not see a <a class=\"normal\" href=\"CastleColors.html#Black\">black</a> screen while the resources are prepared.  <p>It is especially useful on Android, where we can lose the OpenGL context at any moment, as user may switch applications in the middle of the game. When getting back to the application, we need to initiailize some resources, and during this process we also show this image. So this serves as a universal &quot;please wait, we're loading&quot; screen.  <p>You can customize this image, by setting <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#Images\">Theme.Images[tiLoading]</a>, <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#LoadingBackgroundColor\">LoadingBackgroundColor</a>, <a class=\"normal\" href=\"CastleControls.TCastleTheme.html#LoadingTextColor\">LoadingTextColor</a>. See <a  href=\"http://castle-engine.sourceforge.net/tutorial_player_2d_controls.php\">http://castle-engine.sourceforge.net/tutorial_player_2d_controls.php</a> for a sample code that sets a theme image.  <p>Note that the customization of this image should be done before <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">Application.OnInitialize</a> has started, so it has to be usually done from the &quot;initialization&quot; section of some unit. And in the &quot;initialization&quot; section of a unit, you cannot load files (doing <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> at this point may fail on some Android devices, as we cannot load assets before activity is started). So you can only assign images already available in code &mdash; use image-to-pascal tool to convert any image to a Pascal code for this purpose.  tiEdit <a class=\"normal\" href=\"CastleControls.TCastleEdit.html\">TCastleEdit</a> frame.  ", "tags": "", "loc": "CastleControls.html#TThemeImage"},
     {"title": "CastleControls.TCastleButtonImageLayout", "text": "  ilTop    ilBottom    ilLeft    ilRight   ", "tags": "", "loc": "CastleControls.html#TCastleButtonImageLayout"},
     {"title": "CastleControls.TProportionalScaling", "text": "  psNone Adjust to the requested area, ignoring proportions.   psEnclose Adjust to the requested area, honoring proportions, such that the image may be larger than the requested area.   psFit Adjust to the requested area, honoring proportions, such that the image may be smaller than the requested area.  ", "tags": "", "loc": "CastleControls.html#TProportionalScaling"},
     {"title": "CastleControls.TCastleTouchCtlMode", "text": "  ctcmWalking    ctcmWalkWithSideRot    ctcmHeadRotation    ctcmFlyUpdown    ctcmPanXY   ", "tags": "", "loc": "CastleControls.html#TCastleTouchCtlMode"},
     {"title": "CastleControls.TCastleTouchPosition", "text": "  tpManual    tpLeft    tpRight   ", "tags": "", "loc": "CastleControls.html#TCastleTouchPosition"},
     {"title": "CastleControls.TShapeType", "text": "  stRectangle    stCircle   ", "tags": "", "loc": "CastleControls.html#TShapeType"},
     {"title": "CastleControls.TCastleCrosshairShape", "text": "  csCross    csCrossRect   ", "tags": "", "loc": "CastleControls.html#TCastleCrosshairShape"},
     {"title": "CastleControls.UIFont", "text": " ", "tags": "", "loc": "CastleControls.html#UIFont"},
     {"title": "CastleControls.UIFontSmall", "text": " ", "tags": "", "loc": "CastleControls.html#UIFontSmall"},
     {"title": "CastleCreatures", "text": " ", "tags": "", "loc": "CastleCreatures.html"},
     {"title": "CastleCreatures.TCreatureResource", "text": " Basic creature can walk or fly, has life and can be hurt, can fall down because of gravity and such.  <p>A &quot;resource&quot; is an information shared by all creatures of given type, for example you can have two instances of <code>TCreatureResource</code>: Werewolf and Knight. Actually, they would have to be instances of one of the <code>TCreatureResource</code> descendants, like <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html\">TWalkAttackCreatureResource</a>, as <code>TCreatureResource</code> is abstract. Using them you can create and place on your your level milions of actual werewolves and knights (for example instances of <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreature.html\">TWalkAttackCreature</a>). Every werewolf on the level will have potentially different life and state (attacking, walking), but all werewolves will share the same resource, so e.g. all werewolves will use the same dying animation (<a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#DieAnimation\">TWalkAttackCreatureResource.DieAnimation</a>) and dying sound (<a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#SoundDie\">TCreatureResource.SoundDie</a>).  <p>Note that some of the information stored in resource is only used to initialize new creatures and can be changed later during creature life, for example <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#DefaultMaxLife\">TCreatureResource.DefaultMaxLife</a> and <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#Flying\">TCreatureResource.Flying</a>. ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html"},
     {"title": "CastleCreatures.TCreatureResource.DefaultDefaultMaxLife", "text": " Yes, it's not a typo, this identifier starts with &quot;DefaultDefault&quot;. ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#DefaultDefaultMaxLife"},
     {"title": "CastleCreatures.TCreatureResource.DefaultFlying", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#DefaultFlying"},
     {"title": "CastleCreatures.TCreatureResource.DefaultKnockBackDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#DefaultKnockBackDistance"},
     {"title": "CastleCreatures.TCreatureResource.DefaultSoundDieTiedToCreature", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#DefaultSoundDieTiedToCreature"},
     {"title": "CastleCreatures.TCreatureResource.DefaultAttackDamageConst", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#DefaultAttackDamageConst"},
     {"title": "CastleCreatures.TCreatureResource.DefaultAttackDamageRandom", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#DefaultAttackDamageRandom"},
     {"title": "CastleCreatures.TCreatureResource.DefaultAttackKnockbackDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#DefaultAttackKnockbackDistance"},
     {"title": "CastleCreatures.TCreatureResource.RadiusCalculate", "text": " Must be something &lt;&gt; 0 for collision detection to work. Defining it in the creature resource.xml file (as radius=&quot;xxx&quot; attribute on the root &lt;resource&gt; element) overrides the results of this function.    ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#RadiusCalculate"},
     {"title": "CastleCreatures.TCreatureResource.FlexibleUp", "text": " This is used when creating creature in <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#CreateCreature\">CreateCreature</a>. The default implementation here returns <code>True</code>, which allows creature model to point slightly upward/downward.  <p>Override this to return <code>False</code> if given creature kind for some reason cannot have up vector different. For example, <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreature.html\">TWalkAttackCreature</a> AI assumes that the non-flying creature is always standing up. For now, non-flying <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreature.html\">TWalkAttackCreature</a> cannot &quot;stand up&quot; before walking, in case it's up vector gets skewed.    ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#FlexibleUp"},
     {"title": "CastleCreatures.TCreatureResource.Create", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#Create"},
     {"title": "CastleCreatures.TCreatureResource.CreateCreature", "text": " Uses <a class=\"normal\" href=\"CastleCreatures.TCreature.html\">TCreature</a> descendant that can best cooperate with this resource, e.g. if this resource has settings for short-range fight, then the <a class=\"normal\" href=\"CastleCreatures.TCreature.html\">TCreature</a> instance will be able to short-range fight.  <p>The creature is added to the World, and it's owned by World.  <p>This is the only way to create <a class=\"normal\" href=\"CastleCreatures.TCreature.html\">TCreature</a> instances.  <p>ADirection passed here is normalized, and then used as initial TCreature.Direction value.  <p>    ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#CreateCreature"},
     {"title": "CastleCreatures.TCreatureResource.CreateCreature", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#CreateCreature"},
     {"title": "CastleCreatures.TCreatureResource.InstantiatePlaceholder", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#InstantiatePlaceholder"},
     {"title": "CastleCreatures.TCreatureResource.CreatureClass", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#CreatureClass"},
     {"title": "CastleCreatures.TCreatureResource.LoadFromFile", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#LoadFromFile"},
     {"title": "CastleCreatures.TCreatureResource.Radius", "text": " Must be something &lt;&gt; 0 for collision detection to work.  <p>You can define it in the creature resource.xml file, by setting radius=&quot;xxx&quot; attribute on the root &lt;resource&gt; element.  <p>If it's not defined (or zero) in resource.xml file, then we use automatically calculated radius using <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#RadiusCalculate\">RadiusCalculate</a>, that is adjusted to the bounding box of the animation.  <p>This radius is used only for alive creatures, because:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>It would cause incorrect results on many dead creatures. Dead creatures usually have very different boxes than alive (tall alive humanoid creature probably has a small flat bounding box when it's lying dead on the ground). So the same radius would not work nicely.</p></li>   <li><p>It is not necessary to use sphere bounding volumes for dead creatures. The main advantage of sphere bounding volumes (over box bounding volumes) is for moving (alive) creatures: sphere better avoids getting stuck into obstacles (because an animation can change the bounding box at any moment).</p></li>   <li><p>Actually, the results look best when dead creatures don't collide at all.</p></li> </ul>  <p>  <p>The sphere center is the Middle point (&quot;eye position&quot;) of the given creature. If the creature may be affected by gravity then make sure radius is &lt; than PreferredHeight of the creature, see T3D.PreferredHeight, otherwise creature may get stuck into ground. In short, if you use the default implementations, PreferredHeight is by default <i><a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#MiddleHeight\">MiddleHeight</a> (default 0.5) * bounding box height</i>. Your radius must be smaller for all possible bounding box heights when the creature is not dead.    ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#Radius"},
     {"title": "CastleCreatures.TCreatureResource.Flying", "text": "  <p>For all creatures, TCreature.Gravity (inherited from T3D.Gravity) is set to <code>&quot;not Flying&quot;</code> at creation. (Except <a class=\"normal\" href=\"CastleCreatures.TMissileCreatureResource.html\">TMissileCreatureResource</a>, that has special approach to gravity, see <a class=\"normal\" href=\"CastleCreatures.TMissileCreatureResource.html#DirectionFallSpeed\">TMissileCreatureResource.DirectionFallSpeed</a>.)  <p>For <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html\">TWalkAttackCreatureResource</a>, additionally Flying allows to move freely, while non-flying creatures are constrained to move (and think about moving) only horizontally.  <p>You can always change the Gravity property of a particular creature during it's lifetime, so a creature may start/stop flying during game. For example, this is how you can let your creatures to use jetpack and such. Be careful about creature <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#Radius\">Radius</a> and <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#MiddleHeight\">MiddleHeight</a> properties in this case, make sure that the values (explicitly set or automatically calculated) are suitable for both flying and non-flying states. ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#Flying"},
     {"title": "CastleCreatures.TCreatureResource.SoundSuddenPain", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#SoundSuddenPain"},
     {"title": "CastleCreatures.TCreatureResource.SoundDie", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#SoundDie"},
     {"title": "CastleCreatures.TCreatureResource.SoundDieTiedToCreature", "text": " You can set this to false if you want <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#SoundDie\">SoundDie</a> to last even after the creature object was destroyed. ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#SoundDieTiedToCreature"},
     {"title": "CastleCreatures.TCreatureResource.DefaultMaxLife", "text": "  <p>Note that you can always override it for a particular creature instance. You can use a special creature placeholder with a specific starting life value (see <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a> for placeholders docs, and see <a  href=\"http://castle-engine.sourceforge.net/castle-development.php\">http://castle-engine.sourceforge.net/castle-development.php</a> about the creature placeholders). Or you can use <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#CreateCreature\">CreateCreature</a> overloaded version that takes extra MaxLife parameter.  <p>So this is only a &quot;suggested&quot; default for MaxLife of this creature. ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#DefaultMaxLife"},
     {"title": "CastleCreatures.TCreatureResource.KnockBackDistance", "text": "  <p>Will always be multiplied by the knocking distance of the weapon that caused the push (which should reflect the force of the weapon blow), see <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html#AttackKnockbackDistance\">TItemWeaponResource.AttackKnockbackDistance</a>.  <p>Only for <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreature.html\">TWalkAttackCreature</a>, the final distance the creature is knocked back is capped by the time of the HurtAnimation (HurtAnimation.Duration). When the hurt animation ends, the knockback effect always ends, even if the distance (creature * weapon) indicates it should be knocked further. Otherwise knockback would work on standing creature, which could look bad. This may be changed some day. ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#KnockBackDistance"},
     {"title": "CastleCreatures.TCreatureResource.KnockBackSpeed", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#KnockBackSpeed"},
     {"title": "CastleCreatures.TCreatureResource.CollidesWhenDead", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#CollidesWhenDead"},
     {"title": "CastleCreatures.TCreatureResource.AttackDamageConst", "text": " Used only by the creatures that actually do some kind of direct attack. For example it is used for short-range attack by <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html\">TWalkAttackCreatureResource</a> (if <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#AttackAnimation\">TWalkAttackCreatureResource.AttackAnimation</a> defined) and for hit of <a class=\"normal\" href=\"CastleCreatures.TMissileCreatureResource.html\">TMissileCreatureResource</a>.  <p>All these values must be &gt;= 0.  <p><a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#AttackKnockbackDistance\">AttackKnockbackDistance</a> = 0 means no knockback.  <p> ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#AttackDamageConst"},
     {"title": "CastleCreatures.TCreatureResource.AttackDamageRandom", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#AttackDamageRandom"},
     {"title": "CastleCreatures.TCreatureResource.AttackKnockbackDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#AttackKnockbackDistance"},
     {"title": "CastleCreatures.TCreatureResource.MiddleHeight", "text": " See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MiddleHeight\">TCastleTransform.MiddleHeight</a> for a precise documentation.  <p>Game developers can use the RenderDebug variable to easily visualize the bounding sphere (and other things) around resources. The bounding sphere is centered around the point derived from <code>MiddleHeight</code> setting and with given creature radius (given in resource.xml, or automatically calculated by <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#RadiusCalculate\">TCreatureResource.RadiusCalculate</a>). ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#MiddleHeight"},
     {"title": "CastleCreatures.TCreatureResource.FallMinHeightToSound", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#FallMinHeightToSound"},
     {"title": "CastleCreatures.TCreatureResource.FallMinHeightToDamage", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#FallMinHeightToDamage"},
     {"title": "CastleCreatures.TCreatureResource.FallDamageScaleMin", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#FallDamageScaleMin"},
     {"title": "CastleCreatures.TCreatureResource.FallDamageScaleMax", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#FallDamageScaleMax"},
     {"title": "CastleCreatures.TCreatureResource.FallSound", "text": " The default is the sound named 'creature_fall'. ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#FallSound"},
     {"title": "CastleCreatures.TCreatureResource.RadiusOverride", "text": " This can be read from the <code>resource.xml</code> file. When zero, the radius is automatically calculated looking at the 3D model bounding box, and taking into account gravity direction, see <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#RadiusCalculate\">TCreatureResource.RadiusCalculate</a>. ", "tags": "", "loc": "CastleCreatures.TCreatureResource.html#RadiusOverride"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource", "text": " May stand still (idle), walk, attack, fire missiles, and die.  <p>Tracks the enemy (remembers last seen enemy 3D position, walks/flies to it, possibly through sectors/waypoints &mdash; so it can pass through narrow doors in a labyrinth or walk over a narrow bridge). Attacks the enemy from the right distance (a short-range attack) and/or shoots a missile (adds a missile to the 3D world). Runs away from the enemy (when he's too close and/or our health is low).  <p>There are a lot of settings to achieve particular behavior, e.g. cowardly/brave, offensive/defensive, melee/ranged, etc. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultMoveSpeed", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultMoveSpeed"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultMinLifeLossToHurt", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultMinLifeLossToHurt"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultChanceToHurt", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultChanceToHurt"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultMaxHeightAcceptableToFall", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultMaxHeightAcceptableToFall"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultRandomWalkDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultRandomWalkDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultRemoveDead", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultRemoveDead"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultPreferredDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultPreferredDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultRunAwayLife", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultRunAwayLife"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultRunAwayDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultRunAwayDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultVisibilityAngle", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultVisibilityAngle"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultSmellDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultSmellDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultAttackTime", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultAttackTime"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultAttackMinDelay", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultAttackMinDelay"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultAttackMaxDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultAttackMaxDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultAttackMaxAngle", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultAttackMaxAngle"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultFireMissileTime", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultFireMissileTime"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultFireMissileMinDelay", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultFireMissileMinDelay"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultFireMissileMaxDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultFireMissileMaxDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultFireMissileMaxAngle", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultFireMissileMaxAngle"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DefaultFireMissileHeight", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DefaultFireMissileHeight"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.FlexibleUp", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#FlexibleUp"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.Create", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#Create"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.LoadFromFile", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#LoadFromFile"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.CreatureClass", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#CreatureClass"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.IdleAnimation", "text": " Will be played in a loop, so for best look make sure that the beginning and end match. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#IdleAnimation"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.IdleToWalkAnimation", "text": " Optional.  <p>For best look: It's beginnig should glue with the end of <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#IdleAnimation\">IdleAnimation</a>, it's ending should glue with beginning of <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#WalkAnimation\">WalkAnimation</a>. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#IdleToWalkAnimation"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.WalkAnimation", "text": " Will be played in a loop, so for best look make sure that the beginning and end match. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#WalkAnimation"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.AttackAnimation", "text": " Optional.  <p>For best look: Beginning and end of it should roughly glue with (any) frame of <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#WalkAnimation\">WalkAnimation</a> and <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#IdleAnimation\">IdleAnimation</a>.  <p><i>Design notes:</i> I used to have here property like AttacksWhenWalking for the creature, to indicate whether creature changes state like &quot;<a class=\"normal\" href=\"CastleCreatures.html#csWalk\">csWalk</a> -&gt; <a class=\"normal\" href=\"CastleCreatures.html#csAttack\">csAttack</a> -&gt; <a class=\"normal\" href=\"CastleCreatures.html#csWalk\">csWalk</a>&quot; or &quot;<a class=\"normal\" href=\"CastleCreatures.html#csIdle\">csIdle</a> -&gt; <a class=\"normal\" href=\"CastleCreatures.html#csAttack\">csAttack</a> -&gt; <a class=\"normal\" href=\"CastleCreatures.html#csIdle\">csIdle</a>&quot;. But this wasn't good. Intelligent creature sometimes attacks when walking (e.g. if it just made the distance to the enemy closer) or when standing (when the distance was already close enough). And after performing the attack, the creature doesn't need to go back to the original state before the attack. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#AttackAnimation"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.FireMissileAnimation", "text": " Optional. Similar rules like <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#AttackAnimation\">AttackAnimation</a>, but here the &quot;highlight&quot; is not directly hurting enemy, but firing a new creature (missile).  <p>You can always override <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreature.html#FireMissile\">TWalkAttackCreature.FireMissile</a> to do pretty much anything you want, and this way treat this as an &quot;alternate attack&quot;, not necessarily firing a missile. It's not really required to actually fire a missile &mdash; it's only what happens at the default <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreature.html#FireMissile\">TWalkAttackCreature.FireMissile</a> implementation, and it happens only if <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#FireMissileName\">FireMissileName</a> is not empty. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#FireMissileAnimation"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DieAnimation", "text": "  <p>Dying animation is not displayed in a loop, after it runs it's duration we constantly show the final frame, at the <a class=\"normal\" href=\"CastleCreatures.TCreature.html\">TCreature</a> instance will keep existing on the level. Unless you set <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#RemoveDead\">RemoveDead</a> to <code>True</code>, then the dead creature will be completely removed from the level.  <p>For best look: Beginning should roughly glue with any point of the idle/attack/walk animations. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DieAnimation"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.DieBackAnimation", "text": " This may be useful if you want your creature to fall face-down when killed from the back or face-up when killed from the front. If this is defined, then <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#DieAnimation\">DieAnimation</a> is only used when creature is killed by hitting it from the front. The direction of last hit is taken from LastHurtDirection.  <p>For best look: Just like <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#DieAnimation\">DieAnimation</a>, beginning should roughly glue with any point of the idle/attack/walk animations. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#DieBackAnimation"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.HurtAnimation", "text": " Beginning and end should *more-or-less* look like any point of the idle/attack/walk animations. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#HurtAnimation"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.MoveSpeed", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#MoveSpeed"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.PreferredDistance", "text": " The creature will try to walk closer to the enemy if the distance is larger. (If you want to make the creature to also walk father from the enemy when necessary, then set <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#RunAwayLife\">RunAwayLife</a> and <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#RunAwayDistance\">RunAwayDistance</a>.)  <p>This should be &lt;= <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#AttackMaxDistance\">AttackMaxDistance</a> or <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#FireMissileMaxDistance\">FireMissileMaxDistance</a>, if you hope to actually perform a short-range or firing missile attack. The creature can attack enemy from <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#AttackMaxDistance\">AttackMaxDistance</a> or fire missile from <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#FireMissileMaxDistance\">FireMissileMaxDistance</a>, but it will walk closer to the enemy if possible &mdash; until the distance is <code>PreferredDistance</code>. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#PreferredDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.AttackMinDelay", "text": " Note that the duration of <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#AttackAnimation\">AttackAnimation</a> also limits how often creature can do an attack (so e.g. setting this to 0.0 doesn't mean that creature can constantly attack, if <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#AttackAnimation\">AttackAnimation</a> takes 1 second then at least this 1 second will have to pass between actual attack hits). ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#AttackMinDelay"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.AttackMaxDistance", "text": " The distance is measured between enemy (see <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreature.html#Enemy\">TWalkAttackCreature.Enemy</a>) and current creature Middle (see <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Middle\">TCastleTransform.Middle</a>) points. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#AttackMaxDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.AttackTime", "text": " When exactly happens depends on the virtual <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreature.html#Attack\">TWalkAttackCreature.Attack</a> method implementation, in the base <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreature.html\">TWalkAttackCreature</a> it is a short-range attack. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#AttackTime"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.AttackMaxAngle", "text": "  <p>More precisely, the attack is allowed to start only when the angle between current creature <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Direction\">Direction</a> and the vector from creature's Middle to the enemy's Middle (see T3D.Middle) is &lt;= <code>AttackMaxAngle</code>.  <p>This is in radians. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#AttackMaxAngle"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.AttackSoundHit", "text": " None (<a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>) by default. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#AttackSoundHit"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.AttackSoundStart", "text": " To play a sound when the actual hit happens (at <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#AttackTime\">AttackTime</a>) see <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#AttackSoundHit\">AttackSoundHit</a>. None (<a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>) by default. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#AttackSoundStart"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.FireMissileTime", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#FireMissileTime"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.FireMissileMinDelay", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#FireMissileMinDelay"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.FireMissileMaxDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#FireMissileMaxDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.FireMissileMaxAngle", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#FireMissileMaxAngle"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.FireMissileName", "text": " Leave empty to not fire any missile. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#FireMissileName"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.FireMissileHeight", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#FireMissileHeight"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.FireMissileSound", "text": " None (<a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>) by default. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#FireMissileSound"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.RunAwayLife", "text": " <code>RunAwayLife</code> is expressed as a fraction of MaxLife. We run if our <code>Life &lt;= MaxLife * <code>RunAwayLife</code></code> and the distance to the (last seen) enemy is &lt; <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#RunAwayDistance\">RunAwayDistance</a>. Set <code>RunAwayLife</code> = 1 to make the creature always try to keep a safe distance from the enemy.  ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#RunAwayLife"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.RunAwayDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#RunAwayDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.VisibilityAngle", "text": " This way, the creature only looks forward, and you can sneak upon a creature from the back. Simply set this to &gt;= 2 * Pi to remove this limit.  <p>Note that the creature also becomes aware of the enemy when it is hurt by a direct attack, regardless of <code>VisibilityAngle</code>. This way if you sneak and attack a creature from the back, it will turn around and fight you.  <p>Creature can also smell others, see <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#SmellDistance\">SmellDistance</a>. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#VisibilityAngle"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.SmellDistance", "text": " This allows to detect enemy regardless of which direction the creature is facing, regardless of whether there is a line of sight to the enemy, regardless if enemy is moving.  <p>This is quite powerful ability to detect enemies, if you set this to something large (by default it's zero). Detecting enemies allows to more accurately/faster attack them and/or run away from them.  <p>Note: If you want the creature to nicely run from behind the corner, be sure to setup good sectors/waypoints in your level. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#SmellDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.MinLifeLossToHurt", "text": " Changing to <a class=\"normal\" href=\"CastleCreatures.html#csHurt\">csHurt</a> state means that any other state will be interrupted (e.g. enemy can interrupt creature's attack this way if <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#AttackTime\">AttackTime</a> &gt; 0).  <p>It's expected that &quot;tougher&quot; creatures will have <code>MinLifeLossToHurt</code> somewhat higher than <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#DefaultMinLifeLossToHurt\">DefaultMinLifeLossToHurt</a> and <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#ChanceToHurt\">ChanceToHurt</a> significantly lower than <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#DefaultChanceToHurt\">DefaultChanceToHurt</a>. ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#MinLifeLossToHurt"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.ChanceToHurt", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#ChanceToHurt"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.MaxHeightAcceptableToFall", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#MaxHeightAcceptableToFall"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.RandomWalkDistance", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#RandomWalkDistance"},
     {"title": "CastleCreatures.TWalkAttackCreatureResource.RemoveDead", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreatureResource.html#RemoveDead"},
     {"title": "CastleCreatures.TMissileCreatureResource", "text": " It just moves into the given direction (with some possible twists, e.g. it can be a &quot;homing&quot; missile and/or be dragged down by gravity). On collision, it hits, potentially hurting the alive 3D object that was colliding (player or other creatures).  <p>Missiles ignore <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#Flying\">TCreatureResource.Flying</a>, they use their own way to handle gravity with <a class=\"normal\" href=\"CastleCreatures.TMissileCreatureResource.html#DirectionFallSpeed\">DirectionFallSpeed</a>. ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html"},
     {"title": "CastleCreatures.TMissileCreatureResource.DefaultMoveSpeed", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#DefaultMoveSpeed"},
     {"title": "CastleCreatures.TMissileCreatureResource.DefaultCloseDirectionToTargetSpeed", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#DefaultCloseDirectionToTargetSpeed"},
     {"title": "CastleCreatures.TMissileCreatureResource.DefaultPauseBetweenSoundIdle", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#DefaultPauseBetweenSoundIdle"},
     {"title": "CastleCreatures.TMissileCreatureResource.DefaultHitsPlayer", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#DefaultHitsPlayer"},
     {"title": "CastleCreatures.TMissileCreatureResource.DefaultHitsCreatures", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#DefaultHitsCreatures"},
     {"title": "CastleCreatures.TMissileCreatureResource.DefaultDirectionFallSpeed", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#DefaultDirectionFallSpeed"},
     {"title": "CastleCreatures.TMissileCreatureResource.DefaultRemoveDead", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#DefaultRemoveDead"},
     {"title": "CastleCreatures.TMissileCreatureResource.RadiusCalculate", "text": "    ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#RadiusCalculate"},
     {"title": "CastleCreatures.TMissileCreatureResource.Create", "text": "    ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#Create"},
     {"title": "CastleCreatures.TMissileCreatureResource.CreatureClass", "text": "    ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#CreatureClass"},
     {"title": "CastleCreatures.TMissileCreatureResource.LoadFromFile", "text": "    ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#LoadFromFile"},
     {"title": "CastleCreatures.TMissileCreatureResource.CreateCreature", "text": "    ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#CreateCreature"},
     {"title": "CastleCreatures.TMissileCreatureResource.FlyAnimation", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#FlyAnimation"},
     {"title": "CastleCreatures.TMissileCreatureResource.DieAnimation", "text": " Optional. It can depict missile explosion. After showing this animation (or immediately when missile hits something, if this animation is not specified) the missile is removed from the level (unless <a class=\"normal\" href=\"CastleCreatures.TMissileCreatureResource.html#RemoveDead\">RemoveDead</a> = <code>False</code>). ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#DieAnimation"},
     {"title": "CastleCreatures.TMissileCreatureResource.MoveSpeed", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#MoveSpeed"},
     {"title": "CastleCreatures.TMissileCreatureResource.SoundHit", "text": " None (<a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>) by default. ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#SoundHit"},
     {"title": "CastleCreatures.TMissileCreatureResource.CloseDirectionToTargetSpeed", "text": " Zero (default) means that the missile is not &quot;homing&quot;. ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#CloseDirectionToTargetSpeed"},
     {"title": "CastleCreatures.TMissileCreatureResource.SoundIdle", "text": " None (<a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>) by default.  ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#SoundIdle"},
     {"title": "CastleCreatures.TMissileCreatureResource.PauseBetweenSoundIdle", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#PauseBetweenSoundIdle"},
     {"title": "CastleCreatures.TMissileCreatureResource.HitsPlayer", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#HitsPlayer"},
     {"title": "CastleCreatures.TMissileCreatureResource.HitsCreatures", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#HitsCreatures"},
     {"title": "CastleCreatures.TMissileCreatureResource.DirectionFallSpeed", "text": " Non-zero value causes missile direction to gradually point downward, this way missile flies downward eventually.  <p>This is quite different (in different units and with slightly different effect) than T3D.FallSpeed, hence a different name and property. <a class=\"normal\" href=\"CastleCreatures.TMissileCreatureResource.html\">TMissileCreatureResource</a> doesn't use T3D.Gravity and so ignores <a class=\"normal\" href=\"CastleResources.T3DResource.html#FallSpeed\">T3DResource.FallSpeed</a>, <a class=\"normal\" href=\"CastleResources.T3DResource.html#GrowSpeed\">T3DResource.GrowSpeed</a> and other properties.  <p>0 means to not fall down (missile is not affected by gravity). ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#DirectionFallSpeed"},
     {"title": "CastleCreatures.TMissileCreatureResource.RemoveDead", "text": " Useful if you want to see arrows stuck into walls where they hit.  <p>This is like <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#RemoveDead\">TWalkAttackCreatureResource.RemoveDead</a> and <a class=\"normal\" href=\"CastleCreatures.TStillCreatureResource.html#RemoveDead\">TStillCreatureResource.RemoveDead</a>, except for missiles the default is <code>True</code>. Also, even if you switch this to <code>False</code>, it's ignored (works like <code>True</code>) if the missile hit a dynamic object (like another creature or player). It only works when a missile hit something else than a creature/player, which means that it probably hit a static level wall. ", "tags": "", "loc": "CastleCreatures.TMissileCreatureResource.html#RemoveDead"},
     {"title": "CastleCreatures.TStillCreatureResource", "text": " This is just a single 3D animation showing a creature. ", "tags": "", "loc": "CastleCreatures.TStillCreatureResource.html"},
     {"title": "CastleCreatures.TStillCreatureResource.DefaultRemoveDead", "text": " ", "tags": "", "loc": "CastleCreatures.TStillCreatureResource.html#DefaultRemoveDead"},
     {"title": "CastleCreatures.TStillCreatureResource.Create", "text": "    ", "tags": "", "loc": "CastleCreatures.TStillCreatureResource.html#Create"},
     {"title": "CastleCreatures.TStillCreatureResource.CreatureClass", "text": "    ", "tags": "", "loc": "CastleCreatures.TStillCreatureResource.html#CreatureClass"},
     {"title": "CastleCreatures.TStillCreatureResource.LoadFromFile", "text": "    ", "tags": "", "loc": "CastleCreatures.TStillCreatureResource.html#LoadFromFile"},
     {"title": "CastleCreatures.TStillCreatureResource.IdleAnimation", "text": " ", "tags": "", "loc": "CastleCreatures.TStillCreatureResource.html#IdleAnimation"},
     {"title": "CastleCreatures.TStillCreatureResource.DieAnimation", "text": " ", "tags": "", "loc": "CastleCreatures.TStillCreatureResource.html#DieAnimation"},
     {"title": "CastleCreatures.TStillCreatureResource.RemoveDead", "text": " ", "tags": "", "loc": "CastleCreatures.TStillCreatureResource.html#RemoveDead"},
     {"title": "CastleCreatures.TCreature", "text": " ", "tags": "", "loc": "CastleCreatures.TCreature.html"},
     {"title": "CastleCreatures.TCreature.RenderDebug", "text": " ", "tags": "", "loc": "CastleCreatures.TCreature.html#RenderDebug"},
     {"title": "CastleCreatures.TCreature.SetLife", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreature.html#SetLife"},
     {"title": "CastleCreatures.TCreature.Fall", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreature.html#Fall"},
     {"title": "CastleCreatures.TCreature.LerpLegsMiddle", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreature.html#LerpLegsMiddle"},
     {"title": "CastleCreatures.TCreature.AttackHurt", "text": " HurtEnemy may be <code>Nil</code>, in this case we do nothing.    ", "tags": "", "loc": "CastleCreatures.TCreature.html#AttackHurt"},
     {"title": "CastleCreatures.TCreature.UpdateDebugCaption", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreature.html#UpdateDebugCaption"},
     {"title": "CastleCreatures.TCreature.Create", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreature.html#Create"},
     {"title": "CastleCreatures.TCreature.Destroy", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreature.html#Destroy"},
     {"title": "CastleCreatures.TCreature.GetExists", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreature.html#GetExists"},
     {"title": "CastleCreatures.TCreature.GetCollides", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreature.html#GetCollides"},
     {"title": "CastleCreatures.TCreature.Update", "text": "    ", "tags": "", "loc": "CastleCreatures.TCreature.html#Update"},
     {"title": "CastleCreatures.TCreature.Sound3d", "text": "  <p>Exactly, the position is between Position and Middle &mdash; SoundHeight = 0 means Position, SoundHeight = 1 means Middle, SoundHeight between means ... well, between Position and Middle. This can also be higher than 1 or lower than 0, should be treated like lerp between Position and Middle.  <p>If TiedToCreature then the sounds position will be updated as the creature will move, and when the creature object will be destroyed, sound will stop. If not TiedToCreature, then the sound will simply be done at creature's position, but then it will continue to be played independent of this creature.    ", "tags": "", "loc": "CastleCreatures.TCreature.html#Sound3d"},
     {"title": "CastleCreatures.TCreature.Sphere", "text": "  <p>Set to <code>False</code> in descendants if Resource.Radius is not appropriate for this creature state.  <p>In this class, this is implemented to return <code>not Dead</code>. This is usually sensible, since only alive creatures need bounding sphere advantages (stairs climbing), and using sphere with dead creatures would unnecessarily force the sphere radius to be small and Middle to be high.    ", "tags": "", "loc": "CastleCreatures.TCreature.html#Sphere"},
     {"title": "CastleCreatures.TCreature.Radius", "text": " Must be something &lt;&gt; 0 for collision detection to work.     ", "tags": "", "loc": "CastleCreatures.TCreature.html#Radius"},
     {"title": "CastleCreatures.TCreature.Resource", "text": " ", "tags": "", "loc": "CastleCreatures.TCreature.html#Resource"},
     {"title": "CastleCreatures.TCreature.SoundDieEnabled", "text": " This is really seldom needed, usefull only to avoid a loud shriek noise when you kill many creatures at once. Primarily for use by debug menu &quot;kill all creatures&quot; and similar things. ", "tags": "", "loc": "CastleCreatures.TCreature.html#SoundDieEnabled"},
     {"title": "CastleCreatures.TCreature.CollidesWithMoving", "text": " ", "tags": "", "loc": "CastleCreatures.TCreature.html#CollidesWithMoving"},
     {"title": "CastleCreatures.TCreatureList", "text": " ", "tags": "", "loc": "CastleCreatures.TCreatureList.html"},
     {"title": "CastleCreatures.TWalkAttackCreature", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html"},
     {"title": "CastleCreatures.TWalkAttackCreature.HasLastSensedEnemy", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#HasLastSensedEnemy"},
     {"title": "CastleCreatures.TWalkAttackCreature.LastSensedEnemy", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#LastSensedEnemy"},
     {"title": "CastleCreatures.TWalkAttackCreature.LastSensedEnemySector", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#LastSensedEnemySector"},
     {"title": "CastleCreatures.TWalkAttackCreature.SetState", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#SetState"},
     {"title": "CastleCreatures.TWalkAttackCreature.SetLife", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#SetLife"},
     {"title": "CastleCreatures.TWalkAttackCreature.UpdateDebugCaption", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#UpdateDebugCaption"},
     {"title": "CastleCreatures.TWalkAttackCreature.Enemy", "text": " In this class, this always returns global World.Player (if it exists and is still alive). Return <code>Nil</code> for no enemy.    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#Enemy"},
     {"title": "CastleCreatures.TWalkAttackCreature.Attack", "text": " This happens in the middle of AttackAnimation, at the time see AttackTime.  <p>This can happen only if you defined AttackAnimation for this creature.  <p>The default implementation here performs a short range <code>attack</code>, if enemy is still within reach (AttackMaxDistance; even if it was within reach at the start of <a class=\"normal\" href=\"CastleCreatures.html#csAttack\">csAttack</a> state, the enemy could step back, so we need to check AttackMaxDistance again). The damage and knockback are defined by <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#AttackDamageConst\">TCreatureResource.AttackDamageConst</a>, <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#AttackDamageRandom\">TCreatureResource.AttackDamageRandom</a>, <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#AttackKnockbackDistance\">TCreatureResource.AttackKnockbackDistance</a>.    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#Attack"},
     {"title": "CastleCreatures.TWalkAttackCreature.FireMissile", "text": " This happens in the middle of FireMissileAnimation, at the time see FireMissileTime.  <p>This can happen only if you defined FireMissileAnimation for this creature.  <p>The default implementation here creates a new creature with resource defined by FireMissileName, if FireMissileName is not empty.    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#FireMissile"},
     {"title": "CastleCreatures.TWalkAttackCreature.Create", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#Create"},
     {"title": "CastleCreatures.TWalkAttackCreature.Destroy", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#Destroy"},
     {"title": "CastleCreatures.TWalkAttackCreature.Resource", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#Resource"},
     {"title": "CastleCreatures.TWalkAttackCreature.Update", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#Update"},
     {"title": "CastleCreatures.TWalkAttackCreature.Hurt", "text": "    ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#Hurt"},
     {"title": "CastleCreatures.TWalkAttackCreature.StateChangeTime", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#StateChangeTime"},
     {"title": "CastleCreatures.TWalkAttackCreature.State", "text": " ", "tags": "", "loc": "CastleCreatures.TWalkAttackCreature.html#State"},
     {"title": "CastleCreatures.TMissileCreature", "text": " ", "tags": "", "loc": "CastleCreatures.TMissileCreature.html"},
     {"title": "CastleCreatures.TMissileCreature.Create", "text": "    ", "tags": "", "loc": "CastleCreatures.TMissileCreature.html#Create"},
     {"title": "CastleCreatures.TMissileCreature.Resource", "text": "    ", "tags": "", "loc": "CastleCreatures.TMissileCreature.html#Resource"},
     {"title": "CastleCreatures.TMissileCreature.Update", "text": "    ", "tags": "", "loc": "CastleCreatures.TMissileCreature.html#Update"},
     {"title": "CastleCreatures.TStillCreature", "text": " ", "tags": "", "loc": "CastleCreatures.TStillCreature.html"},
     {"title": "CastleCreatures.TStillCreature.Resource", "text": "    ", "tags": "", "loc": "CastleCreatures.TStillCreature.html#Resource"},
     {"title": "CastleCreatures.TStillCreature.Update", "text": "    ", "tags": "", "loc": "CastleCreatures.TStillCreature.html#Update"},
     {"title": "CastleCreatures.csIdle", "text": " ", "tags": "", "loc": "CastleCreatures.html#csIdle"},
     {"title": "CastleCreatures.csWalk", "text": " ", "tags": "", "loc": "CastleCreatures.html#csWalk"},
     {"title": "CastleCreatures.csAttack", "text": " ", "tags": "", "loc": "CastleCreatures.html#csAttack"},
     {"title": "CastleCreatures.csFireMissile", "text": " ", "tags": "", "loc": "CastleCreatures.html#csFireMissile"},
     {"title": "CastleCreatures.csDie", "text": " ", "tags": "", "loc": "CastleCreatures.html#csDie"},
     {"title": "CastleCreatures.csDieBack", "text": " ", "tags": "", "loc": "CastleCreatures.html#csDieBack"},
     {"title": "CastleCreatures.csHurt", "text": " ", "tags": "", "loc": "CastleCreatures.html#csHurt"},
     {"title": "CastleCreatures.csMax", "text": " ", "tags": "", "loc": "CastleCreatures.html#csMax"},
     {"title": "CastleCreatures.TCreatureState", "text": " ", "tags": "", "loc": "CastleCreatures.html#TCreatureState"},
     {"title": "CastleCreatures.TCreatureClass", "text": " ", "tags": "", "loc": "CastleCreatures.html#TCreatureClass"},
     {"title": "CastleCreatures.TCreatureExistsEvent", "text": "    ", "tags": "", "loc": "CastleCreatures.html#TCreatureExistsEvent"},
     {"title": "CastleCreatures.DebugTimeStopForCreatures", "text": " ", "tags": "", "loc": "CastleCreatures.html#DebugTimeStopForCreatures"},
     {"title": "CastleCreatures.OnCreatureExists", "text": " ", "tags": "", "loc": "CastleCreatures.html#OnCreatureExists"},
     {"title": "CastleCubeMaps", "text": " ", "tags": "", "loc": "CastleCubeMaps.html"},
     {"title": "CastleCubeMaps.TCubeMapInfo", "text": " ", "tags": "", "loc": "CastleCubeMaps.TCubeMapInfo.html"},
     {"title": "CastleCubeMaps.TCubeMapInfo.Dir", "text": " ", "tags": "", "loc": "CastleCubeMaps.TCubeMapInfo.html#Dir"},
     {"title": "CastleCubeMaps.TCubeMapInfo.Up", "text": " ", "tags": "", "loc": "CastleCubeMaps.TCubeMapInfo.html#Up"},
     {"title": "CastleCubeMaps.TCubeMapInfo.Side", "text": " ", "tags": "", "loc": "CastleCubeMaps.TCubeMapInfo.html#Side"},
     {"title": "CastleCubeMaps.TCubeMapInfo.ScreenX", "text": " ", "tags": "", "loc": "CastleCubeMaps.TCubeMapInfo.html#ScreenX"},
     {"title": "CastleCubeMaps.TCubeMapInfo.ScreenY", "text": " ", "tags": "", "loc": "CastleCubeMaps.TCubeMapInfo.html#ScreenY"},
     {"title": "CastleCubeMaps.CubeMapSize", "text": " ", "tags": "", "loc": "CastleCubeMaps.html#CubeMapSize"},
     {"title": "CastleCubeMaps.CubeMapInfo", "text": "  <p>Names and orientation of faces match precisely OpenGL naming and orientation (see <a  href=\"http://www.opengl.org/registry/specs/ARB/texture_cube_map.txt\">http://www.opengl.org/registry/specs/ARB/texture_cube_map.txt</a>), so it's straighforward to use this for OpenGL cube maps. ", "tags": "", "loc": "CastleCubeMaps.html#CubeMapInfo"},
     {"title": "CastleCubeMaps.CubeMapDirection", "text": " That is, assuming that the middle of cube is placed at (0, 0, 0), each pixel of the cube map corresponds to some direction.  <p>Pixel number must be between 0 and <a class=\"normal\" href=\"CastleCubeMaps.html#CubeMapSize\">CubeMapSize</a>*2-1. It's assumed that pixels are in the same order as they are in OpenGL images, that is row-by-row, from the lowest row to highest, in each row from left to right.  <p>Returned vector is <i>not normalized</i>.    ", "tags": "", "loc": "CastleCubeMaps.html#CubeMapDirection"},
     {"title": "CastleCubeMaps.DirectionToCubeMap", "text": " This is the reverse of <a class=\"normal\" href=\"CastleCubeMaps.html#CubeMapDirection\">CubeMapDirection</a> function.  <p>Given here Dir need not be normalized, although must not be zero.    ", "tags": "", "loc": "CastleCubeMaps.html#DirectionToCubeMap"},
     {"title": "CastleCubeMaps.Direction4ToCubeMap", "text": " All ratios will sum to 1.  <p>This is like <a class=\"normal\" href=\"CastleCubeMaps.html#DirectionToCubeMap\">DirectionToCubeMap</a>, except this returns 4 values. It allows you to do bilinear interpolation between cube map items.    ", "tags": "", "loc": "CastleCubeMaps.html#Direction4ToCubeMap"},
     {"title": "CastleCubeMaps.CubeMapSolidAngle", "text": "    ", "tags": "", "loc": "CastleCubeMaps.html#CubeMapSolidAngle"},
     {"title": "CastleCubeMaps.TCubeMapSide", "text": " ", "tags": "", "loc": "CastleCubeMaps.html#TCubeMapSide"},
     {"title": "CastleCubeMaps.TCubeMapSide4", "text": " ", "tags": "", "loc": "CastleCubeMaps.html#TCubeMapSide4"},
     {"title": "CastleCubeMaps.TCubeMapFloat", "text": " ", "tags": "", "loc": "CastleCubeMaps.html#TCubeMapFloat"},
     {"title": "CastleCubeMaps.PCubeMapFloat", "text": " ", "tags": "", "loc": "CastleCubeMaps.html#PCubeMapFloat"},
     {"title": "CastleCubeMaps.TCubeMapByte", "text": " This assumes that every item is actually a float in 0..1 range, encoded as Byte. ", "tags": "", "loc": "CastleCubeMaps.html#TCubeMapByte"},
     {"title": "CastleCubeMaps.PCubeMapByte", "text": " ", "tags": "", "loc": "CastleCubeMaps.html#PCubeMapByte"},
     {"title": "CastleCurves", "text": " ", "tags": "", "loc": "CastleCurves.html"},
     {"title": "CastleCurves.ECurveFileInvalid", "text": " ", "tags": "", "loc": "CastleCurves.ECurveFileInvalid.html"},
     {"title": "CastleCurves.TCurve", "text": " ", "tags": "", "loc": "CastleCurves.TCurve.html"},
     {"title": "CastleCurves.TCurve.LoadFromElement", "text": "    ", "tags": "", "loc": "CastleCurves.TCurve.html#LoadFromElement"},
     {"title": "CastleCurves.TCurve.SaveToStream", "text": "    ", "tags": "", "loc": "CastleCurves.TCurve.html#SaveToStream"},
     {"title": "CastleCurves.TCurve.Point", "text": " This determines the actual shape of the curve.    ", "tags": "", "loc": "CastleCurves.TCurve.html#Point"},
     {"title": "CastleCurves.TCurve.Point2D", "text": "    ", "tags": "", "loc": "CastleCurves.TCurve.html#Point2D"},
     {"title": "CastleCurves.TCurve.PointOfSegment", "text": " This is simply a more specialized version of <a class=\"normal\" href=\"CastleCurves.TCurve.html#Point\">Point</a>, it scales the argument such that you get Point(<a class=\"normal\" href=\"CastleCurves.TCurve.html#TBegin\">TBegin</a>) for I = 0 and you get Point(<a class=\"normal\" href=\"CastleCurves.TCurve.html#TEnd\">TEnd</a>) for I = Segments.    ", "tags": "", "loc": "CastleCurves.TCurve.html#PointOfSegment"},
     {"title": "CastleCurves.TCurve.Create", "text": "    ", "tags": "", "loc": "CastleCurves.TCurve.html#Create"},
     {"title": "CastleCurves.TCurve.LoadFromFile", "text": " Hint: use <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Curves-tool\">https://github.com/castle-engine/castle-engine/wiki/Curves-tool</a> to design curves visually.    ", "tags": "", "loc": "CastleCurves.TCurve.html#LoadFromFile"},
     {"title": "CastleCurves.TCurve.BoundingBox", "text": "    ", "tags": "", "loc": "CastleCurves.TCurve.html#BoundingBox"},
     {"title": "CastleCurves.TCurve.TBegin", "text": " Must be <code>TBegin</code> &lt;= <a class=\"normal\" href=\"CastleCurves.TCurve.html#TEnd\">TEnd</a>.  ", "tags": "", "loc": "CastleCurves.TCurve.html#TBegin"},
     {"title": "CastleCurves.TCurve.TEnd", "text": " ", "tags": "", "loc": "CastleCurves.TCurve.html#TEnd"},
     {"title": "CastleCurves.TCurve.DefaultSegments", "text": " ", "tags": "", "loc": "CastleCurves.TCurve.html#DefaultSegments"},
     {"title": "CastleCurves.TCurveList", "text": " ", "tags": "", "loc": "CastleCurves.TCurveList.html"},
     {"title": "CastleCurves.TCurveList.LoadFromFile", "text": " Hint: use <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Curves-tool\">https://github.com/castle-engine/castle-engine/wiki/Curves-tool</a> to design curves visually.    ", "tags": "", "loc": "CastleCurves.TCurveList.html#LoadFromFile"},
     {"title": "CastleCurves.TCurveList.SaveToFile", "text": " Hint: use <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Curves-tool\">https://github.com/castle-engine/castle-engine/wiki/Curves-tool</a> to design curves visually.    ", "tags": "", "loc": "CastleCurves.TCurveList.html#SaveToFile"},
     {"title": "CastleCurves.TCasScriptCurve", "text": " ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html"},
     {"title": "CastleCurves.TCasScriptCurve.LoadFromElement", "text": "    ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#LoadFromElement"},
     {"title": "CastleCurves.TCasScriptCurve.SaveToStream", "text": "    ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#SaveToStream"},
     {"title": "CastleCurves.TCasScriptCurve.Point", "text": "    ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#Point"},
     {"title": "CastleCurves.TCasScriptCurve.BoundingBox", "text": " It is simply a <code>BoundingBox</code> of Point(i, <a class=\"normal\" href=\"CastleCurves.TCasScriptCurve.html#SegmentsForBoundingBox\">SegmentsForBoundingBox</a>) for i in [0 .. <a class=\"normal\" href=\"CastleCurves.TCasScriptCurve.html#SegmentsForBoundingBox\">SegmentsForBoundingBox</a>]. Subclasses may override this to calculate something more accurate.    ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#BoundingBox"},
     {"title": "CastleCurves.TCasScriptCurve.Create", "text": "    ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#Create"},
     {"title": "CastleCurves.TCasScriptCurve.Destroy", "text": "    ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#Destroy"},
     {"title": "CastleCurves.TCasScriptCurve.XFunction", "text": " Once set, these instances become owned by this class, do not free them yourself!  ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#XFunction"},
     {"title": "CastleCurves.TCasScriptCurve.YFunction", "text": " ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#YFunction"},
     {"title": "CastleCurves.TCasScriptCurve.ZFunction", "text": " ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#ZFunction"},
     {"title": "CastleCurves.TCasScriptCurve.TVariable", "text": " This is NOT owned by this class, make sure to free it yourself! ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#TVariable"},
     {"title": "CastleCurves.TCasScriptCurve.SegmentsForBoundingBox", "text": " ", "tags": "", "loc": "CastleCurves.TCasScriptCurve.html#SegmentsForBoundingBox"},
     {"title": "CastleCurves.TControlPointsCurve", "text": " Note: it is <i>not</i> defined in this class any correspondence between values of T (argument for Point function) and <a class=\"normal\" href=\"CastleCurves.TControlPointsCurve.html#ControlPoints\">ControlPoints</a>. ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html"},
     {"title": "CastleCurves.TControlPointsCurve.ControlPoints", "text": " ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html#ControlPoints"},
     {"title": "CastleCurves.TControlPointsCurve.LoadFromElement", "text": "    ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html#LoadFromElement"},
     {"title": "CastleCurves.TControlPointsCurve.SaveToStream", "text": "    ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html#SaveToStream"},
     {"title": "CastleCurves.TControlPointsCurve.BoundingBox", "text": " In this class, it is simply a <code>BoundingBox</code> of <a class=\"normal\" href=\"CastleCurves.TControlPointsCurve.html#ControlPoints\">ControlPoints</a>.    ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html#BoundingBox"},
     {"title": "CastleCurves.TControlPointsCurve.UpdateControlPoints", "text": " It recalculates necessary things. ControlPoints.Count must be &gt;= 2.  <p>When overriding: always call inherited first.    ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html#UpdateControlPoints"},
     {"title": "CastleCurves.TControlPointsCurve.Create", "text": "    ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html#Create"},
     {"title": "CastleCurves.TControlPointsCurve.CreateFromEquation", "text": " <a class=\"normal\" href=\"CastleCurves.TCurve.html#TBegin\">TBegin</a> and <a class=\"normal\" href=\"CastleCurves.TCurve.html#TEnd\">TEnd</a> are copied from CasScriptCurve.    ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html#CreateFromEquation"},
     {"title": "CastleCurves.TControlPointsCurve.Destroy", "text": "    ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html#Destroy"},
     {"title": "CastleCurves.TControlPointsCurve.ConvexHull", "text": " Caller is responsible for freeing the result.    ", "tags": "", "loc": "CastleCurves.TControlPointsCurve.html#ConvexHull"},
     {"title": "CastleCurves.TPiecewiseCubicBezier", "text": " Each segment (<a class=\"normal\" href=\"CastleCurves.TControlPointsCurve.html#ControlPoints\">ControlPoints</a>[i]..ControlPoints[i+1]) is a cubic Bezier curve (Bezier with 4 control points, 2 points in the middle are auto-calculated for max smoothness).  <p>This is a cubic B-spline. Which is equivalent to C2 continuous composite Bézier curves. See <a  href=\"https://en.wikipedia.org/wiki/Spline_%28mathematics%29\">https://en.wikipedia.org/wiki/Spline_%28mathematics%29</a> . Aka Cubic B-Spline (piecewise C2-Smooth Cubic Bezier).  <p>ControlPoints.Count may be 1 (in general, for <a class=\"normal\" href=\"CastleCurves.TControlPointsCurve.html\">TControlPointsCurve</a>, it must be &gt;= 2).  <p>You can use this to calculate points on a curve, you cannot render the curve out-of-the-box with this class. For a portable and renderable curves consider using X3D NURBS nodes (wrapped in a <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>) instead. Or convert this curve to a <a class=\"normal\" href=\"X3DNodes.TLineSetNode.html\">TLineSetNode</a> X3D node. ", "tags": "", "loc": "CastleCurves.TPiecewiseCubicBezier.html"},
     {"title": "CastleCurves.TPiecewiseCubicBezier.Create", "text": "    ", "tags": "", "loc": "CastleCurves.TPiecewiseCubicBezier.html#Create"},
     {"title": "CastleCurves.TPiecewiseCubicBezier.Destroy", "text": "    ", "tags": "", "loc": "CastleCurves.TPiecewiseCubicBezier.html#Destroy"},
     {"title": "CastleCurves.TPiecewiseCubicBezier.UpdateControlPoints", "text": "    ", "tags": "", "loc": "CastleCurves.TPiecewiseCubicBezier.html#UpdateControlPoints"},
     {"title": "CastleCurves.TPiecewiseCubicBezier.Point", "text": "    ", "tags": "", "loc": "CastleCurves.TPiecewiseCubicBezier.html#Point"},
     {"title": "CastleCurves.TPiecewiseCubicBezier.BoundingBox", "text": "    ", "tags": "", "loc": "CastleCurves.TPiecewiseCubicBezier.html#BoundingBox"},
     {"title": "CastleCurves.CubicBezier1D", "text": "    ", "tags": "", "loc": "CastleCurves.html#CubicBezier1D"},
     {"title": "CastleCurves.CubicBezier2D", "text": "    ", "tags": "", "loc": "CastleCurves.html#CubicBezier2D"},
     {"title": "CastleCurves.CubicBezier3D", "text": "    ", "tags": "", "loc": "CastleCurves.html#CubicBezier3D"},
     {"title": "CastleCurves.CatmullRomSpline", "text": " Nice way to have a function that for certain arguments reaches certain values, and between interpolates smoothly.  <p>Catmull-Rom splines are a special case of cubic Hermite splines, see <a  href=\"https://en.wikipedia.org/wiki/Cubic_Hermite_spline\">https://en.wikipedia.org/wiki/Cubic_Hermite_spline</a> .    ", "tags": "", "loc": "CastleCurves.html#CatmullRomSpline"},
     {"title": "CastleCurves.CatmullRom", "text": " For X in [0..1], the curve values change from V1 to V2. V0 and V3 are curve values outside the [0..1] range, used to calculate tangents.  <p>See <a  href=\"http://www.mvps.org/directx/articles/catmull/\">http://www.mvps.org/directx/articles/catmull/</a>.  <p>    ", "tags": "", "loc": "CastleCurves.html#CatmullRom"},
     {"title": "CastleCurves.HermiteSpline", "text": " Nice way to have a function that for certain arguments reaches certain values, and between interpolates smoothly. Requires specifying tangent values (use <a class=\"normal\" href=\"CastleCurves.html#CatmullRomSpline\">CatmullRomSpline</a> or <a class=\"normal\" href=\"CastleCurves.html#HermiteTenseSpline\">HermiteTenseSpline</a> to use automatic tangents).    ", "tags": "", "loc": "CastleCurves.html#HermiteSpline"},
     {"title": "CastleCurves.HermiteTenseSpline", "text": " Nice way to have a function that for certain arguments reaches certain values, and between interpolates smoothly.  <p>This is equivalent (for faster) to using <a class=\"normal\" href=\"CastleCurves.html#HermiteSpline\">HermiteSpline</a> with all tangents equal to zero.  <p>This is called a &quot;cardinal spline&quot;, a special case of Hermite spline, with all tangents calculated with &quot;tension&quot; parameter equal to 1 (maximum), which means that all tangents are simply zero (horizontal). See <a  href=\"https://en.wikipedia.org/wiki/Cubic_Hermite_spline\">https://en.wikipedia.org/wiki/Cubic_Hermite_spline</a> for math behind this.    ", "tags": "", "loc": "CastleCurves.html#HermiteTenseSpline"},
     {"title": "CastleCurves.TControlPointsCurveClass", "text": " ", "tags": "", "loc": "CastleCurves.html#TControlPointsCurveClass"},
     {"title": "CastleCurves.TControlPointsCurveList", "text": " ", "tags": "", "loc": "CastleCurves.html#TControlPointsCurveList"},
     {"title": "CastleCurves.TCubicBezier2DPoints", "text": " ", "tags": "", "loc": "CastleCurves.html#TCubicBezier2DPoints"},
     {"title": "CastleCurves.TCubicBezier3DPoints", "text": " ", "tags": "", "loc": "CastleCurves.html#TCubicBezier3DPoints"},
     {"title": "CastleDataURI", "text": " ", "tags": "", "loc": "CastleDataURI.html"},
     {"title": "CastleDataURI.TDataURI", "text": " Such URI specifies the MIME type and contains the data, encoded in plain text or <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Base64\">base64</a>. That is, the data is not merely referenced / linked (like with a usual URL), it's simply fully encoded inside the URI. Since such URI can be used anywhere a normal URI is expected, it allows you to inline any kind of data inside any container file. For example, you can place images (textures) and such directly inside a VRML/X3D file. ", "tags": "", "loc": "CastleDataURI.TDataURI.html"},
     {"title": "CastleDataURI.TDataURI.Destroy", "text": "    ", "tags": "", "loc": "CastleDataURI.TDataURI.html#Destroy"},
     {"title": "CastleDataURI.TDataURI.IsDataURI", "text": "    ", "tags": "", "loc": "CastleDataURI.TDataURI.html#IsDataURI"},
     {"title": "CastleDataURI.TDataURI.IsDataURI", "text": "    ", "tags": "", "loc": "CastleDataURI.TDataURI.html#IsDataURI"},
     {"title": "CastleDataURI.TDataURI.Stream", "text": " If the <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#URI\">URI</a> is not valid (includes the initial state when it's not set) then returns <code>Nil</code>.  <p>The important property of this reader is that no expensive encoding is done until you call this method. In particular, you can set URI, check <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#MimeType\">MimeType</a>, and if you see that <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#MimeType\">MimeType</a> is something not interesting for you (for example, maybe you require some image type) just don't call this method. Then nothing expensive will happen, e.g. data will not be <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Base64\">base64</a>-decoded without a need.    ", "tags": "", "loc": "CastleDataURI.TDataURI.html#Stream"},
     {"title": "CastleDataURI.TDataURI.ExtractStream", "text": " Makes the stream no longer owner by this <a class=\"normal\" href=\"CastleDataURI.TDataURI.html\">TDataURI</a> instance.  <p>Do not call <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Stream\">Stream</a> after calling <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#ExtractStream\">ExtractStream</a>. Results are undefined. (Right now, another decoding stream will then be created, that will return the same thing as previous stream. But do not depend on it.)    ", "tags": "", "loc": "CastleDataURI.TDataURI.html#ExtractStream"},
     {"title": "CastleDataURI.TDataURI.ForceMemoryStream", "text": " Without this, they may return TBase64DecodingStream that may not be seekable. ", "tags": "", "loc": "CastleDataURI.TDataURI.html#ForceMemoryStream"},
     {"title": "CastleDataURI.TDataURI.URI", "text": "  <p>When you set this, we read the beginning of URI. If this is a valid data URI, then we set <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Valid\">Valid</a> to <code>True</code>, update <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#MimeType\">MimeType</a>, <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Base64\">Base64</a>, <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Charset\">Charset</a>, <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#URIPrefix\">URIPrefix</a> accordingly, and you can call <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Stream\">Stream</a> if you want to read actual contents.  <p>If this is not a valid data URI, then we set <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Valid\">Valid</a> to <code>False</code>, make appropriate warning through <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>, and reset <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#MimeType\">MimeType</a>, <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Base64\">Base64</a>, <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#Charset\">Charset</a>, <a class=\"normal\" href=\"CastleDataURI.TDataURI.html#URIPrefix\">URIPrefix</a> to some default values. ", "tags": "", "loc": "CastleDataURI.TDataURI.html#URI"},
     {"title": "CastleDataURI.TDataURI.Valid", "text": " ", "tags": "", "loc": "CastleDataURI.TDataURI.html#Valid"},
     {"title": "CastleDataURI.TDataURI.MimeType", "text": " ", "tags": "", "loc": "CastleDataURI.TDataURI.html#MimeType"},
     {"title": "CastleDataURI.TDataURI.Base64", "text": " ", "tags": "", "loc": "CastleDataURI.TDataURI.html#Base64"},
     {"title": "CastleDataURI.TDataURI.Charset", "text": " ", "tags": "", "loc": "CastleDataURI.TDataURI.html#Charset"},
     {"title": "CastleDataURI.TDataURI.URIPrefix", "text": " ", "tags": "", "loc": "CastleDataURI.TDataURI.html#URIPrefix"},
     {"title": "CastleDebugTransform", "text": " ", "tags": "", "loc": "CastleDebugTransform.html"},
     {"title": "CastleDebugTransform.TDebugAxis", "text": " This is useful in connection with your custom <a class=\"normal\" href=\"CastleDebugTransform.TDebugTransform.html\">TDebugTransform</a> descendants, to show an axis to visualize something.  <p>Create it and add the <a class=\"normal\" href=\"CastleDebugTransform.TDebugAxis.html#Root\">Root</a> to your X3D scene graph within some <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">TCastleSceneCore.RootNode</a>. You can change properties like <a class=\"normal\" href=\"CastleDebugTransform.TDebugAxis.html#Position\">Position</a> at any time (before and after adding the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">TCastleSceneCore.RootNode</a> to some graph). ", "tags": "", "loc": "CastleDebugTransform.TDebugAxis.html"},
     {"title": "CastleDebugTransform.TDebugAxis.Create", "text": "    ", "tags": "", "loc": "CastleDebugTransform.TDebugAxis.html#Create"},
     {"title": "CastleDebugTransform.TDebugAxis.Root", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugAxis.html#Root"},
     {"title": "CastleDebugTransform.TDebugAxis.Render", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugAxis.html#Render"},
     {"title": "CastleDebugTransform.TDebugAxis.Position", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugAxis.html#Position"},
     {"title": "CastleDebugTransform.TDebugAxis.ScaleFromBox", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugAxis.html#ScaleFromBox"},
     {"title": "CastleDebugTransform.TDebugBox", "text": " This is a ready construction using X3D <a class=\"normal\" href=\"X3DNodes.TBoxNode.html\">TBoxNode</a>, <a class=\"normal\" href=\"X3DNodes.TShapeNode.html\">TShapeNode</a>, <a class=\"normal\" href=\"X3DNodes.TTransformNode.html\">TTransformNode</a> to give you a comfortable box visualization.  <p>This is useful in connection with your custom <a class=\"normal\" href=\"CastleDebugTransform.TDebugTransform.html\">TDebugTransform</a> descendants, to show an axis to visualize something.  <p>Create it and add the <a class=\"normal\" href=\"CastleDebugTransform.TDebugBox.html#Root\">Root</a> to your X3D scene graph within some <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">TCastleSceneCore.RootNode</a>. You can change properties like <a class=\"normal\" href=\"CastleDebugTransform.TDebugBox.html#Box\">Box</a> at any time (before and after adding the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">TCastleSceneCore.RootNode</a> to some graph). ", "tags": "", "loc": "CastleDebugTransform.TDebugBox.html"},
     {"title": "CastleDebugTransform.TDebugBox.Create", "text": "    ", "tags": "", "loc": "CastleDebugTransform.TDebugBox.html#Create"},
     {"title": "CastleDebugTransform.TDebugBox.Root", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugBox.html#Root"},
     {"title": "CastleDebugTransform.TDebugBox.Box", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugBox.html#Box"},
     {"title": "CastleDebugTransform.TDebugSphere", "text": " This is a ready construction using X3D <a class=\"normal\" href=\"X3DNodes.TSphereNode.html\">TSphereNode</a>, <a class=\"normal\" href=\"X3DNodes.TShapeNode.html\">TShapeNode</a>, <a class=\"normal\" href=\"X3DNodes.TTransformNode.html\">TTransformNode</a> to give you a comfortable sphere visualization.  <p>This is useful in connection with your custom <a class=\"normal\" href=\"CastleDebugTransform.TDebugTransform.html\">TDebugTransform</a> descendants, to show an axis to visualize something.  <p>Create it and add the <a class=\"normal\" href=\"CastleDebugTransform.TDebugSphere.html#Root\">Root</a> to your X3D scene graph within some <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">TCastleSceneCore.RootNode</a>. You can change properties like <a class=\"normal\" href=\"CastleDebugTransform.TDebugSphere.html#Position\">Position</a> at any time (before and after adding the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">TCastleSceneCore.RootNode</a> to some graph). ", "tags": "", "loc": "CastleDebugTransform.TDebugSphere.html"},
     {"title": "CastleDebugTransform.TDebugSphere.Create", "text": "    ", "tags": "", "loc": "CastleDebugTransform.TDebugSphere.html#Create"},
     {"title": "CastleDebugTransform.TDebugSphere.Root", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugSphere.html#Root"},
     {"title": "CastleDebugTransform.TDebugSphere.Render", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugSphere.html#Render"},
     {"title": "CastleDebugTransform.TDebugSphere.Position", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugSphere.html#Position"},
     {"title": "CastleDebugTransform.TDebugSphere.Radius", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugSphere.html#Radius"},
     {"title": "CastleDebugTransform.TDebugTransform", "text": " After constructing this, call <a class=\"normal\" href=\"CastleDebugTransform.TDebugTransform.html#Attach\">Attach</a> to <a class=\"normal\" href=\"CastleDebugTransform.TDebugTransform.html#Attach\">attach</a> this to some <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> instance.  <p>Then set <a class=\"normal\" href=\"CastleDebugTransform.TDebugTransform.html#Exists\">Exists</a> to control whether the debug visualization should actually be shown. We take care to only actually construct internal <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> when the <a class=\"normal\" href=\"CastleDebugTransform.TDebugTransform.html#Exists\">Exists</a> becomes <code>True</code>, so you can construct <code>TDebugTransform</code> instance always, even in release mode &ndash; it does not take up resources if never visible. ", "tags": "", "loc": "CastleDebugTransform.TDebugTransform.html"},
     {"title": "CastleDebugTransform.TDebugTransform.Attach", "text": "    ", "tags": "", "loc": "CastleDebugTransform.TDebugTransform.html#Attach"},
     {"title": "CastleDebugTransform.TDebugTransform.ChangedScene", "text": "    ", "tags": "", "loc": "CastleDebugTransform.TDebugTransform.html#ChangedScene"},
     {"title": "CastleDebugTransform.TDebugTransform.Exists", "text": " ", "tags": "", "loc": "CastleDebugTransform.TDebugTransform.html#Exists"},
     {"title": "CastleDebugTransform.TDebugTransform.WorldSpace", "text": " Be sure to call <a class=\"normal\" href=\"CastleDebugTransform.TDebugTransform.html#ChangedScene\">ChangedScene</a> afterwards. ", "tags": "", "loc": "CastleDebugTransform.TDebugTransform.html#WorldSpace"},
     {"title": "CastleDialogs", "text": " ", "tags": "", "loc": "CastleDialogs.html"},
     {"title": "CastleDialogs.TCastleOpenDialog", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleOpenDialog.html"},
     {"title": "CastleDialogs.TCastleOpenDialog.URL", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleOpenDialog.html#URL"},
     {"title": "CastleDialogs.TCastleSaveDialog", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleSaveDialog.html"},
     {"title": "CastleDialogs.TCastleSaveDialog.URL", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleSaveDialog.html#URL"},
     {"title": "CastleDialogs.TCastleOpen3DDialog", "text": " It uses an <a class=\"normal\" href=\"CastleDialogs.TCastleOpen3DDialog.html#URL\">URL</a>, and additionally initializes the filters to include all the 3D model types our engine can load (through <a class=\"normal\" href=\"X3DLoad.html#Load3D\">Load3D</a>, through setting TCastleScene.URL and other functions). ", "tags": "", "loc": "CastleDialogs.TCastleOpen3DDialog.html"},
     {"title": "CastleDialogs.TCastleOpen3DDialog.Create", "text": "    ", "tags": "", "loc": "CastleDialogs.TCastleOpen3DDialog.html#Create"},
     {"title": "CastleDialogs.TCastleOpen3DDialog.URL", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleOpen3DDialog.html#URL"},
     {"title": "CastleDialogs.TCastleOpen3DDialog.Filter", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleOpen3DDialog.html#Filter"},
     {"title": "CastleDialogs.TCastleOpen3DDialog.FilterIndex", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleOpen3DDialog.html#FilterIndex"},
     {"title": "CastleDialogs.TCastleOpenImageDialog", "text": " It uses an <a class=\"normal\" href=\"CastleDialogs.TCastleOpenImageDialog.html#URL\">URL</a>, and additionally initializes the filters to include all the image types our engine can load through <a class=\"normal\" href=\"CastleImages.html#LoadImage\">CastleImages.LoadImage</a>. ", "tags": "", "loc": "CastleDialogs.TCastleOpenImageDialog.html"},
     {"title": "CastleDialogs.TCastleOpenImageDialog.Create", "text": "    ", "tags": "", "loc": "CastleDialogs.TCastleOpenImageDialog.html#Create"},
     {"title": "CastleDialogs.TCastleOpenImageDialog.URL", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleOpenImageDialog.html#URL"},
     {"title": "CastleDialogs.TCastleOpenImageDialog.Filter", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleOpenImageDialog.html#Filter"},
     {"title": "CastleDialogs.TCastleOpenImageDialog.FilterIndex", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleOpenImageDialog.html#FilterIndex"},
     {"title": "CastleDialogs.TCastleSaveImageDialog", "text": " It uses an <a class=\"normal\" href=\"CastleDialogs.TCastleSaveImageDialog.html#URL\">URL</a>, and additionally initializes the filters to include all the image types our engine can save through <a class=\"normal\" href=\"CastleImages.html#SaveImage\">CastleImages.SaveImage</a>. ", "tags": "", "loc": "CastleDialogs.TCastleSaveImageDialog.html"},
     {"title": "CastleDialogs.TCastleSaveImageDialog.Create", "text": "    ", "tags": "", "loc": "CastleDialogs.TCastleSaveImageDialog.html#Create"},
     {"title": "CastleDialogs.TCastleSaveImageDialog.URL", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleSaveImageDialog.html#URL"},
     {"title": "CastleDialogs.TCastleSaveImageDialog.Filter", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleSaveImageDialog.html#Filter"},
     {"title": "CastleDialogs.TCastleSaveImageDialog.FilterIndex", "text": " ", "tags": "", "loc": "CastleDialogs.TCastleSaveImageDialog.html#FilterIndex"},
     {"title": "CastleDialogs.Register", "text": "    ", "tags": "", "loc": "CastleDialogs.html#Register"},
     {"title": "CastleDialogStates", "text": " This unit defines the user-interface state classes (<a class=\"normal\" href=\"CastleUIState.TUIState.html\">TUIState</a> descendants) to display given dialog.  <p>If you use <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> with most platforms (but not iOS), then it's usually more comfortable to use the unit <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a> instead of this unit. Using the <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a>, you get comfortable functions like <a class=\"normal\" href=\"CastleMessages.html#MessageOK\">MessageOK</a> and <a class=\"normal\" href=\"CastleMessages.html#MessageYesNo\">MessageYesNo</a> that wait until user presses a button (like &quot;OK&quot;, &quot;Yes&quot;, &quot;No&quot;) to close the dialog. This is comfortable to use, as you can write code like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">if</span> MessageYesNo(Window, <span class=\"pascal_string\">'Are you sure you want to delete this file?'</span>) <span class=\"pascal_keyword\">then</span>   DeleteFile(<span class=\"pascal_numeric\"></span>...);</pre>  <p>  <p>Underneath, the <a class=\"normal\" href=\"CastleMessages.html#MessageYesNo\">MessageYesNo</a> will use a <a class=\"normal\" href=\"CastleDialogStates.TStateDialogYesNo.html\">TStateDialogYesNo</a>, making sure that your normal window callbacks are redirected as appropriate. But you don't need to be concerned with this.  <p>However, if you need to work on iOS, then you cannot use most of routines from the <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a> unit. You can use <a class=\"normal\" href=\"CastleMessages.html#MessageOK\">MessageOK</a> if you turn on the <a class=\"normal\" href=\"CastleMessages.html#MessageOKPushesState\">MessageOKPushesState</a> flag, but nothing else. E.g. <a class=\"normal\" href=\"CastleMessages.html#MessageYesNo\">MessageYesNo</a> cannot work on iOS now. Making modal boxes like that is not supported on iOS.  <p>In this case you should use this unit and instantiate the user-interface classes yourself, and you need to <i>organize your whole game using <a class=\"normal\" href=\"CastleUIState.TUIState.html\">TUIState</a> classes</i>. See <a  href=\"https://castle-engine.sourceforge.io/manual_2d_user_interface.php#section_ui_state\">https://castle-engine.sourceforge.io/manual_2d_user_interface.php#section_ui_state</a> about how to use <a class=\"normal\" href=\"CastleUIState.TUIState.html\">TUIState</a>. Like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">type</span>   TMyGameState = <span class=\"pascal_keyword\">class</span>(TUIState)   <span class=\"pascal_keyword\">private</span>     DialogAskDeleteFile: TStateDialogYesNo;   <span class=\"pascal_keyword\">public</span>     <span class=\"pascal_keyword\">function</span> Press(<span class=\"pascal_keyword\">const</span> Event: TInputPressRelease): boolean; <span class=\"pascal_keyword\">override</span>;     <span class=\"pascal_keyword\">procedure</span> Resume; <span class=\"pascal_keyword\">override</span>;   <span class=\"pascal_keyword\">end</span>;  <span class=\"pascal_keyword\">function</span> Press(<span class=\"pascal_keyword\">const</span> Event: TInputPressRelease): boolean; <span class=\"pascal_keyword\">override</span>; <span class=\"pascal_keyword\">begin</span>   Result := <span class=\"pascal_keyword\">inherited</span>;   <span class=\"pascal_keyword\">if</span> Result <span class=\"pascal_keyword\">then</span> Exit;    <span class=\"pascal_keyword\">if</span> Event.IsKey(K_Enter) <span class=\"pascal_keyword\">then</span>   <span class=\"pascal_keyword\">begin</span>     DialogAskDeleteFile := TStateDialogYesNo.Create(Self);     DialogAskDeleteFile.Caption := <span class=\"pascal_string\">'Are you sure you want to delete this file?'</span>;     TUIState.Push(DialogAskDeleteFile);   <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;  <span class=\"pascal_keyword\">procedure</span> TStatePlay.Resume; <span class=\"pascal_keyword\">begin</span>   <span class=\"pascal_keyword\">inherited</span>;   <span class=\"pascal_keyword\">if</span> DialogAskDeleteFile &lt;&gt; <span class=\"pascal_keyword\">nil</span> <span class=\"pascal_keyword\">then</span> <span class=\"pascal_comment\">// returning from DialogAskDeleteFile</span>   <span class=\"pascal_keyword\">begin</span>     <span class=\"pascal_keyword\">if</span> DialogAskDeleteFile.Answer <span class=\"pascal_keyword\">then</span>       DeleteFile(<span class=\"pascal_numeric\"></span>...);     FreeAndNil(DialogAskDeleteFile);   <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p> ", "tags": "", "loc": "CastleDialogStates.html"},
     {"title": "CastleDialogStates.TStateDialog", "text": " See unit <a class=\"normal\" href=\"CastleDialogStates.html\">CastleDialogStates</a> documentation for example usage. ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html"},
     {"title": "CastleDialogStates.TStateDialog.DefaultAlignment", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#DefaultAlignment"},
     {"title": "CastleDialogStates.TStateDialog.StateContainer", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#StateContainer"},
     {"title": "CastleDialogStates.TStateDialog.InitializeButtons", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#InitializeButtons"},
     {"title": "CastleDialogStates.TStateDialog.DrawInputText", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#DrawInputText"},
     {"title": "CastleDialogStates.TStateDialog.DoAnswered", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#DoAnswered"},
     {"title": "CastleDialogStates.TStateDialog.Create", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Create"},
     {"title": "CastleDialogStates.TStateDialog.Destroy", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Destroy"},
     {"title": "CastleDialogStates.TStateDialog.Start", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Start"},
     {"title": "CastleDialogStates.TStateDialog.Stop", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Stop"},
     {"title": "CastleDialogStates.TStateDialog.InputText", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#InputText"},
     {"title": "CastleDialogStates.TStateDialog.InterceptInput", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#InterceptInput"},
     {"title": "CastleDialogStates.TStateDialog.Answered", "text": " The state also normally does <a class=\"normal\" href=\"CastleUIState.TUIState.html#Pop\">TUIState.Pop</a>, so there's no need to check this property, unless you set <a class=\"normal\" href=\"CastleDialogStates.TStateDialog.html#PopOnAnswered\">PopOnAnswered</a> to <code>False</code>. ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Answered"},
     {"title": "CastleDialogStates.TStateDialog.Text", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Text"},
     {"title": "CastleDialogStates.TStateDialog.Caption", "text": " This is just a shortcut to get/set <a class=\"normal\" href=\"CastleDialogStates.TStateDialog.html#Text\">Text</a> as a single string.  <p>Use LineEnding or <a class=\"normal\" href=\"CastleUtils.html#NL\">NL</a> constant when setting this to indicate a newline. The two examples below are equivalent:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_comment\">// one way</span> StateDialogOK.Text.Clear; StateDialogOK.Text.Add(<span class=\"pascal_string\">'First line'</span>); StateDialogOK.Text.Add(<span class=\"pascal_string\">'Second line'</span>);  <span class=\"pascal_comment\">// alternative way to do the same</span> StateDialogOK.Caption := <span class=\"pascal_string\">'First line'</span> + LineEnding + <span class=\"pascal_string\">'Second line'</span>;</pre>  <p> ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Caption"},
     {"title": "CastleDialogStates.TStateDialog.Alignment", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Alignment"},
     {"title": "CastleDialogStates.TStateDialog.Html", "text": " See the <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">TCastleFont.PrintStrings</a> for a description of supported <code>HTML</code> constructs. ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Html"},
     {"title": "CastleDialogStates.TStateDialog.Background", "text": "  <p>The obscuring background is defined by <a class=\"normal\" href=\"CastleDialogStates.TStateDialog.html#BackgroundColor\">BackgroundColor</a>. It may be just a solid opaque color. Or it may be a partially-transparent or even completely transparent color, showing the state underneath (or showing the screenshot of the state underneath, if <a class=\"normal\" href=\"CastleDialogStates.TStateDialog.html#BackgroundScreenshot\">BackgroundScreenshot</a>). ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#Background"},
     {"title": "CastleDialogStates.TStateDialog.BackgroundColor", "text": " This color may be partially-transparent (e.g. to visually &quot;dim&quot; the state underneath) or even completely transparent (alpha 0).  <p>Default is Theme.BackgroundColor, which is dark with alpha = 0.5, so it will dim the state underneath. Sometimes (under exception handler) it's Theme.BackgroundOpaqueColor. ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#BackgroundColor"},
     {"title": "CastleDialogStates.TStateDialog.BackgroundScreenshot", "text": " This screenshot is shown, instead of actually rendering the state underneath, under the <a class=\"normal\" href=\"CastleDialogStates.TStateDialog.html#BackgroundColor\">BackgroundColor</a>, when <a class=\"normal\" href=\"CastleDialogStates.TStateDialog.html#Background\">Background</a> is <code>True</code>.  <p>This is less functional (when the user scales the window, the screenshot is stretched too), but is safer: it means that the state underneath does not need to be &quot;renderable&quot; anymore. ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#BackgroundScreenshot"},
     {"title": "CastleDialogStates.TStateDialog.PopOnAnswered", "text": " This is usually most natural. ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#PopOnAnswered"},
     {"title": "CastleDialogStates.TStateDialog.OverrrideContainer", "text": " By default it uses Application.MainWindow. ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#OverrrideContainer"},
     {"title": "CastleDialogStates.TStateDialog.TButtonArray", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialog.html#TButtonArray"},
     {"title": "CastleDialogStates.TStateDialogOK", "text": " See unit <a class=\"normal\" href=\"CastleDialogStates.html\">CastleDialogStates</a> documentation for example usage. ", "tags": "", "loc": "CastleDialogStates.TStateDialogOK.html"},
     {"title": "CastleDialogStates.TStateDialogOK.InitializeButtons", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogOK.html#InitializeButtons"},
     {"title": "CastleDialogStates.TStateDialogOK.Press", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogOK.html#Press"},
     {"title": "CastleDialogStates.TStateDialogYesNo", "text": " See unit <a class=\"normal\" href=\"CastleDialogStates.html\">CastleDialogStates</a> documentation for example usage. ", "tags": "", "loc": "CastleDialogStates.TStateDialogYesNo.html"},
     {"title": "CastleDialogStates.TStateDialogYesNo.InitializeButtons", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogYesNo.html#InitializeButtons"},
     {"title": "CastleDialogStates.TStateDialogYesNo.Press", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogYesNo.html#Press"},
     {"title": "CastleDialogStates.TStateDialogYesNo.Answer", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialogYesNo.html#Answer"},
     {"title": "CastleDialogStates.TStateDialogChoice", "text": " Each choice is shown as a button, user can also press the appropriate character. <a class=\"normal\" href=\"CastleDialogStates.TStateDialogChoice.html#ButtonChars\">ButtonChars</a> length must be always equal to <a class=\"normal\" href=\"CastleDialogStates.TStateDialogChoice.html#ButtonCaptions\">ButtonCaptions</a>. See unit <a class=\"normal\" href=\"CastleDialogStates.html\">CastleDialogStates</a> documentation for example usage. ", "tags": "", "loc": "CastleDialogStates.TStateDialogChoice.html"},
     {"title": "CastleDialogStates.TStateDialogChoice.ButtonCaptions", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialogChoice.html#ButtonCaptions"},
     {"title": "CastleDialogStates.TStateDialogChoice.ButtonChars", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialogChoice.html#ButtonChars"},
     {"title": "CastleDialogStates.TStateDialogChoice.InitializeButtons", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogChoice.html#InitializeButtons"},
     {"title": "CastleDialogStates.TStateDialogChoice.Press", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogChoice.html#Press"},
     {"title": "CastleDialogStates.TStateDialogChoice.Answer", "text": " This is one of the <a class=\"normal\" href=\"CastleDialogStates.TStateDialogChoice.html#ButtonChars\">ButtonChars</a>. ", "tags": "", "loc": "CastleDialogStates.TStateDialogChoice.html#Answer"},
     {"title": "CastleDialogStates.TStateDialogInput", "text": " See unit <a class=\"normal\" href=\"CastleDialogStates.html\">CastleDialogStates</a> documentation for example usage. ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html"},
     {"title": "CastleDialogStates.TStateDialogInput.InitializeButtons", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html#InitializeButtons"},
     {"title": "CastleDialogStates.TStateDialogInput.DrawInputText", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html#DrawInputText"},
     {"title": "CastleDialogStates.TStateDialogInput.Press", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html#Press"},
     {"title": "CastleDialogStates.TStateDialogInput.AllowedChars", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html#AllowedChars"},
     {"title": "CastleDialogStates.TStateDialogInput.MinLength", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html#MinLength"},
     {"title": "CastleDialogStates.TStateDialogInput.MaxLength", "text": " Value of 0 (default) means &quot;no limit&quot;. ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html#MaxLength"},
     {"title": "CastleDialogStates.TStateDialogInput.CanCancel", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html#CanCancel"},
     {"title": "CastleDialogStates.TStateDialogInput.AnswerCancelled", "text": " This is defined only when <a class=\"normal\" href=\"CastleDialogStates.TStateDialog.html#Answered\">Answered</a>. This is possible only if <a class=\"normal\" href=\"CastleDialogStates.TStateDialogInput.html#CanCancel\">CanCancel</a>. ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html#AnswerCancelled"},
     {"title": "CastleDialogStates.TStateDialogInput.Answer", "text": " May be set before starting the state. After the state stopped, if <a class=\"normal\" href=\"CastleDialogStates.TStateDialog.html#Answered\">Answered</a>, then this contains user <code>answer</code>. You should ignore it if <a class=\"normal\" href=\"CastleDialogStates.TStateDialogInput.html#AnswerCancelled\">AnswerCancelled</a>. ", "tags": "", "loc": "CastleDialogStates.TStateDialogInput.html#Answer"},
     {"title": "CastleDialogStates.TStateDialogKey", "text": " See unit <a class=\"normal\" href=\"CastleDialogStates.html\">CastleDialogStates</a> documentation for example usage. ", "tags": "", "loc": "CastleDialogStates.TStateDialogKey.html"},
     {"title": "CastleDialogStates.TStateDialogKey.Press", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogKey.html#Press"},
     {"title": "CastleDialogStates.TStateDialogKey.Answer", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialogKey.html#Answer"},
     {"title": "CastleDialogStates.TStateDialogPressEvent", "text": " See unit <a class=\"normal\" href=\"CastleDialogStates.html\">CastleDialogStates</a> documentation for example usage. ", "tags": "", "loc": "CastleDialogStates.TStateDialogPressEvent.html"},
     {"title": "CastleDialogStates.TStateDialogPressEvent.Press", "text": "    ", "tags": "", "loc": "CastleDialogStates.TStateDialogPressEvent.html#Press"},
     {"title": "CastleDialogStates.TStateDialogPressEvent.Answer", "text": " ", "tags": "", "loc": "CastleDialogStates.TStateDialogPressEvent.html#Answer"},
     {"title": "CastleDownload", "text": " ", "tags": "", "loc": "CastleDownload.html"},
     {"title": "CastleDownload.EDownloadError", "text": " ", "tags": "", "loc": "CastleDownload.EDownloadError.html"},
     {"title": "CastleDownload.ESaveError", "text": " ", "tags": "", "loc": "CastleDownload.ESaveError.html"},
     {"title": "CastleDownload.TTextReaderWriter", "text": " ", "tags": "", "loc": "CastleDownload.TTextReaderWriter.html"},
     {"title": "CastleDownload.TTextReaderWriter.Create", "text": " If AOwnsStream then in destructor we will free given AStream object.    ", "tags": "", "loc": "CastleDownload.TTextReaderWriter.html#Create"},
     {"title": "CastleDownload.TTextReaderWriter.Destroy", "text": "    ", "tags": "", "loc": "CastleDownload.TTextReaderWriter.html#Destroy"},
     {"title": "CastleDownload.TTextReader", "text": " You can read an arbitrary TStream instance, or you can read an URL. Reading from URL supports all kinds of URL protocols supportted by <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a>, including <code>file</code>, <code>http</code> and Android <code>assets</code> (see <a  href=\"http://castle-engine.sourceforge.net/tutorial_network.php\">http://castle-engine.sourceforge.net/tutorial_network.php</a> ).  <p>Includes comfortable <a class=\"normal\" href=\"CastleDownload.TTextReader.html#Readln\">Readln</a> routine to read line by line (lines may be terminated in any OS convention). Includes comfortable <a class=\"normal\" href=\"CastleDownload.TTextReader.html#Read\">Read</a> to read next non-whitespace characters, <a class=\"normal\" href=\"CastleDownload.TTextReader.html#ReadInteger\">ReadInteger</a> to read next integer and such.  <p>Do not use the underlying stream once you started reading it with this class. We will move the position within this stream ourselves. ", "tags": "", "loc": "CastleDownload.TTextReader.html"},
     {"title": "CastleDownload.TTextReader.Create", "text": "    ", "tags": "", "loc": "CastleDownload.TTextReader.html#Create"},
     {"title": "CastleDownload.TTextReader.Readln", "text": " Returned string does not contain any end-of-line characters.    ", "tags": "", "loc": "CastleDownload.TTextReader.html#Readln"},
     {"title": "CastleDownload.TTextReader.Read", "text": " This skips any whitespace (including newlines) we currently see, then reads all non-whitespace characters as far as it can. It does not consume any whitespace characters after the string.  <p>Returns empty string if and only if the stream ended. Otherwise, returns the read non-whitespace characters.    ", "tags": "", "loc": "CastleDownload.TTextReader.html#Read"},
     {"title": "CastleDownload.TTextReader.ReadInteger", "text": " Reads next string of non-whitespace characters, like <a class=\"normal\" href=\"CastleDownload.TTextReader.html#Read\">Read</a>, and then converts it to Integer.  <p>    EConvertError If the next non-whitespace string cannot be converted to Integer. This includes situations when stream ended (<a class=\"normal\" href=\"CastleDownload.TTextReader.html#Read\">Read</a> would return empty string in this case).", "tags": "", "loc": "CastleDownload.TTextReader.html#ReadInteger"},
     {"title": "CastleDownload.TTextReader.ReadSingle", "text": " Reads next string of non-whitespace characters, like <a class=\"normal\" href=\"CastleDownload.TTextReader.html#Read\">Read</a>, and then converts it to Single.  <p>    EConvertError If the next non-whitespace string cannot be converted to Single. This includes situations when stream ended (<a class=\"normal\" href=\"CastleDownload.TTextReader.html#Read\">Read</a> would return empty string in this case).", "tags": "", "loc": "CastleDownload.TTextReader.html#ReadSingle"},
     {"title": "CastleDownload.TTextReader.ReadVector3", "text": "  <p>    EConvertError If one of the components cannot be converted to Single, or when stream ended prematurely.", "tags": "", "loc": "CastleDownload.TTextReader.html#ReadVector3"},
     {"title": "CastleDownload.TTextReader.ReadVector3Single", "text": "    ", "tags": "", "loc": "CastleDownload.TTextReader.html#ReadVector3Single"},
     {"title": "CastleDownload.TTextReader.Eof", "text": "    ", "tags": "", "loc": "CastleDownload.TTextReader.html#Eof"},
     {"title": "CastleDownload.TTextWriter", "text": "  <p>You can write to an arbitrary TStream instance, or you can write to an URL. Writing to an URL supports all URL protocols supportted by <a class=\"normal\" href=\"CastleDownload.html#URLSaveStream\">URLSaveStream</a>, which for now doesn't include much: only <code>file</code> protocol. But it will produce a nice exception message in case of unsupprted URL protocol. ", "tags": "", "loc": "CastleDownload.TTextWriter.html"},
     {"title": "CastleDownload.TTextWriter.Create", "text": "    ", "tags": "", "loc": "CastleDownload.TTextWriter.html#Create"},
     {"title": "CastleDownload.TTextWriter.Write", "text": "    ", "tags": "", "loc": "CastleDownload.TTextWriter.html#Write"},
     {"title": "CastleDownload.TTextWriter.Write", "text": "    ", "tags": "", "loc": "CastleDownload.TTextWriter.html#Write"},
     {"title": "CastleDownload.TTextWriter.Writeln", "text": "    ", "tags": "", "loc": "CastleDownload.TTextWriter.html#Writeln"},
     {"title": "CastleDownload.TTextWriter.Writeln", "text": "    ", "tags": "", "loc": "CastleDownload.TTextWriter.html#Writeln"},
     {"title": "CastleDownload.DefaultEnableNetwork", "text": " ", "tags": "", "loc": "CastleDownload.html#DefaultEnableNetwork"},
     {"title": "CastleDownload.Download", "text": " Returned stream is suitable only for reading, and the initial position is always at the beginning. Overloaded version also returns a MIME type (or '' if unknown).  <p>Any errors are reported by raising exceptions.  <p>A local file URL is always supported, without using any networking library. URL without any protocol is always treated like a local filename (absolute or relative to current dir), so this function can be a drop-in replacement for normal file reading. The MIME type for local files is guessed based on their extension.  <p>A data URI scheme (<a  href=\"http://en.wikipedia.org/wiki/Data_URI_scheme\">http://en.wikipedia.org/wiki/Data_URI_scheme</a>) is also always supported. The MIME type for such content is specified explicitly in URI. TODO: right now, <a class=\"normal\" href=\"CastleDownload.html#soGzip\">soGzip</a> is ignored for data URIs, we never filter them through gunzip.  <p>It also automatically supports protocols to embed script contents: ecmascript, javascript (see VRML and X3D specifications), <a class=\"normal\" href=\"CastleScript.html\">castlescript</a>, kambiscript (see <a  href=\"http://castle-engine.sourceforge.net/castle_script.php\">http://castle-engine.sourceforge.net/castle_script.php</a>), compiled (<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_script_compiled\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_script_compiled</a>). The MIME type for these is implied by the protocol (like &quot;application/javascript&quot; for ecmascript/javascript), and the returned stream simply contains script code.  <p>Set <a class=\"normal\" href=\"CastleDownload.html#EnableNetwork\">EnableNetwork</a> to <code>True</code> to have also support for network protocols. Right now this means only http, handled by FpHttpClient. The MIME type for such content is usually reported by the http server (but if the server doesn't report MIME type, we still try to guess it, looking at URL using <a class=\"normal\" href=\"CastleURIUtils.html#URIMimeType\">URIMimeType</a>).  <p>On Android, URLs that indicate assets (files packaged inside .apk) are also supported, as <code>assets:/my_file.png</code>.  <p>Note if you use a network URL (like <a  href=\"http://\">http://</a>...) and you read from this stream that you make a <b>synchronous downloader</b>. Which means that your application will wait until the data arrives from the Internet. This is why <a  href=\"http://\">http://</a> support is disabled here by default (see <a class=\"normal\" href=\"CastleDownload.html#EnableNetwork\">EnableNetwork</a>). This is sometimes acceptable (e.g. if you're waiting during the &quot;loading&quot; process, and the data just <i>has</i> to be downloaded in order to continue), and it's really easy to use (you just download data exactly the same way like you open a local file). But often you may want to instead use <b>asynchronous downloading</b> &ndash; we plan to implement it by the class TDownload (see comments in <a class=\"normal\" href=\"CastleDownload.html\">CastleDownload</a> code), but it's not ready yet!  <p>    <p>    EDownloadError In case of problems loading from this URL. EFOpenError If case opening the underlying file fails, raised in case of <a  href=\"file://\">file://</a> URLs. EStreamError If case reading the stream fails, raised in case of <a  href=\"file://\">file://</a> URLs. Exception Various TStream classes (used internally by this function) may raise various exceptions in case the stream cannot be created for reading. Right now, we simply let these exceptions to &quot;pass through&quot; from this function (instead of catching and re-raising). So, to be really safe, be ready that this function may raise <i>any</i> Exception class.", "tags": "", "loc": "CastleDownload.html#Download"},
     {"title": "CastleDownload.Download", "text": "    ", "tags": "", "loc": "CastleDownload.html#Download"},
     {"title": "CastleDownload.URLSaveStream", "text": " In other words, perform <i>upload</i>. Right now, this only works for <code>file</code> URLs, and the only advantage it has over manually creating TFileStream is that this accepts URLs.  <p>  <p>    ESaveError In case of problems saving this URL. Exception Various TStream instances (used internally by this function) may raise exceptions in case the stream cannot be created for saving. Right now, we simply let these exceptions to &quot;pass through&quot; from this function (instead of catching and re-raising). So be ready that this function may raise <i>any</i> Exception class.", "tags": "", "loc": "CastleDownload.html#URLSaveStream"},
     {"title": "CastleDownload.CreateReadFileStream", "text": " This gives you a stream most comfortable for reading (buffering means that you can read small, comfortable pieces of it; seeking means you can jump freely to various file positions, back and forward).  <p>On different OSes or even compilers this may require a little different stream, so it's safest to just use this function. For example, traditional Classes.TFileStream doesn't do buffering. Although under Linux, the buffering of file handles is done at kernel level (so everything works fast), on Windows the slowdown is noticeable. This function will always create proper stream descendant, eventually wrapping some standard stream in a buffered stream with full seeking capability.  <p> Instead of this, use <a class=\"normal\" href=\"CastleDownload.html#Download\">CastleDownload.Download</a> with LocalFileInMemory.    ", "tags": "", "loc": "CastleDownload.html#CreateReadFileStream"},
     {"title": "CastleDownload.StreamSaveToFile", "text": "    ", "tags": "", "loc": "CastleDownload.html#StreamSaveToFile"},
     {"title": "CastleDownload.TStreamOption", "text": "  soForceMemoryStream Force result to be a TMemoryStream, with contents fully loaded to the memory, and freely seekable (you can move back and forth within).  Without this option, <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a> may return other streams, for example TFileStream (that may not have good buffering, depending on OS) or TBase64DecodingStream (that may not allow seeking).  <p>Using TMemoryStream means that reading is fast and comfortable, but eats memory and doesn't allow to simultaneously read and process the contents (the file must be fully loaded, e.g. downloaded from the Internet, and ungzipped, before this function returns). So use this option only for files that aren't too big.  <p>For larger files, you usually don't want to use this option, instead wrap result in <a class=\"normal\" href=\"CastleClassUtils.TBufferedReadStream.html\">TBufferedReadStream</a>.  soGzip Filter the contents through gzip decompression.  ", "tags": "", "loc": "CastleDownload.html#TStreamOption"},
     {"title": "CastleDownload.TStreamOptions", "text": " ", "tags": "", "loc": "CastleDownload.html#TStreamOptions"},
     {"title": "CastleDownload.TSaveStreamOption", "text": "  ssoGzip Filter the contents through gzip compression.  ", "tags": "", "loc": "CastleDownload.html#TSaveStreamOption"},
     {"title": "CastleDownload.TSaveStreamOptions", "text": " ", "tags": "", "loc": "CastleDownload.html#TSaveStreamOptions"},
     {"title": "CastleDownload.EnableNetwork", "text": " As all the downloading is blocking for now, this is initially <code>False</code>. If you want to really use the network, change it to <code>True</code>. ", "tags": "", "loc": "CastleDownload.html#EnableNetwork"},
     {"title": "CastleDownload.LogAllLoading", "text": " This allows to easily check e.g. whether the engine is not loading something during the game (which usually badly affects the performance). ", "tags": "", "loc": "CastleDownload.html#LogAllLoading"},
     {"title": "CastleDynLib", "text": " ", "tags": "", "loc": "CastleDynLib.html"},
     {"title": "CastleDynLib.EDynLibError", "text": " ", "tags": "", "loc": "CastleDynLib.EDynLibError.html"},
     {"title": "CastleDynLib.TDynLib", "text": "  <p>I wrote my own class to handle dynamic libraries because:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>I wanted to have <a class=\"normal\" href=\"CastleDynLib.TDynLib.html#Load\">Load</a> and <a class=\"normal\" href=\"CastleDynLib.TDynLib.html#Symbol\">Symbol</a> functions that <i>by default do error checking</i> (and raise necessary exceptions).</p></li>   <li><p>I wanted to have a field <a class=\"normal\" href=\"CastleDynLib.TDynLib.html#SymbolErrorBehaviour\">SymbolErrorBehaviour</a> &mdash; this lets me to specify, <i>once for all subsequent Symbol calls</i>, what error checking I want. Default is to check errors and raise exceptions. There is also a very usefull value reWarnAndContinue: it allows you to run program <i>once</i> and see all symbols that are missing from dynamic library.</p></li>   <li><p>Also, the interface of this is OS-independent and works for both FPC and Delphi, so you can avoid ugly $ifdefs in your code.</p></li> </ul>  <p>  <p>Typical usage:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   ALLibrary: TDynLib = <span class=\"pascal_keyword\">nil</span>; <span class=\"pascal_keyword\">initialization</span>   ALLibrary := TDynLib.Load(<span class=\"pascal_string\">'libopenal.so'</span>);   <span class=\"pascal_comment\">{ ... some calls to ALLibrary.Symbol() ... }</span> <span class=\"pascal_keyword\">finalization</span>   FreeAndNil(ALLibrary); <span class=\"pascal_keyword\">end</span>.</pre>  <p>  <p>It is important that ALLibrary is initialized to nil (actually, writing &quot; = nil&quot; is not necessary for a global variable) and that in finalization you use Free(AndNil). This allows you to exit gracefully if library does not exist on the system and <a class=\"normal\" href=\"CastleDynLib.TDynLib.html#Load\">Load</a> will raise an exception: ALLibrary will stay then as nil and FreeAndNil(ALLibrary) will be a valid NOP. Using FreeAndNil(ALLibrary) instead of ALLibrary.Free is just a good practice. ", "tags": "", "loc": "CastleDynLib.TDynLib.html"},
     {"title": "CastleDynLib.TDynLib.Create", "text": " Usually you will prefer to use <a class=\"normal\" href=\"CastleDynLib.TDynLib.html#Load\">Load</a> method instead of directly calling this constructor.  <p>    ECheckFailed if you supply invalid handle.", "tags": "", "loc": "CastleDynLib.TDynLib.html#Create"},
     {"title": "CastleDynLib.TDynLib.Destroy", "text": "    ", "tags": "", "loc": "CastleDynLib.TDynLib.html#Destroy"},
     {"title": "CastleDynLib.TDynLib.Load", "text": " Returns created <a class=\"normal\" href=\"CastleDynLib.TDynLib.html\">TDynLib</a> instance.  <p>If the library is not found and RaiseExceptionOnError is <code>False</code>, <code>Nil</code> will be returned. If RaiseExceptionOnError is <code>True</code> then <a class=\"normal\" href=\"CastleDynLib.EDynLibError.html\">EDynLibError</a> will be raised in case library is not found. So if RaiseExceptionOnError is <code>True</code>, <code>Nil</code> is never returned.  <p>Note that the default situation prevents from unintentionally ignoring an error and <i>that's good</i>.  <p>    EDynLibError If library not found and RaiseExceptionOnError is <code>True</code>.", "tags": "", "loc": "CastleDynLib.TDynLib.html#Load"},
     {"title": "CastleDynLib.TDynLib.Symbol", "text": " If the symbol doesn't exist, then <a class=\"normal\" href=\"CastleDynLib.TDynLib.html#SymbolErrorBehaviour\">SymbolErrorBehaviour</a> says what happens:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleDynLib.html#seRaise\">seRaise</a> (default), then <a class=\"normal\" href=\"CastleDynLib.EDynLibError.html\">EDynLibError</a> will be raised.</p></li>   <li><p><a class=\"normal\" href=\"CastleDynLib.html#seReturnNil\">seReturnNil</a>, then return <code>Nil</code> (and continue, ignoring error).</p></li>   <li><p><a class=\"normal\" href=\"CastleDynLib.html#seWarnAndReturnNil\">seWarnAndReturnNil</a>, then write warning (using <a class=\"normal\" href=\"CastleUtils.html#WarningWrite\">WarningWrite</a>) and return <code>Nil</code> (and continue, ignoring error).  <p>This is useful for debugging : you can easily open the library and after one run of the program you can see what symbols (that you requested) were missing from the library. This is useful when you have a library but you are not sure whether it is compatible and contains all the symbols that you want.</p></li> </ul>  <p>  <p>    EDynLibError If SymbolName doesn't exist and <a class=\"normal\" href=\"CastleDynLib.TDynLib.html#SymbolErrorBehaviour\">SymbolErrorBehaviour</a> is <a class=\"normal\" href=\"CastleDynLib.html#seRaise\">seRaise</a>.", "tags": "", "loc": "CastleDynLib.TDynLib.html#Symbol"},
     {"title": "CastleDynLib.TDynLib.Name", "text": " In practice, file name of the *.so or *.dylib or *.dll file.  <p>A precise strategy where this library is searched is specific to a platform, see the semantics of SysUtils.LoadLibrary (DynLibs for FPC) call on given OS. ", "tags": "", "loc": "CastleDynLib.TDynLib.html#Name"},
     {"title": "CastleDynLib.TDynLib.SymbolErrorBehaviour", "text": " ", "tags": "", "loc": "CastleDynLib.TDynLib.html#SymbolErrorBehaviour"},
     {"title": "CastleDynLib.InvalidDynLibHandle", "text": " ", "tags": "", "loc": "CastleDynLib.html#InvalidDynLibHandle"},
     {"title": "CastleDynLib.TDynLibHandle", "text": " ", "tags": "", "loc": "CastleDynLib.html#TDynLibHandle"},
     {"title": "CastleDynLib.TDynLibSymbolErrorBehaviour", "text": "  seRaise    seReturnNil    seWarnAndReturnNil   ", "tags": "", "loc": "CastleDynLib.html#TDynLibSymbolErrorBehaviour"},
     {"title": "CastleFacebook", "text": " ", "tags": "", "loc": "CastleFacebook.html"},
     {"title": "CastleFacebook.TFacebook", "text": " Only on iOS now. ", "tags": "", "loc": "CastleFacebook.TFacebook.html"},
     {"title": "CastleFacebook.TFacebook.LoginButton", "text": "    ", "tags": "", "loc": "CastleFacebook.TFacebook.html#LoginButton"},
     {"title": "CastleFileFilters", "text": " ", "tags": "", "loc": "CastleFileFilters.html"},
     {"title": "CastleFileFilters.TFileFilter", "text": " ", "tags": "", "loc": "CastleFileFilters.TFileFilter.html"},
     {"title": "CastleFileFilters.TFileFilter.Create", "text": "    ", "tags": "", "loc": "CastleFileFilters.TFileFilter.html#Create"},
     {"title": "CastleFileFilters.TFileFilter.Destroy", "text": "    ", "tags": "", "loc": "CastleFileFilters.TFileFilter.html#Destroy"},
     {"title": "CastleFileFilters.TFileFilter.Name", "text": " ", "tags": "", "loc": "CastleFileFilters.TFileFilter.html#Name"},
     {"title": "CastleFileFilters.TFileFilter.Patterns", "text": " ", "tags": "", "loc": "CastleFileFilters.TFileFilter.html#Patterns"},
     {"title": "CastleFileFilters.TFileFilterList", "text": " ", "tags": "", "loc": "CastleFileFilters.TFileFilterList.html"},
     {"title": "CastleFileFilters.TFileFilterList.Create", "text": "    ", "tags": "", "loc": "CastleFileFilters.TFileFilterList.html#Create"},
     {"title": "CastleFileFilters.TFileFilterList.AddFilter", "text": "    Name Is a name displayed for for user. Patterns Each string in Patterns is a pattern using * and ? matching characters.  Name Is a name displayed for for user. Patterns Each string in Patterns is a pattern using * and ? matching characters.", "tags": "", "loc": "CastleFileFilters.TFileFilterList.html#AddFilter"},
     {"title": "CastleFileFilters.TFileFilterList.AddFiltersFromString", "text": " Filters are separated by '|' (bar character). Each filter has a name, separated from patterns list also by '|'. If filter name starts with '*', it's set as a default filter. Patterns are separated by ';' (semicolon character).  <p>As you can see, this prevents some special characters from appearing in names and patterns. For maximum flexibility, don't use this function, use <a class=\"normal\" href=\"CastleFileFilters.TFileFilterList.html#AddFilter\">AddFilter</a>.  <p>For example <code>All files (*)|*|All images (*.png;*.jpg)|*.png;*.jpg|PNG images (*.png)|*.png</code>  <p>Not finished pairs of name + pattern at the end of the string are ignored. In particular, empty string is unfinished (actually, it contains an empty Name, and is unfinished because there is no |, so no matching Pattern) so empty string causes no filters to be added.    ", "tags": "", "loc": "CastleFileFilters.TFileFilterList.html#AddFiltersFromString"},
     {"title": "CastleFileFilters.TFileFilterList.DefaultFilter", "text": " ", "tags": "", "loc": "CastleFileFilters.TFileFilterList.html#DefaultFilter"},
     {"title": "CastleFilesUtils", "text": "  <p>Includes functions to help cross-platform programs to know where to read/write files: </p>  <ul class=\"compact_spacing\">   <li><p><a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationConfig\">ApplicationConfig</a> &ndash; user config files</p></li>   <li><p><a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> &ndash; installed program's data files</p></li> </ul>  <p>  <p>Hints about what to use (and what not to use) in a cross-platform applications using Castle Game Engine:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> To get a nice application name, use the <code>ApplicationName</code> function (defined in the standard SysUtils unit for FPC, or <a class=\"normal\" href=\"CastleUtils.html\">CastleUtils</a> unit for Delphi). Every application can customize it by assigning OnGetApplicationName or (often more comfortable) assigning <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#ApplicationName\">ApplicationProperties.ApplicationName</a>. The Castle Game Engine units use it where appropriate. </p></li>   <li><p> Use the <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> for all URLs from which you load your application read-only data. For example, </p>  <pre class=\"longcode\"> MyImage := LoadImage(ApplicationData(<span class=\"pascal_string\">'gui/my_image.png'</span>))</pre>  <p> </p></li>   <li><p> Use the <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationConfig\">ApplicationConfig</a> for all URLs where you save or load the user configuration files, savegames etc. </p></li>   <li><p> Do not try to get the application name, or executable file name, using ParamStr(0). Do not rely on Lazarus Application.ExeName or our own (deprecated) <a class=\"normal\" href=\"CastleFilesUtils.html#ExeName\">ExeName</a>.  <p>The &quot;executable file name&quot; is just not 100% reliably available on all OSes. And in some cases, like Android or iOS, the concept of <i>&quot;executable file name&quot;</i> doesn't even make sense, as your application is a library being called by a higher-level application (written in Java or Objective-C), and it's really an &quot;internal matter&quot; where is the executable file that started it. </p></li>   <li><p> Use <a class=\"normal\" href=\"CastleFindFiles.html\">CastleFindFiles</a> unit to search for files and directories. It nicely works with URLs, has some support for the Android &quot;assets&quot; filesystem, and it has more comfortable API (e.g. searching recursively or not is just a matter of passing a particular flag).  <p>Do not use standard FindFirst/FindNext. </p></li>   <li><p> Read and write all data using streams (TStream) descendants. Open and save these streams using our <a class=\"normal\" href=\"CastleDownload.html\">CastleDownload</a> unit. </p></li> </ul>  <p> ", "tags": "", "loc": "CastleFilesUtils.html"},
     {"title": "CastleFilesUtils.EExeNameNotAvailable", "text": " ", "tags": "", "loc": "CastleFilesUtils.EExeNameNotAvailable.html"},
     {"title": "CastleFilesUtils.ERemoveFailed", "text": " ", "tags": "", "loc": "CastleFilesUtils.ERemoveFailed.html"},
     {"title": "CastleFilesUtils.ExeName", "text": " If it's impossible to obtain, raises exception <a class=\"normal\" href=\"CastleFilesUtils.EExeNameNotAvailable.html\">EExeNameNotAvailable</a>.  <p>Under Windows this is simply ParamStr(0) (and it never raises exception), but under other OSes it's not so simple to obtain (although it's important to note that usually programs under UNIX should not need this, actually).  <p>Internal implementation notes:  <p>Under UNIXes other than Linux I don't know how to obtain this, so e.g. under FreeBSD this will always raise an exception. Under Linux I'm trying to read file /proc/getpid()/exe, this should work under most Linuxes as long as user compiled Linux kernel with /proc support. So under Linux this may work, but still you should be always prepared that it may raise <a class=\"normal\" href=\"CastleFilesUtils.EExeNameNotAvailable.html\">EExeNameNotAvailable</a>.    ", "tags": "", "loc": "CastleFilesUtils.html#ExeName"},
     {"title": "CastleFilesUtils.ProgramName", "text": "  <p> Deprecated, this is equivalent to ApplicationName, and you should just call ApplicationName directly in new code. ApplicationName is included in standard FPC SysUtils unit for FPC, has good default and is easily configurable by callback OnGetApplicationName or our <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#ApplicationName\">ApplicationProperties.ApplicationName</a>. See <a  href=\"http://www.freepascal.org/docs-html/rtl/sysutils/getappconfigdir.html\">http://www.freepascal.org/docs-html/rtl/sysutils/getappconfigdir.html</a> .  <p>This is suitable to show to user. It should also indicate how to run the program, usually it should be the basename of the executable (although we do not depend on it technically). It is used to derive config and data paths for our program, see <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationConfig\">ApplicationConfig</a> and <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a>.    ", "tags": "", "loc": "CastleFilesUtils.html#ProgramName"},
     {"title": "CastleFilesUtils.NormalFileExists", "text": " Detects and returns <code>False</code> for special Windows files like 'con', 'c:\\con', 'c:\\somedir\\con' etc. ('con' is a special device name). For all other files (and other OSes) this function returns the same as FileExists.  <p> Deprecated, since we use URLs everywhere, use <a class=\"normal\" href=\"CastleURIUtils.html#URIFileExists\">URIFileExists</a> to check does file exist.    ", "tags": "", "loc": "CastleFilesUtils.html#NormalFileExists"},
     {"title": "CastleFilesUtils.UserConfigPath", "text": " This is some directory that should be writeable and that is a standard directory under this OS to put user config files. Always returns absolute (not relative) path. Result contains trailing PathDelim.  <p> Deprecated, use <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationConfig\">ApplicationConfig</a> instead.    ", "tags": "", "loc": "CastleFilesUtils.html#UserConfigPath"},
     {"title": "CastleFilesUtils.UserConfigFile", "text": " Always returns absolute (not relative) path.  <p>Returns filename that: </p>  <ul class=\"compact_spacing\">   <li><p>is inside <a class=\"normal\" href=\"CastleFilesUtils.html#UserConfigPath\">UserConfigPath</a></p></li>   <li><p>depends on ApplicationName</p></li>   <li><p>has given Extension. Extension should contain beginning dot. E.g. FExtension = '.ini'. This way you can pass FExtension = '' to have a filename without extension.</p></li> </ul>  <p>  <p> Deprecated, use <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationConfig\">ApplicationConfig</a>(ApplicationName + Extension) instead.    ", "tags": "", "loc": "CastleFilesUtils.html#UserConfigFile"},
     {"title": "CastleFilesUtils.ProgramDataPath", "text": " Returns absolute path, containing trailing PathDelim.  <p> Deprecated, use <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> instead.    ", "tags": "", "loc": "CastleFilesUtils.html#ProgramDataPath"},
     {"title": "CastleFilesUtils.ApplicationConfig", "text": " This always returns a <code><a  href=\"file://\">file://</a>...</code> URL, which is comfortable since our engine operates on URLs most of the time.  <p>Given Path specifies a name of the file (with possible subdirectories) under the user config directory. The Path is a relative URL, so you should always use slashes (regardless of OS), and you can escape characters by %xx. We make sure that the directory (including the subdirectories you specify in Path) exists, creating it if necessary. But we do not create the file. We should have permissions to write inside the given directory (although, as always on multi-process OS, the only 100% way to know if you can write there is to actually try it).  <p>This uses FPC GetAppConfigDir under the hood. Which in turn looks at ApplicationName, and may use OS-specific algorithm to find good config directory, see <a  href=\"http://www.freepascal.org/docs-html/rtl/sysutils/ongetapplicationname.html\">http://www.freepascal.org/docs-html/rtl/sysutils/ongetapplicationname.html</a> . On UNIX this follows XDG Base Directory Specification, see <a  href=\"http://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html\">http://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html</a> (simplifying: looks inside &tilde;/.config/&lt;application-name&gt;/).    ", "tags": "", "loc": "CastleFilesUtils.html#ApplicationConfig"},
     {"title": "CastleFilesUtils.ApplicationData", "text": " This returns URL, which is comfortable since our engine operates on URLs everywhere. On normal desktops systems this will return a <code><a  href=\"file://\">file://</a>...</code> URL. On Android, it will return an URL indicating assets (files packages together inside Android apk) starting with <code>assets:/...</code>.  <p>Given Path specifies a path under the data directory, with possible subdirectories, with possible filename at the end. The Path is a relative URL, so you should always use slashes &quot;/&quot; (regardless of OS), and you can escape characters by %xx. You can use Path = '' to get the URL to whole data directory. Note that files there may be read-only, do not try to write there.  <p>The algorithm to find base data directory (with respect to which Path is resolved) is OS-specific. It looks at ApplicationName, and searches a couple of common locations, using the first location that exists. We try to look first inside user-specific directories, then inside system-wide directories, and as a fallback we use current exe directory (under Windows) or current working directory (under other OSes).  <p>The exact details how we currently look for data directory (specified here so that you know how to install your program):  <p></p>  <dl class=\"paragraph_spacing\">   <dt>Windows</dt>   <dd><p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><code>data</code> subdirectory inside our exe directory, if exists.</p></li>   <li value=\"2\"><p>Last resort fallback: just our exe directory.</p></li> </ol>  <p></p></dd>   <dt>macOS</dt>   <dd><p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><code>Contents/Resources/data</code> subdirectory inside our bundle directory, if we are inside a bundle and such subdirectory exists.</p></li>   <li value=\"2\"><p>Otherwise, algorithm on macOS follows algorithm on other Unixes, see below.</p></li> </ol>  <p></p></dd>   <dt>Android</dt>   <dd><p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>We always return <code>assets:/</code> directory, to read assets from the apk.</p></li> </ol>  <p></p></dd>   <dt>Unix (Linux, macOS, FreeBSD etc.)</dt>   <dd><p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><code>&tilde;/.local/share/</code> + ApplicationName. This is nice user-specific data directory, following the default dictated by <a  href=\"http://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html\">http://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html</a> . If such directory exists, it is returned.  <p>This is checked first, to allow user to always override system-wide installation of a program with his own installation. E.g. consider the situation when an old version of a program is installed system-wide in /usr/local/share/my_program/, but some user (with no access to root account) wants to install a newer version of it for himself. Now he can do it, because &tilde;/.local/share/my_program/ is checked 1st, before system-wide paths.</p></li>   <li value=\"2\"><p><code><a class=\"normal\" href=\"CastleFilesUtils.html#HomePath\">HomePath</a> +'.' +ApplicationName+'.data/'</code>. If such directory exists, it is returned.  <p>This is another location of user-specific data directory, deprecated now. You should instead use more standard <code>&tilde;/.local/share/</code> + ApplicationName.</p></li>   <li value=\"3\"><p><code>'/usr/local/share/' +ApplicationName+ '/'</code>. If such directory exists, it is returned.  <p>This is suitable for system-wide installations without package manager.</p></li>   <li value=\"4\"><p><code>'/usr/share/' +ApplicationName+ '/'</code>. If such directory exists, it is returned.  <p>This is suitable for system-wide installations with package manager.</p></li>   <li value=\"5\"><p><code>data</code> subdirectory of current directory, if exists. Using <code>data</code> subdirectory is usually comfortable, it allows you to separate code from data better.</p></li>   <li value=\"6\"><p>As a last resort, we just return the current directory. So you can just place data files inside the current directory, and if user will run your game from it's own directory &mdash; it will work without any fuss.</p></li> </ol>  <p> </p></dd> </dl>  <p>    ", "tags": "", "loc": "CastleFilesUtils.html#ApplicationData"},
     {"title": "CastleFilesUtils.HomePath", "text": "  <p>Taken from environment variable $HOME, unless it's empty or unset, in which case we take this from Unix user database by real uid. This is what bash does (more-or-less, when home directory does not exist strange things happen), that's what programs should do according to `info libc' and Kambi preferences.    ", "tags": "", "loc": "CastleFilesUtils.html#HomePath"},
     {"title": "CastleFilesUtils.ExpandHomePath", "text": " Expands &tilde; to <a class=\"normal\" href=\"CastleUtils.html#ExclPathDelim\">ExclPathDelim</a>(<a class=\"normal\" href=\"CastleFilesUtils.html#HomePath\">HomePath</a>) under UNIX. Under Windows, does nothing.    ", "tags": "", "loc": "CastleFilesUtils.html#ExpandHomePath"},
     {"title": "CastleFilesUtils.CheckDeleteFile", "text": "  <p>When Warn = <code>False</code> (default) raises an exception on failure, otherwise (when Warn = <code>True</code>) makes only <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> on failure.     ERemoveFailed If delete failed, and Warn = <code>False</code>.", "tags": "", "loc": "CastleFilesUtils.html#CheckDeleteFile"},
     {"title": "CastleFilesUtils.CheckRemoveDir", "text": "  <p>When Warn = <code>False</code> (default) raises an exception on failure, otherwise (when Warn = <code>True</code>) makes only <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> on failure.     ERemoveFailed If delete failed, and Warn = <code>False</code>.", "tags": "", "loc": "CastleFilesUtils.html#CheckRemoveDir"},
     {"title": "CastleFilesUtils.CheckForceDirectories", "text": "    ", "tags": "", "loc": "CastleFilesUtils.html#CheckForceDirectories"},
     {"title": "CastleFilesUtils.CheckCopyFile", "text": "    ", "tags": "", "loc": "CastleFilesUtils.html#CheckCopyFile"},
     {"title": "CastleFilesUtils.CheckRenameFile", "text": "    ", "tags": "", "loc": "CastleFilesUtils.html#CheckRenameFile"},
     {"title": "CastleFilesUtils.RemoveNonEmptyDir", "text": " DirName may but doesn't have to end with PathDelim.  <p>When Warn = <code>False</code> (default) raises an exception on failure, otherwise (when Warn = <code>True</code>) makes only <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> on failure.     ERemoveFailed If delete failed, and Warn = <code>False</code>.", "tags": "", "loc": "CastleFilesUtils.html#RemoveNonEmptyDir"},
     {"title": "CastleFilesUtils.FileNameAutoInc", "text": "  <p>The idea is to start with number = 0 and do <code>Format(FileNamePattern, [number])</code>, until you find non-existing filename. Example filename pattern is <code>screenshot_%d.png</code>, by saving to this filename you're relatively sure that each save goes to a new file. Since we use standard <code>Format</code> function, you can use e.g. <code>screenshot_%04d.png</code> to have a number inside the filename always at least 4 digits long.  <p>Note that it's possible on every OS that some other program, or a second copy of your own program, will write to the filename between <code>FileNameAutoInc</code> determined it doesn't exist and you opened the file. So using this cannot guarantee that you really always write to a new file (use proper file open modes for this).    ", "tags": "", "loc": "CastleFilesUtils.html#FileNameAutoInc"},
     {"title": "CastleFilesUtils.FnameAutoInc", "text": "    ", "tags": "", "loc": "CastleFilesUtils.html#FnameAutoInc"},
     {"title": "CastleFilesUtils.ParentPath", "text": "  <p>Given DirName may be absolute or relative. Given DirName may but doesn't have to include trailing PathDelim. Result is always absolute filename, and contains trailing PathDelim.  <p>Returns the same DirName if there's no parent directory.  <p>When DoExpandDirName = false then it is assumed that DirName already is absolute path. Then this function is pure string-operation (no actual reading of any filesystem info), so it works faster and DirName does not need to exist.    ", "tags": "", "loc": "CastleFilesUtils.html#ParentPath"},
     {"title": "CastleFilesUtils.CombinePaths", "text": " BasePath MUST be an absolute path, on Windows it must contain at least drive specifier (like 'c:'), on Unix it must begin with &quot;/&quot;. RelPath can be relative and can be absolute. If RelPath is absolute, result is RelPath. Else the result is an absolute path calculated by combining RelPath with BasePath.  <p>Usually you should instead operate on URLs and combine them using <a class=\"normal\" href=\"CastleURIUtils.html#CombineURI\">CastleURIUtils.CombineURI</a>.    ", "tags": "", "loc": "CastleFilesUtils.html#CombinePaths"},
     {"title": "CastleFilesUtils.PathFileSearch", "text": " Works with double quotes around components of path list, avoiding this bug: <a  href=\"http://bugs.freepascal.org/view.php?id=19279\">http://bugs.freepascal.org/view.php?id=19279</a>. See <a  href=\"http://www.freepascal.org/docs-html/rtl/sysutils/filesearch.html\">http://www.freepascal.org/docs-html/rtl/sysutils/filesearch.html</a> for original FileSearch docs.  <p>In FPC &gt;= 2.5.1, you should instead use just ExeSearch(Name). It also will use $PATH and avoid double quotes problems on Windows. See <a  href=\"http://bugs.freepascal.org/view.php?id=19282\">http://bugs.freepascal.org/view.php?id=19282</a> and fix on <a  href=\"http://svn.freepascal.org/cgi-bin/viewvc.cgi?view=rev&amp;revision=17717\">http://svn.freepascal.org/cgi-bin/viewvc.cgi?view=rev&amp;revision=17717</a> .    ", "tags": "", "loc": "CastleFilesUtils.html#PathFileSearch"},
     {"title": "CastleFilesUtils.FindExe", "text": " Automatically adds <a class=\"normal\" href=\"CastleUtils.html#ExeExtension\">ExeExtension</a>, so don't add it yourself. On Windows, may also add alternative executable extensions (.com, .bat, .cmd). Searches in $PATH (and, if OS does this, in current directory &mdash; this is standard on Windows but not on Unix). Returns '' (if not found) or absolute filename.    ", "tags": "", "loc": "CastleFilesUtils.html#FindExe"},
     {"title": "CastleFilesUtils.AddExeExtension", "text": " On non-Windows, this is just equal to ExePath + <a class=\"normal\" href=\"CastleUtils.html#ExeExtension\">ExeExtension</a>, which in practice is just equal to ExePath (since <a class=\"normal\" href=\"CastleUtils.html#ExeExtension\">ExeExtension</a> is empty on Unix). But on Windows, this tries to append other extensions (.com, .bat, .cmd, just like <a class=\"normal\" href=\"CastleFilesUtils.html#FindExe\">FindExe</a>), depending on what file exists.    ", "tags": "", "loc": "CastleFilesUtils.html#AddExeExtension"},
     {"title": "CastleFilesUtils.GetTempFileNameCheck", "text": "    ", "tags": "", "loc": "CastleFilesUtils.html#GetTempFileNameCheck"},
     {"title": "CastleFilesUtils.GetTempFileNamePrefix", "text": "    ", "tags": "", "loc": "CastleFilesUtils.html#GetTempFileNamePrefix"},
     {"title": "CastleFilesUtils.FileToString", "text": " MimeType is returned, calculated just like the <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a> function. If AllowStdIn, then URL = '-' (one dash) is treated specially: it means to read contents from standard input (stdin, Input in Pascal).    ", "tags": "", "loc": "CastleFilesUtils.html#FileToString"},
     {"title": "CastleFilesUtils.FileToString", "text": "    ", "tags": "", "loc": "CastleFilesUtils.html#FileToString"},
     {"title": "CastleFilesUtils.StringToFile", "text": "    ", "tags": "", "loc": "CastleFilesUtils.html#StringToFile"},
     {"title": "CastleFilesUtils.ApplicationConfigOverride", "text": " ", "tags": "", "loc": "CastleFilesUtils.html#ApplicationConfigOverride"},
     {"title": "CastleFilesUtils.ApplicationDataOverride", "text": " ", "tags": "", "loc": "CastleFilesUtils.html#ApplicationDataOverride"},
     {"title": "CastleFindFiles", "text": " ", "tags": "", "loc": "CastleFindFiles.html"},
     {"title": "CastleFindFiles.TFileInfo", "text": " ", "tags": "", "loc": "CastleFindFiles.TFileInfo.html"},
     {"title": "CastleFindFiles.TFileInfo.Name", "text": " ", "tags": "", "loc": "CastleFindFiles.TFileInfo.html#Name"},
     {"title": "CastleFindFiles.TFileInfo.AbsoluteName", "text": " For local filesystem paths, this is an absolute filename. For Android asset, this is an absolute path within asset (note that absolute paths within Android assets do <i>not</i> start with slash). It's adviced to use <a class=\"normal\" href=\"CastleFindFiles.TFileInfo.html#URL\">URL</a> field instead of this. ", "tags": "", "loc": "CastleFindFiles.TFileInfo.html#AbsoluteName"},
     {"title": "CastleFindFiles.TFileInfo.URL", "text": " ", "tags": "", "loc": "CastleFindFiles.TFileInfo.html#URL"},
     {"title": "CastleFindFiles.TFileInfo.Directory", "text": " ", "tags": "", "loc": "CastleFindFiles.TFileInfo.html#Directory"},
     {"title": "CastleFindFiles.TFileInfo.Size", "text": " ", "tags": "", "loc": "CastleFindFiles.TFileInfo.html#Size"},
     {"title": "CastleFindFiles.FindFiles", "text": "  <p>  <p>  <p>  <p>  <p>  <p>  <p>  <p>  Path Path URL to search inside. May be absolute or relative. Like everywhere in our engine, it can also be a local filesystem path, although we advice using URLs for everything. May, but doesn't have to, end with slash or PathDelim. Mask Mask of the files to search, may contain wildcards * and ?. PathAndMask Overloaded versions without separate Path and Mask parameters just assume that PathAndMask contain concatenated Path + Mask, separated by any valid path delimiter. FindDirectories Should directories also be found (reported by FileProc). Note that this is completely independent from whether we work recursively (<a class=\"normal\" href=\"CastleFindFiles.html#ffRecursive\">ffRecursive</a> in Options). FileProc Called on each file found. May be <code>Nil</code> (useful if you are only interested in the number of files found, returned by this function). Options A set of options. See <a class=\"normal\" href=\"CastleFindFiles.html#TFindFilesOption\">TFindFilesOption</a> for meaning of each option. How many times FileProc was called, that is: how many files/directories were matching. Useful to report to user how many files were processed, in particular to warn if nothing was processed. Path Path URL to search inside. May be absolute or relative. Like everywhere in our engine, it can also be a local filesystem path, although we advice using URLs for everything. May, but doesn't have to, end with slash or PathDelim. Mask Mask of the files to search, may contain wildcards * and ?. PathAndMask Overloaded versions without separate Path and Mask parameters just assume that PathAndMask contain concatenated Path + Mask, separated by any valid path delimiter. FindDirectories Should directories also be found (reported by FileProc). Note that this is completely independent from whether we work recursively (<a class=\"normal\" href=\"CastleFindFiles.html#ffRecursive\">ffRecursive</a> in Options). FileProc Called on each file found. May be <code>Nil</code> (useful if you are only interested in the number of files found, returned by this function). Options A set of options. See <a class=\"normal\" href=\"CastleFindFiles.html#TFindFilesOption\">TFindFilesOption</a> for meaning of each option.", "tags": "", "loc": "CastleFindFiles.html#FindFiles"},
     {"title": "CastleFindFiles.FindFiles", "text": "    ", "tags": "", "loc": "CastleFindFiles.html#FindFiles"},
     {"title": "CastleFindFiles.FindFiles", "text": "    ", "tags": "", "loc": "CastleFindFiles.html#FindFiles"},
     {"title": "CastleFindFiles.FindFiles", "text": "    ", "tags": "", "loc": "CastleFindFiles.html#FindFiles"},
     {"title": "CastleFindFiles.SearchFileHard", "text": " Path must be absolute URL and contain the final slash. Returns URL relative to Path.  <p>We prefer to return just Base, if it exists, or when no alternative exists. When Base doesn't exist but some likely alternative exists (e.g. with different case), we return it.  <p>Looks for normal files/symlinks, that can be opened as usual files. Not directories.  <p>Returns if some file was found. Note that even when we return <code>False</code>, we still set NewBase (to original Base).    ", "tags": "", "loc": "CastleFindFiles.html#SearchFileHard"},
     {"title": "CastleFindFiles.FindFirstFile", "text": " If found, returns <code>True</code> and sets FileInfo. Otherwise, returns <code>False</code> and leaves FileInfo undefined.    ", "tags": "", "loc": "CastleFindFiles.html#FindFirstFile"},
     {"title": "CastleFindFiles.TFileInfoList", "text": " ", "tags": "", "loc": "CastleFindFiles.html#TFileInfoList"},
     {"title": "CastleFindFiles.TFoundFileProc", "text": " StopSearch is always initially <code>False</code>, you can change it to <code>True</code> to stop the enclosing <a class=\"normal\" href=\"CastleFindFiles.html#FindFiles\">FindFiles</a> call.    ", "tags": "", "loc": "CastleFindFiles.html#TFoundFileProc"},
     {"title": "CastleFindFiles.TFoundFileMethod", "text": "    ", "tags": "", "loc": "CastleFindFiles.html#TFoundFileMethod"},
     {"title": "CastleFindFiles.TFindFilesOption", "text": "  ffRecursive If <code>ffRecursive</code> is in Options then <a class=\"normal\" href=\"CastleFindFiles.html#FindFiles\">FindFiles</a> (and friends) descend into subdirectories.   <p>Note that we always descend into <i>every</i> subdirectory (not only into those matching Mask, that would be pretty useless (and is a problem with Unix shell expansion)).  <p>Note that including <code>ffRecursive</code> in Options is something completely different than the FindDirectories parameter: FindDirectories says whether to report directories to FileProc; <code>ffRecursive</code> says whether to descend into directories and enumerate their files too.  <p>Recursive does <i>not</i> descend into symlinks to directories on Unix right now. The reason is that this would risk an infinite loop (unless some time-consuming precautions would be taken, or a level limit). In other words, it's just not implemented. But it <i>may</i> be implemented someday, as this would be definitely something useful.  <p>For Android asset searching: note that recursive searching if unfortunately not supported. Although Android NDK contains functions to iterate over a files inside a directory, it stupidly omits the subdirectories (only returns the non-directory files).  ffDirContentsLast Determines the order of reporting directory contents.  Meaningfull only if <a class=\"normal\" href=\"CastleFindFiles.html#ffRecursive\">ffRecursive</a> is also included in Options.  <p>If not included, then directory contents (files and directories matching mask) are reported to the callback first. And only then we enter the subdirectories.  <p>If <code>ffDirContentsLast</code> is included, then we first enter subdirectories. Only then we list directory contents to the callback.  ffReadAllFirst If <code>ffReadAllFirst</code> is included in the Options then before calling FileProc, we will first read <i>all</i> file information to an internal array.  And only then we will call FileProc for each item of this array.  <p>Why this may be useful? This way changes to the directory (like renaming / deleting / creating files) will not have any effect on the list of files we will get. This is important if our FileProc may modify the directory contents. Without <code>ffReadAllFirst</code>, it's undefined (OS-dependent and sometimes just random) if the new file names will appear in the directory list. ", "tags": "", "loc": "CastleFindFiles.html#TFindFilesOption"},
     {"title": "CastleFindFiles.TFindFilesOptions", "text": " ", "tags": "", "loc": "CastleFindFiles.html#TFindFilesOptions"},
     {"title": "CastleFlashEffect", "text": " ", "tags": "", "loc": "CastleFlashEffect.html"},
     {"title": "CastleFlashEffect.TCastleFlashEffect", "text": " ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.DefaultDuration", "text": " ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#DefaultDuration"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Create", "text": "    ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Create"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Destroy", "text": "    ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Destroy"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Update", "text": "    ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Update"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Render", "text": "    ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Render"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Rect", "text": "    ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Rect"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.GLContextOpen", "text": "    ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#GLContextOpen"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.GLContextClose", "text": "    ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#GLContextClose"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Flash", "text": "    ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Flash"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Reset", "text": "    ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Reset"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.FullSize", "text": "  <p>When <code>FullSize</code> is <code>True</code> (the default), the effect always fills the whole parent (like <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> or <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a>, if you just placed the <a class=\"normal\" href=\"CastleFlashEffect.TCastleFlashEffect.html\">TCastleFlashEffect</a> on <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a>), and the values of Left, Bottom, Width, Height are ignored.  <p>When <code>FullSize</code> is <code>False</code>, the values of Left, Bottom, Width, Height define the size and position of the rectangle effect.  <p>  <p> ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#FullSize"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Width", "text": " ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Width"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Height", "text": " ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Height"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Duration", "text": " ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Duration"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.Image", "text": " The image is always stretched to cover our whole size. ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#Image"},
     {"title": "CastleFlashEffect.TCastleFlashEffect.OwnsImage", "text": " ", "tags": "", "loc": "CastleFlashEffect.TCastleFlashEffect.html#OwnsImage"},
     {"title": "CastleFont2Pascal", "text": " ", "tags": "", "loc": "CastleFont2Pascal.html"},
     {"title": "CastleFont2Pascal.Font2Pascal", "text": "    ", "tags": "", "loc": "CastleFont2Pascal.html#Font2Pascal"},
     {"title": "CastleFont2Pascal.Font2Pascal", "text": "    ", "tags": "", "loc": "CastleFont2Pascal.html#Font2Pascal"},
     {"title": "CastleFontFamily", "text": " ", "tags": "", "loc": "CastleFontFamily.html"},
     {"title": "CastleFontFamily.TFontFamily", "text": " Used together with <a class=\"normal\" href=\"CastleFontFamily.TRichText.html\">TRichText</a>, that has powerful methods to render and wrap text with HTML elements (&lt;b&gt;, &lt;i&gt; etc. inside). During such processing and rendering, it automatically uses the correct subfont. It's closely tied with the <a class=\"normal\" href=\"CastleFontFamily.TRichText.html\">TRichText</a> class.  <p>For simple operations, it simply uses the subfont indicated by the <a class=\"normal\" href=\"CastleFontFamily.TFontFamily.html#Bold\">Bold</a> and <i><a class=\"normal\" href=\"CastleFontFamily.TFontFamily.html#Italic\">Italic</a></i> properties. By default they are <code>False</code>, and then we simply use <a class=\"normal\" href=\"CastleFontFamily.TFontFamily.html#RegularFont\">RegularFont</a>. This class can be treated as a font itself, since it has all the measuring and rendering commands you expect from a font (and you could even use it as a subfont of another <code>TFontFamily</code> &mdash; weird but works, in which case the &quot;<code>TFontFamily</code> used as a subfont&quot; just acts as a proxy for the Regular subfont).  <p>Similar to <a class=\"normal\" href=\"CastleFonts.TCustomizedFont.html\">TCustomizedFont</a>, it can also change the subfont size. Simply set the <code>Size</code> property of this instance to non-zero to force the specific size of all the underlying subfonts. You can also change the subfont outline, if <a class=\"normal\" href=\"CastleFontFamily.TFontFamily.html#CustomizeOutline\">CustomizeOutline</a> is used. The underlying font properties remain unchanged for subfonts (so they can be still used for other purposes, directly or by other <a class=\"normal\" href=\"CastleFonts.TCustomizedFont.html\">TCustomizedFont</a> or <code>TFontFamily</code> wrappers).  <p><i>Do not get / set the <code>Scale</code> property of this instance</i>, it will not do anything in current implementation and should always stay equal to 1. TODO: remove the Scale property of <a class=\"normal\" href=\"CastleFonts.TCastleFont.html\">TCastleFont</a>, or make it only a protected read-only property? ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html"},
     {"title": "CastleFontFamily.TFontFamily.Notification", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#Notification"},
     {"title": "CastleFontFamily.TFontFamily.Create", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#Create"},
     {"title": "CastleFontFamily.TFontFamily.Destroy", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#Destroy"},
     {"title": "CastleFontFamily.TFontFamily.PrepareResources", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#PrepareResources"},
     {"title": "CastleFontFamily.TFontFamily.Print", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#Print"},
     {"title": "CastleFontFamily.TFontFamily.TextWidth", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#TextWidth"},
     {"title": "CastleFontFamily.TFontFamily.TextHeight", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#TextHeight"},
     {"title": "CastleFontFamily.TFontFamily.TextHeightBase", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#TextHeightBase"},
     {"title": "CastleFontFamily.TFontFamily.TextMove", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#TextMove"},
     {"title": "CastleFontFamily.TFontFamily.RealSize", "text": "    ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#RealSize"},
     {"title": "CastleFontFamily.TFontFamily.RegularFont", "text": " ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#RegularFont"},
     {"title": "CastleFontFamily.TFontFamily.BoldFont", "text": " ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#BoldFont"},
     {"title": "CastleFontFamily.TFontFamily.ItalicFont", "text": " ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#ItalicFont"},
     {"title": "CastleFontFamily.TFontFamily.BoldItalicFont", "text": " ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#BoldItalicFont"},
     {"title": "CastleFontFamily.TFontFamily.Bold", "text": " ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#Bold"},
     {"title": "CastleFontFamily.TFontFamily.Italic", "text": " ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#Italic"},
     {"title": "CastleFontFamily.TFontFamily.CustomizeOutline", "text": " ", "tags": "", "loc": "CastleFontFamily.TFontFamily.html#CustomizeOutline"},
     {"title": "CastleFontFamily.TRichText", "text": " Used to render &quot;rich text&quot;, which is text that may contain (a subset of) HTML.  <p>Note that <code>TRichText</code> instance is always tied to a corresponding <a class=\"normal\" href=\"CastleFontFamily.TFontFamily.html\">TFontFamily</a> used to render it. <b>Through the lifetime of <code>TRichText</code>, we assume that size and other properties of this font remain constant.</b> ", "tags": "", "loc": "CastleFontFamily.TRichText.html"},
     {"title": "CastleFontFamily.TRichText.Create", "text": "    ", "tags": "", "loc": "CastleFontFamily.TRichText.html#Create"},
     {"title": "CastleFontFamily.TRichText.Create", "text": "    ", "tags": "", "loc": "CastleFontFamily.TRichText.html#Create"},
     {"title": "CastleFontFamily.TRichText.Destroy", "text": "    ", "tags": "", "loc": "CastleFontFamily.TRichText.html#Destroy"},
     {"title": "CastleFontFamily.TRichText.Width", "text": "    ", "tags": "", "loc": "CastleFontFamily.TRichText.html#Width"},
     {"title": "CastleFontFamily.TRichText.Wrap", "text": "    ", "tags": "", "loc": "CastleFontFamily.TRichText.html#Wrap"},
     {"title": "CastleFontFamily.TRichText.Print", "text": "    ", "tags": "", "loc": "CastleFontFamily.TRichText.html#Print"},
     {"title": "CastleFontFamily.TRichText.DisplayChars", "text": "    ", "tags": "", "loc": "CastleFontFamily.TRichText.html#DisplayChars"},
     {"title": "CastleFonts", "text": " ", "tags": "", "loc": "CastleFonts.html"},
     {"title": "CastleFonts.TCastleFont", "text": " ", "tags": "", "loc": "CastleFonts.TCastleFont.html"},
     {"title": "CastleFonts.TCastleFont.Create", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Create"},
     {"title": "CastleFonts.TCastleFont.Destroy", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Destroy"},
     {"title": "CastleFonts.TCastleFont.PrintAndMove", "text": " This way you can immediately call another <code>PrintAndMove</code> again, to add something at the end.  <p>It is not adviced to use it, as using the global <a class=\"normal\" href=\"CastleGLUtils.html#WindowPos\">WindowPos</a> leads sooner or later to messy in code, that has to deal with global state. If you need to know how to move after printing text, use <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#TextMove\">TextMove</a>.  <p>May require 1 free slot on the attributes stack. May only be called when current matrix is modelview. Doesn't modify any OpenGL state or matrix, except it moves raster position.    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintAndMove"},
     {"title": "CastleFonts.TCastleFont.Print", "text": " If the last Color component is not 1, the text is rendered with blending.  <p>Overloaded version without X, Y uses <a class=\"normal\" href=\"CastleGLUtils.html#WindowPos\">WindowPos</a> (but doesn't modify it, in contrast to <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintAndMove\">PrintAndMove</a>). Overloaded version without Color uses <a class=\"normal\" href=\"CastleGLUtils.html#CurrentColor\">CurrentColor</a>, last color set by <a class=\"normal\" href=\"CastleGLUtils.html#glColorv\">glColorv</a>. It is not adviced to use overloaded versions without X, Y or Color &mdash; using global state leads to messy code. You should upgrade your code to use the version that gets X,Y,Color explicitly.  <p>May require 1 free slot on the attributes stack. May only be called when current matrix is modelview. Doesn't modify any OpenGL state or matrix, except it moves raster position.    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Print"},
     {"title": "CastleFonts.TCastleFont.Print", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Print"},
     {"title": "CastleFonts.TCastleFont.Print", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Print"},
     {"title": "CastleFonts.TCastleFont.Print", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Print"},
     {"title": "CastleFonts.TCastleFont.PrintRect", "text": "  <p>Hint: Use <a class=\"normal\" href=\"CastleRectangles.TRectangle.html#Grow\">TRectangle.Grow</a>(-10) or similar to align within a rectangle with padding.    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintRect"},
     {"title": "CastleFonts.TCastleFont.PrintRectMultiline", "text": " Newlines within the text will be automatically honored, the text will be rendered as multiple lines. See <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">PrintStrings</a> for description of parameters Html, LineSpacing, TextHorizontalAlignment.    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintRectMultiline"},
     {"title": "CastleFonts.TCastleFont.PrepareResources", "text": " You can explicitly create them using <code>PrepareResources</code> (although it is never needed, resources will be automatically created if needed). There's no public method to explicitly destroy them, they are always destroyed automatically.     ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrepareResources"},
     {"title": "CastleFonts.TCastleFont.TextWidth", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#TextWidth"},
     {"title": "CastleFonts.TCastleFont.TextHeight", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#TextHeight"},
     {"title": "CastleFonts.TCastleFont.TextHeightBase", "text": " This doesn't take into account height of the text below the baseline (for example letter &quot;y&quot; has the tail below the baseline in most fonts).    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#TextHeightBase"},
     {"title": "CastleFonts.TCastleFont.TextMove", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#TextMove"},
     {"title": "CastleFonts.TCastleFont.TextSize", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#TextSize"},
     {"title": "CastleFonts.TCastleFont.RowHeight", "text": " This may be calculated as simply <code><a class=\"normal\" href=\"CastleFonts.TCastleFont.html#TextHeight\">TextHeight</a>('Wy')</code> for most normal fonts.    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#RowHeight"},
     {"title": "CastleFonts.TCastleFont.RowHeightBase", "text": " Similar to <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#TextHeightBase\">TextHeightBase</a> and <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#TextHeight\">TextHeight</a>, note that <code>RowHeightBase</code> is generally smaller than <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#RowHeight\">RowHeight</a>, because <code>RowHeightBase</code> doesn't care how low the letter may go below the baseline.    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#RowHeightBase"},
     {"title": "CastleFonts.TCastleFont.Descend", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Descend"},
     {"title": "CastleFonts.TCastleFont.BreakLines", "text": "  <p>This takes into account current font information (works also for non-monospace fonts, of course), and converts your Unbroken text into Broken text, such that <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#TextWidth\">TextWidth</a> of the longest Broken line fits within MaxLineWidth.  <p>Tries to break on <a class=\"normal\" href=\"CastleColors.html#White\">white</a> characters. If not possible (there's a long stream of non-<a class=\"normal\" href=\"CastleColors.html#White\">white</a> characters that really has to be broken), it will break in the middle of normal (non-<a class=\"normal\" href=\"CastleColors.html#White\">white</a>) characters. The only situation when we have to fail, and the resulting Broken text is wider than required MaxLineWidth, is when <i>a single character in your font</i> is wider than MaxLineWidth. In such case, there's really no solution, and we'll just let such character stay.  <p>If you use the overloaded version where Unbroken is just a string, then note that already existing newlines (<a class=\"normal\" href=\"CastleUtils.html#NL\">NL</a>) inside Unbroken will be correctly preserved.  <p>If you use the overloaded version with separate Unbroken and Broken parameters, then the previous Broken contents are not modified. We only append to Broken new strings, coming from Unbroken text. The overloaded version that takes only Broken parameter (no Unbroken parameter) simply modifies it's Broken parameter (from the line FirstToBreak).  <p>    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#BreakLines"},
     {"title": "CastleFonts.TCastleFont.BreakLines", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#BreakLines"},
     {"title": "CastleFonts.TCastleFont.BreakLines", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#BreakLines"},
     {"title": "CastleFonts.TCastleFont.MaxTextWidth", "text": "  <p>  Html Indicates that strings inside SList use a subset of HTML, the same ones as interpreted by <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">PrintStrings</a>. If your SList uses these elements (for example, you plan to call later <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">PrintStrings</a> with the same SList and Html = <code>True</code>) then make sure you pass Html = <code>True</code> to this method. Otherwise, <code>MaxTextWidth</code> will treat HTML markup (like <code>&lt;font ...&gt;</code>) like a normal text, usually making the width incorrectly large.  Html Indicates that strings inside SList use a subset of HTML, the same ones as interpreted by <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">PrintStrings</a>. If your SList uses these elements (for example, you plan to call later <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">PrintStrings</a> with the same SList and Html = <code>True</code>) then make sure you pass Html = <code>True</code> to this method. Otherwise, <code>MaxTextWidth</code> will treat HTML markup (like <code>&lt;font ...&gt;</code>) like a normal text, usually making the width incorrectly large.", "tags": "", "loc": "CastleFonts.TCastleFont.html#MaxTextWidth"},
     {"title": "CastleFonts.TCastleFont.PrintStrings", "text": "  <p>  <p>  <p>  <p>  <p>  <p>  <p>  X0 The X position of the whole text block. It's exact interpretation depends on TextHorizontalAlignment value. Y0 The bottom position of the whole text block. That is, this is the bottom position of the last string. Color The color of the text. Alpha value of the color is honored, value &lt; 1 renders partially-transparent text.  <p>Overloaded and deprecated versions without explicit Color parameter use <a class=\"normal\" href=\"CastleGLUtils.html#CurrentColor\">CurrentColor</a>. Strs The text to display. Can be given as either TStringList, or a simple array of strings. Html Enable a subset of HTML to mark font changes inside the text. See the example examples/fonts/html_text_demo.html for a demo, supported HTML constructs now are: </p>  <ul class=\"paragraph_spacing\">   <li><p>&lt;b&gt; (bold)</p></li>   <li><p>&lt;i&gt; (italic)</p></li>   <li><p>&lt;font color=&quot;#rrggbb&quot;&gt;, &lt;font color=&quot;#rrggbbaa&quot;&gt; (change color, with or without alpha)</p></li>   <li><p>&lt;font size=&quot;xxx&quot;&gt;, &lt;small&gt; (change size)</p></li>   <li><p>&lt;br&gt; &lt;br/&gt; &lt;br /&gt; &lt;p&gt; (newlines; paragraph makes 2 newlines)</p></li>   <li><p>&amp;amp; &amp;lt; &amp;gt; &amp;apos; &amp;quot; (entities)</p></li>   <li><p>&lt;!&ndash; xxx &ndash;&gt; (comments)</p></li> </ul>  <p> LineSpacing Extra space between lines. Distance between each line is determined by <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#RowHeight\">RowHeight</a> + LineSpacing pixels.  <p>Note that LineSpacing can be &lt; 0 (as well as &gt; 0), this may be sometimes useful if you really want to squeeze more text into the available space. Still, make sure that (<a class=\"normal\" href=\"CastleFonts.TCastleFont.html#RowHeight\">RowHeight</a> + LineSpacing) is &gt; 0.  X0 The X position of the whole text block. It's exact interpretation depends on TextHorizontalAlignment value. Y0 The bottom position of the whole text block. That is, this is the bottom position of the last string. Color The color of the text. Alpha value of the color is honored, value &lt; 1 renders partially-transparent text.  <p>Overloaded and deprecated versions without explicit Color parameter use <a class=\"normal\" href=\"CastleGLUtils.html#CurrentColor\">CurrentColor</a>. Strs The text to display. Can be given as either TStringList, or a simple array of strings. Html Enable a subset of HTML to mark font changes inside the text. See the example examples/fonts/html_text_demo.html for a demo, supported HTML constructs now are: </p>  <ul class=\"paragraph_spacing\">   <li><p>&lt;b&gt; (bold)</p></li>   <li><p>&lt;i&gt; (italic)</p></li>   <li><p>&lt;font color=&quot;#rrggbb&quot;&gt;, &lt;font color=&quot;#rrggbbaa&quot;&gt; (change color, with or without alpha)</p></li>   <li><p>&lt;font size=&quot;xxx&quot;&gt;, &lt;small&gt; (change size)</p></li>   <li><p>&lt;br&gt; &lt;br/&gt; &lt;br /&gt; &lt;p&gt; (newlines; paragraph makes 2 newlines)</p></li>   <li><p>&amp;amp; &amp;lt; &amp;gt; &amp;apos; &amp;quot; (entities)</p></li>   <li><p>&lt;!&ndash; xxx &ndash;&gt; (comments)</p></li> </ul>  <p> LineSpacing Extra space between lines. Distance between each line is determined by <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#RowHeight\">RowHeight</a> + LineSpacing pixels.  <p>Note that LineSpacing can be &lt; 0 (as well as &gt; 0), this may be sometimes useful if you really want to squeeze more text into the available space. Still, make sure that (<a class=\"normal\" href=\"CastleFonts.TCastleFont.html#RowHeight\">RowHeight</a> + LineSpacing) is &gt; 0.", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintStrings"},
     {"title": "CastleFonts.TCastleFont.PrintStrings", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintStrings"},
     {"title": "CastleFonts.TCastleFont.PrintStrings", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintStrings"},
     {"title": "CastleFonts.TCastleFont.PrintStrings", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintStrings"},
     {"title": "CastleFonts.TCastleFont.PrintBrokenString", "text": " The string is broken into many lines using <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#BreakLines\">BreakLines</a>, so the original newlines insides are correctly used, and the length of lines fits inside MaxLineWidth.  <p>The strings are printed on the screen, just like by <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">PrintStrings</a>. If PositionsFirst then the X0, Y0 determine the position of the first (top) line, otherwise they determine the position of the last (bottom) line.  <p>LineSpacing has the same meaning as for <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PrintStrings\">PrintStrings</a>: it adds an additional space between lines (if positive) or forces the lines to be more tightly squeezed (if negative). Always make sure that (<a class=\"normal\" href=\"CastleFonts.TCastleFont.html#RowHeight\">RowHeight</a> + LineSpacing) &gt; 0.  <p>Returns the number of lines printed, that is the number of lines after breaking the text into lines. This may be useful e.g. to calculate the height of the printed text.  <p>May require 1 free slot on the attributes stack. May only be called when current matrix is modelview. Doesn't modify any OpenGL state or matrix.  <p>Overloaded and deprecated version without explicit Color parameter uses <a class=\"normal\" href=\"CastleGLUtils.html#CurrentColor\">CurrentColor</a>.  <p>Overloaded version that takes rectangle as a parameter can align the resulting string box within the rectangle.  <p>    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintBrokenString"},
     {"title": "CastleFonts.TCastleFont.PrintBrokenString", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintBrokenString"},
     {"title": "CastleFonts.TCastleFont.PrintBrokenString", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PrintBrokenString"},
     {"title": "CastleFonts.TCastleFont.PushProperties", "text": " Saves: <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Scale\">Scale</a> (synchronized with <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Size\">Size</a>), <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Outline\">Outline</a>, <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#OutlineColor\">OutlineColor</a>, <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#OutlineHighQuality\">OutlineHighQuality</a>, <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#TargetImage\">TargetImage</a>.    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PushProperties"},
     {"title": "CastleFonts.TCastleFont.PopProperties", "text": "    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#PopProperties"},
     {"title": "CastleFonts.TCastleFont.RealSize", "text": " Usually same thing as <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Size\">Size</a>, but in case of proxy font classes (like <a class=\"normal\" href=\"CastleFonts.TCustomizedFont.html\">TCustomizedFont</a>) it makes sure to never return zero (which, in case of font proxies, means &quot;use underlying font size&quot;).    ", "tags": "", "loc": "CastleFonts.TCastleFont.html#RealSize"},
     {"title": "CastleFonts.TCastleFont.Scale", "text": " ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Scale"},
     {"title": "CastleFonts.TCastleFont.Size", "text": " Underneath, it scales the font using <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Scale\">Scale</a> property, to adjust it to requested size. ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Size"},
     {"title": "CastleFonts.TCastleFont.Outline", "text": " Note that the current implementation is very simple, it will only look sensible for small outline values (like 1 or 2).  <p>TOO: Note that outline size, in pixels, is <b>right now</b> not scaled by font scale. Which may be sensible (this way you can change font &quot;base size&quot; when generating texture freely, as long as you always set font <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Size\">Size</a> in your code explicitly, and things will keep looking the same &mdash; bacause Scale only matters as a multiplier of original &quot;base size&quot;). It also helps our poor outline implementation &mdash; it may look bad at non-integer values. But it has disadvantages: UI scaling (<a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">TUIContainer.UIScaling</a>) doesn't affect outline size now. This will be fixed in the future, please speak up on Castle Game Engine forum if interested.  <p> ", "tags": "", "loc": "CastleFonts.TCastleFont.html#Outline"},
     {"title": "CastleFonts.TCastleFont.OutlineHighQuality", "text": " Used only if Outline &lt;&gt; 0. High quality outline looks better, but is about 2x more expensive to draw.  ", "tags": "", "loc": "CastleFonts.TCastleFont.html#OutlineHighQuality"},
     {"title": "CastleFonts.TCastleFont.OutlineColor", "text": " Default is <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>.  ", "tags": "", "loc": "CastleFonts.TCastleFont.html#OutlineColor"},
     {"title": "CastleFonts.TCastleFont.TargetImage", "text": " Usually (when this is <code>Nil</code>) our rendering routines render to the screen (or the current FBO, if you use <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html\">TGLRenderToTexture</a>). By setting this to non-nil, you make the rendering by done on CPU (without libraries like OpenGL/OpenGLES), and the text is drawn on the given image.  <p>The <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PushProperties\">PushProperties</a> and <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#PopProperties\">PopProperties</a> methods save/restore this.  <p><b>TODO: Font scaling is not done when drawing font to an image.</b> So leave the <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Scale\">Scale</a> at 1 and don't touch the <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Size\">Size</a> if you plan on rendering to image. Also, when using HTML tags, do not change the font size by them. Otherwise <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#TextWidth\">TextWidth</a> / <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#TextHeight\">TextHeight</a> will be unsynchronized with what <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Print\">Print</a> actually does &mdash; so not only your font will remain constant size, also it will overlap with itself. This may get fixed one day &mdash; TCastleImage.Draw just needs to support scaling. ", "tags": "", "loc": "CastleFonts.TCastleFont.html#TargetImage"},
     {"title": "CastleFonts.TTextureFont", "text": "  <p>This can load a font file, or it can use ready data in <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html\">TTextureFontData</a>. The latter allows to use this for fonts embedded in a Pascal source code, since our texture-font-to-pascal can convert a font ttf to a unit that defines ready <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html\">TTextureFontData</a> instance. ", "tags": "", "loc": "CastleFonts.TTextureFont.html"},
     {"title": "CastleFonts.TTextureFont.Create", "text": " If you construct font this way, <b>you must call <a class=\"normal\" href=\"CastleFonts.TTextureFont.html#Load\">Load</a> before doing anything else with the font</b>.    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#Create"},
     {"title": "CastleFonts.TTextureFont.Destroy", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#Destroy"},
     {"title": "CastleFonts.TTextureFont.Create", "text": "  <p>Providing charaters list as <code>Nil</code> means that we only create glyphs for <a class=\"normal\" href=\"CastleStringUtils.html#SimpleAsciiCharacters\">SimpleAsciiCharacters</a>, which includes only the basic ASCII characters. The ACharacters instance <i>does not</i> become owned by this object, so remember to free it after calling this constructor.    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#Create"},
     {"title": "CastleFonts.TTextureFont.Load", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#Load"},
     {"title": "CastleFonts.TTextureFont.Create", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#Create"},
     {"title": "CastleFonts.TTextureFont.Create", "text": "    Data <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html\">TTextureFontData</a> instance containing loaded image and glyphs parameters. OwnsData If <code>True</code>, the Data instance becomes owned by this class (will be freed in our constructor). Usually you <i>do not</i> want this, since usually you pass Data from a unit generated by texture-font-to-pascal. In this case, the finalization of CastleTextureFont_Xxx unit will already free the <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html\">TTextureFontData</a> instance.  Data <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html\">TTextureFontData</a> instance containing loaded image and glyphs parameters. OwnsData If <code>True</code>, the Data instance becomes owned by this class (will be freed in our constructor). Usually you <i>do not</i> want this, since usually you pass Data from a unit generated by texture-font-to-pascal. In this case, the finalization of CastleTextureFont_Xxx unit will already free the <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html\">TTextureFontData</a> instance.", "tags": "", "loc": "CastleFonts.TTextureFont.html#Create"},
     {"title": "CastleFonts.TTextureFont.Load", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#Load"},
     {"title": "CastleFonts.TTextureFont.PrepareResources", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#PrepareResources"},
     {"title": "CastleFonts.TTextureFont.Print", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#Print"},
     {"title": "CastleFonts.TTextureFont.TextWidth", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#TextWidth"},
     {"title": "CastleFonts.TTextureFont.TextHeight", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#TextHeight"},
     {"title": "CastleFonts.TTextureFont.TextHeightBase", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#TextHeightBase"},
     {"title": "CastleFonts.TTextureFont.TextMove", "text": "    ", "tags": "", "loc": "CastleFonts.TTextureFont.html#TextMove"},
     {"title": "CastleFonts.TSimpleTextureFont", "text": "  <p>This class has some assumptions about how the font image looks like: the characters are drawn in ASCII order, starting from space, on an image. Derive your own descendants of <a class=\"normal\" href=\"CastleFonts.TCastleFont.html\">TCastleFont</a> to have more flexibility, see the implementation of this class &mdash; it is quite simple. Or use <a class=\"normal\" href=\"CastleFonts.TTextureFont.html\">TTextureFont</a> that can read data from a FreeType (like ttf) font file.  <p>See e.g. castle_game_engine/examples/fonts/data/sonic_asalga_0.png how to prepare an image for use with such font. You can find more such fonts on the Internet, see e.g. <a  href=\"http://opengameart.org/content/sonic-font\">http://opengameart.org/content/sonic-font</a> and <a  href=\"http://opengameart.org/content/null-terminator\">http://opengameart.org/content/null-terminator</a>. ", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html"},
     {"title": "CastleFonts.TSimpleTextureFont.Create", "text": "    ", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html#Create"},
     {"title": "CastleFonts.TSimpleTextureFont.Destroy", "text": "    ", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html#Destroy"},
     {"title": "CastleFonts.TSimpleTextureFont.Load", "text": "     AImage Image data, becomes owned by this class. ACharMargin There is a margin in the image between rows and cols. ACharDisplayMargin We can display some spacing between characters. This is independent from CharMargin and image contents.  AImage Image data, becomes owned by this class. ACharMargin There is a margin in the image between rows and cols. ACharDisplayMargin We can display some spacing between characters. This is independent from CharMargin and image contents.", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html#Load"},
     {"title": "CastleFonts.TSimpleTextureFont.PrepareResources", "text": "    ", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html#PrepareResources"},
     {"title": "CastleFonts.TSimpleTextureFont.Print", "text": "    ", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html#Print"},
     {"title": "CastleFonts.TSimpleTextureFont.TextWidth", "text": "    ", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html#TextWidth"},
     {"title": "CastleFonts.TSimpleTextureFont.TextHeight", "text": "    ", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html#TextHeight"},
     {"title": "CastleFonts.TSimpleTextureFont.TextHeightBase", "text": "    ", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html#TextHeightBase"},
     {"title": "CastleFonts.TSimpleTextureFont.TextMove", "text": "    ", "tags": "", "loc": "CastleFonts.TSimpleTextureFont.html#TextMove"},
     {"title": "CastleFonts.TCustomizedFont", "text": " Simply set the <code>Size</code> property of this instance to non-zero to force the specific size.  <p>The underlying font properties remain unchanged (so it can be still used for other purposes, directly or by other <code>TCustomizedFont</code> wrappers).  <p><i>Do not get / set the <code>Scale</code> property of this instance</i>, it will not do anything in current implementation and should always stay equal to 1. ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html"},
     {"title": "CastleFonts.TCustomizedFont.Notification", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#Notification"},
     {"title": "CastleFonts.TCustomizedFont.Create", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#Create"},
     {"title": "CastleFonts.TCustomizedFont.Destroy", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#Destroy"},
     {"title": "CastleFonts.TCustomizedFont.PrepareResources", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#PrepareResources"},
     {"title": "CastleFonts.TCustomizedFont.Print", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#Print"},
     {"title": "CastleFonts.TCustomizedFont.TextWidth", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#TextWidth"},
     {"title": "CastleFonts.TCustomizedFont.TextHeight", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#TextHeight"},
     {"title": "CastleFonts.TCustomizedFont.TextHeightBase", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#TextHeightBase"},
     {"title": "CastleFonts.TCustomizedFont.TextMove", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#TextMove"},
     {"title": "CastleFonts.TCustomizedFont.RealSize", "text": "    ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#RealSize"},
     {"title": "CastleFonts.TCustomizedFont.SourceFont", "text": " ", "tags": "", "loc": "CastleFonts.TCustomizedFont.html#SourceFont"},
     {"title": "CastleFonts.TGLBitmapFontAbstract", "text": " ", "tags": "", "loc": "CastleFonts.html#TGLBitmapFontAbstract"},
     {"title": "CastleFonts.TGLBitmapFont", "text": " ", "tags": "", "loc": "CastleFonts.html#TGLBitmapFont"},
     {"title": "CastleFonts.EFreeTypeLibraryNotFound", "text": " ", "tags": "", "loc": "CastleFonts.html#EFreeTypeLibraryNotFound"},
     {"title": "CastleFrustum", "text": " ", "tags": "", "loc": "CastleFrustum.html"},
     {"title": "CastleFrustum.TFrustum", "text": " Calculating and operating on such frustum. Frustums with far plane in infinity (typically used in conjunction with shadow volumes) are fully supported by all methods (we just have 5 frustum planes then).  <p>We define this using ObjectPascal old-style &quot;object&quot;, to have comfort and low-overhead at the same time. ", "tags": "", "loc": "CastleFrustum.TFrustum.html"},
     {"title": "CastleFrustum.TFrustum.Planes", "text": " Direction vectors of these planes must point to the inside of the frustum. Currently, they are always normalized.  <p>Note that if projection has far plane in infinity (indicated by <a class=\"normal\" href=\"CastleFrustum.TFrustum.html#ZFarInfinity\">ZFarInfinity</a>) then the far plane will be invalid &mdash; first three values of it's equation will be 0. ", "tags": "", "loc": "CastleFrustum.TFrustum.html#Planes"},
     {"title": "CastleFrustum.TFrustum.ZFarInfinity", "text": " ", "tags": "", "loc": "CastleFrustum.TFrustum.html#ZFarInfinity"},
     {"title": "CastleFrustum.TFrustum.Init", "text": "    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#Init"},
     {"title": "CastleFrustum.TFrustum.Init", "text": " This is equivalent to 1-parameter Init with Matrix = ModelviewMatrix * <a class=\"normal\" href=\"CastleGLUtils.html#ProjectionMatrix\">ProjectionMatrix</a>. This way you can get from OpenGL your two matrices (modelview and projection) (or you can calculate them using routines like <a class=\"normal\" href=\"CastleProjection.html#FrustumProjectionMatrix\">FrustumProjectionMatrix</a>), then pass them to this routine and you get your current viewing frustum.    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#Init"},
     {"title": "CastleFrustum.TFrustum.CalculatePoints", "text": " These points are simply calculated doing <a class=\"normal\" href=\"CastleVectors.html#ThreePlanesIntersectionPoint\">ThreePlanesIntersectionPoint</a> on appropriate planes.  <p>Using these points you can easily draw given frustum on screen. Use <a class=\"normal\" href=\"CastleFrustum.html#FrustumPointsQuadsIndexes\">FrustumPointsQuadsIndexes</a> to obtain indexes to FrustumPoints.  <p>Note that when the far plane is in infinity, the 4 points of the far plane will be &quot;in infinity&quot;, that is will have 4th component set to zero. Or, equivalently, they will be directions. Homogeneous coordinates allow us for this, and in fact you can just render such points without any problems in OpenGL.  <p>    EPlanesParallel If Frustum doesn't have planes of any valid frustum.", "tags": "", "loc": "CastleFrustum.TFrustum.html#CalculatePoints"},
     {"title": "CastleFrustum.TFrustum.CalculatePoints", "text": "    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#CalculatePoints"},
     {"title": "CastleFrustum.TFrustum.SphereCollisionPossible", "text": "  <p>Check is done fast, but is not accurate, that's why this function's name contains &quot;CollisionPossible&quot;. It returns:  <p><a class=\"normal\" href=\"CastleFrustum.html#fcNoCollision\">fcNoCollision</a> when it's sure that there no collision,  <p><a class=\"normal\" href=\"CastleFrustum.html#fcSomeCollisionPossible\">fcSomeCollisionPossible</a> when some collision is possible, but nothing is sure. There *probably* is some collision, but it's not difficult to find some special situations where there is no collision but this function answers <a class=\"normal\" href=\"CastleFrustum.html#fcSomeCollisionPossible\">fcSomeCollisionPossible</a>. There actually may be either no collision, or only part of sphere may be inside frustum.  <p>Note that it's guaranteed that if the whole sphere (or the whole box in case of <a class=\"normal\" href=\"CastleFrustum.TFrustum.html#Box3DCollisionPossible\">Box3DCollisionPossible</a>) is inside the frustum that <a class=\"normal\" href=\"CastleFrustum.html#fcInsideFrustum\">fcInsideFrustum</a> will be returned, not <a class=\"normal\" href=\"CastleFrustum.html#fcSomeCollisionPossible\">fcSomeCollisionPossible</a>.  <p><a class=\"normal\" href=\"CastleFrustum.html#fcInsideFrustum\">fcInsideFrustum</a> if sphere is for sure inside the frustum.  <p>So this function usually cannot be used for some precise collision detection, but it can be used for e.g. optimizing your graphic engine by doing frustum culling. Note that <a class=\"normal\" href=\"CastleFrustum.html#fcInsideFrustum\">fcInsideFrustum</a> result is often useful when you're comparing your frustum with bounding volume of some tree (e.g. octree) node: <a class=\"normal\" href=\"CastleFrustum.html#fcInsideFrustum\">fcInsideFrustum</a> tells you that not only this node collides with frustum, but also all it's children nodes collide for sure with frustum. This allows you to save some time instead of doing useless recursion down the tree.  <p>Many useful optimization ideas used in implementing this function were found at [<a  href=\"http://www.flipcode.com/articles/article_frustumculling.shtml\">http://www.flipcode.com/articles/article_frustumculling.shtml</a>].  <p>    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#SphereCollisionPossible"},
     {"title": "CastleFrustum.TFrustum.SphereCollisionPossibleSimple", "text": " Like <a class=\"normal\" href=\"CastleFrustum.TFrustum.html#SphereCollisionPossible\">TFrustum.SphereCollisionPossible</a>, but this only returns true (when <a class=\"normal\" href=\"CastleFrustum.TFrustum.html#SphereCollisionPossible\">TFrustum.SphereCollisionPossible</a> would return <a class=\"normal\" href=\"CastleFrustum.html#fcSomeCollisionPossible\">fcSomeCollisionPossible</a> or <a class=\"normal\" href=\"CastleFrustum.html#fcInsideFrustum\">fcInsideFrustum</a>) or false (when <a class=\"normal\" href=\"CastleFrustum.TFrustum.html#SphereCollisionPossible\">TFrustum.SphereCollisionPossible</a> would return <a class=\"normal\" href=\"CastleFrustum.html#fcNoCollision\">fcNoCollision</a>).  <p>Consequently, it runs (very slightly) faster. Use this if you don't need to differentiate between <a class=\"normal\" href=\"CastleFrustum.html#fcSomeCollisionPossible\">fcSomeCollisionPossible</a> or <a class=\"normal\" href=\"CastleFrustum.html#fcInsideFrustum\">fcInsideFrustum</a> cases.    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#SphereCollisionPossibleSimple"},
     {"title": "CastleFrustum.TFrustum.Box3DCollisionPossible", "text": " Meaning of return value like <a class=\"normal\" href=\"CastleFrustum.TFrustum.html#SphereCollisionPossible\">SphereCollisionPossible</a>.    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#Box3DCollisionPossible"},
     {"title": "CastleFrustum.TFrustum.Box3DCollisionPossibleSimple", "text": " Meaning of return value like <a class=\"normal\" href=\"CastleFrustum.TFrustum.html#SphereCollisionPossibleSimple\">SphereCollisionPossibleSimple</a>.    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#Box3DCollisionPossibleSimple"},
     {"title": "CastleFrustum.TFrustum.Move", "text": "    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#Move"},
     {"title": "CastleFrustum.TFrustum.MoveVar", "text": "    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#MoveVar"},
     {"title": "CastleFrustum.TFrustum.DirectionInside", "text": " You can think of direction it as a &quot;point infinitely away in given Direction&quot;, like the direction to the sun. Note that this ignores near/far planes of the frustum, only checking the 4 side planes.    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#DirectionInside"},
     {"title": "CastleFrustum.TFrustum.Transform", "text": "  <p>  <p>  M Transformation matrix. This matrix must be &quot;sane&quot;: it must transform homogeneous positions into homogeneous positions, and homogeneous directions into homogeneous directions. Also, it must not invert or do other weird stuff (like shear) with directions. To be safe just make sure it's a matrix composed only from translations, rotations, and scale (with all scale parameters being &gt; 0).  ETransformedResultInvalid In some cases when matrix is not sane.", "tags": "", "loc": "CastleFrustum.TFrustum.html#Transform"},
     {"title": "CastleFrustum.TFrustum.ToNiceStr", "text": "    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#ToNiceStr"},
     {"title": "CastleFrustum.TFrustum.ToString", "text": "    ", "tags": "", "loc": "CastleFrustum.TFrustum.html#ToString"},
     {"title": "CastleFrustum.FrustumPointsQuadsIndexes", "text": " ", "tags": "", "loc": "CastleFrustum.html#FrustumPointsQuadsIndexes"},
     {"title": "CastleFrustum.FrustumPointsLinesIndexes", "text": "  <p>It's guaranteed that the first 4 items touch only the first 4 (near plane) points of the frustum &mdash; useful if you want to draw only the near plane rect. For <a class=\"normal\" href=\"CastleProjection.html#ZFarInfinity\">ZFarInfinity</a>, other points may be in infinity. ", "tags": "", "loc": "CastleFrustum.html#FrustumPointsLinesIndexes"},
     {"title": "CastleFrustum.TFrustumPlane", "text": "  <p>(This order is the same as the order of params to procedure <a class=\"normal\" href=\"CastleProjection.html#FrustumProjectionMatrix\">FrustumProjectionMatrix</a> and OpenGL's glFrustum routine. Article [<a  href=\"http://www2.ravensoft.com/users/ggribb/plane%20extraction.pdf\">http://www2.ravensoft.com/users/ggribb/plane%20extraction.pdf</a>] has swapped bottom and top positions).  fpLeft    fpRight    fpBottom    fpTop    fpNear    fpFar   ", "tags": "", "loc": "CastleFrustum.html#TFrustumPlane"},
     {"title": "CastleFrustum.TFrustumPoints", "text": " ", "tags": "", "loc": "CastleFrustum.html#TFrustumPoints"},
     {"title": "CastleFrustum.TFrustumPointsSingle", "text": " ", "tags": "", "loc": "CastleFrustum.html#TFrustumPointsSingle"},
     {"title": "CastleFrustum.TFrustumPointsDouble", "text": " ", "tags": "", "loc": "CastleFrustum.html#TFrustumPointsDouble"},
     {"title": "CastleFrustum.TFrustumCollisionPossible", "text": "  fcNoCollision    fcSomeCollisionPossible    fcInsideFrustum   ", "tags": "", "loc": "CastleFrustum.html#TFrustumCollisionPossible"},
     {"title": "CastleFrustum.PFrustum", "text": " ", "tags": "", "loc": "CastleFrustum.html#PFrustum"},
     {"title": "CastleGameNotifications", "text": " It also captures <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> calls of <code>writeln()</code>, to display them as notifications. ", "tags": "", "loc": "CastleGameNotifications.html"},
     {"title": "CastleGameNotifications.Notifications", "text": " ", "tags": "", "loc": "CastleGameNotifications.html#Notifications"},
     {"title": "CastleGameService", "text": " ", "tags": "", "loc": "CastleGameService.html"},
     {"title": "CastleGameService.TGameService", "text": " This integrates with  <p></p>  <ul class=\"compact_spacing\">   <li><p>Google Play Games on Android</p></li>   <li><p>Apple Game Center on iOS.</p></li> </ul>  <p>  <p>Usage:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Include the necessary integration code in your Android / iOS project.  <p>For Android, declare your project type as &quot;integrated&quot; and add the &quot;google_play_games&quot; service inside CastleEngineManifest.xml. See <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> .  <p>For iOS, add the &quot;apple_game_center&quot; service inside CastleEngineManifest.xml. See <a  href=\"https://github.com/castle-engine/castle-engine/wiki/iOS-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/iOS-Project-Services-Integrated-with-Castle-Game-Engine</a> .  <p>Build your project with the Castle Game Engine build tool: <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Build-Tool\">https://github.com/castle-engine/castle-engine/wiki/Build-Tool</a> .</p></li>   <li value=\"2\"><p>Create an instance of this class. Only a single instance of this class is allowed.</p></li>   <li value=\"3\"><p>Call <a class=\"normal\" href=\"CastleGameService.TGameService.html#Initialize\">TGameService.Initialize</a>. You usually do it from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>. The <a class=\"normal\" href=\"CastleGameService.TGameService.html#Initialize\">TGameService.Initialize</a> must be called before calling any other method of this class.</p></li>   <li value=\"4\"><p>Use this to manage achievements, leaderboards and so on.</p></li>   <li value=\"5\"><p>The user must be &quot;signed in&quot; to the game service.  <p>The methods that display some user-interface will automatically attempt to sign-in the user if needed. These include <a class=\"normal\" href=\"CastleGameService.TGameService.html#ShowAchievements\">ShowAchievements</a>, <a class=\"normal\" href=\"CastleGameService.TGameService.html#ShowLeaderboard\">ShowLeaderboard</a>, <a class=\"normal\" href=\"CastleGameService.TGameService.html#ShowSaveGames\">ShowSaveGames</a>. So you don't have to do anything before you call them.  <p>All other methods will <i>not sign-in the user automatically</i>. For example, <a class=\"normal\" href=\"CastleGameService.TGameService.html#Achievement\">Achievement</a> or <a class=\"normal\" href=\"CastleGameService.TGameService.html#SubmitScore\">SubmitScore</a> or <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameLoad\">SaveGameLoad</a> or <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameSave\">SaveGameSave</a>. You should always make sure that the user is signed-in before calling them. To do this, pass AutoStartSignInFlow parameter as <code>True</code> to <a class=\"normal\" href=\"CastleGameService.TGameService.html#Initialize\">Initialize</a> or call the <a class=\"normal\" href=\"CastleGameService.TGameService.html#RequestSignedIn\">RequestSignedIn(true)</a>. And then wait for the <a class=\"normal\" href=\"CastleGameService.TGameService.html#Status\">Status</a> property to change to <a class=\"normal\" href=\"CastleGameService.html#gsSignedIn\">gsSignedIn</a> (you can register <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnStatusChanged\">OnStatusChanged</a> to be notified about changes). </p></li> </ol>  <p> ", "tags": "", "loc": "CastleGameService.TGameService.html"},
     {"title": "CastleGameService.TGameService.DoSignedInChanged", "text": "    ", "tags": "", "loc": "CastleGameService.TGameService.html#DoSignedInChanged"},
     {"title": "CastleGameService.TGameService.DoStatusChanged", "text": "    ", "tags": "", "loc": "CastleGameService.TGameService.html#DoStatusChanged"},
     {"title": "CastleGameService.TGameService.DoPlayerBestScoreReceived", "text": "    ", "tags": "", "loc": "CastleGameService.TGameService.html#DoPlayerBestScoreReceived"},
     {"title": "CastleGameService.TGameService.DoSaveGameChosen", "text": "    ", "tags": "", "loc": "CastleGameService.TGameService.html#DoSaveGameChosen"},
     {"title": "CastleGameService.TGameService.DoSaveGameLoaded", "text": "    ", "tags": "", "loc": "CastleGameService.TGameService.html#DoSaveGameLoaded"},
     {"title": "CastleGameService.TGameService.Create", "text": "    ", "tags": "", "loc": "CastleGameService.TGameService.html#Create"},
     {"title": "CastleGameService.TGameService.Destroy", "text": "    ", "tags": "", "loc": "CastleGameService.TGameService.html#Destroy"},
     {"title": "CastleGameService.TGameService.Initialize", "text": "  <p>If the player already connected this application with Google Play Games (Android) or Apple Game Center (iOS), (s)he will be signed-in automatically. If not, player will be asked to sign-in (which means asking to accept permissions on Android) only if AutoStartSignInFlow. So if you want to avoid the initial Google Play Games dialog on Android, just always pass AutoStartSignInFlow=false.  <p>Calling this when already initialized is harmless (will not do anything).  <p>In theory, you can call this at any point in your application. But you probably want to call it early, e.g. from Application.OnInitialize, otherwise user will not be signed-in automatically. Most calls (like sending the leaderboars or achievements) will be ignored until you call this.  <p>  SaveGames Indicates whether you want to use save games feature. You can then use <a class=\"normal\" href=\"CastleGameService.TGameService.html#ShowSaveGames\">ShowSaveGames</a>, <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameSave\">SaveGameSave</a>, <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameLoad\">SaveGameLoad</a> methods. See also the description of this feature in Google Play Games: <a  href=\"https://developers.google.com/games/services/common/concepts/savedgames\">https://developers.google.com/games/services/common/concepts/savedgames</a>.  SaveGames Indicates whether you want to use save games feature. You can then use <a class=\"normal\" href=\"CastleGameService.TGameService.html#ShowSaveGames\">ShowSaveGames</a>, <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameSave\">SaveGameSave</a>, <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameLoad\">SaveGameLoad</a> methods. See also the description of this feature in Google Play Games: <a  href=\"https://developers.google.com/games/services/common/concepts/savedgames\">https://developers.google.com/games/services/common/concepts/savedgames</a>.", "tags": "", "loc": "CastleGameService.TGameService.html#Initialize"},
     {"title": "CastleGameService.TGameService.SignedIn", "text": " Just a shortcut for <code><a class=\"normal\" href=\"CastleGameService.TGameService.html#Status\">Status</a> = <a class=\"normal\" href=\"CastleGameService.html#gsSignedIn\">gsSignedIn</a></code> check.    ", "tags": "", "loc": "CastleGameService.TGameService.html#SignedIn"},
     {"title": "CastleGameService.TGameService.Achievement", "text": "  <p>For Google Play Games (Android): Use Google Developer Console to define achievements for your game, and use their ids with this method. The <code>achievement</code> ids are autogenerated by Google, they look like <code>CgkIvYuzpZsIEAIQAQ</code>.  <p>For Apple Game Center (iOS): Use iTunes Connect to define achievements for your game, and use their ids with this method. The <code>achievement</code> ids are chosen by you, so you can choose something readable like 'boss_defeated'.    ", "tags": "", "loc": "CastleGameService.TGameService.html#Achievement"},
     {"title": "CastleGameService.TGameService.SubmitScore", "text": " Use Google Developer Console (Android) or iTunes Connect (iOS) to create leaderboards for your game, use their ids here.  <p>TODO: Not implemented for Apple Game Center (iOS) yet.    ", "tags": "", "loc": "CastleGameService.TGameService.html#SubmitScore"},
     {"title": "CastleGameService.TGameService.RequestPlayerBestScore", "text": "  <p>This may (after some time, asynchronously) call <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnPlayerBestScoreReceived\">OnPlayerBestScoreReceived</a> with this score.  <p>Note that no error is signalled if loading the score fails for any reason. This includes failing to load because user is not connected to the game service (this method doesn't connect automatically; wait for <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnStatusChanged\">OnStatusChanged</a> before calling this, if you need).  <p>TODO: Not implemented for Apple Game Center (iOS) yet.    ", "tags": "", "loc": "CastleGameService.TGameService.html#RequestPlayerBestScore"},
     {"title": "CastleGameService.TGameService.RequestSignedIn", "text": " The operation will be done asynchronously (it will in most cases require some network communication).  <p>Watch for changes to the <a class=\"normal\" href=\"CastleGameService.TGameService.html#Status\">Status</a> property. You can register an event on <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnStatusChanged\">OnStatusChanged</a> to be notified about this.    ", "tags": "", "loc": "CastleGameService.TGameService.html#RequestSignedIn"},
     {"title": "CastleGameService.TGameService.ShowAchievements", "text": " Automatically connects (signs-in) player to game services, if not connected yet.    ", "tags": "", "loc": "CastleGameService.TGameService.html#ShowAchievements"},
     {"title": "CastleGameService.TGameService.ShowLeaderboard", "text": " The leaderboard should be created in the Games configuration of the Google Developer Console (Android) or iTunes Connect (iOS). Automatically connects (signs-in) player to game services, if not connected yet.    ", "tags": "", "loc": "CastleGameService.TGameService.html#ShowLeaderboard"},
     {"title": "CastleGameService.TGameService.ShowSaveGames", "text": " This can be used to offer user a choice in which slot to save the game, or from which slot to load the game.  <p>Note that it's not necessary to use this method to manage savegames. E.g. if you want, you can just choose a constant savegame name for your game, and use <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameSave\">SaveGameSave</a> and <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameLoad\">SaveGameLoad</a> with this name. This would imply that each game service user (Google Play Games user or Apple Game Center user) has only one savegame in the cloud for your game.  <p>The user may choose an existing savegame, or indicate creation of a new savegame (if parameter AllowAddButton is <code>True</code>). In response, the callback <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnSaveGameChosen\">OnSaveGameChosen</a> will be called. It will either  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>indicate the name of an existing savegame user has chosen,</p></li>   <li value=\"2\"><p>or that user wants to create a new savegame,</p></li>   <li value=\"3\"><p>or that user cancelled the dialog.</p></li> </ol>  <p>  <p>Using this requires initializing the game service first, by calling the <a class=\"normal\" href=\"CastleGameService.TGameService.html#Initialize\">Initialize</a> with <code>SaveGames</code> parameter set to <code>True</code>. Just like <a class=\"normal\" href=\"CastleGameService.TGameService.html#ShowAchievements\">ShowAchievements</a> and <a class=\"normal\" href=\"CastleGameService.TGameService.html#ShowLeaderboard\">ShowLeaderboard</a>, this method automatically signs-in player to game service, if not signed-in yet.  <p>Note that <i>the <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnSaveGameChosen\">OnSaveGameChosen</a> callback is not called if the user cancels the sign-in operation</i>, and therefore cancels the savegame choice this way. The same remark applies to all reasons why sign-in may fail (network problems etc.). If this is a problem for your logic (e.g. if you want to &quot;wait&quot; until <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnSaveGameChosen\">OnSaveGameChosen</a> is called), then never call <code>ShowSaveGames</code> when <a class=\"normal\" href=\"CastleGameService.TGameService.html#SignedIn\">SignedIn</a> is <code>False</code>. Instead, call <a class=\"normal\" href=\"CastleGameService.TGameService.html#RequestSignedIn\">RequestSignedIn</a>, wait until <a class=\"normal\" href=\"CastleGameService.TGameService.html#SignedIn\">SignedIn</a> changed to <code>True</code> (which may be &quot;never&quot;, in case of network problems or user cancelling!), and only then call <code>ShowSaveGames</code>.  <p>TODO: Not implemented for Apple Game Center (iOS) yet.  <p>     Title Dialog title to display. AllowAddButton Enable user to choose &quot;new save game&quot;. AllowDelete Enable user to delete savegames from the dialog. MaxNumberOfSaveGamesToShow Maximum number of savegames to show. Use -1 to just show all savegames.  Title Dialog title to display. AllowAddButton Enable user to choose &quot;new save game&quot;. AllowDelete Enable user to delete savegames from the dialog. MaxNumberOfSaveGamesToShow Maximum number of savegames to show. Use -1 to just show all savegames.", "tags": "", "loc": "CastleGameService.TGameService.html#ShowSaveGames"},
     {"title": "CastleGameService.TGameService.SaveGameSave", "text": " See the <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameLoad\">SaveGameLoad</a> documentation about the conflict resolution and valid savegame names.  <p>The Contents should be a valid UTF-8 string. For implementation reasons, you should not save arbitrary binary data this way, for now (or it could result in exceptions about being unable to encode/decode UTF-8 sequences).  <p>Description and PlayedTime are shown to player in <a class=\"normal\" href=\"CastleGameService.TGameService.html#ShowSaveGames\">ShowSaveGames</a>. PlayedTime may also be used for conflict resolution (if the savegame on the server was modified in the meantime, without loading it in this game).  <p>No callback is called in response, the game is saved in the background.  <p>This does not connect player to game service, if it's not connected already. An error when saving is not reported back to Pascal, for now. (The assumption here is that you will keep a local savegame anyway, in case user does not connect to game service. So inability to save the savegame to the cloud is not alarming, and does not require any special reaction. Please submit a request if you'd like to have a callback about it.)    ", "tags": "", "loc": "CastleGameService.TGameService.html#SaveGameSave"},
     {"title": "CastleGameService.TGameService.SaveGameLoad", "text": " If the savegame does not exist, it will be automatically created.  <p>If the server requires conflict resolution, the savegame with longest playtime is used (internally: we use RESOLUTION_POLICY_LONGEST_PLAYTIME flag with Google Play Games). For this to work, you must provide a proper PlayedTime parameter when saving all your savegames through <a class=\"normal\" href=\"CastleGameService.TGameService.html#SaveGameSave\">SaveGameSave</a>.  <p>Valid savegame names are defined by Google Play Games: Must be between 1 and 100 non-URL-reserved characters (a-z, A-Z, 0-9, or the symbols &quot;-&quot;, &quot;.&quot;, &quot;_&quot;, or &quot;&tilde;&quot;).  <p>In response, the callback <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnSaveGameLoaded\">OnSaveGameLoaded</a> will be <i>always</i> called, with the loaded savegame contents (as a string), or the error message.  <p>This does not connect player to game service (like Google Play Games), if it's not connected already.  <p>An error will be reported to <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnSaveGameLoaded\">OnSaveGameLoaded</a> callback if trying to load fails for any reason. This includes the case when loading fails because user is not connected to game service yet (this method <i>does not</i> connect user automatically; wait for <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnStatusChanged\">OnStatusChanged</a> before calling this method, if you need it).    ", "tags": "", "loc": "CastleGameService.TGameService.html#SaveGameLoad"},
     {"title": "CastleGameService.TGameService.Initialized", "text": " ", "tags": "", "loc": "CastleGameService.TGameService.html#Initialized"},
     {"title": "CastleGameService.TGameService.Status", "text": " ", "tags": "", "loc": "CastleGameService.TGameService.html#Status"},
     {"title": "CastleGameService.TGameService.OnStatusChanged", "text": " ", "tags": "", "loc": "CastleGameService.TGameService.html#OnStatusChanged"},
     {"title": "CastleGameService.TGameService.OnSignedInChanged", "text": " ", "tags": "", "loc": "CastleGameService.TGameService.html#OnSignedInChanged"},
     {"title": "CastleGameService.TGameService.OnPlayerBestScoreReceived", "text": " ", "tags": "", "loc": "CastleGameService.TGameService.html#OnPlayerBestScoreReceived"},
     {"title": "CastleGameService.TGameService.OnSaveGameChosen", "text": " ", "tags": "", "loc": "CastleGameService.TGameService.html#OnSaveGameChosen"},
     {"title": "CastleGameService.TGameService.OnSaveGameLoaded", "text": " See <a class=\"normal\" href=\"CastleGameService.html#TSaveGameLoadedEvent\">TSaveGameLoadedEvent</a> for documentation of parameters. ", "tags": "", "loc": "CastleGameService.TGameService.html#OnSaveGameLoaded"},
     {"title": "CastleGameService.TPlayerBestScoreEvent", "text": "    ", "tags": "", "loc": "CastleGameService.html#TPlayerBestScoreEvent"},
     {"title": "CastleGameService.TSaveGameChoice", "text": " Used as a parameter for <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnSaveGameChosen\">TGameService.OnSaveGameChosen</a> event.  sgCancel    sgNew    sgExisting   ", "tags": "", "loc": "CastleGameService.html#TSaveGameChoice"},
     {"title": "CastleGameService.TSaveGameChosenEvent", "text": "    ", "tags": "", "loc": "CastleGameService.html#TSaveGameChosenEvent"},
     {"title": "CastleGameService.TSaveGameLoadedEvent", "text": "    Success Whether we loaded the savegame successfully. Content The savegame content, if Success. If not Success, this is the error message.  Success Whether we loaded the savegame successfully. Content The savegame content, if Success. If not Success, this is the error message.", "tags": "", "loc": "CastleGameService.html#TSaveGameLoadedEvent"},
     {"title": "CastleGameService.TGameServiceStatus", "text": "  gsSignedOut Not signed-in to the service.   gsSigningIn Not signed-in to the service, but during signing-in.   gsSignedIn Signed-in to the service.  All game service methods work now.  gsSigningOut During signing-out from the service.  You should not call other methods on the service now. ", "tags": "", "loc": "CastleGameService.html#TGameServiceStatus"},
     {"title": "CastleGenericLists", "text": "  <p>This unit is done to avoid problem <a  href=\"http://bugs.freepascal.org/view.php?id=15480\">http://bugs.freepascal.org/view.php?id=15480</a> with unit FGL (although it's resolved, but the solution there only applies to records; our solution applies to any type; our solution also helps for lists of methods).  <p>Based on FPC FGL unit, copyright by FPC team. License of FPC RTL is the same as our engine (modified LGPL, see COPYING.txt for details). Fixed to compile also under FPC 2.4.0 and 2.2.4. Some small comfortable methods added. ", "tags": "", "loc": "CastleGenericLists.html"},
     {"title": "CastleGenericLists.TGenericStructList", "text": "  <p>This is equivalent to TFPGList, except it doesn't override <a class=\"normal\" href=\"CastleGenericLists.TGenericStructList.html#IndexOf\">IndexOf</a>, so your type doesn't need to have a &quot;=&quot; operator built-in inside FPC. When calling <a class=\"normal\" href=\"CastleGenericLists.TGenericStructList.html#IndexOf\">IndexOf</a> or Remove, it will simply compare values using CompareByte, this is what TFPSList.IndexOf uses. This way it works to create lists of records, vectors (constant size arrays), old-style TP objects, and also is suitable to create a list of methods (since for methods, the &quot;=&quot; is broken, for Delphi compatibility, see <a  href=\"http://bugs.freepascal.org/view.php?id=9228\">http://bugs.freepascal.org/view.php?id=9228</a>).  <p>We also add some trivial helper methods like <a class=\"normal\" href=\"CastleGenericLists.TGenericStructList.html#Add\">Add</a> and <a class=\"normal\" href=\"CastleGenericLists.TGenericStructList.html#L\">L</a>. ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html"},
     {"title": "CastleGenericLists.TGenericStructList.FOnCompare", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#FOnCompare"},
     {"title": "CastleGenericLists.TGenericStructList.CopyItem", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#CopyItem"},
     {"title": "CastleGenericLists.TGenericStructList.Deref", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Deref"},
     {"title": "CastleGenericLists.TGenericStructList.Get", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Get"},
     {"title": "CastleGenericLists.TGenericStructList.GetList", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#GetList"},
     {"title": "CastleGenericLists.TGenericStructList.ItemPtrCompare", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#ItemPtrCompare"},
     {"title": "CastleGenericLists.TGenericStructList.Put", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Put"},
     {"title": "CastleGenericLists.TGenericStructList.Create", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Create"},
     {"title": "CastleGenericLists.TGenericStructList.Add", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Add"},
     {"title": "CastleGenericLists.TGenericStructList.Extract", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Extract"},
     {"title": "CastleGenericLists.TGenericStructList.First", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#First"},
     {"title": "CastleGenericLists.TGenericStructList.IndexOf", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#IndexOf"},
     {"title": "CastleGenericLists.TGenericStructList.Insert", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Insert"},
     {"title": "CastleGenericLists.TGenericStructList.Last", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Last"},
     {"title": "CastleGenericLists.TGenericStructList.Assign", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Assign"},
     {"title": "CastleGenericLists.TGenericStructList.Remove", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Remove"},
     {"title": "CastleGenericLists.TGenericStructList.Sort", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Sort"},
     {"title": "CastleGenericLists.TGenericStructList.L", "text": "  <p>This is exactly the same pointer as <a class=\"normal\" href=\"CastleGenericLists.TGenericStructList.html#List\">List</a>, but the type is different: this points to a single item. This is useful if you have a list of records and you would like to set their fields. This allows to use <code>L[I]</code> instead of <code>List&circ;[I]</code> (only in FPC ObjFpc mode).  <p>See the <a class=\"normal\" href=\"CastleGenericLists.TGenericStructList.html#List\">List</a> description for a more detailed explanation and example.     ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#L"},
     {"title": "CastleGenericLists.TGenericStructList.Add", "text": " Comfortable and efficient way to add a new item that you want to immediately initialize.    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Add"},
     {"title": "CastleGenericLists.TGenericStructList.Ptr", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Ptr"},
     {"title": "CastleGenericLists.TGenericStructList.Items", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#Items"},
     {"title": "CastleGenericLists.TGenericStructList.List", "text": "  <p>This is useful if you have a list of records and you would like to set their fields. This will not work correctly:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">type</span>   TMyRecord = <span class=\"pascal_keyword\">record</span> MyField: Integer; <span class=\"pascal_keyword\">end</span>;   TMyRecordList = <span class=\"pascal_keyword\">specialize</span> TGenericStructList&lt;TMyRecord&gt;; <span class=\"pascal_keyword\">var</span>   MyList: TMyRecordList; <span class=\"pascal_keyword\">begin</span>   <span class=\"pascal_comment\">// ...</span>   MyList[I]<span class=\"pascal_float\">.</span>MyField := <span class=\"pascal_numeric\">123</span>;</pre>  <p>  <p>(It will not work OK because you would modify only a temporary record returned by the <code>MyList[I]</code> getter.) Instead, setting by  <p></p>  <pre class=\"longcode\"> MyList.List&circ;[I]<span class=\"pascal_float\">.</span>MyField := <span class=\"pascal_numeric\">123</span>;</pre>  <p>  <p>will work OK. Or you can use  <p></p>  <pre class=\"longcode\"> MyList.L[I]<span class=\"pascal_float\">.</span>MyField := <span class=\"pascal_numeric\">123</span>;</pre>  <p>  <p> ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#List"},
     {"title": "CastleGenericLists.TGenericStructList.TCompareFunc", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructList.html#TCompareFunc"},
     {"title": "CastleGenericLists.TGenericStructMap", "text": "  <p>This is equivalent to TFPGMap, except our <a class=\"normal\" href=\"CastleGenericLists.TGenericStructMap.html#KeyCompare\">KeyCompare</a> doesn't use &lt; or &gt; or even = operators, instead it compares by CompareByte. So it works with types that do not have built-in &lt; or &gt; or even = operator in FPC, like records or class instances.  <p>See also <a  href=\"http://bugs.freepascal.org/view.php?id=15480\">http://bugs.freepascal.org/view.php?id=15480</a> . ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html"},
     {"title": "CastleGenericLists.TGenericStructMap.FOnKeyCompare", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#FOnKeyCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.FOnDataCompare", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#FOnDataCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.CopyItem", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#CopyItem"},
     {"title": "CastleGenericLists.TGenericStructMap.CopyKey", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#CopyKey"},
     {"title": "CastleGenericLists.TGenericStructMap.CopyData", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#CopyData"},
     {"title": "CastleGenericLists.TGenericStructMap.Deref", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#Deref"},
     {"title": "CastleGenericLists.TGenericStructMap.InitOnPtrCompare", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#InitOnPtrCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.GetKey", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#GetKey"},
     {"title": "CastleGenericLists.TGenericStructMap.GetKeyData", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#GetKeyData"},
     {"title": "CastleGenericLists.TGenericStructMap.GetData", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#GetData"},
     {"title": "CastleGenericLists.TGenericStructMap.KeyCompare", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#KeyCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.KeyCustomCompare", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#KeyCustomCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.DataCustomCompare", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#DataCustomCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.PutKey", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#PutKey"},
     {"title": "CastleGenericLists.TGenericStructMap.PutKeyData", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#PutKeyData"},
     {"title": "CastleGenericLists.TGenericStructMap.PutData", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#PutData"},
     {"title": "CastleGenericLists.TGenericStructMap.SetOnKeyCompare", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#SetOnKeyCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.SetOnDataCompare", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#SetOnDataCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.Create", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#Create"},
     {"title": "CastleGenericLists.TGenericStructMap.Add", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#Add"},
     {"title": "CastleGenericLists.TGenericStructMap.Add", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#Add"},
     {"title": "CastleGenericLists.TGenericStructMap.Find", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#Find"},
     {"title": "CastleGenericLists.TGenericStructMap.IndexOf", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#IndexOf"},
     {"title": "CastleGenericLists.TGenericStructMap.IndexOfData", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#IndexOfData"},
     {"title": "CastleGenericLists.TGenericStructMap.InsertKey", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#InsertKey"},
     {"title": "CastleGenericLists.TGenericStructMap.InsertKeyData", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#InsertKeyData"},
     {"title": "CastleGenericLists.TGenericStructMap.Remove", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#Remove"},
     {"title": "CastleGenericLists.TGenericStructMap.Keys", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#Keys"},
     {"title": "CastleGenericLists.TGenericStructMap.Data", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#Data"},
     {"title": "CastleGenericLists.TGenericStructMap.KeyData", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#KeyData"},
     {"title": "CastleGenericLists.TGenericStructMap.OnCompare", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#OnCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.OnKeyCompare", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#OnKeyCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.OnDataCompare", "text": " ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#OnDataCompare"},
     {"title": "CastleGenericLists.TGenericStructMap.TDataCompareFunc", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#TDataCompareFunc"},
     {"title": "CastleGenericLists.TGenericStructMap.TKeyCompareFunc", "text": "    ", "tags": "", "loc": "CastleGenericLists.TGenericStructMap.html#TKeyCompareFunc"},
     {"title": "CastleGeometryArrays", "text": " ", "tags": "", "loc": "CastleGeometryArrays.html"},
     {"title": "CastleGeometryArrays.TGeometryTexCoord", "text": " If Generation &lt;&gt; <a class=\"normal\" href=\"CastleGeometryArrays.html#tgExplicit\">tgExplicit</a>, then the actual array data is not stored. ", "tags": "", "loc": "CastleGeometryArrays.TGeometryTexCoord.html"},
     {"title": "CastleGeometryArrays.TGeometryTexCoord.Generation", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryTexCoord.html#Generation"},
     {"title": "CastleGeometryArrays.TGeometryTexCoord.GenerationBoundsVector", "text": " TextureGen[0] says how to generate S texture coord, TextureGen[1] says how to generate T texture coord, and TextureGen[2] (only for <a class=\"normal\" href=\"CastleGeometryArrays.html#tgBounds3d\">tgBounds3d</a>) is fo R tex coord. ", "tags": "", "loc": "CastleGeometryArrays.TGeometryTexCoord.html#GenerationBoundsVector"},
     {"title": "CastleGeometryArrays.TGeometryTexCoord.GenerationProjectorMatrix", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryTexCoord.html#GenerationProjectorMatrix"},
     {"title": "CastleGeometryArrays.TGeometryTexCoord.Dimensions", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryTexCoord.html#Dimensions"},
     {"title": "CastleGeometryArrays.TGeometryTexCoord.Offset", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryTexCoord.html#Offset"},
     {"title": "CastleGeometryArrays.TGeometryAttrib", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryAttrib.html"},
     {"title": "CastleGeometryArrays.TGeometryAttrib.Name", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryAttrib.html#Name"},
     {"title": "CastleGeometryArrays.TGeometryAttrib.Internal", "text": " This is only used to change warnings related to this attribute. ", "tags": "", "loc": "CastleGeometryArrays.TGeometryAttrib.html#Internal"},
     {"title": "CastleGeometryArrays.TGeometryAttrib.AType", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryAttrib.html#AType"},
     {"title": "CastleGeometryArrays.TGeometryAttrib.Offset", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryAttrib.html#Offset"},
     {"title": "CastleGeometryArrays.TGeometryAttribList", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryAttribList.html"},
     {"title": "CastleGeometryArrays.TGeometryAttribList.Find", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryAttribList.html#Find"},
     {"title": "CastleGeometryArrays.TGeometryArrays", "text": " Many (eventually, all) geometry nodes (TVRMLGeometryNode) can be processed into an instance of this class.  <p>This can be used to render, as arrays here map very naturally to an efficient OpenGL vertex arrays and VBOs. We use interleaving, storing everything in two arrays: 1st one for positions and normals (stuff that changes during coordinate morphing, most common dynamic shapes, so we specifically think about optimizing it). 2nd one for everything else (colors, tex coords, also GLSL attributes). This should allow for the most efficient usage, making use of interleaving and still allowing fast dynamic updates in common cases. ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Create", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Create"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Destroy", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Destroy"},
     {"title": "CastleGeometryArrays.TGeometryArrays.IndexesPtr", "text": "  <p>Before using <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#FreeData\">FreeData</a>, you could as well use the <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#Indexes\">Indexes</a> property to get the same information. You can use Indexes[Index], Indexes &lt;&gt; nil, Indexes.Count and such. However, <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#FreeData\">FreeData</a> call (that you should use to conserve memory usage after loading arrays to VBO) releases the Indexes property, while these properties stay the same.  <p><code>IndexesPtr</code> may be casted to &quot;&circ;<a class=\"normal\" href=\"CastleGeometryArrays.html#TGeometryIndex\">TGeometryIndex</a>&quot;, before the <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#FreeData\">FreeData</a> call.  <p>    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#IndexesPtr"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Position", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Position"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Position", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Position"},
     {"title": "CastleGeometryArrays.TGeometryArrays.IncPosition", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#IncPosition"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Normal", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Normal"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Normal", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Normal"},
     {"title": "CastleGeometryArrays.TGeometryArrays.IncNormal", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#IncNormal"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddColor", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddColor"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Color", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Color"},
     {"title": "CastleGeometryArrays.TGeometryArrays.IncColor", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#IncColor"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddFogCoord", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddFogCoord"},
     {"title": "CastleGeometryArrays.TGeometryArrays.FogCoord", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#FogCoord"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddTexCoord2D", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddTexCoord2D"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddTexCoord3D", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddTexCoord3D"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddTexCoord4D", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddTexCoord4D"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddTexCoordGenerated", "text": " Such texture coord will not have actual data allocated in the array (you're expected to instead setup and enable glTexGen when rendering). Generation passed here must not be <a class=\"normal\" href=\"CastleGeometryArrays.html#tgExplicit\">tgExplicit</a>.    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddTexCoordGenerated"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddTexCoordCopy", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddTexCoordCopy"},
     {"title": "CastleGeometryArrays.TGeometryArrays.TexCoord", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#TexCoord"},
     {"title": "CastleGeometryArrays.TGeometryArrays.TexCoord2D", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#TexCoord2D"},
     {"title": "CastleGeometryArrays.TGeometryArrays.TexCoord3D", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#TexCoord3D"},
     {"title": "CastleGeometryArrays.TGeometryArrays.TexCoord4D", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#TexCoord4D"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddGLSLAttributeFloat", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddGLSLAttributeFloat"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddGLSLAttributeVector2", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddGLSLAttributeVector2"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddGLSLAttributeVector3", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddGLSLAttributeVector3"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddGLSLAttributeVector4", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddGLSLAttributeVector4"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddGLSLAttributeMatrix3", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddGLSLAttributeMatrix3"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AddGLSLAttributeMatrix4", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AddGLSLAttributeMatrix4"},
     {"title": "CastleGeometryArrays.TGeometryArrays.GLSLAttribute", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#GLSLAttribute"},
     {"title": "CastleGeometryArrays.TGeometryArrays.GLSLAttributeFloat", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#GLSLAttributeFloat"},
     {"title": "CastleGeometryArrays.TGeometryArrays.GLSLAttributeVector2", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#GLSLAttributeVector2"},
     {"title": "CastleGeometryArrays.TGeometryArrays.GLSLAttributeVector3", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#GLSLAttributeVector3"},
     {"title": "CastleGeometryArrays.TGeometryArrays.GLSLAttributeVector4", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#GLSLAttributeVector4"},
     {"title": "CastleGeometryArrays.TGeometryArrays.GLSLAttributeMatrix3", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#GLSLAttributeMatrix3"},
     {"title": "CastleGeometryArrays.TGeometryArrays.GLSLAttributeMatrix4", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#GLSLAttributeMatrix4"},
     {"title": "CastleGeometryArrays.TGeometryArrays.FreeData", "text": " Further calls to <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#IndexesPtr\">IndexesPtr</a>, Normal, Color and such will return only an offset relative to the original arrays pointer. This is necessary if you loaded arrays data into GPU memory (like Vertex Buffer Object of OpenGL), and it is also optimal &ndash; you should not need the data anymore, once loaded to VBO.    ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#FreeData"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Indexes", "text": "  <p>If non-nil, we will render using these indexes, which means that items on the remaining lists (vertex positions, tex coords etc.) may be used multiple times. This is good (the lists may be possibly shorter, and GPU will be able to reuse more calculation results), but it's also limited: a vertex must always have the same properties in this case (e.g. the same normal vector, so shape must be completely smooth).  <p>When this is nil, we will simply use all the vertexes in order. So every item of the remaining lists will be processed exactly once, in the given order. This seems dumb, but actually we're often forced to use this: when you use flat (per-face) normals or colors, then the same vertex position must be used many times with different normal/color. If you want to use OpenGL vertex arrays for whole rendering, this vertex position will just have to be duplicated (which is OK, as the calculation results couldn't be shared anyway, since normal/color are different). ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Indexes"},
     {"title": "CastleGeometryArrays.TGeometryArrays.IndexesCount", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#IndexesCount"},
     {"title": "CastleGeometryArrays.TGeometryArrays.HasIndexes", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#HasIndexes"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Primitive", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Primitive"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Counts", "text": " This is the only way to put many triangle strips, triangle fans and such into one <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html\">TGeometryArrays</a> instance. For normal sets of triangles and quads this has no use, as there's never a need to divide them for rendering.  <p>Each value of this list specifies to take consecutive number of vertexes for next primitive. If Indexes are assigned, then they are divided into groups. Otherwise, the other arrays (positions, normals etc.) are divided into groups.  <p>The sum of values must be equal to the Indexes.Count (if Indexes assigned) or arrays Count (if Indexes not assigned). ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Counts"},
     {"title": "CastleGeometryArrays.TGeometryArrays.CoordinateArray", "text": " <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#CoordinateSize\">CoordinateSize</a> is size, in bytes, of one item of this array (currently just constant, 2 * <a class=\"normal\" href=\"CastleVectors.html#TVector3\">TVector3</a>).  ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#CoordinateArray"},
     {"title": "CastleGeometryArrays.TGeometryArrays.CoordinateSize", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#CoordinateSize"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AttributeArray", "text": " <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#AttributeSize\">AttributeSize</a> is size, in bytes, of one item of this array.  ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AttributeArray"},
     {"title": "CastleGeometryArrays.TGeometryArrays.AttributeSize", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#AttributeSize"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Count", "text": "  <p>You can only set this once. You must do all necessary <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#AddColor\">AddColor</a> / AddAttribute calls before setting this.  <p>You can access all Position / Normal etc. pointers only after setting this. Also, <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#IndexesCount\">IndexesCount</a> and <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#HasIndexes\">HasIndexes</a> is stored at this point. ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Count"},
     {"title": "CastleGeometryArrays.TGeometryArrays.HasColor", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#HasColor"},
     {"title": "CastleGeometryArrays.TGeometryArrays.HasDefaultColor", "text": "  ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#HasDefaultColor"},
     {"title": "CastleGeometryArrays.TGeometryArrays.DefaultColor", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#DefaultColor"},
     {"title": "CastleGeometryArrays.TGeometryArrays.HasFogCoord", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#HasFogCoord"},
     {"title": "CastleGeometryArrays.TGeometryArrays.FogDirectValues", "text": " When this is <code>False</code>, then fog coordinates are understood as distance from the eye, and they are processed by linear/exp equations before being used to blend pixel colors. ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#FogDirectValues"},
     {"title": "CastleGeometryArrays.TGeometryArrays.TexCoords", "text": " Index is texture unit (counted from renderer first available texture unit). If given item is <code>Nil</code> on this list, then this texture unit is not allocated (just like it would be outside of TexCoords.Count). ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#TexCoords"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Attribs", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Attribs"},
     {"title": "CastleGeometryArrays.TGeometryArrays.CullFace", "text": "  <p>Which faces are &quot;back&quot; (and will be culled) is determined by <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#FrontFaceCcw\">FrontFaceCcw</a>. When <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#FrontFaceCcw\">FrontFaceCcw</a> = <code>True</code>, the the faces ordered counter-clockwise are front, and thus the faces ordered clockwise will be culled. When <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#FrontFaceCcw\">FrontFaceCcw</a> = <code>False</code>, the faces ordered counter-clockwise will be culled. ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#CullFace"},
     {"title": "CastleGeometryArrays.TGeometryArrays.FrontFaceCcw", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#FrontFaceCcw"},
     {"title": "CastleGeometryArrays.TGeometryArrays.ForceFlatShading", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#ForceFlatShading"},
     {"title": "CastleGeometryArrays.TGeometryArrays.DataFreed", "text": " ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#DataFreed"},
     {"title": "CastleGeometryArrays.TGeometryArrays.Faces", "text": " Generated for some geometry types. Generated only when <a class=\"normal\" href=\"CastleArraysGenerator.TArraysGenerator.html#FacesNeeded\">TArraysGenerator.FacesNeeded</a> is <code>True</code>. Generated only for indexed shapes. When Indexes &lt;&gt; nil, these have the same count as Indexes.Count. Otherwise these have the same count as our <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html#Count\">Count</a>. ", "tags": "", "loc": "CastleGeometryArrays.TGeometryArrays.html#Faces"},
     {"title": "CastleGeometryArrays.TGeometryPrimitive", "text": " Analogous to OpenGL / OpenGLES primitives.  gpTriangles    gpQuads    gpTriangleFan    gpTriangleStrip    gpLineStrip    gpPoints   ", "tags": "", "loc": "CastleGeometryArrays.html#TGeometryPrimitive"},
     {"title": "CastleGeometryArrays.TTexCoordDimensions", "text": " ", "tags": "", "loc": "CastleGeometryArrays.html#TTexCoordDimensions"},
     {"title": "CastleGeometryArrays.TTextureCoordinateGeneration", "text": "  <p>For their meaning, see the X3D specification about TextureCoordinateGenerator.mode values. We also add some extensions, see [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_tex_coord_worldspace\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_tex_coord_worldspace</a>] and [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_tex_coord_bounds\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_tex_coord_bounds</a>]. We also support ProjectedTextureCoordinate, see [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions_shadow_maps.php#section_ext_texture_gen_projective\">http://castle-engine.sourceforge.net/x3d_extensions_shadow_maps.php#section_ext_texture_gen_projective</a>].  <p>Special value <a class=\"normal\" href=\"CastleGeometryArrays.html#tgExplicit\">tgExplicit</a> means that texture coordinates are not generated.  tgExplicit    tgBounds2d    tgBounds3d    tgSphereMap    tgCoord    tgCoordEye    tgCameraSpaceNormal    tgWorldSpaceNormal    tgCameraSpaceReflectionVector    tgWorldSpaceReflectionVector    tgProjection   ", "tags": "", "loc": "CastleGeometryArrays.html#TTextureCoordinateGeneration"},
     {"title": "CastleGeometryArrays.TProjectorMatrixFunction", "text": "    ", "tags": "", "loc": "CastleGeometryArrays.html#TProjectorMatrixFunction"},
     {"title": "CastleGeometryArrays.TTextureGenerationVectors", "text": " ", "tags": "", "loc": "CastleGeometryArrays.html#TTextureGenerationVectors"},
     {"title": "CastleGeometryArrays.TGeometryTexCoordList", "text": " ", "tags": "", "loc": "CastleGeometryArrays.html#TGeometryTexCoordList"},
     {"title": "CastleGeometryArrays.TGeometryAttribType", "text": "  atFloat    atVector2    atVector3    atVector4    atMatrix3    atMatrix4   ", "tags": "", "loc": "CastleGeometryArrays.html#TGeometryAttribType"},
     {"title": "CastleGeometryArrays.TGeometryIndex", "text": " ", "tags": "", "loc": "CastleGeometryArrays.html#TGeometryIndex"},
     {"title": "CastleGeometryArrays.TGeometryIndexList", "text": " ", "tags": "", "loc": "CastleGeometryArrays.html#TGeometryIndexList"},
     {"title": "CastleGiftiz", "text": " ", "tags": "", "loc": "CastleGiftiz.html"},
     {"title": "CastleGiftiz.TGiftiz", "text": " Only on Android (will simply do nothing on other platforms).  <p>Usage:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Call <a class=\"normal\" href=\"CastleGiftiz.TGiftiz.html#MissionComplete\">TGiftiz.MissionComplete</a> to notify Giftiz about mission completion.</p></li>   <li value=\"2\"><p>Use <a class=\"normal\" href=\"CastleGiftiz.TGiftizButton.html\">TGiftizButton</a> to show on UI the Giftiz button. It's updated/hidden automatically based on Giftiz state.</p></li>   <li value=\"3\"><p>To include the necessary integration code in your Android project, declare your Android project type as &quot;integrated&quot; with the &quot;giftiz&quot; component inside CastleEngineManifest.xml. See <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> .</p></li> </ol>  <p> ", "tags": "", "loc": "CastleGiftiz.TGiftiz.html"},
     {"title": "CastleGiftiz.TGiftiz.MissionComplete", "text": "    ", "tags": "", "loc": "CastleGiftiz.TGiftiz.html#MissionComplete"},
     {"title": "CastleGiftiz.TGiftizButton", "text": " ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html"},
     {"title": "CastleGiftiz.TGiftizButton.Create", "text": "    ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#Create"},
     {"title": "CastleGiftiz.TGiftizButton.Destroy", "text": "    ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#Destroy"},
     {"title": "CastleGiftiz.TGiftizButton.GetExists", "text": "    ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#GetExists"},
     {"title": "CastleGiftiz.TGiftizButton.DoClick", "text": "    ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#DoClick"},
     {"title": "CastleGiftiz.TGiftizButton.Resize", "text": "    ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#Resize"},
     {"title": "CastleGiftiz.TGiftizButton.CustomBackground", "text": " ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#CustomBackground"},
     {"title": "CastleGiftiz.TGiftizButton.OwnsCustomBackgroundNormal", "text": " ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#OwnsCustomBackgroundNormal"},
     {"title": "CastleGiftiz.TGiftizButton.CustomBackgroundNormal", "text": " ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#CustomBackgroundNormal"},
     {"title": "CastleGiftiz.TGiftizButton.AutoSize", "text": " ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#AutoSize"},
     {"title": "CastleGiftiz.TGiftizButton.Width", "text": " ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#Width"},
     {"title": "CastleGiftiz.TGiftizButton.Height", "text": " ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#Height"},
     {"title": "CastleGiftiz.TGiftizButton.KeepInFront", "text": " ", "tags": "", "loc": "CastleGiftiz.TGiftizButton.html#KeepInFront"},
     {"title": "CastleGLBoxes", "text": " ", "tags": "", "loc": "CastleGLBoxes.html"},
     {"title": "CastleGLBoxes.glDrawBox3DWire", "text": " Nothing is generated besides vertex positions &mdash; no normal vectors, no texture coords, nothing.    ", "tags": "", "loc": "CastleGLBoxes.html#glDrawBox3DWire"},
     {"title": "CastleGLContainer", "text": " ", "tags": "", "loc": "CastleGLContainer.html"},
     {"title": "CastleGLContainer.TGLContainer", "text": " This class is internally used by <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> and <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a>. It is not useful from the outside, unless you want to implement your own container provider similar to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> / <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a>. ", "tags": "", "loc": "CastleGLContainer.TGLContainer.html"},
     {"title": "CastleGLContainer.TGLContainer.Create", "text": "    ", "tags": "", "loc": "CastleGLContainer.TGLContainer.html#Create"},
     {"title": "CastleGLContainer.TGLContainer.Destroy", "text": "    ", "tags": "", "loc": "CastleGLContainer.TGLContainer.html#Destroy"},
     {"title": "CastleGLContainer.TGLContainer.EventRender", "text": "    ", "tags": "", "loc": "CastleGLContainer.TGLContainer.html#EventRender"},
     {"title": "CastleGLContainer.TGLContainer.EventClose", "text": "    ", "tags": "", "loc": "CastleGLContainer.TGLContainer.html#EventClose"},
     {"title": "CastleGLContainer.TGLContainer.RenderControl", "text": " Use this to render the UI control off-screen, see e.g. example render_3d_to_texture_and_use_as_quad.lpr.  <p>This doesn't only call <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">Control.Render</a>. It also:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Temporarily sets <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Container\">Control.Container</a>, if needed.</p></li>   <li><p>Calls <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextOpen\">Control.GLContextOpen</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextClose\">Control.GLContextClose</a> around, if needed.</p></li>   <li><p>Calls <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Resize\">Control.Resize</a>, required by some controls (like scene manager) to know viewport size.</p></li>   <li><p>Calls <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#BeforeRender\">Control.BeforeRender</a>, required by some controls (like scene manager) to prepare resources (like generated textures, important for mirrors for screenshots in batch mode).</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleGLContainer.TGLContainer.html#RenderControl"},
     {"title": "CastleGLContainer.TGLContainer.SaveScreen", "text": "    ", "tags": "", "loc": "CastleGLContainer.TGLContainer.html#SaveScreen"},
     {"title": "CastleGLContainer.TGLContainer.Context", "text": " ", "tags": "", "loc": "CastleGLContainer.TGLContainer.html#Context"},
     {"title": "CastleGLContainer.RenderControlToImage", "text": " The background behind the control is filled with BackgroundColor (which may be transparent, e.g. with alpha = 0).  <p>The rendering is done using off-screen FBO. Which means that you can request any size, you are <b>not</b> limited to your current window / control size.  <p>Make sure that the control is nicely positioned to fill the ViewportRect. Usually you want to adjust control size and position, and disable UI scaling (set <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#EnableUIScaling\">TUIControl.EnableUIScaling</a> = <code>False</code> if you use <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">TUIContainer.UIScaling</a>).    ", "tags": "", "loc": "CastleGLContainer.html#RenderControlToImage"},
     {"title": "CastleGLCubeMaps", "text": " ", "tags": "", "loc": "CastleGLCubeMaps.html"},
     {"title": "CastleGLCubeMaps.SHVectorGLCapture", "text": " Environment is rendered by Render(true) callback, from the CapturePoint. It's rendered to color buffer, and captured as grayscale. Captured pixel value is just assumed to be the value of spherical function at this direction. It's also scaled by ScaleColor (since rendering to OpenGL catches values in 0..1 range, but SH vector can express values from any range).  <p>This changes <a class=\"normal\" href=\"CastleGLUtils.html#GLViewport\">glViewport</a>, so be sure to reset <a class=\"normal\" href=\"CastleGLUtils.html#GLViewport\">glViewport</a> to something normal after calling this.  <p>The maps will be drawn in the color buffer (from positions MapScreenX, Y), so will actually be visible (call this before RenderContext.Clear or such if you want to hide them).    ", "tags": "", "loc": "CastleGLCubeMaps.html#SHVectorGLCapture"},
     {"title": "CastleGLCubeMaps.GLCaptureCubeMapImages", "text": "  <p>Environment is rendered by Render callback that must honour camera described in <a class=\"normal\" href=\"CastleRenderingCamera.html#RenderingCamera\">RenderingCamera</a> object. RenderingCamera.Target will be set to <a class=\"normal\" href=\"CastleRenderingCamera.html#rtCubeMapEnvironment\">rtCubeMapEnvironment</a>. <a class=\"normal\" href=\"CastleRenderingCamera.html#RenderingCamera\">RenderingCamera</a> camera will be set to appropriate views from the CapturePoint. You should at least load RenderingCamera.Matrix to OpenGL modelview matrix before rendering your 3D scene.  <p>Cube map is recorded in six images you provide in the Images parameter. These must be already created <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instances, with the exact same size. (They do not have to be square, or have power-of-two size, or honor GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB limit, as we do not initialize actual OpenGL cube map here. You can use generated images for any purpose.) The classes of these images will also matter &mdash; e.g. use <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html\">TGrayscaleImage</a> to capture scene as grayscale, use <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a> for RGB colors.  <p>This changes <a class=\"normal\" href=\"CastleGLUtils.html#GLViewport\">glViewport</a>, so be sure to reset <a class=\"normal\" href=\"CastleGLUtils.html#GLViewport\">glViewport</a> to something normal after calling this.  <p>ProjectionNear, ProjectionFar parameters will be used to set GL projection matrix. ProjectionFar may be equal to <a class=\"normal\" href=\"CastleProjection.html#ZFarInfinity\">ZFarInfinity</a>, as always.    ", "tags": "", "loc": "CastleGLCubeMaps.html#GLCaptureCubeMapImages"},
     {"title": "CastleGLCubeMaps.GLCaptureCubeMapComposite", "text": "  <p>See <a class=\"normal\" href=\"CastleGLCubeMaps.html#GLCaptureCubeMapImages\">GLCaptureCubeMapImages</a> for documentation, this works the same, but it creates <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html\">TCompositeImage</a> instance containing all six images.    ", "tags": "", "loc": "CastleGLCubeMaps.html#GLCaptureCubeMapComposite"},
     {"title": "CastleGLCubeMaps.GLCaptureCubeMapTexture", "text": "  <p>See <a class=\"normal\" href=\"CastleGLCubeMaps.html#GLCaptureCubeMapImages\">GLCaptureCubeMapImages</a> for documentation, this works the same, but it captures images to given OpenGL texture name Tex. Tex must already be created cube map texture (with OpenGL size and internal formats set), with square images of Size. This also means that Size must be a valid OpenGL cube map texture size, you can check it by GLImages.IsCubeMapTextureSized.  <p>This captures the cube map images to &quot;zero&quot; texture level. If you use mipmaps, it's your problem how to generate other texture levels &mdash; in the simplest case, call <a class=\"normal\" href=\"CastleGLUtils.html#GenerateMipmap\">GenerateMipmap</a>(GL_TEXTURE_CUBE_MAP).  <p>It uses RenderToTexture to render to the texture, so it will use framebuffer if available, and it's fast.    ", "tags": "", "loc": "CastleGLCubeMaps.html#GLCaptureCubeMapTexture"},
     {"title": "CastleGLCubeMaps.TCubeMapRenderSimpleFunction", "text": "    ", "tags": "", "loc": "CastleGLCubeMaps.html#TCubeMapRenderSimpleFunction"},
     {"title": "CastleGLImages", "text": "  <p>For non-OpenGL image management, see <a class=\"normal\" href=\"CastleImages.html\">CastleImages</a> and <a class=\"normal\" href=\"CastleTextureImages.html\">CastleTextureImages</a> units. They contain functions and classes to load, save and process images.  <p>This unit has functions and classes to:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Load images as OpenGL textures. You usually do not use these directly, instead <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> automatically uses these to load and render textures as part of 3D models.  <p>A lot of utilities included: for 2D textures (see <a class=\"normal\" href=\"CastleGLImages.html#LoadGLTexture\">LoadGLTexture</a>), cube maps (see <a class=\"normal\" href=\"CastleGLImages.html#glTextureCubeMap\">glTextureCubeMap</a>), 3D textures (see <a class=\"normal\" href=\"CastleGLImages.html#glTextureImage3D\">glTextureImage3D</a>). These functions wrap OpenGL calls like glTexImage2D to handle our images (<a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a> (and descendant <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>), <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html\">TCompositeImage</a>), and to automatically set texture parameters, mipmaps and such.</p></li>   <li><p>Load and draw images in 2D. This is useful to implement various 2D controls. See <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a> class and friends.</p></li>   <li><p>Save the current OpenGL screen contents to our <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>. You usually use this through <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#SaveScreen\">TCastleWindowCustom.SaveScreen</a> or TCastleControl.SaveScreen, based on <a class=\"normal\" href=\"CastleGLImages.html#SaveScreen_NoFlush\">SaveScreen_NoFlush</a> in this unit.</p></li>   <li><p>Render to texture, see <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html\">TGLRenderToTexture</a> class. This is our abstraction over OpenGL framebuffer (or glCopyTexSubImage for ancient GPUs).</p></li> </ul>  <p>  <p>This unit hides from your some details about OpenGL images handling. For example, you don't have to worry about &quot;pixel store alignment&quot;, we handle it here internally when transferring images between memory and GPU. You also don't have to worry about texture sizes being power of 2, or about maximum texture sizes &mdash; we will resize textures if necessary.  <p>Routines in this unit that take <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> or <a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a> parameter are limited to <a class=\"normal\" href=\"CastleTextureImages.html#TextureImageClassesAll\">TextureImageClassesAll</a> (for routines dealing with textures) or <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a> (for routines dealing with images drawn on 2D screen). ", "tags": "", "loc": "CastleGLImages.html"},
     {"title": "CastleGLImages.ETextureLoadError", "text": " ", "tags": "", "loc": "CastleGLImages.ETextureLoadError.html"},
     {"title": "CastleGLImages.EImageClassNotSupportedForOpenGL", "text": " ", "tags": "", "loc": "CastleGLImages.EImageClassNotSupportedForOpenGL.html"},
     {"title": "CastleGLImages.ECannotLoadCompressedTexture", "text": " ", "tags": "", "loc": "CastleGLImages.ECannotLoadCompressedTexture.html"},
     {"title": "CastleGLImages.EInvalidImageForOpenGLTexture", "text": " ", "tags": "", "loc": "CastleGLImages.EInvalidImageForOpenGLTexture.html"},
     {"title": "CastleGLImages.TTextureFilter", "text": " ", "tags": "", "loc": "CastleGLImages.TTextureFilter.html"},
     {"title": "CastleGLImages.TTextureFilter.Magnification", "text": " ", "tags": "", "loc": "CastleGLImages.TTextureFilter.html#Magnification"},
     {"title": "CastleGLImages.TTextureFilter.Minification", "text": " ", "tags": "", "loc": "CastleGLImages.TTextureFilter.html#Minification"},
     {"title": "CastleGLImages.TTextureFilter.NeedsMipmaps", "text": "    ", "tags": "", "loc": "CastleGLImages.TTextureFilter.html#NeedsMipmaps"},
     {"title": "CastleGLImages.TTextureFilter.DisableMipmaps", "text": "    ", "tags": "", "loc": "CastleGLImages.TTextureFilter.html#DisableMipmaps"},
     {"title": "CastleGLImages.TTextureFilter.=", "text": "    ", "tags": "", "loc": "CastleGLImages.TTextureFilter.html#="},
     {"title": "CastleGLImages.TTextureWrap2D", "text": " ", "tags": "", "loc": "CastleGLImages.TTextureWrap2D.html"},
     {"title": "CastleGLImages.TTextureWrap2D.Data", "text": " ", "tags": "", "loc": "CastleGLImages.TTextureWrap2D.html#Data"},
     {"title": "CastleGLImages.TTextureWrap2D.=", "text": "    ", "tags": "", "loc": "CastleGLImages.TTextureWrap2D.html#="},
     {"title": "CastleGLImages.TTextureWrap3D", "text": " ", "tags": "", "loc": "CastleGLImages.TTextureWrap3D.html"},
     {"title": "CastleGLImages.TTextureWrap3D.Data", "text": " ", "tags": "", "loc": "CastleGLImages.TTextureWrap3D.html#Data"},
     {"title": "CastleGLImages.TTextureWrap3D.=", "text": "    ", "tags": "", "loc": "CastleGLImages.TTextureWrap3D.html#="},
     {"title": "CastleGLImages.TGLImageCore", "text": " This image can be drawn in various rendering methods and events, e.g. inside overridden <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a> or from events <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">TCastleWindowCustom.OnRender</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#OnRender\">TCastleControlCustom.OnRender</a>.  <p>An alternative way to show a 2D image is to use the full-featured 2D control <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html\">TCastleImageControl</a>. This will perform the drawing by itself, you only add it to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a>.  <p><b>An instance of this class can only exist when the OpenGL context is open.</b> So usually you create this in <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextOpen\">TUIControl.GLContextOpen</a> and destroy in <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextClose\">TUIControl.GLContextClose</a>. Or create in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">TCastleWindowCustom.OnOpen</a> and destroy in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnClose\">TCastleWindowCustom.OnClose</a>. <b>Use the descendant class <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a> for more comfort. The <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a> instance can be created / destroyed at any moment, regardless of the OpenGL context. This is especially important on platforms when the OpenGL context may get lost at any moment, like on Android.</b> ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html"},
     {"title": "CastleGLImages.TGLImageCore.DefaultBlendingSourceFactor", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#DefaultBlendingSourceFactor"},
     {"title": "CastleGLImages.TGLImageCore.DefaultBlendingDestinationFactor", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#DefaultBlendingDestinationFactor"},
     {"title": "CastleGLImages.TGLImageCore.DefaultBlendingConstantColor", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#DefaultBlendingConstantColor"},
     {"title": "CastleGLImages.TGLImageCore.Create", "text": "  <p>  <p>  <p>  Image Initial image contents. The <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a> class loads it immediately, so you can freely free the Image instance later. Be careful &ndash; <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a> descendant has a different approach, it needs the <a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a> instance to exist throuout the whole <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a> lifetime. ASmoothScaling The initial value of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a>, determines whether the image scaling is smooth (bilinear filtering) or not (nearest-pixel filtering). You can always change it later through the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> property. But each change has a small cost, so it's more efficient to just set the initial value correctly.  EImageClassNotSupportedForOpenGL When Image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Create"},
     {"title": "CastleGLImages.TGLImageCore.Create", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Create"},
     {"title": "CastleGLImages.TGLImageCore.Create", "text": "  <p>  <p>  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImageCore.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> ASmoothScaling The initial value of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a>, determines whether the image scaling is smooth (bilinear filtering) or not (nearest-pixel filtering). You can always change it later through the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> property. But each change has a small cost, so it's more efficient to just set the initial value correctly.  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImageCore.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> ASmoothScaling The initial value of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a>, determines whether the image scaling is smooth (bilinear filtering) or not (nearest-pixel filtering). You can always change it later through the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> property. But each change has a small cost, so it's more efficient to just set the initial value correctly.", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Create"},
     {"title": "CastleGLImages.TGLImageCore.Create", "text": "  <p>  <p>  <p>  <p>  <p>  <p>  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImageCore.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> LoadAsClass Constrain the possible image classes to load into. This can force removing (or adding) an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel, or converting contents to grayscale or RGB, regardless of the preferred image file format. Must be a subset of <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>, as other classes cannot be loaded into OpenGL 2D images, otherwise you may get <a class=\"normal\" href=\"CastleGLImages.EImageClassNotSupportedForOpenGL.html\">EImageClassNotSupportedForOpenGL</a> exception. Pass empty set [] to load into any allowed class (it's equivalent to passing LoadAsClass = <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>).  <p>You can pass e.g. [<a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>] to force loading into an RGB image without an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel (it will be stripped from the image if necessary). ResizeToX After loading, resize to given width. Pass 0 to not resize width. ResizeToY After loading, resize to given height. Pass 0 to not resize height. Interpolation If any resizing will be needed (if ResizeToX / ResizeToY parameters request some specific size, and it is different than loaded image size) then the resize operation will use given interpolation.  EImageClassNotSupportedForOpenGL When image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Create"},
     {"title": "CastleGLImages.TGLImageCore.Create", "text": "  <p>  <p>  <p>  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImageCore.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> LoadAsClass Constrain the possible image classes to load into. This can force removing (or adding) an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel, or converting contents to grayscale or RGB, regardless of the preferred image file format. Must be a subset of <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>, as other classes cannot be loaded into OpenGL 2D images, otherwise you may get <a class=\"normal\" href=\"CastleGLImages.EImageClassNotSupportedForOpenGL.html\">EImageClassNotSupportedForOpenGL</a> exception. Pass empty set [] to load into any allowed class (it's equivalent to passing LoadAsClass = <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>).  <p>You can pass e.g. [<a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>] to force loading into an RGB image without an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel (it will be stripped from the image if necessary). ASmoothScaling The initial value of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a>, determines whether the image scaling is smooth (bilinear filtering) or not (nearest-pixel filtering). You can always change it later through the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> property. But each change has a small cost, so it's more efficient to just set the initial value correctly.  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImageCore.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> LoadAsClass Constrain the possible image classes to load into. This can force removing (or adding) an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel, or converting contents to grayscale or RGB, regardless of the preferred image file format. Must be a subset of <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>, as other classes cannot be loaded into OpenGL 2D images, otherwise you may get <a class=\"normal\" href=\"CastleGLImages.EImageClassNotSupportedForOpenGL.html\">EImageClassNotSupportedForOpenGL</a> exception. Pass empty set [] to load into any allowed class (it's equivalent to passing LoadAsClass = <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>).  <p>You can pass e.g. [<a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>] to force loading into an RGB image without an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel (it will be stripped from the image if necessary). ASmoothScaling The initial value of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a>, determines whether the image scaling is smooth (bilinear filtering) or not (nearest-pixel filtering). You can always change it later through the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> property. But each change has a small cost, so it's more efficient to just set the initial value correctly.", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Create"},
     {"title": "CastleGLImages.TGLImageCore.Destroy", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Destroy"},
     {"title": "CastleGLImages.TGLImageCore.Rect", "text": " Always (Left,Bottom) are zero, and (Width,Height) correspond to image sizes.    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Rect"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "  <p>The X, Y parameters determine where the left-bottom corner of the image will be placed (from 0 to size - 1). The overloaded version without X, Y parameters uses current <a class=\"normal\" href=\"CastleGLUtils.html#WindowPos\">WindowPos</a>.  <p>You should only use this inside <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a>. We require that current projection is 2D and lighting / depth test and such are off, which is the default state there.  <p>The image is drawn in 2D. In normal circumstances 1 pixel of the image is just placed over 1 pixel of the screen, and we draw the whole image. But you can use the overloaded versions where you specify DrawWidth, DrawHeight or ScreenRect, and then the indicated image portion is stretched over the designated screen area. Note: if you plan to use such stretching when drawing the image, then you usually want to create the image with <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> = <code>True</code> (otherwise the scaling will look pixelated).  <p>Note that the image position (ImageX, ImageY) is specified like a texture coordinate. So (0, 0) is actually the left-bottom corner of the left-bottom pixel, and (Width,Height) is the right-top corner of the right-top pixel. That is why image position and sizes are floats, it makes sense to render partial pixels this way (make sure you have <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> = <code>True</code> to get nice scaling of image contents).  <p>You can also flip the image horizontally or vertically, e.g. use ImageX = Width and ImageWidth = -Width to mirror image horizontally. Although it's usually more comfortable to flip using <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#DrawFlipped\">DrawFlipped</a> methods.  <p>    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw"},
     {"title": "CastleGLImages.TGLImageCore.DrawFlipped", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#DrawFlipped"},
     {"title": "CastleGLImages.TGLImageCore.DrawFlipped", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#DrawFlipped"},
     {"title": "CastleGLImages.TGLImageCore.DrawFlipped", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#DrawFlipped"},
     {"title": "CastleGLImages.TGLImageCore.Draw3x3", "text": "  <p>Just like the regular <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw\">Draw</a> method, this fills a rectangle on the 2D screen, with bottom-left corner in (X, Y), and size (DrawWidth, DrawHeight). The image is divided into 3 * 3 = 9 parts:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>4 corners, used to fill the corners of the screen rectangle. They are not stretched.</p></li>   <li><p>4 sides, used to fill the sides of the screen rectangle between the corners. They are scaled in one dimension, to fill the space between corners completely.</p></li>   <li><p>the inside. Used to fill the rectangular inside. Scaled in both dimensions as necessary.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw3x3"},
     {"title": "CastleGLImages.TGLImageCore.Draw3x3", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw3x3"},
     {"title": "CastleGLImages.TGLImageCore.Draw3x3", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Draw3x3"},
     {"title": "CastleGLImages.TGLImageCore.Load", "text": " Use this to efficiently replace the image contents on GPU. Updates the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Width\">Width</a>, <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Height\">Height</a>, <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">Alpha</a> to correspond to new image.    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Load"},
     {"title": "CastleGLImages.TGLImageCore.PrepareResources", "text": " For descendants that load some stuf on demand (<a class=\"normal\" href=\"CastleGLImages.TGLImageOnDemand.html\">TGLImageOnDemand</a> and <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a>) this method can be used to force loading it now (if possible). This is only useful if you want to avoid slowdown when loading it later, and prefer to do the loading now.    ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#PrepareResources"},
     {"title": "CastleGLImages.TGLImageCore.Width", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Width"},
     {"title": "CastleGLImages.TGLImageCore.Height", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Height"},
     {"title": "CastleGLImages.TGLImageCore.Alpha", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleImages.html#acAuto\">acAuto</a> means to guess correct <code>alpha</code> channel from the loaded image contents, and the current <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Color\">Color</a>. We use <i><code>alpha</code> blending</i> if the loaded image <code>alpha</code> indicates so, or <code>Color[3] &lt; 1</code>. Otherwise we use <i><code>alpha</code> testing</i> if the loaded image <code>alpha</code> indicates so. Otherwise we don't use any <code>alpha</code>, we render image opaque.</p></li>   <li><p><a class=\"normal\" href=\"CastleImages.html#acNone\">acNone</a> means to ignore it.</p></li>   <li><p><a class=\"normal\" href=\"CastleImages.html#acTest\">acTest</a> means to render with <code>alpha</code>-test.</p></li>   <li><p><a class=\"normal\" href=\"CastleImages.html#acBlending\">acBlending</a> means to render with blending.</p></li> </ul>  <p>  <p>This is initialized based on loaded image class and data. This means that e.g. if you have smooth <code>alpha</code> channel in the image, it will be automatically rendered with nice blending.  <p>You can change the value of this property to force a specific rendering method, for example to force using <code>alpha</code> test or <code>alpha</code> blending regardless of <code>alpha</code> values. Or to disable <code>alpha</code> channel usage, because your image must always cover pixels underneath.  <p>Remember that you can also change the <code>alpha</code> channel existence at loading: use LoadAsClass parameters of <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> or <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Create\">TGLImageCore.Create</a> to force your image to have/don't have an <code>alpha</code> channel (e.g. use LoadAsClass=[<a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>] to force RGB image without <code>alpha</code>, use LoadAsClass=[<a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a>] to force <code>alpha</code> channel). ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Alpha"},
     {"title": "CastleGLImages.TGLImageCore.BlendingSourceFactor", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#BlendingSourceFactor"},
     {"title": "CastleGLImages.TGLImageCore.BlendingDestinationFactor", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#BlendingDestinationFactor"},
     {"title": "CastleGLImages.TGLImageCore.BlendingConstantColor", "text": " Used only if blending (see <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">Alpha</a>). By default, opaque <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#BlendingConstantColor"},
     {"title": "CastleGLImages.TGLImageCore.ScaleCorners", "text": " This is especially useful for UI scaling, see <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">TUIContainer.UIScaling</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">TUIControl.UIScale</a>. ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#ScaleCorners"},
     {"title": "CastleGLImages.TGLImageCore.IgnoreTooLargeCorners", "text": " Set this to <code>True</code> when it's perfectly possible (you do not want to even see it in log) for <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw3x3\">Draw3x3</a> calls to fail because corners are larger than draw area size. ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#IgnoreTooLargeCorners"},
     {"title": "CastleGLImages.TGLImageCore.Color", "text": " By default this is <a class=\"normal\" href=\"CastleColors.html#White\">White</a>, which is (1, 1, 1, 1) as RGBA, and it means that texture contents are not actually modified. This case is also optimized when possible, to no multiplication will actually happen.  <p>Note that the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> of this color does not determine our <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> rendering mode (it cannot, as you can change this color at any point, and after creation the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">Alpha</a> is never automatically updated). If you set a color with <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> &lt;&gt; 1, consider setting also <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">Alpha</a> property to whatever you need.  <p>Note that if use <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html\">TGrayscaleImage</a> with <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html#TreatAsAlpha\">TGrayscaleImage.TreatAsAlpha</a> (which means that texture does not contain any RGB information), then only this color's RGB values determine the drawn RGB color. ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Color"},
     {"title": "CastleGLImages.TGLImageCore.SmoothScaling", "text": " This is important if you draw the image such that one image pixel does not perfectly fit one screen pixel.  <p>If you will not ever do any scaling, then set this to <code>False</code>. It may cause minimally faster drawing, and avoids any possible artifacts from bilinear filtering.  <p>If you will do scaling, you usually want to set this to <code>True</code>, unless you deliberately want a pixelated look (for pixelart).  <p>Note that switching this property after this object is constructed is possible, but costly. ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#SmoothScaling"},
     {"title": "CastleGLImages.TGLImageCore.ScalingPossible", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#ScalingPossible"},
     {"title": "CastleGLImages.TGLImageCore.CenterX", "text": " Value from 0 to 1. Default value 0.5. ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#CenterX"},
     {"title": "CastleGLImages.TGLImageCore.CenterY", "text": " Value from 0 to 1. Default value 0.5. ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#CenterY"},
     {"title": "CastleGLImages.TGLImageCore.Rotation", "text": " Increase to rotate in a counter-clockwise direction. Hint: use function like ArcTan2 from Math unit to convert 2D direction into a rotation angle. ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Rotation"},
     {"title": "CastleGLImages.TGLImageCore.Clip", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#Clip"},
     {"title": "CastleGLImages.TGLImageCore.ClipLine", "text": " Given a line (A, B, C) and pixel (x, y), the pixel is clipped (rejected) if <code>A * x + B * y + C &lt; 0</code>. This provides a functionality similar to desktop OpenGL <a class=\"normal\" href=\"CastleGLUtils.html#glClipPlane\">glClipPlane</a> (working on all platforms &ndash; desktop, mobile). ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#ClipLine"},
     {"title": "CastleGLImages.TGLImageCore.TColorTreatment", "text": "  ctPureTexture Use texture color to draw.   ctColorMultipliesTexture Use constant color * texture (on all RGBA channels).   ctColorMultipliesTextureAlpha Use constant color for RGB, for alpha use constant color.a * texture.  Useful when texture has no alpha information. ", "tags": "", "loc": "CastleGLImages.TGLImageCore.html#TColorTreatment"},
     {"title": "CastleGLImages.TGLImage", "text": "  <p>This is a descendant of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a> that is easier to use: it can be created and destroyed at any moment (no need to worry about whether OpenGL context is created), and an instance can survive OpenGL context close + open.  <p>The catch is that this keeps the image pixels in normal memory all the time. So it uses a little more memory than <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a>. ", "tags": "", "loc": "CastleGLImages.TGLImage.html"},
     {"title": "CastleGLImages.TGLImage.Create", "text": "  <p>  <p>  Image Initial image contents. The <code>Image</code> instance passed here must exist throughout the whole lifetime of this <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a> instance (so don't free it earlier). It can be automatically freed by us, if <a class=\"normal\" href=\"CastleGLImages.TGLImage.html#OwnsImage\">OwnsImage</a> = <code>True</code>.  EImageClassNotSupportedForOpenGL When Image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.TGLImage.html#Create"},
     {"title": "CastleGLImages.TGLImage.Create", "text": "  <p>This constructor is provided only for compatibility with previous <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a> in CGE &lt;= 5.2.0. It assumes that AImage instance passed here is owned by the caller (we cannot free it), and moreover it may become freed at any point (so we actually have to make a copy of it to be safe).  <p>It is advised to use one of the other constructors, for example use the constructor with additional parameter &quot;AOwnsImage&quot;. The <code>Image</code> instance passed there must exist throughout the lifetime of this instance, regardless of &quot;AOwnsImage&quot;.  <p>Or use <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a> class.    ", "tags": "", "loc": "CastleGLImages.TGLImage.html#Create"},
     {"title": "CastleGLImages.TGLImage.Create", "text": "  <p>  <p>  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImage.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> ASmoothScaling The initial value of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a>, determines whether the image scaling is smooth (bilinear filtering) or not (nearest-pixel filtering). You can always change it later through the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> property. But each change has a small cost, so it's more efficient to just set the initial value correctly.  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImage.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> ASmoothScaling The initial value of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a>, determines whether the image scaling is smooth (bilinear filtering) or not (nearest-pixel filtering). You can always change it later through the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> property. But each change has a small cost, so it's more efficient to just set the initial value correctly.", "tags": "", "loc": "CastleGLImages.TGLImage.html#Create"},
     {"title": "CastleGLImages.TGLImage.Create", "text": "  <p>  <p>  <p>  <p>  <p>  <p>  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImage.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> LoadAsClass Constrain the possible image classes to load into. This can force removing (or adding) an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel, or converting contents to grayscale or RGB, regardless of the preferred image file format. Must be a subset of <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>, as other classes cannot be loaded into OpenGL 2D images, otherwise you may get <a class=\"normal\" href=\"CastleGLImages.EImageClassNotSupportedForOpenGL.html\">EImageClassNotSupportedForOpenGL</a> exception. Pass empty set [] to load into any allowed class (it's equivalent to passing LoadAsClass = <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>).  <p>You can pass e.g. [<a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>] to force loading into an RGB image without an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel (it will be stripped from the image if necessary). ResizeToX After loading, resize to given width. Pass 0 to not resize width. ResizeToY After loading, resize to given height. Pass 0 to not resize height. Interpolation If any resizing will be needed (if ResizeToX / ResizeToY parameters request some specific size, and it is different than loaded image size) then the resize operation will use given interpolation.  EImageClassNotSupportedForOpenGL When image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.TGLImage.html#Create"},
     {"title": "CastleGLImages.TGLImage.Create", "text": "  <p>  <p>  <p>  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImage.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> LoadAsClass Constrain the possible image classes to load into. This can force removing (or adding) an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel, or converting contents to grayscale or RGB, regardless of the preferred image file format. Must be a subset of <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>, as other classes cannot be loaded into OpenGL 2D images, otherwise you may get <a class=\"normal\" href=\"CastleGLImages.EImageClassNotSupportedForOpenGL.html\">EImageClassNotSupportedForOpenGL</a> exception. Pass empty set [] to load into any allowed class (it's equivalent to passing LoadAsClass = <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>).  <p>You can pass e.g. [<a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>] to force loading into an RGB image without an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel (it will be stripped from the image if necessary). ASmoothScaling The initial value of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a>, determines whether the image scaling is smooth (bilinear filtering) or not (nearest-pixel filtering). You can always change it later through the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> property. But each change has a small cost, so it's more efficient to just set the initial value correctly.  URL URL (or filename) from which to load the image. Often you want to pass here the result ot <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function, like:  <p></p>  <pre class=\"longcode\">Image := TGLImage.Create(ApplicationData(<span class=\"pascal_string\">'textures/my_image.png'</span>), <span class=\"pascal_numeric\"></span>...);</pre>  <p> LoadAsClass Constrain the possible image classes to load into. This can force removing (or adding) an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel, or converting contents to grayscale or RGB, regardless of the preferred image file format. Must be a subset of <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>, as other classes cannot be loaded into OpenGL 2D images, otherwise you may get <a class=\"normal\" href=\"CastleGLImages.EImageClassNotSupportedForOpenGL.html\">EImageClassNotSupportedForOpenGL</a> exception. Pass empty set [] to load into any allowed class (it's equivalent to passing LoadAsClass = <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>).  <p>You can pass e.g. [<a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>] to force loading into an RGB image without an <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Alpha\">alpha</a> channel (it will be stripped from the image if necessary). ASmoothScaling The initial value of <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a>, determines whether the image scaling is smooth (bilinear filtering) or not (nearest-pixel filtering). You can always change it later through the <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">SmoothScaling</a> property. But each change has a small cost, so it's more efficient to just set the initial value correctly.", "tags": "", "loc": "CastleGLImages.TGLImage.html#Create"},
     {"title": "CastleGLImages.TGLImage.Destroy", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImage.html#Destroy"},
     {"title": "CastleGLImages.TGLImage.Load", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImage.html#Load"},
     {"title": "CastleGLImages.TGLImage.PrepareResources", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImage.html#PrepareResources"},
     {"title": "CastleGLImages.TGLImage.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImage.html#Draw"},
     {"title": "CastleGLImages.TGLImage.Image", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImage.html#Image"},
     {"title": "CastleGLImages.TGLImage.OwnsImage", "text": " ", "tags": "", "loc": "CastleGLImages.TGLImage.html#OwnsImage"},
     {"title": "CastleGLImages.TGLImageOnDemand", "text": "  <p>The image is loaded from disk on demand (only once needed), and the OpenGL resources are also initilized on demand. This is very efficient for memory usage, but the catch is that even the image sizes are not known before the image will be loaded (which will happen at nearest draw, or when you explicitly call <a class=\"normal\" href=\"CastleGLImages.TGLImageOnDemand.html#PrepareResources\">PrepareResources</a>).  <p>Like <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a>, this image instance can be created and destroyed at any moment (no need to worry about whether OpenGL context is created), and an instance can survive OpenGL context close + open. ", "tags": "", "loc": "CastleGLImages.TGLImageOnDemand.html"},
     {"title": "CastleGLImages.TGLImageOnDemand.Create", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageOnDemand.html#Create"},
     {"title": "CastleGLImages.TGLImageOnDemand.Destroy", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageOnDemand.html#Destroy"},
     {"title": "CastleGLImages.TGLImageOnDemand.PrepareResources", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageOnDemand.html#PrepareResources"},
     {"title": "CastleGLImages.TGLImageOnDemand.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLImageOnDemand.html#Draw"},
     {"title": "CastleGLImages.ECannotSaveTextureContents", "text": " ", "tags": "", "loc": "CastleGLImages.ECannotSaveTextureContents.html"},
     {"title": "CastleGLImages.EFramebufferError", "text": " ", "tags": "", "loc": "CastleGLImages.EFramebufferError.html"},
     {"title": "CastleGLImages.EFramebufferSizeTooLow", "text": " ", "tags": "", "loc": "CastleGLImages.EFramebufferSizeTooLow.html"},
     {"title": "CastleGLImages.EFramebufferInvalid", "text": " ", "tags": "", "loc": "CastleGLImages.EFramebufferInvalid.html"},
     {"title": "CastleGLImages.TGLRenderToTexture", "text": " Uses framebuffer (if available), and has fallback to glCopyTexSubImage2D for (really) old OpenGL implementations. ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html"},
     {"title": "CastleGLImages.TGLRenderToTexture.Create", "text": " Doesn't require OpenGL context, and doesn't initialize the framebuffer. You'll have to use <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextOpen\">GLContextOpen</a> before actually making Render.    ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#Create"},
     {"title": "CastleGLImages.TGLRenderToTexture.Destroy", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#Destroy"},
     {"title": "CastleGLImages.TGLRenderToTexture.SetTexture", "text": "  <p>May be changed also when OpenGL stuff (framebuffer) is already initialized. This is useful, as it allows you to reuse framebuffer setup for rendering to different textures (as long as other settings are Ok, like Width and Height).  <p>It may even be changed between <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderBegin\">RenderBegin</a> and <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderEnd\">RenderEnd</a>. In fact, this is advised, if you have to call <code>SetTexture</code> often: <code>SetTexture</code> call outside of <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderBegin\">RenderBegin</a> / <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderEnd\">RenderEnd</a> causes two costly BindFramebuffer calls, that may be avoided when you're already between <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderBegin\">RenderBegin</a> / <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderEnd\">RenderEnd</a>.    ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#SetTexture"},
     {"title": "CastleGLImages.TGLRenderToTexture.GLContextOpen", "text": "  <p>When OpenGL stuff is initialized (from <code>GLContextOpen</code> until <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextClose\">GLContextClose</a> or destruction) this class is tied to the current OpenGL context.  <p>  <p>    EFramebufferSizeTooLow When required <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Width\">Width</a> x <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Height\">Height</a> is larger than maximum renderbuffer (single buffer within framebuffer) size. EFramebufferInvalid When framebuffer is used, and check glCheckFramebufferStatusEXT fails. This should not happen, it means a programmer error. Or &quot;unsupported&quot; result of glCheckFramebufferStatusEXT (that is possible regardless of programmer) we have a nice fallback to non-FBO implementation.", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#GLContextOpen"},
     {"title": "CastleGLImages.TGLRenderToTexture.GLContextClose", "text": " This is also automatically called in destructor.    ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#GLContextClose"},
     {"title": "CastleGLImages.TGLRenderToTexture.RenderBegin", "text": " Commands following this will render to the texture image.  <p>When framebuffer is used, it's bound here.  <p>When framebuffer is not used, this doesn't do anything. So note that all rendering will be done to normal screen in this case.    ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#RenderBegin"},
     {"title": "CastleGLImages.TGLRenderToTexture.RenderEnd", "text": "  <p>When framebuffer is used, this binds the normal screen back.  <p>When framebuffer is not used, this does actual copying from the screen to the texture using glCopyTexSubImage2D. We use glCopyTexSubImage2D &mdash; which means texture internal format should already be initialized! If you don't have any initial texture data, you can always initialize by glTexImage2D with <code>Nil</code> as pointer to data.  <p>During copying, we may change OpenGL bound 2D texture and read buffer. So their values are ignored, and may be changed arbitrarily, by this method.  <p>  RenderBeginFollows This allows for an optimizaion, to minimize the number of BindFramebuffer calls when you render many textures in the row using the same <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html\">TGLRenderToTexture</a>. If <code>True</code>, then you <b>must</b> call <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderBegin\">RenderBegin</a> after this (before drawing anything else to OpenGL). We will internally leave framebuffer bound, which means that this <code>RenderEnd</code> and the very next <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderBegin\">RenderBegin</a> will actually do nothing.  RenderBeginFollows This allows for an optimizaion, to minimize the number of BindFramebuffer calls when you render many textures in the row using the same <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html\">TGLRenderToTexture</a>. If <code>True</code>, then you <b>must</b> call <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderBegin\">RenderBegin</a> after this (before drawing anything else to OpenGL). We will internally leave framebuffer bound, which means that this <code>RenderEnd</code> and the very next <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderBegin\">RenderBegin</a> will actually do nothing.", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#RenderEnd"},
     {"title": "CastleGLImages.TGLRenderToTexture.GenerateMipmap", "text": " This will use glGenerateMipmap call, which is actually a part of EXT_framebuffer_object extension (or GL core together with framebuffer in GL core), so it will always raise <a class=\"normal\" href=\"CastleGLUtils.EGenerateMipmapNotAvailable.html\">EGenerateMipmapNotAvailable</a> if framebuffer is not available.  <p>You should use <a class=\"normal\" href=\"CastleGLUtils.html#HasGenerateMipmap\">HasGenerateMipmap</a> and never call this if not <a class=\"normal\" href=\"CastleGLUtils.html#HasGenerateMipmap\">HasGenerateMipmap</a>, if you don't want to get this exception.  <p>    EGenerateMipmapNotAvailable If glGenerateMipmap not available.", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#GenerateMipmap"},
     {"title": "CastleGLImages.TGLRenderToTexture.ColorBuffer", "text": " Use only when Buffer = <a class=\"normal\" href=\"CastleGLImages.html#tbNone\">tbNone</a>, between <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextOpen\">GLContextOpen</a> and <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextClose\">GLContextClose</a>. This is the buffer name that you should pass to <a class=\"normal\" href=\"CastleGLImages.html#SaveScreen_NoFlush\">SaveScreen_NoFlush</a>, currently it's just rbColorAttachment0 if we actually have FBO or rbBack if not.    ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#ColorBuffer"},
     {"title": "CastleGLImages.TGLRenderToTexture.Width", "text": " You cannot change them when OpenGL stuff is already initialized (after <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextOpen\">GLContextOpen</a> and before <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextClose\">GLContextClose</a> or destructor).  ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#Width"},
     {"title": "CastleGLImages.TGLRenderToTexture.Height", "text": " ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#Height"},
     {"title": "CastleGLImages.TGLRenderToTexture.Texture", "text": " If <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Buffer\">Buffer</a> is <a class=\"normal\" href=\"CastleGLImages.html#tbColor\">tbColor</a> or <a class=\"normal\" href=\"CastleGLImages.html#tbColorAndDepth\">tbColorAndDepth</a> then we will capture here color contents. If <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Buffer\">Buffer</a> is <a class=\"normal\" href=\"CastleGLImages.html#tbDepth\">tbDepth</a> then we will capture here depth contents (useful e.g. for shadow maps). If If <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Buffer\">Buffer</a> is <a class=\"normal\" href=\"CastleGLImages.html#tbNone\">tbNone</a>, this is ignored.  <p>We require this texture to be set to a valid texture (not 0) before <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextOpen\">GLContextOpen</a> (unless Buffer is <a class=\"normal\" href=\"CastleGLImages.html#tbNone\">tbNone</a>). Also, if you later change it, be careful to assign here other textures of only the same size and format. This allows us to call glCheckFramebufferStatusEXT (and eventually fallback to non-stencil version) right at <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextOpen\">GLContextOpen</a> call, and no need to repeat it (e.g. at each <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderBegin\">RenderBegin</a>).  <p>Changed by <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#SetTexture\">SetTexture</a>. ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#Texture"},
     {"title": "CastleGLImages.TGLRenderToTexture.TextureTarget", "text": " This is GL_TEXTURE_2D for normal 2D textures, but may also be GL_TEXTURE_RECTANGLE, GL_TEXTURE_CUBE_MAP_POSITIVE_X etc. for other texture types.  <p>Companion to <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Texture\">Texture</a> property, changed together by <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#SetTexture\">SetTexture</a>. ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#TextureTarget"},
     {"title": "CastleGLImages.TGLRenderToTexture.CompleteTextureTarget", "text": " &quot;Bind target&quot; means that it describes the whole texture, for example for cube map it should be GL_TEXTURE_CUBE_MAP. ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#CompleteTextureTarget"},
     {"title": "CastleGLImages.TGLRenderToTexture.DepthTexture", "text": " Note that this is not used when <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Buffer\">Buffer</a> = <a class=\"normal\" href=\"CastleGLImages.html#tbDepth\">tbDepth</a> (the <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Texture\">Texture</a> and <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#TextureTarget\">TextureTarget</a> are used then). This must be set before <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextOpen\">GLContextOpen</a>, and not modified later until <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextClose\">GLContextClose</a>. ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#DepthTexture"},
     {"title": "CastleGLImages.TGLRenderToTexture.DepthTextureTarget", "text": " ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#DepthTextureTarget"},
     {"title": "CastleGLImages.TGLRenderToTexture.Buffer", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleGLImages.html#tbColor\">tbColor</a>: the <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Texture\">Texture</a> will contain color contents.</p></li>   <li><p><a class=\"normal\" href=\"CastleGLImages.html#tbDepth\">tbDepth</a>: the <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Texture\">Texture</a> will contain depth contents.</p></li>   <li><p><a class=\"normal\" href=\"CastleGLImages.html#tbColorAndDepth\">tbColorAndDepth</a>: the <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Texture\">Texture</a> will contain color contents, the <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#DepthTexture\">DepthTexture</a> will contain depth contents.</p></li>   <li><p><a class=\"normal\" href=\"CastleGLImages.html#tbNone\">tbNone</a>: we will not capture screen contents to any texture at all. This is useful for rendering a screen that you want to manually capture to normal memory with glReadPixels (see also <a class=\"normal\" href=\"CastleGLImages.html#SaveScreen_NoFlush\">SaveScreen_NoFlush</a> in this unit or <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#SaveScreen\">TCastleWindowCustom.SaveScreen</a>). Be sure to capture the screen before <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#RenderEnd\">RenderEnd</a>.</p></li> </ul>  <p>  <p>For <a class=\"normal\" href=\"CastleGLImages.html#tbDepth\">tbDepth</a> and <a class=\"normal\" href=\"CastleGLImages.html#tbColorAndDepth\">tbColorAndDepth</a>, the texture that will receive depth contents must have GL_DEPTH_COMPONENT* format, and we'll render depth buffer contents to it.  <p>For <a class=\"normal\" href=\"CastleGLImages.html#tbDepth\">tbDepth</a>, if the framebuffer is used (normal on recent GPUs), we will not write to the color buffer at all, so this is quite optimal for rendering shadow maps.  <p>This must be set before <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextOpen\">GLContextOpen</a>, cannot be changed later. ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#Buffer"},
     {"title": "CastleGLImages.TGLRenderToTexture.Stencil", "text": "  <p>This is usually safe, as FBO spec even requires that some format with stencil buffer must be available.  <p>However, <i>this has a high chance to fail if you need <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Buffer\">Buffer</a> = <a class=\"normal\" href=\"CastleGLImages.html#tbDepth\">tbDepth</a> or <a class=\"normal\" href=\"CastleGLImages.html#tbColorAndDepth\">tbColorAndDepth</a></i>. Reason: on GPU with packed depth and stencil buffer (see <a  href=\"http://www.opengl.org/registry/specs/EXT/packed_depth_stencil.txt\">http://www.opengl.org/registry/specs/EXT/packed_depth_stencil.txt</a> and <a  href=\"https://www.khronos.org/registry/OpenGL/extensions/OES/OES_packed_depth_stencil.txt\">https://www.khronos.org/registry/OpenGL/extensions/OES/OES_packed_depth_stencil.txt</a>) FBO with separate depth and stencil may not be possible. And when your texture is GL_DEPTH_COMPONENT, this is a must. In the future, we could allow some flag to allow you to use texture with GL_DEPTH_STENCIL format, this would work with packed depth/stencil (actually, even require it). For now, <i>it's advised to turn off <code>Stencil</code> when you use <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Buffer\">Buffer</a> = <a class=\"normal\" href=\"CastleGLImages.html#tbDepth\">tbDepth</a> or <a class=\"normal\" href=\"CastleGLImages.html#tbColorAndDepth\">tbColorAndDepth</a></i>. ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#Stencil"},
     {"title": "CastleGLImages.TGLRenderToTexture.ColorBufferAlpha", "text": " Relevant only when Buffer = <a class=\"normal\" href=\"CastleGLImages.html#tbNone\">tbNone</a> (as in all other cases, we do not have the color buffer &mdash; colors either go into some texture or are ignored).  <p>This must be set before <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#GLContextOpen\">GLContextOpen</a>, cannot be changed later. ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#ColorBufferAlpha"},
     {"title": "CastleGLImages.TGLRenderToTexture.MultiSampling", "text": " Values greater than 1 mean that <code>multisampling</code> is used, which enables anti-aliasing. Note that all your textures (in <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Texture\">Texture</a>, <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#DepthTexture\">DepthTexture</a>) must be created with the same number of samples.  <p>Ignored if not GLFBOMultiSampling. ", "tags": "", "loc": "CastleGLImages.TGLRenderToTexture.html#MultiSampling"},
     {"title": "CastleGLImages.TTextureMemoryProfiler", "text": " See <a class=\"normal\" href=\"CastleGLImages.html#TextureMemoryProfiler\">TextureMemoryProfiler</a> for usage documentation. ", "tags": "", "loc": "CastleGLImages.TTextureMemoryProfiler.html"},
     {"title": "CastleGLImages.TTextureMemoryProfiler.Create", "text": "    ", "tags": "", "loc": "CastleGLImages.TTextureMemoryProfiler.html#Create"},
     {"title": "CastleGLImages.TTextureMemoryProfiler.Destroy", "text": "    ", "tags": "", "loc": "CastleGLImages.TTextureMemoryProfiler.html#Destroy"},
     {"title": "CastleGLImages.TTextureMemoryProfiler.Allocate", "text": " This should be used only by code doing direct OpenGL operations.    ", "tags": "", "loc": "CastleGLImages.TTextureMemoryProfiler.html#Allocate"},
     {"title": "CastleGLImages.TTextureMemoryProfiler.Deallocate", "text": " This should be used only by code doing direct OpenGL operations.    ", "tags": "", "loc": "CastleGLImages.TTextureMemoryProfiler.html#Deallocate"},
     {"title": "CastleGLImages.TTextureMemoryProfiler.Summary", "text": "    ", "tags": "", "loc": "CastleGLImages.TTextureMemoryProfiler.html#Summary"},
     {"title": "CastleGLImages.TTextureMemoryProfiler.MipmapsSize", "text": " Assumes that all mipmaps are generated, as by <a class=\"normal\" href=\"CastleGLUtils.html#GenerateMipmap\">GenerateMipmap</a> call.    ", "tags": "", "loc": "CastleGLImages.TTextureMemoryProfiler.html#MipmapsSize"},
     {"title": "CastleGLImages.TTextureMemoryProfiler.Enabled", "text": " ", "tags": "", "loc": "CastleGLImages.TTextureMemoryProfiler.html#Enabled"},
     {"title": "CastleGLImages.TGLVideo", "text": " Use <a class=\"normal\" href=\"CastleGLImages.TGLVideo3D.html\">TGLVideo3D</a> to have a list of normal OpenGL textures, e.g. for rendering video as texture on free 3D objects. Use <a class=\"normal\" href=\"CastleGLImages.TGLVideo2D.html\">TGLVideo2D</a> to have a list of GUI textures (<a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a>), e.g. for rendering video as simple 2D control. ", "tags": "", "loc": "CastleGLImages.TGLVideo.html"},
     {"title": "CastleGLImages.TGLVideo.Create", "text": "  <p><a class=\"normal\" href=\"CastleVideos.TVideo.html\">TVideo</a> passed here must be already <a class=\"normal\" href=\"CastleVideos.TVideo.html#Loaded\">Loaded</a>.  <p>Note that this class doesn't descend or keep reference to <a class=\"normal\" href=\"CastleVideos.TVideo.html\">TVideo</a> instance. The idea is that after creating <a class=\"normal\" href=\"CastleGLImages.TGLVideo.html\">TGLVideo</a> instance, you can often free original <a class=\"normal\" href=\"CastleVideos.TVideo.html\">TVideo</a> instance (if you care only about playing the movie). This can conserve memory greatly, as <a class=\"normal\" href=\"CastleVideos.TVideo.html\">TVideo</a> keeps all frames in the memory, and so is rather memory-costly. (Actually, <a class=\"normal\" href=\"CastleGLImages.TGLVideo.html\">TGLVideo</a> itself may eat a lot of texture memory, so be careful with large videos anyway.)    ", "tags": "", "loc": "CastleGLImages.TGLVideo.html#Create"},
     {"title": "CastleGLImages.TGLVideo.IndexFromTime", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLVideo.html#IndexFromTime"},
     {"title": "CastleGLImages.TGLVideo.Duration", "text": " This is just the number of frames <a class=\"normal\" href=\"CastleGLImages.TGLVideo.html#Count\">Count</a> divided by <a class=\"normal\" href=\"CastleGLImages.TGLVideo.html#FramesPerSecond\">FramesPerSecond</a>.    ", "tags": "", "loc": "CastleGLImages.TGLVideo.html#Duration"},
     {"title": "CastleGLImages.TGLVideo.Count", "text": " ", "tags": "", "loc": "CastleGLImages.TGLVideo.html#Count"},
     {"title": "CastleGLImages.TGLVideo.FramesPerSecond", "text": " ", "tags": "", "loc": "CastleGLImages.TGLVideo.html#FramesPerSecond"},
     {"title": "CastleGLImages.TGLVideo.TimeLoop", "text": " ", "tags": "", "loc": "CastleGLImages.TGLVideo.html#TimeLoop"},
     {"title": "CastleGLImages.TGLVideo.TimeBackwards", "text": " ", "tags": "", "loc": "CastleGLImages.TGLVideo.html#TimeBackwards"},
     {"title": "CastleGLImages.TGLVideo.Width", "text": " ", "tags": "", "loc": "CastleGLImages.TGLVideo.html#Width"},
     {"title": "CastleGLImages.TGLVideo.Height", "text": " ", "tags": "", "loc": "CastleGLImages.TGLVideo.html#Height"},
     {"title": "CastleGLImages.TGLVideo3D", "text": " ", "tags": "", "loc": "CastleGLImages.TGLVideo3D.html"},
     {"title": "CastleGLImages.TGLVideo3D.Create", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLVideo3D.html#Create"},
     {"title": "CastleGLImages.TGLVideo3D.Destroy", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLVideo3D.html#Destroy"},
     {"title": "CastleGLImages.TGLVideo3D.GLTextureFromTime", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLVideo3D.html#GLTextureFromTime"},
     {"title": "CastleGLImages.TGLVideo2D", "text": " ", "tags": "", "loc": "CastleGLImages.TGLVideo2D.html"},
     {"title": "CastleGLImages.TGLVideo2D.Create", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLVideo2D.html#Create"},
     {"title": "CastleGLImages.TGLVideo2D.Create", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLVideo2D.html#Create"},
     {"title": "CastleGLImages.TGLVideo2D.Create", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLVideo2D.html#Create"},
     {"title": "CastleGLImages.TGLVideo2D.Destroy", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLVideo2D.html#Destroy"},
     {"title": "CastleGLImages.TGLVideo2D.GLImageFromTime", "text": "    ", "tags": "", "loc": "CastleGLImages.TGLVideo2D.html#GLImageFromTime"},
     {"title": "CastleGLImages.TSpriteAnimationFrame", "text": " Part of the <a class=\"normal\" href=\"CastleGLImages.TSpriteAnimation.html\">TSpriteAnimation</a>. ", "tags": "", "loc": "CastleGLImages.TSpriteAnimationFrame.html"},
     {"title": "CastleGLImages.TSpriteAnimationFrame.Frame", "text": " ", "tags": "", "loc": "CastleGLImages.TSpriteAnimationFrame.html#Frame"},
     {"title": "CastleGLImages.TSpriteAnimationFrame.Duration", "text": " ", "tags": "", "loc": "CastleGLImages.TSpriteAnimationFrame.html#Duration"},
     {"title": "CastleGLImages.TSpriteAnimation", "text": " Used by <a class=\"normal\" href=\"CastleGLImages.TSprite.html#AddAnimation\">TSprite.AddAnimation</a> and TSprite.PlayAnimation. Animation is defined as an array of frames. ", "tags": "", "loc": "CastleGLImages.TSpriteAnimation.html"},
     {"title": "CastleGLImages.TSpriteAnimation.CreateConstantFps", "text": "    ", "tags": "", "loc": "CastleGLImages.TSpriteAnimation.html#CreateConstantFps"},
     {"title": "CastleGLImages.TSpriteAnimation.Create", "text": "    ", "tags": "", "loc": "CastleGLImages.TSpriteAnimation.html#Create"},
     {"title": "CastleGLImages.TSpriteAnimation.Duration", "text": " ", "tags": "", "loc": "CastleGLImages.TSpriteAnimation.html#Duration"},
     {"title": "CastleGLImages.TSprite", "text": " Frames are read from left to right and from top to bottom.  <p>In the simple case, a sprite represents a single animation, and the frames are just in consecutive order.  <p>With the help of &quot;custom animations&quot; feature, you can define many animations in a sprite. Each custom animation is an array of frames with corresponding frames duration. Frames can be in any order. It is valid to use some particural frame many times with different duration time. ", "tags": "", "loc": "CastleGLImages.TSprite.html"},
     {"title": "CastleGLImages.TSprite.Create", "text": "         URL URL of source image. AFrames Total numer of animation frames. AColumns Mumber of columns. ARows Number of rows. ASmoothscaling Enables interpolation, see <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">TGLImageCore.SmoothScaling</a> for details, default <code>True</code>. ATimeLoop Should animation be repeated?, default <code>True</code>. APlay Is animation playing? if not then current frame will be displayed.  URL URL of source image. AFrames Total numer of animation frames. AColumns Mumber of columns. ARows Number of rows. ASmoothscaling Enables interpolation, see <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">TGLImageCore.SmoothScaling</a> for details, default <code>True</code>. ATimeLoop Should animation be repeated?, default <code>True</code>. APlay Is animation playing? if not then current frame will be displayed.", "tags": "", "loc": "CastleGLImages.TSprite.html#Create"},
     {"title": "CastleGLImages.TSprite.CreateFrameSize", "text": "  <p>        AImage Source image (will be owned by this sprite). AFrames Total numer of animation frames. AColumns Number of columns. AFrameWidth Width of each frame. AFrameHeight Height of each frame. ATimeLoop Should animation be repeated?, default <code>True</code>. APlay Is animation playing? if not then current frame will be displayed.  AImage Source image (will be owned by this sprite). AFrames Total numer of animation frames. AColumns Number of columns. AFrameWidth Width of each frame. AFrameHeight Height of each frame. ATimeLoop Should animation be repeated?, default <code>True</code>. APlay Is animation playing? if not then current frame will be displayed.", "tags": "", "loc": "CastleGLImages.TSprite.html#CreateFrameSize"},
     {"title": "CastleGLImages.TSprite.CreateFrameSize", "text": "  <p>         URL URL of source image. AFrames Total numer of animation frames. AColumns Number of columns. AFrameWidth Width of each frame. AFrameHeight Height of each frame. ASmoothscaling Enables interpolation, see <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">TGLImageCore.SmoothScaling</a> for details, default <code>True</code>. ATimeLoop Should animation be repeated?, default True. APlay Is animation playing? if not then current frame will be displayed.  URL URL of source image. AFrames Total numer of animation frames. AColumns Number of columns. AFrameWidth Width of each frame. AFrameHeight Height of each frame. ASmoothscaling Enables interpolation, see <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#SmoothScaling\">TGLImageCore.SmoothScaling</a> for details, default <code>True</code>. ATimeLoop Should animation be repeated?, default True. APlay Is animation playing? if not then current frame will be displayed.", "tags": "", "loc": "CastleGLImages.TSprite.html#CreateFrameSize"},
     {"title": "CastleGLImages.TSprite.Destroy", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Destroy"},
     {"title": "CastleGLImages.TSprite.Update", "text": "   SecondsPassed Time from previous update.  SecondsPassed Time from previous update.", "tags": "", "loc": "CastleGLImages.TSprite.html#Update"},
     {"title": "CastleGLImages.TSprite.Play", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Play"},
     {"title": "CastleGLImages.TSprite.Stop", "text": " When stopped, the <a class=\"normal\" href=\"CastleGLImages.TSprite.html#Time\">Time</a> will not move forward, regardless if you call <a class=\"normal\" href=\"CastleGLImages.TSprite.html#Update\">Update</a>.    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Stop"},
     {"title": "CastleGLImages.TSprite.Pause", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Pause"},
     {"title": "CastleGLImages.TSprite.Draw", "text": "  <p>The overloaded version without AX, AY or ScreenRectangle parameters uses the last position set by <a class=\"normal\" href=\"CastleGLImages.TSprite.html#Move\">Move</a> method. This is the position of the bottom-left frame corner on screen.  <p>The overloaded version without DrawWidth, DrawHeight or ScreenRectangle parameters uses the last size set by <a class=\"normal\" href=\"CastleGLImages.TSprite.html#DrawingWidth\">DrawingWidth</a>, <a class=\"normal\" href=\"CastleGLImages.TSprite.html#DrawingHeight\">DrawingHeight</a> properties. This is the size of the frame on screen.  <p>All versions use the rotation set by the last <a class=\"normal\" href=\"CastleGLImages.TSprite.html#Move\">Move</a> method. This is the rotation of the frame on screen.  <p>The overloaded versions deliberately look and work similar to <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw\">TGLImageCore.Draw</a> versions.     ", "tags": "", "loc": "CastleGLImages.TSprite.html#Draw"},
     {"title": "CastleGLImages.TSprite.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Draw"},
     {"title": "CastleGLImages.TSprite.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Draw"},
     {"title": "CastleGLImages.TSprite.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Draw"},
     {"title": "CastleGLImages.TSprite.Draw", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Draw"},
     {"title": "CastleGLImages.TSprite.DrawFlipped", "text": " These methods ignore the <a class=\"normal\" href=\"CastleGLImages.TSprite.html#HorizontalFlip\">HorizontalFlip</a>, <a class=\"normal\" href=\"CastleGLImages.TSprite.html#VerticalFlip\">VerticalFlip</a>, and <a class=\"normal\" href=\"CastleGLImages.TSprite.html#DiagonalFlip\">DiagonalFlip</a> &ndash; which axis is flipped (if any) depends only on the parameters to these methods.     ", "tags": "", "loc": "CastleGLImages.TSprite.html#DrawFlipped"},
     {"title": "CastleGLImages.TSprite.DrawFlipped", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#DrawFlipped"},
     {"title": "CastleGLImages.TSprite.Move", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Move"},
     {"title": "CastleGLImages.TSprite.AddAnimation", "text": "      AAnimation The animation information. The animation instance (<a class=\"normal\" href=\"CastleGLImages.TSpriteAnimation.html\">TSpriteAnimation</a>) becomes owned by this object, so don't free it yourself. AnimationFrames The animation information can also be given as a simple list of frame indexes. In this case, all frames are assumed to take the same time: <code>1 / <a class=\"normal\" href=\"CastleGLImages.TSprite.html#FramesPerSecond\">FramesPerSecond</a></code>. The animation index, that can be used with <a class=\"normal\" href=\"CastleGLImages.TSprite.html#SwitchToAnimation\">SwitchToAnimation</a>. AAnimation The animation information. The animation instance (<a class=\"normal\" href=\"CastleGLImages.TSpriteAnimation.html\">TSpriteAnimation</a>) becomes owned by this object, so don't free it yourself. AnimationFrames The animation information can also be given as a simple list of frame indexes. In this case, all frames are assumed to take the same time: <code>1 / <a class=\"normal\" href=\"CastleGLImages.TSprite.html#FramesPerSecond\">FramesPerSecond</a></code>.", "tags": "", "loc": "CastleGLImages.TSprite.html#AddAnimation"},
     {"title": "CastleGLImages.TSprite.AddAnimation", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#AddAnimation"},
     {"title": "CastleGLImages.TSprite.AddSpriteAnimation", "text": "    ", "tags": "", "loc": "CastleGLImages.TSprite.html#AddSpriteAnimation"},
     {"title": "CastleGLImages.TSprite.SwitchToAnimation", "text": " Use animation index obtained from <a class=\"normal\" href=\"CastleGLImages.TSprite.html#AddAnimation\">AddAnimation</a> to use a custom animation, or use -1 to use the default animation (spanning all sprite frames).  <p>   <code>True</code> on success, <code>False</code> if AAnimIndex is out of bounds. ", "tags": "", "loc": "CastleGLImages.TSprite.html#SwitchToAnimation"},
     {"title": "CastleGLImages.TSprite.Duration", "text": " See <a class=\"normal\" href=\"CastleGLImages.TSprite.html#CurrentAnimation\">CurrentAnimation</a> to know what the current animation is.    ", "tags": "", "loc": "CastleGLImages.TSprite.html#Duration"},
     {"title": "CastleGLImages.TSprite.X", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#X"},
     {"title": "CastleGLImages.TSprite.Y", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#Y"},
     {"title": "CastleGLImages.TSprite.Position", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#Position"},
     {"title": "CastleGLImages.TSprite.CenterX", "text": " Values between 0 and 1. ", "tags": "", "loc": "CastleGLImages.TSprite.html#CenterX"},
     {"title": "CastleGLImages.TSprite.CenterY", "text": " Values between 0 and 1. ", "tags": "", "loc": "CastleGLImages.TSprite.html#CenterY"},
     {"title": "CastleGLImages.TSprite.DrawingWidth", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#DrawingWidth"},
     {"title": "CastleGLImages.TSprite.DrawingHeight", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#DrawingHeight"},
     {"title": "CastleGLImages.TSprite.DrawRect", "text": " This is just a shortcut to get / set properties <a class=\"normal\" href=\"CastleGLImages.TSprite.html#X\">X</a>, <a class=\"normal\" href=\"CastleGLImages.TSprite.html#Y\">Y</a>, <a class=\"normal\" href=\"CastleGLImages.TSprite.html#DrawingWidth\">DrawingWidth</a>, <a class=\"normal\" href=\"CastleGLImages.TSprite.html#DrawingHeight\">DrawingHeight</a>. ", "tags": "", "loc": "CastleGLImages.TSprite.html#DrawRect"},
     {"title": "CastleGLImages.TSprite.Center", "text": " Values between 0 and 1. ", "tags": "", "loc": "CastleGLImages.TSprite.html#Center"},
     {"title": "CastleGLImages.TSprite.Rotation", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#Rotation"},
     {"title": "CastleGLImages.TSprite.Frames", "text": " Readonly. Defined at creation. ", "tags": "", "loc": "CastleGLImages.TSprite.html#Frames"},
     {"title": "CastleGLImages.TSprite.FramesPerSecond", "text": " This is used only for the default sprite animation (spanning all frames). For the custom animations (added by <a class=\"normal\" href=\"CastleGLImages.TSprite.html#AddAnimation\">AddAnimation</a>), each frame has an explicit (possibly different) duration. ", "tags": "", "loc": "CastleGLImages.TSprite.html#FramesPerSecond"},
     {"title": "CastleGLImages.TSprite.Frame", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#Frame"},
     {"title": "CastleGLImages.TSprite.Playing", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#Playing"},
     {"title": "CastleGLImages.TSprite.TimeLoop", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#TimeLoop"},
     {"title": "CastleGLImages.TSprite.Time", "text": " Yoy can set this explicity. Alternatively, you can call the <a class=\"normal\" href=\"CastleGLImages.TSprite.html#Update\">Update</a> method continously while the animation is <a class=\"normal\" href=\"CastleGLImages.TSprite.html#Playing\">Playing</a>, and then the time will increase automatically. ", "tags": "", "loc": "CastleGLImages.TSprite.html#Time"},
     {"title": "CastleGLImages.TSprite.FrameWidth", "text": " Initial value is set by the constructor. ", "tags": "", "loc": "CastleGLImages.TSprite.html#FrameWidth"},
     {"title": "CastleGLImages.TSprite.FrameHeight", "text": " Initial value is set by the constructor. ", "tags": "", "loc": "CastleGLImages.TSprite.html#FrameHeight"},
     {"title": "CastleGLImages.TSprite.LeftMargin", "text": " Useful if the first frame doesn't start at X=0. ", "tags": "", "loc": "CastleGLImages.TSprite.html#LeftMargin"},
     {"title": "CastleGLImages.TSprite.LeftMarginOffset", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#LeftMarginOffset"},
     {"title": "CastleGLImages.TSprite.TopMargin", "text": " Useful if the first frame doesn't start at Y=0. ", "tags": "", "loc": "CastleGLImages.TSprite.html#TopMargin"},
     {"title": "CastleGLImages.TSprite.TopMarginOffset", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#TopMarginOffset"},
     {"title": "CastleGLImages.TSprite.HorizontalSpacing", "text": " Use this if you have an empty space at the <b>right</b> of every frame in your spritesheet. This is useful to avoid frames &quot;bleeding&quot; into each other (due to smooth scaling). ", "tags": "", "loc": "CastleGLImages.TSprite.html#HorizontalSpacing"},
     {"title": "CastleGLImages.TSprite.VerticalSpacing", "text": " Use this if you have an empty space at the <b>top</b> (or <b>bottom</b>, if <a class=\"normal\" href=\"CastleGLImages.TSprite.html#VerticalSpacingBottom\">VerticalSpacingBottom</a>) of every frame in your spritesheet. This is useful to avoid frames &quot;bleeding&quot; into each other (due to smooth scaling). ", "tags": "", "loc": "CastleGLImages.TSprite.html#VerticalSpacing"},
     {"title": "CastleGLImages.TSprite.VerticalSpacingBottom", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#VerticalSpacingBottom"},
     {"title": "CastleGLImages.TSprite.TimeBackwards", "text": " See <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeBackwards\">TVideo.TimeBackwards</a>. ", "tags": "", "loc": "CastleGLImages.TSprite.html#TimeBackwards"},
     {"title": "CastleGLImages.TSprite.CurrentAnimation", "text": " Equal to -1 when we're using the default animation spanning all sprite frames. Otherwise, indicates a custom animation index (added by <a class=\"normal\" href=\"CastleGLImages.TSprite.html#AddAnimation\">AddAnimation</a> and used by <a class=\"normal\" href=\"CastleGLImages.TSprite.html#SwitchToAnimation\">SwitchToAnimation</a>).  <p>Call <a class=\"normal\" href=\"CastleGLImages.TSprite.html#SwitchToAnimation\">SwitchToAnimation</a> to change this. ", "tags": "", "loc": "CastleGLImages.TSprite.html#CurrentAnimation"},
     {"title": "CastleGLImages.TSprite.HorizontalFlip", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#HorizontalFlip"},
     {"title": "CastleGLImages.TSprite.VerticalFlip", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#VerticalFlip"},
     {"title": "CastleGLImages.TSprite.DiagonalFlip", "text": " ", "tags": "", "loc": "CastleGLImages.TSprite.html#DiagonalFlip"},
     {"title": "CastleGLImages.PixelsImageClasses", "text": " ", "tags": "", "loc": "CastleGLImages.html#PixelsImageClasses"},
     {"title": "CastleGLImages.minNearest", "text": " ", "tags": "", "loc": "CastleGLImages.html#minNearest"},
     {"title": "CastleGLImages.minLinear", "text": " ", "tags": "", "loc": "CastleGLImages.html#minLinear"},
     {"title": "CastleGLImages.minNearestMipmapNearest", "text": " ", "tags": "", "loc": "CastleGLImages.html#minNearestMipmapNearest"},
     {"title": "CastleGLImages.minNearestMipmapLinear", "text": " ", "tags": "", "loc": "CastleGLImages.html#minNearestMipmapLinear"},
     {"title": "CastleGLImages.minLinearMipmapNearest", "text": " ", "tags": "", "loc": "CastleGLImages.html#minLinearMipmapNearest"},
     {"title": "CastleGLImages.minLinearMipmapLinear", "text": " ", "tags": "", "loc": "CastleGLImages.html#minLinearMipmapLinear"},
     {"title": "CastleGLImages.magNearest", "text": " ", "tags": "", "loc": "CastleGLImages.html#magNearest"},
     {"title": "CastleGLImages.magLinear", "text": " ", "tags": "", "loc": "CastleGLImages.html#magLinear"},
     {"title": "CastleGLImages.Texture2DRepeat", "text": " ", "tags": "", "loc": "CastleGLImages.html#Texture2DRepeat"},
     {"title": "CastleGLImages.ImageGLFormat", "text": " If you will pass here Img that is not a descendant of one of <a class=\"normal\" href=\"CastleTextureImages.html#TextureImageClassesAll\">TextureImageClassesAll</a> or <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>, they will raise <a class=\"normal\" href=\"CastleGLImages.EImageClassNotSupportedForOpenGL.html\">EImageClassNotSupportedForOpenGL</a>.  <p><a class=\"normal\" href=\"CastleGLImages.html#ImageGLInternalFormat\">ImageGLInternalFormat</a> works with <a class=\"normal\" href=\"CastleImages.TGPUCompressedImage.html\">TGPUCompressedImage</a> classes also, returning appropriate enum, suitable for glCompressedTexImage2D.  <p>  <p>    EImageClassNotSupportedForOpenGL When Img class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.html#ImageGLFormat"},
     {"title": "CastleGLImages.ImageGLInternalFormat", "text": "    ", "tags": "", "loc": "CastleGLImages.html#ImageGLInternalFormat"},
     {"title": "CastleGLImages.ImageGLType", "text": "    ", "tags": "", "loc": "CastleGLImages.html#ImageGLType"},
     {"title": "CastleGLImages.glFreeTexture", "text": " In other words, this is a simple wrapper over glDeleteTextures that </p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>checks if Tex really should be deleted</p></li>   <li value=\"2\"><p>sets Tex to 0 to not free it once again</p></li> </ol>  <p>    ", "tags": "", "loc": "CastleGLImages.html#glFreeTexture"},
     {"title": "CastleGLImages.TexParameterMaxAnisotropy", "text": "  <p>Takes care to check for appropriate OpenGL extension (if not present, does nothing), and to query OpenGL limit for Anisotropy (eventually clamping provided Anisotropy down).    ", "tags": "", "loc": "CastleGLImages.html#TexParameterMaxAnisotropy"},
     {"title": "CastleGLImages.TextureFilter", "text": "    ", "tags": "", "loc": "CastleGLImages.html#TextureFilter"},
     {"title": "CastleGLImages.SetTextureFilter", "text": "  <p>This is just a thin wrapper for calling </p>  <pre class=\"longcode\"> glTexParameteri(Target, GL_TEXTURE_MIN_FILTER, <span class=\"pascal_numeric\"></span>...); glTexParameteri(Target, GL_TEXTURE_MAG_FILTER, <span class=\"pascal_numeric\"></span>...);</pre>  <p>    ", "tags": "", "loc": "CastleGLImages.html#SetTextureFilter"},
     {"title": "CastleGLImages.Texture2DClampToEdge", "text": "    ", "tags": "", "loc": "CastleGLImages.html#Texture2DClampToEdge"},
     {"title": "CastleGLImages.ImageDraw", "text": " Note that if you want to use this many times, it will be much faster to create <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a> instance.  <p> Deprecated, always use <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a> to draw 2D images.  <p>    EImageClassNotSupportedForOpenGL When Image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.html#ImageDraw"},
     {"title": "CastleGLImages.ResizeForTextureSize", "text": " It tries to resize to a larger size, not smaller, to avoid losing image information.  <p>It also makes texture have power-of-two size, if Sizing &lt;&gt; <a class=\"normal\" href=\"CastleGLImages.html#tsAny\">tsAny</a> (or if GLFeatures.TextureNonPowerOfTwo = <code>False</code>). This is a must for normal textures, used for 3D rendering (with mipmapping and such). Using OpenGL non-power-of-2 textures is not good for such usage case, some OpenGLs crash (ATI), some are ultra slow (NVidia), some cause artifacts (Mesa). OpenGL ES explicitly limits what you can do with non-power-of-2. Sample model using non-power-of-2 is in inlined_textures.wrl.  <p>Use Sizing = <a class=\"normal\" href=\"CastleGLImages.html#tsAny\">tsAny</a> only for textures that you plan to use for drawing GUI images by <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a>.  <p>    ", "tags": "", "loc": "CastleGLImages.html#ResizeForTextureSize"},
     {"title": "CastleGLImages.ResizeToTextureSize", "text": "    ", "tags": "", "loc": "CastleGLImages.html#ResizeToTextureSize"},
     {"title": "CastleGLImages.ResizeToTextureSize", "text": "    ", "tags": "", "loc": "CastleGLImages.html#ResizeToTextureSize"},
     {"title": "CastleGLImages.IsTextureSized", "text": " See <a class=\"normal\" href=\"CastleGLImages.html#ResizeForTextureSize\">ResizeForTextureSize</a>. Note that this checks glGet(GL_MAX_TEXTURE_SIZE), so requires initialized OpenGL context.    ", "tags": "", "loc": "CastleGLImages.html#IsTextureSized"},
     {"title": "CastleGLImages.IsTextureSized", "text": "    ", "tags": "", "loc": "CastleGLImages.html#IsTextureSized"},
     {"title": "CastleGLImages.LoadGLTexture", "text": " Generates new texture number by glGenTextures, then binds this texture, and loads it's data.  <p>Takes care of UNPACK_ALIGNMENT inside (if needed, we'll change it and later revert back, so that the texture is correctly loaded).  <p>Sets texture minification, magnification filters and wrap parameters.  <p>Changes currently bound texture to this one (returned).  <p>If mipmaps will be needed (this is decided looking at Filter.Minification) we will load them too.  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> As a first try, if CompositeForMipmaps is non-nil and has mipmaps (CompositeForMipmaps.Mipmaps), we will load these mipmaps. CompositeForMipmaps must be a normal 2D texture (CompositeType = <a class=\"normal\" href=\"CastleCompositeImage.html#ctTexture\">ctTexture</a>).  <p>Otherwise, we'll try to generate mipmaps, using various OpenGL mechanisms.</p></li>   <li value=\"2\"><p> We will try using <a class=\"normal\" href=\"CastleGLUtils.html#GenerateMipmap\">GenerateMipmap</a> functionality to generate mipmaps on GPU. If not available, for uncompressed textures, we will generate mipmaps on CPU. For compressed textures, we will change minification filter to simple <a class=\"normal\" href=\"CastleGLImages.html#minLinear\">minLinear</a> and make <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>.</p></li> </ol>  <p>  <p>  <p>  <p>  <p>  GUITexture If <code>True</code>, the texture is not forced to have sizes as power-of-two. For <a class=\"normal\" href=\"CastleGLImages.html#TTextureSizing\">TTextureSizing</a>, it is like <a class=\"normal\" href=\"CastleGLImages.html#tsAny\">tsAny</a> instead of <a class=\"normal\" href=\"CastleGLImages.html#tsScalablePowerOf2\">tsScalablePowerOf2</a>. Also, mipmaps are always disabled, regardless of requested Filter value, since mipmaps cannot work without power-of-two.  ETextureLoadError If texture cannot be loaded for whatever reason. This includes <a class=\"normal\" href=\"CastleGLImages.ECannotLoadCompressedTexture.html\">ECannotLoadCompressedTexture</a> if the compressed texture cannot be loaded for whatever reason. This includes <a class=\"normal\" href=\"CastleGLImages.EInvalidImageForOpenGLTexture.html\">EInvalidImageForOpenGLTexture</a> if Image class is invalid for an OpenGL texture. EImageClassNotSupportedForOpenGL When Image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.html#LoadGLTexture"},
     {"title": "CastleGLImages.LoadGLTexture", "text": "    ", "tags": "", "loc": "CastleGLImages.html#LoadGLTexture"},
     {"title": "CastleGLImages.LoadGLGeneratedTexture", "text": " It uses existing OpenGL texture number (TextureId). Everything else works exactly the same as <a class=\"normal\" href=\"CastleGLImages.html#LoadGLTexture\">LoadGLTexture</a>.  <p>You can also use this to set &quot;default unnamed OpenGL texture&quot; parameters by passing TextureId = 0.  <p>  <p>  <p>    ETextureLoadError Raised in the same situations as <a class=\"normal\" href=\"CastleGLImages.html#LoadGLTexture\">LoadGLTexture</a>. EImageClassNotSupportedForOpenGL When Image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.html#LoadGLGeneratedTexture"},
     {"title": "CastleGLImages.GLDecompressTexture", "text": " So this internally uses current OpenGL context.  <p>    ECannotLoadCompressedTexture If cannot decompress S3TC, for example because we cannot load to OpenGL this compressed texture (for example because appropriate OpenGL extensions are not available, or such).", "tags": "", "loc": "CastleGLImages.html#GLDecompressTexture"},
     {"title": "CastleGLImages.SaveTextureContents", "text": " <b>Size of the texture must match the Image size, otherwise terrible things (writing over unallocated memory) will happen</b>.  <p>    ECannotSaveTextureContents If we cannot get texture contents (not supported on OpenGLES).", "tags": "", "loc": "CastleGLImages.html#SaveTextureContents"},
     {"title": "CastleGLImages.glTextureImage3D", "text": " Think about this as doing glTexImage3D(...) for you. It also sets texture minification, magnification filters and creates mipmaps if necessary.  <p>It checks OpenGL 3D texture size requirements, and throws exceptions if not satisfied.  <p>It takes care about OpenGL unpack parameters. Just don't worry about it.  <p>If Filter uses mipmaps, then all mipmap levels will be loaded.  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> As a first try, if CompositeForMipmaps is non-nil and has mipmaps (CompositeForMipmaps.Mipmaps), we will load these mipmaps. CompositeForMipmaps must be a 3D texture (CompositeType = <a class=\"normal\" href=\"CastleCompositeImage.html#ctVolume\">ctVolume</a>).</p></li>   <li value=\"2\"><p>Otherwise, we'll generate mipmaps.  <p><a class=\"normal\" href=\"CastleGLUtils.html#GenerateMipmap\">GenerateMipmap</a> functionality will be required for this. When it is not available on this OpenGL implementation, we will change minification filter to simple linear and make <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>. So usually you just don't have to worry about this.</p></li> </ol>  <p>  <p>Pass TextureIdForProfiler only for profiling purposes (for <a class=\"normal\" href=\"CastleGLImages.html#TextureMemoryProfiler\">TextureMemoryProfiler</a>). This procedure assumes that the texture is already bound.  <p>  <p>    ETextureLoadError If texture cannot be loaded for whatever reason, for example it's size is not correct for OpenGL 3D texture (we cannot automatically resize 3D textures, at least for now). Or it's compressed (although we support here <a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a>, OpenGL doesn't have any 3D texture compression available.) EImageClassNotSupportedForOpenGL When Image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.html#glTextureImage3D"},
     {"title": "CastleGLImages.IsCubeMapTextureSized", "text": "    ", "tags": "", "loc": "CastleGLImages.html#IsCubeMapTextureSized"},
     {"title": "CastleGLImages.ResizeToCubeMapTextureSize", "text": "    ", "tags": "", "loc": "CastleGLImages.html#ResizeToCubeMapTextureSize"},
     {"title": "CastleGLImages.glTextureCubeMap", "text": " Think about this as doing glTexImage2D(Side, ...) for each cube side. It takes care of (almost?) everything you need to prepare OpenGL cube map texture.  <p>It automatically takes care to adjust the texture size to appropriate size, honoring the &quot;power of two&quot; requirement and the GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB limit of OpenGL. So texture image may be resized (preferably up) internally before loading. Although, if texture is compressed, we cannot resize it &mdash; so <a class=\"normal\" href=\"CastleGLImages.ECannotLoadCompressedTexture.html\">ECannotLoadCompressedTexture</a> will be raised if texture is not appropriate size.  <p>It takes care about OpenGL unpack parameters. Just don't worry about it.  <p>Pass TextureIdForProfiler only for profiling purposes (for <a class=\"normal\" href=\"CastleGLImages.html#TextureMemoryProfiler\">TextureMemoryProfiler</a>). This procedure assumes that the texture is already bound.  <p>If mipmaps are requested:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>First of all, if CompositeForMipmaps is non-nil and has mipmaps defined, we will load them from this CompositeForMipmaps image. CompositeForMipmaps must have CompositeType = <a class=\"normal\" href=\"CastleCompositeImage.html#ctCubeMap\">ctCubeMap</a>.</p></li>   <li value=\"2\"><p>Otherwise, we'll try to generate images using OpenGL <a class=\"normal\" href=\"CastleGLUtils.html#GenerateMipmap\">GenerateMipmap</a>.</p></li>   <li value=\"3\"><p>As a last resort, if <a class=\"normal\" href=\"CastleGLUtils.html#GenerateMipmap\">GenerateMipmap</a> is not available, we will fallback to generating mipmaps on CPU by good old gluBuild2DMipmaps call.</p></li> </ol>  <p>  <p>  <p>    ETextureLoadError If texture cannot be loaded for whatever reason. This includes <a class=\"normal\" href=\"CastleGLImages.ECannotLoadCompressedTexture.html\">ECannotLoadCompressedTexture</a> if the compressed texture cannot be loaded for whatever reason (not availble appropriate extension, not correct texture size, mipmaps requested and CompositeForMipmaps/glGenerateMipmap not available). This includes <a class=\"normal\" href=\"CastleGLImages.EInvalidImageForOpenGLTexture.html\">EInvalidImageForOpenGLTexture</a> if Image class is invalid for an OpenGL texture. EImageClassNotSupportedForOpenGL When Image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.html#glTextureCubeMap"},
     {"title": "CastleGLImages.SaveScreen_NoFlush", "text": "  <p>The suffix &quot;NoFlush&quot; is there to remind you that this function grabs the <i>current</i> buffer contents. Usually you want to redraw the screen to the back buffer, and call this function to capture back buffer <i>before</i> swapping, since this is the only reliable way to capture OpenGL screen. Just use <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#SaveScreen\">TCastleWindowCustom.SaveScreen</a> to do it automatically.  <p>Version with ImageClass can save to any image format from <a class=\"normal\" href=\"CastleGLImages.html#PixelsImageClasses\">PixelsImageClasses</a>.  <p>Version with <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instance just uses this instance to save the image. You must pass here already created <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instance, it's class, Width and Height will be used when saving.  <p>  <p>    EImageClassNotSupportedForOpenGL When Image class is not supported by OpenGL.", "tags": "", "loc": "CastleGLImages.html#SaveScreen_NoFlush"},
     {"title": "CastleGLImages.SaveScreen_NoFlush", "text": "    ", "tags": "", "loc": "CastleGLImages.html#SaveScreen_NoFlush"},
     {"title": "CastleGLImages.SaveScreen_NoFlush", "text": "    ", "tags": "", "loc": "CastleGLImages.html#SaveScreen_NoFlush"},
     {"title": "CastleGLImages.SaveScreenToGL_NoFlush", "text": "    ", "tags": "", "loc": "CastleGLImages.html#SaveScreenToGL_NoFlush"},
     {"title": "CastleGLImages.TextureMemoryProfiler", "text": " Especially useful on mobile devices, where texture memory is limited and your application must really optimize texture usage. Also useful to detect texture memory leaks.  <p>Enable it at the very beginning of the application (for example in the main unit initialization clause), like this:  <p></p>  <pre class=\"longcode\"> TextureMemoryProfiler.Enabled := true</pre>  <p>  <p>Then at any point during the game you can query texture usage by <a class=\"normal\" href=\"CastleGLImages.TTextureMemoryProfiler.html#Summary\">TTextureMemoryProfiler.Summary</a> method. For example dump it to the log like this:  <p></p>  <pre class=\"longcode\"> WritelnLog(<span class=\"pascal_string\">'Textures'</span>, TextureMemoryProfiler.Summary);</pre>  <p>  <p>The resulting output lists the currently allocated textures, in descending order of their size. This tells you which textures are worth optimizing. Maybe scale these textures down, maybe compress them, maybe remove alpha channel or convert them to grayscale...  <p>The profiler counts the <i>real texture size on GPU</i>, knowing that some textures are resized to power of 2, that textures may be compressed on GPU, that some textures have mipmaps and so on. All kinds of textures (2D, 3D, cubemaps, float, depth etc.) are covered. Every type is reported &mdash; loaded from files, generated (like by GeneratedCubeMapTexture), embedded in code (by embedding images or fonts in code)... The textures loaded from disk are described by URL, for other textures we invent special URLs like:  <p></p>  <ul class=\"compact_spacing\">   <li><p><code>embedded-font:/CastleTextureFont_CanterBold_120</code></p></li>   <li><p><code>embedded-image:/PanelSeparator</code></p></li>   <li><p><code>generated:/GeneratedCubeMapTexture(GenTex2)</code></p></li> </ul>  <p>  <p>You can also use the profiler from view3dscene, run it with &quot;&ndash;debug-texture-memory&quot; command-line option, load your 3D model and then use menu option &quot;Console -&gt; Print Texture Memory Usage&quot;.    ", "tags": "", "loc": "CastleGLImages.html#TextureMemoryProfiler"},
     {"title": "CastleGLImages.BeforeUnpackImage", "text": " Before you pass this image to some OpenGL procedures (like glDrawPixels for unpacking, glReadPixels for packing), call BeforeXxx, and later call AfterXxx to restore original state. These will take care of setting / restoring pixel alignment.     ", "tags": "", "loc": "CastleGLImages.html#BeforeUnpackImage"},
     {"title": "CastleGLImages.AfterUnpackImage", "text": "    ", "tags": "", "loc": "CastleGLImages.html#AfterUnpackImage"},
     {"title": "CastleGLImages.BeforePackImage", "text": "    ", "tags": "", "loc": "CastleGLImages.html#BeforePackImage"},
     {"title": "CastleGLImages.AfterPackImage", "text": "    ", "tags": "", "loc": "CastleGLImages.html#AfterPackImage"},
     {"title": "CastleGLImages.TGLTextureId", "text": " ", "tags": "", "loc": "CastleGLImages.html#TGLTextureId"},
     {"title": "CastleGLImages.TMinificationFilter", "text": " ", "tags": "", "loc": "CastleGLImages.html#TMinificationFilter"},
     {"title": "CastleGLImages.TMagnificationFilter", "text": " ", "tags": "", "loc": "CastleGLImages.html#TMagnificationFilter"},
     {"title": "CastleGLImages.TGLImageManaged", "text": " ", "tags": "", "loc": "CastleGLImages.html#TGLImageManaged"},
     {"title": "CastleGLImages.TTextureSizing", "text": " Usually you don't need these functions, <a class=\"normal\" href=\"CastleGLImages.html#LoadGLTexture\">LoadGLTexture</a>* and <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a> and such call it automatically when needed.  tsAny Texture size does not have to be a power of two (unless GLFeatures.TextureNonPowerOfTwo = <code>False</code>, in which case all textures must have power-of-two, and then <code>tsAny</code> may be scaled to satisfy it (but it still will not be scaled for <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a>)).  It is not affected by <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a>.  tsRequiredPowerOf2 Texture size must be a power of two.  It is not affected by <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a>, because we cannot scale it.  tsScalablePowerOf2 Texture size must be a power of two.  It is affected by <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a>, we can scale it. ", "tags": "", "loc": "CastleGLImages.html#TTextureSizing"},
     {"title": "CastleGLImages.TColorBuffer", "text": "  cbFront    cbBack    cbColorAttachment0   ", "tags": "", "loc": "CastleGLImages.html#TColorBuffer"},
     {"title": "CastleGLImages.TGLRenderToTextureBuffer", "text": "  tbColor    tbDepth    tbColorAndDepth    tbNone   ", "tags": "", "loc": "CastleGLImages.html#TGLRenderToTextureBuffer"},
     {"title": "CastleGLImages.TSpriteList", "text": " ", "tags": "", "loc": "CastleGLImages.html#TSpriteList"},
     {"title": "CastleGLImages.GLTextureScale", "text": " This allows you to conserve GPU memory. Each size (width, height, and (for 3D textures) depth) is scaled by 1 / 2&circ;<code>GLTextureScale</code>. So value = 1 means no scaling, value = 2 means that each size is 1/2 (texture area is 1/4), value = 3 means that each size is 1/4 and so on.  <p>Note that textures used for GUI, by <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a> (more precisely: all non-power-of-2 textures) avoid this scaling entirely.  <p>This allows to scale the textures at runtime. For an independent mechanism that allows to <b>load</b> already downscaled textures (and scale them as a preprocessing step when packaging your game), see <a class=\"normal\" href=\"CastleMaterialProperties.html#TextureLoadingScale\">TextureLoadingScale</a>. The documentation of <a class=\"normal\" href=\"CastleMaterialProperties.html#TextureLoadingScale\">TextureLoadingScale</a> lists all the differences between these two approaches to scaling. ", "tags": "", "loc": "CastleGLImages.html#GLTextureScale"},
     {"title": "CastleGLImages.GLTextureMinSize", "text": " Scaling caused by <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a> cannot scale texture to something less than <code>GLTextureMinSize</code>. If texture size was already &lt; <code>GLTextureMinSize</code>, it is not scaled at all by <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a>. This must be a power of two. ", "tags": "", "loc": "CastleGLImages.html#GLTextureMinSize"},
     {"title": "CastleGLImages.LogTextureLoading", "text": " If additionally <a class=\"normal\" href=\"CastleGLImages.html#TextureMemoryProfiler\">TextureMemoryProfiler</a> is enabled, then we will dump texture memory usage. ", "tags": "", "loc": "CastleGLImages.html#LogTextureLoading"},
     {"title": "CastleGLShaders", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> Creating/destroying the <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html\">TGLSLProgram</a> instance immediately creates/destroys appropriate program on GPU. So be sure to create/destroy it only when you have OpenGL context available (for example, create in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">TCastleWindowCustom.OnOpen</a> and destroy in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnClose\">TCastleWindowCustom.OnClose</a>).</p></li>   <li><p> Upon creation, we check current OpenGL context abilities. Currently three support levels are possible: no support at all (old OpenGL), support through ARB extensions, or support built-in (newer OpenGL versions, &gt;= 2.0).  <p>All three cases are automatically handled inside, so usually you do not have to care about these details. Note that &quot;none&quot; support (on older OpenGL version with no appropriate ARB extensions) means that shaders are not really initialized at all.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleGLShaders.html"},
     {"title": "CastleGLShaders.EGLSLError", "text": " ", "tags": "", "loc": "CastleGLShaders.EGLSLError.html"},
     {"title": "CastleGLShaders.EGLSLShaderCompileError", "text": " ", "tags": "", "loc": "CastleGLShaders.EGLSLShaderCompileError.html"},
     {"title": "CastleGLShaders.EGLSLProgramLinkError", "text": " ", "tags": "", "loc": "CastleGLShaders.EGLSLProgramLinkError.html"},
     {"title": "CastleGLShaders.EGLSLAttributeNotFound", "text": " ", "tags": "", "loc": "CastleGLShaders.EGLSLAttributeNotFound.html"},
     {"title": "CastleGLShaders.EGLSLUniformInvalid", "text": " ", "tags": "", "loc": "CastleGLShaders.EGLSLUniformInvalid.html"},
     {"title": "CastleGLShaders.EGLSLUniformNotFound", "text": " ", "tags": "", "loc": "CastleGLShaders.EGLSLUniformNotFound.html"},
     {"title": "CastleGLShaders.EGLSLUniformTypeMismatch", "text": " ", "tags": "", "loc": "CastleGLShaders.EGLSLUniformTypeMismatch.html"},
     {"title": "CastleGLShaders.TGLSLUniform", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html"},
     {"title": "CastleGLShaders.TGLSLUniform.Owner", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#Owner"},
     {"title": "CastleGLShaders.TGLSLUniform.Name", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#Name"},
     {"title": "CastleGLShaders.TGLSLUniform.Location", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#Location"},
     {"title": "CastleGLShaders.TGLSLUniform.NotExisting", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#NotExisting"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": " You should get the uniform information first using the <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Uniform\">TGLSLProgram.Uniform</a> call. All the documentation for <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#SetUniform\">TGLSLProgram.SetUniform</a> applies also here, so the program must be linked, and enabled (it will be enabled automatically by calling this).  <p>In this case of this method, you cannot get <a class=\"normal\" href=\"CastleGLShaders.EGLSLUniformNotFound.html\">EGLSLUniformNotFound</a> exception (it will be raised earlier, at <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Uniform\">TGLSLProgram.Uniform</a>).  <p>The <a class=\"normal\" href=\"CastleGLShaders.TGLSLUniform.html\">TGLSLUniform</a> information about a given uniform stays constant while the program is linked. Using the <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Uniform\">TGLSLProgram.Uniform</a> one time, and then repeatedly calling <a class=\"normal\" href=\"CastleGLShaders.TGLSLUniform.html#SetValue\">TGLSLUniform.SetValue</a>, is faster than repeatedly calling <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#SetUniform\">TGLSLProgram.SetUniform</a>. Because the latter will effectively call <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Uniform\">TGLSLProgram.Uniform</a> every time, which may have non-zero cost.  <p>Actually, the uniform location (<a class=\"normal\" href=\"CastleGLShaders.TGLSLUniform.html#Location\">TGLSLUniform.Location</a>) is constant for a given program, and you can even predict the location in some cases without calling <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Uniform\">TGLSLProgram.Uniform</a> method (see GLSL reference). So it can be even faster, as you can prepare correct <a class=\"normal\" href=\"CastleGLShaders.TGLSLUniform.html\">TGLSLUniform</a> instance in your own code, without calling <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Uniform\">TGLSLProgram.Uniform</a>.  <p>    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLUniform.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLUniform.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html"},
     {"title": "CastleGLShaders.TGLSLAttribute.Owner", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#Owner"},
     {"title": "CastleGLShaders.TGLSLAttribute.Name", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#Name"},
     {"title": "CastleGLShaders.TGLSLAttribute.Location", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#Location"},
     {"title": "CastleGLShaders.TGLSLAttribute.LocationOffsetsToDisable", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#LocationOffsetsToDisable"},
     {"title": "CastleGLShaders.TGLSLAttribute.EnableArray", "text": " See the OpenGL documentation of glVertexAttribPointer for meaning of the parameters.  <p>Note that Ptr is usually an offset relative to the currently bound VBO (Vertex Buffer Object), not a regular pointer to a memory content. That is why is has a type PtrUInt (not Pointer), since usually you calculate it as an integer.  <p>Note that the array size is not specified anywhere. The way you access the array (what indexes you use) determines the minimum count of the array you should have (and uploaded to VBO).    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#EnableArray"},
     {"title": "CastleGLShaders.TGLSLAttribute.EnableArraySingle", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#EnableArraySingle"},
     {"title": "CastleGLShaders.TGLSLAttribute.EnableArrayVector2", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#EnableArrayVector2"},
     {"title": "CastleGLShaders.TGLSLAttribute.EnableArrayVector3", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#EnableArrayVector3"},
     {"title": "CastleGLShaders.TGLSLAttribute.EnableArrayVector4", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#EnableArrayVector4"},
     {"title": "CastleGLShaders.TGLSLAttribute.EnableArrayMatrix3", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#EnableArrayMatrix3"},
     {"title": "CastleGLShaders.TGLSLAttribute.EnableArrayMatrix4", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#EnableArrayMatrix4"},
     {"title": "CastleGLShaders.TGLSLAttribute.DisableArray", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#DisableArray"},
     {"title": "CastleGLShaders.TGLSLAttribute.SetValue", "text": " The used type must match the type of this variable in GLSL program.  <p>OpenGL forces some constraints on using this, see SetUniform. In short: use this only after linking the program. The program is automatically enabled (set as <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Current\">TGLSLProgram.Current</a>) by this. And note that attributes declared but not actually used in shader code may be eliminated, use DebugInfo to see which attributes are actually used (<i>active</i> in OpenGL terminology).  <p>These should not be often useful. Usually, you should rather load attribute arrays, by <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#EnableArray\">EnableArray</a>.  <p>    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute.SetValue", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#SetValue"},
     {"title": "CastleGLShaders.TGLSLAttribute.TLocationOffset", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLAttribute.html#TLocationOffset"},
     {"title": "CastleGLShaders.TGLSLProgram", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html"},
     {"title": "CastleGLShaders.TGLSLProgram.Create", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Create"},
     {"title": "CastleGLShaders.TGLSLProgram.Destroy", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Destroy"},
     {"title": "CastleGLShaders.TGLSLProgram.AttachVertexShader", "text": "  <p>For desktop OpenGL, you can attach more than one shader of given type, just make sure that only one main() function is among each type (otherwise link error will be raised later). For OpenGLES, this is not allowed, so don't use this if you want to work with OpenGLES too.  <p>If you want to explicitly get rid of old shaders, use <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#DetachAllShaders\">DetachAllShaders</a>.  <p>  <p>    EGLSLShaderCompileError If the shader source code cannot be compiled, exception message contains precise description from OpenGL where the error is.", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#AttachVertexShader"},
     {"title": "CastleGLShaders.TGLSLProgram.AttachGeometryShader", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#AttachGeometryShader"},
     {"title": "CastleGLShaders.TGLSLProgram.AttachFragmentShader", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#AttachFragmentShader"},
     {"title": "CastleGLShaders.TGLSLProgram.AttachShader", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#AttachShader"},
     {"title": "CastleGLShaders.TGLSLProgram.AttachShader", "text": "  <p>For normal OpenGL, we can use GLSL separate compilation units. So this is equivalent to just calling <code><code>AttachShader</code>(ShaderType, Parts[I])</code> for each part.  <p>For OpenGL ES, this is unfortunately not possible, you can only attach a single shader of a given type (see <a  href=\"http://www.khronos.org/opengles/sdk/docs/man/xhtml/glAttachShader.xml\">http://www.khronos.org/opengles/sdk/docs/man/xhtml/glAttachShader.xml</a> ). So we simply concatenate the shaders into one.    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#AttachShader"},
     {"title": "CastleGLShaders.TGLSLProgram.DetachAllShaders", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#DetachAllShaders"},
     {"title": "CastleGLShaders.TGLSLProgram.Link", "text": "  <p>    EGLSLProgramLinkError If the program cannot be linked, exception message contains precise description from OpenGL where the error is.", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Link"},
     {"title": "CastleGLShaders.TGLSLProgram.Link", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Link"},
     {"title": "CastleGLShaders.TGLSLProgram.Enable", "text": " Shortcut for <code><a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Current\">TGLSLProgram.Current</a> := Self</code>.    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Enable"},
     {"title": "CastleGLShaders.TGLSLProgram.Disable", "text": " Shortcut for <code><a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Current\">TGLSLProgram.Current</a> := nil</code>.    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Disable"},
     {"title": "CastleGLShaders.TGLSLProgram.SetupUniforms", "text": "  <p>This is automatically called after every <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Enable\">Enable</a> by VRML renderer (when it renders shapes) or scene manager (when it renders screen effects). If you use this <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html\">TGLSLProgram</a> directly (if you call <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Enable\">Enable</a> yourself), then it's your responsibility to call this method explicitly, if you want shaders using it to work.  <p>You can set any uniform values, and generally do anything you want to be done each time this shader is enabled. In particular, you can bind textures and set corresponding uniform variables of them. Increase BoundTextureUnits appropriately.  <p>Returns <code>False</code> is some texture couldn't be bound.    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetupUniforms"},
     {"title": "CastleGLShaders.TGLSLProgram.DebugInfo", "text": " Things like how it's supported (not at all ? ARB extension ? standard ?), names of active uniform and attribute variables etc.  <p>fglrx (Radeon closed-source OpenGL drivers) are buggy (that's not news, I know...) and they report GL_INVALID_ENUM on some queries here. We detect this, and still produce nice debug message, without raising any exception (after all, we have to workaround fglrx bugs, and try to run our program anyway...). What's important for caller is that we have to check first whether there are any OpenGL errors pending, and raise exceptions on them.  <p>    EOpenGLError If any OpenGL error will be detected.", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#DebugInfo"},
     {"title": "CastleGLShaders.TGLSLProgram.ProgramInfoLog", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#ProgramInfoLog"},
     {"title": "CastleGLShaders.TGLSLProgram.RunningInHardware", "text": "  <p>Note that this is necessarily implemented in quite hacky way (by looking at <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#ProgramInfoLog\">ProgramInfoLog</a>), there is no way currently (AFAIK ?) to get this information cleanly from OpenGL. In case of doubts, we try to &quot;trust&quot; OpenGL to execute shader in hardware. Return <code>False</code> only when we see clear indication in <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#ProgramInfoLog\">ProgramInfoLog</a> that it'll run in software.    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#RunningInHardware"},
     {"title": "CastleGLShaders.TGLSLProgram.ClassSupport", "text": " This is much like <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Support\">Support</a>, but it's a class function.    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#ClassSupport"},
     {"title": "CastleGLShaders.TGLSLProgram.Uniform", "text": " It can be used to make repeated <a class=\"normal\" href=\"CastleGLShaders.TGLSLUniform.html#SetValue\">TGLSLUniform.SetValue</a> calls. You must link the program first.  <p>If the uniform doesn't exist (or is unused), the action we take depends on <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#UniformNotFoundAction\">UniformNotFoundAction</a> property (by default &ndash; <a class=\"normal\" href=\"CastleGLShaders.html#uaException\">uaException</a>). The overloaded version with extra <code>AUniformNotFoundAction</code> parameter follows this parameter value.  <p>  <p>    EGLSLUniformNotFound If the variable is not found within the program and we the behaviour (determined by AUniformTypeMismatchAction parameter or <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#UniformTypeMismatchAction\">UniformTypeMismatchAction</a> property) is <a class=\"normal\" href=\"CastleGLShaders.html#uaException\">uaException</a>.", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Uniform"},
     {"title": "CastleGLShaders.TGLSLProgram.Uniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Uniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": " The used type must match the type of this variable in GLSL program.  <p>OpenGL forces some constraints on using this:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>This should be used only after linking, and re-linking clears (sets to zero) all uniform variables values.</p></li>   <li><p>This GLSL program must be currently enabled for this to work. So calling this automatically calls <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Enable\">Enable</a> and sets <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Current\">TGLSLProgram.Current</a>.  <p>This is required by OpenGL glUniform* commands. glGetUniformLocation take program id as parameter, so they can operate on any program. But glUniform* operate only on active program.</p></li>   <li><p>Only <i>active</i> uniforms variables may be set. <i>Active</i> means, quoting OpenGL manpages, a variable that is determined during the link operation that it may be accessed during program execution. In other words, when linking GLSL program, unused variables may be eliminated, and you cannot set them by <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#SetUniform\">SetUniform</a>.  <p>Call <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#DebugInfo\">DebugInfo</a> to see what uniform variables are considered active for your shader.  <p>You can change <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#UniformNotFoundAction\">UniformNotFoundAction</a> not to silently ignore setting of inactive (or not existing) uniform values.</p></li> </ul>  <p>  <p>  <p>  <p>    EGLSLUniformNotFound If the variable is not found within the program and <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#UniformNotFoundAction\">UniformNotFoundAction</a> = <a class=\"normal\" href=\"CastleGLShaders.html#uaException\">uaException</a> (default) or ForceException. EGLSLUniformTypeMismatch If the variable type doesn't match the type declared in shader code. Raised only if <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#UniformTypeMismatchAction\">UniformTypeMismatchAction</a> = <a class=\"normal\" href=\"CastleGLShaders.html#utException\">utException</a> or ForceException.  <p>Note that both <a class=\"normal\" href=\"CastleGLShaders.EGLSLUniformNotFound.html\">EGLSLUniformNotFound</a> and <a class=\"normal\" href=\"CastleGLShaders.EGLSLUniformTypeMismatch.html\">EGLSLUniformTypeMismatch</a> may be comfortably catched by an umbrella class <a class=\"normal\" href=\"CastleGLShaders.EGLSLUniformInvalid.html\">EGLSLUniformInvalid</a>.", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.SetUniform", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetUniform"},
     {"title": "CastleGLShaders.TGLSLProgram.Attribute", "text": " It can be used to make repeated <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#SetValue\">TGLSLAttribute.SetValue</a> and <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#EnableArray\">TGLSLAttribute.EnableArray</a>.  <p>    EGLSLAttributeNotFound If the variable is not found within the program.  <p>Note that this is only one of the many things that can go wrong. And on most cases we don't raise any error, instead OpenGL sets it's error state and you probably want to call <a class=\"normal\" href=\"CastleGLUtils.html#CheckGLErrors\">CheckGLErrors</a> from time to time to catch them.", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Attribute"},
     {"title": "CastleGLShaders.TGLSLProgram.AttributeOptional", "text": " It can be used to make repeated <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#SetValue\">TGLSLAttribute.SetValue</a> and <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#EnableArray\">TGLSLAttribute.EnableArray</a>.  <p>Returned attribute has <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#Location\">TGLSLAttribute.Location</a> equal to -1. All the calls to <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#SetValue\">TGLSLAttribute.SetValue</a> or <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#EnableArray\">TGLSLAttribute.EnableArray</a> or <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#DisableArray\">TGLSLAttribute.DisableArray</a> methods are silently ignored.    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#AttributeOptional"},
     {"title": "CastleGLShaders.TGLSLProgram.VertexAttribPointer", "text": " This calls glVertexAttribPointer and enables it by glEnableVertexAttribArray (or ARB extension equivalents), see OpenGL reference for details.  <p>The attribute name is automatically resolved to a &quot;location&quot;. We add LocationOffset (useful if you want to load matrix attributes, when you have to load matrix columns separately, with LocationOffset = column index).  <p>For repeated usage, it's better to use <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Attribute\">Attribute</a> method, and repeatedly call <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#EnableArray\">TGLSLAttribute.EnableArray</a> on the same <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html\">TGLSLAttribute</a> instance.  <p>  <p>   Attribute location (with LocationOffset already applied). You can use it with <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#DisableVertexAttribArray\">DisableVertexAttribArray</a>. EGLSLAttributeNotFound If the variable is not found within the program.", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#VertexAttribPointer"},
     {"title": "CastleGLShaders.TGLSLProgram.DisableVertexAttribArray", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#DisableVertexAttribArray"},
     {"title": "CastleGLShaders.TGLSLProgram.SetAttribute", "text": " The used type must match the type of this variable in GLSL program.  <p>OpenGL forces some constraints on using this, see <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#SetUniform\">SetUniform</a>. In short: use this only after linking the program. The program is automatically enabled (set as <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Current\">TGLSLProgram.Current</a>) by this. And note that attributes declared but not actually used in shader code may be eliminated, use <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#DebugInfo\">DebugInfo</a> to see which attributes are actually used (<i>active</i> in OpenGL terminology).  <p>These should not be often used. Usually, you should rather load attribute arrays, by <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#VertexAttribPointer\">VertexAttribPointer</a>. You should also get attribute by the <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Attribute\">Attribute</a> method, as <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html\">TGLSLAttribute</a>, and then call <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#SetValue\">TGLSLAttribute.SetValue</a> or <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#EnableArray\">TGLSLAttribute.EnableArray</a>.  <p>  <p>    EGLSLAttributeNotFound If the variable is not found within the program.  <p>Note that this is only one of the many things that can go wrong. And on most cases we don't raise any error, instead OpenGL sets it's error state and you probably want to call <a class=\"normal\" href=\"CastleGLUtils.html#CheckGLErrors\">CheckGLErrors</a> from time to time to catch them.", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetAttribute"},
     {"title": "CastleGLShaders.TGLSLProgram.SetAttribute", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetAttribute"},
     {"title": "CastleGLShaders.TGLSLProgram.SetAttribute", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetAttribute"},
     {"title": "CastleGLShaders.TGLSLProgram.SetAttribute", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetAttribute"},
     {"title": "CastleGLShaders.TGLSLProgram.SetAttribute", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetAttribute"},
     {"title": "CastleGLShaders.TGLSLProgram.SetAttribute", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetAttribute"},
     {"title": "CastleGLShaders.TGLSLProgram.SetAttribute", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetAttribute"},
     {"title": "CastleGLShaders.TGLSLProgram.SetAttribute", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetAttribute"},
     {"title": "CastleGLShaders.TGLSLProgram.SetAttribute", "text": "    ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#SetAttribute"},
     {"title": "CastleGLShaders.TGLSLProgram.Support", "text": " ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Support"},
     {"title": "CastleGLShaders.TGLSLProgram.UniformNotFoundAction", "text": " Note that OpenGL aggresively removes unused code and variables from the shader when compiling/linking, so this also happens for &quot;declared but unused&quot; variables.  <p>This is only the default value, each <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Uniform\">Uniform</a> method call may explicitly use other <a class=\"normal\" href=\"CastleGLShaders.html#TUniformNotFoundAction\">TUniformNotFoundAction</a>.  <p> ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#UniformNotFoundAction"},
     {"title": "CastleGLShaders.TGLSLProgram.UniformTypeMismatchAction", "text": "  <p>Note that the default (<a class=\"normal\" href=\"CastleGLShaders.html#utGLError\">utGLError</a>) is fastest. Other options will need to check OpenGL error state often, which may cause performance drop.  <p> ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#UniformTypeMismatchAction"},
     {"title": "CastleGLShaders.TGLSLProgram.Current", "text": " <code>Nil</code> if fixed-function pipeline should be used. Setting this property encapsulates the OpenGL glUseProgram (or equivalent ARB extension), additionally preventing redundant glUseProgram calls. ", "tags": "", "loc": "CastleGLShaders.TGLSLProgram.html#Current"},
     {"title": "CastleGLShaders.GetCurrentProgram", "text": "    ", "tags": "", "loc": "CastleGLShaders.html#GetCurrentProgram"},
     {"title": "CastleGLShaders.SetCurrentProgram", "text": "    ", "tags": "", "loc": "CastleGLShaders.html#SetCurrentProgram"},
     {"title": "CastleGLShaders.TGLuintList", "text": " ", "tags": "", "loc": "CastleGLShaders.html#TGLuintList"},
     {"title": "CastleGLShaders.TUniformNotFoundAction", "text": "  uaWarning Report that uniform variable not found to <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>.   uaException Report that uniform variable not found by raising <a class=\"normal\" href=\"CastleGLShaders.EGLSLUniformNotFound.html\">EGLSLUniformNotFound</a>.   uaIgnore Ignore the fact that uniform variable doesn't exist in the GLSL shader.  Do not warn anywhere. ", "tags": "", "loc": "CastleGLShaders.html#TUniformNotFoundAction"},
     {"title": "CastleGLShaders.TUniformTypeMismatchAction", "text": "  utGLError Do not catch uniform type mismatch, leaving it to OpenGL.  This will cause OpenGL error &quot;invalid operation&quot; (possibly resulting in an exception in some later code that checks OpenGL errors).  <p>This is unsafe (you may get OpenGL errors later), but is also fastest. Other options have to detect invalid types, which means checking the OpenGL error state each time you set uniform value.  utWarning Report type mismatch to <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>.   utException Report type mismatch by raising <a class=\"normal\" href=\"CastleGLShaders.EGLSLUniformTypeMismatch.html\">EGLSLUniformTypeMismatch</a>.  ", "tags": "", "loc": "CastleGLShaders.html#TUniformTypeMismatchAction"},
     {"title": "CastleGLShaders.TGLSLAttributeList", "text": " ", "tags": "", "loc": "CastleGLShaders.html#TGLSLAttributeList"},
     {"title": "CastleGLShaders.TGLSLProgramList", "text": " ", "tags": "", "loc": "CastleGLShaders.html#TGLSLProgramList"},
     {"title": "CastleGLShaders.LogShaders", "text": " ", "tags": "", "loc": "CastleGLShaders.html#LogShaders"},
     {"title": "CastleGLShaders.CurrentProgram", "text": " <code>Nil</code> if fixed-function pipeline should be used. Setting this property encapsulates the OpenGL glUseProgram (or equivalent ARB extension), additionally preventing redundant glUseProgram calls. ", "tags": "", "loc": "CastleGLShaders.html#CurrentProgram"},
     {"title": "CastleGLShadowVolumes", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.html"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer", "text": " This class provides various utilities related to shadow volume rendering. It provides everything, except it doesn't actually render the 3D models or their shadow volumes (actual rendering is provided by <a class=\"normal\" href=\"Castle3D.html#T3D\">T3D</a> descendants, like TCastleScene.RenderShadowVolume).  <p>For general usage tutorial of this class, see [<a  href=\"http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/chapter.shadows.html\">http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/chapter.shadows.html</a>] ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.Create", "text": "    ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#Create"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.GLContextOpen", "text": " For now, this sets StencilOpIncrWrap, StencilOpDecrWrap.    ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#GLContextOpen"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.InitFrustumAndLight", "text": " You have to call this before <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#InitCaster\">InitCaster</a>.  <p>This prepares some things (so that each <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#InitCaster\">InitCaster</a> call doesn't have to) and all subsequent <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#InitCaster\">InitCaster</a> calls assume that Frustum and <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#LightPosition\">LightPosition</a> are the same.  <p>It also resets <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#CountCasters\">CountCasters</a> etc. counters for debug purposes.    ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#InitFrustumAndLight"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.InitCaster", "text": "  <p>This calculates various things related to shadow volumes rendering of this scene. 1. checks whether you need to render shadow of the object inside CasterBox, settting <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#CasterShadowPossiblyVisible\">CasterShadowPossiblyVisible</a>. 2. checks whether <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#ZFail\">ZFail</a> method is needed, setting <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#ZFail\">ZFail</a>.  <p>This assumes that Frustum and <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#LightPosition\">LightPosition</a> values given in <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#InitFrustumAndLight\">InitFrustumAndLight</a> are OK.  <p>Also note that after <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#InitFrustumAndLight\">InitFrustumAndLight</a>, all <code>InitCaster</code> will assume that they have complete control over glStencilOp states for the time of rendering shadow volumes. In other words: <code>InitCaster</code> will setup some stencil configuration, depending on <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#ZFail\">ZFail</a> state and <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#StencilSetupKind\">StencilSetupKind</a>. For the sake of speed, we try to avoid setting the same state twice, so we optimize it: first <code>InitCaster</code> after <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#InitFrustumAndLight\">InitFrustumAndLight</a> does always setup stencil confguration. Following <code>InitCaster</code> will only change stencil configuration if <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#ZFail\">ZFail</a> value will actually change. This means that if e.g. all objects will be detected to be in z-pass method, then stencil configuration will be done only once.  <p>The above optimization works OK if you do not change StencilOp configuration yourself during SV rendering.    ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#InitCaster"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.Render", "text": "  <p>You have to provide the appropriate callbacks that render given scene parts.  <p>Params.Transparent and Params.ShadowVolumesReceivers and Params.InShadow are changed here (their previous values are ignored). They cannot be modified by our callbacks.  <p>Render3D renders part of the scene.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> With Params.ShadowVolumesReceivers = <code>True</code>, renders only things that may be in the shadow. You should use Params.InShadow to either display the version of the scene in the shadows (so probably darker, probably with some lights off) or the version that is currently lighted (probably brighter, with normal scene lights on).</p></li>   <li><p> With Params.ShadowVolumesReceivers = <code>False</code>, renders only things that must never be considered in shadow (are not shadow receivers). Params.InShadow is always <code>False</code> when Params.ShadowVolumesReceivers = <code>False</code>.</p></li> </ul>  <p>  <p>Render3D must also honour Params.Transparent, rendering only opaque or only transparent parts. For Transparent = <code>True</code>, always Params.InShadow = <code>False</code>. Shadow volumes simply don't allow transparent object to function properly as shadow receivers. Reading [<a  href=\"http://developer.nvidia.com/object/fast_shadow_volumes.html\">http://developer.nvidia.com/object/fast_shadow_volumes.html</a>] notes: they also just do separate rendering pass to render the partially-transparent parts, IOW they also note that transparent parts simply don't work at all with shadow volumes.  <p>RenderShadowVolumes renders shadow volumes from shadow casters.  <p>If DrawShadowVolumes then shadow volumes will be also actually drawn to color buffer (as <a class=\"normal\" href=\"CastleColors.html#Yellow\">yellow</a> blended polygons), this is useful for debugging shadow volumes.    ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#Render"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.WrapAvailable", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#WrapAvailable"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.LightPosition", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#LightPosition"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.CasterShadowPossiblyVisible", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#CasterShadowPossiblyVisible"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.ZFail", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#ZFail"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.ZFailAndLightCap", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#ZFailAndLightCap"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.StencilTwoSided", "text": "  <p>This is initialized by <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#GLContextOpen\">GLContextOpen</a>, and is true if OpenGL provides one of: </p>  <ul class=\"paragraph_spacing\">   <li><p>glStencilOpSeparate (in OpenGL &gt;= 2.0)</p></li>   <li><p>GL_ATI_separate_stencil extension, glStencilOpSeparateATI</p></li>   <li><p>We could also handle GL_EXT_stencil_two_side extension, glActiveStencilFaceEXT. But, since OpenGL &gt;= 2.0 is now common, don't try.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#StencilTwoSided"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.StencilSetupKind", "text": "  <p>Set <a class=\"normal\" href=\"CastleGLShadowVolumes.html#ssFrontAndBack\">ssFrontAndBack</a> only if <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#StencilTwoSided\">StencilTwoSided</a> is <code>True</code>. Otherwise, you have to use 2-pass method (render everything 2 times, culling front one time, culling back second time) &mdash; in this case use <a class=\"normal\" href=\"CastleGLShadowVolumes.html#ssFront\">ssFront</a> or <a class=\"normal\" href=\"CastleGLShadowVolumes.html#ssBack\">ssBack</a> as appropriate. ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#StencilSetupKind"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.Count", "text": " They are enabled by default, as calculating them takes practically no time.  ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#Count"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.CountCasters", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#CountCasters"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.CountShadowsNotVisible", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#CountShadowsNotVisible"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.CountZPass", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#CountZPass"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.CountZFailNoLightCap", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#CountZFailNoLightCap"},
     {"title": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.CountZFailAndLightCap", "text": " ", "tags": "", "loc": "CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#CountZFailAndLightCap"},
     {"title": "CastleGLShadowVolumes.TStencilSetupKind", "text": "  ssFrontAndBack    ssFront    ssBack   ", "tags": "", "loc": "CastleGLShadowVolumes.html#TStencilSetupKind"},
     {"title": "CastleGLShadowVolumes.TSVRenderParamsProc", "text": "    ", "tags": "", "loc": "CastleGLShadowVolumes.html#TSVRenderParamsProc"},
     {"title": "CastleGLShadowVolumes.TSVRenderProc", "text": "    ", "tags": "", "loc": "CastleGLShadowVolumes.html#TSVRenderProc"},
     {"title": "CastleGLUtils", "text": " ", "tags": "", "loc": "CastleGLUtils.html"},
     {"title": "CastleGLUtils.EOpenGLError", "text": " Usually OpenGL error indicates a bug in our code (or shader code, depending on <a class=\"normal\" href=\"CastleGLShaders.html#TUniformNotFoundAction\">TUniformNotFoundAction</a> and <a class=\"normal\" href=\"CastleGLShaders.html#TUniformTypeMismatchAction\">TUniformTypeMismatchAction</a>; by default, they do not cause errors). Except the <a class=\"normal\" href=\"CastleGLUtils.EOpenGLOutOfMemoryError.html\">EOpenGLOutOfMemoryError</a>, which may happen regardless of what we do, and depends on the device. ", "tags": "", "loc": "CastleGLUtils.EOpenGLError.html"},
     {"title": "CastleGLUtils.EOpenGLError.ErrorCode", "text": " ", "tags": "", "loc": "CastleGLUtils.EOpenGLError.html#ErrorCode"},
     {"title": "CastleGLUtils.EOpenGLError.Create", "text": "    ", "tags": "", "loc": "CastleGLUtils.EOpenGLError.html#Create"},
     {"title": "CastleGLUtils.EOpenGLOutOfMemoryError", "text": "  <p>When programming for platforms with limited GPU memory (Android, iOS...) you should prepare to handle <code>EOpenGLOutOfMemoryError</code> (corresponding to GL_OUT_OF_MEMORY). This can always happen for large GPU data, and you should be prepared to capture it (at least around <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a>) and display some nice information for user. Alternatively, you can leave <a class=\"normal\" href=\"CastleGLUtils.html#GLOutOfMemoryError\">GLOutOfMemoryError</a> = <code>False</code>, and then <code>EOpenGLOutOfMemoryError</code> will not happen, but you risk all kinds of rendering artifacts. ", "tags": "", "loc": "CastleGLUtils.EOpenGLOutOfMemoryError.html"},
     {"title": "CastleGLUtils.EOpenGLNoMoreDisplayLists", "text": " ", "tags": "", "loc": "CastleGLUtils.EOpenGLNoMoreDisplayLists.html"},
     {"title": "CastleGLUtils.TGLMemoryInfo", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLMemoryInfo.html"},
     {"title": "CastleGLUtils.TGLMemoryInfo.Total", "text": " May be zero if unknown (only some NVidia GPUs support this). ", "tags": "", "loc": "CastleGLUtils.TGLMemoryInfo.html#Total"},
     {"title": "CastleGLUtils.TGLMemoryInfo.Current", "text": " May be zero if unknown (only some NVidia GPUs support this). ", "tags": "", "loc": "CastleGLUtils.TGLMemoryInfo.html#Current"},
     {"title": "CastleGLUtils.TGLMemoryInfo.CurrentVbo", "text": " May be zero if unknown (only some AMD GPUs support this). ", "tags": "", "loc": "CastleGLUtils.TGLMemoryInfo.html#CurrentVbo"},
     {"title": "CastleGLUtils.TGLMemoryInfo.CurrentTexture", "text": " May be zero if unknown (only some AMD GPUs support this). ", "tags": "", "loc": "CastleGLUtils.TGLMemoryInfo.html#CurrentTexture"},
     {"title": "CastleGLUtils.TGLMemoryInfo.CurrentRenderbuffer", "text": " May be zero if unknown (only some AMD GPUs support this). ", "tags": "", "loc": "CastleGLUtils.TGLMemoryInfo.html#CurrentRenderbuffer"},
     {"title": "CastleGLUtils.TGLMemoryInfo.Create", "text": "    ", "tags": "", "loc": "CastleGLUtils.TGLMemoryInfo.html#Create"},
     {"title": "CastleGLUtils.TGLMemoryInfo.Refresh", "text": "    ", "tags": "", "loc": "CastleGLUtils.TGLMemoryInfo.html#Refresh"},
     {"title": "CastleGLUtils.TGLMemoryInfo.LessTextureMemoryThan", "text": " Looks at <a class=\"normal\" href=\"CastleGLUtils.TGLMemoryInfo.html#Current\">Current</a> or <a class=\"normal\" href=\"CastleGLUtils.TGLMemoryInfo.html#CurrentTexture\">CurrentTexture</a>, whichever is available.  <p>This is useful to detect at runtime when to use e.g. compressed textures (S3TC and such) or downscaled textures (using <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a> or <a class=\"normal\" href=\"CastleMaterialProperties.html#TextureLoadingScale\">TextureLoadingScale</a>).    ", "tags": "", "loc": "CastleGLUtils.TGLMemoryInfo.html#LessTextureMemoryThan"},
     {"title": "CastleGLUtils.TGLFeatures", "text": " A single instance of this class is assigned to <a class=\"normal\" href=\"CastleGLUtils.html#GLFeatures\">GLFeatures</a> after the first OpenGL context was created.  <p>If you have multiple OpenGL contexts, our engine assumes they share resources and have equal features. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html"},
     {"title": "CastleGLUtils.TGLFeatures.Version_1_2", "text": " Checked by looking at GL version string <i>and</i> by checking whether actual entry points are available.  <p>This is important because bad OpenGL implementations (like the horrible ATI Linux closed drivers) sometimes lie, claiming support in the GL version string but actually lacking proper function entry points. We check the actual presence of entry points (GLExt.Load_GL_version_x_x do that).  <p>We *also* check version string (TGLVersion.AtLeast), since OpenGL may have some buggy entry point in case of work-in-progress features (not yet advertised in GL version string), e.g. Mesa 6.x had such buggy glStencilOpSeparate. This is correct OpenGL behavior AFAIK, and we handle it. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_1_2"},
     {"title": "CastleGLUtils.TGLFeatures.Version_1_3", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_1_3"},
     {"title": "CastleGLUtils.TGLFeatures.Version_1_4", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_1_4"},
     {"title": "CastleGLUtils.TGLFeatures.Version_1_5", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_1_5"},
     {"title": "CastleGLUtils.TGLFeatures.Version_2_0", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_2_0"},
     {"title": "CastleGLUtils.TGLFeatures.Version_2_1", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_2_1"},
     {"title": "CastleGLUtils.TGLFeatures.Version_3_0", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_3_0"},
     {"title": "CastleGLUtils.TGLFeatures.Version_3_1", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_3_1"},
     {"title": "CastleGLUtils.TGLFeatures.Version_3_2", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_3_2"},
     {"title": "CastleGLUtils.TGLFeatures.Version_3_3", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_3_3"},
     {"title": "CastleGLUtils.TGLFeatures.Version_4_0", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Version_4_0"},
     {"title": "CastleGLUtils.TGLFeatures.ARB_shadow", "text": " Note: we prefer to avoid exposing directly each extension presence like below. Instead most interesting extensions are wrapped in &quot;features&quot; like <a class=\"normal\" href=\"CastleGLUtils.TGLFeatures.html#UseMultiTexturing\">UseMultiTexturing</a>, see lower. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#ARB_shadow"},
     {"title": "CastleGLUtils.TGLFeatures.EXT_texture_filter_anisotropic", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#EXT_texture_filter_anisotropic"},
     {"title": "CastleGLUtils.TGLFeatures.NV_multisample_filter_hint", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#NV_multisample_filter_hint"},
     {"title": "CastleGLUtils.TGLFeatures.ARB_occlusion_query", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#ARB_occlusion_query"},
     {"title": "CastleGLUtils.TGLFeatures.EXT_fog_coord", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#EXT_fog_coord"},
     {"title": "CastleGLUtils.TGLFeatures.ARB_window_pos", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#ARB_window_pos"},
     {"title": "CastleGLUtils.TGLFeatures.MESA_window_pos", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MESA_window_pos"},
     {"title": "CastleGLUtils.TGLFeatures.CLAMP_TO_EDGE", "text": " Otherwise GL_CLAMP.  <p>Use this (insteaf of direct GL_CLAMP_TO_EDGE) to work with <i>really ancient</i> OpenGL versions before 1.2. Note that our engine officially supports only OpenGL &gt;= 1.2, so don't expect everything to work smootly with such ancient OpenGL anyway! ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#CLAMP_TO_EDGE"},
     {"title": "CastleGLUtils.TGLFeatures.MaxTextureSize", "text": " Initialized to 0 if appropriate OpenGL functionality is not available.  ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxTextureSize"},
     {"title": "CastleGLUtils.TGLFeatures.MaxLights", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxLights"},
     {"title": "CastleGLUtils.TGLFeatures.MaxCubeMapTextureSize", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxCubeMapTextureSize"},
     {"title": "CastleGLUtils.TGLFeatures.MaxTexture3DSize", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxTexture3DSize"},
     {"title": "CastleGLUtils.TGLFeatures.MaxTextureMaxAnisotropyEXT", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxTextureMaxAnisotropyEXT"},
     {"title": "CastleGLUtils.TGLFeatures.QueryCounterBits", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#QueryCounterBits"},
     {"title": "CastleGLUtils.TGLFeatures.MaxRenderbufferSize", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxRenderbufferSize"},
     {"title": "CastleGLUtils.TGLFeatures.MaxClipPlanes", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxClipPlanes"},
     {"title": "CastleGLUtils.TGLFeatures.Multisample", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Multisample"},
     {"title": "CastleGLUtils.TGLFeatures.MaxTextureUnitsFixedFunction", "text": " Equal to 0 on OpenGLES (that doesn't have fixed-function pipeline). Equal to <a class=\"normal\" href=\"CastleGLUtils.html#glGetInteger\">glGetInteger</a>(GL_MAX_TEXTURE_UNITS), if multi-texturing available. Equal to 1 (OpenGL supports always 1 texture) otherwise. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxTextureUnitsFixedFunction"},
     {"title": "CastleGLUtils.TGLFeatures.MaxTextureUnitsShaders", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxTextureUnitsShaders"},
     {"title": "CastleGLUtils.TGLFeatures.UseMultiTexturing", "text": "  <p>This used to check a couple of multitexturing extensions, like ARB_multitexture. Right now, it simply checks for OpenGL 1.3 version. It is supported by virtually all existing GPUs. So it's acceptable to just check it, and write your code for 1.3, and eventual fallback code (when this is false) write only for really ancient GPUs. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#UseMultiTexturing"},
     {"title": "CastleGLUtils.TGLFeatures.Texture3D", "text": " If they are, note that GL_TEXTURE_3D and GL_TEXTURE_3D_EXT are equal, so often both <code>Texture3D</code> = <a class=\"normal\" href=\"CastleGLUtils.html#gsStandard\">gsStandard</a> and <code>Texture3D</code> = <a class=\"normal\" href=\"CastleGLUtils.html#gsExtension\">gsExtension</a> cases may be handled by the same code. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Texture3D"},
     {"title": "CastleGLUtils.TGLFeatures.Framebuffer", "text": " Value <a class=\"normal\" href=\"CastleGLUtils.html#gsExtension\">gsExtension</a> means that EXT_framebuffer_object is used, <a class=\"normal\" href=\"CastleGLUtils.html#gsStandard\">gsStandard</a> means that ARB_framebuffer_object (which is a &quot;core extesion&quot;, present the same way in OpenGL 3 core, also in OpenGL ES &gt;= 2.0 core) is available. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Framebuffer"},
     {"title": "CastleGLUtils.TGLFeatures.FBOMultiSampling", "text": " Although these are two orthogonal features of OpenGL, in practice you want to use <a class=\"normal\" href=\"CastleGLUtils.TGLFeatures.html#Multisample\">multisample</a> for both FBO buffers and textures, or for none &mdash; otherwise, FBO can not be initialized correctly when you mix various <a class=\"normal\" href=\"CastleGLUtils.TGLFeatures.html#Multisample\">multisample</a> settings. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#FBOMultiSampling"},
     {"title": "CastleGLUtils.TGLFeatures.CurrentMultiSampling", "text": " Value = 1 means that no multi-sampling is initialized. Values &gt; 1 mean that you have multi-sampling, with given number of samples per pixel. Contrast this with <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MultiSampling\">TCastleWindowCustom.MultiSampling</a> or TOpenGLControl.MultiSampling, that say <i>how many samples you wanted to get</i>. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#CurrentMultiSampling"},
     {"title": "CastleGLUtils.TGLFeatures.PackedDepthStencil", "text": " See OpenGL extensions EXT_packed_depth_stencil and OES_packed_depth_stencil (<a  href=\"http://www.opengl.org/registry/specs/EXT/packed_depth_stencil.txt\">http://www.opengl.org/registry/specs/EXT/packed_depth_stencil.txt</a>, <a  href=\"https://www.khronos.org/registry/OpenGL/extensions/OES/OES_packed_depth_stencil.txt\">https://www.khronos.org/registry/OpenGL/extensions/OES/OES_packed_depth_stencil.txt</a>) for explanation what does it mean.  <p>This is important for FBOs, as the depth/stencil have to be set up differently depending on <code>PackedDepthStencil</code> value. This is also important for all code using <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html\">TGLRenderToTexture</a> with <a class=\"normal\" href=\"CastleGLImages.TGLRenderToTexture.html#Buffer\">TGLRenderToTexture.Buffer</a> equal <a class=\"normal\" href=\"CastleGLImages.html#tbDepth\">tbDepth</a> or <a class=\"normal\" href=\"CastleGLImages.html#tbColorAndDepth\">tbColorAndDepth</a>: your depth texture must be prepared differently, to include both depth+stencil data, to work.  <p>For now, this is simply equal to GL_EXT_packed_depth_stencil. (TODO: for core OpenGL 3, how to detect should we use packed version? <a  href=\"http://www.opengl.org/registry/specs/ARB/framebuffer_object.txt\">http://www.opengl.org/registry/specs/ARB/framebuffer_object.txt</a> incorporates EXT_packed_depth_stencil, so forward-compatible contexts do not need to declare it. Should we assume that forward-compatible gl 3 contexts always have depth/stencil packed?) ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#PackedDepthStencil"},
     {"title": "CastleGLUtils.TGLFeatures.ShadowVolumesPossible", "text": " This simply checks do we have stencil buffer with at least 4 bits for now. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#ShadowVolumesPossible"},
     {"title": "CastleGLUtils.TGLFeatures.TextureNonPowerOfTwo", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#TextureNonPowerOfTwo"},
     {"title": "CastleGLUtils.TGLFeatures.TextureCubeMap", "text": "  <p><a class=\"normal\" href=\"CastleGLUtils.html#gsExtension\">gsExtension</a> means GL_ARB_texture_cube_map on core OpenGL. <a class=\"normal\" href=\"CastleGLUtils.html#gsStandard\">gsStandard</a> means standard feature of OpenGL or OpenGL ES. Since the constants defined by ARB_texture_cube_map were promoted to core with the same values, the distinction between <a class=\"normal\" href=\"CastleGLUtils.html#gsExtension\">gsExtension</a> and <a class=\"normal\" href=\"CastleGLUtils.html#gsStandard\">gsStandard</a> in practice doesn't exist. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#TextureCubeMap"},
     {"title": "CastleGLUtils.TGLFeatures.TextureCompression", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#TextureCompression"},
     {"title": "CastleGLUtils.TGLFeatures.VertexBufferObject", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#VertexBufferObject"},
     {"title": "CastleGLUtils.TGLFeatures.BlendConstant", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#BlendConstant"},
     {"title": "CastleGLUtils.TGLFeatures.TextureFloat", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#TextureFloat"},
     {"title": "CastleGLUtils.TGLFeatures.TextureDepth", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#TextureDepth"},
     {"title": "CastleGLUtils.TGLFeatures.Shaders", "text": " ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Shaders"},
     {"title": "CastleGLUtils.TGLFeatures.EnableFixedFunction", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>This makes Gouraud-shaded shapes rendered using OpenGL fixed-function pipeline on desktops.</p></li>   <li><p>It also makes <a class=\"normal\" href=\"CastleGLImages.TGLImage.html#Draw\">TGLImage.Draw</a>, <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a> (and consequently most of the 2D user-interface) rendered using OpenGL fixed-function pipeline on desktops.</p></li>   <li><p>It also allows you to use fixed-function pipeline calls in the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">TCastleWindowCustom.OnRender</a> callback, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a> override and related places.</p></li>   <li><p>It also allows some deprecated rendering features like <a class=\"normal\" href=\"CastleGLUtils.html#WindowPos\">WindowPos</a> to continue to work.</p></li> </ul>  <p>  <p>This is <code>False</code> by default on modern GPUs (that have good GLSL support).  <p>On OpenGLES, it must be <code>False</code> always, since OpenGLES &gt;= 2 has no fixed-function pipeline. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#EnableFixedFunction"},
     {"title": "CastleGLUtils.TGLFeatures.Memory", "text": " Call Memory.Refresh whenever needed. ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Memory"},
     {"title": "CastleGLUtils.TGLFeatures.MaxTextureUnits", "text": " If <a class=\"normal\" href=\"CastleGLUtils.TGLFeatures.html#EnableFixedFunction\">EnableFixedFunction</a>, this is <a class=\"normal\" href=\"CastleGLUtils.TGLFeatures.html#MaxTextureUnitsFixedFunction\">MaxTextureUnitsFixedFunction</a>, otherwise <a class=\"normal\" href=\"CastleGLUtils.TGLFeatures.html#MaxTextureUnitsShaders\">MaxTextureUnitsShaders</a>.    ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#MaxTextureUnits"},
     {"title": "CastleGLUtils.TGLFeatures.Create", "text": "    ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Create"},
     {"title": "CastleGLUtils.TGLFeatures.Destroy", "text": "    ", "tags": "", "loc": "CastleGLUtils.TGLFeatures.html#Destroy"},
     {"title": "CastleGLUtils.EGenerateMipmapNotAvailable", "text": " ", "tags": "", "loc": "CastleGLUtils.EGenerateMipmapNotAvailable.html"},
     {"title": "CastleGLUtils.TScissor", "text": " Always disable an <a class=\"normal\" href=\"CastleGLUtils.TScissor.html#Enabled\">enabled</a> scissor (destructor does it automatically).  <p>Make sure to enable and disable the scissor when the same OpenGL context is current. In practice, the only reliable way to do this is to enable and then disable the scissor within the same OnRender event. ", "tags": "", "loc": "CastleGLUtils.TScissor.html"},
     {"title": "CastleGLUtils.TScissor.Rect", "text": " Empty by default (will clip everything, if you don't assign this!). Do not change this when scissor is <a class=\"normal\" href=\"CastleGLUtils.TScissor.html#Enabled\">enabled</a>. ", "tags": "", "loc": "CastleGLUtils.TScissor.html#Rect"},
     {"title": "CastleGLUtils.TScissor.Create", "text": "    ", "tags": "", "loc": "CastleGLUtils.TScissor.html#Create"},
     {"title": "CastleGLUtils.TScissor.Destroy", "text": "    ", "tags": "", "loc": "CastleGLUtils.TScissor.html#Destroy"},
     {"title": "CastleGLUtils.TScissor.Enabled", "text": " ", "tags": "", "loc": "CastleGLUtils.TScissor.html#Enabled"},
     {"title": "CastleGLUtils.TRenderContext", "text": " We try hard to make this a <b>very, very</b> small class, because usually it's better to introduce a clean higher-level API than to track the OpenGL context state in a simple global <a class=\"normal\" href=\"CastleGLUtils.html#RenderContext\">RenderContext</a> instance.  <p>Use the methods and properties of this class only when this context is <i>current</i>, which means it's set as <a class=\"normal\" href=\"CastleGLUtils.html#RenderContext\">RenderContext</a> value.  <p>Do not depend on the context state being persistent. The <a class=\"normal\" href=\"CastleGLUtils.html#RenderContext\">RenderContext</a> does not change during a single TUIControl.OnRender method (with all 2D and 3D stuff rendered inside), but that's all we guarantee. On desktops, you control the context creation / destruction explicitly (by opening / closing the <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a>). But on mobile devices &ndash; the context may get destroyed and created at almost any moment. So do not use the instance of <a class=\"normal\" href=\"CastleGLUtils.html#RenderContext\">RenderContext</a> to store anything you rely on being stored. Instead, use your own variables for this, and only synchronize <a class=\"normal\" href=\"CastleGLUtils.html#RenderContext\">RenderContext</a> with your variables. ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html"},
     {"title": "CastleGLUtils.TRenderContext.Create", "text": "    ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#Create"},
     {"title": "CastleGLUtils.TRenderContext.Destroy", "text": "    ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#Destroy"},
     {"title": "CastleGLUtils.TRenderContext.Clear", "text": "  <p>Never call OpenGL <a class=\"normal\" href=\"CastleGLUtils.html#GLClear\">glClear</a> or glClearColor, always use this method.    ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#Clear"},
     {"title": "CastleGLUtils.TRenderContext.ScissorEnable", "text": "  <p>Never call OpenGL glScissor or glEnable(GL_SCISSOR_TEST) / glDisable(GL_SCISSOR_TEST) directly, or push/pop the related attrib (in case of fixed-function pipeline).     ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#ScissorEnable"},
     {"title": "CastleGLUtils.TRenderContext.ScissorDisable", "text": "    ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#ScissorDisable"},
     {"title": "CastleGLUtils.TRenderContext.LineWidth", "text": " Never call OpenGL glLineWidth directly.  <p>Do not access this property directly, unless you make direct OpenGL/OpenGLES calls. In normal circumstances, engine API (like <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a> or <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>) set this automatically. ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#LineWidth"},
     {"title": "CastleGLUtils.TRenderContext.PointSize", "text": " Never call OpenGL glPointSize directly.  <p>Do not access this property directly, unless you make direct OpenGL/OpenGLES calls. In normal circumstances, engine API (like <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a> or <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>) set this automatically. ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#PointSize"},
     {"title": "CastleGLUtils.TRenderContext.GlobalAmbient", "text": " This is added to every 3D object color, multiplied by material ambient.  <p>The default value is (0.2, 0.2, 0.2). It matches default GL_LIGHT_MODEL_AMBIENT in fixed-function OpenGL. It also matches the required value of VRML 1.0 specification. For VRML 2.0 / X3D, lighting equations suggest that it should be zero. ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#GlobalAmbient"},
     {"title": "CastleGLUtils.TRenderContext.ProjectionMatrix", "text": "  <p>When GLFeatures.EnableFixedFunction = true, setting this also sets fixed-function projection matrix. ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#ProjectionMatrix"},
     {"title": "CastleGLUtils.TRenderContext.DepthRange", "text": " For now, our engine has very simple use for this, for <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#RenderOnTop\">TPlayer.RenderOnTop</a>. ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#DepthRange"},
     {"title": "CastleGLUtils.TRenderContext.CullFace", "text": " This controls whether OpenGL GL_CULL_FACE flag is enabled or not. ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#CullFace"},
     {"title": "CastleGLUtils.TRenderContext.FrontFaceCcw", "text": " The &quot;front face&quot; is important to interpreting the <a class=\"normal\" href=\"CastleGLUtils.TRenderContext.html#CullFace\">CullFace</a> and to interpret the normal vectors (they point ourward from front face). ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#FrontFaceCcw"},
     {"title": "CastleGLUtils.TRenderContext.ColorMask", "text": " ", "tags": "", "loc": "CastleGLUtils.TRenderContext.html#ColorMask"},
     {"title": "CastleGLUtils.GLSupportNames", "text": " ", "tags": "", "loc": "CastleGLUtils.html#GLSupportNames"},
     {"title": "CastleGLUtils.DefaultCircleSlices", "text": " ", "tags": "", "loc": "CastleGLUtils.html#DefaultCircleSlices"},
     {"title": "CastleGLUtils.GLOutOfMemory", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLOutOfMemory"},
     {"title": "CastleGLUtils.GLErrorString", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLErrorString"},
     {"title": "CastleGLUtils.CheckGLErrors", "text": " If there are errors, our behavior depends on whether we were compiled with -dRELEASE. With -dRELEASE, we make <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>. This way eventual errors in release builds don't completely abort your program.  <p>Note that the behavior on GL_OUT_OF_MEMORY is different. -dRELEASE does not matter here. Only <a class=\"normal\" href=\"CastleGLUtils.html#GLOutOfMemoryError\">GLOutOfMemoryError</a> boolean dictates if we should raise an exception or merely make warning, regardless of -dRELEASE state.  <p>Without -dRELEASE, we raise <a class=\"normal\" href=\"CastleGLUtils.EOpenGLError.html\">EOpenGLError</a>. So a developer is strongly suggested to fix the code to not produce OpenGL errors, never ever.  <p>    EOpenGLError ", "tags": "", "loc": "CastleGLUtils.html#CheckGLErrors"},
     {"title": "CastleGLUtils.GLErrorRaise", "text": " This has calling convention suitable for registering this procedure as GLU_TESS_ERROR for gluTessCallback, or GLU_ERROR for gluQuadricCallback.    ", "tags": "", "loc": "CastleGLUtils.html#GLErrorRaise"},
     {"title": "CastleGLUtils.glGetFloat", "text": "  <p>Guarantee that result is zero in case of OpenGL error. (Otherwise, OpenGL could leave them undefined and only set glGetError.)     ", "tags": "", "loc": "CastleGLUtils.html#glGetFloat"},
     {"title": "CastleGLUtils.glGetInteger", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glGetInteger"},
     {"title": "CastleGLUtils.glGetBoolean", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glGetBoolean"},
     {"title": "CastleGLUtils.glColorv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glColorv"},
     {"title": "CastleGLUtils.glColorv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glColorv"},
     {"title": "CastleGLUtils.glColorv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glColorv"},
     {"title": "CastleGLUtils.glColorv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glColorv"},
     {"title": "CastleGLUtils.glTranslatev", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glTranslatev"},
     {"title": "CastleGLUtils.glTranslatev", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glTranslatev"},
     {"title": "CastleGLUtils.glScalev", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glScalev"},
     {"title": "CastleGLUtils.glScalev", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glScalev"},
     {"title": "CastleGLUtils.glScalev", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glScalev"},
     {"title": "CastleGLUtils.glRotatev", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glRotatev"},
     {"title": "CastleGLUtils.glClipPlane", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glClipPlane"},
     {"title": "CastleGLUtils.glNormalv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glNormalv"},
     {"title": "CastleGLUtils.glMaterialv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glMaterialv"},
     {"title": "CastleGLUtils.glVertexv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glVertexv"},
     {"title": "CastleGLUtils.glVertexv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glVertexv"},
     {"title": "CastleGLUtils.glVertexv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glVertexv"},
     {"title": "CastleGLUtils.glVertexv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glVertexv"},
     {"title": "CastleGLUtils.glVertexv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glVertexv"},
     {"title": "CastleGLUtils.glVertexv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glVertexv"},
     {"title": "CastleGLUtils.glVertexv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glVertexv"},
     {"title": "CastleGLUtils.glVertexv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glVertexv"},
     {"title": "CastleGLUtils.glVertexv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glVertexv"},
     {"title": "CastleGLUtils.glTexCoordv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glTexCoordv"},
     {"title": "CastleGLUtils.glTexCoordv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glTexCoordv"},
     {"title": "CastleGLUtils.glTexCoordv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glTexCoordv"},
     {"title": "CastleGLUtils.glTexGenv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glTexGenv"},
     {"title": "CastleGLUtils.glLightv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glLightv"},
     {"title": "CastleGLUtils.glLightv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glLightv"},
     {"title": "CastleGLUtils.glLightModelv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glLightModelv"},
     {"title": "CastleGLUtils.glFogv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glFogv"},
     {"title": "CastleGLUtils.glMultMatrix", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glMultMatrix"},
     {"title": "CastleGLUtils.glLoadMatrix", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glLoadMatrix"},
     {"title": "CastleGLUtils.glTexEnvv", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glTexEnvv"},
     {"title": "CastleGLUtils.GLViewport", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLViewport"},
     {"title": "CastleGLUtils.GLSetEnabled", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLSetEnabled"},
     {"title": "CastleGLUtils.GLVerticalLine", "text": " Uses current OpenGL color.  <p>Deprecated, do not draw lines directly like this, instead use <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a> or UI interface drawing like Theme.Draw and <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw\">TGLImageCore.Draw</a>.    ", "tags": "", "loc": "CastleGLUtils.html#GLVerticalLine"},
     {"title": "CastleGLUtils.GLHorizontalLine", "text": " Uses current OpenGL color.  <p>Deprecated, do not draw lines directly like this, instead use <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a> or UI interface drawing like Theme.Draw and <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw\">TGLImageCore.Draw</a>.    ", "tags": "", "loc": "CastleGLUtils.html#GLHorizontalLine"},
     {"title": "CastleGLUtils.GLDrawArrow", "text": " Arrow is placed on Z = 0 plane, points to the up, has height = 2 (from y = 0 to y = 2) and width 1 (from x = -0.5 to 0.5).  <p>Everything is drawn CCW when seen from standard view (x grows right, y up). Uses current OpenGL color.    ", "tags": "", "loc": "CastleGLUtils.html#GLDrawArrow"},
     {"title": "CastleGLUtils.NewGLUQuadric", "text": " Sets all quadric parameters. Sets also the GLU_ERROR callback to ReportGLerror.     Exception If gluNewQuadric fails (returns nil).", "tags": "", "loc": "CastleGLUtils.html#NewGLUQuadric"},
     {"title": "CastleGLUtils.CastleGluSphere", "text": " Radius, Slices, Stacks have the same meaning as for gluSphere (in case they are not self-explanatory...). Other parameters set glu quadric parameters, see glu quadric documentation.    ", "tags": "", "loc": "CastleGLUtils.html#CastleGluSphere"},
     {"title": "CastleGLUtils.glDrawAxisWire", "text": " Nothing is generated besides vertex positions &mdash; no normal vectors, no texture coords, nothing.    ", "tags": "", "loc": "CastleGLUtils.html#glDrawAxisWire"},
     {"title": "CastleGLUtils.glColorOpacity", "text": " Deprecated, do not use colors like that, instead pass <a class=\"normal\" href=\"CastleColors.html#TCastleColor\">TCastleColor</a> to appropriate routines like <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Print\">TCastleFont.Print</a>.     ", "tags": "", "loc": "CastleGLUtils.html#glColorOpacity"},
     {"title": "CastleGLUtils.glColorOpacity", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glColorOpacity"},
     {"title": "CastleGLUtils.glGenListsCheck", "text": "  <p>    EOpenGLNoMoreDisplayLists When glGenLists(Range) returned zero for non-zero Range. The exception's Message shows Place, which may describe where this is called &mdash; makes it easier to debug.", "tags": "", "loc": "CastleGLUtils.html#glGenListsCheck"},
     {"title": "CastleGLUtils.glFreeDisplayList", "text": " In other words this is simply glDeleteList but </p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>only if List really should be deleted</p></li>   <li value=\"2\"><p>sets List to 0 after deletion</p></li> </ol>  <p>    ", "tags": "", "loc": "CastleGLUtils.html#glFreeDisplayList"},
     {"title": "CastleGLUtils.glFreeBuffer", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#glFreeBuffer"},
     {"title": "CastleGLUtils.glSetDepthAndColorWriteable", "text": " This is just a shortcut for </p>  <pre class=\"longcode\"> glDepthMask(Writeable); glColorMask(Writeable, Writeable, Writeable, Writeable);</pre>  <p>    ", "tags": "", "loc": "CastleGLUtils.html#glSetDepthAndColorWriteable"},
     {"title": "CastleGLUtils.GLEnableTexture", "text": " Always use this instead of manually calling <code>glDisable(GL_TEXTURE_2D)</code>, <code>glEnable(GL_TEXTURE_2D)</code> and such. This makes sure to have at most one texture target enabled, and disable others.  <p>Remember that this state is different for every texture unit in OpenGL, in case you use multi-texturing.  <p>Remember that not all texture targets are guaranteed to be supported by OpenGL. Target=<a class=\"normal\" href=\"CastleGLUtils.html#etNone\">etNone</a> and Target=<a class=\"normal\" href=\"CastleGLUtils.html#et2D\">et2D</a> are always supported. For the rest, check appropriate <a class=\"normal\" href=\"CastleGLUtils.html#GLFeatures\">GLFeatures</a> property (before even creating a texture with such type). If you pass an unsupported target type to this procedure, it will be ignored (all targets will be disabled, like for Target=<a class=\"normal\" href=\"CastleGLUtils.html#etNone\">etNone</a>).  <p>Note that this is only for fixed-function OpenGL pipeline. Shader pipeline completely ignores the enabled state of texture units.    ", "tags": "", "loc": "CastleGLUtils.html#GLEnableTexture"},
     {"title": "CastleGLUtils.GLInformationInitialize", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLInformationInitialize"},
     {"title": "CastleGLUtils.DrawRectangle", "text": "  <p>Like with <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a>: Blending is automatically used if Color alpha &lt; 1. ForceBlending forces the usage of blending. When it is <code>False</code>, we use blending only if Color[3] (alpha) &lt; 1.    ", "tags": "", "loc": "CastleGLUtils.html#DrawRectangle"},
     {"title": "CastleGLUtils.DrawRectangleOutline", "text": "  <p>Like with <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a>: Blending is automatically used if Color alpha &lt; 1. ForceBlending forces the usage of blending. When it is <code>False</code>, we use blending only if Color[3] (alpha) &lt; 1.    ", "tags": "", "loc": "CastleGLUtils.html#DrawRectangleOutline"},
     {"title": "CastleGLUtils.DrawCircle", "text": " It may be scaled differently in X than Y, thus resembling an ellipse.  <p>Like with <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a>: Blending is automatically used if Color alpha &lt; 1. ForceBlending forces the usage of blending. When it is <code>False</code>, we use blending only if Color[3] (alpha) &lt; 1.    ", "tags": "", "loc": "CastleGLUtils.html#DrawCircle"},
     {"title": "CastleGLUtils.DrawCircleOutline", "text": " It may be scaled differently in X than Y, thus resembling an ellipse.  <p>Like with <a class=\"normal\" href=\"CastleGLUtils.html#DrawPrimitive2D\">DrawPrimitive2D</a>: Blending is automatically used if Color alpha &lt; 1. ForceBlending forces the usage of blending. When it is <code>False</code>, we use blending only if Color[3] (alpha) &lt; 1.    ", "tags": "", "loc": "CastleGLUtils.html#DrawCircleOutline"},
     {"title": "CastleGLUtils.DrawPrimitive2D", "text": " This can be used to draw a series of points, lines or triangles, depending on the <code>Mode</code> parameter.  <p>Blending is automatically used if Color alpha &lt; 1. ForceBlending forces the usage of blending. When it is <code>False</code>, we use blending only if Color[3] (alpha) &lt; 1.  <p>  <p>  LineWidth Line width, only used when Mode indicates lines.  <p>Note that <b>values other than 1 are not guaranteed to be supported.</b> While it's a fast method to have thick lines, it is implementation-limited in case of </p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>desktop OpenGL with anti-aliasing, see <a  href=\"https://www.opengl.org/sdk/docs/man/html/glLineWidth.xhtml\">https://www.opengl.org/sdk/docs/man/html/glLineWidth.xhtml</a> </p></li>   <li value=\"2\"><p>mobile OpenGLES, with or without anti-aliasing, see <a  href=\"https://www.khronos.org/opengles/sdk/docs/man/xhtml/glLineWidth.xml\">https://www.khronos.org/opengles/sdk/docs/man/xhtml/glLineWidth.xml</a> </p></li> </ol>  <p> PointSize Point size, only used when Mode indicates points.  <p>Note that <b>values other than 1 are not guaranteed to be supported.</b> Mobile OpenGLES does not support setting point size like this. And desktop OpenGL limits point size in case anti-aliasing is used, see <a  href=\"https://www.opengl.org/sdk/docs/man2/xhtml/glPointSize.xml\">https://www.opengl.org/sdk/docs/man2/xhtml/glPointSize.xml</a> .  LineWidth Line width, only used when Mode indicates lines.  <p>Note that <b>values other than 1 are not guaranteed to be supported.</b> While it's a fast method to have thick lines, it is implementation-limited in case of </p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>desktop OpenGL with anti-aliasing, see <a  href=\"https://www.opengl.org/sdk/docs/man/html/glLineWidth.xhtml\">https://www.opengl.org/sdk/docs/man/html/glLineWidth.xhtml</a> </p></li>   <li value=\"2\"><p>mobile OpenGLES, with or without anti-aliasing, see <a  href=\"https://www.khronos.org/opengles/sdk/docs/man/xhtml/glLineWidth.xml\">https://www.khronos.org/opengles/sdk/docs/man/xhtml/glLineWidth.xml</a> </p></li> </ol>  <p> PointSize Point size, only used when Mode indicates points.  <p>Note that <b>values other than 1 are not guaranteed to be supported.</b> Mobile OpenGLES does not support setting point size like this. And desktop OpenGL limits point size in case anti-aliasing is used, see <a  href=\"https://www.opengl.org/sdk/docs/man2/xhtml/glPointSize.xml\">https://www.opengl.org/sdk/docs/man2/xhtml/glPointSize.xml</a> .", "tags": "", "loc": "CastleGLUtils.html#DrawPrimitive2D"},
     {"title": "CastleGLUtils.GLFadeRectangleDark", "text": "  <p>The <a class=\"normal\" href=\"CastleGLUtils.html#GLFadeRectangleLight\">GLFadeRectangleLight</a> version makes a flash to AFadeColor, then goes back to normal. It works reasonably with any color (light or dark).  <p>The <a class=\"normal\" href=\"CastleGLUtils.html#GLFadeRectangleDark\">GLFadeRectangleDark</a> version makes additional flash to blackness in the middle (so it goes from no modulation, to AFadeColor, to pure <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>, and then back to normal). So the &quot;Dark&quot; version is a little more impressive when you're flashing with a dark color.  <p>These are nice as a screen effect, to flash some color (e.g. flash red color when the player is hurt).  <p>Only RGB portion of AFadeColor is used.    ", "tags": "", "loc": "CastleGLUtils.html#GLFadeRectangleDark"},
     {"title": "CastleGLUtils.GLFadeRectangleDark", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLFadeRectangleDark"},
     {"title": "CastleGLUtils.GLFadeRectangleLight", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLFadeRectangleLight"},
     {"title": "CastleGLUtils.GLFadeRectangle", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLFadeRectangle"},
     {"title": "CastleGLUtils.GLFadeRectangle", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLFadeRectangle"},
     {"title": "CastleGLUtils.GLBlendRectangle", "text": "  Deprecated, use <a class=\"normal\" href=\"CastleGLUtils.html#DrawRectangle\">DrawRectangle</a> instead.    ", "tags": "", "loc": "CastleGLUtils.html#GLBlendRectangle"},
     {"title": "CastleGLUtils.GLBlendRectangle", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLBlendRectangle"},
     {"title": "CastleGLUtils.GLBlendFunction", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLBlendFunction"},
     {"title": "CastleGLUtils.GLInformationString", "text": " This simply queries OpenGL using glGet* functions about many things. Does not change OpenGL state in any way.  <p>Note that the last line of returned string does not terminate with a newline character (so e.g. you may want to do Writeln(<code>GLInformationString</code>) instead of just Write(<code>GLInformationString</code>)).    ", "tags": "", "loc": "CastleGLUtils.html#GLInformationString"},
     {"title": "CastleGLUtils.HasGenerateMipmap", "text": " This checks some GL extensions/versions that give us glGenerateMipmap or glGenerateMipmapEXT call, used by <a class=\"normal\" href=\"CastleGLUtils.html#GenerateMipmap\">GenerateMipmap</a>.    ", "tags": "", "loc": "CastleGLUtils.html#HasGenerateMipmap"},
     {"title": "CastleGLUtils.GenerateMipmap", "text": "  <p>    EGenerateMipmapNotAvailable If no glGenerateMipmap version is available on this OpenGL version. If you don't want to get this exception, you can always check <a class=\"normal\" href=\"CastleGLUtils.html#HasGenerateMipmap\">HasGenerateMipmap</a> before calling this.", "tags": "", "loc": "CastleGLUtils.html#GenerateMipmap"},
     {"title": "CastleGLUtils.GLClear", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GLClear"},
     {"title": "CastleGLUtils.GetProjectionMatrix", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GetProjectionMatrix"},
     {"title": "CastleGLUtils.SetProjectionMatrix", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#SetProjectionMatrix"},
     {"title": "CastleGLUtils.PerspectiveProjection", "text": "  <p>For <code>PerspectiveProjection</code>, ZFar may have special <a class=\"normal\" href=\"CastleProjection.html#ZFarInfinity\">ZFarInfinity</a> value to create a perspective projection with far plane set at infinity. Useful e.g. for z-fail shadow volumes.  <p>    ", "tags": "", "loc": "CastleGLUtils.html#PerspectiveProjection"},
     {"title": "CastleGLUtils.OrthoProjection", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#OrthoProjection"},
     {"title": "CastleGLUtils.FrustumProjection", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#FrustumProjection"},
     {"title": "CastleGLUtils.GetDepthRange", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#GetDepthRange"},
     {"title": "CastleGLUtils.SetDepthRange", "text": "    ", "tags": "", "loc": "CastleGLUtils.html#SetDepthRange"},
     {"title": "CastleGLUtils.TGLenum", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLenum"},
     {"title": "CastleGLUtils.TGLboolean", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLboolean"},
     {"title": "CastleGLUtils.TGLbitfield", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLbitfield"},
     {"title": "CastleGLUtils.TGLbyte", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLbyte"},
     {"title": "CastleGLUtils.TGLshort", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLshort"},
     {"title": "CastleGLUtils.TGLint", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLint"},
     {"title": "CastleGLUtils.TGLsizei", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLsizei"},
     {"title": "CastleGLUtils.TGLubyte", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLubyte"},
     {"title": "CastleGLUtils.TGLushort", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLushort"},
     {"title": "CastleGLUtils.TGLuint", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLuint"},
     {"title": "CastleGLUtils.TGLfloat", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLfloat"},
     {"title": "CastleGLUtils.TGLclampf", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLclampf"},
     {"title": "CastleGLUtils.TGLdouble", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLdouble"},
     {"title": "CastleGLUtils.TGLclampd", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TGLclampd"},
     {"title": "CastleGLUtils.TVector2f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TVector2f"},
     {"title": "CastleGLUtils.PVector2f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PVector2f"},
     {"title": "CastleGLUtils.TVector2ub", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TVector2ub"},
     {"title": "CastleGLUtils.PVector2ub", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PVector2ub"},
     {"title": "CastleGLUtils.TVector2i", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TVector2i"},
     {"title": "CastleGLUtils.PVector2i", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PVector2i"},
     {"title": "CastleGLUtils.TVector3f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TVector3f"},
     {"title": "CastleGLUtils.PVector3f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PVector3f"},
     {"title": "CastleGLUtils.TVector3ub", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TVector3ub"},
     {"title": "CastleGLUtils.PVector3ub", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PVector3ub"},
     {"title": "CastleGLUtils.TVector3i", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TVector3i"},
     {"title": "CastleGLUtils.PVector3i", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PVector3i"},
     {"title": "CastleGLUtils.TVector4f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TVector4f"},
     {"title": "CastleGLUtils.PVector4f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PVector4f"},
     {"title": "CastleGLUtils.TVector4ub", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TVector4ub"},
     {"title": "CastleGLUtils.PVector4ub", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PVector4ub"},
     {"title": "CastleGLUtils.TVector4i", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TVector4i"},
     {"title": "CastleGLUtils.PVector4i", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PVector4i"},
     {"title": "CastleGLUtils.TMatrix2f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TMatrix2f"},
     {"title": "CastleGLUtils.PMatrix2f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PMatrix2f"},
     {"title": "CastleGLUtils.TMatrix3f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TMatrix3f"},
     {"title": "CastleGLUtils.PMatrix3f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PMatrix3f"},
     {"title": "CastleGLUtils.TMatrix4f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TMatrix4f"},
     {"title": "CastleGLUtils.PMatrix4f", "text": " ", "tags": "", "loc": "CastleGLUtils.html#PMatrix4f"},
     {"title": "CastleGLUtils.TEnableTextureTarget", "text": "  etNone    et2D    etCubeMap    et3D   ", "tags": "", "loc": "CastleGLUtils.html#TEnableTextureTarget"},
     {"title": "CastleGLUtils.TGLSupport", "text": "  gsNone    gsExtension    gsStandard   ", "tags": "", "loc": "CastleGLUtils.html#TGLSupport"},
     {"title": "CastleGLUtils.TPrimitiveMode", "text": " The modes correspond to OpenGL drawing modes, see <a  href=\"https://www.opengl.org/wiki/Primitive\">https://www.opengl.org/wiki/Primitive</a> <a  href=\"https://www.opengl.org/sdk/docs/man2/xhtml/glBegin.xml\">https://www.opengl.org/sdk/docs/man2/xhtml/glBegin.xml</a>  pmPoints    pmLineStrip    pmLineLoop    pmLines    pmTriangleStrip    pmTriangleFan    pmTriangles   ", "tags": "", "loc": "CastleGLUtils.html#TPrimitiveMode"},
     {"title": "CastleGLUtils.TBlendingSourceFactor", "text": "  bsSrcAlpha    bsOneMinusSrcAlpha    bsZero    bsOne    bsDstColor    bsSrcColor As a source factor only since GL 1.4, check <code>GLFeatures.Version_1_4</code>   bsDstAlpha    bsOneMinusDstColor    bsOneMinusSrcColor As a source factor only since GL 1.4, check <code>GLFeatures.Version_1_4</code>   bsOneMinusDstAlpha    bsSrcAlphaSaturate    bsConstantColor    bsOneMinusConstantColor    bsConstantAlpha    bsOneMinusConstantAlpha   ", "tags": "", "loc": "CastleGLUtils.html#TBlendingSourceFactor"},
     {"title": "CastleGLUtils.TBlendingDestinationFactor", "text": "  bdSrcAlpha    bdOneMinusSrcAlpha    bdZero    bdOne    bdDstColor As a destination factor only since GL 1.4, check <code>GLFeatures.Version_1_4</code>   bdSrcColor    bdDstAlpha    bdOneMinusDstColor As a destination factor only since GL 1.4, check <code>GLFeatures.Version_1_4</code>   bdOneMinusSrcColor    bdOneMinusDstAlpha    bdConstantColor    bdOneMinusConstantColor    bdConstantAlpha    bdOneMinusConstantAlpha   ", "tags": "", "loc": "CastleGLUtils.html#TBlendingDestinationFactor"},
     {"title": "CastleGLUtils.TClearBuffer", "text": "  cbColor    cbDepth    cbStencil   ", "tags": "", "loc": "CastleGLUtils.html#TClearBuffer"},
     {"title": "CastleGLUtils.TClearBuffers", "text": " ", "tags": "", "loc": "CastleGLUtils.html#TClearBuffers"},
     {"title": "CastleGLUtils.TDepthRange", "text": "  drFull    drNear    drFar   ", "tags": "", "loc": "CastleGLUtils.html#TDepthRange"},
     {"title": "CastleGLUtils.GLOutOfMemoryError", "text": " Merely making a warning is very risky (you risk all kinds of rendering artifacts), but sometimes the rendering is actually smooth even though GPU complains. ", "tags": "", "loc": "CastleGLUtils.html#GLOutOfMemoryError"},
     {"title": "CastleGLUtils.CurrentColor", "text": "  <p> Instead of this, use drawing routines that take Color from parameters or properties, like <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Print\">TCastleFont.Print</a>(X,Y,Color,...) or TGLImage.Color. ", "tags": "", "loc": "CastleGLUtils.html#CurrentColor"},
     {"title": "CastleGLUtils.WindowPos", "text": "  Do this use this. Instead of this, use drawing routines that take position as parameters, like <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw\">TGLImageCore.Draw</a>(X,Y) or <a class=\"normal\" href=\"CastleFonts.TCastleFont.html#Print\">TCastleFont.Print</a>(X,Y,...). ", "tags": "", "loc": "CastleGLUtils.html#WindowPos"},
     {"title": "CastleGLUtils.GLFeatures", "text": " ", "tags": "", "loc": "CastleGLUtils.html#GLFeatures"},
     {"title": "CastleGLUtils.Viewport2DSize", "text": " The container (like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a>) must take care to set this before rendering. ", "tags": "", "loc": "CastleGLUtils.html#Viewport2DSize"},
     {"title": "CastleGLUtils.RenderContext", "text": " <b>Only access it during the rendering, i.e. in <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a>.</b>  <p>TODO: In the future, this global singleton may be removed, and this may be accessible instead through a new <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a> parameter. ", "tags": "", "loc": "CastleGLUtils.html#RenderContext"},
     {"title": "CastleGLUtils.ProjectionMatrix", "text": "  <p>For OpenGLES, this is merely a global <code>ProjectionMatrix</code> variable. It must be passed to shaders used by <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> rendering to honour the projection.  <p>For desktop OpenGL, setting this also sets fixed-function projection matrix. The OpenGL matrix mode is temporarily changed to GL_PROJECTION, then changed back to GL_MODELVIEW. ", "tags": "", "loc": "CastleGLUtils.html#ProjectionMatrix"},
     {"title": "CastleGLUtils.DepthRange", "text": " ", "tags": "", "loc": "CastleGLUtils.html#DepthRange"},
     {"title": "CastleGLVersion", "text": " These should be initialized by calling <a class=\"normal\" href=\"CastleGLUtils.html#GLInformationInitialize\">GLInformationInitialize</a>, which is done automatically when opening OpenGL context using <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a>. ", "tags": "", "loc": "CastleGLVersion.html"},
     {"title": "CastleGLVersion.TGenericGLVersion", "text": "  <p>As obtained from glGetString(GL_VERSION) or gluGetString(GLU_VERSION), also by glGetString(GL_VENDOR).  <p>This is usually created by <a class=\"normal\" href=\"CastleGLUtils.html#GLInformationInitialize\">CastleGLUtils.GLInformationInitialize</a>. ", "tags": "", "loc": "CastleGLVersion.TGenericGLVersion.html"},
     {"title": "CastleGLVersion.TGenericGLVersion.Major", "text": "  ", "tags": "", "loc": "CastleGLVersion.TGenericGLVersion.html#Major"},
     {"title": "CastleGLVersion.TGenericGLVersion.Minor", "text": " ", "tags": "", "loc": "CastleGLVersion.TGenericGLVersion.html#Minor"},
     {"title": "CastleGLVersion.TGenericGLVersion.ReleaseExists", "text": "  ", "tags": "", "loc": "CastleGLVersion.TGenericGLVersion.html#ReleaseExists"},
     {"title": "CastleGLVersion.TGenericGLVersion.Release", "text": " ", "tags": "", "loc": "CastleGLVersion.TGenericGLVersion.html#Release"},
     {"title": "CastleGLVersion.TGenericGLVersion.VendorInfo", "text": " It never has any whitespace at the beginning (we trim it when initializing). ", "tags": "", "loc": "CastleGLVersion.TGenericGLVersion.html#VendorInfo"},
     {"title": "CastleGLVersion.TGenericGLVersion.Create", "text": "    ", "tags": "", "loc": "CastleGLVersion.TGenericGLVersion.html#Create"},
     {"title": "CastleGLVersion.TGenericGLVersion.AtLeast", "text": "    ", "tags": "", "loc": "CastleGLVersion.TGenericGLVersion.html#AtLeast"},
     {"title": "CastleGLVersion.TGLVersion", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html"},
     {"title": "CastleGLVersion.TGLVersion.Create", "text": "    ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#Create"},
     {"title": "CastleGLVersion.TGLVersion.Vendor", "text": " This is just glGetString(GL_VENDOR). ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#Vendor"},
     {"title": "CastleGLVersion.TGLVersion.VendorType", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#VendorType"},
     {"title": "CastleGLVersion.TGLVersion.Renderer", "text": " This is just glGetString(GL_RENDERER). ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#Renderer"},
     {"title": "CastleGLVersion.TGLVersion.Mesa", "text": " Detected using VendorSpecific information. ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#Mesa"},
     {"title": "CastleGLVersion.TGLVersion.VendorMajor", "text": " Right now this is detected for Mesa and Intel.  ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#VendorMajor"},
     {"title": "CastleGLVersion.TGLVersion.VendorMinor", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#VendorMinor"},
     {"title": "CastleGLVersion.TGLVersion.VendorRelease", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#VendorRelease"},
     {"title": "CastleGLVersion.TGLVersion.Fglrx", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#Fglrx"},
     {"title": "CastleGLVersion.TGLVersion.BuggyGenerateMipmap", "text": "  <p>This was observed with software (no direct) rendering with 7.0.2 (segfaults) and 7.2.? (makes X crashing; sweet). With Mesa 7.5.1 (but tested only with radeon and radeonhd, so possibly it's not really related to Mesa version! Reports welcome) no problems. ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyGenerateMipmap"},
     {"title": "CastleGLVersion.TGLVersion.BuggyFBOCubeMap", "text": "  <p>Symptoms: Parts of the cube map texture are uninitialized (left magenta). Reproducible with view3dscene on demo_models/cube_environment_mapping/cubemap_generated_in_dynamic_world.x3dv . Using separate FBO for each cube map face doesn't help (actually, makes it worse, there's more magenta), so it's not about being unable to do RenderToTexture.SetTexture multiple times.  <p>Observed, and this workaround is needed, at least on: </p>  <ul class=\"paragraph_spacing\">   <li><p>Version string: 2.1.0 - Build 8.15.10.2104</p></li>   <li><p>Vendor: Intel</p></li>   <li><p>Renderer: Intel(R) HD Graphics</p></li> </ul>  <p> ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyFBOCubeMap"},
     {"title": "CastleGLVersion.TGLVersion.BuggyGenerateCubeMap", "text": "  <p>Symptoms: Parts of the cube map texture are uninitialized (left magenta). Reproducible with view3dscene on demo_models/cube_environment_mapping/cubemap_generated_in_dynamic_world.x3dv . This is worse then <a class=\"normal\" href=\"CastleGLVersion.TGLVersion.html#BuggyFBOCubeMap\">BuggyFBOCubeMap</a>, magenta is always seen at positiveX part of the cube map.  <p>Observed, and this workaround is needed, at least on: </p>  <ul class=\"paragraph_spacing\">   <li><p>Version string: 3.3.0 - Build 8.15.10.2778</p></li>   <li><p>Vendor: Intel</p></li>   <li><p>Renderer: Intel(R) HD Graphics 4000</p></li> </ul>  <p> ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyGenerateCubeMap"},
     {"title": "CastleGLVersion.TGLVersion.BuggyLightModelTwoSide", "text": " See [<a  href=\"https://sourceforge.net/apps/phpbb/vrmlengine/viewtopic.php?f=3&amp;t=14\">https://sourceforge.net/apps/phpbb/vrmlengine/viewtopic.php?f=3&amp;t=14</a>] ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyLightModelTwoSide"},
     {"title": "CastleGLVersion.TGLVersion.BuggyLightModelTwoSideMessage", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyLightModelTwoSideMessage"},
     {"title": "CastleGLVersion.TGLVersion.BuggyVBO", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyVBO"},
     {"title": "CastleGLVersion.TGLVersion.BuggyShaderShadowMap", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyShaderShadowMap"},
     {"title": "CastleGLVersion.TGLVersion.BuggyFBOMultiSampling", "text": " This makes our screen effects broken on multi-sampled contexts. ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyFBOMultiSampling"},
     {"title": "CastleGLVersion.TGLVersion.BuggySwapNonStandardViewport", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggySwapNonStandardViewport"},
     {"title": "CastleGLVersion.TGLVersion.BuggyDepth32", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyDepth32"},
     {"title": "CastleGLVersion.TGLVersion.BuggyGLSLFrontFacing", "text": " Observed on Mesa 10.x with OpenGL 3.x (see implemenetation for details where it's observed / not observed).  <p>Note that avoiding gl_FrontFacing (that seems to always has inverted value?) is only a part of the workaround for these GPUs. The other is to not render back faces, since it seems that normals are *always* oriented to point to the light (so, if you don't look at gl_FrontFacing, you are lit from *both* sides). So enable backface culling, or just be prepared that backfaces may be incorrectly light. ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyGLSLFrontFacing"},
     {"title": "CastleGLVersion.TGLVersion.BuggyGLSLReadVarying", "text": " ", "tags": "", "loc": "CastleGLVersion.TGLVersion.html#BuggyGLSLReadVarying"},
     {"title": "CastleGLVersion.VendorTypeToStr", "text": "    ", "tags": "", "loc": "CastleGLVersion.html#VendorTypeToStr"},
     {"title": "CastleGLVersion.TGLVendorType", "text": "  gvUnknown    gvATI ATI GPU with ATI drivers.   gvNvidia NVidia GPU with NVidia drivers.   gvIntel Intel GPU with Intel drivers.   gvImaginationTechnologies Imagination Technologies (PowerVR) GPU, common on mobile devices.  ", "tags": "", "loc": "CastleGLVersion.html#TGLVendorType"},
     {"title": "CastleGLVersion.GLVersion", "text": " This is usually created by <a class=\"normal\" href=\"CastleGLUtils.html#GLInformationInitialize\">CastleGLUtils.GLInformationInitialize</a>. ", "tags": "", "loc": "CastleGLVersion.html#GLVersion"},
     {"title": "CastleGLVersion.GLUVersion", "text": " This is usually created by <a class=\"normal\" href=\"CastleGLUtils.html#GLInformationInitialize\">CastleGLUtils.GLInformationInitialize</a>. ", "tags": "", "loc": "CastleGLVersion.html#GLUVersion"},
     {"title": "CastleGooglePlayGames", "text": " ", "tags": "", "loc": "CastleGooglePlayGames.html"},
     {"title": "CastleGooglePlayGames.sgCancel", "text": " ", "tags": "", "loc": "CastleGooglePlayGames.html#sgCancel"},
     {"title": "CastleGooglePlayGames.sgNew", "text": " ", "tags": "", "loc": "CastleGooglePlayGames.html#sgNew"},
     {"title": "CastleGooglePlayGames.sgExisting", "text": " ", "tags": "", "loc": "CastleGooglePlayGames.html#sgExisting"},
     {"title": "CastleGooglePlayGames.TPlayerBestScoreEvent", "text": " ", "tags": "", "loc": "CastleGooglePlayGames.html#TPlayerBestScoreEvent"},
     {"title": "CastleGooglePlayGames.TSaveGameChoice", "text": " ", "tags": "", "loc": "CastleGooglePlayGames.html#TSaveGameChoice"},
     {"title": "CastleGooglePlayGames.TSaveGameChosenEvent", "text": " ", "tags": "", "loc": "CastleGooglePlayGames.html#TSaveGameChosenEvent"},
     {"title": "CastleGooglePlayGames.TSaveGameLoadedEvent", "text": " ", "tags": "", "loc": "CastleGooglePlayGames.html#TSaveGameLoadedEvent"},
     {"title": "CastleGooglePlayGames.TGooglePlayGames", "text": " ", "tags": "", "loc": "CastleGooglePlayGames.html#TGooglePlayGames"},
     {"title": "CastleHelpshift", "text": " ", "tags": "", "loc": "CastleHelpshift.html"},
     {"title": "CastleHelpshift.THelpshift", "text": " Only on Android now. ", "tags": "", "loc": "CastleHelpshift.THelpshift.html"},
     {"title": "CastleHelpshift.THelpshift.ShowConversation", "text": "    ", "tags": "", "loc": "CastleHelpshift.THelpshift.html#ShowConversation"},
     {"title": "CastleHelpshift.THelpshift.ShowFAQs", "text": "    ", "tags": "", "loc": "CastleHelpshift.THelpshift.html#ShowFAQs"},
     {"title": "CastleImages", "text": " This unit deals with images, stored in normal memory (not on GPU). Images can be loaded and saved from/to various formats and processed in a lot of ways. For example you can resize images, you can draw one image on another, convert to grayscale and so on.  <p>The &quot;image&quot; as understood by this unit may have some interesting features useful with modern GPUs: image data may be compressed for GPU (<a class=\"normal\" href=\"CastleImages.TGPUCompressedImage.html\">TGPUCompressedImage</a>), image data may be 3D (every image has <code>Depth</code>, in addition to <code>Width</code> and <code>Height</code>).  <p>The most important class here is <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>. It represents an image as a simple uncompressed array of pixels. Descendants of <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> define what exactly is a &quot;pixel&quot;. We have 8-bit color images (<a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a>, <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>, <a class=\"normal\" href=\"CastleImages.TGrayscaleAlphaImage.html\">TGrayscaleAlphaImage</a> and <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html\">TGrayscaleImage</a>). We also have an image with floating-point precision and range: <a class=\"normal\" href=\"CastleImages.TRGBFloatImage.html\">TRGBFloatImage</a>.  <p>There is also a more abstract image class <a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a>, representing either uncompressed image (<a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>) or an image with data compressed for GPU (<a class=\"normal\" href=\"CastleImages.TGPUCompressedImage.html\">TGPUCompressedImage</a>).  <p>When reading and writing image files, we understand various image formats. See glViewImage documentation ( <a  href=\"http://castle-engine.sourceforge.net/glviewimage.php\">http://castle-engine.sourceforge.net/glviewimage.php</a> ) for a current list of supported image formats.  <p>The basic loading and saving procedures are <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> and <a class=\"normal\" href=\"CastleImages.html#SaveImage\">SaveImage</a>. Example usage:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   Image: TCastleImage; <span class=\"pascal_keyword\">begin</span>   Image := LoadImage(<span class=\"pascal_string\">'image.png'</span>);   <span class=\"pascal_comment\">{ scale the image to be 2x smaller }</span>   Image.Resize(Image.Width <span class=\"pascal_keyword\">div</span> <span class=\"pascal_numeric\">2</span>, Image.Height <span class=\"pascal_keyword\">div</span> <span class=\"pascal_numeric\">2</span>);   SaveImage(Image, <span class=\"pascal_string\">'newimage.png'</span>); <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>This unit is not dependent on OpenGL or any other rendering library. See <a class=\"normal\" href=\"CastleGLImages.html\">CastleGLImages</a> for OpenGL image operations (for textures and others). ", "tags": "", "loc": "CastleImages.html"},
     {"title": "CastleImages.EImagePosOutOfRange", "text": " Possibly I will use it in more routines in the future. ", "tags": "", "loc": "CastleImages.EImagePosOutOfRange.html"},
     {"title": "CastleImages.EImageLerpError", "text": " ", "tags": "", "loc": "CastleImages.EImageLerpError.html"},
     {"title": "CastleImages.EImageLerpInvalidClasses", "text": " ", "tags": "", "loc": "CastleImages.EImageLerpInvalidClasses.html"},
     {"title": "CastleImages.EImageLerpDifferentSizes", "text": " ", "tags": "", "loc": "CastleImages.EImageLerpDifferentSizes.html"},
     {"title": "CastleImages.EImageAssignmentError", "text": " ", "tags": "", "loc": "CastleImages.EImageAssignmentError.html"},
     {"title": "CastleImages.EImageCannotConvertFpImage", "text": " ", "tags": "", "loc": "CastleImages.EImageCannotConvertFpImage.html"},
     {"title": "CastleImages.EImageDrawError", "text": " ", "tags": "", "loc": "CastleImages.EImageDrawError.html"},
     {"title": "CastleImages.TEncodedImage", "text": " The idea is that both uncompressed images (<a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>) and images compressed for GPU (<a class=\"normal\" href=\"CastleImages.TGPUCompressedImage.html\">TGPUCompressedImage</a>) are derived from this class. ", "tags": "", "loc": "CastleImages.TEncodedImage.html"},
     {"title": "CastleImages.TEncodedImage.FRawPixels", "text": " It's always freed and nil'ed in destructor. ", "tags": "", "loc": "CastleImages.TEncodedImage.html#FRawPixels"},
     {"title": "CastleImages.TEncodedImage.Destroy", "text": "    ", "tags": "", "loc": "CastleImages.TEncodedImage.html#Destroy"},
     {"title": "CastleImages.TEncodedImage.Size", "text": "    ", "tags": "", "loc": "CastleImages.TEncodedImage.html#Size"},
     {"title": "CastleImages.TEncodedImage.Dimensions", "text": "    ", "tags": "", "loc": "CastleImages.TEncodedImage.html#Dimensions"},
     {"title": "CastleImages.TEncodedImage.IsEmpty", "text": "  <p><code>True</code> means that <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> = <code>Nil</code>, and Width * Height * Depth = 0 (so either Width = 0 or Height = 0 or Depth = 0).  <p><code>False</code> means that <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> &lt;&gt; nil and Width * Height * Depth &lt;&gt; 0 (so all Width &gt; 0 and Height &gt; 0 and Depth &gt; 0, since they are Cardinal (unsigned) always).    ", "tags": "", "loc": "CastleImages.TEncodedImage.html#IsEmpty"},
     {"title": "CastleImages.TEncodedImage.HasAlpha", "text": "  <p>You may also be interested in the <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#AlphaChannel\">AlphaChannel</a>. <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#AlphaChannel\">AlphaChannel</a> answers always atNone if <code>HasAlpha</code> = false, and always <a class=\"normal\" href=\"CastleImages.html#acTest\">acTest</a> or <a class=\"normal\" href=\"CastleImages.html#acBlending\">acBlending</a> if <code>HasAlpha</code> = true. But <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#AlphaChannel\">AlphaChannel</a> may perform longer analysis of pixels (to differ between <a class=\"normal\" href=\"CastleImages.html#acTest\">acTest</a> and <a class=\"normal\" href=\"CastleImages.html#acBlending\">acBlending</a>), while this function always executes ultra-fast (as it's constant for each <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> descendant).  <p><i>Descendants implementors notes:</i> in this class, <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>, this returns <code>False</code>. Override to return <code>True</code> for images with alpha channel.    ", "tags": "", "loc": "CastleImages.TEncodedImage.html#HasAlpha"},
     {"title": "CastleImages.TEncodedImage.AlphaChannel", "text": "  <p>This is quite useful for automatic detection how alpha textures should be displayed: for simple yes/no alpha, OpenGL alpha_test is a simple solution. For full range alpha, OpenGL blending should be used. Blending is a little problematic, since it requires special rendering order, since it doesn't cooperate nicely with Z-buffer. That's why we try to detect simple yes/no alpha textures, so that we're able to use simpler alpha test for them.  <p>We return &quot;simple yes/no alpha channel&quot; is all the alpha values (for every pixel) are 0, or 255, or (when AlphaTolerance &lt;&gt; 0) are close to them by AlphaTolerance. So, to be precise, alpha value must be &lt;= AlphaTolerance, or &gt;= 255 - AlphaTolerance. If any alpha value is between [AlphaTolerance + 1, 255 - AlphaTolerance - 1] then we return &quot;full range alpha channel&quot;. Note that for AlphaTolerance &gt;= 128, all images are treated as &quot;simple yes/no alpha&quot;. Usually, you want to keep AlphaTolerance small.  <p><i>Descendants implementors notes:</i> in this class, this simply always returns atNone. For descendants that have alpha channel, implement it, honouring AlphaTolerance as described.    ", "tags": "", "loc": "CastleImages.TEncodedImage.html#AlphaChannel"},
     {"title": "CastleImages.TEncodedImage.Rect", "text": " Always (Left,Bottom) are zero, and (Width,Height) correspond to image sizes.    ", "tags": "", "loc": "CastleImages.TEncodedImage.html#Rect"},
     {"title": "CastleImages.TEncodedImage.CreateCopy", "text": "    ", "tags": "", "loc": "CastleImages.TEncodedImage.html#CreateCopy"},
     {"title": "CastleImages.TEncodedImage.URL", "text": " ", "tags": "", "loc": "CastleImages.TEncodedImage.html#URL"},
     {"title": "CastleImages.TEncodedImage.Width", "text": " ", "tags": "", "loc": "CastleImages.TEncodedImage.html#Width"},
     {"title": "CastleImages.TEncodedImage.Height", "text": " ", "tags": "", "loc": "CastleImages.TEncodedImage.html#Height"},
     {"title": "CastleImages.TEncodedImage.Depth", "text": " ", "tags": "", "loc": "CastleImages.TEncodedImage.html#Depth"},
     {"title": "CastleImages.TEncodedImage.RawPixels", "text": " ", "tags": "", "loc": "CastleImages.TEncodedImage.html#RawPixels"},
     {"title": "CastleImages.TCastleImage", "text": " <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> is a pointer to Width * Height * Depth of pixels.  <p>What exactly is a &quot;pixel&quot; is undefined in this class. Each descendant of <code>TCastleImage</code> defines it's own pixel encoding and interpretation. The only requirement is that all pixels have the same size (<a class=\"normal\" href=\"CastleImages.TCastleImage.html#PixelSize\">PixelSize</a>). For example, for <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a> a &quot;pixel&quot; is a <a class=\"normal\" href=\"CastleVectors.TVector3Byte.html\">TVector3Byte</a> type representing a (red, green, blue) color value.  <p>When Depth &gt; 1, the image is actually a 3D (not just 2D!) image. We call the particular 2D layers then &quot;slices&quot;. Although some <code>TCastleImage</code> methods (and functions in other units, like <a class=\"normal\" href=\"CastleGLImages.html\">CastleGLImages</a>) still operate only on the 1st &quot;slice&quot;, that is the 2D image on Depth = 0 &mdash; be careful. But many methods correctly take the depth into consideration.  <p>Pixels in <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> are ordered in slices, each slice is ordered in rows, in each row pixels are specified from left to right, rows are specified starting from lower row to upper. This means that you can think of <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> as  <p></p>  <pre class=\"longcode\"> &circ;(<span class=\"pascal_keyword\">packed</span> <span class=\"pascal_keyword\">array</span>[<span class=\"pascal_numeric\">0</span>..Depth - <span class=\"pascal_numeric\">1</span>, <span class=\"pascal_numeric\">0</span>..Height - <span class=\"pascal_numeric\">1</span>, <span class=\"pascal_numeric\">0</span>..Width - <span class=\"pascal_numeric\">1</span>] <span class=\"pascal_keyword\">of</span> TPixel)</pre>  <p>  <p>Assuming the above definition, <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>&circ;[z, y, x] is color of pixel at position z, x, y.  <p>Note that specifying rows from lower to upper follows an OpenGL standard, this makes using this unit with OpenGL straightforward.  <p>Don't ever operate on <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> pointer directly &mdash; allocating, reallocating, freeing memory pointed to by <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> is handled inside this class. You must only worry to always free created <code>TCastleImage</code> instances (like with any class).  <p>Note that the only valid states of instances of this class are when (Width * Height * Depth &gt; 0 and <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> &lt;&gt; nil) or (Width * Height * Depth = 0 and <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> = nil). Otherwise the fundamental assumption that <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> is a pointer to Width * Height * Depth pixels would be broken (as nil pointer cannot point to anything, and on the other side it's rather useless to have a pointer to 0 bytes (since you can never dereference it anyway) even if theoretically every PtrInt value can be treated as valid pointer to 0 bytes).  <p>Note about coordinates:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>All X, Y, Z coordinates of pixels are 0-based (X in range 0..Width-1, and Y in 0..Height-1, and Z in 0..Depth-1).</p></li>   <li value=\"2\"><p>If documentation for some method does not specify otherwise, correctness of coordinates is *not* checked in method, which can lead to various errors at runtime if you will pass incorrect coordinates to given routine.</p></li> </ol>  <p> ", "tags": "", "loc": "CastleImages.TCastleImage.html"},
     {"title": "CastleImages.TCastleImage.LerpSimpleCheckConditions", "text": " If not, raise appropriate ELerpXxx exceptions.  <p>Some implementation of <a class=\"normal\" href=\"CastleImages.TRGBImage.html#LerpWith\">TRGBImage.LerpWith</a> may require other checks (since <a class=\"normal\" href=\"CastleImages.TCastleImage.html#LerpWith\">LerpWith</a> may be sometimes allowed between unequal classes), so this doesn't have to be used by all <a class=\"normal\" href=\"CastleImages.TRGBImage.html#LerpWith\">TRGBImage.LerpWith</a> implementations (although it's comfortable for simple implementations).    ", "tags": "", "loc": "CastleImages.TCastleImage.html#LerpSimpleCheckConditions"},
     {"title": "CastleImages.TCastleImage.DrawFromCore", "text": " Override this to add copying using some more sophisticated method than just memory copying (so also for handling mode other than <a class=\"normal\" href=\"CastleImages.html#dmBlend\">dmBlend</a>).    ", "tags": "", "loc": "CastleImages.TCastleImage.html#DrawFromCore"},
     {"title": "CastleImages.TCastleImage.MakeResizedToFpImage", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#MakeResizedToFpImage"},
     {"title": "CastleImages.TCastleImage.GetColors", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#GetColors"},
     {"title": "CastleImages.TCastleImage.SetColors", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#SetColors"},
     {"title": "CastleImages.TCastleImage.Create", "text": "  <p>Both constructors must be virtual, this allows to implement things like <a class=\"normal\" href=\"CastleImages.TCastleImage.html#MakeCopy\">TCastleImage.MakeCopy</a>.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Create"},
     {"title": "CastleImages.TCastleImage.Create", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Create"},
     {"title": "CastleImages.TCastleImage.Empty", "text": " It sets Width = Height = 0 and <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> = nil.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Empty"},
     {"title": "CastleImages.TCastleImage.SetSize", "text": " Previous pixel contents (<a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>) are lost, and the contents of new pixels are undefined.  <p>Use other method, like <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Resize\">Resize</a>, if you want to change image size preserving it's contents.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#SetSize"},
     {"title": "CastleImages.TCastleImage.SetSize", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#SetSize"},
     {"title": "CastleImages.TCastleImage.PixelSize", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#PixelSize"},
     {"title": "CastleImages.TCastleImage.Size", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Size"},
     {"title": "CastleImages.TCastleImage.ImageSize", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#ImageSize"},
     {"title": "CastleImages.TCastleImage.ColorComponentsCount", "text": "  <p>E.g. RGB is 3 components and RGB+Alpha is 4 components, RGB+Exponent is 3 components (because it describes only Red, Green and Blue values (Exponent value is just used to correctly interpret these, it's not a 4th component)).    ", "tags": "", "loc": "CastleImages.TCastleImage.html#ColorComponentsCount"},
     {"title": "CastleImages.TCastleImage.PixelPtr", "text": "  <p>Note that they don't check X, Y, Z correctness in any way, it's your responsibility to always pass 0 &lt;= X &lt; Width and 0 &lt;= Y &lt; Height and 0 &lt;= Z &lt; Depth.  <p>Note that this function <i>should</i> be reintroduced in descendants to return the same value but typecasted to something better then Pointer (something like &circ;TPixel).    ", "tags": "", "loc": "CastleImages.TCastleImage.html#PixelPtr"},
     {"title": "CastleImages.TCastleImage.RowPtr", "text": " Same thing as <a class=\"normal\" href=\"CastleImages.TCastleImage.html#PixelPtr\">PixelPtr</a> but always with X = 0.  <p>Note that this function <i>should</i> be reintroduced in descendants to return the same value but typecasted to something better then Pointer, preferably something like &circ;(array of TPixel).    ", "tags": "", "loc": "CastleImages.TCastleImage.html#RowPtr"},
     {"title": "CastleImages.TCastleImage.InvertColors", "text": " &quot;Inverting&quot; means changing color C in range [0..1] to 1-C, so <a class=\"normal\" href=\"CastleColors.html#Black\">black</a> becomes <a class=\"normal\" href=\"CastleColors.html#White\">white</a>, <a class=\"normal\" href=\"CastleColors.html#White\">white</a> becomes <a class=\"normal\" href=\"CastleColors.html#Black\">black</a> etc.  <p><i>For descendants implementors:</i> Override it if necessary, otherwise the default implementation in this class will raise <a class=\"normal\" href=\"CastleUtils.EInternalError.html\">EInternalError</a>.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#InvertColors"},
     {"title": "CastleImages.TCastleImage.SetColorRGB", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#SetColorRGB"},
     {"title": "CastleImages.TCastleImage.MakeCopy", "text": "  <p>(Design note: this function is *not* a constructor, because it's implemented in <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>, but it always returns some descendant of <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>.)    ", "tags": "", "loc": "CastleImages.TCastleImage.html#MakeCopy"},
     {"title": "CastleImages.TCastleImage.CreateCopy", "text": "  <p>Equivalent to <a class=\"normal\" href=\"CastleImages.TCastleImage.html#MakeCopy\">MakeCopy</a>, but virtual and declared as returning <a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a> class.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#CreateCopy"},
     {"title": "CastleImages.TCastleImage.Resize", "text": "  <p>If ResizeWidth or ResizeHeight is 0 then it means to take Width or Height, respectively. So e.g. using ResizeWidth = ResizeHeight = 0 is the same thing as using ResizeWidth = Width and ResizeHeight = Height and this is NOP.  <p>Remember that resizing may change <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a> pointer, so all pointers that you aquired using functions like <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, Pixels, PixelsArray, <a class=\"normal\" href=\"CastleImages.TCastleImage.html#RowPtr\">RowPtr</a>, <a class=\"normal\" href=\"CastleImages.TCastleImage.html#PixelPtr\">PixelPtr</a> may be invalid after calling Resize.  <p>If ProgressTitle &lt;&gt; '' this will call Progress.Init/Step/Fini from <a class=\"normal\" href=\"CastleProgress.html\">CastleProgress</a> to indicate progress of operation.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Resize"},
     {"title": "CastleImages.TCastleImage.Resize3x3", "text": "  <p>This scales the image in almost the same way as standard <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Resize\">Resize</a>. However, this is aware of the image corners and edges, which is good if you plan to use this image with <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw3x3\">TGLImageCore.Draw3x3</a> drawing.  <p>The Corners parameter specifies the corners size, in the same clockwise order as for <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html#Draw3x3\">TGLImageCore.Draw3x3</a>: top, right, bottom, left. The corners will be scaled (proportially to image scaling), and new Corners size returned. Additionally it makes sure that filtering (especially bilinear) does not &quot;leak&quot; <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Colors\">colors</a> from one image area to another. Effectively, the image is scaled like a 9 separate parts, and <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Colors\">colors</a> cannot bleed from one part to another.  <p>Both ResizeWidth, ResizeHeight parameters must be provided and non-zero.  <p>For now, only a subset of <a class=\"normal\" href=\"CastleImages.html#TResizeInterpolation\">TResizeInterpolation</a> values are supported by this method, namely the ones in <a class=\"normal\" href=\"CastleImages.html#TResizeInterpolationInternal\">TResizeInterpolationInternal</a>.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Resize3x3"},
     {"title": "CastleImages.TCastleImage.MakeResized", "text": " The exact class of the new instance is the same as our class.  <p>As with <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Resize\">Resize</a> method, when the parameter ResizeTo* is 0 it means to use current Width/Height. So e.g. using <code>MakeResized</code>(0, 0) is the same thing as using <a class=\"normal\" href=\"CastleImages.TCastleImage.html#CreateCopy\">CreateCopy</a>.  <p>As with <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Resize\">Resize</a>, if ProgressTitle &lt;&gt; '' this will call Progress.Init/Step/Fini from <a class=\"normal\" href=\"CastleProgress.html\">CastleProgress</a> to indicate progress of operation.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#MakeResized"},
     {"title": "CastleImages.TCastleImage.FlipHorizontal", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#FlipHorizontal"},
     {"title": "CastleImages.TCastleImage.FlipVertical", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#FlipVertical"},
     {"title": "CastleImages.TCastleImage.MakeRotated", "text": " See <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Rotate\">Rotate</a> for description of parameters.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#MakeRotated"},
     {"title": "CastleImages.TCastleImage.Rotate", "text": " For example, 0 does nothing. 1 rotates by 90 degrees, 2 rotates by 180, 3 rotates by 270. All other values (negative too) are circular (modulo), so e.g. 4 again does nothing, 5 rotates by 90 degrees and so on.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Rotate"},
     {"title": "CastleImages.TCastleImage.MakeTiled", "text": " Must be TileX, TileY &gt; 0.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#MakeTiled"},
     {"title": "CastleImages.TCastleImage.MakeExtracted", "text": " X0 and Y0 are start position (lower-left corner), ExtractWidth, ExtractHeight specify size of area.  <p>This checks parameters for correctness &ndash; if start position is not correct or ExtractWidth/Height are too large then exception <a class=\"normal\" href=\"CastleImages.EImagePosOutOfRange.html\">EImagePosOutOfRange</a> is raised.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#MakeExtracted"},
     {"title": "CastleImages.TCastleImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Clear"},
     {"title": "CastleImages.TCastleImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Clear"},
     {"title": "CastleImages.TCastleImage.IsClear", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#IsClear"},
     {"title": "CastleImages.TCastleImage.TransformRGB", "text": " This is a useful routine for many various conversions of image <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Colors\">colors</a>. Every pixel's RGB color is multiplied by given Matrix, i.e. PixelRGBColor := Matrix * PixelRGBColor.  <p>If some value in some channel will be &lt; 0, it will be set to 0. And if it will be &gt; High(Byte), it will be set to High(Byte).  <p>Examples: when Matrix = TMatrix3.Identity, this is NOOP. Matrix = ((2, 0, 0), (0, 1, 0), (0, 0, 1)) red channel is made lighter. Matrix = ((0, 0, 1), (0, 1, 0), (1, 0, 0)) swaps red and blue channel. Matrix = ((0.33, 0.33, 0.33), (0.33, 0.33, 0.33), (0.33, 0.33, 0.33)) is a simple conversion to grayscale (actually incorrect, even if often visually acceptable; actually instead of 0.33 one has to use GrayscaleFloat/ByteValues, this is already implemented in ImageTransformColorsVar function)  <p>Note: it's often more optimal to hard-code necessary color transformations as TColorModulatorFunc and use <a class=\"normal\" href=\"CastleImages.TCastleImage.html#ModulateRGB\">ModulateRGB</a>.  <p>This function is only implemented for images that represent Pixel as RGB values, for now this means <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a> and <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a>. In case of <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a> (or any other class that represents <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Colors\">colors</a> as RGB + something more) alpha channel (i.e. &quot;something more&quot;) is ignored (i.e. left without any modification).  <p>In this class this simply raises <a class=\"normal\" href=\"CastleUtils.EInternalError.html\">EInternalError</a> to say 'not implemented'. This also means that you must not call inherited in descendants when overriding this method.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#TransformRGB"},
     {"title": "CastleImages.TCastleImage.ModulateRGB", "text": " If ColorModulator = nil then this procedure does nothing. Else, every RGB color value of an image will be transformed using ColorModulator.  <p>Like <a class=\"normal\" href=\"CastleImages.TCastleImage.html#TransformRGB\">TransformRGB</a>: This function is only implemented for images that represent Pixel as RGB values, for now this means <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a> and <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a>. In case of <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a> (or any other class that represents <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Colors\">colors</a> as RGB + something more) alpha channel (i.e. &quot;something more&quot;) is ignored (i.e. left without any modification).  <p>In this class this simply raises <a class=\"normal\" href=\"CastleUtils.EInternalError.html\">EInternalError</a> to say 'not implemented'. This also means that you must not call inherited in descendants when overriding this method.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#ModulateRGB"},
     {"title": "CastleImages.TCastleImage.MakeModulatedRGB", "text": " This means that if ColorModulator = nil this is equivalent to <a class=\"normal\" href=\"CastleImages.TCastleImage.html#CreateCopy\">CreateCopy</a>.  <p>Implemented if and only if <a class=\"normal\" href=\"CastleImages.TCastleImage.html#ModulateRGB\">ModulateRGB</a> is implemented.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#MakeModulatedRGB"},
     {"title": "CastleImages.TCastleImage.Grayscale", "text": "  <p>Implemented if and only if <a class=\"normal\" href=\"CastleImages.TCastleImage.html#ModulateRGB\">ModulateRGB</a> is implemented. When image has alpha channel, alpha channel value (or just anything beyond 3 rgb components) is ignored (not modified).  <p>This changes color to grayscale, but format of memory storage is the same. For example, for <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>, they are still kept in RGB format (just Red = Green = Blue). If you want to convert to true Grayscale format, you should use <a class=\"normal\" href=\"CastleImages.TRGBImage.html#ToGrayscale\">TRGBImage.ToGrayscale</a> that will create new <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html\">TGrayscaleImage</a> instance.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Grayscale"},
     {"title": "CastleImages.TCastleImage.ConvertToChannelRGB", "text": " &quot;Channel&quot; parameter determines which Color*Convert function to use (Red, Green or Blue), must be 0, 1 or 2.  <p>Implemented if and only if <a class=\"normal\" href=\"CastleImages.TCastleImage.html#ModulateRGB\">ModulateRGB</a> is implemented.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#ConvertToChannelRGB"},
     {"title": "CastleImages.TCastleImage.StripToChannelRGB", "text": " &quot;Channel&quot; parameter determines which Color*Strip function to use (Red, Green or Blue), must be 0, 1 or 2.  <p>Implemented if and only if <a class=\"normal\" href=\"CastleImages.TCastleImage.html#ModulateRGB\">ModulateRGB</a> is implemented.    ", "tags": "", "loc": "CastleImages.TCastleImage.html#StripToChannelRGB"},
     {"title": "CastleImages.TCastleImage.IsEqual", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#IsEqual"},
     {"title": "CastleImages.TCastleImage.ArePartsEqual", "text": " Note that it's your responsibility to make sure that given areas are really within the sizes of Self or Image.  <p>Overloaded version without SelfXxx parameters compares whole Self to given part of Image. Analogously, version without ImageXxx parameters compares whole Image to part of Self.  <p>    ", "tags": "", "loc": "CastleImages.TCastleImage.html#ArePartsEqual"},
     {"title": "CastleImages.TCastleImage.ArePartsEqual", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#ArePartsEqual"},
     {"title": "CastleImages.TCastleImage.ArePartsEqual", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#ArePartsEqual"},
     {"title": "CastleImages.TCastleImage.DrawFrom", "text": " X, Y is the lower-left position on the destination image where we draw. Optional SourceX, SourceY, SourceWidth, SourceHeight specify to use only a part of the source image (without them, we take whole source image). The pixel on source image (SourceX, SourceY) will be drawn on destination image on (X, Y).  <p>The coordinates and sizes are carefully checked, so that we do not try to take some pixels outside of the source or destination image.  <p>Note that this method of drawing image-on-image is not GPU-accelerated in any way. It may be slow (esp. for larger source images), and should be avoided for often occuring events (e.g. think twice before using this method at every mouse move, or at every frame draw).  <p><i>Note for descendants implementors:</i> The default implementation of this function in <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> can only directly copy the pixels, regardless of what information they have. This makes it very fast, but not suitable if the source image has some alpha channel and you want to apply it over a destination image with blending (adding scaled source to a destination color), and not suitable when Mode is &lt;&gt; <a class=\"normal\" href=\"CastleImages.html#dmBlend\">dmBlend</a>. Descendants with alpha channel should override <a class=\"normal\" href=\"CastleImages.TCastleImage.html#DrawFromCore\">DrawFromCore</a> to handle drawing with blending (for <a class=\"normal\" href=\"CastleImages.html#dmBlend\">dmBlend</a>), all descendants should override <a class=\"normal\" href=\"CastleImages.TCastleImage.html#DrawFromCore\">DrawFromCore</a> to handle drawing with Mode &lt;&gt; <a class=\"normal\" href=\"CastleImages.html#dmBlend\">dmBlend</a>.  <p>  <p>    EImageDrawError When drawing cannot be performed, for example because drawing with this Mode, and/or for this Source and destination classes, is not implemented yet.", "tags": "", "loc": "CastleImages.TCastleImage.html#DrawFrom"},
     {"title": "CastleImages.TCastleImage.DrawFrom", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#DrawFrom"},
     {"title": "CastleImages.TCastleImage.DrawTo", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#DrawTo"},
     {"title": "CastleImages.TCastleImage.LerpWith", "text": " Intuitively, every pixel in new image is set to  <p></p>  <pre class=\"preformatted\"> (1 - Value) * Self[pixel] + Value * SecondImage[pixel]</pre>  <p>  <p>Both images need to have the exact same size. If they are not, <a class=\"normal\" href=\"CastleImages.EImageLerpDifferentSizes.html\">EImageLerpDifferentSizes</a> is raised.  <p>Not all <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> combinations are allowed. Every subclass is required to override this to at least handle Lerp between itself. That is, TRGBImage.Lerp has to handle Lerp with other <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>, TRGBAlphaImage.Lerp has to handle Lerp with other <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a> etc. Other combinations may be permitted, if useful and implemented. <a class=\"normal\" href=\"CastleImages.EImageLerpInvalidClasses.html\">EImageLerpInvalidClasses</a> is raised if given class combinations are not allowed.  <p>In this class, this simply always raises <a class=\"normal\" href=\"CastleImages.EImageLerpInvalidClasses.html\">EImageLerpInvalidClasses</a>.  <p>     EImageLerpDifferentSizes When SecondImage size differs from this image. EImageLerpInvalidClasses When Lerp between this <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> descendant class and SecondImage class is not implemented.", "tags": "", "loc": "CastleImages.TCastleImage.html#LerpWith"},
     {"title": "CastleImages.TCastleImage.MixColors", "text": " All 4 <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Colors\">Colors</a> and OutputColor must be pointers to a pixel of current image class, that is they must point to <a class=\"normal\" href=\"CastleImages.TCastleImage.html#PixelSize\">PixelSize</a> bytes of memory.  <p>    EImageLerpInvalidClasses When mixing is not implemented for this image class.", "tags": "", "loc": "CastleImages.TCastleImage.html#MixColors"},
     {"title": "CastleImages.TCastleImage.Assign", "text": " This sets our size (Width, Height and Depth) to match Source image, and copies pixels from the Source image, converting them as closely as possible. For example, converting RGBA to RGB will strip alpha channel, but copy RGB values.  <p>When implementing descendants: the base implementation of this method in <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> handles only the case when Image class equals our own class. And raises <a class=\"normal\" href=\"CastleImages.EImageAssignmentError.html\">EImageAssignmentError</a> in other cases. Override this method if you want to actually handle some conversions when assignning.  <p>    EImageAssignmentError If it's not possible to convert from Source class to us. Not every possible conversion is implemented now.", "tags": "", "loc": "CastleImages.TCastleImage.html#Assign"},
     {"title": "CastleImages.TCastleImage.SaveToPascalCode", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#SaveToPascalCode"},
     {"title": "CastleImages.TCastleImage.AlphaBleed", "text": " This fixes problems with <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>/<a class=\"normal\" href=\"CastleColors.html#White\">white</a> borders around the texture regions, when the texture is scaled down (by any means &ndash; on CPU, during rendering on GPU...).  <p><b>The algorithm implemented here, for now, is really slow (but also really correct).</b> It should only be used as a last resort, when your normal tool (like Spine atlas packer) cannot do a decent job on a given image. You should use this when creating assets, and save the resulting image to disk (avoid doing this at runtime during the game, since it's really really slow).  <p>    ", "tags": "", "loc": "CastleImages.TCastleImage.html#AlphaBleed"},
     {"title": "CastleImages.TCastleImage.MakeAlphaBleed", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#MakeAlphaBleed"},
     {"title": "CastleImages.TCastleImage.FillEllipse", "text": "     ", "tags": "", "loc": "CastleImages.TCastleImage.html#FillEllipse"},
     {"title": "CastleImages.TCastleImage.Ellipse", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Ellipse"},
     {"title": "CastleImages.TCastleImage.FillRectangle", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#FillRectangle"},
     {"title": "CastleImages.TCastleImage.Rectangle", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Rectangle"},
     {"title": "CastleImages.TCastleImage.Line", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#Line"},
     {"title": "CastleImages.TCastleImage.FloodFill", "text": "    ", "tags": "", "loc": "CastleImages.TCastleImage.html#FloodFill"},
     {"title": "CastleImages.TCastleImage.Colors", "text": "  <p>In case of descendants without alpha, we may drop this information.  <p>In case of grayscale descendants, when getting or setting we convert the color to/from grayscale as necessary. This means that setting RGB color on a grayscale image may lose information &ndash; we will convert your color to grayscale.  <p>Caller is responsible for checking the correctness of given X, Y, Z coordinates. For speed, we may not check them inside (so nasty memory errors will occur in case of invalid coordinates). ", "tags": "", "loc": "CastleImages.TCastleImage.html#Colors"},
     {"title": "CastleImages.TGPUCompressedImage", "text": " ", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html"},
     {"title": "CastleImages.TGPUCompressedImage.Create", "text": "    ", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html#Create"},
     {"title": "CastleImages.TGPUCompressedImage.Size", "text": "    ", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html#Size"},
     {"title": "CastleImages.TGPUCompressedImage.HasAlpha", "text": "    ", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html#HasAlpha"},
     {"title": "CastleImages.TGPUCompressedImage.AlphaChannel", "text": "    ", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html#AlphaChannel"},
     {"title": "CastleImages.TGPUCompressedImage.FlipVertical", "text": "  <p>This works only for S3TC images, and only when their height is 1, 2, 3 or a multiple of 4. Note that this is always satisfied if image height is a power of two (as common for textures). It uses the knowledge of how S3TC compression works to losslessly flip the image, without re-compressing it. The idea is described here [<a  href=\"http://users.telenet.be/tfautre/softdev/ddsload/explanation.htm\">http://users.telenet.be/tfautre/softdev/ddsload/explanation.htm</a>].    ", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html#FlipVertical"},
     {"title": "CastleImages.TGPUCompressedImage.Decompress", "text": "  <p>This uses <a class=\"normal\" href=\"CastleImages.html#DecompressTexture\">DecompressTexture</a> variable, so you have to initialialize it first (for example to <a class=\"normal\" href=\"CastleGLImages.html#GLDecompressTexture\">CastleGLImages.GLDecompressTexture</a>) before using this.  <p>    ECannotDecompressTexture If we cannot decompress the texture, because decompressor is not set or there was some other error within decompressor.", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html#Decompress"},
     {"title": "CastleImages.TGPUCompressedImage.MakeCopy", "text": "    ", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html#MakeCopy"},
     {"title": "CastleImages.TGPUCompressedImage.CreateCopy", "text": "  <p>Equivalent to <a class=\"normal\" href=\"CastleImages.TGPUCompressedImage.html#MakeCopy\">MakeCopy</a>, but virtual and declared as returning <a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a> class.    ", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html#CreateCopy"},
     {"title": "CastleImages.TGPUCompressedImage.Compression", "text": " ", "tags": "", "loc": "CastleImages.TGPUCompressedImage.html#Compression"},
     {"title": "CastleImages.ECannotDecompressTexture", "text": " ", "tags": "", "loc": "CastleImages.ECannotDecompressTexture.html"},
     {"title": "CastleImages.TRGBImage", "text": " ", "tags": "", "loc": "CastleImages.TRGBImage.html"},
     {"title": "CastleImages.TRGBImage.DrawFromCore", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#DrawFromCore"},
     {"title": "CastleImages.TRGBImage.GetColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#GetColors"},
     {"title": "CastleImages.TRGBImage.SetColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#SetColors"},
     {"title": "CastleImages.TRGBImage.PixelSize", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#PixelSize"},
     {"title": "CastleImages.TRGBImage.ColorComponentsCount", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#ColorComponentsCount"},
     {"title": "CastleImages.TRGBImage.PixelPtr", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#PixelPtr"},
     {"title": "CastleImages.TRGBImage.RowPtr", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#RowPtr"},
     {"title": "CastleImages.TRGBImage.InvertColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#InvertColors"},
     {"title": "CastleImages.TRGBImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#Clear"},
     {"title": "CastleImages.TRGBImage.IsClear", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#IsClear"},
     {"title": "CastleImages.TRGBImage.TransformRGB", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#TransformRGB"},
     {"title": "CastleImages.TRGBImage.ModulateRGB", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#ModulateRGB"},
     {"title": "CastleImages.TRGBImage.ToRGBAlphaImage", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#ToRGBAlphaImage"},
     {"title": "CastleImages.TRGBImage.ToRGBFloat", "text": "  <p>Although float format offers superior precision compared to 8bit RGB, there is a slight chance of some unnoticeable loss of information in such conversion, since floating-point values are involved in calculation.  <p>But generally this conversion is relatively safe (contrary to conversion float -&gt; 8-bit RGB, which must be lossy).  <p>But still you should note that doing such conversion has little sense since float format is useful only when you have <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Colors\">colors</a> that can't be expressed as simple 8-bit RGB. But by using this conversion you initially fill float image with data that does not have precision beyond standard 0..255 discreet range for each RGB component...    ", "tags": "", "loc": "CastleImages.TRGBImage.html#ToRGBFloat"},
     {"title": "CastleImages.TRGBImage.ToGrayscale", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#ToGrayscale"},
     {"title": "CastleImages.TRGBImage.HorizontalLine", "text": " Must be y1 &lt;= y2, else it is NOOP.    ", "tags": "", "loc": "CastleImages.TRGBImage.html#HorizontalLine"},
     {"title": "CastleImages.TRGBImage.HorizontalLine", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#HorizontalLine"},
     {"title": "CastleImages.TRGBImage.VerticalLine", "text": " Must be x1 &lt;= x2, else it is NOOP.    ", "tags": "", "loc": "CastleImages.TRGBImage.html#VerticalLine"},
     {"title": "CastleImages.TRGBImage.VerticalLine", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#VerticalLine"},
     {"title": "CastleImages.TRGBImage.CreateCombined", "text": " This is a very special constructor. It creates image with the same size as MapImage. It also resizes ReplaceWhiteImage, ReplaceBlackImage to the size of MapImage.  <p>Then it inits color of each pixel of our image with combined <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Colors\">colors</a> of two <a class=\"normal\" href=\"CastleImages.TRGBImage.html#Pixels\">pixels</a> on the same coordinates from ReplaceWhiteImage, ReplaceBlackImage, something like  <p></p>  <pre class=\"preformatted\"> Pixel[x, y] := ReplaceWhiteImage[x, y] * S +                ReplaceBlackImage[x, y] * (S-1);</pre>  <p>  <p>where S = average of red, gree, blue of color MapImage[x, y].  <p>This means that final image will look like ReplaceWhiteImage in the areas where MapImage is <a class=\"normal\" href=\"CastleColors.html#White\">white</a>, and it will look like ReplaceBlackImage in the areas where MapImage is <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>.    ", "tags": "", "loc": "CastleImages.TRGBImage.html#CreateCombined"},
     {"title": "CastleImages.TRGBImage.LerpWith", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#LerpWith"},
     {"title": "CastleImages.TRGBImage.MixColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#MixColors"},
     {"title": "CastleImages.TRGBImage.Assign", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#Assign"},
     {"title": "CastleImages.TRGBImage.FillEllipse", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#FillEllipse"},
     {"title": "CastleImages.TRGBImage.Ellipse", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#Ellipse"},
     {"title": "CastleImages.TRGBImage.FillRectangle", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#FillRectangle"},
     {"title": "CastleImages.TRGBImage.Rectangle", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#Rectangle"},
     {"title": "CastleImages.TRGBImage.Line", "text": "    ", "tags": "", "loc": "CastleImages.TRGBImage.html#Line"},
     {"title": "CastleImages.TRGBImage.Pixels", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to <a class=\"normal\" href=\"CastleVectors.html#PVector3Byte\">PVector3Byte</a>. ", "tags": "", "loc": "CastleImages.TRGBImage.html#Pixels"},
     {"title": "CastleImages.TRGBImage.RGBPixels", "text": " ", "tags": "", "loc": "CastleImages.TRGBImage.html#RGBPixels"},
     {"title": "CastleImages.TRGBImage.PixelsArray", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to <a class=\"normal\" href=\"CastleVectors.html#PVector3ByteArray\">PVector3ByteArray</a>. ", "tags": "", "loc": "CastleImages.TRGBImage.html#PixelsArray"},
     {"title": "CastleImages.TRGBAlphaImage", "text": " ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html"},
     {"title": "CastleImages.TRGBAlphaImage.DrawFromCore", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#DrawFromCore"},
     {"title": "CastleImages.TRGBAlphaImage.GetColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#GetColors"},
     {"title": "CastleImages.TRGBAlphaImage.SetColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#SetColors"},
     {"title": "CastleImages.TRGBAlphaImage.PixelSize", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#PixelSize"},
     {"title": "CastleImages.TRGBAlphaImage.ColorComponentsCount", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#ColorComponentsCount"},
     {"title": "CastleImages.TRGBAlphaImage.PixelPtr", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#PixelPtr"},
     {"title": "CastleImages.TRGBAlphaImage.RowPtr", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#RowPtr"},
     {"title": "CastleImages.TRGBAlphaImage.InvertColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#InvertColors"},
     {"title": "CastleImages.TRGBAlphaImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#Clear"},
     {"title": "CastleImages.TRGBAlphaImage.IsClear", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#IsClear"},
     {"title": "CastleImages.TRGBAlphaImage.ClearAlpha", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#ClearAlpha"},
     {"title": "CastleImages.TRGBAlphaImage.TransformRGB", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#TransformRGB"},
     {"title": "CastleImages.TRGBAlphaImage.ModulateRGB", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#ModulateRGB"},
     {"title": "CastleImages.TRGBAlphaImage.AlphaDecide", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#AlphaDecide"},
     {"title": "CastleImages.TRGBAlphaImage.Compose", "text": " RGB channels are copied from the RGB image, alpha channel is copied from the Grayscale image. Given RGB and Grayscale images must have the same size, and this is the resulting size of this image after Compose call.    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#Compose"},
     {"title": "CastleImages.TRGBAlphaImage.HasAlpha", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#HasAlpha"},
     {"title": "CastleImages.TRGBAlphaImage.AlphaChannel", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#AlphaChannel"},
     {"title": "CastleImages.TRGBAlphaImage.LerpWith", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#LerpWith"},
     {"title": "CastleImages.TRGBAlphaImage.MixColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#MixColors"},
     {"title": "CastleImages.TRGBAlphaImage.ToRGBImage", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#ToRGBImage"},
     {"title": "CastleImages.TRGBAlphaImage.ToGrayscaleAlphaImage", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#ToGrayscaleAlphaImage"},
     {"title": "CastleImages.TRGBAlphaImage.ToGrayscaleImage", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#ToGrayscaleImage"},
     {"title": "CastleImages.TRGBAlphaImage.PremultiplyAlpha", "text": " Changes <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html#PremultipliedAlpha\">PremultipliedAlpha</a> from <code>False</code> to <code>True</code>. Unless <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html#PremultipliedAlpha\">PremultipliedAlpha</a> was already <code>True</code>, in which case this method does nothing &mdash; this way it is safe to call this many times, we will not repeat multiplying.  <p><i>The image with premultiplied alpha can only be used with a subset of image routines that actually support premultiplied alpha.</i> Right now, these are only <a class=\"normal\" href=\"CastleImages.TCastleImage.html#DrawTo\">TCastleImage.DrawTo</a> and <a class=\"normal\" href=\"CastleImages.TCastleImage.html#DrawFrom\">TCastleImage.DrawFrom</a>. Image with <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html#PremultipliedAlpha\">PremultipliedAlpha</a> can be used as a source for drawing, and the results will be the same as without premultiplying, but faster.    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#PremultiplyAlpha"},
     {"title": "CastleImages.TRGBAlphaImage.AlphaBleed", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#AlphaBleed"},
     {"title": "CastleImages.TRGBAlphaImage.MakeAlphaBleed", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#MakeAlphaBleed"},
     {"title": "CastleImages.TRGBAlphaImage.FillEllipse", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#FillEllipse"},
     {"title": "CastleImages.TRGBAlphaImage.Ellipse", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#Ellipse"},
     {"title": "CastleImages.TRGBAlphaImage.FillRectangle", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#FillRectangle"},
     {"title": "CastleImages.TRGBAlphaImage.Rectangle", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#Rectangle"},
     {"title": "CastleImages.TRGBAlphaImage.Line", "text": "    ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#Line"},
     {"title": "CastleImages.TRGBAlphaImage.Pixels", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to <a class=\"normal\" href=\"CastleVectors.html#PVector4Byte\">PVector4Byte</a>. ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#Pixels"},
     {"title": "CastleImages.TRGBAlphaImage.AlphaPixels", "text": " ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#AlphaPixels"},
     {"title": "CastleImages.TRGBAlphaImage.PixelsArray", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to <a class=\"normal\" href=\"CastleVectors.html#PVector4ByteArray\">PVector4ByteArray</a>. ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#PixelsArray"},
     {"title": "CastleImages.TRGBAlphaImage.PremultipliedAlpha", "text": " ", "tags": "", "loc": "CastleImages.TRGBAlphaImage.html#PremultipliedAlpha"},
     {"title": "CastleImages.TRGBFloatImage", "text": " ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html"},
     {"title": "CastleImages.TRGBFloatImage.GetColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#GetColors"},
     {"title": "CastleImages.TRGBFloatImage.SetColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#SetColors"},
     {"title": "CastleImages.TRGBFloatImage.PixelSize", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#PixelSize"},
     {"title": "CastleImages.TRGBFloatImage.ColorComponentsCount", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#ColorComponentsCount"},
     {"title": "CastleImages.TRGBFloatImage.PixelPtr", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#PixelPtr"},
     {"title": "CastleImages.TRGBFloatImage.RowPtr", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#RowPtr"},
     {"title": "CastleImages.TRGBFloatImage.InvertColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#InvertColors"},
     {"title": "CastleImages.TRGBFloatImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#Clear"},
     {"title": "CastleImages.TRGBFloatImage.IsClear", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#IsClear"},
     {"title": "CastleImages.TRGBFloatImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#Clear"},
     {"title": "CastleImages.TRGBFloatImage.IsClear", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#IsClear"},
     {"title": "CastleImages.TRGBFloatImage.ToRGBImage", "text": " <a class=\"normal\" href=\"CastleImages.TCastleImage.html#Colors\">Colors</a> in <a class=\"normal\" href=\"CastleImages.TRGBFloatImage.html#Pixels\">pixels</a> are simply rounded using <a class=\"normal\" href=\"CastleVectors.html#Vector3Byte\">Vector3Byte</a>. So such conversion not only kills the floating-point precision in float format but also clamps color components to 0..1.    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#ToRGBImage"},
     {"title": "CastleImages.TRGBFloatImage.ScaleColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#ScaleColors"},
     {"title": "CastleImages.TRGBFloatImage.ExpColors", "text": " So e.g. Exp = 1/2.2 gives commonly used gamma correction.    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#ExpColors"},
     {"title": "CastleImages.TRGBFloatImage.LerpWith", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#LerpWith"},
     {"title": "CastleImages.TRGBFloatImage.MixColors", "text": "    ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#MixColors"},
     {"title": "CastleImages.TRGBFloatImage.Pixels", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to <a class=\"normal\" href=\"CastleVectors.html#PVector3\">PVector3</a>. ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#Pixels"},
     {"title": "CastleImages.TRGBFloatImage.RGBFloatPixels", "text": " ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#RGBFloatPixels"},
     {"title": "CastleImages.TRGBFloatImage.PixelsArray", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to <a class=\"normal\" href=\"CastleVectors.html#PVector3Array\">PVector3Array</a>. ", "tags": "", "loc": "CastleImages.TRGBFloatImage.html#PixelsArray"},
     {"title": "CastleImages.TGrayscaleImage", "text": " Color is a simple Byte value. ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html"},
     {"title": "CastleImages.TGrayscaleImage.DrawFromCore", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#DrawFromCore"},
     {"title": "CastleImages.TGrayscaleImage.GetColors", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#GetColors"},
     {"title": "CastleImages.TGrayscaleImage.SetColors", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#SetColors"},
     {"title": "CastleImages.TGrayscaleImage.PixelSize", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#PixelSize"},
     {"title": "CastleImages.TGrayscaleImage.ColorComponentsCount", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#ColorComponentsCount"},
     {"title": "CastleImages.TGrayscaleImage.PixelPtr", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#PixelPtr"},
     {"title": "CastleImages.TGrayscaleImage.RowPtr", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#RowPtr"},
     {"title": "CastleImages.TGrayscaleImage.InvertColors", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#InvertColors"},
     {"title": "CastleImages.TGrayscaleImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#Clear"},
     {"title": "CastleImages.TGrayscaleImage.IsClear", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#IsClear"},
     {"title": "CastleImages.TGrayscaleImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#Clear"},
     {"title": "CastleImages.TGrayscaleImage.IsClear", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#IsClear"},
     {"title": "CastleImages.TGrayscaleImage.HalfColors", "text": " This is done by simple bitshift, so you can be sure that all components are &lt; 2&circ;7 after this.    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#HalfColors"},
     {"title": "CastleImages.TGrayscaleImage.ToGrayscaleAlphaImage", "text": " The newly created alpha channel will have constant opaque alpha, except in the special case of <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html#TreatAsAlpha\">TGrayscaleImage.TreatAsAlpha</a> = <code>True</code> (where the contents will be copied to alpha, and intensity set to <a class=\"normal\" href=\"CastleColors.html#White\">white</a>).    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#ToGrayscaleAlphaImage"},
     {"title": "CastleImages.TGrayscaleImage.LerpWith", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#LerpWith"},
     {"title": "CastleImages.TGrayscaleImage.MixColors", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#MixColors"},
     {"title": "CastleImages.TGrayscaleImage.AlphaChannel", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#AlphaChannel"},
     {"title": "CastleImages.TGrayscaleImage.Assign", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#Assign"},
     {"title": "CastleImages.TGrayscaleImage.FillEllipse", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#FillEllipse"},
     {"title": "CastleImages.TGrayscaleImage.Ellipse", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#Ellipse"},
     {"title": "CastleImages.TGrayscaleImage.FillRectangle", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#FillRectangle"},
     {"title": "CastleImages.TGrayscaleImage.Rectangle", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#Rectangle"},
     {"title": "CastleImages.TGrayscaleImage.Line", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#Line"},
     {"title": "CastleImages.TGrayscaleImage.Pixels", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to PByte. ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#Pixels"},
     {"title": "CastleImages.TGrayscaleImage.GrayscalePixels", "text": " ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#GrayscalePixels"},
     {"title": "CastleImages.TGrayscaleImage.PixelsArray", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to <a class=\"normal\" href=\"CastleUtils.html#PByteArray\">PByteArray</a>. ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#PixelsArray"},
     {"title": "CastleImages.TGrayscaleImage.TreatAsAlpha", "text": "  <p>This property is meaningful only for a small subset of operations.  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> When creating OpenGL texture from this image. If <code>True</code>, then the grayscale pixel data will be loaded as alpha channel contents (GL_ALPHA texture for OpenGL, it modifies only the fragments alpha value, it doesn't have any &quot;color&quot; in the normal sense). It is also the only way for <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html\">TGrayscaleImage</a> to return <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html#AlphaChannel\">AlphaChannel</a> &lt;&gt; <a class=\"normal\" href=\"CastleImages.html#acNone\">acNone</a>.</p></li>   <li value=\"2\"><p> When using <a class=\"normal\" href=\"CastleImages.TCastleImage.html#DrawFrom\">DrawFrom</a> / <a class=\"normal\" href=\"CastleImages.TCastleImage.html#DrawTo\">DrawTo</a> methods. If <code>True</code>, this image is drawn like an RGBA image, with constant RGB color <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html#ColorWhenTreatedAsAlpha\">ColorWhenTreatedAsAlpha</a>, and alpha channel taken from contents of this image.</p></li> </ol>  <p> ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#TreatAsAlpha"},
     {"title": "CastleImages.TGrayscaleImage.ColorWhenTreatedAsAlpha", "text": " ", "tags": "", "loc": "CastleImages.TGrayscaleImage.html#ColorWhenTreatedAsAlpha"},
     {"title": "CastleImages.TGrayscaleAlphaImage", "text": " Each pixel is two bytes: grayscale + alpha. ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html"},
     {"title": "CastleImages.TGrayscaleAlphaImage.DrawFromCore", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#DrawFromCore"},
     {"title": "CastleImages.TGrayscaleAlphaImage.GetColors", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#GetColors"},
     {"title": "CastleImages.TGrayscaleAlphaImage.SetColors", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#SetColors"},
     {"title": "CastleImages.TGrayscaleAlphaImage.PixelSize", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#PixelSize"},
     {"title": "CastleImages.TGrayscaleAlphaImage.ColorComponentsCount", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#ColorComponentsCount"},
     {"title": "CastleImages.TGrayscaleAlphaImage.PixelPtr", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#PixelPtr"},
     {"title": "CastleImages.TGrayscaleAlphaImage.RowPtr", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#RowPtr"},
     {"title": "CastleImages.TGrayscaleAlphaImage.InvertColors", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#InvertColors"},
     {"title": "CastleImages.TGrayscaleAlphaImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#Clear"},
     {"title": "CastleImages.TGrayscaleAlphaImage.IsClear", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#IsClear"},
     {"title": "CastleImages.TGrayscaleAlphaImage.Clear", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#Clear"},
     {"title": "CastleImages.TGrayscaleAlphaImage.IsClear", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#IsClear"},
     {"title": "CastleImages.TGrayscaleAlphaImage.HasAlpha", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#HasAlpha"},
     {"title": "CastleImages.TGrayscaleAlphaImage.AlphaChannel", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#AlphaChannel"},
     {"title": "CastleImages.TGrayscaleAlphaImage.LerpWith", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#LerpWith"},
     {"title": "CastleImages.TGrayscaleAlphaImage.MixColors", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#MixColors"},
     {"title": "CastleImages.TGrayscaleAlphaImage.Assign", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#Assign"},
     {"title": "CastleImages.TGrayscaleAlphaImage.FillEllipse", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#FillEllipse"},
     {"title": "CastleImages.TGrayscaleAlphaImage.Ellipse", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#Ellipse"},
     {"title": "CastleImages.TGrayscaleAlphaImage.FillRectangle", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#FillRectangle"},
     {"title": "CastleImages.TGrayscaleAlphaImage.Rectangle", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#Rectangle"},
     {"title": "CastleImages.TGrayscaleAlphaImage.Line", "text": "    ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#Line"},
     {"title": "CastleImages.TGrayscaleAlphaImage.Pixels", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to <a class=\"normal\" href=\"CastleVectors.html#PVector2Byte\">PVector2Byte</a>. ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#Pixels"},
     {"title": "CastleImages.TGrayscaleAlphaImage.GrayscaleAlphaPixels", "text": " ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#GrayscaleAlphaPixels"},
     {"title": "CastleImages.TGrayscaleAlphaImage.PixelsArray", "text": " Same as <a class=\"normal\" href=\"CastleImages.TEncodedImage.html#RawPixels\">RawPixels</a>, only typecasted to <a class=\"normal\" href=\"CastleVectors.html#PVector2ByteArray\">PVector2ByteArray</a>. ", "tags": "", "loc": "CastleImages.TGrayscaleAlphaImage.html#PixelsArray"},
     {"title": "CastleImages.EImageLoadError", "text": " ", "tags": "", "loc": "CastleImages.EImageLoadError.html"},
     {"title": "CastleImages.EInvalidImageFormat", "text": " ", "tags": "", "loc": "CastleImages.EInvalidImageFormat.html"},
     {"title": "CastleImages.EUnableToLoadImage", "text": " ", "tags": "", "loc": "CastleImages.EUnableToLoadImage.html"},
     {"title": "CastleImages.EImageFormatNotSupported", "text": " ", "tags": "", "loc": "CastleImages.EImageFormatNotSupported.html"},
     {"title": "CastleImages.EImageSaveError", "text": " ", "tags": "", "loc": "CastleImages.EImageSaveError.html"},
     {"title": "CastleImages.TTextureCompressionInfo", "text": " ", "tags": "", "loc": "CastleImages.TTextureCompressionInfo.html"},
     {"title": "CastleImages.TTextureCompressionInfo.Name", "text": " ", "tags": "", "loc": "CastleImages.TTextureCompressionInfo.html#Name"},
     {"title": "CastleImages.TTextureCompressionInfo.RequiresPowerOf2", "text": " ", "tags": "", "loc": "CastleImages.TTextureCompressionInfo.html#RequiresPowerOf2"},
     {"title": "CastleImages.TTextureCompressionInfo.AlphaChannel", "text": " ", "tags": "", "loc": "CastleImages.TTextureCompressionInfo.html#AlphaChannel"},
     {"title": "CastleImages.TTextureCompressionInfo.DDSFlipped", "text": " When reading, we except them to be already flipped. When loading to OpenGL, they will effectively be flipped again (since OpenGL expects bottom-to-top order, while we load it image in top-to-bottom order), thus making the image correct.  <p>The exceptions are DXT* formats, that we can read correctly (unflipped) from DDS.  <p>This is only a limitation of the DDS format.  <p>For KTX, we can generate KTX images using PowerVR Texture Tools that already have a correct (bottom-to-top) orientation. So we can have textures compressed to PVRTC1_4bpp_RGB with correct orientation. ", "tags": "", "loc": "CastleImages.TTextureCompressionInfo.html#DDSFlipped"},
     {"title": "CastleImages.acSimpleYesNo", "text": " ", "tags": "", "loc": "CastleImages.html#acSimpleYesNo"},
     {"title": "CastleImages.acFullRange", "text": " ", "tags": "", "loc": "CastleImages.html#acFullRange"},
     {"title": "CastleImages.DefaultAlphaTolerance", "text": " ", "tags": "", "loc": "CastleImages.html#DefaultAlphaTolerance"},
     {"title": "CastleImages.AlphaToString", "text": " ", "tags": "", "loc": "CastleImages.html#AlphaToString"},
     {"title": "CastleImages.TextureCompressionInfo", "text": " ", "tags": "", "loc": "CastleImages.html#TextureCompressionInfo"},
     {"title": "CastleImages.EqualRGB", "text": " All three color components may differ by at most Tolerance. When Tolerance is 0, this is a normal (exact) comparison.    ", "tags": "", "loc": "CastleImages.html#EqualRGB"},
     {"title": "CastleImages.InImageClasses", "text": "    ", "tags": "", "loc": "CastleImages.html#InImageClasses"},
     {"title": "CastleImages.InImageClasses", "text": " This is a shortcut for <code>InImageClasses</code>(Image.ClassType, ImageClasses).    ", "tags": "", "loc": "CastleImages.html#InImageClasses"},
     {"title": "CastleImages.ImageClassesEqual", "text": "  <p>May be extended in the future to do better checks and return true also if both array contain the same classes but in different order, and one array may contain the same classes duplicated any times. So the intention is that you should treat both arrays as sets (i.e. order of elements is ignored).  <p>The problem is that this function should be lighting fast. As the main purpose of it is to use it in constructions like setting property values, e.g.  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">if</span> ImageClassesArraysEqual(Value, SomeProperty) <span class=\"pascal_keyword\">then</span> <span class=\"pascal_keyword\">begin</span>   SomeProperty := Value;   <span class=\"pascal_comment\">{ ... do some lengthy operations to update new value of SomeProperty ... }</span> <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>Doing smarter checks may cost us a little time.  <p>So for now this function returns </p>  <ul class=\"paragraph_spacing\">   <li><p><code>True</code> if for sure both arrays contain the same classes and</p></li>   <li><p><code>False</code> if <i>possibly</i> they don't contain the same classes.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleImages.html#ImageClassesEqual"},
     {"title": "CastleImages.Vector3ToRGBE", "text": " This allows you to encode high-precision colors in 4 bytes, see ifRGBE image format for pointers why this is useful.  <p>Each component of V (red, green, blue) must be from range [0, +infinity), not merely from [0, 1]. That is, V must have only nonnegative values.    ", "tags": "", "loc": "CastleImages.html#Vector3ToRGBE"},
     {"title": "CastleImages.VectorRGBETo3Single", "text": "    ", "tags": "", "loc": "CastleImages.html#VectorRGBETo3Single"},
     {"title": "CastleImages.IsImageMimeType", "text": "    ", "tags": "", "loc": "CastleImages.html#IsImageMimeType"},
     {"title": "CastleImages.ListImageExtsLong", "text": "  <p>This is basically for debug/info purposes, you can show this to user to let him know which formats are supported (and by which extensions they are recognized). Although almost always a better way to show this to user is just to use <a class=\"normal\" href=\"CastleImages.html#SaveImage_FileFilters\">SaveImage_FileFilters</a> with a save dialog like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FileDialog\">TCastleWindowCustom.FileDialog</a>, this shows file types in the open/save dialog, so it's most natural and convenient to user.  <p><code>ListImageExtsLong</code> produces a multiline info (separated by <a class=\"normal\" href=\"CastleUtils.html#NL\">NL</a>, last line not terminated by <a class=\"normal\" href=\"CastleUtils.html#NL\">NL</a>), shows all extensions and FormatName for each file format. Each line starts with LinePrefix.  <p><a class=\"normal\" href=\"CastleImages.html#ListImageExtsShort\">ListImageExtsShort</a> writes all recognized extensions separated by comma (', ').  <p>    ", "tags": "", "loc": "CastleImages.html#ListImageExtsLong"},
     {"title": "CastleImages.ListImageExtsShort", "text": "    ", "tags": "", "loc": "CastleImages.html#ListImageExtsShort"},
     {"title": "CastleImages.ImageExtToMimeType", "text": " Empty string if cannot guess.    ", "tags": "", "loc": "CastleImages.html#ImageExtToMimeType"},
     {"title": "CastleImages.LoadImage", "text": "  <p>URL is downloaded using <a class=\"normal\" href=\"CastleDownload.html\">CastleDownload</a> unit. As always, if you all you care about is loading normal files, then just pass a normal filename (absolute or relative to the current directory) as the URL parameter.  <p>Simple examples:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_comment\">{ When you don't care what TCastleImage descendant you get: }</span> Image := LoadImage(<span class=\"pascal_string\">'image.png'</span>);  <span class=\"pascal_comment\">{ When you insist on getting TRGBImage, that is 8-bit color image   without an alpha channel. }</span> ImageRGB := LoadImage(<span class=\"pascal_string\">'image.png'</span>, [TRGBImage]) <span class=\"pascal_keyword\">as</span> TRGBImage;</pre>  <p>  <p>Image file format may be given explicitly (overloaded version with Format parameter), or guessed based on URL extension (which can be given explicitly by TypeExt, or automatically calculated from full URL). For now, we cannot guess the file format based on file contents or MIME type (the latter case would be sensible for http URLs).  <p>AllowedImageClasses says what image classes are allowed. As a special case, AllowedImageClasses = [] is equivalent to AllowedImageClasses = [<a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>] which says that all <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> descendants are allowed. Then this function will do everything it can to load any image into the best subclass of <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>, losing as little image information it can.  <p>Example: consider you're loading a PNG file. Let's suppose you're loading it with AllowedImageClasses = []. Then you can get <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html\">TGrayscaleImage</a>, <a class=\"normal\" href=\"CastleImages.TGrayscaleAlphaImage.html\">TGrayscaleAlphaImage</a>, <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>, <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a>, depending on whether PNG file is grayscale or not and has alpha or not. Now let's suppose you specified AllowedImageClasses = [<a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>]. If PNG file will not be grayscale and not have alpha channel, <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> will return <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a> descendant, as before. But if PNG fill *will* have alpha channel then <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> will simply ignore (strip) alpha channel and return you <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>.  <p>Similar thing for grayscale: if image file was grayscale but you requested only <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>, then grayscale may be &quot;expanded&quot; into full three-channel RGB.  <p>There can also happen reverse situation: you e.g. insist that AllowedImageClasses = [<a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a>] but given PNG image does not have alpha channel. In this case <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> may add &quot;dummy&quot; alpha channel (everywhere equal to 1.0 or High(Byte)). Similar thing when you e.g. gave AllowedImageClasses = [<a class=\"normal\" href=\"CastleImages.TRGBFloatImage.html\">TRGBFloatImage</a>] but you're loading from PNG image. In this case you want float precision, but image file cannot offer it. So <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> can simply convert discreet values to appropriating floating point values.  <p>If at any point <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> will find that it's unable to satisfy AllowedImageClasses, it will raise <a class=\"normal\" href=\"CastleImages.EUnableToLoadImage.html\">EUnableToLoadImage</a>.  <p>  <p>  <p>  <p>  <p>  <p>    EUnableToLoadImage If Image cannot be loaded into allowed AllowedImageClasses. EImageFormatNotSupported If image file format cannot be loaded at all. This can happen if format is totally unknown (not recognized MIME type, derived from file extension in case of local files) or if this image format cannot be loaded at all. EImageLoadError If the image file cannot be processed for some reason. Exception Various TStream instances (used internally by the <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a> function) may raise exceptions in case the stream cannot be created for reading. Right now, we simply let these exceptions to &quot;pass through&quot; from this function (instead of catching and re-raising). So be ready that this function may raise <i>any</i> Exception class. In case of local files (<a  href=\"file://\">file://</a> URLs), the typical exception class is EFOpenError.", "tags": "", "loc": "CastleImages.html#LoadImage"},
     {"title": "CastleImages.LoadImage", "text": "    ", "tags": "", "loc": "CastleImages.html#LoadImage"},
     {"title": "CastleImages.LoadImage", "text": "    ", "tags": "", "loc": "CastleImages.html#LoadImage"},
     {"title": "CastleImages.LoadImage", "text": "    ", "tags": "", "loc": "CastleImages.html#LoadImage"},
     {"title": "CastleImages.LoadEncodedImage", "text": " This allows loading image compressed with GPU, which is good for optimally loading it to GPU. However, the operations on GPU-compressed image are very limited, we generally cannot do much with GPU-compressed data except rendering it.  <p>  <p>    ", "tags": "", "loc": "CastleImages.html#LoadEncodedImage"},
     {"title": "CastleImages.LoadEncodedImage", "text": "    ", "tags": "", "loc": "CastleImages.html#LoadEncodedImage"},
     {"title": "CastleImages.LoadEncodedImage", "text": "    ", "tags": "", "loc": "CastleImages.html#LoadEncodedImage"},
     {"title": "CastleImages.SaveImage", "text": " Takes URL as parameter, you can give <code>file</code> URL or just a normal filename.  <p>File format is determined by looking at URL (guessing MIME type using <a class=\"normal\" href=\"CastleURIUtils.html#URIMimeType\">URIMimeType</a>), or given explicitly as MimeType, or just given explicitly as Format parameter.  <p>Image class does <b>not</b> affect the created image file format, on the assumption that the &quot;memory format&quot; of the image (what <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> descendant is used) can be orthogonal to the actual &quot;file format&quot; used to save this file.  <p>Tries to write the image preserving it as closely as possible in this image format. When it's not possible, according conversions may be done: floating point precision of <a class=\"normal\" href=\"CastleImages.TRGBFloatImage.html\">TRGBFloatImage</a> may be lost (if saving to any file format besides RGBE file, although saving to OpenEXR may also preserve it once implemented), alpha channel may be lost, grayscale may be expanded and such.  <p>Although not absolutely all conversions are implemented for now. You can be sure that all image formats (that allow any saving at all) can be saved from <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a>. Also <a class=\"normal\" href=\"CastleImages.TRGBFloatImage.html\">TRGBFloatImage</a> can be saved to RGBE file. Also PNG format supports full collection (grayscale/rgb, alpha/no alpha are all perfectly possible in PNG file; and <a class=\"normal\" href=\"CastleImages.TRGBFloatImage.html\">TRGBFloatImage</a> will be just converted to 8-bit RGB before saving to PNG).  <p>  <p>    EImageSaveError When it's not possible to save image, because of Img class (memory format) and/or image file format.", "tags": "", "loc": "CastleImages.html#SaveImage"},
     {"title": "CastleImages.SaveImage", "text": "    ", "tags": "", "loc": "CastleImages.html#SaveImage"},
     {"title": "CastleImages.ImageClassBestForSavingToFormat", "text": " The only purpose of this for now is to pick <a class=\"normal\" href=\"CastleImages.TRGBFloatImage.html\">TRGBFloatImage</a> for RGBE files, chooses <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a> for anything else.  <p>For the overloaded version with URL, file format is determined by guessing based on file extension.  <p>    ", "tags": "", "loc": "CastleImages.html#ImageClassBestForSavingToFormat"},
     {"title": "CastleImages.AlphaMaxVar", "text": " Chooses &quot;full range&quot; if anything is &quot;full range&quot;, otherwise choose &quot;simple yes/no&quot; if anything is &quot;simple yes/no&quot;, otherwise returns &quot;no alpha channel&quot;.    ", "tags": "", "loc": "CastleImages.html#AlphaMaxVar"},
     {"title": "CastleImages.StringToAlpha", "text": "    ", "tags": "", "loc": "CastleImages.html#StringToAlpha"},
     {"title": "CastleImages.TextureCompressionToString", "text": "    ", "tags": "", "loc": "CastleImages.html#TextureCompressionToString"},
     {"title": "CastleImages.StringToTextureCompression", "text": " Possible values correspond to names listed in <a class=\"normal\" href=\"CastleImages.html#TextureCompressionInfo\">TextureCompressionInfo</a> array, they are also equal to enum Pascal names without leading &quot;tc&quot;. Compares given strig ignoring the case.     Exception If the string value does not name any <a class=\"normal\" href=\"CastleImages.html#TTextureCompression\">TTextureCompression</a> value.", "tags": "", "loc": "CastleImages.html#StringToTextureCompression"},
     {"title": "CastleImages.AddLoadImageListener", "text": " This allows to globally modify / observe your images paths, e.g. to use GPU compressed alternative versions.  <p>The URL processing is automatically used by <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a>, <a class=\"normal\" href=\"CastleImages.html#LoadEncodedImage\">LoadEncodedImage</a>, <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html#LoadFromFile\">TCompositeImage.LoadFromFile</a>.  <p>The URL processing is automatically registered by <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html\">MaterialProperties</a> to automatically use GPU compressed textures. See <a  href=\"http://castle-engine.sourceforge.net/creating_data_material_properties.php\">http://castle-engine.sourceforge.net/creating_data_material_properties.php</a> . You can also use it yourself, instead or in addition to <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html\">MaterialProperties</a> processing.  <p><i>An example:</i> To work on any GPU, you want to have various versions of your textures (uncompressed, and also compressed with various GPU algorithms) in your data. Use this procedure to redirect all image loading to use your compressed versions, when they are supported by the GPU. By doing it like this we capture all kinds of image loading &mdash; from <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a>, from <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> and so on.  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">uses</span> <span class=\"pascal_numeric\"></span>..., CastleURIUtils, CastleGLUtils, CastleLog, CastleStringUtils,   CastleFilesUtils;  <span class=\"pascal_keyword\">procedure</span> TTextureUtils.GPUTextureAlternative(<span class=\"pascal_keyword\">var</span> ImageUrl: <span class=\"pascal_keyword\">string</span>); <span class=\"pascal_keyword\">begin</span>   <span class=\"pascal_keyword\">if</span> IsPrefix(ApplicationData(<span class=\"pascal_string\">'animation/dragon/'</span>), ImageUrl) <span class=\"pascal_keyword\">then</span>   <span class=\"pascal_keyword\">begin</span>     <span class=\"pascal_keyword\">if</span> GLFeatures = <span class=\"pascal_keyword\">nil</span> <span class=\"pascal_keyword\">then</span>       WritelnWarning(<span class=\"pascal_string\">'TextureCompression'</span>, <span class=\"pascal_string\">'Cannot determine whether to use GPU compressed version for '</span> + ImageUrl + <span class=\"pascal_string\">' because the image is loaded before GPU capabilities are known'</span>) <span class=\"pascal_keyword\">else</span>     <span class=\"pascal_keyword\">if</span> tcPvrtc1_4bpp_RGBA <span class=\"pascal_keyword\">in</span> GLFeatures.TextureCompression <span class=\"pascal_keyword\">then</span>     <span class=\"pascal_keyword\">begin</span>       ImageUrl := ExtractURIPath(ImageUrl) + <span class=\"pascal_string\">'compressed/pvrtc1_4bpp_rgba/'</span> +         ExtractURIName(ImageUrl) + <span class=\"pascal_string\">'.dds'</span>;       WritelnLog(<span class=\"pascal_string\">'TextureCompression'</span>, <span class=\"pascal_string\">'Using compressed alternative '</span> + ImageUrl);     <span class=\"pascal_keyword\">end</span>;   <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;  <span class=\"pascal_keyword\">initialization</span>   AddLoadImageListener(@TTextureUtils(<span class=\"pascal_keyword\">nil</span>)<span class=\"pascal_float\">.</span>GPUTextureAlternative); <span class=\"pascal_keyword\">finalization</span>   RemoveLoadImageListener(@GPUTextureAlternative); <span class=\"pascal_keyword\">end</span>.</pre>  <p>    ", "tags": "", "loc": "CastleImages.html#AddLoadImageListener"},
     {"title": "CastleImages.RemoveLoadImageListener", "text": "    ", "tags": "", "loc": "CastleImages.html#RemoveLoadImageListener"},
     {"title": "CastleImages.ProcessImageUrl", "text": " This is used internally by the engine.    ", "tags": "", "loc": "CastleImages.html#ProcessImageUrl"},
     {"title": "CastleImages.TAutoAlphaChannel", "text": "  acAuto    acNone    acTest    acBlending   ", "tags": "", "loc": "CastleImages.html#TAutoAlphaChannel"},
     {"title": "CastleImages.TAlphaChannel", "text": " ", "tags": "", "loc": "CastleImages.html#TAlphaChannel"},
     {"title": "CastleImages.TResizeInterpolation", "text": "  riNearest Fastest interpolation mode.   riBilinear Bilinear interpolation mode, quite fast.   riMitchel Slower but prettier interpolation modes.  All the following interpolation modes are slower, not only because their equations are more complicated (and using more inputs), but also because their current implementation involves round-trip to FpImage format. Use these if speed is not a concern, but quality is crucial.  riBlackman    riBlackmanSinc    riBlackmanBessel    riGaussian    riHermite    riLanczos    riQuadratic    riCubic    riCatrom    riHanning    riHamming   ", "tags": "", "loc": "CastleImages.html#TResizeInterpolation"},
     {"title": "CastleImages.TResizeInterpolationInternal", "text": " ", "tags": "", "loc": "CastleImages.html#TResizeInterpolationInternal"},
     {"title": "CastleImages.TResizeInterpolationFpImage", "text": " ", "tags": "", "loc": "CastleImages.html#TResizeInterpolationFpImage"},
     {"title": "CastleImages.TDrawMode", "text": "  dmBlend Normal drawing mode, where the image contents are blended using the opacity (alpha) of the source image.  That is,  <p></p>  <pre class=\"preformatted\"> destination.rgb := destination.rgb * (1 - source.alpha) + source.rgb * source.alpha; destination.alpha := destination.alpha; // never changed by this drawing mode</pre>  <p>  <p>An image type without alpha (like <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a> or <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html\">TGrayscaleImage</a>) is always treated like it has alpha = 1.0 (fully opaque) everywhere. In particular, this means that when drawing <i>an image without alpha over any other image</i>, source RGB contents will simply replace the destination RGB contents.  dmBlendSmart An advanced blending mode, capable of blending 2 images with alpha channel better than <a class=\"normal\" href=\"CastleImages.html#dmBlend\">dmBlend</a>.  Based on <a  href=\"https://en.wikipedia.org/wiki/Alpha_compositing\">https://en.wikipedia.org/wiki/Alpha_compositing</a> formula for alpha-blending. This one is much less efficient than <a class=\"normal\" href=\"CastleImages.html#dmBlend\">dmBlend</a> and should be used only in case several layers of semi-transparent images should overlay one another and it matters to accurately account for both images alpha channel. Implemented for all <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a> and <a class=\"normal\" href=\"CastleImages.TGrayscaleAlphaImage.html\">TGrayscaleAlphaImage</a> combinations.  dmMultiply Multiply two images.  Simply multiply source with destination, channel by channel:  <p></p>  <pre class=\"preformatted\"> destination.rgba := destination.rgba * source.rgba;</pre>  <p>  <p>The exception is when the source image has alpha channel, but destination does not. For example, when source is <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a> or <a class=\"normal\" href=\"CastleImages.TGrayscaleAlphaImage.html\">TGrayscaleAlphaImage</a> and destination is <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">TRGBImage</a> or <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html\">TGrayscaleImage</a>. In this case the multiplication is followed by a simple blending, to apply the effects of source alpha:  <p></p>  <pre class=\"preformatted\"> destination.rgb :=   source.rgb * destination.rgb * source.alpha +                destination.rgb * (1 - source.alpha);</pre>  <p>  <p>Note that if source.alpha = 1 (source is opaque) that this is equivalent to the previous simple multiply equation.  dmAdd Additive drawing mode, where the image contents of source image are added to the existing destination image.  That is,  <p></p>  <pre class=\"preformatted\"> destination.rgb := destination.rgb + source.rgb * source.alpha; destination.alpha := destination.alpha; // never changed by this drawing mode</pre>  <p>  <p>So when drawing <i>an image with alpha over an image without alpha</i>, the colors will be added according to the above equation, only source is multiplied by alpha. To speed this operation, one can use <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html#PremultiplyAlpha\">TRGBAlphaImage.PremultiplyAlpha</a> on the source image first, very useful if you plan to draw the same source image many times. ", "tags": "", "loc": "CastleImages.html#TDrawMode"},
     {"title": "CastleImages.TCastleImageList", "text": " ", "tags": "", "loc": "CastleImages.html#TCastleImageList"},
     {"title": "CastleImages.TEncodedImageList", "text": " ", "tags": "", "loc": "CastleImages.html#TEncodedImageList"},
     {"title": "CastleImages.TTextureCompression", "text": "  tcDxt1_RGB S3TC DXT1 compression, for RGB images with no alpha or simple yes/no alpha.  This compression format is often supported by desktop OpenGL implementations. See <a  href=\"http://en.wikipedia.org/wiki/S3_Texture_Compression\">http://en.wikipedia.org/wiki/S3_Texture_Compression</a> about S3TC. It is also supported by a small number of Android devices.  <p><code>tcDxt1_RGB</code> and <a class=\"normal\" href=\"CastleImages.html#tcDxt1_RGBA\">tcDxt1_RGBA</a> are the same compression method, except in <code>tcDxt1_RGB</code> the alpha information is ignored while rendering, while in <a class=\"normal\" href=\"CastleImages.html#tcDxt1_RGBA\">tcDxt1_RGBA</a> the rendering assumes we have simple yes/no alpha.  <p>The difference is equivalent to OpenGL differences in treating </p>  <ul class=\"compact_spacing\">   <li><p>GL_COMPRESSED_RGB_S3TC_DXT1_EXT and</p></li>   <li><p>GL_COMPRESSED_RGBA_S3TC_DXT1_EXT.</p></li> </ul>  <p>  tcDxt1_RGBA S3TC DXT1 compression, <b>for RGB images with no alpha or simple yes/no alpha</b>.  See above <a class=\"normal\" href=\"CastleImages.html#tcDxt1_RGB\">tcDxt1_RGB</a> description for details.  tcDxt3 S3TC DXT3 compression, <b>for RGBA images with full alpha channel</b>, best for images with sharp alpha transitions.  This compression format is often supported by desktop OpenGL implementations. See <a  href=\"http://en.wikipedia.org/wiki/S3_Texture_Compression\">http://en.wikipedia.org/wiki/S3_Texture_Compression</a> about S3TC.  tcDxt5 S3TC DXT3 compression, <b>for RGBA images with full alpha channel</b>, best for images with smooth alpha transitions.  This compression format is often supported by desktop OpenGL implementations. See <a  href=\"http://en.wikipedia.org/wiki/S3_Texture_Compression\">http://en.wikipedia.org/wiki/S3_Texture_Compression</a> about S3TC.  tcPvrtc1_4bpp_RGB PowerVR texture compression (PVRTC) format.  Supported by some Android and iOS devices, using PowerVR GPU by Imagination Technologies. See <a  href=\"http://en.wikipedia.org/wiki/PVRTC\">http://en.wikipedia.org/wiki/PVRTC</a> .  <p>To generate such textures, PowerVR provides a nice tool PVRTexTool, see <a  href=\"http://community.imgtec.com/developers/powervr/tools/pvrtextool/\">http://community.imgtec.com/developers/powervr/tools/pvrtextool/</a> .  tcPvrtc1_2bpp_RGB    tcPvrtc1_4bpp_RGBA    tcPvrtc1_2bpp_RGBA    tcPvrtc2_4bpp    tcPvrtc2_2bpp    tcATITC_RGB ATI texture compression format, <b>without alpha</b>.  Supported by some Android devices (Adreno GPU from Qualcomm).  <p>There is no perfect program to generate such texture, unfortunately. The only sensible choice is to use ATI compressonator from <a  href=\"http://developer.amd.com/tools-and-sdks/archive/legacy-cpu-gpu-tools/the-compressonator/\">http://developer.amd.com/tools-and-sdks/archive/legacy-cpu-gpu-tools/the-compressonator/</a> . Unfortunately, it's installation may fail on some Windows versions and wine (Linux). We've had most success installing it on 32-bit Windows, and them copying to wine. ATI deprecated this program.  <p>Adreno SDK contains library to compress to ATITC formats, but no useful program to actually convert files to this format (wrapped in ktx or dds).  tcATITC_RGBA_ExplicitAlpha ATI texture compression format, <b>with sharp alpha</b>.  Supported by some Android devices (Adreno GPU from Qualcomm).  tcATITC_RGBA_InterpolatedAlpha ATI texture compression format, <b>with smooth alpha</b>.  Supported by some Android devices (Adreno GPU from Qualcomm).  tcETC1 ETC texture compression, <b>without alpha</b>.  See <a  href=\"http://en.wikipedia.org/wiki/Ericsson_Texture_Compression\">http://en.wikipedia.org/wiki/Ericsson_Texture_Compression</a> . Available on almost all Android OpenGLES 2.0 devices, unfortunately it doesn't support alpha channel.  <p>It can be generated using various tools &mdash; dedicated etcpack, also PVRTexTool and ATI compressonator. ", "tags": "", "loc": "CastleImages.html#TTextureCompression"},
     {"title": "CastleImages.TTextureCompressions", "text": " ", "tags": "", "loc": "CastleImages.html#TTextureCompressions"},
     {"title": "CastleImages.TS3TCImage", "text": " ", "tags": "", "loc": "CastleImages.html#TS3TCImage"},
     {"title": "CastleImages.TDecompressTextureFunction", "text": "    ", "tags": "", "loc": "CastleImages.html#TDecompressTextureFunction"},
     {"title": "CastleImages.TCastleImageClass", "text": " ", "tags": "", "loc": "CastleImages.html#TCastleImageClass"},
     {"title": "CastleImages.TEncodedImageClass", "text": " ", "tags": "", "loc": "CastleImages.html#TEncodedImageClass"},
     {"title": "CastleImages.TLoadImageEvent", "text": "    ", "tags": "", "loc": "CastleImages.html#TLoadImageEvent"},
     {"title": "CastleImages.DecompressTexture", "text": " This way the &quot;decompressor&quot; is pluggable, which means that you can even use OpenGL to decompress textures, if you're going to load images while some OpenGL context is active. ", "tags": "", "loc": "CastleImages.html#DecompressTexture"},
     {"title": "CastleImages.LoadImage_FileFilters", "text": "  <p>These objects should be treated as read-only outside this unit. Initialization / finalization of this unit automatically take care of them.  <p> ", "tags": "", "loc": "CastleImages.html#LoadImage_FileFilters"},
     {"title": "CastleImages.SaveImage_FileFilters", "text": " ", "tags": "", "loc": "CastleImages.html#SaveImage_FileFilters"},
     {"title": "CastleImages.SupportedTextureCompressionKnown", "text": " ", "tags": "", "loc": "CastleImages.html#SupportedTextureCompressionKnown"},
     {"title": "CastleImages.SupportedTextureCompression", "text": " ", "tags": "", "loc": "CastleImages.html#SupportedTextureCompression"},
     {"title": "CastleInAppPurchases", "text": " ", "tags": "", "loc": "CastleInAppPurchases.html"},
     {"title": "CastleInAppPurchases.TInAppProduct", "text": " ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html"},
     {"title": "CastleInAppPurchases.TInAppProduct.Price", "text": "     ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html#Price"},
     {"title": "CastleInAppPurchases.TInAppProduct.Name", "text": " ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html#Name"},
     {"title": "CastleInAppPurchases.TInAppProduct.PriceRaw", "text": " Empty before receiving information about the product from the store. This may contain various UTF-8 local characters used to describe currency, which do not have to be supported in all fonts.  <p>Use <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#Price\">Price</a> to display the <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#Price\">price</a> as a &quot;safe&quot; string, with most unusual characters replaced with ASCII (so it should work reliably with any font), and with special value if not received yet. ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html#PriceRaw"},
     {"title": "CastleInAppPurchases.TInAppProduct.Title", "text": " Empty if not known yet. May be translated to current user language. ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html#Title"},
     {"title": "CastleInAppPurchases.TInAppProduct.Description", "text": " Empty if not known yet. May be translated to current user language. ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html#Description"},
     {"title": "CastleInAppPurchases.TInAppProduct.PriceAmountMicros", "text": " 0 if not known yet. ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html#PriceAmountMicros"},
     {"title": "CastleInAppPurchases.TInAppProduct.PriceCurrencyCode", "text": " Empty if not known yet. ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html#PriceCurrencyCode"},
     {"title": "CastleInAppPurchases.TInAppProduct.Owns", "text": " Use this for non-consumable items (things that user buys, and then &quot;<code>owns</code>&quot; for the rest of his life).  <p>Caution: <i>this may not be up-to-date knowledge</i>. Call <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#RefreshPurchases\">TInAppPurchases.RefreshPurchases</a> to refresh it (on Android, this happens automatically on app launch; but on iOS, it cannot be done automatically, as it requires logging to AppStore &ndash; this is also explicitly said in Apple docs). Watch for <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Owns\">TInAppPurchases.Owns</a> and <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#OnRefreshedPurchases\">TInAppPurchases.OnRefreshedPurchases</a> then.  <p>Do not depend on this for consumables (use <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#SuccessfullyConsumed\">SuccessfullyConsumed</a> for them, and be sure to call <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#SuccessfullyConsumed\">TInAppPurchases.SuccessfullyConsumed</a> from <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Owns\">TInAppPurchases.Owns</a> for them). ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html#Owns"},
     {"title": "CastleInAppPurchases.TInAppProduct.SuccessfullyConsumed", "text": " We should &quot;provision&quot; it now, which means that we should set <code><code>SuccessfullyConsumed</code>:=false</code>, and perform whatever is necessary upon consuming &mdash; e.g. continue the game or increase player's gold. ", "tags": "", "loc": "CastleInAppPurchases.TInAppProduct.html#SuccessfullyConsumed"},
     {"title": "CastleInAppPurchases.TAvailableProduct", "text": " ", "tags": "", "loc": "CastleInAppPurchases.TAvailableProduct.html"},
     {"title": "CastleInAppPurchases.TAvailableProduct.Name", "text": " ", "tags": "", "loc": "CastleInAppPurchases.TAvailableProduct.html#Name"},
     {"title": "CastleInAppPurchases.TAvailableProduct.Category", "text": " For now used only for analytics. ", "tags": "", "loc": "CastleInAppPurchases.TAvailableProduct.html#Category"},
     {"title": "CastleInAppPurchases.TInAppPurchases", "text": "  <p>Typical usage:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Construct one instance of this class. Or a subclass &ndash; it is useful to override some methods of this class for a particular game.</p></li>   <li value=\"2\"><p>Early (e.g. from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">TCastleApplication.OnInitialize</a>) call <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#SetAvailableProducts\">SetAvailableProducts</a>, and wait for <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#OnRefreshedPrices\">OnRefreshedPrices</a> to know the prices about products (in user's local currency).</p></li>   <li value=\"3\"><p>Query the product information using <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Product\">Product</a> method, and looking at various <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html\">TInAppProduct</a> properties.</p></li>   <li value=\"4\"><p>Buy products using <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Purchase\">Purchase</a>, <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Consume\">consume</a> products using <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Consume\">Consume</a>, refresh the ownership information using <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#RefreshPurchases\">RefreshPurchases</a>.</p></li> </ol>  <p>  <p>You need to add a &quot;service&quot; to include the necessary integration code on Android and iOS. For Android, set project type as <code>&quot;integrated&quot;</code> and add the <code>&quot;google_in_app_purchases&quot;</code> service (see <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> ). For iOS, add the <code>&quot;in_app_purchases&quot;</code> service (see <a  href=\"https://github.com/castle-engine/castle-engine/wiki/iOS-Services\">https://github.com/castle-engine/castle-engine/wiki/iOS-Services</a> ).  <p>You need to define the products you want sell in the <i>Google Play Developer Console</i> ( <a  href=\"https://developer.android.com/distribute/console/index.html\">https://developer.android.com/distribute/console/index.html</a> ) for Android, or <i>iTunes Connect</i> ( <a  href=\"https://itunesconnect.apple.com/\">https://itunesconnect.apple.com/</a> ) for iOS. The names of products you provide to <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#SetAvailableProducts\">SetAvailableProducts</a> or <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Product\">Product</a> methods must correspond to product names you set on these websites. ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html"},
     {"title": "CastleInAppPurchases.TInAppPurchases.KnownCompletely", "text": "    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#KnownCompletely"},
     {"title": "CastleInAppPurchases.TInAppPurchases.RefreshedPrices", "text": " The default implementation of this method in this class just calls <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#OnRefreshedPrices\">OnRefreshedPrices</a>.    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#RefreshedPrices"},
     {"title": "CastleInAppPurchases.TInAppPurchases.RefreshedPurchases", "text": " The default implementation of this method in this class just calls <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#OnRefreshedPurchases\">OnRefreshedPurchases</a>.    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#RefreshedPurchases"},
     {"title": "CastleInAppPurchases.TInAppPurchases.SuccessfullyConsumed", "text": "  <p>In this class, this simply sets <code>Product.SuccessfullyConsumed</code> flag to <code>True</code>, and waits for some other code (maybe overridden <code>SuccessfullyConsumed</code> implementation, maybe something else) will handle it and reset the <code>Product.SuccessfullyConsumed</code> flag to <code>False</code>.    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#SuccessfullyConsumed"},
     {"title": "CastleInAppPurchases.TInAppPurchases.Owns", "text": "  <p>If the product is <b>not consumable</b> (which means that it can be owned only once, and it's owned forever once bought): Note that this method may be called multiple times, because there are various situations in which we may &quot;gain knowledge&quot; that user <code>owns</code> this item (e.g. each <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#RefreshPurchases\">RefreshPurchases</a> call). Write your code to react gracefullly to this, such that calling this method on an already-owned item is handled correctly.  <p>E.g. if you increase some stat (e.g. &quot;gold owned&quot;) when user buys a &quot;chest of gold&quot;, and &quot;chest of gold&quot; is non-consumable (you can only own it once, and then you just own it forever), then store the fact that you &quot;already increased gold because of the chest ownership&quot; in the user persistent data (see <a  href=\"https://castle-engine.sourceforge.io/manual_user_prefs.php\">https://castle-engine.sourceforge.io/manual_user_prefs.php</a>). Do not just increase the &quot;gold owned&quot; at every call of this method.  <p>If the product is a <b>consumable</b>, which means it has a one-time use (and should disappear afterwards, until user will buy it again), then:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><b>Call the <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Consume\">Consume</a> method</b> once you know the item is owned. You can call <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Consume\">Consume</a> directly from the overridden implementation of <code>Owns</code>, this is often the simplest approach.</p></li>   <li value=\"2\"><p><b>Actually perform the consumption</b> (bump the player gold, grant extra life and so on) <b>only when the item is successfully consumed</b>. You are notified about this by the <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#SuccessfullyConsumed\">SuccessfullyConsumed</a> call (you can override it), or you can watch if the <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#SuccessfullyConsumed\">TInAppProduct.SuccessfullyConsumed</a> flag is set.  <p><b>Do not give any one-time gain as a response to the <code>Owns</code> call.</b> Always wait for <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#SuccessfullyConsumed\">SuccessfullyConsumed</a> call.  <p>This protects you from the scenario when you're notified that you own the item multiple times (which may happen, since purchases may be resumed asynchronously while other code is executing), and you call <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Consume\">Consume</a> twice. The <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#SuccessfullyConsumed\">SuccessfullyConsumed</a> will only fire once, if user bought item once.</p></li> </ol>  <p>    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#Owns"},
     {"title": "CastleInAppPurchases.TInAppPurchases.Create", "text": "    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#Create"},
     {"title": "CastleInAppPurchases.TInAppPurchases.Destroy", "text": "    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#Destroy"},
     {"title": "CastleInAppPurchases.TInAppPurchases.SetAvailableProducts", "text": " The overloaded version with <a class=\"normal\" href=\"CastleInAppPurchases.TAvailableProduct.html\">TAvailableProduct</a> allows to provide additional information to the in-app payment system, see <a class=\"normal\" href=\"CastleInAppPurchases.TAvailableProduct.html\">TAvailableProduct</a> docs.     ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#SetAvailableProducts"},
     {"title": "CastleInAppPurchases.TInAppPurchases.SetAvailableProducts", "text": "    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#SetAvailableProducts"},
     {"title": "CastleInAppPurchases.TInAppPurchases.Purchase", "text": "    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#Purchase"},
     {"title": "CastleInAppPurchases.TInAppPurchases.Consume", "text": " You should listen on a &quot;successful consumption&quot; (override <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#SuccessfullyConsumed\">SuccessfullyConsumed</a> method and/or watch <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#SuccessfullyConsumed\">TInAppProduct.SuccessfullyConsumed</a>) until you actually act on the consumption (increase player gold or such).    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#Consume"},
     {"title": "CastleInAppPurchases.TInAppPurchases.Product", "text": "  <p>Creates and adds new product, if not found (useful in case you asked for a product before information about it arrived from the net, or before you even called <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#SetAvailableProducts\">SetAvailableProducts</a> with it).    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#Product"},
     {"title": "CastleInAppPurchases.TInAppPurchases.RefreshPurchases", "text": " This will call <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Owns\">Owns</a> on the owned items, and then <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#RefreshedPurchases\">RefreshedPurchases</a> or <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#OnRefreshedPurchases\">OnRefreshedPurchases</a>.  <p>This is necessary to be called explicitly on iOS (for AppStore), as it will ask user to login to AppStore. On Android, this is done automatically at app start, and doesn't ask user anything.    ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#RefreshPurchases"},
     {"title": "CastleInAppPurchases.TInAppPurchases.DebugMockupBuying", "text": " ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#DebugMockupBuying"},
     {"title": "CastleInAppPurchases.TInAppPurchases.OnRefreshedPrices", "text": " The information is stored inside <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html\">TInAppProduct</a> instances, e.g. query <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#Price\">TInAppProduct.Price</a>, <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#Title\">TInAppProduct.Title</a> and so on. Get the <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html\">TInAppProduct</a> instance by <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Product\">Product</a> method.  <p>This signals that we queried the shop for the product information like <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#Price\">TInAppProduct.Price</a> and <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#Title\">TInAppProduct.Title</a> and <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#Description\">TInAppProduct.Description</a>. This is automatically done always when launching the application, and sometimes later too.  <p>It does not mean that we have queried the ownership status of the products, for this see <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#OnRefreshedPurchases\">OnRefreshedPurchases</a>.  <p>See also <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#RefreshedPrices\">RefreshedPrices</a> method. Instead of assigning this event, you cal override <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#RefreshedPrices\">RefreshedPrices</a> method in descendants. ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#OnRefreshedPrices"},
     {"title": "CastleInAppPurchases.TInAppPurchases.OnRefreshedPurchases", "text": " The information is stored inside <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html#Owns\">TInAppProduct.Owns</a>, you can get the <a class=\"normal\" href=\"CastleInAppPurchases.TInAppProduct.html\">TInAppProduct</a> instance using the <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#Product\">Product</a> method.  <p>The ownership status is automatically queried when the application starts on Android. On iOS, it must be explicitly invoked using <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html#RefreshPurchases\">RefreshPurchases</a> (this is a limitation of iOS user-interface around this, so it cannot be hidden / workarounded by us). ", "tags": "", "loc": "CastleInAppPurchases.TInAppPurchases.html#OnRefreshedPurchases"},
     {"title": "CastleInputs", "text": "  <p><a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> instance represents a key/mouse shortcut. Instances of this class are spread throughout the engine. We have two different ways of using <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> instance:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> <b>Global</b>  <p><a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> instance with <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Group\">TInputShortcut.Group</a> &lt;&gt; <a class=\"normal\" href=\"CastleInputs.html#igLocal\">igLocal</a> is called &quot;global&quot;. Such instance is automatically (at construction) added to <a class=\"normal\" href=\"CastleInputs.html#InputsAll\">InputsAll</a> and <a class=\"normal\" href=\"CastleInputs.html#InputsGroup\">InputsGroup</a>[Group] lists.  <p>The purpose of such global input map is to be able to detect key conflicts, be able to restore whole input map to default, load/save them to the user config file, and so on. All shortcuts used in a typical 3D game, with normal <a class=\"normal\" href=\"CastleLevels.html\">CastleLevels</a> and <a class=\"normal\" href=\"CastlePlayer.html\">CastlePlayer</a> usage, are global.  <p>Global shortcuts are owned (they will be freed by) this unit (more specifically, they will be freed by <a class=\"normal\" href=\"CastleInputs.html#InputsAll\">InputsAll</a>). When creating them, pass <code>Nil</code> to the Owner parameter of constructor <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Create\">TInputShortcut.Create</a>. This implies that <a class=\"normal\" href=\"CastleInputs.html#InputsAll\">InputsAll</a> and <a class=\"normal\" href=\"CastleInputs.html#InputsGroup\">InputsGroup</a>[Group] lists will never shrink, which is useful &mdash; once added, shortcuts will not disappear. Global <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> instances are always in practice also global variables.  <p>For example <a class=\"normal\" href=\"CastleSceneManager.html\">CastleSceneManager</a> unit contains <a class=\"normal\" href=\"CastleSceneManager.html#Input_Interact\">Input_Interact</a>. For example <a class=\"normal\" href=\"CastlePlayer.html\">CastlePlayer</a> contains many inputs. </p></li>   <li><p> <b>Local</b>  <p><a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> instance with <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Group\">TInputShortcut.Group</a> = <a class=\"normal\" href=\"CastleInputs.html#igLocal\">igLocal</a> is called &quot;local&quot;. Basically, it means it's a normal component, it's not magically present on any global list, it's not magically managed by any list.  <p>For example <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> contains a number of them like <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Input_Forward\">TWalkCamera.Input_Forward</a>.  <p>Although it seems like &quot;global&quot; inputs are such a good idea, there are some reasons for having some inputs &quot;local&quot;:  <p></p>  <ul class=\"compact_spacing\">   <li><p>You can set them locally, obviously, not program-wide.</p></li>   <li><p>You can set them from Lazarus object inspector e.g. for cameras.</p></li>   <li><p>We cannot add shortcuts of both <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> and <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> to global, as they would conflict (e.g. &quot;up arrow key&quot; is used by both by default). The <a class=\"normal\" href=\"CastleInputs.html#InputsAll\">InputsAll</a> doesn't have (for now) any mechanism to indicate that only one of the cameras will be in practice used for a given <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>.</p></li>   <li><p>We cannot add shortcuts of <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a> descendants also because <a class=\"normal\" href=\"CastlePlayer.html\">CastlePlayer</a> has shortcuts that override camera shortcuts. One day this problem may disappear, when <a class=\"normal\" href=\"CastlePlayer.TPlayer.html\">TPlayer</a> and <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a> will become integrated more.</p></li> </ul>  <p> </p></li> </ul>  <p>  <p>You create new inputs by simply constructing new <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> instances. Make sure you add all global inputs before calling <code>Config.Load</code>, as some functionality assumes that all shortcuts are already added at the time <code>Config.Load</code> is called. The engine units themselves never call <code>Config.Load</code>, it is left to the final application. ", "tags": "", "loc": "CastleInputs.html"},
     {"title": "CastleInputs.TInputShortcut", "text": "  <p>Action may be activated by: </p>  <ul class=\"compact_spacing\">   <li><p>at most two key shortcuts,</p></li>   <li><p>and one mouse button shortcut,</p></li>   <li><p>and one character shortcut,</p></li>   <li><p>and one mouse wheel shortcut.</p></li> </ul>  <p>  <p>The difference between <i>key shortcut</i> and <i>character shortcut</i>: <i>&quot;Key&quot;</i> is something that can be expressed as <a class=\"normal\" href=\"CastleKeysMouse.html#TKey\">TKey</a> value. <i>&quot;Character&quot;</i> is something that can be expressed as Char value. They are keys like &quot;control key&quot; (<a class=\"normal\" href=\"CastleKeysMouse.html#K_Ctrl\">K_Ctrl</a>) or &quot;shift key&quot; (<a class=\"normal\" href=\"CastleKeysMouse.html#K_Shift\">K_Shift</a>) that cannot be expressed (on their own) as characters. Characters are both more and less specific: character &quot;A&quot; (upper letter &quot;a&quot;) is activated by pressing &quot;a&quot;, but only when Shift is pressed or CapsLock is on (window system / GUI toolkit may also allow other ways to input characters).  <p>Name of this component is additionally used if this is a global input shortcut (with Group &lt;&gt; <a class=\"normal\" href=\"CastleInputs.html#igLocal\">igLocal</a>, see <a class=\"normal\" href=\"CastleInputs.html\">CastleInputs</a> unit documentation): it is used for config file entries and for the <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> <code>shortcut()</code> function [castle-engine.sourceforge.net/castle_script.php#function_shortcut] . Any valid Pascal identifier will be Ok for these purposes. ", "tags": "", "loc": "CastleInputs.TInputShortcut.html"},
     {"title": "CastleInputs.TInputShortcut.Changed", "text": " Note that this is called only when the &quot;current&quot; values (<a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Key1\">Key1</a>, <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Key2\">Key2</a>, Character, <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseButtonUse\">MouseButtonUse</a>, <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseButton\">MouseButton</a>, <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseWheel\">MouseWheel</a>) changed, and it's not called when just the DefaultXxx values changed.    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Changed"},
     {"title": "CastleInputs.TInputShortcut.Create", "text": " Caption and Name are left empty (they do not have to be set for local shortcuts; although you may wish to later assign Name anyway, if you use this as sub-component in Lazarus).    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Create"},
     {"title": "CastleInputs.TInputShortcut.Create", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Create"},
     {"title": "CastleInputs.TInputShortcut.MakeDefault", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#MakeDefault"},
     {"title": "CastleInputs.TInputShortcut.AssignFromDefault", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#AssignFromDefault"},
     {"title": "CastleInputs.TInputShortcut.Assign", "text": " It always copies &quot;current&quot; properties (<a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Key1\">Key1</a>, <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Key2\">Key2</a>, Character, <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseButtonUse\">MouseButtonUse</a>, <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseButton\">MouseButton</a>, <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseWheel\">MouseWheel</a>), and optionally (if CopyDefaults) also copies the DefaultXxx properties.    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Assign"},
     {"title": "CastleInputs.TInputShortcut.Assign", "text": " Sets both current and default properties.    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Assign"},
     {"title": "CastleInputs.TInputShortcut.MakeClear", "text": " This sets both keys to <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a>, Character to #0, <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseButtonUse\">MouseButtonUse</a> to <code>False</code>, and <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseWheel\">MouseWheel</a> to <a class=\"normal\" href=\"CastleKeysMouse.html#mwNone\">mwNone</a>.    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#MakeClear"},
     {"title": "CastleInputs.TInputShortcut.IsPressed", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#IsPressed"},
     {"title": "CastleInputs.TInputShortcut.IsPressed", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#IsPressed"},
     {"title": "CastleInputs.TInputShortcut.IsKey", "text": " If Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> and ACharacter = #0, result is always <code>False</code>.    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#IsKey"},
     {"title": "CastleInputs.TInputShortcut.IsMouseButton", "text": " In practice, just checks <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseButtonUse\">MouseButtonUse</a> and if <code>True</code>, compares AMouseButton with <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseButton\">MouseButton</a>.    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#IsMouseButton"},
     {"title": "CastleInputs.TInputShortcut.IsMouseWheel", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#IsMouseWheel"},
     {"title": "CastleInputs.TInputShortcut.IsEvent", "text": "  <p>For key/character press, set AKey &lt;&gt; <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> or ACharacter &lt;&gt; #0. For mouse button press, set AMousePress to <code>True</code> and pass relevant AMouseButton. For mouse wheel, pass AMouseWheel &lt;&gt; <a class=\"normal\" href=\"CastleKeysMouse.html#mwNone\">mwNone</a>. Pass only one of these three events here, for example if you AMousePress to <code>True</code> then pass AKey = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> and ACharacter = #0 and AMouseWheel = <a class=\"normal\" href=\"CastleKeysMouse.html#mwNone\">mwNone</a>.  <p>Basically, this is a &quot;dispatcher&quot; that simply calls one of the <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#IsKey\">IsKey</a> or <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#IsMouseButton\">IsMouseButton</a> or <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#IsMouseWheel\">IsMouseWheel</a> methods. It's sometimes more comfortable to use this instead of taking care of them separately.    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#IsEvent"},
     {"title": "CastleInputs.TInputShortcut.IsEvent", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#IsEvent"},
     {"title": "CastleInputs.TInputShortcut.Description", "text": " If there is no way to press this shortcut (all properties like <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Key1\">Key1</a> and such are empty, like after <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MakeClear\">MakeClear</a>), we will use NoneString.  <p>The overloaded version without NoneString parameter will assume that NoneString should describe the shortcut <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Caption\">Caption</a>. This way, if user cleared (deleted all key/mouse buttons assigned) the shortcut in the game configuration, and we show him a message like:  <p></p>  <pre class=\"longcode\"><span class=\"pascal_string\">'Press '</span> + Input.Description + <span class=\"pascal_string\">' to do something'</span></pre>  <p>  <p>then user will see it as <code>'Press &quot;use&quot; key to do something'</code> and will know that (s)he should configure the &quot;use&quot; key.     ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Description"},
     {"title": "CastleInputs.TInputShortcut.Description", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Description"},
     {"title": "CastleInputs.TInputShortcut.Modifiers", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Modifiers"},
     {"title": "CastleInputs.TInputShortcut.Add", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Add"},
     {"title": "CastleInputs.TInputShortcut.Caption", "text": " With spaces, localized characters etc. ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Caption"},
     {"title": "CastleInputs.TInputShortcut.Group", "text": " Games may use this group to better show the keys configuration for user, presenting together keys from the same group. ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Group"},
     {"title": "CastleInputs.TInputShortcut.GroupOrder", "text": " The order may be important, as menus may show <a class=\"normal\" href=\"CastleInputs.html#InputsGroup\">InputsGroup</a> to user in this order. This order is applied (the group is actually sorted by <code>GroupOrder</code>) when reading config file. For equal <code>GroupOrder</code>, the order of creation (equal to the order on <a class=\"normal\" href=\"CastleInputs.html#InputsAll\">InputsAll</a> list) decides which is first. ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#GroupOrder"},
     {"title": "CastleInputs.TInputShortcut.Key1", "text": " You can set any of them to <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> to indicate that no key is assigned.  ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Key1"},
     {"title": "CastleInputs.TInputShortcut.Key2", "text": " ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Key2"},
     {"title": "CastleInputs.TInputShortcut.Character", "text": " You can set this to #0 to indicate that no character shortcut is assigned. ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#Character"},
     {"title": "CastleInputs.TInputShortcut.MouseButtonUse", "text": " You can set <code>MouseButtonUse</code> to <code>False</code> if you don't want to use this.  ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#MouseButtonUse"},
     {"title": "CastleInputs.TInputShortcut.MouseButton", "text": " ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#MouseButton"},
     {"title": "CastleInputs.TInputShortcut.MouseWheel", "text": " Note that mouse wheels cannot be continously pressed (our method <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#IsPressed\">IsPressed</a> doesn't look at it), so this is only suitable for commands that work in steps (not continously). ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#MouseWheel"},
     {"title": "CastleInputs.TInputShortcut.DefaultKey1", "text": " You can change them &mdash; this will change what <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MakeDefault\">MakeDefault</a> does.  <p>Note that setting these properties doesn't automatically set corresponding &quot;current&quot; property. E.g. <code><code>DefaultKey1</code> := <a class=\"normal\" href=\"CastleKeysMouse.html#K_Space\">K_Space</a>;</code> doesn't change the value of <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Key1\">Key1</a> property &mdash; only <code>DefaultKey1</code> changes. You can explicitly change <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Key1\">Key1</a> property, or just call <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MakeDefault\">MakeDefault</a> afterwards, if you want this to happen.  ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#DefaultKey1"},
     {"title": "CastleInputs.TInputShortcut.DefaultKey2", "text": " ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#DefaultKey2"},
     {"title": "CastleInputs.TInputShortcut.DefaultCharacter", "text": " ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#DefaultCharacter"},
     {"title": "CastleInputs.TInputShortcut.DefaultMouseButtonUse", "text": " ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#DefaultMouseButtonUse"},
     {"title": "CastleInputs.TInputShortcut.DefaultMouseButton", "text": " ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#DefaultMouseButton"},
     {"title": "CastleInputs.TInputShortcut.DefaultMouseWheel", "text": " ", "tags": "", "loc": "CastleInputs.TInputShortcut.html#DefaultMouseWheel"},
     {"title": "CastleInputs.TInputShortcutList", "text": "  <p>Right now both <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> and <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> check modifiers and have not configurable behavior:  <p>- <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> allows inputs only when modifiers = []. Except Input_Right/LeftRot and Input_Up/DownRotate that have special meaning when Ctrl is pressed (see <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#AllowSlowerRotations\">TWalkCamera.AllowSlowerRotations</a>). - <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> allows Inputs_Move only when modifiers = [<a class=\"normal\" href=\"CastleKeysMouse.html#mkCtrl\">mkCtrl</a>]. Other <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> are allowed only when modifiers = []. ", "tags": "", "loc": "CastleInputs.TInputShortcutList.html"},
     {"title": "CastleInputs.TInputShortcutList.FindName", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcutList.html#FindName"},
     {"title": "CastleInputs.TInputShortcutList.SeekMatchingShortcut", "text": " <code>Nil</code> if not found.    ", "tags": "", "loc": "CastleInputs.TInputShortcutList.html#SeekMatchingShortcut"},
     {"title": "CastleInputs.TInputShortcutList.RestoreDefaults", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcutList.html#RestoreDefaults"},
     {"title": "CastleInputs.TInputShortcutList.SeekConflict", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcutList.html#SeekConflict"},
     {"title": "CastleInputs.TInputShortcutList.LoadFromConfig", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcutList.html#LoadFromConfig"},
     {"title": "CastleInputs.TInputShortcutList.SaveToConfig", "text": "    ", "tags": "", "loc": "CastleInputs.TInputShortcutList.html#SaveToConfig"},
     {"title": "CastleInputs.TInputGroup", "text": "  igLocal    igBasic    igItems    igOther   ", "tags": "", "loc": "CastleInputs.html#TInputGroup"},
     {"title": "CastleInputs.InputsAll", "text": " Will be created in initialization and freed in finalization of this unit. All <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> instances will automatically add to this. ", "tags": "", "loc": "CastleInputs.html#InputsAll"},
     {"title": "CastleInputs.InputsGroup", "text": " ", "tags": "", "loc": "CastleInputs.html#InputsGroup"},
     {"title": "CastleInspectorControl", "text": " ", "tags": "", "loc": "CastleInspectorControl.html"},
     {"title": "CastleInspectorControl.TCastleInspectorControl", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.DefaultPadding", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#DefaultPadding"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.Create", "text": "    ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#Create"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.Destroy", "text": "    ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#Destroy"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.Rect", "text": "    ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#Rect"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.BeforeRender", "text": "    ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#BeforeRender"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.Render", "text": "    ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#Render"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.CapturesEventsAtPosition", "text": "    ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#CapturesEventsAtPosition"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.Motion", "text": "    ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#Motion"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.Color", "text": " By default it's <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#Color"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.Padding", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#Padding"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.HasHorizontalAnchor", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#HasHorizontalAnchor"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.HasVerticalAnchor", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#HasVerticalAnchor"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.HorizontalAnchorSelf", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#HorizontalAnchorSelf"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.HorizontalAnchorParent", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#HorizontalAnchorParent"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.VerticalAnchorSelf", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#VerticalAnchorSelf"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.VerticalAnchorParent", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#VerticalAnchorParent"},
     {"title": "CastleInspectorControl.TCastleInspectorControl.KeepInFront", "text": " ", "tags": "", "loc": "CastleInspectorControl.TCastleInspectorControl.html#KeepInFront"},
     {"title": "CastleInterfaces", "text": "  <p> This unit will be removed at some point, and Castle Game Engine will use CORBA interfaces only. ", "tags": "", "loc": "CastleInterfaces.html"},
     {"title": "CastleInterfaces.TNonRefCountedInterfacedObject", "text": "  <p>For COM-style interfaces, it's needed to descend from this to provide dumb <a class=\"normal\" href=\"CastleInterfaces.TNonRefCountedInterfacedObject.html#_AddRef\">_AddRef</a> and <a class=\"normal\" href=\"CastleInterfaces.TNonRefCountedInterfacedObject.html#_Release\">_Release</a> implementations (that do nothing) and trivial <a class=\"normal\" href=\"CastleInterfaces.TNonRefCountedInterfacedObject.html#QueryInterface\">QueryInterface</a> implementation.  <p>See e.g. thread [<a  href=\"http://lists.freepascal.org/lists/fpc-devel/2007-November/012060.html\">http://lists.freepascal.org/lists/fpc-devel/2007-November/012060.html</a>]. ", "tags": "", "loc": "CastleInterfaces.TNonRefCountedInterfacedObject.html"},
     {"title": "CastleInterfaces.TNonRefCountedInterfacedObject._AddRef", "text": "    ", "tags": "", "loc": "CastleInterfaces.TNonRefCountedInterfacedObject.html#_AddRef"},
     {"title": "CastleInterfaces.TNonRefCountedInterfacedObject._Release", "text": "    ", "tags": "", "loc": "CastleInterfaces.TNonRefCountedInterfacedObject.html#_Release"},
     {"title": "CastleInterfaces.TNonRefCountedInterfacedObject.QueryInterface", "text": "    ", "tags": "", "loc": "CastleInterfaces.TNonRefCountedInterfacedObject.html#QueryInterface"},
     {"title": "CastleInterfaces.TNonRefCountedInterfacedPersistent", "text": " Analogous to <a class=\"normal\" href=\"CastleInterfaces.TNonRefCountedInterfacedObject.html\">TNonRefCountedInterfacedObject</a>. ", "tags": "", "loc": "CastleInterfaces.TNonRefCountedInterfacedPersistent.html"},
     {"title": "CastleInterfaces.TNonRefCountedInterfacedPersistent._AddRef", "text": "    ", "tags": "", "loc": "CastleInterfaces.TNonRefCountedInterfacedPersistent.html#_AddRef"},
     {"title": "CastleInterfaces.TNonRefCountedInterfacedPersistent._Release", "text": "    ", "tags": "", "loc": "CastleInterfaces.TNonRefCountedInterfacedPersistent.html#_Release"},
     {"title": "CastleInterfaces.TNonRefCountedInterfacedPersistent.QueryInterface", "text": "    ", "tags": "", "loc": "CastleInterfaces.TNonRefCountedInterfacedPersistent.html#QueryInterface"},
     {"title": "CastleItems", "text": " ", "tags": "", "loc": "CastleItems.html"},
     {"title": "CastleItems.TItemResource", "text": "  <p>A &quot;resource&quot; is an information shared by all items of given type, for example you can have two instances of class <code>TItemResource</code>: Sword and LifePotion. (Actually, <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html\">TItemWeaponResource</a>, which is a descendant of <code>TItemResource</code>, sounds like a better candidate for the Sword.) Using them, you can create milions of actual swords and life potions, and place them of your level (as well as in inventories of creatures able to carry items). Every life potion (<a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> instance) may keep some individual information (for example, how much of the potion is already used/drunk), but all life potions will share the same <code>TItemResource</code> instance, so e.g. they all will be displayed using the same model on 3D level (<a class=\"normal\" href=\"CastleItems.TItemResource.html#BaseAnimation\">TItemResource.BaseAnimation</a>) and the same image in 2D inventory (<a class=\"normal\" href=\"CastleItems.TItemResource.html#Image\">TItemResource.Image</a>). ", "tags": "", "loc": "CastleItems.TItemResource.html"},
     {"title": "CastleItems.TItemResource.PrepareCore", "text": "    ", "tags": "", "loc": "CastleItems.TItemResource.html#PrepareCore"},
     {"title": "CastleItems.TItemResource.ItemClass", "text": "    ", "tags": "", "loc": "CastleItems.TItemResource.html#ItemClass"},
     {"title": "CastleItems.TItemResource.Create", "text": "    ", "tags": "", "loc": "CastleItems.TItemResource.html#Create"},
     {"title": "CastleItems.TItemResource.Destroy", "text": "    ", "tags": "", "loc": "CastleItems.TItemResource.html#Destroy"},
     {"title": "CastleItems.TItemResource.LoadFromFile", "text": "    ", "tags": "", "loc": "CastleItems.TItemResource.html#LoadFromFile"},
     {"title": "CastleItems.TItemResource.Image", "text": " The core engine itself doesn't use it, and doesn't force anything about such image (whether it should have some specific size, whether it should have alpha channel and such). It is up to the final game to make use of these images.  <p>If you're wondering how to generate such image: one option is to open the item 3D model in [<a  href=\"http://castle-engine.sourceforge.net/view3dscene.php\">http://castle-engine.sourceforge.net/view3dscene.php</a>] and use &quot;Display -&gt; Screenshot ...&quot; menu option (maybe the one that makes transparent background). It is usually a good idea to also remember the camera used for such screenshot with &quot;Console -&gt; Print Current Camera (Viewpoint)...&quot; menu option.    ", "tags": "", "loc": "CastleItems.TItemResource.html#Image"},
     {"title": "CastleItems.TItemResource.GLImage", "text": "    ", "tags": "", "loc": "CastleItems.TItemResource.html#GLImage"},
     {"title": "CastleItems.TItemResource.CreateItem", "text": " This is how you should create new <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> instances. It is analogous to <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#CreateCreature\">TCreatureResource.CreateCreature</a>, but now for items.  <p>Note that the item itself doesn't exist on a 3D world &mdash; you have to put it there if you want by <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#PutOnWorld\">TInventoryItem.PutOnWorld</a>. That is because items can also exist only in player's backpack and such, and then they are independent from 3D world.  <p><b>Examples:</b>  <p>You usually define your own item resources by adding a subdirectory with resource.xml file to your game data. See [<a  href=\"http://castle-engine.sourceforge.net/creating_data_resources.php\">http://castle-engine.sourceforge.net/creating_data_resources.php</a>] and engine tutorial for examples how to do this. Then you load the item resources with  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   Sword: TItemResource; <span class=\"pascal_numeric\"></span>...   Resources.LoadFromFiles;   Sword := Resources.FindName(<span class=\"pascal_string\">'Sword'</span>) <span class=\"pascal_keyword\">as</span> TItemResource;</pre>  <p>  <p>where 'Sword' is just our example item resource, assuming that one of your resource.xml files has resource with name=&quot;Sword&quot;.  <p>Now if you want to add the sword to your 3D world by code:  <p>Because <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> instance is automatically owned (freed) by the 3D world or inventory that contains it, a simplest example how to add an item to your 3D world is this:  <p></p>  <pre class=\"longcode\"> Sword.CreateItem(<span class=\"pascal_numeric\">1</span>).PutOnWorld(SceneManager.World, Vector3(<span class=\"pascal_numeric\">2</span>, <span class=\"pascal_numeric\">3</span>, <span class=\"pascal_numeric\">4</span>));</pre>  <p>  <p>This adds 1 item of the MyItemResource to the 3D world, on position (2, 3, 4). In simple cases you can get SceneManager instance from <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html#SceneManager\">TCastleWindow.SceneManager</a> or <a class=\"normal\" href=\"CastleControl.TCastleControl.html#SceneManager\">TCastleControl.SceneManager</a>.  <p>If you want to instead add sword to the inventory of Player, you can call  <p></p>  <pre class=\"longcode\"> SceneManager.Player.PickItem(Sword.CreateItem(<span class=\"pascal_numeric\">1</span>));</pre>  <p>  <p>This assumes that you use SceneManager.Player property. It's not really obligatory, but it's the simplest way to have player with an inventory. See engine tutorial for examples how to create player. Anyway, if you have any <a class=\"normal\" href=\"CastleItems.TInventory.html\">TInventory</a> instance, you can use <a class=\"normal\" href=\"CastleItems.TInventory.html#Pick\">TInventory.Pick</a> to add <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> this way.    ", "tags": "", "loc": "CastleItems.TItemResource.html#CreateItem"},
     {"title": "CastleItems.TItemResource.InstantiatePlaceholder", "text": "    ", "tags": "", "loc": "CastleItems.TItemResource.html#InstantiatePlaceholder"},
     {"title": "CastleItems.TItemResource.AlwaysPrepared", "text": "    ", "tags": "", "loc": "CastleItems.TItemResource.html#AlwaysPrepared"},
     {"title": "CastleItems.TItemResource.Caption", "text": " ", "tags": "", "loc": "CastleItems.TItemResource.html#Caption"},
     {"title": "CastleItems.TItemResource.BaseAnimation", "text": " ", "tags": "", "loc": "CastleItems.TItemResource.html#BaseAnimation"},
     {"title": "CastleItems.TItemResource.ImageURL", "text": " ", "tags": "", "loc": "CastleItems.TItemResource.html#ImageURL"},
     {"title": "CastleItems.TItemWeaponResource", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html"},
     {"title": "CastleItems.TItemWeaponResource.DefaultAttackTime", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#DefaultAttackTime"},
     {"title": "CastleItems.TItemWeaponResource.DefaultAttackDamageConst", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#DefaultAttackDamageConst"},
     {"title": "CastleItems.TItemWeaponResource.DefaultAttackDamageRandom", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#DefaultAttackDamageRandom"},
     {"title": "CastleItems.TItemWeaponResource.DefaultAttackKnockbackDistance", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#DefaultAttackKnockbackDistance"},
     {"title": "CastleItems.TItemWeaponResource.DefaultAttackShoot", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#DefaultAttackShoot"},
     {"title": "CastleItems.TItemWeaponResource.ItemClass", "text": "    ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#ItemClass"},
     {"title": "CastleItems.TItemWeaponResource.Create", "text": "    ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#Create"},
     {"title": "CastleItems.TItemWeaponResource.LoadFromFile", "text": "    ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#LoadFromFile"},
     {"title": "CastleItems.TItemWeaponResource.EquippingSound", "text": " Each weapon can have it's own equipping sound. ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#EquippingSound"},
     {"title": "CastleItems.TItemWeaponResource.AttackAnimation", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#AttackAnimation"},
     {"title": "CastleItems.TItemWeaponResource.ReadyAnimation", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#ReadyAnimation"},
     {"title": "CastleItems.TItemWeaponResource.AttackTime", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#AttackTime"},
     {"title": "CastleItems.TItemWeaponResource.AttackSoundStart", "text": " This is played when attack animation starts, and it means that we already checked that you have necessary ammunition (see <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html#AttackAmmo\">AttackAmmo</a>). None (<a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>) by default. ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#AttackSoundStart"},
     {"title": "CastleItems.TItemWeaponResource.AttackAmmo", "text": " Indicates item resource name to use as ammunition (like 'Quiver' or 'Bullets'). It may be empty, in which case the ammunition is not necessary to make an attack. If it's set, we will check whether owner of the weapon (like a player) has at least one item of this resource, and we'll decrease it when firing.  <p>For example, if this weapon is a pistol, then you can set <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html#AttackDamageConst\">AttackDamageConst</a> and <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html#AttackDamageRandom\">AttackDamageRandom</a> to non-zero and <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html#AttackShoot\">AttackShoot</a> to <code>True</code> to perform an immediatele shooting attack. And set <code>AttackAmmo</code> to something like 'Bullets'.  <p>For example, if this weapon is a bow, then you can set <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html#FireMissileName\">FireMissileName</a> to 'Arrow', to fire arrows as missiles (they will fly and can be avoided by fast moving enemies). And set <code>AttackAmmo</code> to something like 'Quiver'. ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#AttackAmmo"},
     {"title": "CastleItems.TItemWeaponResource.AttackDamageConst", "text": " This type of attack (along with <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html#AttackSoundHit\">AttackSoundHit</a>) is only done if one of these properties is non-zero. They must be &gt;= 0.  ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#AttackDamageConst"},
     {"title": "CastleItems.TItemWeaponResource.AttackDamageRandom", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#AttackDamageRandom"},
     {"title": "CastleItems.TItemWeaponResource.AttackKnockbackDistance", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#AttackKnockbackDistance"},
     {"title": "CastleItems.TItemWeaponResource.AttackShoot", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Shooting means that the hit enemy is determined by casting a ray from owner (like a shooting player) and seeing what it hits. Even enemies far away may be hit, but you have to aim precisely.</p></li>   <li><p>When this is <code>False</code>, we make a short-range (melee) attack. In this case the hit enemy is determined by looking at the weapon bounding volume near owner. Only the enemies very close to the owner get hit.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#AttackShoot"},
     {"title": "CastleItems.TItemWeaponResource.AttackSoundHit", "text": " ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#AttackSoundHit"},
     {"title": "CastleItems.TItemWeaponResource.FireMissileName", "text": " Must be set to something not empty to actually fire a missile. ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#FireMissileName"},
     {"title": "CastleItems.TItemWeaponResource.FireMissileSound", "text": " None (<a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>) by default. ", "tags": "", "loc": "CastleItems.TItemWeaponResource.html#FireMissileSound"},
     {"title": "CastleItems.TInventoryItem", "text": " Thanks to the <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#Quantity\">Quantity</a> property, this may actually represent many &quot;stacked&quot; items, all having the same properties. ", "tags": "", "loc": "CastleItems.TInventoryItem.html"},
     {"title": "CastleItems.TInventoryItem.Stack", "text": " The idea is that if player has 5 arrows, and picks an item representing another 5 arrows, then we sum then into one <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> instance representing 10 arrows.  <p>Various games, and various items, may require various approaches: for example, maybe you don't want some items to <code>stack</code> at all (e.g. you want to only allow stacking for items naturally appearing in vast quantities, like arrows and bolts and bullets (if you represent them as <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> at all)). Maybe you want to allow stacking only to centain number, e.g. arrows are summed into groups of maximum 20 items, anything above creates new <code>stack</code>? Overriding this procedure allows you to do all this.  <p>You can here increase the Quantity of current item, decrease the Quantity of parameter Item. In case the parameter Item no longer exists (it's Quantity reaches 0) you have to free it and set to <code>Nil</code> the Item parameter, in practice you usually want to call then <code>FreeAndNil(Item)</code>.  <p>The default implementation of this in <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> class allows stacking always, as long as the Resource matches. This means that, by default, every <a class=\"normal\" href=\"CastleItems.TItemResource.html\">TItemResource</a> is existing at most once in <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#Inventory\">TAliveWithInventory.Inventory</a>.    ", "tags": "", "loc": "CastleItems.TInventoryItem.html#Stack"},
     {"title": "CastleItems.TInventoryItem.Picked", "text": " The default implementation in this class adds the item to the Inventory by calling <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#PickItem\">TAliveWithInventory.PickItem</a>.  <p>You can override this to cause different behavior (for example, to consume some items right at pickup). Remember that this method must take care of memory management of this item.    ", "tags": "", "loc": "CastleItems.TInventoryItem.html#Picked"},
     {"title": "CastleItems.TInventoryItem.Use", "text": "  <p>In this class, this just prints a message &quot;this item cannot be used&quot;.  <p>Implementation of this method can assume for now that this is one of player's owned Items. Implementation of this method can change our properties, including Quantity. As a very special exception, implementation of this method is allowed to set Quantity of Item to 0.  <p>Never call this method when Player.Dead. Implementation of this method may assume that Player is not Dead.  <p>Caller of this method should always be prepared to immediately handle the &quot;Quantity = 0&quot; situation by freeing given item, removing it from any list etc.    ", "tags": "", "loc": "CastleItems.TInventoryItem.html#Use"},
     {"title": "CastleItems.TInventoryItem.Split", "text": " It returns newly created object with the same properties as this object, and with Quantity set to QuantitySplit. And it lowers our Quantity by QuantitySplit.  <p>Always QuantitySplit must be &gt;= 1 and &lt; Quantity.    ", "tags": "", "loc": "CastleItems.TInventoryItem.html#Split"},
     {"title": "CastleItems.TInventoryItem.PutOnWorld", "text": " Although normal item knows (through <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#Owner3D\">Owner3D</a>) the world it lives in, but this method may be used for items that don't have an owner yet, so we take AWorld parameter explicitly. This is how you should create new <a class=\"normal\" href=\"CastleItems.TItemOnWorld.html\">TItemOnWorld</a> instances. It is analogous to <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#CreateCreature\">TCreatureResource.CreateCreature</a>, but now for items.    ", "tags": "", "loc": "CastleItems.TInventoryItem.html#PutOnWorld"},
     {"title": "CastleItems.TInventoryItem.World", "text": "  <p>Although the <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a>, by itself, is not a 3D thing (only pickable <a class=\"normal\" href=\"CastleItems.TItemOnWorld.html\">TItemOnWorld</a> is a 3D thing). But it exists inside a 3D world: either as pickable (<a class=\"normal\" href=\"CastleItems.TItemOnWorld.html\">TItemOnWorld</a>), or as being owned by a 3D object (like player or creature) that are part of 3D world. In other words, our Owner3D.World is the 3D world this item lives in.    ", "tags": "", "loc": "CastleItems.TInventoryItem.html#World"},
     {"title": "CastleItems.TInventoryItem.Resource", "text": " ", "tags": "", "loc": "CastleItems.TInventoryItem.html#Resource"},
     {"title": "CastleItems.TInventoryItem.Quantity", "text": " This must always be &gt;= 1. ", "tags": "", "loc": "CastleItems.TInventoryItem.html#Quantity"},
     {"title": "CastleItems.TInventoryItem.Owner3D", "text": " May be <code>Nil</code> only in special situations (when item is moved from one 3D to another, and technically it's safer to <code>Nil</code> this property).  <p>The owner is always responsible for freeing this <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> instance (in case of <a class=\"normal\" href=\"CastleItems.TItemOnWorld.html\">TItemOnWorld</a>, it does it directly; in case of player or creature, it does it by <a class=\"normal\" href=\"CastleItems.TInventory.html\">TInventory</a>). ", "tags": "", "loc": "CastleItems.TInventoryItem.html#Owner3D"},
     {"title": "CastleItems.TItemWeapon", "text": " ", "tags": "", "loc": "CastleItems.TItemWeapon.html"},
     {"title": "CastleItems.TItemWeapon.Attack", "text": " Called during weapon <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html#AttackAnimation\">TItemWeaponResource.AttackAnimation</a>, at the time <a class=\"normal\" href=\"CastleItems.TItemWeaponResource.html#AttackTime\">TItemWeaponResource.AttackTime</a>. The default implementation in <code>TItemWeapon</code> does a short-range/shoot <code>attack</code> (if AttackDamageConst or AttackDamageRandom or AttackKnockbackDistance non-zero) and fires a missile (if FireMissileName not empty).    ", "tags": "", "loc": "CastleItems.TItemWeapon.html#Attack"},
     {"title": "CastleItems.TItemWeapon.Use", "text": "    ", "tags": "", "loc": "CastleItems.TItemWeapon.html#Use"},
     {"title": "CastleItems.TItemWeapon.Resource", "text": "    ", "tags": "", "loc": "CastleItems.TItemWeapon.html#Resource"},
     {"title": "CastleItems.TItemWeapon.Equip", "text": "    ", "tags": "", "loc": "CastleItems.TItemWeapon.html#Equip"},
     {"title": "CastleItems.TItemWeapon.EquippedAttack", "text": "    ", "tags": "", "loc": "CastleItems.TItemWeapon.html#EquippedAttack"},
     {"title": "CastleItems.TItemWeapon.EquippedUpdate", "text": "    ", "tags": "", "loc": "CastleItems.TItemWeapon.html#EquippedUpdate"},
     {"title": "CastleItems.TItemWeapon.EquippedScene", "text": "    ", "tags": "", "loc": "CastleItems.TItemWeapon.html#EquippedScene"},
     {"title": "CastleItems.TInventory", "text": " Do not directly change this list, always <a class=\"normal\" href=\"CastleItems.TInventory.html#Use\">use</a> the owner (<a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html\">TAliveWithInventory</a>) methods like <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#PickItem\">TAliveWithInventory.PickItem</a> or <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#DropItem\">TAliveWithInventory.DropItem</a>. They make sure that items are correctly stacked, and that <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#Owner3D\">TInventoryItem.Owner3D</a> and memory management is good. ", "tags": "", "loc": "CastleItems.TInventory.html"},
     {"title": "CastleItems.TInventory.Pick", "text": " See <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#PickItemUpdate\">TAliveWithInventory.PickItemUpdate</a> description, this method actually implements it.    ", "tags": "", "loc": "CastleItems.TInventory.html#Pick"},
     {"title": "CastleItems.TInventory.Drop", "text": " ItemIndex must be valid (between 0 and Items.Count - 1). You <i>must</i> take care yourself of returned <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> memory management. This is the low-level basis for <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#DropItem\">TAliveWithInventory.DropItem</a>.    ", "tags": "", "loc": "CastleItems.TInventory.html#Drop"},
     {"title": "CastleItems.TInventory.CheckDepleted", "text": " This frees the item (removing it from the list) if it's quantity reached zero.    ", "tags": "", "loc": "CastleItems.TInventory.html#CheckDepleted"},
     {"title": "CastleItems.TInventory.Use", "text": " This is the low-level basis for <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#UseItem\">TAliveWithInventory.UseItem</a>.    ", "tags": "", "loc": "CastleItems.TInventory.html#Use"},
     {"title": "CastleItems.TInventory.Create", "text": "    ", "tags": "", "loc": "CastleItems.TInventory.html#Create"},
     {"title": "CastleItems.TInventory.FindResource", "text": " Returns index of first found, or -1 if not found.    ", "tags": "", "loc": "CastleItems.TInventory.html#FindResource"},
     {"title": "CastleItems.TInventory.Owner3D", "text": " Never <code>Nil</code>, always valid for given inventory. All items on this list always have the same <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#Owner3D\">TInventoryItem.Owner3D</a> value as the inventory they are in. ", "tags": "", "loc": "CastleItems.TInventory.html#Owner3D"},
     {"title": "CastleItems.TItemOnWorld", "text": " It's not in anyone's inventory. ", "tags": "", "loc": "CastleItems.TItemOnWorld.html"},
     {"title": "CastleItems.TItemOnWorld.RenderDebug", "text": " ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#RenderDebug"},
     {"title": "CastleItems.TItemOnWorld.RotationSpeed", "text": " In radians per second, default is <a class=\"normal\" href=\"CastleItems.TItemOnWorld.html#DefaultRotationSpeed\">DefaultRotationSpeed</a>. Set to zero to disable rotation. ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#RotationSpeed"},
     {"title": "CastleItems.TItemOnWorld.AutoPick", "text": " Default is <code>True</code>. If you set this to <code>False</code>, you most probably want to implement some other way of picking up items, use the <a class=\"normal\" href=\"CastleItems.TItemOnWorld.html#ExtractItem\">ExtractItem</a> method.  <p>More precisely, this variable controls when <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#Picked\">TInventoryItem.Picked</a> is called. When <code>True</code>, it is called for player when player steps over an item (otherwise it's never called). You can always override <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#Picked\">TInventoryItem.Picked</a> for particular items to customize what happens at &quot;pick&quot; &mdash; the default implementation picks an item by adding it to inventory, but you could override it e.g. to consume some potions immediately on pickup. ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#AutoPick"},
     {"title": "CastleItems.TItemOnWorld.DefaultRotationSpeed", "text": " ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#DefaultRotationSpeed"},
     {"title": "CastleItems.TItemOnWorld.Create", "text": "    ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#Create"},
     {"title": "CastleItems.TItemOnWorld.Destroy", "text": "    ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#Destroy"},
     {"title": "CastleItems.TItemOnWorld.GetExists", "text": "    ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#GetExists"},
     {"title": "CastleItems.TItemOnWorld.Update", "text": "    ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#Update"},
     {"title": "CastleItems.TItemOnWorld.ExtractItem", "text": " This returns our <a class=\"normal\" href=\"CastleItems.TItemOnWorld.html#Item\">Item</a> property, and clears it (clearing also <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#Owner3D\">TInventoryItem.Owner3D</a>). At the next <a class=\"normal\" href=\"CastleItems.TItemOnWorld.html#Update\">Update</a>, this <a class=\"normal\" href=\"CastleItems.TItemOnWorld.html\">TItemOnWorld</a> instance will be freed and removed from 3D world.  <p>It's up to you what to do with resulting <a class=\"normal\" href=\"CastleItems.TInventoryItem.html\">TInventoryItem</a> instance. You can pick it up, by <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#PickItem\">TAliveWithInventory.PickItem</a> (for example player is an instance of <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html\">TAliveWithInventory</a>), or add it back to 3D world by <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#PutOnWorld\">TInventoryItem.PutOnWorld</a>, or at least free it (or you'll get a memory leak).    ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#ExtractItem"},
     {"title": "CastleItems.TItemOnWorld.Item", "text": " Never <code>Nil</code>. ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#Item"},
     {"title": "CastleItems.TItemOnWorld.Collides", "text": " ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#Collides"},
     {"title": "CastleItems.TItemOnWorld.CollidesWithMoving", "text": " ", "tags": "", "loc": "CastleItems.TItemOnWorld.html#CollidesWithMoving"},
     {"title": "CastleItems.TAliveWithInventory", "text": " ", "tags": "", "loc": "CastleItems.TAliveWithInventory.html"},
     {"title": "CastleItems.TAliveWithInventory.Create", "text": "    ", "tags": "", "loc": "CastleItems.TAliveWithInventory.html#Create"},
     {"title": "CastleItems.TAliveWithInventory.Destroy", "text": "    ", "tags": "", "loc": "CastleItems.TAliveWithInventory.html#Destroy"},
     {"title": "CastleItems.TAliveWithInventory.PickItemUpdate", "text": " Because an item may be stacked with others, the actual Item instance may be freed and replaced with other by this method, that is why Item parameter is &quot;var&quot;. Use <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#PickItem\">PickItem</a> method if you don't care about your Item instance.  <p>Returns index to the added item.  <p>Using this method means that the memory management of the item becomes the responsibility of this list.    ", "tags": "", "loc": "CastleItems.TAliveWithInventory.html#PickItemUpdate"},
     {"title": "CastleItems.TAliveWithInventory.PickItem", "text": " See <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#PickItemUpdate\">PickItemUpdate</a> for details.  <p>This is a shortcut to call <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#PickItemUpdate\">PickItemUpdate</a> and then ignore changes to Item instance. Calling this method may be comfortable, but remember that the Item instance possibly doesn't exist after we finish.    ", "tags": "", "loc": "CastleItems.TAliveWithInventory.html#PickItem"},
     {"title": "CastleItems.TAliveWithInventory.DropItem", "text": " It is Ok to pass here Index out of range, it will be ignored.    Droppped item, or <code>Nil</code> if the operation was not completed due to any reason (e.g. no space on 3D world to fit this item). ", "tags": "", "loc": "CastleItems.TAliveWithInventory.html#DropItem"},
     {"title": "CastleItems.TAliveWithInventory.UseItem", "text": " Calls <a class=\"normal\" href=\"CastleItems.TInventoryItem.html#Use\">TInventoryItem.Use</a>, and then checks whether the item was depleted (and eventually removes it from repository). It is Ok to pass here Index out of range, it will be ignored.    ", "tags": "", "loc": "CastleItems.TAliveWithInventory.html#UseItem"},
     {"title": "CastleItems.TAliveWithInventory.Inventory", "text": " Never change the contents of this list directly, always use <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html\">TAliveWithInventory</a> methods like <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#PickItem\">PickItem</a> or <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#DropItem\">DropItem</a> for this. ", "tags": "", "loc": "CastleItems.TAliveWithInventory.html#Inventory"},
     {"title": "CastleItems.TInventoryItemClass", "text": " ", "tags": "", "loc": "CastleItems.html#TInventoryItemClass"},
     {"title": "CastleItems.TItemOnWorldExistsEvent", "text": "    ", "tags": "", "loc": "CastleItems.html#TItemOnWorldExistsEvent"},
     {"title": "CastleItems.OnItemOnWorldExists", "text": " ", "tags": "", "loc": "CastleItems.html#OnItemOnWorldExists"},
     {"title": "CastleJoysticks", "text": " ", "tags": "", "loc": "CastleJoysticks.html"},
     {"title": "CastleJoysticks.TJoyInfo", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyInfo.html"},
     {"title": "CastleJoysticks.TJoyInfo.Name", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyInfo.html#Name"},
     {"title": "CastleJoysticks.TJoyInfo.Count", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyInfo.html#Count"},
     {"title": "CastleJoysticks.TJoyInfo.Caps", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyInfo.html#Caps"},
     {"title": "CastleJoysticks.TJoyState", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyState.html"},
     {"title": "CastleJoysticks.TJoyState.Axis", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyState.html#Axis"},
     {"title": "CastleJoysticks.TJoyState.BtnUp", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyState.html#BtnUp"},
     {"title": "CastleJoysticks.TJoyState.BtnDown", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyState.html#BtnDown"},
     {"title": "CastleJoysticks.TJoyState.BtnPress", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyState.html#BtnPress"},
     {"title": "CastleJoysticks.TJoyState.BtnCanPress", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoyState.html#BtnCanPress"},
     {"title": "CastleJoysticks.TJoy", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoy.html"},
     {"title": "CastleJoysticks.TJoy.Info", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoy.html#Info"},
     {"title": "CastleJoysticks.TJoy.State", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoy.html#State"},
     {"title": "CastleJoysticks.TJoysticks", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html"},
     {"title": "CastleJoysticks.TJoysticks.Create", "text": " If new device will be connected after Create it won't be automatically discovered. In such case <a class=\"normal\" href=\"CastleJoysticks.TJoysticks.html\">TJoysticks</a> have to be destroied and created again.    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#Create"},
     {"title": "CastleJoysticks.TJoysticks.Destroy", "text": "    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#Destroy"},
     {"title": "CastleJoysticks.TJoysticks.Poll", "text": "    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#Poll"},
     {"title": "CastleJoysticks.TJoysticks.GetInfo", "text": "    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#GetInfo"},
     {"title": "CastleJoysticks.TJoysticks.AxisPos", "text": "    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#AxisPos"},
     {"title": "CastleJoysticks.TJoysticks.Down", "text": "    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#Down"},
     {"title": "CastleJoysticks.TJoysticks.Up", "text": "    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#Up"},
     {"title": "CastleJoysticks.TJoysticks.Press", "text": "    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#Press"},
     {"title": "CastleJoysticks.TJoysticks.ClearState", "text": "    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#ClearState"},
     {"title": "CastleJoysticks.TJoysticks.GetJoy", "text": "    ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#GetJoy"},
     {"title": "CastleJoysticks.TJoysticks.OnAxisMove", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#OnAxisMove"},
     {"title": "CastleJoysticks.TJoysticks.OnButtonDown", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#OnButtonDown"},
     {"title": "CastleJoysticks.TJoysticks.OnButtonUp", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#OnButtonUp"},
     {"title": "CastleJoysticks.TJoysticks.OnButtonPress", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#OnButtonPress"},
     {"title": "CastleJoysticks.TJoysticks.JoyCount", "text": " ", "tags": "", "loc": "CastleJoysticks.TJoysticks.html#JoyCount"},
     {"title": "CastleJoysticks.JOY_HAS_Z", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_HAS_Z"},
     {"title": "CastleJoysticks.JOY_HAS_R", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_HAS_R"},
     {"title": "CastleJoysticks.JOY_HAS_U", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_HAS_U"},
     {"title": "CastleJoysticks.JOY_HAS_V", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_HAS_V"},
     {"title": "CastleJoysticks.JOY_HAS_POV", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_HAS_POV"},
     {"title": "CastleJoysticks.JOY_AXIS_X", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_AXIS_X"},
     {"title": "CastleJoysticks.JOY_AXIS_Y", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_AXIS_Y"},
     {"title": "CastleJoysticks.JOY_AXIS_Z", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_AXIS_Z"},
     {"title": "CastleJoysticks.JOY_AXIS_R", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_AXIS_R"},
     {"title": "CastleJoysticks.JOY_AXIS_U", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_AXIS_U"},
     {"title": "CastleJoysticks.JOY_AXIS_V", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_AXIS_V"},
     {"title": "CastleJoysticks.JOY_POVX", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_POVX"},
     {"title": "CastleJoysticks.JOY_POVY", "text": " ", "tags": "", "loc": "CastleJoysticks.html#JOY_POVY"},
     {"title": "CastleJoysticks.EnableJoysticks", "text": "    ", "tags": "", "loc": "CastleJoysticks.html#EnableJoysticks"},
     {"title": "CastleJoysticks.PJoyInfo", "text": " This is comfortable (the FontStyle font works, with 3 * 4 font variations, out of the box), but it increases your exe size &mdash; possibly without a reason, if you don't use FontStyle X3D node.  <p>Undefine this to conserve around 0.7 MB in exe size. All the Text X3D nodes will use standard sans non-bold, non-italic font. ", "tags": "", "loc": "CastleJoysticks.html#PJoyInfo"},
     {"title": "CastleJoysticks.PJoyState", "text": " ", "tags": "", "loc": "CastleJoysticks.html#PJoyState"},
     {"title": "CastleJoysticks.PJoy", "text": " ", "tags": "", "loc": "CastleJoysticks.html#PJoy"},
     {"title": "CastleJoysticks.TOnJoyAxisMove", "text": "    ", "tags": "", "loc": "CastleJoysticks.html#TOnJoyAxisMove"},
     {"title": "CastleJoysticks.TOnJoyButtonEvent", "text": " Used on button press/up/down.    ", "tags": "", "loc": "CastleJoysticks.html#TOnJoyButtonEvent"},
     {"title": "CastleJoysticks.Joysticks", "text": " To initialize <code>Joysticks</code> instance run <a class=\"normal\" href=\"CastleJoysticks.html#EnableJoysticks\">EnableJoysticks</a> procedure ", "tags": "", "loc": "CastleJoysticks.html#Joysticks"},
     {"title": "CastleKeysMouse", "text": " They are used throughout our engine, both by <a class=\"normal\" href=\"CastleControl.html\">CastleControl</a> (Lazarus component) and by non-Lazarus <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a>. ", "tags": "", "loc": "CastleKeysMouse.html"},
     {"title": "CastleKeysMouse.TKeysPressed", "text": " Allows you to query is key (<a class=\"normal\" href=\"CastleKeysMouse.html#TKey\">TKey</a>) pressed, and is some character (Char type) pressed. ", "tags": "", "loc": "CastleKeysMouse.TKeysPressed.html"},
     {"title": "CastleKeysMouse.TKeysPressed.Keys", "text": "  <p>This array is read-only from outside of this class! Always Keys[<a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a>] = false. ", "tags": "", "loc": "CastleKeysMouse.TKeysPressed.html#Keys"},
     {"title": "CastleKeysMouse.TKeysPressed.Characters", "text": "  <p>This array is read-only from outside of this class! Always Characters[#0] = false.  <p>Note that since a given character may be generated by various key combinations, this doesn't work as reliably as <a class=\"normal\" href=\"CastleKeysMouse.TKeysPressed.html#Keys\">Keys</a> array. For example, consider pressing a, then shift, then releasing a &mdash; for a short time character 'A', and not 'a', should be pressed.  <p>Although we do our best (have some mapping tables to track characters), and in practice this works Ok. But still checking for keys on <a class=\"normal\" href=\"CastleKeysMouse.TKeysPressed.html#Keys\">Keys</a> array, when possible, is advised. ", "tags": "", "loc": "CastleKeysMouse.TKeysPressed.html#Characters"},
     {"title": "CastleKeysMouse.TKeysPressed.Modifiers", "text": " The result it based on current Keys[<a class=\"normal\" href=\"CastleKeysMouse.html#K_Ctrl\">K_Ctrl</a>], Keys[<a class=\"normal\" href=\"CastleKeysMouse.html#K_Shift\">K_Shift</a>] etc. values.    ", "tags": "", "loc": "CastleKeysMouse.TKeysPressed.html#Modifiers"},
     {"title": "CastleKeysMouse.TKeysPressed.KeyDown", "text": " Pass <a class=\"normal\" href=\"CastleKeysMouse.html#TKey\">TKey</a>, and corresponding character (Char).  <p>Pass Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> if this is not representable as <a class=\"normal\" href=\"CastleKeysMouse.html#TKey\">TKey</a>, pass CharKey = #0 if this is not representable as char. But never pass both Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> and CharKey = #0 (this would have no meaning).    ", "tags": "", "loc": "CastleKeysMouse.TKeysPressed.html#KeyDown"},
     {"title": "CastleKeysMouse.TKeysPressed.KeyUp", "text": " Never pass Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> here.  <p>It returns which character was released as a consequence of this key release.    ", "tags": "", "loc": "CastleKeysMouse.TKeysPressed.html#KeyUp"},
     {"title": "CastleKeysMouse.TKeysPressed.Clear", "text": " That is, this sets all <a class=\"normal\" href=\"CastleKeysMouse.TKeysPressed.html#Keys\">Keys</a> and <a class=\"normal\" href=\"CastleKeysMouse.TKeysPressed.html#Characters\">Characters</a> items to <code>False</code>. Also resets internal arrays used to track <a class=\"normal\" href=\"CastleKeysMouse.TKeysPressed.html#Characters\">Characters</a> from <a class=\"normal\" href=\"CastleKeysMouse.TKeysPressed.html#KeyDown\">KeyDown</a> and <a class=\"normal\" href=\"CastleKeysMouse.TKeysPressed.html#KeyUp\">KeyUp</a>.    ", "tags": "", "loc": "CastleKeysMouse.TKeysPressed.html#Clear"},
     {"title": "CastleKeysMouse.TKeysPressed.Items", "text": "  <p>Returns the same values as are in the <a class=\"normal\" href=\"CastleKeysMouse.TKeysPressed.html#Keys\">Keys</a> table. Although this is more comfortable: it's a default property of this class, so you can write simply <code>KeysPressed[<a class=\"normal\" href=\"CastleKeysMouse.html#K_X\">K_X</a>]</code> instead of <code>KeysPressed.Keys[<a class=\"normal\" href=\"CastleKeysMouse.html#K_X\">K_X</a>]</code>. ", "tags": "", "loc": "CastleKeysMouse.TKeysPressed.html#Items"},
     {"title": "CastleKeysMouse.TInputPressRelease", "text": " Either key press/release or mouse button press/release or mouse wheel action. This is nicely matching with <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> processing in <a class=\"normal\" href=\"CastleInputs.html\">CastleInputs</a>, so it allows to easily store and check for user actions. ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html"},
     {"title": "CastleKeysMouse.TInputPressRelease.EventType", "text": " ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#EventType"},
     {"title": "CastleKeysMouse.TInputPressRelease.Key", "text": " Either Key &lt;&gt; <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> or <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#KeyCharacter\">KeyCharacter</a> &lt;&gt; #0 in this case. When <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#EventType\">EventType</a> &lt;&gt; <a class=\"normal\" href=\"CastleKeysMouse.html#itKey\">itKey</a>, then Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> and <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#KeyCharacter\">KeyCharacter</a> = #0.  <p>Both Key and <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#KeyCharacter\">KeyCharacter</a> represent the same action. Sometimes one, sometimes the other is useful.  <p><b>Not all key presses can be represented as <a class=\"normal\" href=\"CastleKeysMouse.html#TKey\">TKey</a> value.</b> For example, pressing '(' (opening parenthesis), which is done on most keyboards by pressing shift + zero, does not have any <a class=\"normal\" href=\"CastleKeysMouse.html#TKey\">TKey</a> value. So it will generate event with Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a>, but <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#KeyCharacter\">KeyCharacter</a> = '('.  <p><b>Likewise, not all key presses can be represented as char value.</b> For example &quot;up arrow&quot; (Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_Up\">K_Up</a>) doesn't have a char code (it will have <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#KeyCharacter\">KeyCharacter</a> = #0).  <p><a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#KeyCharacter\">KeyCharacter</a> is influenced by some other keys state, like Shift or Ctrl or CapsLock or some key to input localized characters (all dependent on your system settings, we don't deal with it in our engine, we merely take what system gives us). For example, you can get &quot;a&quot; or &quot;A&quot; depending of Shift and CapsLock state, or <a class=\"normal\" href=\"CastleStringUtils.html#CtrlA\">CtrlA</a> if you hold Ctrl.  <p>When the user holds the key pressed, we will get consecutive key down events. Under some OSes, you will also get consecutive key up events, but it's not guaranteed (on some OSes, you may simply get only consecutive key down). So the more precise definition when key down occurs is: it's a notification that the key is (still) pressed down.  ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#Key"},
     {"title": "CastleKeysMouse.TInputPressRelease.KeyCharacter", "text": " ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#KeyCharacter"},
     {"title": "CastleKeysMouse.TInputPressRelease.MouseButton", "text": " Always <a class=\"normal\" href=\"CastleKeysMouse.html#mbLeft\">mbLeft</a> for touch device press/release events.  <p><a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> notes (but relevant also to other interfaces, like Lazarus component, although in that case it's beyond our control): When user presses the mouse over our control, mouse is automatically captured, so all further OnMotion following mouse release will be passed to this control (even if user moves mouse outside of this control), until user releases all mouse buttons. Note that this means that mouse positions may be outside of [0..Width - 1, 0..Height - 1] range. ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#MouseButton"},
     {"title": "CastleKeysMouse.TInputPressRelease.FingerIndex", "text": " Always 0 for normal mouse events. ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#FingerIndex"},
     {"title": "CastleKeysMouse.TInputPressRelease.Position", "text": "  <p>For normal backends that simply support a single mouse device, this is just equivalent to TCastleWindow.MousePosition and TCastleControl.MousePosition, so it's not really interesting.  <p>For multi-touch devices, this is very useful, as it describes the position of the current finger (corresponding to <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#FingerIndex\">FingerIndex</a>).  <p>For other <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#EventType\">EventType</a> values (not <a class=\"normal\" href=\"CastleKeysMouse.html#itMouseButton\">itMouseButton</a>), this is the position of main mouse/finger. See TCastleWindow.MousePosition documentation for what it means, in particular what happens on touch devices. ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#Position"},
     {"title": "CastleKeysMouse.TInputPressRelease.MouseWheelScroll", "text": " <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#MouseWheel\">MouseWheel</a> is <a class=\"normal\" href=\"CastleKeysMouse.html#mwNone\">mwNone</a> if and only if <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#EventType\">EventType</a> &lt;&gt; <a class=\"normal\" href=\"CastleKeysMouse.html#itMouseWheel\">itMouseWheel</a>.  <p>Positive value of Scroll means user scrolled up or left, negative means user scrolled down or right. It is never zero (as long as <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html#EventType\">EventType</a> = <a class=\"normal\" href=\"CastleKeysMouse.html#itMouseWheel\">itMouseWheel</a> of course).  <p>Scroll units are such that 1.0 should be treated like a &quot;one operation&quot;, like a one click. On most normal mouses only an integer scroll will be possible to make. On the other hand, on touchpads it's common to be able to scroll by flexible amounts.  <p><a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> backends notes: GTK and Xlib cannot generate Scroll values different than 1 or -1.  <p> ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#MouseWheelScroll"},
     {"title": "CastleKeysMouse.TInputPressRelease.MouseWheelVertical", "text": " ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#MouseWheelVertical"},
     {"title": "CastleKeysMouse.TInputPressRelease.MouseWheel", "text": "    ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#MouseWheel"},
     {"title": "CastleKeysMouse.TInputPressRelease.IsKey", "text": " Always false for AKey = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> or AKeyCharacter = #0.     ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#IsKey"},
     {"title": "CastleKeysMouse.TInputPressRelease.IsKey", "text": "    ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#IsKey"},
     {"title": "CastleKeysMouse.TInputPressRelease.IsMouseButton", "text": "    ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#IsMouseButton"},
     {"title": "CastleKeysMouse.TInputPressRelease.IsMouseWheel", "text": "    ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#IsMouseWheel"},
     {"title": "CastleKeysMouse.TInputPressRelease.ToString", "text": "    ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#ToString"},
     {"title": "CastleKeysMouse.TInputPressRelease.Description", "text": "    ", "tags": "", "loc": "CastleKeysMouse.TInputPressRelease.html#Description"},
     {"title": "CastleKeysMouse.TInputMotion", "text": " ", "tags": "", "loc": "CastleKeysMouse.TInputMotion.html"},
     {"title": "CastleKeysMouse.TInputMotion.OldPosition", "text": " ", "tags": "", "loc": "CastleKeysMouse.TInputMotion.html#OldPosition"},
     {"title": "CastleKeysMouse.TInputMotion.Position", "text": " ", "tags": "", "loc": "CastleKeysMouse.TInputMotion.html#Position"},
     {"title": "CastleKeysMouse.TInputMotion.Pressed", "text": " ", "tags": "", "loc": "CastleKeysMouse.TInputMotion.html#Pressed"},
     {"title": "CastleKeysMouse.TInputMotion.FingerIndex", "text": " ", "tags": "", "loc": "CastleKeysMouse.TInputMotion.html#FingerIndex"},
     {"title": "CastleKeysMouse.TCastleConfigKeysMouseHelper", "text": " ", "tags": "", "loc": "CastleKeysMouse.TCastleConfigKeysMouseHelper.html"},
     {"title": "CastleKeysMouse.TCastleConfigKeysMouseHelper.GetKey", "text": " Key names are expected to follow <a class=\"normal\" href=\"CastleKeysMouse.html#StrToKey\">StrToKey</a> and <a class=\"normal\" href=\"CastleKeysMouse.html#KeyToStr\">KeyToStr</a> functions in <a class=\"normal\" href=\"CastleKeysMouse.html\">CastleKeysMouse</a>.  <p>    ", "tags": "", "loc": "CastleKeysMouse.TCastleConfigKeysMouseHelper.html#GetKey"},
     {"title": "CastleKeysMouse.TCastleConfigKeysMouseHelper.SetKey", "text": "    ", "tags": "", "loc": "CastleKeysMouse.TCastleConfigKeysMouseHelper.html#SetKey"},
     {"title": "CastleKeysMouse.TCastleConfigKeysMouseHelper.SetDeleteKey", "text": "    ", "tags": "", "loc": "CastleKeysMouse.TCastleConfigKeysMouseHelper.html#SetDeleteKey"},
     {"title": "CastleKeysMouse.MouseButtonStr", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#MouseButtonStr"},
     {"title": "CastleKeysMouse.ModifierKeyToKey", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#ModifierKeyToKey"},
     {"title": "CastleKeysMouse.MouseWheelDirectionStr", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#MouseWheelDirectionStr"},
     {"title": "CastleKeysMouse.KeyToStr", "text": "    ", "tags": "", "loc": "CastleKeysMouse.html#KeyToStr"},
     {"title": "CastleKeysMouse.ModifiersDown", "text": "  <p>Version with <a class=\"normal\" href=\"CastleKeysMouse.TKeysPressed.html\">TKeysPressed</a> parameter returns [] (empty set) when argument is <code>Nil</code>. This may be useful sometimes.  <p>    ", "tags": "", "loc": "CastleKeysMouse.html#ModifiersDown"},
     {"title": "CastleKeysMouse.ModifiersDown", "text": "    ", "tags": "", "loc": "CastleKeysMouse.html#ModifiersDown"},
     {"title": "CastleKeysMouse.ModifierKeysToNiceStr", "text": "    ", "tags": "", "loc": "CastleKeysMouse.html#ModifierKeysToNiceStr"},
     {"title": "CastleKeysMouse.CharToNiceStr", "text": " When Modifiers is not empty, these are the additional modifiers required to be pressed (although some C values, like <a class=\"normal\" href=\"CastleStringUtils.html#CtrlA\">CtrlA</a> ... <a class=\"normal\" href=\"CastleStringUtils.html#CtrlZ\">CtrlZ</a>, may already indicate some modifier).  <p>For normal readable characters just returns them, for special characters returns short string like &quot;Ctrl+C&quot; or &quot;Escape&quot;.  <p>The returned string doesn't contain any quotes around, doesn't contain any word merely stating &quot;character&quot; (for example argument 'c' just generates 'c', not 'character &quot;c&quot;').  <p>BackSpaceTabEnterString determines behavior on three special values: #8, #9, #13. These may be either described as Backspace/Tab/Enter (if BackSpaceTabEnterString = true) or as Ctrl+H, Ctrl+I, Ctrl+M (if BackSpaceTabEnterString = false).    ", "tags": "", "loc": "CastleKeysMouse.html#CharToNiceStr"},
     {"title": "CastleKeysMouse.MouseWheelDirection", "text": " Assumes that Scroll &lt;&gt; 0, like TCastleWindowCustom.OnMouseWheel guarantees.    ", "tags": "", "loc": "CastleKeysMouse.html#MouseWheelDirection"},
     {"title": "CastleKeysMouse.StrToKey", "text": " If string does not contain any recognized key name, return DefaultKey.    ", "tags": "", "loc": "CastleKeysMouse.html#StrToKey"},
     {"title": "CastleKeysMouse.InputKey", "text": "     ", "tags": "", "loc": "CastleKeysMouse.html#InputKey"},
     {"title": "CastleKeysMouse.InputMouseButton", "text": "    ", "tags": "", "loc": "CastleKeysMouse.html#InputMouseButton"},
     {"title": "CastleKeysMouse.InputMouseWheel", "text": "    ", "tags": "", "loc": "CastleKeysMouse.html#InputMouseWheel"},
     {"title": "CastleKeysMouse.InputMotion", "text": "    ", "tags": "", "loc": "CastleKeysMouse.html#InputMotion"},
     {"title": "CastleKeysMouse.TKey", "text": " Do not ever use values K_Reserved_Xxx (they are declared here only to avoid using assignments, which would prevent FPC from allowing <code>TKey</code> to index arrays).  <p>Some properties of K_Xxx constants that are guaranteed:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> means &quot;no key&quot;. It's guaranteed that it's always equal to zero.</p></li>   <li><p>Letters (constants <a class=\"normal\" href=\"CastleKeysMouse.html#K_A\">K_A</a> .. <a class=\"normal\" href=\"CastleKeysMouse.html#K_Z\">K_Z</a>) are guaranteed to be always equal to <code>TKey</code>('A') .. <code>TKey</code>('Z') and digits (constants <a class=\"normal\" href=\"CastleKeysMouse.html#K_0\">K_0</a> .. <a class=\"normal\" href=\"CastleKeysMouse.html#K_9\">K_9</a>) are guaranteed to be always equal to <code>TKey</code>('0') .. <code>TKey</code>('9'). That is, their ordinal values are equal to their ASCII codes, and they are always ordered.  <p>Also <a class=\"normal\" href=\"CastleKeysMouse.html#K_F1\">K_F1</a> .. <a class=\"normal\" href=\"CastleKeysMouse.html#K_F12\">K_F12</a> (function keys) are guaranteed to be always nicely ordered (i.e. <a class=\"normal\" href=\"CastleKeysMouse.html#K_F2\">K_F2</a> = <a class=\"normal\" href=\"CastleKeysMouse.html#K_F1\">K_F1</a> + 1, <a class=\"normal\" href=\"CastleKeysMouse.html#K_F3\">K_F3</a> = <a class=\"normal\" href=\"CastleKeysMouse.html#K_F2\">K_F2</a> + 1 and so on).  <p>Also <a class=\"normal\" href=\"CastleKeysMouse.html#K_Escape\">K_Escape</a>, <a class=\"normal\" href=\"CastleKeysMouse.html#K_BackSpace\">K_BackSpace</a>, <a class=\"normal\" href=\"CastleKeysMouse.html#K_Tab\">K_Tab</a>, <a class=\"normal\" href=\"CastleKeysMouse.html#K_Enter\">K_Enter</a> are guaranteed to be always equal to <a class=\"normal\" href=\"CastleStringUtils.html#CharEscape\">CharEscape</a>, <a class=\"normal\" href=\"CastleStringUtils.html#CharBackSpace\">CharBackSpace</a>, <a class=\"normal\" href=\"CastleStringUtils.html#CharTab\">CharTab</a>, <a class=\"normal\" href=\"CastleStringUtils.html#CharEnter\">CharEnter</a> (well, typecasted to <code>TKey</code> type).</p></li> </ul>  <p>  K_None    K_PrintScreen    K_CapsLock    K_ScrollLock    K_NumLock    K_Pause    K_Apostrophe    K_Semicolon    K_BackSpace = Ord(<a class=\"normal\" href=\"CastleStringUtils.html#CharBackSpace\">CharBackSpace</a>) = 8   K_Tab = Ord(<a class=\"normal\" href=\"CastleStringUtils.html#CharTab\">CharTab</a>) = 9   K_Slash    K_BackQuote    K_Minus    K_Enter = Ord(<a class=\"normal\" href=\"CastleStringUtils.html#CharEnter\">CharEnter</a>) = 13   K_Equal    K_BackSlash    K_Shift    K_Ctrl    K_Alt    K_Plus    K_Reserved_20    K_Reserved_21    K_Reserved_22    K_Reserved_23    K_Reserved_24    K_Reserved_25    K_Reserved_26    K_Escape = Ord(<a class=\"normal\" href=\"CastleStringUtils.html#CharEscape\">CharEscape</a>) = 27   K_Reserved_28    K_Reserved_29    K_Reserved_30    K_Reserved_31    K_Space = Ord(' ') = 32   K_PageUp    K_PageDown    K_End    K_Home    K_Left    K_Up    K_Right    K_Down    K_Reserved_41    K_Reserved_42    K_Reserved_43    K_Reserved_44    K_Insert    K_Delete    K_Reserved_47    K_0 = Ord('0') = 48   K_1 = Ord('1')   K_2 = Ord('2')   K_3 = Ord('3')   K_4 = Ord('4')   K_5 = Ord('5')   K_6 = Ord('6')   K_7 = Ord('7')   K_8 = Ord('8')   K_9 = Ord('9') = 57   K_Reserved_58    K_Reserved_59    K_Reserved_60    K_Reserved_61    K_Reserved_62    K_Reserved_63    K_Reserved_64    K_A = Ord('A') = 65   K_B = Ord('B')   K_C = Ord('C')   K_D = Ord('D')   K_E = Ord('E')   K_F = Ord('F')   K_G = Ord('G')   K_H = Ord('H')   K_I = Ord('I')   K_J = Ord('J')   K_K = Ord('K')   K_L = Ord('L')   K_M = Ord('M')   K_N = Ord('N')   K_O = Ord('O')   K_P = Ord('P')   K_Q = Ord('Q')   K_R = Ord('R')   K_S = Ord('S')   K_T = Ord('T')   K_U = Ord('U')   K_V = Ord('V')   K_W = Ord('W')   K_X = Ord('X')   K_Y = Ord('Y')   K_Z = Ord('Z') = 90   K_LeftBracket    K_Reserved_92    K_RightBracket    K_Reserved_94    K_Reserved_95    K_Reserved_96    K_Reserved_97    K_Reserved_98    K_Reserved_99    K_Reserved_100    K_Reserved_101    K_Reserved_102    K_Reserved_103    K_Reserved_104    K_Reserved_105    K_Reserved_106    K_Numpad_Plus    K_Reserved_108    K_Numpad_Minus    K_Reserved_110    K_Reserved_111    K_F1    K_F2    K_F3    K_F4    K_F5    K_F6    K_F7    K_F8    K_F9    K_F10    K_F11    K_F12    K_Reserved_124    K_Reserved_125    K_Reserved_126    K_Reserved_127    K_Reserved_128    K_Reserved_129    K_Reserved_130    K_Reserved_131    K_Reserved_132    K_Reserved_133    K_Reserved_134    K_Reserved_135    K_Reserved_136    K_Reserved_137    K_Reserved_138    K_Reserved_139    K_Numpad_0    K_Numpad_1    K_Numpad_2    K_Numpad_3    K_Numpad_4    K_Numpad_5    K_Numpad_6    K_Numpad_7    K_Numpad_8    K_Numpad_9    K_Numpad_End    K_Numpad_Down    K_Numpad_PageDown    K_Numpad_Left    K_Numpad_Begin    K_Numpad_Right    K_Numpad_Home    K_Numpad_Up    K_Numpad_PageUp    K_Numpad_Insert    K_Numpad_Delete    K_Numpad_Enter    K_Numpad_Multiply    K_Numpad_Divide    K_Reserved_164    K_Reserved_165    K_Reserved_166    K_Reserved_167    K_Reserved_168    K_Reserved_169    K_Reserved_170    K_Reserved_171    K_Reserved_172    K_Reserved_173    K_Reserved_174    K_Reserved_175    K_Reserved_176    K_Reserved_177    K_Reserved_178    K_Reserved_179    K_Reserved_180    K_Reserved_181    K_Reserved_182    K_Reserved_183    K_Reserved_184    K_Reserved_185    K_Reserved_186    K_Reserved_187    K_Comma    K_Reserved_189    K_Period    K_Reserved_191   ", "tags": "", "loc": "CastleKeysMouse.html#TKey"},
     {"title": "CastleKeysMouse.TKeysBooleans", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#TKeysBooleans"},
     {"title": "CastleKeysMouse.PKeysBooleans", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#PKeysBooleans"},
     {"title": "CastleKeysMouse.TKeysBytes", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#TKeysBytes"},
     {"title": "CastleKeysMouse.PKeysBytes", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#PKeysBytes"},
     {"title": "CastleKeysMouse.TCharactersBooleans", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#TCharactersBooleans"},
     {"title": "CastleKeysMouse.PCharactersBooleans", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#PCharactersBooleans"},
     {"title": "CastleKeysMouse.TMouseButton", "text": "  mbLeft    mbMiddle    mbRight    mbExtra1    mbExtra2   ", "tags": "", "loc": "CastleKeysMouse.html#TMouseButton"},
     {"title": "CastleKeysMouse.TMouseButtons", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#TMouseButtons"},
     {"title": "CastleKeysMouse.TMouseCursor", "text": " Used for various properties: TUIControl.Cursor, T3D.Cursor, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Cursor\">TCastleWindowCustom.Cursor</a>.  <p><a class=\"normal\" href=\"CastleKeysMouse.html#mcDefault\">mcDefault</a>, <a class=\"normal\" href=\"CastleKeysMouse.html#mcNone\">mcNone</a>, <a class=\"normal\" href=\"CastleKeysMouse.html#mcForceNone\">mcForceNone</a>, <a class=\"normal\" href=\"CastleKeysMouse.html#mcCustom\">mcCustom</a> have somewhat special meanings. The rest are some cursor images will well-defined meanings for the user, their exact look may depend on current window manager theme etc.  mcDefault Leave cursor as default, decided by a window manager.   mcNone Make cursor invisible.   mcForceNone Forcefully make cursor invisible.   <p>If *any* UI control under the cursor says that the cursor is <code>mcForceNone</code>, it will be invisible. This is in contrast to <a class=\"normal\" href=\"CastleKeysMouse.html#mcNone\">mcNone</a>, that only hides the cursor if the currently focused control (under the mouse cursor) sets it.  mcCustom Use a custom cursor image in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#CustomCursor\">TCastleWindowCustom.CustomCursor</a>.   <p>In normal circumstances, this should not be used for TUIControl.Cursor, T3D.Cursor and others, as they have no way to set <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#CustomCursor\">TCastleWindowCustom.CustomCursor</a>.  mcStandard Standard arrow, indicates, well, that user can point / click something.   mcWait Indicates the program is busy and user should wait.   mcText Text cursor, indicates that there's text under the cursor, which usually means that it can be selected, or that user can click to set focus to the text area.   mcHand Indicates something active is under cursor, usually for links.  ", "tags": "", "loc": "CastleKeysMouse.html#TMouseCursor"},
     {"title": "CastleKeysMouse.TModifierKey", "text": " Of course, this is actually just a convention. The actual interpretation is left up to the final program &ndash; there you have to decide when and how modifiers affect the meaning of other keys.  mkCtrl    mkShift    mkAlt   ", "tags": "", "loc": "CastleKeysMouse.html#TModifierKey"},
     {"title": "CastleKeysMouse.TModifierKeys", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#TModifierKeys"},
     {"title": "CastleKeysMouse.TMouseWheelDirection", "text": "  mwNone    mwUp    mwDown    mwLeft    mwRight   ", "tags": "", "loc": "CastleKeysMouse.html#TMouseWheelDirection"},
     {"title": "CastleKeysMouse.TInputPressReleaseType", "text": "  itKey    itMouseButton    itMouseWheel   ", "tags": "", "loc": "CastleKeysMouse.html#TInputPressReleaseType"},
     {"title": "CastleKeysMouse.TFingerIndex", "text": " ", "tags": "", "loc": "CastleKeysMouse.html#TFingerIndex"},
     {"title": "CastleLCLRecentFiles", "text": " See <a class=\"normal\" href=\"CastleRecentFiles.TRecentFiles.html\">TRecentFiles</a> class. ", "tags": "", "loc": "CastleLCLRecentFiles.html"},
     {"title": "CastleLCLRecentFiles.TCastleRecentFiles", "text": " ", "tags": "", "loc": "CastleLCLRecentFiles.TCastleRecentFiles.html"},
     {"title": "CastleLCLRecentFiles.TCastleRecentFiles.MenuCreate", "text": "    ", "tags": "", "loc": "CastleLCLRecentFiles.TCastleRecentFiles.html#MenuCreate"},
     {"title": "CastleLCLRecentFiles.TCastleRecentFiles.MenuDestroy", "text": " Internal (do not call this directly, it's only called by parent class). Note that it doesn't read <a class=\"normal\" href=\"CastleRecentFiles.TRecentFiles.html#URLs\">URLs</a> list at all, it only depends on FirstSeparator value.    ", "tags": "", "loc": "CastleLCLRecentFiles.TCastleRecentFiles.html#MenuDestroy"},
     {"title": "CastleLCLRecentFiles.TCastleRecentFiles.NextMenuItem", "text": "  <p>If this is not <code>Nil</code> then each update to the recent files list (for example by <a class=\"normal\" href=\"CastleRecentFiles.TRecentFiles.html#Add\">Add</a> method) will result in the menu items right before <code>NextMenuItem</code> to be updated.  <p>Also changing the value of this property will result in one-time update of the menu. Menu at the place of old <code>NextMenuItem</code> will be removed and menu at the place of new <code>NextMenuItem</code> will get created.  <p>Usually <code>NextMenuItem</code> should be the separator that divides the print and properties menu sections and the close menu sections. That's consistent with other GNOME programs, and this is what we usually try to follow. ", "tags": "", "loc": "CastleLCLRecentFiles.TCastleRecentFiles.html#NextMenuItem"},
     {"title": "CastleLCLRecentFiles.Register", "text": "    ", "tags": "", "loc": "CastleLCLRecentFiles.html#Register"},
     {"title": "CastleLCLUtils", "text": " ", "tags": "", "loc": "CastleLCLUtils.html"},
     {"title": "CastleLCLUtils.CursorCastleToLCL", "text": " ", "tags": "", "loc": "CastleLCLUtils.html#CursorCastleToLCL"},
     {"title": "CastleLCLUtils.FileFiltersToDialog", "text": " Suitable for both open and save dialogs (TOpenDialog, TSaveDialog both descend from TFileDialog).  <p>Input filters are either given as a string FileFilters (encoded just like for <a class=\"normal\" href=\"CastleFileFilters.TFileFilterList.html#AddFiltersFromString\">TFileFilterList.AddFiltersFromString</a>), or as <a class=\"normal\" href=\"CastleFileFilters.TFileFilterList.html\">TFileFilterList</a> instance.  <p>Output filters are either written to LCLFilter, LCLFilterIndex variables, or set appropriate properties of given Dialog instance.  <p>When AllFields is false, then filters starting with &quot;All &quot; in the name, like &quot;All files&quot;, &quot;All images&quot;, are not included in the output.  <p>    ", "tags": "", "loc": "CastleLCLUtils.html#FileFiltersToDialog"},
     {"title": "CastleLCLUtils.FileFiltersToDialog", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#FileFiltersToDialog"},
     {"title": "CastleLCLUtils.FileFiltersToDialog", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#FileFiltersToDialog"},
     {"title": "CastleLCLUtils.FileFiltersToDialog", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#FileFiltersToDialog"},
     {"title": "CastleLCLUtils.SQuoteLCLCaption", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#SQuoteLCLCaption"},
     {"title": "CastleLCLUtils.FileFiltersToOpenDialog", "text": "      ", "tags": "", "loc": "CastleLCLUtils.html#FileFiltersToOpenDialog"},
     {"title": "CastleLCLUtils.FileFiltersToOpenDialog", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#FileFiltersToOpenDialog"},
     {"title": "CastleLCLUtils.FileFiltersToOpenDialog", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#FileFiltersToOpenDialog"},
     {"title": "CastleLCLUtils.KeyLCLToCastle", "text": "  <p>In addition, this tries to convert Key to a character (MyCharKey). It's awful that this function has to do conversion to Char, but that's the way of VCL and LCL: KeyPress and KeyDown are separate events. While I want to have them in one event, and passed as one event to TUIControl.KeyDown.    ", "tags": "", "loc": "CastleLCLUtils.html#KeyLCLToCastle"},
     {"title": "CastleLCLUtils.KeyCastleToLCL", "text": " Sets LazKey to VK_UNKNOWN (zero) when conversion not possible (or when Key is <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> and CharKey = #0).  <p>Note that this is not a perfect reverse of <a class=\"normal\" href=\"CastleLCLUtils.html#KeyLCLToCastle\">KeyLCLToCastle</a> function. It can't, as there are ambiguities (e.g. character 'A' may be a key <a class=\"normal\" href=\"CastleKeysMouse.html#K_A\">K_A</a> with <a class=\"normal\" href=\"CastleKeysMouse.html#mkShift\">mkShift</a> in modifiers).  <p>    ", "tags": "", "loc": "CastleLCLUtils.html#KeyCastleToLCL"},
     {"title": "CastleLCLUtils.KeyCastleToLCL", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#KeyCastleToLCL"},
     {"title": "CastleLCLUtils.MouseButtonLCLToCastle", "text": "  <p>(By coincidence, my type name and values are the same as used by LCL; but beware &mdash; the order of values in my type is different (<a class=\"normal\" href=\"CastleKeysMouse.html#mbMiddle\">mbMiddle</a> is in the middle in my type)).    ", "tags": "", "loc": "CastleLCLUtils.html#MouseButtonLCLToCastle"},
     {"title": "CastleLCLUtils.FilenameToURISafeUTF8", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#FilenameToURISafeUTF8"},
     {"title": "CastleLCLUtils.URIToFilenameSafeUTF8", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#URIToFilenameSafeUTF8"},
     {"title": "CastleLCLUtils.ColorToVector3", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#ColorToVector3"},
     {"title": "CastleLCLUtils.ColorToVector3Byte", "text": "    ", "tags": "", "loc": "CastleLCLUtils.html#ColorToVector3Byte"},
     {"title": "CastleLevels", "text": " ", "tags": "", "loc": "CastleLevels.html"},
     {"title": "CastleLevels.TLevelInfo", "text": " ", "tags": "", "loc": "CastleLevels.TLevelInfo.html"},
     {"title": "CastleLevels.TLevelInfo.Element", "text": " ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#Element"},
     {"title": "CastleLevels.TLevelInfo.Create", "text": "    ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#Create"},
     {"title": "CastleLevels.TLevelInfo.Destroy", "text": "    ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#Destroy"},
     {"title": "CastleLevels.TLevelInfo.LogicClass", "text": " This is indicated by the &quot;type&quot; attribute in level.xml file. By default level logic uses a base <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> class, which corresponds to using <code>type=&quot;Level&quot;</code> in level.xml file.  <p>Changing this allows to use a different ObjectPascal class to implement the level behavior. You can create your own <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> descendants and register them like  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">type</span>   TMyLevelLogic = <span class=\"pascal_keyword\">class</span>(TLevelLogic)     <span class=\"pascal_comment\">{ ... override whatever you want ... }</span>   <span class=\"pascal_keyword\">end</span>;  <span class=\"pascal_numeric\"></span>... LevelLogicClasses[<span class=\"pascal_string\">'MyLevel'</span>] := TMyLevelLogic;</pre>  <p>  <p>And then you can use <code>type=&quot;MyLevel&quot;</code> inside level.xml to use your class. Many advanced tricks are possible by implementing your own <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> descendant. See Castle1 GameLevelSpecific.pas unit for some examples. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#LogicClass"},
     {"title": "CastleLevels.TLevelInfo.Name", "text": " This name may be useful in scripts, as <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a> parameter and such.  <p>For all (current and future) uses it should be a valid VRML/X3D and ObjectPascal identifier, so use only (English) letters, underscores and digits (and don't start with a digit). ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#Name"},
     {"title": "CastleLevels.TLevelInfo.SceneURL", "text": " When the level is loaded, this scene will be set as <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a>, so it determines the default viewpoint, background and such.  <p>Usually it also contains the most (if not all) of the visible level geometry, scripts and such. Although level logic (<a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> descendant determined by LevelClass) may also add any number of additional objects (<a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> instances) to the world. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#SceneURL"},
     {"title": "CastleLevels.TLevelInfo.SceneFileName", "text": " ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#SceneFileName"},
     {"title": "CastleLevels.TLevelInfo.Title", "text": " This should be user-friendly, so it can use spaces, non-English letters and such.  <p>The core engine (like this <a class=\"normal\" href=\"CastleLevels.html\">CastleLevels</a> unit) doesn't use this title much, it's only for progress bars and log messages.  <p>It is up to the final game code to use this title in more interesting ways. For example to show a choice of starting level to the user. The core engine doesn't make such &quot;New Game&quot; menus automatically (because various games may have widly different ideas how to make it and how to show it). But we give the developer tools to make such menus easily, for example you can use <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html\">TCastleOnScreenMenu</a> for this. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#Title"},
     {"title": "CastleLevels.TLevelInfo.TitleHint", "text": "  <p>The engine doesn't use this property at all, it's only loaded from level.xml file. It is available for your &quot;New Game&quot; (or similar screen) implementation (see <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#Title\">Title</a> for more comments about this). ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#TitleHint"},
     {"title": "CastleLevels.TLevelInfo.Number", "text": "  <p>The engine doesn't use this property at all, it's only loaded from level.xml file. It is available for your &quot;New Game&quot; (or similar screen) implementation (see <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#Title\">Title</a> for more comments about this).  <p>For example level number may be used to order levels in the menu. This <i>does not</i> determine the order in which levels are played, as levels do not have to be played in a linear order. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#Number"},
     {"title": "CastleLevels.TLevelInfo.Demo", "text": "  <p>The engine doesn't use this property at all, it's only loaded from level.xml file. It is available for your &quot;New Game&quot; (or similar screen) implementation (see <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#Title\">Title</a> for more comments about this). ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#Demo"},
     {"title": "CastleLevels.TLevelInfo.Played", "text": "  <p>This is automatically managed. Basically, we set it to <code>True</code> when the level is played, and we save it to user preferences.  <p>Details: </p>  <ul class=\"paragraph_spacing\">   <li><p>It is set to <code>True</code> when loading level.</p></li>   <li><p>It is saved to disk (user preferences file) when game exits, and loaded when game starts. As long as you call <code>Config.Load</code>, <code>Config.Save</code> from <a class=\"normal\" href=\"CastleConfig.html\">CastleConfig</a> unit. To load, you must also call explicitly <a class=\"normal\" href=\"CastleLevels.TLevelInfoList.html#LoadFromConfig\">Levels.LoadFromConfig</a> now.</p></li>   <li><p>The default value comes from <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#DefaultPlayed\">DefaultPlayed</a> property, which in turn is loaded from level.xml file, and by default is <code>False</code>. To allows you to artificially mark some levels as &quot;Played&quot; on the first game run, which may be helpful if you use this property e.g. to filter the levels in &quot;New Game&quot; menu.</p></li> </ul>  <p>  <p>The engine doesn't look at this property for anything, whether the level is played or not has no influence over how we work. It is just available for your game, for example to use in your &quot;New Game&quot; (or similar screen) implementation (see <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#Title\">Title</a> for more comments about this). ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#Played"},
     {"title": "CastleLevels.TLevelInfo.DefaultPlayed", "text": " This determines the initial value of <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#Played\">Played</a> property (if nothing was stored in user preferences about this level, see <a class=\"normal\" href=\"CastleLevels.TLevelInfoList.html#LoadFromConfig\">TLevelInfoList.LoadFromConfig</a>; or if <a class=\"normal\" href=\"CastleLevels.TLevelInfoList.html#LoadFromConfig\">TLevelInfoList.LoadFromConfig</a> is not called by the game).  <p>How is this information useful, depends on a particular game. For example, some games may decide to show in the &quot;New Game&quot; menu levels only with Played=true. Some games may simply ignore it. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#DefaultPlayed"},
     {"title": "CastleLevels.TLevelInfo.LoadingImage", "text": " This is loaded from URL indicated by attribute loading_image in level.xml. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#LoadingImage"},
     {"title": "CastleLevels.TLevelInfo.LoadingBarYPosition", "text": " Between 0 and 1, default value 0.5 means &quot;middle of the screen&quot;. Should be synchronized with how <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#LoadingImage\">LoadingImage</a> looks (if you set it), to make the progress when loading level look nice.  <p>Technically, this is used for <a class=\"normal\" href=\"CastleProgress.TProgressUserInterface.html#BarYPosition\">TProgressUserInterface.BarYPosition</a>. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#LoadingBarYPosition"},
     {"title": "CastleLevels.TLevelInfo.PlaceholderName", "text": " See <a class=\"normal\" href=\"CastleShapes.html#TPlaceholderName\">TPlaceholderName</a>, and see <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a> for a description when we use placeholders. Default value is <code><a class=\"normal\" href=\"CastleShapes.html#PlaceholderNames\">PlaceholderNames</a>['x3dshape']</code>. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#PlaceholderName"},
     {"title": "CastleLevels.TLevelInfo.PlaceholderReferenceDirection", "text": " Some placeholders (currently, only creatures) may be used to determine initial direction of the resource. For example, the direction the creature is initially facing. This direction is calculated as the transformation of given placeholder applied to this 3D vector.  <p>The correct value may depend on the exporter you used to create 3D models, and on the exporter settings (how and if it rotates the model when exporting, and is this rotation recorded in placeholder transformation or applied directly to mesh coordinates). It may also depend on personal preference, as it determines how you set resources in your 3D modelling tool (like Blender).  <p>Fortunately, the default value (+X vector) is suitable for at least 2 common situations:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>If your exporter rotates the world to turn +Z up into +Y up. (This is the case of default Blender X3D exporter with default settings.)</p></li>   <li value=\"2\"><p>If your exporter doesn't rotate the world. (You can configure Blender exporter to behave like this. You may also then configure engine to use +Z as up vector for everything, see &quot;Which way is up?&quot; on [<a  href=\"http://castle-engine.sourceforge.net/tutorial_up.php\">http://castle-engine.sourceforge.net/tutorial_up.php</a>].)</p></li> </ol>  <p>  <p>In Blender it's useful to enable the &quot;Display -&gt; Wire&quot; option for placeholder objects, then Blender will show arrows inside the placeholder. +X of the arrow determines the default direction understood by our engine. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#PlaceholderReferenceDirection"},
     {"title": "CastleLevels.TLevelInfo.MusicSound", "text": " None (<a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>) by default. ", "tags": "", "loc": "CastleLevels.TLevelInfo.html#MusicSound"},
     {"title": "CastleLevels.TLevelInfoList", "text": " ", "tags": "", "loc": "CastleLevels.TLevelInfoList.html"},
     {"title": "CastleLevels.TLevelInfoList.FindName", "text": "    ", "tags": "", "loc": "CastleLevels.TLevelInfoList.html#FindName"},
     {"title": "CastleLevels.TLevelInfoList.LoadFromFiles", "text": " Overloaded version without parameter just looks inside <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a>. For the specification of level.xml format see [<a  href=\"http://castle-engine.sourceforge.net/creating_data_levels.php\">http://castle-engine.sourceforge.net/creating_data_levels.php</a>] .  <p>This should be called after resources (creatures and items) are known, as they may be referenced by level.xml files. So call <a class=\"normal\" href=\"CastleResources.T3DResourceList.html#LoadFromFiles\">Resources.LoadFromFiles</a> <i>before</i> calling this (if you want to use any creatures / items at all, of course).  <p>All <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#Played\">TLevelInfo.Played</a> values are initially set to <code>False</code>. You must call <a class=\"normal\" href=\"CastleLevels.TLevelInfoList.html#LoadFromConfig\">LoadFromConfig</a> <i>after</i> calling this to read <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#Played\">TLevelInfo.Played</a> values from user preferences file.  <p>Note that on Android, searching the Android asset filesystem recursively is not possible (this is a fault of Android NDK API...). So instead of this method, you should use <a class=\"normal\" href=\"CastleLevels.TLevelInfoList.html#AddFromFile\">AddFromFile</a> repeatedly to explicitly list all level.xml locations.  <p>    ", "tags": "", "loc": "CastleLevels.TLevelInfoList.html#LoadFromFiles"},
     {"title": "CastleLevels.TLevelInfoList.LoadFromFiles", "text": "    ", "tags": "", "loc": "CastleLevels.TLevelInfoList.html#LoadFromFiles"},
     {"title": "CastleLevels.TLevelInfoList.AddFromFile", "text": " The given XML file must have &lt;level&gt; root element and be written according to <a  href=\"http://castle-engine.sourceforge.net/creating_data_levels.php\">http://castle-engine.sourceforge.net/creating_data_levels.php</a> .    ", "tags": "", "loc": "CastleLevels.TLevelInfoList.html#AddFromFile"},
     {"title": "CastleLevels.TLevelInfoList.SortByNumber", "text": " Done automatically at the end of <a class=\"normal\" href=\"CastleLevels.TLevelInfoList.html#LoadFromFiles\">LoadFromFiles</a>, you may want to call it explicitly after doing <a class=\"normal\" href=\"CastleLevels.TLevelInfoList.html#AddFromFile\">AddFromFile</a>.    ", "tags": "", "loc": "CastleLevels.TLevelInfoList.html#SortByNumber"},
     {"title": "CastleLevels.TLevelInfoList.LoadFromConfig", "text": "  <p>This is useful only if you actually look at <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#Played\">TLevelInfo.Played</a> for any purpose (for example, to decide which levels are displayed in the menu). By default, our engine doesn't look at <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html#Played\">TLevelInfo.Played</a> for anything.    ", "tags": "", "loc": "CastleLevels.TLevelInfoList.html#LoadFromConfig"},
     {"title": "CastleLevels.TLevelInfoList.SaveToConfig", "text": "    ", "tags": "", "loc": "CastleLevels.TLevelInfoList.html#SaveToConfig"},
     {"title": "CastleLevels.TGameSceneManager", "text": " It really adds only one new method to <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>: <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">LoadLevel</a>, see it's documentation to know what it gives you. It also exposes <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#Logic\">Logic</a> and <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#Info\">Info</a> properties corresponding to the currently loaded level. ", "tags": "", "loc": "CastleLevels.TGameSceneManager.html"},
     {"title": "CastleLevels.TGameSceneManager.Destroy", "text": "    ", "tags": "", "loc": "CastleLevels.TGameSceneManager.html#Destroy"},
     {"title": "CastleLevels.TGameSceneManager.LoadLevel", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><b>Set scene manager 3D items</b>:  <p>Clear all 3D items from <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a> list (except <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Player\">TCastleSceneManager.Player</a>), clear <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">Camera</a> and <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a> as well. Then load a new main scene and camera, adding to <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a> all 3D resources (creatures and items) defined by placeholders named CasRes* in the main level 3D file.</p></li>   <li><p><b>Make sure 3D resources are ready:</b>  <p>Resources are <a class=\"normal\" href=\"CastleResources.T3DResource.html\">T3DResource</a> instances on <a class=\"normal\" href=\"CastleResources.html#Resources\">Resources</a> list. They are heavy (in terms of memory use and preparation time), so you don't want to just load everything for every level. This method makes sure that all resources required by this level are prepared. All resources requested in level.xml file (in &lt;resources&gt; element in level.xml), as well as resources requested in player.xml file, as well as resources with AlwaysPrepared (usually: all possible items that can be dropped from player inventory on any level) will be prepared.</p></li>   <li><p><b>Initialize move limits and water volume from placeholders</b>. Special object names CasMoveLimit and CasWater (in the future: CasWater* with any suffix) in the main scene 3D model determine the places where player can go and where water is.  <p>When CasMoveLimit object is missing, we calculate it to include the level bounding box, with some additional space above (to allow flying).</p></li>   <li><p><b>Initialize sectors and waypoints from placeholders</b>. Special shape names CasSector* and CasWaypoint* can be used in level 3D model to help creature AI. You can add and name such shapes in 3D modeler, like Blender, and they will be automatically understood by the engine when loading level.  <p>Objects named CasSector&lt;index&gt;[_&lt;ignored&gt;] define sectors. The geometry of a sector with given &lt;index&gt; is set to be the sum of all CasSector&lt;index&gt;* boxes. Sectors are numbered from 0.  <p>Objects named CasWaypoint[&lt;ignored&gt;] define waypoints. Each waypoint is stored as a 3D point, this point is the middle of the bounding box of the object named CasWaypoint[&lt;ignored&gt;].  <p>After extracting from level 3D model, sectors and waypoints are then connected together by <a class=\"normal\" href=\"CastleSectors.TSectorList.html#LinkToWaypoints\">TSectorList.LinkToWaypoints</a>. The idea is that you can go from one sector to the other through the waypoint that is placed on the border of both of them.</p></li>   <li><p><b>Prepare everything possible for rendering and collision detection</b> to avoid later preparing things on-demand (which would cause unpleasant delay during gameplay). E.g. prepares octree and OpenGL resources.</p></li> </ul>  <p>  <p>The overloaded version with a LevelName string searches the <a class=\"normal\" href=\"CastleLevels.html#Levels\">Levels</a> list for a level with given name (and raises exception if it cannot be found). It makes sense if you filled the <a class=\"normal\" href=\"CastleLevels.html#Levels\">Levels</a> list before, usually by <a class=\"normal\" href=\"CastleLevels.TLevelInfoList.html#LoadFromFiles\">Levels.LoadFromFiles</a> call. So you can easily define a level in your data with <code>name=&quot;xxx&quot;</code> in the <code>level.xml</code> file, and then you can load it by <code><a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">LoadLevel</a>('xxx')</code> call.  <p>It's important to note that <b>you do not have to use this method to make a 3D game</b>. You may as well just load the 3D scene yourself, and add things to <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a> and <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a> directly. This method is just a very comfortable way to set your 3D world in one call &mdash; but it's not the only way.  <p>    ", "tags": "", "loc": "CastleLevels.TGameSceneManager.html#LoadLevel"},
     {"title": "CastleLevels.TGameSceneManager.LoadLevel", "text": "    ", "tags": "", "loc": "CastleLevels.TGameSceneManager.html#LoadLevel"},
     {"title": "CastleLevels.TGameSceneManager.UnloadLevel", "text": "  <p>You do not have to call this in normal circumstances, as each <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">LoadLevel</a> automatically clears previous 3D world. If fact, you should not call this in normal circumstances: calling this prevents the next <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">LoadLevel</a> to reuse resources that were needed by both old and new level.  <p>Call this only if you really want to conserve memory <i>right now</i>. Or when you want to force reload of resources at next <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">LoadLevel</a> call (for example, if you changed <a class=\"normal\" href=\"X3DLoad.html#BakedAnimationSmoothness\">BakedAnimationSmoothness</a>, it is useful &mdash; otherwise the old animations will remain loaded with old <a class=\"normal\" href=\"X3DLoad.html#BakedAnimationSmoothness\">BakedAnimationSmoothness</a> setting).    ", "tags": "", "loc": "CastleLevels.TGameSceneManager.html#UnloadLevel"},
     {"title": "CastleLevels.TGameSceneManager.Logic", "text": " ", "tags": "", "loc": "CastleLevels.TGameSceneManager.html#Logic"},
     {"title": "CastleLevels.TGameSceneManager.Info", "text": " ", "tags": "", "loc": "CastleLevels.TGameSceneManager.html#Info"},
     {"title": "CastleLevels.TLevelLogic", "text": " We use <a class=\"normal\" href=\"Castle3D.html#T3D\">T3D</a> descendant, since this is the comfortable way to add any behavior to the 3D world (it doesn't matter that &quot;level logic&quot; is not a usual 3D object &mdash; it doesn't have to collide or be visible). ", "tags": "", "loc": "CastleLevels.TLevelLogic.html"},
     {"title": "CastleLevels.TLevelLogic.LoadLevelScene", "text": " </p>  <ul class=\"paragraph_spacing\">   <li><p>optionally create triangle octree</p></li>   <li><p>call <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PrepareResources\">PrepareResources</a>, with <a class=\"normal\" href=\"CastleScene.html#prRender\">prRender</a>, <a class=\"normal\" href=\"CastleScene.html#prBoundingBox\">prBoundingBox</a>, <a class=\"normal\" href=\"CastleScene.html#prShadowVolume\">prShadowVolume</a> (if shadow volumes possible at all in this OpenGL context),</p></li>   <li><p>Free texture data, since they will not be needed anymore</p></li> </ul>  <p>     ", "tags": "", "loc": "CastleLevels.TLevelLogic.html#LoadLevelScene"},
     {"title": "CastleLevels.TLevelLogic.LoadLevelScene", "text": "    ", "tags": "", "loc": "CastleLevels.TLevelLogic.html#LoadLevelScene"},
     {"title": "CastleLevels.TLevelLogic.Placeholder", "text": " Return <code>True</code> if this is indeed a recognized <code>placeholder</code> name, and it was handled and relevant shape should be removed from level geometry (to not be rendered).    ", "tags": "", "loc": "CastleLevels.TLevelLogic.html#Placeholder"},
     {"title": "CastleLevels.TLevelLogic.PlaceholdersEnd", "text": " Override it to do anything you want.    ", "tags": "", "loc": "CastleLevels.TLevelLogic.html#PlaceholdersEnd"},
     {"title": "CastleLevels.TLevelLogic.Create", "text": " Called before resources (creatures and items) are initialized (override <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html#PlaceholdersEnd\">PlaceholdersEnd</a> if you need to do something after creatures and items are added). You can modify MainScene contents here.  <p>  <p>  AWorld <p>3D world items. We provide AWorld instance at construction, and the created <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> instance will be added to this AWorld, and you cannot change it later. This is necessary, as <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> descendants at construction may actually modify your world, and depend on it later. DOMElement <p>An XML tree of level.xml file. You can read it however you want, to handle additional attributes in level.xml. You can use standard FPC DOM unit and classes, and add a handful of simple comfortable routines in <a class=\"normal\" href=\"CastleXMLUtils.html\">CastleXMLUtils</a> unit, for example you can use this to read a string attribute:  <p></p>  <pre class=\"longcode\"> MyAttribute := DOMElement.AttributeStringDef(<span class=\"pascal_string\">'my_attribute'</span>, <span class=\"pascal_string\">'default value'</span>); MyRequiredAttribute := DOMElement.AttributeString(<span class=\"pascal_string\">'my_required_attribute'</span>);</pre>  <p>  AWorld <p>3D world items. We provide AWorld instance at construction, and the created <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> instance will be added to this AWorld, and you cannot change it later. This is necessary, as <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> descendants at construction may actually modify your world, and depend on it later. DOMElement <p>An XML tree of level.xml file. You can read it however you want, to handle additional attributes in level.xml. You can use standard FPC DOM unit and classes, and add a handful of simple comfortable routines in <a class=\"normal\" href=\"CastleXMLUtils.html\">CastleXMLUtils</a> unit, for example you can use this to read a string attribute:  <p></p>  <pre class=\"longcode\"> MyAttribute := DOMElement.AttributeStringDef(<span class=\"pascal_string\">'my_attribute'</span>, <span class=\"pascal_string\">'default value'</span>); MyRequiredAttribute := DOMElement.AttributeString(<span class=\"pascal_string\">'my_required_attribute'</span>);</pre>  <p>", "tags": "", "loc": "CastleLevels.TLevelLogic.html#Create"},
     {"title": "CastleLevels.TLevelLogic.LocalBoundingBox", "text": "    ", "tags": "", "loc": "CastleLevels.TLevelLogic.html#LocalBoundingBox"},
     {"title": "CastleLevels.TLevelLogic.PrepareNewPlayer", "text": " This may be used to equip the player with some basic weapon / items.  <p>This is never called or used by the engine itself. This does nothing in the default <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> class implementation.  <p>Your particular game, where you can best decide when the player &quot;starts a new game&quot; and when the player merely &quot;continues the previous game&quot;, may call it. And you may override this in your <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html\">TLevelLogic</a> descendants to equip the player.    ", "tags": "", "loc": "CastleLevels.TLevelLogic.html#PrepareNewPlayer"},
     {"title": "CastleLevels.TLevelLogic.Update", "text": "    ", "tags": "", "loc": "CastleLevels.TLevelLogic.html#Update"},
     {"title": "CastleLevels.TLevelLogic.Time", "text": " Time 0 when level is created. This is updated in our <a class=\"normal\" href=\"CastleLevels.TLevelLogic.html#Update\">Update</a>. ", "tags": "", "loc": "CastleLevels.TLevelLogic.html#Time"},
     {"title": "CastleLevels.TLevelLogicClasses", "text": " ", "tags": "", "loc": "CastleLevels.TLevelLogicClasses.html"},
     {"title": "CastleLevels.TLevelLogicClasses.Items", "text": " Setting this is allowed regardless if the key previously existed or not, in other words: setting this does AddOrSetValue, contrary to the ancestor TDictionary that only allows setting when the key already exists. ", "tags": "", "loc": "CastleLevels.TLevelLogicClasses.html#Items"},
     {"title": "CastleLevels.LevelLogicClasses", "text": "    ", "tags": "", "loc": "CastleLevels.html#LevelLogicClasses"},
     {"title": "CastleLevels.Levels", "text": " You can use this to show a list of available levels to user. You can also search it and use <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a> to load a given <a class=\"normal\" href=\"CastleLevels.TLevelInfo.html\">TLevelInfo</a> instance.    ", "tags": "", "loc": "CastleLevels.html#Levels"},
     {"title": "CastleLevels.TLevelLogicClass", "text": " ", "tags": "", "loc": "CastleLevels.html#TLevelLogicClass"},
     {"title": "CastleLevels.TCastleSceneClass", "text": " ", "tags": "", "loc": "CastleLevels.html#TCastleSceneClass"},
     {"title": "CastleLog", "text": " Log has to be activated in your program (nothing in the Castle Game Engine activates it automatically) by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a>. Various units of the engine print some logging info when <a class=\"normal\" href=\"CastleLog.html#Log\">Log</a> is true. ", "tags": "", "loc": "CastleLog.html"},
     {"title": "CastleLog.Log", "text": " Initially no. Activate by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a>.    ", "tags": "", "loc": "CastleLog.html#Log"},
     {"title": "CastleLog.InitializeLog", "text": " The default log output is documented on <a  href=\"https://castle-engine.sourceforge.io/manual_log.php\">https://castle-engine.sourceforge.io/manual_log.php</a> .  <p>  <p>  ALogStream Where to generate the log.  <p>If you leave ALogStream as <code>Nil</code> (default), the default log output is determined as follows:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>On Unix and on console Windows applications, the output goes to the standard output, StdOut. This is most useful and common behavior on Unix, where most programs log to StdOut, and StdOut is always available.  <p>This approach avoids any questions from users asking &quot;where can I find the log file?&quot;. And it avoids technical questions like &quot;should we create a new log file with new number when old log file exists, or just overwrite old file, or append to it?&quot; or &quot;which directory is user-writeable&quot;. Since the user must explicitly redirect the output to the file, (s)he knows where the log file is.  <p>Note that on Android, we also automatically log to Android-specific log facility (that you can browse using &quot;adb logcat&quot;.) </p></li>   <li><p>On Windows GUI applications, we create a file xxx.log in the current directory. Where xxx is from <code>ApplicatioName</code>.  <p>GUI programs (with apptype GUI) do not have StdOut available under Windows (at least not always). </p></li> </ul>  <p> ALogTimePrefix optionally adds date&amp;time prefix to each log record.  ALogStream Where to generate the log.  <p>If you leave ALogStream as <code>Nil</code> (default), the default log output is determined as follows:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>On Unix and on console Windows applications, the output goes to the standard output, StdOut. This is most useful and common behavior on Unix, where most programs log to StdOut, and StdOut is always available.  <p>This approach avoids any questions from users asking &quot;where can I find the log file?&quot;. And it avoids technical questions like &quot;should we create a new log file with new number when old log file exists, or just overwrite old file, or append to it?&quot; or &quot;which directory is user-writeable&quot;. Since the user must explicitly redirect the output to the file, (s)he knows where the log file is.  <p>Note that on Android, we also automatically log to Android-specific log facility (that you can browse using &quot;adb logcat&quot;.) </p></li>   <li><p>On Windows GUI applications, we create a file xxx.log in the current directory. Where xxx is from <code>ApplicatioName</code>.  <p>GUI programs (with apptype GUI) do not have StdOut available under Windows (at least not always). </p></li> </ul>  <p> ALogTimePrefix optionally adds date&amp;time prefix to each log record.", "tags": "", "loc": "CastleLog.html#InitializeLog"},
     {"title": "CastleLog.InitializeLog", "text": "    ", "tags": "", "loc": "CastleLog.html#InitializeLog"},
     {"title": "CastleLog.WritelnLog", "text": " Ignored when log is not initialized (<a class=\"normal\" href=\"CastleLog.html#Log\">Log</a> is <code>False</code>).  <p>Although we check <a class=\"normal\" href=\"CastleLog.html#Log\">Log</a> here, you can also check it yourself before even calling this procedure. This way you can avoid spending time on constructing Message.  <p>When no Category, we use ApplicationName as a category.    ", "tags": "", "loc": "CastleLog.html#WritelnLog"},
     {"title": "CastleLog.WritelnLog", "text": "    ", "tags": "", "loc": "CastleLog.html#WritelnLog"},
     {"title": "CastleLog.WritelnLog", "text": " Ignored when log is not initialized (<a class=\"normal\" href=\"CastleLog.html#Log\">Log</a> is <code>False</code>). This is a shortcut for <code><a class=\"normal\" href=\"CastleLog.html#WritelnLog\">WritelnLog</a>(Category, Format(MessageBase, Args))</code>.    ", "tags": "", "loc": "CastleLog.html#WritelnLog"},
     {"title": "CastleLog.WritelnLog", "text": "    ", "tags": "", "loc": "CastleLog.html#WritelnLog"},
     {"title": "CastleLog.WriteLog", "text": "    ", "tags": "", "loc": "CastleLog.html#WriteLog"},
     {"title": "CastleLog.WritelnLogMultiline", "text": " The Message may, but doesn't have to, terminate with newline &ndash; we will format it OK either way.    ", "tags": "", "loc": "CastleLog.html#WritelnLogMultiline"},
     {"title": "CastleLog.WriteLogMultiline", "text": "    ", "tags": "", "loc": "CastleLog.html#WriteLogMultiline"},
     {"title": "CastleLog.WritelnWarning", "text": "  <p>This outputs a log message, if the log is initialized by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a>. We simply append the word &quot;warning&quot; to the Category, and pass arguments to <a class=\"normal\" href=\"CastleLog.html#WritelnLog\">WritelnLog</a>.  <p>Then, <i>regardless if the log is initialized or not</i>, we also call <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#OnWarning\">ApplicationProperties.OnWarning</a>. This allows to react to warnings e.g. by displaying a message dialog (like <code>ShowMessage</code> in Lazarus, or <a class=\"normal\" href=\"CastleMessages.html#MessageOK\">MessageOK</a> in <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a>, or <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MessageOK\">TCastleWindowCustom.MessageOK</a>). Or by raising an exception, if you want to be strict about warnings.    ", "tags": "", "loc": "CastleLog.html#WritelnWarning"},
     {"title": "CastleLog.WritelnWarning", "text": "    ", "tags": "", "loc": "CastleLog.html#WritelnWarning"},
     {"title": "CastleLog.WritelnWarning", "text": "    ", "tags": "", "loc": "CastleLog.html#WritelnWarning"},
     {"title": "CastleLog.WritelnWarning", "text": "    ", "tags": "", "loc": "CastleLog.html#WritelnWarning"},
     {"title": "CastleLog.TLogTimePrefix", "text": "  ltNone Default: no DateTime prefix is added.   ltTime Add time prefix to each log record.   ltDateTime Add date&amp;time prefix to each log record.  ", "tags": "", "loc": "CastleLog.html#TLogTimePrefix"},
     {"title": "CastleLog.BacktraceOnLog", "text": " Displaying line info requires compiling your program with -gl. ", "tags": "", "loc": "CastleLog.html#BacktraceOnLog"},
     {"title": "CastleLog.LogTimePrefix", "text": " Can be changed runtime. ", "tags": "", "loc": "CastleLog.html#LogTimePrefix"},
     {"title": "CastleMaterialProperties", "text": " ", "tags": "", "loc": "CastleMaterialProperties.html"},
     {"title": "CastleMaterialProperties.TMaterialProperty", "text": " ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperty.html"},
     {"title": "CastleMaterialProperties.TMaterialProperty.TextureBaseName", "text": " For now, this is the only way to associate property, but more are possible in the future (like MaterialNodeName). ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperty.html#TextureBaseName"},
     {"title": "CastleMaterialProperties.TMaterialProperty.FootstepsSound", "text": " <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a> is no information is available. ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperty.html#FootstepsSound"},
     {"title": "CastleMaterialProperties.TMaterialProperty.Toxic", "text": " Taken into account only if you assign <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Player\">TCastleSceneManager.Player</a>.  ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperty.html#Toxic"},
     {"title": "CastleMaterialProperties.TMaterialProperty.ToxicDamageConst", "text": " ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperty.html#ToxicDamageConst"},
     {"title": "CastleMaterialProperties.TMaterialProperty.ToxicDamageRandom", "text": " ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperty.html#ToxicDamageRandom"},
     {"title": "CastleMaterialProperties.TMaterialProperty.ToxicDamageTime", "text": " ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperty.html#ToxicDamageTime"},
     {"title": "CastleMaterialProperties.TMaterialProperty.NormalMap", "text": " This is a simple method to activate bump mapping, equivalent to using <code>normalMap</code> field in an Appearance node of VRML/X3D, see <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_bump_mapping\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_bump_mapping</a> .  <p>In case both VRML/X3D Appearance specifies <code>normalMap</code> and we have <code>NormalMap</code> defined here, the VRML/X3D Appearance is used. ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperty.html#NormalMap"},
     {"title": "CastleMaterialProperties.TMaterialProperty.AlphaChannel", "text": " The meaning and allowed values for this are the same as for <code>alphaChannel</code> field for texture nodes, see <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_alpha_channel_detection\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_alpha_channel_detection</a> . Empty value (default) doesn't change the alpha channel type (set in VRML/X3D or auto-detected). ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperty.html#AlphaChannel"},
     {"title": "CastleMaterialProperties.TMaterialProperties", "text": " Documentation and example of such file is on <a  href=\"http://castle-engine.sourceforge.net/creating_data_material_properties.php\">http://castle-engine.sourceforge.net/creating_data_material_properties.php</a> . Right now this allows to define things like:  <p></p>  <ul class=\"compact_spacing\">   <li><p>footsteps,</p></li>   <li><p>toxic ground (hurts player),</p></li>   <li><p>bump mapping (normal maps and height maps for given texture),</p></li>   <li><p>texture GPU-compressed and downscaled alternatives.</p></li> </ul>  <p>  <p>In the future, it should be possible to express all these properties in pure VRML/X3D (inside Appearance / Material / ImageTexture nodes). Right now, you can do this with bump mapping, see <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_bump_mapping\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_bump_mapping</a> , but not footsteps or toxic ground. In the future it should also be possible to express these properties in 3D authoring software (like Blender), and easily export them to appropriate VRML/X3D nodes. For now, this <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperty.html\">TMaterialProperty</a> allows us to easily customize materials in a way that is not possible in Blender.  <p>Using an external file for material properties has also long-term advantages: it can be shared across many 3D models, for example you can define footsteps sound for all grounds using the <code>grass.png</code> textures, in all levels, at once.  <p>You have to load an XML file by setting <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#URL\">MaterialProperties.URL</a> property. ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html"},
     {"title": "CastleMaterialProperties.TMaterialProperties.AutoGeneratedDirName", "text": " ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#AutoGeneratedDirName"},
     {"title": "CastleMaterialProperties.TMaterialProperties.Create", "text": "    ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#Create"},
     {"title": "CastleMaterialProperties.TMaterialProperties.Destroy", "text": "    ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#Destroy"},
     {"title": "CastleMaterialProperties.TMaterialProperties.FindTextureBaseName", "text": " Returns <code>Nil</code> if no material properties are found (in particular, if <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#URL\">URL</a> was not set yet).    ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#FindTextureBaseName"},
     {"title": "CastleMaterialProperties.TMaterialProperties.AutoGeneratedTextures", "text": " Returns a list of absolute URLs. This actually searches on disk, right now, to find the texture list, applying the include/exclude rules specified in material_properties.xml file.  <p>This is to be used by &quot;castle-engine auto-generate-textures&quot; tool, or similar tools.  <p>Caller is responsible for freeing the returned <a class=\"normal\" href=\"CastleStringUtils.TCastleStringList.html\">TCastleStringList</a> list.    ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#AutoGeneratedTextures"},
     {"title": "CastleMaterialProperties.TMaterialProperties.AutoGeneratedTextureURL", "text": " Scaling is defined just like <a class=\"normal\" href=\"CastleMaterialProperties.html#TextureLoadingScale\">TextureLoadingScale</a>.    ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#AutoGeneratedTextureURL"},
     {"title": "CastleMaterialProperties.TMaterialProperties.AutoCompressedTextureFormats", "text": "   TextureURL An absolute texture <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#URL\">URL</a>. Usually should just be taken from <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#AutoGeneratedTextures\">AutoGeneratedTextures</a> returned list.  TextureURL An absolute texture <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#URL\">URL</a>. Usually should just be taken from <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#AutoGeneratedTextures\">AutoGeneratedTextures</a> returned list.", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#AutoCompressedTextureFormats"},
     {"title": "CastleMaterialProperties.TMaterialProperties.AutoScale", "text": " Return value should be intepreted just like <a class=\"normal\" href=\"CastleMaterialProperties.html#TextureLoadingScale\">TextureLoadingScale</a>. See <a  href=\"http://castle-engine.sourceforge.net/creating_data_material_properties.php#section_texture_scale\">http://castle-engine.sourceforge.net/creating_data_material_properties.php#section_texture_scale</a>   TextureURL An absolute texture <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#URL\">URL</a>. Usually should just be taken from <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#AutoGeneratedTextures\">AutoGeneratedTextures</a> returned list.  TextureURL An absolute texture <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#URL\">URL</a>. Usually should just be taken from <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#AutoGeneratedTextures\">AutoGeneratedTextures</a> returned list.", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#AutoScale"},
     {"title": "CastleMaterialProperties.TMaterialProperties.URL", "text": " Set this to empty string to unload previously loaded properties. See Castle1 and fps_game data for examples how this looks like, in <code>material_properties.xml</code>. ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#URL"},
     {"title": "CastleMaterialProperties.TMaterialProperties.FileName", "text": " ", "tags": "", "loc": "CastleMaterialProperties.TMaterialProperties.html#FileName"},
     {"title": "CastleMaterialProperties.MaterialProperties", "text": " Set the <a class=\"normal\" href=\"CastleMaterialProperties.TMaterialProperties.html#URL\">URL</a> property to load material properties from XML file.    ", "tags": "", "loc": "CastleMaterialProperties.html#MaterialProperties"},
     {"title": "CastleMaterialProperties.TextureLoadingScale", "text": " This allows to conserve both GPU memory and loading time by using a downscaled images versions.  <p>The subset of your images which are affected by this must be declared inside the material_properties.xml file, which is loaded to <a class=\"normal\" href=\"CastleMaterialProperties.html#MaterialProperties\">MaterialProperties</a>. And the image files must be prepared earlier by the build tool call <code>&quot;castle-engine auto-generate-textures&quot;</code>. See the <a  href=\"http://castle-engine.sourceforge.net/creating_data_material_properties.php#section_texture_scale\">http://castle-engine.sourceforge.net/creating_data_material_properties.php#section_texture_scale</a> .  <p>Each size (width, height, and (for 3D images) depth) is scaled by 1 / 2&circ;<code>TextureLoadingScale</code>. So value = 1 means no scaling, value = 2 means that each size is 1/2 (texture area is 1/4), value = 3 means that each size is 1/4 and so on.  <p>This mechanism will <i>not</i> automatically downscale textures at runtime. If the downscaled texture version should exist, according to the material_properties.xml file, but it doesn't, then texture loading will simply fail. If you want to scale the texture at runtime, use the similar <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a> instead.  <p>This mechanism is independent from <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a>:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Scaling indicated by <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a> is performed at runtime, after loading. It happens <b>after</b> the results of <code>TextureLoadingScale</code> have already been applied.</p></li>   <li><p>The <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a> works on a different subset of textures.  <p>For <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a>, the usage of a texture determines if it's a GUI texture (which cannot be scaled) or not. So textures loaded through <a class=\"normal\" href=\"CastleGLImages.TGLImage.html\">TGLImage</a>, or declared as guiTexture in X3D, are not affected by <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a>. All other textures are affected. It doesn't matter from where they are loaded &ndash; so it affects also texture contents created by code, or downloaded from the Internet.  <p>In contrast, the <code>TextureLoadingScale</code> works (only) on all the images declared as having a downscaled version in material_properties.xml. It is not affected by how the texture will be used.</p></li>   <li><p>The <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a> works only on texture formats that can be scaled. In particular, it cannot scale textures compressed with a GPU compression (S3TC and such). It silently ignores them.  <p>In contrast, the <code>TextureLoadingScale</code> can cooperate with GPU-compressed textures, if you also compress them automatically using the material_properties.xml and the build tool call <code>&quot;castle-engine auto-generate-textures&quot;</code>. The downscaled image versions are generated from original (uncompressed, unscaled) images, and are then compressed.</p></li>   <li><p>The <a class=\"normal\" href=\"CastleGLImages.html#GLTextureScale\">GLTextureScale</a> scaling is usually of worse quality, since it's done at runtime.  <p>In contrast, the downscaled textures used by <code>TextureLoadingScale</code> are generated as a preprocessing step. The build tool <code>&quot;castle-engine auto-generate-textures&quot;</code> may use a slower but higher-quality scaling.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleMaterialProperties.html#TextureLoadingScale"},
     {"title": "CastleMessages", "text": "  <p>Features:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>All the MessageXxx routines display a modal dialog. They return only when the user accepted / answered the dialog box. This way they are comfortable to use anywhere in your program.</p></li>   <li><p>MessageInputXxx family of functions ask user to enter some text.</p></li>   <li><p>All the dialog boxes have vertical scroll bar, displayed when needed. So it's OK to use really long text. Scroll bar can be operated with keys (up/down, ctrl+up/down, page up/down, home/end) and mouse (drag the scroll bar, or click below/above it).</p></li>   <li><p>Long text lines are automatically broken. So it's OK to use text with long lines. We will try to break text only at whitespace.  <p>If you pass a text as a single string parameter, then our &quot;line breaking&quot; works correctly even for text that already contains newline characters (they are correctly recognized as forcing line break).  <p>If you pass a text as an &quot;array of string&quot; or TStringList, it's expected that strings inside don't contain newline characters anymore. It's undefined what will happen (i.e. whether they will be correctly broken) otherwise. Of course, TStringList contents used to pass text to MessageXxx will never be modified in any way.</p></li>   <li><p>User is allowed to resize the window while MessageXxx works. (As long as <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">TCastleWindowCustom.ResizeAllowed</a> = <a class=\"normal\" href=\"CastleWindow.html#raAllowed\">raAllowed</a>, of course.) Long lines are automatically broken taking into account current window width.</p></li>   <li><p>You can configure dialog boxes look using <a class=\"normal\" href=\"CastleControls.TCastleTheme.html\">TCastleTheme</a>. Various parts of the dialog use scaled images. This way you can change the border, background of the dialog, you can also make the dialog box partially transparent.</p></li> </ul>  <p>  <p>Call MessageXxx functions only when Window.Closed = false.  <p>Notes about implementation:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>We temporary replace normal window callbacks and controls using <a class=\"normal\" href=\"CastleWindowModes.TGLMode.html\">TGLMode</a>. This allows you to call MessageXxx procedures in any place of your program, and things will just work, the MessageXxx will return only once user answers the dialog box.</p></li>   <li><p>Be careful if you use <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnUpdate\">TCastleApplication.OnUpdate</a> or <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnTimer\">TCastleApplication.OnTimer</a>. As these events are not tied to a particular window, they continue to work even while we're inside MessageXxx procedure. Be sure to implement them such that they make sense also when we're inside a dialog box.  <p>In particular, remember that you cannot close the Window when the message box in running. So do not blindly call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Close\">TCastleWindowCustom.Close</a> from <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html\">TCastleApplication</a> callbacks. </p></li>   <li><p>Since your normal callbacks and controls are not run when message box is running, you usually don't need to do anything special about it, unless you use <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html\">TCastleApplication</a> callbacks mentioned above.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleMessages.html"},
     {"title": "CastleMessages.DefaultAlign", "text": " ", "tags": "", "loc": "CastleMessages.html#DefaultAlign"},
     {"title": "CastleMessages.taRight", "text": " ", "tags": "", "loc": "CastleMessages.html#taRight"},
     {"title": "CastleMessages.taMiddle", "text": " ", "tags": "", "loc": "CastleMessages.html#taMiddle"},
     {"title": "CastleMessages.taLeft", "text": " ", "tags": "", "loc": "CastleMessages.html#taLeft"},
     {"title": "CastleMessages.MessageOK", "text": " This is the simplest &quot;OK&quot; dialog box.  <p>    ", "tags": "", "loc": "CastleMessages.html#MessageOK"},
     {"title": "CastleMessages.MessageOK", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageOK"},
     {"title": "CastleMessages.MessageOK", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageOK"},
     {"title": "CastleMessages.MessageInput", "text": " User must give an answer (there is no &quot;Cancel&quot; button), use <a class=\"normal\" href=\"CastleMessages.html#MessageInputQuery\">MessageInputQuery</a> if you want a version with &quot;Cancel&quot; button.   <p>  AnswerMaxLen 0 (zero) means that there's no maximum answer length.  AnswerMaxLen 0 (zero) means that there's no maximum answer length.", "tags": "", "loc": "CastleMessages.html#MessageInput"},
     {"title": "CastleMessages.MessageInput", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageInput"},
     {"title": "CastleMessages.MessageInputQuery", "text": " Returns <code>True</code> and sets Answer if user accepted some text. Note that initial Answer value is the answer proposed to the user.   <p>  AnswerMaxLen 0 (zero) means that there's no maximum answer length.  AnswerMaxLen 0 (zero) means that there's no maximum answer length.", "tags": "", "loc": "CastleMessages.html#MessageInputQuery"},
     {"title": "CastleMessages.MessageInputQuery", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageInputQuery"},
     {"title": "CastleMessages.MessageChoice", "text": " ButtonCaptions contain a list of button captions.  <p>ButtonChars (must have always the same length as ButtonCaptions) contains the chars that are returned for each corresponding button press. The user can also directly press the given key. ButtonChars is not case sensitive, all letters on this list must be different (not only in case). We always return a lowercase letter corresponding to one of ButtonChars letters.  <p>Example usage:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">case</span> MessageChoice(Window, <span class=\"pascal_string\">'Which fruit to you want to eat?'</span>,   [<span class=\"pascal_string\">'Apple'</span>, <span class=\"pascal_string\">'Banana'</span>, <span class=\"pascal_string\">'Cancel'</span>],   [<span class=\"pascal_string\">'a'</span>, <span class=\"pascal_string\">'b'</span>, CharEscape]) <span class=\"pascal_keyword\">of</span>   <span class=\"pascal_string\">'a'</span>: <span class=\"pascal_comment\">// ... user pressed &quot;Apple&quot; button or &quot;A&quot; key -&gt; likes apples</span>   <span class=\"pascal_string\">'b'</span>: <span class=\"pascal_comment\">// ... user pressed &quot;Banana&quot; button or &quot;B&quot; key -&gt; likes bananas</span>   CharEscape: <span class=\"pascal_comment\">// ... user pressed &quot;Cancel&quot; button or &quot;Escape&quot; key -&gt; cancelled</span> <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>    ", "tags": "", "loc": "CastleMessages.html#MessageChoice"},
     {"title": "CastleMessages.MessageChoice", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageChoice"},
     {"title": "CastleMessages.MessageChoice", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageChoice"},
     {"title": "CastleMessages.MessageKey", "text": "  <p>Never returns <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> (which means that keys that cannot be interpreted as Keys.TKey will be ignored, and will not close the dialog box).  <p>    ", "tags": "", "loc": "CastleMessages.html#MessageKey"},
     {"title": "CastleMessages.MessageKey", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageKey"},
     {"title": "CastleMessages.MessageKey", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageKey"},
     {"title": "CastleMessages.MessageKeyMouse", "text": " The natural use for this is to allow user to configure keybindings of your program, like for <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a>.     ", "tags": "", "loc": "CastleMessages.html#MessageKeyMouse"},
     {"title": "CastleMessages.MessageKeyMouse", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageKeyMouse"},
     {"title": "CastleMessages.MessageKeyMouse", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageKeyMouse"},
     {"title": "CastleMessages.MessageKeyMouse", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageKeyMouse"},
     {"title": "CastleMessages.MessageYesNo", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageYesNo"},
     {"title": "CastleMessages.MessageYesNo", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageYesNo"},
     {"title": "CastleMessages.MessageYesNo", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageYesNo"},
     {"title": "CastleMessages.MessageInputCardinal", "text": "  <p>Note that AnswerDefault below may be given as Cardinal or as a string. The latter is useful if you want the default answer to be '', i.e. empty string &mdash; no default answer.  <p>    ", "tags": "", "loc": "CastleMessages.html#MessageInputCardinal"},
     {"title": "CastleMessages.MessageInputCardinal", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageInputCardinal"},
     {"title": "CastleMessages.MessageInputQueryCardinal", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageInputQueryCardinal"},
     {"title": "CastleMessages.MessageInputQueryCardinalHex", "text": " Give MaxWidth = 0 to say that there is no maximum width.    ", "tags": "", "loc": "CastleMessages.html#MessageInputQueryCardinalHex"},
     {"title": "CastleMessages.MessageInputQuery", "text": "  <p>If you give non-empty ValueAsString, it will be used to show the initial value for the user. Otherwise, we will just show FloatToStr(Value), which sometimes may be too ugly. For example Value = 0.01 cannot be precisely represented as a floating point number, and FloatToStr shows that this is really something like 0.0099xxxxx.  <p>    ", "tags": "", "loc": "CastleMessages.html#MessageInputQuery"},
     {"title": "CastleMessages.MessageInputQuery", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageInputQuery"},
     {"title": "CastleMessages.MessageInputQueryVector3", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageInputQueryVector3"},
     {"title": "CastleMessages.MessageInputQueryVector4", "text": "    ", "tags": "", "loc": "CastleMessages.html#MessageInputQueryVector4"},
     {"title": "CastleMessages.TTextAlign", "text": " Deprecated, use <a class=\"normal\" href=\"CastleRectangles.html#THorizontalPosition\">THorizontalPosition</a> instead. ", "tags": "", "loc": "CastleMessages.html#TTextAlign"},
     {"title": "CastleMessages.MessageOKPushesState", "text": "  <p>Why you may want to use this (or not to use this)?  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> This is the only way to make <a class=\"normal\" href=\"CastleMessages.html#MessageOK\">MessageOK</a> working on iOS (where Application.ProcessMessages is not available).</p></li>   <li><p> This looks a little better in case user may resize the window while the <a class=\"normal\" href=\"CastleMessages.html#MessageOK\">MessageOK</a> is running, or when something animates under <a class=\"normal\" href=\"CastleMessages.html#MessageOK\">MessageOK</a>. When this is <code>True</code>, the state underneath redraws properly, so it can adjust to window size and animate. Otherwise, all MessageXxx methods in this unit only show a static screenshot underneath, that is scaled if needed.</p></li>   <li><p> On the other hand, the notification about unhandled exceptions (done by <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> automatically, using <a class=\"normal\" href=\"CastleMessages.html#MessageOK\">MessageOK</a>) is a little safer when this is <code>False</code>. When this is <code>False</code>, there's a greater chance that the problematic code (e.g. the update method of some other <a class=\"normal\" href=\"CastleUIState.TUIState.html\">TUIState</a>) it disabled during the display of the error messsage.</p></li> </ul>  <p>  <p>If you turn this on, then you should organize your whole application into states using <a class=\"normal\" href=\"CastleUIState.TUIState.html\">TUIState</a>. You can even pause the running game in overridden <a class=\"normal\" href=\"CastleUIState.TUIState.html#Pause\">TUIState.Pause</a>, to make game paused when the message dialog is displayed.  <p>Note that this feature doesn't change other routines in <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a>. For example <a class=\"normal\" href=\"CastleMessages.html#MessageYesNo\">MessageYesNo</a> is still a modal function (it waits for user input), and it simply doesn't work on iOS. If you want to use <a class=\"normal\" href=\"CastleUIState.TUIState.html\">TUIState</a> to manage all dialogs, then use explicitly states like <a class=\"normal\" href=\"CastleDialogStates.TStateDialogYesNo.html\">TStateDialogYesNo</a> from the <a class=\"normal\" href=\"CastleDialogStates.html\">CastleDialogStates</a> unit. ", "tags": "", "loc": "CastleMessages.html#MessageOKPushesState"},
     {"title": "CastleMessaging", "text": " ", "tags": "", "loc": "CastleMessaging.html"},
     {"title": "CastleMessaging.TMessageReceivedEventList", "text": " ", "tags": "", "loc": "CastleMessaging.TMessageReceivedEventList.html"},
     {"title": "CastleMessaging.TMessageReceivedEventList.ExecuteAll", "text": "    ", "tags": "", "loc": "CastleMessaging.TMessageReceivedEventList.html#ExecuteAll"},
     {"title": "CastleMessaging.TMessaging", "text": " Use through auto-created <a class=\"normal\" href=\"CastleMessaging.html#Messaging\">Messaging</a> singleton. On platforms other than Android / iOS, it simply does nothing &mdash; messsages are not send anywhere.  <p>To make this work, on Android you need to declare your Android project type as &quot;integrated&quot;. See <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Components-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Components-Integrated-with-Castle-Game-Engine</a> . For iOS, you don't need to do anything. You should also use the <code>game_units</code> attribute in <code>CastleEngineManifest.xml</code>, so that the build tool automatically generates a proper Android / iOS library code, exporting the proper functions.  <p>All the communication is asynchronous on all platforms &ndash; Pascal code sends a message, and any answers will come asynchronously later. This means that e.g. <a class=\"normal\" href=\"CastleGameService.TGameService.html#RequestSignedIn\">TGameService.RequestSignedIn</a> will never call <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnStatusChanged\">TGameService.OnStatusChanged</a> right inside, the call to <a class=\"normal\" href=\"CastleGameService.TGameService.html#OnStatusChanged\">TGameService.OnStatusChanged</a> will always happen at a later time.  <p>This is used automatically by various engine classes like <a class=\"normal\" href=\"CastleGooglePlayGames.html#TGooglePlayGames\">TGooglePlayGames</a>, <a class=\"normal\" href=\"CastleAds.TAds.html\">TAds</a>, <a class=\"normal\" href=\"CastleAnalytics.TAnalytics.html\">TAnalytics</a>, <a class=\"normal\" href=\"CastleInAppPurchases.TInAppPurchases.html\">TInAppPurchases</a>. ", "tags": "", "loc": "CastleMessaging.TMessaging.html"},
     {"title": "CastleMessaging.TMessaging.Create", "text": "    ", "tags": "", "loc": "CastleMessaging.TMessaging.html#Create"},
     {"title": "CastleMessaging.TMessaging.Destroy", "text": "    ", "tags": "", "loc": "CastleMessaging.TMessaging.html#Destroy"},
     {"title": "CastleMessaging.TMessaging.Send", "text": "    ", "tags": "", "loc": "CastleMessaging.TMessaging.html#Send"},
     {"title": "CastleMessaging.TMessaging.BoolToStr", "text": "    ", "tags": "", "loc": "CastleMessaging.TMessaging.html#BoolToStr"},
     {"title": "CastleMessaging.TMessaging.TimeToStr", "text": "    ", "tags": "", "loc": "CastleMessaging.TMessaging.html#TimeToStr"},
     {"title": "CastleMessaging.TMessaging.OnReceive", "text": " ", "tags": "", "loc": "CastleMessaging.TMessaging.html#OnReceive"},
     {"title": "CastleMessaging.TMessaging.Log", "text": " Note that this is sometimes quite verbose, and it also allows cheaters to easier debug what happens in your game (e.g. how to fake getting some achievement), so in general don't leave it &quot;on&quot; in production. ", "tags": "", "loc": "CastleMessaging.TMessaging.html#Log"},
     {"title": "CastleMessaging.Messaging", "text": "    ", "tags": "", "loc": "CastleMessaging.html#Messaging"},
     {"title": "CastleMessaging.TMessageReceivedEvent", "text": " Returns if the message was handled (this does <b>not</b> block the message from being passed to other callbacks, it only means we will not report a warning about unhandled message).    ", "tags": "", "loc": "CastleMessaging.html#TMessageReceivedEvent"},
     {"title": "CastleNoise", "text": " ", "tags": "", "loc": "CastleNoise.html"},
     {"title": "CastleNoise.InterpolatedNoise2D_None", "text": "  <p>This is the interpolated integer noise. That is, values on integer grid points (when X, Y are ints) come from the really independent &quot;integer noise&quot;. Values between integer points are interpolated.  <p>Suffix describes interpolation method.  <p>    ", "tags": "", "loc": "CastleNoise.html#InterpolatedNoise2D_None"},
     {"title": "CastleNoise.InterpolatedNoise2D_Linear", "text": "    ", "tags": "", "loc": "CastleNoise.html#InterpolatedNoise2D_Linear"},
     {"title": "CastleNoise.InterpolatedNoise2D_Cosine", "text": "    ", "tags": "", "loc": "CastleNoise.html#InterpolatedNoise2D_Cosine"},
     {"title": "CastleNoise.InterpolatedNoise2D_Spline", "text": "    ", "tags": "", "loc": "CastleNoise.html#InterpolatedNoise2D_Spline"},
     {"title": "CastleNoise.BlurredInterpolatedNoise2D_None", "text": "  <p>Blurring smooths the noise by averaging values a little with neighbors (just like blur on normal 2D images). This helps for 2D noise to be less vertical/horizontal oriented.  <p>BlurredInterpolatedNoise* functions first blur the IntegerNoise, and then blurred noise is interpolated. Results are the same as the other way around (first interpolate IntegerNoise, and only then blur it), and marginally faster.  <p>    ", "tags": "", "loc": "CastleNoise.html#BlurredInterpolatedNoise2D_None"},
     {"title": "CastleNoise.BlurredInterpolatedNoise2D_Linear", "text": "    ", "tags": "", "loc": "CastleNoise.html#BlurredInterpolatedNoise2D_Linear"},
     {"title": "CastleNoise.BlurredInterpolatedNoise2D_Cosine", "text": "    ", "tags": "", "loc": "CastleNoise.html#BlurredInterpolatedNoise2D_Cosine"},
     {"title": "CastleNoise.BlurredInterpolatedNoise2D_Spline", "text": "    ", "tags": "", "loc": "CastleNoise.html#BlurredInterpolatedNoise2D_Spline"},
     {"title": "CastleNotifications", "text": " ", "tags": "", "loc": "CastleNotifications.html"},
     {"title": "CastleNotifications.TCastleNotifications", "text": " Each message disappears after a short time. Suitable for game messages like &quot;Picked up 20 ammo&quot;. Call <a class=\"normal\" href=\"CastleNotifications.TCastleNotifications.html#Show\">Show</a> to display a message.  <p>This is a <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> descendant, so to use it &mdash; just add it to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a>. Use <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> anchors to automatically position it on the screen, for example:  <p></p>  <pre class=\"longcode\"> Notifications := TCastleNotifications.Create(Owner); Notifications.Anchor(hpMiddle); Notifications.Anchor(vpMiddle); Notifications.TextAlignment := hpMiddle; <span class=\"pascal_comment\">// looks best, when anchor is also in the middle</span></pre>  <p> ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html"},
     {"title": "CastleNotifications.TCastleNotifications.DefaultMaxMessages", "text": " ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#DefaultMaxMessages"},
     {"title": "CastleNotifications.TCastleNotifications.DefaultTimeout", "text": " ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#DefaultTimeout"},
     {"title": "CastleNotifications.TCastleNotifications.DefaultFade", "text": " ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#DefaultFade"},
     {"title": "CastleNotifications.TCastleNotifications.Create", "text": "    ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Create"},
     {"title": "CastleNotifications.TCastleNotifications.Destroy", "text": "    ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Destroy"},
     {"title": "CastleNotifications.TCastleNotifications.Show", "text": " An overloaded version that takes a single string will detect newlines in the string automatically so a message may be multi-line. The messages will be automatically broken to fit on the screen width with given font.     ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Show"},
     {"title": "CastleNotifications.TCastleNotifications.Show", "text": "    ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Show"},
     {"title": "CastleNotifications.TCastleNotifications.Clear", "text": "    ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Clear"},
     {"title": "CastleNotifications.TCastleNotifications.Update", "text": "    ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Update"},
     {"title": "CastleNotifications.TCastleNotifications.Render", "text": "    ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Render"},
     {"title": "CastleNotifications.TCastleNotifications.Rect", "text": "    ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Rect"},
     {"title": "CastleNotifications.TCastleNotifications.Color", "text": " Default value is <a class=\"normal\" href=\"CastleColors.html#White\">white</a>. ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Color"},
     {"title": "CastleNotifications.TCastleNotifications.History", "text": " May be <code>Nil</code> when not <a class=\"normal\" href=\"CastleNotifications.TCastleNotifications.html#CollectHistory\">CollectHistory</a>. ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#History"},
     {"title": "CastleNotifications.TCastleNotifications.MaxMessages", "text": " ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#MaxMessages"},
     {"title": "CastleNotifications.TCastleNotifications.Timeout", "text": " Message stops being visible when this timeout passed, or when we need more space for new messages (see <a class=\"normal\" href=\"CastleNotifications.TCastleNotifications.html#MaxMessages\">MaxMessages</a>). ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Timeout"},
     {"title": "CastleNotifications.TCastleNotifications.Fade", "text": " ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#Fade"},
     {"title": "CastleNotifications.TCastleNotifications.CollectHistory", "text": " <a class=\"normal\" href=\"CastleNotifications.TCastleNotifications.html#History\">History</a> is expanded by <a class=\"normal\" href=\"CastleNotifications.TCastleNotifications.html#Show\">Show</a>, it is cleared by <a class=\"normal\" href=\"CastleNotifications.TCastleNotifications.html#Clear\">Clear</a>, just like the notifications on screen. However, unlike the visible messages, it has unlimited size (messages there are not removed when <a class=\"normal\" href=\"CastleNotifications.TCastleNotifications.html#MaxMessages\">MaxMessages</a> or <a class=\"normal\" href=\"CastleNotifications.TCastleNotifications.html#Timeout\">Timeout</a> take action), and messages inside are not broken to honour screen width.  <p>This is useful if you want to show the player a history of messages (in case they missed the message in game). ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#CollectHistory"},
     {"title": "CastleNotifications.TCastleNotifications.TextAlignment", "text": " ", "tags": "", "loc": "CastleNotifications.TCastleNotifications.html#TextAlignment"},
     {"title": "CastleNotifications.Register", "text": "    ", "tags": "", "loc": "CastleNotifications.html#Register"},
     {"title": "CastleNURBS", "text": " ", "tags": "", "loc": "CastleNURBS.html"},
     {"title": "CastleNURBS.ActualTessellation", "text": " This follows X3D spec for &quot;an implementation subdividing the surface into an equal number of subdivision steps&quot;. Give value of tessellation field, and count of controlPoints.  <p>Returned value is for sure &gt; 0 (never exactly 0).    ", "tags": "", "loc": "CastleNURBS.html#ActualTessellation"},
     {"title": "CastleNURBS.NurbsCurvePoint", "text": "  <p>Requires: </p>  <ul class=\"paragraph_spacing\">   <li><p>PointsCount &gt; 0 (not exactly 0).</p></li>   <li><p>Order &gt;= 2 (X3D and VRML 97 spec require this too).</p></li>   <li><p>Knot must have exactly PointsCount + Order items.</p></li> </ul>  <p>  <p>Weight will be used only if it has the same length as PointsCount. Otherwise, weight = 1.0 (that is, defining non-rational curve) will be used (this follows X3D spec).  <p>Tangent, if non-nil, will be set to the direction at given point of the curve, pointing from the smaller to larger knot values. It will be normalized. This can be directly useful to generate orientations by X3D NurbsOrientationInterpolator node.  <p>    ", "tags": "", "loc": "CastleNURBS.html#NurbsCurvePoint"},
     {"title": "CastleNURBS.NurbsCurvePoint", "text": "    ", "tags": "", "loc": "CastleNURBS.html#NurbsCurvePoint"},
     {"title": "CastleNURBS.NurbsSurfacePoint", "text": "  <p>Requires: </p>  <ul class=\"paragraph_spacing\">   <li><p>UDimension, VDimension &gt; 0 (not exactly 0).</p></li>   <li><p>Points.Count must match UDimension * VDimension.</p></li>   <li><p>Order &gt;= 2 (X3D and VRML 97 spec require this too).</p></li>   <li><p>Each xKnot must have exactly xDimension + Order items.</p></li> </ul>  <p>  <p>Weight will be used only if it has the same length as PointsCount. Otherwise, weight = 1.0 (that is, defining non-rational curve) will be used (this follows X3D spec).  <p>Normal, if non-nil, will be set to the normal at given point of the surface. It will be normalized. You can use this to pass these normals to rendering. Or to generate normals for X3D NurbsSurfaceInterpolator node.    ", "tags": "", "loc": "CastleNURBS.html#NurbsSurfacePoint"},
     {"title": "CastleNURBS.NurbsKnotIfNeeded", "text": " After this, it's guaranteed that Knot.Count is Dimension + Order (just as required by <a class=\"normal\" href=\"CastleNURBS.html#NurbsCurvePoint\">NurbsCurvePoint</a>, <a class=\"normal\" href=\"CastleNURBS.html#NurbsSurfacePoint\">NurbsSurfacePoint</a>).    ", "tags": "", "loc": "CastleNURBS.html#NurbsKnotIfNeeded"},
     {"title": "CastleNURBS.NurbsBoundingBox", "text": "    ", "tags": "", "loc": "CastleNURBS.html#NurbsBoundingBox"},
     {"title": "CastleNURBS.NurbsBoundingBox", "text": "    ", "tags": "", "loc": "CastleNURBS.html#NurbsBoundingBox"},
     {"title": "CastleNURBS.NurbsBoundingBox", "text": "    ", "tags": "", "loc": "CastleNURBS.html#NurbsBoundingBox"},
     {"title": "CastleNURBS.NurbsBoundingBox", "text": "    ", "tags": "", "loc": "CastleNURBS.html#NurbsBoundingBox"},
     {"title": "CastleNURBS.TNurbsKnotKind", "text": "  nkPeriodicUniform All knot values are evenly spaced, all knots are single.  This is good for periodic curves.  nkEndpointUniform Starting and ending knots have Order multiplicity, rest is evenly spaced.  The curve hits endpoints. ", "tags": "", "loc": "CastleNURBS.html#TNurbsKnotKind"},
     {"title": "CastleOnScreenMenu", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.html"},
     {"title": "CastleOnScreenMenu.TCastleMenuButton", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuButton.html"},
     {"title": "CastleOnScreenMenu.TCastleMenuButton.Create", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuButton.html#Create"},
     {"title": "CastleOnScreenMenu.TCastleMenuButton.CustomBackground", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuButton.html#CustomBackground"},
     {"title": "CastleOnScreenMenu.TCastleMenuButton.CustomTextColorUse", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuButton.html#CustomTextColorUse"},
     {"title": "CastleOnScreenMenu.TCastleMenuButton.PaddingHorizontal", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuButton.html#PaddingHorizontal"},
     {"title": "CastleOnScreenMenu.TCastleMenuButton.PaddingVertical", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuButton.html#PaddingVertical"},
     {"title": "CastleOnScreenMenu.TCastleMenuToggle", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuToggle.html"},
     {"title": "CastleOnScreenMenu.TCastleMenuToggle.SetPressed", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuToggle.html#SetPressed"},
     {"title": "CastleOnScreenMenu.TCastleMenuToggle.Create", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuToggle.html#Create"},
     {"title": "CastleOnScreenMenu.TCastleMenuToggle.DoClick", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuToggle.html#DoClick"},
     {"title": "CastleOnScreenMenu.TCastleMenuToggle.Toggle", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuToggle.html#Toggle"},
     {"title": "CastleOnScreenMenu.TCastleMenuToggle.AutoToggle", "text": " This makes it easy to handle this component, often it means that you don't need to handle it's <a class=\"normal\" href=\"CastleControls.TCastleButton.html#OnClick\">OnClick</a> event, and you only need to observe it's <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Pressed\">Pressed</a> value. ", "tags": "", "loc": "CastleOnScreenMenu.TCastleMenuToggle.html#AutoToggle"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu", "text": " Typical for game menus. Normal tools may prefer to use the menu bar instead of this (for example TCastleWindowCustom.Menu, or normal Lazarus menu).  <p>Each menu item can have an &quot;accessory&quot;, for example an associated slider (from <a class=\"normal\" href=\"CastleControls.TCastleFloatSlider.html\">TCastleFloatSlider</a>, any <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> is OK). This allows to use this menu also for settings. ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultMenuKeyNextItem", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultMenuKeyNextItem"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultMenuKeyPreviousItem", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultMenuKeyPreviousItem"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultMenuKeySelectItem", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultMenuKeySelectItem"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultCurrentItemBorderColor1", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultCurrentItemBorderColor1"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultCurrentItemBorderColor2", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultCurrentItemBorderColor2"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultCurrentItemColor", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultCurrentItemColor"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultNonCurrentItemColor", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultNonCurrentItemColor"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultNonFocusableItemColor", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultNonFocusableItemColor"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultRegularSpaceBetweenItems", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultRegularSpaceBetweenItems"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultBackgroundOpacityNotFocused", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultBackgroundOpacityNotFocused"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DefaultBackgroundOpacityFocused", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultBackgroundOpacityFocused"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.UIScaleChanged", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#UIScaleChanged"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.ControlFocusable", "text": " This is used to decide should we show an &quot;active frame&quot; around this item in the menu. It <i>does not</i> determine whether the mouse events actually reach the child control.  <p>By default, a single <a class=\"normal\" href=\"CastleControls.TCastleLabel.html\">TCastleLabel</a> (without children) is considered &quot;not focusable&quot;. Everything else is focusable.    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#ControlFocusable"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Create", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Create"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Destroy", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Destroy"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Add", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Add"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Add", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Add"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Add", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Add"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Add", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Add"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.NextItem", "text": " Usually you will just let this class call it internally (from <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#Motion\">Motion</a>, KeyDown etc.) and will not need to call it yourself.  <p>  <p>  UserAction Determines should we play a sound when user changes menu items.  UserAction Determines should we play a sound when user changes menu items.", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#NextItem"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.PreviousItem", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#PreviousItem"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.RecalculateSize", "text": " Usually this is called automatically when necessary.    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#RecalculateSize"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Resize", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Resize"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Rect", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Rect"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.CapturesEventsAtPosition", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#CapturesEventsAtPosition"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Render", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Render"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Press", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Press"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Release", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Release"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Motion", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Motion"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Update", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Update"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.AllowSuspendForInput", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#AllowSuspendForInput"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.Click", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#Click"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.CurrentItemSelected", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItemSelected"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.CurrentItemChanged", "text": " But *not* when <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItem\">CurrentItem</a> changed because of <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ControlsCount\">ControlsCount</a> changes. If you want to only get notified when the <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItem\">CurrentItem</a> changed because of user actions, better override <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItemChangedByUser\">CurrentItemChangedByUser</a>.    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItemChanged"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.CurrentItemChangedByUser", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItemChangedByUser"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.SpaceBetweenItems", "text": " This will be a space between NextItemIndex - 1 and NextItemIndex (this method will not be called for NextItemIndex = 0).  <p>Default implementation in this class simply returns <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#RegularSpaceBetweenItems\">RegularSpaceBetweenItems</a> always.  <p>Note that this is used only at <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#RecalculateSize\">RecalculateSize</a> call. So when some variable affecting the implementation of this changes, you should call <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#RecalculateSize\">RecalculateSize</a> again.    ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#SpaceBetweenItems"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.CurrentItem", "text": " This is always some number between <code>0</code> and <code><a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ControlsCount\">ControlsCount</a> - 1</code>. It can also be <code>-1</code> to indicate &quot;no child is selected&quot;. When there are no controls (<code><a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ControlsCount\">ControlsCount</a> = 0</code>) it is always <code>-1</code>.  <p>You can change it by code. Assigning here an invalid value (e.g. larger then <code><a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ControlsCount\">ControlsCount</a> - 1</code>) will be automatically fixed. Also when the children change (and so <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ControlsCount\">ControlsCount</a> changes), this is automatically fixed if necessary.  <p>Changing this calls <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItemChanged\">CurrentItemChanged</a> automatically, but not <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItemChangedByUser\">CurrentItemChangedByUser</a>. ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItem"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.KeyNextItem", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#KeyNextItem"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.KeyPreviousItem", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#KeyPreviousItem"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.KeySelectItem", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#KeySelectItem"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.CurrentItemBorderColor1", "text": " Default value is <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultCurrentItemBorderColor1\">DefaultCurrentItemBorderColor1</a> ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItemBorderColor1"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.CurrentItemBorderColor2", "text": " Default value is <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultCurrentItemBorderColor2\">DefaultCurrentItemBorderColor2</a> ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItemBorderColor2"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.CurrentItemColor", "text": " Default value is <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultCurrentItemColor\">DefaultCurrentItemColor</a> ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#CurrentItemColor"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.NonCurrentItemColor", "text": " Default value is <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultNonCurrentItemColor\">DefaultNonCurrentItemColor</a> ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#NonCurrentItemColor"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.NonFocusableItemColor", "text": " Default value is <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#DefaultNonFocusableItemColor\">DefaultNonFocusableItemColor</a> ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#NonFocusableItemColor"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.OnClick", "text": "  ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#OnClick"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.BackgroundOpacityFocused", "text": "  ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#BackgroundOpacityFocused"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.BackgroundOpacityNotFocused", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#BackgroundOpacityNotFocused"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DrawBackgroundRectangle", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DrawBackgroundRectangle"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.RegularSpaceBetweenItems", "text": "  <p>If you want more control over it (if you want to add more/less space between some menu items), override <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html#SpaceBetweenItems\">SpaceBetweenItems</a> method. ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#RegularSpaceBetweenItems"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.DrawFocusedBorder", "text": " ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#DrawFocusedBorder"},
     {"title": "CastleOnScreenMenu.TCastleOnScreenMenu.CaptureAllEvents", "text": " This affects key/mouse processing (menu processes input before all controls underneath), but not drawing (controls underneath are still visible as usual). ", "tags": "", "loc": "CastleOnScreenMenu.TCastleOnScreenMenu.html#CaptureAllEvents"},
     {"title": "CastleOnScreenMenu.Register", "text": "    ", "tags": "", "loc": "CastleOnScreenMenu.html#Register"},
     {"title": "CastleOpenDocument", "text": " ", "tags": "", "loc": "CastleOpenDocument.html"},
     {"title": "CastleOpenDocument.SCannotOpenURL", "text": " This is comfortable (the FontStyle font works, with 3 * 4 font variations, out of the box), but it increases your exe size &mdash; possibly without a reason, if you don't use FontStyle X3D node.  <p>Undefine this to conserve around 0.7 MB in exe size. All the Text X3D nodes will use standard sans non-bold, non-italic font. ", "tags": "", "loc": "CastleOpenDocument.html#SCannotOpenURL"},
     {"title": "CastleOpenDocument.OpenURL", "text": "  <p>This detects and handles also local files (as filenames, or URLs with &quot;file:&quot; protocol).  <p>On Android and iOS, it uses the OS functions to open the URL, supporting all URL types that are handled by the installed applications. For example, it will support the <a  href=\"market://\">market://</a> URLs on Android.  <p>To use this on Android, declare your Android project type as &quot;integrated&quot;, see <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> .    ", "tags": "", "loc": "CastleOpenDocument.html#OpenURL"},
     {"title": "CastleOpenDocument.OpenDocument", "text": "  You should instead use <a class=\"normal\" href=\"CastleOpenDocument.html#OpenURL\">OpenURL</a>, that automatically detects local filenames and URLs leading to local filenames.    ", "tags": "", "loc": "CastleOpenDocument.html#OpenDocument"},
     {"title": "CastleOpenDocument.ShareText", "text": "  <p>This works only on Android and iOS right now. For Android, you need to declare the project type as &quot;integrated&quot;: See <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> .  <p>    Title The short title of the share. Subject Used as an email subject, and any other app on Android that interprets EXTRA_SUBJECT parameter. Content Multi-line share text content, possibly with URL inside.  Title The short title of the share. Subject Used as an email subject, and any other app on Android that interprets EXTRA_SUBJECT parameter. Content Multi-line share text content, possibly with URL inside.", "tags": "", "loc": "CastleOpenDocument.html#ShareText"},
     {"title": "CastleOpenDocument.OpenApplicationStore", "text": " Ignored on other platforms now.  <p></p>  <ul class=\"compact_spacing\">   <li><p>On Android, ApplicationId should be the qualitied name of the application (same thing you use as qualified_name in CastleEngineManifest.xml).  <p>To include the necessary integration code in your Android project, you must declare your Android project type as &quot;integrated&quot;. See <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> . </p></li>   <li><p>On iOS, ApplicationId has to be the &quot;Apple ID&quot; number of your application (you can see it e.g. in <a  href=\"https://itunesconnect.apple.com/\">https://itunesconnect.apple.com/</a> page of your application). </p></li> </ul>  <p>    ", "tags": "", "loc": "CastleOpenDocument.html#OpenApplicationStore"},
     {"title": "CastleOpenDocument.Vibrate", "text": "  <p>This is available only on Android right now, ignored elsewhere. To include the necessary integration code in your Android project, declare your Android project type as &quot;integrated&quot; with the &quot;vibrate&quot; service inside CastleEngineManifest.xml. See <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> .    ", "tags": "", "loc": "CastleOpenDocument.html#Vibrate"},
     {"title": "CastleOpenDocument.OnScreenNotification", "text": "  <p>This is available only on Android right now, ignored elsewhere. To include the necessary integration code in your Android project, you must declare your Android project type as &quot;integrated&quot;. See <a  href=\"https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine\">https://github.com/castle-engine/castle-engine/wiki/Android-Project-Services-Integrated-with-Castle-Game-Engine</a> .    ", "tags": "", "loc": "CastleOpenDocument.html#OnScreenNotification"},
     {"title": "CastleParameters", "text": " ", "tags": "", "loc": "CastleParameters.html"},
     {"title": "CastleParameters.EInvalidParams", "text": " ", "tags": "", "loc": "CastleParameters.EInvalidParams.html"},
     {"title": "CastleParameters.EInvalidShortOption", "text": " ", "tags": "", "loc": "CastleParameters.EInvalidShortOption.html"},
     {"title": "CastleParameters.EInvalidLongOption", "text": " ", "tags": "", "loc": "CastleParameters.EInvalidLongOption.html"},
     {"title": "CastleParameters.EWrongOptionArgument", "text": " ", "tags": "", "loc": "CastleParameters.EWrongOptionArgument.html"},
     {"title": "CastleParameters.EExcessiveOptionArgument", "text": " ", "tags": "", "loc": "CastleParameters.EExcessiveOptionArgument.html"},
     {"title": "CastleParameters.EMissingOptionArgument", "text": " ", "tags": "", "loc": "CastleParameters.EMissingOptionArgument.html"},
     {"title": "CastleParameters.TOption", "text": "  <p>Both Short and Long option names are case-sensitive. The convention is to make Long option names using only lower-case letters, separates by dashes, like <code>my-option-name</code>.  <p>Note that spaces are allowed (as Short option name, or within Long option nam), but in practice should not be used as they are a pain to pass for the users (you'd have to quote option names under most shells). ", "tags": "", "loc": "CastleParameters.TOption.html"},
     {"title": "CastleParameters.TOption.Short", "text": " Use #0 if none. Cannot be '-' or '=' (these would cause ambiguity when parsing options). ", "tags": "", "loc": "CastleParameters.TOption.html#Short"},
     {"title": "CastleParameters.TOption.Long", "text": " Use '' if none. Cannot contain '=' (this would cause ambiguity when parsing options). ", "tags": "", "loc": "CastleParameters.TOption.html#Long"},
     {"title": "CastleParameters.TOption.Argument", "text": " ", "tags": "", "loc": "CastleParameters.TOption.html#Argument"},
     {"title": "CastleParameters.TParameters", "text": " For simple processing, you can just read values of this list, checking count with comfortable methods like <a class=\"normal\" href=\"CastleParameters.TParameters.html#CheckHigh\">CheckHigh</a>. For more involved processing, use the Parse function, that does a whole job for you based on a simple specification of allowed options.  <p>Some terminology:  <p></p>  <dl class=\"paragraph_spacing\">   <dt><i>Parameter</i></dt>   <dd><p>Command-line parameters list is given directly by the OS to our program. These are the contents of this list, initialized from the standard Pascal ParamStr/ParamCount. They can be modified to remove the already-handled parameters.</p></dd>   <dt><i>Option</i></dt>   <dd><p>AOptions are things encoded by the user in the parameters. Examples:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Command-line  <p></p>  <pre class=\"preformatted\">view3dscene --navigation Walk</pre>  <p>  <p>passes two parameters (<code>--navigation</code> and <code>Walk</code>) for view3dscene, and these two parameters form one option: <code>--navigation=Walk</code>.</p></li>   <li><p>Command-line  <p></p>  <pre class=\"preformatted\">view3dscene -hv</pre>  <p>  <p>passes one parameter (<code>-hv</code>) for view3dscene, and inside this parameter two options are encoded: <code>-h</code> and <code>-v</code>.</p></li> </ul>  <p>  <p>The very idea of this unit is to decode &quot;options&quot; from the &quot;parameters&quot;. </p></dd>   <dt><i>Argument</i></dt>   <dd><p>Argument is a part of the option, that clarifies what this option does. For example in <code>--navigation=Walk</code>, &quot;<code>Walk</code>&quot; is the argument and &quot;<code>--navigation</code>&quot; is the option long name.  <p>Some options don't take any arguments, some take optional argument, some take required argument, some have a couple of arguments. <a class=\"normal\" href=\"CastleParameters.html#TOptionArgument\">TOptionArgument</a> type allows you to specify all this.</p></dd> </dl>  <p>  <p>For simple programs, you can directly parse command-line by looking at our parameters strings. For more involved cases, using <a class=\"normal\" href=\"CastleParameters.TParameters.html#Parse\">Parse</a> method has a lot of advantages:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Less error-prone, and your program's code stays simple.</p></li>   <li><p>We automatically handle special parameter -- that is a standard way to mark the end of the options. (Useful for users that have filenames that start with &quot;-&quot; character.)</p></li>   <li><p>We automatically detect and make exceptions with nice messages on various errors. For example unrecognized options are clearly reported (so they will not mistaken for e.g. missing filenames by your program).</p></li>   <li><p>We automatically allow combining of short options, so user can use <code>-abc</code> instead of <code>-a -b -c</code>.</p></li>   <li><p>We have a simple interface, where you simply specify what options you want, long and short option names, option arguments and such.</p></li> </ul>  <p>  <p>See [<a  href=\"http://castle-engine.sourceforge.net/common_options.php\">http://castle-engine.sourceforge.net/common_options.php</a>] for a user description how short and long options are expected to be given on the command-line. ", "tags": "", "loc": "CastleParameters.TParameters.html"},
     {"title": "CastleParameters.TParameters.High", "text": "    ", "tags": "", "loc": "CastleParameters.TParameters.html#High"},
     {"title": "CastleParameters.TParameters.CheckHigh", "text": "      EInvalidParams When High is wrong.", "tags": "", "loc": "CastleParameters.TParameters.html#CheckHigh"},
     {"title": "CastleParameters.TParameters.CheckHighAtLeast", "text": "    ", "tags": "", "loc": "CastleParameters.TParameters.html#CheckHighAtLeast"},
     {"title": "CastleParameters.TParameters.CheckHighAtMost", "text": "    ", "tags": "", "loc": "CastleParameters.TParameters.html#CheckHighAtMost"},
     {"title": "CastleParameters.TParameters.IsPresent", "text": " Looks inside Strings[1..High], case sensitive.    ", "tags": "", "loc": "CastleParameters.TParameters.html#IsPresent"},
     {"title": "CastleParameters.TParameters.Parse", "text": " Given a specification of your command-line options (in AOptions), we will find and pass these options to your OptionProc callback. The handled options will be removed from the <a class=\"normal\" href=\"CastleParameters.html#Parameters\">Parameters</a> list.  <p>After running this, you should treat the remaining <a class=\"normal\" href=\"CastleParameters.html#Parameters\">Parameters</a> as &quot;normal&quot; parameters, usually a filenames to open by your program or such.  <p>See also <a class=\"normal\" href=\"CastleParameters.TOption.html\">TOption</a> for a specification of an option, and see <a class=\"normal\" href=\"CastleParameters.html#TOptionArgument\">TOptionArgument</a> for a specification of an option argument, and see <a class=\"normal\" href=\"CastleParameters.html#TOptionProc\">TOptionProc</a> for a specification what your OptionProc callback gets.  <p>      <p>Note that a single dash parameter is left alone, without making any exceptions, as this is a standard way of telling &quot;standard input&quot; or &quot;standard output&quot; for some programs.  <p>Note that a double dash parameter -- is handled and removed from the <a class=\"normal\" href=\"CastleParameters.html#Parameters\">Parameters</a> list, and signals an end of options.  <p>You should not modify <a class=\"normal\" href=\"CastleParameters.html#Parameters\">Parameters</a> list when this function is running, in particular do not modify it from your OptionProc callback. Also, do not depend on when the handled options are exactly removed from the <a class=\"normal\" href=\"CastleParameters.html#Parameters\">Parameters</a> list (before or after OptionProc callback).  <p>We never touch here the Strings[0] value, we look only at the Strings[1] to Strings[High].  <p>ParseOnlyKnownLongOptions = <code>True</code> makes this procedure work a little differently, it's designed to allow you to process <i>some</i> long options and leave the rest options not handled (without making any error):  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>All short options are ignored then.</p></li>   <li value=\"2\"><p>All unknown long options are also ignored, without making any error.</p></li>   <li value=\"3\"><p>The special -- is handled (signals the end of options), but it's not removed from the <a class=\"normal\" href=\"CastleParameters.html#Parameters\">Parameters</a>.</p></li> </ol>  <p>  <p>The ParseOnlyKnownLongOptions = <code>True</code> is useful if you want to handle some command-line options, but you still want to leave final options parsing to a later code. For example <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ParseParameters\">TCastleWindowCustom.ParseParameters</a> parses some window parameters (like &ndash;geometry), leaving your program-specific stuff in peace.  <p>Note that ParseOnlyKnownLongOptions = <code>True</code> isn't an absolutely fool-proof solution, for example the command-line <code>view3dscene &ndash;navigation &ndash;geometry 800x600 Walk</code> is actually invalid. But we will handle it, by first detecting and removing <code>&ndash;geometry 800x600</code> from <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ParseParameters\">TCastleWindowCustom.ParseParameters</a>, and then detecting and removing <code>&ndash;navigation Walk</code> from view3dscene code. Basically, processing by Parse many times is not fool-proof in some weird situations.  <p>    EInvalidShortOption On invalid (unknown) short option name. EInvalidLongOption On invalid long option name. EExcessiveOptionArgument When an option gets too many arguments, this may happen for options with <a class=\"normal\" href=\"CastleParameters.html#oaNone\">oaNone</a> or oaRequiredXSeparate that are specified with <code>&ndash;option=argument</code> form. EMissingOptionArgument When an option gets too few arguments, this may happen when argument for <a class=\"normal\" href=\"CastleParameters.html#oaRequired\">oaRequired</a> option is missing, or when too few arguments are given for oaRequiredXSeparate option. EInvalidParams On invalid parameter without an option, like <code>-=argument</code> or <code>&ndash;=argument</code>.", "tags": "", "loc": "CastleParameters.TParameters.html#Parse"},
     {"title": "CastleParameters.TParameters.Parse", "text": "    ", "tags": "", "loc": "CastleParameters.TParameters.html#Parse"},
     {"title": "CastleParameters.oaRequiredSeparateFirst", "text": " ", "tags": "", "loc": "CastleParameters.html#oaRequiredSeparateFirst"},
     {"title": "CastleParameters.oaRequiredSeparateLast", "text": " ", "tags": "", "loc": "CastleParameters.html#oaRequiredSeparateLast"},
     {"title": "CastleParameters.RequiredSeparateFirstCount", "text": " ", "tags": "", "loc": "CastleParameters.html#RequiredSeparateFirstCount"},
     {"title": "CastleParameters.RequiredSeparateLastCount", "text": " ", "tags": "", "loc": "CastleParameters.html#RequiredSeparateLastCount"},
     {"title": "CastleParameters.OptionArgumentsRequiredSeparate", "text": " ", "tags": "", "loc": "CastleParameters.html#OptionArgumentsRequiredSeparate"},
     {"title": "CastleParameters.EmptySeparateArgs", "text": " ", "tags": "", "loc": "CastleParameters.html#EmptySeparateArgs"},
     {"title": "CastleParameters.OnlyHelpOptions", "text": " ", "tags": "", "loc": "CastleParameters.html#OnlyHelpOptions"},
     {"title": "CastleParameters.HelpOptionHelp", "text": " ", "tags": "", "loc": "CastleParameters.html#HelpOptionHelp"},
     {"title": "CastleParameters.VersionOptionHelp", "text": " ", "tags": "", "loc": "CastleParameters.html#VersionOptionHelp"},
     {"title": "CastleParameters.SeparateArgsToVector3", "text": "    ", "tags": "", "loc": "CastleParameters.html#SeparateArgsToVector3"},
     {"title": "CastleParameters.SeparateArgsToVector3Single", "text": "    ", "tags": "", "loc": "CastleParameters.html#SeparateArgsToVector3Single"},
     {"title": "CastleParameters.OptionDescription", "text": " Existing newlines in Description are correctly accounted for.    ", "tags": "", "loc": "CastleParameters.html#OptionDescription"},
     {"title": "CastleParameters.TOptionArgument", "text": "  oaNone No arguments allowed.   oaOptional An optional argument.  It must be given as --option=argument or (short form) -o=argument.  <p>If you use a short form and you combine many short option names into one parameter, then only the last option may have an argument. For example <code>-abc=blah</code> is equivalent to <code>-a -b -c=blah</code>.  oaRequired A required argument.  It must be given as for <a class=\"normal\" href=\"CastleParameters.html#oaOptional\">oaOptional</a>, but this time the equal sign is not needed (we know anyway that following parameter must be an argument). So the following versions are possible:  <p></p>  <pre class=\"preformatted\"> --option=argument # long form, as one parameter --option argument # long form, as two parameters -o=argument # short form, as one parameter -o argument # short form, as two parameters</pre>  <p>  oaRequired2Separate We require a specified (more than one) argument.  All of the arguments must be specified as separate parameters, like  <p></p>  <pre class=\"preformatted\"> --option Argument1 Argument2 -o Argument1 Argument2</pre>  <p>  oaRequired3Separate    oaRequired4Separate    oaRequired5Separate    oaRequired6Separate    oaRequired7Separate    oaRequired8Separate    oaRequired9Separate   ", "tags": "", "loc": "CastleParameters.html#TOptionArgument"},
     {"title": "CastleParameters.TOptionArguments", "text": " ", "tags": "", "loc": "CastleParameters.html#TOptionArguments"},
     {"title": "CastleParameters.TOptionSeparateArgument", "text": " ", "tags": "", "loc": "CastleParameters.html#TOptionSeparateArgument"},
     {"title": "CastleParameters.TSeparateArgs", "text": " ", "tags": "", "loc": "CastleParameters.html#TSeparateArgs"},
     {"title": "CastleParameters.TOptionProc", "text": "  <p>  <p>  <p>  <p>  <p>  OptionNum The option number in the AOptions table (zero-based). HasArgument Says if you have a single argument in the Argument parameter. Always <code>False</code> when your option has <a class=\"normal\" href=\"CastleParameters.html#oaNone\">oaNone</a> or oaRequiredXSeparate. Always <code>True</code> when your option has <a class=\"normal\" href=\"CastleParameters.html#oaRequired\">oaRequired</a>. For <a class=\"normal\" href=\"CastleParameters.html#oaOptional\">oaOptional</a>, this is how you know if the optional argument was used. Argument A single argument for <a class=\"normal\" href=\"CastleParameters.html#oaRequired\">oaRequired</a> or <a class=\"normal\" href=\"CastleParameters.html#oaOptional\">oaOptional</a>, only if HasArgument. Otherwise empty string. SeparateArgs For options using oaRequiredXSeparate, your arguments are here. You get exactly as many argument as your oaRequiredXSeparate requested, the rest of SeparateArgs is empty strings. Data This is the OptionProcData value you passed to <a class=\"normal\" href=\"CastleParameters.TParameters.html#Parse\">TParameters.Parse</a>, use this to pass some pointer to your callback.  OptionNum The option number in the AOptions table (zero-based). HasArgument Says if you have a single argument in the Argument parameter. Always <code>False</code> when your option has <a class=\"normal\" href=\"CastleParameters.html#oaNone\">oaNone</a> or oaRequiredXSeparate. Always <code>True</code> when your option has <a class=\"normal\" href=\"CastleParameters.html#oaRequired\">oaRequired</a>. For <a class=\"normal\" href=\"CastleParameters.html#oaOptional\">oaOptional</a>, this is how you know if the optional argument was used. Argument A single argument for <a class=\"normal\" href=\"CastleParameters.html#oaRequired\">oaRequired</a> or <a class=\"normal\" href=\"CastleParameters.html#oaOptional\">oaOptional</a>, only if HasArgument. Otherwise empty string. SeparateArgs For options using oaRequiredXSeparate, your arguments are here. You get exactly as many argument as your oaRequiredXSeparate requested, the rest of SeparateArgs is empty strings. Data This is the OptionProcData value you passed to <a class=\"normal\" href=\"CastleParameters.TParameters.html#Parse\">TParameters.Parse</a>, use this to pass some pointer to your callback.", "tags": "", "loc": "CastleParameters.html#TOptionProc"},
     {"title": "CastleParameters.POption", "text": " ", "tags": "", "loc": "CastleParameters.html#POption"},
     {"title": "CastleParameters.TOption_Array", "text": " ", "tags": "", "loc": "CastleParameters.html#TOption_Array"},
     {"title": "CastleParameters.POption_Array", "text": " ", "tags": "", "loc": "CastleParameters.html#POption_Array"},
     {"title": "CastleParameters.Parameters", "text": " Initialized from standard ParamStr(0) ... ParamStr(ParamCount). Can be later modified, which is good &mdash; you can remove handled parameters. You also have all the methods of <a class=\"normal\" href=\"CastleStringUtils.TCastleStringList.html\">TCastleStringList</a> class (e.g. you can assign to another <a class=\"normal\" href=\"CastleStringUtils.TCastleStringList.html\">TCastleStringList</a> instance). ", "tags": "", "loc": "CastleParameters.html#Parameters"},
     {"title": "CastlePhotoService", "text": " ", "tags": "", "loc": "CastlePhotoService.html"},
     {"title": "CastlePhotoService.TPhotoService", "text": " It may also request user to take a new photo with the camera.  <p>At the moment, only storing images is implemented. ", "tags": "", "loc": "CastlePhotoService.TPhotoService.html"},
     {"title": "CastlePhotoService.TPhotoService.StoreImage", "text": "    ", "tags": "", "loc": "CastlePhotoService.TPhotoService.html#StoreImage"},
     {"title": "CastlePlayer", "text": " ", "tags": "", "loc": "CastlePlayer.html"},
     {"title": "CastlePlayer.TPlayer", "text": "  <p>Note that you can operate on player even before level is loaded, before <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> and such are initialized. This allows to create player before level is started (create it from scratch, or by loading from save game), and &quot;carry&quot; the same player instance across various loaded levels.  <p><a class=\"normal\" href=\"Castle3D.TAlive.html#Dead\">Dead</a> or <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Blocked\">Blocked</a> player behaves much like alive and normal player. For example, it still has an associated Camera that can animate by code (e.g. to apply physics to the dead player body, because player was killed when he was flying, or it's corpse lays on some moving object of the level &mdash; like elevator). However, Camera input shortcuts will be cleared, to prevent user from directly moving the camera and player.  <p>Do not do some stuff when player is dead: </p>  <ul class=\"paragraph_spacing\">   <li><p>No calling <a class=\"normal\" href=\"CastleItems.TAliveWithInventory.html#PickItem\">PickItem</a>, <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#DropItem\">DropItem</a>, <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#UseItem\">UseItem</a>.</p></li>   <li><p>No increasing Life (further decreasing Life is OK). This implies that once Player is Dead, (s)he cannot be alive again.</p></li>   <li><p>No changing <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#EquippedWeapon\">EquippedWeapon</a>, no calling Attack.</p></li> </ul>  <p>  <p>Note that a player has an associated and synchronized <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Camera\">Camera</a> instance. ", "tags": "", "loc": "CastlePlayer.TPlayer.html"},
     {"title": "CastlePlayer.TPlayer.DefaultMoveHorizontalSpeed", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultMoveHorizontalSpeed"},
     {"title": "CastlePlayer.TPlayer.DefaultMoveVerticalSpeed", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultMoveVerticalSpeed"},
     {"title": "CastlePlayer.TPlayer.DefaultPreferredHeight", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultPreferredHeight"},
     {"title": "CastlePlayer.TPlayer.DefaultLife", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultLife"},
     {"title": "CastlePlayer.TPlayer.DefaultSickProjectionSpeed", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultSickProjectionSpeed"},
     {"title": "CastlePlayer.TPlayer.DefaultRenderOnTop", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultRenderOnTop"},
     {"title": "CastlePlayer.TPlayer.DefaultPlayerKnockBackSpeed", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultPlayerKnockBackSpeed"},
     {"title": "CastlePlayer.TPlayer.DefaultSwimBreath", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultSwimBreath"},
     {"title": "CastlePlayer.TPlayer.DefaultDrownPause", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultDrownPause"},
     {"title": "CastlePlayer.TPlayer.DefaultDrownDamageConst", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultDrownDamageConst"},
     {"title": "CastlePlayer.TPlayer.DefaultDrownDamageRandom", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultDrownDamageRandom"},
     {"title": "CastlePlayer.TPlayer.DefaultSwimSoundPause", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DefaultSwimSoundPause"},
     {"title": "CastlePlayer.TPlayer.SetLife", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#SetLife"},
     {"title": "CastlePlayer.TPlayer.Notification", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Notification"},
     {"title": "CastlePlayer.TPlayer.LocalHeightCollision", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#LocalHeightCollision"},
     {"title": "CastlePlayer.TPlayer.LocalSegmentCollision", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#LocalSegmentCollision"},
     {"title": "CastlePlayer.TPlayer.LocalRender", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#LocalRender"},
     {"title": "CastlePlayer.TPlayer.Fall", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Fall"},
     {"title": "CastlePlayer.TPlayer.ChangedTransform", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#ChangedTransform"},
     {"title": "CastlePlayer.TPlayer.Create", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Create"},
     {"title": "CastlePlayer.TPlayer.Destroy", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Destroy"},
     {"title": "CastlePlayer.TPlayer.PrepareResources", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#PrepareResources"},
     {"title": "CastlePlayer.TPlayer.PickItemUpdate", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#PickItemUpdate"},
     {"title": "CastlePlayer.TPlayer.DropItem", "text": "     ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DropItem"},
     {"title": "CastlePlayer.TPlayer.DropCurrentItem", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DropCurrentItem"},
     {"title": "CastlePlayer.TPlayer.UseItem", "text": " You can pass Index that is out of range (or call <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#UseCurrentItem\">UseCurrentItem</a> when <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#InventoryCurrentItem\">InventoryCurrentItem</a> = -1), it will then show a <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Notification\">notification</a> (by <a class=\"normal\" href=\"CastleGameNotifications.html\">CastleGameNotifications</a> unit) that nothing is selected.     ", "tags": "", "loc": "CastlePlayer.TPlayer.html#UseItem"},
     {"title": "CastlePlayer.TPlayer.UseCurrentItem", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#UseCurrentItem"},
     {"title": "CastlePlayer.TPlayer.ChangeInventoryCurrentItem", "text": " Note that you can also always directly change <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#InventoryCurrentItem\">InventoryCurrentItem</a> property.    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#ChangeInventoryCurrentItem"},
     {"title": "CastlePlayer.TPlayer.Update", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Update"},
     {"title": "CastlePlayer.TPlayer.Middle", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Middle"},
     {"title": "CastlePlayer.TPlayer.FadeOut", "text": " The <a class=\"normal\" href=\"CastlePlayer.TPlayer.html\">TPlayer</a> class doesn't do the actual drawing of the fade-out effect on the screen, we merely store and animate the <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#FadeOutColor\">FadeOutColor</a> and <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#FadeOutIntensity\">FadeOutIntensity</a> properties. To draw the effect, use a procedure like <a class=\"normal\" href=\"CastleGLUtils.html#GLFadeRectangle\">GLFadeRectangle</a> inside your 2D controls drawing code, see engine tutorial for example.    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FadeOut"},
     {"title": "CastlePlayer.TPlayer.Attack", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Attack"},
     {"title": "CastlePlayer.TPlayer.LoadFromFile", "text": " Properties not specified in the indicated file will be reset to their default values. This is handy to use in a game to allow to configure player behavior by simply editing an XML file (instead of hacking code).  <p>Overloaded parameterless version reads from file <code><a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a>('player.xml')</code>.  <p>Note that the indicated file may not exist, and it will not cause errors. Not existing file is equivalent to a file with everything set at default values.  <p>It is Ok to call this multiple times, at any moment. This way you can make some debug command to reload player.xml file, very useful to test various player properties without restarting the game.  <p>    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#LoadFromFile"},
     {"title": "CastlePlayer.TPlayer.LoadFromFile", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#LoadFromFile"},
     {"title": "CastlePlayer.TPlayer.Ground", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Ground"},
     {"title": "CastlePlayer.TPlayer.LevelChanged", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#LevelChanged"},
     {"title": "CastlePlayer.TPlayer.Sphere", "text": "    ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Sphere"},
     {"title": "CastlePlayer.TPlayer.Flying", "text": " How it interacts with <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#FlyingTimeOut\">FlyingTimeout</a>: Setting this property to any value removes any timeout set by <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#FlyingTimeOut\">FlyingTimeout</a>. That is, setting this to <code>True</code> makes player fly indefinitely, and setting this to <code>False</code> makes player stop flying (regardless if flying was initialized by <code>Flying := true</code> or <code><a class=\"normal\" href=\"CastlePlayer.TPlayer.html#FlyingTimeOut\">FlyingTimeout</a></code>). ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Flying"},
     {"title": "CastlePlayer.TPlayer.FlyingTimeOut", "text": " The <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Flying\">Flying</a> property will also change to <code>True</code> for this time. It will automatically change back to <code>False</code> after given number of seconds (you can also always just manually switch <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Flying\">Flying</a> back to <code>False</code>).  <p>Set this only with value &gt; 0.  <p>When this is &gt; 0 it means flying with a timeout (always <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Flying\">Flying</a> = <code>True</code> then), otherwise it's = 0 (which means were not flying, or flying indefinitely long, depending on <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Flying\">Flying</a>). ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FlyingTimeOut"},
     {"title": "CastlePlayer.TPlayer.EquippedWeapon", "text": "  <p>You can set this property only to some item existing on Inventory. When you drop the current weapon, DeleteItem will automatically set this to <code>Nil</code>.  <p>When setting this property (to nil or non-nil) player may get GameMessage about using/not using a weapon. ", "tags": "", "loc": "CastlePlayer.TPlayer.html#EquippedWeapon"},
     {"title": "CastlePlayer.TPlayer.FadeOutColor", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FadeOutColor"},
     {"title": "CastlePlayer.TPlayer.FadeOutIntensity", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FadeOutIntensity"},
     {"title": "CastlePlayer.TPlayer.Swimming", "text": " This object will just use this property (changing it's <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Camera\">Camera</a> properties etc.). ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Swimming"},
     {"title": "CastlePlayer.TPlayer.InventoryCurrentItem", "text": "  <p>Note: while we try to always sensibly update <code>InventoryCurrentItem</code>, to keep the assumptions that </p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Inventory.Count = 0 =&gt; <code>InventoryCurrentItem</code> = -1</p></li>   <li value=\"2\"><p>Inventory.Count &gt; 0 =&gt; <code>InventoryCurrentItem</code> between 0 and Inventory.Count - 1</p></li> </ol>  <p>  <p>but you should <i>nowhere</i> depend on these assuptions. That's because I want to allow myself freedom to modify Inventory in various situations, so <code>InventoryCurrentItem</code> can become invalid in many situations.  <p>So every code should check that </p>  <ul class=\"paragraph_spacing\">   <li><p>If <code>InventoryCurrentItem</code> between 0 and Inventory.Count - 1 then <code>InventoryCurrentItem</code> is selected</p></li>   <li><p>Else no item is selected (possibly Inventory.Count = 0, possibly not)</p></li> </ul>  <p> ", "tags": "", "loc": "CastlePlayer.TPlayer.html#InventoryCurrentItem"},
     {"title": "CastlePlayer.TPlayer.InventoryVisible", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#InventoryVisible"},
     {"title": "CastlePlayer.TPlayer.SickProjectionSpeed", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#SickProjectionSpeed"},
     {"title": "CastlePlayer.TPlayer.CollidesWithMoving", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#CollidesWithMoving"},
     {"title": "CastlePlayer.TPlayer.Blocked", "text": " It's useful when you want to temporarily force camera to some specific setting (you can even use handy Player.Camera.AnimateTo method to do this easily, see TWalkCamera.AnimateTo). ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Blocked"},
     {"title": "CastlePlayer.TPlayer.RenderOnTop", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#RenderOnTop"},
     {"title": "CastlePlayer.TPlayer.FallMinHeightToSound", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FallMinHeightToSound"},
     {"title": "CastlePlayer.TPlayer.FallMinHeightToDamage", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FallMinHeightToDamage"},
     {"title": "CastlePlayer.TPlayer.FallDamageScaleMin", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FallDamageScaleMin"},
     {"title": "CastlePlayer.TPlayer.FallDamageScaleMax", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FallDamageScaleMax"},
     {"title": "CastlePlayer.TPlayer.FallSound", "text": " The default is the sound named 'player_fall'. ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FallSound"},
     {"title": "CastlePlayer.TPlayer.HeadBobbing", "text": " See TWalkCamera.HeadBobbing for exact meaning of this. TPlayer.Camera.HeadBobbing is automatically updated as necessary.  <p>Note that when using <a class=\"normal\" href=\"CastleLevels.html\">CastleLevels</a>, then the <code>headBobbing</code> defined inside VRML/X3D file (see <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_head_bobbing\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_head_bobbing</a> ) is ignored. Instead, Player properties control TWalkCamera.HeadBobbing and TWalkCamera.HeadBobbingTime. ", "tags": "", "loc": "CastlePlayer.TPlayer.html#HeadBobbing"},
     {"title": "CastlePlayer.TPlayer.SwimBreath", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#SwimBreath"},
     {"title": "CastlePlayer.TPlayer.DrownPause", "text": " Drown event makes <a class=\"normal\" href=\"CastleSoundEngine.html#stPlayerDrowning\">stPlayerDrowning</a> sound and causes damage <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#DrownDamageConst\">DrownDamageConst</a> + Random * <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#DrownDamageRandom\">DrownDamageRandom</a>. ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DrownPause"},
     {"title": "CastlePlayer.TPlayer.DrownDamageConst", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DrownDamageConst"},
     {"title": "CastlePlayer.TPlayer.DrownDamageRandom", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#DrownDamageRandom"},
     {"title": "CastlePlayer.TPlayer.SwimSoundPause", "text": " This should be something that is not easily synchronized with SwimDrownPause. ", "tags": "", "loc": "CastlePlayer.TPlayer.html#SwimSoundPause"},
     {"title": "CastlePlayer.TPlayer.FallingEffect", "text": " This indirectly controls <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#FallingEffect\">TWalkCamera.FallingEffect</a> underneath.  <p>Note: do not set <code>Camera.FallingEffect</code>, as it will be overridden in our update. Use only this property to turn on/off the effect. ", "tags": "", "loc": "CastlePlayer.TPlayer.html#FallingEffect"},
     {"title": "CastlePlayer.TPlayer.Camera", "text": "  <p>You can use this camera as <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">TCastleAbstractViewport.Camera</a> to allow user to directly control this player in first-person game. <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a> sets this automatically.  <p>The view vectors (position, direction and up), <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">TWalkCamera.Gravity</a>, and various camera inputs are automatically adjusted based on the current player state (<a class=\"normal\" href=\"Castle3D.TAlive.html#Dead\">Dead</a>, <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Blocked\">Blocked</a>) and global PlayerInput_Xxx values, like <a class=\"normal\" href=\"CastlePlayer.html#PlayerInput_Forward\">PlayerInput_Forward</a>. The outside code may still directly access and change some camera properties like TWalkCamera.PreferredHeight, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#RotationHorizontalSpeed\">TWalkCamera.RotationHorizontalSpeed</a> <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#RotationVerticalSpeed\">TWalkCamera.RotationVerticalSpeed</a>. In fact, it's Ok to call <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Init\">TWalkCamera.Init</a>. ", "tags": "", "loc": "CastlePlayer.TPlayer.html#Camera"},
     {"title": "CastlePlayer.TPlayer.KnockBackSpeed", "text": " ", "tags": "", "loc": "CastlePlayer.TPlayer.html#KnockBackSpeed"},
     {"title": "CastlePlayer.TPlayer.EnableCameraDragging", "text": " This results in including <a class=\"normal\" href=\"CastleCameras.html#ciMouseDragging\">ciMouseDragging</a> in <a class=\"normal\" href=\"CastleCameras.TCamera.html#Input\">TCamera.Input</a> (when player is not <a class=\"normal\" href=\"Castle3D.TAlive.html#Dead\">Dead</a> or <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Blocked\">Blocked</a>). ", "tags": "", "loc": "CastlePlayer.TPlayer.html#EnableCameraDragging"},
     {"title": "CastlePlayer.TPlayer.RenderDebug", "text": " Warning: It looks a little confusing (since it's a box around camera). ", "tags": "", "loc": "CastlePlayer.TPlayer.html#RenderDebug"},
     {"title": "CastlePlayer.DefaultAutoOpenInventory", "text": " ", "tags": "", "loc": "CastlePlayer.html#DefaultAutoOpenInventory"},
     {"title": "CastlePlayer.TPlayerSwimming", "text": "  psNo    psAboveWater Player is floating on the water.  Not falling down, but also not drowning. This means that player head is above the water surface but his feet are in the water. In some sense he/she is swimming, in some not.  psUnderWater   ", "tags": "", "loc": "CastlePlayer.html#TPlayerSwimming"},
     {"title": "CastlePlayer.AutoOpenInventory", "text": " ", "tags": "", "loc": "CastlePlayer.html#AutoOpenInventory"},
     {"title": "CastlePlayer.PlayerInput_Forward", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_Forward"},
     {"title": "CastlePlayer.PlayerInput_Backward", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_Backward"},
     {"title": "CastlePlayer.PlayerInput_LeftRot", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_LeftRot"},
     {"title": "CastlePlayer.PlayerInput_RightRot", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_RightRot"},
     {"title": "CastlePlayer.PlayerInput_LeftStrafe", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_LeftStrafe"},
     {"title": "CastlePlayer.PlayerInput_RightStrafe", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_RightStrafe"},
     {"title": "CastlePlayer.PlayerInput_UpRotate", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_UpRotate"},
     {"title": "CastlePlayer.PlayerInput_DownRotate", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_DownRotate"},
     {"title": "CastlePlayer.PlayerInput_GravityUp", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_GravityUp"},
     {"title": "CastlePlayer.PlayerInput_Jump", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_Jump"},
     {"title": "CastlePlayer.PlayerInput_Crouch", "text": " ", "tags": "", "loc": "CastlePlayer.html#PlayerInput_Crouch"},
     {"title": "CastleProgress", "text": " ", "tags": "", "loc": "CastleProgress.html"},
     {"title": "CastleProgress.TProgressUserInterface", "text": " See <a class=\"normal\" href=\"CastleProgress.TProgress.html\">TProgress</a> for information how to use progress bars. ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html"},
     {"title": "CastleProgress.TProgressUserInterface.DefaultBarYPosition", "text": " ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#DefaultBarYPosition"},
     {"title": "CastleProgress.TProgressUserInterface.Create", "text": "    ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#Create"},
     {"title": "CastleProgress.TProgressUserInterface.Destroy", "text": "    ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#Destroy"},
     {"title": "CastleProgress.TProgressUserInterface.Init", "text": "    ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#Init"},
     {"title": "CastleProgress.TProgressUserInterface.Update", "text": "    ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#Update"},
     {"title": "CastleProgress.TProgressUserInterface.Fini", "text": "    ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#Fini"},
     {"title": "CastleProgress.TProgressUserInterface.Image", "text": "  <p>Not all progress bar interfaces support it, some simply ignore it. You can leave it <code>Nil</code>, then the interface will use whatever is suitable (e.g. capture screen contents each time the progress bar starts).  <p>Whether the image assigned here is &quot;owned&quot; (that is, &quot;automatically freed&quot;) by <a class=\"normal\" href=\"CastleProgress.TProgressUserInterface.html\">TProgressUserInterface</a> instance depends on <a class=\"normal\" href=\"CastleProgress.TProgressUserInterface.html#OwnsImage\">OwnsImage</a>. In any case, we don't modify the image (if we need to resize it to fit the screen size, we do it on a temporary copy).  <p>The type of this must be <a class=\"normal\" href=\"CastleImages.TRGBImage.html\">CastleImages.TRGBImage</a>, but it cannot be declared as such here, we want this unit to be part of base units, not dependent on images. ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#Image"},
     {"title": "CastleProgress.TProgressUserInterface.OwnsImage", "text": " ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#OwnsImage"},
     {"title": "CastleProgress.TProgressUserInterface.BarYPosition", "text": " This feature is supposed to indicate a suitable free space on the background <a class=\"normal\" href=\"CastleProgress.TProgressUserInterface.html#Image\">Image</a> where we can nicely fit the progress bar UI.  <p>Not all progress bar interfaces support it, some simply ignore it.  <p>0 means the middle of progress bar is at the bottom of the image, 1 means at the top. 0.5 indicates the middle, and it's the default. ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#BarYPosition"},
     {"title": "CastleProgress.TProgressUserInterface.ImageBarYPosition", "text": " ", "tags": "", "loc": "CastleProgress.TProgressUserInterface.html#ImageBarYPosition"},
     {"title": "CastleProgress.TProgress", "text": "  <p>This provides the functionality of a progress bar (everything that wants to signal progress should call <a class=\"normal\" href=\"CastleProgress.html#Progress\">Progress</a> methods), but not the actual user interface. The user interface is &quot;pluggable&quot;, that is you assign something to the Progress.UserInterface property. See the units:  <p></p>  <ul class=\"compact_spacing\">   <li><p><a class=\"normal\" href=\"CastleWindowProgress.html\">CastleWindowProgress</a> &mdash; show progress bar in OpenGL window</p></li>   <li><p><a class=\"normal\" href=\"CastleProgressConsole.html\">CastleProgressConsole</a> &mdash; show progress bar on StdErr</p></li>   <li><p>And you can also implement progress handling yourself, e.g. using Lazarus form or using Lazarus progress bar on existing form.</p></li> </ul>  <p>  <p>This way any unit that implements some lengthy operation can call appropriate functions of the <a class=\"normal\" href=\"CastleProgress.html#Progress\">Progress</a> object. And the final program can choose how it wants to show that progress to user (in console? in OpenGL window? etc.).  <p>Usage example:  <p></p>  <pre class=\"longcode\"> Progress.UserInterface := <span class=\"pascal_numeric\"></span>... some TProgressUserInterface instance <span class=\"pascal_numeric\"></span>...; <span class=\"pascal_numeric\"></span>... Progress.Init(<span class=\"pascal_numeric\">100</span>, <span class=\"pascal_string\">'Doing something time-consuming, please wait'</span>); <span class=\"pascal_keyword\">try</span>   <span class=\"pascal_keyword\">for</span> i := <span class=\"pascal_numeric\">1</span> <span class=\"pascal_keyword\">to</span> <span class=\"pascal_numeric\">100</span> <span class=\"pascal_keyword\">do</span>   <span class=\"pascal_keyword\">begin</span>     <span class=\"pascal_numeric\"></span>... <span class=\"pascal_keyword\">do</span> something <span class=\"pascal_numeric\"></span>...     Progress.Step;   <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">finally</span> Progress.Fini; <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>Using <code>&quot;try ... finally ... end&quot;</code> above is not strictly required, but is strongly suggested. Rule of thumb says to always call Progress.Fini when you called Progress.Init.  <p>The <a class=\"normal\" href=\"CastleProgress.TProgress.html#Step\">TProgress.Step</a> is implemented such that you don't have to worry about calling it too often. We will not update the interface (<a class=\"normal\" href=\"CastleProgress.TProgressUserInterface.html#Update\">TProgressUserInterface.Update</a>) too often, see <a class=\"normal\" href=\"CastleProgress.TProgress.html#UpdatePart\">TProgress.UpdatePart</a> and <a class=\"normal\" href=\"CastleProgress.TProgress.html#UpdateDelay\">TProgress.UpdateDelay</a> for details.  <p>This unit creates one instance of the class <a class=\"normal\" href=\"CastleProgress.TProgress.html\">TProgress</a>: <a class=\"normal\" href=\"CastleProgress.html#Progress\">Progress</a>. Usually this is what you want to use. For complicated cases, you can create and pass around more instances (e.g. from different threads, each <a class=\"normal\" href=\"CastleProgress.TProgress.html\">TProgress</a> object displaying it's state in a separate window.) ", "tags": "", "loc": "CastleProgress.TProgress.html"},
     {"title": "CastleProgress.TProgress.DefaultUpdatePart", "text": " ", "tags": "", "loc": "CastleProgress.TProgress.html#DefaultUpdatePart"},
     {"title": "CastleProgress.TProgress.DefaultUpdateDelay", "text": " ", "tags": "", "loc": "CastleProgress.TProgress.html#DefaultUpdateDelay"},
     {"title": "CastleProgress.TProgress.Init", "text": " You can call Init only when Active = false (that is, you cannot Init while another progress is working). Initializes <a class=\"normal\" href=\"CastleProgress.TProgress.html#Max\">Max</a>, <a class=\"normal\" href=\"CastleProgress.TProgress.html#Title\">Title</a>, sets <a class=\"normal\" href=\"CastleProgress.TProgress.html#Position\">Position</a> to 0 and changes <a class=\"normal\" href=\"CastleProgress.TProgress.html#Active\">Active</a> to true.  <p><a class=\"normal\" href=\"CastleProgress.TProgress.html#UserInterface\">UserInterface</a> must be initialized (non-nil) when calling Init, and you cannot change <a class=\"normal\" href=\"CastleProgress.TProgress.html#UserInterface\">UserInterface</a> when progress is Active (i.e. before you call Fini).  <p>If DelayUserInterface is set to <code>True</code>, a very useful optimization is performed: <code>TProgress.Init</code> will not immediately result in <a class=\"normal\" href=\"CastleProgress.TProgressUserInterface.html#Init\">TProgressUserInterface.Init</a> call. Instead, actual initialization of the interface will be delayed until some TProgress.Update, when <a class=\"normal\" href=\"CastleProgress.TProgress.html#UpdateDelay\">UpdateDelay</a> time will pass.  <p>The advantage of DelayUserInterface is that if an operation will take a very short time, we will not waste time on possibly lengthy initialization of the progress bar interface. For example, <a class=\"normal\" href=\"CastleWindowProgress.html\">CastleWindowProgress</a> may have to capture OpenGL screen at the initialization, which takes a noticeable fraction of second by itself. So it's not sensible to init <a class=\"normal\" href=\"CastleWindowProgress.html\">CastleWindowProgress</a> if an entire operation between Progress.Init and Fini will take only 0.001 of second..  <p>The only downside of DelayUserInterface is that it's not applicable to an operation with very few steps (e.g. 1) that may take a long time. If a time between Init and the first Update or Fini is really large, the progress bar will not be visible.    ", "tags": "", "loc": "CastleProgress.TProgress.html#Init"},
     {"title": "CastleProgress.TProgress.Step", "text": " Use only when <a class=\"normal\" href=\"CastleProgress.TProgress.html#Active\">Active</a>, that is between <a class=\"normal\" href=\"CastleProgress.TProgress.html#Init\">Init</a> and <a class=\"normal\" href=\"CastleProgress.TProgress.html#Fini\">Fini</a> calls.  <p><a class=\"normal\" href=\"CastleProgress.TProgress.html#Position\">Position</a> always stays &lt;= <a class=\"normal\" href=\"CastleProgress.TProgress.html#Max\">Max</a> (you can depend on this when implementaing <a class=\"normal\" href=\"CastleProgress.TProgressUserInterface.html\">TProgressUserInterface</a> descendants). But it is legal to try to raise <a class=\"normal\" href=\"CastleProgress.TProgress.html#Position\">Position</a> above <a class=\"normal\" href=\"CastleProgress.TProgress.html#Max\">Max</a> by using this method, we will silently clamp <a class=\"normal\" href=\"CastleProgress.TProgress.html#Position\">Position</a> to <a class=\"normal\" href=\"CastleProgress.TProgress.html#Max\">Max</a>. This is usefull when given <a class=\"normal\" href=\"CastleProgress.TProgress.html#Max\">Max</a> was only an approximation of needed steps.    ", "tags": "", "loc": "CastleProgress.TProgress.html#Step"},
     {"title": "CastleProgress.TProgress.Fini", "text": " You can call it only when Active = true (that is, if you called Init before). Fini changes Active to false.  <p>Note that it's perfectly legal to call Fini before Position reaches Max (it's sensible e.g. when you're allowing user to break some lenghty operation, or when Max was only an approximation of steps needed).    ", "tags": "", "loc": "CastleProgress.TProgress.html#Fini"},
     {"title": "CastleProgress.TProgress.Create", "text": "    ", "tags": "", "loc": "CastleProgress.TProgress.html#Create"},
     {"title": "CastleProgress.TProgress.UserInterface", "text": " ", "tags": "", "loc": "CastleProgress.TProgress.html#UserInterface"},
     {"title": "CastleProgress.TProgress.UpdatePart", "text": " Position must change by (1/<code>UpdatePart</code>) * Max and at the same time at least <a class=\"normal\" href=\"CastleProgress.TProgress.html#UpdateDelay\">UpdateDelay</a> seconds must pass to redraw.  <p>This allows you to call <a class=\"normal\" href=\"CastleProgress.TProgress.html#Step\">Step</a> very often, without worrying that you cause redraw too often (which would cause slowdown).  <p><a class=\"normal\" href=\"CastleProgress.TProgress.html#UpdateDelay\">UpdateDelay</a> default value is <a class=\"normal\" href=\"CastleProgress.TProgress.html#DefaultUpdateDelay\">DefaultUpdateDelay</a>.  ", "tags": "", "loc": "CastleProgress.TProgress.html#UpdatePart"},
     {"title": "CastleProgress.TProgress.UpdateDelay", "text": " ", "tags": "", "loc": "CastleProgress.TProgress.html#UpdateDelay"},
     {"title": "CastleProgress.TProgress.Position", "text": " Always &gt;= 0 and &lt;= <a class=\"normal\" href=\"CastleProgress.TProgress.html#Max\">Max</a>.  <p>You can set this property only when <a class=\"normal\" href=\"CastleProgress.TProgress.html#Active\">Active</a>. Setting it to something &gt; <a class=\"normal\" href=\"CastleProgress.TProgress.html#Max\">Max</a> will be silently clamped to <a class=\"normal\" href=\"CastleProgress.TProgress.html#Max\">Max</a>. You can only increase it (trying to decrease it will be silently ignored, which is useful if your position information is only an approximation). In other words, setthing this property is equivalent to appropriate <a class=\"normal\" href=\"CastleProgress.TProgress.html#Step\">Step</a> call. ", "tags": "", "loc": "CastleProgress.TProgress.html#Position"},
     {"title": "CastleProgress.TProgress.Max", "text": " ", "tags": "", "loc": "CastleProgress.TProgress.html#Max"},
     {"title": "CastleProgress.TProgress.Title", "text": " ", "tags": "", "loc": "CastleProgress.TProgress.html#Title"},
     {"title": "CastleProgress.TProgress.Active", "text": " Init changes Active to true, Fini changes Active to false. ", "tags": "", "loc": "CastleProgress.TProgress.html#Active"},
     {"title": "CastleProgress.TProgressNullInterface", "text": " ", "tags": "", "loc": "CastleProgress.TProgressNullInterface.html"},
     {"title": "CastleProgress.TProgressNullInterface.Init", "text": "    ", "tags": "", "loc": "CastleProgress.TProgressNullInterface.html#Init"},
     {"title": "CastleProgress.TProgressNullInterface.Update", "text": "    ", "tags": "", "loc": "CastleProgress.TProgressNullInterface.html#Update"},
     {"title": "CastleProgress.TProgressNullInterface.Fini", "text": "    ", "tags": "", "loc": "CastleProgress.TProgressNullInterface.html#Fini"},
     {"title": "CastleProgress.Progress", "text": " Created in initialization of this unit, freed in finalization. ", "tags": "", "loc": "CastleProgress.html#Progress"},
     {"title": "CastleProgress.ProgressNullInterface", "text": "  <p>If you set Progress.UserInterface to this, then progress Init/Update/Fini will work &mdash; but will not be displayed anywhere. This is done at the initialization of this unit, so you can safely use progress bars even before real interface is initialized.  <p>Created in initialization, freed in finalization. ", "tags": "", "loc": "CastleProgress.html#ProgressNullInterface"},
     {"title": "CastleProgressConsole", "text": "  <p>You can assign <a class=\"normal\" href=\"CastleProgressConsole.html#ProgressConsoleInterface\">ProgressConsoleInterface</a> to Progress.UserInterface, like  <p></p>  <pre class=\"longcode\">Progress.UserInterface := ProgressConsoleInterface;</pre>  <p>  <p>and then all progress bars will be displayed on console.  <p>This displays a title surrounded by [] characters and the progress is indicated by displaying dots. This way we visualize progress incrementing from 0 to 100%, and at the same time we use only normal streaming I/O on StdErr. Totally no console/terminal specific operations, no special codes, no Crt / Curses unit's used etc. So this unit doesn't create any terminal compatibility problems, doesn't mess standard input/output/error streams etc.  <p>The only restriction is that you should not output anything (on stdout and stderr) to not mess the displayed progress bar. Of course, the worse that will happen is that the progress bar will stop looking good for user, nothing more.  <p>If you really want a progress bar that uses your terminal capabilities see ProgressVideo unit, that displays progress on terminal by FPC's Video unit. ", "tags": "", "loc": "CastleProgressConsole.html"},
     {"title": "CastleProgressConsole.TProgressConsoleInterface", "text": " ", "tags": "", "loc": "CastleProgressConsole.TProgressConsoleInterface.html"},
     {"title": "CastleProgressConsole.TProgressConsoleInterface.Init", "text": "    ", "tags": "", "loc": "CastleProgressConsole.TProgressConsoleInterface.html#Init"},
     {"title": "CastleProgressConsole.TProgressConsoleInterface.Update", "text": "    ", "tags": "", "loc": "CastleProgressConsole.TProgressConsoleInterface.html#Update"},
     {"title": "CastleProgressConsole.TProgressConsoleInterface.Fini", "text": "    ", "tags": "", "loc": "CastleProgressConsole.TProgressConsoleInterface.html#Fini"},
     {"title": "CastleProgressConsole.ProgressConsoleInterface", "text": " This instance is created in initialization, freed in finalization. ", "tags": "", "loc": "CastleProgressConsole.html#ProgressConsoleInterface"},
     {"title": "CastleProjection", "text": " ", "tags": "", "loc": "CastleProjection.html"},
     {"title": "CastleProjection.TProjection", "text": " To change the currently displayed projection, you usually want to override the <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#CalculateProjection\">TCastleAbstractViewport.CalculateProjection</a>. ", "tags": "", "loc": "CastleProjection.TProjection.html"},
     {"title": "CastleProjection.TProjection.ProjectionType", "text": " ", "tags": "", "loc": "CastleProjection.TProjection.html#ProjectionType"},
     {"title": "CastleProjection.TProjection.PerspectiveAngles", "text": "  <p>Note that when overriding the <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#CalculateProjection\">TCastleAbstractViewport.CalculateProjection</a>, you are expected to provide both angles calculated, even though some routines for now will only use the vertical angle (and automatically adjust the other to the aspect ratio). Use the <a class=\"normal\" href=\"CastleProjection.html#AdjustViewAngleDegToAspectRatio\">AdjustViewAngleDegToAspectRatio</a> to calculate the angles as necessary. ", "tags": "", "loc": "CastleProjection.TProjection.html#PerspectiveAngles"},
     {"title": "CastleProjection.TProjection.Dimensions", "text": " ", "tags": "", "loc": "CastleProjection.TProjection.html#Dimensions"},
     {"title": "CastleProjection.TProjection.ProjectionNear", "text": " Everything closer to this distance is clipped (invisible). ", "tags": "", "loc": "CastleProjection.TProjection.html#ProjectionNear"},
     {"title": "CastleProjection.TProjection.ProjectionFar", "text": " Everything further than this distance is clipped (invisible). Note that it have a special value <a class=\"normal\" href=\"CastleProjection.html#ZFarInfinity\">ZFarInfinity</a>, which means that no far clipping plane is used. E.g. shadow volumes require this. ", "tags": "", "loc": "CastleProjection.TProjection.html#ProjectionFar"},
     {"title": "CastleProjection.TProjection.ProjectionFarFinite", "text": " Unlike <a class=\"normal\" href=\"CastleProjection.TProjection.html#ProjectionFar\">ProjectionFar</a>, this property cannot have a magical value <a class=\"normal\" href=\"CastleProjection.html#ZFarInfinity\">ZFarInfinity</a>. It should be calculated just like <a class=\"normal\" href=\"CastleProjection.TProjection.html#ProjectionFar\">ProjectionFar</a>, except it's never changed to be <a class=\"normal\" href=\"CastleProjection.html#ZFarInfinity\">ZFarInfinity</a>. ", "tags": "", "loc": "CastleProjection.TProjection.html#ProjectionFarFinite"},
     {"title": "CastleProjection.TProjection.Matrix", "text": "    ", "tags": "", "loc": "CastleProjection.TProjection.html#Matrix"},
     {"title": "CastleProjection.ZFarInfinity", "text": " These functions include like <a class=\"normal\" href=\"CastleProjection.html#FrustumProjectionMatrix\">FrustumProjectionMatrix</a>, <a class=\"normal\" href=\"CastleProjection.html#PerspectiveProjectionMatrixDeg\">PerspectiveProjectionMatrixDeg</a>, <a class=\"normal\" href=\"CastleProjection.html#PerspectiveProjectionMatrixRad\">PerspectiveProjectionMatrixRad</a>, <a class=\"normal\" href=\"CastleGLUtils.html#PerspectiveProjection\">PerspectiveProjection</a>. You can pass <code>ZFarInfinity</code> as their <code>ZFar</code> parameter value.  <p><i>Implementation note:</i> It would be &quot;cooler&quot; to define this constant as Math.Infinity, but operating on Math.Infinity requires unnecessary turning off of some compiler checks. The point was only to have some special ZFar value, so 0 is as good as Infinity. ", "tags": "", "loc": "CastleProjection.html#ZFarInfinity"},
     {"title": "CastleProjection.AdjustViewAngleDegToAspectRatio", "text": " Given one viewing angle of the camera (FirstViewAngleDeg) and aspect ratio of your window sizes (SecondToFirstRatio), calculate second viewing angle of the camera.  <p>The intention is that when projecting camera view (with given view angles) on a screen with given aspect ratio), the image will not be distorted (squeezed horizontally or vertically).  <p>For the &quot;Deg&quot; version both angles (given and returned) are in degress, for the &quot;Rad&quot; version both angles and in radians.  <p>    ", "tags": "", "loc": "CastleProjection.html#AdjustViewAngleDegToAspectRatio"},
     {"title": "CastleProjection.AdjustViewAngleRadToAspectRatio", "text": "    ", "tags": "", "loc": "CastleProjection.html#AdjustViewAngleRadToAspectRatio"},
     {"title": "CastleProjection.OrthoProjectionMatrix", "text": " That are equivalent to OpenGL glOrtho, glFrustum, gluPerspective.  <p>The frustum and pespective generation (routines <a class=\"normal\" href=\"CastleProjection.html#FrustumProjectionMatrix\">FrustumProjectionMatrix</a>, <a class=\"normal\" href=\"CastleProjection.html#PerspectiveProjectionMatrixDeg\">PerspectiveProjectionMatrixDeg</a>, <a class=\"normal\" href=\"CastleProjection.html#PerspectiveProjectionMatrixRad\">PerspectiveProjectionMatrixRad</a>) accept also a special value <a class=\"normal\" href=\"CastleProjection.html#ZFarInfinity\">ZFarInfinity</a> as the ZFar parameter. Then you get perspective projection matrix withour far clipping plane, which is very useful for the z-fail shadow volumes technique.     ", "tags": "", "loc": "CastleProjection.html#OrthoProjectionMatrix"},
     {"title": "CastleProjection.OrthoProjectionMatrix", "text": "    ", "tags": "", "loc": "CastleProjection.html#OrthoProjectionMatrix"},
     {"title": "CastleProjection.Ortho2DProjectionMatrix", "text": "    ", "tags": "", "loc": "CastleProjection.html#Ortho2DProjectionMatrix"},
     {"title": "CastleProjection.Ortho2DProjectionMatrix", "text": "    ", "tags": "", "loc": "CastleProjection.html#Ortho2DProjectionMatrix"},
     {"title": "CastleProjection.FrustumProjectionMatrix", "text": "    ", "tags": "", "loc": "CastleProjection.html#FrustumProjectionMatrix"},
     {"title": "CastleProjection.FrustumProjectionMatrix", "text": "    ", "tags": "", "loc": "CastleProjection.html#FrustumProjectionMatrix"},
     {"title": "CastleProjection.PerspectiveProjectionMatrixDeg", "text": "    ", "tags": "", "loc": "CastleProjection.html#PerspectiveProjectionMatrixDeg"},
     {"title": "CastleProjection.PerspectiveProjectionMatrixRad", "text": "    ", "tags": "", "loc": "CastleProjection.html#PerspectiveProjectionMatrixRad"},
     {"title": "CastleProjection.TProjectionType", "text": "  ptOrthographic    ptPerspective    ptFrustum   ", "tags": "", "loc": "CastleProjection.html#TProjectionType"},
     {"title": "CastleQuaternions", "text": "  ", "tags": "", "loc": "CastleQuaternions.html"},
     {"title": "CastleQuaternions.TQuaternion", "text": " Note that, while this structure (and some, but not all, of it's methods) can handle <i>any</i> quaternion, you are usually interested <i>only in <b>unit quaternions</b>, that can represent a 3D rotation</i>. ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html"},
     {"title": "CastleQuaternions.TQuaternion.Data", "text": " ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#Data"},
     {"title": "CastleQuaternions.TQuaternion.ZeroRotation", "text": " Note: this is <i>not</i> a quaternion filled with zeros (the <code>Data.Real</code> component is 1.0), instead this is a unit quaternion that correctly represents <i>&quot;rotation by zero degrees/radians&quot;</i>.    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#ZeroRotation"},
     {"title": "CastleQuaternions.TQuaternion.ToAxisAngle", "text": " This is the reverse of <a class=\"normal\" href=\"CastleQuaternions.html#QuatFromAxisAngle\">QuatFromAxisAngle</a>.    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#ToAxisAngle"},
     {"title": "CastleQuaternions.TQuaternion.ToAxisAngle", "text": " Axis is normalized if quaternion was also normalized (which is true if working with rotation quaternions). Angle is in radians.    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#ToAxisAngle"},
     {"title": "CastleQuaternions.TQuaternion.ToRotationMatrix", "text": "    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#ToRotationMatrix"},
     {"title": "CastleQuaternions.TQuaternion.Rotate", "text": " For this operation to make sense in 3D, this must be a &quot;unit&quot; quaternion (which is created by a function like <a class=\"normal\" href=\"CastleQuaternions.html#QuatFromAxisAngle\">QuatFromAxisAngle</a>).  <p>You can pass here <a class=\"normal\" href=\"CastleVectors.html#TVector4\">TVector4</a>, which is then understood to be a 3D position in homogeneous coordinates.     ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#Rotate"},
     {"title": "CastleQuaternions.TQuaternion.Rotate", "text": "    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#Rotate"},
     {"title": "CastleQuaternions.TQuaternion.Conjugate", "text": " This is just a fancy name for negating <code>Data.Vector</code>.     ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#Conjugate"},
     {"title": "CastleQuaternions.TQuaternion.ConjugateMe", "text": "    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#ConjugateMe"},
     {"title": "CastleQuaternions.TQuaternion.NormalizeMe", "text": "    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#NormalizeMe"},
     {"title": "CastleQuaternions.TQuaternion.Normalize", "text": "    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#Normalize"},
     {"title": "CastleQuaternions.TQuaternion.LazyNormalizeMe", "text": " It checks if the quaternion needs normalization using fast <a class=\"normal\" href=\"CastleVectors.html#VectorLenSqr\">VectorLenSqr</a>, that is quaternion length is not needed for the check (sqrt not needed). Only if it's significantly different that 1.0, sqrt is done and quaternion is normalized.  <p>This may be useful if you fear of eventual errors because of floating-point error cumulations, e.g. when you repeatedly multiply one quaternion by another, and yet another, and yet another etc. Calling this will trigger normalization from time to time (although will tolerate very small, epsilon-like, differences that are normal). Thus it prevents the quaternion from getting &quot;too unnormalized&quot;.  <p>Generally, this is not needed, as quaternions are nicely numerically stable (which means that quaternion &quot;very slightly unnormalized&quot; will only generate &quot;very slightly wrong&quot; results, so it's not that bad). And no, I didn't actually observe the need for this in my programs. But you can see it actually called when you use TMatrixExaminer and deliberately cause spinning by very very large value (e.g. run view3dscene and press and hold right key, this will cause model spinning very fast, which causes quat multiplication every frame). So possibly this would trigger incorrect quaternions at some point.  <p>Anyway, this remains mostly a paranoid correctness measure.    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#LazyNormalizeMe"},
     {"title": "CastleQuaternions.TQuaternion.LazyNormalize", "text": "    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#LazyNormalize"},
     {"title": "CastleQuaternions.TQuaternion.*", "text": "  <p>Geometric interpretation: If these are unit quaternions representing rotations, multiplying them calculates one rotation that has the same effect as rotating by Q2 and then by Q1.  <p>Normal of result is equal to norm of Q1 * norm of Q2 (in particular, multiplying unit quaternions (used for rotations) yields another unit quaternion for sure).    ", "tags": "", "loc": "CastleQuaternions.TQuaternion.html#*"},
     {"title": "CastleQuaternions.QuatIdentityRot", "text": " ", "tags": "", "loc": "CastleQuaternions.html#QuatIdentityRot"},
     {"title": "CastleQuaternions.QuatFromAxisAngle", "text": "  <p>Axis must be normalized, or you have to pass NormalizeAxis = true (then we'll normalize it ourselves inside). Otherwise you will get non-normalized quaternion that doesn't represent rotation, and is usually useless for us.    ", "tags": "", "loc": "CastleQuaternions.html#QuatFromAxisAngle"},
     {"title": "CastleQuaternions.QuatFromAxisAngle", "text": "    ", "tags": "", "loc": "CastleQuaternions.html#QuatFromAxisAngle"},
     {"title": "CastleQuaternions.SLerp", "text": "  <p>The overloaded version that works with <a class=\"normal\" href=\"CastleVectors.html#TVector4\">TVector4</a> takes a rotation (not a quaternion) expressed as an axis (first 3 elements) and angle (in radians, 4th element). Axis does not have to be normalized (we'll normalize it). This is nice e.g. to interpolate VRML/X3D rotations.  <p>    ", "tags": "", "loc": "CastleQuaternions.html#SLerp"},
     {"title": "CastleQuaternions.SLerp", "text": "    ", "tags": "", "loc": "CastleQuaternions.html#SLerp"},
     {"title": "CastleQuaternions.NLerp", "text": "  <p>This is faster than <a class=\"normal\" href=\"CastleQuaternions.html#SLerp\">SLerp</a>, but does not guarantee the interpolated result travels with constant speed. Often it's not a noticeable / important problem (see <a  href=\"http://number-none.com/product/Understanding%20Slerp,%20Then%20Not%20Using%20It/\">http://number-none.com/product/Understanding%20Slerp,%20Then%20Not%20Using%20It/</a>)  <p>When ForceShortestPath = <code>False</code>, this doesn't guarantee choosing the shortest path. Although it goes through the <i>straightest</i> path, there are two such paths, it may go through the shorter or longer one. Use ForceShortestPath = <code>True</code> if you want to interpolate through the shortest.  <p>The overloaded version that works with <a class=\"normal\" href=\"CastleVectors.html#TVector4\">TVector4</a> takes a rotation (not a quaternion) expressed as an axis (first 3 elements) and angle (in radians, 4th element). Axis does not have to be normalized (we'll normalize it). This is nice e.g. to interpolate VRML/X3D rotations.  <p>    ", "tags": "", "loc": "CastleQuaternions.html#NLerp"},
     {"title": "CastleQuaternions.NLerp", "text": "    ", "tags": "", "loc": "CastleQuaternions.html#NLerp"},
     {"title": "CastleRandom", "text": " ", "tags": "", "loc": "CastleRandom.html"},
     {"title": "CastleRandom.TCastleRandom", "text": " Implementation of XorShift algorithm for random numbers generation. In some cases it works 2 to 3 times faster than native FPC random function. It also allows for multiple repeatable random seeds to support parallel pseudo-random sequences. The algorithm should not be used for cryptographic purposes, because it's speed-oriented (with quality ok for game, but not cryptographic use), and might subject to change in future. ", "tags": "", "loc": "CastleRandom.TCastleRandom.html"},
     {"title": "CastleRandom.TCastleRandom.Create", "text": " Parameter RandomSeed value 0 indicates to use a random seed (derived from current time and some other paramteres).    ", "tags": "", "loc": "CastleRandom.TCastleRandom.html#Create"},
     {"title": "CastleRandom.TCastleRandom.Initialize", "text": " The seed must be a non-zero integer. Provide Zero value to <code>initialize</code> random seed based on current time (CPU ticks) and some other paramteres. This procedure is thread-safe, you'll get different random seeds even if initialization happens absolutely simultaneously.    ", "tags": "", "loc": "CastleRandom.TCastleRandom.html#Initialize"},
     {"title": "CastleRandom.TCastleRandom.Random", "text": "    ", "tags": "", "loc": "CastleRandom.TCastleRandom.html#Random"},
     {"title": "CastleRandom.TCastleRandom.Random", "text": "    ", "tags": "", "loc": "CastleRandom.TCastleRandom.html#Random"},
     {"title": "CastleRandom.TCastleRandom.RandomInt64", "text": "    ", "tags": "", "loc": "CastleRandom.TCastleRandom.html#RandomInt64"},
     {"title": "CastleRandom.TCastleRandom.RandomBoolean", "text": " Something like flipping a coin...    ", "tags": "", "loc": "CastleRandom.TCastleRandom.html#RandomBoolean"},
     {"title": "CastleRandom.TCastleRandom.RandomSign", "text": "    ", "tags": "", "loc": "CastleRandom.TCastleRandom.html#RandomSign"},
     {"title": "CastleRandom.TCastleRandom.Random32bit", "text": " High(LongWord) range.    ", "tags": "", "loc": "CastleRandom.TCastleRandom.html#Random32bit"},
     {"title": "CastleRandom.StringToHash", "text": " It may be used for better initialization of user defined random seeds (e.g. &quot;My New World&quot; sounds much better than 6592202398) or for better sorting/searching of strings. Warning: the hash is deterministic, but the result may be different depending on CPU architecture or endianness (test required).  <p>    InputString The input string Seed Optional parameter enabling initialization of the algorithm seed different from default Unsigned 32-bit integer InputString The input string Seed Optional parameter enabling initialization of the algorithm seed different from default", "tags": "", "loc": "CastleRandom.html#StringToHash"},
     {"title": "CastleRandom.Rand", "text": "    ", "tags": "", "loc": "CastleRandom.html#Rand"},
     {"title": "CastleRandom.Rnd", "text": "    ", "tags": "", "loc": "CastleRandom.html#Rnd"},
     {"title": "CastleRandom.Rnd", "text": "    ", "tags": "", "loc": "CastleRandom.html#Rnd"},
     {"title": "CastleRays", "text": " This is used by ray-tracing (casting a ray for each image pixel) or when picking objects (what 3D object/point is indicated by the current mouse position). ", "tags": "", "loc": "CastleRays.html"},
     {"title": "CastleRays.TRaysWindow", "text": " ", "tags": "", "loc": "CastleRays.TRaysWindow.html"},
     {"title": "CastleRays.TRaysWindow.Create", "text": " Calculates some values based on camera settings, this way many calls to <a class=\"normal\" href=\"CastleRays.TRaysWindow.html#PrimaryRay\">PrimaryRay</a> for the same camera settings are fast (useful for ray-tracers).    ", "tags": "", "loc": "CastleRays.TRaysWindow.html#Create"},
     {"title": "CastleRays.TRaysWindow.CreateDescendant", "text": " Constructs non-abstract descendant (<a class=\"normal\" href=\"CastleRays.TPerspectiveRaysWindow.html\">TPerspectiveRaysWindow</a> or <a class=\"normal\" href=\"CastleRays.TOrthographicRaysWindow.html\">TOrthographicRaysWindow</a>, depending on Projection.ProjectionType).    ", "tags": "", "loc": "CastleRays.TRaysWindow.html#CreateDescendant"},
     {"title": "CastleRays.TRaysWindow.PrimaryRay", "text": "  <p>X, Y coordinates start from (0, 0) if bottom left (like in typical 2D OpenGL). When they are integers and in the range of X = 0..ScreenWidth-1 (left..right), Y = 0..ScreenHeight-1 (bottom..top) it's guaranteed that resulting ray will go exactly through the middle of the appropriate pixel (on imaginary &quot;rzutnia&quot; = image positioned paraller to view direction). But you can provide non-integer X, Y, useful for multisampling (taking many samples within the pixel, like (X, Y) = (PixX + Random - 0.5, PixY + Random - 0.5)).  <p>Resulting RayDirection is guaranteed to be normalized (this is in practice not costly to us, and it often helps &mdash; when ray direction is normalized, various distances from ray collisions are &quot;real&quot;).    ", "tags": "", "loc": "CastleRays.TRaysWindow.html#PrimaryRay"},
     {"title": "CastleRays.TRaysWindow.CamPosition", "text": " Initialized in the constructor. Must be given already normalized. Note that <a class=\"normal\" href=\"CastleRays.TRaysWindow.html#CamUp\">CamUp</a> may be changed in constructor, to be always perfectly orthogonal to <a class=\"normal\" href=\"CastleRays.TRaysWindow.html#CamDirection\">CamDirection</a>.  <p> ", "tags": "", "loc": "CastleRays.TRaysWindow.html#CamPosition"},
     {"title": "CastleRays.TRaysWindow.CamDirection", "text": " ", "tags": "", "loc": "CastleRays.TRaysWindow.html#CamDirection"},
     {"title": "CastleRays.TRaysWindow.CamUp", "text": " ", "tags": "", "loc": "CastleRays.TRaysWindow.html#CamUp"},
     {"title": "CastleRays.TPerspectiveRaysWindow", "text": " ", "tags": "", "loc": "CastleRays.TPerspectiveRaysWindow.html"},
     {"title": "CastleRays.TPerspectiveRaysWindow.Create", "text": "    ", "tags": "", "loc": "CastleRays.TPerspectiveRaysWindow.html#Create"},
     {"title": "CastleRays.TPerspectiveRaysWindow.PrimaryRay", "text": "    ", "tags": "", "loc": "CastleRays.TPerspectiveRaysWindow.html#PrimaryRay"},
     {"title": "CastleRays.TFrustumRaysWindow", "text": " ", "tags": "", "loc": "CastleRays.TFrustumRaysWindow.html"},
     {"title": "CastleRays.TFrustumRaysWindow.Create", "text": "    ", "tags": "", "loc": "CastleRays.TFrustumRaysWindow.html#Create"},
     {"title": "CastleRays.TFrustumRaysWindow.PrimaryRay", "text": "    ", "tags": "", "loc": "CastleRays.TFrustumRaysWindow.html#PrimaryRay"},
     {"title": "CastleRays.TOrthographicRaysWindow", "text": " ", "tags": "", "loc": "CastleRays.TOrthographicRaysWindow.html"},
     {"title": "CastleRays.TOrthographicRaysWindow.Create", "text": "    ", "tags": "", "loc": "CastleRays.TOrthographicRaysWindow.html#Create"},
     {"title": "CastleRays.TOrthographicRaysWindow.PrimaryRay", "text": "    ", "tags": "", "loc": "CastleRays.TOrthographicRaysWindow.html#PrimaryRay"},
     {"title": "CastleRays.PrimaryRay", "text": " Takes into account camera 3D settings and screen sizes. RayDirection will always be normalized, just like from <a class=\"normal\" href=\"CastleRays.TRaysWindow.html#PrimaryRay\">TRaysWindow.PrimaryRay</a>.  <p>If you want to call this many times for the same camera settings, it may be more optimal to create <a class=\"normal\" href=\"CastleRays.TRaysWindow.html\">TRaysWindow</a> instance first and call it's <a class=\"normal\" href=\"CastleRays.TRaysWindow.html#PrimaryRay\">TRaysWindow.PrimaryRay</a> method.    ", "tags": "", "loc": "CastleRays.html#PrimaryRay"},
     {"title": "CastleRayTracer", "text": " ", "tags": "", "loc": "CastleRayTracer.html"},
     {"title": "CastleRayTracer.TRayTracer", "text": " ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html"},
     {"title": "CastleRayTracer.TRayTracer.Octree", "text": " Must be set before calling <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#Execute\">Execute</a>. ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#Octree"},
     {"title": "CastleRayTracer.TRayTracer.Image", "text": " Must be set before calling <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#Execute\">Execute</a>.  <p>We will not resize given here Image. Instead we will use it's current size &mdash; so you just have to set Image size as appropriate before calling this method.  <p>For every pixel, we calculate it's color and store it by <code>TCastleImage.Color[X, Y, 0] := xxx</code> method. We don't modify alpha channel of the image.  <p>Using <a class=\"normal\" href=\"CastleImages.TRGBFloatImage.html\">TRGBFloatImage</a> class is advised if you want the full color information. Otherwise color precision is lost beyond 8 bits, and values above 1.0 are clamped. ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#Image"},
     {"title": "CastleRayTracer.TRayTracer.CamPosition", "text": " <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamDirection\">CamDirection</a> and <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamUp\">CamUp</a> do not have to be normalized &mdash; we will correct them here if needed. <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamUp\">CamUp</a> will be automatically corrected to be orthogonal to <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamDirection\">CamDirection</a> if necessary, you only make sure it's not parallel to <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamDirection\">CamDirection</a>. ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#CamPosition"},
     {"title": "CastleRayTracer.TRayTracer.CamDirection", "text": " <code>CamDirection</code> and <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamUp\">CamUp</a> do not have to be normalized &mdash; we will correct them here if needed. <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamUp\">CamUp</a> will be automatically corrected to be orthogonal to <code>CamDirection</code> if necessary, you only make sure it's not parallel to <code>CamDirection</code>. ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#CamDirection"},
     {"title": "CastleRayTracer.TRayTracer.CamUp", "text": " <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamDirection\">CamDirection</a> and <code>CamUp</code> do not have to be normalized &mdash; we will correct them here if needed. <code>CamUp</code> will be automatically corrected to be orthogonal to <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamDirection\">CamDirection</a> if necessary, you only make sure it's not parallel to <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#CamDirection\">CamDirection</a>. ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#CamUp"},
     {"title": "CastleRayTracer.TRayTracer.Projection", "text": " ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#Projection"},
     {"title": "CastleRayTracer.TRayTracer.SceneBGColor", "text": " ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#SceneBGColor"},
     {"title": "CastleRayTracer.TRayTracer.Background", "text": " ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#Background"},
     {"title": "CastleRayTracer.TRayTracer.PixelsMadeNotifier", "text": " This way you can display somewhere, or store to file, partially generated image. This callback gets information (in PixelsMadeCount) about how many pixels were generated (this includes also pixels skipped in case <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#FirstPixel\">FirstPixel</a> &gt; 0).  <p>The pixels are written in the order of <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSwapScanCurve.html\">TSwapScanCurve</a> for <a class=\"normal\" href=\"CastleRayTracer.TClassicRayTracer.html\">TClassicRayTracer</a>, and in order dependent on <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#SFCurveClass\">TPathTracer.SFCurveClass</a> for <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html\">TPathTracer</a>. When shadow cache will be implemented to <a class=\"normal\" href=\"CastleRayTracer.TClassicRayTracer.html\">TClassicRayTracer</a>, then configurable SFCurveClass may be done also for <a class=\"normal\" href=\"CastleRayTracer.TClassicRayTracer.html\">TClassicRayTracer</a>.  <p>Remember that pixels not done yet have the same content as they had when you <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#Execute\">Execute</a> method started. In other words, if you set <code>PixelsMadeNotifier</code> &lt;&gt; nil, then often it's desirable to initialize Image content with some color (e.g. <a class=\"normal\" href=\"CastleColors.html#Black\">black</a>) before calling <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#Execute\">Execute</a>. Otherwise at the time of <a class=\"normal\" href=\"CastleRayTracer.TRayTracer.html#Execute\">Execute</a> call, the pixels not done yet will have undefined colors. ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#PixelsMadeNotifier"},
     {"title": "CastleRayTracer.TRayTracer.PixelsMadeNotifierData", "text": " ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#PixelsMadeNotifierData"},
     {"title": "CastleRayTracer.TRayTracer.FirstPixel", "text": " By setting this to something &gt; 0, you can (re-)start rendering from the middle. Useful to finish the job of a previous terminated ray-tracer process.  <p>Must be in [0 .. Image.Width * Image.Height] range. Setting to <code>Image.Width * Image.Height</code> makes the ray-tracer do nothing. ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#FirstPixel"},
     {"title": "CastleRayTracer.TRayTracer.Execute", "text": "    ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#Execute"},
     {"title": "CastleRayTracer.TRayTracer.ExecuteStats", "text": " The statistics will be added to the given string list.    ", "tags": "", "loc": "CastleRayTracer.TRayTracer.html#ExecuteStats"},
     {"title": "CastleRayTracer.TClassicRayTracer", "text": " See [<a  href=\"http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/section.classic_ray_tracer.html\">http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/section.classic_ray_tracer.html</a>] for documentation.  <p>Make sure that VRML2Lights in states are properly initialized if you plan to render VRML 2.0 nodes. <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> and descendants do this for you automatically. ", "tags": "", "loc": "CastleRayTracer.TClassicRayTracer.html"},
     {"title": "CastleRayTracer.TClassicRayTracer.InitialDepth", "text": " 0 means that only primary rays will be cast, 1 means that primary rays and 1 ray into mirror / transmitted / shadow, and so on. ", "tags": "", "loc": "CastleRayTracer.TClassicRayTracer.html#InitialDepth"},
     {"title": "CastleRayTracer.TClassicRayTracer.FogNode", "text": " Set <code>FogNode</code> &lt;&gt; <code>Nil</code> to render a fog, following VRML 2.0/X3D lighting equations. FogNode.TransformScale is used. ", "tags": "", "loc": "CastleRayTracer.TClassicRayTracer.html#FogNode"},
     {"title": "CastleRayTracer.TClassicRayTracer.BaseLights", "text": " ", "tags": "", "loc": "CastleRayTracer.TClassicRayTracer.html#BaseLights"},
     {"title": "CastleRayTracer.TClassicRayTracer.OwnsBaseLights", "text": " ", "tags": "", "loc": "CastleRayTracer.TClassicRayTracer.html#OwnsBaseLights"},
     {"title": "CastleRayTracer.TClassicRayTracer.AppendStats", "text": "    ", "tags": "", "loc": "CastleRayTracer.TClassicRayTracer.html#AppendStats"},
     {"title": "CastleRayTracer.TClassicRayTracer.Execute", "text": "    ", "tags": "", "loc": "CastleRayTracer.TClassicRayTracer.html#Execute"},
     {"title": "CastleRayTracer.TClassicRayTracer.Destroy", "text": "    ", "tags": "", "loc": "CastleRayTracer.TClassicRayTracer.html#Destroy"},
     {"title": "CastleRayTracer.TPathTracer", "text": " See [<a  href=\"http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/section.path_tracer.html\">http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/section.path_tracer.html</a>] for documentation. ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html"},
     {"title": "CastleRayTracer.TPathTracer.MinDepth", "text": " The path has at least <code>MinDepth</code> length, and then Russian roulette is used.  <p>See [<a  href=\"http://castle-engine.sourceforge.net/rayhunter.php\">http://castle-engine.sourceforge.net/rayhunter.php</a>] documentation about &quot;&lt;recursion-depth&gt;&quot; and --r-roul-continue for suggestions about how to use these parameters. See also [<a  href=\"http://castle-engine.sourceforge.net/raytr_gallery.php\">http://castle-engine.sourceforge.net/raytr_gallery.php</a>] for some experiments with these values.  <p><a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#RRoulContinue\">RRoulContinue</a> must be in 0..1 range.  <p>You can give <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#RRoulContinue\">RRoulContinue</a> = 0 if you don't want to use Russian roulette at all (works OK because our comparison <code>Random &lt; <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#RRoulContinue\">RRoulContinue</a></code> uses &quot;&lt;&quot;, not &quot;&lt;=&quot;). Note that this causes bias (result is darker than it should be). Only <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#RRoulContinue\">RRoulContinue</a> &gt; 0 removes bias (the expected result is the correct one).  <p>Small <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#RRoulContinue\">RRoulContinue</a> values cause a lot of noise. Large <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#RRoulContinue\">RRoulContinue</a> values cause long rendering.  <p><code>MinDepth</code> must be &gt;= 0. You can use <code>MinDepth</code> = 0 to disable &quot;minimal path length&quot;, and use Russian roulette always (noisy).  ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html#MinDepth"},
     {"title": "CastleRayTracer.TPathTracer.RRoulContinue", "text": " ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html#RRoulContinue"},
     {"title": "CastleRayTracer.TPathTracer.PrimarySamplesCount", "text": " Both must be &gt; 0.  <p><code>PrimarySamplesCount</code> tells how many paths are used for primary ray, and is really useful only for anti-aliasing. You can set this to a few. Values above &tilde;10 are useless, they cause much longer rendering without really improving the result. You can set this to 1 if you don't need anti-aliasing.  <p><a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#NonPrimarySamplesCount\">NonPrimarySamplesCount</a> is the number of paths caused by each hit of a primary ray. This is the main quality control for the path-tracer, more paths mean that colors are gathered from more random samples, which means that final color is more accurate. In total you have pixels count * <code>PrimarySamplesCount</code> * <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#NonPrimarySamplesCount\">NonPrimarySamplesCount</a>, so beware when increasing this: you really have a lot paths. ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html#PrimarySamplesCount"},
     {"title": "CastleRayTracer.TPathTracer.NonPrimarySamplesCount", "text": " Both must be &gt; 0.  <p><a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#PrimarySamplesCount\">PrimarySamplesCount</a> tells how many paths are used for primary ray, and is really useful only for anti-aliasing. You can set this to a few. Values above &tilde;10 are useless, they cause much longer rendering without really improving the result. You can set this to 1 if you don't need anti-aliasing.  <p><code>NonPrimarySamplesCount</code> is the number of paths caused by each hit of a primary ray. This is the main quality control for the path-tracer, more paths mean that colors are gathered from more random samples, which means that final color is more accurate. In total you have pixels count * <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#PrimarySamplesCount\">PrimarySamplesCount</a> * <code>NonPrimarySamplesCount</code>, so beware when increasing this: you really have a lot paths. ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html#NonPrimarySamplesCount"},
     {"title": "CastleRayTracer.TPathTracer.DirectIllumSamplesCount", "text": " These are rays sent into random points of random light sources, to test if given light shines here.  <p>Set this to 0 to have a really naive path-tracing, that wanders randomly hoping to hit light source by chance. This will usually need an enormous amount of <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#PrimarySamplesCount\">PrimarySamplesCount</a> * <a class=\"normal\" href=\"CastleRayTracer.TPathTracer.html#NonPrimarySamplesCount\">NonPrimarySamplesCount</a> to given any sensible results.  <p>Set this to 1 or more for a normal path-tracer. ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html#DirectIllumSamplesCount"},
     {"title": "CastleRayTracer.TPathTracer.SFCurveClass", "text": " In theory, something like <a class=\"normal\" href=\"CastleSpaceFillingCurves.THilbertCurve.html\">THilbertCurve</a> or <a class=\"normal\" href=\"CastleSpaceFillingCurves.TPeanoCurve.html\">TPeanoCurve</a> could speed up rendering (because shadow cache is more utilized) compared to <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSwapScanCurve.html\">TSwapScanCurve</a>. But in practice, right now this doesn't give any noticeable benefit. ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html#SFCurveClass"},
     {"title": "CastleRayTracer.TPathTracer.AppendStats", "text": "    ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html#AppendStats"},
     {"title": "CastleRayTracer.TPathTracer.Create", "text": "    ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html#Create"},
     {"title": "CastleRayTracer.TPathTracer.Execute", "text": "    ", "tags": "", "loc": "CastleRayTracer.TPathTracer.html#Execute"},
     {"title": "CastleRayTracer.TPixelsMadeNotifierFunc", "text": "    ", "tags": "", "loc": "CastleRayTracer.html#TPixelsMadeNotifierFunc"},
     {"title": "CastleRayTracer.TRayTracerKind", "text": "  rtkClassic    rtkPathTracer   ", "tags": "", "loc": "CastleRayTracer.html#TRayTracerKind"},
     {"title": "CastleRecentFiles", "text": " ", "tags": "", "loc": "CastleRecentFiles.html"},
     {"title": "CastleRecentFiles.TRecentFiles", "text": "  <p>This is designed as a base class, usable on it's own, but also as a parent for classes that show this list inside a menu. For Lazarus menu version, see TLazRecentFiles. For <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> menu version, see <a class=\"normal\" href=\"CastleLCLRecentFiles.TCastleRecentFiles.html\">TCastleRecentFiles</a>. ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html"},
     {"title": "CastleRecentFiles.TRecentFiles.DefaultMaxCount", "text": " ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#DefaultMaxCount"},
     {"title": "CastleRecentFiles.TRecentFiles.MenuCreate", "text": "     ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#MenuCreate"},
     {"title": "CastleRecentFiles.TRecentFiles.MenuDestroy", "text": "    ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#MenuDestroy"},
     {"title": "CastleRecentFiles.TRecentFiles.Create", "text": "    ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#Create"},
     {"title": "CastleRecentFiles.TRecentFiles.Destroy", "text": "    ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#Destroy"},
     {"title": "CastleRecentFiles.TRecentFiles.Add", "text": "  <p>If MaybeStdIn, then we treat URL = '-' specially: it's ignored. Use this if your program interprets '-' as &quot;load file from standard input&quot;, such files should not be added to recent files menu.  <p>Note that we want to store only absolute <a class=\"normal\" href=\"CastleRecentFiles.TRecentFiles.html#URLs\">URLs</a>. So this method will always call <a class=\"normal\" href=\"CastleURIUtils.html#AbsoluteURI\">AbsoluteURI</a> (which will eventually call ExpandFileName on filename inside, and make sure it has appropriate protocol) on the given URL.    ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#Add"},
     {"title": "CastleRecentFiles.TRecentFiles.LoadFromConfig", "text": "     ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#LoadFromConfig"},
     {"title": "CastleRecentFiles.TRecentFiles.SaveToConfig", "text": "    ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#SaveToConfig"},
     {"title": "CastleRecentFiles.TRecentFiles.URLs", "text": " <i>This is readonly.</i> ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#URLs"},
     {"title": "CastleRecentFiles.TRecentFiles.OnOpenRecent", "text": " ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#OnOpenRecent"},
     {"title": "CastleRecentFiles.TRecentFiles.MaxCount", "text": " ", "tags": "", "loc": "CastleRecentFiles.TRecentFiles.html#MaxCount"},
     {"title": "CastleRecentFiles.TOnOpenRecent", "text": "    ", "tags": "", "loc": "CastleRecentFiles.html#TOnOpenRecent"},
     {"title": "CastleRectangles", "text": " ", "tags": "", "loc": "CastleRectangles.html"},
     {"title": "CastleRectangles.TRectangle", "text": " Useful for various 2D GUI operations.  <p>The area covered by the rectangle starts in (Left,Bottom) pixel and spans (Width,Height) pixels. This means that the <a class=\"normal\" href=\"CastleRectangles.TRectangle.html#Right\">right</a>-top pixel covered by the rectangle is (Left + Width - 1,Bottom + Height - 1). The rectangle is empty (<a class=\"normal\" href=\"CastleRectangles.TRectangle.html#Contains\">Contains</a> will always answer <code>False</code>) when either Width or Height are zero. Neither Width nor Height can ever be negative. ", "tags": "", "loc": "CastleRectangles.TRectangle.html"},
     {"title": "CastleRectangles.TRectangle.Left", "text": " ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Left"},
     {"title": "CastleRectangles.TRectangle.Bottom", "text": " ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Bottom"},
     {"title": "CastleRectangles.TRectangle.Width", "text": " ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Width"},
     {"title": "CastleRectangles.TRectangle.Height", "text": " ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Height"},
     {"title": "CastleRectangles.TRectangle.Empty", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Empty"},
     {"title": "CastleRectangles.TRectangle.IsEmpty", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#IsEmpty"},
     {"title": "CastleRectangles.TRectangle.Contains", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Contains"},
     {"title": "CastleRectangles.TRectangle.Contains", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Contains"},
     {"title": "CastleRectangles.TRectangle.Contains", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Contains"},
     {"title": "CastleRectangles.TRectangle.CenterInside", "text": " The given W, H may be smaller or larger than this rectangle sizes.    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#CenterInside"},
     {"title": "CastleRectangles.TRectangle.Grow", "text": " This adds a margin of Delta pixels around all sides of the rectangle, so in total width grows by 2 * Delta, and the same for height. In case of shrinking, we protect from shrinking too much: the resulting width or height is set to zero (which makes a valid and empty rectangle) if shrinking too much.    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Grow"},
     {"title": "CastleRectangles.TRectangle.Grow", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Grow"},
     {"title": "CastleRectangles.TRectangle.RemoveLeft", "text": " Returns an empty rectangle if you try to remove too much.     ", "tags": "", "loc": "CastleRectangles.TRectangle.html#RemoveLeft"},
     {"title": "CastleRectangles.TRectangle.RemoveBottom", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#RemoveBottom"},
     {"title": "CastleRectangles.TRectangle.RemoveRight", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#RemoveRight"},
     {"title": "CastleRectangles.TRectangle.RemoveTop", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#RemoveTop"},
     {"title": "CastleRectangles.TRectangle.GrowLeft", "text": "     ", "tags": "", "loc": "CastleRectangles.TRectangle.html#GrowLeft"},
     {"title": "CastleRectangles.TRectangle.GrowBottom", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#GrowBottom"},
     {"title": "CastleRectangles.TRectangle.GrowRight", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#GrowRight"},
     {"title": "CastleRectangles.TRectangle.GrowTop", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#GrowTop"},
     {"title": "CastleRectangles.TRectangle.LeftPart", "text": " This is similar to RemoveXxx methods, but here you specify which side to keep, as opposed to RemoveXxx methods where you specify which side you remove.  <p>If the requested size is larger than current size (for example, W &gt; Width for <code>LeftPart</code>) then the unmodified rectangle is returned.  <p>    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#LeftPart"},
     {"title": "CastleRectangles.TRectangle.BottomPart", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#BottomPart"},
     {"title": "CastleRectangles.TRectangle.RightPart", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#RightPart"},
     {"title": "CastleRectangles.TRectangle.TopPart", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#TopPart"},
     {"title": "CastleRectangles.TRectangle.Middle", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Middle"},
     {"title": "CastleRectangles.TRectangle.Center", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Center"},
     {"title": "CastleRectangles.TRectangle.ClampX", "text": " That is, clamp to <code>[Left, <a class=\"normal\" href=\"CastleRectangles.TRectangle.html#Right\">Right</a> - 1]</code>.    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ClampX"},
     {"title": "CastleRectangles.TRectangle.ClampY", "text": " That is, clamp to <code>[Bottom, Top - 1]</code>.    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ClampY"},
     {"title": "CastleRectangles.TRectangle.ScaleToWidth", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ScaleToWidth"},
     {"title": "CastleRectangles.TRectangle.ScaleToHeight", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ScaleToHeight"},
     {"title": "CastleRectangles.TRectangle.ScaleAroundCenter", "text": "  <p>Since the scaling is independent in each axis, this handles &quot;carefully&quot; a half-empty rectangles (when one size is &lt;= 0, but other is &gt; 0). It scales correctly the positive dimension (not just returns <a class=\"normal\" href=\"CastleRectangles.TRectangle.html#Empty\">Empty</a> constant), leaving the other dimension (it's position and size) untouched.    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ScaleAroundCenter"},
     {"title": "CastleRectangles.TRectangle.ScaleAroundMiddle", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ScaleAroundMiddle"},
     {"title": "CastleRectangles.TRectangle.ScaleAround0", "text": "  <p>Since the scaling is independent in each axis, this handles &quot;carefully&quot; a half-empty rectangles (when one size is &lt;= 0, but other is &gt; 0). It scales correctly the positive dimension (not just returns <a class=\"normal\" href=\"CastleRectangles.TRectangle.html#Empty\">Empty</a> constant), leaving the other dimension (it's position and size) untouched.  <p>These details matter, e.g. when you set <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Width\">TUIControlSizeable.Width</a>, but not <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Height\">TUIControlSizeable.Height</a>, and then you expect the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CalculatedWidth\">TUIControl.CalculatedWidth</a> to work.    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ScaleAround0"},
     {"title": "CastleRectangles.TRectangle.ScaleWidthAround0", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ScaleWidthAround0"},
     {"title": "CastleRectangles.TRectangle.ScaleHeightAround0", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ScaleHeightAround0"},
     {"title": "CastleRectangles.TRectangle.FitInside", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#FitInside"},
     {"title": "CastleRectangles.TRectangle.AlignCore", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#AlignCore"},
     {"title": "CastleRectangles.TRectangle.Align", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Align"},
     {"title": "CastleRectangles.TRectangle.AlignCore", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#AlignCore"},
     {"title": "CastleRectangles.TRectangle.Align", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Align"},
     {"title": "CastleRectangles.TRectangle.ToString", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#ToString"},
     {"title": "CastleRectangles.TRectangle.Translate", "text": " Empty rectangle after moving is still an empty rectangle.    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Translate"},
     {"title": "CastleRectangles.TRectangle.Collides", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Collides"},
     {"title": "CastleRectangles.TRectangle.+", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#+"},
     {"title": "CastleRectangles.TRectangle.*", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangle.html#*"},
     {"title": "CastleRectangles.TRectangle.Right", "text": " <code><code>Right</code></code> is simply the <code>Left + Width</code>, <code>Top</code> is simply the <code>Bottom + Height</code>.  <p>If you use this for drawing, note that the pixel with coordinates <code>(<code>Right</code>, Top)</code> is actually *outside* of the rectangle (by 1 pixel). That's because the rectangle starts at pixel <code>(Left, Bottom)</code> and spans the <code>(Width, Height)</code> pixels.  ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Right"},
     {"title": "CastleRectangles.TRectangle.Top", "text": " ", "tags": "", "loc": "CastleRectangles.TRectangle.html#Top"},
     {"title": "CastleRectangles.TRectangle.LeftBottom", "text": " ", "tags": "", "loc": "CastleRectangles.TRectangle.html#LeftBottom"},
     {"title": "CastleRectangles.TFloatRectangle", "text": " Useful for various 2D GUI operations, and for bounding boxes for 2D objects.  <p>The area covered by the rectangle starts at (Left,Bottom) position and spans (Width,Height) units. The rectangle is empty (<a class=\"normal\" href=\"CastleRectangles.TFloatRectangle.html#Contains\">Contains</a> will always answer <code>False</code>) when either Width or Height are less than zero. <b>This is consistent with it's 3D equivalent, <a class=\"normal\" href=\"CastleBoxes.TBox3D.html\">TBox3D</a>, and different from it's integer counterpart <a class=\"normal\" href=\"CastleRectangles.TRectangle.html\">TRectangle</a>.</b> In case of float bounding box (<a class=\"normal\" href=\"CastleBoxes.TBox3D.html\">TBox3D</a>) or float rectangle (<code>TFloatRectangle</code>), having a zero size makes sense, and it still is something non-empty (a single 2D or 3D point has zero size, but it also still has a position). ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html"},
     {"title": "CastleRectangles.TFloatRectangle.Left", "text": " procedure SetRight(const Value: Single); procedure SetTop(const Value: Single); ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Left"},
     {"title": "CastleRectangles.TFloatRectangle.Bottom", "text": " procedure SetRight(const Value: Single); procedure SetTop(const Value: Single); ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Bottom"},
     {"title": "CastleRectangles.TFloatRectangle.Width", "text": " ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Width"},
     {"title": "CastleRectangles.TFloatRectangle.Height", "text": " ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Height"},
     {"title": "CastleRectangles.TFloatRectangle.Empty", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Empty"},
     {"title": "CastleRectangles.TFloatRectangle.IsEmpty", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#IsEmpty"},
     {"title": "CastleRectangles.TFloatRectangle.Contains", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Contains"},
     {"title": "CastleRectangles.TFloatRectangle.Contains", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Contains"},
     {"title": "CastleRectangles.TFloatRectangle.Middle", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Middle"},
     {"title": "CastleRectangles.TFloatRectangle.Center", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Center"},
     {"title": "CastleRectangles.TFloatRectangle.Grow", "text": " This adds a margin of Delta pixels around all sides of the rectangle, so in total width grows by 2 * Delta, and the same for height. In case of shrinking, we protect from shrinking too much: the resulting width or height is set to zero (which makes a valid and empty rectangle) if shrinking too much.    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Grow"},
     {"title": "CastleRectangles.TFloatRectangle.Grow", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Grow"},
     {"title": "CastleRectangles.TFloatRectangle.ToString", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#ToString"},
     {"title": "CastleRectangles.TFloatRectangle.Translate", "text": " Empty rectangle after moving is still an empty rectangle.    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Translate"},
     {"title": "CastleRectangles.TFloatRectangle.Collides", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Collides"},
     {"title": "CastleRectangles.TFloatRectangle.CollidesDisc", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#CollidesDisc"},
     {"title": "CastleRectangles.TFloatRectangle.ScaleAround0", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#ScaleAround0"},
     {"title": "CastleRectangles.TFloatRectangle.Include", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Include"},
     {"title": "CastleRectangles.TFloatRectangle.ToX3DVector", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#ToX3DVector"},
     {"title": "CastleRectangles.TFloatRectangle.FromX3DVector", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#FromX3DVector"},
     {"title": "CastleRectangles.TFloatRectangle.+", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#+"},
     {"title": "CastleRectangles.TFloatRectangle.*", "text": "    ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#*"},
     {"title": "CastleRectangles.TFloatRectangle.Right", "text": " <code><code>Right</code></code> is simply the <code>Left + Width</code>, <code>Top</code> is simply the <code>Bottom + Height</code>.  <p>Note: If you use this for drawing, and the values of Left, Bottom, Width, Height are actually integers (or close to integers), then the pixel with <code>(Round(<code>Right</code>), Round(Top))</code> coordinates is actually *outside* of the rectangle (by 1 pixel). That's because the rectangle starts at the pixel <code>(Round(Left), Round(Bottom))</code> and spans the <code>(Round(Width), Round(Height))</code> pixels.  ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Right"},
     {"title": "CastleRectangles.TFloatRectangle.Top", "text": " ", "tags": "", "loc": "CastleRectangles.TFloatRectangle.html#Top"},
     {"title": "CastleRectangles.TRectangleList", "text": " ", "tags": "", "loc": "CastleRectangles.TRectangleList.html"},
     {"title": "CastleRectangles.TRectangleList.FindRectangle", "text": " Returns -1 if not found.    ", "tags": "", "loc": "CastleRectangles.TRectangleList.html#FindRectangle"},
     {"title": "CastleRectangles.TRectangleList.FindRectangle", "text": "    ", "tags": "", "loc": "CastleRectangles.TRectangleList.html#FindRectangle"},
     {"title": "CastleRectangles.Rectangle", "text": "    ", "tags": "", "loc": "CastleRectangles.html#Rectangle"},
     {"title": "CastleRectangles.Rectangle", "text": "    ", "tags": "", "loc": "CastleRectangles.html#Rectangle"},
     {"title": "CastleRectangles.FloatRectangle", "text": "    ", "tags": "", "loc": "CastleRectangles.html#FloatRectangle"},
     {"title": "CastleRectangles.FloatRectangle", "text": "    ", "tags": "", "loc": "CastleRectangles.html#FloatRectangle"},
     {"title": "CastleRectangles.FloatRectangle", "text": "    ", "tags": "", "loc": "CastleRectangles.html#FloatRectangle"},
     {"title": "CastleRectangles.THorizontalPosition", "text": "  <p>This is used by <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Align\">TUIControl.Align</a> and <a class=\"normal\" href=\"CastleRectangles.TRectangle.html#Align\">TRectangle.Align</a> to specify the alignment of one control/rectangle with respect to another. In case of <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Align\">TUIControl.Align</a>, this specifies the align of control with respect to the container (<a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> or <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a>).  <p>This is used to talk about position of the control and the container.  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> When we talk about the position of the control (for example ControlPosition for <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Align\">TUIControl.Align</a>), it determines which border of the control to align.</p></li>   <li value=\"2\"><p> When we talk about the position of the container (for example ContainerPosition for <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Align\">TUIControl.Align</a>), this specifies the container border.</p></li> </ol>  <p>  <p>In most cases you use equal both control and container borders. For example, both ControlPosition and ContainerPosition are usually equal for TUIControlPos.Align call. This allows to align left control edge to left container edge, or right control edge to right container edge, or to center control within the container &mdash; which is the most common usage.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>If both are <a class=\"normal\" href=\"CastleRectangles.html#hpLeft\">hpLeft</a>, then X specifies position of left control border relative to left container border. X should be &gt;= 0 if you want to see the control completely within the container.</p></li>   <li><p>If both are <a class=\"normal\" href=\"CastleRectangles.html#hpMiddle\">hpMiddle</a>, then X (most often just 0) specifies the shift between container middle to control middle. If X is zero, then control is just in the middle of the container.</p></li>   <li><p>If both are <a class=\"normal\" href=\"CastleRectangles.html#hpRight\">hpRight</a>, then X specifies position of right control border relative to right container border. X should be &lt;= 0 if you want to see the control completely within the container.</p></li> </ul>  <p>  <p>  hpLeft    hpMiddle    hpRight   ", "tags": "", "loc": "CastleRectangles.html#THorizontalPosition"},
     {"title": "CastleRectangles.TVerticalPosition", "text": "   vpBottom    vpMiddle    vpTop   ", "tags": "", "loc": "CastleRectangles.html#TVerticalPosition"},
     {"title": "CastleRectangles.PFloatRectangle", "text": " ", "tags": "", "loc": "CastleRectangles.html#PFloatRectangle"},
     {"title": "CastleRectangles.TFloatRectangleArray", "text": " ", "tags": "", "loc": "CastleRectangles.html#TFloatRectangleArray"},
     {"title": "CastleRectangles.PFloatRectangleArray", "text": " ", "tags": "", "loc": "CastleRectangles.html#PFloatRectangleArray"},
     {"title": "CastleRectangles.TFloatRectangleList", "text": " ", "tags": "", "loc": "CastleRectangles.html#TFloatRectangleList"},
     {"title": "CastleRenderer", "text": " You should never use this renderer directly, you should always use <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> that wraps this renderer and gives you simple method to render whole scene. TODO: this unit should be renamed to Internal at some point.  <p>The overview of the renderer can also be found in engine documentation [<a  href=\"http://castle-engine.sourceforge.net/engine_doc.php\">http://castle-engine.sourceforge.net/engine_doc.php</a>] in chapter &quot;OpenGL rendering&quot;, section &quot;Basic OpenGL rendering&quot;.  <p><b>Usage:</b>  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> Call <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#Prepare\">TGLRenderer.Prepare</a> for all the states that you want to later render. The order of calling <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#Prepare\">TGLRenderer.Prepare</a> methods doesn't matter, also you are free to prepare states that you will not actually use later. Of course a state, once prepared, may be used in rendering as many times as you want.  <p>It's important that you have to prepare <i>every state that you plan to later render</i>. During rendring the state must have exactly the same (fields, properties) values as when it was prepared. In particular, it must have the same pointers to nodes Last*/Active* and their contents also must be the same. <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#Prepare\">TGLRenderer.Prepare</a> may save some associations between objects and OpenGL resources, so it's important that the same pointer must always point to the same object (until it's unprepared).  <p><a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#Prepare\">TGLRenderer.Prepare</a> requires active OpenGL context. It doesn't modify OpenGL state (only allocates some resources like texture names). It cannot be called inside a display list. </p></li>   <li value=\"2\"><p> When you want to release resources, you should call TGLRenderer.Unprepare on nodes that you want to change or free. This should be used with nodes that were passed as Last*/Active* in some State for <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#Prepare\">TGLRenderer.Prepare</a>.  <p>Note that you cannot free the nodes before unpreparing them. The node instance must remain valid while it's prepared. </p></li>   <li value=\"3\"><p> To start actual rendering, call <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#RenderBegin\">TGLRenderer.RenderBegin</a>. To end rendering, call <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#RenderEnd\">TGLRenderer.RenderEnd</a>. Between these calls, you should not touch OpenGL state yourself &mdash; the renderer may depend that every state change goes through it. At the end of <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#RenderEnd\">TGLRenderer.RenderEnd</a>, the OpenGL state is restored just as it was before <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#RenderBegin\">TGLRenderer.RenderBegin</a>. </p></li>   <li value=\"4\"><p> Between <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#RenderBegin\">TGLRenderer.RenderBegin</a> and <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#RenderEnd\">TGLRenderer.RenderEnd</a> you should render the shapes by calling RenderShape.  <p>Remember that you can render only shapes that have Shape.State prepared by <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#Prepare\">TGLRenderer.Prepare</a>. </p></li>   <li value=\"5\"><p> Since the first prepare / render calls, this renderer assumes it's always called in the same OpenGL context. To break association with OpenGL context call <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#UnprepareAll\">TGLRenderer.UnprepareAll</a> (this is like calling TGLRenderer.Unprepare on every prepared thing + clearing some remaining resources). </p></li> </ol>  <p>  <p><b>OpenGL state affecting VRML rendering:</b>  <p>Some OpenGL state is unconditionally reset by <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#RenderBegin\">TGLRenderer.RenderBegin</a>.  <p>There's also some OpenGL state that we let affect our rendering. This allows you to customize rendering by using normal OpenGL commands.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Current glPolygonMode. This is used by <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> to optionally render wireframe. </p></li>   <li><p>Blending settings (GL_BLEND enabled state, glBlendFunc), and glDepthMask.  <p>This is used by <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> to render scenes with a mix of tranparent and opaque objects. Only <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> deals with it (not this renderer), as doing it correctly requires ordering the shapes. </p></li> </ul>  <p>  <p>The renderer uses arrays in GPU-friendly format defined by <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html\">TGeometryArrays</a>.  <p>They have the same number of triangles and vertices as calculated by TAbstractGeometryNode.Triangulate, TAbstractGeometryNode.LocalTriangulate, <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#TrianglesCount\">TAbstractGeometryNode.TrianglesCount</a>, <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#VerticesCount\">TAbstractGeometryNode.VerticesCount</a> (with OverTriangulate = <code>True</code>). ", "tags": "", "loc": "CastleRenderer.html"},
     {"title": "CastleRenderer.TRenderingAttributes", "text": "  <p>They are collected here, in a class separate from <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html\">TGLRenderer</a>, to allow <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> to hide internal <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html\">TGLRenderer</a> but still expose <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html\">TRenderingAttributes</a> instance. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html"},
     {"title": "CastleRenderer.TRenderingAttributes.DefaultPointSize", "text": " ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#DefaultPointSize"},
     {"title": "CastleRenderer.TRenderingAttributes.DefaultLineWidth", "text": " ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#DefaultLineWidth"},
     {"title": "CastleRenderer.TRenderingAttributes.DefaultBumpMapping", "text": " ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#DefaultBumpMapping"},
     {"title": "CastleRenderer.TRenderingAttributes.DefaultPhongShading", "text": " ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#DefaultPhongShading"},
     {"title": "CastleRenderer.TRenderingAttributes.SetOnRadianceTransfer", "text": "     ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetOnRadianceTransfer"},
     {"title": "CastleRenderer.TRenderingAttributes.SetOnVertexColor", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetOnVertexColor"},
     {"title": "CastleRenderer.TRenderingAttributes.SetEnableTextures", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetEnableTextures"},
     {"title": "CastleRenderer.TRenderingAttributes.SetMinificationFilter", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetMinificationFilter"},
     {"title": "CastleRenderer.TRenderingAttributes.SetMagnificationFilter", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetMagnificationFilter"},
     {"title": "CastleRenderer.TRenderingAttributes.SetBumpMapping", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetBumpMapping"},
     {"title": "CastleRenderer.TRenderingAttributes.SetMode", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetMode"},
     {"title": "CastleRenderer.TRenderingAttributes.SetShadowSampling", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetShadowSampling"},
     {"title": "CastleRenderer.TRenderingAttributes.SetVertexBufferObject", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetVertexBufferObject"},
     {"title": "CastleRenderer.TRenderingAttributes.SetVisualizeDepthMap", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetVisualizeDepthMap"},
     {"title": "CastleRenderer.TRenderingAttributes.SetPhongShading", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SetPhongShading"},
     {"title": "CastleRenderer.TRenderingAttributes.ReleaseCachedResources", "text": " This includes attributes that affect:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>How TShapeCache.Arrays contents are generated. For example, Generator uses TexCoordsNeeded, so changing any attribute that affects TexCoordsNeeded calls this method. Likewise <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#OnVertexColor\">OnVertexColor</a> determines if color array will be loaded at all.</p></li>   <li><p>How (and if) TShapeCache.Vbo are loaded.</p></li>   <li><p>How textures are loaded (texture filtering options affect them).</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#ReleaseCachedResources"},
     {"title": "CastleRenderer.TRenderingAttributes.Create", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#Create"},
     {"title": "CastleRenderer.TRenderingAttributes.Assign", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#Assign"},
     {"title": "CastleRenderer.TRenderingAttributes.EqualForShapeCache", "text": " This compares the subset of variables that call <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#ReleaseCachedResources\">ReleaseCachedResources</a> &mdash; only the ones that affect <a class=\"normal\" href=\"CastleRenderer.TShapeCache.html\">TShapeCache</a>.    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#EqualForShapeCache"},
     {"title": "CastleRenderer.TRenderingAttributes.TextureFilter", "text": "    ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#TextureFilter"},
     {"title": "CastleRenderer.TRenderingAttributes.OnRadianceTransfer", "text": " If this is assigned, and geometry object has radianceTransfer field (see [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_radiance_transfer\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_radiance_transfer</a>]) then this is used to calculate the color of each vertex.  <p>Note that this is evaluated when object is rendered. It causes the shapes resources to be regenerated at each render frame, since we have to assume that results of this function change. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#OnRadianceTransfer"},
     {"title": "CastleRenderer.TRenderingAttributes.OnVertexColor", "text": " If this is assigned, then this is used to calculate the color of each vertex.  <p>Note that this is evaluated when object is rendered. It causes the shapes resources to be regenerated at each render frame, since we have to assume that results of this function change. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#OnVertexColor"},
     {"title": "CastleRenderer.TRenderingAttributes.Lighting", "text": " This is <code>True</code> by default, since it's almost always wanted.  <p>When Lighting is <code>False</code>, we disable OpenGL lighting. (We had previously a different approach, when we left GL_LIGHTING untouched and caller could enable/disable it. But this doesn't really work for modern OpenGL, the renderer really has to know if lighting is enabled. (to generate proper shaders, and to avoid clumsy glPushAttrib / glPopAttrib at some places).) ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#Lighting"},
     {"title": "CastleRenderer.TRenderingAttributes.UseSceneLights", "text": "  <p>VRML/X3D lights are loaded into OpenGL lights. All OpenGL lights are always used (we always start from the first OpenGL light 0, up to the last available OpenGL light &mdash; this is necessary, as shader pipeline must know all the lights anyway).  <p>Initial OpenGL lights are reserved for BaseLights (useful for you to define any lights from outside of the scene). Then following OpenGL lights are reserved for the lights defined in your scene (if this property is <code>True</code>). The remaining OpenGL lights, if any, are not used (we make sure they are disabled for fixed-function pipeline).  <p>This is independent from the <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#Lighting\">Lighting</a> property (which merely says whether we will turn OpenGL lighting on at all). ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#UseSceneLights"},
     {"title": "CastleRenderer.TRenderingAttributes.Opacity", "text": " Setting this to something &lt; 1 you can make every shape transparent. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#Opacity"},
     {"title": "CastleRenderer.TRenderingAttributes.EnableTextures", "text": " When <code>True</code> (default), then our engine takes care of everything related to texturing for you: enabling and using textures for textured parts of the model, disabling textures for non-textured parts.  <p>Otherwise, textures are disabled. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#EnableTextures"},
     {"title": "CastleRenderer.TRenderingAttributes.MinificationFilter", "text": " These can be overridden on a per-texture basis in VRML / X3D files by X3D TextureProperties node (see X3D specification).  <p> ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#MinificationFilter"},
     {"title": "CastleRenderer.TRenderingAttributes.MagnificationFilter", "text": " ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#MagnificationFilter"},
     {"title": "CastleRenderer.TRenderingAttributes.PointSize", "text": " This has an effect on VRML/X3D PointSet rendering. Must be &gt; 0. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#PointSize"},
     {"title": "CastleRenderer.TRenderingAttributes.LineWidth", "text": " This has an effect on VRML/X3D LineSet rendering, and on wireframe rendering for <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#WireframeEffect\">TSceneRenderingAttributes.WireframeEffect</a>. Must be &gt; 0. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#LineWidth"},
     {"title": "CastleRenderer.TRenderingAttributes.BumpMapping", "text": " To actually use this, particular shape must also provide normal map (and height map, if you want parallax bump mapping). This also requires some OpenGL capabilities, in particular GLSL.  <p>Simple bump mapping (when only normal map is available) means that normals are provided in the texture, and lighting is calculated per-fragment.  <p>Parallax bump mapping means that additionally the texture coordinate is perturbed, based on height map and camera direction, to create illusion of 3D shape instead of flat surface. This makes e.g. the bricks on the texture really visible as &quot;standing out&quot;, in 3D, from the wall. And self-shadowing means that these bricks even cast appropriate shadows on each other.  <p>Steep parallax mapping requires good GPU to work correctly and fast enough. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#BumpMapping"},
     {"title": "CastleRenderer.TRenderingAttributes.Shaders", "text": " This is now a deprecated property, better use <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#PhongShading\">PhongShading</a> to determine the shading. The engine auto-detects whether to use shaders based on OpenGL capabilities, particular shape needs (phong shading, bump mapping, shadow maps, compositing shader effects), and GLFeatures.EnableFixedFunction. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#Shaders"},
     {"title": "CastleRenderer.TRenderingAttributes.PhongShading", "text": " Note that each shape may override it by <a class=\"normal\" href=\"X3DNodes.TAbstractShapeNode.html#Shading\">TAbstractShapeNode.Shading</a> field. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#PhongShading"},
     {"title": "CastleRenderer.TRenderingAttributes.CustomShader", "text": " When this is assigned, <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#Shaders\">Shaders</a> value is ignored.  <p><i>Avoid using this.</i> It's not easy to create portable shaders, that work both with OpenGL and OpenGLES. Try using &quot;compositing shaders&quot; instead <a  href=\"http://castle-engine.sourceforge.net/compositing_shaders.php\">http://castle-engine.sourceforge.net/compositing_shaders.php</a> which still allow you to write GLSL effects, but they are integrated into standard shader code. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#CustomShader"},
     {"title": "CastleRenderer.TRenderingAttributes.CustomShaderAlphaTest", "text": " Relevant only if <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#CustomShader\">CustomShader</a> &lt;&gt; nil.  <p><i>Do not use this.</i> This is a temporary hack to enable VSM working with alpha test. It's not clean, and should not be used for anything else. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#CustomShaderAlphaTest"},
     {"title": "CastleRenderer.TRenderingAttributes.Mode", "text": " ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#Mode"},
     {"title": "CastleRenderer.TRenderingAttributes.VertexBufferObject", "text": " This is always a good idea. You can set this to <code>False</code> for debug purposes, e.g. to check how much speedup you get from VBO. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#VertexBufferObject"},
     {"title": "CastleRenderer.TRenderingAttributes.ShadowSampling", "text": " Various approaches result in various quality and speed. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#ShadowSampling"},
     {"title": "CastleRenderer.TRenderingAttributes.VisualizeDepthMap", "text": "  <p>Even without turning this on, VRML author can always activate it explicitly for specific lights. For this, you have to use <code>X3DLightNode.defaultShadowMap</code> field, and place a GeneratedShadowMap node there. If the <code>GeneratedShadowMap.compareMode</code> is set to <code>'NONE'</code>, we will always visualize depths of this shadow map.  <p>Setting this property to <code>True</code> has the same effect as setting compareMode to &quot;NONE&quot; on all (explicit and implicitly created) GeneratedShadowMap nodes. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#VisualizeDepthMap"},
     {"title": "CastleRenderer.TRenderingAttributes.DepthTest", "text": " This allows to display all 3D content (all <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instances, and all shapes inside them) in any order.  <p>For very special purposes, you can disable depth testing. This means that 3D objects will always be drawn in front of the previous ones, in the order in which they are rendered, ignoring the contents of the depth buffer. Use only if you know what you're doing, if you're sure that the order of rendering will always be good. ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#DepthTest"},
     {"title": "CastleRenderer.TRenderingAttributes.SolidColor", "text": " ", "tags": "", "loc": "CastleRenderer.TRenderingAttributes.html#SolidColor"},
     {"title": "CastleRenderer.TTextureImageCache", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureImageCache.html"},
     {"title": "CastleRenderer.TTextureImageCache.FullUrl", "text": " Empty ('') if not known (or maybe this texture didn't come from any URL, e.g. it's generated). ", "tags": "", "loc": "CastleRenderer.TTextureImageCache.html#FullUrl"},
     {"title": "CastleRenderer.TTextureImageCache.InitialNode", "text": " This is only the first node, that initiated this <a class=\"normal\" href=\"CastleRenderer.TTextureImageCache.html\">TTextureImageCache</a> item. Note that many <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html\">TAbstractTexture2DNode</a> nodes may correspond to a single <a class=\"normal\" href=\"CastleRenderer.TTextureImageCache.html\">TTextureImageCache</a> (since <a class=\"normal\" href=\"CastleRenderer.TTextureImageCache.html\">TTextureImageCache</a> only tries to share <a class=\"normal\" href=\"CastleRenderer.TTextureImageCache.html#GLName\">GLName</a> between them). So this may help during _IncReference, but nothing more &mdash; it's *not* an exhaustive list of texture nodes related to this video texture!  <p>It may be currently <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html\">TAbstractTexture2DNode</a>, or <a class=\"normal\" href=\"X3DNodes.TRenderedTextureNode.html\">TRenderedTextureNode</a>. ", "tags": "", "loc": "CastleRenderer.TTextureImageCache.html#InitialNode"},
     {"title": "CastleRenderer.TTextureImageCache.Filter", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureImageCache.html#Filter"},
     {"title": "CastleRenderer.TTextureImageCache.Anisotropy", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureImageCache.html#Anisotropy"},
     {"title": "CastleRenderer.TTextureImageCache.Wrap", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureImageCache.html#Wrap"},
     {"title": "CastleRenderer.TTextureImageCache.GUITexture", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureImageCache.html#GUITexture"},
     {"title": "CastleRenderer.TTextureImageCache.References", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureImageCache.html#References"},
     {"title": "CastleRenderer.TTextureImageCache.GLName", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureImageCache.html#GLName"},
     {"title": "CastleRenderer.TTextureVideoCache", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureVideoCache.html"},
     {"title": "CastleRenderer.TTextureVideoCache.FullUrl", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureVideoCache.html#FullUrl"},
     {"title": "CastleRenderer.TTextureVideoCache.InitialNode", "text": " This is only the first <a class=\"normal\" href=\"X3DNodes.TMovieTextureNode.html\">TMovieTextureNode</a> node, that initiated this <a class=\"normal\" href=\"CastleRenderer.TTextureVideoCache.html\">TTextureVideoCache</a> item. Note that many <a class=\"normal\" href=\"X3DNodes.TMovieTextureNode.html\">TMovieTextureNode</a> nodes may correspond to a single <a class=\"normal\" href=\"CastleRenderer.TTextureVideoCache.html\">TTextureVideoCache</a> (since <a class=\"normal\" href=\"CastleRenderer.TTextureVideoCache.html\">TTextureVideoCache</a> only tries to share <a class=\"normal\" href=\"CastleGLImages.TGLVideo3D.html\">TGLVideo3D</a> between them, they don't have to share other fields like current time etc.). So this may help during _IncReference, but nothing more &mdash; it's *not* an exhaustive list of MovieTexture nodes related to this video texture! ", "tags": "", "loc": "CastleRenderer.TTextureVideoCache.html#InitialNode"},
     {"title": "CastleRenderer.TTextureVideoCache.Filter", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureVideoCache.html#Filter"},
     {"title": "CastleRenderer.TTextureVideoCache.Anisotropy", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureVideoCache.html#Anisotropy"},
     {"title": "CastleRenderer.TTextureVideoCache.Wrap", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureVideoCache.html#Wrap"},
     {"title": "CastleRenderer.TTextureVideoCache.GUITexture", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureVideoCache.html#GUITexture"},
     {"title": "CastleRenderer.TTextureVideoCache.References", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureVideoCache.html#References"},
     {"title": "CastleRenderer.TTextureVideoCache.GLVideo", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureVideoCache.html#GLVideo"},
     {"title": "CastleRenderer.TTextureCubeMapCache", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureCubeMapCache.html"},
     {"title": "CastleRenderer.TTextureCubeMapCache.InitialNode", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureCubeMapCache.html#InitialNode"},
     {"title": "CastleRenderer.TTextureCubeMapCache.Filter", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureCubeMapCache.html#Filter"},
     {"title": "CastleRenderer.TTextureCubeMapCache.Anisotropy", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureCubeMapCache.html#Anisotropy"},
     {"title": "CastleRenderer.TTextureCubeMapCache.References", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureCubeMapCache.html#References"},
     {"title": "CastleRenderer.TTextureCubeMapCache.GLName", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureCubeMapCache.html#GLName"},
     {"title": "CastleRenderer.TTexture3DCache", "text": " ", "tags": "", "loc": "CastleRenderer.TTexture3DCache.html"},
     {"title": "CastleRenderer.TTexture3DCache.InitialNode", "text": " ", "tags": "", "loc": "CastleRenderer.TTexture3DCache.html#InitialNode"},
     {"title": "CastleRenderer.TTexture3DCache.Filter", "text": " ", "tags": "", "loc": "CastleRenderer.TTexture3DCache.html#Filter"},
     {"title": "CastleRenderer.TTexture3DCache.Anisotropy", "text": " ", "tags": "", "loc": "CastleRenderer.TTexture3DCache.html#Anisotropy"},
     {"title": "CastleRenderer.TTexture3DCache.Wrap", "text": " ", "tags": "", "loc": "CastleRenderer.TTexture3DCache.html#Wrap"},
     {"title": "CastleRenderer.TTexture3DCache.References", "text": " ", "tags": "", "loc": "CastleRenderer.TTexture3DCache.html#References"},
     {"title": "CastleRenderer.TTexture3DCache.GLName", "text": " ", "tags": "", "loc": "CastleRenderer.TTexture3DCache.html#GLName"},
     {"title": "CastleRenderer.TTextureDepthOrFloatCache", "text": " For now, depth and float textures require the same fields. ", "tags": "", "loc": "CastleRenderer.TTextureDepthOrFloatCache.html"},
     {"title": "CastleRenderer.TTextureDepthOrFloatCache.InitialNode", "text": " For now, this may be <a class=\"normal\" href=\"X3DNodes.TGeneratedShadowMapNode.html\">TGeneratedShadowMapNode</a> or <a class=\"normal\" href=\"X3DNodes.TRenderedTextureNode.html\">TRenderedTextureNode</a>. ", "tags": "", "loc": "CastleRenderer.TTextureDepthOrFloatCache.html#InitialNode"},
     {"title": "CastleRenderer.TTextureDepthOrFloatCache.Wrap", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureDepthOrFloatCache.html#Wrap"},
     {"title": "CastleRenderer.TTextureDepthOrFloatCache.References", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureDepthOrFloatCache.html#References"},
     {"title": "CastleRenderer.TTextureDepthOrFloatCache.GLName", "text": " ", "tags": "", "loc": "CastleRenderer.TTextureDepthOrFloatCache.html#GLName"},
     {"title": "CastleRenderer.TShapeCache", "text": " ", "tags": "", "loc": "CastleRenderer.TShapeCache.html"},
     {"title": "CastleRenderer.TShapeCache.Create", "text": "    ", "tags": "", "loc": "CastleRenderer.TShapeCache.html#Create"},
     {"title": "CastleRenderer.TShapeCache.Destroy", "text": "    ", "tags": "", "loc": "CastleRenderer.TShapeCache.html#Destroy"},
     {"title": "CastleRenderer.TShapeCache.FreeArrays", "text": "    ", "tags": "", "loc": "CastleRenderer.TShapeCache.html#FreeArrays"},
     {"title": "CastleRenderer.TShaderProgramCache", "text": " ", "tags": "", "loc": "CastleRenderer.TShaderProgramCache.html"},
     {"title": "CastleRenderer.TShaderProgramCache.Hash", "text": " Used to decide when shader needs to be regenerated, and when it can be shared. ", "tags": "", "loc": "CastleRenderer.TShaderProgramCache.html#Hash"},
     {"title": "CastleRenderer.TShaderProgramCache.ShaderProgram", "text": " May be <code>Nil</code> (if it failed to link). ", "tags": "", "loc": "CastleRenderer.TShaderProgramCache.html#ShaderProgram"},
     {"title": "CastleRenderer.TShaderProgramCache.References", "text": " ", "tags": "", "loc": "CastleRenderer.TShaderProgramCache.html#References"},
     {"title": "CastleRenderer.TShaderProgramCache.Destroy", "text": "    ", "tags": "", "loc": "CastleRenderer.TShaderProgramCache.html#Destroy"},
     {"title": "CastleRenderer.TGLRendererContextCache", "text": " This may save a lot of OpenGL memory when you use multiple renderers (for example, multiple <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instances).  <p>The cache can only be shared by renderers in the same OpenGL context, or in shared OpenGL contexts. It cannot be reused in totally alien OpenGL contexts, as the OpenGL identifiers will simply not exist there. In practice, this should not be a problem, as our OpenGL contexts always share resources, and you will almost always just use a single instance of this cache inside <a class=\"normal\" href=\"CastleScene.html#GLContextCache\">GLContextCache</a>. ", "tags": "", "loc": "CastleRenderer.TGLRendererContextCache.html"},
     {"title": "CastleRenderer.TGLRendererContextCache.Create", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRendererContextCache.html#Create"},
     {"title": "CastleRenderer.TGLRendererContextCache.Destroy", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRendererContextCache.html#Destroy"},
     {"title": "CastleRenderer.TGLRendererContextCache.Shape_IncReference", "text": " We return <a class=\"normal\" href=\"CastleRenderer.TShapeCache.html\">TShapeCache</a>, either taking an existing instance from cache or creating and adding a new one. Caller is responsible for checking are Arrays / Vbo zero and eventually initializing and setting.    ", "tags": "", "loc": "CastleRenderer.TGLRendererContextCache.html#Shape_IncReference"},
     {"title": "CastleRenderer.TGLRendererContextCache.Shape_DecReference", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRendererContextCache.html#Shape_DecReference"},
     {"title": "CastleRenderer.TGLRendererContextCache.Program_IncReference", "text": " We return <a class=\"normal\" href=\"CastleRenderer.TShaderProgramCache.html\">TShaderProgramCache</a>, either taking an existing instance from cache or creating and adding a new one. If we create a new one, we will use Shader to initialize program hash and to create and link actual <a class=\"normal\" href=\"CastleRenderer.TX3DGLSLProgram.html\">TX3DGLSLProgram</a> instance.    ", "tags": "", "loc": "CastleRenderer.TGLRendererContextCache.html#Program_IncReference"},
     {"title": "CastleRenderer.TGLRendererContextCache.Program_DecReference", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRendererContextCache.html#Program_DecReference"},
     {"title": "CastleRenderer.TResourceRenderer", "text": " Such helper is associated with a given VRML node, and has methods like Prepare, Enable (their exact semantics depends on descendant) and Unprepare. ", "tags": "", "loc": "CastleRenderer.TResourceRenderer.html"},
     {"title": "CastleRenderer.TResourceRenderer.Create", "text": "    ", "tags": "", "loc": "CastleRenderer.TResourceRenderer.html#Create"},
     {"title": "CastleRenderer.TResourceRenderer.Unprepare", "text": "    ", "tags": "", "loc": "CastleRenderer.TResourceRenderer.html#Unprepare"},
     {"title": "CastleRenderer.TResourceRenderer.Renderer", "text": " ", "tags": "", "loc": "CastleRenderer.TResourceRenderer.html#Renderer"},
     {"title": "CastleRenderer.TResourceRenderer.Node", "text": " Never <code>Nil</code>. ", "tags": "", "loc": "CastleRenderer.TResourceRenderer.html#Node"},
     {"title": "CastleRenderer.TResourceRendererList", "text": " ", "tags": "", "loc": "CastleRenderer.TResourceRendererList.html"},
     {"title": "CastleRenderer.TResourceRendererList.NodeIndex", "text": " Returns -1 if not found.    ", "tags": "", "loc": "CastleRenderer.TResourceRendererList.html#NodeIndex"},
     {"title": "CastleRenderer.TResourceRendererList.Node", "text": " Returns <code>Nil</code> if not found.    ", "tags": "", "loc": "CastleRenderer.TResourceRendererList.html#Node"},
     {"title": "CastleRenderer.TResourceRendererList.Unprepare", "text": "  <p>Note: for complicated reasons, this is ignored if called during <a class=\"normal\" href=\"CastleRenderer.TResourceRendererList.html#UnprepareAll\">UnprepareAll</a> call on the same list. E.g. it may happen when your <a class=\"normal\" href=\"CastleRenderer.TResourceRenderer.html\">TResourceRenderer</a> calls Unprepare on it's own list from it's own Unprepare (like <a class=\"normal\" href=\"CastleRenderer.TGLMultiTextureNode.html\">TGLMultiTextureNode</a>). Although it's ignored in this case, you still can be sure ANode will be unprepared (as <a class=\"normal\" href=\"CastleRenderer.TResourceRendererList.html#UnprepareAll\">UnprepareAll</a> will eventually unprepare, well, all). Just be aware that effect may be delayed in this case.    ", "tags": "", "loc": "CastleRenderer.TResourceRendererList.html#Unprepare"},
     {"title": "CastleRenderer.TResourceRendererList.UnprepareAll", "text": " Clears the list.    ", "tags": "", "loc": "CastleRenderer.TResourceRendererList.html#UnprepareAll"},
     {"title": "CastleRenderer.TGLTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html"},
     {"title": "CastleRenderer.TGLTextureNode.HandleTextureProperties", "text": " If TextureProperties = <code>Nil</code>, they are taken from defaults (possibly in Attributes).    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#HandleTextureProperties"},
     {"title": "CastleRenderer.TGLTextureNode.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLTextureNode.PrepareCore", "text": " Called from <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#Prepare\">TGLRenderer.Prepare</a>, always through our Prepare method. Our Prepare method takes care to catch common exceptions from this (<a class=\"normal\" href=\"CastleGLImages.EFramebufferError.html\">EFramebufferError</a>, <a class=\"normal\" href=\"CastleGLImages.ETextureLoadError.html\">ETextureLoadError</a>), convert them to <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> and make Unprepare to undo the preparations. So Prepare-Unprepare work like constructor-destructor, with Unprepare having to be prepared to finilizing incomplete instance.    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#PrepareCore"},
     {"title": "CastleRenderer.TGLTextureNode.Create", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#Create"},
     {"title": "CastleRenderer.TGLTextureNode.TextureNode", "text": " Never <code>Nil</code>. It's guaranteed to satisfy <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html#IsClassForTextureNode\">IsClassForTextureNode</a> method of this class.    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGLTextureNode.ClassForTextureNode", "text": " Returns <code>Nil</code> if not found.  <p><i>Descedants implementors</i>: override <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html#IsClassForTextureNode\">IsClassForTextureNode</a> to be correctly recognized by this.    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#ClassForTextureNode"},
     {"title": "CastleRenderer.TGLTextureNode.Prepare", "text": " Calls <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html#PrepareCore\">PrepareCore</a>.    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#Prepare"},
     {"title": "CastleRenderer.TGLTextureNode.Bind", "text": "  <p>Just like Enable, returns <code>False</code> when texture node was not successfully prepared for OpenGL. Returns <code>True</code> when it was successfully bound (caller can be sure then that given texture unit is currently active).    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#Bind"},
     {"title": "CastleRenderer.TGLTextureNode.Enable", "text": " This has to bind texture identifier and enable proper texture state (for example: 2D, and not 3D, and not cube).  <p>When returns <code>False</code>, it means that texture node was not successfully prepared for OpenGL, which means (we assume that you called Prepare before Enable) that texture failed to load, required not available OpenGL version / extension etc. Caller will then disable the texture unit, and you don't have to generate tex coords for it.  <p>When returns <code>True</code> (success) caller can be sure that the specified TextureUnit is currently bound (if OpenGL multitexturing extensions are available at all). This is useful, if you want to later adjust texture unit parameters, like glTexEnvi(GL_TEXTURE_ENV, ...).  <p>It's also already enabled (by glEnable(GL_TEXTURE_2D / GL_TEXTURE_CUBE_MAP / GL_TEXTURE_3D) ).    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#Enable"},
     {"title": "CastleRenderer.TGLTextureNode.EnableAll", "text": " On every texture unit where something is enabled, proper texture identifier must be bound. Also, has to set complete glTexEnv on every enabled texture unit.  <p>TextureUnitsCount says how many texture units can be enabled/disabled.  <p>TextureUnitsCount does *not* take into account whether multitexturing OpenGL extensions are available at all. Look at GLFeatures.UseMultiTexturing for this. Think of GLFeatures.UseMultiTexturing as capping TextureUnitsCount to 1 (still, remember to honour TextureUnitsCount = 0 case in your implementation, even when GLFeatures.UseMultiTexturing = <code>True</code>).  <p>You have to update TextureSlotsUsed, this is the count of texture units where some texture coordinates should be generated. It's initial value may be &gt; 0, in case some texture slots are already taken. This means that all texture units above TextureSlotsUsed (to TextureUnitsCount - 1) should be disabled by the caller (no need to do this in <code>EnableAll</code>), and there's no need to generated texture coords for them.  <p>( Yes, there is some small optimization missed in the definition of TextureSlotsUsed: if some textures in the middle of multitexture children list failed to load, but some following children succeded, we'll generate tex coords even for the useless texture units in the middle. We could avoid generating texture coords for them, by changing TextureSlotsUsed into bool array. This optimization is not considered worthy implementing for now. )  <p>You have to set texture state of all texture units &lt; TextureSlotsUsed, and only on them.    ", "tags": "", "loc": "CastleRenderer.TGLTextureNode.html#EnableAll"},
     {"title": "CastleRenderer.TGLTextureNodes", "text": " ", "tags": "", "loc": "CastleRenderer.TGLTextureNodes.html"},
     {"title": "CastleRenderer.TGLTextureNodes.TextureNodeIndex", "text": " Returns -1 if not found.    ", "tags": "", "loc": "CastleRenderer.TGLTextureNodes.html#TextureNodeIndex"},
     {"title": "CastleRenderer.TGLTextureNodes.TextureNode", "text": " Returns <code>Nil</code> if not found.    ", "tags": "", "loc": "CastleRenderer.TGLTextureNodes.html#TextureNode"},
     {"title": "CastleRenderer.TGLTextureNodes.Prepare", "text": " Accepts multi texture or not-multi texture nodes, accepts (and ignores) also <code>Nil</code> as <a class=\"normal\" href=\"CastleRenderer.TGLTextureNodes.html#TextureNode\">TextureNode</a>. Ignore not handled node classes.  <p>Returns created (or already existing) <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html\">TGLTextureNode</a>, it may be useful in case of TGLMultiTextureNode.Prepare implementation.  <p>Returns <code>Nil</code> if Node not suitable for <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html\">TGLTextureNode</a> (not handled, or not really a texture node at all).    ", "tags": "", "loc": "CastleRenderer.TGLTextureNodes.html#Prepare"},
     {"title": "CastleRenderer.TGLTextureNodes.Bind", "text": " Calls <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html#Enable\">TGLTextureNode.Enable</a> method. If no texture renderer is prepared for this node, returns <code>False</code>.    ", "tags": "", "loc": "CastleRenderer.TGLTextureNodes.html#Bind"},
     {"title": "CastleRenderer.TGLTextureNodes.Enable", "text": " Calls <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html#Enable\">TGLTextureNode.Enable</a> method. If no texture renderer is prepared for this node, returns <code>False</code>.    ", "tags": "", "loc": "CastleRenderer.TGLTextureNodes.html#Enable"},
     {"title": "CastleRenderer.TGLTextureNodes.Items", "text": " ", "tags": "", "loc": "CastleRenderer.TGLTextureNodes.html#Items"},
     {"title": "CastleRenderer.TGLSingleTextureNode", "text": "  <p>Implements <a class=\"normal\" href=\"CastleRenderer.TGLSingleTextureNode.html#EnableAll\">EnableAll</a> method, by calling <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html#Enable\">Enable</a> call. Override only <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html#Enable\">Enable</a> in descendants. ", "tags": "", "loc": "CastleRenderer.TGLSingleTextureNode.html"},
     {"title": "CastleRenderer.TGLSingleTextureNode.TextureRGB", "text": " Default false, you should set this in descendant (latest possibility is to set this is a successful Enable call, but usually you want to do it in a Prepare call). You can set it by <a class=\"normal\" href=\"CastleRenderer.TGLSingleTextureNode.html#SetTextureRGBFromImage\">SetTextureRGBFromImage</a>. ", "tags": "", "loc": "CastleRenderer.TGLSingleTextureNode.html#TextureRGB"},
     {"title": "CastleRenderer.TGLSingleTextureNode.SetTextureRGBFromImage", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLSingleTextureNode.html#SetTextureRGBFromImage"},
     {"title": "CastleRenderer.TGLSingleTextureNode.EnableAll", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLSingleTextureNode.html#EnableAll"},
     {"title": "CastleRenderer.TGLMultiTextureNode", "text": "  <p>This is somewhat special, in that it will use other <a class=\"normal\" href=\"CastleRenderer.TGLTextureNode.html\">TGLTextureNode</a> handlers to handle single textures inside &mdash; but this is completely hidden from the interface. ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html"},
     {"title": "CastleRenderer.TGLMultiTextureNode.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLMultiTextureNode.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html#PrepareCore"},
     {"title": "CastleRenderer.TGLMultiTextureNode.Create", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html#Create"},
     {"title": "CastleRenderer.TGLMultiTextureNode.Destroy", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html#Destroy"},
     {"title": "CastleRenderer.TGLMultiTextureNode.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGLMultiTextureNode.Unprepare", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html#Unprepare"},
     {"title": "CastleRenderer.TGLMultiTextureNode.Bind", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html#Bind"},
     {"title": "CastleRenderer.TGLMultiTextureNode.Enable", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html#Enable"},
     {"title": "CastleRenderer.TGLMultiTextureNode.EnableAll", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMultiTextureNode.html#EnableAll"},
     {"title": "CastleRenderer.TGL2DTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGL2DTextureNode.html"},
     {"title": "CastleRenderer.TGL2DTextureNode.GLName", "text": " It may be 0 if the texture was initialized successfully.    ", "tags": "", "loc": "CastleRenderer.TGL2DTextureNode.html#GLName"},
     {"title": "CastleRenderer.TGLImageTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html"},
     {"title": "CastleRenderer.TGLImageTextureNode.NormalMap", "text": " ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#NormalMap"},
     {"title": "CastleRenderer.TGLImageTextureNode.HeightMap", "text": " ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#HeightMap"},
     {"title": "CastleRenderer.TGLImageTextureNode.HeightMapScale", "text": " ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#HeightMapScale"},
     {"title": "CastleRenderer.TGLImageTextureNode.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLImageTextureNode.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#PrepareCore"},
     {"title": "CastleRenderer.TGLImageTextureNode.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGLImageTextureNode.Unprepare", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#Unprepare"},
     {"title": "CastleRenderer.TGLImageTextureNode.Bind", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#Bind"},
     {"title": "CastleRenderer.TGLImageTextureNode.Enable", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#Enable"},
     {"title": "CastleRenderer.TGLImageTextureNode.GLName", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageTextureNode.html#GLName"},
     {"title": "CastleRenderer.TGLMovieTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGLMovieTextureNode.html"},
     {"title": "CastleRenderer.TGLMovieTextureNode.GLVideo", "text": " ", "tags": "", "loc": "CastleRenderer.TGLMovieTextureNode.html#GLVideo"},
     {"title": "CastleRenderer.TGLMovieTextureNode.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMovieTextureNode.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLMovieTextureNode.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMovieTextureNode.html#PrepareCore"},
     {"title": "CastleRenderer.TGLMovieTextureNode.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMovieTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGLMovieTextureNode.Unprepare", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMovieTextureNode.html#Unprepare"},
     {"title": "CastleRenderer.TGLMovieTextureNode.Bind", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMovieTextureNode.html#Bind"},
     {"title": "CastleRenderer.TGLMovieTextureNode.Enable", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMovieTextureNode.html#Enable"},
     {"title": "CastleRenderer.TGLMovieTextureNode.GLName", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLMovieTextureNode.html#GLName"},
     {"title": "CastleRenderer.TGLRenderedTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.Width", "text": " ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#Width"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.Height", "text": " ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#Height"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.NeedsMipmaps", "text": " ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#NeedsMipmaps"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.DepthMap", "text": " ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#DepthMap"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#PrepareCore"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.Unprepare", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#Unprepare"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.Bind", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#Bind"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.Enable", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#Enable"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.GLName", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#GLName"},
     {"title": "CastleRenderer.TGLRenderedTextureNode.Update", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderedTextureNode.html#Update"},
     {"title": "CastleRenderer.TGLCubeMapTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGLCubeMapTextureNode.html"},
     {"title": "CastleRenderer.TGLCubeMapTextureNode.GLName", "text": " ", "tags": "", "loc": "CastleRenderer.TGLCubeMapTextureNode.html#GLName"},
     {"title": "CastleRenderer.TGLCubeMapTextureNode.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLCubeMapTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGLCubeMapTextureNode.Unprepare", "text": " Suitable for descendants tht initialize <a class=\"normal\" href=\"CastleRenderer.TGLCubeMapTextureNode.html#GLName\">GLName</a> by TextureCubeMap_IncReference.    ", "tags": "", "loc": "CastleRenderer.TGLCubeMapTextureNode.html#Unprepare"},
     {"title": "CastleRenderer.TGLCubeMapTextureNode.Bind", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLCubeMapTextureNode.html#Bind"},
     {"title": "CastleRenderer.TGLCubeMapTextureNode.Enable", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLCubeMapTextureNode.html#Enable"},
     {"title": "CastleRenderer.TGLComposedCubeMapTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGLComposedCubeMapTextureNode.html"},
     {"title": "CastleRenderer.TGLComposedCubeMapTextureNode.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLComposedCubeMapTextureNode.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLComposedCubeMapTextureNode.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLComposedCubeMapTextureNode.html#PrepareCore"},
     {"title": "CastleRenderer.TGLComposedCubeMapTextureNode.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLComposedCubeMapTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGLImageCubeMapTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGLImageCubeMapTextureNode.html"},
     {"title": "CastleRenderer.TGLImageCubeMapTextureNode.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageCubeMapTextureNode.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLImageCubeMapTextureNode.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageCubeMapTextureNode.html#PrepareCore"},
     {"title": "CastleRenderer.TGLImageCubeMapTextureNode.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLImageCubeMapTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGLGeneratedCubeMapTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGLGeneratedCubeMapTextureNode.html"},
     {"title": "CastleRenderer.TGLGeneratedCubeMapTextureNode.Size", "text": " ", "tags": "", "loc": "CastleRenderer.TGLGeneratedCubeMapTextureNode.html#Size"},
     {"title": "CastleRenderer.TGLGeneratedCubeMapTextureNode.NeedsMipmaps", "text": " ", "tags": "", "loc": "CastleRenderer.TGLGeneratedCubeMapTextureNode.html#NeedsMipmaps"},
     {"title": "CastleRenderer.TGLGeneratedCubeMapTextureNode.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedCubeMapTextureNode.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLGeneratedCubeMapTextureNode.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedCubeMapTextureNode.html#PrepareCore"},
     {"title": "CastleRenderer.TGLGeneratedCubeMapTextureNode.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedCubeMapTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGLGeneratedCubeMapTextureNode.Unprepare", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedCubeMapTextureNode.html#Unprepare"},
     {"title": "CastleRenderer.TGLGeneratedCubeMapTextureNode.Update", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedCubeMapTextureNode.html#Update"},
     {"title": "CastleRenderer.TGL3DTextureNode", "text": " ", "tags": "", "loc": "CastleRenderer.TGL3DTextureNode.html"},
     {"title": "CastleRenderer.TGL3DTextureNode.GLName", "text": " ", "tags": "", "loc": "CastleRenderer.TGL3DTextureNode.html#GLName"},
     {"title": "CastleRenderer.TGL3DTextureNode.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGL3DTextureNode.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGL3DTextureNode.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGL3DTextureNode.html#PrepareCore"},
     {"title": "CastleRenderer.TGL3DTextureNode.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGL3DTextureNode.html#TextureNode"},
     {"title": "CastleRenderer.TGL3DTextureNode.Unprepare", "text": "    ", "tags": "", "loc": "CastleRenderer.TGL3DTextureNode.html#Unprepare"},
     {"title": "CastleRenderer.TGL3DTextureNode.Bind", "text": "    ", "tags": "", "loc": "CastleRenderer.TGL3DTextureNode.html#Bind"},
     {"title": "CastleRenderer.TGL3DTextureNode.Enable", "text": "    ", "tags": "", "loc": "CastleRenderer.TGL3DTextureNode.html#Enable"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap", "text": " ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.Size", "text": " ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#Size"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.VisualizeDepthMap", "text": " ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#VisualizeDepthMap"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#PrepareCore"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.TextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#TextureNode"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.Unprepare", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#Unprepare"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.Bind", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#Bind"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.Enable", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#Enable"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.GLName", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#GLName"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.Update", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#Update"},
     {"title": "CastleRenderer.TGLGeneratedShadowMap.ClassVarianceShadowMaps", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLGeneratedShadowMap.html#ClassVarianceShadowMaps"},
     {"title": "CastleRenderer.TGLShaderTexture", "text": " ", "tags": "", "loc": "CastleRenderer.TGLShaderTexture.html"},
     {"title": "CastleRenderer.TGLShaderTexture.IsClassForTextureNode", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLShaderTexture.html#IsClassForTextureNode"},
     {"title": "CastleRenderer.TGLShaderTexture.PrepareCore", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLShaderTexture.html#PrepareCore"},
     {"title": "CastleRenderer.TGLShaderTexture.Unprepare", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLShaderTexture.html#Unprepare"},
     {"title": "CastleRenderer.TGLShaderTexture.Bind", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLShaderTexture.html#Bind"},
     {"title": "CastleRenderer.TGLShaderTexture.Enable", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLShaderTexture.html#Enable"},
     {"title": "CastleRenderer.TX3DGLSLProgram", "text": " Adds ability to bind VRML/X3D textures to uniform variables of GLSL shader. ", "tags": "", "loc": "CastleRenderer.TX3DGLSLProgram.html"},
     {"title": "CastleRenderer.TX3DGLSLProgram.Create", "text": "    ", "tags": "", "loc": "CastleRenderer.TX3DGLSLProgram.html#Create"},
     {"title": "CastleRenderer.TX3DGLSLProgram.SetupUniforms", "text": "    ", "tags": "", "loc": "CastleRenderer.TX3DGLSLProgram.html#SetupUniforms"},
     {"title": "CastleRenderer.TX3DRendererShape", "text": " ", "tags": "", "loc": "CastleRenderer.TX3DRendererShape.html"},
     {"title": "CastleRenderer.TX3DRendererShape.ProgramCache", "text": " Note that ShaderProgram may still be <code>Nil</code>, if it failed to link.  <p>Separate values for each rendering pass, since different rendering passes probably have different BaseLights and so will require different shaders. This makes multi-pass rendering, like for shadow volumes, play nicely with shaders. Otherwise we could recreate shaders at each rendering pass. ", "tags": "", "loc": "CastleRenderer.TX3DRendererShape.html#ProgramCache"},
     {"title": "CastleRenderer.TX3DRendererShape.Cache", "text": " ", "tags": "", "loc": "CastleRenderer.TX3DRendererShape.html#Cache"},
     {"title": "CastleRenderer.TX3DRendererShape.ModelView", "text": " ", "tags": "", "loc": "CastleRenderer.TX3DRendererShape.html#ModelView"},
     {"title": "CastleRenderer.TGLRenderer", "text": " ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html"},
     {"title": "CastleRenderer.TGLRenderer.PrepareRenderShape", "text": " ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#PrepareRenderShape"},
     {"title": "CastleRenderer.TGLRenderer.Create", "text": " Always pass a cache instance &mdash; preferably, something created and used by many scenes.    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#Create"},
     {"title": "CastleRenderer.TGLRenderer.Destroy", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#Destroy"},
     {"title": "CastleRenderer.TGLRenderer.Prepare", "text": " Between preparing and unpreparing, nodes passed here are &quot;frozen&quot;: do not change, do not free them.    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#Prepare"},
     {"title": "CastleRenderer.TGLRenderer.UnprepareTexture", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#UnprepareTexture"},
     {"title": "CastleRenderer.TGLRenderer.UnprepareAll", "text": " That is release any knowledge connecting us to the current OpenGL context and any knowledge about your prepared VRML nodes, states etc.  <p>Calling <code>UnprepareAll</code> is valid (and ignored) call if everything is already released.  <p>Destructor callls <code>UnprepareAll</code> automatically. So be sure to either call <code>UnprepareAll</code> or destroy this renderer when your OpenGL context is still active.    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#UnprepareAll"},
     {"title": "CastleRenderer.TGLRenderer.RenderBegin", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#RenderBegin"},
     {"title": "CastleRenderer.TGLRenderer.RenderEnd", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#RenderEnd"},
     {"title": "CastleRenderer.TGLRenderer.RenderShape", "text": "    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#RenderShape"},
     {"title": "CastleRenderer.TGLRenderer.UpdateGeneratedTextures", "text": "  <p>NeedsRestoreViewport will be set to <code>True</code> if viewport was (possibly) changed by this procedure (otherwise, NeedsRestoreViewport will not be modified).  <p>The given camera position, direction, up should be in world space (that is, in <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> space, not in space local to this <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>).    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#UpdateGeneratedTextures"},
     {"title": "CastleRenderer.TGLRenderer.PrepareScreenEffect", "text": " Makes sure that Node.ShaderLoaded is true. When changing Node.ShaderLoaded false to true tries to initialize the shader, setting Node.Shader if some GLSL program was successfully loaded.  <p>The GLSL program (<a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html\">TGLSLProgram</a>) will be stored here, and will be automatically freed during <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#UnprepareAll\">UnprepareAll</a> call.    ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#PrepareScreenEffect"},
     {"title": "CastleRenderer.TGLRenderer.Attributes", "text": " You can change them only when renderer is not tied to the current OpenGL context, so only after construction or after <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html#UnprepareAll\">UnprepareAll</a> call (before any Prepare or Render* calls). ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#Attributes"},
     {"title": "CastleRenderer.TGLRenderer.Cache", "text": " ", "tags": "", "loc": "CastleRenderer.TGLRenderer.html#Cache"},
     {"title": "CastleRenderer.AllVboTypes", "text": " ", "tags": "", "loc": "CastleRenderer.html#AllVboTypes"},
     {"title": "CastleRenderer.BumpMappingNames", "text": " ", "tags": "", "loc": "CastleRenderer.html#BumpMappingNames"},
     {"title": "CastleRenderer.rmPureGeometry", "text": " ", "tags": "", "loc": "CastleRenderer.html#rmPureGeometry"},
     {"title": "CastleRenderer.TBeforeGLVertexProc", "text": "    ", "tags": "", "loc": "CastleRenderer.html#TBeforeGLVertexProc"},
     {"title": "CastleRenderer.TShadersRendering", "text": "  srDisable    srWhenRequired    srAlways   ", "tags": "", "loc": "CastleRenderer.html#TShadersRendering"},
     {"title": "CastleRenderer.TBumpMapping", "text": " ", "tags": "", "loc": "CastleRenderer.html#TBumpMapping"},
     {"title": "CastleRenderer.TLightRenderEvent", "text": " ", "tags": "", "loc": "CastleRenderer.html#TLightRenderEvent"},
     {"title": "CastleRenderer.TRenderingMode", "text": "  rmFull Normal rendering features.  Everything is enabled (as long as other <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html\">TRenderingAttributes</a> settings allow them).  rmSolidColor Solid color is used for everything.  We do not show any color variation, materials, lights, fog, textures on surfaces. We still do back-face culling and depth test. The idea is that we &quot;hit&quot; the same pixels as normal rendering (with the exception of alpha test textures, this mode doesn't set up alpha test for them). But everything has color <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#SolidColor\">TRenderingAttributes.SolidColor</a>.  <p>This is useful for special tricks.  rmDepth Only the rendering fetures that affect depth buffer work reliably, everything else is undefined (and works as fast as possible).  This is suitable if you render only to depth buffer, like for shadow maps.  <p>It's quite similar to <a class=\"normal\" href=\"CastleRenderer.html#rmSolidColor\">rmSolidColor</a>, except alpha testing must work, so (at least some) textures must be applied over the model. ", "tags": "", "loc": "CastleRenderer.html#TRenderingMode"},
     {"title": "CastleRenderer.TRenderingAttributesClass", "text": " ", "tags": "", "loc": "CastleRenderer.html#TRenderingAttributesClass"},
     {"title": "CastleRenderer.TTextureImageCacheList", "text": " ", "tags": "", "loc": "CastleRenderer.html#TTextureImageCacheList"},
     {"title": "CastleRenderer.TTextureVideoCacheList", "text": " ", "tags": "", "loc": "CastleRenderer.html#TTextureVideoCacheList"},
     {"title": "CastleRenderer.TTextureCubeMapCacheList", "text": " ", "tags": "", "loc": "CastleRenderer.html#TTextureCubeMapCacheList"},
     {"title": "CastleRenderer.TTexture3DCacheList", "text": " ", "tags": "", "loc": "CastleRenderer.html#TTexture3DCacheList"},
     {"title": "CastleRenderer.TTextureDepthOrFloatCacheList", "text": " ", "tags": "", "loc": "CastleRenderer.html#TTextureDepthOrFloatCacheList"},
     {"title": "CastleRenderer.TVboType", "text": "  vtCoordinate    vtAttribute    vtIndex   ", "tags": "", "loc": "CastleRenderer.html#TVboType"},
     {"title": "CastleRenderer.TVboTypes", "text": " ", "tags": "", "loc": "CastleRenderer.html#TVboTypes"},
     {"title": "CastleRenderer.TVboArrays", "text": " ", "tags": "", "loc": "CastleRenderer.html#TVboArrays"},
     {"title": "CastleRenderer.TShapeCacheList", "text": " ", "tags": "", "loc": "CastleRenderer.html#TShapeCacheList"},
     {"title": "CastleRenderer.TShaderProgramCacheList", "text": " ", "tags": "", "loc": "CastleRenderer.html#TShaderProgramCacheList"},
     {"title": "CastleRenderer.TGLTextureNodeClass", "text": " ", "tags": "", "loc": "CastleRenderer.html#TGLTextureNodeClass"},
     {"title": "CastleRenderer.LogRendererCache", "text": " Allows to see how the cache performs. A <i>lot</i> of log messages.  <p>Meaningful only if you initialized log (see <a class=\"normal\" href=\"CastleLog.html\">CastleLog</a> unit) by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a> first. ", "tags": "", "loc": "CastleRenderer.html#LogRendererCache"},
     {"title": "CastleRenderer.LogRenderer", "text": "  <p>Meaningful only if you initialized log (see <a class=\"normal\" href=\"CastleLog.html\">CastleLog</a> unit) by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a> first. ", "tags": "", "loc": "CastleRenderer.html#LogRenderer"},
     {"title": "CastleRendererBaseTypes", "text": " Independent from OpenGL, X3D and other higher-level types. ", "tags": "", "loc": "CastleRendererBaseTypes.html"},
     {"title": "CastleRendererBaseTypes.ShaderTypeName", "text": " ", "tags": "", "loc": "CastleRendererBaseTypes.html#ShaderTypeName"},
     {"title": "CastleRendererBaseTypes.TShaderType", "text": "  stVertex    stGeometry    stFragment   ", "tags": "", "loc": "CastleRendererBaseTypes.html#TShaderType"},
     {"title": "CastleRenderingCamera", "text": "  <p><b>This is mostly an internal unit</b>, normal applications should not access camera this way (instead use <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">TCastleAbstractViewport.Camera</a>). However, there are some valid uses for it (like querying <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#Target\">TRenderingCamera.Target</a> to selectively hide some stuff). ", "tags": "", "loc": "CastleRenderingCamera.html"},
     {"title": "CastleRenderingCamera.TCameraChangedEventList", "text": " ", "tags": "", "loc": "CastleRenderingCamera.TCameraChangedEventList.html"},
     {"title": "CastleRenderingCamera.TCameraChangedEventList.ExecuteAll", "text": "    ", "tags": "", "loc": "CastleRenderingCamera.TCameraChangedEventList.html#ExecuteAll"},
     {"title": "CastleRenderingCamera.TRenderingCamera", "text": "  <p><b>This is an internal class</b>, normal applications should not access camera this way (instead use <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">TCastleAbstractViewport.Camera</a>). ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html"},
     {"title": "CastleRenderingCamera.TRenderingCamera.Matrix", "text": " Transforms from world space (normal 3D space) to camera space (camera space is the space where you're always standing on zero point, looking in -Z, and so on).  <p>This is needed for various things, like TextureCoordinateGenerator.mode = &quot;WORLDSPACE*&quot; or generating Viewpoint.camera[Inverse]Matrix event.  <p>Always after changing this, change also all other camera fields, and then call <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#Changed\">Changed</a>. ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#Matrix"},
     {"title": "CastleRenderingCamera.TRenderingCamera.InverseMatrix", "text": "  <p>Always call <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#InverseMatrixNeeded\">InverseMatrixNeeded</a> before using it, <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#InverseMatrixNeeded\">InverseMatrixNeeded</a> will check <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#InverseMatrixDone\">InverseMatrixDone</a> and eventually will calculate inverse and set <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#InverseMatrixDone\">InverseMatrixDone</a> to <code>True</code>. ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#InverseMatrix"},
     {"title": "CastleRenderingCamera.TRenderingCamera.InverseMatrixDone", "text": " ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#InverseMatrixDone"},
     {"title": "CastleRenderingCamera.TRenderingCamera.RotationMatrix", "text": " That is, this is like <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#Matrix\">Matrix</a> but it doesn't move the camera, only rotates it.  <p>It's guaranteed that this is actually only 3x3 matrix, the 4th row and 4th column are all zero except the lowest right item which is 1.0. ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#RotationMatrix"},
     {"title": "CastleRenderingCamera.TRenderingCamera.RotationOnly", "text": " ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#RotationOnly"},
     {"title": "CastleRenderingCamera.TRenderingCamera.RotationInverseMatrix", "text": "  <p>Always call <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#RotationInverseMatrixNeeded\">RotationInverseMatrixNeeded</a> before using it, <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#RotationInverseMatrixNeeded\">RotationInverseMatrixNeeded</a> will check <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#RotationInverseMatrixDone\">RotationInverseMatrixDone</a> and eventually will calculate inverse and set <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#RotationInverseMatrixDone\">RotationInverseMatrixDone</a> to <code>True</code>. ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#RotationInverseMatrix"},
     {"title": "CastleRenderingCamera.TRenderingCamera.RotationInverseMatrixDone", "text": " ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#RotationInverseMatrixDone"},
     {"title": "CastleRenderingCamera.TRenderingCamera.Frustum", "text": " ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#Frustum"},
     {"title": "CastleRenderingCamera.TRenderingCamera.Create", "text": "    ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#Create"},
     {"title": "CastleRenderingCamera.TRenderingCamera.Destroy", "text": "    ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#Destroy"},
     {"title": "CastleRenderingCamera.TRenderingCamera.InverseMatrixNeeded", "text": "    ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#InverseMatrixNeeded"},
     {"title": "CastleRenderingCamera.TRenderingCamera.RotationInverseMatrixNeeded", "text": "    ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#RotationInverseMatrixNeeded"},
     {"title": "CastleRenderingCamera.TRenderingCamera.RotationMatrix3", "text": "    ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#RotationMatrix3"},
     {"title": "CastleRenderingCamera.TRenderingCamera.RotationInverseMatrix3", "text": "    ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#RotationInverseMatrix3"},
     {"title": "CastleRenderingCamera.TRenderingCamera.FromCameraObject", "text": " See <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#FromMatrix\">FromMatrix</a> for comments about <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#Target\">Target</a> property and Viewpoint parameter.    ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#FromCameraObject"},
     {"title": "CastleRenderingCamera.TRenderingCamera.FromMatrix", "text": " <a class=\"normal\" href=\"CastleGLUtils.html#ProjectionMatrix\">ProjectionMatrix</a> is needed to calculate frustum.  <p>Remember that <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#Target\">Target</a> must be already set correctly when calling this, registered <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#OnChanged\">OnChanged</a> callbacks may read it.  <p>Viewpoint is only passed to the Changed and <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#OnChanged\">OnChanged</a>. It should be non-nil to indicate that the view comes from non-standard (not currently bound) VRML/X3D Viewpoint node.    ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#FromMatrix"},
     {"title": "CastleRenderingCamera.TRenderingCamera.Changed", "text": " This will call all registered <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#OnChanged\">OnChanged</a> events. Remember that <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#Target\">Target</a> must be already set correctly when calling this, registered <a class=\"normal\" href=\"CastleRenderingCamera.TRenderingCamera.html#OnChanged\">OnChanged</a> callbacks may read it.    ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#Changed"},
     {"title": "CastleRenderingCamera.TRenderingCamera.Target", "text": " ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#Target"},
     {"title": "CastleRenderingCamera.TRenderingCamera.OnChanged", "text": " ", "tags": "", "loc": "CastleRenderingCamera.TRenderingCamera.html#OnChanged"},
     {"title": "CastleRenderingCamera.TCameraChangedEvent", "text": "    ", "tags": "", "loc": "CastleRenderingCamera.html#TCameraChangedEvent"},
     {"title": "CastleRenderingCamera.TRenderTarget", "text": "  rtScreen Normal rendering.   rfOffScreen Rendering color buffer contents to normal single 2D texture.   rtCubeMapEnvironment Rendering color buffer contents to cube map texture.   rtShadowMap Rendering depth buffer contents to shadow map texture.   rtVarianceShadowMap Rendering with a special VSM shader to capture shadow map texture (in the normal color buffer).  ", "tags": "", "loc": "CastleRenderingCamera.html#TRenderTarget"},
     {"title": "CastleRenderingCamera.RenderingCamera", "text": "  <p><b>This is an internal information</b>, normal applications should not access camera this way (instead use <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">TCastleAbstractViewport.Camera</a>). ", "tags": "", "loc": "CastleRenderingCamera.html#RenderingCamera"},
     {"title": "CastleResources", "text": " ", "tags": "", "loc": "CastleResources.html"},
     {"title": "CastleResources.T3DResourceAnimation", "text": " ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html"},
     {"title": "CastleResources.T3DResourceAnimation.Create", "text": "    ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#Create"},
     {"title": "CastleResources.T3DResourceAnimation.BoundingBox", "text": "    ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#BoundingBox"},
     {"title": "CastleResources.T3DResourceAnimation.Defined", "text": " May be <code>False</code> only if <a class=\"normal\" href=\"CastleResources.T3DResourceAnimation.html#Required\">Required</a> was <code>False</code>, or before we actually read animation info from resource.xml file.    ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#Defined"},
     {"title": "CastleResources.T3DResourceAnimation.Scene", "text": "  <p>Looping is automatically done here, if parameter Loop is <code>True</code>. When it is <code>False</code>, there is no looping, which means that when Time is &lt; 0, we show the first frame, and when Time is &gt; <a class=\"normal\" href=\"CastleResources.T3DResourceAnimation.html#Duration\">Duration</a>, we show the last frame forever.  <p>This looping (or not looping) is done regardless of whether the 3D model wants (or not) looping. For example, in case of castle-anim-frames files, we ignore their loop boolean attribute. In case of X3D, we ignore TimeSensor.loop field. In other words, any looping settings inside 3D model are ignored. You control looping fully by the Loop parameter to this method.  <p>This returns the scene (<a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>) with state reflecting given time (<a class=\"normal\" href=\"CastleResources.T3DResourceAnimation.html#TimeSensor\">TimeSensor</a> forced to given time).    ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#Scene"},
     {"title": "CastleResources.T3DResourceAnimation.Duration", "text": " See engine tutorial about how resources animations duration is calculated. Always 0 if not <a class=\"normal\" href=\"CastleResources.T3DResourceAnimation.html#Defined\">Defined</a>. ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#Duration"},
     {"title": "CastleResources.T3DResourceAnimation.URL", "text": " See [<a  href=\"http://castle-engine.sourceforge.net/creating_data_resources.php\">http://castle-engine.sourceforge.net/creating_data_resources.php</a>] for documentation how you can define creature animations. ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#URL"},
     {"title": "CastleResources.T3DResourceAnimation.AnimationName", "text": " All animations are started by X3D <a class=\"normal\" href=\"CastleResources.T3DResourceAnimation.html#TimeSensor\">TimeSensor</a> node. If not given, we assume it's just 'animation', which is fine at least for castle-anim-frames and MD3 files loaded using TNodeInterpolator. This refers to an X3D <a class=\"normal\" href=\"CastleResources.T3DResourceAnimation.html#TimeSensor\">TimeSensor</a> node inside animation model (from <a class=\"normal\" href=\"CastleResources.T3DResourceAnimation.html#URL\">URL</a>) or, when not defined, inside whole resource model (from <a class=\"normal\" href=\"CastleResources.T3DResource.html#ModelURL\">T3DResource.ModelURL</a>).  <p>See [<a  href=\"http://castle-engine.sourceforge.net/creating_data_resources.php\">http://castle-engine.sourceforge.net/creating_data_resources.php</a>] for documentation how you can define creature animations. ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#AnimationName"},
     {"title": "CastleResources.T3DResourceAnimation.TimeSensor", "text": " ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#TimeSensor"},
     {"title": "CastleResources.T3DResourceAnimation.Name", "text": " ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#Name"},
     {"title": "CastleResources.T3DResourceAnimation.Required", "text": " ", "tags": "", "loc": "CastleResources.T3DResourceAnimation.html#Required"},
     {"title": "CastleResources.T3DResourceAnimationList", "text": " ", "tags": "", "loc": "CastleResources.T3DResourceAnimationList.html"},
     {"title": "CastleResources.T3DResourceAnimationList.FindName", "text": "     Exception if not found.", "tags": "", "loc": "CastleResources.T3DResourceAnimationList.html#FindName"},
     {"title": "CastleResources.TResourceFrame", "text": " This is reliable even when multiple <code>TResourceFrame</code> request different frames from the same animation. ", "tags": "", "loc": "CastleResources.TResourceFrame.html"},
     {"title": "CastleResources.TResourceFrame.LocalRender", "text": "    ", "tags": "", "loc": "CastleResources.TResourceFrame.html#LocalRender"},
     {"title": "CastleResources.TResourceFrame.SetFrame", "text": "    ", "tags": "", "loc": "CastleResources.TResourceFrame.html#SetFrame"},
     {"title": "CastleResources.TResourceFrame.Animation", "text": " ", "tags": "", "loc": "CastleResources.TResourceFrame.html#Animation"},
     {"title": "CastleResources.TResourceFrame.Time", "text": " ", "tags": "", "loc": "CastleResources.TResourceFrame.html#Time"},
     {"title": "CastleResources.TResourceFrame.Loop", "text": " ", "tags": "", "loc": "CastleResources.TResourceFrame.html#Loop"},
     {"title": "CastleResources.T3DResource", "text": " By itself this doesn't render or do anything. But some 3D objects may need to have such resource prepared to work.  <p>It can also load it's configuration from XML config file. For this purpose, it has a unique identifier in <a class=\"normal\" href=\"CastleResources.T3DResource.html#Name\">Name</a> property. ", "tags": "", "loc": "CastleResources.T3DResource.html"},
     {"title": "CastleResources.T3DResource.DefaultFallSpeed", "text": " ", "tags": "", "loc": "CastleResources.T3DResource.html#DefaultFallSpeed"},
     {"title": "CastleResources.T3DResource.DefaultGrowSpeed", "text": " ", "tags": "", "loc": "CastleResources.T3DResource.html#DefaultGrowSpeed"},
     {"title": "CastleResources.T3DResource.DefaultReceiveShadowVolumes", "text": " ", "tags": "", "loc": "CastleResources.T3DResource.html#DefaultReceiveShadowVolumes"},
     {"title": "CastleResources.T3DResource.DefaultCastShadowVolumes", "text": " ", "tags": "", "loc": "CastleResources.T3DResource.html#DefaultCastShadowVolumes"},
     {"title": "CastleResources.T3DResource.PrepareCore", "text": " <code>PrepareCore</code> and <a class=\"normal\" href=\"CastleResources.T3DResource.html#ReleaseCore\">ReleaseCore</a> should never be called directly, they are only to be overridden in descendants. These are used by actual <a class=\"normal\" href=\"CastleResources.T3DResource.html#Prepare\">Prepare</a> and <a class=\"normal\" href=\"CastleResources.T3DResource.html#Release\">Release</a> when the actual allocation / deallocation should take place (when <a class=\"normal\" href=\"CastleResources.T3DResource.html#UsageCount\">UsageCount</a> raises from zero or drops back to zero).  <p><a class=\"normal\" href=\"CastleResources.T3DResource.html#ReleaseCore\">ReleaseCore</a> is also called in destructor, regardless of <a class=\"normal\" href=\"CastleResources.T3DResource.html#UsageCount\">UsageCount</a>. This is done to free resources even if user forgot to call Release before destroying this resource instance.  <p><code>PrepareCore</code> must call Progress.Step exactly <a class=\"normal\" href=\"CastleResources.T3DResource.html#PrepareCoreSteps\">PrepareCoreSteps</a> times, only if DoProgress. This allows to make nice progress bar in <a class=\"normal\" href=\"CastleResources.T3DResource.html#Prepare\">Prepare</a>. In this class, <a class=\"normal\" href=\"CastleResources.T3DResource.html#PrepareCoreSteps\">PrepareCoreSteps</a> returns 0.     ", "tags": "", "loc": "CastleResources.T3DResource.html#PrepareCore"},
     {"title": "CastleResources.T3DResource.PrepareCoreSteps", "text": "    ", "tags": "", "loc": "CastleResources.T3DResource.html#PrepareCoreSteps"},
     {"title": "CastleResources.T3DResource.ReleaseCore", "text": "    ", "tags": "", "loc": "CastleResources.T3DResource.html#ReleaseCore"},
     {"title": "CastleResources.T3DResource.Create", "text": "    ", "tags": "", "loc": "CastleResources.T3DResource.html#Create"},
     {"title": "CastleResources.T3DResource.Destroy", "text": "    ", "tags": "", "loc": "CastleResources.T3DResource.html#Destroy"},
     {"title": "CastleResources.T3DResource.LoadFromFile", "text": "    ", "tags": "", "loc": "CastleResources.T3DResource.html#LoadFromFile"},
     {"title": "CastleResources.T3DResource.RedoPrepare", "text": " Call only when <a class=\"normal\" href=\"CastleResources.T3DResource.html#UsageCount\">UsageCount</a> &lt;&gt; 0, that is when resource is prepared. Shows nice progress bar, using <a class=\"normal\" href=\"CastleProgress.html#Progress\">Progress</a>.    ", "tags": "", "loc": "CastleResources.T3DResource.html#RedoPrepare"},
     {"title": "CastleResources.T3DResource.Prepare", "text": "  <p>There is an internal counter tracking how many times given resource was prepared and released. Which means that preparing and releasing resource multiple times is correct &mdash; but make sure that every single call to prepare is paired with exactly one call to release. Actual allocation / deallocation (when protected methods <a class=\"normal\" href=\"CastleResources.T3DResource.html#PrepareCore\">PrepareCore</a>, <a class=\"normal\" href=\"CastleResources.T3DResource.html#ReleaseCore\">ReleaseCore</a> are called) happens only when <a class=\"normal\" href=\"CastleResources.T3DResource.html#UsageCount\">UsageCount</a> raises from zero or drops back to zero.  <p>Show nice progress bar, using <a class=\"normal\" href=\"CastleProgress.html#Progress\">Progress</a>.  <p>  <p>  Params World parameters to prepare for. See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PrepareResources\">TCastleTransform.PrepareResources</a> for more comments.  Params World parameters to prepare for. See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PrepareResources\">TCastleTransform.PrepareResources</a> for more comments.", "tags": "", "loc": "CastleResources.T3DResource.html#Prepare"},
     {"title": "CastleResources.T3DResource.Prepare", "text": "    ", "tags": "", "loc": "CastleResources.T3DResource.html#Prepare"},
     {"title": "CastleResources.T3DResource.Release", "text": "    ", "tags": "", "loc": "CastleResources.T3DResource.html#Release"},
     {"title": "CastleResources.T3DResource.InstantiatePlaceholder", "text": "    ", "tags": "", "loc": "CastleResources.T3DResource.html#InstantiatePlaceholder"},
     {"title": "CastleResources.T3DResource.AlwaysPrepared", "text": " For example, in typical 3D game when player has inventory and can drop items from inventory on the ground, then all items should be prepared for all levels, since you can in theory drop everything anywhere.  <p>Return <code>True</code> if this is such resource.  <p>Default implementation in <a class=\"normal\" href=\"CastleResources.T3DResource.html\">T3DResource</a> returns here the <a class=\"normal\" href=\"CastleResources.T3DResource.html#ConfigAlwaysPrepared\">ConfigAlwaysPrepared</a> value, which may be set in resource.xml and by default is false. This allows to configure this using resource.xml files. Descendants may choose to override this, to override value from resource.xml file.    ", "tags": "", "loc": "CastleResources.T3DResource.html#AlwaysPrepared"},
     {"title": "CastleResources.T3DResource.Prepared", "text": " That is after a (fully successful) <a class=\"normal\" href=\"CastleResources.T3DResource.html#Prepare\">Prepare</a> call and before <a class=\"normal\" href=\"CastleResources.T3DResource.html#Release\">Release</a>. Note that this is slightly different than checking <code><a class=\"normal\" href=\"CastleResources.T3DResource.html#UsageCount\">UsageCount</a> &lt;&gt; 0</code>: in some situations, <a class=\"normal\" href=\"CastleResources.T3DResource.html#UsageCount\">UsageCount</a> may be non-zero while the preparation is not finished yet. This property is guaranteed to be <code>True</code> only if preparation was fully successfully (no exceptions) finished. ", "tags": "", "loc": "CastleResources.T3DResource.html#Prepared"},
     {"title": "CastleResources.T3DResource.Name", "text": " Used to refer to this resource from level placeholders (see <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a> about placeholders), from other XML files (for example one creature may shoot another creature as a missile using <a class=\"normal\" href=\"CastleCreatures.TWalkAttackCreatureResource.html#FireMissileName\">TWalkAttackCreatureResource.FireMissileName</a>), and in other places.  <p>This can use only letters, use CamelCase. Reason: This must be a valid identifier in both VRML/X3D and ObjectPascal. Also digits and underscores are reserved, as we may use them to get other information from placeholder names. ", "tags": "", "loc": "CastleResources.T3DResource.html#Name"},
     {"title": "CastleResources.T3DResource.UsageCount", "text": " Used by Prepare and Release: actual allocation / deallocation happens when this raises from zero or drops back to zero. ", "tags": "", "loc": "CastleResources.T3DResource.html#UsageCount"},
     {"title": "CastleResources.T3DResource.Animations", "text": "  <p>The first animation, if exists, right now determines the default radius calculation. So the first animation should have the bounding box representative for all animations. Other than that, the order on this list doesn't matter.  <p>The properties of these animations are automatically loaded from resource.xml file in <a class=\"normal\" href=\"CastleResources.T3DResource.html#LoadFromFile\">LoadFromFile</a>. The animations are automatically prepared / released by our <a class=\"normal\" href=\"CastleResources.T3DResource.html#Prepare\">Prepare</a> / <a class=\"normal\" href=\"CastleResources.T3DResource.html#Release\">Release</a> methods. ", "tags": "", "loc": "CastleResources.T3DResource.html#Animations"},
     {"title": "CastleResources.T3DResource.ConfigAlwaysPrepared", "text": " ", "tags": "", "loc": "CastleResources.T3DResource.html#ConfigAlwaysPrepared"},
     {"title": "CastleResources.T3DResource.FallSpeed", "text": " Note that the gravity direction is controlled by your level 3D model, see &quot;Which way is up&quot; section in the engine tutorial [<a  href=\"http://castle-engine.sourceforge.net/tutorial_up.php\">http://castle-engine.sourceforge.net/tutorial_up.php</a>].  <p>Currently, falling down of creatures and items just uses this constant speed. In the future, we plan to add properties to control mass and air friction and perform more physically-correct simulation of falling down.  <p>This has no effect for creatures with <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#Flying\">TCreatureResource.Flying</a> = <code>True</code>. This also has no effect for missile creatures (their <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#Flying\">TCreatureResource.Flying</a> is ignored, they have special approach to gravity).  <p>See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#FallSpeed\">TCastleTransform.FallSpeed</a> for precise definition, this works the same, except our default value is non-zero, and by default T3D.Gravity and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">TCastleTransform.PreferredHeight</a> are already sensible for creatures/items. ", "tags": "", "loc": "CastleResources.T3DResource.html#FallSpeed"},
     {"title": "CastleResources.T3DResource.GrowSpeed", "text": "  <p>&quot;Growing&quot; is used to allow non-flying creatures to climb stairs. The creature can move whenever a sphere (see <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#MiddleHeight\">TCreatureResource.MiddleHeight</a> and <a class=\"normal\" href=\"CastleCreatures.TCreatureResource.html#Radius\">TCreatureResource.Radius</a>) can move. This means that part of the bounding box (part of the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">TCastleTransform.PreferredHeight</a>) may temporarily &quot;sink&quot; into the ground. Then growing, controlled by this property, pushes the creature up.  <p>See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GrowSpeed\">TCastleTransform.GrowSpeed</a>, this works the same, except the default value is non-zero, and by default <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Gravity\">TCastleTransform.Gravity</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">TCastleTransform.PreferredHeight</a> are already sensible for creatures/items. ", "tags": "", "loc": "CastleResources.T3DResource.html#GrowSpeed"},
     {"title": "CastleResources.T3DResource.ReceiveShadowVolumes", "text": " ", "tags": "", "loc": "CastleResources.T3DResource.html#ReceiveShadowVolumes"},
     {"title": "CastleResources.T3DResource.CastShadowVolumes", "text": " ", "tags": "", "loc": "CastleResources.T3DResource.html#CastShadowVolumes"},
     {"title": "CastleResources.T3DResource.ModelURL", "text": " See [<a  href=\"http://castle-engine.sourceforge.net/creating_data_resources.php\">http://castle-engine.sourceforge.net/creating_data_resources.php</a>] for notes about &lt;model&gt; element in resource.xml files. ", "tags": "", "loc": "CastleResources.T3DResource.html#ModelURL"},
     {"title": "CastleResources.T3DResourceList", "text": " ", "tags": "", "loc": "CastleResources.T3DResourceList.html"},
     {"title": "CastleResources.T3DResourceList.FindName", "text": "     Exception if not found and NilWhenNotFound = false.", "tags": "", "loc": "CastleResources.T3DResourceList.html#FindName"},
     {"title": "CastleResources.T3DResourceList.LoadFromFiles", "text": " Overloaded version without Path just scans the whole <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> directory.  <p>Note that on Android, searching the Android asset filesystem recursively is not possible (this is a fault of Android NDK API...). So instead of this method, you should use <a class=\"normal\" href=\"CastleResources.T3DResourceList.html#AddFromFile\">AddFromFile</a> repeatedly to explicitly list all resource.xml locations.  <p>  <p>  Reload If Reload, then we will not clear the initial list contents. Instead, resource.xml files found that refer to the existing <a class=\"normal\" href=\"CastleResources.T3DResource.html#Name\">T3DResource.Name</a> will cause <a class=\"normal\" href=\"CastleResources.T3DResource.html#LoadFromFile\">T3DResource.LoadFromFile</a> call on an existing resource. Using Reload is a nice debug feature, if you want to reload configuration from resource.xml files (and eventually add new resources in new resource.xml files), but you don't want to recreate existing resource instances.  Reload If Reload, then we will not clear the initial list contents. Instead, resource.xml files found that refer to the existing <a class=\"normal\" href=\"CastleResources.T3DResource.html#Name\">T3DResource.Name</a> will cause <a class=\"normal\" href=\"CastleResources.T3DResource.html#LoadFromFile\">T3DResource.LoadFromFile</a> call on an existing resource. Using Reload is a nice debug feature, if you want to reload configuration from resource.xml files (and eventually add new resources in new resource.xml files), but you don't want to recreate existing resource instances.", "tags": "", "loc": "CastleResources.T3DResourceList.html#LoadFromFiles"},
     {"title": "CastleResources.T3DResourceList.LoadFromFiles", "text": "    ", "tags": "", "loc": "CastleResources.T3DResourceList.html#LoadFromFiles"},
     {"title": "CastleResources.T3DResourceList.AddFromFile", "text": "  <p>  Reload If <code>True</code>, and the loaded resource will have a name matching existing <a class=\"normal\" href=\"CastleResources.T3DResource.html#Name\">T3DResource.Name</a>, we will replace the current resource. Otherwise, we'll make an exception.  Reload If <code>True</code>, and the loaded resource will have a name matching existing <a class=\"normal\" href=\"CastleResources.T3DResource.html#Name\">T3DResource.Name</a>, we will replace the current resource. Otherwise, we'll make an exception.", "tags": "", "loc": "CastleResources.T3DResourceList.html#AddFromFile"},
     {"title": "CastleResources.T3DResourceList.LoadResources", "text": " &lt;prepare_resources&gt; element is an optional child of given ParentElement. Sets current list value with all mentioned required resources (subset of <a class=\"normal\" href=\"CastleResources.html#Resources\">Resources</a>).    ", "tags": "", "loc": "CastleResources.T3DResourceList.html#LoadResources"},
     {"title": "CastleResources.T3DResourceList.Prepare", "text": "     ", "tags": "", "loc": "CastleResources.T3DResourceList.html#Prepare"},
     {"title": "CastleResources.T3DResourceList.Release", "text": "    ", "tags": "", "loc": "CastleResources.T3DResourceList.html#Release"},
     {"title": "CastleResources.Resources", "text": " Usually you call <a class=\"normal\" href=\"CastleResources.T3DResourceList.html#LoadFromFiles\">Resources.LoadFromFiles</a> to fill this list, based on resource.xml files present in your data.    ", "tags": "", "loc": "CastleResources.html#Resources"},
     {"title": "CastleResources.RegisterResourceClass", "text": "    ", "tags": "", "loc": "CastleResources.html#RegisterResourceClass"},
     {"title": "CastleResources.T3DResourceClass", "text": " ", "tags": "", "loc": "CastleResources.html#T3DResourceClass"},
     {"title": "CastleScene", "text": " ", "tags": "", "loc": "CastleScene.html"},
     {"title": "CastleScene.TSceneRenderingAttributes", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html"},
     {"title": "CastleScene.TSceneRenderingAttributes.DefaultBlendingSourceFactor", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#DefaultBlendingSourceFactor"},
     {"title": "CastleScene.TSceneRenderingAttributes.DefaultBlendingDestinationFactor", "text": " See <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#BlendingDestinationFactor\">TSceneRenderingAttributes.BlendingDestinationFactor</a>.  <p>Using <a class=\"normal\" href=\"CastleGLUtils.html#bdOneMinusSrcAlpha\">bdOneMinusSrcAlpha</a> is the standard value for 3D graphic stuff, often producing best results. However, it causes troubles when multiple transparent shapes are visible on the same screen pixel. For closed convex 3D objects, using backface culling (solid = TRUE for geometry) helps. For multiple transparent shapes, sorting the transparent shapes helps, see <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#BlendingSort\">TSceneRenderingAttributes.BlendingSort</a>. Sometimes, no solution works for all camera angles.  <p>Another disadvantage of <a class=\"normal\" href=\"CastleGLUtils.html#bdOneMinusSrcAlpha\">bdOneMinusSrcAlpha</a> may be that the color of opaque shapes disappears too quickly from resulting image (since <a class=\"normal\" href=\"CastleGLUtils.html#bdOneMinusSrcAlpha\">bdOneMinusSrcAlpha</a> scales it down). So the image may be darker than you like.  <p>You can instead consider using <a class=\"normal\" href=\"CastleGLUtils.html#bdOne\">bdOne</a>, that doesn't require sorting and never has problems with multiple transparent shapes. On the other hand, it only adds to the color, often making too bright results. ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#DefaultBlendingDestinationFactor"},
     {"title": "CastleScene.TSceneRenderingAttributes.DefaultBlendingSort", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#DefaultBlendingSort"},
     {"title": "CastleScene.TSceneRenderingAttributes.DefaultWireframeColor", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#DefaultWireframeColor"},
     {"title": "CastleScene.TSceneRenderingAttributes.DefaultSolidWireframeScale", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#DefaultSolidWireframeScale"},
     {"title": "CastleScene.TSceneRenderingAttributes.DefaultSolidWireframeBias", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#DefaultSolidWireframeBias"},
     {"title": "CastleScene.TSceneRenderingAttributes.DefaultSilhouetteScale", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#DefaultSilhouetteScale"},
     {"title": "CastleScene.TSceneRenderingAttributes.DefaultSilhouetteBias", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#DefaultSilhouetteBias"},
     {"title": "CastleScene.TSceneRenderingAttributes.OnCreate", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#OnCreate"},
     {"title": "CastleScene.TSceneRenderingAttributes.ReleaseCachedResources", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#ReleaseCachedResources"},
     {"title": "CastleScene.TSceneRenderingAttributes.SetBlending", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SetBlending"},
     {"title": "CastleScene.TSceneRenderingAttributes.SetBlendingSourceFactor", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SetBlendingSourceFactor"},
     {"title": "CastleScene.TSceneRenderingAttributes.SetBlendingDestinationFactor", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SetBlendingDestinationFactor"},
     {"title": "CastleScene.TSceneRenderingAttributes.SetBlendingSort", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SetBlendingSort"},
     {"title": "CastleScene.TSceneRenderingAttributes.SetControlBlending", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SetControlBlending"},
     {"title": "CastleScene.TSceneRenderingAttributes.SetUseOcclusionQuery", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SetUseOcclusionQuery"},
     {"title": "CastleScene.TSceneRenderingAttributes.SetPhongShading", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SetPhongShading"},
     {"title": "CastleScene.TSceneRenderingAttributes.Create", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#Create"},
     {"title": "CastleScene.TSceneRenderingAttributes.Destroy", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#Destroy"},
     {"title": "CastleScene.TSceneRenderingAttributes.Assign", "text": "    ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#Assign"},
     {"title": "CastleScene.TSceneRenderingAttributes.Blending", "text": "  <p>More precisely: if this is <code>True</code>, all shapes with transparent materials or textures with non-trivial (not only yes/no) alpha channel will be rendered using OpenGL blending (with depth test off, like they should for OpenGL).  <p>If this attribute is <code>False</code>, everything will be rendered as opaque. ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#Blending"},
     {"title": "CastleScene.TSceneRenderingAttributes.BlendingSourceFactor", "text": " Note that this is only a default, VRML/X3D model can override this for specific shapes by using our extension BlendMode node. See [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_blending\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_blending</a>].  ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#BlendingSourceFactor"},
     {"title": "CastleScene.TSceneRenderingAttributes.BlendingDestinationFactor", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#BlendingDestinationFactor"},
     {"title": "CastleScene.TSceneRenderingAttributes.BlendingSort", "text": " See the <a class=\"normal\" href=\"CastleBoxes.html#TBlendingSort\">TBlendingSort</a> documentation for possible values.  <p>This may be overridden in a specific 3D models by using NavigationInfo node with <code>blendingSort</code> field, see <a class=\"normal\" href=\"X3DNodes.TNavigationInfoNode.html#BlendingSort\">TNavigationInfoNode.BlendingSort</a>. ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#BlendingSort"},
     {"title": "CastleScene.TSceneRenderingAttributes.OcclusionSort", "text": " This may generate speedup on some scenes. ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#OcclusionSort"},
     {"title": "CastleScene.TSceneRenderingAttributes.ControlBlending", "text": " This makes every other <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#Blending\">Blending</a> setting ignored, and is useful only if you set your own OpenGL blending parameters when rendering this scene. ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#ControlBlending"},
     {"title": "CastleScene.TSceneRenderingAttributes.WireframeEffect", "text": "  <p>When this is <a class=\"normal\" href=\"CastleScene.html#weNormal\">weNormal</a> (default), nothing special is done, which means that model polygons are simply passed to OpenGL. Whether this results in filled or wireframe, depends on OpenGL glPolygonMode setting, filled by default.  <p>How the wireframe effects work when Mode = <a class=\"normal\" href=\"CastleRenderer.html#rmDepth\">rmDepth</a> is undefined now. Just don't use Mode = <a class=\"normal\" href=\"CastleRenderer.html#rmDepth\">rmDepth</a> if you're unsure.  <p>See description of <a class=\"normal\" href=\"CastleScene.html#TWireframeEffect\">TWireframeEffect</a> for what other modes do. ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#WireframeEffect"},
     {"title": "CastleScene.TSceneRenderingAttributes.SolidWireframeScale", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SolidWireframeScale"},
     {"title": "CastleScene.TSceneRenderingAttributes.SolidWireframeBias", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SolidWireframeBias"},
     {"title": "CastleScene.TSceneRenderingAttributes.SilhouetteScale", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SilhouetteScale"},
     {"title": "CastleScene.TSceneRenderingAttributes.SilhouetteBias", "text": " ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#SilhouetteBias"},
     {"title": "CastleScene.TSceneRenderingAttributes.WireframeColor", "text": " Default value is <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#DefaultWireframeColor\">DefaultWireframeColor</a>. ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#WireframeColor"},
     {"title": "CastleScene.TSceneRenderingAttributes.UseOcclusionQuery", "text": " Ignored if GPU doesn't support ARB_occlusion_query.  <p><code>True</code> may give you a large speedup in some scenes. OTOH, a lag of one frame may happen between an object should be rendered and it actually appears.  <p>When you render more than once the same instance of <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> scene, you should not activate it (as the occlusion query doesn't make sense if each following render of the scene takes place at totally different translation). Also, when rendering something more than just one <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> scene (maybe many times the same <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instance, maybe many different <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instances, maybe some other 3D objects) you should try to sort rendering order from the most to the least possible occluder (otherwise occlusion query will not be as efficient at culling).  <p>This is ignored if UseHierarchicalOcclusionQuery. ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#UseOcclusionQuery"},
     {"title": "CastleScene.TSceneRenderingAttributes.DebugHierOcclusionQueryResults", "text": "  <p>Use this only after render with UseHierarchicalOcclusionQuery. TODO: for <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#UseOcclusionQuery\">UseOcclusionQuery</a> I would also like to make it work, for now not done as frustum information is gone. This will disable actual occlusion query, instead reusing results from last occlusion query done when this debug flag was <code>False</code>.  <p>Useful to quickly visualize the benefits of occlusion query. ", "tags": "", "loc": "CastleScene.TSceneRenderingAttributes.html#DebugHierOcclusionQueryResults"},
     {"title": "CastleScene.TCastleScene", "text": " This is a descendant of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> that adds efficient rendering. ", "tags": "", "loc": "CastleScene.TCastleScene.html"},
     {"title": "CastleScene.TCastleScene.InternalIgnoreFrustum", "text": " ", "tags": "", "loc": "CastleScene.TCastleScene.html#InternalIgnoreFrustum"},
     {"title": "CastleScene.TCastleScene.InternalVisibilityTest", "text": " ", "tags": "", "loc": "CastleScene.TCastleScene.html#InternalVisibilityTest"},
     {"title": "CastleScene.TCastleScene.CreateShape", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#CreateShape"},
     {"title": "CastleScene.TCastleScene.InvalidateBackground", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#InvalidateBackground"},
     {"title": "CastleScene.TCastleScene.LocalRender", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#LocalRender"},
     {"title": "CastleScene.TCastleScene.LocalRenderShadowVolume", "text": " Uses ShadowVolumeRenderer for rendering, and to detect if rendering is necessary at all. It will calculate current bounding box (looking at ParentTransform, ParentTransformIsIdentity and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#LocalBoundingBox\">LocalBoundingBox</a> method).  <p>It always uses silhouette optimization. This is the usual, fast method of rendering shadow volumes. Will not do anything (treat scene like not casting shadows, like <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#CastShadowVolumes\">CastShadowVolumes</a> = false) if the model is not perfect 2-manifold, i.e. has some BorderEdges (although we could handle some BorderEdges for some points of view, this could leading to rendering artifacts).  <p>All shadow quads are generated from scene triangles transformed by ParentTransform. We must be able to correctly detect front and back facing triangles with respect to light position, so ShadowVolumeRenderer.LightPosition and &quot;this scene transformed by ParentTransform&quot; must be in the same coordinate system. If ParentTransformIsIdentity then ParentTransform value is ignored and everything works like ParentTransform = <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Identity\">identity</a> matrix (and is a little faster in this special case).  <p>Uses TrianglesListShadowCasters and ManifoldEdges and BorderEdges (so you may prefer to prepare it before, e.g. by calling <a class=\"normal\" href=\"CastleScene.TCastleScene.html#PrepareResources\">PrepareResources</a> with <a class=\"normal\" href=\"CastleScene.html#prShadowVolume\">prShadowVolume</a> included).  <p>We look at some Attributes, like Attributes.Blending, because transparent triangles have to be handled a little differently, and when Attributes.Blending = false then all triangles are forced to be opaque. In other words, this takes Attributes into account, to cooperate with our Render method.  <p>ShadowVolumeRenderer.LightPosition is the light position. ShadowVolumeRenderer.LightPosition[3] must be 1 (to indicate positional light) or 0 (a directional light). It's expected that ShadowVolumeRenderer is already initialized by ShadowVolumeRenderer.InitFrustumAndLight.  <p>Faces (both shadow quads and caps) are rendered such that CCW &lt;=&gt; you're looking at it from outside (i.e. it's considered front face of this shadow volume).    ", "tags": "", "loc": "CastleScene.TCastleScene.html#LocalRenderShadowVolume"},
     {"title": "CastleScene.TCastleScene.Create", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#Create"},
     {"title": "CastleScene.TCastleScene.Destroy", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#Destroy"},
     {"title": "CastleScene.TCastleScene.GLContextClose", "text": " For example, release any allocated texture names.  <p>Generally speaking, destroys everything that is allocated by <a class=\"normal\" href=\"CastleScene.TCastleScene.html#PrepareResources\">PrepareResources</a> call. It's harmless to call this method when there are already no associations with current OpenGL context. This is called automatically from the destructor.    ", "tags": "", "loc": "CastleScene.TCastleScene.html#GLContextClose"},
     {"title": "CastleScene.TCastleScene.PrepareResources", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#PrepareResources"},
     {"title": "CastleScene.TCastleScene.BeforeNodesFree", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#BeforeNodesFree"},
     {"title": "CastleScene.TCastleScene.FreeResources", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#FreeResources"},
     {"title": "CastleScene.TCastleScene.Background", "text": " Current background is the top node on the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#BackgroundStack\">BackgroundStack</a> of this scene, following VRML/X3D specifications, and can be dynamic. The scene manager should use this to render background.  <p>You should not access the background this way in your own code. This is public only because our own <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> needs to access it. And this is not marked &quot;internal&quot; because you may want to implement custom <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> descendants that override this.  <p><b>If you simply use <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> to render 3D stuff, and want to change background properties, then do not use this method.</b> To change the background, find (or add) an X3D <code>Background</code> node (<a class=\"normal\" href=\"X3DNodes.TBackgroundNode.html\">TBackgroundNode</a> instance) in the X3D graph in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a>, and change it's properties or &quot;bind&quot; to change current backround.  <p>We use the current value of <a class=\"normal\" href=\"CastleScene.TCastleScene.html#BackgroundSkySphereRadius\">BackgroundSkySphereRadius</a>.  <p>Returns <code>Nil</code> if there is no currently bound background node in this scene, or if the bound background is not supported for now (the latter case right now happens with TextureBakckground).  <p>This instance is managed (automatically created/freed and so on) by this <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instance. It is cached (so that it's recreated only when relevant things change, like VRML/X3D nodes affecting this background, or changes to <a class=\"normal\" href=\"CastleScene.TCastleScene.html#BackgroundSkySphereRadius\">BackgroundSkySphereRadius</a>, or OpenGL context is closed).    ", "tags": "", "loc": "CastleScene.TCastleScene.html#Background"},
     {"title": "CastleScene.TCastleScene.Attributes", "text": "  <p>You are free to change them all at any time. Although note that changing some attributes (the ones defined in base <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html\">TRenderingAttributes</a> class) may be a costly operation (next <a class=\"normal\" href=\"CastleScene.TCastleScene.html#PrepareResources\">PrepareResources</a> with <a class=\"normal\" href=\"CastleScene.html#prRender\">prRender</a>, or Render call, may need to recalculate some things).    ", "tags": "", "loc": "CastleScene.TCastleScene.html#Attributes"},
     {"title": "CastleScene.TCastleScene.UpdateGeneratedTextures", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#UpdateGeneratedTextures"},
     {"title": "CastleScene.TCastleScene.ViewChangedSuddenly", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#ViewChangedSuddenly"},
     {"title": "CastleScene.TCastleScene.VisibleChangeNotification", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#VisibleChangeNotification"},
     {"title": "CastleScene.TCastleScene.CameraChanged", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#CameraChanged"},
     {"title": "CastleScene.TCastleScene.ScreenEffects", "text": " <a class=\"normal\" href=\"CastleScene.TCastleScene.html#ScreenEffectsCount\">ScreenEffectsCount</a> may actually prepare screen effects.     ", "tags": "", "loc": "CastleScene.TCastleScene.html#ScreenEffects"},
     {"title": "CastleScene.TCastleScene.ScreenEffectsCount", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#ScreenEffectsCount"},
     {"title": "CastleScene.TCastleScene.ScreenEffectsNeedDepth", "text": "    ", "tags": "", "loc": "CastleScene.TCastleScene.html#ScreenEffectsNeedDepth"},
     {"title": "CastleScene.TCastleScene.Clone", "text": " The created scene has exactly the same class as this one (we use ClassType.Create to call a virtual constructor).  <p>Note that this <b>does not copy other scene attributes</b>, like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">ProcessEvents</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">Spatial</a> or rendering attributes in <a class=\"normal\" href=\"CastleScene.TCastleScene.html#Attributes\">Attributes</a>.    ", "tags": "", "loc": "CastleScene.TCastleScene.html#Clone"},
     {"title": "CastleScene.TCastleScene.BackgroundSkySphereRadius", "text": " ", "tags": "", "loc": "CastleScene.TCastleScene.html#BackgroundSkySphereRadius"},
     {"title": "CastleScene.TCastleScene.FrustumCulling", "text": "  <p><a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Render\">Render</a> tests each Shape for collision with given Frustum before rendering this Shape. It can use Shape.BoundingBox or Shape.BoundingSphere or both. See <a class=\"normal\" href=\"CastleScene.html#TFrustumCulling\">TFrustumCulling</a>.  <p>Shape.BoundingBox is (in a current implementation) always a better approximation of shape geometry than Shape.BoundingSphere. So advantage of using Shape.BoundingBox is that more Shapes may be eliminated. Advantage of using Shape.BoundingSphere is that checking for collision Frustum&lt;-&gt;Sphere is faster, so you don't waste so much time on testing for collisions between frustum and Shape. ", "tags": "", "loc": "CastleScene.TCastleScene.html#FrustumCulling"},
     {"title": "CastleScene.TCastleScene.OctreeFrustumCulling", "text": "  <p>See <a class=\"normal\" href=\"CastleScene.html#TFrustumCulling\">TFrustumCulling</a>. ", "tags": "", "loc": "CastleScene.TCastleScene.html#OctreeFrustumCulling"},
     {"title": "CastleScene.TCastleScene.ReceiveShadowVolumes", "text": " ", "tags": "", "loc": "CastleScene.TCastleScene.html#ReceiveShadowVolumes"},
     {"title": "CastleScene.TCastleScene.DistanceCulling", "text": " Ignored if &lt;= 0. ", "tags": "", "loc": "CastleScene.TCastleScene.html#DistanceCulling"},
     {"title": "CastleScene.TCastleSceneList", "text": " ", "tags": "", "loc": "CastleScene.TCastleSceneList.html"},
     {"title": "CastleScene.TCastleSceneList.GLContextClose", "text": "    ", "tags": "", "loc": "CastleScene.TCastleSceneList.html#GLContextClose"},
     {"title": "CastleScene.TCastleSceneList.ViewChangedSuddenly", "text": "    ", "tags": "", "loc": "CastleScene.TCastleSceneList.html#ViewChangedSuddenly"},
     {"title": "CastleScene.prRender", "text": " ", "tags": "", "loc": "CastleScene.html#prRender"},
     {"title": "CastleScene.prBackground", "text": " ", "tags": "", "loc": "CastleScene.html#prBackground"},
     {"title": "CastleScene.prBoundingBox", "text": " ", "tags": "", "loc": "CastleScene.html#prBoundingBox"},
     {"title": "CastleScene.prShadowVolume", "text": " ", "tags": "", "loc": "CastleScene.html#prShadowVolume"},
     {"title": "CastleScene.bsNone", "text": " ", "tags": "", "loc": "CastleScene.html#bsNone"},
     {"title": "CastleScene.bs2D", "text": " ", "tags": "", "loc": "CastleScene.html#bs2D"},
     {"title": "CastleScene.bs3D", "text": " ", "tags": "", "loc": "CastleScene.html#bs3D"},
     {"title": "CastleScene.paDefault", "text": " ", "tags": "", "loc": "CastleScene.html#paDefault"},
     {"title": "CastleScene.paForceLooping", "text": " ", "tags": "", "loc": "CastleScene.html#paForceLooping"},
     {"title": "CastleScene.paForceNotLooping", "text": " ", "tags": "", "loc": "CastleScene.html#paForceNotLooping"},
     {"title": "CastleScene.ssRendering", "text": " ", "tags": "", "loc": "CastleScene.html#ssRendering"},
     {"title": "CastleScene.ssDynamicCollisions", "text": " ", "tags": "", "loc": "CastleScene.html#ssDynamicCollisions"},
     {"title": "CastleScene.ssVisibleTriangles", "text": " ", "tags": "", "loc": "CastleScene.html#ssVisibleTriangles"},
     {"title": "CastleScene.ssStaticCollisions", "text": " ", "tags": "", "loc": "CastleScene.html#ssStaticCollisions"},
     {"title": "CastleScene.Register", "text": "    ", "tags": "", "loc": "CastleScene.html#Register"},
     {"title": "CastleScene.TWireframeEffect", "text": "  <p>Generally, two other attributes may affect the way wireframe is rendered: <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#WireframeColor\">TSceneRenderingAttributes.WireframeColor</a> and TSceneRenderingAttributes.LineWidth, quite self-explanatory.  weNormal Default setting, model polygons are simply passed to OpenGL.  Whether this results in filled or wireframe look, depends on OpenGL glPolygonMode setting, filled by default.  weWireframeOnly The model is rendered in wireframe mode.   <p>LineWidth is used as wireframe line width (regardless of TSceneRenderingAttributes.Mode).  <p>Depending on TSceneRenderingAttributes.Mode value:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>If &lt;&gt; <a class=\"normal\" href=\"CastleRenderer.html#rmFull\">rmFull</a> then WireframeColor is used as wireframe line color.</p></li>   <li><p>If <a class=\"normal\" href=\"CastleRenderer.html#rmFull\">rmFull</a>, then lines are colored and potentially lighted and textured just like their corresponding triangles would be colored. So you can control lighting using Lighting, UseSceneLights etc. attributes, and you can control texturing by EnableTextures attribute.</p></li> </ul>  <p>  weSolidWireframe The model is rendered as normal, with it's wireframe version visible on top.  This is most often called &quot;solid wireframe&quot;, since the intention is too see wireframe version of the model but still render shapes solid (e.g. filled polygons with depth test).  <p><a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#WireframeColor\">Scene.Attributes.WireframeColor</a> and <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#LineWidth\">Scene.Attributes.LineWidth</a> determine the color and width of lines.  <p>This is often used together with the <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#Mode\">Attributes.Mode</a> set to <a class=\"normal\" href=\"CastleRenderer.html#rmSolidColor\">rmSolidColor</a>. In such case, Then <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#SolidColor\">TRenderingAttributes.SolidColor</a> determinesthe fill color.  weSilhouette The model is rendered as normal, with silhouette outlined around it.  This works quite like <a class=\"normal\" href=\"CastleScene.html#weSolidWireframe\">weSolidWireframe</a>, except that <a class=\"normal\" href=\"CastleScene.html#weSolidWireframe\">weSolidWireframe</a> makes the wireframe mesh slightly in front the model, while <code>weSilhouette</code> makes the wireframe mesh slightly at the back of the model. This way only the silhouette is visible from the wireframe rendering.  <p><a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#WireframeColor\">Scene.Attributes.WireframeColor</a> and <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#LineWidth\">Scene.Attributes.LineWidth</a> determine the color and width of silhouette lines.  <p>This is often used together with the <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#Mode\">Attributes.Mode</a> set to <a class=\"normal\" href=\"CastleRenderer.html#rmSolidColor\">rmSolidColor</a>. In such case, Then <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#SolidColor\">TRenderingAttributes.SolidColor</a> determinesthe fill color. ", "tags": "", "loc": "CastleScene.html#TWireframeEffect"},
     {"title": "CastleScene.TBeforeShapeRenderProc", "text": "    ", "tags": "", "loc": "CastleScene.html#TBeforeShapeRenderProc"},
     {"title": "CastleScene.TRenderingAttributesEvent", "text": "    ", "tags": "", "loc": "CastleScene.html#TRenderingAttributesEvent"},
     {"title": "CastleScene.TPrepareResourcesOption", "text": " ", "tags": "", "loc": "CastleScene.html#TPrepareResourcesOption"},
     {"title": "CastleScene.TPrepareResourcesOptions", "text": " ", "tags": "", "loc": "CastleScene.html#TPrepareResourcesOptions"},
     {"title": "CastleScene.TFrustumCulling", "text": "  <p>This is used for <a class=\"normal\" href=\"CastleScene.TCastleScene.html#FrustumCulling\">TCastleScene.FrustumCulling</a> (what checks should be done when shapes octree is not available) and <a class=\"normal\" href=\"CastleScene.TCastleScene.html#OctreeFrustumCulling\">TCastleScene.OctreeFrustumCulling</a> (what checks should be done when shapes octree is available).  <p>In the second case, checks done by <code>TFrustumCulling</code> are applied after octree traverse. That is, octree already eliminated some shapes, and fully included some other shapes while traversing. <code>TFrustumCulling</code> are used in this case only as a &quot;last resort&quot;, to check only the shapes in octree leaves that are in &quot;possibly-colliding&quot; state with frustum.  <p>Generally, more checks mean that more shapes may be eliminated but also that we waste more time on checks themselves. What is optimal depends on given 3D model, and how you expect the player to view it (e.g. if player usually sees the whole model, then <code>TFrustumCulling</code> checks may be useless waste of time; OTOH, if player stands inside the model composed from many shapes then <code>TFrustumCulling</code> may help).  fcNone No checks.   <p>Setting this as <a class=\"normal\" href=\"CastleScene.TCastleScene.html#FrustumCulling\">TCastleScene.FrustumCulling</a> turns off frustum culling entirely, which is usually not a wise thing to do. Setting this as <a class=\"normal\" href=\"CastleScene.TCastleScene.html#OctreeFrustumCulling\">TCastleScene.OctreeFrustumCulling</a> means that frustum culling is only done during octree traversal (we only visit octree nodes possibly colliding with frustum), this is also not optimal.  fcSphere Check shape's bounding sphere for collision with frustum.   fcBox Check shape's bounding box for collision with frustum.   fcBoth Check shape's bounding sphere, and then box, for collision with frustum.  This is the most rigoristic check, but usually this is a waste of time: in most cases, when bounding sphere collides, then bounding box collides too. ", "tags": "", "loc": "CastleScene.html#TFrustumCulling"},
     {"title": "CastleScene.TTriangle4List", "text": " ", "tags": "", "loc": "CastleScene.html#TTriangle4List"},
     {"title": "CastleScene.GLContextCache", "text": " This caches common things, like textures, shapes, and much more. Our OpenGL resources are currently shared across all OpenGL contexts, and they all automatically share this cache. ", "tags": "", "loc": "CastleScene.html#GLContextCache"},
     {"title": "CastleSceneCore", "text": " ", "tags": "", "loc": "CastleSceneCore.html"},
     {"title": "CastleSceneCore.TX3DBindableStack", "text": " This keeps a stack of <a class=\"normal\" href=\"X3DNodes.TAbstractBindableNode.html\">TAbstractBindableNode</a>, with comfortable routines to examine top and push/pop from top. The stack is actually stored as a list, with the last item being the top one. ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html"},
     {"title": "CastleSceneCore.TX3DBindableStack.DoBoundChanged", "text": " In this class, just calls <a class=\"normal\" href=\"CastleSceneCore.TX3DBindableStack.html#OnBoundChanged\">OnBoundChanged</a> if assigned.    ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html#DoBoundChanged"},
     {"title": "CastleSceneCore.TX3DBindableStack.DoScheduleBoundChanged", "text": " Either now (when not inside BeginChangesSchedule / EndChangesSchedule) or at a closing EndChangesSchedule.    ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html#DoScheduleBoundChanged"},
     {"title": "CastleSceneCore.TX3DBindableStack.Create", "text": "    ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html#Create"},
     {"title": "CastleSceneCore.TX3DBindableStack.Top", "text": "    ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html#Top"},
     {"title": "CastleSceneCore.TX3DBindableStack.PushIfEmpty", "text": " If SendEvents, then isBound = true and bindTime events will be send to newly bound node.    ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html#PushIfEmpty"},
     {"title": "CastleSceneCore.TX3DBindableStack.CheckForDeletedNodes", "text": " In this case, they have to be removed from stack.  <p>If this will change the currently bound node, then the new bound node will receive isBound = true and bindTime events (the old node will not receive any <a class=\"normal\" href=\"CastleSceneCore.TX3DBindableStack.html#Set_Bind\">set_bind</a> = false or isBound = false events, since it may be destroyed by now).    ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html#CheckForDeletedNodes"},
     {"title": "CastleSceneCore.TX3DBindableStack.Set_Bind", "text": " This always generates appropriate events.    ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html#Set_Bind"},
     {"title": "CastleSceneCore.TX3DBindableStack.ParentScene", "text": " ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html#ParentScene"},
     {"title": "CastleSceneCore.TX3DBindableStack.OnBoundChanged", "text": " This also includes notification when <a class=\"normal\" href=\"CastleSceneCore.TX3DBindableStack.html#Top\">Top</a> changed to (or from) <code>Nil</code>, that is when no node becomes bound or when some node is initially bound. ", "tags": "", "loc": "CastleSceneCore.TX3DBindableStack.html#OnBoundChanged"},
     {"title": "CastleSceneCore.TBackgroundStack", "text": " ", "tags": "", "loc": "CastleSceneCore.TBackgroundStack.html"},
     {"title": "CastleSceneCore.TBackgroundStack.Top", "text": "    ", "tags": "", "loc": "CastleSceneCore.TBackgroundStack.html#Top"},
     {"title": "CastleSceneCore.TBackgroundStack.PushIfEmpty", "text": "    ", "tags": "", "loc": "CastleSceneCore.TBackgroundStack.html#PushIfEmpty"},
     {"title": "CastleSceneCore.TFogStack", "text": " ", "tags": "", "loc": "CastleSceneCore.TFogStack.html"},
     {"title": "CastleSceneCore.TFogStack.Top", "text": "    ", "tags": "", "loc": "CastleSceneCore.TFogStack.html#Top"},
     {"title": "CastleSceneCore.TFogStack.PushIfEmpty", "text": "    ", "tags": "", "loc": "CastleSceneCore.TFogStack.html#PushIfEmpty"},
     {"title": "CastleSceneCore.TNavigationInfoStack", "text": " ", "tags": "", "loc": "CastleSceneCore.TNavigationInfoStack.html"},
     {"title": "CastleSceneCore.TNavigationInfoStack.DoBoundChanged", "text": "    ", "tags": "", "loc": "CastleSceneCore.TNavigationInfoStack.html#DoBoundChanged"},
     {"title": "CastleSceneCore.TNavigationInfoStack.Top", "text": "    ", "tags": "", "loc": "CastleSceneCore.TNavigationInfoStack.html#Top"},
     {"title": "CastleSceneCore.TNavigationInfoStack.PushIfEmpty", "text": "    ", "tags": "", "loc": "CastleSceneCore.TNavigationInfoStack.html#PushIfEmpty"},
     {"title": "CastleSceneCore.TViewpointStack", "text": " ", "tags": "", "loc": "CastleSceneCore.TViewpointStack.html"},
     {"title": "CastleSceneCore.TViewpointStack.DoBoundChanged", "text": "    ", "tags": "", "loc": "CastleSceneCore.TViewpointStack.html#DoBoundChanged"},
     {"title": "CastleSceneCore.TViewpointStack.Top", "text": "    ", "tags": "", "loc": "CastleSceneCore.TViewpointStack.html#Top"},
     {"title": "CastleSceneCore.TViewpointStack.PushIfEmpty", "text": "    ", "tags": "", "loc": "CastleSceneCore.TViewpointStack.html#PushIfEmpty"},
     {"title": "CastleSceneCore.TTransformInstancesList", "text": " ", "tags": "", "loc": "CastleSceneCore.TTransformInstancesList.html"},
     {"title": "CastleSceneCore.TTransformInstancesList.Instances", "text": " If not found, and AutoCreate, then creates new. If not found, and not AutoCreate, then return <code>Nil</code>.    ", "tags": "", "loc": "CastleSceneCore.TTransformInstancesList.html#Instances"},
     {"title": "CastleSceneCore.TTransformInstancesList.FreeShapeTrees", "text": "    ", "tags": "", "loc": "CastleSceneCore.TTransformInstancesList.html#FreeShapeTrees"},
     {"title": "CastleSceneCore.TTimeDependentHandlerList", "text": " ", "tags": "", "loc": "CastleSceneCore.TTimeDependentHandlerList.html"},
     {"title": "CastleSceneCore.TTimeDependentHandlerList.AddIfNotExists", "text": "    ", "tags": "", "loc": "CastleSceneCore.TTimeDependentHandlerList.html#AddIfNotExists"},
     {"title": "CastleSceneCore.TCastleSceneCore", "text": " Almost everything visible in your game will be an instance of <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>, which is a descendant of this class that adds rendering capabilities.  <p>This class provides a lot of functionality, like loading of the scene (<a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Load\">Load</a> method), animating it, performing collisions with the scene, and calculating things (like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#LocalBoundingBox\">LocalBoundingBox</a>).  <p>The actual scene information (visible and collidable things) is inside X3D nodes graph contained within the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a>. During the lifetime of the scene, this X3D graph can change (e.g. because of animations), and you can always change it by code too. E.g. you can freely change <a class=\"normal\" href=\"X3DNodes.TTransformNode.html#Translation\">TTransformNode.Translation</a> or add children by <a class=\"normal\" href=\"X3DNodes.TAbstractX3DGroupingNode.html#AddChildren\">RootNode.AddChildren</a>. The X3D nodes graph works like a DOM tree for rendering HTML documents: it's typically initialized from a file (3D model), but during the game execution it is dynamic, always changing.  <p>This class takes care of performing the X3D events and routes mechanism (if <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">ProcessEvents</a> is <code>True</code>). This is what allows X3D graph to be animated, or even be interactive (respond to user actions). For a simple way to play animations, use the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PlayAnimation\">PlayAnimation</a> method.  <p>This class maintains a <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Shapes\">Shapes</a> tree is always synchronized with the X3D nodes tree in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a>. The <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Shapes\">Shapes</a> tree provides a little simple view at the scene, sometimes easier (or faster) to iterate over.  <p>Many results are cached, so querying them multiple times is fast, if the scene does not change (in a significant way) between each query. So you can query information like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#LocalBoundingBox\">LocalBoundingBox</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#BoundingBox\">BoundingBox</a>, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#VerticesCount\">VerticesCount</a>... as often as you want to. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html"},
     {"title": "CastleSceneCore.TCastleSceneCore.ScreenEffectNodes", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ScreenEffectNodes"},
     {"title": "CastleSceneCore.TCastleSceneCore.IsVisibleNow", "text": " Descendants may set this to <code>True</code> during <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#LocalRender\">TCastleTransform.LocalRender</a>. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#IsVisibleNow"},
     {"title": "CastleSceneCore.TCastleSceneCore.GeneratedTextures", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#GeneratedTextures"},
     {"title": "CastleSceneCore.TCastleSceneCore.DefaultShadowMapsDefaultSize", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#DefaultShadowMapsDefaultSize"},
     {"title": "CastleSceneCore.TCastleSceneCore.CreateShape", "text": " In this class, this simply creates new <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> instance. If you make a descendant of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, you may need to store some per-shape information, and then it may be useful to have your own <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> descendant to carry this information. So you can override this to create your own descendant, and then you're sure that all leafs within Shapes tree are created using this.  <p>Example: <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> uses this to create TGLShape.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CreateShape"},
     {"title": "CastleSceneCore.TCastleSceneCore.UpdateHeadlightOnFromNavigationInfo", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#UpdateHeadlightOnFromNavigationInfo"},
     {"title": "CastleSceneCore.TCastleSceneCore.InvalidateBackground", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InvalidateBackground"},
     {"title": "CastleSceneCore.TCastleSceneCore.ChangedTransform", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ChangedTransform"},
     {"title": "CastleSceneCore.TCastleSceneCore.ChangeWorld", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ChangeWorld"},
     {"title": "CastleSceneCore.TCastleSceneCore.DoPointingDeviceSensorsChange", "text": "  <p>In this class, <code>DoPointingDeviceSensorsChange</code> updates Cursor and calls <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#OnPointingDeviceSensorsChange\">OnPointingDeviceSensorsChange</a>.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#DoPointingDeviceSensorsChange"},
     {"title": "CastleSceneCore.TCastleSceneCore.ExecuteCompiledScript", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ExecuteCompiledScript"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalHeightCollision", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalHeightCollision"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalMoveCollision", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalMoveCollision"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalMoveCollision", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalMoveCollision"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalSegmentCollision", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalSegmentCollision"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalSphereCollision", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalSphereCollision"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalSphereCollision2D", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalSphereCollision2D"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalPointCollision2D", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalPointCollision2D"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalBoxCollision", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalBoxCollision"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalRayCollision", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalRayCollision"},
     {"title": "CastleSceneCore.TCastleSceneCore.Create", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Create"},
     {"title": "CastleSceneCore.TCastleSceneCore.Load", "text": " This replaces <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a> with new value.  <p>If AResetTime, we will also do <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ResetTimeAtLoad\">ResetTimeAtLoad</a>, changing <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Time\">Time</a> &mdash; this is usually what you want when you really load a new world.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Load"},
     {"title": "CastleSceneCore.TCastleSceneCore.Load", "text": "  <p>Model is loaded by <a class=\"normal\" href=\"X3DLoad.html#Load3D\">Load3D</a>, so this supports all 3D model formats that <a class=\"normal\" href=\"X3DLoad.html#Load3D\">Load3D</a> handles (VRML, X3D, Wavefront OBJ, 3DS, Collada and more).  <p><a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#URL\">URL</a> is downloaded using <a class=\"normal\" href=\"CastleDownload.html\">CastleDownload</a> unit. If you all you care about is loading normal files, then just pass a normal filename (absolute or relative to the current directory) as the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#URL\">URL</a> parameter.  <p>  AllowStdIn If AllowStdIn and AURL = '-' then we will load a file from standard input (<a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a>), using current working directory as BaseUrl (to resolve relative URLs from the file). Currently, this limits the file to be VRML/X3D.  AllowStdIn If AllowStdIn and AURL = '-' then we will load a file from standard input (<a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a>), using current working directory as BaseUrl (to resolve relative URLs from the file). Currently, this limits the file to be VRML/X3D.", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Load"},
     {"title": "CastleSceneCore.TCastleSceneCore.Save", "text": "  <p>The X3D encoding is automatically guessed from the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#URL\">URL</a> extension. By default it is XML, and we suggest using the <code>.x3d</code> extension. If you specify an extension indicating &quot;classic encoding&quot;, we will use such encoding (use <code>.x3dv</code> for X3D in classic encoding, or <code>.wrl</code> for older VRML content).  <p>The file may also be automatically gzip compressed if extension indicates it. Use <code>.x3d.gz</code> to indicated XML compressed with gzip, or use <code>.x3dv.gz</code> or <code>.wrl.gz</code> to indicate classic encoding compressed with gzip.  <p>The <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#URL\">URL</a> property is also changed.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Save"},
     {"title": "CastleSceneCore.TCastleSceneCore.Destroy", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Destroy"},
     {"title": "CastleSceneCore.TCastleSceneCore.ShapesActiveCount", "text": " This is equivalent to Shapes.ShapesCount(true), except that this is faster (it's cached and reused in this instance, and automatically invalidated only when needed).    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ShapesActiveCount"},
     {"title": "CastleSceneCore.TCastleSceneCore.ShapesActiveVisibleCount", "text": "  <p>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ShapesActiveVisibleCount"},
     {"title": "CastleSceneCore.TCastleSceneCore.VerticesCount", "text": " For detailed specification of what these functions do (and what does OverTriangulate mean) see appropriate <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> methods. Here, we just sum their results for all shapes.     ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#VerticesCount"},
     {"title": "CastleSceneCore.TCastleSceneCore.TrianglesCount", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#TrianglesCount"},
     {"title": "CastleSceneCore.TCastleSceneCore.ViewpointsCount", "text": "     ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ViewpointsCount"},
     {"title": "CastleSceneCore.TCastleSceneCore.GetViewpointName", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#GetViewpointName"},
     {"title": "CastleSceneCore.TCastleSceneCore.MoveToViewpoint", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#MoveToViewpoint"},
     {"title": "CastleSceneCore.TCastleSceneCore.AddViewpointFromCamera", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#AddViewpointFromCamera"},
     {"title": "CastleSceneCore.TCastleSceneCore.BeforeNodesFree", "text": " In particular, this will release OpenGL resources connected to your nodes. You should always call this <i>before</i> you (may) free some nodes in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a>.  <p><i>You have to call <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a> or Load at sometime after <code>BeforeNodesFree</code>, and before you try actual rendering, events etc.</i> Otherwise some stuff may not get recalculated.  <p>The InternalChangedAll parameter is for internal use. It is set to <code>True</code> when <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a> calls this method at the beginning of it's work, and means that nothing is freed, and we only require necessary cleanup at the beginning of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a>. This way <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a> (when it wasn't preceeded by explicit <code>BeforeNodesFree</code>(false)) produces events from stacks CheckForDeletedNodes.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#BeforeNodesFree"},
     {"title": "CastleSceneCore.TCastleSceneCore.NodeFreeRemovingFromAllParents", "text": " This makes sure we call <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#BeforeNodesFree\">BeforeNodesFree</a> befor freeing, and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a> afterwards.  <p>This avoids a common pitfall with relying on <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> or such existence between <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#BeforeNodesFree\">BeforeNodesFree</a> and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a>. <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#BeforeNodesFree\">BeforeNodesFree</a> may free all our <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> instances, so if you want to free <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> from our graph &mdash; you typically want to get this <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> instance *before* calling <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#BeforeNodesFree\">BeforeNodesFree</a>. Using this method to free the node ensures this.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#NodeFreeRemovingFromAllParents"},
     {"title": "CastleSceneCore.TCastleSceneCore.RemoveShape", "text": " In case of VRML 1.0 / Inventor, when the Shape doesn't have a node, we remove the geometry node.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#RemoveShape"},
     {"title": "CastleSceneCore.TCastleSceneCore.ChangedAll", "text": " This includes adding/removal of some nodes within <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a> graph and changing their fields' values. (Before freeing the nodes, remember to also call <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#BeforeNodesFree\">BeforeNodesFree</a> earlier.)  <p><b>You usually never need to call this method explicitly. It's called by engine when necesssary.</b> However, you need to call it yourself if you change the X3D graph directly through nodes' <code>FdXxx</code> fields, and you don't want to call for some reason <a class=\"normal\" href=\"X3DFields.TX3DField.html\">FdXxx.Changed</a>.  <p><code>ChangedAll</code> causes recalculation of all things dependent on <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a>, so it's very costly to call this. Avoid calling this. When you change a simple field, like by <code>FdXxx.Value := ...</code>, you should rather call <code>FdXxx.Changed</code>, and it may do something much faster than rebuilding the scene.  <p><i>Descendant implementors notes:</i> <code>ChangedAll</code> is virtual, when overriding it remember that it's called by constructor of this class, so you can put a lot of your initialization there (instead of in the constructor).  <p><code>ChangedAll</code> calls <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#BeforeNodesFree\">BeforeNodesFree</a>(true) first, for safety (and TGLShape actually depends on it, see implementation comments).    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ChangedAll"},
     {"title": "CastleSceneCore.TCastleSceneCore.DoGeometryChanged", "text": " Does <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#OnGeometryChanged\">OnGeometryChanged</a>, and does some other stuff necessary (mark some octrees for regenerating at next access).  <p>This is public only for overloading (and for internal <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> access). Do not call this yourself &mdash; <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> implementations know when and how to call this.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#DoGeometryChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.DoViewpointsChanged", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#DoViewpointsChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.DoBoundViewpointVectorsChanged", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#DoBoundViewpointVectorsChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.DoBoundNavigationInfoFieldsChanged", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#DoBoundNavigationInfoFieldsChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.ScheduleChangedAll", "text": "  <p>Since these calls may be costly (traversing the hierarchy), and their results are often not immediately needed by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> or <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> hierarchy, it's sometimes not desirable to call them immediately when geometry changed / all changed.  <p>So you can use <code>ScheduleChangedAll</code> instead of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a>. All event handlers within <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> already do this.  <p>When you're within Begin/<a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#EndChangesSchedule\">EndChangesSchedule</a>, then <code>ScheduleChangedAll</code> just sets an internal flag and actual <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a> will be done only once at <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#EndChangesSchedule\">EndChangesSchedule</a>. Otherwise (when not within Begin/<a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#EndChangesSchedule\">EndChangesSchedule</a>), <code>ScheduleChangedAll</code> will immediately call <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a>.  <p>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ScheduleChangedAll"},
     {"title": "CastleSceneCore.TCastleSceneCore.BeginChangesSchedule", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#BeginChangesSchedule"},
     {"title": "CastleSceneCore.TCastleSceneCore.EndChangesSchedule", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#EndChangesSchedule"},
     {"title": "CastleSceneCore.TCastleSceneCore.Info", "text": " This consists of a few lines, separated by newlines. Last line also ends with <a class=\"normal\" href=\"CastleUtils.html#NL\">CastleUtils.NL</a>.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Info"},
     {"title": "CastleSceneCore.TCastleSceneCore.InfoTriangleVerticesCounts", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InfoTriangleVerticesCounts"},
     {"title": "CastleSceneCore.TCastleSceneCore.InfoBoundingBox", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InfoBoundingBox"},
     {"title": "CastleSceneCore.TCastleSceneCore.InfoManifoldAndBorderEdges", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InfoManifoldAndBorderEdges"},
     {"title": "CastleSceneCore.TCastleSceneCore.EdgesCount", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#EdgesCount"},
     {"title": "CastleSceneCore.TCastleSceneCore.InternalOctreeRendering", "text": " Add <a class=\"normal\" href=\"CastleSceneCore.html#ssRendering\">ssRendering</a> to <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">Spatial</a> property, otherwise it's <code>Nil</code>.  <p><b>You should not usually use this directly. Instead use SceneManager (like <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> or <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html\">T2DSceneManager</a>) and then use <code>SceneManager.Items.WorldXxxCollision</code> methods like <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldRay\">SceneManager.Items.WorldRay</a> or <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldSphereCollision\">SceneManager.Items.WorldSphereCollision</a>.</b>  <p>Note that when VRML/X3D scene contains Collision nodes, this octree contains the <i>visible (not necessarily collidable)</i> objects.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InternalOctreeRendering"},
     {"title": "CastleSceneCore.TCastleSceneCore.InternalOctreeDynamicCollisions", "text": " Add <a class=\"normal\" href=\"CastleSceneCore.html#ssDynamicCollisions\">ssDynamicCollisions</a> to <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">Spatial</a> property, otherwise it's <code>Nil</code>.  <p><b>You should not usually use this directly. Instead use SceneManager (like <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> or <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html\">T2DSceneManager</a>) and then use <code>SceneManager.Items.WorldXxxCollision</code> methods like <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldRay\">SceneManager.Items.WorldRay</a> or <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldSphereCollision\">SceneManager.Items.WorldSphereCollision</a>.</b>  <p>You can use <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InternalOctreeCollisions\">InternalOctreeCollisions</a> to get either <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InternalOctreeDynamicCollisions\">InternalOctreeDynamicCollisions</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InternalOctreeStaticCollisions\">InternalOctreeStaticCollisions</a>, whichever is available.  <p>Note that when VRML/X3D scene contains Collision nodes, this octree contains the <i>collidable (not necessarily rendered)</i> objects.  <p>TODO: Temporarily, this is updated simply by rebuilding.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InternalOctreeDynamicCollisions"},
     {"title": "CastleSceneCore.TCastleSceneCore.InternalOctreeVisibleTriangles", "text": " Add <a class=\"normal\" href=\"CastleSceneCore.html#ssVisibleTriangles\">ssVisibleTriangles</a> to <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">Spatial</a> property, otherwise it's <code>Nil</code>.  <p><b>You should not usually use this directly. Instead use SceneManager (like <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> or <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html\">T2DSceneManager</a>) and then use <code>SceneManager.Items.WorldXxxCollision</code> methods like <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldRay\">SceneManager.Items.WorldRay</a> or <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldSphereCollision\">SceneManager.Items.WorldSphereCollision</a>.</b>  <p>Note that when VRML/X3D scene contains X3D Collision nodes, this octree contains the <i>visible (not necessarily collidable)</i> objects.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InternalOctreeVisibleTriangles"},
     {"title": "CastleSceneCore.TCastleSceneCore.InternalOctreeStaticCollisions", "text": " Add <a class=\"normal\" href=\"CastleSceneCore.html#ssStaticCollisions\">ssStaticCollisions</a> to <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">Spatial</a> property, otherwise it's <code>Nil</code>.  <p><b>You should not usually use this directly. Instead use SceneManager (like <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> or <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html\">T2DSceneManager</a>) and then use <code>SceneManager.Items.WorldXxxCollision</code> methods like <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldRay\">SceneManager.Items.WorldRay</a> or <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldSphereCollision\">SceneManager.Items.WorldSphereCollision</a>.</b>  <p>It is automatically used by the XxxCollision methods in this class, if exists, unless OctreeDynamicCollisions exists.  <p>Note that you can use <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InternalOctreeCollisions\">InternalOctreeCollisions</a> to get either <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InternalOctreeDynamicCollisions\">InternalOctreeDynamicCollisions</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InternalOctreeStaticCollisions\">InternalOctreeStaticCollisions</a>, whichever is available.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InternalOctreeStaticCollisions"},
     {"title": "CastleSceneCore.TCastleSceneCore.InternalOctreeCollisions", "text": " This returns either <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InternalOctreeStaticCollisions\">InternalOctreeStaticCollisions</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InternalOctreeDynamicCollisions\">InternalOctreeDynamicCollisions</a>, whichever is available (or <code>Nil</code> if none). Be sure to add <a class=\"normal\" href=\"CastleSceneCore.html#ssDynamicCollisions\">ssDynamicCollisions</a> or <a class=\"normal\" href=\"CastleSceneCore.html#ssStaticCollisions\">ssStaticCollisions</a> to have this available.  <p><b>You should not usually use this directly. Instead use SceneManager (like <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> or <a class=\"normal\" href=\"Castle2DSceneManager.T2DSceneManager.html\">T2DSceneManager</a>) and then use <code>SceneManager.Items.WorldXxxCollision</code> methods like <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldRay\">SceneManager.Items.WorldRay</a> or <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#WorldSphereCollision\">SceneManager.Items.WorldSphereCollision</a>.</b>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InternalOctreeCollisions"},
     {"title": "CastleSceneCore.TCastleSceneCore.UseInternalOctreeCollisions", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#UseInternalOctreeCollisions"},
     {"title": "CastleSceneCore.TCastleSceneCore.GetViewpoint", "text": "  <p><code>GetViewpoint</code> seeks for VRML/X3D nodes like Viewpoint, OrthoViewpoint (actually, any X3DViewpointNode) and VRML 1.0 PerspectiveCamera and OrthographicCamera. <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#GetPerspectiveViewpoint\">GetPerspectiveViewpoint</a> seeks only for perspective viewpoints.  <p>If ViewpointDescription = '', they return the first found viewpoint node. Otherwise, they look for X3DViewpointNode with description field mathing given string.  <p>If camera properties were found in some node, it returns this node. Otherwise it returns nil. This way you can optionally extract some additional info from used viewpoint node, or do something special if default values were used. Often you will just ignore result of this function &mdash; after all, the most important feature of this function is that you don't <i>have</i> to care about details of dealing with camera node.  <p>Returned CamDir and CamUp and GravityUp are always normalized &mdash; reasons the same as for <a class=\"normal\" href=\"X3DNodes.TAbstractViewpointNode.html#GetView\">TAbstractViewpointNode.GetView</a>.  <p>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#GetViewpoint"},
     {"title": "CastleSceneCore.TCastleSceneCore.GetPerspectiveViewpoint", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#GetPerspectiveViewpoint"},
     {"title": "CastleSceneCore.TCastleSceneCore.FreeResources", "text": " See <a class=\"normal\" href=\"CastleSceneCore.html#TSceneFreeResources\">TSceneFreeResources</a> documentation.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#FreeResources"},
     {"title": "CastleSceneCore.TCastleSceneCore.UnregisterScene", "text": " Useful if you want to remove part of a node graph and put it in some other scene.  <p><i>You almost never need to call this method</i> &mdash; this is done automatically for you when <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> is destroyed. However, if you process <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a> graph and extract some node from it (that is, delete node from our <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a> graph, but instead of freeing it you insert it into some other VRML/X3D graph) you must call it to manually &quot;untie&quot; this node (and all it's children) from this <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> instance.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#UnregisterScene"},
     {"title": "CastleSceneCore.TCastleSceneCore.Press", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Press"},
     {"title": "CastleSceneCore.TCastleSceneCore.Release", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Release"},
     {"title": "CastleSceneCore.TCastleSceneCore.PointingDeviceActivate", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PointingDeviceActivate"},
     {"title": "CastleSceneCore.TCastleSceneCore.PointingDeviceMove", "text": " This may generate the continously-generated events like hitPoint_changed, also it updates <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceOverItem\">PointingDeviceOverItem</a> and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceOverPoint\">PointingDeviceOverPoint</a>, thus producing isOver and such events.  <p>To make pointing-device sensors work Ok, make sure you have non-nil OctreeCollisions (e.g. include <a class=\"normal\" href=\"CastleSceneCore.html#ssDynamicCollisions\">ssDynamicCollisions</a> in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">Spatial</a>).    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PointingDeviceMove"},
     {"title": "CastleSceneCore.TCastleSceneCore.PointingDeviceSensors", "text": " This is just a shortcut for <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceOverItem\">PointingDeviceOverItem</a>&circ;.State.PointingDeviceSensors, returning <code>Nil</code> if <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceOverItem\">PointingDeviceOverItem</a> = <code>Nil</code>.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PointingDeviceSensors"},
     {"title": "CastleSceneCore.TCastleSceneCore.PointingDeviceClear", "text": " This is sometimes useful, because <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceMove\">PointingDeviceMove</a> may save the last passed OverItem, and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceActivate\">PointingDeviceActivate</a> may even save some sensors for a longer time.  <p>You could free it by calling <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceMove\">PointingDeviceMove</a> with Collision = <code>Nil</code>, but this could cause other X3D events, so it's undesirable to call this when you're going to e.g. release the scene or it's octree. Also, you would have to deactivate sensor first, causing even more events.  <p>So this method clears any references to saved OverItem and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceActiveSensors\">PointingDeviceActiveSensors</a>, without calling any VRML/X3D events. Note that this still calls <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#DoPointingDeviceSensorsChange\">DoPointingDeviceSensorsChange</a> (making <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#OnPointingDeviceSensorsChange\">OnPointingDeviceSensorsChange</a> event), if <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceActiveSensors\">PointingDeviceActiveSensors</a> / <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceSensors\">PointingDeviceSensors</a> possibly changed.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PointingDeviceClear"},
     {"title": "CastleSceneCore.TCastleSceneCore.LocalBoundingBox", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#LocalBoundingBox"},
     {"title": "CastleSceneCore.TCastleSceneCore.Update", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Update"},
     {"title": "CastleSceneCore.TCastleSceneCore.SetTime", "text": " It is crucial that you call this continously to have some VRML/X3D time-dependent features working, like TimeSensor and MovieTexture. See <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Time\">Time</a> for details what is affected by this.  <p>This is automatically taken care of if you added this scene to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a>. Then our <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> takes care of doing the job, according to <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#TimePlaying\">TimePlaying</a> and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#TimePlayingSpeed\">TimePlayingSpeed</a>.  <p>This causes time to be passed to appropriate time-dependent nodes, events will be called etc.  <p><code>SetTime</code> and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#IncreaseTime\">IncreaseTime</a> do exactly the same, the difference is only that for <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#IncreaseTime\">IncreaseTime</a> you specify increase in the time (that is, NewTime = <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Time\">Time</a> + TimeIncrease). Use whichever version is more handy.  <p>Following X3D specification, time should only grow. So NewValue should be &gt; <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Time\">Time</a> (or TimeIncrease &gt; 0). Otherwise we ignore this call. For resetting the time (when you don't necessarily want to grow <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Time\">Time</a>) see <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ResetTime\">ResetTime</a>.  <p>If a change of Time will produce some visible change in the VRML/X3D model (for example, MovieTexture will change, or TimeSensor change will be routed by interpolator to coordinates of some visible node) it will be reported by usual method, that is <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#VisibleChangeHere\">VisibleChangeHere</a>.  <p>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#SetTime"},
     {"title": "CastleSceneCore.TCastleSceneCore.IncreaseTime", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#IncreaseTime"},
     {"title": "CastleSceneCore.TCastleSceneCore.IncreaseTimeTick", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#IncreaseTimeTick"},
     {"title": "CastleSceneCore.TCastleSceneCore.Time", "text": " Increasing this &quot;drives&quot; the animations (by increasing time of time-dependent nodes like X3D TimeSensor, which in turn drive the rest of the animation).  <p>You can use <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#SetTime\">SetTime</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#IncreaseTime\">IncreaseTime</a> to move time forward manually. But usually there's no need for it: our <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> method takes care of it automatically, you only need to place the scene inside <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a>.  <p>You can start/stop time progress by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#TimePlaying\">TimePlaying</a> and scale it by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#TimePlayingSpeed\">TimePlayingSpeed</a>. These properties affect how the time is updated by the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> method (so if you use <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#SetTime\">SetTime</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#IncreaseTime\">IncreaseTime</a> methods, you're working around these properties).  <p>Default time value is 0.0 (zero). However it will be reset at load to a current time (seconds since Unix epoch &mdash; that's what X3D standard says to use, although you can change it by KambiNavigationInfo.timeOriginAtLoad, see <a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_navigation_extensions.php#section_ext_time_origin_at_load\">http://castle-engine.sourceforge.net/x3d_implementation_navigation_extensions.php#section_ext_time_origin_at_load</a> ). You can perform this &quot;time reset&quot; yourself by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ResetTimeAtLoad\">ResetTimeAtLoad</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ResetTime\">ResetTime</a>.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Time"},
     {"title": "CastleSceneCore.TCastleSceneCore.NextEventTime", "text": " You usually don't need to call this directly, this is automatically used by <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#Send\">TX3DEvent.Send</a> when you don't specify explicit time.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#NextEventTime"},
     {"title": "CastleSceneCore.TCastleSceneCore.ResetTime", "text": "  <p>You should only use this when you loaded new VRML/X3D model.  <p>Unlike <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#SetTime\">SetTime</a> and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#IncreaseTime\">IncreaseTime</a>, this doesn't require that <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Time\">Time</a> grows. It still does some time-dependent events work, although some time-dependent nodes may be just unconditionally reset by this to starting value (as they keep local time, and so require TimeIncrease notion, without it we can only reset them).  <p>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ResetTime"},
     {"title": "CastleSceneCore.TCastleSceneCore.ResetTimeAtLoad", "text": "  <p>This honours VRML/X3D specification about VRML/X3D time origin, and our extension [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_time_origin_at_load\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_time_origin_at_load</a>].    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ResetTimeAtLoad"},
     {"title": "CastleSceneCore.TCastleSceneCore.GetBackgroundStack", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#GetBackgroundStack"},
     {"title": "CastleSceneCore.TCastleSceneCore.GetFogStack", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#GetFogStack"},
     {"title": "CastleSceneCore.TCastleSceneCore.GetNavigationInfoStack", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#GetNavigationInfoStack"},
     {"title": "CastleSceneCore.TCastleSceneCore.GetViewpointStack", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#GetViewpointStack"},
     {"title": "CastleSceneCore.TCastleSceneCore.CameraPosition", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CameraPosition"},
     {"title": "CastleSceneCore.TCastleSceneCore.CameraDirection", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CameraDirection"},
     {"title": "CastleSceneCore.TCastleSceneCore.CameraUp", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CameraUp"},
     {"title": "CastleSceneCore.TCastleSceneCore.CameraViewKnown", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CameraViewKnown"},
     {"title": "CastleSceneCore.TCastleSceneCore.CameraChanged", "text": " This includes sensors like ProximitySensor, LOD nodes, camera settings for next RenderedTexture update and more.  <p><b>There should be no need to call this method explicitly. The scene is notified about camera changes automatically, by the <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>. This method may be renamed / removed in future releases.</b>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CameraChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.RegisterCompiledScript", "text": " See [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_script_compiled\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_script_compiled</a>].    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#RegisterCompiledScript"},
     {"title": "CastleSceneCore.TCastleSceneCore.NavigationTypeFromNavigationInfo", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#NavigationTypeFromNavigationInfo"},
     {"title": "CastleSceneCore.TCastleSceneCore.CameraFromNavigationInfo", "text": "  <p>Bound NavigationInfo node is taken from NavigationInfoStack.Top. If no NavigationInfo is bound, this is <code>Nil</code>, and we will create camera corresponding to default NavigationInfo values (this is following VRML/X3D spec), so it will have initial type = EXAMINE.  <p>This initializes a lot of camera properties: </p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleCameras.TCamera.html#Radius\">TCamera.Radius</a>,</p></li>   <li><p><a class=\"normal\" href=\"CastleCameras.TCamera.html#Input\">TCamera.Input</a>,</p></li>   <li><p><a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">TWalkCamera.Gravity</a>,</p></li>   <li><p><a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForRotations\">TWalkCamera.PreferGravityUpForRotations</a>,</p></li>   <li><p><a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">TWalkCamera.PreferGravityUpForMoving</a>,</p></li>   <li><p>TWalkCamera.PreferredHeight,</p></li>   <li><p>TWalkCamera.ClimbHeight,</p></li>   <li><p>TWalkCamera.HeadBobbing, TWalkCamera.HeadBobbingTime.</p></li> </ul>  <p>  <p>Box is the expected bounding box of the whole 3D scene. Usually, it should be SceneManager.Items.BoundingBox. In simple cases (if this scene is the only <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instance in your world, and it's not transformed) it may be equal to just <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#BoundingBox\">BoundingBox</a> of this scene.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CameraFromNavigationInfo"},
     {"title": "CastleSceneCore.TCastleSceneCore.CameraFromViewpoint", "text": " When no viewpoint is currently bound, we will go to a suitable viewpoint to see the whole scene (based on the Camera.ModelBox, which should be set in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#CameraFromNavigationInfo\">CameraFromNavigationInfo</a> to the world bounding box).  <p>The initial camera vectors (<a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialPosition\">TCamera.InitialPosition</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialDirection\">TCamera.InitialDirection</a>, <a class=\"normal\" href=\"CastleCameras.TCamera.html#InitialUp\">TCamera.InitialUp</a>, TWalkCamera.GravityUp) are set to the current viewpoint. This is done regardless of the RelativeCameraTransform value.  <p>How current camera vectors change depends on RelativeCameraTransform:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>RelativeCameraTransform = <code>False</code> means that we just set current vectors to the initial vectors. In other words, camera jumps to the viewpoint.  <p>In this case, AllowTransitionAnimate determines if we allow moving camera by a smooth transition. If this is <code>True</code>, and also NavigationInfo allows it (see <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#CameraTransition\">CameraTransition</a>), then camera will jump smoothy. Otherwise camera will jump to viewpoint immediately.</p></li>   <li><p>RelativeCameraTransform = <code>True</code> means that we translate/rotate the current camera in the same manner as initial camera changed. This is suitable when you change transformation, position or orientation of the VRML/X3D Viewpoint node: conceptually, there exists a &quot;user&quot; camera transformation that is the child of the viewpoint. When viewpoint is moved, then the current camera moves with it.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CameraFromViewpoint"},
     {"title": "CastleSceneCore.TCastleSceneCore.CameraTransition", "text": "  <p>Honours current NavigationInfo.transitionType and transitionTime. If transitionType indicates instanteneous transition, then jumps by simple <code>Camera.SetView(APosition, ADirection, AUp)</code>. Otherwise makes a smooth animation into new values by <code>Camera.AnimateTo(APosition, ADirection, AUp, TransitionTime)</code>.  <p>Will generate NavigationInfo.transitionComplete when transition ends.  <p>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CameraTransition"},
     {"title": "CastleSceneCore.TCastleSceneCore.CameraTransition", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CameraTransition"},
     {"title": "CastleSceneCore.TCastleSceneCore.MainLightForShadows", "text": " This is useful when you want to make shadows on the scene from only a single light, but your scene has many lights.  <p>The main light is simply one with both <code>shadowVolumes</code> and <code>shadowVolumesMain</code> fields set to <code>True</code>. See [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadows\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadows</a>] for more info. If no light with shadowVolumes = shadowVolumesMain = TRUE is present then this function returns <code>False</code>, since AMainLightPosition cannot be calculated.  <p>AMainLightPosition[3] is always set to 1 (positional light) or 0 (indicates that this is a directional light).  <p>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#MainLightForShadows"},
     {"title": "CastleSceneCore.TCastleSceneCore.CustomHeadlight", "text": "  <p>This never returns <code>Nil</code>. It's not concerned whether the headlight should actually be used &mdash; for this, see <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#HeadlightOn\">HeadlightOn</a>.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CustomHeadlight"},
     {"title": "CastleSceneCore.TCastleSceneCore.ViewChangedSuddenly", "text": " It may be called when you make a sudden change to the camera, like teleporting the player to a completely different scene part.  <p>This may be used as a hint by some optimizations. It tells that what will be visible in the next rendered frame will be probably very different from what was visible in the last frame.  <p><i>Current implementation notes:</i>  <p>Currently, this is used by <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> if you use Attributes.UseOcclusionQuery. Normally, occlusion query tries to reuse results from previous frame, using the assumption that usually camera changes slowly and objects appear progressively in the view. When you make a sudden camera jump/change, this assumption breaks, so it's better to resign from occlusion query for the very next frame. This method will do exactly that.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ViewChangedSuddenly"},
     {"title": "CastleSceneCore.TCastleSceneCore.PrepareResources", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PrepareResources"},
     {"title": "CastleSceneCore.TCastleSceneCore.Dragging", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Dragging"},
     {"title": "CastleSceneCore.TCastleSceneCore.Caption", "text": " Uses the &quot;title&quot; of WorldInfo node inside the VRML/X3D scene. If there is no WorldInfo node (or it has empty title) then result is based on loaded <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#URL\">URL</a>.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Caption"},
     {"title": "CastleSceneCore.TCastleSceneCore.Node", "text": " They search all nodes (in active or not) graph parts.  <p>For more flexible and extensive search methods, use <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a> property along with <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#FindNodeByName\">TX3DNode.FindNodeByName</a>, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#FindNode\">TX3DNode.FindNode</a> and other methods.  <p>     EX3DNotFound If given node (or field/event inside this node) could not be found.", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Node"},
     {"title": "CastleSceneCore.TCastleSceneCore.Field", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Field"},
     {"title": "CastleSceneCore.TCastleSceneCore.Event", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Event"},
     {"title": "CastleSceneCore.TCastleSceneCore.HasAnimation", "text": "      ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#HasAnimation"},
     {"title": "CastleSceneCore.TCastleSceneCore.AnimationTimeSensor", "text": " <code>Nil</code> if this name not found. Use this for example to watch when the animation ends playing, like  <p></p>  <pre class=\"longcode\"> Scene.AnimationTimeSensor(<span class=\"pascal_string\">'my_animation'</span>)<span class=\"pascal_float\">.</span>EventIsActive.AddNotification(   @AnimationIsActiveChanged);</pre>  <p>  <p>See the examples/3d_rendering_processing/listen_on_x3d_events.lpr .    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#AnimationTimeSensor"},
     {"title": "CastleSceneCore.TCastleSceneCore.AnimationTimeSensor", "text": " <code>Nil</code> if this index not found.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#AnimationTimeSensor"},
     {"title": "CastleSceneCore.TCastleSceneCore.Animations", "text": "    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Animations"},
     {"title": "CastleSceneCore.TCastleSceneCore.ForceAnimationPose", "text": "  <p>This avoids the normal passage of time in X3D scenes, it ignores the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">ProcessEvents</a> and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#AnimateOnlyWhenVisible\">AnimateOnlyWhenVisible</a> properties, it ignores the current animation set by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PlayAnimation\">PlayAnimation</a>, and forces the current time on TimeSensors by <a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html#FakeTime\">TTimeSensorNode.FakeTime</a>.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ForceAnimationPose"},
     {"title": "CastleSceneCore.TCastleSceneCore.PlayAnimation", "text": " This also stops previously playing named animation, if any. Returns whether such animation was found. Playing an already-playing animation is guaranteed to start it from the beginning.  <p>Notes:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Calling this method <i>does not change the scene immediately</i>. There may be a delay between calling <code>PlayAnimation</code> and actually changing the scene to reflect the state at the beginning of the indicated animation. This delay is usually 1 frame (that is, the scene is updated at the next <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> call), but it may be larger if you use the optimization <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#AnimateSkipTicks\">AnimateSkipTicks</a>.  <p>This is often a desirable optimization. There's often no &quot;rush&quot; to visually change the animation <i>right now</i>, and doing it at the nearest <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> call is acceptable. It also means that calling <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PlayAnimation\">PlayAnimation</a> multiple times before a single <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> call is not expensive.  <p>But, sometimes you need to change the scene immediately (for example, because you don't want to show user the initial scene state). To do this, simply call <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ForceAnimationPose\">ForceAnimationPose</a> with <code>TimeInAnimation</code> parameter = 0 and the same animation. This will change the scene immediately, to show the beginning of this animation. You can call <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ForceAnimationPose\">ForceAnimationPose</a> before or after <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PlayAnimation\">PlayAnimation</a>, it doesn't matter. </p></li>   <li><p>Internally, <i>the animation is performed using <a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html\">TTimeSensorNode</a> that instructs other nodes to change</i>. For exampe, <a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html\">TTimeSensorNode</a> may instruct a <a class=\"normal\" href=\"X3DNodes.TCoordinateInterpolatorNode.html\">TCoordinateInterpolatorNode</a> to update the <a class=\"normal\" href=\"X3DNodes.TIndexedFaceSetNode.html\">TIndexedFaceSetNode</a> coordinates, and in effect the animation can deform a mesh. Or <a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html\">TTimeSensorNode</a> may instruct a <a class=\"normal\" href=\"X3DNodes.TPositionInterpolatorNode.html\">TPositionInterpolatorNode</a> to update <a class=\"normal\" href=\"X3DNodes.TTransformNode.html#Translation\">TTransformNode.Translation</a>, and in effect the animation can move something.  <p>So the animation means that the X3D nodes graph within <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a> is being changed. The exact subset of the nodes inside <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a> that change depends on your animation.  <p>This means that internally our mechanism is very flexible. E.g. you can have another animation running (another <a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html\">TTimeSensorNode</a> running) in parallel to the animation run by this method. You can also change parts of the node graph by your own code (accessing <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a>) in parallel to the animation by this method, as long as you don't touch the same nodes. <i>Such tricks are possible, but require manually designing a proper X3D file</i>.  <p>If you load a model from a castle-anim-frames or MD3 format, note that it is animated using a special &quot;node interpolator&quot; algorithm. In this case, you cannot really change the model inside <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">RootNode</a> anymore &mdash; any modifications may be overwritten by the &quot;node interpolator&quot; at some point (the exact overwrite moment depends on the &quot;merge nodes&quot; optimization done by the &quot;node interpolator&quot;). </p></li> </ul>  <p>    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PlayAnimation"},
     {"title": "CastleSceneCore.TCastleSceneCore.AnimationDuration", "text": " For a looping animation, this is the duration of a single cycle. 0 if not found.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#AnimationDuration"},
     {"title": "CastleSceneCore.TCastleSceneCore.FontChanged", "text": " For now, we don't detect font changes (when <a class=\"normal\" href=\"X3DNodes.TFontStyleNode.html#OnFont\">TFontStyleNode.OnFont</a> returns something different) ourselves. This calls <a class=\"normal\" href=\"X3DNodes.TTextNode.html#FontChanged\">TTextNode.FontChanged</a> and <a class=\"normal\" href=\"X3DNodes.TAsciiTextNode_1.html#FontChanged\">TAsciiTextNode_1.FontChanged</a> on all appropriate nodes.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#FontChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.Clone", "text": " The created scene has exactly the same class as this one (we use ClassType.Create to call a virtual constructor).  <p>Note that this <b>does not copy other scene attributes</b>, like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">ProcessEvents</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">Spatial</a> or rendering attributes in <a class=\"normal\" href=\"CastleScene.TCastleScene.html#Attributes\">TCastleScene.Attributes</a>.    ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Clone"},
     {"title": "CastleSceneCore.TCastleSceneCore.VisibilitySensors", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#VisibilitySensors"},
     {"title": "CastleSceneCore.TCastleSceneCore.Shapes", "text": "  <p>Contents of this tree are read-only from outside.  <p>Note that the only place where <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Shapes\">Shapes</a> structure is rebuild in this class is <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a> procedure. So e.g. if you want to do something after each change of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Shapes\">Shapes</a> tree, you can simply override <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a> and do your work after calling &quot;inherited&quot;. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Shapes"},
     {"title": "CastleSceneCore.TCastleSceneCore.OnGeometryChanged", "text": " &quot;Geometry changed&quot; means that the positions of triangles changed. This is not send when merely things like material changed.  <p>It is not guaranteed that octrees are already recalculated when this is called. (They may be recalculated only on-demand, that is when you actually access them.) However, it is guaranteed that shape's transformation (like TShape.State.Transform) are already updated. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#OnGeometryChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.OnViewpointsChanged", "text": "  <p>Note that this doesn't necessarily mean that the current, bound viewpoint changed (although it could). If you only want to get notified when currently <i>bound</i> viewpoint changes, then what you seek is rather <a class=\"normal\" href=\"CastleSceneCore.TX3DBindableStack.html#OnBoundChanged\">ViewpointStack.OnBoundChanged</a>. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#OnViewpointsChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.OnBoundViewpointVectorsChanged", "text": "  <p>More precisely, this is called whenever values generated by ViewpointStack.Top.GetView changed.  <p>It cannot be called when ViewpointStack.Top = <code>Nil</code>. Note that this also doesn't notify you about changes to currently bound viewpoint, for this you rather want to use <a class=\"normal\" href=\"CastleSceneCore.TX3DBindableStack.html#OnBoundChanged\">ViewpointStack.OnBoundChanged</a>. This is called only when <i>currently bound viewpoint stays the same, only it's vectors change</i>. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#OnBoundViewpointVectorsChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.OnBoundNavigationInfoFieldsChanged", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#OnBoundNavigationInfoFieldsChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.RootNode", "text": "  <p>It is allowed to change contents of <code>RootNode</code>. Just make sure the scene is notified about these changes. The simplest option is to use simple properties of nodes (not the ones starting with <code>Fd...</code> prefix), when possible. Then everything is notified automatically. If you must use fields through the <code>FdXxx</code> properties, then assign them using <a class=\"normal\" href=\"X3DFields.TX3DField.html#Send\">TX3DField.Send</a>, or (if you need to assign field values directly, like <code>TSFVec3f.Value := ...</code>) call <a class=\"normal\" href=\"X3DFields.TX3DField.html#Changed\">TX3DField.Changed</a>.  <p>It is also allowed to change the value of <code>RootNode</code> and even to set <code>RootNode</code> to <code>Nil</code>. Changing <code>RootNode</code> allows you to load and unload whole new VRML/X3D graph (for example from some 3D file) whenever you want, and keep the same <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> instance (with the same rendering settings and such). ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#RootNode"},
     {"title": "CastleSceneCore.TCastleSceneCore.OwnsRootNode", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#OwnsRootNode"},
     {"title": "CastleSceneCore.TCastleSceneCore.TriangleOctreeProgressTitle", "text": " Uses only when not empty, and only if progress was not active already (so we avoid starting &quot;progress bar within a progress bar&quot;). ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#TriangleOctreeProgressTitle"},
     {"title": "CastleSceneCore.TCastleSceneCore.ShapeOctreeProgressTitle", "text": " Uses only when not empty, and only if progress was not active already (so we avoid starting &quot;progress bar within a progress bar&quot;). ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ShapeOctreeProgressTitle"},
     {"title": "CastleSceneCore.TCastleSceneCore.PointingDeviceOverItem", "text": " <code>Nil</code> if over none. For example, you can investigate it's pointing device sensors (in <code>PointingDeviceOverItem</code>&circ;.State.PointingDeviceSensors), although there's a shortcut for just this in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceSensors\">PointingDeviceSensors</a>. You can change this by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceMove\">PointingDeviceMove</a> and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceClear\">PointingDeviceClear</a>. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PointingDeviceOverItem"},
     {"title": "CastleSceneCore.TCastleSceneCore.PointingDeviceOverPoint", "text": " Only meaningful when <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceOverItem\">PointingDeviceOverItem</a> &lt;&gt; nil, otherwise undefined. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PointingDeviceOverPoint"},
     {"title": "CastleSceneCore.TCastleSceneCore.PointingDeviceActiveSensors", "text": " Only <a class=\"normal\" href=\"X3DNodes.TAbstractPointingDeviceSensorNode.html\">TAbstractPointingDeviceSensorNode</a> instances. Always empty when <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceActive\">PointingDeviceActive</a> = <code>False</code>. Read-only from outside of this class.  <p>Note that sensor specified here doesn't have to be one of the sensors of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceOverItem\">PointingDeviceOverItem</a>. When some sensor is activated, it grabs further events until it's deactivated (e.g. when you set <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceActive\">PointingDeviceActive</a> := false, which means that user released mouse button). This means that when user moves the mouse while given sensors are active, he can move mouse over other items, even the ones where the active sensors aren't listed &mdash; but the sensors remain active. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PointingDeviceActiveSensors"},
     {"title": "CastleSceneCore.TCastleSceneCore.PointingDeviceActive", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#PointingDeviceActive"},
     {"title": "CastleSceneCore.TCastleSceneCore.OnPointingDeviceSensorsChange", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#OnPointingDeviceSensorsChange"},
     {"title": "CastleSceneCore.TCastleSceneCore.TimeAtLoad", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#TimeAtLoad"},
     {"title": "CastleSceneCore.TCastleSceneCore.BackgroundStack", "text": " The node at the top is the current background. All nodes on this stack must descend from <a class=\"normal\" href=\"X3DNodes.TAbstractBackgroundNode.html\">TAbstractBackgroundNode</a> class. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#BackgroundStack"},
     {"title": "CastleSceneCore.TCastleSceneCore.FogStack", "text": " The node at the top is the current fog. All nodes on this stack must descend from <a class=\"normal\" href=\"X3DNodes.TFogNode.html\">TFogNode</a> class. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#FogStack"},
     {"title": "CastleSceneCore.TCastleSceneCore.NavigationInfoStack", "text": " The node at the top is the current NavigatinInfo. All nodes on this stack must descend from <a class=\"normal\" href=\"X3DNodes.TNavigationInfoNode.html\">TNavigationInfoNode</a> class. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#NavigationInfoStack"},
     {"title": "CastleSceneCore.TCastleSceneCore.ViewpointStack", "text": " The node at the top is the current Viewpoint. All nodes on this stack must descend from <a class=\"normal\" href=\"X3DNodes.TAbstractViewpointNode.html\">TAbstractViewpointNode</a>. Note that this includes also VRML 1.0/Inventor nodes. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ViewpointStack"},
     {"title": "CastleSceneCore.TCastleSceneCore.CompiledScriptHandlers", "text": " This is read-only, change this only by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RegisterCompiledScript\">RegisterCompiledScript</a>. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CompiledScriptHandlers"},
     {"title": "CastleSceneCore.TCastleSceneCore.HeadlightOn", "text": " Controls if containing <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> will use a headlight, if this is the main scene.  <p>When you load a new model, this is always updated based on this model's NavigationInfo.headlight. (If no NavigationInfo node, then default is to use the headlight.) When you bind a new NavigationInfo node, this is also updated to follow NavigationInfo.headlight.  <p>You can change the value of this property. If we have a NavigationInfo node, then NavigationInfo.headlight field will be always updated to correspond to this value. (It will be even updated using events mechanism if <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">ProcessEvents</a>, so scripts inside the VRML/X3D &quot;know&quot; when you turn on/off the headlight and may react to it, e.g. spawn a zombie monster when you turn on the flashlight.) ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#HeadlightOn"},
     {"title": "CastleSceneCore.TCastleSceneCore.OnHeadlightOnChanged", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#OnHeadlightOnChanged"},
     {"title": "CastleSceneCore.TCastleSceneCore.Static", "text": " This means that <a class=\"normal\" href=\"X3DFields.TX3DField.html#Send\">TX3DField.Send</a> and <a class=\"normal\" href=\"X3DFields.TX3DField.html#Changed\">TX3DField.Changed</a> will not notify this scene. This makes a small optimization when you know you will not modify scene's VRML/X3D graph besides loading (or you're prepared to do it by manually calling Scene.InternalChangedField, but this should not be used anymore, it's really dirty).  <p>The behavior of events is undefined when scene is static. This means that you should always have <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">ProcessEvents</a> = <code>False</code> when Static = <code>True</code>. Only when Static = false you're allowed to freely change <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">ProcessEvents</a> to <code>True</code>.  <p>Changing this is expensive when the scene content is already loaded, so it's best to adjust this before <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Load\">Load</a>. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Static"},
     {"title": "CastleSceneCore.TCastleSceneCore.GlobalLights", "text": " Read-only. May be useful to render other 3D objects with lights defined inside this scene. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#GlobalLights"},
     {"title": "CastleSceneCore.TCastleSceneCore.AnimationsList", "text": " Animations are detected in VRML/X3D models as simply TimeSensor nodes (if you set <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#AnimationPrefix\">AnimationPrefix</a> property, we additionally filter them to show only the names starting with given prefix). You can even get the time sensor node directly by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#AnimationTimeSensor\">AnimationTimeSensor</a>.  <p>The resulting TStringList instance is owned by this object, do not free it.  <p>Note that the list of animations may change if you rebuild the underlying X3D nodes graph, for example if you start to delete / add some TimeSensor nodes. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#AnimationsList"},
     {"title": "CastleSceneCore.TCastleSceneCore.AnimationPrefix", "text": " Named animation are used by methods <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#AnimationsList\">AnimationsList</a>, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PlayAnimation\">PlayAnimation</a>, and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#AnimationDuration\">AnimationDuration</a>, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#HasAnimation\">HasAnimation</a>. By default this is empty, which means we consider all TimeSensor nodes a &quot;named animation&quot;.  <p>You can set this to something like 'Anim_' or 'Animation_' or whatever your 3D export software produces. Only the TimeSensor nodes with names starting with this prefix will be available on <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#AnimationsList\">AnimationsList</a>, and this prefix will be stripped from the names you use with methods like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PlayAnimation\">PlayAnimation</a>. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#AnimationPrefix"},
     {"title": "CastleSceneCore.TCastleSceneCore.CurrentAnimation", "text": " Note that in X3D world, you can have multiple active animations (TimeSensor nodes) at the same time. This property only describes the animation controlled by the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PlayAnimation\">PlayAnimation</a> method.  <p>Note that the animation may be started by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PlayAnimation\">PlayAnimation</a> with a 1-frame delay, but this property hides it from you, it is changed immediately by the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PlayAnimation\">PlayAnimation</a> call. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#CurrentAnimation"},
     {"title": "CastleSceneCore.TCastleSceneCore.FileName", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#FileName"},
     {"title": "CastleSceneCore.TCastleSceneCore.TimePlaying", "text": " More precisely, our <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> will take care of increasing <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Time\">Time</a>. Our <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> is usually automatically called (if you added this scene to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a>) so you don't have to do anything to make this work. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#TimePlaying"},
     {"title": "CastleSceneCore.TCastleSceneCore.TimePlayingSpeed", "text": " ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#TimePlayingSpeed"},
     {"title": "CastleSceneCore.TCastleSceneCore.Spatial", "text": "  <p>Using &quot;spatial structures&quot; allows to achieve various things:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><b><a class=\"normal\" href=\"CastleSceneCore.html#ssDynamicCollisions\">ssDynamicCollisions</a></b> or <b><a class=\"normal\" href=\"CastleSceneCore.html#ssStaticCollisions\">ssStaticCollisions</a></b>:  <p>Using any of these flags allows to resolve collisions with the (collidable) triangles of the model. By default, every shape is collidable, but you can use the <a class=\"normal\" href=\"X3DNodes.TCollisionNode.html\">TCollisionNode</a> to turn collisions off for some shapes (or replace them with simpler objects for the collision-detection purposes).  <p>As for the distinction between these two flags, <a class=\"normal\" href=\"CastleSceneCore.html#ssDynamicCollisions\">ssDynamicCollisions</a> and <a class=\"normal\" href=\"CastleSceneCore.html#ssStaticCollisions\">ssStaticCollisions</a>: Almost always you should use <a class=\"normal\" href=\"CastleSceneCore.html#ssDynamicCollisions\">ssDynamicCollisions</a>. The speedup of <a class=\"normal\" href=\"CastleSceneCore.html#ssStaticCollisions\">ssStaticCollisions</a> is very small, and sometimes it costs memory usage (as shapes cannot be reused), and <a class=\"normal\" href=\"CastleSceneCore.html#ssStaticCollisions\">ssStaticCollisions</a> may cause crashes if the model accidentally changes.  <p>If you use neither <b><a class=\"normal\" href=\"CastleSceneCore.html#ssDynamicCollisions\">ssDynamicCollisions</a></b> nor <b><a class=\"normal\" href=\"CastleSceneCore.html#ssStaticCollisions\">ssStaticCollisions</a></b>, then the collisions are resolved using the whole scene bounding box. That is, treating the whole scene as a giant cube.  <p>You can always toggle <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a> to quickly make the scene not collidable.</p></li>   <li><p><b><a class=\"normal\" href=\"CastleSceneCore.html#ssRendering\">ssRendering</a></b>:  <p>Using this adds an additional optimization during rendering. This allows to use frustum culling with an octree.  <p>Using this is adviced, if your camera usually only sees a small portion of the scene. For example, a typical level / location in a game usually qualifies.</p></li>   <li><p><b><a class=\"normal\" href=\"CastleSceneCore.html#ssVisibleTriangles\">ssVisibleTriangles</a></b>:  <p>Using this allows to resolve collisions with visible triangles quickly. This mostly useful only for ray-tracers.</p></li> </ul>  <p>  <p>See <a class=\"normal\" href=\"CastleSceneCore.html#TSceneSpatialStructure\">TSceneSpatialStructure</a> for more details about the possible values. For usual dynamic scenes rendered in real-time, you set this to <code>[<a class=\"normal\" href=\"CastleSceneCore.html#ssRendering\">ssRendering</a>, <a class=\"normal\" href=\"CastleSceneCore.html#ssDynamicCollisions\">ssDynamicCollisions</a>]</code>.  <p>By default, the value of this property is empty, which means that no octrees will be created. This has to be the default value, to:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Not create octrees by default (e.g. at construction). Creating them takes time (and memory).</p></li>   <li value=\"2\"><p>Allow developer to adjust TriangleOctreeLimits before creating the octree.</p></li> </ol>  <p> ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#Spatial"},
     {"title": "CastleSceneCore.TCastleSceneCore.ProcessEvents", "text": "  <p>If <code>True</code>, then events will be send and received through routes, time dependent nodes (X3DTimeDependentNode, like TimeSensor) will be activated and updated from <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Time\">Time</a> time property, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Press\">Press</a>, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Release\">Release</a> and other methods will activate key/mouse sensor nodes, scripts will be initialized and work, etc.  <p>In other words, this makes the scene fully animated and interacting with the user.  <p>If <code>False</code>, this all doesn't work, which makes the scene static. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ProcessEvents"},
     {"title": "CastleSceneCore.TCastleSceneCore.URL", "text": " Set this to load a 3D scene from the given <code>URL</code>, we can load from any known 3D format (VRML, X3D, Collada, 3ds, Wavefront, etc.).  <p>Works just like the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Load\">Load</a> method (the overloaded version that takes <code>AURL: string</code> parameter). And, in fact, using directly the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Load\">Load</a> method will also change this <code>URL</code> property.  <p>The only difference of <code>Scene.URL := 'blah.x3d'</code> vs <code>Scene.Load('blah.x3d')</code> is that setting the <code>URL</code> will <i>not</i> reload the scene if you set it to the same value. That is, <code>Scene.URL := Scene.URL;</code> will not reload the scene (you have to use explicit <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Load\">Load</a> for this.). ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#URL"},
     {"title": "CastleSceneCore.TCastleSceneCore.ShadowMaps", "text": " This happens at the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Load\">Load</a> method call, and it makes &quot;receiveShadows&quot; field automatically handled.  <p>Note that this is not the only way to make shadow maps. VRML/X3D author can always make shadow maps by using lower-level nodes, see [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadow_maps\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadow_maps</a>]. When using these lower-level nodes, this property does not matter This property (and related ones like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ShadowMapsDefaultSize\">ShadowMapsDefaultSize</a>) is relevant only for handling shadows by the &quot;receiveShadows&quot; field. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ShadowMaps"},
     {"title": "CastleSceneCore.TCastleSceneCore.ShadowMapsDefaultSize", "text": "  <p>Affects how shadow maps are handled for the &quot;receiveShadows&quot; field. This is taken into account at the scene <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Load\">Load</a> time, and only if <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ShadowMaps\">ShadowMaps</a> is <code>True</code>.  <p>VRML/X3D author can always override this by placing a <code>GeneratedShadowMap</code> node inside light's <code>defaultShadowMap</code> field. In this case, <code>GeneratedShadowMap.size</code> determines shadow map size. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#ShadowMapsDefaultSize"},
     {"title": "CastleSceneCore.TCastleSceneCore.InitialViewpointIndex", "text": " VRML/X3D specification says to use the first (index = 0) viewpoint, you can change this property to bind 2nd, 3rd and so on viewpoints.  <p>This is applied only at loading (actually, at <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">ChangedAll</a>). If you later want to bind another viewpoint, just send set_bind := true to it. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InitialViewpointIndex"},
     {"title": "CastleSceneCore.TCastleSceneCore.InitialViewpointName", "text": " Relevant only if non-empty.  <p>This may cooperate with <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InitialViewpointIndex\">InitialViewpointIndex</a>: <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InitialViewpointIndex\">InitialViewpointIndex</a> specifies the index of viewpoint node that satisfies also <code>InitialViewpointName</code> condition. For example:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InitialViewpointIndex\">InitialViewpointIndex</a> = 0 and <code>InitialViewpointName</code> = '' means to use the first viewpoint, ignoring nodes' names. This is the default behavior, also following VRML/X3D specification.</p></li>   <li><p><a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InitialViewpointIndex\">InitialViewpointIndex</a> = 1 and <code>InitialViewpointName</code> = '' means to use the 2nd viewpoint. Node name doesn't matter.</p></li>   <li><p><a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#InitialViewpointIndex\">InitialViewpointIndex</a> = 1 and <code>InitialViewpointName</code> = 'blah' means to use the first viewpoint named 'blah'. That is, we are only counting nodes named 'blah' for this.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#InitialViewpointName"},
     {"title": "CastleSceneCore.TCastleSceneCore.AnimateOnlyWhenVisible", "text": " This is a powerful optimization, but be careful if you depend on your animations for something else than just visual effect. ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#AnimateOnlyWhenVisible"},
     {"title": "CastleSceneCore.TCastleSceneCore.AnimateSkipTicks", "text": " After updating the animation in one <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> call, the next <code>AnimateSkipTicks</code> number of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> calls will go very quickly, as they will not actually change the scene at all.  <p>This is an effective optimization if the scene is usually not large on the screen.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>The animation is less smooth. For example, if <code>AnimateSkipTicks</code> = 1, then every other <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> call does not change the scene. For example, if you have 60 FPS, and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Update\">Update</a> is called 60 times per second, then we will actually change the scene only 30 times per second.  <p>The &quot;skip&quot; within every scene has a little random shift, to avoid synchronizing this skip across many created scenes. This makes this a little harder to notice.</p></li>   <li><p>In exchange, the speedup is substantial. For example, if <code>AnimateSkipTicks</code> = 1, then the animation on CPU effectively costs 2x less. In general, <code>AnimateSkipTicks</code> = N means that the cost drops to <code>1 / (1 + N)</code>.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleSceneCore.TCastleSceneCore.html#AnimateSkipTicks"},
     {"title": "CastleSceneCore.TMeshCollider", "text": " Place this inside <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">TRigidBody.Collider</a> property. ", "tags": "", "loc": "CastleSceneCore.TMeshCollider.html"},
     {"title": "CastleSceneCore.TMeshCollider.Scene", "text": " It does not have to be convex.  <p>The <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Scene.Collides</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetCollides\">Scene.GetCollides</a> do not matter here. Using the <a class=\"normal\" href=\"X3DNodes.TCollisionNode.html\">TCollisionNode</a> inside Scene matters (so the scene may collide as something different than it's visible, see <a  href=\"https://castle-engine.sourceforge.io/x3d_implementation_navigation.php\">https://castle-engine.sourceforge.io/x3d_implementation_navigation.php</a> ). ", "tags": "", "loc": "CastleSceneCore.TMeshCollider.html#Scene"},
     {"title": "CastleSceneCore.ssCollidableTriangles", "text": " ", "tags": "", "loc": "CastleSceneCore.html#ssCollidableTriangles"},
     {"title": "CastleSceneCore.TSceneFreeResource", "text": "  <p><i>Warning</i>: This is for experienced usage of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>. Everything is explained in detail below, but still &mdash; if you have some doubts, or you just don't observe any memory shortage in your program, it's probably best to not use <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#FreeResources\">TCastleSceneCore.FreeResources</a>.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>For <a class=\"normal\" href=\"CastleSceneCore.html#frTextureDataInNodes\">frTextureDataInNodes</a>, <a class=\"normal\" href=\"CastleSceneCore.html#frBackgroundImageInNodes\">frBackgroundImageInNodes</a> and TrianglesList, if you will free them unnecessarily (i.e. you will use it after you freed it), it will be automatically recreated on next use. So everything will work correctly, but you will experience unnecessary slowdown if we will need to recreate exactly the same resource over and over again.</p></li>   <li><p>For <a class=\"normal\" href=\"CastleSceneCore.html#frTextureDataInNodes\">frTextureDataInNodes</a> and <a class=\"normal\" href=\"CastleSceneCore.html#frBackgroundImageInNodes\">frBackgroundImageInNodes</a> note that freeing these resources too eagerly may make texture cache (see TextureImages) less effective. In normal circumstances, if you will use the same cache instance throughout the program, loaded images are reused. If you free <a class=\"normal\" href=\"CastleSceneCore.html#frTextureDataInNodes\">frTextureDataInNodes</a> too early, you may remove them from the cache too early, and lose a chance to reuse them. So you may cause unnecessary slowdown of preparing models, e.g. inside PrepareResources.</p></li> </ul>  <p>  frTextureDataInNodes Unloads the texture images/videos allocated in texture nodes.   <p>It's useful if you know that you already prepared everything that needed the texture images, and you will not need texture images later. For <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> this means that you use Optimization method other than roNone, and you already did PrepareResources (so textures are already loaded to OpenGL), and your code will not access TextureImage / TextureVideo anymore. This is commonly <code>True</code> for various games.  <p>Then you can call this to free some resources.  <p>Note that if you made an accident and you will use some TextureImage or TextureVideo after FreeResources, then you will get no crash, but texture image will be simply reloaded. So you may experience slowdown if you inappropriately use this feature.  frBackgroundImageInNodes Unloads the background images allocated in VRML/X3D Background nodes.  The same comments as for <a class=\"normal\" href=\"CastleSceneCore.html#frTextureDataInNodes\">frTextureDataInNodes</a> apply.  frShadowVolume Free data created for shadow volumes processing.  This frees some memory, but trying to render shadow volumes will need to recreate this data again (at least for all active shapes). So freeing this is useful only if you have used shadow volumes, but you will not need to render with shadow volumes anymore (for some time). ", "tags": "", "loc": "CastleSceneCore.html#TSceneFreeResource"},
     {"title": "CastleSceneCore.TSceneFreeResources", "text": " ", "tags": "", "loc": "CastleSceneCore.html#TSceneFreeResources"},
     {"title": "CastleSceneCore.TSceneNotification", "text": "    ", "tags": "", "loc": "CastleSceneCore.html#TSceneNotification"},
     {"title": "CastleSceneCore.TSceneGeometryChanged", "text": "  <p>SomeLocalGeometryChanged means that octree, triangles, bounding volumes local to some shape changed (not just e.g. shape transformation).  <p>OnlyShapeChanged is meaningful when SomeLocalGeometryChanged = <code>True</code>. If nil, it indicates that only the given shape geometry changed. If not nil, assume that every shape's geometry potentially changed.    ", "tags": "", "loc": "CastleSceneCore.html#TSceneGeometryChanged"},
     {"title": "CastleSceneCore.PGeneratedTexture", "text": " ", "tags": "", "loc": "CastleSceneCore.html#PGeneratedTexture"},
     {"title": "CastleSceneCore.TCompiledScriptHandler", "text": "    ", "tags": "", "loc": "CastleSceneCore.html#TCompiledScriptHandler"},
     {"title": "CastleSceneCore.PCompiledScriptHandlerInfo", "text": " ", "tags": "", "loc": "CastleSceneCore.html#PCompiledScriptHandlerInfo"},
     {"title": "CastleSceneCore.TCompiledScriptHandlerInfoList", "text": " ", "tags": "", "loc": "CastleSceneCore.html#TCompiledScriptHandlerInfoList"},
     {"title": "CastleSceneCore.TSceneSpatialStructure", "text": "  ssRendering Create <i>and keep up-to-date</i> a spatial structure containing all visible shapes.  It's useful for &quot;frustum culling&quot;, it will be automatically used by <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> rendering to speed it up.  <p>This octree will be automatically updated on dynamic scenes (when e.g. animation moves some shape by changing it's transformation).  ssDynamicCollisions Create <i>and keep up-to-date</i> a spatial structure containing all collidable shapes (and then reaching into collidable triangles for a specifc shape).  It is automatically used by the XxxCollision methods in this class.  <p>This is actually a hierarchy of octrees: scene is partitioned first into Shapes (each instance of VRML/X3D geometry node), and then each Shape has an octree of triangles inside.  <p>This octree is useful for all kinds of collision detection. Compared to <a class=\"normal\" href=\"CastleSceneCore.html#ssStaticCollisions\">ssStaticCollisions</a>, it is (very slightly on typical scenes) less efficient, but it can also be updated very fast. For example, merely transforming some Shape means that only one item needs to be moved in the top-level shape tree. So this is the most important structure for collision detection on dynamic scenes.  ssVisibleTriangles Create a spatial structure containing all visible triangles, suitable only for scenes that stay static.   <p>It's primarily use is for ray-tracers, that make a lot of collision queries to the same scene in the same time. When rendering using OpenGL, this has no use currently.  <p>This structure is not updated on scene changes. In fact, the scene contents cannot change when this octree is created &mdash; as this octree keeps pointers to some states that may become invalid in dynamic scenes.  ssStaticCollisions Create a spatial structure containing all collidable triangles, <b>only for scenes that never change</b>.   <p>It may be useful if you're absolutely sure that you have a static scene (nothing changes, i.e. ProcessEvents = <code>False</code> and you never make any change to X3D nodes from code) and you want to have collision detection with the scene.  <p>For dynamic scenes, using this is a bad idea as this octree is not updated on scene changes. In fact, the scene contents cannot change when this octree is created &mdash; as this octree keeps pointers to some states that may become invalid in dynamic scenes. Use <a class=\"normal\" href=\"CastleSceneCore.html#ssDynamicCollisions\">ssDynamicCollisions</a> for dynamic scenes. ", "tags": "", "loc": "CastleSceneCore.html#TSceneSpatialStructure"},
     {"title": "CastleSceneCore.TSceneSpatialStructures", "text": " ", "tags": "", "loc": "CastleSceneCore.html#TSceneSpatialStructures"},
     {"title": "CastleSceneCore.TGeometryChange", "text": "  gcAll Everything changed.  All octrees must be rebuild, old State pointers may be invalid.  <p>Every ChangedAll call does this. ChangedAll must take into account that everything could change. Note that ChangedAll traverses the VRML/X3D graph again, recalculating State values... so the old States are not correct anymore. You have to rebuild the octree or your pointers will be bad.  <p>When DoGeometryChanged with <code>gcAll</code> is called, we know that ChangedAll called this, and every <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> will be (or already is) destroyed and created new.  gcCollidableTransformChanged Transformation of some shape changed.    gcVisibleTransformChanged    gcLocalGeometryChanged Local geometry change happened (actual octree free is already done by TShape.LocalGeometryChanged, octree create will be done at next demand).  We should update stuff at higher (<a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>) level accordingly.  <p><a class=\"normal\" href=\"CastleSceneCore.html#gcLocalGeometryChangedCoord\">gcLocalGeometryChangedCoord</a> means that coordinates changed. Compared to <code>gcLocalGeometryChanged</code>, this means that model edges structure remains the same (this is helpful e.g. to avoid recalculating Manifold/BorderEdges).  <p>In this case, DoGeometryChanged parameter LocalGeometryShape is non-nil and indicated the (only) shape that changed.  <p>  gcLocalGeometryChangedCoord    gcActiveShapesChanged What is considered &quot;active&quot; shapes changed.  Like after Switch.whichChoice change. ", "tags": "", "loc": "CastleSceneCore.html#TGeometryChange"},
     {"title": "CastleSceneCore.TPlayAnimationLooping", "text": "  paDefault Use current TimeSensor.Loop value to determine whether animation should loop.  Suitable when X3D model already has sensible &quot;TimeSensor.loop&quot; values.  paForceLooping Force TimeSensor.Loop to be <code>True</code>, to force looping.   paForceNotLooping Force TimeSensor.Loop to be <code>False</code>, to force not looping.  ", "tags": "", "loc": "CastleSceneCore.html#TPlayAnimationLooping"},
     {"title": "CastleSceneCore.LogChanges", "text": " This debugs what and why happens through TCastleSceneCore.InternalChangedField method and friends, which is central to VRML/X3D dynamic changes and events engine.  <p>Meaningful only if you initialized log (see <a class=\"normal\" href=\"CastleLog.html\">CastleLog</a> unit) by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a> first. ", "tags": "", "loc": "CastleSceneCore.html#LogChanges"},
     {"title": "CastleSceneCore.OptimizeExtensiveTransformations", "text": " Often particularly effective for skeletal animations of characters, 3D and 2D (e.g. from Spine). ", "tags": "", "loc": "CastleSceneCore.html#OptimizeExtensiveTransformations"},
     {"title": "CastleSceneManager", "text": " ", "tags": "", "loc": "CastleSceneManager.html"},
     {"title": "CastleSceneManager.EViewportSceneManagerMissing", "text": " ", "tags": "", "loc": "CastleSceneManager.EViewportSceneManagerMissing.html"},
     {"title": "CastleSceneManager.TCastleAbstractViewport", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.DefaultScreenSpaceAmbientOcclusion", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#DefaultScreenSpaceAmbientOcclusion"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.DefaultUseGlobalLights", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#DefaultUseGlobalLights"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.DefaultUseGlobalFog", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#DefaultUseGlobalFog"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.DefaultShadowVolumes", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#DefaultShadowVolumes"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.CalculateProjection", "text": " Determines if the view is perspective or orthogonal and exact field of view parameters. Used by our Render method.  <p>The default implementation is <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html\">TCastleAbstractViewport</a> calculates projection based on MainScene currently bound Viewpoint, NavigationInfo and used <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">Camera</a>. If scene manager's MainScene is not assigned, we use some default sensible perspective projection.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#CalculateProjection"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Render3D", "text": " All current camera settings are saved in <a class=\"normal\" href=\"CastleRenderingCamera.html#RenderingCamera\">RenderingCamera</a>, and the camera matrix is already loaded to OpenGL.  <p>If you want to display something 3D during rendering, this is the simplest method to override. (Or you can use <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#OnRender3D\">OnRender3D</a> event, which is called at the end of this method.) Alternatively, you can create new <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> descendant and add it to the <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#GetItems\">GetItems</a> list.  <p>  Params Parameters specify what lights should be used (Params.BaseLights, Params.InShadow), and which parts of the 3D scene should be rendered (Params.Transparent, Params.ShadowVolumesReceivers &mdash; only matching 3D objects should be rendered by this method).  Params Parameters specify what lights should be used (Params.BaseLights, Params.InShadow), and which parts of the 3D scene should be rendered (Params.Transparent, Params.ShadowVolumesReceivers &mdash; only matching 3D objects should be rendered by this method).", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Render3D"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.RenderShadowVolume", "text": " You can use here ShadowVolumeRenderer instance, which is guaranteed to be initialized with <a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#InitFrustumAndLight\">TGLShadowVolumeRenderer.InitFrustumAndLight</a>, so you can do shadow volumes culling.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#RenderShadowVolume"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.RenderFromViewEverything", "text": " Current RenderingCamera.Target says to where we generate the image. Takes method must take care of making many rendering passes for shadow volumes, but doesn't take care of updating generated textures.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#RenderFromViewEverything"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.InitializeLights", "text": " <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#BaseLights\">BaseLights</a> contents should be initialized here.  <p>The implementation in this class adds headlight determined by the <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Headlight\">Headlight</a> method. By default, this looks at the MainScene, and follows NavigationInfo.headlight and KambiNavigationInfo.headlightNode properties.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#InitializeLights"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Headlight", "text": " Returns non-nil headlight node, if headlight is present, or <code>Nil</code> when no headlight.  <p>Default implementation of this method in <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> looks at the MainScene headlight. We return if MainScene is assigned and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#HeadlightOn\">TCastleSceneCore.HeadlightOn</a> is <code>True</code>. (HeadlightOn in turn looks at information in VRML/X3D file (NavigationInfo.headlight) and you can also always set HeadlightOn explicitly by code.) The custom light node is obtained from <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#CustomHeadlight\">TCastleSceneCore.CustomHeadlight</a>, eventually using a default directional light node for a simple headlight.  <p>Default implementation of this method in <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html\">TCastleViewport</a> looks at SceneManager.Headlight.  <p>You can override this method to determine the headlight in any other way.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Headlight"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.RenderFromView3D", "text": " Called by <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#RenderFromViewEverything\">RenderFromViewEverything</a> at the end, when everything (clearing, background, headlight, loading camera matrix) is done and all that remains is to pass to OpenGL actual 3D world.  <p>This will change Params.Transparent, Params.InShadow and Params.ShadowVolumesReceivers as needed. Their previous values do not matter.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#RenderFromView3D"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Background", "text": " <code>Nil</code> if no background should be rendered.  <p>The default implementation in this class does what is usually most natural: return MainScene.Background, if MainScene assigned.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Background"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.MainLightForShadows", "text": " The default implementation in this class looks at MainScene.MainLightForShadows.  <p>    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#MainLightForShadows"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.SetCamera", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#SetCamera"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Notification", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Notification"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.SetContainer", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#SetContainer"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GetItems", "text": " For scene maager, these methods simply return it's own properties. For <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html\">TCastleViewport</a>, these methods refer to scene manager.     ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GetItems"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GetMainScene", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GetMainScene"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GetShadowVolumeRenderer", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GetShadowVolumeRenderer"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GetMouseRayHit", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GetMouseRayHit"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GetHeadlightCamera", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GetHeadlightCamera"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GetPlayer", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GetPlayer"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GetTimeScale", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GetTimeScale"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.PointingDeviceMove", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#PointingDeviceMove"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.PointingDeviceActivate", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#PointingDeviceActivate"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.CameraMoveAllowed", "text": "  <p>Scene manager implements collisions by looking at 3D scene, custom viewports implements collisions by calling their scene manager.  <p>    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#CameraMoveAllowed"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.CameraHeight", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#CameraHeight"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.CameraRayCollision", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#CameraRayCollision"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.CameraVisibleChange", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#CameraVisibleChange"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GetScreenEffects", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GetScreenEffects"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.AssignDefaultCamera", "text": " The newly created camera owned should be Self. This is automatically used when <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">Camera</a> is <code>Nil</code> at various places, and implementation may assume that <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">Camera</a> is <code>Nil</code> at entry.  <p>The implementation in base <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html\">TCastleAbstractViewport</a> uses MainScene.NavigationTypeFromNavigationInfo (so it will follow your VRML/X3D scene Viewpoint, NavigationInfo and such). If MainScene is not assigned, we create a simple camera in Examine mode.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#AssignDefaultCamera"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Create", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Create"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Destroy", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Destroy"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Resize", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Resize"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.AllowSuspendForInput", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#AllowSuspendForInput"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Press", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Press"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Release", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Release"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Motion", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Motion"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.SensorRotation", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#SensorRotation"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.SensorTranslation", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#SensorTranslation"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Update", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Update"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.RequiredCamera", "text": " Automatically creates it if missing.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#RequiredCamera"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.WalkCamera", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> When SwitchNavigationTypeIfNeeded is <code>True</code> (the default), this method makes sure that the <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a> corresponds to a type handled by <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a>, creating and adjusting the camera if necessary.  <p>If the current <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a> does not use <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> (see <a class=\"normal\" href=\"CastleCameras.html#TNavigationType\">TNavigationType</a> documentation for information which navigation types use which <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a> descendants), then it's switched to <a class=\"normal\" href=\"CastleCameras.html#ntWalk\">ntWalk</a>. </p></li>   <li><p> When SwitchNavigationTypeIfNeeded is <code>False</code>, then we return <code>Nil</code> if the current camera is not already a <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> instance.  <p>We <i>never</i> create a new camera in this case (even if the NavigatinInfo node in MainScene would indicate that the new camera would be a <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a>). </p></li> </ul>  <p>    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#WalkCamera"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ExamineCamera", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> When SwitchNavigationTypeIfNeeded is <code>True</code> (the default), this method makes sure that the <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a> corresponds to a type handled by <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a>, creating and adjusting the camera if necessary.  <p>If the current <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a> does not use <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> (see <a class=\"normal\" href=\"CastleCameras.html#TNavigationType\">TNavigationType</a> documentation for information which navigation types use which <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a> descendants), then it's switched to <a class=\"normal\" href=\"CastleCameras.html#ntExamine\">ntExamine</a>. </p></li>   <li><p> When SwitchNavigationTypeIfNeeded is <code>False</code>, then we return <code>Nil</code> if the current camera is not already a <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> instance.  <p>We <i>never</i> create a new camera in this case (even if the NavigatinInfo node in MainScene would indicate that the new camera would be a <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a>). </p></li> </ul>  <p>    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ExamineCamera"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ClearCameras", "text": " The actual creation may be caused by calling <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ExamineCamera\">ExamineCamera</a>, <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#WalkCamera\">WalkCamera</a>, <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#InternalExamineCamera\">InternalExamineCamera</a>, <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#InternalWalkCamera\">InternalWalkCamera</a>, or by setting <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a>.  <p>In all cases, these methods will create a new camera instance after a <code>ClearCameras</code> call. No previous cached camera instance will be used.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ClearCameras"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.InternalExamineCamera", "text": " Using these methods automatically creates these instances (so they are never <code>Nil</code>).  <p>Using these methods <i>does not</i> make these camera instances current (in contast to calling <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ExamineCamera\">ExamineCamera</a>, <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#WalkCamera\">WalkCamera</a> or setting <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a>).  <p>When you switch navigation types by calling <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ExamineCamera\">ExamineCamera</a>, <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#WalkCamera\">WalkCamera</a> or setting <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a> the scene manager keeps using these instances of cameras, instead of creating new camera instances. This way all the camera properties (not only those copied by <a class=\"normal\" href=\"CastleCameras.TCamera.html#Assign\">TCamera.Assign</a>) are preserved when you switch e.g. <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a> from <a class=\"normal\" href=\"CastleCameras.html#ntWalk\">ntWalk</a> to <a class=\"normal\" href=\"CastleCameras.html#ntExamine\">ntExamine</a> to <a class=\"normal\" href=\"CastleCameras.html#ntWalk\">ntWalk</a> again.     ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#InternalExamineCamera"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.InternalWalkCamera", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#InternalWalkCamera"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ScreenEffectsCount", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ScreenEffectsCount"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ScreenEffectsNeedDepth", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ScreenEffectsNeedDepth"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ScreenSpaceAmbientOcclusionAvailable", "text": " This does <i>not</i> depend on the current state of <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ScreenSpaceAmbientOcclusion\">ScreenSpaceAmbientOcclusion</a> property. You can use it e.g. to disable the menu item to switch SSAO in 3D viewer.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ScreenSpaceAmbientOcclusionAvailable"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GLContextOpen", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GLContextOpen"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.GLContextClose", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#GLContextClose"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.HeadlightInstance", "text": " Uses <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Headlight\">Headlight</a> method, applies appropriate camera position/direction. Returns <code>True</code> only if <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Headlight\">Headlight</a> method returned <code>True</code> and a suitable camera was present.  <p>Instance should be considered undefined (&quot;out&quot; parameter) when we return <code>False</code>.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#HeadlightInstance"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.PrepareParams", "text": " This should be passed to <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PrepareResources\">TCastleTransform.PrepareResources</a>.  <p>Note: Instead of using <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PrepareResources\">TCastleTransform.PrepareResources</a>, and this method, it's usually easier to call <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#PrepareResources\">TCastleSceneManager.PrepareResources</a>. Then the appropriate <a class=\"normal\" href=\"CastleTransform.TPrepareParams.html\">TPrepareParams</a> will be passed automatically.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#PrepareParams"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.BaseLights", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#BaseLights"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Statistics", "text": " See <a class=\"normal\" href=\"CastleTransform.TRenderStatistics.html\">TRenderStatistics</a> docs.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Statistics"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.TriangleHit", "text": " Updated in every mouse move. May be <code>Nil</code>.    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#TriangleHit"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Projection", "text": " <b>Read only</b>, change these parameters only by overriding <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#CalculateProjection\">CalculateProjection</a>. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Projection"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.NavigationType", "text": " This is automatically determined from the currently bound NavigatinInfo X3D node in the <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#GetMainScene\">GetMainScene</a>. You can also set this manually, thus overriding the NavigatinInfo node.  <p>This is a shortcut property for adjusting the camera class (by calling <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#WalkCamera\">WalkCamera</a>, <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ExamineCamera\">ExamineCamera</a>) and adjusting a couple of camera properties. Note that you can also affect the current <code>NavigationType</code> by directly changing the camera properties, e.g. you can directly change <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">TWalkCamera.Gravity</a> from <code>False</code> to <code>True</code>, and thus you effectively switch from <a class=\"normal\" href=\"CastleCameras.html#ntFly\">ntFly</a> to <a class=\"normal\" href=\"CastleCameras.html#ntWalk\">ntWalk</a> navigation types. When you read the <code>NavigationType</code> property, we determine the current navigation type from current camera properties.  <p>When the camera is created for the first time, it's parameters are determined from the current NavigationInfo and Viewpoint nodes in <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#GetMainScene\">GetMainScene</a>, and from bounding box of the world. When the camera class is switched later, the common camera properties (defined at <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a>, like <a class=\"normal\" href=\"CastleCameras.TCamera.html#Radius\">TCamera.Radius</a> and view vectors &ndash; position, direction, up) are copied, so they are preserved. The other camera properties (those defined only at <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a> or <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> descendants, e.g. <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MouseLook\">TWalkCamera.MouseLook</a> and various inputs of cameras) are also preserved within <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#InternalExamineCamera\">InternalExamineCamera</a> and <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#InternalWalkCamera\">InternalWalkCamera</a>.  <p>To reliably force recreating the camera from scratch, call <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ClearCameras\">ClearCameras</a>. Simply freeing the current camera by <code>SceneManager.Camera.Free</code> is also valid operation, but it does not free both cameras (<a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#InternalExamineCamera\">InternalExamineCamera</a> and <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#InternalWalkCamera\">InternalWalkCamera</a>) so it doesn't guarantee that all cameras will be recreated from a &quot;clean&quot; state. You can also explicitly assign your own camera descendant to <code>SceneManager.Camera</code>.  <p>Setting this sets: </p>  <ul class=\"compact_spacing\">   <li><p><a class=\"normal\" href=\"CastleCameras.TCamera.html#Input\">TCamera.Input</a></p></li>   <li><p><a class=\"normal\" href=\"CastleCameras.TExamineCamera.html#Turntable\">TExamineCamera.Turntable</a>, only in case of <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a></p></li>   <li><p><a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#Gravity\">TWalkCamera.Gravity</a>, only in case of <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a></p></li>   <li><p><a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForRotations\">TWalkCamera.PreferGravityUpForRotations</a>, only in case of <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a></p></li>   <li><p><a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#PreferGravityUpForMoving\">TWalkCamera.PreferGravityUpForMoving</a>, only in case of <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html\">TWalkCamera</a></p></li> </ul>  <p>  <p>If you write to <code>NavigationType</code>, then you <i>should not</i> touch the above properties directly. That's because not every combination of above properties correspond to some sensible value of <code>NavigationType</code>. If you directly set some weird configuration, reading <code>NavigationType</code> will try it's best to determine the closest <a class=\"normal\" href=\"CastleCameras.html#TNavigationType\">TNavigationType</a> value that is similar to your configuration. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#NavigationType"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ScreenEffects", "text": " If any screen effects are active, we will automatically render screen to a temporary texture, processing it with each shader.  <p>By default, screen effects come from GetMainScene.ScreenEffects, so the effects may be defined by VRML/X3D author using ScreenEffect nodes (see docs: [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions_screen_effects.php\">http://castle-engine.sourceforge.net/x3d_extensions_screen_effects.php</a>]). Descendants may override <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#GetScreenEffects\">GetScreenEffects</a>, <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ScreenEffectsCount\">ScreenEffectsCount</a>, and <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ScreenEffectsNeedDepth\">ScreenEffectsNeedDepth</a> to add screen effects by code. Each viewport may have it's own, different screen effects.  <p> ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ScreenEffects"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.BackgroundColor", "text": " Unless the MainScene has a Background node defined, in which case the Background (colored and/or textured) of the 3D scene is used.  <p><a class=\"normal\" href=\"CastleColors.html#Black\">Black</a> by default. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#BackgroundColor"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Camera", "text": "  <p>Note this property may be <code>Nil</code> before rendering. If you don't assign anything here, we'll create a default camera when necessary (usually at the ApplyProjection which happens before the rendering). Use <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#RequiredCamera\">RequiredCamera</a> instead of this property to get a camera that is never <code>Nil</code>. Or use <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ExamineCamera\">ExamineCamera</a> or <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#WalkCamera\">WalkCamera</a> to get a camera that is never <code>Nil</code>, and has particular type. Or set <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#NavigationType\">NavigationType</a> first, this also sets the camera always.  <p>For many purposes, you can directly operate on this camera, for example you can change it's <a class=\"normal\" href=\"CastleCameras.TCamera.html#Position\">Position</a>. An exception to this is assigning events to the camera instance. The scene manager or viewport will &quot;hijack&quot; some Camera events: TCamera.OnVisibleChange, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnMoveAllowed\">TWalkCamera.OnMoveAllowed</a>, <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnHeight\">TWalkCamera.OnHeight</a>, TCamera.OnCursorChange. We will handle them in a proper way. Do not assign them yourself.  <p><i>Comments for <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html\">TCastleViewport</a> only:</i> The <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html\">TCastleViewport</a>'s camera is slightly less important than TCastleSceneManager.Camera, because TCastleSceneManager.Camera may be treated as a &quot;central&quot; camera. Viewport's camera may not (because you may have many viewports and they all deserve fair treatment). So e.g. headlight is done only from TCastleSceneManager.Camera (for mirror textures, there must be one headlight for your 3D world). Also VRML/X3D ProximitySensors receive events only from TCastleSceneManager.Camera.  <p> ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Camera"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Paused", "text": "  <p><i>For scene manager:</i>  <p>&quot;Paused&quot; means that no events (key, mouse, <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Update\">Update</a>) are passed to any <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a> or the <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">Camera</a>. This is suitable if you really want to totally, unconditionally, make your 3D world view temporary still (for example, useful when entering some modal dialog box and you want 3D scene to behave as a still background).  <p>You can of course still directly change some scene property, and then 3D world will change. But no change will be initialized automatically by scene manager events.  <p><i>See also</i>: For less drastic pausing methods, there are other methods of pausing / disabling some events processing for the 3D world:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>You can set TCastleScene.TimePlaying to <code>False</code>. This is roughly equivalent to not running their <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Update\">Update</a> methods. This means that time will &quot;stand still&quot; for them, so their animations will not play. Although they may still react and change in response to mouse clicks / key presses, if TCastleScene.ProcessEvents.</p></li>   <li><p>You can set TCastleScene.ProcessEvents to <code>False</code>. This means that scene will not receive and process any key / mouse and other events (through VRML/X3D sensors). Some animations (not depending on VRML/X3D events processing) may still run, for example MovieTexture will still animate, if only TCastleScene.TimePlaying.</p></li>   <li><p>For cameras, you can set <code><a class=\"normal\" href=\"CastleCameras.TCamera.html#Input\">TCamera.Input</a> := []</code> to ignore key / mouse clicks.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Paused"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.OnRender3D", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#OnRender3D"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ShadowVolumes", "text": " You can change this at any time, to switch rendering shadows on/off.  <p>This works only if OpenGL context actually can render shadow volumes, checked by GLFeatures.ShadowVolumesPossible, which means that you have to initialize OpenGL context with stencil buffer.  <p>The shadow volumes algorithm is used only if shadow caster is 2-manifold, that is has a correctly closed volume. Also you need a light source marked as the main shadow volumes light (<code>shadowVolumes</code> = shadowVolumesMain = TRUE). See [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadows\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadows</a>] for details. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ShadowVolumes"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ShadowVolumesRender", "text": " If shadows are rendered (see GLFeatures.ShadowVolumesPossible and <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ShadowVolumes\">ShadowVolumes</a>), you can use this to actually see shadow volumes, for debug / demo purposes. Shadow volumes will be rendered on top of the scene, as <a class=\"normal\" href=\"CastleColors.html#Yellow\">yellow</a> blended polygons. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ShadowVolumesRender"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.BackgroundWireframe", "text": "  <p>There's a catch here: this works only if the background is actually internally rendered as a geometry. If the background is rendered by clearing the screen (this is an optimized case of sky color being just one simple color, and no textures), then it will just cover the screen as normal, like without wireframe. This is uncertain situation anyway (what should the wireframe look like in this case anyway?), so I don't consider it a bug.  <p>Useful especially for debugging when you want to see how your background geometry looks like. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#BackgroundWireframe"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.Transparent", "text": " by Material.transparency). For this to make sense, make sure that you always place some other 2D control under this viewport, that actually draws something predictable underneath.  <p>The normal background, derived from <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Background\">Background</a> will be ignored. We will also not do any RenderContext.Clear on color buffer. Also <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#BackgroundWireframe\">BackgroundWireframe</a> and <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#BackgroundColor\">BackgroundColor</a> doesn't matter in this case. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#Transparent"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ClearDepth", "text": " This makes every scene manager draw everything on top of the previous 2D and 3D stuff (including on top of previous scene managers), like a layer.  <p>You can disable this, which allows to combine together the 3D objects rendered by various scene managers (and by custom OpenGL rendering), such that the 3D positions determime what overlaps what. This only makes sense if all these scene managers (or custom renderers) use the same viewport, the same projection and the same camera.  <p>It's your responsibility in such case to clear the depth buffer. E.g. place one scene manager in the back that has <code>ClearDepth</code> = <code>True</code>. Or place a <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> descendant in the back, that calls <code>TRenderContent.Clear RenderContent.Clear</code> in overridden <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a>.  <p>Note: to disable clearning the color buffer, set <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Transparent\">Transparent</a> to <code>False</code>.  <p>Note: if you use shadow volumes, we will still clear the stencil buffer at the beginning of rendering. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ClearDepth"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.HeadlightFromViewport", "text": " This is meaningless in <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>.  <p>By default this is <code>False</code>, which means that when rendering custom viewport (<a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html\">TCastleViewport</a>) we render headlight from TCastleViewport.SceneManager.Camera (not from current viewport's TCastleViewport.Camera). On one hand, this is sensible: there is exactly one headlight in your 3D world, and it shines from a central camera in SceneManager.Camera. When SceneManager.Camera is <code>Nil</code> (which may happen if you set SceneManager.DefaultViewport := false and you didn't assign SceneManager.Camera explicitly) headlight is never done. This means that when observing 3D world from other cameras, you will see a light shining from SceneManager.Camera. This is also the only way to make headlight lighting correctly reflected in mirror textures (like GeneratedCubeMapTexture) &mdash; since we render to one mirror texture, we need a knowledge of &quot;cental&quot; camera for this.  <p>When this is <code>True</code>, then each viewport actually renders headlight from it's current camera. This means that actually each viewport has it's own, independent headlight (althoug they all follow VRML/X3D NavigationInfo.headlight and KambiNavigationInfo settings). This may allow you to light your view better (if you only use headlight to &quot;just make the view brighter&quot;), but it's not entirely correct (in particular, mirror reflections of the headlight are undefined then).  <p> This is deprecated, since <code>HeadlightFromViewport</code> = <code>True</code> is not really nicely defined, and it's not practically that useful either. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#HeadlightFromViewport"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.UseGlobalLights", "text": " This is an easy way to lit your whole world with lights defined inside MainScene file. Be sure to set lights global=TRUE.  <p>Note that for now this assumes that MainScene coordinates equal world coordinates. This means that you should not transform the MainScene, it should be placed inside <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a> and not transformed by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a>. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#UseGlobalLights"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.UseGlobalFog", "text": " This is consistent with <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#UseGlobalLights\">UseGlobalLights</a>, that allows lights from MainScene to shine on all objects. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#UseGlobalFog"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ApproximateActivation", "text": " Every time you press or release <a class=\"normal\" href=\"CastleSceneManager.html#Input_Interact\">Input_Interact</a> (by default just left mouse button), we look if current mouse position hits 3D object that actually does something on activation. The objects may do various stuff inside <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PointingDeviceActivate\">TCastleTransform.PointingDeviceActivate</a>, generally this causes various picking/interaction with the object (like pulling a level, opening a door), possibly dragging, possibly with the help of VRML/X3D pointing device and drag sensors.  <p>When this is <code>True</code>, we try harder to hit some 3D object that handles <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#PointingDeviceActivate\">PointingDeviceActivate</a>. If there's nothing interesting under mouse, we will retry a couple of other positions arount the current mouse.  <p>This should be usually used when you use <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#MouseLook\">TWalkCamera.MouseLook</a>, or other navigation when mouse cursor is hidden. It allows user to only approximately look at interesting item and hit interaction button or key. Otherwise, activating a small 3D object is difficult, as you don't see the mouse cursor. ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ApproximateActivation"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.DefaultVisibilityLimit", "text": " This is the distance the far projection clipping plane.  <p>The default <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#CalculateProjection\">CalculateProjection</a> implementation calculates the final visibility limit as follows:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>First of all, if (GLFeatures.ShadowVolumesPossible and <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#ShadowVolumes\">ShadowVolumes</a>), then it's infinity.</p></li>   <li><p>Then we look NavigationInfo.visibilityLimit value inside MainScene. This allows your 3D data creators to set this inside VRML/X3D data.  <p>Only if MainScene is not set, or doesn't contain NavigationInfo node, or NavigationInfo.visibilityLimit is left at (default) zero, we look further.</p></li>   <li><p>We use this property, <code>DefaultVisibilityLimit</code>, if it's not zero.</p></li>   <li><p>Finally, as a last resort we calculate something suitable looking at the 3D bounding box of items inside our 3D world.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#DefaultVisibilityLimit"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.ScreenSpaceAmbientOcclusion", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#ScreenSpaceAmbientOcclusion"},
     {"title": "CastleSceneManager.TCastleAbstractViewport.FullSize", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewport.html#FullSize"},
     {"title": "CastleSceneManager.TCastleAbstractViewportList", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewportList.html"},
     {"title": "CastleSceneManager.TCastleAbstractViewportList.UsesShadowVolumes", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleAbstractViewportList.html#UsesShadowVolumes"},
     {"title": "CastleSceneManager.TCastleSceneManager", "text": "  <p>Single scenes/models (like <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instances) can be rendered directly, but it's not always comfortable. Scenes have to assume that they are &quot;one of the many&quot; inside your 3D world, which means that multi-pass rendering techniques have to be implemented at a higher level. This concerns the need for multiple passes from the same camera (for shadow volumes) and multiple passes from different cameras (for generating textures for shadow maps, cube map environment etc.).  <p>Scene manager overcomes this limitation. A single SceneManager object knows about all 3D things in your world, and renders them all for you, taking care of doing multiple rendering passes for particular features. Naturally, it also serves as container for all your visible 3D scenes.  <p><a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">Items</a> property keeps a tree of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> objects. <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> and <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> can be added to this tree. Naturally you can implement your own <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> descendants, representing any (possibly dynamic, animated and even interactive) object.  <p><a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Render\">TCastleSceneManager.Render</a> can assume that it's the <i>only</i> manager rendering to the screen (although you can safely render more 3D geometry *after* calling <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Render\">TCastleSceneManager.Render</a>). So it's Render method takes care of  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>clearing the screen,</p></li>   <li><p>rendering the background of the scene,</p></li>   <li><p>rendering the headlight,</p></li>   <li><p>rendering the scene from given camera,</p></li>   <li><p>and making multiple passes for shadow volumes and generated textures.</p></li> </ul>  <p>  <p>For some of these features, you'll have to set the <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">MainScene</a> property.  <p>This is a <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> descendant, which means it's advised usage is to add this to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a>. This passes relevant <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> events to all the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> objects inside. Note that even when you set <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#DefaultViewport\">DefaultViewport</a> = <code>False</code> (and use custom viewports, by <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html\">TCastleViewport</a> class, to render your 3D world), you still should add scene manager to the controls list (this allows e.g. 3D items to receive <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Update\">Update</a> events). ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html"},
     {"title": "CastleSceneManager.TCastleSceneManager.FSectors", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#FSectors"},
     {"title": "CastleSceneManager.TCastleSceneManager.Waypoints", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Waypoints"},
     {"title": "CastleSceneManager.TCastleSceneManager.SetCamera", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#SetCamera"},
     {"title": "CastleSceneManager.TCastleSceneManager.CollisionIgnoreItem", "text": " The default implementation in this class resturns always <code>False</code>, so nothing is ignored. You can override it e.g. to ignore your &quot;water&quot; material, when you want player to dive under the water.    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#CollisionIgnoreItem"},
     {"title": "CastleSceneManager.TCastleSceneManager.Notification", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Notification"},
     {"title": "CastleSceneManager.TCastleSceneManager.CameraMoveAllowed", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#CameraMoveAllowed"},
     {"title": "CastleSceneManager.TCastleSceneManager.CameraHeight", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#CameraHeight"},
     {"title": "CastleSceneManager.TCastleSceneManager.CameraRayCollision", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#CameraRayCollision"},
     {"title": "CastleSceneManager.TCastleSceneManager.CameraVisibleChange", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#CameraVisibleChange"},
     {"title": "CastleSceneManager.TCastleSceneManager.GetItems", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GetItems"},
     {"title": "CastleSceneManager.TCastleSceneManager.GetMainScene", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GetMainScene"},
     {"title": "CastleSceneManager.TCastleSceneManager.GetShadowVolumeRenderer", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GetShadowVolumeRenderer"},
     {"title": "CastleSceneManager.TCastleSceneManager.GetMouseRayHit", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GetMouseRayHit"},
     {"title": "CastleSceneManager.TCastleSceneManager.GetHeadlightCamera", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GetHeadlightCamera"},
     {"title": "CastleSceneManager.TCastleSceneManager.GetPlayer", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GetPlayer"},
     {"title": "CastleSceneManager.TCastleSceneManager.GetTimeScale", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GetTimeScale"},
     {"title": "CastleSceneManager.TCastleSceneManager.PointingDeviceActivate", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#PointingDeviceActivate"},
     {"title": "CastleSceneManager.TCastleSceneManager.PointingDeviceMove", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#PointingDeviceMove"},
     {"title": "CastleSceneManager.TCastleSceneManager.PointingDeviceActivateFailed", "text": " You can override this to make a message / sound signal to notify user that his <a class=\"normal\" href=\"CastleSceneManager.html#Input_Interact\">Input_Interact</a> click was not successful.    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#PointingDeviceActivateFailed"},
     {"title": "CastleSceneManager.TCastleSceneManager.PointingDeviceActivate3D", "text": " See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PointingDeviceActivate\">TCastleTransform.PointingDeviceActivate</a> method for description how it should be handled. Default implementation in <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> just calls <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PointingDeviceActivate\">TCastleTransform.PointingDeviceActivate</a>.    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#PointingDeviceActivate3D"},
     {"title": "CastleSceneManager.TCastleSceneManager.MoveAllowed", "text": " See the description of <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#OnMoveAllowed\">OnMoveAllowed</a> property for information.  <p>When this is called, collision detection determined that this move is allowed. The default implementation in <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> calculates the result using the algorithm described at the <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MoveLimit\">MoveLimit</a> property, then calls <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#OnMoveAllowed\">OnMoveAllowed</a> event.    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#MoveAllowed"},
     {"title": "CastleSceneManager.TCastleSceneManager.BoundNavigationInfoChanged", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#BoundNavigationInfoChanged"},
     {"title": "CastleSceneManager.TCastleSceneManager.BoundViewpointChanged", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#BoundViewpointChanged"},
     {"title": "CastleSceneManager.TCastleSceneManager.Headlight", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Headlight"},
     {"title": "CastleSceneManager.TCastleSceneManager.Create", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Create"},
     {"title": "CastleSceneManager.TCastleSceneManager.Destroy", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Destroy"},
     {"title": "CastleSceneManager.TCastleSceneManager.GLContextOpen", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GLContextOpen"},
     {"title": "CastleSceneManager.TCastleSceneManager.GLContextClose", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GLContextClose"},
     {"title": "CastleSceneManager.TCastleSceneManager.PrepareResources", "text": " If DisplayProgressTitle &lt;&gt; '', we will display progress bar during loading.    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#PrepareResources"},
     {"title": "CastleSceneManager.TCastleSceneManager.PrepareResources", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#PrepareResources"},
     {"title": "CastleSceneManager.TCastleSceneManager.BeforeRender", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#BeforeRender"},
     {"title": "CastleSceneManager.TCastleSceneManager.Render", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Render"},
     {"title": "CastleSceneManager.TCastleSceneManager.CameraToChanges", "text": " You may want to use it when calling Scene.CameraChanged.  <p>Implementation in this class is correlated with RenderHeadlight.    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#CameraToChanges"},
     {"title": "CastleSceneManager.TCastleSceneManager.Update", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Update"},
     {"title": "CastleSceneManager.TCastleSceneManager.GravityUp", "text": " Gravity force pulls in -<code>GravityUp</code> direction.    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#GravityUp"},
     {"title": "CastleSceneManager.TCastleSceneManager.Rect", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Rect"},
     {"title": "CastleSceneManager.TCastleSceneManager.MoveLimit", "text": " In case of 1st-person view (always, for now) limiting the player position also implies limiting the camera position. Intuitively, this is the &quot;sensible&quot; part of 3D space where normal physics should work.  <p>TODO: When you activate 3rd-person camera (not implemented yet), this limit will apply to the Player.Position, not Camera.Position.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>When <code>MoveLimit</code> is an empty box (this is the default situation) then movement is limited to not fall because of gravity outside of Items.BoundingBox. Still, we can freely move anywhere (only gravity effect is limited to the Items.BoundingBox).  <p>This is the safest behavior for general 3D model browsers, it prevents camera from falling into an infinite abyss of our 3D space, since gravity will always stop at the Items.BoundingBox border.</p></li>   <li><p>When <code>MoveLimit</code> is not an empty box, then position cannot go outside of this box.  <p>Note that the <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a> always, automatically, assigns this property to be non-empty. It's either determined by CasMoveLimit placeholder in the level 3D model, or it's automatically calculated to include level bounding box + some space for flying.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#MoveLimit"},
     {"title": "CastleSceneManager.TCastleSceneManager.ShadowVolumeRenderer", "text": " You can use this to optimize rendering of your shadow quads in <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#RenderShadowVolume\">RenderShadowVolume</a>, and you can control it's statistics (<a class=\"normal\" href=\"CastleGLShadowVolumes.TGLShadowVolumeRenderer.html#Count\">TGLShadowVolumeRenderer.Count</a> and related properties).  <p>This is internally initialized by scene manager. It's <code>Nil</code> when OpenGL context is not yet initialized (or scene manager is not added to <code>Controls</code> list yet). ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#ShadowVolumeRenderer"},
     {"title": "CastleSceneManager.TCastleSceneManager.MouseRayHit", "text": " Updated in every mouse move. May be <code>Nil</code>. ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#MouseRayHit"},
     {"title": "CastleSceneManager.TCastleSceneManager.Viewports", "text": " This contains all <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html\">TCastleViewport</a> instances that have <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html#SceneManager\">TCastleViewport.SceneManager</a> set to us. Also it contains Self (this very scene manager) if and only if <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#DefaultViewport\">DefaultViewport</a> = <code>True</code> (because when <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#DefaultViewport\">DefaultViewport</a>, scene manager acts as an additional viewport too).  <p>This list is read-only from the outside! It's automatically managed in this unit (when you change <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html#SceneManager\">TCastleViewport.SceneManager</a> or <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#DefaultViewport\">TCastleSceneManager.DefaultViewport</a>, we automatically update this list as appropriate). ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Viewports"},
     {"title": "CastleSceneManager.TCastleSceneManager.Sectors", "text": " Initialized by <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a>. <code>Nil</code> if you never call <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a>.  <p>A generic AI code should work regardless if these are <code>Nil</code> or not. But if you're making a game and you know you will always call <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a>, you can just use them straight away. ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Sectors"},
     {"title": "CastleSceneManager.TCastleSceneManager.Water", "text": " It may be used by various 3D objects to indicate appropriate behavior &mdash; some things swim, some things drown and such. For now, this is only used by <a class=\"normal\" href=\"CastlePlayer.TPlayer.html\">TPlayer</a> class to detect swimming (and make appropriate sounds, special rendering, drowning and such).  <p>For now, this is just a simple <a class=\"normal\" href=\"CastleBoxes.TBox3D.html\">TBox3D</a>. It will be extended to represent a set of flexible 3D volumes in the future.  <p>Empty initially. Initialize it however you want. ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Water"},
     {"title": "CastleSceneManager.TCastleSceneManager.TimeScale", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#TimeScale"},
     {"title": "CastleSceneManager.TCastleSceneManager.Items", "text": " This is the place where you should add your scenes to have them handled by scene manager. You may also set your main <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> (if you have any) as <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">MainScene</a>. ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Items"},
     {"title": "CastleSceneManager.TCastleSceneManager.MainScene", "text": " It's not necessary to set this (after all, your 3D world doesn't even need to have any <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instance). This <i>must be</i> also added to our <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">Items</a> (otherwise things will work strangely).  <p>When set, this is used for a couple of things:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Decides what headlight is used (by TCastleScene.Headlight).</p></li>   <li><p>Decides what background is rendered. <i>Notes for implementing descendants of this class:</i> You can change this by overriding Background method.</p></li>   <li><p>Decides if, and where, the main light casting shadows is. <i>Notes for implementing descendants of this class:</i> You can change this by overriding <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#MainLightForShadows\">MainLightForShadows</a> method.</p></li>   <li><p>Determines projection for viewing (if you use default <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#CalculateProjection\">CalculateProjection</a> implementation).</p></li>   <li><p>Synchronizes our <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">Camera</a> with VRML/X3D viewpoints and navigation info. This means that <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Camera\">Camera</a> will be updated when VRML/X3D events change current Viewpoint or NavigationInfo, for example you can animate the camera by animating the viewpoint (or it's transformation) or bind camera to a viewpoint.  <p>Note that scene manager &quot;hijacks&quot; some Scene events: <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#OnBoundViewpointVectorsChanged\">TCastleSceneCore.OnBoundViewpointVectorsChanged</a>, TCastleSceneCore.ViewpointStack.OnBoundChanged, TCastleSceneCore.NavigationInfoStack.OnBoundChanged for this purpose. If you want to know when viewpoint changes, you can use scene manager's event <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#OnBoundViewpointChanged\">OnBoundViewpointChanged</a>, <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#OnBoundNavigationInfoChanged\">OnBoundNavigationInfoChanged</a>.</p></li> </ul>  <p>  <p>The above stuff is only sensible when done once per scene manager, that's why we need <code>MainScene</code> property to indicate this. (We cannot just use every 3D object from <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">Items</a> for this.)  <p>Freeing <code>MainScene</code> will automatically set this to <code>Nil</code>. ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#MainScene"},
     {"title": "CastleSceneManager.TCastleSceneManager.OnCameraChanged", "text": " Exactly when <a class=\"normal\" href=\"CastleCameras.TCamera.html\">TCamera</a> generates it's <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#OnVisibleChange\">OnVisibleChange</a> event. ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#OnCameraChanged"},
     {"title": "CastleSceneManager.TCastleSceneManager.OnBoundViewpointChanged", "text": " Called exactly when TCastleSceneCore.ViewpointStack.OnBoundChanged is called. ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#OnBoundViewpointChanged"},
     {"title": "CastleSceneManager.TCastleSceneManager.OnBoundNavigationInfoChanged", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#OnBoundNavigationInfoChanged"},
     {"title": "CastleSceneManager.TCastleSceneManager.DefaultViewport", "text": " This is usually what you want. For more complicated uses, you can turn this off, and use explicit <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html\">TCastleViewport</a> (connected to this scene manager by <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html#SceneManager\">TCastleViewport.SceneManager</a> property) for making your world visible. ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#DefaultViewport"},
     {"title": "CastleSceneManager.TCastleSceneManager.Player", "text": " This currently serves various purposes:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>In the 1st person view, this 3D object guides the camera and it never collides with the camera. That is, our <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#CameraMoveAllowed\">CameraMoveAllowed</a> and similar methods simply call Player.MoveAllowed, that in turn calls World.WorldMoveAllowed making sure that player is temporarily disabled (does not collide with itself).  <p><a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a> will set Player.Camera to TCastleSceneManager.Camera. This means that user can directly control Player.Camera view (position, direction, up), which in turn is always synchronized with Player view (that is, TPlayer.Direction always equals TPlayer.Camera.Direction and so on).</p></li>   <li><p>For simple AI in <a class=\"normal\" href=\"CastleCreatures.html\">CastleCreatures</a>, hostile creatures will attack this player. So this determines the target position that creatures try to reach, where they shoot missiles etc. More advanced AI, with friendlies/companions, or cooperating factions of creatures, may have other mechanisms to determine who wants to attack who.</p></li>   <li><p>For items on level in <a class=\"normal\" href=\"CastleItems.html\">CastleItems</a>, this player will pick up the items lying on the ground, and will be able to equip weapons. This functionality may be generalized in the future, to allow anyone to pick up and carry and equip items.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#Player"},
     {"title": "CastleSceneManager.TCastleSceneManager.OnMoveAllowed", "text": " This applies to all 3D objects using TCastleTransform.WorldMoveAllowed for movement. In case of 1st-person view (always for now), limiting the player position also implies limiting the camera position.  <p>When this event is called at all, the basic collision detection already decided that the move is allowed (so object does not collide with other collidable 3D features). You can now implement additional rules to say when the move is, or is not, allowed.  <p>Callback parameters:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><b>Allowed</b>:  <p>Initially, the Allowed parameter is set following the algorithm described at the <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MoveLimit\">MoveLimit</a> property. Your event can use this, and e.g. do something like  <p></p>  <pre class=\"longcode\">Allowed := Allowed <span class=\"pascal_keyword\">and</span> (my custom move rule);</pre>  <p>  <p>Or you can simply ignore the default Allowed value, thus ignoring the algorithm described at the <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MoveLimit\">MoveLimit</a> property, and simply always set Allowed to your own decision. For example, setting  <p></p>  <pre class=\"longcode\">Allowed := true;</pre>  <p>  <p>will make gravity and movement work everywhere.</p></li>   <li><p><b>BecauseOfGravity</b>:  <p><code>True</code> if this move was caused by gravity, that is: given object is falling down. You can use this to limit gravity to some box, but keep other movement unlimited, like  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_comment\">{ Allow movement everywhere, but limit gravity to a box. }</span> Allowed := (<span class=\"pascal_keyword\">not</span> BecauseOfGravity) <span class=\"pascal_keyword\">or</span> MyGravityBox.Contains(NewPos);</pre>  <p> </p></li> </ul>  <p> ", "tags": "", "loc": "CastleSceneManager.TCastleSceneManager.html#OnMoveAllowed"},
     {"title": "CastleSceneManager.TCastleViewport", "text": " This uses assigned <a class=\"normal\" href=\"CastleSceneManager.TCastleViewport.html#SceneManager\">SceneManager</a> to show 3D world on the screen.  <p>For simple games, using this is not needed, because <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> also acts as a viewport (when <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#DefaultViewport\">TCastleSceneManager.DefaultViewport</a> is <code>True</code>, which is the default). Using custom viewports (implemented by this class) is useful when you want to have more than one viewport showing the same 3D world. Different viewports may have different cameras, but they always share the same 3D world (in scene manager).  <p>You can control the size of this viewport by <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#FullSize\">FullSize</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Left\">Left</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Bottom\">Bottom</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Width\">Width</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Height\">Height</a> properties. For custom viewports, you often want to set <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#FullSize\">FullSize</a> = <code>False</code> and control viewport's position and size explicitly.  <p>Viewports may be overlapping, that is one viewport may (partially) obscure another viewport. Just like with any other <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a>, position of viewport on the Controls list (like <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a> or <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a>) is important: Controls are specified in the back-to-front order. That is, if the viewport A may obscure viewport B, then A must be after B on the Controls list.  <p>The viewports are a cool feature for many cases. For example typical 3D modeling programs have 4 viewports to view the model from various sides. Or you can make a split-screen game, played by 2 people on a single monitor. Or you can show in a 3D FPS game an additional view from some security camera, or from a flying rocket. For examples of using viewports see:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Explanation with an example: <a  href=\"http://castle-engine.sourceforge.net/tutorial_2d_user_interface.php#section_viewport\">http://castle-engine.sourceforge.net/tutorial_2d_user_interface.php#section_viewport</a></p></li>   <li><p>Example in engine sources: examples/3d_rendering_processing/multiple_viewports.lpr</p></li>   <li><p>Example in engine sources: examples/fps_game/</p></li> </ul>  <p> ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html"},
     {"title": "CastleSceneManager.TCastleViewport.GetItems", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#GetItems"},
     {"title": "CastleSceneManager.TCastleViewport.GetMainScene", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#GetMainScene"},
     {"title": "CastleSceneManager.TCastleViewport.GetShadowVolumeRenderer", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#GetShadowVolumeRenderer"},
     {"title": "CastleSceneManager.TCastleViewport.GetMouseRayHit", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#GetMouseRayHit"},
     {"title": "CastleSceneManager.TCastleViewport.GetHeadlightCamera", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#GetHeadlightCamera"},
     {"title": "CastleSceneManager.TCastleViewport.GetPlayer", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#GetPlayer"},
     {"title": "CastleSceneManager.TCastleViewport.GetTimeScale", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#GetTimeScale"},
     {"title": "CastleSceneManager.TCastleViewport.PointingDeviceActivate", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#PointingDeviceActivate"},
     {"title": "CastleSceneManager.TCastleViewport.PointingDeviceMove", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#PointingDeviceMove"},
     {"title": "CastleSceneManager.TCastleViewport.CameraMoveAllowed", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#CameraMoveAllowed"},
     {"title": "CastleSceneManager.TCastleViewport.CameraHeight", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#CameraHeight"},
     {"title": "CastleSceneManager.TCastleViewport.CameraRayCollision", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#CameraRayCollision"},
     {"title": "CastleSceneManager.TCastleViewport.CameraVisibleChange", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#CameraVisibleChange"},
     {"title": "CastleSceneManager.TCastleViewport.Headlight", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#Headlight"},
     {"title": "CastleSceneManager.TCastleViewport.Destroy", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#Destroy"},
     {"title": "CastleSceneManager.TCastleViewport.Render", "text": "    ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#Render"},
     {"title": "CastleSceneManager.TCastleViewport.SceneManager", "text": " ", "tags": "", "loc": "CastleSceneManager.TCastleViewport.html#SceneManager"},
     {"title": "CastleSceneManager.Register", "text": "    ", "tags": "", "loc": "CastleSceneManager.html#Register"},
     {"title": "CastleSceneManager.TRender3DEvent", "text": "    ", "tags": "", "loc": "CastleSceneManager.html#TRender3DEvent"},
     {"title": "CastleSceneManager.TWorldMoveAllowedEvent", "text": "    ", "tags": "", "loc": "CastleSceneManager.html#TWorldMoveAllowedEvent"},
     {"title": "CastleSceneManager.Input_Interact", "text": " More precisely, this input will activate pointing device sensors in VRML/X3D, which are used to touch (click) or drag 3D things. By default this is left mouse button click.  <p>You can change it to any other mouse button or even to key combination. Simply change properties like <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#Key1\">TInputShortcut.Key1</a> or <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html#MouseButtonUse\">TInputShortcut.MouseButtonUse</a>. ", "tags": "", "loc": "CastleSceneManager.html#Input_Interact"},
     {"title": "CastleSceneManager.Input_Attack", "text": " They are used only when Player is assigned, and only when it's not Dead and not Blocked (see <a class=\"normal\" href=\"Castle3D.TAlive.html#Dead\">TAlive.Dead</a>, <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Blocked\">TPlayer.Blocked</a>). Also other <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html\">TCastleAbstractViewport</a> rules for processing inputs must be satisfied, of course (<a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html\">TCastleAbstractViewport</a> must exist, according to TCastleAbstractViewport.GetExists, and not be paused, see <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Paused\">TCastleAbstractViewport.Paused</a>). The event must also not be handled first by something else, like camera.  ", "tags": "", "loc": "CastleSceneManager.html#Input_Attack"},
     {"title": "CastleSceneManager.Input_InventoryShow", "text": " ", "tags": "", "loc": "CastleSceneManager.html#Input_InventoryShow"},
     {"title": "CastleSceneManager.Input_InventoryPrevious", "text": " ", "tags": "", "loc": "CastleSceneManager.html#Input_InventoryPrevious"},
     {"title": "CastleSceneManager.Input_InventoryNext", "text": " ", "tags": "", "loc": "CastleSceneManager.html#Input_InventoryNext"},
     {"title": "CastleSceneManager.Input_UseItem", "text": " ", "tags": "", "loc": "CastleSceneManager.html#Input_UseItem"},
     {"title": "CastleSceneManager.Input_DropItem", "text": " ", "tags": "", "loc": "CastleSceneManager.html#Input_DropItem"},
     {"title": "CastleSceneManager.Input_CancelFlying", "text": " ", "tags": "", "loc": "CastleSceneManager.html#Input_CancelFlying"},
     {"title": "CastleScreenEffects", "text": " ", "tags": "", "loc": "CastleScreenEffects.html"},
     {"title": "CastleScreenEffects.TGLSLScreenEffect", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions_screen_effects.php\">http://castle-engine.sourceforge.net/x3d_extensions_screen_effects.php</a> about screen effects.  <p>Do not use the ancestor <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#AttachVertexShader\">AttachVertexShader</a> and <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#AttachFragmentShader\">AttachFragmentShader</a> methods, instead set the <a class=\"normal\" href=\"CastleScreenEffects.TGLSLScreenEffect.html#ScreenEffectShader\">ScreenEffectShader</a>. This way, the standard GLSL functionality of screen effects will be attached to the vertex and fragment shader code automatically. At link time, this looks at current OpenGL context multi-sampling capabilities, and the <a class=\"normal\" href=\"CastleScreenEffects.TGLSLScreenEffect.html#NeedsDepth\">NeedsDepth</a> value, to link the correct shader code. ", "tags": "", "loc": "CastleScreenEffects.TGLSLScreenEffect.html"},
     {"title": "CastleScreenEffects.TGLSLScreenEffect.Create", "text": "    ", "tags": "", "loc": "CastleScreenEffects.TGLSLScreenEffect.html#Create"},
     {"title": "CastleScreenEffects.TGLSLScreenEffect.Link", "text": "    ", "tags": "", "loc": "CastleScreenEffects.TGLSLScreenEffect.html#Link"},
     {"title": "CastleScreenEffects.TGLSLScreenEffect.NeedsDepth", "text": " ", "tags": "", "loc": "CastleScreenEffects.TGLSLScreenEffect.html#NeedsDepth"},
     {"title": "CastleScreenEffects.TGLSLScreenEffect.UniformNotFoundAction", "text": " ", "tags": "", "loc": "CastleScreenEffects.TGLSLScreenEffect.html#UniformNotFoundAction"},
     {"title": "CastleScreenEffects.TGLSLScreenEffect.ScreenEffectShader", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions_screen_effects.php\">http://castle-engine.sourceforge.net/x3d_extensions_screen_effects.php</a> . ", "tags": "", "loc": "CastleScreenEffects.TGLSLScreenEffect.html#ScreenEffectShader"},
     {"title": "CastleScreenEffects.ScreenEffectVertex", "text": " <b>In your own programs, it's usually easier to use <a class=\"normal\" href=\"CastleScreenEffects.TGLSLScreenEffect.html\">TGLSLScreenEffect</a>, and then this function is not necessary</b>.    ", "tags": "", "loc": "CastleScreenEffects.html#ScreenEffectVertex"},
     {"title": "CastleScreenEffects.ScreenEffectFragment", "text": " This looks at current OpenGL context multi-sampling capabilities to return the correct shader code.  <p><b>In your own programs, it's usually easier to use <a class=\"normal\" href=\"CastleScreenEffects.TGLSLScreenEffect.html\">TGLSLScreenEffect</a>, and then this function is not necessary</b>.  <p>Note that to work with OpenGLES, we have to glue all fragment shaders, and <code>ScreenEffectFragment</code> must be before the actual shader code. The string returned by this function is guaranteed to end with a newline, to make it easy.  <p>So you usually want to create screen effect shaders like this:  <p></p>  <pre class=\"longcode\"> Shader := TGLSLProgram.Create; Shader.AttachVertexShader(ScreenEffectVertex); Shader.AttachFragmentShader(   ScreenEffectFragment(false <span class=\"pascal_comment\">{ or true if you use depth }</span>) +   <span class=\"pascal_string\">'... my custom screen effect GLSL code ...'</span>); Shader.Link; <span class=\"pascal_comment\">{ uaIgnore is a good idea here, in case some uniform variable   from ScreenEffectFragment code may be left unused. }</span> Shader.UniformNotFoundAction := uaIgnore;</pre>  <p>    ", "tags": "", "loc": "CastleScreenEffects.html#ScreenEffectFragment"},
     {"title": "CastleScript", "text": "  <p>It is designed to be extendable, so you can add new <a class=\"normal\" href=\"CastleScript.TCasScriptValue.html\">TCasScriptValue</a> descendants and new <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a> descendants, and register their handlers in <a class=\"normal\" href=\"CastleScript.html#FunctionHandlers\">FunctionHandlers</a> instance (<a class=\"normal\" href=\"CastleScript.TCasScriptFunctionHandlers.html\">TCasScriptFunctionHandlers</a>).  <p>Using structures here you can also build <code>CastleScript</code> expressions by Pascal code (that is, you don't have to parse them). For example this is an expression that calculates <code>sin(3) + 10 + 1</code>:  <p></p>  <pre class=\"longcode\"> Expr := TCasScriptAdd.Create([     TCasScriptSin.Create([TCasScriptFloat.Create(false, <span class=\"pascal_numeric\">3</span>)]),     TCasScriptFloat.Create(false, <span class=\"pascal_numeric\">10</span>),     TCasScriptFloat.Create(false, <span class=\"pascal_numeric\">1</span>)   ]);</pre>  <p>  <p>You can then call <code>Expr.Execute</code> to calculate such expression.  <p>To make a variable in the expression, just create and remember a <a class=\"normal\" href=\"CastleScript.TCasScriptFloat.html\">TCasScriptFloat</a> instance first, and then change it's value freely between <code>Expr.Execute</code> calls. For example  <p></p>  <pre class=\"longcode\"> MyVariable := TCasScriptFloat.Create(false, <span class=\"pascal_numeric\">3</span>); Expr := TCasScriptAdd.Create([     TCasScriptSin.Create([MyVariable]),     TCasScriptFloat.Create(false, <span class=\"pascal_numeric\">10</span>),     TCasScriptFloat.Create(false, <span class=\"pascal_numeric\">1</span>)   ]);  Writeln((Expr.Execute <span class=\"pascal_keyword\">as</span> TKamStringFloat)<span class=\"pascal_float\">.</span>Value); <span class=\"pascal_comment\">// calculate &quot;sin(3) + 10 + 1&quot;</span>  MyVariable.Value := <span class=\"pascal_numeric\">4</span>; Writeln((Expr.Execute <span class=\"pascal_keyword\">as</span> TKamStringFloat)<span class=\"pascal_float\">.</span>Value); <span class=\"pascal_comment\">// calculate &quot;sin(4) + 10 + 1&quot;</span>  MyVariable.Value := <span class=\"pascal_numeric\">5</span>; Writeln((Expr.Execute <span class=\"pascal_keyword\">as</span> TKamStringFloat)<span class=\"pascal_float\">.</span>Value); <span class=\"pascal_comment\">// calculate &quot;sin(5) + 10 + 1&quot;</span></pre>  <p>  <p>Note that generally each <a class=\"normal\" href=\"CastleScript.TCasScriptExpression.html\">TCasScriptExpression</a> owns it's children expressions, so they will be automatically freed when parent is freed. Also, the values returned by Execute are owned by expression. So you can simply free whole thing by <code>Expr.Free</code>.  <p>If you're want to parse <code>CastleScript</code> expression from a text file, see <a class=\"normal\" href=\"CastleScriptParser.html\">CastleScriptParser</a>. ", "tags": "", "loc": "CastleScript.html"},
     {"title": "CastleScript.ECasScriptError", "text": " ", "tags": "", "loc": "CastleScript.ECasScriptError.html"},
     {"title": "CastleScript.ECasScriptAssignError", "text": " ", "tags": "", "loc": "CastleScript.ECasScriptAssignError.html"},
     {"title": "CastleScript.ECasScriptAnyMathError", "text": " ", "tags": "", "loc": "CastleScript.ECasScriptAnyMathError.html"},
     {"title": "CastleScript.TCasScriptEnvironment", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptEnvironment.html"},
     {"title": "CastleScript.TCasScriptEnvironment.BaseUrl", "text": " Similar to <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#BaseUrl\">TX3DNode.BaseUrl</a>. ", "tags": "", "loc": "CastleScript.TCasScriptEnvironment.html#BaseUrl"},
     {"title": "CastleScript.TCasScriptExpression", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptExpression.html"},
     {"title": "CastleScript.TCasScriptExpression.CoreExecute", "text": "  <p>This doesn't necessarily check floating-point exceptions. Execute actually calls <code>CoreExecute</code> and then ClearExceptions.  <p>Also this doesn't try to convert EIntError and EMathError to <a class=\"normal\" href=\"CastleScript.ECasScriptAnyMathError.html\">ECasScriptAnyMathError</a>. This is done by Execute.  <p>When one <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> <code>CoreExecute</code> calls another function, it can use <code>CoreExecute</code> instead of Execute. This way only one ClearExceptions will be needed for whole expression execution, instead of doing ClearExceptions after each function handler.    ", "tags": "", "loc": "CastleScript.TCasScriptExpression.html#CoreExecute"},
     {"title": "CastleScript.TCasScriptExpression.Execute", "text": "  <p>Returned value is owned by this object. Which should be comfortable for you usually, as you do not have to worry about freeing it. Also, it allows us to make various optimizations to avoid creating/destroying lots of temporary <a class=\"normal\" href=\"CastleScript.TCasScriptExpression.html\">TCasScriptExpression</a> instances during calculation of complex expression.  <p>The disadvantage of this is that returned object value is valid only until you executed this same expression again, or until you freed this expression. If you need to remember the execute result for longer, you have to copy it somewhere. For example you can do  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_comment\">{ This will always work, thanks to virtual TCasScriptValue.Create   and AssignValue methods. }</span> Copy := TCasScriptValue(ReturnedValue.ClassType)<span class=\"pascal_float\">.</span>Create; Copy.AssignValue(ReturnedValue);</pre>  <p>  <p>    ECasScriptError <p>Execute is guaranteed to raise an <a class=\"normal\" href=\"CastleScript.ECasScriptError.html\">ECasScriptError</a> exception if some calculation fails because of invalid arguments.  <p>This means that when you run <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> expression provided by the user, you only have to catch <a class=\"normal\" href=\"CastleScript.ECasScriptError.html\">ECasScriptError</a> to be safe from errors produced by user. No need to catch something more general like Exception class.  <p>Also it's guaranteed that no hanging floating-point errors are left. Normally, there is no guarantee that floating-point errors are raised immediately, they may be raised at the next fp operation (this is needed for fp operations to proceed in parallel, and be much faster). For executing <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a>, Execute calls Math.ClearExceptions(true) to make sure that all floating point errors are caught. This ensures that we can safely execute even invalid expressions (like 'ln(-3)') and get reliable exceptions.  <p>Floating-point errors of course also result in <a class=\"normal\" href=\"CastleScript.ECasScriptError.html\">ECasScriptError</a> descendants. More specifically, EIntError and EMathError result in <a class=\"normal\" href=\"CastleScript.ECasScriptAnyMathError.html\">ECasScriptAnyMathError</a>.", "tags": "", "loc": "CastleScript.TCasScriptExpression.html#Execute"},
     {"title": "CastleScript.TCasScriptExpression.TryExecuteMath", "text": " &quot;Math error within expression&quot; means that a <a class=\"normal\" href=\"CastleScript.ECasScriptAnyMathError.html\">ECasScriptAnyMathError</a> exception occurred while calculating expression.  <p>This is useful to secure you against math arguments errors ('ln(-3)', 'sqrt(-3)') but still raises normal exception on other <a class=\"normal\" href=\"CastleScript.ECasScriptError.html\">ECasScriptError</a> errors (like invalid argument type for function).    ", "tags": "", "loc": "CastleScript.TCasScriptExpression.html#TryExecuteMath"},
     {"title": "CastleScript.TCasScriptExpression.AsFloat", "text": " It assumes that the expression is written to always return float. To easily create such expression, use <a class=\"normal\" href=\"CastleScriptParser.html#ParseFloatExpression\">ParseFloatExpression</a>.    ", "tags": "", "loc": "CastleScript.TCasScriptExpression.html#AsFloat"},
     {"title": "CastleScript.TCasScriptExpression.AsInt", "text": " It assumes that the expression is written to always return integer. To easily create such expression, use <a class=\"normal\" href=\"CastleScriptParser.html#ParseIntExpression\">ParseIntExpression</a>.    ", "tags": "", "loc": "CastleScript.TCasScriptExpression.html#AsInt"},
     {"title": "CastleScript.TCasScriptExpression.AsString", "text": " It assumes that the expression is written to always return string. To easily create such expression, use <a class=\"normal\" href=\"CastleScriptParser.html#ParseStringExpression\">ParseStringExpression</a>.    ", "tags": "", "loc": "CastleScript.TCasScriptExpression.html#AsString"},
     {"title": "CastleScript.TCasScriptExpression.AsBool", "text": " It assumes that the expression is written to always return boolean. To easily create such expression, use <a class=\"normal\" href=\"CastleScriptParser.html#ParseBoolExpression\">ParseBoolExpression</a>.    ", "tags": "", "loc": "CastleScript.TCasScriptExpression.html#AsBool"},
     {"title": "CastleScript.TCasScriptExpression.FreeByParentExpression", "text": " (This cannot be implemented cleanly, as virtual procedure, since it must work when Self is <code>Nil</code>, and then virtual method table is not available of course.)    ", "tags": "", "loc": "CastleScript.TCasScriptExpression.html#FreeByParentExpression"},
     {"title": "CastleScript.TCasScriptExpression.Environment", "text": " May be <code>Nil</code>. This object is not owned by <a class=\"normal\" href=\"CastleScript.TCasScriptExpression.html\">TCasScriptExpression</a>, will not be freed by <a class=\"normal\" href=\"CastleScript.TCasScriptExpression.html\">TCasScriptExpression</a> and such. ", "tags": "", "loc": "CastleScript.TCasScriptExpression.html#Environment"},
     {"title": "CastleScript.TCasScriptExpressionList", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptExpressionList.html"},
     {"title": "CastleScript.TCasScriptExpressionList.AddArray", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptExpressionList.html#AddArray"},
     {"title": "CastleScript.TCasScriptExpressionList.AddList", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptExpressionList.html#AddList"},
     {"title": "CastleScript.TCasScriptExpressionList.FreeContentsByParentExpression", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptExpressionList.html#FreeContentsByParentExpression"},
     {"title": "CastleScript.TCasScriptValue", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptValue.html"},
     {"title": "CastleScript.TCasScriptValue.CoreExecute", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptValue.html#CoreExecute"},
     {"title": "CastleScript.TCasScriptValue.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptValue.html#Create"},
     {"title": "CastleScript.TCasScriptValue.AssignValue", "text": "     ECasScriptAssignError if assignment is not possible because types don't match.", "tags": "", "loc": "CastleScript.TCasScriptValue.html#AssignValue"},
     {"title": "CastleScript.TCasScriptValue.Writeable", "text": " If not, this will not be allowed to change by <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> assignment and such functions. Note that Writeable = <code>False</code> will not prevent you from changing value internally, by <a class=\"normal\" href=\"CastleScript.TCasScriptValue.html#AssignValue\">AssignValue</a> or changin Value property directly (that would be too uncomfortable). ", "tags": "", "loc": "CastleScript.TCasScriptValue.html#Writeable"},
     {"title": "CastleScript.TCasScriptValue.OwnedByParentExpression", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptValue.html#OwnedByParentExpression"},
     {"title": "CastleScript.TCasScriptValue.Name", "text": " Named value can be recognized in expressions by <a class=\"normal\" href=\"CastleScriptParser.html\">CastleScriptParser</a>. ", "tags": "", "loc": "CastleScript.TCasScriptValue.html#Name"},
     {"title": "CastleScript.TCasScriptValue.ValueAssigned", "text": " You can reset it at any time to <code>False</code>.  <p>This allows the caller to know which variables were assigned during script execution, which is useful if changes to <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> variables should be propagated to some other things after the script finished execution. This is essential for behavior in VRML/X3D Script node.  <p>Descendants note: you have to set this to <code>True</code> in SetValue. ", "tags": "", "loc": "CastleScript.TCasScriptValue.html#ValueAssigned"},
     {"title": "CastleScript.TCasScriptValueList", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptValueList.html"},
     {"title": "CastleScript.TCasScriptValueList.AddArray", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptValueList.html#AddArray"},
     {"title": "CastleScript.TCasScriptValueList.FindName", "text": " <code>Nil</code> if not found.    ", "tags": "", "loc": "CastleScript.TCasScriptValueList.html#FindName"},
     {"title": "CastleScript.TCasScriptParameterValue", "text": " This poses itself as a <a class=\"normal\" href=\"CastleScript.TCasScriptValue.html\">TCasScriptValue</a> descendant, and it has working <a class=\"normal\" href=\"CastleScript.TCasScriptParameterValue.html#AssignValue\">AssignValue</a> and everything else. This way it can be used in &quot;Variables&quot; list for various <a class=\"normal\" href=\"CastleScriptParser.html\">CastleScriptParser</a> functions.  <p>Except it's cheating: it doesn't actually store the value. Instead, it has <a class=\"normal\" href=\"CastleScript.TCasScriptParameterValue.html#SourceValue\">SourceValue</a> property that is used when doing <a class=\"normal\" href=\"CastleScript.TCasScriptParameterValue.html#AssignValue\">AssignValue</a>. So <a class=\"normal\" href=\"CastleScript.TCasScriptParameterValue.html#AssignValue\">AssignValue</a> is handled by SourceValue.AssignValue, and Execute is handled by SourceValue.Execute, and so reading/writing this works.  <p>The advantage: the exact type of function parameter is not known, and still we can parse the function expression. This is crucial for parser implementation: when parsing you need to create <code>TCasScriptParameterValue</code> instance, but you don't know actual type of parameter that will be passed here. ", "tags": "", "loc": "CastleScript.TCasScriptParameterValue.html"},
     {"title": "CastleScript.TCasScriptParameterValue.CoreExecute", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptParameterValue.html#CoreExecute"},
     {"title": "CastleScript.TCasScriptParameterValue.AssignValue", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptParameterValue.html#AssignValue"},
     {"title": "CastleScript.TCasScriptParameterValue.SourceValue", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptParameterValue.html#SourceValue"},
     {"title": "CastleScript.TCasScriptInteger", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptInteger.html"},
     {"title": "CastleScript.TCasScriptInteger.Create", "text": " Note that the inherited constructor (without AValue parameter) is also fine to use, it will set value to zero.    ", "tags": "", "loc": "CastleScript.TCasScriptInteger.html#Create"},
     {"title": "CastleScript.TCasScriptInteger.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptInteger.html#Create"},
     {"title": "CastleScript.TCasScriptInteger.Destroy", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptInteger.html#Destroy"},
     {"title": "CastleScript.TCasScriptInteger.AssignValue", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptInteger.html#AssignValue"},
     {"title": "CastleScript.TCasScriptInteger.PromoteToFloat", "text": "  <p>This object is kept and owned by this <a class=\"normal\" href=\"CastleScript.TCasScriptInteger.html\">TCasScriptInteger</a> instance, so it's valid as long as this <a class=\"normal\" href=\"CastleScript.TCasScriptInteger.html\">TCasScriptInteger</a> instance is valid. This allows you to safely use this (since you may have to return <code>PromoteToFloat</code> as return value of some Execute expressions, so it desirable that it's valid object reference).    ", "tags": "", "loc": "CastleScript.TCasScriptInteger.html#PromoteToFloat"},
     {"title": "CastleScript.TCasScriptInteger.Value", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptInteger.html#Value"},
     {"title": "CastleScript.TCasScriptFloat", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptFloat.html"},
     {"title": "CastleScript.TCasScriptFloat.Create", "text": " Note that the inherited constructor (without AValue parameter) is also fine to use, it will set value to zero.    ", "tags": "", "loc": "CastleScript.TCasScriptFloat.html#Create"},
     {"title": "CastleScript.TCasScriptFloat.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFloat.html#Create"},
     {"title": "CastleScript.TCasScriptFloat.AssignValue", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFloat.html#AssignValue"},
     {"title": "CastleScript.TCasScriptFloat.Value", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptFloat.html#Value"},
     {"title": "CastleScript.TCasScriptBoolean", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptBoolean.html"},
     {"title": "CastleScript.TCasScriptBoolean.Create", "text": " Note that the inherited constructor (without AValue parameter) is also fine to use, it will set value to false.    ", "tags": "", "loc": "CastleScript.TCasScriptBoolean.html#Create"},
     {"title": "CastleScript.TCasScriptBoolean.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptBoolean.html#Create"},
     {"title": "CastleScript.TCasScriptBoolean.AssignValue", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptBoolean.html#AssignValue"},
     {"title": "CastleScript.TCasScriptBoolean.Value", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptBoolean.html#Value"},
     {"title": "CastleScript.TCasScriptString", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptString.html"},
     {"title": "CastleScript.TCasScriptString.Create", "text": " Note that the inherited constructor (without AValue parameter) is also fine to use, it will set value to ''.    ", "tags": "", "loc": "CastleScript.TCasScriptString.html#Create"},
     {"title": "CastleScript.TCasScriptString.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptString.html#Create"},
     {"title": "CastleScript.TCasScriptString.AssignValue", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptString.html#AssignValue"},
     {"title": "CastleScript.TCasScriptString.Value", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptString.html#Value"},
     {"title": "CastleScript.TCasScriptSearchArgumentClassesCache", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptSearchArgumentClassesCache.html"},
     {"title": "CastleScript.TCasScriptSearchArgumentClassesCache.IsCache", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptSearchArgumentClassesCache.html#IsCache"},
     {"title": "CastleScript.TCasScriptSearchArgumentClassesCache.QueryHandlersByArgument", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptSearchArgumentClassesCache.html#QueryHandlersByArgument"},
     {"title": "CastleScript.TCasScriptSearchArgumentClassesCache.QueryArgumentClasses", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptSearchArgumentClassesCache.html#QueryArgumentClasses"},
     {"title": "CastleScript.TCasScriptSearchArgumentClassesCache.Answer", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptSearchArgumentClassesCache.html#Answer"},
     {"title": "CastleScript.TCasScriptSearchArgumentClassesCache.AnswerArgumentIndex", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptSearchArgumentClassesCache.html#AnswerArgumentIndex"},
     {"title": "CastleScript.TCasScriptSearchArgumentClassesCache.AnswerHandler", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptSearchArgumentClassesCache.html#AnswerHandler"},
     {"title": "CastleScript.TCasScriptFunction", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html"},
     {"title": "CastleScript.TCasScriptFunction.CheckArguments", "text": " Also, right now this gets FunctionHandlersByArgument (this way we don't have to search it at each TCasScriptFunction.Execute call, so TCasScriptFunction.Execute may work much faster).     ECasScriptFunctionArgumentsError on invalid Args passed to function.", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#CheckArguments"},
     {"title": "CastleScript.TCasScriptFunction.CoreExecute", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#CoreExecute"},
     {"title": "CastleScript.TCasScriptFunction.Create", "text": " AArgs list contents is copied, i.e. AArgs refence is not stored or freed by <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a>. But items on AArags are not copied recursively, we copy references from AArags items, and so we become their owners.  <p>    ECasScriptFunctionArgumentsError if you specified invalid number of arguments for this function.", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#Create"},
     {"title": "CastleScript.TCasScriptFunction.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#Create"},
     {"title": "CastleScript.TCasScriptFunction.Destroy", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#Destroy"},
     {"title": "CastleScript.TCasScriptFunction.Name", "text": " This is possibly with spaces, parenthesis and other funny characters. It will be used in error messages and such to describe this function.  <p>Default implementation in this class simply returns <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html#ShortName\">ShortName</a>. This should be suitable for most &quot;norma&quot; functions.    ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#Name"},
     {"title": "CastleScript.TCasScriptFunction.ShortName", "text": " This is the name of the function for use in expressions like &quot;function_name(arg_1, arg_2 ... , arg_n)&quot;.  <p>This can be an empty string ('') if no explicit name for this function exists. This is useful for operators, which are implemented just like normal functions (a descendant of <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a>), but with a special support from parser (e.g. to turn &quot;x + b&quot; into a call to the <a class=\"normal\" href=\"CastleScriptCoreFunctions.TCasScriptAdd.html\">TCasScriptAdd</a> function).    ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#ShortName"},
     {"title": "CastleScript.TCasScriptFunction.InfixOperatorName", "text": "  <p>Empty string ('') if no such name for this function. This is returned by default implementation of this in this class.  <p>This does require cooperation from the parser to actually work, that is you cannot simply define new operators by registering new <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a> with <code>InfixOperatorName</code> &lt;&gt; ''. For now.  <p>Note that at least one of <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html#ShortName\">ShortName</a> and <code>InfixOperatorName</code> must not be empty.  <p>The only exception is the <a class=\"normal\" href=\"CastleScriptCoreFunctions.TCasScriptNegate.html\">TCasScriptNegate</a> function, that is neither infix operator nor a usual function that must be specified as &quot;function_name(arguments)&quot;. So this is an exception, and if there will be a need, I shall fix this (probably by introducing some third field, like PrefixOperatorName ?)  <p>Note 2 things:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> Function that can be used as infix operator (i.e. has <code>InfixOperatorName</code> &lt;&gt; '') is not necessary binary operator, i.e. <code>InfixOperatorName</code> &lt;&gt; '' does not determine the value of ArgsCount. This way I was able to define infix operators +, -, * etc. that take any number of arguments and operators like &circ; and &gt; that always take 2 arguments.</p></li>   <li value=\"2\"><p> Function may have both <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html#ShortName\">ShortName</a> &lt;&gt; '' and <code>InfixOperatorName</code> &lt;&gt; ''. E.g. <a class=\"normal\" href=\"CastleScriptCoreFunctions.TCasScriptPower.html\">TCasScriptPower</a> can be used as &quot;Power(3, 1.5)&quot; or &quot;3 &circ; 1.5&quot;.</p></li> </ol>  <p>    ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#InfixOperatorName"},
     {"title": "CastleScript.TCasScriptFunction.GreedyArgumentsCalculation", "text": "  <p>If = -1 (default value returned by implementation in this class) then all arguments are greedily calculated, which simply means that all arguments are calculated before executing function handler. This is the usual and expected behavior of normal functions. It's also a prerequisite for most of overloaded things to work, since we need to know types of <i>calculated</i> arguments (<a class=\"normal\" href=\"CastleScript.TCasScriptValue.html\">TCasScriptValue</a> classes) before we choose overloaded handler for function.  <p>If this is &gt;= 0, then arguments with index &gt;= of this will not be calculated before handler execution. Since their type is unknown, they will match any type in handler's ArgumentClasses. Your handler will receive <code>Nil</code> in their places, and is responsible for calling their Execute on it's own if needed.  <p>This is particularly suited for implementing control-flow instructions, like &quot;if&quot; and &quot;while&quot;, as normal functions inside <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a>. For example, &quot;if&quot; will have <code>GreedyArgumentsCalculation</code> = 1, so the first argument (condition) will be calculated, but the execution of 2nd or 3rd argument (&quot;then&quot; code or &quot;else&quot; code) will be left to the handler.    ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#GreedyArgumentsCalculation"},
     {"title": "CastleScript.TCasScriptFunction.ArgumentMustBeAssignable", "text": "  <p>Default implementation in <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a> just returns <code>False</code> always. If you're making a function that changes it's argument (like assignment operator, or vector_set, array_set and such) you want to override this.  <p>This is actually checked by <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html#CheckArguments\">CheckArguments</a>, called from constructors.    ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#ArgumentMustBeAssignable"},
     {"title": "CastleScript.TCasScriptFunction.Args", "text": " Don't modify this list after function is created (although you can modify values inside arguments). ", "tags": "", "loc": "CastleScript.TCasScriptFunction.html#Args"},
     {"title": "CastleScript.TCasScriptSequence", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptSequence.html"},
     {"title": "CastleScript.TCasScriptSequence.Name", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptSequence.html#Name"},
     {"title": "CastleScript.TCasScriptSequence.ShortName", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptSequence.html#ShortName"},
     {"title": "CastleScript.TCasScriptSequence.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptSequence.html#InfixOperatorName"},
     {"title": "CastleScript.TCasScriptAssignment", "text": " This is a special function, that must have <a class=\"normal\" href=\"CastleScript.TCasScriptValue.html\">TCasScriptValue</a> (with Writeable = true) as it's 1st argument. ", "tags": "", "loc": "CastleScript.TCasScriptAssignment.html"},
     {"title": "CastleScript.TCasScriptAssignment.Name", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptAssignment.html#Name"},
     {"title": "CastleScript.TCasScriptAssignment.ShortName", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptAssignment.html#ShortName"},
     {"title": "CastleScript.TCasScriptAssignment.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptAssignment.html#InfixOperatorName"},
     {"title": "CastleScript.TCasScriptAssignment.ArgumentMustBeAssignable", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptAssignment.html#ArgumentMustBeAssignable"},
     {"title": "CastleScript.TCasScriptIf", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptIf.html"},
     {"title": "CastleScript.TCasScriptIf.ShortName", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptIf.html#ShortName"},
     {"title": "CastleScript.TCasScriptIf.GreedyArgumentsCalculation", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptIf.html#GreedyArgumentsCalculation"},
     {"title": "CastleScript.TCasScriptWhen", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptWhen.html"},
     {"title": "CastleScript.TCasScriptWhen.ShortName", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptWhen.html#ShortName"},
     {"title": "CastleScript.TCasScriptWhen.GreedyArgumentsCalculation", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptWhen.html#GreedyArgumentsCalculation"},
     {"title": "CastleScript.TCasScriptWhile", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptWhile.html"},
     {"title": "CastleScript.TCasScriptWhile.ShortName", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptWhile.html#ShortName"},
     {"title": "CastleScript.TCasScriptWhile.GreedyArgumentsCalculation", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptWhile.html#GreedyArgumentsCalculation"},
     {"title": "CastleScript.TCasScriptFor", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptFor.html"},
     {"title": "CastleScript.TCasScriptFor.ShortName", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFor.html#ShortName"},
     {"title": "CastleScript.TCasScriptFor.GreedyArgumentsCalculation", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFor.html#GreedyArgumentsCalculation"},
     {"title": "CastleScript.TCasScriptFor.ArgumentMustBeAssignable", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFor.html#ArgumentMustBeAssignable"},
     {"title": "CastleScript.TCasScriptRegisteredHandler", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptRegisteredHandler.html"},
     {"title": "CastleScript.TCasScriptRegisteredHandler.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptRegisteredHandler.html#Create"},
     {"title": "CastleScript.TCasScriptRegisteredHandler.Handler", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptRegisteredHandler.html#Handler"},
     {"title": "CastleScript.TCasScriptRegisteredHandler.FunctionClass", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptRegisteredHandler.html#FunctionClass"},
     {"title": "CastleScript.TCasScriptRegisteredHandler.ArgumentClasses", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptRegisteredHandler.html#ArgumentClasses"},
     {"title": "CastleScript.TCasScriptRegisteredHandler.VariableArgumentsCount", "text": "  <p>If yes, then the last argument class may be repeated any number of times (but must occur at least once). That is, the <a class=\"normal\" href=\"CastleScript.TCasScriptRegisteredHandler.html#ArgumentClasses\">ArgumentClasses</a> array dictates the required arguments, and more arguments are allowed. Note that this means that at least one argument must be allowed (we have to know the argument class that can be repeated at the end), otherwise the handler will not be able to receive variable number of arguments anyway. ", "tags": "", "loc": "CastleScript.TCasScriptRegisteredHandler.html#VariableArgumentsCount"},
     {"title": "CastleScript.TCasScriptFunctionHandlers", "text": " You can think of this as a table that has a handler for each possible <a class=\"normal\" href=\"CastleScript.TCasScriptValue.html\">TCasScriptValue</a> sequence and <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a> combination.  <p>The idea is to allow programmer to extend KambiScipt by  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Defining new types of values for <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a>: add new <a class=\"normal\" href=\"CastleScript.TCasScriptValue.html\">TCasScriptValue</a> class, and create handlers for known functions to handle this type.  <p>It may be comfortable to place these handlers as private methods within your new <a class=\"normal\" href=\"CastleScript.TCasScriptValue.html\">TCasScriptValue</a> descendant, although this is your private decision.</p></li>   <li value=\"2\"><p>Defining new functions for <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a>: add new <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a> class, and create handlers for known values to be handled by this function.  <p>It may be comfortable to place these handlers as private methods within your new <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a> descendant, although this is your private decision.</p></li> </ol>  <p>  <p>You have a guarantee that every registered here Handler will be called only with AFunction of registstered type and all Arguments matching the array of registered types and satisfying VariableArgumentsCount setting.  <p>As a bonus, this also provides a list of all usable function classes. That's because you have to register at least one handler for each <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a> descendant to make this function actually usable, so we know about it here. ", "tags": "", "loc": "CastleScript.TCasScriptFunctionHandlers.html"},
     {"title": "CastleScript.TCasScriptFunctionHandlers.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFunctionHandlers.html#Create"},
     {"title": "CastleScript.TCasScriptFunctionHandlers.Destroy", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFunctionHandlers.html#Destroy"},
     {"title": "CastleScript.TCasScriptFunctionHandlers.RegisterHandler", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptFunctionHandlers.html#RegisterHandler"},
     {"title": "CastleScript.TCasScriptFunctionHandlers.SearchFunctionShortName", "text": " Returns <code>Nil</code> if not found.    ", "tags": "", "loc": "CastleScript.TCasScriptFunctionHandlers.html#SearchFunctionShortName"},
     {"title": "CastleScript.ECasScriptFunctionArgumentsError", "text": " ", "tags": "", "loc": "CastleScript.ECasScriptFunctionArgumentsError.html"},
     {"title": "CastleScript.ECasScriptFunctionNoHandler", "text": " ", "tags": "", "loc": "CastleScript.ECasScriptFunctionNoHandler.html"},
     {"title": "CastleScript.TCasScriptUserFunction", "text": "  <p>Not to be confused with <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a>: <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a> is an internal, built-in function or operator. This class represents functions defined by user. ", "tags": "", "loc": "CastleScript.TCasScriptUserFunction.html"},
     {"title": "CastleScript.TCasScriptUserFunction.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptUserFunction.html#Create"},
     {"title": "CastleScript.TCasScriptUserFunction.Destroy", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptUserFunction.html#Destroy"},
     {"title": "CastleScript.TCasScriptUserFunction.Name", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptUserFunction.html#Name"},
     {"title": "CastleScript.TCasScriptUserFunction.Parameters", "text": "  <p>Note that they are also referenced inside function Expression, so you simply change them to set value of this parameter within whole function body.  <p>These are always fresh variables, not referenced anywhere outside of Body. This means that they are owned (always, regardless of OwnedByParentExpression) by this class.  <p>They must always be of <a class=\"normal\" href=\"CastleScript.TCasScriptParameterValue.html\">TCasScriptParameterValue</a> class. ", "tags": "", "loc": "CastleScript.TCasScriptUserFunction.html#Parameters"},
     {"title": "CastleScript.TCasScriptUserFunction.Body", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptUserFunction.html#Body"},
     {"title": "CastleScript.TCasScriptUserFunctionList", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptUserFunctionList.html"},
     {"title": "CastleScript.TCasScriptUserFunctionList.IndexOfName", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptUserFunctionList.html#IndexOfName"},
     {"title": "CastleScript.ECasScriptMissingFunction", "text": " ", "tags": "", "loc": "CastleScript.ECasScriptMissingFunction.html"},
     {"title": "CastleScript.TCasScriptProgram", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptProgram.html"},
     {"title": "CastleScript.TCasScriptProgram.Create", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptProgram.html#Create"},
     {"title": "CastleScript.TCasScriptProgram.Destroy", "text": "    ", "tags": "", "loc": "CastleScript.TCasScriptProgram.html#Destroy"},
     {"title": "CastleScript.TCasScriptProgram.ExecuteFunction", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Looks for given FunctionName.  <p>IgnoreMissingFunction says what to do in case of missing function: if true, it will be simply ignored (<code>ExecuteFunction</code> will silently do nothng). If false (default) then we will raise exception <a class=\"normal\" href=\"CastleScript.ECasScriptMissingFunction.html\">ECasScriptMissingFunction</a>.</p></li>   <li><p>Sets function parameters to given values (number of parameters must match, otherwise <a class=\"normal\" href=\"CastleScript.ECasScriptError.html\">ECasScriptError</a>). Values from your parameters are set as our parameters <a class=\"normal\" href=\"CastleScript.TCasScriptParameterValue.html#SourceValue\">TCasScriptParameterValue.SourceValue</a>, so script can read and write your values.</p></li>   <li><p>Finally executes function body.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleScript.TCasScriptProgram.html#ExecuteFunction"},
     {"title": "CastleScript.TCasScriptProgram.Functions", "text": " ", "tags": "", "loc": "CastleScript.TCasScriptProgram.html#Functions"},
     {"title": "CastleScript.TCasScriptProgram.Environment", "text": "  <p>This will be created and is owned by this <a class=\"normal\" href=\"CastleScript.TCasScriptProgram.html\">TCasScriptProgram</a> instance. You should take care to copy this reference to all expressions within this program (for example <a class=\"normal\" href=\"CastleScriptParser.html#ParseProgram\">ParseProgram</a> does this), this way all expressions share the same Environment instance. ", "tags": "", "loc": "CastleScript.TCasScriptProgram.html#Environment"},
     {"title": "CastleScript.CreateValueIfNeeded", "text": " If Value is not assigned, or is not exactly of NeededClass, it will be freed and new will be created.    ", "tags": "", "loc": "CastleScript.html#CreateValueIfNeeded"},
     {"title": "CastleScript.EKamAssignValueError", "text": " ", "tags": "", "loc": "CastleScript.html#EKamAssignValueError"},
     {"title": "CastleScript.TCasScriptMessage", "text": "    ", "tags": "", "loc": "CastleScript.html#TCasScriptMessage"},
     {"title": "CastleScript.TCasScriptValueClass", "text": " ", "tags": "", "loc": "CastleScript.html#TCasScriptValueClass"},
     {"title": "CastleScript.TCasScriptValueClassArray", "text": " ", "tags": "", "loc": "CastleScript.html#TCasScriptValueClassArray"},
     {"title": "CastleScript.TCasScriptValuesArray", "text": " ", "tags": "", "loc": "CastleScript.html#TCasScriptValuesArray"},
     {"title": "CastleScript.TCasScriptFunctionClass", "text": " ", "tags": "", "loc": "CastleScript.html#TCasScriptFunctionClass"},
     {"title": "CastleScript.TCasScriptFunctionHandler", "text": " Place result in AResult.  <p>The current function is also passed here, although usually you don't need it (you already get a list of calculated Arguments, and you should register different procedures for different <a class=\"normal\" href=\"CastleScript.TCasScriptFunction.html\">TCasScriptFunction</a> classes, so you know what operation on arguments should be done). For functions when GreedyArgumentsCalculation &gt;= 0, it may be useful to directly access AFunction.Args.  <p>If needed, previous value of AResult should be freed and new created. If current AResult is &lt;&gt; nil and it's of appropriate class, you may also reuse it and only change it's fields (this is helpful, to avoid many creations/destroying of class instances while calculating an expression many times). <a class=\"normal\" href=\"CastleScript.html#CreateValueIfNeeded\">CreateValueIfNeeded</a> may be helpful for implementing this.    ", "tags": "", "loc": "CastleScript.html#TCasScriptFunctionHandler"},
     {"title": "CastleScript.FunctionHandlers", "text": " ", "tags": "", "loc": "CastleScript.html#FunctionHandlers"},
     {"title": "CastleScript.OnScriptMessage", "text": " If not assigned, we will use <a class=\"normal\" href=\"CastleLog.html#WritelnLog\">CastleLog.WritelnLog</a>. ", "tags": "", "loc": "CastleScript.html#OnScriptMessage"},
     {"title": "CastleScriptArrays", "text": " ", "tags": "", "loc": "CastleScriptArrays.html"},
     {"title": "CastleScriptArrays.TCasScriptArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArray.html"},
     {"title": "CastleScriptArrays.TCasScriptArray.Create", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArray.html#Create"},
     {"title": "CastleScriptArrays.TCasScriptArray.Create", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArray.html#Create"},
     {"title": "CastleScriptArrays.TCasScriptArray.Destroy", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArray.html#Destroy"},
     {"title": "CastleScriptArrays.TCasScriptArray.AssignValue", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArray.html#AssignValue"},
     {"title": "CastleScriptArrays.TCasScriptArray.Value", "text": " Assigning here makes a <i>copy</i> of the array. ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArray.html#Value"},
     {"title": "CastleScriptArrays.TCasScriptLongIntArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptLongIntArray.html"},
     {"title": "CastleScriptArrays.TCasScriptSingleArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptSingleArray.html"},
     {"title": "CastleScriptArrays.TCasScriptDoubleArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptDoubleArray.html"},
     {"title": "CastleScriptArrays.TCasScriptBooleanArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptBooleanArray.html"},
     {"title": "CastleScriptArrays.TCasScriptStringArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptStringArray.html"},
     {"title": "CastleScriptArrays.TCasScriptVec2fArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptVec2fArray.html"},
     {"title": "CastleScriptArrays.TCasScriptVec3fArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptVec3fArray.html"},
     {"title": "CastleScriptArrays.TCasScriptVec4fArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptVec4fArray.html"},
     {"title": "CastleScriptArrays.TCasScriptVec2dArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptVec2dArray.html"},
     {"title": "CastleScriptArrays.TCasScriptVec3dArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptVec3dArray.html"},
     {"title": "CastleScriptArrays.TCasScriptVec4dArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptVec4dArray.html"},
     {"title": "CastleScriptArrays.TCasScriptMatrix3dArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptMatrix3dArray.html"},
     {"title": "CastleScriptArrays.TCasScriptMatrix4dArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptMatrix4dArray.html"},
     {"title": "CastleScriptArrays.TCasScriptMatrix3fArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptMatrix3fArray.html"},
     {"title": "CastleScriptArrays.TCasScriptMatrix4fArray", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptMatrix4fArray.html"},
     {"title": "CastleScriptArrays.TCasScriptArrayFun", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArrayFun.html"},
     {"title": "CastleScriptArrays.TCasScriptArrayFun.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArrayFun.html#ShortName"},
     {"title": "CastleScriptArrays.TCasScriptArrayD", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArrayD.html"},
     {"title": "CastleScriptArrays.TCasScriptArrayD.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArrayD.html#ShortName"},
     {"title": "CastleScriptArrays.TCasScriptArrayGetCount", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArrayGetCount.html"},
     {"title": "CastleScriptArrays.TCasScriptArrayGetCount.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArrayGetCount.html#ShortName"},
     {"title": "CastleScriptArrays.TCasScriptArraySetCount", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArraySetCount.html"},
     {"title": "CastleScriptArrays.TCasScriptArraySetCount.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArraySetCount.html#ShortName"},
     {"title": "CastleScriptArrays.TCasScriptArraySetCount.ArgumentMustBeAssignable", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArraySetCount.html#ArgumentMustBeAssignable"},
     {"title": "CastleScriptArrays.TCasScriptArrayGet", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArrayGet.html"},
     {"title": "CastleScriptArrays.TCasScriptArrayGet.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArrayGet.html#ShortName"},
     {"title": "CastleScriptArrays.TCasScriptArraySet", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArraySet.html"},
     {"title": "CastleScriptArrays.TCasScriptArraySet.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArraySet.html#ShortName"},
     {"title": "CastleScriptArrays.TCasScriptArraySet.ArgumentMustBeAssignable", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptArraySet.html#ArgumentMustBeAssignable"},
     {"title": "CastleScriptArrays.TCasScriptCatmullRomSpline", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptCatmullRomSpline.html"},
     {"title": "CastleScriptArrays.TCasScriptCatmullRomSpline.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptCatmullRomSpline.html#ShortName"},
     {"title": "CastleScriptArrays.TCasScriptHermiteSpline", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptHermiteSpline.html"},
     {"title": "CastleScriptArrays.TCasScriptHermiteSpline.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptHermiteSpline.html#ShortName"},
     {"title": "CastleScriptArrays.TCasScriptHermiteTenseSpline", "text": " ", "tags": "", "loc": "CastleScriptArrays.TCasScriptHermiteTenseSpline.html"},
     {"title": "CastleScriptArrays.TCasScriptHermiteTenseSpline.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptArrays.TCasScriptHermiteTenseSpline.html#ShortName"},
     {"title": "CastleScriptCoreFunctions", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAdd", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAdd.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAdd.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAdd.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAdd.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAdd.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAdd.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAdd.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSubtract", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSubtract.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSubtract.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSubtract.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSubtract.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSubtract.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSubtract.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSubtract.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptMultiply", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptMultiply.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptMultiply.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptMultiply.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptMultiply.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptMultiply.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptMultiply.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptMultiply.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptDivide", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptDivide.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptDivide.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptDivide.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptDivide.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptDivide.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptDivide.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptDivide.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNegate", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNegate.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNegate.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNegate.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNegate.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNegate.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptModulo", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptModulo.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptModulo.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptModulo.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptModulo.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptModulo.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptModulo.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptModulo.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSin", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSin.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSin.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSin.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSin.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSin.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCos", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCos.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCos.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCos.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCos.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCos.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptTan", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptTan.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptTan.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptTan.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptTan.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptTan.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCotan", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCotan.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCotan.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCotan.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCotan.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCotan.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcSin", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcSin.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcSin.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcSin.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcSin.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcSin.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcCos", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcCos.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcCos.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcCos.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcCos.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcCos.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcTan", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcTan.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcTan.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcTan.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcTan.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcTan.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcCotan", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcCotan.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcCotan.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcCotan.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptArcCotan.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptArcCotan.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSinh", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSinh.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSinh.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSinh.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSinh.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSinh.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCosh", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCosh.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCosh.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCosh.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCosh.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCosh.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptTanh", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptTanh.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptTanh.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptTanh.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptTanh.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptTanh.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCotanh", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCotanh.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCotanh.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCotanh.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCotanh.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCotanh.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLog2", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLog2.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLog2.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLog2.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLog2.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLog2.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLn", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLn.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLn.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLn.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLn.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLn.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLog", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLog.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLog.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLog.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLog.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLog.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptPower2", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptPower2.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptPower2.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptPower2.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptPower2.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptPower2.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptExp", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptExp.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptExp.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptExp.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptExp.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptExp.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptPower", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptPower.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptPower.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptPower.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptPower.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptPower.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptPower.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptPower.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSqr", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSqr.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSqr.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSqr.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSqr.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSqr.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSqrt", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSqrt.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSqrt.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSqrt.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSqrt.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSqrt.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptMax", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptMax.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptMax.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptMax.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptMin", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptMin.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptMin.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptMin.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSgn", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSgn.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSgn.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSgn.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptSgn.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptSgn.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAbs", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAbs.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAbs.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAbs.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAbs.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAbs.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCeil", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCeil.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCeil.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCeil.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptFloor", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptFloor.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptFloor.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptFloor.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptRound", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptRound.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptRound.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptRound.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptGreater", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptGreater.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptGreater.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptGreater.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptGreater.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptGreater.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptGreater.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptGreater.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLesser", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLesser.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLesser.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLesser.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLesser.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLesser.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLesser.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLesser.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptGreaterEq", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptGreaterEq.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptGreaterEq.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptGreaterEq.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptGreaterEq.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptGreaterEq.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptGreaterEq.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptGreaterEq.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLesserEq", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLesserEq.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLesserEq.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLesserEq.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLesserEq.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLesserEq.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLesserEq.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLesserEq.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptEqual", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptEqual.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptEqual.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptEqual.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptEqual.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptEqual.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptEqual.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptEqual.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNotEqual", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNotEqual.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNotEqual.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNotEqual.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNotEqual.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNotEqual.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNotEqual.InfixOperatorName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNotEqual.html#InfixOperatorName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptOr", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptOr.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptOr.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptOr.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptOr.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptOr.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAnd", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAnd.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAnd.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAnd.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptAnd.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptAnd.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNot", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNot.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNot.Name", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNot.html#Name"},
     {"title": "CastleScriptCoreFunctions.TCasScriptNot.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptNot.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptInt", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptInt.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptInt.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptInt.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptFloatFun", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptFloatFun.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptFloatFun.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptFloatFun.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptBool", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptBool.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptBool.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptBool.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptStringFun", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptStringFun.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptStringFun.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptStringFun.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptWriteln", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptWriteln.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptWriteln.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptWriteln.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCharacterFromCode", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCharacterFromCode.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptCharacterFromCode.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptCharacterFromCode.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptRandom", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptRandom.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptRandom.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptRandom.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLerp", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLerp.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptLerp.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptLerp.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptShortcut", "text": " ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptShortcut.html"},
     {"title": "CastleScriptCoreFunctions.TCasScriptShortcut.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptShortcut.html#ShortName"},
     {"title": "CastleScriptCoreFunctions.TCasScriptShortcut.Handle", "text": "    ", "tags": "", "loc": "CastleScriptCoreFunctions.TCasScriptShortcut.html#Handle"},
     {"title": "CastleScriptImages", "text": " ", "tags": "", "loc": "CastleScriptImages.html"},
     {"title": "CastleScriptImages.TCasScriptImage", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImage.html"},
     {"title": "CastleScriptImages.TCasScriptImage.Create", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImage.html#Create"},
     {"title": "CastleScriptImages.TCasScriptImage.Create", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImage.html#Create"},
     {"title": "CastleScriptImages.TCasScriptImage.Destroy", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImage.html#Destroy"},
     {"title": "CastleScriptImages.TCasScriptImage.AssignValue", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImage.html#AssignValue"},
     {"title": "CastleScriptImages.TCasScriptImage.Value", "text": " Assigning here makes a <i>copy</i> of the image. ", "tags": "", "loc": "CastleScriptImages.TCasScriptImage.html#Value"},
     {"title": "CastleScriptImages.TCasScriptImageFun", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageFun.html"},
     {"title": "CastleScriptImages.TCasScriptImageFun.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageFun.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageLoad", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageLoad.html"},
     {"title": "CastleScriptImages.TCasScriptImageLoad.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageLoad.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageWidth", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageWidth.html"},
     {"title": "CastleScriptImages.TCasScriptImageWidth.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageWidth.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageHeight", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageHeight.html"},
     {"title": "CastleScriptImages.TCasScriptImageHeight.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageHeight.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageComponents", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageComponents.html"},
     {"title": "CastleScriptImages.TCasScriptImageComponents.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageComponents.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageGet", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageGet.html"},
     {"title": "CastleScriptImages.TCasScriptImageGet.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageGet.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageGetColor", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageGetColor.html"},
     {"title": "CastleScriptImages.TCasScriptImageGetColor.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageGetColor.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageGetAlpha", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageGetAlpha.html"},
     {"title": "CastleScriptImages.TCasScriptImageGetAlpha.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageGetAlpha.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageSet", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageSet.html"},
     {"title": "CastleScriptImages.TCasScriptImageSet.CheckArguments", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageSet.html#CheckArguments"},
     {"title": "CastleScriptImages.TCasScriptImageSet.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageSet.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageSetColor", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageSetColor.html"},
     {"title": "CastleScriptImages.TCasScriptImageSetColor.CheckArguments", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageSetColor.html#CheckArguments"},
     {"title": "CastleScriptImages.TCasScriptImageSetColor.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageSetColor.html#ShortName"},
     {"title": "CastleScriptImages.TCasScriptImageSetAlpha", "text": " ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageSetAlpha.html"},
     {"title": "CastleScriptImages.TCasScriptImageSetAlpha.CheckArguments", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageSetAlpha.html#CheckArguments"},
     {"title": "CastleScriptImages.TCasScriptImageSetAlpha.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptImages.TCasScriptImageSetAlpha.html#ShortName"},
     {"title": "CastleScriptLexer", "text": "  <p>For specification of tokens that this lexer understands, see documentation of <a class=\"normal\" href=\"CastleScriptParser.html\">CastleScriptParser</a> unit. ", "tags": "", "loc": "CastleScriptLexer.html"},
     {"title": "CastleScriptLexer.TCasScriptLexer", "text": " ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html"},
     {"title": "CastleScriptLexer.TCasScriptLexer.NextToken", "text": "  <p>When <a class=\"normal\" href=\"CastleScriptLexer.TCasScriptLexer.html#Token\">Token</a> is <a class=\"normal\" href=\"CastleScriptLexer.html#tokEnd\">tokEnd</a>, then <code>NextToken</code> doesn't do anything, i.e. <a class=\"normal\" href=\"CastleScriptLexer.TCasScriptLexer.html#Token\">Token</a> will remain <a class=\"normal\" href=\"CastleScriptLexer.html#tokEnd\">tokEnd</a> forever.  <p>    ECasScriptLexerError ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#NextToken"},
     {"title": "CastleScriptLexer.TCasScriptLexer.Create", "text": "    ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#Create"},
     {"title": "CastleScriptLexer.TCasScriptLexer.TokenDescription", "text": " Useful mainly for debugging lexer.    ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#TokenDescription"},
     {"title": "CastleScriptLexer.TCasScriptLexer.CheckTokenIs", "text": " This is an utility for parser.  <p>    ECasScriptParserError if current Token doesn't match required Tok.", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#CheckTokenIs"},
     {"title": "CastleScriptLexer.TCasScriptLexer.Token", "text": " ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#Token"},
     {"title": "CastleScriptLexer.TCasScriptLexer.TokenInteger", "text": " ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#TokenInteger"},
     {"title": "CastleScriptLexer.TCasScriptLexer.TokenFloat", "text": " ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#TokenFloat"},
     {"title": "CastleScriptLexer.TCasScriptLexer.TokenString", "text": " ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#TokenString"},
     {"title": "CastleScriptLexer.TCasScriptLexer.TokenBoolean", "text": " ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#TokenBoolean"},
     {"title": "CastleScriptLexer.TCasScriptLexer.TokenFunctionClass", "text": " ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#TokenFunctionClass"},
     {"title": "CastleScriptLexer.TCasScriptLexer.TextPos", "text": " ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#TextPos"},
     {"title": "CastleScriptLexer.TCasScriptLexer.Text", "text": " ", "tags": "", "loc": "CastleScriptLexer.TCasScriptLexer.html#Text"},
     {"title": "CastleScriptLexer.ECasScriptSyntaxError", "text": " ", "tags": "", "loc": "CastleScriptLexer.ECasScriptSyntaxError.html"},
     {"title": "CastleScriptLexer.ECasScriptSyntaxError.Create", "text": "    ", "tags": "", "loc": "CastleScriptLexer.ECasScriptSyntaxError.html#Create"},
     {"title": "CastleScriptLexer.ECasScriptSyntaxError.CreateFmt", "text": "    ", "tags": "", "loc": "CastleScriptLexer.ECasScriptSyntaxError.html#CreateFmt"},
     {"title": "CastleScriptLexer.ECasScriptSyntaxError.LexerTextPos", "text": " We do not copy reference to Lexer since this would be too dangerous in usual situation (you would have to be always sure that you will not access it before you Freed it; too troublesome, usually) ", "tags": "", "loc": "CastleScriptLexer.ECasScriptSyntaxError.html#LexerTextPos"},
     {"title": "CastleScriptLexer.ECasScriptSyntaxError.LexerText", "text": " ", "tags": "", "loc": "CastleScriptLexer.ECasScriptSyntaxError.html#LexerText"},
     {"title": "CastleScriptLexer.ECasScriptLexerError", "text": " ", "tags": "", "loc": "CastleScriptLexer.ECasScriptLexerError.html"},
     {"title": "CastleScriptLexer.ECasScriptParserError", "text": " ", "tags": "", "loc": "CastleScriptLexer.ECasScriptParserError.html"},
     {"title": "CastleScriptLexer.TToken", "text": "  tokEnd    tokInteger Value of constant integer will be in w <a class=\"normal\" href=\"CastleScriptLexer.TCasScriptLexer.html#TokenInteger\">TCasScriptLexer.TokenInteger</a>.   tokFloat Value of constant float will be in w <a class=\"normal\" href=\"CastleScriptLexer.TCasScriptLexer.html#TokenFloat\">TCasScriptLexer.TokenFloat</a>.   tokBoolean Value of constant boolean will be in w <a class=\"normal\" href=\"CastleScriptLexer.TCasScriptLexer.html#TokenBoolean\">TCasScriptLexer.TokenBoolean</a>.   tokString Value of constant string will be in w <a class=\"normal\" href=\"CastleScriptLexer.TCasScriptLexer.html#TokenString\">TCasScriptLexer.TokenString</a>.   tokIdentifier Identifier will be in <a class=\"normal\" href=\"CastleScriptLexer.TCasScriptLexer.html#TokenString\">TCasScriptLexer.TokenString</a>.   tokFuncName Function class of given function will be in <a class=\"normal\" href=\"CastleScriptLexer.TCasScriptLexer.html#TokenFunctionClass\">TCasScriptLexer.TokenFunctionClass</a>.   tokFunctionKeyword    tokMinus    tokPlus    tokMultiply    tokDivide    tokPower    tokModulo    tokGreater    tokLesser    tokGreaterEqual    tokLesserEqual    tokEqual    tokNotEqual    tokLParen    tokRParen    tokLQaren    tokRQaren    tokComma    tokSemicolon    tokAssignment   ", "tags": "", "loc": "CastleScriptLexer.html#TToken"},
     {"title": "CastleScriptParser", "text": "  <p>Can parse whole program in <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> language, is also prepared to parse only a single expression (usefull for cases when I need to input only a mathematical expression, like for glplotter function expression). ", "tags": "", "loc": "CastleScriptParser.html"},
     {"title": "CastleScriptParser.ParseFloatExpression", "text": " The easiest way to evaluate such expression is to call <a class=\"normal\" href=\"CastleScript.TCasScriptExpression.html#AsFloat\">TCasScriptExpression.AsFloat</a> method.  <p>This creates and returns an instance of <a class=\"normal\" href=\"CastleScript.TCasScriptExpression.html\">TCasScriptExpression</a>, that represents parsed tree of expression in S, casted to float. This parses a subset of <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> language, that allows you to define only one expression without any assignments. Also the end result is always casted to the float() type (just like it would be wrapped inside float() function call &mdash; in fact this is exactly what happens.)  <p>The end result is that this is perfect for describing things like function expressions, ideal e.g. for [<a  href=\"http://castle-engine.sourceforge.net/glplotter_and_gen_function.php\">http://castle-engine.sourceforge.net/glplotter_and_gen_function.php</a>].  <p>  <p>  Variables contains a list of named values you want to allow in this expression.  <p>Important: They will all have OwnedByParentExpression set to <code>False</code>, and you will have to free them yourself. That's because given expression may use the same variable more than once (so freeing it twice would cause bugs), or not use it at all (so it will be automatically freed at all).  <p>So setting OwnedByParentExpression and freeing it yourself is the only sensible thing to do.  ECasScriptSyntaxError in case of error when parsing expression.", "tags": "", "loc": "CastleScriptParser.html#ParseFloatExpression"},
     {"title": "CastleScriptParser.ParseIntExpression", "text": " The easiest way to evaluate such expression is to call <a class=\"normal\" href=\"CastleScript.TCasScriptExpression.html#AsInt\">TCasScriptExpression.AsInt</a> method.  <p>See <a class=\"normal\" href=\"CastleScriptParser.html#ParseFloatExpression\">ParseFloatExpression</a> for more details, this procedure is equivalent but it operates on floats.    ", "tags": "", "loc": "CastleScriptParser.html#ParseIntExpression"},
     {"title": "CastleScriptParser.ParseStringExpression", "text": " The easiest way to evaluate such expression is to call <a class=\"normal\" href=\"CastleScript.TCasScriptExpression.html#AsString\">TCasScriptExpression.AsString</a> method.  <p>See <a class=\"normal\" href=\"CastleScriptParser.html#ParseFloatExpression\">ParseFloatExpression</a> for more details, this procedure is equivalent but it operates on strings.    ", "tags": "", "loc": "CastleScriptParser.html#ParseStringExpression"},
     {"title": "CastleScriptParser.ParseBoolExpression", "text": " The easiest way to evaluate such expression is to call <a class=\"normal\" href=\"CastleScript.TCasScriptExpression.html#AsBool\">TCasScriptExpression.AsBool</a> method.  <p>See <a class=\"normal\" href=\"CastleScriptParser.html#ParseFloatExpression\">ParseFloatExpression</a> for more details, this procedure is equivalent but it operates on booleans.    ", "tags": "", "loc": "CastleScriptParser.html#ParseBoolExpression"},
     {"title": "CastleScriptParser.ParseExpression", "text": "    Variables contains a list of named values you want to allow in this expression. See <a class=\"normal\" href=\"CastleScriptParser.html#ParseFloatExpression\">ParseFloatExpression</a> for description.  ECasScriptSyntaxError in case of error when parsing expression.", "tags": "", "loc": "CastleScriptParser.html#ParseExpression"},
     {"title": "CastleScriptParser.ParseConstantFloatExpression", "text": " This can be used as a drop-in replacement for StrToFloat. Takes a string with any constant mathematical expression, according to <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> syntax, parses it and calculates.  <p>    ECasScriptSyntaxError in case of error when parsing expression.", "tags": "", "loc": "CastleScriptParser.html#ParseConstantFloatExpression"},
     {"title": "CastleScriptParser.ParseProgram", "text": "  <p>Variable list works like for <a class=\"normal\" href=\"CastleScriptParser.html#ParseFloatExpression\">ParseFloatExpression</a>, see there for description.  <p>  <p>    ECasScriptSyntaxError in case of error when parsing expression.", "tags": "", "loc": "CastleScriptParser.html#ParseProgram"},
     {"title": "CastleScriptParser.ParseProgram", "text": "    ", "tags": "", "loc": "CastleScriptParser.html#ParseProgram"},
     {"title": "CastleScriptParser.ECasScriptSyntaxError", "text": " ", "tags": "", "loc": "CastleScriptParser.html#ECasScriptSyntaxError"},
     {"title": "CastleScriptVectors", "text": " ", "tags": "", "loc": "CastleScriptVectors.html"},
     {"title": "CastleScriptVectors.TCasScriptVec", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVec.html"},
     {"title": "CastleScriptVectors.TCasScriptVec.AssignValue", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVec.html#AssignValue"},
     {"title": "CastleScriptVectors.TCasScriptVec.Value", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVec.html#Value"},
     {"title": "CastleScriptVectors.TCasScriptVec2f", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVec2f.html"},
     {"title": "CastleScriptVectors.TCasScriptVec3f", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVec3f.html"},
     {"title": "CastleScriptVectors.TCasScriptVec4f", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVec4f.html"},
     {"title": "CastleScriptVectors.TCasScriptVec2d", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVec2d.html"},
     {"title": "CastleScriptVectors.TCasScriptVec3d", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVec3d.html"},
     {"title": "CastleScriptVectors.TCasScriptVec4d", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVec4d.html"},
     {"title": "CastleScriptVectors.TCasScriptMatrix", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrix.html"},
     {"title": "CastleScriptVectors.TCasScriptMatrix.AssignValue", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrix.html#AssignValue"},
     {"title": "CastleScriptVectors.TCasScriptMatrix.Value", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrix.html#Value"},
     {"title": "CastleScriptVectors.TCasScriptMatrix3f", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrix3f.html"},
     {"title": "CastleScriptVectors.TCasScriptMatrix4f", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrix4f.html"},
     {"title": "CastleScriptVectors.TCasScriptMatrix3d", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrix3d.html"},
     {"title": "CastleScriptVectors.TCasScriptMatrix4d", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrix4d.html"},
     {"title": "CastleScriptVectors.TCasScriptVector", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVector.html"},
     {"title": "CastleScriptVectors.TCasScriptVector.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVector.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptVectorD", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorD.html"},
     {"title": "CastleScriptVectors.TCasScriptVectorD.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorD.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptVectorGet", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorGet.html"},
     {"title": "CastleScriptVectors.TCasScriptVectorGet.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorGet.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptVectorSet", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorSet.html"},
     {"title": "CastleScriptVectors.TCasScriptVectorSet.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorSet.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptVectorSet.ArgumentMustBeAssignable", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorSet.html#ArgumentMustBeAssignable"},
     {"title": "CastleScriptVectors.TCasScriptVectorGetCount", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorGetCount.html"},
     {"title": "CastleScriptVectors.TCasScriptVectorGetCount.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorGetCount.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptVectorLength", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorLength.html"},
     {"title": "CastleScriptVectors.TCasScriptVectorLength.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorLength.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptVectorSqrLength", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorSqrLength.html"},
     {"title": "CastleScriptVectors.TCasScriptVectorSqrLength.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorSqrLength.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptVectorDot", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorDot.html"},
     {"title": "CastleScriptVectors.TCasScriptVectorDot.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorDot.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptVectorCross", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorCross.html"},
     {"title": "CastleScriptVectors.TCasScriptVectorCross.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptVectorCross.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptGrayscale", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptGrayscale.html"},
     {"title": "CastleScriptVectors.TCasScriptGrayscale.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptGrayscale.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptOrientationFromDirectionUp", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptOrientationFromDirectionUp.html"},
     {"title": "CastleScriptVectors.TCasScriptOrientationFromDirectionUp.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptOrientationFromDirectionUp.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptRotate", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptRotate.html"},
     {"title": "CastleScriptVectors.TCasScriptRotate.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptRotate.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptOrientationToDirection", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptOrientationToDirection.html"},
     {"title": "CastleScriptVectors.TCasScriptOrientationToDirection.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptOrientationToDirection.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptOrientationToUp", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptOrientationToUp.html"},
     {"title": "CastleScriptVectors.TCasScriptOrientationToUp.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptOrientationToUp.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptSlerp", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptSlerp.html"},
     {"title": "CastleScriptVectors.TCasScriptSlerp.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptSlerp.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptMatrixFun", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrixFun.html"},
     {"title": "CastleScriptVectors.TCasScriptMatrixFun.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrixFun.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptMatrixGet", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrixGet.html"},
     {"title": "CastleScriptVectors.TCasScriptMatrixGet.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrixGet.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptMatrixSet", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrixSet.html"},
     {"title": "CastleScriptVectors.TCasScriptMatrixSet.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrixSet.html#ShortName"},
     {"title": "CastleScriptVectors.TCasScriptMatrixSet.ArgumentMustBeAssignable", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrixSet.html#ArgumentMustBeAssignable"},
     {"title": "CastleScriptVectors.TCasScriptMatrixGetCount", "text": " ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrixGetCount.html"},
     {"title": "CastleScriptVectors.TCasScriptMatrixGetCount.ShortName", "text": "    ", "tags": "", "loc": "CastleScriptVectors.TCasScriptMatrixGetCount.html#ShortName"},
     {"title": "CastleScriptXML", "text": " ", "tags": "", "loc": "CastleScriptXML.html"},
     {"title": "CastleScriptXML.TCastleConfigScriptHelper", "text": " Use this unit, and then you can call powerful <a class=\"normal\" href=\"CastleScriptXML.TCastleConfigScriptHelper.html#GetFloatExpression\">GetFloatExpression</a> instead of <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#GetFloat\">TCastleConfig.GetFloat</a>. ", "tags": "", "loc": "CastleScriptXML.TCastleConfigScriptHelper.html"},
     {"title": "CastleScriptXML.TCastleConfigScriptHelper.GetFloatExpression", "text": "     ", "tags": "", "loc": "CastleScriptXML.TCastleConfigScriptHelper.html#GetFloatExpression"},
     {"title": "CastleScriptXML.TCastleConfigScriptHelper.GetFloatExpression", "text": "    ", "tags": "", "loc": "CastleScriptXML.TCastleConfigScriptHelper.html#GetFloatExpression"},
     {"title": "CastleScriptXML.TCastleConfigScriptHelper.GetFloatExpression", "text": "    ", "tags": "", "loc": "CastleScriptXML.TCastleConfigScriptHelper.html#GetFloatExpression"},
     {"title": "CastleScriptXML.TCastleConfigScriptHelper.GetIntExpression", "text": "     ", "tags": "", "loc": "CastleScriptXML.TCastleConfigScriptHelper.html#GetIntExpression"},
     {"title": "CastleScriptXML.TCastleConfigScriptHelper.GetIntExpression", "text": "    ", "tags": "", "loc": "CastleScriptXML.TCastleConfigScriptHelper.html#GetIntExpression"},
     {"title": "CastleScriptXML.TCastleConfigScriptHelper.GetIntExpression", "text": "    ", "tags": "", "loc": "CastleScriptXML.TCastleConfigScriptHelper.html#GetIntExpression"},
     {"title": "CastleScriptXML.TDOMElementScriptHelper", "text": " Use this unit, and then you can call powerful methods <a class=\"normal\" href=\"CastleScriptXML.TDOMElementScriptHelper.html#AttributeFloatExpression\">AttributeFloatExpression</a>, <a class=\"normal\" href=\"CastleScriptXML.TDOMElementScriptHelper.html#AttributeFloatExpressionDef\">AttributeFloatExpressionDef</a> instead of the <a class=\"normal\" href=\"CastleXMLUtils.TDOMElementHelper.html#AttributeFloat\">TDOMElementHelper.AttributeFloat</a>, <a class=\"normal\" href=\"CastleXMLUtils.TDOMElementHelper.html#AttributeFloatDef\">TDOMElementHelper.AttributeFloatDef</a>. ", "tags": "", "loc": "CastleScriptXML.TDOMElementScriptHelper.html"},
     {"title": "CastleScriptXML.TDOMElementScriptHelper.AttributeFloatExpression", "text": " The expression can be anything in <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> <a  href=\"http://castle-engine.sourceforge.net/castle_script.php\">http://castle-engine.sourceforge.net/castle_script.php</a> , for example something crazy like <code>2.0 * sin(5.0) + Pi</code>. You can use this method instead of <a class=\"normal\" href=\"CastleXMLUtils.TDOMElementHelper.html#AttributeFloat\">AttributeFloat</a> to easily allow mathematical exressions in XML attributes.  <p>If there is no such attribute returns <code>False</code> and does not modify Value.    ", "tags": "", "loc": "CastleScriptXML.TDOMElementScriptHelper.html#AttributeFloatExpression"},
     {"title": "CastleScriptXML.TDOMElementScriptHelper.AttributeFloatExpression", "text": "  <p>The expression can be anything in <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> <a  href=\"http://castle-engine.sourceforge.net/castle_script.php\">http://castle-engine.sourceforge.net/castle_script.php</a> , for example something crazy like <code>2.0 * sin(5.0) + Pi</code>. You can use this method instead of <a class=\"normal\" href=\"CastleXMLUtils.TDOMElementHelper.html#AttributeFloat\">AttributeFloat</a> to easily allow mathematical exressions in XML attributes.  <p>    EDOMAttributeMissing ", "tags": "", "loc": "CastleScriptXML.TDOMElementScriptHelper.html#AttributeFloatExpression"},
     {"title": "CastleScriptXML.TDOMElementScriptHelper.AttributeFloatExpressionDef", "text": "  <p>The expression can be anything in <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> <a  href=\"http://castle-engine.sourceforge.net/castle_script.php\">http://castle-engine.sourceforge.net/castle_script.php</a> , for example something crazy like <code>2.0 * sin(5.0) + Pi</code>. You can use this method instead of <a class=\"normal\" href=\"CastleXMLUtils.TDOMElementHelper.html#AttributeFloatDef\">AttributeFloatDef</a> to easily allow mathematical exressions in XML attributes.    ", "tags": "", "loc": "CastleScriptXML.TDOMElementScriptHelper.html#AttributeFloatExpressionDef"},
     {"title": "CastleSectors", "text": " For user-oriented description what are sectors and waypoints, see &quot;The Castle&quot; developer docs, [<a  href=\"http://castle-engine.sourceforge.net/castle-development.php\">http://castle-engine.sourceforge.net/castle-development.php</a>]. ", "tags": "", "loc": "CastleSectors.html"},
     {"title": "CastleSectors.TWaypoint", "text": " ", "tags": "", "loc": "CastleSectors.TWaypoint.html"},
     {"title": "CastleSectors.TWaypoint.Position", "text": " ", "tags": "", "loc": "CastleSectors.TWaypoint.html#Position"},
     {"title": "CastleSectors.TWaypoint.Box", "text": " This box is <i>not</i> used by actual AI using waypoints/sectors (only <a class=\"normal\" href=\"CastleSectors.TWaypoint.html#Position\">Position</a> matters then). ", "tags": "", "loc": "CastleSectors.TWaypoint.html#Box"},
     {"title": "CastleSectors.TWaypoint.Create", "text": "    ", "tags": "", "loc": "CastleSectors.TWaypoint.html#Create"},
     {"title": "CastleSectors.TWaypoint.Destroy", "text": "    ", "tags": "", "loc": "CastleSectors.TWaypoint.html#Destroy"},
     {"title": "CastleSectors.TWaypoint.Sectors", "text": " ", "tags": "", "loc": "CastleSectors.TWaypoint.html#Sectors"},
     {"title": "CastleSectors.TWaypointList", "text": " ", "tags": "", "loc": "CastleSectors.TWaypointList.html"},
     {"title": "CastleSectors.TSector", "text": " ", "tags": "", "loc": "CastleSectors.TSector.html"},
     {"title": "CastleSectors.TSector.Create", "text": "    ", "tags": "", "loc": "CastleSectors.TSector.html#Create"},
     {"title": "CastleSectors.TSector.Destroy", "text": "    ", "tags": "", "loc": "CastleSectors.TSector.html#Destroy"},
     {"title": "CastleSectors.TSector.Contains", "text": "    ", "tags": "", "loc": "CastleSectors.TSector.html#Contains"},
     {"title": "CastleSectors.TSector.Collision", "text": "    ", "tags": "", "loc": "CastleSectors.TSector.html#Collision"},
     {"title": "CastleSectors.TSector.Boxes", "text": " ", "tags": "", "loc": "CastleSectors.TSector.html#Boxes"},
     {"title": "CastleSectors.TSector.VisibleSectors", "text": "  <p>When reading this, you should generally be prepared that length of it may be smaller than all sectors of your scene. That's because sometimes we don't initialize <code>VisibleSectors</code> fully.  <p>In this case you should assume that not initialized sector indexes are visible. And always you can assume that Always Sectors[I].VisibleSectors[I] = <code>True</code>, i.e. the sector is visible from itself (assuming that <code>VisibleSectors</code> has enough length to contain I). ", "tags": "", "loc": "CastleSectors.TSector.html#VisibleSectors"},
     {"title": "CastleSectors.TSector.Waypoints", "text": " ", "tags": "", "loc": "CastleSectors.TSector.html#Waypoints"},
     {"title": "CastleSectors.ESectorNotInitialized", "text": " ", "tags": "", "loc": "CastleSectors.ESectorNotInitialized.html"},
     {"title": "CastleSectors.EWaypointNotInitialized", "text": " ", "tags": "", "loc": "CastleSectors.EWaypointNotInitialized.html"},
     {"title": "CastleSectors.TSectorList", "text": " ", "tags": "", "loc": "CastleSectors.TSectorList.html"},
     {"title": "CastleSectors.TSectorList.LinkToWaypoints", "text": " Adds appropriate waypoints to sectors and sectors to waypoints, knowing which waypoint belongs (presumably, lies at the border of) to which sector. A waypoint belongs to the sector simply when <a class=\"normal\" href=\"CastleSectors.TWaypoint.html#Box\">TWaypoint.Box</a> collides with one of the sector boxes.  <p>     ESectorNotInitialized When some sector is nil. EWaypointNotInitialized When some waypoint is nil.", "tags": "", "loc": "CastleSectors.TSectorList.html#LinkToWaypoints"},
     {"title": "CastleSectors.TSectorList.SectorWithPoint", "text": " Returns nil if no such sector.    ", "tags": "", "loc": "CastleSectors.TSectorList.html#SectorWithPoint"},
     {"title": "CastleSectors.TSectorList.FindWay", "text": "  <p>Special cases: when either SectorBegin or SectorEnd are nil (this can easily happen if you pass here results of <a class=\"normal\" href=\"CastleSectors.TSectorList.html#SectorWithPoint\">SectorWithPoint</a> method), or when SectorBegin = SectorEnd, or when there is no possible way, it returns <code>False</code> and just clears Waypoints (i.e. sets Waypoints.Count to 0).  <p>Otherwise (if a way is found) it returns <code>True</code> and sets Waypoints items as appropriate. The order of Waypoints is significant: starting from SectorBegin, you should first travel to Waypoints[0], then to Waypoints[1] etc. In this case for sure we have at least one Waypoint.  <p>(So the result of this function is actually just a comfortable thing, you can get the same result just checking Waypoints.Count &lt;&gt; 0)  <p>TODO: This should use breadth-first search. Right now it uses depth-first search. For small sectors+waypoints graphs it doesn't matter.    ", "tags": "", "loc": "CastleSectors.TSectorList.html#FindWay"},
     {"title": "CastleSectors.LogSectors", "text": " ", "tags": "", "loc": "CastleSectors.html#LogSectors"},
     {"title": "CastleShaders", "text": " ", "tags": "", "loc": "CastleShaders.html"},
     {"title": "CastleShaders.stVertex", "text": " ", "tags": "", "loc": "CastleShaders.html#stVertex"},
     {"title": "CastleShaders.stGeometry", "text": " ", "tags": "", "loc": "CastleShaders.html#stGeometry"},
     {"title": "CastleShaders.stFragment", "text": " ", "tags": "", "loc": "CastleShaders.html#stFragment"},
     {"title": "CastleShaders.ShaderTypeName", "text": " ", "tags": "", "loc": "CastleShaders.html#ShaderTypeName"},
     {"title": "CastleShaders.ShaderTypeNameX3D", "text": " ", "tags": "", "loc": "CastleShaders.html#ShaderTypeNameX3D"},
     {"title": "CastleShaders.TShaderType", "text": " ", "tags": "", "loc": "CastleShaders.html#TShaderType"},
     {"title": "CastleShapes", "text": " ", "tags": "", "loc": "CastleShapes.html"},
     {"title": "CastleShapes.TTriangleHelper", "text": " Helper methods. ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html"},
     {"title": "CastleShapes.TTriangleHelper.Shape", "text": "    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#Shape"},
     {"title": "CastleShapes.TTriangleHelper.State", "text": " This is a shortcut for <a class=\"normal\" href=\"CastleShapes.TTriangleHelper.html#Shape\">Shape</a>.State.    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#State"},
     {"title": "CastleShapes.TTriangleHelper.UpdateWorld", "text": "    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#UpdateWorld"},
     {"title": "CastleShapes.TTriangleHelper.ShapeNode", "text": " May be <code>Nil</code> in case of VRML 1.0.    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#ShapeNode"},
     {"title": "CastleShapes.TTriangleHelper.Material", "text": " May be <code>Nil</code> in case material is not set, or in VRML 1.0.    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#Material"},
     {"title": "CastleShapes.TTriangleHelper.MaterialNode", "text": "    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#MaterialNode"},
     {"title": "CastleShapes.TTriangleHelper.MaterialInfo", "text": " See <a class=\"normal\" href=\"X3DNodes.TMaterialInfo.html\">TMaterialInfo</a> for usage description. Returns <code>Nil</code> when no node determines material properties (which indicates <a class=\"normal\" href=\"CastleColors.html#White\">white</a> unlit look).  <p>Returned <a class=\"normal\" href=\"X3DNodes.TMaterialInfo.html\">TMaterialInfo</a> is valid only as long as the underlying Material or CommonSurfaceShader node exists. Do not free it yourself, it will be automatically freed.    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#MaterialInfo"},
     {"title": "CastleShapes.TTriangleHelper.Transparency", "text": " Equivalent to MaterialInfo.Transparency, although a little faster.    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#Transparency"},
     {"title": "CastleShapes.TTriangleHelper.IsTransparent", "text": "    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#IsTransparent"},
     {"title": "CastleShapes.TTriangleHelper.IgnoreForShadowRays", "text": " Returns <code>True</code> for transparent triangles (with Material.Transparency &gt; 0) and non-shadow-casting triangles (with Appearance.shadowCaster = FALSE).  <p>    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#IgnoreForShadowRays"},
     {"title": "CastleShapes.TTriangleHelper.INormalWorldSpace", "text": "  <p>    ", "tags": "", "loc": "CastleShapes.TTriangleHelper.html#INormalWorldSpace"},
     {"title": "CastleShapes.TShapeTree", "text": "  <p>Although VRML/X3D model already provides the tree (graph of VRML/X3D nodes), it's a little too complicated to be used at each render call. It's especially true for VRML &lt;= 1.0 (where properties may &quot;leak out&quot; from one node to the next), VRML/X3D &gt;= 2.0 cleaned a lot here but still some work must be done when traversing (like accumulating transformations).  <p>So we process VRML/X3D tree to this tree, which is much simpler with all the geometry nodes (<a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a>) along with their state (<a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a>) as leafs (<a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a>). ", "tags": "", "loc": "CastleShapes.TShapeTree.html"},
     {"title": "CastleShapes.TShapeTree.Create", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTree.html#Create"},
     {"title": "CastleShapes.TShapeTree.Traverse", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTree.html#Traverse"},
     {"title": "CastleShapes.TShapeTree.ShapesCount", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTree.html#ShapesCount"},
     {"title": "CastleShapes.TShapeTree.FindGeometryNodeName", "text": " Returns <code>Nil</code> if not found.    ", "tags": "", "loc": "CastleShapes.TShapeTree.html#FindGeometryNodeName"},
     {"title": "CastleShapes.TShapeTree.FindShapeWithParentNamed", "text": " Parent is searched by Geometry.TryFindParentNodeByName. Returns <code>Nil</code> if not found.    ", "tags": "", "loc": "CastleShapes.TShapeTree.html#FindShapeWithParentNamed"},
     {"title": "CastleShapes.TShapeTree.EnumerateTextures", "text": " This looks into all shapes (not only active, so e.g. it looks into all Switch/LOD children, not only the chosen one).  <p>This looks into the  <p></p>  <ul class=\"compact_spacing\">   <li><p>Appearance.texture field (and if it's MultiTexture, looks into it's children)</p></li>   <li><p>Into shaders textures (GLSL shaders, CommonSurfaceShader...).</p></li>   <li><p>For VRML 1.0, it also looks into VRML1State.Texture2.</p></li> </ul>  <p>  <p>If Enumerate callbacks returns non-nil for some texture, returns it immediately, and stops further processing.    ", "tags": "", "loc": "CastleShapes.TShapeTree.html#EnumerateTextures"},
     {"title": "CastleShapes.TShapeTree.DebugInfo", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTree.html#DebugInfo"},
     {"title": "CastleShapes.TShapeTree.ParentScene", "text": " This cannot be declared here as <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> (this would create circular unit dependency), but it always is <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>. ", "tags": "", "loc": "CastleShapes.TShapeTree.html#ParentScene"},
     {"title": "CastleShapes.TShape", "text": " For VRML &gt;= 2.0, this usually corresponds to a single instance of actual VRML <code>Shape</code> node. It allows to perform many operations that need to know both geometry and it's current state (parent Shape node, current transformation and such).  <p>This class caches results of methods <a class=\"normal\" href=\"CastleShapes.TShape.html#LocalBoundingBox\">LocalBoundingBox</a>, <a class=\"normal\" href=\"CastleShapes.TShape.html#BoundingBox\">BoundingBox</a>, and most others (see TShapeValidities for hints). This means that things work fast, but this also means that you must manually call <a class=\"normal\" href=\"CastleShapes.TShape.html#Changed\">Changed</a> when you changed some properties of Geometry or contents of State.  <p>But note that you can't change Geometry or State to different objects &mdash; they are readonly properties.  <p>Also note that if you're using <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> class then you don't have to worry about calling <a class=\"normal\" href=\"CastleShapes.TShape.html#Changed\">Changed</a> of items in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Shapes\">TCastleSceneCore.Shapes</a>. All you have to do is to call appropriate <code>Changed*</code> methods of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>. ", "tags": "", "loc": "CastleShapes.TShape.html"},
     {"title": "CastleShapes.TShape.Create", "text": "   ParentInfo Resursive information about parents, for the geometry node of given shape. Note that for VRML 2.0/X3D, the immediate parent of geometry node is always <a class=\"normal\" href=\"X3DNodes.TShapeNode.html\">TShapeNode</a>.  ParentInfo Resursive information about parents, for the geometry node of given shape. Note that for VRML 2.0/X3D, the immediate parent of geometry node is always <a class=\"normal\" href=\"X3DNodes.TShapeNode.html\">TShapeNode</a>.", "tags": "", "loc": "CastleShapes.TShape.html#Create"},
     {"title": "CastleShapes.TShape.Destroy", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#Destroy"},
     {"title": "CastleShapes.TShape.Geometry", "text": " This may come from initial VRML/X3D node graph (see <a class=\"normal\" href=\"CastleShapes.TShape.html#OriginalGeometry\">OriginalGeometry</a>), or it may be processed by <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#Proxy\">TAbstractGeometryNode.Proxy</a> for easier handling.    ", "tags": "", "loc": "CastleShapes.TShape.html#Geometry"},
     {"title": "CastleShapes.TShape.State", "text": " This may come from initial VRML/X3D node graph (see <a class=\"normal\" href=\"CastleShapes.TShape.html#OriginalState\">OriginalState</a>), or it may be processed by <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#Proxy\">TAbstractGeometryNode.Proxy</a> for easier handling.  <p>Owned by this <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> class.    ", "tags": "", "loc": "CastleShapes.TShape.html#State"},
     {"title": "CastleShapes.TShape.LocalBoundingBox", "text": "     ", "tags": "", "loc": "CastleShapes.TShape.html#LocalBoundingBox"},
     {"title": "CastleShapes.TShape.BoundingBox", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#BoundingBox"},
     {"title": "CastleShapes.TShape.VerticesCount", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#VerticesCount"},
     {"title": "CastleShapes.TShape.TrianglesCount", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#TrianglesCount"},
     {"title": "CastleShapes.TShape.GeometryArrays", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#GeometryArrays"},
     {"title": "CastleShapes.TShape.BoundingSphereCenter", "text": " In the future this may be changed to use BoundingSphere method of <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a>, when I will implement it. For now, BoundingSphere is always worse approximation of bounding volume than <a class=\"normal\" href=\"CastleShapes.TShape.html#BoundingBox\">BoundingBox</a> (i.e. BoundingSphere is always larger) but it may be useful in some cases when detecting collision versus bounding sphere is much faster than detecting them versus bounding box.  <p><a class=\"normal\" href=\"CastleShapes.TShape.html#BoundingSphereRadiusSqr\">BoundingSphereRadiusSqr</a> = 0 and <code>BoundingSphereCenter</code> is undefined if Box is empty.  <p>    ", "tags": "", "loc": "CastleShapes.TShape.html#BoundingSphereCenter"},
     {"title": "CastleShapes.TShape.BoundingSphereRadiusSqr", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#BoundingSphereRadiusSqr"},
     {"title": "CastleShapes.TShape.BoundingSphereRadius", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#BoundingSphereRadius"},
     {"title": "CastleShapes.TShape.FrustumBoundingSphereCollisionPossible", "text": "  <p>But it may be a little faster since it avoids some small speed problems (like copying memory contents when you get values of BoundingSphereXxx properties and checking twice are BoundingSphereXxx calculated).    ", "tags": "", "loc": "CastleShapes.TShape.html#FrustumBoundingSphereCollisionPossible"},
     {"title": "CastleShapes.TShape.FrustumBoundingSphereCollisionPossibleSimple", "text": "  <p>But it may be a little faster since it avoids some small speed problems.    ", "tags": "", "loc": "CastleShapes.TShape.html#FrustumBoundingSphereCollisionPossibleSimple"},
     {"title": "CastleShapes.TShape.Changed", "text": " This should be called when fields within Shape.Geometry, Shape.State.Last*, Shape.State.ShapeNode or such change.  <p>Pass InactiveOnly = <code>True</code> is you know that this shape is fully in inactive VRML graph part (inactive Switch, LOD etc. children).  <p>Including <a class=\"normal\" href=\"X3DFields.html#chTransform\">chTransform</a> in Changes means something more than general <a class=\"normal\" href=\"X3DFields.html#chTransform\">chTransform</a> (which means that transformation of children changed, which implicates many things &mdash; not only shape changes). Here, <a class=\"normal\" href=\"X3DFields.html#chTransform\">chTransform</a> in Changes means that only the transformation of <a class=\"normal\" href=\"CastleShapes.TShape.html#State\">TShape.State</a> changed (so only on fields ignored by EqualsNoTransform).    ", "tags": "", "loc": "CastleShapes.TShape.html#Changed"},
     {"title": "CastleShapes.TShape.InternalOctreeTriangles", "text": " It contains only triangles within this shape.  <p>There is no distinction here between collidable / visible (as for <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> octrees), since only the whole shape may be marked as visible and/or collidable, not particular triangles.  <p>The triangles are specified in local coordinate system of this shape (that is, they are independent from transformation within State.Transform). This allows the tree to remain unmodified when transformation of this shape changes.  <p>This is automatically managed (initialized, updated, and used) by parent <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>. You usually don't need to know about this octree from outside.  <p>To initialize this, add <a class=\"normal\" href=\"CastleShapes.html#ssTriangles\">ssTriangles</a> to <a class=\"normal\" href=\"CastleShapes.TShape.html#InternalSpatial\">InternalSpatial</a> property, otherwise it's <code>Nil</code>. Parent <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> will take care of this (when parent <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">TCastleSceneCore.Spatial</a> contains <a class=\"normal\" href=\"CastleScene.html#ssDynamicCollisions\">ssDynamicCollisions</a>, then all shapes contain <a class=\"normal\" href=\"CastleShapes.html#ssTriangles\">ssTriangles</a> within their <a class=\"normal\" href=\"CastleShapes.TShape.html#InternalSpatial\">InternalSpatial</a>).  <p>Parent <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> will take care to keep this octree always updated.  <p>Parent <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> will also take care of actually using this octree: TCastleSceneCore.OctreeCollisions methods actually use the octrees of specific shapes at the bottom.    ", "tags": "", "loc": "CastleShapes.TShape.html#InternalOctreeTriangles"},
     {"title": "CastleShapes.TShape.InternalTriangleOctreeLimits", "text": " See TriangleOctree unit comments for description.  <p>Default value comes from <a class=\"normal\" href=\"CastleShapes.html#DefLocalTriangleOctreeLimits\">DefLocalTriangleOctreeLimits</a>.  <p>They are used only when the octree is created, so usually you want to set them right before changing <a class=\"normal\" href=\"CastleShapes.TShape.html#InternalSpatial\">InternalSpatial</a> from [] to something else.    ", "tags": "", "loc": "CastleShapes.TShape.html#InternalTriangleOctreeLimits"},
     {"title": "CastleShapes.TShape.Blending", "text": "  <p>This may look at the data of the texture node, so it should be called before any calls to <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#FreeResources\">TCastleSceneCore.FreeResources</a>. It checks AlphaChannel of textures, so assumes that given shape textures are already loaded.    ", "tags": "", "loc": "CastleShapes.TShape.html#Blending"},
     {"title": "CastleShapes.TShape.Transparent", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#Transparent"},
     {"title": "CastleShapes.TShape.Traverse", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#Traverse"},
     {"title": "CastleShapes.TShape.ShapesCount", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#ShapesCount"},
     {"title": "CastleShapes.TShape.Visible", "text": " Ths is simply a shortcut (with more obvious name) for <code>State.InsideInvisible = 0</code>.    ", "tags": "", "loc": "CastleShapes.TShape.html#Visible"},
     {"title": "CastleShapes.TShape.Collidable", "text": " Ths is simply a shortcut (with more obvious name) for <code>State.InsideIgnoreCollision = 0</code>.    ", "tags": "", "loc": "CastleShapes.TShape.html#Collidable"},
     {"title": "CastleShapes.TShape.RayCollision", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#RayCollision"},
     {"title": "CastleShapes.TShape.SegmentCollision", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#SegmentCollision"},
     {"title": "CastleShapes.TShape.NormalsSmooth", "text": "  <p>You can call this only when Geometry is coordinate-based X3D geometry, implementing Coord and having non-empty coordinates (that is, Geometry.Coord returns <code>True</code> and sets ACoord &lt;&gt; <code>Nil</code>), and having Geometry.CoordIndex &lt;&gt; <code>Nil</code>.  <p>For <code>NormalsSmooth</code>, also Geometry.CoordIndex = <code>Nil</code> is allowed, but make sure that Geometry.InternalCoordPolygons is available. See CreateSmoothNormalsCoordinateNode.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Smooth normals are perfectly smooth, per-vertex.  <p>As an exception, you can call this even when coords are currently empty (Geometry.Coord returns <code>True</code> but ACoord is <code>Nil</code>), then result is also <code>Nil</code>.</p></li>   <li><p>Flat normals are per-face. Calculated by CreateFlatNormals.</p></li>   <li><p>Finally <a class=\"normal\" href=\"CastleShapes.TShape.html#NormalsCreaseAngle\">NormalsCreaseAngle</a> creates separate normal per index (auto-smoothing by CreaseAngle).</p></li> </ul>  <p>  <p>The normals here are cached. So using these methods makes condiderable speedup if the shape will not change (<a class=\"normal\" href=\"CastleShapes.TShape.html#Changed\">Changed</a> method) and will need normals many times (e.g. will be rendered many times).  <p>    ", "tags": "", "loc": "CastleShapes.TShape.html#NormalsSmooth"},
     {"title": "CastleShapes.TShape.NormalsFlat", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#NormalsFlat"},
     {"title": "CastleShapes.TShape.NormalsCreaseAngle", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#NormalsCreaseAngle"},
     {"title": "CastleShapes.TShape.EnumerateTextures", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#EnumerateTextures"},
     {"title": "CastleShapes.TShape.UsesTexture", "text": " This is equivalent to checking does EnumerateShapeTextures return this shape.    ", "tags": "", "loc": "CastleShapes.TShape.html#UsesTexture"},
     {"title": "CastleShapes.TShape.ShadowCaster", "text": " Looks at Shape's Appearance.shadowCaster field (see <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadow_caster\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadow_caster</a>).    ", "tags": "", "loc": "CastleShapes.TShape.html#ShadowCaster"},
     {"title": "CastleShapes.TShape.Triangulate", "text": " Calls TriangleEvent callback for each triangle. <a class=\"normal\" href=\"CastleShapes.TShape.html#LocalTriangulate\">LocalTriangulate</a> returns coordinates in local shape transformation (that is, not transformed by State.Transform yet).  <p>OverTriangulate determines if we should make more triangles for Gouraud shading. For example, it makes Cones and Cylinders divided into additional stacks.  <p>    ", "tags": "", "loc": "CastleShapes.TShape.html#Triangulate"},
     {"title": "CastleShapes.TShape.LocalTriangulate", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#LocalTriangulate"},
     {"title": "CastleShapes.TShape.DebugInfo", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#DebugInfo"},
     {"title": "CastleShapes.TShape.NiceName", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#NiceName"},
     {"title": "CastleShapes.TShape.Node", "text": " This is always present for VRML &gt;= 2 (including X3D). For VRML 1.0 and Inventor this is <code>Nil</code>.    ", "tags": "", "loc": "CastleShapes.TShape.html#Node"},
     {"title": "CastleShapes.TShape.InternalMaterialProperty", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#InternalMaterialProperty"},
     {"title": "CastleShapes.TShape.MaterialProperty", "text": "    ", "tags": "", "loc": "CastleShapes.TShape.html#MaterialProperty"},
     {"title": "CastleShapes.TShape.OriginalGeometry", "text": " ", "tags": "", "loc": "CastleShapes.TShape.html#OriginalGeometry"},
     {"title": "CastleShapes.TShape.OriginalState", "text": " ", "tags": "", "loc": "CastleShapes.TShape.html#OriginalState"},
     {"title": "CastleShapes.TShape.InternalSpatial", "text": " This works analogous to <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">TCastleSceneCore.Spatial</a>, but this manages octrees within this <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a>.  <p>Parent <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> will take care to keep this value updated, you should only set <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">TCastleSceneCore.Spatial</a> from the outside. ", "tags": "", "loc": "CastleShapes.TShape.html#InternalSpatial"},
     {"title": "CastleShapes.TShape.InternalTriangleOctreeProgressTitle", "text": " Will be shown only if progress is not active already (so we avoid starting &quot;progress bar within progress bar&quot;). ", "tags": "", "loc": "CastleShapes.TShape.html#InternalTriangleOctreeProgressTitle"},
     {"title": "CastleShapes.TShape.DynamicGeometry", "text": " This is automatically detected and set to <code>True</code>, although you can also explicitly set this if you want.  <p>Dynamic geometry has worse collision detection (using a crude approximation) and falls back to rendering method better for dynamic geometry (for example, marking VBO data as dynamic for OpenGL rendering). ", "tags": "", "loc": "CastleShapes.TShape.html#DynamicGeometry"},
     {"title": "CastleShapes.TShape.GeometryParentNodeName", "text": " Note that for X3D/VRML 2.0, <code>GeometryParentNodeName</code> is the same as Node.NodeName, because the parent of geometry node is always a <a class=\"normal\" href=\"X3DNodes.TShapeNode.html\">TShapeNode</a>.  ", "tags": "", "loc": "CastleShapes.TShape.html#GeometryParentNodeName"},
     {"title": "CastleShapes.TShape.GeometryGrandParentNodeName", "text": " ", "tags": "", "loc": "CastleShapes.TShape.html#GeometryGrandParentNodeName"},
     {"title": "CastleShapes.TShape.GeometryGrandGrandParentNodeName", "text": " ", "tags": "", "loc": "CastleShapes.TShape.html#GeometryGrandGrandParentNodeName"},
     {"title": "CastleShapes.TShape.TNormalsCached", "text": "  ncSmooth    ncFlat    ncCreaseAngle   ", "tags": "", "loc": "CastleShapes.TShape.html#TNormalsCached"},
     {"title": "CastleShapes.TShapeTreeGroup", "text": " This is practically just a list of other children (other <a class=\"normal\" href=\"CastleShapes.TShapeTree.html\">TShapeTree</a> items).  <p>All children are considered &quot;active&quot; by this class.  <p>This class owns it's children <a class=\"normal\" href=\"CastleShapes.TShapeTree.html\">TShapeTree</a>. Since <a class=\"normal\" href=\"CastleShapes.TShapeTree.html\">TShapeTree</a> is a simple tree structure, there are no duplicates possible, that is given <a class=\"normal\" href=\"CastleShapes.TShapeTree.html\">TShapeTree</a> instance may be within only one parent <a class=\"normal\" href=\"CastleShapes.TShapeTree.html\">TShapeTree</a>. (VRML node's parenting mechanism is more complicated than this, because of DEF/USE mechanism.) ", "tags": "", "loc": "CastleShapes.TShapeTreeGroup.html"},
     {"title": "CastleShapes.TShapeTreeGroup.Create", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeGroup.html#Create"},
     {"title": "CastleShapes.TShapeTreeGroup.Destroy", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeGroup.html#Destroy"},
     {"title": "CastleShapes.TShapeTreeGroup.Traverse", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeGroup.html#Traverse"},
     {"title": "CastleShapes.TShapeTreeGroup.ShapesCount", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeGroup.html#ShapesCount"},
     {"title": "CastleShapes.TShapeTreeGroup.EnumerateTextures", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeGroup.html#EnumerateTextures"},
     {"title": "CastleShapes.TShapeTreeGroup.DebugInfo", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeGroup.html#DebugInfo"},
     {"title": "CastleShapes.TShapeTreeGroup.Children", "text": " ", "tags": "", "loc": "CastleShapes.TShapeTreeGroup.html#Children"},
     {"title": "CastleShapes.TShapeTreeSwitch", "text": "  <p>It's ideal for representing the VRML &gt;= 2.0 Switch node (not possible for VRML 1.0 Switch node, as it may affect also other nodes after Switch). Actually, it even has a <a class=\"normal\" href=\"CastleShapes.TShapeTreeSwitch.html#SwitchNode\">SwitchNode</a> link that is used to decide which child to choose (using SwitchNode.FdWhichChoice). ", "tags": "", "loc": "CastleShapes.TShapeTreeSwitch.html"},
     {"title": "CastleShapes.TShapeTreeSwitch.Traverse", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeSwitch.html#Traverse"},
     {"title": "CastleShapes.TShapeTreeSwitch.ShapesCount", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeSwitch.html#ShapesCount"},
     {"title": "CastleShapes.TShapeTreeSwitch.SwitchNode", "text": " ", "tags": "", "loc": "CastleShapes.TShapeTreeSwitch.html#SwitchNode"},
     {"title": "CastleShapes.TShapeTreeTransform", "text": "  <p>It's ideal for handling VRML 2.0 / X3D Transform node, and similar nodes (MatrixTransform and some H-Anim nodes also act as a transformation node and also may be handled by this). ", "tags": "", "loc": "CastleShapes.TShapeTreeTransform.html"},
     {"title": "CastleShapes.TShapeTreeTransform.Create", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeTransform.html#Create"},
     {"title": "CastleShapes.TShapeTreeTransform.Destroy", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeTransform.html#Destroy"},
     {"title": "CastleShapes.TShapeTreeTransform.TransformNode", "text": " Always assigned, always may be casted to <a class=\"normal\" href=\"X3DNodes.ITransformNode.html\">ITransformNode</a> interface. ", "tags": "", "loc": "CastleShapes.TShapeTreeTransform.html#TransformNode"},
     {"title": "CastleShapes.TShapeTreeTransform.TransformState", "text": " Owned by this <a class=\"normal\" href=\"CastleShapes.TShapeTreeTransform.html\">TShapeTreeTransform</a> instance. You should assign to it when you set <a class=\"normal\" href=\"CastleShapes.TShapeTreeTransform.html#TransformNode\">TransformNode</a>. ", "tags": "", "loc": "CastleShapes.TShapeTreeTransform.html#TransformState"},
     {"title": "CastleShapes.TShapeTreeLOD", "text": " It chooses one child from it's children list as active. Represents the VRML &gt;= 2.0 LOD node (not possible for VRML 1.0 LOD node, as it may affect also other nodes after LOD).  <p>To choose which child is active we need to know the LOD node, with it's transformation in VRML graph. This information is in <a class=\"normal\" href=\"CastleShapes.TShapeTreeLOD.html#LODNode\">LODNode</a> and <a class=\"normal\" href=\"CastleShapes.TShapeTreeLOD.html#LODInvertedTransform\">LODInvertedTransform</a> properties.  <p>Also, we need to know the current camera position. This is passed as CameraPosition to <a class=\"normal\" href=\"CastleShapes.TShapeTreeLOD.html#CalculateLevel\">CalculateLevel</a>. Note that this class doesn't call <a class=\"normal\" href=\"CastleShapes.TShapeTreeLOD.html#CalculateLevel\">CalculateLevel</a> by itself, never. You have to call <a class=\"normal\" href=\"CastleShapes.TShapeTreeLOD.html#CalculateLevel\">CalculateLevel</a>, and use it to set Level property, from parent scene to make this LOD work. (Reasoning behind this decision: parent scene has CameraPosition and such, and parent scene knows whether to initiate level_changes event sending.) ", "tags": "", "loc": "CastleShapes.TShapeTreeLOD.html"},
     {"title": "CastleShapes.TShapeTreeLOD.LODInvertedTransform", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeLOD.html#LODInvertedTransform"},
     {"title": "CastleShapes.TShapeTreeLOD.CalculateLevel", "text": " This only calculates level, doesn't assign <a class=\"normal\" href=\"CastleShapes.TShapeTreeLOD.html#Level\">Level</a> property or send level_changed event.    ", "tags": "", "loc": "CastleShapes.TShapeTreeLOD.html#CalculateLevel"},
     {"title": "CastleShapes.TShapeTreeLOD.Traverse", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeLOD.html#Traverse"},
     {"title": "CastleShapes.TShapeTreeLOD.ShapesCount", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeLOD.html#ShapesCount"},
     {"title": "CastleShapes.TShapeTreeLOD.LODNode", "text": " ", "tags": "", "loc": "CastleShapes.TShapeTreeLOD.html#LODNode"},
     {"title": "CastleShapes.TShapeTreeLOD.Level", "text": " This is always &lt; Children.Count, unless there are no children. In this case it's 0.  <p>Should be calculated by <a class=\"normal\" href=\"CastleShapes.TShapeTreeLOD.html#CalculateLevel\">CalculateLevel</a>. By default we simply use the first (highest-detail) LOD as active. So if you never assign this (e.g. because <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#CameraViewKnown\">TCastleSceneCore.CameraViewKnown</a> = <code>False</code>, that is user position is never known) we'll always use the highest-detail children. ", "tags": "", "loc": "CastleShapes.TShapeTreeLOD.html#Level"},
     {"title": "CastleShapes.TShapeTreeLOD.WasLevel_ChangedSend", "text": " ", "tags": "", "loc": "CastleShapes.TShapeTreeLOD.html#WasLevel_ChangedSend"},
     {"title": "CastleShapes.TProximitySensorInstance", "text": " ", "tags": "", "loc": "CastleShapes.TProximitySensorInstance.html"},
     {"title": "CastleShapes.TProximitySensorInstance.InvertedTransform", "text": " ", "tags": "", "loc": "CastleShapes.TProximitySensorInstance.html#InvertedTransform"},
     {"title": "CastleShapes.TProximitySensorInstance.IsActive", "text": " ", "tags": "", "loc": "CastleShapes.TProximitySensorInstance.html#IsActive"},
     {"title": "CastleShapes.TProximitySensorInstance.Traverse", "text": "    ", "tags": "", "loc": "CastleShapes.TProximitySensorInstance.html#Traverse"},
     {"title": "CastleShapes.TProximitySensorInstance.ShapesCount", "text": "    ", "tags": "", "loc": "CastleShapes.TProximitySensorInstance.html#ShapesCount"},
     {"title": "CastleShapes.TProximitySensorInstance.EnumerateTextures", "text": "    ", "tags": "", "loc": "CastleShapes.TProximitySensorInstance.html#EnumerateTextures"},
     {"title": "CastleShapes.TProximitySensorInstance.DebugInfo", "text": "    ", "tags": "", "loc": "CastleShapes.TProximitySensorInstance.html#DebugInfo"},
     {"title": "CastleShapes.TProximitySensorInstance.Node", "text": " ", "tags": "", "loc": "CastleShapes.TProximitySensorInstance.html#Node"},
     {"title": "CastleShapes.TVisibilitySensorInstance", "text": " ", "tags": "", "loc": "CastleShapes.TVisibilitySensorInstance.html"},
     {"title": "CastleShapes.TVisibilitySensorInstance.Box", "text": " That is, transformed by parent Transform and similar nodes. ", "tags": "", "loc": "CastleShapes.TVisibilitySensorInstance.html#Box"},
     {"title": "CastleShapes.TVisibilitySensorInstance.Transform", "text": " ", "tags": "", "loc": "CastleShapes.TVisibilitySensorInstance.html#Transform"},
     {"title": "CastleShapes.TVisibilitySensorInstance.Traverse", "text": "    ", "tags": "", "loc": "CastleShapes.TVisibilitySensorInstance.html#Traverse"},
     {"title": "CastleShapes.TVisibilitySensorInstance.ShapesCount", "text": "    ", "tags": "", "loc": "CastleShapes.TVisibilitySensorInstance.html#ShapesCount"},
     {"title": "CastleShapes.TVisibilitySensorInstance.EnumerateTextures", "text": "    ", "tags": "", "loc": "CastleShapes.TVisibilitySensorInstance.html#EnumerateTextures"},
     {"title": "CastleShapes.TVisibilitySensorInstance.DebugInfo", "text": "    ", "tags": "", "loc": "CastleShapes.TVisibilitySensorInstance.html#DebugInfo"},
     {"title": "CastleShapes.TVisibilitySensorInstance.Node", "text": " ", "tags": "", "loc": "CastleShapes.TVisibilitySensorInstance.html#Node"},
     {"title": "CastleShapes.TShapeTreeIterator", "text": " Sometimes it's easier to write code using this iterator than to create callbacks and use <a class=\"normal\" href=\"CastleShapes.TShapeTree.html#Traverse\">TShapeTree.Traverse</a>. ", "tags": "", "loc": "CastleShapes.TShapeTreeIterator.html"},
     {"title": "CastleShapes.TShapeTreeIterator.Create", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeIterator.html#Create"},
     {"title": "CastleShapes.TShapeTreeIterator.Destroy", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeIterator.html#Destroy"},
     {"title": "CastleShapes.TShapeTreeIterator.GetNext", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeTreeIterator.html#GetNext"},
     {"title": "CastleShapes.TShapeTreeIterator.Current", "text": " ", "tags": "", "loc": "CastleShapes.TShapeTreeIterator.html#Current"},
     {"title": "CastleShapes.TShapeList", "text": " ", "tags": "", "loc": "CastleShapes.TShapeList.html"},
     {"title": "CastleShapes.TShapeList.Create", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeList.html#Create"},
     {"title": "CastleShapes.TShapeList.Create", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeList.html#Create"},
     {"title": "CastleShapes.TShapeList.SortFrontToBack", "text": "    ", "tags": "", "loc": "CastleShapes.TShapeList.html#SortFrontToBack"},
     {"title": "CastleShapes.TShapeList.SortBackToFront", "text": "  <p>If Distance3D is <code>True</code>: we use real distance in 3D to sort. See the <a class=\"normal\" href=\"CastleBoxes.html#bs3D\">bs3D</a> at <a class=\"normal\" href=\"CastleBoxes.html#TBlendingSort\">TBlendingSort</a> documentation.  <p>If Distance3D is <code>False</code>: we use only the distance in the Z coordinate to sort. This is suitable for rendering things that pretend to be 2D, like Spine slots. See the <a class=\"normal\" href=\"CastleBoxes.html#bs2D\">bs2D</a> at <a class=\"normal\" href=\"CastleBoxes.html#TBlendingSort\">TBlendingSort</a> documentation.    ", "tags": "", "loc": "CastleShapes.TShapeList.html#SortBackToFront"},
     {"title": "CastleShapes.TPlaceholderNames", "text": " ", "tags": "", "loc": "CastleShapes.TPlaceholderNames.html"},
     {"title": "CastleShapes.TPlaceholderNames.Items", "text": " Setting this is allowed regardless if the key previously existed or not, in other words: setting this does AddOrSetValue, contrary to the ancestor TDictionary that only allows setting when the key already exists. ", "tags": "", "loc": "CastleShapes.TPlaceholderNames.html#Items"},
     {"title": "CastleShapes.ShadowSamplingNames", "text": " ", "tags": "", "loc": "CastleShapes.html#ShadowSamplingNames"},
     {"title": "CastleShapes.DefaultShadowSampling", "text": " ", "tags": "", "loc": "CastleShapes.html#DefaultShadowSampling"},
     {"title": "CastleShapes.DefLocalTriangleOctreeMaxDepth", "text": " ", "tags": "", "loc": "CastleShapes.html#DefLocalTriangleOctreeMaxDepth"},
     {"title": "CastleShapes.DefLocalTriangleOctreeLeafCapacity", "text": "  <p>This is slightly larger than DefTriangleOctreeLeafCapacity, as this octree will usually be used interactively for collision detection, not by ray-tracer. So octree construction speed is somewhat important, and cannot be too large... ", "tags": "", "loc": "CastleShapes.html#DefLocalTriangleOctreeLeafCapacity"},
     {"title": "CastleShapes.DefLocalTriangleOctreeLimits", "text": " ", "tags": "", "loc": "CastleShapes.html#DefLocalTriangleOctreeLimits"},
     {"title": "CastleShapes.TShadowSampling", "text": "  ssSimple    ssPCF4 Percentage Closer Filtering improve shadow maps look, by sampling the depth map a couple of times.  They also make shadow more blurry (increase shadow map size to counteract this), and a little slower. They may also introduce new artifacts (due to bad interaction with the &quot;polygon offset&quot; of shadow map).  ssPCF4Bilinear    ssPCF16    ssVarianceShadowMaps Variance Shadow Maps, see <a  href=\"http://www.punkuser.net/vsm/\">http://www.punkuser.net/vsm/</a> .  This may generally produce superior results, as shadow maps can be then filtered like normal textures (bilinear, mipmaps, anisotropic filtering). So shadows look much nicer from very close and very far distances. However, this requires new GPU, and may cause artifacts on some scenes. ", "tags": "", "loc": "CastleShapes.html#TShadowSampling"},
     {"title": "CastleShapes.TShapeSpatialStructure", "text": "  ssTriangles Create the TShape.OctreeTriangles.  This is an octree containing all triangles. ", "tags": "", "loc": "CastleShapes.html#TShapeSpatialStructure"},
     {"title": "CastleShapes.TShapeSpatialStructures", "text": " ", "tags": "", "loc": "CastleShapes.html#TShapeSpatialStructures"},
     {"title": "CastleShapes.TShapeTraverseFunc", "text": "    ", "tags": "", "loc": "CastleShapes.html#TShapeTraverseFunc"},
     {"title": "CastleShapes.TEnumerateShapeTexturesFunction", "text": "    ", "tags": "", "loc": "CastleShapes.html#TEnumerateShapeTexturesFunction"},
     {"title": "CastleShapes.TTestShapeVisibility", "text": "    ", "tags": "", "loc": "CastleShapes.html#TTestShapeVisibility"},
     {"title": "CastleShapes.TTriangleEvent", "text": " See the <a class=\"normal\" href=\"CastleTriangles.TTriangle.html\">TTriangle</a> fields documentation for the meaning of parameters of this callback.    ", "tags": "", "loc": "CastleShapes.html#TTriangleEvent"},
     {"title": "CastleShapes.TShapeTreeList", "text": " ", "tags": "", "loc": "CastleShapes.html#TShapeTreeList"},
     {"title": "CastleShapes.TPlaceholderName", "text": " Assumes that a specific modeler was used to create and export this 3D model. Each <code>TPlaceholderName</code> function is made to follow the logic of a single modeler, and they are gathered in <a class=\"normal\" href=\"CastleShapes.html#PlaceholderNames\">PlaceholderNames</a>.  <p>Returns empty string if none.  <p>When implementing this, you may find useful the following properties of the shape: TShape.OriginalGeometry.X3DName, TShape.Node.X3DName, <a class=\"normal\" href=\"CastleShapes.TShape.html#GeometryParentNodeName\">TShape.GeometryParentNodeName</a>, <a class=\"normal\" href=\"CastleShapes.TShape.html#GeometryGrandParentNodeName\">TShape.GeometryGrandParentNodeName</a>, <a class=\"normal\" href=\"CastleShapes.TShape.html#GeometryGrandGrandParentNodeName\">TShape.GeometryGrandGrandParentNodeName</a>.  <p>Preferably, the result should be unique, only for this VRML/X3D shape. But in practice it's the responsibility of the modeler and model author to make it true. For example, modelers that allow multiple materials on object (like Blender) <i>must</i> split a single 3D object into many VRML/X3D shapes sometimes. So just don't use shapes with multiple materials if this shape may be meaningful for a placeholder.  <p>This is used only by <a class=\"normal\" href=\"CastleLevels.TGameSceneManager.html#LoadLevel\">TGameSceneManager.LoadLevel</a> placeholders. Ultimately, this should be something that is easy to set when creating a 3D model in given external modeler. <i>Nothing else in our engine depends on a particular modeler strategy for exporting VRML/X3D models.</i>  <p>This should be object name (to allow sharing a single mesh underneath). Except when it's not possible (like for old Blender VRML 1.0 exporter, when only mesh names are stored in VRML/X3D exported files), in which case it can be a mesh name.    ", "tags": "", "loc": "CastleShapes.html#TPlaceholderName"},
     {"title": "CastleShapes.DisableAutoDynamicGeometry", "text": " This is useful if you do some interactive editing of the shape, but you don't want the shape octree to be replaced by it's approximation. ", "tags": "", "loc": "CastleShapes.html#DisableAutoDynamicGeometry"},
     {"title": "CastleShapes.LogShapes", "text": " This displays quite a lot of non-critical information when opening non-trivial models.  <p>Meaningful only if you initialized log (see <a class=\"normal\" href=\"CastleLog.html\">CastleLog</a> unit) by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a> first. ", "tags": "", "loc": "CastleShapes.html#LogShapes"},
     {"title": "CastleShapes.PlaceholderNames", "text": " ", "tags": "", "loc": "CastleShapes.html#PlaceholderNames"},
     {"title": "CastleSoundEngine", "text": " ", "tags": "", "loc": "CastleSoundEngine.html"},
     {"title": "CastleSoundEngine.ENoMoreOpenALSources", "text": " ", "tags": "", "loc": "CastleSoundEngine.ENoMoreOpenALSources.html"},
     {"title": "CastleSoundEngine.ESoundBufferNotLoaded", "text": " ", "tags": "", "loc": "CastleSoundEngine.ESoundBufferNotLoaded.html"},
     {"title": "CastleSoundEngine.EInvalidSoundBufferFree", "text": " ", "tags": "", "loc": "CastleSoundEngine.EInvalidSoundBufferFree.html"},
     {"title": "CastleSoundEngine.TSoundBuffer", "text": " It can be only allocated by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#LoadBuffer\">TSoundEngine.LoadBuffer</a> and freed by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#FreeBuffer\">TSoundEngine.FreeBuffer</a>. <b>Do not free <code>TSoundBuffer</code> instances yourself.</b> ", "tags": "", "loc": "CastleSoundEngine.TSoundBuffer.html"},
     {"title": "CastleSoundEngine.TSoundBuffer.Destroy", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundBuffer.html#Destroy"},
     {"title": "CastleSoundEngine.TSoundBuffer.Duration", "text": " Zero if not loaded yet. ", "tags": "", "loc": "CastleSoundEngine.TSoundBuffer.html#Duration"},
     {"title": "CastleSoundEngine.TSound", "text": " Internally, this corresponds to an allocated OpenAL sound source. ", "tags": "", "loc": "CastleSoundEngine.TSound.html"},
     {"title": "CastleSoundEngine.TSound.Create", "text": " This allocates actual OpenAL source.     ENoMoreOpenALSources If no more sources available. It should be caught and silenced by <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#AllocateSound\">TSoundAllocator.AllocateSound</a>.", "tags": "", "loc": "CastleSoundEngine.TSound.html#Create"},
     {"title": "CastleSoundEngine.TSound.Destroy", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Destroy"},
     {"title": "CastleSoundEngine.TSound.Release", "text": "  <p>You can call this yourself if you want to stop playing the sound. It's preferable to call this (instead of manually calling alSourceStop), because this will immediately mark Used property as <code>False</code> and will call <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#OnRelease\">OnRelease</a>. Otherwise we would have to get source state at some time (they are checked in AllocateSound) and check it, then see that it's no longer playing.  <p>You can call this only when Used = <code>True</code>.    ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Release"},
     {"title": "CastleSoundEngine.TSound.PlayingOrPaused", "text": " This is almost always <code>True</code> for sounds returned by <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#AllocateSound\">TSoundAllocator.AllocateSound</a>, when it stops being <code>True</code> &mdash; the sound engine will realize it (soon), which will cause <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#Release\">Release</a> and <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#OnRelease\">OnRelease</a> being automatically called, and this <a class=\"normal\" href=\"CastleSoundEngine.TSound.html\">TSound</a> may then be reused for playing other sounds.    ", "tags": "", "loc": "CastleSoundEngine.TSound.html#PlayingOrPaused"},
     {"title": "CastleSoundEngine.TSound.KeepPlaying", "text": "  <p>This is an alternative approach to play a sound many times, like in a loop, but without using the <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#Looping\">Looping</a> property. The idea is that you leave <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#Looping\">Looping</a> set to <code>False</code>, and you keep calling this method from some &quot;update&quot; event (like some <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">TInputListener.Update</a> implementation). Once you stop calling this method, the sound will automatically stop (once it finishes the current cycle).  <p>Note that you still (as always when using <a class=\"normal\" href=\"CastleSoundEngine.TSound.html\">TSound</a>) must observe the <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#OnRelease\">TSound.OnRelease</a>. When it's called, it means that the sound engine (<a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html\">TSoundEngine</a>) decided that this sound should be used for other purposes (there's also a very small chance that the sound engine &quot;caught&quot; the sound as unused, in a short time when it stopped playing but you didn't yet call this method). In such case, you must stop doing anything with this <a class=\"normal\" href=\"CastleSoundEngine.TSound.html\">TSound</a> instance (including calling this method, <code>KeepPlaying</code>, on it). You have to start playing the sound again by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#PlaySound\">TSoundEngine.PlaySound</a> instead.  <p>Note that calling this method is better than observing <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#OnRelease\">TSound.OnRelease</a>, to start playing a new sound when the previous one stopped. That's because <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#OnRelease\">TSound.OnRelease</a> may be called with some small delay after the sound actually stopped, and it may be noticeable (e.g. in case of using this for a short rhytmic sound, like footsteps).    ", "tags": "", "loc": "CastleSoundEngine.TSound.html#KeepPlaying"},
     {"title": "CastleSoundEngine.TSound.ALSource", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#ALSource"},
     {"title": "CastleSoundEngine.TSound.Used", "text": " Sources that are not Used are simply OpenAL allocated sources that are not used right now, and will be used when we will need them. ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Used"},
     {"title": "CastleSoundEngine.TSound.Importance", "text": "  <p>Higher <code>Importance</code> means that it's more important to keep it. (I didn't name this property &quot;Priority&quot; so that it's obvious that higher <code>Importance</code> means more important sound). ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Importance"},
     {"title": "CastleSoundEngine.TSound.UserData", "text": " It should be initialized after calling <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#AllocateSound\">TSoundAllocator.AllocateSound</a>, and should be finalized in <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#OnRelease\">OnRelease</a>. ", "tags": "", "loc": "CastleSoundEngine.TSound.html#UserData"},
     {"title": "CastleSoundEngine.TSound.OnRelease", "text": " It may stop be used because there are more demanding sources (see <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#Importance\">Importance</a> and to keep MaxAllocatedSources) and we must assign this OpenAL sound slot to something else, or it may stop be used because it simply stopped playing.  <p>When this event occurs, you should forget (e.g. set to <code>Nil</code>) all your references to this sound instance. That's because this <a class=\"normal\" href=\"CastleSoundEngine.TSound.html\">TSound</a> instance may be freed (or reused for other sounds) after calling <code>OnRelease</code>. For the same reason, right after calling this event, we always clear it (set <code>OnRelease</code> to <code>Nil</code>).  <p>It's guaranteed that when this will be called, <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#Used\">Used</a> will be <code>False</code> and <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#PlayingOrPaused\">PlayingOrPaused</a> will be <code>False</code>.  <p>Note that we do not guarantee that sources that stopped playing will be immediately reported to <code>OnRelease</code>. A source may have Used = <code>True</code> state for a short time when it stopped playing (when <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#PlayingOrPaused\">PlayingOrPaused</a> is already <code>False</code>). ", "tags": "", "loc": "CastleSoundEngine.TSound.html#OnRelease"},
     {"title": "CastleSoundEngine.TSound.Position", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Position"},
     {"title": "CastleSoundEngine.TSound.Velocity", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Velocity"},
     {"title": "CastleSoundEngine.TSound.Looping", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Looping"},
     {"title": "CastleSoundEngine.TSound.Relative", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Relative"},
     {"title": "CastleSoundEngine.TSound.Gain", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Gain"},
     {"title": "CastleSoundEngine.TSound.MinGain", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#MinGain"},
     {"title": "CastleSoundEngine.TSound.MaxGain", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#MaxGain"},
     {"title": "CastleSoundEngine.TSound.Buffer", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Buffer"},
     {"title": "CastleSoundEngine.TSound.Pitch", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Pitch"},
     {"title": "CastleSoundEngine.TSound.RolloffFactor", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#RolloffFactor"},
     {"title": "CastleSoundEngine.TSound.ReferenceDistance", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#ReferenceDistance"},
     {"title": "CastleSoundEngine.TSound.MaxDistance", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSound.html#MaxDistance"},
     {"title": "CastleSoundEngine.TSound.Offset", "text": "  <p>This value will loop back to zero for looping sound sources. Setting this to something larger than the <i>sound buffer duration</i> is ignored.  <p>This offset refers to the sound like it had a <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#Pitch\">Pitch</a> equal 1.0 (when the sound is not slowed down or sped up). So this offset will vary from 0 to the <i>sound buffer duration</i>, regardless of the current <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#Pitch\">Pitch</a> value. The <i>actual</i> seconds passed since the sound started playing may be different, if you will change the <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#Pitch\">Pitch</a> to something else than 1.0.  <p>Setting this on a not-yet playing sound source (this is done by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#PlaySound\">TSoundEngine.PlaySound</a>) causes the sound to start playing from that offset. ", "tags": "", "loc": "CastleSoundEngine.TSound.html#Offset"},
     {"title": "CastleSoundEngine.TSoundList", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundList.html"},
     {"title": "CastleSoundEngine.TSoundList.SortByImportance", "text": " First all sounds with Used = <code>True</code> are placed, starting from the sound with largest Importance, and so on until the sound with smallest Importance. Then all sounds with Used = <code>False</code> are placed (in any, arbitrary order).  <p>List must not contain nil values when calling this.    ", "tags": "", "loc": "CastleSoundEngine.TSoundList.html#SortByImportance"},
     {"title": "CastleSoundEngine.TSoundAllocator", "text": "  <p>For efficiency, the pool of available sound sources (things that are actually audible at a given time) is limited. This limit is not only in OpenAL, it may also stem from sound hardware limitations, or limitations of APIs underneath OpenAL. So you cannot simply allocate new sound source for each of 100 creatures you display in the game.  <p>This class hides this limitation, by managing a pool of sound sources, and returning on demand (by <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#AllocateSound\">AllocateSound</a> method) the next unused sound source (or <code>Nil</code>). It can prioritize sound sources, it can reuse sound sources that finished playing, it can even interrupt a lower-priority sound when necessary to play a higher-priority sound.  <p>This is automatically used by higher-level comfortable methods to play sounds: <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#PlaySound\">TSoundEngine.PlaySound</a>, <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound\">TRepoSoundEngine.Sound</a> and <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound3D\">TRepoSoundEngine.Sound3D</a>. ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html"},
     {"title": "CastleSoundEngine.TSoundAllocator.DefaultMinAllocatedSources", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#DefaultMinAllocatedSources"},
     {"title": "CastleSoundEngine.TSoundAllocator.DefaultMaxAllocatedSources", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#DefaultMaxAllocatedSources"},
     {"title": "CastleSoundEngine.TSoundAllocator.Create", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#Create"},
     {"title": "CastleSoundEngine.TSoundAllocator.Destroy", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#Destroy"},
     {"title": "CastleSoundEngine.TSoundAllocator.ALVersionAtLeast", "text": " Available only when OpenAL is initialized, that is: between <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">TSoundEngine.ALContextOpen</a> and <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextClose\">TSoundEngine.ALContextClose</a>, only when <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALActive\">TSoundEngine.ALActive</a>.    ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#ALVersionAtLeast"},
     {"title": "CastleSoundEngine.TSoundAllocator.AllocateSound", "text": " You should initialize the OpenAL sound properties and start playing the sound (you have OpenAL sound identifier in <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#ALSource\">TSound.ALSource</a>).  <p>Note that if you don't call alSourcePlay, the source may be detected as unused (and recycled for another sound) at the next <code>AllocateSound</code>, PlaySound, DetectUnusedSounds and such calls.  <p>If we can't allocate new OpenAL sound, we return nil. This may happen your OpenAL context is not initialized. It may also happen if we cannot create more sources (because we hit <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#MaxAllocatedSources\">MaxAllocatedSources</a> limit, or OpenAL just refuses to create more sources) and all existing sounds are used and their Importance is &gt; given here Importance.  <p>Note for looping sounds: just like any other sound, looping sound may be stopped because the sounds are needed for other sounds. If you want to try to restart the looping sound, you will have to implement it yourself. Or you can just set Importance of looping sounds high enough, and don't use too many looping sounds, to never let them be eliminated by other sounds.    ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#AllocateSound"},
     {"title": "CastleSoundEngine.TSoundAllocator.Refresh", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#Refresh"},
     {"title": "CastleSoundEngine.TSoundAllocator.StopAllSources", "text": " Especially useful since you have to stop a source before releasing it's associated buffer.    ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#StopAllSources"},
     {"title": "CastleSoundEngine.TSoundAllocator.LoadFromConfig", "text": " For example use with <a class=\"normal\" href=\"CastleConfig.html#UserConfig\">UserConfig</a> to store sound preferences along with other user preferences. Everything is loaded / saved under the path &quot;sound/&quot; inside Config.  <p><a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html\">TSoundAllocator</a> saves <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#MinAllocatedSources\">MinAllocatedSources</a>, <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#MaxAllocatedSources\">MaxAllocatedSources</a>. Descendant <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html\">TSoundEngine</a> additionally saves current Device, Enable (unless Enable was set by --no-sound command-line option). Descendant <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html\">TRepoSoundEngine</a> additionally saves sound and music volume.  <p>    ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#LoadFromConfig"},
     {"title": "CastleSoundEngine.TSoundAllocator.SaveToConfig", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#SaveToConfig"},
     {"title": "CastleSoundEngine.TSoundAllocator.AllocatedSources", "text": " Accessing this is useful only for debugging tasks, in normal circumstances this is internal. This is <code>Nil</code> when ALContextOpen was not yet called. ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#AllocatedSources"},
     {"title": "CastleSoundEngine.TSoundAllocator.MinAllocatedSources", "text": " Always keep <code>MinAllocatedSources</code> &lt;= <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#MaxAllocatedSources\">MaxAllocatedSources</a>.  <p>For the sake of speed, we always keep allocated at least <code>MinAllocatedSources</code> OpenAL sources. This must be &gt;= 1. Setting <code>MinAllocatedSources</code> too large value will raise <a class=\"normal\" href=\"CastleSoundEngine.ENoMoreOpenALSources.html\">ENoMoreOpenALSources</a>.  <p>At most <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#MaxAllocatedSources\">MaxAllocatedSources</a> sources may be simultaneously used (played). This prevents us from allocating too many sounds, which would be bad for OpenAL speed (not to mention that it may be impossible under some OpenAL implementations, like Windows one). When all <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#MaxAllocatedSources\">MaxAllocatedSources</a> sources are playing, the only way to play another sound is to use appropriately high <code>Importance</code> to <a class=\"normal\" href=\"CastleSoundEngine.TSoundAllocator.html#AllocateSound\">AllocateSound</a>.  <p> ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#MinAllocatedSources"},
     {"title": "CastleSoundEngine.TSoundAllocator.MaxAllocatedSources", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundAllocator.html#MaxAllocatedSources"},
     {"title": "CastleSoundEngine.TSoundDevice", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundDevice.html"},
     {"title": "CastleSoundEngine.TSoundDevice.Name", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundDevice.html#Name"},
     {"title": "CastleSoundEngine.TSoundDevice.Caption", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundDevice.html#Caption"},
     {"title": "CastleSoundEngine.TSoundDevice.NiceName", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundDevice.html#NiceName"},
     {"title": "CastleSoundEngine.TSoundParameters", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html"},
     {"title": "CastleSoundEngine.TSoundParameters.Buffer", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#Buffer"},
     {"title": "CastleSoundEngine.TSoundParameters.Spatial", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#Spatial"},
     {"title": "CastleSoundEngine.TSoundParameters.Looping", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#Looping"},
     {"title": "CastleSoundEngine.TSoundParameters.Importance", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#Importance"},
     {"title": "CastleSoundEngine.TSoundParameters.Gain", "text": " <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html#MinGain\">MinGain</a> and <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html#MaxGain\">MaxGain</a> determine how it can change because of spatialization (where the sound may get quieter / louder as you get further / closer to it). By default, Gain and <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html#MaxGain\">MaxGain</a> are 1.0, and <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html#MinGain\">MinGain</a> is 0.0. ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#Gain"},
     {"title": "CastleSoundEngine.TSoundParameters.MinGain", "text": " <code>MinGain</code> and <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html#MaxGain\">MaxGain</a> determine how it can change because of spatialization (where the sound may get quieter / louder as you get further / closer to it). By default, Gain and <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html#MaxGain\">MaxGain</a> are 1.0, and <code>MinGain</code> is 0.0. ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#MinGain"},
     {"title": "CastleSoundEngine.TSoundParameters.MaxGain", "text": " <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html#MinGain\">MinGain</a> and <code>MaxGain</code> determine how it can change because of spatialization (where the sound may get quieter / louder as you get further / closer to it). By default, Gain and <code>MaxGain</code> are 1.0, and <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html#MinGain\">MinGain</a> is 0.0. ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#MaxGain"},
     {"title": "CastleSoundEngine.TSoundParameters.Position", "text": " Used only if <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html#Spatial\">Spatial</a> = <code>True</code>. ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#Position"},
     {"title": "CastleSoundEngine.TSoundParameters.Pitch", "text": " By default it is 1.0. ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#Pitch"},
     {"title": "CastleSoundEngine.TSoundParameters.RolloffFactor", "text": " The <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#DefaultRolloffFactor\">TSoundEngine.DefaultRolloffFactor</a> is also the default value of this field. ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#RolloffFactor"},
     {"title": "CastleSoundEngine.TSoundParameters.ReferenceDistance", "text": " The <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#DefaultReferenceDistance\">TSoundEngine.DefaultReferenceDistance</a> is also the default value of this field. ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#ReferenceDistance"},
     {"title": "CastleSoundEngine.TSoundParameters.MaxDistance", "text": " The <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#DefaultMaxDistance\">TSoundEngine.DefaultMaxDistance</a> is also the default value of this field. ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#MaxDistance"},
     {"title": "CastleSoundEngine.TSoundParameters.Offset", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#Offset"},
     {"title": "CastleSoundEngine.TSoundParameters.Create", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundParameters.html#Create"},
     {"title": "CastleSoundEngine.TSoundEngine", "text": "  <p>There should always be only one instance of this class, accessed through the global <a class=\"normal\" href=\"CastleSoundEngine.html#SoundEngine\">SoundEngine</a> variable. See docs at <a class=\"normal\" href=\"CastleSoundEngine.html#SoundEngine\">SoundEngine</a> for more details.  <p>The sound engine is actually a wrapper over OpenAL. You can explicitly initialize OpenAL context by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a>, and explicitly close it by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextClose\">ALContextClose</a>. If you did not call <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a> explicitly (that is, <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALInitialized\">ALInitialized</a> is <code>False</code>), then the first <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#LoadBuffer\">LoadBuffer</a> or <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound\">TRepoSoundEngine.Sound</a> or TRepoSoundEngine.Sound3D will automatically do it for you. If you do not call <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextClose\">ALContextClose</a> explicitly, then at destructor we'll do it automatically. ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultVolume", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultVolume"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultDefaultRolloffFactor", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultDefaultRolloffFactor"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultDefaultReferenceDistance", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultDefaultReferenceDistance"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultDefaultMaxDistance", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultDefaultMaxDistance"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultDistanceModel", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultDistanceModel"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultDevice", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultDevice"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultEnabled", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultEnabled"},
     {"title": "CastleSoundEngine.TSoundEngine.Create", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#Create"},
     {"title": "CastleSoundEngine.TSoundEngine.Destroy", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#Destroy"},
     {"title": "CastleSoundEngine.TSoundEngine.ALContextOpen", "text": " Initializes OpenAL library. Sets <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALInitialized\">ALInitialized</a>, <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALActive\">ALActive</a>, <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Information\">Information</a>, <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#EFXSupported\">EFXSupported</a>.  <p>You can set <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Device\">Device</a> before calling this.  <p>Note that we continue (without any exception) if the initialization failed for any reason (maybe OpenAL library is not available, or no sound output device is available). You can check <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALActive\">ALActive</a> and <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Information\">Information</a> to know if the initialization was actually successfull. But you can also ignore it, the sound engine will silently (literally) keep working even if OpenAL could not be initialized.    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#ALContextOpen"},
     {"title": "CastleSoundEngine.TSoundEngine.ALContextClose", "text": " This sets <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALInitialized\">ALInitialized</a> and <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALActive\">ALActive</a> to <code>False</code>. It's allowed and harmless to call this when one of them is already <code>False</code>.    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#ALContextClose"},
     {"title": "CastleSoundEngine.TSoundEngine.LoadFromConfig", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#LoadFromConfig"},
     {"title": "CastleSoundEngine.TSoundEngine.SaveToConfig", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#SaveToConfig"},
     {"title": "CastleSoundEngine.TSoundEngine.ALVersionAtLeast", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#ALVersionAtLeast"},
     {"title": "CastleSoundEngine.TSoundEngine.GetContextString", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#GetContextString"},
     {"title": "CastleSoundEngine.TSoundEngine.LoadBuffer", "text": "  <p>This method tries to initialize OpenAL context, and internally load the buffer contents to OpenAL. But even when it fails, it still returns a valid (non-nil) <a class=\"normal\" href=\"CastleSoundEngine.TSoundBuffer.html\">TSoundBuffer</a> instance. The <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#PlaySound\">PlaySound</a> must be ready anyway to always load the buffer on-demand (because OpenAL context may be lost while the game is ongoing, in case of Android).  <p>The buffer should be released by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#FreeBuffer\">FreeBuffer</a> later when it's not needed. Although we will take care to always free remaining buffers before closing OpenAL context anyway.  <p>We have a cache of sound files here. An absolute URL will be recorded as being loaded to given buffer. Loading the same URL second time returns the same buffer instance. The buffer is released only once you call <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#FreeBuffer\">FreeBuffer</a> as many times as you called <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#LoadBuffer\">LoadBuffer</a> for it.  <p>  <p>    ESoundFileError If loading of this sound file failed. There are many reasons why this may happen: we cannot read given URL, or it may contain invalid contents, or a library required to decompress e.g. OggVorbis is missing.", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#LoadBuffer"},
     {"title": "CastleSoundEngine.TSoundEngine.LoadBuffer", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#LoadBuffer"},
     {"title": "CastleSoundEngine.TSoundEngine.FreeBuffer", "text": " Ignored when buffer is <code>Nil</code>. Buffer is always set to <code>Nil</code> after this.  <p>    ESoundBufferNotLoaded When invalid (not <code>Nil</code>, and not returned by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#LoadBuffer\">LoadBuffer</a>) buffer identifier is given.", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#FreeBuffer"},
     {"title": "CastleSoundEngine.TSoundEngine.PlaySound", "text": "  <p>We use a smart OpenAL sound allocator, so the sound will be actually played only if resources allow. Use higher Importance to indicate sounds that are more important to play.  <p>We set the sound properties and start playing it.  <p>Both spatialized (3D) and not sounds are possible. See the <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html\">TSoundParameters</a> for a full list of sound parameters. You can pass all the sound parameters as a <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html\">TSoundParameters</a> instance. You can destroy the <a class=\"normal\" href=\"CastleSoundEngine.TSoundParameters.html\">TSoundParameters</a> instance right after calling this method, the reference to it is not saved anywhere.  <p>   The allocated sound as <a class=\"normal\" href=\"CastleSoundEngine.TSound.html\">TSound</a>.  <p>Returns <code>Nil</code> when there were no resources to play another sound (and it wasn't important enough to override another sound). Always returns <code>Nil</code> when SoundBuffer is zero (indicating that buffer was not loaded).  <p>In simple cases you can just ignore the result of this method. In advanced cases, you can use it to observe and update the sound later. ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#PlaySound"},
     {"title": "CastleSoundEngine.TSoundEngine.PlaySound", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#PlaySound"},
     {"title": "CastleSoundEngine.TSoundEngine.PlaySound", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#PlaySound"},
     {"title": "CastleSoundEngine.TSoundEngine.PlaySound", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#PlaySound"},
     {"title": "CastleSoundEngine.TSoundEngine.ParseParameters", "text": " Internally it uses Parameters.Parse with ParseOnlyKnownLongOptions = <code>True</code>. Recognized options:  <p></p>  <dl class=\"paragraph_spacing\">   <dt>--audio-device DEVICE-NAME</dt>   <dd><p>Set <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Device\">Device</a> variable to given argument.</p></dd>   <dt>--no-sound</dt>   <dd><p>Disable any sound (sets <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Enable\">Enable</a> to <code>False</code>).</p></dd> </dl>  <p>  <p>More user-oriented documentation for the above options is here: [<a  href=\"http://castle-engine.sourceforge.net/openal_notes.php#section_options\">http://castle-engine.sourceforge.net/openal_notes.php#section_options</a>]    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#ParseParameters"},
     {"title": "CastleSoundEngine.TSoundEngine.ParseParametersHelp", "text": "  <p>Note that it also lists the available OpenAL <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Devices\">Devices</a>, as they are valid arguments for the --audio-device option.    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#ParseParametersHelp"},
     {"title": "CastleSoundEngine.TSoundEngine.UpdateListener", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#UpdateListener"},
     {"title": "CastleSoundEngine.TSoundEngine.Devices", "text": " Read-only.  <p>Use <code>Devices[].Name</code> as <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Device\">Device</a> values. On some OpenAL implementations, some other <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Device\">Device</a> values may be possible, e.g. old Loki implementation allowed some hints to be encoded in Lisp-like language inside the <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Device\">Device</a> string.    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#Devices"},
     {"title": "CastleSoundEngine.TSoundEngine.DeviceNiceName", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DeviceNiceName"},
     {"title": "CastleSoundEngine.TSoundEngine.DeviceCaption", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DeviceCaption"},
     {"title": "CastleSoundEngine.TSoundEngine.ALActive", "text": " This is <code>True</code> when you successfully called <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a> (and you didn't call <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextClose\">ALContextClose</a> yet). This also implies that OpenAL library is loaded. ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#ALActive"},
     {"title": "CastleSoundEngine.TSoundEngine.ALInitialized", "text": " This indicates that <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a> was called, and not closed with <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextClose\">ALContextClose</a> yet. Contrary to <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALActive\">ALActive</a>, this <i>doesn't care if <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a> was a success</i>. ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#ALInitialized"},
     {"title": "CastleSoundEngine.TSoundEngine.EFXSupported", "text": " Meaningful only when <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALActive\">ALActive</a>, that is it's initialized by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a>. ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#EFXSupported"},
     {"title": "CastleSoundEngine.TSoundEngine.SoundInitializationReport", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#SoundInitializationReport"},
     {"title": "CastleSoundEngine.TSoundEngine.Information", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#Information"},
     {"title": "CastleSoundEngine.TSoundEngine.OnOpenClose", "text": " More precisely, when <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALInitialized\">ALInitialized</a> changes (and so, possibly, <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALActive\">ALActive</a> changed). ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#OnOpenClose"},
     {"title": "CastleSoundEngine.TSoundEngine.EnableSaveToConfig", "text": " This is always reset to <code>True</code> after setting <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Enable\">Enable</a> value. ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#EnableSaveToConfig"},
     {"title": "CastleSoundEngine.TSoundEngine.Volume", "text": " This must always be within 0..1 range. 0.0 means that there are no effects (this case should be optimized). ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#Volume"},
     {"title": "CastleSoundEngine.TSoundEngine.Device", "text": "  <p>You can change it even when OpenAL is already initialized. Then we'll close the old device (<a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextClose\">ALContextClose</a>), change <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Device\">Device</a> value, and initialize context again (<a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a>). Note that you will need to reload your buffers and sources again. ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#Device"},
     {"title": "CastleSoundEngine.TSoundEngine.Enabled", "text": "  <p>If <code>False</code>, then <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a> will not initialize any OpenAL device. This is useful if you simply want to disable any sound output (or OpenAL usage), even when OpenAL library is available.  <p>If the OpenAL context is already initialized when setting this, we will eventually close it. (More precisely, we will do <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextClose\">ALContextClose</a> and then <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a> again. This behaves correctly.) ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#Enabled"},
     {"title": "CastleSoundEngine.TSoundEngine.Enable", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#Enable"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultRolloffFactor", "text": " These are used only for spatialized sounds created with <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#PlaySound\">PlaySound</a>. The <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#DefaultReferenceDistance\">DefaultReferenceDistance</a> and <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#DefaultMaxDistance\">DefaultMaxDistance</a> values are used only if you don't supply explicit values to <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#PlaySound\">PlaySound</a>.  <p>The exact interpretation of these depends on current <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#DistanceModel\">DistanceModel</a>. See OpenAL specification for exact equations. In short:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Smaller Rolloff Factor makes the attenuation weaker. In particular 0 turns off attenuation by distance. Default is 1.</p></li>   <li><p>Reference Distance is the distance at which exactly sound gain is heard. Default is 1.</p></li>   <li><p>Max Distance interpretation depends on the model. For &quot;inverse clamped model&quot;, the gain is no longer scaled down after reaching this distance. For linear models, the gain reaches zero at this distance. Default is maximum float (I don't know the interpretation of this for linear model).</p></li> </ul>  <p>  <p>Our default values follow OpenAL default values.  ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultRolloffFactor"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultReferenceDistance", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultReferenceDistance"},
     {"title": "CastleSoundEngine.TSoundEngine.DefaultMaxDistance", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DefaultMaxDistance"},
     {"title": "CastleSoundEngine.TSoundEngine.DistanceModel", "text": " For precise meaning, see OpenAL specification of alDistanceModel.  <p>Note that some models are actually available only since OpenAL 1.1 version. Older OpenAL versions may (but don't have to) support them through extensions. We will internally do everything possible to request given model, but eventually may fallback on some other model. This probably will not be a problem in practice, as all modern OS versions (Linux distros, Windows OpenAL installers etc.) include OpenAL 1.1.  <p>The default distance model, <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#DefaultDistanceModel\">DefaultDistanceModel</a>, is the linear model most conforming to VRML/X3D sound requirements. You can change it if you want (for example, OpenAL default is <a class=\"normal\" href=\"CastleSoundEngine.html#dmInverseDistanceClamped\">dmInverseDistanceClamped</a>). ", "tags": "", "loc": "CastleSoundEngine.TSoundEngine.html#DistanceModel"},
     {"title": "CastleSoundEngine.TSoundInfo", "text": " Most fields of this classs correspond to appropriate attributes in the XML file loaded by setting <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#RepositoryURL\">TRepoSoundEngine.RepositoryURL</a>. ", "tags": "", "loc": "CastleSoundEngine.TSoundInfo.html"},
     {"title": "CastleSoundEngine.TSoundInfo.Name", "text": " Empty for the special sound <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>. ", "tags": "", "loc": "CastleSoundEngine.TSoundInfo.html#Name"},
     {"title": "CastleSoundEngine.TSoundInfo.URL", "text": "  <p>Empty means that the sound data is not defined, so the OpenAL buffer will not be initialized and trying to play this sound (with methods like TSoundEngine.Sound or TSoundEngine.Sound3D) will do nothing. This is useful if you want to use a sound name in code, but you do not have the actual sound file for this yet. ", "tags": "", "loc": "CastleSoundEngine.TSoundInfo.html#URL"},
     {"title": "CastleSoundEngine.TSoundInfo.Gain", "text": " They are mapped directly to respective OpenAL source properties, so see OpenAL specification for exact details what they mean. In short:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Gain scales the sound loudness. Use this to indicate that e.g. a plane engine is louder than a mouse squeak (when heard from the same distance).  <p>Do <i>not</i> make the actual sound data (in wav, ogg and such files) louder/more silent for this purpose. This is usually bad for sound quality. Instead, keep your sound data at max loudness (normalized), and use this <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#Gain\">Gain</a> property to scale sound.  <p>It can be antything from 0 to +infinity. The default is 1.</p></li>   <li><p><a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MinGain\">MinGain</a> and <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MaxGain\">MaxGain</a> force a minimum/maximum sound loudness. These can be used to &quot;cheat&quot; around default distance attenuation calculation.  <p>These must be in [0, 1] range. By default <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MinGain\">MinGain</a> is 0 and <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MaxGain\">MaxGain</a> is 1.</p></li> </ul>  <p>  <p>Note that Gain value &gt; 1 is allowed. Although OpenAL may clip the resulting sound (after all calculations taking into account 3D position will be done). The resulting sound is also clamped by <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MaxGain\">MaxGain</a> (that generally must be in [0, 1], although some OpenAL implementations allow values &gt; 1).  <p>When this sound is used for MusicPlayer.Sound: </p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MinGain\">MinGain</a>, <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MaxGain\">MaxGain</a> are ignored.</p></li>   <li value=\"2\"><p>Effective Gain (passed to OpenAL sound source) is the <a class=\"normal\" href=\"CastleSoundEngine.TMusicPlayer.html#MusicVolume\">TMusicPlayer.MusicVolume</a> multiplied by our <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#Gain\">Gain</a>.</p></li> </ol>  <p> ", "tags": "", "loc": "CastleSoundEngine.TSoundInfo.html#Gain"},
     {"title": "CastleSoundEngine.TSoundInfo.MinGain", "text": " They are mapped directly to respective OpenAL source properties, so see OpenAL specification for exact details what they mean. In short:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Gain scales the sound loudness. Use this to indicate that e.g. a plane engine is louder than a mouse squeak (when heard from the same distance).  <p>Do <i>not</i> make the actual sound data (in wav, ogg and such files) louder/more silent for this purpose. This is usually bad for sound quality. Instead, keep your sound data at max loudness (normalized), and use this <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#Gain\">Gain</a> property to scale sound.  <p>It can be antything from 0 to +infinity. The default is 1.</p></li>   <li><p><code>MinGain</code> and <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MaxGain\">MaxGain</a> force a minimum/maximum sound loudness. These can be used to &quot;cheat&quot; around default distance attenuation calculation.  <p>These must be in [0, 1] range. By default <code>MinGain</code> is 0 and <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MaxGain\">MaxGain</a> is 1.</p></li> </ul>  <p>  <p>Note that Gain value &gt; 1 is allowed. Although OpenAL may clip the resulting sound (after all calculations taking into account 3D position will be done). The resulting sound is also clamped by <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MaxGain\">MaxGain</a> (that generally must be in [0, 1], although some OpenAL implementations allow values &gt; 1).  <p>When this sound is used for MusicPlayer.Sound: </p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><code>MinGain</code>, <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MaxGain\">MaxGain</a> are ignored.</p></li>   <li value=\"2\"><p>Effective Gain (passed to OpenAL sound source) is the <a class=\"normal\" href=\"CastleSoundEngine.TMusicPlayer.html#MusicVolume\">TMusicPlayer.MusicVolume</a> multiplied by our <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#Gain\">Gain</a>.</p></li> </ol>  <p> ", "tags": "", "loc": "CastleSoundEngine.TSoundInfo.html#MinGain"},
     {"title": "CastleSoundEngine.TSoundInfo.MaxGain", "text": " They are mapped directly to respective OpenAL source properties, so see OpenAL specification for exact details what they mean. In short:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Gain scales the sound loudness. Use this to indicate that e.g. a plane engine is louder than a mouse squeak (when heard from the same distance).  <p>Do <i>not</i> make the actual sound data (in wav, ogg and such files) louder/more silent for this purpose. This is usually bad for sound quality. Instead, keep your sound data at max loudness (normalized), and use this <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#Gain\">Gain</a> property to scale sound.  <p>It can be antything from 0 to +infinity. The default is 1.</p></li>   <li><p><a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MinGain\">MinGain</a> and <code>MaxGain</code> force a minimum/maximum sound loudness. These can be used to &quot;cheat&quot; around default distance attenuation calculation.  <p>These must be in [0, 1] range. By default <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MinGain\">MinGain</a> is 0 and <code>MaxGain</code> is 1.</p></li> </ul>  <p>  <p>Note that Gain value &gt; 1 is allowed. Although OpenAL may clip the resulting sound (after all calculations taking into account 3D position will be done). The resulting sound is also clamped by <code>MaxGain</code> (that generally must be in [0, 1], although some OpenAL implementations allow values &gt; 1).  <p>When this sound is used for MusicPlayer.Sound: </p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#MinGain\">MinGain</a>, <code>MaxGain</code> are ignored.</p></li>   <li value=\"2\"><p>Effective Gain (passed to OpenAL sound source) is the <a class=\"normal\" href=\"CastleSoundEngine.TMusicPlayer.html#MusicVolume\">TMusicPlayer.MusicVolume</a> multiplied by our <a class=\"normal\" href=\"CastleSoundEngine.TSoundInfo.html#Gain\">Gain</a>.</p></li> </ol>  <p> ", "tags": "", "loc": "CastleSoundEngine.TSoundInfo.html#MaxGain"},
     {"title": "CastleSoundEngine.TSoundInfo.DefaultImportance", "text": " Influences what happens when we have a lot of sounds playing at once. See <a class=\"normal\" href=\"CastleSoundEngine.TSound.html#Importance\">TSound.Importance</a>.  <p>Ignored when this sound is used for MusicPlayer.Sound. ", "tags": "", "loc": "CastleSoundEngine.TSoundInfo.html#DefaultImportance"},
     {"title": "CastleSoundEngine.TSoundType", "text": " ", "tags": "", "loc": "CastleSoundEngine.TSoundType.html"},
     {"title": "CastleSoundEngine.TSoundType.Info", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundType.html#Info"},
     {"title": "CastleSoundEngine.TSoundType.=", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TSoundType.html#="},
     {"title": "CastleSoundEngine.TRepoSoundEngine", "text": " This allows to have simple <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound\">Sound</a> and <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound3D\">Sound3D</a> methods, that take a sound identifier (managing sound buffers will just happen automatically under the hood).  <p>It extends <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html\">TSoundEngine</a>, so you can always still load new buffers and play them by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#LoadBuffer\">TSoundEngine.LoadBuffer</a>, <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#PlaySound\">TSoundEngine.PlaySound</a> and all other methods. This only adds easy preloaded sounds, but you're not limited to them.  <p>To initialize your sounds repository, you have to set the <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#RepositoryURL\">RepositoryURL</a> property. ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.Create", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#Create"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.Destroy", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#Destroy"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.LoadFromConfig", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#LoadFromConfig"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.SaveToConfig", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#SaveToConfig"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.ReloadSounds", "text": " Useful as a tool for game designers, to reload the sounds XML file without restarting the game and sound engine.    ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#ReloadSounds"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.SoundFromName", "text": " Available names are given in SoundNames, defined in XML file pointed by <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#RepositoryURL\">RepositoryURL</a>. Always for SoundName = '' it will return <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>.  <p>  Required <p>If Required = <code>True</code>, it will make a warning when the sound name is not found. This may mean that sound is missing in your sounds.xml file (so you should correct your sounds.xml), or that you didn't load the sounds.xml file yet (so you should correct your code to set <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#RepositoryURL\">TRepoSoundEngine.RepositoryURL</a> early enough), or that you specified invalid sound name. When Required = <code>False</code>, missing sound is silently ignored, which is sensible if it was optional.  <p>Regardless of the Required value, we return <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a> for missing sound. So the Required parameter only determines whether we make a warning, or not.  Required <p>If Required = <code>True</code>, it will make a warning when the sound name is not found. This may mean that sound is missing in your sounds.xml file (so you should correct your sounds.xml), or that you didn't load the sounds.xml file yet (so you should correct your code to set <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#RepositoryURL\">TRepoSoundEngine.RepositoryURL</a> early enough), or that you specified invalid sound name. When Required = <code>False</code>, missing sound is silently ignored, which is sensible if it was optional.  <p>Regardless of the Required value, we return <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a> for missing sound. So the Required parameter only determines whether we make a warning, or not.", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#SoundFromName"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.Sound", "text": " This should be used to play sounds that are not spatial, i.e. have no place in 3D space.  <p>Returns used <a class=\"normal\" href=\"CastleSoundEngine.TSound.html\">TSound</a> (or nil if none was available). You don't have to do anything with this returned <a class=\"normal\" href=\"CastleSoundEngine.TSound.html\">TSound</a>.    ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#Sound"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.Sound3D", "text": "  <p>Returns used <a class=\"normal\" href=\"CastleSoundEngine.TSound.html\">TSound</a> (or nil if none was available). You don't have to do anything with this returned <a class=\"normal\" href=\"CastleSoundEngine.TSound.html\">TSound</a>.  <p>    ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#Sound3D"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.AddSoundImportanceName", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#AddSoundImportanceName"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.RepositoryURL", "text": " This should be an URL (in simple cases, just a filename) pointing to an XML file describing your sounds. See <a  href=\"http://castle-engine.sourceforge.net/creating_data_sound.php\">http://castle-engine.sourceforge.net/creating_data_sound.php</a> and engine examples for details (<code>examples/audio/sample_sounds.xml</code> contains an example file with lots of comments).  <p>When you set <code>RepositoryURL</code> property, we read sound <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#Information\">information</a> from given XML file. You usually set <code>RepositoryURL</code> at the very beginning, before OpenAL context is initialized (although it's also Ok to do this after). Right after setting <code>RepositoryURL</code> you usually call <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#SoundFromName\">SoundFromName</a> a couple of times to convert some names into <a class=\"normal\" href=\"CastleSoundEngine.TSoundType.html\">TSoundType</a> values, to later use these <a class=\"normal\" href=\"CastleSoundEngine.TSoundType.html\">TSoundType</a> values with <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound\">Sound</a> and <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound3D\">Sound3D</a> methods.  <p>When OpenAL is initialized, sound buffers will actually be loaded.  <p>If this is empty (the default), then no sounds are loaded, and <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html\">TRepoSoundEngine</a> doesn't really give you much above standard <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html\">TSoundEngine</a>.  <p>If you want to actually use <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html\">TRepoSoundEngine</a> features (like the <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound\">Sound</a> and <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound3D\">Sound3D</a> methods) you have to set this property. For example like this:  <p></p>  <pre class=\"longcode\"> SoundEngine.RepositoryURL := ApplicationData(<span class=\"pascal_string\">'sounds.xml'</span>); stMySound1 := SoundEngine.SoundFromName(<span class=\"pascal_string\">'my_sound_1'</span>); stMySound2 := SoundEngine.SoundFromName(<span class=\"pascal_string\">'my_sound_2'</span>); <span class=\"pascal_comment\">// ... and later in your game you can do stuff like this:</span> SoundEngine.Sound(stMySound1); SoundEngine.Sound3D(stMySound1, Vector3(<span class=\"pascal_numeric\">0</span>, <span class=\"pascal_numeric\">0</span>, <span class=\"pascal_numeric\">10</span>));</pre>  <p>  <p>See <a class=\"normal\" href=\"CastleFilesUtils.html\">CastleFilesUtils</a> unit for docs of <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationData\">ApplicationData</a> function. ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#RepositoryURL"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.SoundsFileName", "text": "  ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#SoundsFileName"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.Sounds", "text": " Each sound has a unique name, used to identify sound in the XML file and for <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#SoundFromName\">SoundFromName</a> function.  <p>At the beginning, this list always contains exactly one sound: empty <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>. This is a special &quot;sound type&quot; that has index 0 (should be always expressed as <a class=\"normal\" href=\"CastleSoundEngine.TSoundType.html\">TSoundType</a> value <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>) and name ''. <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a> is a special sound as it actually means &quot;no sound&quot; in many cases. ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#Sounds"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.SoundImportanceNames", "text": " Each item is a name (as a string) and a value (that is stored in Objects property of the item as a pointer; add new importances by <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#AddSoundImportanceName\">AddSoundImportanceName</a> for comfort).  <p>These can be used within sounds.xml file. Before using <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ALContextOpen\">ALContextOpen</a>, you can fill this list with values.  <p>Initially, it contains a couple of useful values (ordered here from most to least important):  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>'max' - <a class=\"normal\" href=\"CastleSoundEngine.html#MaxSoundImportance\">MaxSoundImportance</a></p></li>   <li><p>'level_event' - <a class=\"normal\" href=\"CastleSoundEngine.html#LevelEventSoundImportance\">LevelEventSoundImportance</a></p></li>   <li><p>'player' - <a class=\"normal\" href=\"CastleSoundEngine.html#PlayerSoundImportance\">PlayerSoundImportance</a></p></li>   <li><p>'default_creature' - <a class=\"normal\" href=\"CastleSoundEngine.html#DefaultCreatureSoundImportance\">DefaultCreatureSoundImportance</a></p></li>   <li><p>'minor_non_spatial' - <a class=\"normal\" href=\"CastleSoundEngine.html#MinorNonSpatialSoundImportance\">MinorNonSpatialSoundImportance</a></p></li> </ul>  <p> ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#SoundImportanceNames"},
     {"title": "CastleSoundEngine.TRepoSoundEngine.MusicPlayer", "text": " ", "tags": "", "loc": "CastleSoundEngine.TRepoSoundEngine.html#MusicPlayer"},
     {"title": "CastleSoundEngine.TMusicPlayer", "text": " Instance of this class should be created only internally by the <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html\">TRepoSoundEngine</a>, always use this through <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#MusicPlayer\">TRepoSoundEngine.MusicPlayer</a>. ", "tags": "", "loc": "CastleSoundEngine.TMusicPlayer.html"},
     {"title": "CastleSoundEngine.TMusicPlayer.DefaultMusicVolume", "text": " ", "tags": "", "loc": "CastleSoundEngine.TMusicPlayer.html#DefaultMusicVolume"},
     {"title": "CastleSoundEngine.TMusicPlayer.Create", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TMusicPlayer.html#Create"},
     {"title": "CastleSoundEngine.TMusicPlayer.Destroy", "text": "    ", "tags": "", "loc": "CastleSoundEngine.TMusicPlayer.html#Destroy"},
     {"title": "CastleSoundEngine.TMusicPlayer.Sound", "text": " Set to <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a> to stop playing music. Set to anything else to play that music.  <p>Changing value of this property (when both the old and new values are &lt;&gt; <a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a> and are different) restarts playing the music.  <p>By default none (<a class=\"normal\" href=\"CastleSoundEngine.html#stNone\">stNone</a>). ", "tags": "", "loc": "CastleSoundEngine.TMusicPlayer.html#Sound"},
     {"title": "CastleSoundEngine.TMusicPlayer.MusicVolume", "text": " This must always be within 0..1 range. 0.0 means that there is no music (this case should be optimized). ", "tags": "", "loc": "CastleSoundEngine.TMusicPlayer.html#MusicVolume"},
     {"title": "CastleSoundEngine.stNone", "text": " <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound\">TRepoSoundEngine.Sound</a> and <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html#Sound3D\">TRepoSoundEngine.Sound3D</a> will do nothing when called with this sound type. ", "tags": "", "loc": "CastleSoundEngine.html#stNone"},
     {"title": "CastleSoundEngine.MaxSoundImportance", "text": " ", "tags": "", "loc": "CastleSoundEngine.html#MaxSoundImportance"},
     {"title": "CastleSoundEngine.LevelEventSoundImportance", "text": " ", "tags": "", "loc": "CastleSoundEngine.html#LevelEventSoundImportance"},
     {"title": "CastleSoundEngine.PlayerSoundImportance", "text": " ", "tags": "", "loc": "CastleSoundEngine.html#PlayerSoundImportance"},
     {"title": "CastleSoundEngine.DefaultCreatureSoundImportance", "text": " ", "tags": "", "loc": "CastleSoundEngine.html#DefaultCreatureSoundImportance"},
     {"title": "CastleSoundEngine.MinorNonSpatialSoundImportance", "text": " ", "tags": "", "loc": "CastleSoundEngine.html#MinorNonSpatialSoundImportance"},
     {"title": "CastleSoundEngine.SoundEngine", "text": " Singleton instance of <a class=\"normal\" href=\"CastleSoundEngine.TRepoSoundEngine.html\">TRepoSoundEngine</a>, the most capable engine class. Created on first call to this function.    ", "tags": "", "loc": "CastleSoundEngine.html#SoundEngine"},
     {"title": "CastleSoundEngine.ESoundFileError", "text": " ", "tags": "", "loc": "CastleSoundEngine.html#ESoundFileError"},
     {"title": "CastleSoundEngine.TSoundEvent", "text": "    ", "tags": "", "loc": "CastleSoundEngine.html#TSoundEvent"},
     {"title": "CastleSoundEngine.TSoundDistanceModel", "text": "  dmNone    dmInverseDistance    dmInverseDistanceClamped    dmLinearDistance    dmLinearDistanceClamped    dmExponentDistance    dmExponentDistanceClamped   ", "tags": "", "loc": "CastleSoundEngine.html#TSoundDistanceModel"},
     {"title": "CastleSoundEngine.TSoundDeviceList", "text": " ", "tags": "", "loc": "CastleSoundEngine.html#TSoundDeviceList"},
     {"title": "CastleSoundEngine.TSoundInfoList", "text": " ", "tags": "", "loc": "CastleSoundEngine.html#TSoundInfoList"},
     {"title": "CastleSoundEngine.stPlayerInteractFailed", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerInteractFailed"},
     {"title": "CastleSoundEngine.stPlayerPickItem", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerPickItem"},
     {"title": "CastleSoundEngine.stPlayerDropItem", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerDropItem"},
     {"title": "CastleSoundEngine.stPlayerSwimming", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerSwimming"},
     {"title": "CastleSoundEngine.stPlayerDrowning", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerDrowning"},
     {"title": "CastleSoundEngine.stPlayerFootstepsDefault", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerFootstepsDefault"},
     {"title": "CastleSoundEngine.stPlayerToxicPain", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerToxicPain"},
     {"title": "CastleSoundEngine.stPlayerSuddenPain", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerSuddenPain"},
     {"title": "CastleSoundEngine.stPlayerDies", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerDies"},
     {"title": "CastleSoundEngine.stPlayerSwimmingChange", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stPlayerSwimmingChange"},
     {"title": "CastleSoundEngine.stMenuCurrentItemChanged", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stMenuCurrentItemChanged"},
     {"title": "CastleSoundEngine.stMenuClick", "text": "  ", "tags": "", "loc": "CastleSoundEngine.html#stMenuClick"},
     {"title": "CastleSoundMenu", "text": " ", "tags": "", "loc": "CastleSoundMenu.html"},
     {"title": "CastleSoundMenu.TSoundInfoMenuItem", "text": " Simply add it to your <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html\">TCastleOnScreenMenu</a> like  <p></p>  <pre class=\"longcode\"> OnScreenMenu.Add(TSoundInfoMenuItem.Create(OnScreenMenu));</pre>  <p>  <p>Also be sure to assign Application.MainWindow, it is used as the window from which we show modal dialog box with sound information. ", "tags": "", "loc": "CastleSoundMenu.TSoundInfoMenuItem.html"},
     {"title": "CastleSoundMenu.TSoundInfoMenuItem.Create", "text": "    ", "tags": "", "loc": "CastleSoundMenu.TSoundInfoMenuItem.html#Create"},
     {"title": "CastleSoundMenu.TMenuVolumeSlider", "text": " Range is always [0 .. 1] and when the slider is exactly on 0.0 position it shows &quot;Off&quot;. ", "tags": "", "loc": "CastleSoundMenu.TMenuVolumeSlider.html"},
     {"title": "CastleSoundMenu.TMenuVolumeSlider.ValueToStr", "text": "    ", "tags": "", "loc": "CastleSoundMenu.TMenuVolumeSlider.html#ValueToStr"},
     {"title": "CastleSoundMenu.TSoundVolumeMenuItem", "text": " Simply add it to your <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html\">TCastleOnScreenMenu</a> like  <p></p>  <pre class=\"longcode\"> OnScreenMenu.Add(TSoundVolumeMenuItem.Create(OnScreenMenu));</pre>  <p> ", "tags": "", "loc": "CastleSoundMenu.TSoundVolumeMenuItem.html"},
     {"title": "CastleSoundMenu.TSoundVolumeMenuItem.Create", "text": "    ", "tags": "", "loc": "CastleSoundMenu.TSoundVolumeMenuItem.html#Create"},
     {"title": "CastleSoundMenu.TSoundVolumeMenuItem.Refresh", "text": "    ", "tags": "", "loc": "CastleSoundMenu.TSoundVolumeMenuItem.html#Refresh"},
     {"title": "CastleSoundMenu.TMusicVolumeMenuItem", "text": " Simply add it to your <a class=\"normal\" href=\"CastleOnScreenMenu.TCastleOnScreenMenu.html\">TCastleOnScreenMenu</a> like  <p></p>  <pre class=\"longcode\"> OnScreenMenu.Add(TMusicVolumeMenuItem.Create(OnScreenMenu));</pre>  <p> ", "tags": "", "loc": "CastleSoundMenu.TMusicVolumeMenuItem.html"},
     {"title": "CastleSoundMenu.TMusicVolumeMenuItem.Create", "text": "    ", "tags": "", "loc": "CastleSoundMenu.TMusicVolumeMenuItem.html#Create"},
     {"title": "CastleSoundMenu.TMusicVolumeMenuItem.Refresh", "text": "    ", "tags": "", "loc": "CastleSoundMenu.TMusicVolumeMenuItem.html#Refresh"},
     {"title": "CastleSpaceFillingCurves", "text": " These are sequences of points that completely fill some 2D space. ", "tags": "", "loc": "CastleSpaceFillingCurves.html"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve", "text": "  <p>Generates consecutive points by <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#NextPixel\">NextPixel</a>, until <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#EndOfPixels\">EndOfPixels</a> = <code>True</code>, filling the 2D space in [0..SizeX-1, 0..SizeY-1]. To process (exactly once) each point of your 2D space, you can use something like  <p></p>  <pre class=\"longcode\"><span class=\"pascal_keyword\">while</span> <span class=\"pascal_keyword\">not</span> SFCurve.EndOfPixels <span class=\"pascal_keyword\">do</span> DoSomethingOnPixel(SFCurve.NextPixel);</pre>  <p>  <p>We try to make <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#NextPixel\">NextPixel</a> and <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#EndOfPixels\">EndOfPixels</a> work instantly fast, preferably making some preprocessing at construction time. ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.Create", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#Create"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.EndOfPixels", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#EndOfPixels"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.NextPixel", "text": " Do not ever call this when <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#EndOfPixels\">EndOfPixels</a> = <code>True</code>.    ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#NextPixel"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.SkipPixels", "text": " Just like you would call <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#NextPixel\">NextPixel</a> SkipCount times, ignoring the result. Although may be implemented much faster, so don't worry about calling with large SkipCount values.  <p>Do not ever try to skip beyond the end of points. That is, do not use <code>SkipCount &gt; <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#PixelsCount\">PixelsCount</a> - <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#PixelsDone\">PixelsDone</a></code>. For example, do not use SkipCount &gt; 0 if currently <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#EndOfPixels\">EndOfPixels</a> - <code>True</code>.    ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#SkipPixels"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.Reset", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#Reset"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.PixelsDone", "text": " Number of generated points (by <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#NextPixel\">NextPixel</a> or skipped by <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#SkipPixels\">SkipPixels</a>), since the last <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#Reset\">Reset</a> or constructor.    ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#PixelsDone"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.SFCName", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#SFCName"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.SizeX", "text": " It's OK even if they are 0 (then <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#EndOfPixels\">EndOfPixels</a> = <code>True</code> instantly).  ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#SizeX"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.SizeY", "text": " ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#SizeY"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurve.PixelsCount", "text": " ", "tags": "", "loc": "CastleSpaceFillingCurves.TSpaceFillingCurve.html#PixelsCount"},
     {"title": "CastleSpaceFillingCurves.TPrecalcCurve", "text": " In descendants, you only need to override GeneratePoints. ", "tags": "", "loc": "CastleSpaceFillingCurves.TPrecalcCurve.html"},
     {"title": "CastleSpaceFillingCurves.TPrecalcCurve.GeneratePixels", "text": " You should generate next <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#PixelsCount\">PixelsCount</a> points to the Pixels table (it's guaranteed that <a class=\"normal\" href=\"CastleSpaceFillingCurves.TSpaceFillingCurve.html#PixelsCount\">PixelsCount</a> &gt; 0).    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPrecalcCurve.html#GeneratePixels"},
     {"title": "CastleSpaceFillingCurves.TPrecalcCurve.Create", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPrecalcCurve.html#Create"},
     {"title": "CastleSpaceFillingCurves.TPrecalcCurve.Destroy", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPrecalcCurve.html#Destroy"},
     {"title": "CastleSpaceFillingCurves.TPrecalcCurve.EndOfPixels", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPrecalcCurve.html#EndOfPixels"},
     {"title": "CastleSpaceFillingCurves.TPrecalcCurve.NextPixel", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPrecalcCurve.html#NextPixel"},
     {"title": "CastleSpaceFillingCurves.TPrecalcCurve.SkipPixels", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPrecalcCurve.html#SkipPixels"},
     {"title": "CastleSpaceFillingCurves.TPrecalcCurve.Reset", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPrecalcCurve.html#Reset"},
     {"title": "CastleSpaceFillingCurves.TPrecalcCurve.PixelsDone", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPrecalcCurve.html#PixelsDone"},
     {"title": "CastleSpaceFillingCurves.TSwapScanCurve", "text": " This is a trivial space-filling curve, at least it goes by neighboring points. We go from the bottom to the top, in even rows we go the right, in odd rows we go to the left. ", "tags": "", "loc": "CastleSpaceFillingCurves.TSwapScanCurve.html"},
     {"title": "CastleSpaceFillingCurves.TSwapScanCurve.GeneratePixels", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TSwapScanCurve.html#GeneratePixels"},
     {"title": "CastleSpaceFillingCurves.TSwapScanCurve.SFCName", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TSwapScanCurve.html#SFCName"},
     {"title": "CastleSpaceFillingCurves.THilbertCurve", "text": " See e.g. [<a  href=\"http://en.wikipedia.org/wiki/Space-filling_curve\">http://en.wikipedia.org/wiki/Space-filling_curve</a>]. It's cut off to fill nicely the rectangular [0..SizeX-1, 0..SizeY-1] space. ", "tags": "", "loc": "CastleSpaceFillingCurves.THilbertCurve.html"},
     {"title": "CastleSpaceFillingCurves.THilbertCurve.GeneratePixels", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.THilbertCurve.html#GeneratePixels"},
     {"title": "CastleSpaceFillingCurves.THilbertCurve.SFCName", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.THilbertCurve.html#SFCName"},
     {"title": "CastleSpaceFillingCurves.TPeanoCurve", "text": " See e.g. [<a  href=\"http://en.wikipedia.org/wiki/Space-filling_curve\">http://en.wikipedia.org/wiki/Space-filling_curve</a>]. It's cut off to fill nicely the rectangular [0..SizeX-1, 0..SizeY-1] space. ", "tags": "", "loc": "CastleSpaceFillingCurves.TPeanoCurve.html"},
     {"title": "CastleSpaceFillingCurves.TPeanoCurve.GeneratePixels", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPeanoCurve.html#GeneratePixels"},
     {"title": "CastleSpaceFillingCurves.TPeanoCurve.SFCName", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.TPeanoCurve.html#SFCName"},
     {"title": "CastleSpaceFillingCurves.EInvalidSFCurveClassName", "text": " ", "tags": "", "loc": "CastleSpaceFillingCurves.EInvalidSFCurveClassName.html"},
     {"title": "CastleSpaceFillingCurves.AvailableSFCurveClasses", "text": " ", "tags": "", "loc": "CastleSpaceFillingCurves.html#AvailableSFCurveClasses"},
     {"title": "CastleSpaceFillingCurves.PeanoCurve", "text": " See e.g. &quot;Graphic Gems II&quot; (gem I.8) or <a  href=\"http://en.wikipedia.org/wiki/Space-filling_curve\">http://en.wikipedia.org/wiki/Space-filling_curve</a> for nice description.  <p>Step is a function that goes to a neighbor 2D point, and &quot;marks&quot; it (whatever it means for your usage). If the starting point is &quot;marked&quot; at the beginning, using Peano or Hilbert curve guarantees that you will eventually &quot;mark&quot; the whole 2D space.  <p>Peano curve fills a plane size 3&circ;Level, Hilbert curve fills size 2&circ;Level.  <p>Angle is an initial orientation, determining in which direction the curve will be drawn. If you want to fill the space up and to the left from the initial point (according to conventions that Angle = 0 is right, Angle = 1 is up, and so on (CCW)), then use:  <p></p>  <ul class=\"compact_spacing\">   <li><p>InitialOrient = false and Angle = 0 for <code>PeanoCurve</code>.</p></li>   <li><p>InitialOrient = true and Angle = 0 for <a class=\"normal\" href=\"CastleSpaceFillingCurves.html#HilbertCurve\">HilbertCurve</a>.</p></li> </ul>  <p>  <p>    ", "tags": "", "loc": "CastleSpaceFillingCurves.html#PeanoCurve"},
     {"title": "CastleSpaceFillingCurves.HilbertCurve", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.html#HilbertCurve"},
     {"title": "CastleSpaceFillingCurves.StrToSFCurveClass", "text": " Not case-sensitive.     EInvalidSFCurveClassName For unknown curve names.", "tags": "", "loc": "CastleSpaceFillingCurves.html#StrToSFCurveClass"},
     {"title": "CastleSpaceFillingCurves.AllSFCurveClassesNames", "text": " Separated by commas, in apostrophes.    ", "tags": "", "loc": "CastleSpaceFillingCurves.html#AllSFCurveClassesNames"},
     {"title": "CastleSpaceFillingCurves.TSFCAngle", "text": "  <p>Let's say 0 = 0 degrees, 1 = 90 degrees, 2 = 180, 3 = 270, but actually it doesn't matter much &mdash; it all a matter of convention here. ", "tags": "", "loc": "CastleSpaceFillingCurves.html#TSFCAngle"},
     {"title": "CastleSpaceFillingCurves.TSFCStepFunction", "text": "    ", "tags": "", "loc": "CastleSpaceFillingCurves.html#TSFCStepFunction"},
     {"title": "CastleSpaceFillingCurves.TSpaceFillingCurveClass", "text": " ", "tags": "", "loc": "CastleSpaceFillingCurves.html#TSpaceFillingCurveClass"},
     {"title": "CastleSphereSampling", "text": " Useful e.g. for ray-tracers.  <p>Most of the implementation based on &quot;Global Illumination Compendium&quot; IV.B [<a  href=\"http://www.cs.kuleuven.ac.be/~phil/GI/\">http://www.cs.kuleuven.ac.be/&tilde;phil/GI/</a>]. See also images there, they help to illustrate the meaning of some functions here.  <p>We use two ways to represent points on hemisphere:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Functions <i>without &quot;XYZ&quot; suffix</i> return vector of 2 floats = two angles, called phi and theta (in this order). Phi (in [0, 2*Pi]) is an angle from some chosen meridian. Theta (in [0, Pi/2] for hemisphere and [0, Pi] for sphere) is an angle from chosen vector pointing outward from the (hemi)sphere. See images in &quot;Global Illumination Compendium&quot;, they are probably much easier to understand than this definition.</p></li>   <li value=\"2\"><p>Functions <i>with &quot;XYZ&quot; suffix</i> return 3D point x, y, z.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>(0, 0, 0) is the center of (hemi)sphere,</p></li>   <li><p>(0, 0, 1) is the chosen outward vector (i.e. Theta = 0 there),</p></li>   <li><p>(1, 0, 0) is the direction where Phi = 0 and Theta = Pi/2,</p></li>   <li><p>(0, 1, 0) is the direction where Phi = Pi/2 and Theta = Pi/2.</p></li> </ul>  <p>  <p>This is matching conventions in &quot;Global Illumination Compendium&quot;, see there (point 21).</p></li> </ol>  <p>  <p>Functions with Density &lt;&gt; Const return PdfValue for returned point, i.e. for density p(Theta) it's PfdValue = p(Result[1]). These functions try to calculate PdfValue smartly (often calculating PfdValue and calculating Result uses the same intermediate calculation, so we can save some computation). PdfValue is needed for importance sampling. ", "tags": "", "loc": "CastleSphereSampling.html"},
     {"title": "CastleSphereSampling.PhiThetaToXYZ", "text": "  <p>See the beginning of this unit's documentation, <a class=\"normal\" href=\"CastleSphereSampling.html\">CastleSphereSampling</a>, for more precise description of XYZ representation.    ", "tags": "", "loc": "CastleSphereSampling.html#PhiThetaToXYZ"},
     {"title": "CastleSphereSampling.PhiThetaToXYZ", "text": "  <p>This is the more advanced version where you can freely specify which vector is the &quot;main outside (hemi)sphere vector&quot;, SphereTheta0. Points with Theta = 0 are exactly on SphereTheta0. It is <i>undefined</i> where point like (Phi = 0, Theta = Pi/2) (or any other point with Theta &lt;&gt; 0) will be placed, i.e. it's not defined where's the &quot;chosen meridian&quot; for Phi = 0. However <i>it's defined that this meridian will be determined only by SphereTheta0</i>, and this is usually sufficient (since this makes sure that sampling and then converting to XYZ multiple points with the same SphereTheta0 will preserve sampled density).  <p>Note that the length of SphereTheta0 determines also the sphere radius.    ", "tags": "", "loc": "CastleSphereSampling.html#PhiThetaToXYZ"},
     {"title": "CastleSphereSampling.XYZToPhiTheta", "text": "    ", "tags": "", "loc": "CastleSphereSampling.html#XYZToPhiTheta"},
     {"title": "CastleSphereSampling.RandomHemispherePointConst", "text": "     ", "tags": "", "loc": "CastleSphereSampling.html#RandomHemispherePointConst"},
     {"title": "CastleSphereSampling.RandomHemispherePointConstXYZ", "text": "    ", "tags": "", "loc": "CastleSphereSampling.html#RandomHemispherePointConstXYZ"},
     {"title": "CastleSphereSampling.RandomHemispherePointCosTheta", "text": "     ", "tags": "", "loc": "CastleSphereSampling.html#RandomHemispherePointCosTheta"},
     {"title": "CastleSphereSampling.RandomHemispherePointCosThetaXYZ", "text": "    ", "tags": "", "loc": "CastleSphereSampling.html#RandomHemispherePointCosThetaXYZ"},
     {"title": "CastleSphereSampling.RandomHemispherePointCosThetaExp", "text": "     ", "tags": "", "loc": "CastleSphereSampling.html#RandomHemispherePointCosThetaExp"},
     {"title": "CastleSphereSampling.RandomHemispherePointCosThetaExpXYZ", "text": "    ", "tags": "", "loc": "CastleSphereSampling.html#RandomHemispherePointCosThetaExpXYZ"},
     {"title": "CastleSphericalHarmonics", "text": " ", "tags": "", "loc": "CastleSphericalHarmonics.html"},
     {"title": "CastleSphericalHarmonics.MaxSHBasis", "text": " LM for <a class=\"normal\" href=\"CastleSphericalHarmonics.html#SHBasis\">SHBasis</a> must be within 0 .. SHBasesCount - 1. ", "tags": "", "loc": "CastleSphericalHarmonics.html#MaxSHBasis"},
     {"title": "CastleSphericalHarmonics.SHBasis0", "text": " This is sometimes useful. ", "tags": "", "loc": "CastleSphericalHarmonics.html#SHBasis0"},
     {"title": "CastleSphericalHarmonics.SHBasis", "text": "  <p>LM indicates (L, M) that specify which SH basis to use. LM determines a pair (L, M) in the natural order: for each L, take for each M from -L to L. That is, LM = (0, 1, 2, 3, ...) indicate </p>  <pre class=\"preformatted\">   (L, M) = ( (0, 0),   (1, -1), (1, 0), (1, 1),   (2, -2), (2, -1), (2, 0), (2, 1), (2, 2),   ... )</pre>  <p> )    ", "tags": "", "loc": "CastleSphericalHarmonics.html#SHBasis"},
     {"title": "CastleSphericalHarmonics.LMDecode", "text": "    ", "tags": "", "loc": "CastleSphericalHarmonics.html#LMDecode"},
     {"title": "CastleSphericalHarmonics.InitializeSHBasisMap", "text": "    ", "tags": "", "loc": "CastleSphericalHarmonics.html#InitializeSHBasisMap"},
     {"title": "CastleSphericalHarmonics.SHVectorFromCubeMap", "text": " This uses <a class=\"normal\" href=\"CastleSphericalHarmonics.html#SHBasisMap\">SHBasisMap</a>, so be sure to initialize it first.    ", "tags": "", "loc": "CastleSphericalHarmonics.html#SHVectorFromCubeMap"},
     {"title": "CastleSphericalHarmonics.TSHVectorSingle", "text": " ", "tags": "", "loc": "CastleSphericalHarmonics.html#TSHVectorSingle"},
     {"title": "CastleSphericalHarmonics.PSHVectorSingle", "text": " ", "tags": "", "loc": "CastleSphericalHarmonics.html#PSHVectorSingle"},
     {"title": "CastleSphericalHarmonics.SHBasisMap", "text": " Multiplied by solid angle of this cube map pixel, since this is what you usually need.  <p>For each side of the cube, and for each pixel on this side (pixels are arranged same as in <a class=\"normal\" href=\"CastleImages.TGrayscaleImage.html\">TGrayscaleImage</a>, that is row-by-row from lower to higher, from left to right) this gives the result of <a class=\"normal\" href=\"CastleSphericalHarmonics.html#SHBasis\">SHBasis</a> for this direction. Multiplied by solid angle.  <p>You have to initialize this (once, like at the beginning of your program) by <a class=\"normal\" href=\"CastleSphericalHarmonics.html#InitializeSHBasisMap\">InitializeSHBasisMap</a>.  <p>This is useful for calculating sh basis vector from given cube map: since you can just project any function on any basis, so if you have a particular cube map you can project it on each SH basis function. See <a class=\"normal\" href=\"CastleSphericalHarmonics.html#SHVectorFromCubeMap\">SHVectorFromCubeMap</a> implementation for code how to use <code>SHBasisMap</code> for this, and in simple cases you can just call <a class=\"normal\" href=\"CastleSphericalHarmonics.html#SHVectorFromCubeMap\">SHVectorFromCubeMap</a>. ", "tags": "", "loc": "CastleSphericalHarmonics.html#SHBasisMap"},
     {"title": "CastleStreamUtils", "text": " ", "tags": "", "loc": "CastleStreamUtils.html"},
     {"title": "CastleStreamUtils.TStreamHelper", "text": " ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "  <p>    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadLE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadBE", "text": "  <p>    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadBE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadBE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadBE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadBE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadBE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadBE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadBE"},
     {"title": "CastleStreamUtils.TStreamHelper.ReadBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#ReadBE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteLE", "text": "  <p>    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteLE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteLE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteLE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteLE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteLE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteLE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteLE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteLE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteLE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteBE", "text": "  <p>    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteBE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteBE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteBE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteBE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteBE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteBE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteBE"},
     {"title": "CastleStreamUtils.TStreamHelper.WriteBE", "text": "    ", "tags": "", "loc": "CastleStreamUtils.TStreamHelper.html#WriteBE"},
     {"title": "CastleStringUtils", "text": " Also some operations on chars and PChars. And various conversions strings&lt;-&gt;numbers.  <p>General comments for all procedures that have parameter like IgnoreCase: </p>  <ul class=\"paragraph_spacing\">   <li><p> If such parameter has some default value, this default value should be </p>  <dl class=\"paragraph_spacing\">   <dt><code>True</code></dt>   <dd><p>for procedures that only read processed string</p></dd>   <dt><code>False</code></dt>   <dd><p>for procedures that can modify processed string (for safety, so that accidental modification should be harder)</p></dd> </dl>  <p></p></li>   <li><p> If I don't write in docs for this procedure whether this procedure takes current locale into account (as current locale can change the meaning of &quot;ignoring case&quot;), then it means it <i>does</i> take current locale into account.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleStringUtils.html"},
     {"title": "CastleStringUtils.TStringsHelper", "text": " ", "tags": "", "loc": "CastleStringUtils.TStringsHelper.html"},
     {"title": "CastleStringUtils.TStringsHelper.ToArray", "text": "    ", "tags": "", "loc": "CastleStringUtils.TStringsHelper.html#ToArray"},
     {"title": "CastleStringUtils.TCastleStringList", "text": " This is a slightly extended version of standard TStringList. The default CaseSensitive value is <code>True</code>. ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html"},
     {"title": "CastleStringUtils.TCastleStringList.Create", "text": "    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#Create"},
     {"title": "CastleStringUtils.TCastleStringList.AddRange", "text": " Alias for AddStrings, useful for usage with macros, since it's consistent with <a class=\"normal\" href=\"CastleStringUtils.TCastleStringList.html#AddRange\">AddRange</a> in other lists.    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#AddRange"},
     {"title": "CastleStringUtils.TCastleStringList.AddList", "text": "    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#AddList"},
     {"title": "CastleStringUtils.TCastleStringList.AddRange", "text": "    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#AddRange"},
     {"title": "CastleStringUtils.TCastleStringList.AddArray", "text": "    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#AddArray"},
     {"title": "CastleStringUtils.TCastleStringList.AssignArray", "text": "    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#AssignArray"},
     {"title": "CastleStringUtils.TCastleStringList.Assign", "text": "    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#Assign"},
     {"title": "CastleStringUtils.TCastleStringList.Equals", "text": "  <p>Any other TStrings descendant may be equal to this instance, we don't require it to be a <a class=\"normal\" href=\"CastleStringUtils.TCastleStringList.html\">TCastleStringList</a> instance. We also don't check all the properties, like Delimiter or such. We only compare the contents: count, and actual strings.  <p>The comparison is case-sensitive, or not, depending on the value of CaseSensitive property of this list.    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#Equals"},
     {"title": "CastleStringUtils.TCastleStringList.Equals", "text": "    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#Equals"},
     {"title": "CastleStringUtils.TCastleStringList.PerfectlyEquals", "text": "  <p>This method does the same thing as <a class=\"normal\" href=\"CastleStringUtils.TCastleStringList.html#Equals\">Equals</a>. It is defined for consistency &ndash; on some lists, like <a class=\"normal\" href=\"CastleUtils.TSingleList.html\">TSingleList</a>, there is an important difference between Equals (compares with some epsilon tolerance) and <code>PerfectlyEquals</code>.    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#PerfectlyEquals"},
     {"title": "CastleStringUtils.TCastleStringList.Reverse", "text": "    ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#Reverse"},
     {"title": "CastleStringUtils.TCastleStringList.Count", "text": " ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#Count"},
     {"title": "CastleStringUtils.TCastleStringList.L", "text": " This is exactly equivalent to just using standard TStringList.Strings property, and is useful only for implementing macros that work for both <a class=\"normal\" href=\"CastleStringUtils.TCastleStringList.html\">TCastleStringList</a> and <a class=\"normal\" href=\"CastleUtils.TStructList.html\">TStructList</a>. ", "tags": "", "loc": "CastleStringUtils.TCastleStringList.html#L"},
     {"title": "CastleStringUtils.TStringStringMap", "text": " Note that in simple cases you can also use standard TStringList functionality (see it's properties Names, Values), but this is better if your key/values may be multiline. ", "tags": "", "loc": "CastleStringUtils.TStringStringMap.html"},
     {"title": "CastleStringUtils.TStringStringMap.PutPreserve", "text": " This is useful for safely setting X3D META values.  <p>Compared to normal PutKeyData, this behaves smarter if given Name is already set. If it's set with the same Content, we do nothing. If the Content is different, we move previous content to a <code>Name + '-previous'</code> key. This way previous content value is preserved once (but not more, to not grow the X3D file indefinitely).    ", "tags": "", "loc": "CastleStringUtils.TStringStringMap.html#PutPreserve"},
     {"title": "CastleStringUtils.TStringStringMap.CreateCopy", "text": "    ", "tags": "", "loc": "CastleStringUtils.TStringStringMap.html#CreateCopy"},
     {"title": "CastleStringUtils.TStringStringMap.Assign", "text": "    ", "tags": "", "loc": "CastleStringUtils.TStringStringMap.html#Assign"},
     {"title": "CastleStringUtils.TStringStringMap.Items", "text": " Setting this is allowed regardless if the key previously existed or not, in other words: setting this does AddOrSetValue, contrary to the ancestor TDictionary that only allows setting when the key already exists. ", "tags": "", "loc": "CastleStringUtils.TStringStringMap.html#Items"},
     {"title": "CastleStringUtils.EDeformatError", "text": " ", "tags": "", "loc": "CastleStringUtils.EDeformatError.html"},
     {"title": "CastleStringUtils.TPercentReplace", "text": " ", "tags": "", "loc": "CastleStringUtils.TPercentReplace.html"},
     {"title": "CastleStringUtils.TPercentReplace.c", "text": " ", "tags": "", "loc": "CastleStringUtils.TPercentReplace.html#c"},
     {"title": "CastleStringUtils.TPercentReplace.s", "text": " ", "tags": "", "loc": "CastleStringUtils.TPercentReplace.html#s"},
     {"title": "CastleStringUtils.EUnknownPercentFormat", "text": " ", "tags": "", "loc": "CastleStringUtils.EUnknownPercentFormat.html"},
     {"title": "CastleStringUtils.EInvalidChar", "text": " ", "tags": "", "loc": "CastleStringUtils.EInvalidChar.html"},
     {"title": "CastleStringUtils.AllChars", "text": " ", "tags": "", "loc": "CastleStringUtils.html#AllChars"},
     {"title": "CastleStringUtils.DefaultWordBorders", "text": " ", "tags": "", "loc": "CastleStringUtils.html#DefaultWordBorders"},
     {"title": "CastleStringUtils.WhiteSpaces", "text": " ", "tags": "", "loc": "CastleStringUtils.html#WhiteSpaces"},
     {"title": "CastleStringUtils.SimpleAsciiCharacters", "text": " ", "tags": "", "loc": "CastleStringUtils.html#SimpleAsciiCharacters"},
     {"title": "CastleStringUtils.CtrlA", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlA"},
     {"title": "CastleStringUtils.CtrlB", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlB"},
     {"title": "CastleStringUtils.CtrlC", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlC"},
     {"title": "CastleStringUtils.CtrlD", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlD"},
     {"title": "CastleStringUtils.CtrlE", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlE"},
     {"title": "CastleStringUtils.CtrlF", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlF"},
     {"title": "CastleStringUtils.CtrlG", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlG"},
     {"title": "CastleStringUtils.CtrlH", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlH"},
     {"title": "CastleStringUtils.CtrlI", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlI"},
     {"title": "CastleStringUtils.CtrlJ", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlJ"},
     {"title": "CastleStringUtils.CtrlK", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlK"},
     {"title": "CastleStringUtils.CtrlL", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlL"},
     {"title": "CastleStringUtils.CtrlM", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlM"},
     {"title": "CastleStringUtils.CtrlN", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlN"},
     {"title": "CastleStringUtils.CtrlO", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlO"},
     {"title": "CastleStringUtils.CtrlP", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlP"},
     {"title": "CastleStringUtils.CtrlQ", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlQ"},
     {"title": "CastleStringUtils.CtrlR", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlR"},
     {"title": "CastleStringUtils.CtrlS", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlS"},
     {"title": "CastleStringUtils.CtrlT", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlT"},
     {"title": "CastleStringUtils.CtrlU", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlU"},
     {"title": "CastleStringUtils.CtrlV", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlV"},
     {"title": "CastleStringUtils.CtrlW", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlW"},
     {"title": "CastleStringUtils.CtrlX", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlX"},
     {"title": "CastleStringUtils.CtrlY", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlY"},
     {"title": "CastleStringUtils.CtrlZ", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CtrlZ"},
     {"title": "CastleStringUtils.CharBackSpace", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CharBackSpace"},
     {"title": "CastleStringUtils.CharTab", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CharTab"},
     {"title": "CastleStringUtils.CharEnter", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CharEnter"},
     {"title": "CastleStringUtils.CharEscape", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CharEscape"},
     {"title": "CastleStringUtils.CharDelete", "text": " ", "tags": "", "loc": "CastleStringUtils.html#CharDelete"},
     {"title": "CastleStringUtils.RandomString", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#RandomString"},
     {"title": "CastleStringUtils.StringReplaceAllVar", "text": "  <p><code><code>StringReplaceAllVar</code>(s, from, to)</code> is actually equivalent to simply <code>s := StringReplace(s, from, to, [rfReplaceAll, rfIgnoreCase])</code>. So <code>StringReplaceAllVar</code> is just a wrapper for very common use case of StringReplace.    ", "tags": "", "loc": "CastleStringUtils.html#StringReplaceAllVar"},
     {"title": "CastleStringUtils.BreakLine", "text": "  <p>It tries to insert newline sequence at the last character in AllowedBreakChars but still before MaxCol limit, and the character in AllowedBreakChars is deleted in this case. In other words, in most typical situation it simply breaks the string where the whitespace is, trying to make the line as long as possible within MaxCol limit. If no such character in AllowedBreakChars is found (e.g., you put a long line of non-<a class=\"normal\" href=\"CastleColors.html#White\">white</a> characters), it will still break the string at MaxCol position (so in this exceptional case, it will cause a break in the middle of the word).  <p>While breaking the string in the middle of the word in not nice, this allows us a safe feeling that this will always break the string into MaxCol chunks.  <p>This intelligently recognizes already existing newline characters (#13, #10, #13#10 or #10#13) in the string, so e.g. it will not insert more newline characters when they are not necessary.  <p>The Indent is added after every newline. This is a bit more powerful than simply specyfing Newline parameter as <code><a class=\"normal\" href=\"CastleUtils.html#NL\">NL</a> + Indent</code>, because this function also adds Indent after existing newlines in the input string.    ", "tags": "", "loc": "CastleStringUtils.html#BreakLine"},
     {"title": "CastleStringUtils.BreakLine", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#BreakLine"},
     {"title": "CastleStringUtils.SDeleteChars", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SDeleteChars"},
     {"title": "CastleStringUtils.SReplaceChars", "text": " There are three overloaded versions:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><a class=\"normal\" href=\"CastleStringUtils.html#SReplaceChars\">SReplaceChars</a>(string, string, string) looks in S for characters within FromChars, and replaces them with characters on appropriate position in ToChars. For example, <a class=\"normal\" href=\"CastleStringUtils.html#SReplaceChars\">SReplaceChars</a>(S, 'ab', 'cd') replaces all occurrences of 'a' into 'c' and all occurrences of 'b' into 'd'. It must always be Length(FromChars) &lt;= Length(ToChars).</p></li>   <li value=\"2\"><p><a class=\"normal\" href=\"CastleStringUtils.html#SReplaceChars\">SReplaceChars</a>(string, <a class=\"normal\" href=\"CastleStringUtils.html#TSetOfChars\">TSetOfChars</a>, char) replaces all occurrences of any character in given set with the one specified character.</p></li>   <li value=\"3\"><p><a class=\"normal\" href=\"CastleStringUtils.html#SReplaceChars\">SReplaceChars</a>(string, char, char) simply replaces all occurrences of one character into another.</p></li> </ol>  <p>  <p>    ", "tags": "", "loc": "CastleStringUtils.html#SReplaceChars"},
     {"title": "CastleStringUtils.SReplaceChars", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SReplaceChars"},
     {"title": "CastleStringUtils.SReplaceChars", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SReplaceChars"},
     {"title": "CastleStringUtils.SPad", "text": "  <p>For example, <code><code>SPad</code>('29', 4, '0')</code> gives '0029'    ", "tags": "", "loc": "CastleStringUtils.html#SPad"},
     {"title": "CastleStringUtils.SZeroPad", "text": " It's actually just a shortcut for <a class=\"normal\" href=\"CastleStringUtils.html#SPad\">SPad</a> with padding character set to '0'.    ", "tags": "", "loc": "CastleStringUtils.html#SZeroPad"},
     {"title": "CastleStringUtils.LoCase", "text": " Analogous to UpCase. Doesn't change other characters. Just like UpCase, this doesn't take current locale into account, and works only on English A-Z -&gt; a-z letters.    ", "tags": "", "loc": "CastleStringUtils.html#LoCase"},
     {"title": "CastleStringUtils.CharPos", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#CharPos"},
     {"title": "CastleStringUtils.CharsPos", "text": " This is quite like <a class=\"normal\" href=\"CastleStringUtils.html#FirstDelimiter\">FirstDelimiter</a> but it takes parameter as <a class=\"normal\" href=\"CastleStringUtils.html#TSetOfChars\">TSetOfChars</a> and has much more sensible name.  <p><a class=\"normal\" href=\"CastleStringUtils.html#BackCharsPos\">BackCharsPos</a> does the same, but from the end of the string (i.e. finds the last occurrence).  <p><a class=\"normal\" href=\"CastleStringUtils.html#CharsPosEx\">CharsPosEx</a> searches starting from Offset char.  <p>They all return 0 if not found.  <p>    ", "tags": "", "loc": "CastleStringUtils.html#CharsPos"},
     {"title": "CastleStringUtils.CharsPosEx", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#CharsPosEx"},
     {"title": "CastleStringUtils.BackCharsPos", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#BackCharsPos"},
     {"title": "CastleStringUtils.BackPos", "text": " 0 if not found. Overloaded version is optimized for searching for single character.    ", "tags": "", "loc": "CastleStringUtils.html#BackPos"},
     {"title": "CastleStringUtils.BackPos", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#BackPos"},
     {"title": "CastleStringUtils.FirstDelimiter", "text": " Name is analogous to LastDelimiter. Returns 0 if not found.    ", "tags": "", "loc": "CastleStringUtils.html#FirstDelimiter"},
     {"title": "CastleStringUtils.SEnding", "text": " Returns '' if P &gt; length(S). Yes, this is simply equivalent to Copy(S, P, MaxInt).    ", "tags": "", "loc": "CastleStringUtils.html#SEnding"},
     {"title": "CastleStringUtils.IsPrefix", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#IsPrefix"},
     {"title": "CastleStringUtils.IsSuffix", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#IsSuffix"},
     {"title": "CastleStringUtils.PrefixRemove", "text": " More precisely, if <a class=\"normal\" href=\"CastleStringUtils.html#IsPrefix\">IsPrefix</a>(Prefix, S, IgnoreCase) then returns S with this prefix removed. Else returns S.    ", "tags": "", "loc": "CastleStringUtils.html#PrefixRemove"},
     {"title": "CastleStringUtils.SuffixRemove", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SuffixRemove"},
     {"title": "CastleStringUtils.SAppendData", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SAppendData"},
     {"title": "CastleStringUtils.SChar", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SChar"},
     {"title": "CastleStringUtils.SCharIs", "text": " Return false if S is too short, or the chatacter differs.  <p>    ", "tags": "", "loc": "CastleStringUtils.html#SCharIs"},
     {"title": "CastleStringUtils.SCharIs", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SCharIs"},
     {"title": "CastleStringUtils.SReadableForm", "text": " Useful for printing strings with some unprintable chars for debugging purposes.    ", "tags": "", "loc": "CastleStringUtils.html#SReadableForm"},
     {"title": "CastleStringUtils.SReadableForm", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SReadableForm"},
     {"title": "CastleStringUtils.CopyPos", "text": " This is similar to standard Copy procedure, but last parameter is EndPosition instead of Count, which is more comfortable sometimes.    ", "tags": "", "loc": "CastleStringUtils.html#CopyPos"},
     {"title": "CastleStringUtils.DeletePos", "text": " Analogous to standard Delete but with EndPosition parameter (while standard Delete takes Count).    ", "tags": "", "loc": "CastleStringUtils.html#DeletePos"},
     {"title": "CastleStringUtils.NextToken", "text": " More precisely: search S, starting from position SeekPos, for the first character that is <i>not in TokenDelims</i>. Then, all subsequent characters that are not in TokenDelims are appended to the Result, until any character <i>is in TokenDelims</i> is found. In effect, Result contains the whole part that was in TokenDelims.  <p>SeekPos is advanced to the position of the next character, i.e. the character right after the ending character that was in TokenDelims. In other words, SeekPos points to the position of the next &quot;unprocessed&quot; character in string S. Often you will want to make another call to <code>NextToken</code>, passing this SeekPos, and this way you can split your string S into parts delimited by TokenDelims.  <p>Returns '' if no more tokens available (SeekPos value at the end is unspecified).  <p>Typical use scenario (iterate over all tokens in the string) :  <p></p>  <pre class=\"longcode\"> SeekPos := <span class=\"pascal_numeric\">1</span>; <span class=\"pascal_keyword\">repeat</span>   Token := NextToken(S, SeekPos);   <span class=\"pascal_keyword\">if</span> Token = <span class=\"pascal_string\">''</span> <span class=\"pascal_keyword\">then</span> break;   <span class=\"pascal_comment\">{ ... process_next_token (Token) ... }</span> <span class=\"pascal_keyword\">until</span> false;</pre>  <p>  <p>The above example will split the string into parts separated by whitespace.  <p>Note: it's much easier to use <a class=\"normal\" href=\"CastleStringUtils.html#CreateTokens\">CreateTokens</a> instead of this procedure. But this procedure gives you quite more flexibility.    ", "tags": "", "loc": "CastleStringUtils.html#NextToken"},
     {"title": "CastleStringUtils.NextTokenOnce", "text": " This means that it's quite useless when you're interested in <i>all</i> tokens inside some string, but it's also more comfortable when you're interested in only <i>one</i> token inside some string. When SeekPos = 1, this is the first token.    ", "tags": "", "loc": "CastleStringUtils.html#NextTokenOnce"},
     {"title": "CastleStringUtils.CreateTokens", "text": " Token is something delimited by TokenDelims. TokenDelims are not contained in resulting items. E.g. <code>CreateTokens</code>('foo, bar', [' ', ',']) returns <a class=\"normal\" href=\"CastleStringUtils.TCastleStringList.html\">TCastleStringList</a> with 2 items: 'foo' and 'bar'.    ", "tags": "", "loc": "CastleStringUtils.html#CreateTokens"},
     {"title": "CastleStringUtils.SplitString", "text": " For example, <code><code>SplitString</code>('foo|bar', '|')</code> returns a list with 2 parts: <code>'foo'</code> and <code>'bar'</code>.  <p>The splitting is done &quot;strictly&quot;, which means that we always return exactly one more part than the occurences of delimiter in the source string.  <p>In particular, this means that: </p>  <ul class=\"paragraph_spacing\">   <li><p>If the Delimiter does not occur in the source string, then the result is a list with a single part. This applies even if the source string is empty.  <p></p>  <ul class=\"compact_spacing\">   <li><p><code><code>SplitString</code>('foo', '|') = ['foo']</code></p></li>   <li><p><code><code>SplitString</code>('', '|') = ['']</code></p></li> </ul>  <p> </p></li>   <li><p>If the Delimiter occurs two or more times in a row within the source string, then the we will have one or more empty parts in the resulting list.  <p></p>  <ul class=\"compact_spacing\">   <li><p><code><code>SplitString</code>('foo||bar', '|') = ['foo', '', 'bar]</code></p></li>   <li><p><code><code>SplitString</code>('foo|||bar', '|') = ['foo', '', '', 'bar]</code></p></li> </ul>  <p> </p></li>   <li><p>f the Delimiter occurs at the very end of the source string, then the very last part of the resulting list will be an empty string.  <p></p>  <ul class=\"compact_spacing\">   <li><p><code><code>SplitString</code>('foo||bar|', '|') = ['foo', '', 'bar, '']</code></p></li> </ul>  <p> </p></li> </ul>  <p>  <p>The reverse of this operation is <a class=\"normal\" href=\"CastleStringUtils.html#GlueStrings\">GlueStrings</a>.  <p>See also <a class=\"normal\" href=\"CastleStringUtils.html#CreateTokens\">CreateTokens</a>, for a different way to split, that treats any sequence of delimiters like a single delimiter, and is more suitable e.g. to extract words separated by whitespace. See also standard TStringList.Delimiter feature.    ", "tags": "", "loc": "CastleStringUtils.html#SplitString"},
     {"title": "CastleStringUtils.GlueStrings", "text": " This is the reverse of <a class=\"normal\" href=\"CastleStringUtils.html#SplitString\">SplitString</a>.     ", "tags": "", "loc": "CastleStringUtils.html#GlueStrings"},
     {"title": "CastleStringUtils.GlueStrings", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#GlueStrings"},
     {"title": "CastleStringUtils.GlueStrings", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#GlueStrings"},
     {"title": "CastleStringUtils.GlueStrings", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#GlueStrings"},
     {"title": "CastleStringUtils.FindPos", "text": " Returns 0 if not found. Similar to a standard Pos function, with some improvements.  <p>  <p>  <p>  StartPosition Starts searching for SubText starting from this position. Note that the resulting position is still returned with respect to the string beginning. Just like standard PosEx. Count Looks only at Count characters from Text. You can say that the search is done only within Copy(Text, StartPosition, Count). Options Various searching options:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>soMatchCase: makes searching case-sensitive (by default, case is ignored, taking locale into account).</p></li>   <li><p>soWholeWord: looks only for SubText occurrences surrounded by characters from WordBorders (or the beginning/end of Text).  <p>Note that, while the beginning/end of Text is always treated like a word border, but the mere beginning/end of the searching range (StartPosition, Count) is not a word border. For example <code>FindPos</code>('cat', 'foocat dog', 4, MaxInt, [soWholeWord]) will answer 0 (not found), because the only 'cat' occurrence is not surrounded by default word borders.</p></li>   <li><p>soBackwards: search from the end, that is return rightmost found occurrence.</p></li> </ul>  <p>  StartPosition Starts searching for SubText starting from this position. Note that the resulting position is still returned with respect to the string beginning. Just like standard PosEx. Count Looks only at Count characters from Text. You can say that the search is done only within Copy(Text, StartPosition, Count). Options Various searching options:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>soMatchCase: makes searching case-sensitive (by default, case is ignored, taking locale into account).</p></li>   <li><p>soWholeWord: looks only for SubText occurrences surrounded by characters from WordBorders (or the beginning/end of Text).  <p>Note that, while the beginning/end of Text is always treated like a word border, but the mere beginning/end of the searching range (StartPosition, Count) is not a word border. For example <code>FindPos</code>('cat', 'foocat dog', 4, MaxInt, [soWholeWord]) will answer 0 (not found), because the only 'cat' occurrence is not surrounded by default word borders.</p></li>   <li><p>soBackwards: search from the end, that is return rightmost found occurrence.</p></li> </ul>  <p>", "tags": "", "loc": "CastleStringUtils.html#FindPos"},
     {"title": "CastleStringUtils.SRight", "text": " If RPart &gt; Length(S) then returns S.    ", "tags": "", "loc": "CastleStringUtils.html#SRight"},
     {"title": "CastleStringUtils.SAppendPart", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SAppendPart"},
     {"title": "CastleStringUtils.DeFormat", "text": "  <p>Format parameter is a sequence of <a class=\"normal\" href=\"CastleColors.html#White\">white</a> spaces, placeholders like %d or %f, and other characters. More precisely:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>If RelaxedWhitespaceChecking = <code>True</code> (that's the default value) then 1 or more <a class=\"normal\" href=\"CastleColors.html#White\">white</a> spaces in Format must correspond to 1 or more any whitespace characters in Data. I.e., the actual number and kind of whitespace in Format and Data doesn't have to match &mdash; it's only important that <i>some whitespace in Format</i> correspond to <i>some whitespace in Data</i>.</p></li>   <li><p><code>%d</code> in Format means an integer value (possibly signed) in Data. Args should have a pointer to Integer variable on the appropriate position.</p></li>   <li><p><code>%f</code> in Format means a float value (possibly signed, possibly with a dot) in Data. Args should have a pointer to Float variable on the appropriate position.</p></li>   <li><p><code>%.single.</code>, <code>%.double.</code>, <code>%.extended.</code> are like <code>%f</code>, but they specify appropriate variable type in Args. Since <code>DeFormat</code> can't check the type validity of your pointers, always be sure to pass in Args pointers to appropriate types.</p></li>   <li><p><code>%s</code> in Format means a string (will end on the first whitespace) in Data. Args should contain a pointer to an AnsiString on the appropriate position. Note that I mean it &mdash; a pointer to an AnsiString, not just a string typecasted into a pointer. I.e., if S is AnsiString, Args should contain @S, not Pointer(S).  <p>Note that a string may be empty in some cases, e.g. Format = '%d %s' and Data = '123 ' will result in the empty string as second Args.</p></li>   <li><p><code>%%</code> in Format means a one % sign in Data.</p></li>   <li><p>All the other characters (non-<a class=\"normal\" href=\"CastleColors.html#White\">white</a>, not %x sequences above) should be present in Data exactly like they are specified in Format. IgnoreCase controls is the letter case checked. When RelaxedWhitespaceChecking = <code>False</code> then <a class=\"normal\" href=\"CastleColors.html#White\">white</a>-space characters are treated just like non-<a class=\"normal\" href=\"CastleColors.html#White\">white</a> chars: they must match exactly between Format and Data.</p></li> </ul>  <p>  <p>Format must always match the whole Data &mdash; in other words, when we finished reading the Format, Data should be finished too. The exception is at the beginning and end of Data, if RelaxedWhitespaceChecking = <code>True</code> : then at the beginning and end of Data any number of <a class=\"normal\" href=\"CastleColors.html#White\">white</a>-space is allowed.  <p>For <code>DeFormat</code>, the opposite must also be true: when we finished reading Data, Format should be finished too. However, for <a class=\"normal\" href=\"CastleStringUtils.html#TryDeFormat\">TryDeFormat</a>, it's allowed for Data to end prematurely. <a class=\"normal\" href=\"CastleStringUtils.html#TryDeFormat\">TryDeFormat</a> returns how many Args were initialized.  <p>Note that while usually you will want RelaxedWhitespaceChecking = <code>True</code>, sometimes it can be needed to set this to <code>False</code> not only to get strickter checking, but also to get some things matching that otherwise wouldn't match. For example, consider Data = 'first second apple' and Format = 'first %s second %s'. With RelaxedWhitespaceChecking these things <i>do not match</i> &mdash; because the 1st space character in the Format string &quot;consumes&quot; the 1st and 2nd space characters in the Data. Then '%s' is matched to the word 'second', and the word 'second' is compared with 'apple' and they do not match. If you want such Data and Format to match, you must pass RelaxedWhitespaceChecking = <code>True</code>. Then the first '%s' will be matched to '' (empty string).  <p>This was written because both JclSscanf and scanf units were buggy. (see openGL.testy/nehe10).  <p>    EDeformatError In case of any error &mdash; mismatch between Format and Data. Note that in case of error, some of Args may be initialized, and some not &mdash; no guarantees here, sorry.", "tags": "", "loc": "CastleStringUtils.html#DeFormat"},
     {"title": "CastleStringUtils.TryDeFormat", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#TryDeFormat"},
     {"title": "CastleStringUtils.GetFileFilterExts", "text": "  <p>More precisely: expects FileFilter to be in the form of <code>'xxxx|name1.ext1;name2.ext2'</code>. Where &quot;xxxx&quot; is just about anything (it is ignored), and in fact whole &quot;xxxx|&quot; (with bar) may be omitted. The rest (after &quot;|&quot;) is treated as a filename list, separated by semicolon &quot;;&quot;.  <p>As Extensions contents, we set an array of all extensions extracted from these filenames. For example above, we would set Extensions to array with two items: <code>['.ext1', '.ext2']</code>.    ", "tags": "", "loc": "CastleStringUtils.html#GetFileFilterExts"},
     {"title": "CastleStringUtils.GetFileFilterName", "text": "  <p>More precisely: if we do not see bar &quot;|&quot; character, then this is the filter name. Otherwise, everything on the right of &quot;|&quot; is &quot;extensions&quot; and everything on the left is &quot;filter name&quot;.  <p>Additionally, if filter name ends with extensions value in parenthesis, they are removed. In other words, for 'Pascal files (*.pas)|*.pas', this will return just 'Pascal files'. The '(*.pas)' was removed from the filter name, because we detected this just repeats the extensions on the right of &quot;|&quot;. Extensions on the right of &quot;|&quot; must be separated by semicolons, extensions within parenthesis on the left of &quot;|&quot; may be separated by semicolons &quot;;&quot; or colons &quot;,&quot;.    ", "tags": "", "loc": "CastleStringUtils.html#GetFileFilterName"},
     {"title": "CastleStringUtils.GetFileFilterExtsStr", "text": " This is a simple basis for <a class=\"normal\" href=\"CastleStringUtils.html#GetFileFilterExts\">GetFileFilterExts</a>.  <p>If no &quot;|&quot; found, we return an empty string (in other words, file filter without &quot;|&quot; is treated as just a filter name, without any extensions).    ", "tags": "", "loc": "CastleStringUtils.html#GetFileFilterExtsStr"},
     {"title": "CastleStringUtils.SReplacePatterns", "text": " This is similar to standard StringReplace, but this does many replacements at once. This is just like StrUtils.StringsReplace in FPC.  <p>Patterns and Values arrays must have equal length. Patterns[0] will be replaced with Values[0], Patterns[1] with Values[0] etc. Patterns are scanned from left to right, that is if two pattern occurrences overlap &mdash; we will detect the leftmost one. If both patterns start at the same place (this means that one pattern is a prefix of the other), we will choose the first pattern in Patterns table.  <p>Using this avoids a common trap at repeated search-replace operations. A naive implementation of doing many search-replace over the same string is like  <p></p>  <pre class=\"longcode\"> Result := S; Result := StringReplace(Result, Patterns[<span class=\"pascal_numeric\">0</span>], Values[<span class=\"pascal_numeric\">0</span>], [rfReplaceAll]); Result := StringReplace(Result, Patterns[<span class=\"pascal_numeric\">1</span>], Values[<span class=\"pascal_numeric\">1</span>], [rfReplaceAll]); <span class=\"pascal_comment\">// etc.</span></pre>  <p>  <p>But the above fails badly when inserting some Values[] creates an occurrence of Pattern checked later. For example, when Values[0] contains inside whole Patterns[1]. More exotic situations involve when some Values[] glues with previous string contents to make a pattern detected later. This means that you could replace the same content many times, which is usually not what you want.  <p>That's why you should instead use this function for such situations.    ", "tags": "", "loc": "CastleStringUtils.html#SReplacePatterns"},
     {"title": "CastleStringUtils.SReplacePatterns", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SReplacePatterns"},
     {"title": "CastleStringUtils.SReplacePatterns", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SReplacePatterns"},
     {"title": "CastleStringUtils.SCharsCount", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SCharsCount"},
     {"title": "CastleStringUtils.SCharsCount", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SCharsCount"},
     {"title": "CastleStringUtils.STruncateHash", "text": " Removes also this very &quot;#&quot; character.  <p>If string doesn't contain hash character, it's simply returned.  <p>Useful for interpreting simple text files when you want to treat things after &quot;#&quot; like a comment.    ", "tags": "", "loc": "CastleStringUtils.html#STruncateHash"},
     {"title": "CastleStringUtils.SUnformattable", "text": " Saying simply, this doubles the &quot;%&quot; characters inside the string. The intention is to make such string that <code>Format(<code>SUnformattable</code>(S), []) = S</code>. In other words, &quot;quote&quot; any suspicious &quot;%&quot; characters in S for Format.    ", "tags": "", "loc": "CastleStringUtils.html#SUnformattable"},
     {"title": "CastleStringUtils.SAnsiCompare", "text": " This simply does AnsiCompareStr or AnsiCompareText, depending on IgnoreCase.  <p>Returns value &lt; 0 when S1 &lt; S2, returns 0 when S1 = S2 and value &gt; 0 when S1 &gt; S2.    ", "tags": "", "loc": "CastleStringUtils.html#SAnsiCompare"},
     {"title": "CastleStringUtils.SAnsiSame", "text": " Shortcut for <a class=\"normal\" href=\"CastleStringUtils.html#SAnsiCompare\">SAnsiCompare</a>(S1, S2) = 0    ", "tags": "", "loc": "CastleStringUtils.html#SAnsiSame"},
     {"title": "CastleStringUtils.SPercentReplace", "text": " Something like a more generalized Format routine.  <p>More precisely: every two-char sequence that starts with PercentChar and then is followed by one of Replaces[I].c characters is replaced with appropriate Replaces[i].s. Moreover, a pair of two PercentChar characters is replaced with one PercentChar character.  <p><i>For example</i>, assume that Replaces contains two items: <code>(c: 'B'; s: '&lt;bold&gt;'), (c: 'b'; s: '&lt;/bold&gt;')</code>. Then <code><a class=\"normal\" href=\"CastleStringUtils.html#SPercentReplace\">SPercentReplace</a>('100%% of cats are %Bcute%b', Replaces)</code> will return string <code>'100% of cats are &lt;bold&gt;cute&lt;/bold&gt;'</code>.  <p><a class=\"normal\" href=\"CastleStringUtils.EUnknownPercentFormat.html\">EUnknownPercentFormat</a> is raised if we will see two-char sequence that starts with PercentChar and then is followed by character that is not any Replaces[i].c and is not PercentChar. Also, a single PercentChar at the end of the string is an error.  <p><i>For example</i>, assume that Replaces contains the same two items as previously. Following calls will result in <a class=\"normal\" href=\"CastleStringUtils.EUnknownPercentFormat.html\">EUnknownPercentFormat</a> being raised: <code><a class=\"normal\" href=\"CastleStringUtils.html#SPercentReplace\">SPercentReplace</a>('Unknown sequence %x', Replaces)</code>, <code><a class=\"normal\" href=\"CastleStringUtils.html#SPercentReplace\">SPercentReplace</a>('Unterminated sequence %', Replaces)</code>.  <p>If ErrorOnUnknownPercentFormat is <code>False</code>, then <a class=\"normal\" href=\"CastleStringUtils.EUnknownPercentFormat.html\">EUnknownPercentFormat</a> will not be raised. Instead, incorrect sequence (like %x or unterminated % in examples above) will simply be left in the string.  <p>Of course, replacing is done intelligently. Which means that e.g. sequence of four % characters will be correctly transformed into two % characters.  <p>Note that IgnoreCase is used to match characters for Replaces[I].c. IgnoreCase is not used when it comes to comparing with PercentChar character, i.e. even when PercentChar will be set to some letter, it will always be compared in case-sensitive manner, regardless of IgnoreCase value.  <p>It is undefined (meaning: don't do it) what happens if Replaces array contains more than once the same character C, or if any character C in Replaces array is equal to PercentChar.  <p>ReplacementsDone, if passed, will return how many replacements were done. Not counting &quot;meaningless&quot; replacements of pair of PercentChar to one PercentChar (that is, we count only actual replacements from Replaces array).  <p>  <p>    EUnknownPercentFormat In case of error in InitialFormat string, if ErrorOnUnknownPercentFormat is <code>True</code>.", "tags": "", "loc": "CastleStringUtils.html#SPercentReplace"},
     {"title": "CastleStringUtils.SPercentReplace", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#SPercentReplace"},
     {"title": "CastleStringUtils.FormatNameCounter", "text": " Any sequence <code>@counter(&lt;padding&gt;)</code> is detected (where &lt;padding&gt; is any integer &gt;= 0) and replaced with Index padded with zeros (to given &lt;padding&gt; length).  <p>If AllowOldPercentSyntax is <code>True</code> then we also allow older deprecated syntax: replace %d in the NamePattern with Index. This is used only if <code>@counter(&lt;padding&gt;)</code> was not found in NamePattern.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>%d is replaced with Index.  <p>You can insert a non-negative number between % and d, to pad the counter with zeros to desired length. For example, with Counter = 2, %d is replaced with just &quot;2&quot;, %2d is replaced with &quot;02&quot;, %4d is replaced with &quot;0002&quot;.</p></li>   <li><p>%% is replaced with single percent char %.</p></li>   <li><p>Everything else is just copied to resulting string. Not recognized %-patterns are also just copied. The main purpose of this is to specify filenames with optional placeholders, so unrecognized stuff should be gracefully ignored.</p></li> </ul>  <p>  <p>The percent syntax was deprecated as it cannot be used with URLs. Inside URLs, percent character must always be encodede as <code>%25</code>. Sequence like <code>%4d</code> must mean letter &quot;M&quot; (ASCII 77, which is 4d in hexadecimal) inside URL. We could potentially allow syntax like <code>%25d</code> or <code>%254d</code> (4-digit counter), but that's just ugly, and compatibility had to be broken anyway (after Castle Game Engine 4.0.1, you have to fix URLs to image sequences anyway, as <code>%4d</code> must mean letter &quot;M&quot;).  <p>See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_movie_from_image_sequence\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_movie_from_image_sequence</a> for an example when this is useful.  <p>    ", "tags": "", "loc": "CastleStringUtils.html#FormatNameCounter"},
     {"title": "CastleStringUtils.FormatNameCounter", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#FormatNameCounter"},
     {"title": "CastleStringUtils.DigitAsChar", "text": " Use only for arguments within 0..9 range.    ", "tags": "", "loc": "CastleStringUtils.html#DigitAsChar"},
     {"title": "CastleStringUtils.DigitAsByte", "text": " Use only for characters in '0'...'9' range.    ", "tags": "", "loc": "CastleStringUtils.html#DigitAsByte"},
     {"title": "CastleStringUtils.IntToStrZPad", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#IntToStrZPad"},
     {"title": "CastleStringUtils.IntToStrThousands", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#IntToStrThousands"},
     {"title": "CastleStringUtils.IntToStrThousands", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#IntToStrThousands"},
     {"title": "CastleStringUtils.IntToStrBase", "text": " For digits above '9', we will use upper letters 'A', 'B'... etc. That's also why Base cannot be larger than 'Z'-'A' + 1 + 10 (we would not have enough digits then).  <p>Overloaded versions with MinLength pad result with zeros to have at least MinLength.  <p>This is similar to the standard StrUtils.Dec2Numb, but it can handle negative numbers without any problems (adds a minus sign at the beginning then).  <p>    ", "tags": "", "loc": "CastleStringUtils.html#IntToStrBase"},
     {"title": "CastleStringUtils.IntToStrBase", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#IntToStrBase"},
     {"title": "CastleStringUtils.IntToStrBase", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#IntToStrBase"},
     {"title": "CastleStringUtils.IntToStrBase", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#IntToStrBase"},
     {"title": "CastleStringUtils.IntToStr2", "text": " MinLength means to left-pad result with zeros if necessary.  <p>This is similar to the standard StrUtils.IntToBin function, but this works in an obvious way for negative numbers (adds a minus sign at the beginning).    ", "tags": "", "loc": "CastleStringUtils.html#IntToStr2"},
     {"title": "CastleStringUtils.IntToStr16", "text": "  <p>This is similar to the standard SysUtils.IntToHex function, but this works in an obvious way for negative numbers (adds a minus sign at the beginning). Contrast this with SysUtils.IntToHex, that instead shows the value of negative integer typecasted as unsigned (so it's in 2-completent). So IntToHex(-1, 1) = 'FFFFFFFF', while <a class=\"normal\" href=\"CastleStringUtils.html#IntToStr16\">IntToStr16</a>(-1) = '-1'.  <p>    ", "tags": "", "loc": "CastleStringUtils.html#IntToStr16"},
     {"title": "CastleStringUtils.IntToStr16", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#IntToStr16"},
     {"title": "CastleStringUtils.PointerToStr", "text": " hexadecimal value. &quot;0x&quot; is not a Pascal standard for coding hex values, but it's so popular that users are more likely to &quot;get&quot; 0x notation.    ", "tags": "", "loc": "CastleStringUtils.html#PointerToStr"},
     {"title": "CastleStringUtils.Str2ToInt", "text": " String must contain only '0', '1' (digits) and start with an optional sign (+ or -).  <p>This is similar to the standard StrUtils.Numb2Dec (with Base = 2) function, but this reliably raises EConvertError in case of trouble.  <p>    EConvertError In case of invalid string.", "tags": "", "loc": "CastleStringUtils.html#Str2ToInt"},
     {"title": "CastleStringUtils.StrHexToInt", "text": " String must contain only digits (0-9, a-z, A-Z), and with an optional sign (+ or -).  <p>This is similar to the standard StrUtils.Hex2Dec function, but it returns an Int64 value. So this is safer and more consistent with standard StrToInt.  <p>    EConvertError In case of invalid string.", "tags": "", "loc": "CastleStringUtils.html#StrHexToInt"},
     {"title": "CastleStringUtils.StrToFloatDef", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#StrToFloatDef"},
     {"title": "CastleStringUtils.SetToStr", "text": " This assumes that given SetVariable is a set value, and the set type is &quot;set of [NumStart .. NumEnd]&quot;.  <p><i>Implementation is heavily dependent on how the sets are internally stored.</i> For now, we depend that a set of [NumStart .. NumEnd] behaves like a set of Byte, shifted to the left (i.e., NumStart corresponds to a 0 in set of Byte). This is not necessarily true ! For example in Delphi 5 (as far as I remember &mdash; I don't have this Delphi now, and I don't remember on which Delphi version I observed this) set of 1..16 uses first three bytes, and the first bit (that would correspond to 0) is simply wasted. In fact, SizeOf such set is still 4, which means that internally sets eat 4 bytes anyway. But SizeOf set 200..216 is also 4, which means that the compiler is smart and doesn't waste too much space to store only 17 bits.  <p>This all is not a rant on internal set handling by Delphi. On the contrary, Delphi does it for speed reasons, and that's very good. This is just a warning that <code>SetToStr</code> is not really reliable, and you may need to experiment a little with NumStart / NumEnd values to get sensible results. Although if your set is like &quot;set of [0 ... something]&quot;, this should usually work OK.  <p>Still: <i>this function should be used only for debug purposes. Don't depend on it working 100% correctly always &mdash; it can't, because we can't depend on how compiler stores sets.</i>    ", "tags": "", "loc": "CastleStringUtils.html#SetToStr"},
     {"title": "CastleStringUtils.CharSetToStr", "text": "    ", "tags": "", "loc": "CastleStringUtils.html#CharSetToStr"},
     {"title": "CastleStringUtils.PCharOrNil", "text": " If string is empty, this returns <code>Nil</code>, otherwise it works just like PChar(S): returns a Pointer(S) with appropriate type cast.    ", "tags": "", "loc": "CastleStringUtils.html#PCharOrNil"},
     {"title": "CastleStringUtils.SCompressWhiteSpace", "text": " This is nice when you have a string (possibly multiline) supplied by user, and you want to use this for some UI item (like window's caption or menu item) &mdash; this &quot;sanitizes&quot; whitespace inside such string.    ", "tags": "", "loc": "CastleStringUtils.html#SCompressWhiteSpace"},
     {"title": "CastleStringUtils.SCheckChars", "text": " Raise exception otherwise (if RaiseExceptionOnError, default) or make a warning.     EInvalidChar If string contains an invalid character and RaiseExceptionOnError = <code>True</code>. The exception string is informative, containing the string value, character, character position.", "tags": "", "loc": "CastleStringUtils.html#SCheckChars"},
     {"title": "CastleStringUtils.TDynamicStringArray", "text": " ", "tags": "", "loc": "CastleStringUtils.html#TDynamicStringArray"},
     {"title": "CastleStringUtils.TSearchOptions", "text": " ", "tags": "", "loc": "CastleStringUtils.html#TSearchOptions"},
     {"title": "CastleStringUtils.TSetOfChars", "text": " ", "tags": "", "loc": "CastleStringUtils.html#TSetOfChars"},
     {"title": "CastleTerrain", "text": " ", "tags": "", "loc": "CastleTerrain.html"},
     {"title": "CastleTerrain.TTerrain", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrain.html"},
     {"title": "CastleTerrain.TTerrain.Height", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrain.html#Height"},
     {"title": "CastleTerrain.TTerrain.CreateNode", "text": "  <p>InputRange determines the range of values (minimum and maximum X and Y) queried from the underlying terrain, that is: queried using the <a class=\"normal\" href=\"CastleTerrain.TTerrain.html#Height\">Height</a> method.  <p>OutputRange determines the span of the resulting shape in X and Z coordinates. Note that, when converting a heightmap to 3D, the 2nd dimension is Z. In 3D, we use Y for height, as this is the default in X3D and Castle Game Engine.  <p>Often you will set InputRange and OutputRange to the same values, but you don't have to. Often they will at least have the same aspect ratio (actually, often they will be square), but you don't have to.  <p>Divisions determines how dense is the mesh.  <p>We return the node that you should insert to your scene.  <p>It will use the given <a class=\"normal\" href=\"X3DNodes.TAppearanceNode.html\">TAppearanceNode</a>. The appearance is not configured in any way by this method, and it can even be <code>Nil</code>.    ", "tags": "", "loc": "CastleTerrain.TTerrain.html#CreateNode"},
     {"title": "CastleTerrain.TTerrain.UpdateNode", "text": " The appearance of the previously created node (in <a class=\"normal\" href=\"CastleTerrain.TTerrain.html#CreateNode\">CreateNode</a>) is preserved.    ", "tags": "", "loc": "CastleTerrain.TTerrain.html#UpdateNode"},
     {"title": "CastleTerrain.TTerrain.CreateNode", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrain.html#CreateNode"},
     {"title": "CastleTerrain.TTerrain.CreateTriangulatedNode", "text": " It's has little less quality (triangulation is not adaptive like for ElevationGrid), but updating it (by <a class=\"normal\" href=\"CastleTerrain.TTerrain.html#UpdateTriangulatedNode\">UpdateTriangulatedNode</a>) is a little faster (than updating the <a class=\"normal\" href=\"CastleTerrain.TTerrain.html#CreateNode\">CreateNode</a> by UpdatNode). In practice, the speed gain is minimal, and this method will likely be removed at some point.  <p>The parameters have the same meaning as for <a class=\"normal\" href=\"CastleTerrain.TTerrain.html#CreateNode\">CreateNode</a>, and resulting look should be the same.    ", "tags": "", "loc": "CastleTerrain.TTerrain.html#CreateTriangulatedNode"},
     {"title": "CastleTerrain.TTerrain.UpdateTriangulatedNode", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrain.html#UpdateTriangulatedNode"},
     {"title": "CastleTerrain.TTerrainImage", "text": "  <p>The image covers (<a class=\"normal\" href=\"CastleTerrain.TTerrainImage.html#ImageX1\">ImageX1</a>, <a class=\"normal\" href=\"CastleTerrain.TTerrainImage.html#ImageY1\">ImageY1</a>) ... (<a class=\"normal\" href=\"CastleTerrain.TTerrainImage.html#ImageX2\">ImageX2</a>, <a class=\"normal\" href=\"CastleTerrain.TTerrainImage.html#ImageY2\">ImageY2</a>) area in XY plane. If you ask for Height outside of this range, it is repeated infinitely (if <a class=\"normal\" href=\"CastleTerrain.TTerrainImage.html#ImageRepeat\">ImageRepeat</a>) or clamped (if not <a class=\"normal\" href=\"CastleTerrain.TTerrainImage.html#ImageRepeat\">ImageRepeat</a>). Image color (converted to grayscale) acts as height (scaled by <a class=\"normal\" href=\"CastleTerrain.TTerrainImage.html#ImageHeightScale\">ImageHeightScale</a>).  <p>When image is not loaded, this always returns height = 0. ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html"},
     {"title": "CastleTerrain.TTerrainImage.Create", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#Create"},
     {"title": "CastleTerrain.TTerrainImage.Destroy", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#Destroy"},
     {"title": "CastleTerrain.TTerrainImage.Height", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#Height"},
     {"title": "CastleTerrain.TTerrainImage.LoadImage", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#LoadImage"},
     {"title": "CastleTerrain.TTerrainImage.ClearImage", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#ClearImage"},
     {"title": "CastleTerrain.TTerrainImage.ImageURL", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#ImageURL"},
     {"title": "CastleTerrain.TTerrainImage.ImageHeightScale", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#ImageHeightScale"},
     {"title": "CastleTerrain.TTerrainImage.ImageRepeat", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#ImageRepeat"},
     {"title": "CastleTerrain.TTerrainImage.ImageX1", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#ImageX1"},
     {"title": "CastleTerrain.TTerrainImage.ImageY1", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#ImageY1"},
     {"title": "CastleTerrain.TTerrainImage.ImageX2", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#ImageX2"},
     {"title": "CastleTerrain.TTerrainImage.ImageY2", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainImage.html#ImageY2"},
     {"title": "CastleTerrain.TTerrainCasScript", "text": " At construction, pass FunctionExpression, that is <a class=\"normal\" href=\"CastleScript.html\">CastleScript</a> language expression calculating height based on X, Y.  <p>This descends from <a class=\"normal\" href=\"CastleTerrain.TTerrainImage.html\">TTerrainImage</a>, so you add an image to your function result. ", "tags": "", "loc": "CastleTerrain.TTerrainCasScript.html"},
     {"title": "CastleTerrain.TTerrainCasScript.Create", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainCasScript.html#Create"},
     {"title": "CastleTerrain.TTerrainCasScript.Destroy", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainCasScript.html#Destroy"},
     {"title": "CastleTerrain.TTerrainCasScript.Height", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainCasScript.html#Height"},
     {"title": "CastleTerrain.TTerrainNoise", "text": "  <p>&quot;Synthesized noise&quot; means it's not simply something random. We take the noise (integer noise, i.e. hash), smooth it (how well, and how fast &mdash; see <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Interpolation\">Interpolation</a> and <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Blur\">Blur</a>), and add several functions (&quot;<a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Octaves\">octaves</a>&quot;) of such noise (with varying <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Frequency\">frequency</a> and <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Amplitude\">amplitude</a>) together. This is the kind of noise used to synthesize textures, terrains and all other procedural stuff.  <p>For more info about math inside:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>[<a  href=\"http://en.wikipedia.org/wiki/Fractional_Brownian_motion\">http://en.wikipedia.org/wiki/Fractional_Brownian_motion</a>]. This is the idea of summing up <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Octaves\">octaves</a> of noise. Ken Musgrave's dissertation has a lot of info and interesting references: [<a  href=\"http://www.kenmusgrave.com/dissertation.html\">http://www.kenmusgrave.com/dissertation.html</a>]</p></li>   <li><p>Blender's source code is informative, interesting file is blender/source/blender/blenlib/intern/noise.c</p></li>   <li><p>The simplest practical <a class=\"normal\" href=\"introduction.html\">introduction</a> to the idea is on [<a  href=\"http://freespace.virgin.net/hugo.elias/models/m_perlin.htm\">http://freespace.virgin.net/hugo.elias/models/m_perlin.htm</a>]. It describes how to get nice noise very easily, and my approach follows theirs.</p></li> </ul>  <p>  <p>This descends from <a class=\"normal\" href=\"CastleTerrain.TTerrainImage.html\">TTerrainImage</a>, so you can add an image to your function result, e.g. to flatten some specific generated area. ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html"},
     {"title": "CastleTerrain.TTerrainNoise.Create", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Create"},
     {"title": "CastleTerrain.TTerrainNoise.Height", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Height"},
     {"title": "CastleTerrain.TTerrainNoise.Octaves", "text": " This linearly affects the time for Height call, so don't make it too much. Usually &tilde;a few are Ok.  <p>(The fact that it's a float is just a simple trick to allow smooth transitions from x to x+1. In fact, it's executed like Trunc(<code>Octaves</code>) * some noises + Frac(<code>Octaves</code>) * some last noise.) ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Octaves"},
     {"title": "CastleTerrain.TTerrainNoise.Smoothness", "text": " When we double <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Frequency\">frequency</a>, <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Amplitude\">amplitude</a> is divided by this. Smaller values &lt;=&gt; larger <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Frequency\">frequency</a> noise is more visible, so terrain is less smooth (more noisy).  <p>This is elsewhere called fractal increment, fractal dimension parameter, &quot;H&quot;, spectral exponent (see e.g. Blender sources, Musgrave's dissertation). Do not confuse this with &quot;lacunarity&quot; (how <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Frequency\">frequency</a> changes in each octave), that is simply hardcoded to 2.0 in our code currently. In [<a  href=\"http://freespace.virgin.net/hugo.elias/models/m_perlin.htm\">http://freespace.virgin.net/hugo.elias/models/m_perlin.htm</a>], the inverse of this 1/<code>Smoothness</code> is called &quot;Persistence&quot;.  <p>I decided to call it &quot;<code>Smoothness</code>&quot;, since this is the practical intuitive meaning.  <p>Value equal 1.0 means that <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Amplitude\">amplitude</a> doesn't change at all, each noise <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Frequency\">frequency</a> is visible the same, so in effect you will just see a lot of noise. And values &lt; 1.0 are really nonsense, they make more <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Frequency\">frequency</a> noise even more visible, which means that the terrain is dominated by noise. ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Smoothness"},
     {"title": "CastleTerrain.TTerrainNoise.Amplitude", "text": " <code>Amplitude</code> scales the height of the result, and <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Frequency\">Frequency</a> scales the size of the bumps.  ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Amplitude"},
     {"title": "CastleTerrain.TTerrainNoise.Frequency", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Frequency"},
     {"title": "CastleTerrain.TTerrainNoise.Interpolation", "text": "  <p>Setting this to <a class=\"normal\" href=\"CastleTerrain.html#niNone\">niNone</a> turns off <code>interpolation</code>, which means that your terrain is a sum of a couple of blocky noises &mdash; ugly.  <p>Using <a class=\"normal\" href=\"CastleTerrain.html#niLinear\">niLinear</a> (means &quot;bilinear&quot;, since this is 2D case) is also usually bad. Unless you use <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Octaves\">octaves</a> of really high frequencies, usually sharp edges / flat in-betweens will be visible.  <p>Using <a class=\"normal\" href=\"CastleTerrain.html#niCosine\">niCosine</a> in right now the best.  <p>Using <a class=\"normal\" href=\"CastleTerrain.html#niSpline\">niSpline</a> is even better looking (usese Catmull-Rom splines, which are special case of cubic Hermite spline, see <a  href=\"http://en.wikipedia.org/wiki/Cubic_Hermite_spline\">http://en.wikipedia.org/wiki/Cubic_Hermite_spline</a>, <a  href=\"http://en.wikipedia.org/wiki/Bicubic_interpolation\">http://en.wikipedia.org/wiki/Bicubic_interpolation</a>). But it's more time consuming under current implementation. ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Interpolation"},
     {"title": "CastleTerrain.TTerrainNoise.Blur", "text": " This helps to remove the inherent vertical/horizontal directionality in our 2D noise (it also makes it more smooth, since that's what blurring is about; you may want to increase <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Frequency\">Frequency</a> * 2 to balance this).  <p>This is independent from <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Interpolation\">Interpolation</a>. Although the need for <code>Blur</code> is most obvious in poor/none <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Interpolation\">interpolation</a> methods (none, linear), it also helps for the nicer <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Interpolation\">interpolation</a> methods (cosine, cubic).  <p>Note about [<a  href=\"http://freespace.virgin.net/hugo.elias/models/m_perlin.htm\">http://freespace.virgin.net/hugo.elias/models/m_perlin.htm</a>]: this &quot;blurring&quot; is called &quot;smoothing&quot; there. I call it blurring, as it seems more precise to me. ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Blur"},
     {"title": "CastleTerrain.TTerrainNoise.Seed", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Seed"},
     {"title": "CastleTerrain.TTerrainNoise.Heterogeneous", "text": " Intuitively, the idea is that the terrain details (from higher <a class=\"normal\" href=\"CastleTerrain.TTerrainNoise.html#Octaves\">octaves</a>) are more noisy when ground is higher. This is realistic (debris gathers in lower terrain, smoothing it more).  <p>More precisely, this means that we accumulate multiplied previous noise, at each step dividing this accumulated result by <code>Heterogeneous</code>, and clamping at 1.0. So when <code>Heterogeneous</code> is very small, this always ends up 1.0, and we get normal (homogeneous) generation. When <code>Heterogeneous</code> is larger, the details (at lower ground) are scaled down (terrain is smoother).  <p>This is called &quot;threshold&quot; in Musgrave's dissertation (see algorithm in section 2.3.2.5 &quot;A Large Scale Terrain Model&quot;). ", "tags": "", "loc": "CastleTerrain.TTerrainNoise.html#Heterogeneous"},
     {"title": "CastleTerrain.TTerrainGrid", "text": " Used when your underlying data is a simple 2D array of <a class=\"normal\" href=\"CastleTerrain.TTerrainGrid.html#GridSizeX\">GridSizeX</a> * <a class=\"normal\" href=\"CastleTerrain.TTerrainGrid.html#GridSizeY\">GridSizeY</a> heights. The idea is that on such terrain, there are special grid points where the height data is accurate. Everything else is an interpolation derived from this data. ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html"},
     {"title": "CastleTerrain.TTerrainGrid.Create", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#Create"},
     {"title": "CastleTerrain.TTerrainGrid.Height", "text": "  <p>This is implemented in <a class=\"normal\" href=\"CastleTerrain.TTerrainGrid.html\">TTerrainGrid</a> class, using the data returned by <a class=\"normal\" href=\"CastleTerrain.TTerrainGrid.html#GridHeight\">GridHeight</a>. For float X in 0..1 range, we return grid values for grid points 0..GridSizeX - 1. Outside 0..1 range, we clamp (that is, take nearest value from 0..1 range) &mdash; this way the terrain seemingly continues into the infinity.  <p>In comparison to <a class=\"normal\" href=\"CastleTerrain.TTerrainGrid.html#GridHeight\">GridHeight</a>, it's (very slightly) slower, and it doesn't really present any more interesting information (in contrast to typical procedural terrain, where there can be always more and more detail at each level).    ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#Height"},
     {"title": "CastleTerrain.TTerrainGrid.GridHeight", "text": " Use <code>GridHeight</code>(0..GridSizeX - 1, 0..GridSizeY - 1) to get height at particular grid point.     ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#GridHeight"},
     {"title": "CastleTerrain.TTerrainGrid.GridSizeX", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#GridSizeX"},
     {"title": "CastleTerrain.TTerrainGrid.GridSizeY", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#GridSizeY"},
     {"title": "CastleTerrain.TTerrainGrid.GridX1", "text": " These do not affect <a class=\"normal\" href=\"CastleTerrain.TTerrainGrid.html#GridHeight\">GridHeight</a> method.  ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#GridX1"},
     {"title": "CastleTerrain.TTerrainGrid.GridY1", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#GridY1"},
     {"title": "CastleTerrain.TTerrainGrid.GridX2", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#GridX2"},
     {"title": "CastleTerrain.TTerrainGrid.GridY2", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#GridY2"},
     {"title": "CastleTerrain.TTerrainGrid.GridHeightScale", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainGrid.html#GridHeightScale"},
     {"title": "CastleTerrain.TTerrainSRTM", "text": " ", "tags": "", "loc": "CastleTerrain.TTerrainSRTM.html"},
     {"title": "CastleTerrain.TTerrainSRTM.CreateFromFile", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainSRTM.html#CreateFromFile"},
     {"title": "CastleTerrain.TTerrainSRTM.GridHeight", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainSRTM.html#GridHeight"},
     {"title": "CastleTerrain.TTerrainSRTM.GridSizeX", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainSRTM.html#GridSizeX"},
     {"title": "CastleTerrain.TTerrainSRTM.GridSizeY", "text": "    ", "tags": "", "loc": "CastleTerrain.TTerrainSRTM.html#GridSizeY"},
     {"title": "CastleTerrain.TColorFromHeightFunction", "text": "    ", "tags": "", "loc": "CastleTerrain.html#TColorFromHeightFunction"},
     {"title": "CastleTerrain.TNoiseInterpolation", "text": "  niNone    niLinear    niCosine    niSpline   ", "tags": "", "loc": "CastleTerrain.html#TNoiseInterpolation"},
     {"title": "CastleTerrain.TNoise2DMethod", "text": "    ", "tags": "", "loc": "CastleTerrain.html#TNoise2DMethod"},
     {"title": "CastleTextureFontData", "text": " ", "tags": "", "loc": "CastleTextureFontData.html"},
     {"title": "CastleTextureFontData.TTextureFontData", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html"},
     {"title": "CastleTextureFontData.TTextureFontData.Create", "text": "  <p>Providing charaters list as <code>Nil</code> means that we only create glyphs for <a class=\"normal\" href=\"CastleStringUtils.html#SimpleAsciiCharacters\">SimpleAsciiCharacters</a>, which includes only the basic ASCII characters. The ACharacters instance <i>does not</i> become owned by this object, so remember to free it after calling this constructor.  <p>    EFreeTypeLibraryNotFound If the freetype library is not installed.", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#Create"},
     {"title": "CastleTextureFontData.TTextureFontData.CreateFromData", "text": " Useful when font data is embedded inside the Pascal source code. AGlyphs instance, and AImage instance, become owned by this class.    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#CreateFromData"},
     {"title": "CastleTextureFontData.TTextureFontData.Destroy", "text": "    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#Destroy"},
     {"title": "CastleTextureFontData.TTextureFontData.Glyph", "text": " <code>Nil</code> if given <code>glyph</code> not loaded (because was not requested at constructor, or because it doesn't exist in the font).    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#Glyph"},
     {"title": "CastleTextureFontData.TTextureFontData.LoadedGlyphs", "text": " <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html#Glyph\">Glyph</a> will answer non-nil exactly for these characters. The resulting list instance is owned by caller, so take care to free it.    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#LoadedGlyphs"},
     {"title": "CastleTextureFontData.TTextureFontData.TextWidth", "text": "    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#TextWidth"},
     {"title": "CastleTextureFontData.TTextureFontData.TextHeight", "text": "    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#TextHeight"},
     {"title": "CastleTextureFontData.TTextureFontData.TextHeightBase", "text": " This doesn't take into account height of the text below the baseline (for example letter &quot;y&quot; has the tail below the baseline in most fonts).    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#TextHeightBase"},
     {"title": "CastleTextureFontData.TTextureFontData.TextMove", "text": "    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#TextMove"},
     {"title": "CastleTextureFontData.TTextureFontData.RowHeight", "text": " This may be calculated as simply <code><a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html#TextHeight\">TextHeight</a>('Wy')</code> for most normal fonts.    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#RowHeight"},
     {"title": "CastleTextureFontData.TTextureFontData.RowHeightBase", "text": " Similar to <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html#TextHeightBase\">TextHeightBase</a> and <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html#TextHeight\">TextHeight</a>, note that <code>RowHeightBase</code> is generally smaller than <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html#RowHeight\">RowHeight</a>, because <code>RowHeightBase</code> doesn't care how low the letter may go below the baseline.    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#RowHeightBase"},
     {"title": "CastleTextureFontData.TTextureFontData.Descend", "text": "    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#Descend"},
     {"title": "CastleTextureFontData.TTextureFontData.AntiAliased", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#AntiAliased"},
     {"title": "CastleTextureFontData.TTextureFontData.Size", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#Size"},
     {"title": "CastleTextureFontData.TTextureFontData.Image", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.html#Image"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyph", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyph.html"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyph.X", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyph.html#X"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyph.Y", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyph.html#Y"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyph.AdvanceX", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyph.html#AdvanceX"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyph.AdvanceY", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyph.html#AdvanceY"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyph.Width", "text": " Always Width and Height &gt;= 0 (they are Cardinal type after all), but note that it is possible that Width = Height = 0 (it commonly happens for space ' ' character). ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyph.html#Width"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyph.Height", "text": " Always Width and Height &gt;= 0 (they are Cardinal type after all), but note that it is possible that Width = Height = 0 (it commonly happens for space ' ' character). ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyph.html#Height"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyph.ImageX", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyph.html#ImageX"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyph.ImageY", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyph.html#ImageY"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyphDictionary", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyphDictionary.html"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyphDictionary.Create", "text": "    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyphDictionary.html#Create"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyphDictionary.Destroy", "text": "    ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyphDictionary.html#Destroy"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyphDictionary.OwnsGlyphs", "text": " ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyphDictionary.html#OwnsGlyphs"},
     {"title": "CastleTextureFontData.TTextureFontData.TGlyphDictionary.Items", "text": " Setting this is allowed regardless if the key previously existed or not, in other words: setting this does AddOrSetValue, contrary to the ancestor TDictionary that only allows setting when the key already exists. ", "tags": "", "loc": "CastleTextureFontData.TTextureFontData.TGlyphDictionary.html#Items"},
     {"title": "CastleTextureFontData.EFreeTypeLibraryNotFound", "text": " ", "tags": "", "loc": "CastleTextureFontData.html#EFreeTypeLibraryNotFound"},
     {"title": "CastleTextureImages", "text": " This unit is not OpenGL-specific, it should be suitable for all 3D libraries. See CastleGLImage for OpenGL-specific handling of textures and other images.  <p>Texture is any <a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a> instance. This includes not only a traditional 2D/3D matrix of pixels represented as <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>, but also a texture compressed for GPU (<a class=\"normal\" href=\"CastleImages.TGPUCompressedImage.html\">TGPUCompressedImage</a>). Moreover, a texture may have mipmaps defined &mdash; they are stored inside <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html\">TCompositeImage</a> instance (that contains a list of <a class=\"normal\" href=\"CastleImages.TEncodedImage.html\">TEncodedImage</a>).  <p>Since not everything can really deal with such flexible definition of a texture, we decided to separate some routines specifically for textures. For example, you have <a class=\"normal\" href=\"CastleTextureImages.html#LoadTextureImage\">LoadTextureImage</a> to load full texture information &mdash; contrast this with <a class=\"normal\" href=\"CastleImages.html#LoadImage\">LoadImage</a> routine in <a class=\"normal\" href=\"CastleImages.html\">CastleImages</a> unit, that only returns <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> (a &quot;normal&quot; way to deal with image data). ", "tags": "", "loc": "CastleTextureImages.html"},
     {"title": "CastleTextureImages.TTexturesVideosCache", "text": "  <p>Load by <a class=\"normal\" href=\"CastleTextureImages.TTexturesVideosCache.html#TextureImage_IncReference\">TextureImage_IncReference</a>, free by <a class=\"normal\" href=\"CastleTextureImages.TTexturesVideosCache.html#TextureImage_DecReference\">TextureImage_DecReference</a>. These replace <a class=\"normal\" href=\"CastleTextureImages.html#LoadTextureImage\">LoadTextureImage</a>, and manual freeing of Image/Composite.  <p>If you used IncReference that returns Composite, then you should also free using DecReference that takes Composite. If you used IncReference without Composite parameter, then also free using DecReference without Composite parameter.  <p>The idea is that instead of <code><a class=\"normal\" href=\"CastleTextureImages.html#LoadTextureImage\">LoadTextureImage</a>(...)</code> call <code>Cache.TextureImage_IncReference(...)</code>. Later, instead of freeing this image, call <code><a class=\"normal\" href=\"CastleTextureImages.TTexturesVideosCache.html#TextureImage_DecReference\">TextureImage_DecReference</a>(Image)</code>. From your point of view, things will work the same. But if you expect to load many textures from the same URL, then you will get a great speed and memory saving, because image will only be actually loaded once. Notes:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Note that in case of problems with loading, <a class=\"normal\" href=\"CastleTextureImages.TTexturesVideosCache.html#TextureImage_IncReference\">TextureImage_IncReference</a> may raise an exception, just like normal <a class=\"normal\" href=\"CastleTextureImages.html#LoadTextureImage\">LoadTextureImage</a>. In this case it's guaranteed that no reference will be incremented, of course. If LoadTextureImage_IncReference returns in a normal way, then it will return something non-<code>Nil</code>, just like <a class=\"normal\" href=\"CastleTextureImages.html#LoadTextureImage\">LoadTextureImage</a> does.</p></li>   <li><p>LoadTextureImage_DecReference alwas sets Image to <code>Nil</code>, like FreeAndNil.</p></li>   <li><p>Since detecting image alpha channel type may be a little time-consuming (iteration over all pixels is needed), we also do it here and save in cache.</p></li> </ul>  <p>  <p>Note that before destroying this object you must free all textures, i.e. call LoadTextureImage_DecReference for all images allocated by LoadTextureImage_IncReference. <i>This class is not a lousy way of avoiding memory leaks</i> &mdash; it would be a bad idea, because it would cause sloppy programming, where memory is unnecessarily allocated for a long time. In fact, this class asserts in destructor that no images are in cache anymore, so if you compiled with assertions enabled, this class does the job of memory-leak detector. ", "tags": "", "loc": "CastleTextureImages.TTexturesVideosCache.html"},
     {"title": "CastleTextureImages.TTexturesVideosCache.Create", "text": "    ", "tags": "", "loc": "CastleTextureImages.TTexturesVideosCache.html#Create"},
     {"title": "CastleTextureImages.TTexturesVideosCache.Destroy", "text": "    ", "tags": "", "loc": "CastleTextureImages.TTexturesVideosCache.html#Destroy"},
     {"title": "CastleTextureImages.TTexturesVideosCache.TextureImage_IncReference", "text": "    ", "tags": "", "loc": "CastleTextureImages.TTexturesVideosCache.html#TextureImage_IncReference"},
     {"title": "CastleTextureImages.TTexturesVideosCache.TextureImage_IncReference", "text": "    ", "tags": "", "loc": "CastleTextureImages.TTexturesVideosCache.html#TextureImage_IncReference"},
     {"title": "CastleTextureImages.TTexturesVideosCache.TextureImage_DecReference", "text": "    ", "tags": "", "loc": "CastleTextureImages.TTexturesVideosCache.html#TextureImage_DecReference"},
     {"title": "CastleTextureImages.TTexturesVideosCache.TextureImage_DecReference", "text": "    ", "tags": "", "loc": "CastleTextureImages.TTexturesVideosCache.html#TextureImage_DecReference"},
     {"title": "CastleTextureImages.TTexturesVideosCache.Empty", "text": "    ", "tags": "", "loc": "CastleTextureImages.TTexturesVideosCache.html#Empty"},
     {"title": "CastleTextureImages.TextureImageClasses", "text": " ", "tags": "", "loc": "CastleTextureImages.html#TextureImageClasses"},
     {"title": "CastleTextureImages.TextureImageClassesAll", "text": " Some of them may require specific OpenGL extensions or versions (like GPU-compressed or float textures). ", "tags": "", "loc": "CastleTextureImages.html#TextureImageClassesAll"},
     {"title": "CastleTextureImages.LoadTextureImage", "text": " This will load image to memory formats supported by common 3D libraries (like OpenGL), for example it will never return <a class=\"normal\" href=\"CastleImages.TRGBFloatImage.html\">TRGBFloatImage</a> (although OpenGL may support it, but we cannot be sure at this point). It may return texture compressed using one of the GPU compression algorithms (see <a class=\"normal\" href=\"CastleImages.html#TTextureCompression\">TTextureCompression</a>).  <p>If the image comes from a <a class=\"normal\" href=\"CastleCompositeImage.TCompositeImage.html\">TCompositeImage</a> file (DDS, KTX...), it will also return it (if not, Composite returned will be <code>Nil</code>). This allows you to e.g. use texture mipmaps recorded there. Note that Composite.OwnsFirstImage is set to <code>False</code>, so you can always safely free everything by simple <code>FreeAndNil(Image); FreeAndNil(Composite);</code>.  <p>Overloaded version without Composite parameter assumes you're not interested in this information (still it handles Composite files of course, it just doesn't return Composite object instance).  <p>    ", "tags": "", "loc": "CastleTextureImages.html#LoadTextureImage"},
     {"title": "CastleTextureImages.LoadTextureImage", "text": "    ", "tags": "", "loc": "CastleTextureImages.html#LoadTextureImage"},
     {"title": "CastleTextureImages.TAutoMinificationFilter", "text": "  minNearest    minLinear    minNearestMipmapNearest    minNearestMipmapLinear    minLinearMipmapNearest    minLinearMipmapLinear    minDefault Interpretation of this filter depends on current <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#MagnificationFilter\">Scene.Attributes.MagnificationFilter</a>.   minFastest Alias for <a class=\"normal\" href=\"CastleTextureImages.html#minNearest\">minNearest</a>.   minNicest Alias for <a class=\"normal\" href=\"CastleTextureImages.html#minLinearMipmapLinear\">minLinearMipmapLinear</a>.  ", "tags": "", "loc": "CastleTextureImages.html#TAutoMinificationFilter"},
     {"title": "CastleTextureImages.TMinificationFilter", "text": " ", "tags": "", "loc": "CastleTextureImages.html#TMinificationFilter"},
     {"title": "CastleTextureImages.TAutoMagnificationFilter", "text": "  magNearest    magLinear    magDefault Interpretation of this filter depends on current <a class=\"normal\" href=\"CastleRenderer.TRenderingAttributes.html#MagnificationFilter\">Scene.Attributes.MagnificationFilter</a>.   magFastest Alias for magnNearest.   magNicest Alias for <a class=\"normal\" href=\"CastleTextureImages.html#magLinear\">magLinear</a>.  ", "tags": "", "loc": "CastleTextureImages.html#TAutoMagnificationFilter"},
     {"title": "CastleTextureImages.TMagnificationFilter", "text": " ", "tags": "", "loc": "CastleTextureImages.html#TMagnificationFilter"},
     {"title": "CastleTextureImages.LogTextureCache", "text": " Allows to see how the cache performs, and also how alpha channel is detected. A <i>lot</i> of log messages.  <p>Meaningful only if you initialized log (see <a class=\"normal\" href=\"CastleLog.html\">CastleLog</a> unit) by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a> first. ", "tags": "", "loc": "CastleTextureImages.html#LogTextureCache"},
     {"title": "CastleTiledMap", "text": " Based on Tiled v0.17. ", "tags": "", "loc": "CastleTiledMap.html"},
     {"title": "CastleTiledMap.TProperty", "text": " ", "tags": "", "loc": "CastleTiledMap.TProperty.html"},
     {"title": "CastleTiledMap.TProperty.Name", "text": " ", "tags": "", "loc": "CastleTiledMap.TProperty.html#Name"},
     {"title": "CastleTiledMap.TProperty.Value", "text": " ", "tags": "", "loc": "CastleTiledMap.TProperty.html#Value"},
     {"title": "CastleTiledMap.TProperty.AType", "text": " Can be string (default), int, float, bool, color or file (since 0.16, with color and file added in 0.17). ", "tags": "", "loc": "CastleTiledMap.TProperty.html#AType"},
     {"title": "CastleTiledMap.TData", "text": " ", "tags": "", "loc": "CastleTiledMap.TData.html"},
     {"title": "CastleTiledMap.TData.Encoding", "text": " When used, it can be &quot;base64&quot; and &quot;csv&quot; at the moment. ", "tags": "", "loc": "CastleTiledMap.TData.html#Encoding"},
     {"title": "CastleTiledMap.TData.Compression", "text": " Tiled Qt supports &quot;gzip&quot; and &quot;zlib&quot;. ", "tags": "", "loc": "CastleTiledMap.TData.html#Compression"},
     {"title": "CastleTiledMap.TData.Data", "text": " Uncompressed and decoded. ", "tags": "", "loc": "CastleTiledMap.TData.html#Data"},
     {"title": "CastleTiledMap.TImage", "text": " ", "tags": "", "loc": "CastleTiledMap.TImage.html"},
     {"title": "CastleTiledMap.TImage.Format", "text": " Valid values are file extensions like png, gif, jpg, bmp, etc. (since 0.9) ", "tags": "", "loc": "CastleTiledMap.TImage.html#Format"},
     {"title": "CastleTiledMap.TImage.Source", "text": " ", "tags": "", "loc": "CastleTiledMap.TImage.html#Source"},
     {"title": "CastleTiledMap.TImage.Trans", "text": " Up until Tiled 0.12, this value is written out without a # but this is planned to change. ", "tags": "", "loc": "CastleTiledMap.TImage.html#Trans"},
     {"title": "CastleTiledMap.TImage.Width", "text": " ", "tags": "", "loc": "CastleTiledMap.TImage.html#Width"},
     {"title": "CastleTiledMap.TImage.Height", "text": " ", "tags": "", "loc": "CastleTiledMap.TImage.html#Height"},
     {"title": "CastleTiledMap.TImage.Data", "text": " ", "tags": "", "loc": "CastleTiledMap.TImage.html#Data"},
     {"title": "CastleTiledMap.TTiledObject", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html"},
     {"title": "CastleTiledMap.TTiledObject.Id", "text": " Each object that is placed on a map gets a unique <code>id</code>. Even if an object was deleted, no object gets the same <code>ID</code>. Can not be changed in Tiled Qt. (since Tiled 0.11) ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Id"},
     {"title": "CastleTiledMap.TTiledObject.Name", "text": " An arbitrary string. ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Name"},
     {"title": "CastleTiledMap.TTiledObject.Type_", "text": " An arbitrary string. ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Type_"},
     {"title": "CastleTiledMap.TTiledObject.X", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#X"},
     {"title": "CastleTiledMap.TTiledObject.Y", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Y"},
     {"title": "CastleTiledMap.TTiledObject.Width", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Width"},
     {"title": "CastleTiledMap.TTiledObject.Height", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Height"},
     {"title": "CastleTiledMap.TTiledObject.Rotation", "text": " (since 0.10) ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Rotation"},
     {"title": "CastleTiledMap.TTiledObject.GId", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#GId"},
     {"title": "CastleTiledMap.TTiledObject.Visible", "text": " Defaults to 1. (since 0.9) ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Visible"},
     {"title": "CastleTiledMap.TTiledObject.Properties", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Properties"},
     {"title": "CastleTiledMap.TTiledObject.Points", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Points"},
     {"title": "CastleTiledMap.TTiledObject.Primitive", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Primitive"},
     {"title": "CastleTiledMap.TTiledObject.Image", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Image"},
     {"title": "CastleTiledMap.TTiledObject.Free", "text": "    ", "tags": "", "loc": "CastleTiledMap.TTiledObject.html#Free"},
     {"title": "CastleTiledMap.TTiledObjects", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledObjects.html"},
     {"title": "CastleTiledMap.TTiledObjects.Destroy", "text": "    ", "tags": "", "loc": "CastleTiledMap.TTiledObjects.html#Destroy"},
     {"title": "CastleTiledMap.TLayer", "text": " Internally we treat &quot;object group&quot; as normal layer. ", "tags": "", "loc": "CastleTiledMap.TLayer.html"},
     {"title": "CastleTiledMap.TLayer.Name", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Name"},
     {"title": "CastleTiledMap.TLayer.Opacity", "text": " Defaults to 1. ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Opacity"},
     {"title": "CastleTiledMap.TLayer.Visible", "text": " Defaults to 1. ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Visible"},
     {"title": "CastleTiledMap.TLayer.OffsetX", "text": " Defaults to 0. (since 0.14). ", "tags": "", "loc": "CastleTiledMap.TLayer.html#OffsetX"},
     {"title": "CastleTiledMap.TLayer.OffsetY", "text": " Defaults to 0. (since 0.14). ", "tags": "", "loc": "CastleTiledMap.TLayer.html#OffsetY"},
     {"title": "CastleTiledMap.TLayer.Properties", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Properties"},
     {"title": "CastleTiledMap.TLayer.Data", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Data"},
     {"title": "CastleTiledMap.TLayer.IsLayerAnObjectGroup", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayer.html#IsLayerAnObjectGroup"},
     {"title": "CastleTiledMap.TLayer.Color", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Color"},
     {"title": "CastleTiledMap.TLayer.X", "text": " Defaults to 0 and can no longer be changed in Tiled Qt. ", "tags": "", "loc": "CastleTiledMap.TLayer.html#X"},
     {"title": "CastleTiledMap.TLayer.Y", "text": " Defaults to 0 and can no longer be changed in Tiled Qt. ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Y"},
     {"title": "CastleTiledMap.TLayer.Width", "text": " Meaningless. ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Width"},
     {"title": "CastleTiledMap.TLayer.Height", "text": " Meaningless. ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Height"},
     {"title": "CastleTiledMap.TLayer.DrawOrder", "text": " Defaults to &quot;topdown&quot;. ", "tags": "", "loc": "CastleTiledMap.TLayer.html#DrawOrder"},
     {"title": "CastleTiledMap.TLayer.Objects", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Objects"},
     {"title": "CastleTiledMap.TLayer.LayerType", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayer.html#LayerType"},
     {"title": "CastleTiledMap.TLayer.Image", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Image"},
     {"title": "CastleTiledMap.TLayer.Free", "text": "    ", "tags": "", "loc": "CastleTiledMap.TLayer.html#Free"},
     {"title": "CastleTiledMap.TLayers", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayers.html"},
     {"title": "CastleTiledMap.TLayers.FreeChildren", "text": " ", "tags": "", "loc": "CastleTiledMap.TLayers.html#FreeChildren"},
     {"title": "CastleTiledMap.TLayers.Destroy", "text": "    ", "tags": "", "loc": "CastleTiledMap.TLayers.html#Destroy"},
     {"title": "CastleTiledMap.TFrame", "text": " ", "tags": "", "loc": "CastleTiledMap.TFrame.html"},
     {"title": "CastleTiledMap.TFrame.TileId", "text": " ", "tags": "", "loc": "CastleTiledMap.TFrame.html#TileId"},
     {"title": "CastleTiledMap.TFrame.Duration", "text": " ", "tags": "", "loc": "CastleTiledMap.TFrame.html#Duration"},
     {"title": "CastleTiledMap.TTile", "text": " ", "tags": "", "loc": "CastleTiledMap.TTile.html"},
     {"title": "CastleTiledMap.TTile.Id", "text": " ", "tags": "", "loc": "CastleTiledMap.TTile.html#Id"},
     {"title": "CastleTiledMap.TTile.Terrain", "text": " Leaving out a value means that corner has no <code>terrain</code>. (optional) (since 0.9) ", "tags": "", "loc": "CastleTiledMap.TTile.html#Terrain"},
     {"title": "CastleTiledMap.TTile.Probability", "text": " (optional) (since 0.9) ", "tags": "", "loc": "CastleTiledMap.TTile.html#Probability"},
     {"title": "CastleTiledMap.TTile.Properties", "text": " ", "tags": "", "loc": "CastleTiledMap.TTile.html#Properties"},
     {"title": "CastleTiledMap.TTile.Image", "text": " ", "tags": "", "loc": "CastleTiledMap.TTile.html#Image"},
     {"title": "CastleTiledMap.TTile.ObjectGroup", "text": " ", "tags": "", "loc": "CastleTiledMap.TTile.html#ObjectGroup"},
     {"title": "CastleTiledMap.TTile.Animation", "text": " ", "tags": "", "loc": "CastleTiledMap.TTile.html#Animation"},
     {"title": "CastleTiledMap.TTile.Free", "text": "    ", "tags": "", "loc": "CastleTiledMap.TTile.html#Free"},
     {"title": "CastleTiledMap.TTiles", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiles.html"},
     {"title": "CastleTiledMap.TTiles.Destroy", "text": "    ", "tags": "", "loc": "CastleTiledMap.TTiles.html#Destroy"},
     {"title": "CastleTiledMap.TTerrain", "text": " ", "tags": "", "loc": "CastleTiledMap.TTerrain.html"},
     {"title": "CastleTiledMap.TTerrain.Name", "text": " ", "tags": "", "loc": "CastleTiledMap.TTerrain.html#Name"},
     {"title": "CastleTiledMap.TTerrain.Tile", "text": " ", "tags": "", "loc": "CastleTiledMap.TTerrain.html#Tile"},
     {"title": "CastleTiledMap.TTerrain.Properties", "text": " ", "tags": "", "loc": "CastleTiledMap.TTerrain.html#Properties"},
     {"title": "CastleTiledMap.TTileset", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html"},
     {"title": "CastleTiledMap.TTileset.FirstGID", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#FirstGID"},
     {"title": "CastleTiledMap.TTileset.Source", "text": " That TSX file has the same structure as the &lt;tileset&gt; element described here. (There is the <a class=\"normal\" href=\"CastleTiledMap.TTileset.html#FirstGID\">firstgid</a> attribute missing and this <code>source</code> attribute is also not there. These two attributes are kept in the TMX map, since they are map specific.) ", "tags": "", "loc": "CastleTiledMap.TTileset.html#Source"},
     {"title": "CastleTiledMap.TTileset.Name", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#Name"},
     {"title": "CastleTiledMap.TTileset.TileWidth", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#TileWidth"},
     {"title": "CastleTiledMap.TTileset.TileHeight", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#TileHeight"},
     {"title": "CastleTiledMap.TTileset.Spacing", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#Spacing"},
     {"title": "CastleTiledMap.TTileset.Margin", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#Margin"},
     {"title": "CastleTiledMap.TTileset.TileCount", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#TileCount"},
     {"title": "CastleTiledMap.TTileset.Columns", "text": " For image collection tilesets it is editable and is used when displaying the tileset. (since 0.15) ", "tags": "", "loc": "CastleTiledMap.TTileset.html#Columns"},
     {"title": "CastleTiledMap.TTileset.TileOffset", "text": " When not present, no offset is applied. ", "tags": "", "loc": "CastleTiledMap.TTileset.html#TileOffset"},
     {"title": "CastleTiledMap.TTileset.Properties", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#Properties"},
     {"title": "CastleTiledMap.TTileset.Image", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#Image"},
     {"title": "CastleTiledMap.TTileset.Tiles", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#Tiles"},
     {"title": "CastleTiledMap.TTileset.TerrainTypes", "text": " ", "tags": "", "loc": "CastleTiledMap.TTileset.html#TerrainTypes"},
     {"title": "CastleTiledMap.TTileset.ImageData", "text": " Used by renderer. Not a part of file format. ", "tags": "", "loc": "CastleTiledMap.TTileset.html#ImageData"},
     {"title": "CastleTiledMap.TTileset.Free", "text": "    ", "tags": "", "loc": "CastleTiledMap.TTileset.html#Free"},
     {"title": "CastleTiledMap.TTilesets", "text": " ", "tags": "", "loc": "CastleTiledMap.TTilesets.html"},
     {"title": "CastleTiledMap.TTilesets.Destroy", "text": "    ", "tags": "", "loc": "CastleTiledMap.TTilesets.html#Destroy"},
     {"title": "CastleTiledMap.TTiledMap", "text": " Based on Tiled version 0.14. ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html"},
     {"title": "CastleTiledMap.TTiledMap.Create", "text": "   AURL URL to Tiled (TMX) file.  AURL URL to Tiled (TMX) file.", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#Create"},
     {"title": "CastleTiledMap.TTiledMap.Destroy", "text": "    ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#Destroy"},
     {"title": "CastleTiledMap.TTiledMap.GIDToTileset", "text": "    ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#GIDToTileset"},
     {"title": "CastleTiledMap.TTiledMap.Layers", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#Layers"},
     {"title": "CastleTiledMap.TTiledMap.Orientation", "text": " Tiled supports &quot;orthogonal&quot;, &quot;isometric&quot; and &quot;staggered&quot; (since 0.9) at the moment. ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#Orientation"},
     {"title": "CastleTiledMap.TTiledMap.Properties", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#Properties"},
     {"title": "CastleTiledMap.TTiledMap.Tilesets", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#Tilesets"},
     {"title": "CastleTiledMap.TTiledMap.Width", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#Width"},
     {"title": "CastleTiledMap.TTiledMap.Height", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#Height"},
     {"title": "CastleTiledMap.TTiledMap.TileWidth", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#TileWidth"},
     {"title": "CastleTiledMap.TTiledMap.TileHeight", "text": " ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#TileHeight"},
     {"title": "CastleTiledMap.TTiledMap.RenderOrder", "text": " Valid values are right-down (the default), right-up, left-down and left-up. In all cases, the map is drawn row-by-row. (since 0.10, but only supported for orthogonal maps at the moment) ", "tags": "", "loc": "CastleTiledMap.TTiledMap.html#RenderOrder"},
     {"title": "CastleTiledMap.TCastleTiledMapControl", "text": " ", "tags": "", "loc": "CastleTiledMap.TCastleTiledMapControl.html"},
     {"title": "CastleTiledMap.TCastleTiledMapControl.Create", "text": "    ", "tags": "", "loc": "CastleTiledMap.TCastleTiledMapControl.html#Create"},
     {"title": "CastleTiledMap.TCastleTiledMapControl.Create", "text": "    ", "tags": "", "loc": "CastleTiledMap.TCastleTiledMapControl.html#Create"},
     {"title": "CastleTiledMap.TCastleTiledMapControl.Destroy", "text": "    ", "tags": "", "loc": "CastleTiledMap.TCastleTiledMapControl.html#Destroy"},
     {"title": "CastleTiledMap.TCastleTiledMapControl.LoadFromFile", "text": "    ", "tags": "", "loc": "CastleTiledMap.TCastleTiledMapControl.html#LoadFromFile"},
     {"title": "CastleTiledMap.TCastleTiledMapControl.Render", "text": "    ", "tags": "", "loc": "CastleTiledMap.TCastleTiledMapControl.html#Render"},
     {"title": "CastleTiledMap.TCastleTiledMapControl.ObjectsVisible", "text": " ", "tags": "", "loc": "CastleTiledMap.TCastleTiledMapControl.html#ObjectsVisible"},
     {"title": "CastleTiledMap.TProperties", "text": " ", "tags": "", "loc": "CastleTiledMap.html#TProperties"},
     {"title": "CastleTiledMap.TEncodingType", "text": "  etNone    etBase64    etCSV   ", "tags": "", "loc": "CastleTiledMap.html#TEncodingType"},
     {"title": "CastleTiledMap.TCompressionType", "text": "  ctNone    ctGZip    ctZLib   ", "tags": "", "loc": "CastleTiledMap.html#TCompressionType"},
     {"title": "CastleTiledMap.TObjectsDrawOrder", "text": "  odoIndex    odoTopDown   ", "tags": "", "loc": "CastleTiledMap.html#TObjectsDrawOrder"},
     {"title": "CastleTiledMap.TTileObjectPrimitive", "text": "  topEllipse    topPoligon    topPolyLine   ", "tags": "", "loc": "CastleTiledMap.html#TTileObjectPrimitive"},
     {"title": "CastleTiledMap.TLayerType", "text": "  ltLayer    ltObjectGroup    ltImageLayer   ", "tags": "", "loc": "CastleTiledMap.html#TLayerType"},
     {"title": "CastleTiledMap.PLayer", "text": " ", "tags": "", "loc": "CastleTiledMap.html#PLayer"},
     {"title": "CastleTiledMap.TAnimation", "text": " As of Tiled 0.10, each tile can have exactly one animation associated with it. In the future, there could be support for multiple named animations on a tile. ", "tags": "", "loc": "CastleTiledMap.html#TAnimation"},
     {"title": "CastleTiledMap.TTerrainTypes", "text": " ", "tags": "", "loc": "CastleTiledMap.html#TTerrainTypes"},
     {"title": "CastleTiledMap.PTileset", "text": " ", "tags": "", "loc": "CastleTiledMap.html#PTileset"},
     {"title": "CastleTiledMap.TMapOrientation", "text": "  moOrthogonal    moIsometric    moStaggered   ", "tags": "", "loc": "CastleTiledMap.html#TMapOrientation"},
     {"title": "CastleTiledMap.TMapRenderOrder", "text": "  mroRightDown    mroRightUp    mroLeftDown    mroLeftUp   ", "tags": "", "loc": "CastleTiledMap.html#TMapRenderOrder"},
     {"title": "CastleTimeUtils", "text": " ", "tags": "", "loc": "CastleTimeUtils.html"},
     {"title": "CastleTimeUtils.TProcessTimerResult", "text": " If possible, this measures only the CPU usage local to this process. ", "tags": "", "loc": "CastleTimeUtils.TProcessTimerResult.html"},
     {"title": "CastleTimeUtils.TProcessTimerResult.ElapsedTime", "text": " Equivalent to <code><a class=\"normal\" href=\"CastleTimeUtils.html#ProcessTimerSeconds\">ProcessTimerSeconds</a>(<a class=\"normal\" href=\"CastleTimeUtils.html#ProcessTimer\">ProcessTimer</a>, Self)</code>    ", "tags": "", "loc": "CastleTimeUtils.TProcessTimerResult.html#ElapsedTime"},
     {"title": "CastleTimeUtils.TTimerResult", "text": " ", "tags": "", "loc": "CastleTimeUtils.TTimerResult.html"},
     {"title": "CastleTimeUtils.TTimerResult.ElapsedTime", "text": " Equivalent to <code><a class=\"normal\" href=\"CastleTimeUtils.html#TimerSeconds\">TimerSeconds</a>(Timer, Self)</code>    ", "tags": "", "loc": "CastleTimeUtils.TTimerResult.html#ElapsedTime"},
     {"title": "CastleTimeUtils.TFramesPerSecond", "text": " For example, it can be easily &quot;plugged&quot; into <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> (see <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Fps\">TCastleWindowCustom.Fps</a>) or Lazarus GL control (see <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Fps\">TCastleControlCustom.Fps</a>).  <p>Things named &quot;_&quot; here are supposed to be internal to the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> / <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a> and such implementations. Other properties can be controlled by the user of <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> / <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a>. ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html"},
     {"title": "CastleTimeUtils.TFramesPerSecond.DefaultMaxSensibleSecondsPassed", "text": " ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#DefaultMaxSensibleSecondsPassed"},
     {"title": "CastleTimeUtils.TFramesPerSecond.Create", "text": "    ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#Create"},
     {"title": "CastleTimeUtils.TFramesPerSecond.ToString", "text": "    ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#ToString"},
     {"title": "CastleTimeUtils.TFramesPerSecond.ZeroNextSecondsPassed", "text": "  <p>This is useful if you just came back from some modal state, like a modal dialog box (like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FileDialog\">TCastleWindowCustom.FileDialog</a> or modal boxes in <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a> &ndash; they already call this method). <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html#SecondsPassed\">SecondsPassed</a> could be ridicoulously long in such case (if our message loop is totally paused, as in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FileDialog\">TCastleWindowCustom.FileDialog</a> on Windows) or not relevant (if we do our message loop, but we display something entirely different, like <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a>). So it's best to pretend that <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html#SecondsPassed\">SecondsPassed</a> is 0.0, so things such as <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Time\">TCastleSceneCore.Time</a> do not advance wildly just because we did a modal dialog.  <p>This forces the <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html#SecondsPassed\">SecondsPassed</a> to be zero at the next update event (_UpdateBegin).    ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#ZeroNextSecondsPassed"},
     {"title": "CastleTimeUtils.TFramesPerSecond.FrameId", "text": "  <p>Changed when each container &quot;update&quot; event occurs, so this is equal during all <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">TInputListener.Update</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Update\">TCastleTransform.Update</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#LocalRender\">TCastleTransform.LocalRender</a> occuring within the same frame. You can use this to avoid performing the same job many times in a single frame.  <p>Never zero.  <p>It's a class function, so you can access it like <code><code>TFramesPerSecond.FrameId</code></code>, no need to have a <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html\">TFramesPerSecond</a> instance (which is usually accessed from <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html\">TUIContainer</a>, like <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Fps\">TUIContainer.Fps</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Fps\">TCastleWindowCustom.Fps</a>, <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Fps\">TCastleControlCustom.Fps</a>.    ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#FrameId"},
     {"title": "CastleTimeUtils.TFramesPerSecond.OnlyRenderFps", "text": "  <p>This measures only time spend in <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventRender\">TUIContainer.EventRender</a> method (and it's subordinates, like <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a>, <a class=\"normal\" href=\"CastleScene.TCastleScene.html#LocalRender\">TCastleScene.LocalRender</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">TCastleWindowCustom.OnRender</a>). It does not take into account time spent on other activities, like &quot;update&quot; calls, and it doesn't take into account that frames are possibly not rendered all the time (when AutoRedisplay = <code>False</code>).  <p>See <a  href=\"https://castle-engine.sourceforge.io/manual_optimization.php#section_fps\">https://castle-engine.sourceforge.io/manual_optimization.php#section_fps</a> for a detailed description what FPS mean and how they should be interpreted.  <p> ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#OnlyRenderFps"},
     {"title": "CastleTimeUtils.TFramesPerSecond.FrameTime", "text": " ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#FrameTime"},
     {"title": "CastleTimeUtils.TFramesPerSecond.RealFps", "text": " This is the number of <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventRender\">TUIContainer.EventRender</a> calls that actually happened within a real second of time. So it's an actual speed of your program. Anything can slow this down, not only long rendering, but also slow processing of other events (like &quot;update&quot; that does physics).  <p>When <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AutoRedisplay\">TCastleWindowCustom.AutoRedisplay</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#AutoRedisplay\">TCastleControlCustom.AutoRedisplay</a> is <code>False</code>, this may be very low, since we may not render the frames all the time (we may sleep for some time, or perform updates without rendering). In this case, the <code>RealFps</code> value may be confusing and useless (it does not reflect the speed of your application). Use the <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html#WasSleeping\">WasSleeping</a> to detect this, and potentially hide the display of <code>RealFps</code> from user.  <p>See <a  href=\"https://castle-engine.sourceforge.io/manual_optimization.php#section_fps\">https://castle-engine.sourceforge.io/manual_optimization.php#section_fps</a> for a detailed description what FPS mean and how they should be interpreted.  <p> ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#RealFps"},
     {"title": "CastleTimeUtils.TFramesPerSecond.RealTime", "text": " ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#RealTime"},
     {"title": "CastleTimeUtils.TFramesPerSecond.WasSleeping", "text": " This happens only when <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AutoRedisplay\">TCastleWindowCustom.AutoRedisplay</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#AutoRedisplay\">TCastleControlCustom.AutoRedisplay</a> are <code>False</code>, and it basically indicates that the <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html#RealFps\">RealFps</a> value is not a useful indicator of your application speed.  <p>See <a  href=\"https://castle-engine.sourceforge.io/manual_optimization.php#section_fps\">https://castle-engine.sourceforge.io/manual_optimization.php#section_fps</a> for a detailed description what this means. ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#WasSleeping"},
     {"title": "CastleTimeUtils.TFramesPerSecond.SecondsPassed", "text": " You should use this inside &quot;update&quot; events and methods (<a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventUpdate\">TUIContainer.EventUpdate</a>, <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">TInputListener.Update</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Update\">TCastleTransform.Update</a>...) to scale the movement. This way, your animation will work with the same speed (objects will travel at the same speed), regardless of the system performance (regardless of how often the &quot;update&quot; event occurs).  <p>This is calculated as a time between start of previous &quot;update&quot; event and start of current &quot;update&quot; event. ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#SecondsPassed"},
     {"title": "CastleTimeUtils.TFramesPerSecond.UpdateSecondsPassed", "text": " ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#UpdateSecondsPassed"},
     {"title": "CastleTimeUtils.TFramesPerSecond.MaxSensibleSecondsPassed", "text": " Used only when non-zero. By default it's <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html#DefaultMaxSensibleSecondsPassed\">DefaultMaxSensibleSecondsPassed</a>. ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#MaxSensibleSecondsPassed"},
     {"title": "CastleTimeUtils.TFramesPerSecond.UpdateStartTime", "text": " ", "tags": "", "loc": "CastleTimeUtils.TFramesPerSecond.html#UpdateStartTime"},
     {"title": "CastleTimeUtils.OldestTime", "text": " ", "tags": "", "loc": "CastleTimeUtils.html#OldestTime"},
     {"title": "CastleTimeUtils.MinDateTime", "text": " ", "tags": "", "loc": "CastleTimeUtils.html#MinDateTime"},
     {"title": "CastleTimeUtils.ProcessTimersPerSec", "text": " ", "tags": "", "loc": "CastleTimeUtils.html#ProcessTimersPerSec"},
     {"title": "CastleTimeUtils.TimeTickSecondLater", "text": "  <p>Simple implementation of this would be <code>SecondTime - FirstTime &gt;= TimeDelay</code>.  <p>FirstTime and SecondTime are milisecond times from some initial point. For example, they may be taken from a function like 32-bit GetTickCount (on older Windows; on newer we use <a class=\"normal\" href=\"CastleTimeUtils.html#GetTickCount64\">GetTickCount64</a>). Such time may &quot;wrap&quot;. This function checks these times intelligently, using the assumption that the SecondTime is always &quot;later&quot; than the FirstTime, and only having to check if it's later by at least TimeDelay.  <p>Always TimeTickSecond(X, X, 0) = <code>True</code>. that is, when both times are actually equal, it's correctly &quot;later by zero miliseconds&quot;.    ", "tags": "", "loc": "CastleTimeUtils.html#TimeTickSecondLater"},
     {"title": "CastleTimeUtils.TimeTickDiff", "text": "  <p>Naive implementation would be just <code>SecondTime - FirstTime</code>, this function does a little better: takes into account that times may &quot;wrap&quot; (see <a class=\"normal\" href=\"CastleTimeUtils.html#TimeTickSecondLater\">TimeTickSecondLater</a>), and uses the assumption that the SecondTime for sure &quot;later&quot;, to calculate hopefully correct difference.    ", "tags": "", "loc": "CastleTimeUtils.html#TimeTickDiff"},
     {"title": "CastleTimeUtils.MilisecTimesAdd", "text": "  <p>These don't care if <a class=\"normal\" href=\"CastleTimeUtils.html#TMilisecTime\">TMilisecTime</a> is a point in time, or time interval. They simply add / subtract values. It's your problem if adding / subtracting them is sensible.  <p>Range checking is ignored. In particular, this means that if you subtract smaller value from larger value, the result will be like the time &quot;wrapped&quot; in between (since <a class=\"normal\" href=\"CastleTimeUtils.html#TMilisecTime\">TMilisecTime</a> range is limited).  <p>    ", "tags": "", "loc": "CastleTimeUtils.html#MilisecTimesAdd"},
     {"title": "CastleTimeUtils.MilisecTimesSubtract", "text": "    ", "tags": "", "loc": "CastleTimeUtils.html#MilisecTimesSubtract"},
     {"title": "CastleTimeUtils.GetTickCount64", "text": " On newer OSes (non-Windows, or Windows &gt;= Windows Vista) this uses 64-bit int under the hood. Or older Windows versions it's based on 32-bit Windows.GetTickCount that measures time since system start, that will wrap in &tilde; 49 days.    ", "tags": "", "loc": "CastleTimeUtils.html#GetTickCount64"},
     {"title": "CastleTimeUtils.DateTimeToAtStr", "text": "    ", "tags": "", "loc": "CastleTimeUtils.html#DateTimeToAtStr"},
     {"title": "CastleTimeUtils.ProcessTimer", "text": " Use this to measure and compare the time it takes your program to do some calculations.  <p>If possible, this measures only the CPU usage of this process. So it ignores delays caused by other processes doing something on your system, and it ignores things like waiting for hard disk (I/O). This is possible on Unix thanks to the <code>clock</code> API, see <a  href=\"http://www.gnu.org/software/libc/manual/html_node/Processor-And-CPU-Time.html\">http://www.gnu.org/software/libc/manual/html_node/Processor-And-CPU-Time.html</a> . On other platforms (like Windows), this simply measures real time that passed.  <p>You usually take two <code>ProcessTimer</code> values, subtract them with <a class=\"normal\" href=\"CastleTimeUtils.html#ProcessTimerSeconds\">ProcessTimerSeconds</a>, and this is the time that passed &ndash; in seconds. Like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   TimeStart: TProcessTimerResult;   Seconds: TFloatTime; <span class=\"pascal_keyword\">begin</span>   TimeStart := ProcessTimer;   <span class=\"pascal_comment\">// ...  do something time-consuming ...</span>   Seconds := ProcessTimerSeconds(ProcessTimer, TimeStart);   <span class=\"pascal_comment\">// or: Seconds := TimeStart.ElapsedTime;</span>   WritelnLog(<span class=\"pascal_string\">'Seconds passed (in this process): %f'</span>, [Seconds]); <span class=\"pascal_keyword\">end</span>;</pre>  <p>    ", "tags": "", "loc": "CastleTimeUtils.html#ProcessTimer"},
     {"title": "CastleTimeUtils.ProcessTimerNow", "text": "    ", "tags": "", "loc": "CastleTimeUtils.html#ProcessTimerNow"},
     {"title": "CastleTimeUtils.ProcessTimerDiff", "text": "  <p>Although it may just subtract two values, it may also do something more. For example, if timer resolution is only miliseconds, and it may wrap (just like <a class=\"normal\" href=\"CastleTimeUtils.html#TMilisecTime\">TMilisecTime</a>), then we may subtract values intelligently, taking into account that time could wrap (see <a class=\"normal\" href=\"CastleTimeUtils.html#TimeTickDiff\">TimeTickDiff</a>).    ", "tags": "", "loc": "CastleTimeUtils.html#ProcessTimerDiff"},
     {"title": "CastleTimeUtils.ProcessTimerSeconds", "text": "    ", "tags": "", "loc": "CastleTimeUtils.html#ProcessTimerSeconds"},
     {"title": "CastleTimeUtils.ProcessTimerBegin", "text": " Call <code>ProcessTimerBegin</code> at the beginning of your calculation, call <a class=\"normal\" href=\"CastleTimeUtils.html#ProcessTimerEnd\">ProcessTimerEnd</a> at the end. <a class=\"normal\" href=\"CastleTimeUtils.html#ProcessTimerEnd\">ProcessTimerEnd</a> returns a float number, with 1.0 being one second.  <p>Note that using this is unsafe in libraries, not to mention multi-threaded programs (it's not &quot;reentrant&quot;) &mdash; you risk that some other code called <code>ProcessTimerBegin</code>, and your <a class=\"normal\" href=\"CastleTimeUtils.html#ProcessTimerEnd\">ProcessTimerEnd</a> doesn't measure what you think. So in general units, do not use this, use <a class=\"normal\" href=\"CastleTimeUtils.html#ProcessTimer\">ProcessTimer</a> and <a class=\"normal\" href=\"CastleTimeUtils.html#ProcessTimerSeconds\">ProcessTimerSeconds</a> instead.  <p>    ", "tags": "", "loc": "CastleTimeUtils.html#ProcessTimerBegin"},
     {"title": "CastleTimeUtils.ProcessTimerEnd", "text": "    ", "tags": "", "loc": "CastleTimeUtils.html#ProcessTimerEnd"},
     {"title": "CastleTimeUtils.Timer", "text": " It is a &quot;real&quot; time, which means that subtracting two values measures the actual time that passed between two events. Contrast this with <a class=\"normal\" href=\"CastleTimeUtils.html#ProcessTimer\">ProcessTimer</a> that tries to measure only CPU time used by the current process.  <p>Call Timer twice, and calculate the difference (in seconds) using the <a class=\"normal\" href=\"CastleTimeUtils.html#TimerSeconds\">TimerSeconds</a>. Like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   TimeStart: TTimerResult;   Seconds: TFloatTime; <span class=\"pascal_keyword\">begin</span>   TimeStart := Timer;   <span class=\"pascal_comment\">// ...  do something time-consuming ...</span>   Seconds := TimerSeconds(Timer, TimeStart);   <span class=\"pascal_comment\">// or: Seconds := TimeStart.ElapsedTime;</span>   WritelnLog(<span class=\"pascal_string\">'Seconds passed: %f'</span>, [Seconds]); <span class=\"pascal_keyword\">end</span>;</pre>  <p>    ", "tags": "", "loc": "CastleTimeUtils.html#Timer"},
     {"title": "CastleTimeUtils.TimerSeconds", "text": "    ", "tags": "", "loc": "CastleTimeUtils.html#TimerSeconds"},
     {"title": "CastleTimeUtils.TFloatTime", "text": " This is used throughout my engine to represent time as a floating-point value with good accuracy in seconds.  <p>Using the &quot;double&quot; precision (not just &quot;single&quot;) is good to guarantee good accuracy. It is also the precision required for storing time in X3D. See also: <a  href=\"https://randomascii.wordpress.com/2012/02/13/dont-store-that-in-a-float/\">https://randomascii.wordpress.com/2012/02/13/dont-store-that-in-a-float/</a> <a  href=\"https://twitter.com/ID_AA_Carmack/status/418158611664097280\">https://twitter.com/ID_AA_Carmack/status/418158611664097280</a>  <p>To test that &quot;single&quot; is not enough, open some animation in view3dscene, and change &quot;on display&quot; time pass to 1000. It goes even better if AutoRedisplay is <code>False</code>, and <a class=\"normal\" href=\"CastleControl.html#LimitFPS\">LimitFps</a> is 0.0, and model is still for some time &mdash; then we do many OnUpdate calls with very small SecondsPassed values. ", "tags": "", "loc": "CastleTimeUtils.html#TFloatTime"},
     {"title": "CastleTimeUtils.TMilisecTime", "text": " ", "tags": "", "loc": "CastleTimeUtils.html#TMilisecTime"},
     {"title": "CastleTransform", "text": " ", "tags": "", "loc": "CastleTransform.html"},
     {"title": "CastleTransform.ECannotAddToAnotherWorld", "text": " ", "tags": "", "loc": "CastleTransform.ECannotAddToAnotherWorld.html"},
     {"title": "CastleTransform.ETransformParentUndefined", "text": " ", "tags": "", "loc": "CastleTransform.ETransformParentUndefined.html"},
     {"title": "CastleTransform.EMultipleReferencesInWorld", "text": " ", "tags": "", "loc": "CastleTransform.EMultipleReferencesInWorld.html"},
     {"title": "CastleTransform.ENotAddedToWorld", "text": " ", "tags": "", "loc": "CastleTransform.ENotAddedToWorld.html"},
     {"title": "CastleTransform.EPhysicsError", "text": " ", "tags": "", "loc": "CastleTransform.EPhysicsError.html"},
     {"title": "CastleTransform.TBaseShadowVolumeRenderer", "text": " ", "tags": "", "loc": "CastleTransform.TBaseShadowVolumeRenderer.html"},
     {"title": "CastleTransform.TRayCollisionNode", "text": " Everything (Point, <a class=\"normal\" href=\"CastleTransform.TRayCollisionNode.html#RayOrigin\">RayOrigin</a>, <a class=\"normal\" href=\"CastleTransform.TRayCollisionNode.html#RayDirection\">RayDirection</a>) is expressed in the local coordinates of given 3D object (in <a class=\"normal\" href=\"CastleTransform.TRayCollisionNode.html#Item\">Item</a>). ", "tags": "", "loc": "CastleTransform.TRayCollisionNode.html"},
     {"title": "CastleTransform.TRayCollisionNode.Item", "text": " ", "tags": "", "loc": "CastleTransform.TRayCollisionNode.html#Item"},
     {"title": "CastleTransform.TRayCollisionNode.Point", "text": "  <p>If the ray hit empty space (<a class=\"normal\" href=\"CastleTransform.TRayCollisionNode.html#Item\">Item</a> field is <code>Nil</code>), then this is undefined. Note that only <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a> is informed about pointing device events when the ray hit empty space, so this is an unusual case. ", "tags": "", "loc": "CastleTransform.TRayCollisionNode.html#Point"},
     {"title": "CastleTransform.TRayCollisionNode.Triangle", "text": " This triangle is always a part of <a class=\"normal\" href=\"CastleTransform.TRayCollisionNode.html#Item\">Item</a>.  <p>If the ray hit empty space (<a class=\"normal\" href=\"CastleTransform.TRayCollisionNode.html#Item\">Item</a> field is <code>Nil</code>), then this is <code>Nil</code>. Note that only <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a> is informed about pointing device events when the ray hit empty space, so this is an unusual case.  <p>May also be <code>Nil</code> if RayCollision implementation for the 3D object simply left it <code>Nil</code>. For example,  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>If the collision occured with a <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> with <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">TCastleSceneCore.Spatial</a> that includes a collidable structure (<a class=\"normal\" href=\"CastleScene.html#ssDynamicCollisions\">ssDynamicCollisions</a> or <a class=\"normal\" href=\"CastleScene.html#ssStaticCollisions\">ssStaticCollisions</a>), then this triangle is set.</p></li>   <li><p>If the collision occured merely with a <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> bounding box, the triangle is left as <code>Nil</code>.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleTransform.TRayCollisionNode.html#Triangle"},
     {"title": "CastleTransform.TRayCollisionNode.RayOrigin", "text": " ", "tags": "", "loc": "CastleTransform.TRayCollisionNode.html#RayOrigin"},
     {"title": "CastleTransform.TRayCollisionNode.RayDirection", "text": " ", "tags": "", "loc": "CastleTransform.TRayCollisionNode.html#RayDirection"},
     {"title": "CastleTransform.TRayCollision", "text": " Just access the <code>First</code> item for the collision information with the final 3D object. The rest of items are containers of this 3D object (a path within <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a> hierarchy tree, usually).  <p>This list is a path in the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> tree leading from the final colliding object (usually <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>) to the root of the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> tree. This allows you to track the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> containers that contain given collision.  <p>This is never an empty list when returned by RayCollision. ", "tags": "", "loc": "CastleTransform.TRayCollision.html"},
     {"title": "CastleTransform.TRayCollision.Distance", "text": " The suggested usage is to decide if player is close enough to reach the 3D object &mdash; for example, you may not want to allow player to open a door by clicking on it from a far distance.  <p>If the ray hit empty space, the distance is <a class=\"normal\" href=\"Castle3D.html#MaxSingle\">MaxSingle</a>. Note that only MainScene is informed about pointing device events when the ray hit empty space. ", "tags": "", "loc": "CastleTransform.TRayCollision.html#Distance"},
     {"title": "CastleTransform.TRayCollision.IndexOfItem", "text": "    ", "tags": "", "loc": "CastleTransform.TRayCollision.html#IndexOfItem"},
     {"title": "CastleTransform.TRayCollision.IndexOfItem", "text": "    ", "tags": "", "loc": "CastleTransform.TRayCollision.html#IndexOfItem"},
     {"title": "CastleTransform.TCollisionDetailsItem", "text": " ", "tags": "", "loc": "CastleTransform.TCollisionDetailsItem.html"},
     {"title": "CastleTransform.TCollisionDetailsItem.Item", "text": " ", "tags": "", "loc": "CastleTransform.TCollisionDetailsItem.html#Item"},
     {"title": "CastleTransform.TCollisionDetails", "text": " Just access the <code>First</code> item for the collision information with the final 3D object. The rest of items are containers of this 3D object (a path within <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a> hierarchy tree, usually).  <p>This list is a path in the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> tree leading from the final colliding object to the root of the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> tree. This allows you to track the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> containers that contain given collision.  <p>This is never an empty list when returned by XxxCollision method. ", "tags": "", "loc": "CastleTransform.TCollisionDetails.html"},
     {"title": "CastleTransform.TCollisionDetails.IndexOfItem", "text": "    ", "tags": "", "loc": "CastleTransform.TCollisionDetails.html#IndexOfItem"},
     {"title": "CastleTransform.TCollisionDetails.Add", "text": "    ", "tags": "", "loc": "CastleTransform.TCollisionDetails.html#Add"},
     {"title": "CastleTransform.TRenderStatistics", "text": " You will usually access this by scene manager property, see <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#Statistics\">TCastleAbstractViewport.Statistics</a>. ", "tags": "", "loc": "CastleTransform.TRenderStatistics.html"},
     {"title": "CastleTransform.TRenderStatistics.ShapesRendered", "text": " Potentially visible shapes are the ones with <a class=\"normal\" href=\"CastleShapes.TShape.html#Visible\">TShape.Visible</a> inside a 3D object with <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">TCastleTransform.GetExists</a>.  <p>When <code>ShapesRendered</code> is much smaller than <a class=\"normal\" href=\"CastleTransform.TRenderStatistics.html#ShapesVisible\">ShapesVisible</a>, it means that the algorithm for removing invisible scene parts works good. This includes frustum culling (automatically used by <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>), or occlusion culling (see <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#UseOcclusionQuery\">TSceneRenderingAttributes.UseOcclusionQuery</a>), or any custom algorithm you implement by using <a class=\"normal\" href=\"CastleShapes.html#TTestShapeVisibility\">TTestShapeVisibility</a> callback with <a class=\"normal\" href=\"CastleScene.TCastleScene.html#LocalRender\">TCastleScene.LocalRender</a>. ", "tags": "", "loc": "CastleTransform.TRenderStatistics.html#ShapesRendered"},
     {"title": "CastleTransform.TRenderStatistics.ShapesVisible", "text": " Potentially visible shapes are the ones with <a class=\"normal\" href=\"CastleShapes.TShape.html#Visible\">TShape.Visible</a> inside a 3D object with <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">TCastleTransform.GetExists</a>.  <p>When <a class=\"normal\" href=\"CastleTransform.TRenderStatistics.html#ShapesRendered\">ShapesRendered</a> is much smaller than <code>ShapesVisible</code>, it means that the algorithm for removing invisible scene parts works good. This includes frustum culling (automatically used by <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>), or occlusion culling (see <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#UseOcclusionQuery\">TSceneRenderingAttributes.UseOcclusionQuery</a>), or any custom algorithm you implement by using <a class=\"normal\" href=\"CastleShapes.html#TTestShapeVisibility\">TTestShapeVisibility</a> callback with <a class=\"normal\" href=\"CastleScene.TCastleScene.html#LocalRender\">TCastleScene.LocalRender</a>. ", "tags": "", "loc": "CastleTransform.TRenderStatistics.html#ShapesVisible"},
     {"title": "CastleTransform.TRenderStatistics.BoxesOcclusionQueriedCount", "text": " This is always zero when not using occlusion query (see <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#UseOcclusionQuery\">TSceneRenderingAttributes.UseOcclusionQuery</a>). Basically, this measures the &quot;invisible overhead&quot; of occlusion query. ", "tags": "", "loc": "CastleTransform.TRenderStatistics.html#BoxesOcclusionQueriedCount"},
     {"title": "CastleTransform.TPrepareParams", "text": "  <p>This is <b>mostly an internal class</b>. You should not need to create it, you should not need to read anything inside or deal with this class otherwise.  <p>The only official usage allowed is to pass an instance of this class taken from <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#PrepareParams\">TCastleAbstractViewport.PrepareParams</a> as a parameter to <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PrepareResources\">TCastleTransform.PrepareResources</a> and friends like <a class=\"normal\" href=\"CastleResources.T3DResource.html#Prepare\">T3DResource.Prepare</a>. You should treat this class as a &quot;<a class=\"normal\" href=\"CastleColors.html#Black\">black</a> box&quot; in normal applications. ", "tags": "", "loc": "CastleTransform.TPrepareParams.html"},
     {"title": "CastleTransform.TRenderParams", "text": " Read-only for <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#LocalRender\">TCastleTransform.LocalRender</a> (except Statistics, which should be updated during rendering).  <p>This is <b>mostly an internal class</b>. You should not need to create it, you should not need to read anything inside or deal with this class otherwise, and actually you should not need to override <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#LocalRender\">TCastleTransform.LocalRender</a> during normal engine usage. But it may be useful for special customized rendering. ", "tags": "", "loc": "CastleTransform.TRenderParams.html"},
     {"title": "CastleTransform.TRenderParams.Transparent", "text": " This should &quot;filter&quot; the rendered parts by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#LocalRender\">TCastleTransform.LocalRender</a>. ", "tags": "", "loc": "CastleTransform.TRenderParams.html#Transparent"},
     {"title": "CastleTransform.TRenderParams.ShadowVolumesReceivers", "text": " During rendering, simply check does it match <a class=\"normal\" href=\"CastleScene.TCastleScene.html#ReceiveShadowVolumes\">TCastleScene.ReceiveShadowVolumes</a>. This should &quot;filter&quot; the rendered parts by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#LocalRender\">TCastleTransform.LocalRender</a>. ", "tags": "", "loc": "CastleTransform.TRenderParams.html#ShadowVolumesReceivers"},
     {"title": "CastleTransform.TRenderParams.InShadow", "text": "  <p>Which means that most lights (ones with shadowVolumes = TRUE) should be turned off, see [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadows\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadows</a>].) ", "tags": "", "loc": "CastleTransform.TRenderParams.html#InShadow"},
     {"title": "CastleTransform.TRenderParams.StencilTest", "text": " ", "tags": "", "loc": "CastleTransform.TRenderParams.html#StencilTest"},
     {"title": "CastleTransform.TRenderParams.Pass", "text": " ", "tags": "", "loc": "CastleTransform.TRenderParams.html#Pass"},
     {"title": "CastleTransform.TRenderParams.Transform", "text": " If <a class=\"normal\" href=\"CastleTransform.TRenderParams.html#TransformIdentity\">TransformIdentity</a>, then Transform and <a class=\"normal\" href=\"CastleTransform.TRenderParams.html#InverseTransform\">InverseTransform</a> is always identity.  ", "tags": "", "loc": "CastleTransform.TRenderParams.html#Transform"},
     {"title": "CastleTransform.TRenderParams.InverseTransform", "text": " If <a class=\"normal\" href=\"CastleTransform.TRenderParams.html#TransformIdentity\">TransformIdentity</a>, then Transform and <code>InverseTransform</code> is always identity.  ", "tags": "", "loc": "CastleTransform.TRenderParams.html#InverseTransform"},
     {"title": "CastleTransform.TRenderParams.TransformIdentity", "text": " ", "tags": "", "loc": "CastleTransform.TRenderParams.html#TransformIdentity"},
     {"title": "CastleTransform.TRenderParams.Statistics", "text": " ", "tags": "", "loc": "CastleTransform.TRenderParams.html#Statistics"},
     {"title": "CastleTransform.TRenderParams.GlobalFog", "text": " ", "tags": "", "loc": "CastleTransform.TRenderParams.html#GlobalFog"},
     {"title": "CastleTransform.TRenderParams.Frustum", "text": " Local for the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> instance receiving this <a class=\"normal\" href=\"CastleTransform.TRenderParams.html\">TRenderParams</a> as <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#LocalRender\">TCastleTransform.LocalRender</a> parameter. ", "tags": "", "loc": "CastleTransform.TRenderParams.html#Frustum"},
     {"title": "CastleTransform.TRenderParams.Create", "text": "    ", "tags": "", "loc": "CastleTransform.TRenderParams.html#Create"},
     {"title": "CastleTransform.TRenderParams.BaseLights", "text": "    ", "tags": "", "loc": "CastleTransform.TRenderParams.html#BaseLights"},
     {"title": "CastleTransform.TRenderParams.RenderTransform", "text": "    ", "tags": "", "loc": "CastleTransform.TRenderParams.html#RenderTransform"},
     {"title": "CastleTransform.TRenderParams.RenderTransformIdentity", "text": "    ", "tags": "", "loc": "CastleTransform.TRenderParams.html#RenderTransformIdentity"},
     {"title": "CastleTransform.TCastleTransformList", "text": " This inherits from <a class=\"normal\" href=\"CastleClassUtils.TCastleObjectList.html\">TCastleObjectList</a>, getting many features like TList notification mechanism. You should not create instances of this class yourself &mdash; instead use <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> to group your scenes and transformations. ", "tags": "", "loc": "CastleTransform.TCastleTransformList.html"},
     {"title": "CastleTransform.TCastleTransformList.Create", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransformList.html#Create"},
     {"title": "CastleTransform.TCastleTransformList.Notify", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransformList.html#Notify"},
     {"title": "CastleTransform.TCastleTransformList.First", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransformList.html#First"},
     {"title": "CastleTransform.TCastleTransformList.Last", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransformList.html#Last"},
     {"title": "CastleTransform.TCastleTransformList.Items", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransformList.html#Items"},
     {"title": "CastleTransform.TCastleTransformList.Owner", "text": " May be <code>Nil</code>, for example when this list is used by <a class=\"normal\" href=\"CastleTransform.TRayCollision.html\">TRayCollision</a>. ", "tags": "", "loc": "CastleTransform.TCastleTransformList.html#Owner"},
     {"title": "CastleTransform.TCastleTransform", "text": "  <p>Add and remove children using the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Add\">Add</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Remove\">Remove</a> and similar methods. A child can be any <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> instance, in particular it can be a <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instance (which allows to load and render any 3D or 2D model).  <p>Control the transformation using these properties:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Move using <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Translation\">Translation</a>.</p></li>   <li value=\"2\"><p>Rotate using <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Rotation\">Rotation</a>. The rotation is performed around the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Center\">Center</a> point. The rotation may be alternatively controlled using the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Direction\">Direction</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Up\">Up</a> vectors.</p></li>   <li value=\"3\"><p>Change size using <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Scale\">Scale</a>. Scale is done around <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Center\">Center</a> and with orientation given by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#ScaleOrientation\">ScaleOrientation</a>.</p></li> </ol>  <p>  <p>This class is the base object that is managed by the <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>. You insert instances of this class into <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a>, which is actually an instance of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> too.  <p>This class implements also optional gravity and physics. See the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Gravity\">Gravity</a> property for a simple unrealistic gravity model. See the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#RigidBody\">RigidBody</a> for a proper rigid-bidy simulation, with correct gravity model and collisions with other rigid bodies. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html"},
     {"title": "CastleTransform.TCastleTransform.DefaultMiddleHeight", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#DefaultMiddleHeight"},
     {"title": "CastleTransform.TCastleTransform.DefaultDirection", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#DefaultDirection"},
     {"title": "CastleTransform.TCastleTransform.DefaultUp", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#DefaultUp"},
     {"title": "CastleTransform.TCastleTransform.DefaultOrientation", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#DefaultOrientation"},
     {"title": "CastleTransform.TCastleTransform.AddToWorld", "text": " Value must not be <code>Nil</code>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#AddToWorld"},
     {"title": "CastleTransform.TCastleTransform.RemoveFromWorld", "text": " Value must not be <code>Nil</code>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#RemoveFromWorld"},
     {"title": "CastleTransform.TCastleTransform.ChangeWorld", "text": " This can be ignored (not care about FWorldReferences) when Value = FWorld.  <p>Each 3D object can only be part of one <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html\">TSceneManagerWorld</a> at a time. The object may be present many times within the world (counted by FWorldReferences, which is always set to 1 by this procedure for non-nil Value, and 0 for nil Value). Always remove 3D object from previous world (scene manager) before adding it to new one.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#ChangeWorld"},
     {"title": "CastleTransform.TCastleTransform.Notification", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Notification"},
     {"title": "CastleTransform.TCastleTransform.HeightCollision", "text": " This checks ray collision, from APosition along the negated GravityUp vector. Measures distance to the nearest scene item (called &quot;ground&quot; here).  <p>  <p>  <p>  AboveHeight Height above the ground. <i>One height unit equals one GravityUp vector</i>. Always use normalized GravityUp vector if you expect to receive here a normal distance.  <p>AboveHeight is always set to <a class=\"normal\" href=\"Castle3D.html#MaxSingle\">MaxSingle</a> when returned result is <code>False</code> (this guarantee simplifies some code). AboveGround Pointer to <a class=\"normal\" href=\"CastleTriangles.html#PTriangle\">PTriangle</a> representing the ground. Must be <code>Nil</code> if returned result is <code>False</code>. <b>May</b> be <code>Nil</code> even if we returned <code>True</code> (not all 3D objects may be able to generate <a class=\"normal\" href=\"CastleTriangles.html#PTriangle\">PTriangle</a> information about collision).  <p>This may be useful for example to make a footsteps sound dependent on texture of the ground. Or to decrease player life points for walking on hot lava. See &quot;The Castle&quot; game for examples. If the 3D scene is hit. <code>False</code> means that APosition floats above an empty space. That is, if you turn gravity on, it will fall down forever, as far as this 3D scene is concerned. AboveHeight Height above the ground. <i>One height unit equals one GravityUp vector</i>. Always use normalized GravityUp vector if you expect to receive here a normal distance.  <p>AboveHeight is always set to <a class=\"normal\" href=\"Castle3D.html#MaxSingle\">MaxSingle</a> when returned result is <code>False</code> (this guarantee simplifies some code). AboveGround Pointer to <a class=\"normal\" href=\"CastleTriangles.html#PTriangle\">PTriangle</a> representing the ground. Must be <code>Nil</code> if returned result is <code>False</code>. <b>May</b> be <code>Nil</code> even if we returned <code>True</code> (not all 3D objects may be able to generate <a class=\"normal\" href=\"CastleTriangles.html#PTriangle\">PTriangle</a> information about collision).  <p>This may be useful for example to make a footsteps sound dependent on texture of the ground. Or to decrease player life points for walking on hot lava. See &quot;The Castle&quot; game for examples.", "tags": "", "loc": "CastleTransform.TCastleTransform.html#HeightCollision"},
     {"title": "CastleTransform.TCastleTransform.MoveCollision", "text": "  <p>If IsRadius, then you should prefer to perform exact collision with sphere of given radius (must be &gt; 0). At the very least, this checks that the line segment between OldPos and NewPos doesn't collide, <b>and</b> that sphere with given Radius centered around NewPos doesn't collide.  <p>If not IsRadius, or if checking for collisions with sphere is not possible for some reasons, then you can check for collisions with boxes. OldBox should usually be ignored (it can be useful when collision-checking has to be approximate in some corner cases, see TCreature.MoveCollision). NewBox plays the same role as &quot;sphere centered around NewPos&quot; in paragraph above.  <p>Overloaded version with separate ProposedNewPos and NewPos parameters allows you to accept the move, but for NewPos (that should be some slightly modified version of ProposedNewPos). This allows to implement wall-sliding: when camera tries to walk into the wall, we will change movement to move alongside the wall (instead of just completely blocking the move). When this version returns <code>False</code>, it's undefined what is the NewPos.  <p>    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#MoveCollision"},
     {"title": "CastleTransform.TCastleTransform.MoveCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#MoveCollision"},
     {"title": "CastleTransform.TCastleTransform.SegmentCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#SegmentCollision"},
     {"title": "CastleTransform.TCastleTransform.SphereCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#SphereCollision"},
     {"title": "CastleTransform.TCastleTransform.SphereCollision2D", "text": "  <p>Note that <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PointCollision2D\">PointCollision2D</a> and <code>SphereCollision2D</code> <i>do not work reliably on objects that have 3D rotations</i>. See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PointCollision2D\">PointCollision2D</a> for details.  <p>  Details If non-nil, these are automatically filled with the details about the collision. If the result is <code>False</code>, the Details contents are untouched. If the result is <code>True</code>, the Details contents are set to describe the 3D objects hierarchy that caused this collision.  Details If non-nil, these are automatically filled with the details about the collision. If the result is <code>False</code>, the Details contents are untouched. If the result is <code>True</code>, the Details contents are set to describe the 3D objects hierarchy that caused this collision.", "tags": "", "loc": "CastleTransform.TCastleTransform.html#SphereCollision2D"},
     {"title": "CastleTransform.TCastleTransform.PointCollision2D", "text": "  <p>Note that <code>PointCollision2D</code> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#SphereCollision2D\">SphereCollision2D</a> <i>do not work reliably on objects that have 3D rotations</i>, that is: rotations that change the direction of Z axis! This applies to all ways of rotating &ndash; using the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> or using the X3D node <a class=\"normal\" href=\"X3DNodes.TTransformNode.html\">TTransformNode</a> (within a TCastleSce).  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p><i>The reason</i>: we transform the point (or sphere center) to the local coordinates, and we should also transform the Z axis to the local coordinates, to be always correct. Right now, we don't do the latter.</p></li>   <li value=\"2\"><p>And we don't want to do it (at least not in all cases)! The simple 2D point collision check would then actually perform a 3D line collision check, thus <code>PointCollision2D</code> would lose all the speed benefits over LineCollision. <code>PointCollision2D</code> would become a simple shortcut to perform <i>LineCollision with a line parallel to Z axis</i>.  <p>And in case of 2D games, or mostly 2D games, this speed loss would not be justified. Often you <i>know</i> that your objects have no 3D rotations, for example if your animations are done in Spine.</p></li>   <li value=\"3\"><p>In the future, we may overcome this limitation. To do this, we will detect whether the transformation is &quot;only 2D&quot; (actually this part is easy, you can detect it by looking at the matrix even, so check whether appropriate numbers are zero). And then <code>PointCollision2D</code> will change to LineCollision, and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#SphereCollision2D\">SphereCollision2D</a> will change to something like ExtrudedCircleCollision, <i>only when necessary</i>.</p></li> </ol>  <p>    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#PointCollision2D"},
     {"title": "CastleTransform.TCastleTransform.BoxCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#BoxCollision"},
     {"title": "CastleTransform.TCastleTransform.RayCollision", "text": " Returns a collision as <a class=\"normal\" href=\"CastleTransform.TRayCollision.html\">TRayCollision</a> instance, or <code>Nil</code> if no collision. Caller is responsible for freeing the returned <a class=\"normal\" href=\"CastleTransform.TRayCollision.html\">TRayCollision</a> instance.  <p>Contrary to other collision routines, this should <i>ignore the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a> property</i>. The <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a> property specifies whether item collides with camera. And this method is used for picking (pointing) 3D stuff &mdash; everything visible can be picked, collidable or not. Instead, this looks at <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Pickable\">Pickable</a> property (actually, at <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetPickable\">GetPickable</a> method result).  <p>This always returns the first collision with the 3D world, that is the one with smallest <a class=\"normal\" href=\"CastleTransform.TRayCollision.html#Distance\">TRayCollision.Distance</a>. For example, when implemented in <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a>, this checks collisions for all list items, and chooses the closest one.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#RayCollision"},
     {"title": "CastleTransform.TCastleTransform.LocalHeightCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalHeightCollision"},
     {"title": "CastleTransform.TCastleTransform.LocalMoveCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalMoveCollision"},
     {"title": "CastleTransform.TCastleTransform.LocalMoveCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalMoveCollision"},
     {"title": "CastleTransform.TCastleTransform.LocalSegmentCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalSegmentCollision"},
     {"title": "CastleTransform.TCastleTransform.LocalSphereCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalSphereCollision"},
     {"title": "CastleTransform.TCastleTransform.LocalSphereCollision2D", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalSphereCollision2D"},
     {"title": "CastleTransform.TCastleTransform.LocalPointCollision2D", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalPointCollision2D"},
     {"title": "CastleTransform.TCastleTransform.LocalBoxCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalBoxCollision"},
     {"title": "CastleTransform.TCastleTransform.LocalRayCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalRayCollision"},
     {"title": "CastleTransform.TCastleTransform.LocalRender", "text": "  <p>This is <b>mostly an internal method</b>. You should not need to override it during normal engine usage. Instead, you should render everything using <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>, which allows to load or build (by code) nodes to display meshes, light and everything else. But overriding this may be useful for special customized rendering.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalRender"},
     {"title": "CastleTransform.TCastleTransform.LocalRenderShadowVolume", "text": "  <p>This is <b>mostly an internal method</b>. You should not need to override it during normal engine usage. If you render everything using <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>, then rendering shadow volumes is also automatically handled by <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalRenderShadowVolume"},
     {"title": "CastleTransform.TCastleTransform.Translation2D", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Translation2D"},
     {"title": "CastleTransform.TCastleTransform.TransformMatricesMult", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#TransformMatricesMult"},
     {"title": "CastleTransform.TCastleTransform.TransformMatrices", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#TransformMatrices"},
     {"title": "CastleTransform.TCastleTransform.AverageScale", "text": " It is not calculated as a simple average, it's a little smarter to prevent from weird results sometimes, see <a class=\"normal\" href=\"CastleVectors.html#Approximate3DScale\">Approximate3DScale</a>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#AverageScale"},
     {"title": "CastleTransform.TCastleTransform.AverageScale2D", "text": " It is not calculated as a simple average, it's a little smarter to prevent from weird results sometimes, see <a class=\"normal\" href=\"CastleVectors.html#Approximate2DScale\">Approximate2DScale</a>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#AverageScale2D"},
     {"title": "CastleTransform.TCastleTransform.Fall", "text": " You can use FallHeight to decrease creature life or such.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Fall"},
     {"title": "CastleTransform.TCastleTransform.ChangedTransform", "text": " By default, this calls <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#VisibleChangeHere\">VisibleChangeHere</a>, which causes the window to redraw.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#ChangedTransform"},
     {"title": "CastleTransform.TCastleTransform.Create", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Create"},
     {"title": "CastleTransform.TCastleTransform.Destroy", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Destroy"},
     {"title": "CastleTransform.TCastleTransform.GetExists", "text": " It <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> class, returns <code>True</code> if <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Exists\">Exists</a> and not disabled. May be modified in subclasses, to return something more complicated.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#GetExists"},
     {"title": "CastleTransform.TCastleTransform.GetCollides", "text": " It <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> class, returns <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">GetExists</a>. May be modified in subclasses, to return something more complicated.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#GetCollides"},
     {"title": "CastleTransform.TCastleTransform.GetPickable", "text": " It <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> class, returns <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Pickable\">Pickable</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">GetExists</a>. May be modified in subclasses, to return something more complicated.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#GetPickable"},
     {"title": "CastleTransform.TCastleTransform.GetVisible", "text": " It v class, returns <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Visible\">Visible</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">GetExists</a>. May be modified in subclasses, to return something more complicated.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#GetVisible"},
     {"title": "CastleTransform.TCastleTransform.Disable", "text": " Every <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Disable\">Disable</a> call should always be paired with <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Enable\">Enable</a> call (usually using <code>try ... finally .... end</code> block). Internally, we keep a counter of how many times the object is disabled, and if this counter is &lt;&gt; 0 then <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">GetExists</a> returns <code>False</code>. Using this is useful for taming collisions, especially to avoid self-collisions (when a creature moves, it checks for collision with other creatures, but it doesn't want to check for collisions with it's own bounding volume).     ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Disable"},
     {"title": "CastleTransform.TCastleTransform.Enable", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Enable"},
     {"title": "CastleTransform.TCastleTransform.Add", "text": " You can also operate directly on <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#List\">List</a> instance.     ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Add"},
     {"title": "CastleTransform.TCastleTransform.Insert", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Insert"},
     {"title": "CastleTransform.TCastleTransform.Remove", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Remove"},
     {"title": "CastleTransform.TCastleTransform.Count", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Count"},
     {"title": "CastleTransform.TCastleTransform.Clear", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Clear"},
     {"title": "CastleTransform.TCastleTransform.Exchange", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Exchange"},
     {"title": "CastleTransform.TCastleTransform.SortBackToFront", "text": " Only the immediate list items are reordered, looking at their bounding boxes.  <p>Calling this method makes sense if you have a list of objects, and some of them are partially-transparent and may be visible at the same place on the screen. It may even make sense to call this method every frame (like in every <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnUpdate\">TCastleWindowCustom.OnUpdate</a>), if you move or otherwise change the objects (changing their bounding boxes), or if the CameraPosition may change (note that CameraPosition is only relevant if BlendingSort = <a class=\"normal\" href=\"CastleBoxes.html#bs3D\">bs3D</a>).  <p>Sorting partially-transparent objects avoids artifacts when rendering.  <p>Note that this doesn't take care of sorting the shapes within the scenes. For this, you should set <a class=\"normal\" href=\"CastleScene.TSceneRenderingAttributes.html#BlendingSort\">Scene.Attributes.BlendingSort</a> to a value like <a class=\"normal\" href=\"CastleBoxes.html#bs3D\">bs3D</a>, to keep it sorted. It is actually the default now.  <p>See the <a class=\"normal\" href=\"CastleBoxes.html#TBlendingSort\">TBlendingSort</a> documentation for the exact specification of sorting algorithms. Using BlendingSort = <a class=\"normal\" href=\"CastleBoxes.html#bsNone\">bsNone</a> does nothing.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#SortBackToFront"},
     {"title": "CastleTransform.TCastleTransform.SortBackToFront2D", "text": " See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#SortBackToFront\">SortBackToFront</a> for documentation, this method is only a shortcut for <code><a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#SortBackToFront\">SortBackToFront</a>(<a class=\"normal\" href=\"CastleBoxes.html#bs2D\">bs2D</a>, TVector3.Zero)</code>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#SortBackToFront2D"},
     {"title": "CastleTransform.TCastleTransform.BoundingBox", "text": "  <p>Should take into account both collidable and visible objects. For example, invisible walls (not visible) and fake walls (not collidable) should all be accounted here.  <p>It's a <i>bounding</i> volume, it should be as large as necessary to include the object inside. At the same time, it should be as &quot;tight&quot; as it can, to make various optimizations work best.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#BoundingBox"},
     {"title": "CastleTransform.TCastleTransform.LocalBoundingBox", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalBoundingBox"},
     {"title": "CastleTransform.TCastleTransform.Render", "text": " Should check and immediately exit when <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetVisible\">GetVisible</a> is <code>False</code>.  <p>The rendering transformation, frustum, and filtering is specified inside <a class=\"normal\" href=\"CastleTransform.TRenderParams.html\">TRenderParams</a> class. This method should only update <a class=\"normal\" href=\"CastleTransform.TRenderParams.html#Statistics\">TRenderParams.Statistics</a>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Render"},
     {"title": "CastleTransform.TCastleTransform.Render", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Render"},
     {"title": "CastleTransform.TCastleTransform.RenderShadowVolume", "text": " This is done only if <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Exists\">Exists</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#CastShadowVolumes\">CastShadowVolumes</a>.  <p>It does shadow volumes culling inside (so ShadowVolumeRenderer should have FrustumCullingInit already initialized).  <p>ParentTransform and ParentTransformIsIdentity describe the transformation of this object in the 3D world. <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> objects may be organized in a hierarchy when parent transforms it's children. When ParentTransformIsIdentity, ParentTransform must be TMatrix4.Identity (it's not guaranteed that when ParentTransformIsIdentity = <code>True</code>, Transform value will be ignored !).    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#RenderShadowVolume"},
     {"title": "CastleTransform.TCastleTransform.PrepareResources", "text": "  <p>It is usually simpler to call <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#PrepareResources\">TCastleSceneManager.PrepareResources</a> then this method. Calling <code>SceneManager.PrepareResources(MyScene)</code> will automatically call <code>MyScene.PrepareResources(...)</code> underneath, with proper parameters.  <p>It is best to call this after the rendering context is initailized, which means: at Application.OnInitialize, or Window.OnOpen or later. Calling this method earlier will omit some preparations, thus reducing the effectiveness of them.  <p>This makes sure that appropriate methods execute as fast as possible. It's never required to call this method &mdash; everything will be prepared &quot;as needed&quot; anyway. But if you allow everything to be prepared &quot;as needed&quot;, then e.g. the first <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Render\">Render</a> call may take a long time because it may have to prepare resources that will be reused in next <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Render\">Render</a> calls. This is bad, as your program will seem very slow at the beginning (when rendering resources are being prepared, so at first frame, or a couple of first animation frames). To avoid this, call this method, showing the user something like &quot;now we're preparing the resources &mdash; please wait&quot;.  <p>For OpenGL rendered objects, this method ties this object to the current OpenGL context. But it doesn't change any OpenGL state or buffers contents (at most, it allocates some texture and display list names).  <p>  <p>  <p>  Options What features should be prepared to execute fast. See <a class=\"normal\" href=\"CastleTransform.html#TPrepareResourcesOption\">TPrepareResourcesOption</a>, the names should be self-explanatory (they refer to appropriate methods of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a>, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> or <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>). ProgressStep Says that we should make this many Progress.Step calls during preparation. Useful to show progress bar to the user during long preparation.  <p>TODO: for now, do not include <a class=\"normal\" href=\"CastleTransform.html#prSpatial\">prSpatial</a> if you use ProgressStep. Reason: octree preparations have a separate mechanism that may want to show progress. Params Rendering parameters to prepare for. It is used only if Options contains <a class=\"normal\" href=\"CastleTransform.html#prRender\">prRender</a>.  Options What features should be prepared to execute fast. See <a class=\"normal\" href=\"CastleTransform.html#TPrepareResourcesOption\">TPrepareResourcesOption</a>, the names should be self-explanatory (they refer to appropriate methods of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a>, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> or <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>). ProgressStep Says that we should make this many Progress.Step calls during preparation. Useful to show progress bar to the user during long preparation.  <p>TODO: for now, do not include <a class=\"normal\" href=\"CastleTransform.html#prSpatial\">prSpatial</a> if you use ProgressStep. Reason: octree preparations have a separate mechanism that may want to show progress. Params Rendering parameters to prepare for. It is used only if Options contains <a class=\"normal\" href=\"CastleTransform.html#prRender\">prRender</a>.", "tags": "", "loc": "CastleTransform.TCastleTransform.html#PrepareResources"},
     {"title": "CastleTransform.TCastleTransform.PrepareResourcesSteps", "text": " Useful only if you want to pass ProgressStep = <code>True</code> to <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PrepareResources\">PrepareResources</a>. In the base class <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> this just returns 0.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#PrepareResourcesSteps"},
     {"title": "CastleTransform.TCastleTransform.Press", "text": " Return <code>True</code> if you handled them. See also <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> analogous events.     ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Press"},
     {"title": "CastleTransform.TCastleTransform.Release", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Release"},
     {"title": "CastleTransform.TCastleTransform.PointingDeviceActivate", "text": " Return <code>True</code> if you handled the event.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><code>PointingDeviceActivate</code> signals that the picking button (usually, left mouse button) is pressed or released (depending on Active parameter).  <p>Note that the exact key or mouse responsible for this is configurable in our engine by <a class=\"normal\" href=\"CastleSceneManager.html#Input_Interact\">Input_Interact</a>. By default it's the left mouse button, as is usual for VRML/X3D browsers. But it can be configured to be other mouse button or a key, for example most 3D games use &quot;e&quot; key to interact.  <p>In case of Active = <code>False</code> (which means that pointing device is no longer pressed), an extra parameter CancelAction indicates whether this pointing device &quot;press and release&quot; sequence may be considered a &quot;click&quot;. When CancelAction = <code>True</code>, then you should not make a &quot;click&quot; event (e.g. TouchSensor should not send touchTime event etc.).  <p>In case of Active = <code>True</code>, CancelAction is always <code>False</code>. </p></li>   <li><p><a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PointingDeviceMove\">PointingDeviceMove</a> signals that pointer moves over this 3D object.</p></li> </ul>  <p>  <p><a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PointingDeviceMove\">PointingDeviceMove</a> receives Pick information about what exactly is hit by the 3D ray corresponding to the current mouse position. It contains the detailed information about 3D point, triangle and ray (all in local coordinate system) that are indicated by the mouse. <code>PointingDeviceActivate</code> does not receive this information now (because it may happen in obscure situations when ray direction is not known; this is all related to our &quot;fallback to MainScene&quot; mechanism).  <p>They also receive Distance to the collision, in world coordinates. See <a class=\"normal\" href=\"CastleTransform.TRayCollision.html#Distance\">TRayCollision.Distance</a>.  <p>The pointing device event (activation, deactivation or move) is send first to the innermost 3D object. That is, we first send this event to the first item on <a class=\"normal\" href=\"CastleTransform.TRayCollision.html\">TRayCollision</a> list corresponding to the current ray. This way, the innermost (&quot;most local&quot;) 3D object has the chance to handle this event first. If the event is not handled, it is passed to other 3D objects (we simply iterate over the <a class=\"normal\" href=\"CastleTransform.TRayCollision.html\">TRayCollision</a> list). If nothing on <a class=\"normal\" href=\"CastleTransform.TRayCollision.html\">TRayCollision</a> list handled the item, it is eventually passed to main 3D scene (<a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a>), if it wasn't already present on <a class=\"normal\" href=\"CastleTransform.TRayCollision.html\">TRayCollision</a> list.  <p>Note that when passing this event to <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a>, it is possible that 3D ray simply didn't hit anything (mouse pointer is over the background). In this case, <a class=\"normal\" href=\"CastleTransform.TRayCollisionNode.html#Point\">TRayCollisionNode.Point</a> is undefined, <a class=\"normal\" href=\"CastleTransform.TRayCollisionNode.html#Triangle\">TRayCollisionNode.Triangle</a> is <code>Nil</code> and Distance is <a class=\"normal\" href=\"Castle3D.html#MaxSingle\">MaxSingle</a>.  <p>This event should be handled only if <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">GetExists</a>. Usually, 3D objects with <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">GetExists</a> = <code>False</code> will not be returned by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#RayCollision\">RayCollision</a>, so they will not receive this event anyway. However, if 3D object may be equal to <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#MainScene\">TCastleSceneManager.MainScene</a>, then it should be secured and check for <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">GetExists</a> inside <code>PointingDeviceActivate</code> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PointingDeviceMove\">PointingDeviceMove</a>.  <p>    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#PointingDeviceActivate"},
     {"title": "CastleTransform.TCastleTransform.PointingDeviceMove", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#PointingDeviceMove"},
     {"title": "CastleTransform.TCastleTransform.Update", "text": "   RemoveMe Set this to <a class=\"normal\" href=\"CastleTransform.html#rtRemove\">rtRemove</a> or <a class=\"normal\" href=\"CastleTransform.html#rtRemoveAndFree\">rtRemoveAndFree</a> to remove this item from 3D world (parent list) after Update finished. <a class=\"normal\" href=\"CastleTransform.html#rtRemoveAndFree\">rtRemoveAndFree</a> additionally will free this item. Initially it's <a class=\"normal\" href=\"CastleTransform.html#rtNone\">rtNone</a> when this method is called.  RemoveMe Set this to <a class=\"normal\" href=\"CastleTransform.html#rtRemove\">rtRemove</a> or <a class=\"normal\" href=\"CastleTransform.html#rtRemoveAndFree\">rtRemoveAndFree</a> to remove this item from 3D world (parent list) after Update finished. <a class=\"normal\" href=\"CastleTransform.html#rtRemoveAndFree\">rtRemoveAndFree</a> additionally will free this item. Initially it's <a class=\"normal\" href=\"CastleTransform.html#rtNone\">rtNone</a> when this method is called.", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Update"},
     {"title": "CastleTransform.TCastleTransform.VisibleChangeHere", "text": " This is usually called by implementation of this 3D object, to notify others that it changed.  <p>Changes is a set describing what changes occurred. See <a class=\"normal\" href=\"CastleTransform.html#TVisibleChange\">TVisibleChange</a> docs for more information. It must specify all things that possibly changed.  <p>Changes can be [], meaning &quot;something tells us to redraw, but no visible change happened yet, maybe something will happen during a redraw&quot; (this is used when e.g. possibly LOD level changed). We still broadcast <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#VisibleChangeNotification\">VisibleChangeNotification</a>, even when Changes=[].  <p>The information about visibility changed is passed upward, to the Parent, and eventually to the <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>, that broadcasts this to all 3D objects by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#VisibleChangeNotification\">VisibleChangeNotification</a>. If you want to <i>react</i> to visibility changes, you should override <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#VisibleChangeNotification\">VisibleChangeNotification</a>, not this method.  <p>Be careful when handling this, various changes may cause this, so be prepared to handle this at every time.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#VisibleChangeHere"},
     {"title": "CastleTransform.TCastleTransform.VisibleChangeNotification", "text": " This is usually called by our container (like <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>), to allow this object to react (e.g. by regenerating mirror textures) to changes in the world (not necessarily in this object, maybe in some other <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> instance).  <p>If you want to <i>react</i> to visibility changes, you should override this.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#VisibleChangeNotification"},
     {"title": "CastleTransform.TCastleTransform.CameraChanged", "text": " This is usually called by our container (like <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a>) to notify that camera changed.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#CameraChanged"},
     {"title": "CastleTransform.TCastleTransform.GLContextClose", "text": " This will be also automatically called from destructor.  <p>Control should clear here any resources that are tied to the GL context.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#GLContextClose"},
     {"title": "CastleTransform.TCastleTransform.UpdateGeneratedTextures", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#UpdateGeneratedTextures"},
     {"title": "CastleTransform.TCastleTransform.Dragging", "text": "  <p>This should be set to <code>True</code> to disable camera navigation methods that also use mouse move. In practice, to disable <a class=\"normal\" href=\"CastleCameras.TExamineCamera.html\">TExamineCamera</a> view rotation/movement by moving the mouse, as it makes (comfortable) dragging practically impossible (at each mouse move, view changes...).  <p>In particular, when you operate on active X3D pointing-device sensors (like drag sensors, e.g. PlaneSensor, but also TouchSensor may use it).    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Dragging"},
     {"title": "CastleTransform.TCastleTransform.Middle", "text": " This is used for sphere center (if overriden Sphere returns <code>True</code>) and is the central point from which collisions of this object are checked (Move, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MoveAllowed\">MoveAllowed</a>, Height, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#LineOfSight\">LineOfSight</a>). For 3D things like level scene this is mostly useless (as you will leave Sphere at default <code>False</code> then, and the scene itself doesn't move), but it's crucial for dynamic 3D things like player and moving creatures.  <p>In short, it's usually most comfortable to think about this as a position of the eye, or the middle of the creature's head.  <p>In an ideal situation, it should not be based on anything dynamic. For example, when this is based on the current bounding box of the animation, there is a risk that a large and sudden change in animation box could make the Middle point to jump to the other side of the wall (breaking collisions, as it changes Middle without a chance to check for collisions by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MoveAllowed\">MoveAllowed</a>). Ideally, it should remain constant even when the shape of the object changes, and be possible to change only when <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MoveAllowed\">MoveAllowed</a> is checked (so only when <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Translation\">TCastleTransform.Translation</a> can change).  <p>In this class this returns something sensible above the bottom of the box. See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MiddleHeight\">TCastleTransform.MiddleHeight</a>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Middle"},
     {"title": "CastleTransform.TCastleTransform.Sector", "text": " Used for AI. <code>Nil</code> if none (maybe because we're not part of any world, maybe because sectors of the world were not initialized, or maybe simply because we're outside of all sectors).    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Sector"},
     {"title": "CastleTransform.TCastleTransform.Sphere", "text": " If <code>True</code> then Radius (and Middle point) determine the approximate sphere surrounding the 3D object (it does not have to be a perfect bounding sphere around the object), and it may be used for some collisions instead of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#BoundingBox\">BoundingBox</a>. See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#CollidesWithMoving\">CollidesWithMoving</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MoveAllowed\">MoveAllowed</a> for when it may happen.  <p>Must return <code>False</code> when not <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">GetExists</a> (because we can't express &quot;empty sphere&quot; by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Sphere\">Sphere</a> method for now, but <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#BoundingBox\">BoundingBox</a> can express <a class=\"normal\" href=\"CastleBoxes.TBox3D.html#Empty\">TBox3D.Empty</a>).  <p>By default, in <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> class, this always returns <code>False</code> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Sphere\">Sphere</a> is undefined.  <p>The advantages of using a sphere, that does not have to be a perfect bounding sphere (it may be smaller than necessary, and only account e.g. for upper body part of the creature), are:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>It can have constant radius, even though the actual creature animates. This allows us to perfectly, reliably guarantee that sphere absolutely never collides with level and such.  <p>In case of a tight bounding volume (box or sphere) that animates, this guarantee is not really possible. Simply increasing time changes the animation to the next frame, which may be slightly larger in one dimension because e.g. creature moves a hand in this direction. This means that simply increasing time may change the non-collidable creature into a collidable one, if creature stands close to a wall/other creature and such. And we cannot simply stop/reverse an arbitrary animation at an arbitrary time (to avoid collision), this would look weird for some animations and would require some additional work at preparing animations and designing AI (as then &quot;every action can be interrupted&quot;).  <p>Also using a bounding volume large enough to account for all possible positions is not doable, as it would be too large. Consider that for humanoid creatures, walking animation usually has tall and thin bounding box (creature stands) but dead/lying animation usually has flat and wide bounding box.  <p>So, only a bounding volume (like a sphere) that <i>may be smaller than bounding volume</i> can remain constant and easily guarantee the assertion &quot;it never collides&quot;.  <p>This means that using such sphere results in simpler collision detection routines, as they may assume that collision doesn't occur. In contrast, detection routines looking at our (possibly animated) <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#BoundingBox\">BoundingBox</a> must take into account that collision may already be happening, and they must incorporate code to allow creatures/players to &quot;get unstruck&quot;.</p></li>   <li><p>Using smaller sphere also allows to naturally ascend the stairs and upward slopes. Sphere can move forward slightly, and then creature may raise up, to reach it's preferred height. Then sphere can move further forward, and so on. This alllows to allow stair climbing for creatures without any extra effort in the code.  <p>The downside is that creature legs will temporarily &quot;sink into the floor&quot; when climbing up the stairs. But it's not noticeable if &quot;growing up&quot; mechanism works fast enough.</p></li> </ul>  <p>  <p>Sphere disadvantage:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Sphere is far from perfect as a bounding volume &mdash; it's too small, sometimes also too large, sometimes both at the same time...  <p>Since the Sphere radius remains always the same, it must be good for many creature animation frames. In cases where the sphere isn't suitable, and you don't need advantages above &mdash; you can make <code>Sphere</code> return <code>False</code>. E.g. a dead creature may be stuck in a wall, and it doesn't have to climb stairs. So you don't really need sphere advantages listed above, and <code>Sphere</code> may return <code>False</code> when creature is in dying state.  <p>But still it may be a problem sometimes, if some creature states have entirely different animations and bounding boxes. Then you will be forced to choose one universal Radius for all creature states. And you need constant radius to keep the advantage above of &quot;guarantee&quot;.  <p>1. Obviously you can't set radius too small, because if it's much smaller than actual creature's geometry then the creature will noticeably collide with level geometry and other creatures.  <p>2. On the other hand, you can't set radius too large (or move sphere center, Middle, much lower). This would block stair climbing. </p></li> </ul>  <p>    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Sphere"},
     {"title": "CastleTransform.TCastleTransform.Height", "text": "  <p>This ignores the geometry of this 3D object (to not accidentaly collide with your own geometry), and checks collisions with the rest of the world.     ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Height"},
     {"title": "CastleTransform.TCastleTransform.Height", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Height"},
     {"title": "CastleTransform.TCastleTransform.LineOfSight", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LineOfSight"},
     {"title": "CastleTransform.TCastleTransform.MoveAllowed", "text": " Returns true and sets NewPos if some move is allowed. Overloaded version without ProposedNewPos doesn't do wall-sliding, and only answers if exactly this move is allowed.  <p>If this 3D object allows to use sphere as the bounding volume, if will be used (see <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Sphere\">Sphere</a>).  <p>This ignores the geometry of this 3D object (to not accidentaly collide with your own geometry), and checks collisions with the rest of the world.     ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#MoveAllowed"},
     {"title": "CastleTransform.TCastleTransform.MoveAllowed", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#MoveAllowed"},
     {"title": "CastleTransform.TCastleTransform.Ray", "text": "  <p>This ignores the geometry of this 3D object (to not accidentaly collide with your own geometry), and checks collisions with the rest of the world.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Ray"},
     {"title": "CastleTransform.TCastleTransform.OutsideToLocal", "text": " This is called <code>OutsideToLocal</code>, not WorldToLocal, because it only handles transformation defined in this item &mdash; it does not recursively apply all transform on the way to root .    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#OutsideToLocal"},
     {"title": "CastleTransform.TCastleTransform.LocalToOutside", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#LocalToOutside"},
     {"title": "CastleTransform.TCastleTransform.PreferredHeight", "text": " This is used by objects affected by gravity (like non-flying creatures and items) to know how far they should fall down or grow up.  <p>The default implementation in this class looks at <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MiddleHeight\">MiddleHeight</a> property, see the algorithm described there. This may be dynamic (may change during creature lifetime, so you can make the creature duck or grow if you want).    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#PreferredHeight"},
     {"title": "CastleTransform.TCastleTransform.Transform", "text": " This matrix represents a concise version of properties like <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Translation\">Translation</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Rotation\">Rotation</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Scale\">Scale</a>. It does not takie into account the transformation of parent <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> (for this, use <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#WorldTransform\">WorldTransform</a>).    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Transform"},
     {"title": "CastleTransform.TCastleTransform.InverseTransform", "text": " This is an inverse of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Transform\">Transform</a>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#InverseTransform"},
     {"title": "CastleTransform.TCastleTransform.HasWorldTransform", "text": " When this returns <code>True</code>, you know that <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#WorldTransform\">WorldTransform</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#WorldInverseTransform\">WorldInverseTransform</a> will not raise <a class=\"normal\" href=\"CastleTransform.ETransformParentUndefined.html\">ETransformParentUndefined</a>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#HasWorldTransform"},
     {"title": "CastleTransform.TCastleTransform.WorldTransform", "text": " This accumulates the transformation of this instance (derived from properties like <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Translation\">Translation</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Rotation\">Rotation</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Scale\">Scale</a>) with the transformation of parent <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> instances, all the way up to and including the root transformation of <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html\">TSceneManagerWorld</a>. Thus, this is a transformation to the world known to the <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> instance.  <p>Two conditions are necessary to make this available:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> This instance must be part of some <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>. So it must be added to <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">SceneManager.Items</a>, or to some other <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> that is part of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>.  <p>Otherwise reading this raises <a class=\"normal\" href=\"CastleTransform.ENotAddedToWorld.html\">ENotAddedToWorld</a>. </p></li>   <li><p> This instance must not be present multiple times inside the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>. Ever (even in the past).  <p>In general, it is allowed to have multiple references to the same <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> within the same <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>. So you can add the same <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> or <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> many times to <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">SceneManager.Items</a>. This is a useful optimization (sharing), and is explicitly allowed. But if you do this &mdash; you cannot rely on <code>WorldTransform</code> property.  <p>Otherwise reading this raises <a class=\"normal\" href=\"CastleTransform.EMultipleReferencesInWorld.html\">EMultipleReferencesInWorld</a> or <a class=\"normal\" href=\"CastleTransform.ETransformParentUndefined.html\">ETransformParentUndefined</a>. </p></li> </ul>  <p>  <p>You can check <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#HasWorldTransform\">HasWorldTransform</a> before calling this method, to avoid catching an exception.  <p>Note that the <code>WorldTransform</code> is not updated in <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Update\">Update</a>, it is smartly updated on-demand. So you do not have to wait for <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Update\">Update</a> or other method to be called before accessing the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#WorldTransform\">WorldTransform</a>.  <p>      ENotAddedToWorld When this instance is not yet part of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>. EMultipleReferencesInWorld When this instance is added multiple times to <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>. ETransformParentUndefined When this instance was once added multiple times to <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>, or for some other reason cannot be calculated. This is an ancestor of <a class=\"normal\" href=\"CastleTransform.ENotAddedToWorld.html\">ENotAddedToWorld</a> and <a class=\"normal\" href=\"CastleTransform.EMultipleReferencesInWorld.html\">EMultipleReferencesInWorld</a> too.", "tags": "", "loc": "CastleTransform.TCastleTransform.html#WorldTransform"},
     {"title": "CastleTransform.TCastleTransform.WorldInverseTransform", "text": "  <p>See <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#WorldTransform\">WorldTransform</a> for more details how this works.  <p>      ENotAddedToWorld When this instance is not yet part of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>. EMultipleReferencesInWorld When this instance is added multiple times to <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>. EMultipleReferencesInWorld When this instance was once added multiple times to <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a>, or for some other reason cannot be calculated. This is an ancestor of <a class=\"normal\" href=\"CastleTransform.ENotAddedToWorld.html\">ENotAddedToWorld</a> and <a class=\"normal\" href=\"CastleTransform.EMultipleReferencesInWorld.html\">EMultipleReferencesInWorld</a> too.", "tags": "", "loc": "CastleTransform.TCastleTransform.html#WorldInverseTransform"},
     {"title": "CastleTransform.TCastleTransform.Translate", "text": " You usually don't want to use this directly, instead use <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Move\">Move</a> method to move checking collisions (and with optional wall sliding).    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Translate"},
     {"title": "CastleTransform.TCastleTransform.Move", "text": " This is the simplest way to move a 3D object, and a basic building block for artificial intelligence of creatures.  <p>Checks move possibility by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MoveAllowed\">MoveAllowed</a>, using <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Middle\">Middle</a> point. Actual move is done using <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Translate\">Translate</a>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Move"},
     {"title": "CastleTransform.TCastleTransform.GetTranslation", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#GetTranslation"},
     {"title": "CastleTransform.TCastleTransform.Identity", "text": " Also resets <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#ScaleOrientation\">ScaleOrientation</a>.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Identity"},
     {"title": "CastleTransform.TCastleTransform.GetView", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#GetView"},
     {"title": "CastleTransform.TCastleTransform.SetView", "text": "  <p>ADir and AUp given here do not have to be normalized (they will be normalized if needed). They will be automatically fixed to be orthogonal, if necessary: when AdjustUp = <code>True</code> (the default) we will adjust the up vector (preserving the given direction value), otherwise we will adjust the direction (preserving the given up value).    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#SetView"},
     {"title": "CastleTransform.TCastleTransform.SetView", "text": "    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#SetView"},
     {"title": "CastleTransform.TCastleTransform.UpPrefer", "text": " If necessary, the up vector provided here will be fixed to be orthogonal to direction.  <p>This is similar to assigning <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Up\">Up</a> vector using it's property setter, but different behavior happens when we need to fix vectors to have direction orthogonal to up (which must be always true). In case of assigning <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Up\">Up</a> by property setter, the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Direction\">Direction</a> vector is changed (if necessary, to be orthogonal to up). In case of this method, the up vector is changed (if necessary, to be orthogonal to direction).  <p>It's good to use this if you have a preferred up vector for creatures, but still preserving the direction vector has the highest priority.    ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#UpPrefer"},
     {"title": "CastleTransform.TCastleTransform.Exists", "text": "  <p>Setting this to <code>False</code> pretty much turns everything of this 3D object to &quot;off&quot;. This is useful for objects that disappear completely from the level when something happens. You could just as well remove this object from <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a> tree, but sometimes it's more comfortable to simply turn this property to <code>False</code>.  <p>Descendants may also override <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetExists\">GetExists</a> method.  <p> ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Exists"},
     {"title": "CastleTransform.TCastleTransform.Collides", "text": " You can turn this off, useful to make e.g. &quot;fake&quot; walls (to some secret places on level).  <p>This describes collision resolution with almost everything &mdash; camera, player (in third-person perspective, camera may differ from player), other creatures. That is because everything resolves collisions through our methods <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MoveCollision\">MoveCollision</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#HeightCollision\">HeightCollision</a> (high-level) or <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#SegmentCollision\">SegmentCollision</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#SphereCollision\">SphereCollision</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#SphereCollision2D\">SphereCollision2D</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PointCollision2D\">PointCollision2D</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#BoxCollision\">BoxCollision</a> (low-level).  <p>(Note that <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#RayCollision\">RayCollision</a> is excluded from this, it exceptionally ignores Collides value, as it's primarily used for picking. Same for <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#SegmentCollision\">SegmentCollision</a> with <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#LineOfSight\">LineOfSight</a>=true.)  <p>The only exception are the collisions with <a class=\"normal\" href=\"Castle3D.T3DMoving.html\">T3DMoving</a> instances (movable world parts like elevators and doors) that have their own detection routines and look at <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#CollidesWithMoving\">CollidesWithMoving</a> property of other objects. That is, the <a class=\"normal\" href=\"Castle3D.T3DMoving.html\">T3DMoving</a> instance itself must still have Collides = <code>True</code>, but it interacts with <i>other</i> objects if and only if they have <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#CollidesWithMoving\">CollidesWithMoving</a> = <code>True</code> (ignoring their Collides value). This allows items to be moved by elevators, but still player and creatures can pass through them.  <p>Note that if not <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Exists\">Exists</a> then this doesn't matter (not existing objects never participate in collision detection).  <p>Descendants may also override <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetCollides\">GetCollides</a> method. Sometimes it's more comfortable than changing the property value.  <p> ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Collides"},
     {"title": "CastleTransform.TCastleTransform.Pickable", "text": " Note that if not <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Exists\">Exists</a> then this doesn't matter (not existing objects are never pickable). This is independent from <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a>, as <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#RayCollision\">RayCollision</a> does not look at <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a>, it only looks at <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Pickable\">Pickable</a>.  <p>Descendants may also override <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetPickable\">GetPickable</a> method. Sometimes it's more comfortable than changing the property value.  <p> ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Pickable"},
     {"title": "CastleTransform.TCastleTransform.Visible", "text": " Note that if not <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Exists\">Exists</a> then this doesn't matter (not existing objects are never visible). This is independent from <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a> or <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Pickable\">Pickable</a>.  <p>Descendants may also override <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#GetVisible\">GetVisible</a> method. Sometimes it's more comfortable than changing the property value.  <p> ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Visible"},
     {"title": "CastleTransform.TCastleTransform.Items", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Items"},
     {"title": "CastleTransform.TCastleTransform.CastShadowVolumes", "text": " See also <a class=\"normal\" href=\"CastleScene.TCastleScene.html#ReceiveShadowVolumes\">TCastleScene.ReceiveShadowVolumes</a>. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#CastShadowVolumes"},
     {"title": "CastleTransform.TCastleTransform.World", "text": " In other words, the root of 3D objects tree containing this object. In practice, the world instance is always 1-1 corresponding to a particular <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html\">TCastleSceneManager</a> instance (each scene manager has it's world instance in <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a>).  <p><code>Nil</code> if we are not part of a hierarchy rooted in <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html\">TSceneManagerWorld</a>. In pratice, this happens if we're not yet part of a <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Items\">TCastleSceneManager.Items</a> hierarchy. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#World"},
     {"title": "CastleTransform.TCastleTransform.Cursor", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Cursor"},
     {"title": "CastleTransform.TCastleTransform.CollidesWithMoving", "text": "  <p>Some 3D moving objects may try to avoid crushing this item. Like an automatic door that stops it's closing animation to not crush things standing in the doorway.  <p>Some other 3D moving objects may push this object. Like elevators (vertical, or horizontal moving platforms). We may use sphere (see <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Sphere\">TCastleTransform.Sphere</a>) for checking collisions, or bounding box (<a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#BoundingBox\">TCastleTransform.BoundingBox</a>), depending on need. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#CollidesWithMoving"},
     {"title": "CastleTransform.TCastleTransform.InternalExcludeFromParentBoundingVolume", "text": " This should be always <code>True</code> for non-debug scenes. Violating this may cause rendering artifacts, things could disappear when they should not. Using this is reasonable only if you attach a debug geometry to your scene, and you don't want to enlarge your bounding volume (e.g. because this debug geometry visualizes something determined by the bounding volume, and it would create a &quot;feedback loop&quot; if the visualization itself would enlarge the bounding box). ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#InternalExcludeFromParentBoundingVolume"},
     {"title": "CastleTransform.TCastleTransform.Gravity", "text": " See also <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">PreferredHeight</a>.  <p>Special notes for <a class=\"normal\" href=\"CastlePlayer.TPlayer.html\">TPlayer</a>: player doesn't use this (TPlayer.Gravity should remain <code>False</code>), instead player relies on TPlayer.Camera.Gravity = <code>True</code>, that does a similar thing (with some extras, to make camera effects). This will change in the future, to merge these two gravity implementations. Although the <a class=\"normal\" href=\"CastlePlayer.TPlayer.html#Fall\">TPlayer.Fall</a> method still works as expected (it's linked to <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnFall\">TWalkCamera.OnFall</a> in this case).  <p>TODO: In CGE 6.6 this will be deprecated, and you will be adviced to always use physics, through <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#RigidBody\">TCastleTransform.RigidBody</a>, to have realistic gravity. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Gravity"},
     {"title": "CastleTransform.TCastleTransform.FallSpeed", "text": "  <p>This is relevant only if <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Gravity\">Gravity</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">PreferredHeight</a> &lt;&gt; 0. 0 means no falling.  <p>TODO: In CGE 6.6 this will be deprecated, and you will be adviced to always use physics, through <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#RigidBody\">TCastleTransform.RigidBody</a>, to have realistic gravity. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#FallSpeed"},
     {"title": "CastleTransform.TCastleTransform.GrowSpeed", "text": " This is used by non-flying creatures when climbing up stairs, in which case <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Translation\">Translation</a> (&quot;legs positon&quot;) may be sometimes under the ground while Middle (&quot;eyes position&quot;) will be always above the ground and will try to grow to be at <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">PreferredHeight</a> above the ground.  <p>This is relevant only if <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Gravity\">Gravity</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">PreferredHeight</a> &lt;&gt; 0. 0 means no growing. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#GrowSpeed"},
     {"title": "CastleTransform.TCastleTransform.MiddleHeight", "text": " Value 0 means that eyes are at the bottom of the model, 0.5 means the middle, 1 means top.  <p>The <i>top</i> is always considered to be at the top of the bounding box.  <p>Definition of <i>bottom</i> depends on <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Gravity\">Gravity</a>:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> When Gravity is <code>True</code>, then the <i>bottom</i> is considered to be the plane where World.GravityCoordinate (like Z or Y axis) is zero. The actual bottom (lowest point) of the bounding box doesn't matter. This means that things placed below zero plane (like a creature tentacle or leg) will sink into the ground, instead of causing whole creature to move up. It also means that the creature can easily float above the ground, just model it a little above the zero plane.  <p>In other words, this allows you to model the creature with respect to the ground (zero plane), which is comfortable.  <p>Note that setting <code>MiddleHeight</code> to exact 0 means that gravity will not work, as it means that the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">PreferredHeight</a> above the ground is to be stuck right at the ground level.  <p>For gravity to work right, the <code>MiddleHeight</code> should be large enough to cause <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">PreferredHeight</a> to be &gt; <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Sphere\">Sphere</a> radius, for all possible animation states (for all possible bounding box values). </p></li>   <li><p> When Gravity is <code>False</code>, then the <i>bottom</i> is considered at the bottom of the bounding box.  <p>This way it works regardless of where (0,0,0) is in your model (regardless if (0,0,0) represents legs, or middle of your creature), since we adjust to the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#BoundingBox\">BoundingBox</a> position. </p></li> </ul>  <p>  <p>This property determines how the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> handles the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Middle\">Middle</a> implementation (this is the point used for various collision detection routines) and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#PreferredHeight\">PreferredHeight</a> (this is the preferred height of <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Middle\">Middle</a> above the ground). You can override these two methods to use a different approach, and then ignore <code>MiddleHeight</code> completely. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#MiddleHeight"},
     {"title": "CastleTransform.TCastleTransform.Translation", "text": " Zero by default. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Translation"},
     {"title": "CastleTransform.TCastleTransform.Center", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Center"},
     {"title": "CastleTransform.TCastleTransform.Rotation", "text": " Rotation is expressed as a 4D vector, in which the first 3 components specify the rotation axis (does not need to be normalized, but must be non-zero), and the last component is the rotation angle <i>in radians</i>.  <p>Rotation is done around <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Center\">Center</a>. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Rotation"},
     {"title": "CastleTransform.TCastleTransform.Scale", "text": " Scaling is done around <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Center\">Center</a> and with orientation given by <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#ScaleOrientation\">ScaleOrientation</a>.  <p>We do the best we can to work with <i>any</i> scale value, even negative or zero. But usually, it's best to keep the scale positive. More information:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>If you can, keep the scale uniform, that is scale equal amount in X, Y and Z. For example set scale = <code>(3.0, 3.0, 3.0)</code> to scale 3x times, and avoid scale like <code>(3.0, 1.0, 1.0)</code> that scales more in one direction.  <p>Non-uniform scale works, but some collisions are not perfectly calculated then. (For example, an ideal sphere is no longer a sphere when scaled in non-uniform fashion, and not everywhere do we account for that.) Although it works Ok on meshes. <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#ScaleOrientation\">ScaleOrientation</a> matters in case of non-uniform scale. </p></li>   <li value=\"2\"><p>All scale components should &gt; 0 if you want 3D lighting to work corrrectly. That is, avoid negative scale, that flips the orientation of faces (CCW becomes CW), or standard lighting may not work Ok.  <p>For unlit stuff, or custom lighting, negative scale may be Ok. For many 2D games that use no lighting/custom lighting, negative scale is Ok.</p></li>   <li value=\"3\"><p>At least, keep all scale components non-zero. Otherwise the scaling operation is not invertible, and generally collisions will not work correctly.  <p>If you really need to set zero scale, at least consider using <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a> = <code>False</code>.</p></li> </ol>  <p> ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Scale"},
     {"title": "CastleTransform.TCastleTransform.ScaleOrientation", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#ScaleOrientation"},
     {"title": "CastleTransform.TCastleTransform.RigidBody", "text": " This makes this object collidable with other rigid bodies (if <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a>) and it allows to move and rotate because of gravity or because of collisions with other objects (if <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Dynamic\">TRigidBody.Dynamic</a> is <code>True</code>).  <p>Setting this property makes this 3D object a single rigid body for the physics engine.  <p>If this property is assigned and the <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Dynamic\">TRigidBody.Dynamic</a> is <code>True</code> (and <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Dynamic\">TRigidBody.Dynamic</a> is <code>True</code> by default) then this object is moved and rotated using the physics engine. It will move because of gravity (if <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Gravity\">TRigidBody.Gravity</a>, also <code>True</code> by default), and because of collisions with other objects.  <p>The <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">TRigidBody.Collider</a> property must be initialized <i>before</i> assigning the <a class=\"normal\" href=\"CastleTransform.TRigidBody.html\">TRigidBody</a> instance here. So you must create a <a class=\"normal\" href=\"CastleTransform.TCollider.html\">TCollider</a> descendant, specyfying the given <a class=\"normal\" href=\"CastleTransform.TRigidBody.html\">TRigidBody</a> as a parent. A rigid body without a collider would in theory not collide with anything, and (if <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Dynamic\">TRigidBody.Dynamic</a>) would simply fall down because of gravity. In practice, a rigid body without a collider is simply not allowed. If you really need this, assign anything to <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">TRigidBody.Collider</a> and just set <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">Collides</a> to <code>False</code>.  <p><b>Our engine (for now) also has an internal, simple physics simulation, used to perform collisions with player, creatures, and optional (unrealistic) gravity.</b> So we have two independent physics systems, but they try to not get into each others way (they each perform a different task). In the future there will be an option to use the full-featured physics engine for all simulations, also for player and creatures, at which point our &quot;internal physics simulation&quot; will become deprecated. For now, be aware of these:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Collides\">TCastleTransform.Collides</a> property affects <i>both our &quot;simple physics simulation&quot; and the &quot;full-featured physics engine&quot;</i>. It determines whether the object is collidable. </p></li>   <li><p><a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Gravity\">TCastleTransform.Gravity</a> property <i>only affects the &quot;simple physics simulation&quot;</i>. It is by default <code>False</code>.  <p>It has no effect on the &quot;full-featured physics engine&quot; behaviour, that has an independent property <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Gravity\">TRigidBody.Gravity</a>, which is <code>True</code> by default.  <p>You should not set both <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Gravity\">TCastleTransform.Gravity</a> to <code>True</code> and <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Gravity\">TRigidBody.Gravity</a> to <code>True</code>, it would mean that <i>gravity simulation is performed twice</i>. In the future, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Gravity\">TCastleTransform.Gravity</a> may be removed (or merged with <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Gravity\">TRigidBody.Gravity</a>, but then old games may by surprised by a new default <code>True</code>.) </p></li>   <li><p>The collider used by our internal, simple physics is independent from the <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">TRigidBody.Collider</a>. The internal, simple physics uses colliders implicitly implemented in the overridden <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#HeightCollision\">TCastleTransform.HeightCollision</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MoveCollision\">TCastleTransform.MoveCollision</a> and friends. In case of <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, the rule is simple:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>If the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">TCastleSceneCore.Spatial</a> contains <a class=\"normal\" href=\"CastleScene.html#ssDynamicCollisions\">ssDynamicCollisions</a> or <a class=\"normal\" href=\"CastleScene.html#ssStaticCollisions\">ssStaticCollisions</a>, then the object collides as a mesh. This makes precise collisions with all the triangles. Any mesh, convex or concave, is correctly solved.</p></li>   <li><p>Otherwise, the object collides as it's axis-aligned bounding box.</p></li> </ul>  <p> </p></li> </ul>  <p>  <p>Note that an object can only be present once in the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#World\">World</a> to be a rigid body. Breaking this rule will cause the <a class=\"normal\" href=\"CastleTransform.EMultipleReferencesInWorld.html\">EMultipleReferencesInWorld</a> exception at an undefined time. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#RigidBody"},
     {"title": "CastleTransform.TCastleTransform.Position", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Position"},
     {"title": "CastleTransform.TCastleTransform.Direction", "text": " These properties provide an alternative way to get and set the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Rotation\">Rotation</a> of the transformation. Thinking in terms of &quot;direction&quot; and &quot;up&quot; is often more natural when transforming creatures and player.  <p>The <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Orientation\">Orientation</a> determines what is your default direction and up (when the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Rotation\">Rotation</a> is zero). By default we follow X3D standard vectors suitable for gravity along the Y axis. So direction is -Z (<a class=\"normal\" href=\"CastleCameras.html#DefaultCameraDirection\">DefaultCameraDirection</a>), up is +Y (<a class=\"normal\" href=\"CastleCameras.html#DefaultCameraUp\">DefaultCameraUp</a>).  <p>The <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Direction\">Direction</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Up\">Up</a> vectors should always be normalized (have length 1). When setting them by these properties, we will normalize them automatically.  <p>They must also always be orthogonal. When setting <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Direction\">Direction</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Up\">Up</a> will always be automatically adjusted to be orthogonal to <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Direction\">Direction</a>. And vice versa &mdash; when setting <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Up\">Up</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Direction\">Direction</a> will be adjusted.  <p> ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Direction"},
     {"title": "CastleTransform.TCastleTransform.Up", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Up"},
     {"title": "CastleTransform.TCastleTransform.Orientation", "text": " See <a class=\"normal\" href=\"CastleTransform.html#TOrientationType\">TOrientationType</a> for values documentation.  <p>The default value of this is determined by static variable <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#DefaultOrientation\">DefaultOrientation</a>, this is usually comfortable (because almost always you use the same Orientation throughout your game). By default it's <a class=\"normal\" href=\"CastleTransform.html#otUpYDirectionMinusZ\">otUpYDirectionMinusZ</a> (matching default cameras of OpenGL and VRML/X3D).  <p>This value determines how you should model your 3D models, like the creatures, the items, and the player weapons. Generally, it applies to every 3D model that is used as a child of this <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> instance. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#Orientation"},
     {"title": "CastleTransform.TCastleTransform.List", "text": " Freeing these items automatically removes them from this list. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#List"},
     {"title": "CastleTransform.TCastleTransform.ExcludeFromGlobalLights", "text": "  <p>Note that this is not applied recursively. Instead, it is checked at each <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> instance that checks <a class=\"normal\" href=\"CastleTransform.TRenderParams.html#BaseLights\">TRenderParams.BaseLights</a>. In practice, it is only checked at <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>, unless you do custom rendering on your own. ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#ExcludeFromGlobalLights"},
     {"title": "CastleTransform.TCastleTransform.ExcludeFromStatistics", "text": " ", "tags": "", "loc": "CastleTransform.TCastleTransform.html#ExcludeFromStatistics"},
     {"title": "CastleTransform.TSceneManagerWorld", "text": " List of 3D objects, with some central properties. ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html"},
     {"title": "CastleTransform.TSceneManagerWorld.OnCursorChange", "text": " ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#OnCursorChange"},
     {"title": "CastleTransform.TSceneManagerWorld.OnVisibleChange", "text": " ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#OnVisibleChange"},
     {"title": "CastleTransform.TSceneManagerWorld.Create", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#Create"},
     {"title": "CastleTransform.TSceneManagerWorld.Destroy", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#Destroy"},
     {"title": "CastleTransform.TSceneManagerWorld.CollisionIgnoreItem", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#CollisionIgnoreItem"},
     {"title": "CastleTransform.TSceneManagerWorld.GravityUp", "text": " Gravity force pulls in -<code>GravityUp</code> direction.    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#GravityUp"},
     {"title": "CastleTransform.TSceneManagerWorld.GravityCoordinate", "text": " This is derived from <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#GravityUp\">GravityUp</a> value. It can only truly express <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#GravityUp\">GravityUp</a> vector values (1,0,0) or (0,1,0) or (0,0,1), although in practice this is enough for normal games (normal 3D scenes use up either +Y or +Z).  <p>We try to avoid using it in the engine, and use full <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#GravityUp\">GravityUp</a> vector wherever possible. Full <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#GravityUp\">GravityUp</a> vector may allow for more fun with weird gravity in future games.    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#GravityCoordinate"},
     {"title": "CastleTransform.TSceneManagerWorld.Player", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#Player"},
     {"title": "CastleTransform.TSceneManagerWorld.PrepareParams", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#PrepareParams"},
     {"title": "CastleTransform.TSceneManagerWorld.Sectors", "text": " See <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Sectors\">TCastleSceneManager.Sectors</a>.    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#Sectors"},
     {"title": "CastleTransform.TSceneManagerWorld.Water", "text": " See <a class=\"normal\" href=\"CastleSceneManager.TCastleSceneManager.html#Water\">TCastleSceneManager.Water</a>.    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#Water"},
     {"title": "CastleTransform.TSceneManagerWorld.WorldMoveAllowed", "text": " They call corresponding methods without the World prefix, automatically taking into account some knowledge about this 3D world.  <p>Calling these methods to check collisions makes sense if your collision query is not initiated by any existing <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> instance.  <p>If your query originates from some existing <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> instance, you usually do not want to call these WorldXxx methods. Instead call <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#MoveAllowed\">TCastleTransform.MoveAllowed</a>, <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Height\">TCastleTransform.Height</a> methods. Underneath, they still call <code>World.WorldMoveAllowed</code> and <code>World.WorldHeight</code>, additionally making sure that the 3D object does not collide with itself.     ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#WorldMoveAllowed"},
     {"title": "CastleTransform.TSceneManagerWorld.WorldMoveAllowed", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#WorldMoveAllowed"},
     {"title": "CastleTransform.TSceneManagerWorld.WorldHeight", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#WorldHeight"},
     {"title": "CastleTransform.TSceneManagerWorld.WorldLineOfSight", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#WorldLineOfSight"},
     {"title": "CastleTransform.TSceneManagerWorld.WorldRay", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#WorldRay"},
     {"title": "CastleTransform.TSceneManagerWorld.WorldBoxCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#WorldBoxCollision"},
     {"title": "CastleTransform.TSceneManagerWorld.WorldSphereCollision", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#WorldSphereCollision"},
     {"title": "CastleTransform.TSceneManagerWorld.WorldSphereCollision2D", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#WorldSphereCollision2D"},
     {"title": "CastleTransform.TSceneManagerWorld.WorldPointCollision2D", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#WorldPointCollision2D"},
     {"title": "CastleTransform.TSceneManagerWorld.Update", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#Update"},
     {"title": "CastleTransform.TSceneManagerWorld.CameraChanged", "text": "    ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#CameraChanged"},
     {"title": "CastleTransform.TSceneManagerWorld.CameraPosition", "text": "  <p>Note that some features of <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> (like LOD or Billboard or ProximitySensor) will need to transform this camera to scene local space. They use <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#WorldTransform\">WorldTransform</a>, and will raise <a class=\"normal\" href=\"CastleTransform.ETransformParentUndefined.html\">ETransformParentUndefined</a> when it is not possible (e.g. when the same scene instance is reused under many different locations).  <p>So, to be on the safe side, do not turn on <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">TCastleSceneCore.ProcessEvents</a>, or do not share the scene in multiple places in the scene manager. Or at least don't use features like LOD or Billboard or ProximitySensor, that cannot work in case the same scene instance in rendered in multiple locations on the world.  <p><a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#CameraKnown\">CameraKnown</a> = <code>False</code> means that <a class=\"normal\" href=\"CastleTransform.TSceneManagerWorld.html#CameraChanged\">CameraChanged</a> was never called, and so camera settings are not known, and so other Camera* properties have undefined values.  <p> ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#CameraPosition"},
     {"title": "CastleTransform.TSceneManagerWorld.CameraDirection", "text": " ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#CameraDirection"},
     {"title": "CastleTransform.TSceneManagerWorld.CameraUp", "text": " ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#CameraUp"},
     {"title": "CastleTransform.TSceneManagerWorld.CameraKnown", "text": " ", "tags": "", "loc": "CastleTransform.TSceneManagerWorld.html#CameraKnown"},
     {"title": "CastleTransform.TCollider", "text": " ", "tags": "", "loc": "CastleTransform.TCollider.html"},
     {"title": "CastleTransform.TCollider.DefaultDensity", "text": " ", "tags": "", "loc": "CastleTransform.TCollider.html#DefaultDensity"},
     {"title": "CastleTransform.TCollider.DefaultMass", "text": " ", "tags": "", "loc": "CastleTransform.TCollider.html#DefaultMass"},
     {"title": "CastleTransform.TCollider.DefaultRestitution", "text": " ", "tags": "", "loc": "CastleTransform.TCollider.html#DefaultRestitution"},
     {"title": "CastleTransform.TCollider.DefaultFriction", "text": " ", "tags": "", "loc": "CastleTransform.TCollider.html#DefaultFriction"},
     {"title": "CastleTransform.TCollider.Create", "text": " The collider instance is <b>owned</b> by the <a class=\"normal\" href=\"CastleTransform.TRigidBody.html\">TRigidBody</a> instance, so will be freed when the <a class=\"normal\" href=\"CastleTransform.TRigidBody.html\">TRigidBody</a> is freed. This automatically sets the <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">TRigidBody.Collider</a> property and <a class=\"normal\" href=\"CastleTransform.TCollider.html#Parent\">TCollider.Parent</a> property.    ", "tags": "", "loc": "CastleTransform.TCollider.html#Create"},
     {"title": "CastleTransform.TCollider.Destroy", "text": "    ", "tags": "", "loc": "CastleTransform.TCollider.html#Destroy"},
     {"title": "CastleTransform.TCollider.Parent", "text": " ", "tags": "", "loc": "CastleTransform.TCollider.html#Parent"},
     {"title": "CastleTransform.TCollider.Density", "text": " If you instead prefer to explicitly set <a class=\"normal\" href=\"CastleTransform.TCollider.html#Mass\">mass</a>, set <a class=\"normal\" href=\"CastleTransform.TCollider.html#Mass\">Mass</a> property to something non-zero. ", "tags": "", "loc": "CastleTransform.TCollider.html#Density"},
     {"title": "CastleTransform.TCollider.Mass", "text": " When non-zero, this overrides the automatically calculated <code>mass</code> from the volume and <a class=\"normal\" href=\"CastleTransform.TCollider.html#Density\">Density</a>. ", "tags": "", "loc": "CastleTransform.TCollider.html#Mass"},
     {"title": "CastleTransform.TCollider.Restitution", "text": " ", "tags": "", "loc": "CastleTransform.TCollider.html#Restitution"},
     {"title": "CastleTransform.TCollider.Friction", "text": " ", "tags": "", "loc": "CastleTransform.TCollider.html#Friction"},
     {"title": "CastleTransform.TPlaneCollider", "text": " Place this inside <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">TRigidBody.Collider</a> property. ", "tags": "", "loc": "CastleTransform.TPlaneCollider.html"},
     {"title": "CastleTransform.TPlaneCollider.Normal", "text": " ", "tags": "", "loc": "CastleTransform.TPlaneCollider.html#Normal"},
     {"title": "CastleTransform.TPlaneCollider.Distance", "text": " ", "tags": "", "loc": "CastleTransform.TPlaneCollider.html#Distance"},
     {"title": "CastleTransform.TBoxCollider", "text": " Place this inside <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">TRigidBody.Collider</a> property. ", "tags": "", "loc": "CastleTransform.TBoxCollider.html"},
     {"title": "CastleTransform.TBoxCollider.Size", "text": " ", "tags": "", "loc": "CastleTransform.TBoxCollider.html#Size"},
     {"title": "CastleTransform.TSphereCollider", "text": " Place this inside <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">TRigidBody.Collider</a> property. ", "tags": "", "loc": "CastleTransform.TSphereCollider.html"},
     {"title": "CastleTransform.TSphereCollider.Radius", "text": " ", "tags": "", "loc": "CastleTransform.TSphereCollider.html#Radius"},
     {"title": "CastleTransform.TRigidBody", "text": "  <p>TODO: For now all the properties of this class, including the <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">Collider</a> and all properties of <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Collider\">Collider</a>, must be assigned before setting <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#RigidBody\">TCastleTransform.RigidBody</a> . ", "tags": "", "loc": "CastleTransform.TRigidBody.html"},
     {"title": "CastleTransform.TRigidBody.Create", "text": "    ", "tags": "", "loc": "CastleTransform.TRigidBody.html#Create"},
     {"title": "CastleTransform.TRigidBody.Destroy", "text": "    ", "tags": "", "loc": "CastleTransform.TRigidBody.html#Destroy"},
     {"title": "CastleTransform.TRigidBody.Setup2D", "text": " Locks moving along the Z axis, locks rotating along the X and Y axes.    ", "tags": "", "loc": "CastleTransform.TRigidBody.html#Setup2D"},
     {"title": "CastleTransform.TRigidBody.InitializeTransform", "text": "    ", "tags": "", "loc": "CastleTransform.TRigidBody.html#InitializeTransform"},
     {"title": "CastleTransform.TRigidBody.DeinitializeTransform", "text": "    ", "tags": "", "loc": "CastleTransform.TRigidBody.html#DeinitializeTransform"},
     {"title": "CastleTransform.TRigidBody.Update", "text": "    ", "tags": "", "loc": "CastleTransform.TRigidBody.html#Update"},
     {"title": "CastleTransform.TRigidBody.InitialAngularVelocity", "text": " ", "tags": "", "loc": "CastleTransform.TRigidBody.html#InitialAngularVelocity"},
     {"title": "CastleTransform.TRigidBody.InitialLinearVelocity", "text": " ", "tags": "", "loc": "CastleTransform.TRigidBody.html#InitialLinearVelocity"},
     {"title": "CastleTransform.TRigidBody.Dynamic", "text": "  <p></p>  <dl class=\"paragraph_spacing\">   <dt>true (<code>dynamic</code> object, the default)</dt>   <dd><p> In this case you cannot change the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Translation\">TCastleTransform.Translation</a> and other transformation properties of the related <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> after assigning <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#RigidBody\">TCastleTransform.RigidBody</a>. They are under the control of the physics engine. You can still reliably read them.  <p>Also, the value <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Animated\">Animated</a> is ignored in this case. </p></dd>   <dt>false</dt>   <dd><p> In this case object is not transformed by the physics simulation. It still collides with other physical objects.  <p>You can change the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Translation\">TCastleTransform.Translation</a> and other transformation properties by your own code. But if you plan to change them <i>very often</i> (e.g. every frame), then set the <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Animated\">Animated</a> property to <code>True</code>. </p></dd> </dl>  <p> ", "tags": "", "loc": "CastleTransform.TRigidBody.html#Dynamic"},
     {"title": "CastleTransform.TRigidBody.Animated", "text": "  <p>This property is taken into account only if <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Dynamic\">Dynamic</a> = <code>False</code>. When <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Dynamic\">Dynamic</a> = <code>False</code>, you can change the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Translation\">TCastleTransform.Translation</a> and other transformation properties of the related <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a>. This property is an optimization hint to the physics engine, it says <i>how often</i> you will change the transformation.  <p></p>  <dl class=\"paragraph_spacing\">   <dt>true (<code>animated</code> object, also known as &quot;kinematic&quot;)</dt>   <dd><p> The physics engine is prepared that this object can move often, e.g. every frame, so you can animate the related <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> using any technique. </p></dd>   <dt>false (static object)</dt>   <dd><p> Changing the transformation properties is costly, it may even be like destroying this object and creating a new one from the point of view of the physics engine, <i>so do not change them often, e.g. every frame</i>.  <p>The upside is that collisions with static objects may be much more optimized, since the physics engine can assume that all the static objects form a completely frozen unmovable geometry in the world. </p></dd> </dl>  <p> ", "tags": "", "loc": "CastleTransform.TRigidBody.html#Animated"},
     {"title": "CastleTransform.TRigidBody.Collider", "text": " You cannot assign this property directly, it is automatically assigned when you create a <a class=\"normal\" href=\"CastleTransform.TCollider.html\">TCollider</a> specifying this <a class=\"normal\" href=\"CastleTransform.TRigidBody.html\">TRigidBody</a> as it's parent. ", "tags": "", "loc": "CastleTransform.TRigidBody.html#Collider"},
     {"title": "CastleTransform.TRigidBody.Gravity", "text": " ", "tags": "", "loc": "CastleTransform.TRigidBody.html#Gravity"},
     {"title": "CastleTransform.TRigidBody.LockTranslation", "text": "  <p>For 2D games, you will usually want to disable motion along the Z axis. Instead of directly changing this property, you can achieve this by calling <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Setup2D\">Setup2D</a>. ", "tags": "", "loc": "CastleTransform.TRigidBody.html#LockTranslation"},
     {"title": "CastleTransform.TRigidBody.LockRotation", "text": "  <p>For 2D games, you will usually want to disable rotation along the X and Y axes. Instead of directly changing this property, you can achieve this by calling <a class=\"normal\" href=\"CastleTransform.TRigidBody.html#Setup2D\">Setup2D</a>. ", "tags": "", "loc": "CastleTransform.TRigidBody.html#LockRotation"},
     {"title": "CastleTransform.TransformMatricesMult", "text": " Calculates at the same time transformation matrix, and it's inverse, and multiplies given Transform, InverseTransform appropriately. The precise meaning of Center, Translation and such parameters follows exactly the X3D Transform node definition (see <a  href=\"http://www.web3d.org/files/specifications/19775-1/V3.2/Part01/components/group.html#Transform\">http://www.web3d.org/files/specifications/19775-1/V3.2/Part01/components/group.html#Transform</a> ).  <p>  Rotation Rotation is expressed as a 4D vector, in which the first 3 components specify the rotation axis (does not need to be normalized, but must be non-zero), and the last component is the rotation angle <i>in radians</i>.  Rotation Rotation is expressed as a 4D vector, in which the first 3 components specify the rotation axis (does not need to be normalized, but must be non-zero), and the last component is the rotation angle <i>in radians</i>.", "tags": "", "loc": "CastleTransform.html#TransformMatricesMult"},
     {"title": "CastleTransform.TCastleTransformClass", "text": " ", "tags": "", "loc": "CastleTransform.html#TCastleTransformClass"},
     {"title": "CastleTransform.TRenderFromViewFunction", "text": "    ", "tags": "", "loc": "CastleTransform.html#TRenderFromViewFunction"},
     {"title": "CastleTransform.TVisibleChange", "text": "  vcVisibleGeometry Visible geometry (actual 3D shape) changed.  It's not used when only light conditions, materials, textures and such changed.  <p>In practice, this means that the depth buffer from some point in space changed. Which means that shadow maps should be regenerated.  vcVisibleNonGeometry Something visible, but not the geometry shape, changes.  For example, material or texture on a visible surface changed. ", "tags": "", "loc": "CastleTransform.html#TVisibleChange"},
     {"title": "CastleTransform.TVisibleChanges", "text": " ", "tags": "", "loc": "CastleTransform.html#TVisibleChanges"},
     {"title": "CastleTransform.TVisibleChangeEvent", "text": "    ", "tags": "", "loc": "CastleTransform.html#TVisibleChangeEvent"},
     {"title": "CastleTransform.TPrepareResourcesOption", "text": "  prRender    prBackground    prBoundingBox    prShadowVolume    prSpatial Prepare octrees (determined by things like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Spatial\">TCastleSceneCore.Spatial</a>).   prScreenEffects   ", "tags": "", "loc": "CastleTransform.html#TPrepareResourcesOption"},
     {"title": "CastleTransform.TPrepareResourcesOptions", "text": " ", "tags": "", "loc": "CastleTransform.html#TPrepareResourcesOptions"},
     {"title": "CastleTransform.PRayCollisionNode", "text": " ", "tags": "", "loc": "CastleTransform.html#PRayCollisionNode"},
     {"title": "CastleTransform.PCollisionDetailsItem", "text": " ", "tags": "", "loc": "CastleTransform.html#PCollisionDetailsItem"},
     {"title": "CastleTransform.TRenderingPass", "text": " ", "tags": "", "loc": "CastleTransform.html#TRenderingPass"},
     {"title": "CastleTransform.TRemoveType", "text": "  rtNone    rtRemove    rtRemoveAndFree   ", "tags": "", "loc": "CastleTransform.html#TRemoveType"},
     {"title": "CastleTransform.TOrientationType", "text": " Used by the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Orientation\">TCastleTransform.Orientation</a> and <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#DefaultOrientation\">TCastleTransform.DefaultOrientation</a>.  otUpYDirectionMinusZ Orientation sensible for models oriented around Y axis.  That is when gravity pulls in -Y and GravityUp vector is +Y. Transformation makes -Z and +Y match (respectively) Direction and Up.  <p>This matches default direction/up of OpenGL and VRML/X3D cameras.  <p>For example, using this value for <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Orientation\">TCastleTransform.Orientation</a> (or even <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#DefaultOrientation\">TCastleTransform.DefaultOrientation</a>) is sensible if you use default Blender X3D exporter, and you let the exporter to make a transformation (to make +Z up into +Y up). This is the default setting. Then you can follow the standard Blender view names (&quot;front&quot;, &quot;top&quot; and such) when modelling, and Blender tools like &quot;X-axis mirror&quot; will work best.  otUpZDirectionMinusY Orientation sensible for models oriented around Z axis.  Transformation makes -Y and +Z match (respectively) Direction and Up.  <p>Using this value for <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Orientation\">TCastleTransform.Orientation</a> (or even <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#DefaultOrientation\">TCastleTransform.DefaultOrientation</a>) is sensible if you export your models from Blender <i>without transforming them during export</i>. Note that <i>this is not the default Blender X3D exporter behavior</i>. But you can configure the exporter to work like this (not transform), and then you can follow the standard Blender view names (&quot;front&quot;, &quot;top&quot; and such) when modelling.  otUpZDirectionX  Up in +Z (like <a class=\"normal\" href=\"CastleTransform.html#otUpZDirectionMinusY\">otUpZDirectionMinusY</a>) and direction in +X.  Should not be used in new models. ", "tags": "", "loc": "CastleTransform.html#TOrientationType"},
     {"title": "CastleTransform.T3DCoord", "text": " ", "tags": "", "loc": "CastleTransform.html#T3DCoord"},
     {"title": "CastleTransform.T3DCoords", "text": " ", "tags": "", "loc": "CastleTransform.html#T3DCoords"},
     {"title": "CastleTriangles", "text": " In 2D, 3D and 4D space. ", "tags": "", "loc": "CastleTriangles.html"},
     {"title": "CastleTriangles.TTriangle2", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle2.html"},
     {"title": "CastleTriangles.TTriangle2.Data", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle2.html#Data"},
     {"title": "CastleTriangles.TTriangle2.ToString", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle2.html#ToString"},
     {"title": "CastleTriangles.TTriangle3", "text": "  <p>Triangle's three points must not be collinear, i.e. routines in this unit generally don't accept &quot;degenerated&quot; triangles that are not really triangles. So 3D triangle must unambiguously define some plane in the 3D space. The only function in this unit that is able to handle &quot;degenerated&quot; triangles is <a class=\"normal\" href=\"CastleTriangles.TTriangle3.html#IsValid\">TTriangle3.IsValid</a>, which is exactly used to check whether the triangle is degenerated. ", "tags": "", "loc": "CastleTriangles.TTriangle3.html"},
     {"title": "CastleTriangles.TTriangle3.Data", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#Data"},
     {"title": "CastleTriangles.TTriangle3.ToString", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#ToString"},
     {"title": "CastleTriangles.TTriangle3.IsValid", "text": " That is, check does the triangle not degenerate to a point or line segment (which can happen when some points are at the same position, or are colinear).    ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#IsValid"},
     {"title": "CastleTriangles.TTriangle3.Direction", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#Direction"},
     {"title": "CastleTriangles.TTriangle3.Normal", "text": " Returns vector pointing our from CCW triangle side (for right-handed coordinate system), and orthogonal to triangle plane. For degenerated triangles (when <a class=\"normal\" href=\"CastleTriangles.TTriangle3.html#IsValid\">IsValid</a> would return <code>False</code>), we return zero vector.    ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#Normal"},
     {"title": "CastleTriangles.TTriangle3.Plane", "text": " Note that this has many possible solutions (plane representation as equation <code>Ax + By + Cz + D = 0</code> is not unambiguous), this just returns some solution deterministically.  <p>It's guaranteed that the direction of this plane (i.e. first 3 items of returned vector) will be in the same direction as calcualted by <a class=\"normal\" href=\"CastleTriangles.TTriangle3.html#Direction\">Direction</a>, which means that it points outward from CCW side of the triangle (assuming right-handed coord system).  <p>For <a class=\"normal\" href=\"CastleTriangles.TTriangle3.html#NormalizedPlane\">NormalizedPlane</a>, this direction is also normalized (makes a vector with length 1). This way <a class=\"normal\" href=\"CastleTriangles.TTriangle3.html#NormalizedPlane\">NormalizedPlane</a> calculates also <a class=\"normal\" href=\"CastleTriangles.TTriangle3.html#Normal\">Normal</a>.  <p>For three points that do not define a plane, a plane with first three components = 0 is returned. In fact, the 4th component will be zero too in this case (for now), but don't depend on it.     ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#Plane"},
     {"title": "CastleTriangles.TTriangle3.NormalizedPlane", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#NormalizedPlane"},
     {"title": "CastleTriangles.TTriangle3.Transform", "text": " This simply transforms each triangle point.  <p>    ETransformedResultInvalid Raised when matrix will transform some point to a direction (vector with 4th component equal zero). In this case we just cannot interpret the result as a 3D point.", "tags": "", "loc": "CastleTriangles.TTriangle3.html#Transform"},
     {"title": "CastleTriangles.TTriangle3.Area", "text": " This works for degenerated (equal to line segment or even single point) triangles too: returns 0 for them.  <p>    ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#Area"},
     {"title": "CastleTriangles.TTriangle3.AreaSqr", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#AreaSqr"},
     {"title": "CastleTriangles.TTriangle3.RandomPoint", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#RandomPoint"},
     {"title": "CastleTriangles.TTriangle3.Barycentric", "text": "  <p>The resulting Barycentric coordinates can be used for linearly interpolating values along the triangle, as they satisfy the equation:  <p></p>  <pre class=\"preformatted\"> Result.Data[0] * Triangle.Data[0] + Result.Data[1] * Triangle.Data[1] + Result.Data[2] * Triangle.Data[2] = Point</pre>  <p>  <p>See also [<a  href=\"http://en.wikipedia.org/wiki/Barycentric_coordinate_system_%28mathematics%29\">http://en.wikipedia.org/wiki/Barycentric_coordinate_system_%28mathematics%29</a>]    ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#Barycentric"},
     {"title": "CastleTriangles.TTriangle3.Items", "text": " This is the same as accessing <a class=\"normal\" href=\"CastleTriangles.TTriangle3.html#Data\">Data</a> field, it is also the default record property so you can just write <code>MyTriangle[0]</code> instead of <code>MyTriangle.Items[0]</code> or <code>MyTriangle.Data[0]</code>. ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#Items"},
     {"title": "CastleTriangles.TTriangle3.TIndex", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle3.html#TIndex"},
     {"title": "CastleTriangles.TTriangle4", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle4.html"},
     {"title": "CastleTriangles.TTriangle4.Data", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle4.html#Data"},
     {"title": "CastleTriangles.TTriangle4.ToString", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle4.html#ToString"},
     {"title": "CastleTriangles.TTriangleGeometry", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangleGeometry.html"},
     {"title": "CastleTriangles.TTriangleGeometry.Triangle", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangleGeometry.html#Triangle"},
     {"title": "CastleTriangles.TTriangleGeometry.Area", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangleGeometry.html#Area"},
     {"title": "CastleTriangles.TTriangleGeometry.Plane", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangleGeometry.html#Plane"},
     {"title": "CastleTriangles.TTriangleGeometry.Normal", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangleGeometry.html#Normal"},
     {"title": "CastleTriangles.TFaceIndex", "text": "  <p>When a triangle is part of a face defined by the coordIndex field (like in IndexedFaceSet) then this describes where in this coordIndex this face is located. This is useful for editing / removing a face corresponding to a given triangle.  <p>Otherwise, both <a class=\"normal\" href=\"CastleTriangles.TFaceIndex.html#IndexBegin\">IndexBegin</a> and <a class=\"normal\" href=\"CastleTriangles.TFaceIndex.html#IndexEnd\">IndexEnd</a> are -1. ", "tags": "", "loc": "CastleTriangles.TFaceIndex.html"},
     {"title": "CastleTriangles.TFaceIndex.IndexBegin", "text": " ", "tags": "", "loc": "CastleTriangles.TFaceIndex.html#IndexBegin"},
     {"title": "CastleTriangles.TFaceIndex.IndexEnd", "text": " ", "tags": "", "loc": "CastleTriangles.TFaceIndex.html#IndexEnd"},
     {"title": "CastleTriangles.TTriangle", "text": " This object should always be initialized by <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#Init\">Init</a>, and updated only by it's methods (never modify fields of this object directly). ", "tags": "", "loc": "CastleTriangles.TTriangle.html"},
     {"title": "CastleTriangles.TTriangle.Local", "text": " We need two geometry descriptions:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Local is based on initial Triangle, given when constructing this <a class=\"normal\" href=\"CastleTriangles.TTriangle.html\">TTriangle</a>. It's constant for this <a class=\"normal\" href=\"CastleTriangles.TTriangle.html\">TTriangle</a>. It's used by octree collision routines, that is things like <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SphereCollision\">TBaseTrianglesOctree.SphereCollision</a>, <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">TBaseTrianglesOctree.RayCollision</a> and such expect parameters in the same coord space.  <p>This may be local coord space of this shape (this is used by TShape.OctreeTriangles) or world coord space (this is used by TCastleSceneCore.OctreeTriangles).</p></li>   <li><p>World is the geometry of Local transformed to be in world coordinates. Initially, World is just a copy of Local.  <p>If Local already contains world-space geometry, then World can just remain constant, and so is always Local copy.  <p>If Local contains local shape-space geometry, then World will have to be updated by TTriangle.UpdateWorld whenever some octree item's geometry will be needed in world coords. This will have to be done e.g. by TBaseTrianglesOctree.XxxCollision for each returned item.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleTriangles.TTriangle.html#Local"},
     {"title": "CastleTriangles.TTriangle.World", "text": " We need two geometry descriptions:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Local is based on initial Triangle, given when constructing this <a class=\"normal\" href=\"CastleTriangles.TTriangle.html\">TTriangle</a>. It's constant for this <a class=\"normal\" href=\"CastleTriangles.TTriangle.html\">TTriangle</a>. It's used by octree collision routines, that is things like <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SphereCollision\">TBaseTrianglesOctree.SphereCollision</a>, <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">TBaseTrianglesOctree.RayCollision</a> and such expect parameters in the same coord space.  <p>This may be local coord space of this shape (this is used by TShape.OctreeTriangles) or world coord space (this is used by TCastleSceneCore.OctreeTriangles).</p></li>   <li><p>World is the geometry of Local transformed to be in world coordinates. Initially, World is just a copy of Local.  <p>If Local already contains world-space geometry, then World can just remain constant, and so is always Local copy.  <p>If Local contains local shape-space geometry, then World will have to be updated by TTriangle.UpdateWorld whenever some octree item's geometry will be needed in world coords. This will have to be done e.g. by TBaseTrianglesOctree.XxxCollision for each returned item.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleTriangles.TTriangle.html#World"},
     {"title": "CastleTriangles.TTriangle.InternalShape", "text": " This is always an instance of <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> class, but due to unit dependencies it cannot be declared as such here. Use <a class=\"normal\" href=\"X3DTriangles.html\">X3DTriangles</a> unit to have a &quot;record helper&quot; method that returns a Shape as <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> instance. ", "tags": "", "loc": "CastleTriangles.TTriangle.html#InternalShape"},
     {"title": "CastleTriangles.TTriangle.MailboxSavedTag", "text": " Intersection result is in <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#MailboxIsIntersection\">MailboxIsIntersection</a>, <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#MailboxIntersection\">MailboxIntersection</a>, <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#MailboxIntersectionDistance\">MailboxIntersectionDistance</a>.  <p>To make things correct, we obviously assume that every segment and ray have different tags. Also, tag -1 is reserved. In practice, we simply initialize <code>MailboxSavedTag</code> to -1, and each new segment/ray get consecutive tags starting from 0.  <p><i>History</i>: a naive implementation at the beginning was not using tags, instead I had MailboxState (empty, ray or segment) and I was storing ray/line vectors (2 <a class=\"normal\" href=\"CastleVectors.html#TVector3\">TVector3</a> values). This had much larger size (6 * SizeOf(Single) + SizeOf(enum) = 28 bytes) than tag, which is important (3D models have easily thousands of <a class=\"normal\" href=\"CastleTriangles.TTriangle.html\">TTriangle</a>). And it took longer to compare and assign, so it was working much slower.  <p> ", "tags": "", "loc": "CastleTriangles.TTriangle.html#MailboxSavedTag"},
     {"title": "CastleTriangles.TTriangle.MailboxIsIntersection", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle.html#MailboxIsIntersection"},
     {"title": "CastleTriangles.TTriangle.MailboxIntersection", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle.html#MailboxIntersection"},
     {"title": "CastleTriangles.TTriangle.MailboxIntersectionDistance", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle.html#MailboxIntersectionDistance"},
     {"title": "CastleTriangles.TTriangle.Normal", "text": " ", "tags": "", "loc": "CastleTriangles.TTriangle.html#Normal"},
     {"title": "CastleTriangles.TTriangle.TexCoord", "text": "  <p>Each texture coordinate is a 4D vector, since we may have 3D textures referenced by 4D (homogeneous) coordinates. For normal 2D textures, you can simply take the first 2 components of the vector, and ignore the remaining 2 components. The 3th component is always 0 if was not specified (if model had only 2D texture coords). The 4th component is always 1 if was not specified (if model had only 2D or 3D texture coords).  <p>In case of multi-texturing, this describes coordinates of the first texture unit. In case no texture is defined, this is undefined. ", "tags": "", "loc": "CastleTriangles.TTriangle.html#TexCoord"},
     {"title": "CastleTriangles.TTriangle.Face", "text": " See <a class=\"normal\" href=\"CastleTriangles.TFaceIndex.html\">TFaceIndex</a>. ", "tags": "", "loc": "CastleTriangles.TTriangle.html#Face"},
     {"title": "CastleTriangles.TTriangle.Init", "text": " Given ATriangle must satisfy ATriangle.IsValid.    ", "tags": "", "loc": "CastleTriangles.TTriangle.html#Init"},
     {"title": "CastleTriangles.TTriangle.SegmentDirCollision", "text": "  <p>Always use these routines to check for collisions, to use mailboxes if possible. Mailboxes are used only if this was compiled with TRIANGLE_OCTREE_USE_MAILBOX defined.  <p>Increments <a class=\"normal\" href=\"CastleTriangles.html#TriangleCollisionTestsCounter\">TriangleCollisionTestsCounter</a> if actual test was done (that is, if we couldn't use mailbox to get the result quickier).  <p>    ", "tags": "", "loc": "CastleTriangles.TTriangle.html#SegmentDirCollision"},
     {"title": "CastleTriangles.TTriangle.RayCollision", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle.html#RayCollision"},
     {"title": "CastleTriangles.TTriangle.ITexCoord", "text": " It is an interpolated texture coordinate from our per-vertex texture coordinates in <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#TexCoord\">TexCoord</a> field.  <p>This assumes that Position actually lies within the triangle.  <p>The <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#ITexCoord2D\">ITexCoord2D</a> returns the same, but cut to the first 2 texture coordinate components. Usable for normal 2D textures.     ", "tags": "", "loc": "CastleTriangles.TTriangle.html#ITexCoord"},
     {"title": "CastleTriangles.TTriangle.ITexCoord2D", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle.html#ITexCoord2D"},
     {"title": "CastleTriangles.TTriangle.INormal", "text": " It is an interpolated normal from our per-vertex normals in the <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#Normal\">Normal</a> field, thus is supports also the case when you have smooth shading (normals change throughout the triangle).  <p>Like the <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#Normal\">Normal</a> field, the returned vector is a normal vector in the local coordinates. Use <a class=\"normal\" href=\"CastleShapes.TTriangleHelper.html#INormalWorldSpace\">TTriangleHelper.INormalWorldSpace</a> to get a normal vector in scene coordinates.  <p>This assumes that Position actally lies within the triangle.    ", "tags": "", "loc": "CastleTriangles.TTriangle.html#INormal"},
     {"title": "CastleTriangles.TTriangle.INormalCore", "text": "    ", "tags": "", "loc": "CastleTriangles.TTriangle.html#INormalCore"},
     {"title": "CastleTriangles.UnknownFaceIndex", "text": " ", "tags": "", "loc": "CastleTriangles.html#UnknownFaceIndex"},
     {"title": "CastleTriangles.Triangle3", "text": "    ", "tags": "", "loc": "CastleTriangles.html#Triangle3"},
     {"title": "CastleTriangles.IndexedTriangleNormal", "text": " VerticesStride is the shift between vertex values in the array, VerticesStride = 0 behaves like VerticesStride = SizeOf(<a class=\"normal\" href=\"CastleVectors.html#TVector3\">TVector3</a>).    ", "tags": "", "loc": "CastleTriangles.html#IndexedTriangleNormal"},
     {"title": "CastleTriangles.IndexedConvexPolygonNormal", "text": " Polygon is defines as vertices Verts&circ;[Indices[0]], Verts&circ;[Indices[1]] ... Verts&circ;[Indices[IndicesCount-1]]. Returns normal pointing from CCW.  <p>It's secured against invalid indexes on Indices list (that's the only reason why it takes VertsCount parameter, after all): they are ignored.  <p>If the polygon is degenerated, that is it doesn't determine a plane in 3D space (this includes, but is not limited, to cases when there are less than 3 valid points, like when IndicesCount &lt; 3) then it returns ResultForIncorrectPoly.  <p>    ", "tags": "", "loc": "CastleTriangles.html#IndexedConvexPolygonNormal"},
     {"title": "CastleTriangles.IndexedConvexPolygonNormal", "text": "    ", "tags": "", "loc": "CastleTriangles.html#IndexedConvexPolygonNormal"},
     {"title": "CastleTriangles.IndexedConvexPolygonArea", "text": " Polygon is defines as vertices Verts&circ;[Indices[0]], Verts&circ;[Indices[1]] ... Verts&circ;[Indices[IndicesCount-1]].  <p>It's secured against invalid indexes on Indices list (that's the only reason why it takes VertsCount parameter, after all): they are ignored.  <p>    ", "tags": "", "loc": "CastleTriangles.html#IndexedConvexPolygonArea"},
     {"title": "CastleTriangles.IndexedConvexPolygonArea", "text": "    ", "tags": "", "loc": "CastleTriangles.html#IndexedConvexPolygonArea"},
     {"title": "CastleTriangles.IsPolygon2dCCW", "text": " When viewed with typical camera settings, that is +Y goes up and +X goes right.  <p>Polygon doesn't have to be convex. Polygon doesn't have to have all triangles valid, that is it's OK if some polygon triangles degenerate into points or line segments.  <p>Returns something &gt; 0 if polygon is CCW, or &lt; 0 when it's not. Returns zero when polygon has area 0.     ", "tags": "", "loc": "CastleTriangles.html#IsPolygon2dCCW"},
     {"title": "CastleTriangles.IsPolygon2dCCW", "text": "    ", "tags": "", "loc": "CastleTriangles.html#IsPolygon2dCCW"},
     {"title": "CastleTriangles.Polygon2dArea", "text": "  <p>Polygon doesn't have to be convex. Polygon doesn't have to have all triangles valid, that is it's OK if some polygon triangles degenerate into points or line segments.  <p>    ", "tags": "", "loc": "CastleTriangles.html#Polygon2dArea"},
     {"title": "CastleTriangles.Polygon2dArea", "text": "    ", "tags": "", "loc": "CastleTriangles.html#Polygon2dArea"},
     {"title": "CastleTriangles.IsPointOnTrianglePlaneWithinTriangle", "text": " Give first 3 components of triangle plane as TriDir.     ", "tags": "", "loc": "CastleTriangles.html#IsPointOnTrianglePlaneWithinTriangle"},
     {"title": "CastleTriangles.IsPointWithinTriangle2D", "text": "     ", "tags": "", "loc": "CastleTriangles.html#IsPointWithinTriangle2D"},
     {"title": "CastleTriangles.IsPointWithinTriangle2D", "text": "    ", "tags": "", "loc": "CastleTriangles.html#IsPointWithinTriangle2D"},
     {"title": "CastleTriangles.IsTriangleSegmentCollision", "text": " You can pass the triangle plane along with a triangle, this will speed calculation.     ", "tags": "", "loc": "CastleTriangles.html#IsTriangleSegmentCollision"},
     {"title": "CastleTriangles.IsTriangleSegmentCollision", "text": "    ", "tags": "", "loc": "CastleTriangles.html#IsTriangleSegmentCollision"},
     {"title": "CastleTriangles.IsTriangleSphereCollision", "text": "    ", "tags": "", "loc": "CastleTriangles.html#IsTriangleSphereCollision"},
     {"title": "CastleTriangles.IsTriangleSphereCollision", "text": "    ", "tags": "", "loc": "CastleTriangles.html#IsTriangleSphereCollision"},
     {"title": "CastleTriangles.IsTriangleSphereCollision2D", "text": " If you use overloaded version with <a class=\"normal\" href=\"CastleTriangles.TTriangle3.html\">TTriangle3</a>, the Z coordinate of the triangle corners is simply ignored, so everything is projected on the Z=0 plane.     ", "tags": "", "loc": "CastleTriangles.html#IsTriangleSphereCollision2D"},
     {"title": "CastleTriangles.IsTriangleSphereCollision2D", "text": "    ", "tags": "", "loc": "CastleTriangles.html#IsTriangleSphereCollision2D"},
     {"title": "CastleTriangles.TryTriangleSegmentCollision", "text": " You can pass the triangle plane along with a triangle, this will speed calculation.  <p>When there's no intersection, returns <code>False</code> and doesn't modify Intersection or T.     ", "tags": "", "loc": "CastleTriangles.html#TryTriangleSegmentCollision"},
     {"title": "CastleTriangles.TryTriangleSegmentDirCollision", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TryTriangleSegmentDirCollision"},
     {"title": "CastleTriangles.TryTriangleSegmentDirCollision", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TryTriangleSegmentDirCollision"},
     {"title": "CastleTriangles.TryTriangleRayCollision", "text": " You can pass the triangle plane along with a triangle, this will speed calculation.  <p>When there's no intersection, returns <code>False</code> and doesn't modify Intersection or T.     ", "tags": "", "loc": "CastleTriangles.html#TryTriangleRayCollision"},
     {"title": "CastleTriangles.TryTriangleRayCollision", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TryTriangleRayCollision"},
     {"title": "CastleTriangles.TriangleDirection", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TriangleDirection"},
     {"title": "CastleTriangles.TriangleDir", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TriangleDir"},
     {"title": "CastleTriangles.TriangleNormal", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TriangleNormal"},
     {"title": "CastleTriangles.TrianglePlane", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TrianglePlane"},
     {"title": "CastleTriangles.TriangleDir", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TriangleDir"},
     {"title": "CastleTriangles.TriangleNormal", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TriangleNormal"},
     {"title": "CastleTriangles.TrianglePlane", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TrianglePlane"},
     {"title": "CastleTriangles.TriangleTransform", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TriangleTransform"},
     {"title": "CastleTriangles.TriangleNormPlane", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TriangleNormPlane"},
     {"title": "CastleTriangles.TriangleArea", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TriangleArea"},
     {"title": "CastleTriangles.Barycentric", "text": "    ", "tags": "", "loc": "CastleTriangles.html#Barycentric"},
     {"title": "CastleTriangles.TriangleToNiceStr", "text": "    ", "tags": "", "loc": "CastleTriangles.html#TriangleToNiceStr"},
     {"title": "CastleTriangles.PTriangle2", "text": " ", "tags": "", "loc": "CastleTriangles.html#PTriangle2"},
     {"title": "CastleTriangles.TTriangle3List", "text": " ", "tags": "", "loc": "CastleTriangles.html#TTriangle3List"},
     {"title": "CastleTriangles.PTriangle3", "text": " ", "tags": "", "loc": "CastleTriangles.html#PTriangle3"},
     {"title": "CastleTriangles.PTriangle4", "text": " ", "tags": "", "loc": "CastleTriangles.html#PTriangle4"},
     {"title": "CastleTriangles.TTriangle2Single", "text": " ", "tags": "", "loc": "CastleTriangles.html#TTriangle2Single"},
     {"title": "CastleTriangles.TTriangle3Single", "text": " ", "tags": "", "loc": "CastleTriangles.html#TTriangle3Single"},
     {"title": "CastleTriangles.TTriangle4Single", "text": " ", "tags": "", "loc": "CastleTriangles.html#TTriangle4Single"},
     {"title": "CastleTriangles.PTriangle2Single", "text": " ", "tags": "", "loc": "CastleTriangles.html#PTriangle2Single"},
     {"title": "CastleTriangles.PTriangle3Single", "text": " ", "tags": "", "loc": "CastleTriangles.html#PTriangle3Single"},
     {"title": "CastleTriangles.PTriangle4Single", "text": " ", "tags": "", "loc": "CastleTriangles.html#PTriangle4Single"},
     {"title": "CastleTriangles.TFaceIndexesList", "text": " ", "tags": "", "loc": "CastleTriangles.html#TFaceIndexesList"},
     {"title": "CastleTriangles.TMailboxTag", "text": " ", "tags": "", "loc": "CastleTriangles.html#TMailboxTag"},
     {"title": "CastleTriangles.PTriangle", "text": " ", "tags": "", "loc": "CastleTriangles.html#PTriangle"},
     {"title": "CastleTriangles.TTriangleList", "text": " ", "tags": "", "loc": "CastleTriangles.html#TTriangleList"},
     {"title": "CastleTriangles.TTriangleIgnoreFunc", "text": " For now, Sender is always TTriangleOctree.    ", "tags": "", "loc": "CastleTriangles.html#TTriangleIgnoreFunc"},
     {"title": "CastleTriangles.T3DTriangleGeometry", "text": " ", "tags": "", "loc": "CastleTriangles.html#T3DTriangleGeometry"},
     {"title": "CastleTriangles.T3DTriangle", "text": " ", "tags": "", "loc": "CastleTriangles.html#T3DTriangle"},
     {"title": "CastleTriangles.P3DTriangle", "text": " ", "tags": "", "loc": "CastleTriangles.html#P3DTriangle"},
     {"title": "CastleTriangles.T3DTriangleIgnoreFunc", "text": " ", "tags": "", "loc": "CastleTriangles.html#T3DTriangleIgnoreFunc"},
     {"title": "CastleTriangles.TriangleCollisionTestsCounter", "text": " This counts all calls to <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#SegmentDirCollision\">TTriangle.SegmentDirCollision</a> and <a class=\"normal\" href=\"CastleTriangles.TTriangle.html#RayCollision\">TTriangle.RayCollision</a> when the result had to be actually geometrically calculated (result was not in the cache aka &quot;mailbox&quot;).  <p>It is especially useful to look at this after using some spatial data structure, like an octree. The goal of tree structures is to minimize this number.  <p>It is a global variable, because that's the most comfortable way to use it. Triangles are usually wrapped in an octree (like TTriangleOctree), or even in an octree of octrees (like TShapeOctree). Tracking collisions using the global variable is most comfortable, instead of spending time on propagating this (purely debugging) information through the octree structures. ", "tags": "", "loc": "CastleTriangles.html#TriangleCollisionTestsCounter"},
     {"title": "CastleTriangulate", "text": " ", "tags": "", "loc": "CastleTriangulate.html"},
     {"title": "CastleTriangulate.TriangulateFace", "text": "  <p>FaceIndices[0]..FaceIndices[Count - 1] are indices to the Vertices array. They describe the outline of the polygon (face). You can pass FaceIndices = <code>Nil</code>, this is understood that indices are just 0..Count - 1 (in other words, it's equivalent to setting FaceIndices[0] = 0, FaceIndices[1] = 1 etc.).  <p>For each resulting triangle we will call TriangulatorProc with Tri (first param of TriangulatorProc) containing indices to FaceIndices[] array. We return indices to FaceIndices (not ready vectors from Vertices, not even indices to Vertices[] array) to allow the caller to obtain all information about the triangle. In the simple case, you can just use Vertices[FaceIndices[Tri[0..2]]] to obtain your triangle, in the more sophisticated cases you have other options to e.g. extract other vertex information from whatever data you have (see e.g. VRML/X3D IndexedFaceSet renderer).  <p>Generated triangles have the same orientation (normal from ccw etc.) as original polygon. This also means that if you're sure that your polygon is planar (and it should be &mdash; although we handle gracefully small deviations from planar, this procedure doesn't actually handle arbitrary (dis)located 3D data) then normal vector of all your triangles is the same.  <p>Note that you generally shouldn't use this procedure if you <i>know</i> that your polygon is convex. Then using this is a waste of time, after all convex polygons can be triangulated much easier. You can use <a class=\"normal\" href=\"CastleTriangulate.html#TriangulateConvexFace\">TriangulateConvexFace</a> in this case, which has deliberately very similar interface to this procedure.  <p>  <p>  <p>  <p>  TriangulatorProcData Is just passed unmodified to every TriangulatorProc call (as the second parameter). This is standard method to pass whatever data to your callback. AddToIndices Indexes returned in Tri[0..2] are all incremented by AddToIndices (which may also be negative), this is useful if your FaceIndices is actually a pointer to the middle of some larger indexes array. Just pass 0 if you don't want this.  TriangulatorProcData Is just passed unmodified to every TriangulatorProc call (as the second parameter). This is standard method to pass whatever data to your callback. AddToIndices Indexes returned in Tri[0..2] are all incremented by AddToIndices (which may also be negative), this is useful if your FaceIndices is actually a pointer to the middle of some larger indexes array. Just pass 0 if you don't want this.", "tags": "", "loc": "CastleTriangulate.html#TriangulateFace"},
     {"title": "CastleTriangulate.TriangulateFace", "text": "    ", "tags": "", "loc": "CastleTriangulate.html#TriangulateFace"},
     {"title": "CastleTriangulate.TriangulateConvexFace", "text": "  <p>This performs very easy triangulation. It has deliberately similar interface to <a class=\"normal\" href=\"CastleTriangulate.html#TriangulateFace\">TriangulateFace</a>, so it can be used as drop-in replacement for <a class=\"normal\" href=\"CastleTriangulate.html#TriangulateFace\">TriangulateFace</a>, when you know that your face is convex.  <p>Note that it doesn't even need to know FaceIndices or Vertices, it's enough to know Count.  <p>This also guarantees consequent triangles orientation, like <a class=\"normal\" href=\"CastleTriangulate.html#TriangulateFace\">TriangulateFace</a>.  <p>    ", "tags": "", "loc": "CastleTriangulate.html#TriangulateConvexFace"},
     {"title": "CastleTriangulate.IndexedPolygonNormal", "text": "    ", "tags": "", "loc": "CastleTriangulate.html#IndexedPolygonNormal"},
     {"title": "CastleTriangulate.TTriangulatorProc", "text": "    ", "tags": "", "loc": "CastleTriangulate.html#TTriangulatorProc"},
     {"title": "CastleTriangulate.LogTriangulation", "text": " Useful for examples/visualize_triangulation/ . ", "tags": "", "loc": "CastleTriangulate.html#LogTriangulation"},
     {"title": "CastleUIControls", "text": " ", "tags": "", "loc": "CastleUIControls.html"},
     {"title": "CastleUIControls.TTouch", "text": " ", "tags": "", "loc": "CastleUIControls.TTouch.html"},
     {"title": "CastleUIControls.TTouch.FingerIndex", "text": " Always simply zero on traditional desktops with just a single mouse device. For devices with multi-touch (and/or possible multiple mouse pointers) this is actually useful to connect touches from different frames into a single move action. In other words: the FinderIndex stays constant while user moves a finger over a touch device.  <p>All the touches on a <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Touches\">TUIContainer.Touches</a> array always have different <code>FingerIndex</code> value.  <p>Note that the index of <a class=\"normal\" href=\"CastleUIControls.TTouch.html\">TTouch</a> structure in <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Touches\">TUIContainer.Touches</a> array is <i>not</i> necessarily equal to the <code>FingerIndex</code>. It cannot be &mdash; imagine you press 1st finger, then press 2nd finger, then let go of the 1st finger. The <code>FingerIndex</code> of the 2nd finger cannot change (to keep events sensibly reporting the same touch), so there has to be a temporary &quot;hole&quot; in FinderIndex numeration. ", "tags": "", "loc": "CastleUIControls.TTouch.html#FingerIndex"},
     {"title": "CastleUIControls.TTouch.Position", "text": "  <p>Position (0, 0) is the window's bottom-left corner. This is consistent with how our 2D controls (<a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a>) treat all positions.  <p>The position is expressed as a float value, to support backends that can report positions with sub-pixel accuracy. For example GTK and Android can do it, although it depends on underlying hardware capabilities as well. The top-right corner or the top-right pixel has the coordinates (Width, Height). Note that if you want to actually draw something at the window's edge (for example, paint the top-right pixel of the window with some color), then the pixel coordinates are (Width - 1, Height - 1). The idea is that the whole top-right pixel is an area starting in (Width - 1, Height - 1) and ending in (Width, Height).  <p>Note that we have mouse capturing (when user presses and holds the mouse button, all the following mouse events are reported to this window, even when user moves the mouse outside of the window). This is typical of all window libraries (GTK, LCL etc.). This implicates that mouse positions are sometimes tracked also when mouse is outside the window, which means that mouse position may be outside the rectangle (0, 0) - (Width, Height), so it may even be negative. ", "tags": "", "loc": "CastleUIControls.TTouch.html#Position"},
     {"title": "CastleUIControls.TTouchList", "text": " ", "tags": "", "loc": "CastleUIControls.TTouchList.html"},
     {"title": "CastleUIControls.TTouchList.RemoveFingerIndex", "text": "    ", "tags": "", "loc": "CastleUIControls.TTouchList.html#RemoveFingerIndex"},
     {"title": "CastleUIControls.TTouchList.FingerIndexPosition", "text": " If there is no information for given FingerIndex on the list, the getter will return zero, and the setter will automatically create and add appropriate information. ", "tags": "", "loc": "CastleUIControls.TTouchList.html#FingerIndexPosition"},
     {"title": "CastleUIControls.TUIContainer", "text": " Connects OpenGL context management code with Castle Game Engine controls (<a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a>, that is the basis for all our 2D and 3D rendering). When you use <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> (a window) or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a> (Lazarus component), they provide you a non-abstact implementation of <code>TUIContainer</code>.  <p>Basically, this class manages a <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">Controls</a> list.  <p>We pass our inputs (mouse / key / touch events) to the controls on this list. Input goes to the front-most (that is, last on the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">Controls</a> list) control under the event position (or mouse position, or the appropriate touch position). We use <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CapturesEventsAtPosition\">TUIControl.CapturesEventsAtPosition</a> to decide this (by default it simply checks control's <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ScreenRect\">TUIControl.ScreenRect</a> vs the given position). As long as the event is not handled, we search for the next control that can handle this event and returns <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CapturesEventsAtPosition\">TUIControl.CapturesEventsAtPosition</a> = <code>True</code>.  <p>We also call various methods to every control. These include <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">TInputListener.Update</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a>, <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Resize\">TInputListener.Resize</a>. ", "tags": "", "loc": "CastleUIControls.TUIContainer.html"},
     {"title": "CastleUIControls.TUIContainer.Notification", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Notification"},
     {"title": "CastleUIControls.TUIContainer.SetInternalCursor", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#SetInternalCursor"},
     {"title": "CastleUIControls.TUIContainer.GetMousePosition", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#GetMousePosition"},
     {"title": "CastleUIControls.TUIContainer.SetMousePosition", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#SetMousePosition"},
     {"title": "CastleUIControls.TUIContainer.GetTouches", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#GetTouches"},
     {"title": "CastleUIControls.TUIContainer.DefaultUIScale", "text": " Useful only when <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#GLInitialized\">GLInitialized</a>, when we know that our size is sensible. Most UI code should rather be placed in <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a>, and use <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">TUIControl.UIScale</a>.    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#DefaultUIScale"},
     {"title": "CastleUIControls.TUIContainer.Create", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Create"},
     {"title": "CastleUIControls.TUIContainer.Destroy", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Destroy"},
     {"title": "CastleUIControls.TUIContainer.EventOpen", "text": "  <p>These methods are called automatically when necessary, so usually you don't call them. But in rare cases, it makes sense to &quot;fake&quot; some event by calling these methods.  <p>Most of these methods are called automatically by the container owner, like <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> or <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a>. Some are called by <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventUpdate\">EventUpdate</a>, which is special in this regard, as <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventUpdate\">EventUpdate</a> is not only responsible for calling <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">TInputListener.Update</a> on all <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">Controls</a>, it also calls <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventJoyAxisMove\">EventJoyAxisMove</a>, <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventJoyButtonPress\">EventJoyButtonPress</a>, <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventSensorRotation\">EventSensorRotation</a>, <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventSensorTranslation\">EventSensorTranslation</a>.  <p>    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventOpen"},
     {"title": "CastleUIControls.TUIContainer.EventClose", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventClose"},
     {"title": "CastleUIControls.TUIContainer.EventPress", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventPress"},
     {"title": "CastleUIControls.TUIContainer.EventRelease", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventRelease"},
     {"title": "CastleUIControls.TUIContainer.EventUpdate", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventUpdate"},
     {"title": "CastleUIControls.TUIContainer.EventMotion", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventMotion"},
     {"title": "CastleUIControls.TUIContainer.AllowSuspendForInput", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#AllowSuspendForInput"},
     {"title": "CastleUIControls.TUIContainer.EventBeforeRender", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventBeforeRender"},
     {"title": "CastleUIControls.TUIContainer.EventRender", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventRender"},
     {"title": "CastleUIControls.TUIContainer.EventResize", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventResize"},
     {"title": "CastleUIControls.TUIContainer.EventJoyAxisMove", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventJoyAxisMove"},
     {"title": "CastleUIControls.TUIContainer.EventJoyButtonPress", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventJoyButtonPress"},
     {"title": "CastleUIControls.TUIContainer.EventSensorRotation", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventSensorRotation"},
     {"title": "CastleUIControls.TUIContainer.EventSensorTranslation", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#EventSensorTranslation"},
     {"title": "CastleUIControls.TUIContainer.Controls", "text": "  <p>Usually you explicitly add / remove controls to this list using the <a class=\"normal\" href=\"CastleUIControls.TChildrenControls.html#InsertFront\">Controls.InsertFront</a> or <a class=\"normal\" href=\"CastleUIControls.TChildrenControls.html#InsertBack\">Controls.InsertBack</a> methods. Freeing any control that is on this list automatically removes it from this list (we use the TComponent.Notification mechanism).  <p>Controls on the list should be specified in back-to-front order. That is, controls at the beginning of this list are rendered first, and are last to catch some events, since the rest of controls cover them.    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Controls"},
     {"title": "CastleUIControls.TUIContainer.Invalidate", "text": " This method does not redraw immediately (it does not call <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventBeforeRender\">EventBeforeRender</a> and <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#EventRender\">EventRender</a> inside), it only makes sure that they will be called <i>very soon</i>. Calling this on a closed container (with <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#GLInitialized\">GLInitialized</a> = <code>False</code>) is allowed and ignored.    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Invalidate"},
     {"title": "CastleUIControls.TUIContainer.GLInitialized", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#GLInitialized"},
     {"title": "CastleUIControls.TUIContainer.Width", "text": " This is expressed in real device pixels. Prefer using <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UnscaledWidth\">UnscaledWidth</a> instead of this. <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UnscaledWidth\">UnscaledWidth</a> is more natural when you use UI scaling (<a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">UIScaling</a>), and it's simply equal to <code>Width</code> when UI scaling is not used.    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Width"},
     {"title": "CastleUIControls.TUIContainer.Height", "text": " This is expressed in real device pixels. Prefer using <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UnscaledHeight\">UnscaledHeight</a> instead of this. <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UnscaledHeight\">UnscaledHeight</a> is more natural when you use UI scaling (<a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">UIScaling</a>), and it's simply equal to <code>Height</code> when UI scaling is not used.    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Height"},
     {"title": "CastleUIControls.TUIContainer.Rect", "text": " This is expressed in real device pixels, using <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Width\">Width</a> and <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Height\">Height</a>. Prefer using <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UnscaledRect\">UnscaledRect</a> instead of this. <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UnscaledRect\">UnscaledRect</a> is more natural when you use UI scaling (<a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">UIScaling</a>), and it's simply equal to <code>Rect</code> when UI scaling is not used.    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Rect"},
     {"title": "CastleUIControls.TUIContainer.UnscaledWidth", "text": " In other words, this is the real <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Width\">Width</a> with UI scaling reversed (divided). Suitable to adjust size of your UI controls to container, when UI scaling is used.  <p>This is equivalent to just <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Width\">Width</a> when <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">UIScaling</a> is <a class=\"normal\" href=\"CastleUIControls.html#usNone\">usNone</a> (default).  <p>Note: the name &quot;unscaled&quot; may seem a little unintuitive, but it's consistent. We call UI sizes &quot;scaled&quot; when they are expressed in real device pixels, because they are usually calculated as &quot;desired size * <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">UIScaling</a>&quot;. So the UI size is &quot;unscaled&quot; when it's expressed in your &quot;desired size&quot;. We usually don't use the prefix &quot;unscaled&quot; (e.g. <a class=\"normal\" href=\"CastleControls.TCastleButton.html#Width\">TCastleButton.Width</a> is &quot;unscaled&quot; by we don't call it &quot;<code>UnscaledWidth</code>&quot;; every property inside <a class=\"normal\" href=\"CastleControls.TCastleButton.html\">TCastleButton</a> is actually &quot;unscaled&quot;). But here, we use prefix &quot;unscaled&quot;, because the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Width\">TUIContainer.Width</a> is (for historic reasons) the &quot;real&quot; size.  <p>    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#UnscaledWidth"},
     {"title": "CastleUIControls.TUIContainer.UnscaledHeight", "text": "     ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#UnscaledHeight"},
     {"title": "CastleUIControls.TUIContainer.UnscaledRect", "text": "     ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#UnscaledRect"},
     {"title": "CastleUIControls.TUIContainer.Dpi", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Dpi"},
     {"title": "CastleUIControls.TUIContainer.Focused", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Focused"},
     {"title": "CastleUIControls.TUIContainer.TouchesCount", "text": "     ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#TouchesCount"},
     {"title": "CastleUIControls.TUIContainer.SaveScreen", "text": "  <p>Note that only capturing from the double-buffered OpenGL windows (which the default for our <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> and <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a>) is reliable. Internally, these methods may need to redraw the screen to the back buffer, because that's the only guaranteed way to capture OpenGL drawing (you have to capture the back buffer, before swap).  <p>    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#SaveScreen"},
     {"title": "CastleUIControls.TUIContainer.SaveScreen", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#SaveScreen"},
     {"title": "CastleUIControls.TUIContainer.SaveScreen", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#SaveScreen"},
     {"title": "CastleUIControls.TUIContainer.UpdateFocusAndMouseCursor", "text": " In practice, called when TUIControl.Cursor or <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CapturesEventsAtPosition\">TUIControl.CapturesEventsAtPosition</a> (and so also <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ScreenRect\">TUIControl.ScreenRect</a>) results change.  <p>This recalculates the focused control and the final cursor of the container, looking at Container's Controls, testing <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CapturesEventsAtPosition\">TUIControl.CapturesEventsAtPosition</a> with current mouse position, and looking at Cursor property of various controls.  <p>When you add / remove some control from the Controls list, or when you move mouse (focused changes) this will also be automatically called (since focused control or final container cursor may also change then).    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#UpdateFocusAndMouseCursor"},
     {"title": "CastleUIControls.TUIContainer.IsMousePositionForMouseLook", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#IsMousePositionForMouseLook"},
     {"title": "CastleUIControls.TUIContainer.MakeMousePositionForMouseLook", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#MakeMousePositionForMouseLook"},
     {"title": "CastleUIControls.TUIContainer.ReleaseCapture", "text": " This is usually desirable, to allow the control to handle the dragging. But sometimes you want to cancel the dragging, and allow other controls to handle the following motion and release events, in which case calling this method helps.    ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#ReleaseCapture"},
     {"title": "CastleUIControls.TUIContainer.OnOpen", "text": "  ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnOpen"},
     {"title": "CastleUIControls.TUIContainer.OnOpenObject", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnOpenObject"},
     {"title": "CastleUIControls.TUIContainer.OnBeforeRender", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnBeforeRender"},
     {"title": "CastleUIControls.TUIContainer.OnRender", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnRender"},
     {"title": "CastleUIControls.TUIContainer.OnResize", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnResize"},
     {"title": "CastleUIControls.TUIContainer.OnClose", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnClose"},
     {"title": "CastleUIControls.TUIContainer.OnCloseObject", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnCloseObject"},
     {"title": "CastleUIControls.TUIContainer.OnPress", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnPress"},
     {"title": "CastleUIControls.TUIContainer.OnRelease", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnRelease"},
     {"title": "CastleUIControls.TUIContainer.OnMotion", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnMotion"},
     {"title": "CastleUIControls.TUIContainer.OnUpdate", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#OnUpdate"},
     {"title": "CastleUIControls.TUIContainer.Cursor", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Cursor"},
     {"title": "CastleUIControls.TUIContainer.InternalCursor", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#InternalCursor"},
     {"title": "CastleUIControls.TUIContainer.Focus", "text": " So the front-most control, that should receive events first, is last on this list. ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Focus"},
     {"title": "CastleUIControls.TUIContainer.TooltipVisible", "text": "  <p>The tooltip is only detected when <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipExists\">TUIControl.TooltipExists</a>. See <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipExists\">TUIControl.TooltipExists</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipStyle\">TUIControl.TooltipStyle</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipRender\">TUIControl.TooltipRender</a>. For simple purposes just set <a class=\"normal\" href=\"CastleControls.TUIControlFont.html#Tooltip\">TUIControlFont.Tooltip</a> to something non-empty.  ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#TooltipVisible"},
     {"title": "CastleUIControls.TUIContainer.TooltipPosition", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#TooltipPosition"},
     {"title": "CastleUIControls.TUIContainer.MousePosition", "text": " See <a class=\"normal\" href=\"CastleUIControls.TTouch.html#Position\">TTouch.Position</a> for a documentation how this is expressed. ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#MousePosition"},
     {"title": "CastleUIControls.TUIContainer.MousePressed", "text": " When this changes, you're always notified by <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#OnPress\">OnPress</a> or <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#OnRelease\">OnRelease</a> events.  <p>This value is always current, in particular it's already updated before we call events <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#OnPress\">OnPress</a> or <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#OnRelease\">OnRelease</a>. ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#MousePressed"},
     {"title": "CastleUIControls.TUIContainer.Pressed", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Pressed"},
     {"title": "CastleUIControls.TUIContainer.Fps", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Fps"},
     {"title": "CastleUIControls.TUIContainer.Touches", "text": " This tracks currently pressed fingers, in case of touch devices (mobile, like Android and iOS). In case of desktops, it tracks the current mouse position, regardless if any mouse button is currently pressed.  <p>Indexed from 0 to <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#TouchesCount\">TouchesCount</a> - 1.   ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#Touches"},
     {"title": "CastleUIControls.TUIContainer.ForceCaptureInput", "text": " This control also always has <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Focus\">focus</a>.  <p>An example when this is useful is when you use camera MouseLook, and the associated viewport does not fill the full window (<a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html#FullSize\">TCastleAbstractViewport.FullSize</a> is <code>False</code>, and actual sizes are smaller than window, and may not include window center). In this case you want to make sure that motion events get passed to this control, and that this control has <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Focus\">focus</a> (to keep mouse cursor hidden). ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#ForceCaptureInput"},
     {"title": "CastleUIControls.TUIContainer.RenderStyle", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleUIControls.html#rs2D\">rs2D</a> means that <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#OnRender\">OnRender</a> is called at the end, after all our <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">Controls</a> (3D and 2D) are drawn.</p></li>   <li><p><a class=\"normal\" href=\"CastleUIControls.html#rs3D\">rs3D</a> means that <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#OnRender\">OnRender</a> is called after all other <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">Controls</a> with <a class=\"normal\" href=\"CastleUIControls.html#rs3D\">rs3D</a> draw style, but before any 2D controls.  <p>This is suitable if you want to draw something 3D, that may be later covered by 2D controls.</p></li> </ul>  <p>  <p> Do not use this to control the order of rendering, better to use proper InsertFront or InsertBack or KeepInFront. ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#RenderStyle"},
     {"title": "CastleUIControls.TUIContainer.TooltipDelay", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#TooltipDelay"},
     {"title": "CastleUIControls.TUIContainer.TooltipDistance", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#TooltipDistance"},
     {"title": "CastleUIControls.TUIContainer.UIScaling", "text": " This is great when the container size may vary widly (for example, on mobile devices, although it becomes more and more sensible for desktops too). See <a class=\"normal\" href=\"CastleUIControls.html#TUIScaling\">TUIScaling</a> values for precise description how it works. ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#UIScaling"},
     {"title": "CastleUIControls.TUIContainer.UIReferenceWidth", "text": " See <a class=\"normal\" href=\"CastleUIControls.html#usEncloseReferenceSize\">usEncloseReferenceSize</a> and <a class=\"normal\" href=\"CastleUIControls.html#usFitReferenceSize\">usFitReferenceSize</a> for precise description how this works. Set both these properties, or set only one (and leave the other as zero).  ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#UIReferenceWidth"},
     {"title": "CastleUIControls.TUIContainer.UIReferenceHeight", "text": " ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#UIReferenceHeight"},
     {"title": "CastleUIControls.TUIContainer.UIExplicitScale", "text": " See <a class=\"normal\" href=\"CastleUIControls.html#usExplicitScale\">usExplicitScale</a> for precise description how this works. ", "tags": "", "loc": "CastleUIControls.TUIContainer.html#UIExplicitScale"},
     {"title": "CastleUIControls.TInputListener", "text": " ", "tags": "", "loc": "CastleUIControls.TInputListener.html"},
     {"title": "CastleUIControls.TInputListener.ContainerWidth", "text": "     ", "tags": "", "loc": "CastleUIControls.TInputListener.html#ContainerWidth"},
     {"title": "CastleUIControls.TInputListener.ContainerHeight", "text": "    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#ContainerHeight"},
     {"title": "CastleUIControls.TInputListener.ContainerRect", "text": "    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#ContainerRect"},
     {"title": "CastleUIControls.TInputListener.ContainerSizeKnown", "text": "    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#ContainerSizeKnown"},
     {"title": "CastleUIControls.TInputListener.SetContainer", "text": "    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#SetContainer"},
     {"title": "CastleUIControls.TInputListener.DoCursorChange", "text": " In <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> class, just calls <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#OnCursorChange\">OnCursorChange</a>.    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#DoCursorChange"},
     {"title": "CastleUIControls.TInputListener.Create", "text": "    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#Create"},
     {"title": "CastleUIControls.TInputListener.Press", "text": " Return <code>True</code> if the event was somehow handled.  <p>In this class this always returns <code>False</code>, when implementing in descendants you should override it like  <p></p>  <pre class=\"longcode\"> Result := <span class=\"pascal_keyword\">inherited</span>; <span class=\"pascal_keyword\">if</span> Result <span class=\"pascal_keyword\">then</span> Exit; <span class=\"pascal_comment\">{ ... And do the job here.   In other words, the handling of events in inherited   class should have a priority. }</span></pre>  <p>  <p>Note that releasing of mouse wheel is not implemented for now, neither by <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> or Lazarus <a class=\"normal\" href=\"CastleControl.html\">CastleControl</a>.     ", "tags": "", "loc": "CastleUIControls.TInputListener.html#Press"},
     {"title": "CastleUIControls.TInputListener.Release", "text": "    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#Release"},
     {"title": "CastleUIControls.TInputListener.Motion", "text": "    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#Motion"},
     {"title": "CastleUIControls.TInputListener.SensorRotation", "text": " Used for example by 3Dconnexion devices or touch controls.  <p>      X X axis (tilt forward/backwards) Y Y axis (rotate) Z Z axis (tilt sidewards) Angle Angle of rotation SecondsPassed The time passed since last <code>SensorRotation</code> call. This is necessary because some sensors, e.g. 3Dconnexion, may *not* reported as often as normal <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">Update</a> calls.  X X axis (tilt forward/backwards) Y Y axis (rotate) Z Z axis (tilt sidewards) Angle Angle of rotation SecondsPassed The time passed since last <code>SensorRotation</code> call. This is necessary because some sensors, e.g. 3Dconnexion, may *not* reported as often as normal <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">Update</a> calls.", "tags": "", "loc": "CastleUIControls.TInputListener.html#SensorRotation"},
     {"title": "CastleUIControls.TInputListener.SensorTranslation", "text": " Used for example by 3Dconnexion devices or touch controls.  <p>      X X axis (move left/right) Y Y axis (move up/down) Z Z axis (move forward/backwards) Length Length of the vector consisting of the above SecondsPassed The time passed since last <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#SensorRotation\">SensorRotation</a> call. This is necessary because some sensors, e.g. 3Dconnexion, may *not* reported as often as normal <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">Update</a> calls.  X X axis (move left/right) Y Y axis (move up/down) Z Z axis (move forward/backwards) Length Length of the vector consisting of the above SecondsPassed The time passed since last <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#SensorRotation\">SensorRotation</a> call. This is necessary because some sensors, e.g. 3Dconnexion, may *not* reported as often as normal <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">Update</a> calls.", "tags": "", "loc": "CastleUIControls.TInputListener.html#SensorTranslation"},
     {"title": "CastleUIControls.TInputListener.JoyAxisMove", "text": "  JoyID ID of joystick with pressed button Axis Number of moved axis  JoyID ID of joystick with pressed button Axis Number of moved axis", "tags": "", "loc": "CastleUIControls.TInputListener.html#JoyAxisMove"},
     {"title": "CastleUIControls.TInputListener.JoyButtonPress", "text": "  <p>   JoyID ID of joystick with pressed button Button Number of pressed button  JoyID ID of joystick with pressed button Button Number of pressed button", "tags": "", "loc": "CastleUIControls.TInputListener.html#JoyButtonPress"},
     {"title": "CastleUIControls.TInputListener.Update", "text": " E.g. camera handles here falling down due to gravity, rotating model in Examine mode, and many more.  <p>  <p>This method may be used, among many other things, to continously react to the fact that user pressed some key (or mouse button). For example, if holding some key should move some 3D object, you should do something like:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">if</span> HandleInput <span class=\"pascal_keyword\">then</span> <span class=\"pascal_keyword\">begin</span>   <span class=\"pascal_keyword\">if</span> Container.Pressed[K_Right] <span class=\"pascal_keyword\">then</span>     Transform.Position := Transform.Position + Vector3(SecondsPassed * <span class=\"pascal_numeric\">10</span>, <span class=\"pascal_numeric\">0</span>, <span class=\"pascal_numeric\">0</span>);   HandleInput := <span class=\"pascal_keyword\">not</span> ExclusiveEvents; <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>Instead of directly using a key code, consider also using <a class=\"normal\" href=\"CastleInputs.TInputShortcut.html\">TInputShortcut</a> that makes the input key nicely configurable. See engine tutorial about handling inputs.  <p>Multiplying movement by SecondsPassed makes your operation frame-rate independent. Object will move by 10 units in a second, regardless of how many FPS your game has.  <p>The code related to HandleInput is important if you write a generally-useful control that should nicely cooperate with all other controls, even when placed on top of them or under them. The correct approach is to only look at pressed keys/mouse buttons if HandleInput is <code>True</code>. Moreover, if you did check that HandleInput is <code>True</code>, and you did actually handle some keys, then you have to set <code>HandleInput := not <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#ExclusiveEvents\">ExclusiveEvents</a></code>. As <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#ExclusiveEvents\">ExclusiveEvents</a> is <code>True</code> in normal circumstances, this will prevent the other controls (behind the current control) from handling the keys (they will get HandleInput = <code>False</code>). And this is important to avoid doubly-processing the same key press, e.g. if two controls react to the same key, only the one on top should process it.  <p>Note that to handle a single press / release (like &quot;switch light on when pressing a key&quot;) you should rather use <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Press\">Press</a> and <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Release\">Release</a> methods. Use this method only for continous handling (like &quot;holding this key makes the light brighter and brighter&quot;).  <p>To understand why such HandleInput approach is needed, realize that the &quot;Update&quot; events are called differently than simple mouse and key events like &quot;Press&quot; and &quot;Release&quot;. &quot;Press&quot; and &quot;Release&quot; events return whether the event was somehow &quot;handled&quot;, and the container passes them only to the controls under the mouse (decided by <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CapturesEventsAtPosition\">TUIControl.CapturesEventsAtPosition</a>). And as soon as some control says it &quot;handled&quot; the event, other controls (even if under the mouse) will not receive the event.  <p>This approach is not suitable for Update events. Some controls need to do the Update job all the time, regardless of whether the control is under the mouse and regardless of what other controls already did. So all controls (well, all controls that exist, in case of <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a>, see <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GetExists\">TUIControl.GetExists</a>) receive Update calls.  <p>So the &quot;handled&quot; status is passed through HandleInput. If a control is not under the mouse, it will receive HandleInput = <code>False</code>. If a control is under the mouse, it will receive HandleInput = <code>True</code> as long as no other control on top of it didn't already change it to <code>False</code>.  SecondsPassed Should be calculated like <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html#SecondsPassed\">TFramesPerSecond.SecondsPassed</a>, and usually it's in fact just taken from TCastleWindowCustom.Fps.SecondsPassed.  SecondsPassed Should be calculated like <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html#SecondsPassed\">TFramesPerSecond.SecondsPassed</a>, and usually it's in fact just taken from TCastleWindowCustom.Fps.SecondsPassed.", "tags": "", "loc": "CastleUIControls.TInputListener.html#Update"},
     {"title": "CastleUIControls.TInputListener.VisibleChange", "text": " In the simplest case, this is used by the controls manager to know when we need to redraw the control.  <p>In this class this simply calls <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#OnVisibleChange\">OnVisibleChange</a> (if assigned).  <p>  RectOrCursorChanged Set to <code>True</code> if the final control size or position on the screen, or cursor, changed. This simply causes a call to <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UpdateFocusAndMouseCursor\">TUIContainer.UpdateFocusAndMouseCursor</a>.  RectOrCursorChanged Set to <code>True</code> if the final control size or position on the screen, or cursor, changed. This simply causes a call to <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UpdateFocusAndMouseCursor\">TUIContainer.UpdateFocusAndMouseCursor</a>.", "tags": "", "loc": "CastleUIControls.TInputListener.html#VisibleChange"},
     {"title": "CastleUIControls.TInputListener.AllowSuspendForInput", "text": " Typically you want to override this to return <code>False</code> when you do something in the overridden <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">Update</a> method.  <p>In this class, this simply returns always <code>True</code>.  <p>    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#AllowSuspendForInput"},
     {"title": "CastleUIControls.TInputListener.Resize", "text": " Called always when the container (component or window with OpenGL context) size changes. Called only when the OpenGL context of the container is initialized, so you can be sure that this is called only between GLContextOpen and GLContextClose.  <p>We also make sure to call this once when inserting into the controls list (like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a> or inside parent <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a>), if inserting into the container/parent with already initialized OpenGL context. If inserting into the container/parent without OpenGL context initialized, it will be called later, when OpenGL context will get initialized, right after GLContextOpen.  <p>In other words, this is always called to let the control know the size of the container, if and only if the OpenGL context is initialized.    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#Resize"},
     {"title": "CastleUIControls.TInputListener.ContainerResize", "text": "    ", "tags": "", "loc": "CastleUIControls.TInputListener.html#ContainerResize"},
     {"title": "CastleUIControls.TInputListener.OnVisibleChange", "text": " In the simplest case, this is used by the controls manager to know when we need to redraw the control.  <p>Be careful when handling this event, various changes may cause this, so be prepared to handle <code>OnVisibleChange</code> at every time.  <p> ", "tags": "", "loc": "CastleUIControls.TInputListener.html#OnVisibleChange"},
     {"title": "CastleUIControls.TInputListener.Container", "text": " When adding control to container's Controls list (like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a>) container will automatically set itself here, and when removing from container this will be changed back to <code>Nil</code>.  <p>May be <code>Nil</code> if this control is not yet inserted into any container. ", "tags": "", "loc": "CastleUIControls.TInputListener.html#Container"},
     {"title": "CastleUIControls.TInputListener.Cursor", "text": " When user moves mouse over the Container, the currently focused (topmost under the cursor) control determines the mouse cursor look. ", "tags": "", "loc": "CastleUIControls.TInputListener.html#Cursor"},
     {"title": "CastleUIControls.TInputListener.OnCursorChange", "text": " This event is, in normal circumstances, used by the Container, so you should not use it in your own programs. ", "tags": "", "loc": "CastleUIControls.TInputListener.html#OnCursorChange"},
     {"title": "CastleUIControls.TInputListener.ExclusiveEvents", "text": " If <code>True</code>, then our events will return <code>True</code> for mouse and key events handled.  <p>This means that events will not be simultaneously handled by both this control and some other (or camera or normal window callbacks), which is usually more sensible, but sometimes somewhat limiting. ", "tags": "", "loc": "CastleUIControls.TInputListener.html#ExclusiveEvents"},
     {"title": "CastleUIControls.TUIControl", "text": " All controls derive from this class, overriding chosen methods to react to some events. Various user interface containers (things that directly receive messages from something outside, like operating system, windowing library etc.) implement support for such controls.  <p>Control has children controls, see <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Controls\">Controls</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ControlsCount\">ControlsCount</a>. Parent control is recorded inside <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Parent\">Parent</a>. A control may only be a child of one other control &mdash; that is, you cannot insert to the 2D hierarchy the same control multiple times (in <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a> hierarchy, such trick is allowed).  <p>Control may handle mouse/keyboard input, see <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Press\">Press</a> and <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Release\">Release</a> methods.  <p>Various methods return boolean saying if input event is handled. The idea is that not handled events are passed to the next control suitable. Handled events are generally not processed more &mdash; otherwise the same event could be handled by more than one listener, which is bad. Generally, return <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#ExclusiveEvents\">ExclusiveEvents</a> if anything (possibly) was done (you changed any field value etc.) as a result of this, and only return <code>False</code> when you're absolutely sure that nothing was done by this control.  <p>Every control also has a position and takes some rectangular space on the container.  <p>The position is controlled using the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Left\">Left</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Bottom\">Bottom</a> fields. The rectangle where the control is visible can be queried using the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Rect\">Rect</a> or <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ScreenRect\">ScreenRect</a> methods.  <p>Note that each descendant has it's own definition of the size of the control. E.g. some descendants may automatically calculate the size (based on text or images or such placed within the control). Some descendants may allow to control the size explicitly using fields like Width, Height, FullSize. Some descendants may allow both approaches, switchable by property like <a class=\"normal\" href=\"CastleControls.TCastleButton.html#AutoSize\">TCastleButton.AutoSize</a> or <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Stretch\">TCastleImageControl.Stretch</a>. The base <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Rect\">TUIControl.Rect</a> returns always an empty rectangle, most descendants will want to override it (you can also ignore the issue in your own <code>TUIControl</code> descendants, if the given control size will never be used for anything).  <p>All screen (mouse etc.) coordinates passed here should be in the usual window system coordinates, that is (0, 0) is left-top window corner. (Note that this is contrary to the usual OpenGL 2D system, where (0, 0) is left-bottom window corner.) ", "tags": "", "loc": "CastleUIControls.TUIControl.html"},
     {"title": "CastleUIControls.TUIControl.DefineProperties", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#DefineProperties"},
     {"title": "CastleUIControls.TUIControl.SetContainer", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#SetContainer"},
     {"title": "CastleUIControls.TUIControl.LeftBottomScaled", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#LeftBottomScaled"},
     {"title": "CastleUIControls.TUIControl.UIScaleChanged", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#UIScaleChanged"},
     {"title": "CastleUIControls.TUIControl.Create", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Create"},
     {"title": "CastleUIControls.TUIControl.Destroy", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Destroy"},
     {"title": "CastleUIControls.TUIControl.ControlsCount", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#ControlsCount"},
     {"title": "CastleUIControls.TUIControl.InsertFront", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#InsertFront"},
     {"title": "CastleUIControls.TUIControl.InsertFrontIfNotExists", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#InsertFrontIfNotExists"},
     {"title": "CastleUIControls.TUIControl.InsertFront", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#InsertFront"},
     {"title": "CastleUIControls.TUIControl.InsertBack", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#InsertBack"},
     {"title": "CastleUIControls.TUIControl.InsertBackIfNotExists", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#InsertBackIfNotExists"},
     {"title": "CastleUIControls.TUIControl.InsertBack", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#InsertBack"},
     {"title": "CastleUIControls.TUIControl.RemoveControl", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#RemoveControl"},
     {"title": "CastleUIControls.TUIControl.ClearControls", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#ClearControls"},
     {"title": "CastleUIControls.TUIControl.GetExists", "text": " Non-existing item does not receive any of the render or input or update calls. They only receive <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextOpen\">GLContextOpen</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextClose\">GLContextClose</a>, <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Resize\">Resize</a> calls.  <p>It <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> class, this returns the value of <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Exists\">Exists</a> property. May be overridden in descendants, to return something more complicated, but it should always be a logical &quot;and&quot; with the inherited <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GetExists\">GetExists</a> implementation (so setting the <code>Exists := false</code> will always work), like  <p></p>  <pre class=\"longcode\"> Result := (<span class=\"pascal_keyword\">inherited</span> GetExists) <span class=\"pascal_keyword\">and</span> MyComplicatedConditionForExists;</pre>  <p>    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#GetExists"},
     {"title": "CastleUIControls.TUIControl.CapturesEventsAtPosition", "text": " The default implementation simply checks whether Position is inside <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ScreenRect\">ScreenRect</a> now. It also checks whether <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#CapturesEvents\">CapturesEvents</a> is <code>True</code>.  <p>Always treated like <code>False</code> when <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GetExists\">GetExists</a> returns <code>False</code>, so the implementation of this method only needs to make checks assuming that <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GetExists\">GetExists</a> = <code>True</code>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#CapturesEventsAtPosition"},
     {"title": "CastleUIControls.TUIControl.BeforeRender", "text": " Called only when <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GetExists\">GetExists</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLInitialized\">GLInitialized</a>.  <p><b>Do not explicitly call this method.</b> Instead, render controls by adding them to the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> list, or render them explicitly (for off-screen rendering) by <a class=\"normal\" href=\"CastleGLContainer.TGLContainer.html#RenderControl\">TGLContainer.RenderControl</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#BeforeRender"},
     {"title": "CastleUIControls.TUIControl.Render", "text": " Called only when <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GetExists\">GetExists</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLInitialized\">GLInitialized</a>, you can depend on it in the implementation of this method.  <p><b>Do not explicitly call this method.</b> Instead, render controls by adding them to the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> list, or render them explicitly (for off-screen rendering) by <a class=\"normal\" href=\"CastleGLContainer.TGLContainer.html#RenderControl\">TGLContainer.RenderControl</a>. This is method should only be overridden in your own code.  <p>Before calling this method we always set some OpenGL state, and you can depend on it (and you can carelessly change it, as it will be reset again before rendering other control).  <p>OpenGL state always set:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleGLUtils.html#GLViewport\">glViewport</a> is set to include whole container.</p></li>   <li><p>Depth test is off.</p></li>   <li><p><i>(For fixed-function pipeline:)</i> The 2D orthographic projection is always set at the beginning. Useful for 2D controls, 3D controls can just override projection matrix, e.g. use <a class=\"normal\" href=\"CastleGLUtils.html#PerspectiveProjection\">CastleGLUtils.PerspectiveProjection</a>.</p></li>   <li><p><i>(For fixed-function pipeline:)</i> The modelview matrix is set to identity. The matrix mode is always modelview.</p></li>   <li><p><i>(For fixed-function pipeline:)</i> The raster position is set to (0,0). The (deprecated) <a class=\"normal\" href=\"CastleGLUtils.html#WindowPos\">WindowPos</a> is also set to (0,0).</p></li>   <li><p><i>(For fixed-function pipeline:)</i> Texturing, lighting, fog is off.</p></li> </ul>  <p>  <p>Beware that GLSL <a class=\"normal\" href=\"CastleGLShaders.TGLSLProgram.html#Current\">TGLSLProgram.Current</a> has undefined value when this is called. You should always set it, before making direct OpenGL drawing calls (all the engine drawing routines of course do it already, this is only a concern if you make direct OpenGL / OpenGLES calls).    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Render"},
     {"title": "CastleUIControls.TUIControl.RenderOverChildren", "text": " This is analogous to <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">Render</a>, but it executes after children are drawn. You should usually prefer to override <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">Render</a> instead of this method, as the convention is that the parent is underneath children.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#RenderOverChildren"},
     {"title": "CastleUIControls.TUIControl.TooltipStyle", "text": " If you want to have tooltip for this control detected, you have to override <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipExists\">TooltipExists</a>. Then the TCastleWindowCustom.TooltipVisible will be detected, and your <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipRender\">TooltipRender</a> will be called.  <p>The values of <a class=\"normal\" href=\"CastleUIControls.html#rs2D\">rs2D</a> and <a class=\"normal\" href=\"CastleUIControls.html#rs3D\">rs3D</a> are interpreted in the same way as <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#RenderStyle\">RenderStyle</a>. And <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipRender\">TooltipRender</a> is called in the same way as <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">Render</a>, so e.g. you can safely assume that modelview matrix is identity and (for 2D) <a class=\"normal\" href=\"CastleGLUtils.html#WindowPos\">WindowPos</a> is zero. <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#TooltipRender\">TooltipRender</a> is always called as a last (front-most) 2D or 3D control.  <p>    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#TooltipStyle"},
     {"title": "CastleUIControls.TUIControl.TooltipExists", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#TooltipExists"},
     {"title": "CastleUIControls.TUIControl.TooltipRender", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#TooltipRender"},
     {"title": "CastleUIControls.TUIControl.GLContextOpen", "text": "  <p>This is called when OpenGL context of the container is created, or when the control is added to the already existing context. In other words, this is the moment when you can initialize OpenGL resources, like display lists, VBOs, OpenGL texture names, etc.  <p>As an exception, this is called regardless of the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GetExists\">GetExists</a> value. This way a control can prepare it's resources, regardless if it exists now.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#GLContextOpen"},
     {"title": "CastleUIControls.TUIControl.GLContextClose", "text": "  <p>Called when OpenGL context of the container is destroyed. Also called when controls is removed from the container <code>Controls</code> list. Also called from the destructor.  <p>You should release here any resources that are tied to the OpenGL context. In particular, the ones created in <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextOpen\">GLContextOpen</a>.  <p>As an exception, this is called regardless of the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GetExists\">GetExists</a> value. This way a control can release it's resources, regardless if it exists now.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#GLContextClose"},
     {"title": "CastleUIControls.TUIControl.SetFocused", "text": " In this class, they simply update Focused property. You can override this to react to mouse enter / mouse exit events.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#SetFocused"},
     {"title": "CastleUIControls.TUIControl.Rect", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><b>This must ignore</b> the current value of the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GetExists\">GetExists</a> method and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Exists\">Exists</a> property, that is: the result of this function assumes that control does exist.</p></li>   <li><p><b>This must ignore</b> the anchors. Their effect is applied outside of this method.</p></li>   <li><p><b>This must take into account</b> UI scaling. This method must calculate a result already multiplied by <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">UIScale</a>. In simple cases, this can be done easily, like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">function</span> TMyControl.Rect: TRectangle; <span class=\"pascal_keyword\">begin</span>   Result := Rectangle(Left, Bottom, Width, Height)<span class=\"pascal_float\">.</span>ScaleAround0(UIScale); <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>In fact, <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html\">TUIControlSizeable</a> already provides such implementation for you.</p></li> </ul>  <p>  <p>In this class, returns empty rectangle (zero width and height) with Left and Bottom correctly set (scaled by <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">UIScale</a>).  <p>    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Rect"},
     {"title": "CastleUIControls.TUIControl.CalculatedRect", "text": " Useful if you want to base other controls size/position on this control calculated size/position.  <p>This is similar to <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Rect\">Rect</a>, but:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><b>This takes into account</b> the anchors.</p></li>   <li><p><b>This ignores</b> the UI scaling.</p></li> </ul>  <p>  <p><b>If you implement descendants of this class</b>: Note that you cannot override this method. It is implemented by simply taking <code>RectWithAnchors</code> result (which in turn is derived from <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Rect\">Rect</a> result) and dividing it by <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">UIScale</a>. This should always be correct.  <p>Maybe in the future overriding this can be possible, but only for the sake of more optimal implementation.  <p>If you implement descendants, you should rather think about overriding the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Rect\">Rect</a> method, if your control has special sizing mechanism. The reason why we prefer overriding <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Rect\">Rect</a> (and <code>CalculatedRect</code> is just derived from it), not the other way around: it is because font measurements are already done in scaled coordinates (because UI scaling changes font size for <a class=\"normal\" href=\"CastleControls.TUIControlFont.html\">TUIControlFont</a>). So things like <a class=\"normal\" href=\"CastleControls.TCastleLabel.html\">TCastleLabel</a> have to calculate size in scaled coordinates anyway, and the unscaled size can only be derived from it by division.  <p>    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#CalculatedRect"},
     {"title": "CastleUIControls.TUIControl.CalculatedWidth", "text": " Useful if you want to base other controls size/position on this control calculated size.  <p>Unlike various other width properties of descendants (like <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Width\">TUIControlSizeable.Width</a> or <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Width\">TCastleImageControl.Width</a>), this is the <i>calculated</i> size, not the desired size. So this is already processed by any auto-sizing mechanism (e.g. <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html\">TCastleImageControl</a> may adjust it's own size to the underlying image, depending on settings).  <p>Unlike <code>Rect.Width</code>, this does not have UI scaling applied.  <p>It is always equal to just <code>CalculatedRect.Width</code>.  <p>    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#CalculatedWidth"},
     {"title": "CastleUIControls.TUIControl.CalculatedHeight", "text": " Useful if you want to base other controls size/position on this control calculated size.  <p>Unlike various other height properties of descendants (like <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Height\">TUIControlSizeable.Height</a> or <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html#Height\">TCastleImageControl.Height</a>), this is the <i>calculated</i> size, not the desired size. So this is already processed by any auto-sizing mechanism (e.g. <a class=\"normal\" href=\"CastleControls.TCastleImageControl.html\">TCastleImageControl</a> may adjust it's own size to the underlying image, depending on settings).  <p>Unlike <code>Rect.Height</code>, this does not have UI scaling applied.  <p>It is always equal to just <code>CalculatedRect.Height</code>.  <p>    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#CalculatedHeight"},
     {"title": "CastleUIControls.TUIControl.ScreenRect", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#ScreenRect"},
     {"title": "CastleUIControls.TUIControl.LocalToScreenTranslation", "text": " If you use UI scaling, this works in final coordinates (after scaling, real pixels on screen).    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#LocalToScreenTranslation"},
     {"title": "CastleUIControls.TUIControl.ParentRect", "text": " Since this is in local coordinates, the returned rectangle Left and Bottom are always zero. This is already scaled by UI scaling, since it's derived from <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Rect\">Rect</a> size that should also be already scaled.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#ParentRect"},
     {"title": "CastleUIControls.TUIControl.Anchor", "text": " Sets <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HasHorizontalAnchor\">HasHorizontalAnchor</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HorizontalAnchorSelf\">HorizontalAnchorSelf</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HorizontalAnchorParent\">HorizontalAnchorParent</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HorizontalAnchorDelta\">HorizontalAnchorDelta</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Anchor"},
     {"title": "CastleUIControls.TUIControl.Anchor", "text": " Sets <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HasHorizontalAnchor\">HasHorizontalAnchor</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HorizontalAnchorSelf\">HorizontalAnchorSelf</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HorizontalAnchorParent\">HorizontalAnchorParent</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HorizontalAnchorDelta\">HorizontalAnchorDelta</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Anchor"},
     {"title": "CastleUIControls.TUIControl.Anchor", "text": " Sets <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HasVerticalAnchor\">HasVerticalAnchor</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#VerticalAnchorSelf\">VerticalAnchorSelf</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#VerticalAnchorParent\">VerticalAnchorParent</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#VerticalAnchorDelta\">VerticalAnchorDelta</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Anchor"},
     {"title": "CastleUIControls.TUIControl.Anchor", "text": " Sets <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HasVerticalAnchor\">HasVerticalAnchor</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#VerticalAnchorSelf\">VerticalAnchorSelf</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#VerticalAnchorParent\">VerticalAnchorParent</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#VerticalAnchorDelta\">VerticalAnchorDelta</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Anchor"},
     {"title": "CastleUIControls.TUIControl.AlignHorizontal", "text": " Deprecated, use <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Align\">Align</a> with <a class=\"normal\" href=\"CastleRectangles.html#THorizontalPosition\">THorizontalPosition</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#AlignHorizontal"},
     {"title": "CastleUIControls.TUIControl.Align", "text": "  <p>Note that using <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Anchor\">Anchor</a> is often more comfortable than this method, since you only need to set anchor once (for example, right after creating the control). In contract, adjusting position using this method will typically need to be repeated at each window on resize, like in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">TCastleWindowCustom.OnResize</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Align"},
     {"title": "CastleUIControls.TUIControl.AlignVertical", "text": " Deprecated, use <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Align\">Align</a> with <a class=\"normal\" href=\"CastleRectangles.html#TVerticalPosition\">TVerticalPosition</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#AlignVertical"},
     {"title": "CastleUIControls.TUIControl.Align", "text": "  <p>Note that using <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Anchor\">Anchor</a> is often more comfortable than this method, since you only need to set anchor once (for example, right after creating the control). In contract, adjusting position using this method will typically need to be repeated at each window on resize, like in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">TCastleWindowCustom.OnResize</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Align"},
     {"title": "CastleUIControls.TUIControl.Center", "text": "  <p>Note that using <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Anchor\">Anchor</a> is often more comfortable than this method, since you only need to set anchor once. For example, right after creating the control call <code>Anchor(<a class=\"normal\" href=\"CastleUIControls.html#hpMiddle\">hpMiddle</a>); Anchor(<a class=\"normal\" href=\"CastleUIControls.html#vpMiddle\">vpMiddle</a>);</code>. In contrast, adjusting position using this method will typically need to be repeated at each window on resize, like in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">TCastleWindowCustom.OnResize</a>.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Center"},
     {"title": "CastleUIControls.TUIControl.UIScale", "text": "  <p>All the drawing and measuring inside your control must take this into account. The final <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Rect\">Rect</a> result must already take this scaling into account, so that parent controls may depend on it. All descendants, like <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html\">TUIControlSizeable</a>, provide a <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Rect\">Rect</a> implementation that does what is necessary.    ", "tags": "", "loc": "CastleUIControls.TUIControl.html#UIScale"},
     {"title": "CastleUIControls.TUIControl.Controls", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Controls"},
     {"title": "CastleUIControls.TUIControl.RenderStyle", "text": " All controls with <code>RenderStyle</code> = <a class=\"normal\" href=\"CastleUIControls.html#rs3D\">rs3D</a> are drawn first. Then all the controls with <code>RenderStyle</code> = <a class=\"normal\" href=\"CastleUIControls.html#rs2D\">rs2D</a> are drawn. Among the controls with equal <code>RenderStyle</code>, their order on <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> list determines the rendering order. ", "tags": "", "loc": "CastleUIControls.TUIControl.html#RenderStyle"},
     {"title": "CastleUIControls.TUIControl.GLInitialized", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#GLInitialized"},
     {"title": "CastleUIControls.TUIControl.DisableContextOpenClose", "text": "  <p>This can be useful as an optimization, to keep the OpenGL resources created even for controls that are not present on the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> list. <i>This must used very, very carefully</i>, as bad things will happen if the actual OpenGL context will be destroyed while the control keeps the OpenGL resources (because it had <code>DisableContextOpenClose</code> &gt; 0). The control will then remain having incorrect OpenGL resource handles, and will try to use them, causing OpenGL errors or at least weird display artifacts.  <p>Most of the time, when you think of using this, you should instead use the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Exists\">TUIControl.Exists</a> property. This allows you to keep the control of the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> list, and it will be receive <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextOpen\">GLContextOpen</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextClose\">GLContextClose</a> events as usual, but will not exist for all other purposes.  <p>Using this mechanism is only sensible if you want to reliably hide a control, but also allow readding it to the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> list, and then you want to show it again. This is useful for <a class=\"normal\" href=\"CastleWindowModes.html\">CastleWindowModes</a>, that must push (and then pop) the controls, but then allows the caller to modify the controls list. And some games, e.g. castle1, add back some (but not all) of the just-hidden controls. For example the <a class=\"normal\" href=\"CastleNotifications.TCastleNotifications.html\">TCastleNotifications</a> instance is added back, to be visible even in the menu mode. This means that <a class=\"normal\" href=\"CastleWindowModes.html\">CastleWindowModes</a> cannot just modify the TUIContainer.Exists value, leaving the control on the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> list: it would leave the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> existing many times on the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> list, with the undefined TUIContainer.Exists value. ", "tags": "", "loc": "CastleUIControls.TUIControl.html#DisableContextOpenClose"},
     {"title": "CastleUIControls.TUIControl.Focused", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Focused"},
     {"title": "CastleUIControls.TUIControl.Parent", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Parent"},
     {"title": "CastleUIControls.TUIControl.Exists", "text": " You can also remove this from controls list (like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a>), but often it's more comfortable to set this property to false. ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Exists"},
     {"title": "CastleUIControls.TUIControl.Left", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Left"},
     {"title": "CastleUIControls.TUIControl.Bottom", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#Bottom"},
     {"title": "CastleUIControls.TUIControl.HasHorizontalAnchor", "text": " Note that the value of <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Left\">Left</a> remains unchanged (it is just ignored), using the anchors only modifies the output of the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ScreenRect\">ScreenRect</a> value that should be used for rendering/physics.  <p><i>Anchor distance is automatically affected by <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">TUIContainer.UIScaling</a>.</i> ", "tags": "", "loc": "CastleUIControls.TUIControl.html#HasHorizontalAnchor"},
     {"title": "CastleUIControls.TUIControl.HorizontalAnchorSelf", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#HorizontalAnchorSelf"},
     {"title": "CastleUIControls.TUIControl.HorizontalAnchorParent", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#HorizontalAnchorParent"},
     {"title": "CastleUIControls.TUIControl.HorizontalAnchorDelta", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#HorizontalAnchorDelta"},
     {"title": "CastleUIControls.TUIControl.HasVerticalAnchor", "text": " Note that the value of <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Bottom\">Bottom</a> remains unchanged (it is tjust ignored), using the anchors only modifies the output of the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#ScreenRect\">ScreenRect</a> value that should be used for rendering/physics.  <p><i>Anchor distance is automatically affected by <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">TUIContainer.UIScaling</a>.</i> ", "tags": "", "loc": "CastleUIControls.TUIControl.html#HasVerticalAnchor"},
     {"title": "CastleUIControls.TUIControl.VerticalAnchorSelf", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#VerticalAnchorSelf"},
     {"title": "CastleUIControls.TUIControl.VerticalAnchorParent", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#VerticalAnchorParent"},
     {"title": "CastleUIControls.TUIControl.VerticalAnchorDelta", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#VerticalAnchorDelta"},
     {"title": "CastleUIControls.TUIControl.EnableUIScaling", "text": " See more about UI scaling on <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIScaling\">TUIContainer.UIScaling</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">TUIControl.UIScale</a>. Setting this to <code>False</code> forces <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">TUIControl.UIScale</a> to always return 1.0.  <p>Note that this does not work recursively, i.e. it does not affect the children of this control. Setting this to <code>False</code> does not prevent UI scaling on children (you have to turn it off explicitly for children too, if you need to disable UI scaling recursively). ", "tags": "", "loc": "CastleUIControls.TUIControl.html#EnableUIScaling"},
     {"title": "CastleUIControls.TUIControl.KeepInFront", "text": "  <p>TODO: Do not change this propertyu while the control is already a children of something. ", "tags": "", "loc": "CastleUIControls.TUIControl.html#KeepInFront"},
     {"title": "CastleUIControls.TUIControl.CapturesEvents", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControl.html#CapturesEvents"},
     {"title": "CastleUIControls.TUIControlSizeable", "text": " By itself, this does not show anything. But it's useful as an ancestor class for new UI classes that want their size to be fully configurable, or as a container for UI children. ", "tags": "", "loc": "CastleUIControls.TUIControlSizeable.html"},
     {"title": "CastleUIControls.TUIControlSizeable.Create", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControlSizeable.html#Create"},
     {"title": "CastleUIControls.TUIControlSizeable.Rect", "text": "  <p>Looks at <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#FullSize\">FullSize</a> value, and the parent size (when <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#FullSize\">FullSize</a> is <code>True</code>), or at the properties <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Left\">Left</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Bottom\">Bottom</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Width\">Width</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Height\">Height</a> (when <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#FullSize\">FullSize</a> is <code>False</code>).    ", "tags": "", "loc": "CastleUIControls.TUIControlSizeable.html#Rect"},
     {"title": "CastleUIControls.TUIControlSizeable.FullSize", "text": "  <p>When <code>FullSize</code> is <code>True</code>, the control always fills the whole parent (like <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> or <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a>, if you just placed the control on <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> or <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html#Controls\">TCastleControlCustom.Controls</a>), and the values of <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Left\">Left</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Bottom\">Bottom</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Width\">Width</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControlSizeable.html#Height\">Height</a> are ignored.  <p>  <p> ", "tags": "", "loc": "CastleUIControls.TUIControlSizeable.html#FullSize"},
     {"title": "CastleUIControls.TUIControlSizeable.Width", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControlSizeable.html#Width"},
     {"title": "CastleUIControls.TUIControlSizeable.Height", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControlSizeable.html#Height"},
     {"title": "CastleUIControls.TUIControlList", "text": " ", "tags": "", "loc": "CastleUIControls.TUIControlList.html"},
     {"title": "CastleUIControls.TUIControlList.InsertFront", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControlList.html#InsertFront"},
     {"title": "CastleUIControls.TUIControlList.InsertFrontIfNotExists", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControlList.html#InsertFrontIfNotExists"},
     {"title": "CastleUIControls.TUIControlList.InsertFront", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControlList.html#InsertFront"},
     {"title": "CastleUIControls.TUIControlList.InsertBack", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControlList.html#InsertBack"},
     {"title": "CastleUIControls.TUIControlList.InsertBackIfNotExists", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControlList.html#InsertBackIfNotExists"},
     {"title": "CastleUIControls.TUIControlList.InsertBack", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControlList.html#InsertBack"},
     {"title": "CastleUIControls.TUIControlList.InsertWithZOrder", "text": "    ", "tags": "", "loc": "CastleUIControls.TUIControlList.html#InsertWithZOrder"},
     {"title": "CastleUIControls.TChildrenControls", "text": " Ordered from back to front. Used for <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a>. ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html"},
     {"title": "CastleUIControls.TChildrenControls.Create", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#Create"},
     {"title": "CastleUIControls.TChildrenControls.Destroy", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#Destroy"},
     {"title": "CastleUIControls.TChildrenControls.Count", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#Count"},
     {"title": "CastleUIControls.TChildrenControls.Assign", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#Assign"},
     {"title": "CastleUIControls.TChildrenControls.Remove", "text": " Note that the given Item should always exist only once on a list (it is not allowed to add it multiple times), so there's no <code>RemoveAll</code> method.    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#Remove"},
     {"title": "CastleUIControls.TChildrenControls.Clear", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#Clear"},
     {"title": "CastleUIControls.TChildrenControls.Add", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#Add"},
     {"title": "CastleUIControls.TChildrenControls.Insert", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#Insert"},
     {"title": "CastleUIControls.TChildrenControls.IndexOf", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#IndexOf"},
     {"title": "CastleUIControls.TChildrenControls.MakeSingle", "text": " See <a class=\"normal\" href=\"CastleClassUtils.TCastleObjectList.html#MakeSingle\">TCastleObjectList.MakeSingle</a> for precise description.    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#MakeSingle"},
     {"title": "CastleUIControls.TChildrenControls.InsertFront", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#InsertFront"},
     {"title": "CastleUIControls.TChildrenControls.InsertFrontIfNotExists", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#InsertFrontIfNotExists"},
     {"title": "CastleUIControls.TChildrenControls.InsertFront", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#InsertFront"},
     {"title": "CastleUIControls.TChildrenControls.InsertBack", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#InsertBack"},
     {"title": "CastleUIControls.TChildrenControls.InsertBackIfNotExists", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#InsertBackIfNotExists"},
     {"title": "CastleUIControls.TChildrenControls.InsertBack", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#InsertBack"},
     {"title": "CastleUIControls.TChildrenControls.InsertIfNotExists", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#InsertIfNotExists"},
     {"title": "CastleUIControls.TChildrenControls.AddIfNotExists", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#AddIfNotExists"},
     {"title": "CastleUIControls.TChildrenControls.BeginDisableContextOpenClose", "text": " <a class=\"normal\" href=\"CastleUIControls.TChildrenControls.html#EndDisableContextOpenClose\">EndDisableContextOpenClose</a> ends this. They work by increasing / decreasing the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#DisableContextOpenClose\">TUIControl.DisableContextOpenClose</a> for all the items on the list.  <p>    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#BeginDisableContextOpenClose"},
     {"title": "CastleUIControls.TChildrenControls.EndDisableContextOpenClose", "text": "    ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#EndDisableContextOpenClose"},
     {"title": "CastleUIControls.TChildrenControls.Items", "text": " ", "tags": "", "loc": "CastleUIControls.TChildrenControls.html#Items"},
     {"title": "CastleUIControls.DefaultDpi", "text": " ", "tags": "", "loc": "CastleUIControls.html#DefaultDpi"},
     {"title": "CastleUIControls.DefaultTooltipDelay", "text": " ", "tags": "", "loc": "CastleUIControls.html#DefaultTooltipDelay"},
     {"title": "CastleUIControls.DefaultTooltipDistance", "text": " ", "tags": "", "loc": "CastleUIControls.html#DefaultTooltipDistance"},
     {"title": "CastleUIControls.ds2D", "text": " ", "tags": "", "loc": "CastleUIControls.html#ds2D"},
     {"title": "CastleUIControls.ds3D", "text": " ", "tags": "", "loc": "CastleUIControls.html#ds3D"},
     {"title": "CastleUIControls.prLeft", "text": " ", "tags": "", "loc": "CastleUIControls.html#prLeft"},
     {"title": "CastleUIControls.prRight", "text": " ", "tags": "", "loc": "CastleUIControls.html#prRight"},
     {"title": "CastleUIControls.prBottom", "text": " ", "tags": "", "loc": "CastleUIControls.html#prBottom"},
     {"title": "CastleUIControls.prTop", "text": " ", "tags": "", "loc": "CastleUIControls.html#prTop"},
     {"title": "CastleUIControls.hpLeft", "text": " ", "tags": "", "loc": "CastleUIControls.html#hpLeft"},
     {"title": "CastleUIControls.hpMiddle", "text": " ", "tags": "", "loc": "CastleUIControls.html#hpMiddle"},
     {"title": "CastleUIControls.hpRight", "text": " ", "tags": "", "loc": "CastleUIControls.html#hpRight"},
     {"title": "CastleUIControls.vpBottom", "text": " ", "tags": "", "loc": "CastleUIControls.html#vpBottom"},
     {"title": "CastleUIControls.vpMiddle", "text": " ", "tags": "", "loc": "CastleUIControls.html#vpMiddle"},
     {"title": "CastleUIControls.vpTop", "text": " ", "tags": "", "loc": "CastleUIControls.html#vpTop"},
     {"title": "CastleUIControls.OnGLContextOpen", "text": "    ", "tags": "", "loc": "CastleUIControls.html#OnGLContextOpen"},
     {"title": "CastleUIControls.OnGLContextClose", "text": "    ", "tags": "", "loc": "CastleUIControls.html#OnGLContextClose"},
     {"title": "CastleUIControls.IsGLContextOpen", "text": "    ", "tags": "", "loc": "CastleUIControls.html#IsGLContextOpen"},
     {"title": "CastleUIControls.TRenderStyle", "text": " All 3D controls are always under all 2D controls. See <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a>, <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#RenderStyle\">TUIControl.RenderStyle</a>.  rs2D    rs3D   ", "tags": "", "loc": "CastleUIControls.html#TRenderStyle"},
     {"title": "CastleUIControls.TContainerEvent", "text": "    ", "tags": "", "loc": "CastleUIControls.html#TContainerEvent"},
     {"title": "CastleUIControls.TContainerObjectEvent", "text": "    ", "tags": "", "loc": "CastleUIControls.html#TContainerObjectEvent"},
     {"title": "CastleUIControls.TInputPressReleaseEvent", "text": "    ", "tags": "", "loc": "CastleUIControls.html#TInputPressReleaseEvent"},
     {"title": "CastleUIControls.TInputMotionEvent", "text": "    ", "tags": "", "loc": "CastleUIControls.html#TInputMotionEvent"},
     {"title": "CastleUIControls.PTouch", "text": " ", "tags": "", "loc": "CastleUIControls.html#PTouch"},
     {"title": "CastleUIControls.TUIScaling", "text": "  usNone Do not scale UI.   usEncloseReferenceSize Scale to fake that the container sizes enclose <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIReferenceWidth\">TUIContainer.UIReferenceWidth</a> and <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIReferenceHeight\">TUIContainer.UIReferenceHeight</a>.  So one size will be equal to reference size, and the other will be equal or larger to reference.  <p>Controls that look at <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">TUIControl.UIScale</a> will be affected by this. Together with anchors (see <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HasHorizontalAnchor\">TUIControl.HasHorizontalAnchor</a> and friends), this allows to easily design a scalable UI.  usFitReferenceSize Scale to fake that the container sizes fit inside <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIReferenceWidth\">TUIContainer.UIReferenceWidth</a> and <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIReferenceHeight\">TUIContainer.UIReferenceHeight</a>.  So one size will be equal to reference size, and the other will be equal or smaller to reference.  <p>Controls that look at <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">TUIControl.UIScale</a> will be affected by this. Together with anchors (see <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#HasHorizontalAnchor\">TUIControl.HasHorizontalAnchor</a> and friends), this allows to easily design a scalable UI.  usExplicitScale Scale to fake that the container sizes are smaller/larger by an explicit factor <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIExplicitScale\">TUIContainer.UIExplicitScale</a>.  Controls that look at <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#UIScale\">TUIControl.UIScale</a> will be affected by this.  <p>Like <a class=\"normal\" href=\"CastleUIControls.html#usEncloseReferenceSize\">usEncloseReferenceSize</a> or <a class=\"normal\" href=\"CastleUIControls.html#usFitReferenceSize\">usFitReferenceSize</a>, this allows to design a scalable UI. In this case, the scale factor has to be calculated by your code (by default <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIExplicitScale\">TUIContainer.UIExplicitScale</a> is 1.0 and the engine will not modify it automatically in any way), which allows customizing the scale to your requirements.  <p>For example derive the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#UIExplicitScale\">TUIContainer.UIExplicitScale</a> from the <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Dpi\">TUIContainer.Dpi</a> value to keep UI controls at constant <i>physical</i> (real-world) size, at least on devices where <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Dpi\">TUIContainer.Dpi</a> is a real value (right now: iOS). ", "tags": "", "loc": "CastleUIControls.html#TUIScaling"},
     {"title": "CastleUIControls.TPositionRelative", "text": "  Deprecated, rather use cleaner <a class=\"normal\" href=\"CastleRectangles.html#THorizontalPosition\">THorizontalPosition</a> and <a class=\"normal\" href=\"CastleRectangles.html#TVerticalPosition\">TVerticalPosition</a>.  prLow    prMiddle    prHigh   ", "tags": "", "loc": "CastleUIControls.html#TPositionRelative"},
     {"title": "CastleUIControls.TUIControlClass", "text": " ", "tags": "", "loc": "CastleUIControls.html#TUIControlClass"},
     {"title": "CastleUIControls.TUIControlPos", "text": " ", "tags": "", "loc": "CastleUIControls.html#TUIControlPos"},
     {"title": "CastleUIControls.TUIRectangularControl", "text": " ", "tags": "", "loc": "CastleUIControls.html#TUIRectangularControl"},
     {"title": "CastleUIState", "text": " ", "tags": "", "loc": "CastleUIState.html"},
     {"title": "CastleUIState.TUIState", "text": " See also <a  href=\"https://castle-engine.sourceforge.io/manual_2d_user_interface.php#section_ui_state\">https://castle-engine.sourceforge.io/manual_2d_user_interface.php#section_ui_state</a> for an overview of using <code>TUIState</code>.  <p>In simple cases, only one state is <i>current</i> at a given time, and it can be get or set using the <a class=\"normal\" href=\"CastleUIState.TUIState.html#Current\">TUIState.Current</a> property. In more complex cases, you can use <a class=\"normal\" href=\"CastleUIState.TUIState.html#Push\">TUIState.Push</a> and <a class=\"normal\" href=\"CastleUIState.TUIState.html#Pop\">TUIState.Pop</a> to build a stack of states, and in effect multiple states are active at the same time. All of the states on stack are <i>started</i>, but only the top-most is <i>resumed</i>.  <p>Each state has <a class=\"normal\" href=\"CastleUIState.TUIState.html#Start\">Start</a> and <a class=\"normal\" href=\"CastleUIState.TUIState.html#Stop\">Stop</a> methods that you can override to perform work when state becomes part of the current state stack, or stops being part of it. You can also override <a class=\"normal\" href=\"CastleUIState.TUIState.html#Resume\">Resume</a> and <a class=\"normal\" href=\"CastleUIState.TUIState.html#Pause\">Pause</a> methods, to perform work when the state becomes the top-most state or is no longer the top-most state. The distinction becomes important once you play around with pushing/popping states. The names are deliberaly similar to Android lifecycle callback names.  <p>You can add/remove state-specific UI controls in various ways. You can add them in the constructor of this state (and then free in destructor), or add them in <a class=\"normal\" href=\"CastleUIState.TUIState.html#Start\">Start</a>, free in <a class=\"normal\" href=\"CastleUIState.TUIState.html#Stop\">Stop</a>.  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>It's simplest and best to add/keep children controls as real children of the current state, so add them using methods <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#InsertFront\">TUIControl.InsertFront</a> and <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#InsertBack\">TUIControl.InsertBack</a>.</p></li>   <li value=\"2\"><p>Eventually, for special tricks, you can add controls that are conceptually the state &quot;children&quot; directly to the <code>StateContainer.Controls</code> list. This allows to keep some children on the <code>StateContainer.Controls</code> list for a longer time (not only when this state is active), which may be useful for optimization, to not reinitialize GL resources too often. To do this, add controls using <code>StateContainer.Controls.InsertFront(...)</code>, remove them by <code>StateContainer.Controls.Remove(...)</code>, and make sure to override <a class=\"normal\" href=\"CastleUIState.TUIState.html#InsertAtPosition\">InsertAtPosition</a> method such that state instance is inserted in <code>StateContainer.Controls</code> right behind your UI.</p></li> </ol>  <p>  <p>Current state is also placed on the list of container controls. This way state is notified about UI events, and can react to them. Since state-specific UI should always be at the front of us, or our children, so in case of events that can be &quot;handled&quot; (like TUIControl.Press, TUIControl.Release events) the state-specific UI controls will handle them <i>before</i> the state itself (if you override TUIControl.Press or such in state, be sure to call <code>inherited</code> first, to make sure it really happens).  <p>This way state can  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>catch press/release and similar events, when no other state-specific control handled them,</p></li>   <li><p>catch update, GL context open/close and other useful events,</p></li>   <li><p>can have it's own render function, to directly draw UI.</p></li> </ul>  <p>  <p>See the <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> class for a lot of useful methods that you can override in your state descendants to capture various events. ", "tags": "", "loc": "CastleUIState.TUIState.html"},
     {"title": "CastleUIState.TUIState.Log", "text": " ", "tags": "", "loc": "CastleUIState.TUIState.html#Log"},
     {"title": "CastleUIState.TUIState.StateContainer", "text": " By default, this is Application.MainWindow. When the state is current, then <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Container\">Container</a> property (from ancestor, see TUIControl.Container) is equal to this.    ", "tags": "", "loc": "CastleUIState.TUIState.html#StateContainer"},
     {"title": "CastleUIState.TUIState.InsertAtPosition", "text": " By default, state is inserted as the front-most control, so position is equal to <code>StateContainer.Controls.Count</code>.    ", "tags": "", "loc": "CastleUIState.TUIState.html#InsertAtPosition"},
     {"title": "CastleUIState.TUIState.FreeAtStop", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#FreeAtStop"},
     {"title": "CastleUIState.TUIState.Push", "text": "  <p>The state known as <a class=\"normal\" href=\"CastleUIState.TUIState.html#Current\">Current</a> is conceptually at the bottom of state stack, always. When it is nil, then pushing new state sets the <a class=\"normal\" href=\"CastleUIState.TUIState.html#Current\">Current</a> state. Otherwise <a class=\"normal\" href=\"CastleUIState.TUIState.html#Current\">Current</a> state is left as-it-is, new state is added on top.    ", "tags": "", "loc": "CastleUIState.TUIState.html#Push"},
     {"title": "CastleUIState.TUIState.Pop", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#Pop"},
     {"title": "CastleUIState.TUIState.Pop", "text": " Makes a warning, and does nothing, if the current top-most state is different than indicated. This is usually a safer (more chance to easily catch bugs) version of Pop than the parameter-less version.    ", "tags": "", "loc": "CastleUIState.TUIState.html#Pop"},
     {"title": "CastleUIState.TUIState.StateStackCount", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#StateStackCount"},
     {"title": "CastleUIState.TUIState.Create", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#Create"},
     {"title": "CastleUIState.TUIState.Destroy", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#Destroy"},
     {"title": "CastleUIState.TUIState.Start", "text": "  <p>Started state is part of the <a class=\"normal\" href=\"CastleUIState.TUIState.html#StateStack\">StateStack</a>, and will soon become running (top-most on the stack). When the state is set to be current, by <code><a class=\"normal\" href=\"CastleUIState.TUIState.html#Current\">TUIState.Current</a> := MyState</code>, this happens:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>MyStart is pushed as the top-most state on state stack.</p></li>   <li value=\"2\"><p>MyStart.Start is called.</p></li>   <li value=\"3\"><p>MyStart is added to the <code>StateContainer.Controls</code> list, so the state methods <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextOpen\">GLContextOpen</a> and Resize are called (as for all normal <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> instances).</p></li>   <li value=\"4\"><p>MyStar.Resume is called.</p></li> </ol>  <p>    ", "tags": "", "loc": "CastleUIState.TUIState.html#Start"},
     {"title": "CastleUIState.TUIState.Stop", "text": "  <p>When the state stops becoming active, this happens:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>MyStart.Pause is called.</p></li>   <li value=\"2\"><p>MyStart is removed from the <code>StateContainer.Controls</code> list. So the state method <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#GLContextClose\">GLContextClose</a> is called (as for all normal <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> instances).</p></li>   <li value=\"3\"><p>MyStart.Stop is called.</p></li>   <li value=\"4\"><p>MyStart is removed from the on state stack.</p></li> </ol>  <p>  <p>This is always called to finalize the started state. When the state is destroyed, it's <a class=\"normal\" href=\"CastleUIState.TUIState.html#Pause\">Pause</a> and <a class=\"normal\" href=\"CastleUIState.TUIState.html#Stop\">Stop</a> are called too, so you can use this method to reliably finalize whatever you initialized in <a class=\"normal\" href=\"CastleUIState.TUIState.html#Start\">Start</a>.    ", "tags": "", "loc": "CastleUIState.TUIState.html#Stop"},
     {"title": "CastleUIState.TUIState.Resume", "text": " See <a class=\"normal\" href=\"CastleUIState.TUIState.html#Start\">Start</a> and <a class=\"normal\" href=\"CastleUIState.TUIState.html#Stop\">Stop</a> docs about state lifecycle methods. This is called after <a class=\"normal\" href=\"CastleUIState.TUIState.html#Start\">Start</a>, it is also called when you pop another state, making this state the top-most.    ", "tags": "", "loc": "CastleUIState.TUIState.html#Resume"},
     {"title": "CastleUIState.TUIState.Pause", "text": " See <a class=\"normal\" href=\"CastleUIState.TUIState.html#Start\">Start</a> and <a class=\"normal\" href=\"CastleUIState.TUIState.html#Stop\">Stop</a> docs about state lifecycle methods. This is called before <a class=\"normal\" href=\"CastleUIState.TUIState.html#Stop\">Stop</a>, it is also called when another state is pushed over this state, so this stops being the the top-most state.    ", "tags": "", "loc": "CastleUIState.TUIState.html#Pause"},
     {"title": "CastleUIState.TUIState.Finish", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#Finish"},
     {"title": "CastleUIState.TUIState.Rect", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#Rect"},
     {"title": "CastleUIState.TUIState.Active", "text": " The state is added to the stack before the <a class=\"normal\" href=\"CastleUIState.TUIState.html#Start\">Start</a> call, and removed after the <a class=\"normal\" href=\"CastleUIState.TUIState.html#Stop\">Stop</a> call, so this returns <code>True</code> during all the methods &mdash; <a class=\"normal\" href=\"CastleUIState.TUIState.html#Start\">Start</a>, <a class=\"normal\" href=\"CastleUIState.TUIState.html#Resume\">Resume</a>, <a class=\"normal\" href=\"CastleUIState.TUIState.html#Pause\">Pause</a>, <a class=\"normal\" href=\"CastleUIState.TUIState.html#Stop\">Stop</a>.    ", "tags": "", "loc": "CastleUIState.TUIState.html#Active"},
     {"title": "CastleUIState.TUIState.Press", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#Press"},
     {"title": "CastleUIState.TUIState.Release", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#Release"},
     {"title": "CastleUIState.TUIState.Motion", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#Motion"},
     {"title": "CastleUIState.TUIState.Update", "text": "    ", "tags": "", "loc": "CastleUIState.TUIState.html#Update"},
     {"title": "CastleUIState.TUIState.Current", "text": " In case multiple states are active (only possible if you used <a class=\"normal\" href=\"CastleUIState.TUIState.html#Push\">Push</a> method), this is the bottom state (use <a class=\"normal\" href=\"CastleUIState.TUIState.html#CurrentTop\">CurrentTop</a> to get top state). Setting this resets whole state stack. ", "tags": "", "loc": "CastleUIState.TUIState.html#Current"},
     {"title": "CastleUIState.TUIState.CurrentTop", "text": " ", "tags": "", "loc": "CastleUIState.TUIState.html#CurrentTop"},
     {"title": "CastleUIState.TUIState.StateStack", "text": " ", "tags": "", "loc": "CastleUIState.TUIState.html#StateStack"},
     {"title": "CastleUIState.TUIState.InterceptInput", "text": "  <p>More precisely, when this property is <code>True</code>, then the <a class=\"normal\" href=\"CastleUIState.TUIState.html#Press\">Press</a>, <a class=\"normal\" href=\"CastleUIState.TUIState.html#Release\">Release</a> and <a class=\"normal\" href=\"CastleUIState.TUIState.html#Motion\">Motion</a> events are marked as &quot;handled&quot; in this UI state. This means that they will not be processed further, by UI controls under this state, in particular by UI states that are underneath this state in <i>state stack</i> (created by <a class=\"normal\" href=\"CastleUIState.TUIState.html#Push\">Push</a> method). They will also not be passed to final container (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a>, <a class=\"normal\" href=\"CastleControl.TCastleControlCustom.html\">TCastleControlCustom</a>) callbacks like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnPress\">TCastleWindowCustom.OnPress</a> (as these callbacks are always used at the end, when nothing else handled the event). ", "tags": "", "loc": "CastleUIState.TUIState.html#InterceptInput"},
     {"title": "CastleUIState.TUIStateList", "text": " ", "tags": "", "loc": "CastleUIState.TUIStateList.html"},
     {"title": "CastleUnicode", "text": " ", "tags": "", "loc": "CastleUnicode.html"},
     {"title": "CastleUnicode.TUnicodeCharList", "text": " ", "tags": "", "loc": "CastleUnicode.TUnicodeCharList.html"},
     {"title": "CastleUnicode.TUnicodeCharList.Add", "text": "    ", "tags": "", "loc": "CastleUnicode.TUnicodeCharList.html#Add"},
     {"title": "CastleUnicode.TUnicodeCharList.Add", "text": " Useful to fill <a class=\"normal\" href=\"CastleUnicode.TUnicodeCharList.html\">TUnicodeCharList</a> when you have a sample text of international letters.    ", "tags": "", "loc": "CastleUnicode.TUnicodeCharList.html#Add"},
     {"title": "CastleUnicode.TUnicodeCharList.Add", "text": " Try e.g. <a class=\"normal\" href=\"CastleStringUtils.html#SimpleAsciiCharacters\">SimpleAsciiCharacters</a>.    ", "tags": "", "loc": "CastleUnicode.TUnicodeCharList.html#Add"},
     {"title": "CastleUnicode.UTF8CharacterLength", "text": "    ", "tags": "", "loc": "CastleUnicode.html#UTF8CharacterLength"},
     {"title": "CastleUnicode.UTF8Length", "text": "    ", "tags": "", "loc": "CastleUnicode.html#UTF8Length"},
     {"title": "CastleUnicode.UTF8Length", "text": "    ", "tags": "", "loc": "CastleUnicode.html#UTF8Length"},
     {"title": "CastleUnicode.UTF8CharStart", "text": "    ", "tags": "", "loc": "CastleUnicode.html#UTF8CharStart"},
     {"title": "CastleUnicode.UTF8Copy", "text": "    ", "tags": "", "loc": "CastleUnicode.html#UTF8Copy"},
     {"title": "CastleUnicode.UTF8CharacterToUnicode", "text": " CharLen is set to 0 only when pointer P is <code>Nil</code>, otherwise it's always &gt; 0.  <p>The typical usage of this is to iterate over UTF-8 string char-by-char, like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   C: TUnicodeChar;   TextPtr: PChar;   CharLen: Integer; <span class=\"pascal_keyword\">begin</span>   TextPtr := PChar(S);   C := UTF8CharacterToUnicode(TextPtr, CharLen);   <span class=\"pascal_keyword\">while</span> (C &gt; <span class=\"pascal_numeric\">0</span>) <span class=\"pascal_keyword\">and</span> (CharLen &gt; <span class=\"pascal_numeric\">0</span>) <span class=\"pascal_keyword\">do</span>   <span class=\"pascal_keyword\">begin</span>     Inc(TextPtr, CharLen);     <span class=\"pascal_comment\">// here process C...</span>     C := UTF8CharacterToUnicode(TextPtr, CharLen);   <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p>    ", "tags": "", "loc": "CastleUnicode.html#UTF8CharacterToUnicode"},
     {"title": "CastleUnicode.UnicodeToUTF8", "text": "    ", "tags": "", "loc": "CastleUnicode.html#UnicodeToUTF8"},
     {"title": "CastleUnicode.UnicodeToUTF8Inline", "text": "    ", "tags": "", "loc": "CastleUnicode.html#UnicodeToUTF8Inline"},
     {"title": "CastleUnicode.TUnicodeChar", "text": " ", "tags": "", "loc": "CastleUnicode.html#TUnicodeChar"},
     {"title": "CastleURIUtils", "text": " These extend standard FPC URIParser unit. ", "tags": "", "loc": "CastleURIUtils.html"},
     {"title": "CastleURIUtils.URIExtractAnchor", "text": " On input, URI contains full URI. On output, Anchor is removed from URI and saved in Anchor. If no #anchor existed, Anchor is set to ''.  <p>When RecognizeEvenEscapedHash, we also recognize as a delimiter escaped hash, %23. This is a hack and should not be used (prevents from using actual filename with hash, thus making the escaping process useless). Unless there's no other sensible way &mdash; e.g. specify Spine skin name when opening Spine json file...    ", "tags": "", "loc": "CastleURIUtils.html#URIExtractAnchor"},
     {"title": "CastleURIUtils.URIDeleteAnchor", "text": "    ", "tags": "", "loc": "CastleURIUtils.html#URIDeleteAnchor"},
     {"title": "CastleURIUtils.RawURIDecode", "text": "  <p>The intention is that this is similar to PHP function with the same name.  <p>To account for badly encoded strings, invalid encoded URIs do not raise an error &mdash; they are only reported to <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>. So you can simply ignore them, or write a warning about them for user. This is done because often you will use this with URIs provided by the user, read from some file etc., so you can't be sure whether they are correctly encoded, and raising error unconditionally is not OK. (Considering the number of bad HTML pages on WWW.)  <p>The cases of badly encoded strings are:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>&quot;%xx&quot; sequence ends unexpectedly at the end of the string. That is, string ends with &quot;%&quot; or &quot;%x&quot;. In this case we simply keep &quot;%&quot; or &quot;%x&quot; in resulting string.</p></li>   <li><p>&quot;xx&quot; in &quot;%xx&quot; sequence is not a valid hexadecimal number. In this case we also simply keep &quot;%xx&quot; in resulting string.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleURIUtils.html#RawURIDecode"},
     {"title": "CastleURIUtils.URIProtocol", "text": "  <p>This is very similar to how URIParser.ParseURI function detects the protocol, although not 100% compatible:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>We allow whitespace (including newline) before protocol name.  <p>This is useful, because some VRML/X3D files have the ECMAScript code inlined and there is sometimes whitespace before &quot;ecmascript:&quot; protocol.</p></li>   <li><p>We never detect a single-letter protocol name.  <p>This is useful, because we do not use any single-letter protocol name, and it allows to detect Windows absolute filenames like <code>c:\\blah.txt</code> as filenames. Otherwise, Windows absolute filenames could not be accepted by any of our routines that work with URLs (like the <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a> function), since they would be detected as URLs with unknown protocol &quot;c&quot;.  <p>Our <code>URIProtocol</code> will answer that protocol is empty for <code>c:\\blah.txt</code>. Which means no protocol, so our engine will treat it as a filename. (In contrast with URIParser.ParseURI that would detect protocol called &quot;c&quot;.) See doc/uri_filename.txt in sources for more comments about differentiating URI and filenames in our engine.</p></li>   <li><p>We always return lowercase protocol. This is comfortable, since you almost always calculate protocol to compare it, and protocol names are not case-sensitive, and you should always produce URLs with lowercase (see <a  href=\"http://tools.ietf.org/html/rfc3986#section-3.1\">http://tools.ietf.org/html/rfc3986#section-3.1</a>).</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleURIUtils.html#URIProtocol"},
     {"title": "CastleURIUtils.URIProtocolIs", "text": " This is equivalent to checking <a class=\"normal\" href=\"CastleURIUtils.html#URIProtocol\">URIProtocol</a>(S) = Protocol, ignoring case, although may be a little faster. Given Protocol string cannot contain &quot;:&quot; character.    ", "tags": "", "loc": "CastleURIUtils.html#URIProtocolIs"},
     {"title": "CastleURIUtils.URIDeleteProtocol", "text": "    ", "tags": "", "loc": "CastleURIUtils.html#URIDeleteProtocol"},
     {"title": "CastleURIUtils.CombineURI", "text": "  <p>Base URI must be either an absolute (with protocol) URI, or only an absolute filename (in which case we'll convert it to <a  href=\"file://\">file://</a> URI under the hood, if necessary). This is usually the URI of the containing file, for example an HTML file referencing the image, processed by <a class=\"normal\" href=\"CastleURIUtils.html#AbsoluteURI\">AbsoluteURI</a>.  <p>Relative URI may be a relative URI or an absolute URI. In the former case it is merged with Base. In the latter case it is simply returned.  <p>If you want to support relative URIs, you want to use this routine. It treats Relative always as an URI (so it should be percent-escaped, with slashes and such). Other routines in our engine, like <a class=\"normal\" href=\"CastleURIUtils.html#AbsoluteURI\">AbsoluteURI</a> and <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a>, treat strings without protocol as a filename (so it's not percent-escaped, it uses PathDelim specific to OS &mdash; slash or backslash etc.). This routine, on the other hand, treats Relative string always as an URI (when it doesn't include protocol, it just means it's relative to Base).    ", "tags": "", "loc": "CastleURIUtils.html#CombineURI"},
     {"title": "CastleURIUtils.AbsoluteURI", "text": " This function treats an URI without a protocol as a simple filename (absolute or relative to the current directory). This includes treating empty string as equivalent to current directory.    ", "tags": "", "loc": "CastleURIUtils.html#AbsoluteURI"},
     {"title": "CastleURIUtils.AbsoluteFileURI", "text": " Useful for warnings, since you usually do not want to have such paths in your data, as they it impossible to transfer the data (move/copy files) to other system/location.    ", "tags": "", "loc": "CastleURIUtils.html#AbsoluteFileURI"},
     {"title": "CastleURIUtils.URIToFilenameSafe", "text": " This is an improved URIToFilename from URIParser. When URI is already a filename, this does a better job than URIToFilename, as it handles also Windows absolute filenames (see <a class=\"normal\" href=\"CastleURIUtils.html#URIProtocol\">URIProtocol</a>). Returns empty string in case of problems, for example when this is not a file URI.  <p>Just like URIParser.URIToFilename, this percent-decodes the parameter. For example, <code>%4d</code> in URI will turn into letter <code>M</code> in result.    ", "tags": "", "loc": "CastleURIUtils.html#URIToFilenameSafe"},
     {"title": "CastleURIUtils.FilenameToURISafe", "text": "  <p>This is a fixed version of URIParser.FilenameToURI, that correctly percent-encodes the parameter, making it truly a reverse of <a class=\"normal\" href=\"CastleURIUtils.html#URIToFilenameSafe\">URIToFilenameSafe</a>. In FPC &gt; 2.6.2 URIParser.FilenameToURI will also do this (after Michalis' patch, see <a  href=\"http://svn.freepascal.org/cgi-bin/viewvc.cgi?view=revision&amp;revision=24321\">http://svn.freepascal.org/cgi-bin/viewvc.cgi?view=revision&amp;revision=24321</a> ).  <p>It also makes sure the filename is absolute (it uses ExpandFileName, so if the FileName is relative &mdash; it will be expanded, treating it as relative to the current directory).    ", "tags": "", "loc": "CastleURIUtils.html#FilenameToURISafe"},
     {"title": "CastleURIUtils.URIMimeType", "text": " For local and remote files (file, http, and similar protocols) it guesses MIME type based on file extension. (Although we may add here detection of local file types by opening them and reading a header, in the future.) Only for data: URI scheme it actually reads the MIME type.  <p>Using this function is not adviced if you want to properly support MIME types returned by http server for network resources. For this, you have to download the file, as look at what MIME type the http server reports. The <a class=\"normal\" href=\"CastleDownload.html#Download\">Download</a> function returns such proper MimeType. This function only guesses without downloading.  <p>Returns empty string if MIME type is unknown.  <p>Overloaded version returns also Gzipped to detect whether file contents are gzipped.  <p>The recognition mechanism can be enhanced by adding your own mappings to the <a class=\"normal\" href=\"CastleURIUtils.html#URIMimeExtensions\">URIMimeExtensions</a>.  <p>    ", "tags": "", "loc": "CastleURIUtils.html#URIMimeType"},
     {"title": "CastleURIUtils.URIMimeType", "text": "    ", "tags": "", "loc": "CastleURIUtils.html#URIMimeType"},
     {"title": "CastleURIUtils.URIMimeExtensions", "text": " The extension should be lowercase, and includes a leading dot, like <code>.png</code>.    ", "tags": "", "loc": "CastleURIUtils.html#URIMimeExtensions"},
     {"title": "CastleURIUtils.URIDisplay", "text": " It makes sure to nicely trim URLs that would be too long/unreadable otherwise (like &quot;data:&quot; URI, or multi-line URLs with inlined ECMAScript/<a class=\"normal\" href=\"CastleScript.html\">CastleScript</a>/shader code).  <p>When Short = <code>False</code> (default), then for most &quot;file:&quot; and &quot;http:&quot; URLs, it just returns them untouched.  <p>When Short = <code>True</code>, it will try to extract the last path component from URLs like &quot;file:&quot; and &quot;http:&quot;, if this last component is not empty. Similar to what ExtractFileName does for filenames. It will also decode the URI (convert %xx to normal charaters). Because of the percent-decoding, it is not advised to use this on filenames with Short=true. Usually, you want to call <a class=\"normal\" href=\"CastleURIUtils.html#URICaption\">URICaption</a> that makes sure that argument is URL (using <a class=\"normal\" href=\"CastleURIUtils.html#AbsoluteURI\">AbsoluteURI</a>) and then returns <code>URIDisplay</code> with Short=true.  <p>It is safe to use this on both absolute and relative URLs. It does not resolve relative URLs in any way. It also means that it returns empty string for empty URI (contrary to most other routines that convert empty string to a current directory when resolving relative URLs).    ", "tags": "", "loc": "CastleURIUtils.html#URIDisplay"},
     {"title": "CastleURIUtils.URICaption", "text": "  <p>Returns empty string for empty URI (contrary to most other routines that treat empty string like a current directory).  <p>See <a class=\"normal\" href=\"CastleURIUtils.html#URIDisplay\">URIDisplay</a> documentation for details.    ", "tags": "", "loc": "CastleURIUtils.html#URICaption"},
     {"title": "CastleURIUtils.ChangeURIExt", "text": "    ", "tags": "", "loc": "CastleURIUtils.html#ChangeURIExt"},
     {"title": "CastleURIUtils.DeleteURIExt", "text": "    ", "tags": "", "loc": "CastleURIUtils.html#DeleteURIExt"},
     {"title": "CastleURIUtils.ExtractURIName", "text": "    ", "tags": "", "loc": "CastleURIUtils.html#ExtractURIName"},
     {"title": "CastleURIUtils.ExtractURIPath", "text": "    ", "tags": "", "loc": "CastleURIUtils.html#ExtractURIPath"},
     {"title": "CastleURIUtils.URIFileExists", "text": " Always answers <code>True</code> for URLs that do not indicate local files (assume remote file exist).    ", "tags": "", "loc": "CastleURIUtils.html#URIFileExists"},
     {"title": "CastleURIUtils.URICurrentPath", "text": "    ", "tags": "", "loc": "CastleURIUtils.html#URICurrentPath"},
     {"title": "CastleUtils", "text": " Developed for &quot;Castle Game Engine&quot;, but generally usable.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Lists of primitives, using FPC generics. Like <a class=\"normal\" href=\"CastleUtils.TIntegerList.html\">TIntegerList</a>, <a class=\"normal\" href=\"CastleUtils.TFloatList.html\">TFloatList</a> etc.</p></li>   <li><p>Basic operations on numbers.</p></li>   <li><p>Some OS-dependent things.</p></li>   <li><p>Filenames operations (they somehow complement the standard set of routines in SysUtils).</p></li>   <li><p>Basic algorithms: <a class=\"normal\" href=\"CastleUtils.html#Sort\">Sort</a>.</p></li> </ul>  <p>  <p>This unit is a bag for simple and generally useful things. As a rule (to not let myself put too much things here) this unit must not depend on the Classes unit (see <a class=\"normal\" href=\"CastleClassUtils.html\">CastleClassUtils</a> for those). Or any higher-level GUI libs like LCL, VCL, or CLX. The only classes defined and used here are exceptions (the base Exception class comes from SysUtils unit) and primitives lists classes.  <p>Initialization of this unit does some generally-useful things:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Calls Randomize (so that you never forget about it).</p></li>   <li><p>Sets DecimalSeparator to '.'.  <p>Delphi and FPC define DecimalSeparator based on local settings (like configured user's country). But this makes things like StrToFloat and FloatToStr less predictable &mdash; they may give different results on different systems, which limits their use. E.g. FloatToStr(0.9) may output '0,9' on some system. And if you write '0,9' to a text file, it may not be understood by StrToFloat on some other system.  <p>Initial (probably localized) value of DecimalSeparator is saved in <a class=\"normal\" href=\"CastleUtils.html#LocaleDecimalSeparator\">LocaleDecimalSeparator</a> variable.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleUtils.html"},
     {"title": "CastleUtils.EInternalError", "text": " Something that definitely should not happen and indicates a bug that should be reported.  <p>This exception must be shown to user (never silently ignored), and usually the safest thing to do is to close the program at this point.  <p>We will add to your error message (passed to the constructor) some instructive message, like <code>'Internal error occurred, please submit this to the author : '</code>. ", "tags": "", "loc": "CastleUtils.EInternalError.html"},
     {"title": "CastleUtils.EInternalError.Create", "text": "    ", "tags": "", "loc": "CastleUtils.EInternalError.html#Create"},
     {"title": "CastleUtils.EInternalError.CreateFmt", "text": "    ", "tags": "", "loc": "CastleUtils.EInternalError.html#CreateFmt"},
     {"title": "CastleUtils.ECheckFailed", "text": " ", "tags": "", "loc": "CastleUtils.ECheckFailed.html"},
     {"title": "CastleUtils.TNoParameterlessContructor", "text": "  <p>In Delphi, if you have multiple overloaded constructors (marked with &quot;overload&quot;), the user can call any constructor of the ancestor class that you have not &quot;obscured&quot; by a new definition. In particular, if all your constructors have some parameters, then user can &quot;bypass&quot; them by calling a parameterless constructor defined by TObject. Descend from this class to disallow this. See <a  href=\"https://stackoverflow.com/questions/14003153/how-to-hide-the-inherited-tobject-constructor-while-the-class-has-overloaded-one\">https://stackoverflow.com/questions/14003153/how-to-hide-the-inherited-tobject-constructor-while-the-class-has-overloaded-one</a> <a  href=\"http://andy.jgknet.de/blog/2011/07/hiding-the-tobject-create-constructor/\">http://andy.jgknet.de/blog/2011/07/hiding-the-tobject-create-constructor/</a>  <p>Note that in FPC (in ObjFpc mode) this is not a problem, as the standard overloading (without the &quot;overload&quot; keyword) is more sane: the overloaded constructors obscure the ancestor constructors. ", "tags": "", "loc": "CastleUtils.TNoParameterlessContructor.html"},
     {"title": "CastleUtils.TStructList", "text": " This is just TList class from Generics.Collections, with some useful helpers. ", "tags": "", "loc": "CastleUtils.TStructList.html"},
     {"title": "CastleUtils.TStructList.List", "text": "  <p>This is useful if you have a list of records and you would like to set their fields. This will not work correctly:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">type</span>   TMyRecord = <span class=\"pascal_keyword\">record</span> MyField: Integer; <span class=\"pascal_keyword\">end</span>;   TMyRecordList = <span class=\"pascal_keyword\">specialize</span> TGenericStructList&lt;TMyRecord&gt;; <span class=\"pascal_keyword\">var</span>   MyList: TMyRecordList; <span class=\"pascal_keyword\">begin</span>   <span class=\"pascal_comment\">// ...</span>   MyList[I]<span class=\"pascal_float\">.</span>MyField := <span class=\"pascal_numeric\">123</span>;</pre>  <p>  <p>(It will not work OK because you would modify only a temporary record returned by the <code>MyList[I]</code> getter.) Instead, setting by  <p></p>  <pre class=\"longcode\"> MyList.List&circ;[I]<span class=\"pascal_float\">.</span>MyField := <span class=\"pascal_numeric\">123</span>;</pre>  <p>  <p>will work OK. Or you can use (only in FPC ObjFpc mode) even shorter this:  <p></p>  <pre class=\"longcode\"> MyList.L[I]<span class=\"pascal_float\">.</span>MyField := <span class=\"pascal_numeric\">123</span>;</pre>  <p>  <p>    ", "tags": "", "loc": "CastleUtils.TStructList.html#List"},
     {"title": "CastleUtils.TStructList.L", "text": "  <p>This is exactly the same pointer as <a class=\"normal\" href=\"CastleUtils.TStructList.html#List\">List</a>, but the type is different: this points to a single item. This is useful if you have a list of records and you would like to set their fields. This allows to use <code>L[I]</code> instead of <code>List&circ;[I]</code> (only in FPC ObjFpc mode).  <p>See the <a class=\"normal\" href=\"CastleUtils.TStructList.html#List\">List</a> description for a more detailed explanation and example.     ", "tags": "", "loc": "CastleUtils.TStructList.html#L"},
     {"title": "CastleUtils.TStructList.Add", "text": " Comfortable and efficient way to add a new item that you want to immediately initialize.    ", "tags": "", "loc": "CastleUtils.TStructList.html#Add"},
     {"title": "CastleUtils.TStructList.Ptr", "text": "    ", "tags": "", "loc": "CastleUtils.TStructList.html#Ptr"},
     {"title": "CastleUtils.TStructList.Assign", "text": "    ", "tags": "", "loc": "CastleUtils.TStructList.html#Assign"},
     {"title": "CastleUtils.TStructList.Assign", "text": "    ", "tags": "", "loc": "CastleUtils.TStructList.html#Assign"},
     {"title": "CastleUtils.TStructList.ItemSize", "text": "    ", "tags": "", "loc": "CastleUtils.TStructList.html#ItemSize"},
     {"title": "CastleUtils.TStructList.AddArray", "text": "    ", "tags": "", "loc": "CastleUtils.TStructList.html#AddArray"},
     {"title": "CastleUtils.TStructList.AddList", "text": "    ", "tags": "", "loc": "CastleUtils.TStructList.html#AddList"},
     {"title": "CastleUtils.TStructList.AssignArray", "text": "    ", "tags": "", "loc": "CastleUtils.TStructList.html#AssignArray"},
     {"title": "CastleUtils.TStructList.PtrT", "text": " ", "tags": "", "loc": "CastleUtils.TStructList.html#PtrT"},
     {"title": "CastleUtils.TStructList.PTypeList", "text": " ", "tags": "", "loc": "CastleUtils.TStructList.html#PTypeList"},
     {"title": "CastleUtils.TStructList.TTypeList", "text": " ", "tags": "", "loc": "CastleUtils.TStructList.html#TTypeList"},
     {"title": "CastleUtils.EListsDifferentCount", "text": " ", "tags": "", "loc": "CastleUtils.EListsDifferentCount.html"},
     {"title": "CastleUtils.TWordList", "text": " ", "tags": "", "loc": "CastleUtils.TWordList.html"},
     {"title": "CastleUtils.TWordList.Max", "text": "    ", "tags": "", "loc": "CastleUtils.TWordList.html#Max"},
     {"title": "CastleUtils.TWordList.Assign", "text": "    ", "tags": "", "loc": "CastleUtils.TWordList.html#Assign"},
     {"title": "CastleUtils.TLongWordList", "text": " ", "tags": "", "loc": "CastleUtils.TLongWordList.html"},
     {"title": "CastleUtils.TLongWordList.Max", "text": "    ", "tags": "", "loc": "CastleUtils.TLongWordList.html#Max"},
     {"title": "CastleUtils.TLongWordList.Assign", "text": "    ", "tags": "", "loc": "CastleUtils.TLongWordList.html#Assign"},
     {"title": "CastleUtils.TFloatList", "text": " ", "tags": "", "loc": "CastleUtils.TFloatList.html"},
     {"title": "CastleUtils.TFloatList.AppendFloats", "text": "    ", "tags": "", "loc": "CastleUtils.TFloatList.html#AppendFloats"},
     {"title": "CastleUtils.TSingleList", "text": " ", "tags": "", "loc": "CastleUtils.TSingleList.html"},
     {"title": "CastleUtils.TSingleList.AppendFloats", "text": "    ", "tags": "", "loc": "CastleUtils.TSingleList.html#AppendFloats"},
     {"title": "CastleUtils.TSingleList.ToDouble", "text": "    ", "tags": "", "loc": "CastleUtils.TSingleList.html#ToDouble"},
     {"title": "CastleUtils.TSingleList.Assign", "text": "    ", "tags": "", "loc": "CastleUtils.TSingleList.html#Assign"},
     {"title": "CastleUtils.TSingleList.AssignLerp", "text": " We take ACount items, from V1[Index1 ... Index1 + ACount - 1] and V2[Index2 ... Index2 + ACount - 1], and interpolate between them like normal Lerp functions.  <p>It's Ok for both V1 and V2 to be the same objects. But their ranges should not overlap, for future optimizations (although it's Ok for current implementation).    ", "tags": "", "loc": "CastleUtils.TSingleList.html#AssignLerp"},
     {"title": "CastleUtils.TSingleList.AddSubRange", "text": "    ", "tags": "", "loc": "CastleUtils.TSingleList.html#AddSubRange"},
     {"title": "CastleUtils.TSingleList.AddListRange", "text": "    ", "tags": "", "loc": "CastleUtils.TSingleList.html#AddListRange"},
     {"title": "CastleUtils.TSingleList.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleUtils.TSingleList.html#AssignLerp"},
     {"title": "CastleUtils.TSingleList.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleUtils.TSingleList.html#Equals"},
     {"title": "CastleUtils.TSingleList.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleUtils.TSingleList.html#PerfectlyEquals"},
     {"title": "CastleUtils.TDoubleList", "text": " ", "tags": "", "loc": "CastleUtils.TDoubleList.html"},
     {"title": "CastleUtils.TDoubleList.ToSingle", "text": "    ", "tags": "", "loc": "CastleUtils.TDoubleList.html#ToSingle"},
     {"title": "CastleUtils.TDoubleList.Assign", "text": "    ", "tags": "", "loc": "CastleUtils.TDoubleList.html#Assign"},
     {"title": "CastleUtils.TDoubleList.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleUtils.TDoubleList.html#AssignLerp"},
     {"title": "CastleUtils.TDoubleList.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleUtils.TDoubleList.html#Equals"},
     {"title": "CastleUtils.TDoubleList.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleUtils.TDoubleList.html#PerfectlyEquals"},
     {"title": "CastleUtils.TCardinalList", "text": " ", "tags": "", "loc": "CastleUtils.TCardinalList.html"},
     {"title": "CastleUtils.TCardinalList.BigSum", "text": "    ", "tags": "", "loc": "CastleUtils.TCardinalList.html#BigSum"},
     {"title": "CastleUtils.TCardinalList.Sum", "text": "    ", "tags": "", "loc": "CastleUtils.TCardinalList.html#Sum"},
     {"title": "CastleUtils.TBooleanList", "text": " ", "tags": "", "loc": "CastleUtils.TBooleanList.html"},
     {"title": "CastleUtils.TBooleanList.SetFalse", "text": " These are useful methods to pass as callback in some situations (e.g. TCastleScene.RenderFrustumOctree passes RenderFrustumOctree_Visible.SetTrue method as callback that should mark visible items.)     ", "tags": "", "loc": "CastleUtils.TBooleanList.html#SetFalse"},
     {"title": "CastleUtils.TBooleanList.SetTrue", "text": "    ", "tags": "", "loc": "CastleUtils.TBooleanList.html#SetTrue"},
     {"title": "CastleUtils.TBooleanList.ToLongInt", "text": "    ", "tags": "", "loc": "CastleUtils.TBooleanList.html#ToLongInt"},
     {"title": "CastleUtils.TBooleanList.Equals", "text": "    ", "tags": "", "loc": "CastleUtils.TBooleanList.html#Equals"},
     {"title": "CastleUtils.TBooleanList.PerfectlyEquals", "text": "  <p>This method does the same thing as <a class=\"normal\" href=\"CastleUtils.TBooleanList.html#Equals\">Equals</a>. It is defined for consistency &ndash; on some lists, like <a class=\"normal\" href=\"CastleUtils.TSingleList.html\">TSingleList</a>, there is an important difference between Equals (compares with some epsilon tolerance) and <code>PerfectlyEquals</code>.    ", "tags": "", "loc": "CastleUtils.TBooleanList.html#PerfectlyEquals"},
     {"title": "CastleUtils.TLongIntList", "text": " ", "tags": "", "loc": "CastleUtils.TLongIntList.html"},
     {"title": "CastleUtils.TLongIntList.Max", "text": "    ", "tags": "", "loc": "CastleUtils.TLongIntList.html#Max"},
     {"title": "CastleUtils.TLongIntList.Sum", "text": "    ", "tags": "", "loc": "CastleUtils.TLongIntList.html#Sum"},
     {"title": "CastleUtils.TLongIntList.DeleteRange", "text": "    ", "tags": "", "loc": "CastleUtils.TLongIntList.html#DeleteRange"},
     {"title": "CastleUtils.TLongIntList.AddDuplicate", "text": "    ", "tags": "", "loc": "CastleUtils.TLongIntList.html#AddDuplicate"},
     {"title": "CastleUtils.TLongIntList.Equals", "text": "    ", "tags": "", "loc": "CastleUtils.TLongIntList.html#Equals"},
     {"title": "CastleUtils.TLongIntList.PerfectlyEquals", "text": "  <p>This method does the same thing as <a class=\"normal\" href=\"CastleUtils.TLongIntList.html#Equals\">Equals</a>. It is defined for consistency &ndash; on some lists, like <a class=\"normal\" href=\"CastleUtils.TSingleList.html\">TSingleList</a>, there is an important difference between Equals (compares with some epsilon tolerance) and <code>PerfectlyEquals</code>.    ", "tags": "", "loc": "CastleUtils.TLongIntList.html#PerfectlyEquals"},
     {"title": "CastleUtils.TIntegerList", "text": " ", "tags": "", "loc": "CastleUtils.TIntegerList.html"},
     {"title": "CastleUtils.TIntegerList.Sum", "text": "    ", "tags": "", "loc": "CastleUtils.TIntegerList.html#Sum"},
     {"title": "CastleUtils.EWithHiddenClassName", "text": " Sometimes useful, when you know that exception message is good enough, and showing exception class is not needed. ", "tags": "", "loc": "CastleUtils.EWithHiddenClassName.html"},
     {"title": "CastleUtils.TCodeBreaker", "text": " ", "tags": "", "loc": "CastleUtils.TCodeBreaker.html"},
     {"title": "CastleUtils.EVectorInvalidOp", "text": " ", "tags": "", "loc": "CastleUtils.EVectorInvalidOp.html"},
     {"title": "CastleUtils.ETransformedResultInvalid", "text": " ", "tags": "", "loc": "CastleUtils.ETransformedResultInvalid.html"},
     {"title": "CastleUtils.DefaultCountToUseSimpleSort", "text": " If number of items is &lt;= CountToUseSimpleSort, then <a class=\"normal\" href=\"CastleUtils.html#Sort\">Sort</a> will fallback to SimpleSort (= sort by choosing for now) instead of recursive QuickSort. Set CountToUseSimpleSort = 0 to make it never fall back to SimpleSort.  <p>By default this is <code>DefaultCountToUseSimpleSort</code>. ", "tags": "", "loc": "CastleUtils.html#DefaultCountToUseSimpleSort"},
     {"title": "CastleUtils.NL", "text": " Short name for LineEnding. ", "tags": "", "loc": "CastleUtils.html#NL"},
     {"title": "CastleUtils.CastleEngineVersion", "text": " ", "tags": "", "loc": "CastleUtils.html#CastleEngineVersion"},
     {"title": "CastleUtils.enatural", "text": " ", "tags": "", "loc": "CastleUtils.html#enatural"},
     {"title": "CastleUtils.sqrt2", "text": " ", "tags": "", "loc": "CastleUtils.html#sqrt2"},
     {"title": "CastleUtils.Sqrt3", "text": " ", "tags": "", "loc": "CastleUtils.html#Sqrt3"},
     {"title": "CastleUtils.HalfPi", "text": " Taken from FPC sources, file rtl/inc/genmath.inc ", "tags": "", "loc": "CastleUtils.html#HalfPi"},
     {"title": "CastleUtils.RootDir", "text": " Empty if not applicable to this OS. ", "tags": "", "loc": "CastleUtils.html#RootDir"},
     {"title": "CastleUtils.ExeExtension", "text": " ", "tags": "", "loc": "CastleUtils.html#ExeExtension"},
     {"title": "CastleUtils.Sort", "text": "  <p>Sorts items ascending, that is Arr[FirstIndex] &lt;= ... &lt;= Arr[LastIndex].  <p>  <p>  <p>  <p>  <p>  <p>  Arr Pointer to items array in memory. ArrRecordSize Size (in bytes) of every item. This is the size of item that will be moved around in the memory. IsSmallerFunc Comparison function, should return is &quot;A &lt; B&quot; true.  <p>I'm assuming here that IsSmallerFunc works like mathematical &quot;&lt;&quot;: it's not reflexive (IsSmallerFunc(A, A) = <code>False</code>), for A &lt;&gt; B exactly one of IsSmallerFunc(A, B) or IsSmallerFunc(B, A) is true, and it's transitive.  <p>Note that IsSmallerFunc gets only the pointers to the items. These may be pointers to the Arr, or a pointer to internal temporary copy of some array item. So IsSmallerFunc cannot modify the item underneath (it would not work for internal copy, and also would create problems with types that need initialization/finalization since our internal copy is done using low-level memory copying.) FirstIndex FirstIndex and LastIndex allow you to sort only given part of the array. We don't touch items outside of this range. Note that you could achieve the effect of FirstIndex &gt; 0 also by increasing the Arr pointer, but FirstIndex is usually more comfortable.  <p>If FirstIndex &gt; LastIndex, we do nothing. ArrStride Distance (in bytes) between array items in memory. If you don't provide it, we'll assume ArrRecordSize. ArrStride is useful if your array is interleaved with another array, and you want to keep the other data untouched by sorting.  <p>ArrStride must be &gt; 0, actually it must be &gt; ArrRecordSize for sensible behavior. (Unless ArrRecordSize is 0, then ArrStride may be 0 too.).  Arr Pointer to items array in memory. ArrRecordSize Size (in bytes) of every item. This is the size of item that will be moved around in the memory. IsSmallerFunc Comparison function, should return is &quot;A &lt; B&quot; true.  <p>I'm assuming here that IsSmallerFunc works like mathematical &quot;&lt;&quot;: it's not reflexive (IsSmallerFunc(A, A) = <code>False</code>), for A &lt;&gt; B exactly one of IsSmallerFunc(A, B) or IsSmallerFunc(B, A) is true, and it's transitive.  <p>Note that IsSmallerFunc gets only the pointers to the items. These may be pointers to the Arr, or a pointer to internal temporary copy of some array item. So IsSmallerFunc cannot modify the item underneath (it would not work for internal copy, and also would create problems with types that need initialization/finalization since our internal copy is done using low-level memory copying.) FirstIndex FirstIndex and LastIndex allow you to sort only given part of the array. We don't touch items outside of this range. Note that you could achieve the effect of FirstIndex &gt; 0 also by increasing the Arr pointer, but FirstIndex is usually more comfortable.  <p>If FirstIndex &gt; LastIndex, we do nothing. ArrStride Distance (in bytes) between array items in memory. If you don't provide it, we'll assume ArrRecordSize. ArrStride is useful if your array is interleaved with another array, and you want to keep the other data untouched by sorting.  <p>ArrStride must be &gt; 0, actually it must be &gt; ArrRecordSize for sensible behavior. (Unless ArrRecordSize is 0, then ArrStride may be 0 too.).", "tags": "", "loc": "CastleUtils.html#Sort"},
     {"title": "CastleUtils.Sort", "text": "    ", "tags": "", "loc": "CastleUtils.html#Sort"},
     {"title": "CastleUtils.SortByObject", "text": "    ", "tags": "", "loc": "CastleUtils.html#SortByObject"},
     {"title": "CastleUtils.SortByObject", "text": "    ", "tags": "", "loc": "CastleUtils.html#SortByObject"},
     {"title": "CastleUtils.Check", "text": "     ECheckFailed Raised with ErrMessage if condition TrueValue if false.", "tags": "", "loc": "CastleUtils.html#Check"},
     {"title": "CastleUtils.ArrayPosStr", "text": " Returns index (zero-based) or -1 if not found.  <p>Useful for writing case as:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">case</span> ArrayPosStr(variable, [val1, val2]) <span class=\"pascal_keyword\">of</span>   <span class=\"pascal_numeric\">0</span> : Something1;   <span class=\"pascal_numeric\">1</span> : Something2;   <span class=\"pascal_keyword\">else</span> SomethingElse; <span class=\"pascal_keyword\">end</span>;</pre>  <p>    ", "tags": "", "loc": "CastleUtils.html#ArrayPosStr"},
     {"title": "CastleUtils.ArrayPosText", "text": "    ", "tags": "", "loc": "CastleUtils.html#ArrayPosText"},
     {"title": "CastleUtils.Iff", "text": "    ", "tags": "", "loc": "CastleUtils.html#Iff"},
     {"title": "CastleUtils.Iff", "text": "    ", "tags": "", "loc": "CastleUtils.html#Iff"},
     {"title": "CastleUtils.Iff", "text": "    ", "tags": "", "loc": "CastleUtils.html#Iff"},
     {"title": "CastleUtils.Iff", "text": "    ", "tags": "", "loc": "CastleUtils.html#Iff"},
     {"title": "CastleUtils.Iff", "text": "    ", "tags": "", "loc": "CastleUtils.html#Iff"},
     {"title": "CastleUtils.SFPCVersion", "text": " In the form 'version.release.patch'.  <p>This is actually a constant (for every run of a program it has always the same value) but I can't declare it as a Pascal constant because it must use &quot;Format&quot; function that is not allowed in constant expressions.    ", "tags": "", "loc": "CastleUtils.html#SFPCVersion"},
     {"title": "CastleUtils.SCompilerDescription", "text": " It is a constant, actually, but I cannot declare it as a constant because it must call <a class=\"normal\" href=\"CastleUtils.html#SFPCVersion\">SFPCVersion</a> that is not declared as a constant.    ", "tags": "", "loc": "CastleUtils.html#SCompilerDescription"},
     {"title": "CastleUtils.SCastleEngineProgramHelpSuffix", "text": " This is useful only for programs released on this WWW page by Michalis. Resulting string is multiline.  <p>  <p>  <p>  DisplayApplicationName Short application name. Usually you should take it from ApplicationName. Version Version to display. Usually you should take it from <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#Version\">ApplicationProperties.Version</a>. WrapLines If true then resulting string will not have lines longer than 80 characters. Suitable for printing program help message on stdout, e.g. in response to --help option.  DisplayApplicationName Short application name. Usually you should take it from ApplicationName. Version Version to display. Usually you should take it from <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#Version\">ApplicationProperties.Version</a>. WrapLines If true then resulting string will not have lines longer than 80 characters. Suitable for printing program help message on stdout, e.g. in response to --help option.", "tags": "", "loc": "CastleUtils.html#SCastleEngineProgramHelpSuffix"},
     {"title": "CastleUtils.OSCheck", "text": "    ", "tags": "", "loc": "CastleUtils.html#OSCheck"},
     {"title": "CastleUtils.OSCheck", "text": "    ", "tags": "", "loc": "CastleUtils.html#OSCheck"},
     {"title": "CastleUtils.ExceptMessage", "text": " Contains exception ClassName (if not descends from <a class=\"normal\" href=\"CastleUtils.EWithHiddenClassName.html\">EWithHiddenClassName</a>), exception Message (if descends from Exception), and ExceptAddr (if not <code>Nil</code>, and code is compiled with -dDEBUG), and BonusErrorMesssg.    ", "tags": "", "loc": "CastleUtils.html#ExceptMessage"},
     {"title": "CastleUtils.ProgramBreak", "text": "    ", "tags": "", "loc": "CastleUtils.html#ProgramBreak"},
     {"title": "CastleUtils.CastleReadLink", "text": " Like Libc.ReadLink or FpReadLink, but more comfortable, it returns a normal Pascal string.     EOSError In case of any failure (non-existing FileName etc.)", "tags": "", "loc": "CastleUtils.html#CastleReadLink"},
     {"title": "CastleUtils.SwapValues", "text": "     ", "tags": "", "loc": "CastleUtils.html#SwapValues"},
     {"title": "CastleUtils.SwapValues", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapValues"},
     {"title": "CastleUtils.SwapValues", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapValues"},
     {"title": "CastleUtils.SwapValues", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapValues"},
     {"title": "CastleUtils.SwapValues", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapValues"},
     {"title": "CastleUtils.SwapValues", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapValues"},
     {"title": "CastleUtils.SwapValues", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapValues"},
     {"title": "CastleUtils.SwapValues", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapValues"},
     {"title": "CastleUtils.SwapValues", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapValues"},
     {"title": "CastleUtils.OrderUp", "text": "     ", "tags": "", "loc": "CastleUtils.html#OrderUp"},
     {"title": "CastleUtils.OrderUp", "text": "    ", "tags": "", "loc": "CastleUtils.html#OrderUp"},
     {"title": "CastleUtils.OrderUp", "text": "    ", "tags": "", "loc": "CastleUtils.html#OrderUp"},
     {"title": "CastleUtils.OrderUp", "text": "    ", "tags": "", "loc": "CastleUtils.html#OrderUp"},
     {"title": "CastleUtils.OrderUp", "text": "    ", "tags": "", "loc": "CastleUtils.html#OrderUp"},
     {"title": "CastleUtils.OrderUp", "text": "     ", "tags": "", "loc": "CastleUtils.html#OrderUp"},
     {"title": "CastleUtils.OrderUp", "text": "    ", "tags": "", "loc": "CastleUtils.html#OrderUp"},
     {"title": "CastleUtils.OrderUp", "text": "    ", "tags": "", "loc": "CastleUtils.html#OrderUp"},
     {"title": "CastleUtils.OrderUp", "text": "    ", "tags": "", "loc": "CastleUtils.html#OrderUp"},
     {"title": "CastleUtils.MinVar", "text": " Works like <code>A := Min(A, B)</code>, but is marginally faster, since you don't have to do anything when A is already smaller.     ", "tags": "", "loc": "CastleUtils.html#MinVar"},
     {"title": "CastleUtils.MinVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MinVar"},
     {"title": "CastleUtils.MinVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MinVar"},
     {"title": "CastleUtils.MinVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MinVar"},
     {"title": "CastleUtils.MinVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MinVar"},
     {"title": "CastleUtils.MinVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MinVar"},
     {"title": "CastleUtils.MaxVar", "text": " Works like <code>A := Max(A, B)</code>, but is marginally faster, since you don't have to do anything when A is already larger.     ", "tags": "", "loc": "CastleUtils.html#MaxVar"},
     {"title": "CastleUtils.MaxVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MaxVar"},
     {"title": "CastleUtils.MaxVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MaxVar"},
     {"title": "CastleUtils.MaxVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MaxVar"},
     {"title": "CastleUtils.MaxVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MaxVar"},
     {"title": "CastleUtils.MaxVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#MaxVar"},
     {"title": "CastleUtils.IndexMax", "text": "     ", "tags": "", "loc": "CastleUtils.html#IndexMax"},
     {"title": "CastleUtils.IndexMin", "text": "    ", "tags": "", "loc": "CastleUtils.html#IndexMin"},
     {"title": "CastleUtils.Between", "text": "    ", "tags": "", "loc": "CastleUtils.html#Between"},
     {"title": "CastleUtils.Between", "text": "    ", "tags": "", "loc": "CastleUtils.html#Between"},
     {"title": "CastleUtils.Between", "text": "    ", "tags": "", "loc": "CastleUtils.html#Between"},
     {"title": "CastleUtils.Between", "text": "    ", "tags": "", "loc": "CastleUtils.html#Between"},
     {"title": "CastleUtils.Between", "text": "    ", "tags": "", "loc": "CastleUtils.html#Between"},
     {"title": "CastleUtils.RoundClamp255", "text": "    ", "tags": "", "loc": "CastleUtils.html#RoundClamp255"},
     {"title": "CastleUtils.Clamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamped"},
     {"title": "CastleUtils.Clamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamped"},
     {"title": "CastleUtils.Clamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamped"},
     {"title": "CastleUtils.Clamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamped"},
     {"title": "CastleUtils.Clamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamped"},
     {"title": "CastleUtils.Clamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamped"},
     {"title": "CastleUtils.ClampVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#ClampVar"},
     {"title": "CastleUtils.ClampVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#ClampVar"},
     {"title": "CastleUtils.ClampVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#ClampVar"},
     {"title": "CastleUtils.ClampVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#ClampVar"},
     {"title": "CastleUtils.ClampVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#ClampVar"},
     {"title": "CastleUtils.ClampVar", "text": "    ", "tags": "", "loc": "CastleUtils.html#ClampVar"},
     {"title": "CastleUtils.Clamp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamp"},
     {"title": "CastleUtils.Clamp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamp"},
     {"title": "CastleUtils.Clamp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamp"},
     {"title": "CastleUtils.Clamp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamp"},
     {"title": "CastleUtils.Clamp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Clamp"},
     {"title": "CastleUtils.RestOf3dCoords", "text": " If Coord = 0, then it sets First = 1 and Second = 2. And so on &mdash; for each Coord value, we set First and Second to the remaining indexes.    ", "tags": "", "loc": "CastleUtils.html#RestOf3dCoords"},
     {"title": "CastleUtils.ChangeIntCycle", "text": " The final value is always in the [0..MaxValue] range, even when initial Value was outside.    ", "tags": "", "loc": "CastleUtils.html#ChangeIntCycle"},
     {"title": "CastleUtils.Lerp", "text": " Returns <code>(1-A)*L + A*H</code>.     ", "tags": "", "loc": "CastleUtils.html#Lerp"},
     {"title": "CastleUtils.Lerp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Lerp"},
     {"title": "CastleUtils.Lerp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Lerp"},
     {"title": "CastleUtils.Lerp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Lerp"},
     {"title": "CastleUtils.Lerp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Lerp"},
     {"title": "CastleUtils.Lerp", "text": "    ", "tags": "", "loc": "CastleUtils.html#Lerp"},
     {"title": "CastleUtils.RoundUpToMultiply", "text": "    ", "tags": "", "loc": "CastleUtils.html#RoundUpToMultiply"},
     {"title": "CastleUtils.BiggestPowerOf2", "text": " When Value = 0 returns 0.    ", "tags": "", "loc": "CastleUtils.html#BiggestPowerOf2"},
     {"title": "CastleUtils.Biggest2Exponent", "text": " Like <a class=\"normal\" href=\"CastleUtils.html#BiggestPowerOf2\">BiggestPowerOf2</a>, except that this returns which power of 2 it is, while <a class=\"normal\" href=\"CastleUtils.html#BiggestPowerOf2\">BiggestPowerOf2</a> just returns exactly this power. <code>Biggest2Exponent</code>(0) = -1.    ", "tags": "", "loc": "CastleUtils.html#Biggest2Exponent"},
     {"title": "CastleUtils.Smallest2Exponent", "text": " <code>Smallest2Exponent</code>(0) = -1 (this is different situation than <code>Smallest2Exponent</code>(1), when we return 0.    ", "tags": "", "loc": "CastleUtils.html#Smallest2Exponent"},
     {"title": "CastleUtils.Smallest2Power", "text": " Like <a class=\"normal\" href=\"CastleUtils.html#Smallest2Exponent\">Smallest2Exponent</a>, except here we return 2&circ;<a class=\"normal\" href=\"CastleUtils.html#Smallest2Exponent\">Smallest2Exponent</a>(Value). Returns 0 when Value = 0.    ", "tags": "", "loc": "CastleUtils.html#Smallest2Power"},
     {"title": "CastleUtils.IsPowerOf2", "text": "    ", "tags": "", "loc": "CastleUtils.html#IsPowerOf2"},
     {"title": "CastleUtils.DivRoundUp", "text": "    ", "tags": "", "loc": "CastleUtils.html#DivRoundUp"},
     {"title": "CastleUtils.DivRoundUp", "text": "    ", "tags": "", "loc": "CastleUtils.html#DivRoundUp"},
     {"title": "CastleUtils.MapRange", "text": "  <p>Consider how SourceVal is placed in the [SourceBegin .. SourceEnd] (it may be outside of this range, it all still works OK). It has some distance to range start (SourceBegin), and some distance to range end (SourceEnd).  <p>We want to find another number, that is identically placed in another range [DestBegin .. DestEnd].  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Such that <i>Distance(SourceVal, SourceBegin) / Distance(SourceVal, SourceEnd) = Distance(Result, DestBegin) / Distance(Result, DestEnd)</i>.</p></li>   <li value=\"2\"><p>And such that it's on the same side of the range. So if SourceVal is beyond SourceEnd (that is, <code>SourceBegin &lt; SourceEnd &lt; SourceVal</code> or <code>SourceBegin &gt; SourceEnd &gt; SourceVal</code>) then the result must be similarly beyond DestEnd.  <p>As you can see, this works regardless if one, or both, of the ranges increase (range end is larger than range begin).</p></li> </ol>  <p>  <p><a class=\"normal\" href=\"CastleUtils.html#MapRangeClamped\">MapRangeClamped</a> additionally at the end clamps the result to be within [destBegin, destEnd] range (or [destEnd, destBegin] range, in case destEnd &lt; destBegin).  <p>    ", "tags": "", "loc": "CastleUtils.html#MapRange"},
     {"title": "CastleUtils.MapRange", "text": "    ", "tags": "", "loc": "CastleUtils.html#MapRange"},
     {"title": "CastleUtils.MapRange", "text": "    ", "tags": "", "loc": "CastleUtils.html#MapRange"},
     {"title": "CastleUtils.MapRange", "text": "    ", "tags": "", "loc": "CastleUtils.html#MapRange"},
     {"title": "CastleUtils.MapRangeClamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#MapRangeClamped"},
     {"title": "CastleUtils.MapRangeClamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#MapRangeClamped"},
     {"title": "CastleUtils.MapRangeClamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#MapRangeClamped"},
     {"title": "CastleUtils.MapRangeClamped", "text": "    ", "tags": "", "loc": "CastleUtils.html#MapRangeClamped"},
     {"title": "CastleUtils.RandomFloatRange", "text": " Always pass arguments such that RangeBegin &lt; RangeEnd.    ", "tags": "", "loc": "CastleUtils.html#RandomFloatRange"},
     {"title": "CastleUtils.RandomFloatRange", "text": "    ", "tags": "", "loc": "CastleUtils.html#RandomFloatRange"},
     {"title": "CastleUtils.RandomIntRange", "text": " So <i>result is never equal to RangeEnd</i>, this is often convenient, and makes <code><a class=\"normal\" href=\"CastleUtils.html#RandomIntRange\">RandomIntRange</a>(0, N)</code> consistent with <code>Random(N)</code>. Always pass arguments such that RangeBegin &lt; RangeEnd.    ", "tags": "", "loc": "CastleUtils.html#RandomIntRange"},
     {"title": "CastleUtils.RandomIntRange", "text": "    ", "tags": "", "loc": "CastleUtils.html#RandomIntRange"},
     {"title": "CastleUtils.RandomBoolean", "text": "    ", "tags": "", "loc": "CastleUtils.html#RandomBoolean"},
     {"title": "CastleUtils.RandomPlusMinus", "text": "    ", "tags": "", "loc": "CastleUtils.html#RandomPlusMinus"},
     {"title": "CastleUtils.AngleRadPointToPoint", "text": " Angle 0 means that Y1 = Y2 and X2 &gt; X1, then the angle increases as you rotate CCW. In radians.    ", "tags": "", "loc": "CastleUtils.html#AngleRadPointToPoint"},
     {"title": "CastleUtils.NatNatPower", "text": "    ", "tags": "", "loc": "CastleUtils.html#NatNatPower"},
     {"title": "CastleUtils.ArcCot", "text": "    ", "tags": "", "loc": "CastleUtils.html#ArcCot"},
     {"title": "CastleUtils.SmallFactorial", "text": " Beware, the results very quickly stop to fit inside Int64 range.    ", "tags": "", "loc": "CastleUtils.html#SmallFactorial"},
     {"title": "CastleUtils.CastleDivMod", "text": "  <p>This fixes lack of DivMod with negative Remainder (for FPC at least older than 2.2.4, see fpc-devel thread &quot;Math.DivMod results should be signed&quot; on 2006-03-21, <a  href=\"http://www.mail-archive.com/fpc-devel@lists.freepascal.org/msg04565.html\">http://www.mail-archive.com/fpc-devel@lists.freepascal.org/msg04565.html</a>).  <p>And workarounds faulty DivMod behavior with FPC 2.4.0, see <a  href=\"http://bugs.freepascal.org/view.php?id=15453\">http://bugs.freepascal.org/view.php?id=15453</a>    ", "tags": "", "loc": "CastleUtils.html#CastleDivMod"},
     {"title": "CastleUtils.DivUnsignedMod", "text": "  <p>This is useful in case when Dividend &lt; 0. Standard DivMod (and Pascal div and mod operators) return then Result rounded toward zero, and Remainder may be &lt; 0. This procedure will return Result rounded toward negative infinity, and Remainder will always be &gt;= 0.    ", "tags": "", "loc": "CastleUtils.html#DivUnsignedMod"},
     {"title": "CastleUtils.CeilDiv", "text": "    ", "tags": "", "loc": "CastleUtils.html#CeilDiv"},
     {"title": "CastleUtils.FloatDivMod", "text": " Requires that A &gt;= 0 and B &gt; 0, and the Result is always &gt;= 0.  <p>Tries to secure against floating point imprecision. It's always guaranteed that Remainder &gt;= 0 and &lt;= B (and usually should be &lt; B, but this cannot be guaranteed).    ", "tags": "", "loc": "CastleUtils.html#FloatDivMod"},
     {"title": "CastleUtils.FloatModulo", "text": " Works for any A (lesser than zero too). Assumes that B &gt; 0.  <p>Tries to secure against floating point imprecision. It's always guaranteed that Remainder &gt;= 0 and &lt;= B (and usually should be &lt; B, but this cannot be guaranteed).    ", "tags": "", "loc": "CastleUtils.html#FloatModulo"},
     {"title": "CastleUtils.MinMax", "text": "    ", "tags": "", "loc": "CastleUtils.html#MinMax"},
     {"title": "CastleUtils.MinMax", "text": "    ", "tags": "", "loc": "CastleUtils.html#MinMax"},
     {"title": "CastleUtils.CastleCoTan", "text": "    ", "tags": "", "loc": "CastleUtils.html#CastleCoTan"},
     {"title": "CastleUtils.IntSqrt", "text": "    ", "tags": "", "loc": "CastleUtils.html#IntSqrt"},
     {"title": "CastleUtils.SmoothStep", "text": " For X changing from Edge0 to Edge1, the resulting value changes from 0 to 1, smoothly (not with a linear speed). This is useful to make nicer transition from one value to another, it often looks better than using directly <a class=\"normal\" href=\"CastleUtils.html#Lerp\">Lerp</a> or <a class=\"normal\" href=\"CastleUtils.html#MapRange\">MapRange</a>.  <p>Just like GLSL <code>smoothstep</code>: <a  href=\"http://www.khronos.org/opengles/sdk/docs/manglsl/xhtml/smoothstep.xml\">http://www.khronos.org/opengles/sdk/docs/manglsl/xhtml/smoothstep.xml</a>    ", "tags": "", "loc": "CastleUtils.html#SmoothStep"},
     {"title": "CastleUtils.Swap32", "text": "    ", "tags": "", "loc": "CastleUtils.html#Swap32"},
     {"title": "CastleUtils.Swap64", "text": "    ", "tags": "", "loc": "CastleUtils.html#Swap64"},
     {"title": "CastleUtils.SwapEndian", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapEndian"},
     {"title": "CastleUtils.SwapEndian", "text": "    ", "tags": "", "loc": "CastleUtils.html#SwapEndian"},
     {"title": "CastleUtils.NtoLE", "text": "    ", "tags": "", "loc": "CastleUtils.html#NtoLE"},
     {"title": "CastleUtils.NtoLE", "text": "    ", "tags": "", "loc": "CastleUtils.html#NtoLE"},
     {"title": "CastleUtils.NtoBE", "text": "    ", "tags": "", "loc": "CastleUtils.html#NtoBE"},
     {"title": "CastleUtils.NtoBE", "text": "    ", "tags": "", "loc": "CastleUtils.html#NtoBE"},
     {"title": "CastleUtils.LEtoN", "text": "    ", "tags": "", "loc": "CastleUtils.html#LEtoN"},
     {"title": "CastleUtils.LEtoN", "text": "    ", "tags": "", "loc": "CastleUtils.html#LEtoN"},
     {"title": "CastleUtils.BEtoN", "text": "    ", "tags": "", "loc": "CastleUtils.html#BEtoN"},
     {"title": "CastleUtils.BEtoN", "text": "    ", "tags": "", "loc": "CastleUtils.html#BEtoN"},
     {"title": "CastleUtils.DeleteFileExt", "text": " Note that if the FileName had a couple of extensions (e.g. <code>blah.x3d.gz</code>) this will remove only the last one. Will remove nothing if filename has no extension.  <p><i>It is not adviced to use this function, better to operate on URLs and MIME types instead of filenames and extensions, see <a class=\"normal\" href=\"CastleURIUtils.html\">CastleURIUtils</a>.</i>    ", "tags": "", "loc": "CastleUtils.html#DeleteFileExt"},
     {"title": "CastleUtils.ExtractFileDoubleExt", "text": " If the filename has only one extension, returns that one extension, if the filename has no extension &mdash; returns empty string, similar to ExtractFileExt.  <p>This is useful to detect file types from filenames like <code>model.x3d.gz</code>, where ExtractFileExt returns only <code>.gz</code>. This function will return <code>.x3d.gz</code>.  <p><i>It is not adviced to use this function, better to operate on URLs and MIME types instead of filenames and extensions, see <a class=\"normal\" href=\"CastleURIUtils.html\">CastleURIUtils</a>.</i>    ", "tags": "", "loc": "CastleUtils.html#ExtractFileDoubleExt"},
     {"title": "CastleUtils.ExtractOnlyFilename", "text": "  <p> Deprecated, since we use URLs everywhere and also because this has very low usage. Use <a class=\"normal\" href=\"CastleURIUtils.html#DeleteURIExt\">DeleteURIExt</a>(<a class=\"normal\" href=\"CastleURIUtils.html#ExtractURIName\">ExtractURIName</a>(URL)) if you really need to.    ", "tags": "", "loc": "CastleUtils.html#ExtractOnlyFilename"},
     {"title": "CastleUtils.ChangeFilePath", "text": " NewPath <b>must</b> contain trailing PathDelim.  <p> Deprecated, since we use URLs everywhere and also because this has very low usage.    ", "tags": "", "loc": "CastleUtils.html#ChangeFilePath"},
     {"title": "CastleUtils.InclPathDelim", "text": " They are just comfortable shorter names for IncludeTrailingPathDelimiter and ExcludeTrailingPathDelimiter.     ", "tags": "", "loc": "CastleUtils.html#InclPathDelim"},
     {"title": "CastleUtils.ExclPathDelim", "text": "    ", "tags": "", "loc": "CastleUtils.html#ExclPathDelim"},
     {"title": "CastleUtils.IsPathAbsolute", "text": "  <p>Path may point to directory or normal file, it doesn't matter. Also it doesn't matter whether Path ends with PathDelim or not.  <p>Note for Windows: while it's obvious that <code>'c:\\autoexec.bat'</code> is an absolute path, and <code>'autoexec.bat'</code> is not, there's a question whether path like <code>'\\autoexec.bat'</code> is absolute? It doesn't specify drive letter, but it does specify full directory hierarchy on some drive. This function treats this as <i>not absolute</i>, on the reasoning that &quot;not all information is contained in Path&quot;.  <p>    ", "tags": "", "loc": "CastleUtils.html#IsPathAbsolute"},
     {"title": "CastleUtils.IsPathAbsoluteOnDrive", "text": "  <p>    ", "tags": "", "loc": "CastleUtils.html#IsPathAbsoluteOnDrive"},
     {"title": "CastleUtils.SpecialDirName", "text": "  <p>The precise definition of &quot;special&quot; is that you cannot ever create or even have any filenames / directories named like this.    ", "tags": "", "loc": "CastleUtils.html#SpecialDirName"},
     {"title": "CastleUtils.AppendToFilename", "text": " Returns <code><a class=\"normal\" href=\"CastleUtils.html#DeleteFileExt\">DeleteFileExt</a>(FileName) + Suffix + ExtractFileExt(FileName)</code>.    ", "tags": "", "loc": "CastleUtils.html#AppendToFilename"},
     {"title": "CastleUtils.PointerAdd", "text": " Will wrap over if you add too much. Add may be negative. This is just a shortcut for <code>PtrInt(Result) := PtrInt(P)+Add</code>, without any range / overflow checks.    ", "tags": "", "loc": "CastleUtils.html#PointerAdd"},
     {"title": "CastleUtils.GetClearMem", "text": "    ", "tags": "", "loc": "CastleUtils.html#GetClearMem"},
     {"title": "CastleUtils.FreeMemNiling", "text": "    ", "tags": "", "loc": "CastleUtils.html#FreeMemNiling"},
     {"title": "CastleUtils.CheckIsMemCharFilled", "text": " Returns -1 is <code>True</code>, or the number (between 0 .. Size - 1) or the first character different than AChar.    ", "tags": "", "loc": "CastleUtils.html#CheckIsMemCharFilled"},
     {"title": "CastleUtils.IsMemCharFilled", "text": " Returns simple boolean, use <a class=\"normal\" href=\"CastleUtils.html#CheckIsMemCharFilled\">CheckIsMemCharFilled</a> to get more informative result.    ", "tags": "", "loc": "CastleUtils.html#IsMemCharFilled"},
     {"title": "CastleUtils.IsMemWordFilled", "text": " Size if the number of words (not bytes), this is consequent with Size parameter from FillWord from FPC's RTL.    ", "tags": "", "loc": "CastleUtils.html#IsMemWordFilled"},
     {"title": "CastleUtils.IsMemDWordFilled", "text": " Size if the number of dwords (not bytes), this is consequent with Size parameter from FillDWord from FPC's RTL.    ", "tags": "", "loc": "CastleUtils.html#IsMemDWordFilled"},
     {"title": "CastleUtils.OffsetUInt", "text": " Useful to pass as offsets to methods like <a class=\"normal\" href=\"CastleGLShaders.TGLSLAttribute.html#EnableArray\">TGLSLAttribute.EnableArray</a> that wrap OpenGL vertex-array API. This is simply Result := A - B, except we do some typecasting.    ", "tags": "", "loc": "CastleUtils.html#OffsetUInt"},
     {"title": "CastleUtils.Offset", "text": "    ", "tags": "", "loc": "CastleUtils.html#Offset"},
     {"title": "CastleUtils.CompareMethods", "text": "    ", "tags": "", "loc": "CastleUtils.html#CompareMethods"},
     {"title": "CastleUtils.ErrorWrite", "text": "  <p>If we are a Windows GUI program (not IsConsole) then we use native Windows dialog boxes. Otherwise (a console is available, which is always true on non-Windows) we output the message using simple Writeln (to standard output for <a class=\"normal\" href=\"CastleUtils.html#InfoWrite\">InfoWrite</a>, or ErrOutput for <a class=\"normal\" href=\"CastleUtils.html#ErrorWrite\">ErrorWrite</a> and <a class=\"normal\" href=\"CastleUtils.html#WarningWrite\">WarningWrite</a>).  <p>    ", "tags": "", "loc": "CastleUtils.html#ErrorWrite"},
     {"title": "CastleUtils.WarningWrite", "text": "    ", "tags": "", "loc": "CastleUtils.html#WarningWrite"},
     {"title": "CastleUtils.InfoWrite", "text": "    ", "tags": "", "loc": "CastleUtils.html#InfoWrite"},
     {"title": "CastleUtils.ErrorWrite", "text": "    ", "tags": "", "loc": "CastleUtils.html#ErrorWrite"},
     {"title": "CastleUtils.WarningWrite", "text": "    ", "tags": "", "loc": "CastleUtils.html#WarningWrite"},
     {"title": "CastleUtils.InfoWrite", "text": "    ", "tags": "", "loc": "CastleUtils.html#InfoWrite"},
     {"title": "CastleUtils.InfoWriteParts", "text": "  <p>If we're not on Windows or IsConsole, then we simply output Messages using Writeln.  <p>If we're on Windows and not IsConsole, then every Messages is displayed in a separate dialog box. Dialog box uses our InfoBox routine, with Messages[I] being message content and title being <code>Format(TitleFormat, [I + 1, Messages.Count])</code>.  <p>This is good for outputting a lot of information.  <p> Deprecated. This just looks ugly in GUI version. It's better to present long information using only a console (just use Writeln), or only a full-featured GUI (like Lazarus LCL or our <a class=\"normal\" href=\"CastleUIControls.html\">CastleUIControls</a>).    ", "tags": "", "loc": "CastleUtils.html#InfoWriteParts"},
     {"title": "CastleUtils.Float", "text": " ", "tags": "", "loc": "CastleUtils.html#Float"},
     {"title": "CastleUtils.PFloat", "text": " ", "tags": "", "loc": "CastleUtils.html#PFloat"},
     {"title": "CastleUtils.PCardinal", "text": " ", "tags": "", "loc": "CastleUtils.html#PCardinal"},
     {"title": "CastleUtils.PLongWord", "text": " ", "tags": "", "loc": "CastleUtils.html#PLongWord"},
     {"title": "CastleUtils.PShortint", "text": " ", "tags": "", "loc": "CastleUtils.html#PShortint"},
     {"title": "CastleUtils.PBoolean", "text": " Defined as &circ;Byte in some Delphi Windows unit, for FPC 1.0.x <code>PBoolean</code> is not available at all. ", "tags": "", "loc": "CastleUtils.html#PBoolean"},
     {"title": "CastleUtils.PByteArray", "text": " ", "tags": "", "loc": "CastleUtils.html#PByteArray"},
     {"title": "CastleUtils.TByteArray", "text": " ", "tags": "", "loc": "CastleUtils.html#TByteArray"},
     {"title": "CastleUtils.PString", "text": " ", "tags": "", "loc": "CastleUtils.html#PString"},
     {"title": "CastleUtils.PtrObject", "text": " Don't call this PObject or PTObject to avoid possible name clashes with other units (pointers are often used in situations that prevent good type-checking, so better to avoid name clashes to avoid some nasty errors). ", "tags": "", "loc": "CastleUtils.html#PtrObject"},
     {"title": "CastleUtils.TIsSmallerFunc", "text": "    ", "tags": "", "loc": "CastleUtils.html#TIsSmallerFunc"},
     {"title": "CastleUtils.TIsSmallerFuncByObject", "text": "    ", "tags": "", "loc": "CastleUtils.html#TIsSmallerFuncByObject"},
     {"title": "CastleUtils.TSingleArray", "text": " ", "tags": "", "loc": "CastleUtils.html#TSingleArray"},
     {"title": "CastleUtils.PSingleArray", "text": " ", "tags": "", "loc": "CastleUtils.html#PSingleArray"},
     {"title": "CastleUtils.TLongIntArray", "text": " ", "tags": "", "loc": "CastleUtils.html#TLongIntArray"},
     {"title": "CastleUtils.PLongIntArray", "text": " ", "tags": "", "loc": "CastleUtils.html#PLongIntArray"},
     {"title": "CastleUtils.LocaleDecimalSeparator", "text": " ", "tags": "", "loc": "CastleUtils.html#LocaleDecimalSeparator"},
     {"title": "CastleVectors", "text": "  <p>Various routines in this unit perform operations on geometric objects, like spheres and line segments. Here's an outline <b>how do we represent various geometric objects</b>:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> <i>Plane in 3D space</i> is a vector of 4 values. Such vector [A, B, C, D] defines a surface that consists of all points satisfying equation <code>A * x + B * y + C * z + D = 0</code>. At least one of A, B, C must be different than zero.  <p>Vector [A, B, C] is called PlaneDir in many places. It is called PlaneNormal when it's guaranteed (or required to be) normalized, i.e. scaled to have length 1.</p></li>   <li><p> <i>Line in 3D space</i> is represented by two 3D vectors: Line0 and LineVector. They determine a line consisting of all points that can be calculated as <code>Line0 + R * LineVector</code> where R is any real value.  <p>LineVector must not be a zero vector.</p></li>   <li><p> <i>Line in 2D space</i> is sometimes represented as 2D vectors Line0 and LineVector (analogously like line in 3D).  <p>And sometimes it's represented as a 3-items vector, like <a class=\"normal\" href=\"CastleVectors.html#TVector3Single\">TVector3Single</a> (for [A, B, C] line consists of all points satisfying <code>A * x + B * y + C = 0</code>). At least one of A, B must be different than zero.</p></li>   <li><p> A <i>tunnel</i> is an object that you get by moving a sphere along the line segment. In other words, this is like a cylinder, but ended with a hemispheres. The tunnel is represented in this unit as two points Tunnel1, Tunnel2 (this defines a line segment) and a TunnelRadius.</p></li>   <li><p> A <i>ray</i> is defined just like a line: two vectors RayOrigin and RayDirection, RayDirection must be nonzero. Ray consists of all points <code>RayOrigin + R * RayDirection</code> for R being any real value &gt;= 0.</p></li>   <li><p> An <i>axis-aligned plane in 3D</i> is a plane parallel to one of the three basic planes. This is a plane defined by the equation <code>X = Const</code> or <code>Y = Count</code> or <code>Z = Const</code>. Such plane is represented as PlaneConstCoord integer value equal to 0, 1 or 2 and PlaneConstValue.  <p>Note that you can always represent the same plane using a more general plane 3D equation, just take  <p></p>  <pre class=\"preformatted\"> Plane[0..2 / PlaneConstCoord] = 0, Plane[PlaneConstCoord] = -1, Plane[3] = PlaneConstValue.</pre>  <p> </p></li>   <li><p> A <i>line segment</i> (often referred to as just <i>segment</i>) is represented by two points Pos1 and Pos2. For some routines the order of points Pos1 and Pos2 is significant (but this is always explicitly stated in the interface, so don't worry).  <p>Sometimes line segment is also represented as Segment0 and SegmentVector, this consists of all points <code>Segment0 + SegmentVector * t</code> for t in [0..1]. SegmentVector must not be a zero vector.  <p>Conversion between the two representations above is trivial, just take Pos1 = Segment0 and Pos2 = Segment0 + SegmentVector.</p></li> </ul>  <p>  <p><b>Requirements of the geometric objects:</b>  <p>In descriptions of the geometric objects above, you can see some <i>requirements</i>, e.g. <i>&quot;the triangle must not be degenerated (equivalent to a line segment)&quot;</i>, <i>&quot;RayDirection must not be a zero vector&quot;</i>, etc. These requirements are generally <i>not checked</i> by routines in this unit (for the sake of speed) and <i>passing wrong values to many of the routines may lead to exceptions</i> (like an arithmetic exception) or nonsensible results. So try to make sure that the values you pass satisfy the requirements.  <p>However, <i>wrong input values should never lead to exceptions that would be a security risk</i>, like access violations or range check errors. As these exceptions could be uncatched in some situations, and then allow accessing a memory that otherwise should not be accessed, so we protect from this. Sometimes you simply cannot guarantee for 100% that input values are correct, because the floating-point operations are inherently not precise.  <p><b>About floating-point precision:</b>  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>As floating-point operations are never precise, when comparing floating-point values we always use some epsilon to &quot;tolerate&quot; some small differences.  <p>This epsilon is either done through the standard Math.SameValue and Math.IsZero or by using our own <a class=\"normal\" href=\"CastleVectors.html#SingleEpsilon\">SingleEpsilon</a> and <a class=\"normal\" href=\"CastleVectors.html#DoubleEpsilon\">DoubleEpsilon</a> constants (they are equal to standard Math unit epsilon values). The floating-point vector and matrix comparison methods, like <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html#Equals\">TVector3.Equals</a> and <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html#IsZero\">TVector3.IsZero</a>, compare with such epsilon.  <p>If you really want to compare things precisely, use methods like <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html#PerfectlyEquals\">TVector3.PerfectlyEquals</a> or <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html#IsPerfectlyZero\">TVector3.IsPerfectlyZero</a>. </p></li>   <li><p>For collision-detecting routines, the general strategy in case of uncertainty (when we're not sure whether there is a collision or the objects are just very very close to each other) is to say that there <i>is a collision</i>.  <p>This means that we may detect a collision when in fact the precise mathematical calculation says that there is no collision.  <p>This approach should be suitable for most use cases.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleVectors.html"},
     {"title": "CastleVectors.TVector2Byte", "text": "  ", "tags": "", "loc": "CastleVectors.TVector2Byte.html"},
     {"title": "CastleVectors.TVector2Byte.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#Data"},
     {"title": "CastleVectors.TVector2Byte.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#+"},
     {"title": "CastleVectors.TVector2Byte.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#-"},
     {"title": "CastleVectors.TVector2Byte.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#-"},
     {"title": "CastleVectors.TVector2Byte.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#ToString"},
     {"title": "CastleVectors.TVector2Byte.IsZero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#IsZero"},
     {"title": "CastleVectors.TVector2Byte.Equals", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#Equals"},
     {"title": "CastleVectors.TVector2Byte.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#Zero"},
     {"title": "CastleVectors.TVector2Byte.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#Items"},
     {"title": "CastleVectors.TVector2Byte.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#X"},
     {"title": "CastleVectors.TVector2Byte.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#Y"},
     {"title": "CastleVectors.TVector2Byte.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Byte.html#TIndex"},
     {"title": "CastleVectors.TVector3Byte", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Byte.html"},
     {"title": "CastleVectors.TVector3Byte.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#Data"},
     {"title": "CastleVectors.TVector3Byte.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#+"},
     {"title": "CastleVectors.TVector3Byte.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#-"},
     {"title": "CastleVectors.TVector3Byte.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#-"},
     {"title": "CastleVectors.TVector3Byte.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#ToString"},
     {"title": "CastleVectors.TVector3Byte.IsZero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#IsZero"},
     {"title": "CastleVectors.TVector3Byte.Equals", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#Equals"},
     {"title": "CastleVectors.TVector3Byte.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#Zero"},
     {"title": "CastleVectors.TVector3Byte.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#Items"},
     {"title": "CastleVectors.TVector3Byte.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#X"},
     {"title": "CastleVectors.TVector3Byte.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#Y"},
     {"title": "CastleVectors.TVector3Byte.Z", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#Z"},
     {"title": "CastleVectors.TVector3Byte.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Byte.html#TIndex"},
     {"title": "CastleVectors.TVector4Byte", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Byte.html"},
     {"title": "CastleVectors.TVector4Byte.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#Data"},
     {"title": "CastleVectors.TVector4Byte.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#+"},
     {"title": "CastleVectors.TVector4Byte.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#-"},
     {"title": "CastleVectors.TVector4Byte.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#-"},
     {"title": "CastleVectors.TVector4Byte.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#ToString"},
     {"title": "CastleVectors.TVector4Byte.IsZero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#IsZero"},
     {"title": "CastleVectors.TVector4Byte.Equals", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#Equals"},
     {"title": "CastleVectors.TVector4Byte.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#Zero"},
     {"title": "CastleVectors.TVector4Byte.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#Items"},
     {"title": "CastleVectors.TVector4Byte.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#X"},
     {"title": "CastleVectors.TVector4Byte.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#Y"},
     {"title": "CastleVectors.TVector4Byte.Z", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#Z"},
     {"title": "CastleVectors.TVector4Byte.W", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#W"},
     {"title": "CastleVectors.TVector4Byte.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Byte.html#TIndex"},
     {"title": "CastleVectors.TVector2Integer", "text": "  ", "tags": "", "loc": "CastleVectors.TVector2Integer.html"},
     {"title": "CastleVectors.TVector2Integer.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#Data"},
     {"title": "CastleVectors.TVector2Integer.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#+"},
     {"title": "CastleVectors.TVector2Integer.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#-"},
     {"title": "CastleVectors.TVector2Integer.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#-"},
     {"title": "CastleVectors.TVector2Integer.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#ToString"},
     {"title": "CastleVectors.TVector2Integer.IsZero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#IsZero"},
     {"title": "CastleVectors.TVector2Integer.Equals", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#Equals"},
     {"title": "CastleVectors.TVector2Integer.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#Zero"},
     {"title": "CastleVectors.TVector2Integer.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#Items"},
     {"title": "CastleVectors.TVector2Integer.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#X"},
     {"title": "CastleVectors.TVector2Integer.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#Y"},
     {"title": "CastleVectors.TVector2Integer.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Integer.html#TIndex"},
     {"title": "CastleVectors.TVector3Integer", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Integer.html"},
     {"title": "CastleVectors.TVector3Integer.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#Data"},
     {"title": "CastleVectors.TVector3Integer.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#+"},
     {"title": "CastleVectors.TVector3Integer.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#-"},
     {"title": "CastleVectors.TVector3Integer.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#-"},
     {"title": "CastleVectors.TVector3Integer.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#ToString"},
     {"title": "CastleVectors.TVector3Integer.IsZero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#IsZero"},
     {"title": "CastleVectors.TVector3Integer.Equals", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#Equals"},
     {"title": "CastleVectors.TVector3Integer.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#Zero"},
     {"title": "CastleVectors.TVector3Integer.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#Items"},
     {"title": "CastleVectors.TVector3Integer.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#X"},
     {"title": "CastleVectors.TVector3Integer.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#Y"},
     {"title": "CastleVectors.TVector3Integer.Z", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#Z"},
     {"title": "CastleVectors.TVector3Integer.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Integer.html#TIndex"},
     {"title": "CastleVectors.TVector4Integer", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Integer.html"},
     {"title": "CastleVectors.TVector4Integer.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#Data"},
     {"title": "CastleVectors.TVector4Integer.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#+"},
     {"title": "CastleVectors.TVector4Integer.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#-"},
     {"title": "CastleVectors.TVector4Integer.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#-"},
     {"title": "CastleVectors.TVector4Integer.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#ToString"},
     {"title": "CastleVectors.TVector4Integer.IsZero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#IsZero"},
     {"title": "CastleVectors.TVector4Integer.Equals", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#Equals"},
     {"title": "CastleVectors.TVector4Integer.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#Zero"},
     {"title": "CastleVectors.TVector4Integer.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#Items"},
     {"title": "CastleVectors.TVector4Integer.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#X"},
     {"title": "CastleVectors.TVector4Integer.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#Y"},
     {"title": "CastleVectors.TVector4Integer.Z", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#Z"},
     {"title": "CastleVectors.TVector4Integer.W", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#W"},
     {"title": "CastleVectors.TVector4Integer.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Integer.html#TIndex"},
     {"title": "CastleVectors.TVector2Cardinal", "text": "  ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html"},
     {"title": "CastleVectors.TVector2Cardinal.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#Data"},
     {"title": "CastleVectors.TVector2Cardinal.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#+"},
     {"title": "CastleVectors.TVector2Cardinal.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#-"},
     {"title": "CastleVectors.TVector2Cardinal.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#-"},
     {"title": "CastleVectors.TVector2Cardinal.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#ToString"},
     {"title": "CastleVectors.TVector2Cardinal.IsZero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#IsZero"},
     {"title": "CastleVectors.TVector2Cardinal.Equals", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#Equals"},
     {"title": "CastleVectors.TVector2Cardinal.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#Zero"},
     {"title": "CastleVectors.TVector2Cardinal.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#Items"},
     {"title": "CastleVectors.TVector2Cardinal.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#X"},
     {"title": "CastleVectors.TVector2Cardinal.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#Y"},
     {"title": "CastleVectors.TVector2Cardinal.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector2Cardinal.html#TIndex"},
     {"title": "CastleVectors.TVector3Cardinal", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html"},
     {"title": "CastleVectors.TVector3Cardinal.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#Data"},
     {"title": "CastleVectors.TVector3Cardinal.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#+"},
     {"title": "CastleVectors.TVector3Cardinal.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#-"},
     {"title": "CastleVectors.TVector3Cardinal.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#-"},
     {"title": "CastleVectors.TVector3Cardinal.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#ToString"},
     {"title": "CastleVectors.TVector3Cardinal.IsZero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#IsZero"},
     {"title": "CastleVectors.TVector3Cardinal.Equals", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#Equals"},
     {"title": "CastleVectors.TVector3Cardinal.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#Zero"},
     {"title": "CastleVectors.TVector3Cardinal.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#Items"},
     {"title": "CastleVectors.TVector3Cardinal.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#X"},
     {"title": "CastleVectors.TVector3Cardinal.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#Y"},
     {"title": "CastleVectors.TVector3Cardinal.Z", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#Z"},
     {"title": "CastleVectors.TVector3Cardinal.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector3Cardinal.html#TIndex"},
     {"title": "CastleVectors.TVector4Cardinal", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html"},
     {"title": "CastleVectors.TVector4Cardinal.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#Data"},
     {"title": "CastleVectors.TVector4Cardinal.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#+"},
     {"title": "CastleVectors.TVector4Cardinal.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#-"},
     {"title": "CastleVectors.TVector4Cardinal.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#-"},
     {"title": "CastleVectors.TVector4Cardinal.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#ToString"},
     {"title": "CastleVectors.TVector4Cardinal.IsZero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#IsZero"},
     {"title": "CastleVectors.TVector4Cardinal.Equals", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#Equals"},
     {"title": "CastleVectors.TVector4Cardinal.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#Zero"},
     {"title": "CastleVectors.TVector4Cardinal.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#Items"},
     {"title": "CastleVectors.TVector4Cardinal.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#X"},
     {"title": "CastleVectors.TVector4Cardinal.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#Y"},
     {"title": "CastleVectors.TVector4Cardinal.Z", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#Z"},
     {"title": "CastleVectors.TVector4Cardinal.W", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#W"},
     {"title": "CastleVectors.TVector4Cardinal.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Cardinal.html#TIndex"},
     {"title": "CastleVectors.TVector2SmallInt", "text": " ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html"},
     {"title": "CastleVectors.TVector2SmallInt.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#Data"},
     {"title": "CastleVectors.TVector2SmallInt.+", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#+"},
     {"title": "CastleVectors.TVector2SmallInt.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#-"},
     {"title": "CastleVectors.TVector2SmallInt.-", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#-"},
     {"title": "CastleVectors.TVector2SmallInt.ToString", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#ToString"},
     {"title": "CastleVectors.TVector2SmallInt.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#Zero"},
     {"title": "CastleVectors.TVector2SmallInt.Items", "text": " ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#Items"},
     {"title": "CastleVectors.TVector2SmallInt.X", "text": " ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#X"},
     {"title": "CastleVectors.TVector2SmallInt.Y", "text": " ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#Y"},
     {"title": "CastleVectors.TVector2SmallInt.TIndex", "text": " ", "tags": "", "loc": "CastleVectors.TVector2SmallInt.html#TIndex"},
     {"title": "CastleVectors.TVector2List", "text": " ", "tags": "", "loc": "CastleVectors.TVector2List.html"},
     {"title": "CastleVectors.TVector2List.MinMax", "text": " Returns <code>False</code> when Count = 0.    ", "tags": "", "loc": "CastleVectors.TVector2List.html#MinMax"},
     {"title": "CastleVectors.TVector2List.AssignLerp", "text": " We take ACount items, from V1[Index1 ... Index1 + ACount - 1] and V2[Index2 ... Index2 + ACount - 1], and interpolate between them like normal Lerp functions.  <p>It's Ok for both V1 and V2 to be the same objects. But their ranges should not overlap, for future optimizations (although it's Ok for current implementation).    ", "tags": "", "loc": "CastleVectors.TVector2List.html#AssignLerp"},
     {"title": "CastleVectors.TVector2List.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TVector2List.html#AssignLerp"},
     {"title": "CastleVectors.TVector2List.AddSubRange", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2List.html#AddSubRange"},
     {"title": "CastleVectors.TVector2List.AddListRange", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2List.html#AddListRange"},
     {"title": "CastleVectors.TVector2List.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TVector2List.html#Equals"},
     {"title": "CastleVectors.TVector2List.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TVector2List.html#PerfectlyEquals"},
     {"title": "CastleVectors.TVector3List", "text": " ", "tags": "", "loc": "CastleVectors.TVector3List.html"},
     {"title": "CastleVectors.TVector3List.AssignNegated", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3List.html#AssignNegated"},
     {"title": "CastleVectors.TVector3List.Negate", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3List.html#Negate"},
     {"title": "CastleVectors.TVector3List.Normalize", "text": " Zero vectors are left as zero.    ", "tags": "", "loc": "CastleVectors.TVector3List.html#Normalize"},
     {"title": "CastleVectors.TVector3List.MultiplyComponents", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3List.html#MultiplyComponents"},
     {"title": "CastleVectors.TVector3List.AssignLerp", "text": " We take ACount items, from V1[Index1 ... Index1 + ACount - 1] and V2[Index2 ... Index2 + ACount - 1], and interpolate between them like normal Lerp functions.  <p>It's Ok for both V1 and V2 to be the same objects. But their ranges should not overlap, for future optimizations (although it's Ok for current implementation).    ", "tags": "", "loc": "CastleVectors.TVector3List.html#AssignLerp"},
     {"title": "CastleVectors.TVector3List.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TVector3List.html#AssignLerp"},
     {"title": "CastleVectors.TVector3List.AssignLerpNormalize", "text": "     ", "tags": "", "loc": "CastleVectors.TVector3List.html#AssignLerpNormalize"},
     {"title": "CastleVectors.TVector3List.AssignLerpRgbInHsv", "text": "     ", "tags": "", "loc": "CastleVectors.TVector3List.html#AssignLerpRgbInHsv"},
     {"title": "CastleVectors.TVector3List.AddSubRange", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3List.html#AddSubRange"},
     {"title": "CastleVectors.TVector3List.AddListRange", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3List.html#AddListRange"},
     {"title": "CastleVectors.TVector3List.ToVector4", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3List.html#ToVector4"},
     {"title": "CastleVectors.TVector3List.MergeCloseVertexes", "text": " Returns how many vertex positions were changed.    ", "tags": "", "loc": "CastleVectors.TVector3List.html#MergeCloseVertexes"},
     {"title": "CastleVectors.TVector3List.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TVector3List.html#Equals"},
     {"title": "CastleVectors.TVector3List.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TVector3List.html#PerfectlyEquals"},
     {"title": "CastleVectors.TVector4List", "text": " ", "tags": "", "loc": "CastleVectors.TVector4List.html"},
     {"title": "CastleVectors.TVector4List.AddSubRange", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4List.html#AddSubRange"},
     {"title": "CastleVectors.TVector4List.AddListRange", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4List.html#AddListRange"},
     {"title": "CastleVectors.TVector4List.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TVector4List.html#AssignLerp"},
     {"title": "CastleVectors.TVector4List.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TVector4List.html#Equals"},
     {"title": "CastleVectors.TVector4List.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TVector4List.html#PerfectlyEquals"},
     {"title": "CastleVectors.TMatrix3List", "text": " ", "tags": "", "loc": "CastleVectors.TMatrix3List.html"},
     {"title": "CastleVectors.TMatrix3List.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TMatrix3List.html#AssignLerp"},
     {"title": "CastleVectors.TMatrix3List.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TMatrix3List.html#Equals"},
     {"title": "CastleVectors.TMatrix3List.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TMatrix3List.html#PerfectlyEquals"},
     {"title": "CastleVectors.TMatrix4List", "text": " ", "tags": "", "loc": "CastleVectors.TMatrix4List.html"},
     {"title": "CastleVectors.TMatrix4List.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TMatrix4List.html#AssignLerp"},
     {"title": "CastleVectors.TMatrix4List.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TMatrix4List.html#Equals"},
     {"title": "CastleVectors.TMatrix4List.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TMatrix4List.html#PerfectlyEquals"},
     {"title": "CastleVectors.TVector2DoubleList", "text": " ", "tags": "", "loc": "CastleVectors.TVector2DoubleList.html"},
     {"title": "CastleVectors.TVector2DoubleList.ToVector2", "text": "    ", "tags": "", "loc": "CastleVectors.TVector2DoubleList.html#ToVector2"},
     {"title": "CastleVectors.TVector2DoubleList.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TVector2DoubleList.html#AssignLerp"},
     {"title": "CastleVectors.TVector2DoubleList.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TVector2DoubleList.html#Equals"},
     {"title": "CastleVectors.TVector2DoubleList.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TVector2DoubleList.html#PerfectlyEquals"},
     {"title": "CastleVectors.TVector3DoubleList", "text": " ", "tags": "", "loc": "CastleVectors.TVector3DoubleList.html"},
     {"title": "CastleVectors.TVector3DoubleList.ToVector3", "text": "    ", "tags": "", "loc": "CastleVectors.TVector3DoubleList.html#ToVector3"},
     {"title": "CastleVectors.TVector3DoubleList.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TVector3DoubleList.html#AssignLerp"},
     {"title": "CastleVectors.TVector3DoubleList.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TVector3DoubleList.html#Equals"},
     {"title": "CastleVectors.TVector3DoubleList.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TVector3DoubleList.html#PerfectlyEquals"},
     {"title": "CastleVectors.TVector4DoubleList", "text": " ", "tags": "", "loc": "CastleVectors.TVector4DoubleList.html"},
     {"title": "CastleVectors.TVector4DoubleList.ToVector4", "text": "    ", "tags": "", "loc": "CastleVectors.TVector4DoubleList.html#ToVector4"},
     {"title": "CastleVectors.TVector4DoubleList.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TVector4DoubleList.html#AssignLerp"},
     {"title": "CastleVectors.TVector4DoubleList.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TVector4DoubleList.html#Equals"},
     {"title": "CastleVectors.TVector4DoubleList.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TVector4DoubleList.html#PerfectlyEquals"},
     {"title": "CastleVectors.TMatrix3DoubleList", "text": " ", "tags": "", "loc": "CastleVectors.TMatrix3DoubleList.html"},
     {"title": "CastleVectors.TMatrix3DoubleList.ToMatrix3", "text": "    ", "tags": "", "loc": "CastleVectors.TMatrix3DoubleList.html#ToMatrix3"},
     {"title": "CastleVectors.TMatrix3DoubleList.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TMatrix3DoubleList.html#AssignLerp"},
     {"title": "CastleVectors.TMatrix3DoubleList.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TMatrix3DoubleList.html#Equals"},
     {"title": "CastleVectors.TMatrix3DoubleList.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TMatrix3DoubleList.html#PerfectlyEquals"},
     {"title": "CastleVectors.TMatrix4DoubleList", "text": " ", "tags": "", "loc": "CastleVectors.TMatrix4DoubleList.html"},
     {"title": "CastleVectors.TMatrix4DoubleList.ToMatrix4", "text": "    ", "tags": "", "loc": "CastleVectors.TMatrix4DoubleList.html#ToMatrix4"},
     {"title": "CastleVectors.TMatrix4DoubleList.AssignLerp", "text": "     EListsDifferentCount If V1 and V2 have different count.", "tags": "", "loc": "CastleVectors.TMatrix4DoubleList.html#AssignLerp"},
     {"title": "CastleVectors.TMatrix4DoubleList.Equals", "text": " The values are compared with an Epsilon tolerance, as usual for floating-point values.    ", "tags": "", "loc": "CastleVectors.TMatrix4DoubleList.html#Equals"},
     {"title": "CastleVectors.TMatrix4DoubleList.PerfectlyEquals", "text": " The values are compared perfectly, without any tolerance for difference.    ", "tags": "", "loc": "CastleVectors.TMatrix4DoubleList.html#PerfectlyEquals"},
     {"title": "CastleVectors.TVector4Pointer", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Pointer.html"},
     {"title": "CastleVectors.TVector4Pointer.Data", "text": " ", "tags": "", "loc": "CastleVectors.TVector4Pointer.html#Data"},
     {"title": "CastleVectors.EPlanesParallel", "text": " ", "tags": "", "loc": "CastleVectors.EPlanesParallel.html"},
     {"title": "CastleVectors.ELinesParallel", "text": " ", "tags": "", "loc": "CastleVectors.ELinesParallel.html"},
     {"title": "CastleVectors.ZeroVector2Single", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector2Single"},
     {"title": "CastleVectors.ZeroVector3Single", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector3Single"},
     {"title": "CastleVectors.ZeroVector4Single", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector4Single"},
     {"title": "CastleVectors.ZeroVector2Double", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector2Double"},
     {"title": "CastleVectors.ZeroVector3Double", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector3Double"},
     {"title": "CastleVectors.ZeroVector4Double", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector4Double"},
     {"title": "CastleVectors.ZeroVector2Byte", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector2Byte"},
     {"title": "CastleVectors.ZeroVector3Byte", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector3Byte"},
     {"title": "CastleVectors.ZeroVector4Byte", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector4Byte"},
     {"title": "CastleVectors.ZeroVector2Integer", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector2Integer"},
     {"title": "CastleVectors.ZeroVector3Integer", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector3Integer"},
     {"title": "CastleVectors.ZeroVector4Integer", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector4Integer"},
     {"title": "CastleVectors.ZeroVector2Cardinal", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector2Cardinal"},
     {"title": "CastleVectors.ZeroVector3Cardinal", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector3Cardinal"},
     {"title": "CastleVectors.ZeroVector4Cardinal", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroVector4Cardinal"},
     {"title": "CastleVectors.ZeroMatrix2Single", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroMatrix2Single"},
     {"title": "CastleVectors.ZeroMatrix3Single", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroMatrix3Single"},
     {"title": "CastleVectors.ZeroMatrix4Single", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroMatrix4Single"},
     {"title": "CastleVectors.ZeroMatrix2Double", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroMatrix2Double"},
     {"title": "CastleVectors.ZeroMatrix3Double", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroMatrix3Double"},
     {"title": "CastleVectors.ZeroMatrix4Double", "text": " ", "tags": "", "loc": "CastleVectors.html#ZeroMatrix4Double"},
     {"title": "CastleVectors.IdentityMatrix2Single", "text": " ", "tags": "", "loc": "CastleVectors.html#IdentityMatrix2Single"},
     {"title": "CastleVectors.IdentityMatrix3Single", "text": " ", "tags": "", "loc": "CastleVectors.html#IdentityMatrix3Single"},
     {"title": "CastleVectors.IdentityMatrix4Single", "text": " ", "tags": "", "loc": "CastleVectors.html#IdentityMatrix4Single"},
     {"title": "CastleVectors.IdentityMatrix2Double", "text": " ", "tags": "", "loc": "CastleVectors.html#IdentityMatrix2Double"},
     {"title": "CastleVectors.IdentityMatrix3Double", "text": " ", "tags": "", "loc": "CastleVectors.html#IdentityMatrix3Double"},
     {"title": "CastleVectors.IdentityMatrix4Double", "text": " ", "tags": "", "loc": "CastleVectors.html#IdentityMatrix4Double"},
     {"title": "CastleVectors.UnitVector2Single", "text": " ", "tags": "", "loc": "CastleVectors.html#UnitVector2Single"},
     {"title": "CastleVectors.UnitVector3Single", "text": " ", "tags": "", "loc": "CastleVectors.html#UnitVector3Single"},
     {"title": "CastleVectors.UnitVector4Single", "text": " ", "tags": "", "loc": "CastleVectors.html#UnitVector4Single"},
     {"title": "CastleVectors.SingleEpsilon", "text": " Compatible with Math unit value, used by standard routines like Math.SameValue and Math.IsZero. ", "tags": "", "loc": "CastleVectors.html#SingleEpsilon"},
     {"title": "CastleVectors.DoubleEpsilon", "text": " Compatible with Math unit value, used by standard routines like Math.SameValue and Math.IsZero. ", "tags": "", "loc": "CastleVectors.html#DoubleEpsilon"},
     {"title": "CastleVectors.SingleEqualityEpsilon", "text": " ", "tags": "", "loc": "CastleVectors.html#SingleEqualityEpsilon"},
     {"title": "CastleVectors.DoubleEqualityEpsilon", "text": " ", "tags": "", "loc": "CastleVectors.html#DoubleEqualityEpsilon"},
     {"title": "CastleVectors.ExtendedEqualityEpsilon", "text": " ", "tags": "", "loc": "CastleVectors.html#ExtendedEqualityEpsilon"},
     {"title": "CastleVectors.Vector2", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2"},
     {"title": "CastleVectors.Vector2", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2"},
     {"title": "CastleVectors.Vector2Double", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2Double"},
     {"title": "CastleVectors.Vector3", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3"},
     {"title": "CastleVectors.Vector3", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3"},
     {"title": "CastleVectors.Vector3", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3"},
     {"title": "CastleVectors.Vector3Double", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3Double"},
     {"title": "CastleVectors.Vector3Double", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3Double"},
     {"title": "CastleVectors.Vector4", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4"},
     {"title": "CastleVectors.Vector4", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4"},
     {"title": "CastleVectors.Vector4", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4"},
     {"title": "CastleVectors.Vector4", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4"},
     {"title": "CastleVectors.Vector4Double", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4Double"},
     {"title": "CastleVectors.Vector4Double", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4Double"},
     {"title": "CastleVectors.Matrix3", "text": "    ", "tags": "", "loc": "CastleVectors.html#Matrix3"},
     {"title": "CastleVectors.Matrix4", "text": "    ", "tags": "", "loc": "CastleVectors.html#Matrix4"},
     {"title": "CastleVectors.Matrix3Double", "text": "    ", "tags": "", "loc": "CastleVectors.html#Matrix3Double"},
     {"title": "CastleVectors.Matrix4Double", "text": "    ", "tags": "", "loc": "CastleVectors.html#Matrix4Double"},
     {"title": "CastleVectors.Vector2FromStr", "text": " Each component is simply parsed by StrToFloat, and components must be separated by whitespace (see <a class=\"normal\" href=\"CastleStringUtils.html#WhiteSpaces\">WhiteSpaces</a> constant).      EConvertError In case of problems during conversion (invalid float or unexpected string end or expected but missed string end).", "tags": "", "loc": "CastleVectors.html#Vector2FromStr"},
     {"title": "CastleVectors.Vector3FromStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3FromStr"},
     {"title": "CastleVectors.Vector4FromStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4FromStr"},
     {"title": "CastleVectors.Lerp", "text": " Returns <code>(1-A) * V1 + A * V2</code>.  <p>So:  <p></p>  <ul class=\"compact_spacing\">   <li><p>A = 0 gives V1,</p></li>   <li><p>A = 1 gives V2,</p></li>   <li><p>values between are interpolated,</p></li>   <li><p>values outside are extrapolated.</p></li> </ul>  <p>  <p>    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.TryInverseHarder", "text": "    ", "tags": "", "loc": "CastleVectors.html#TryInverseHarder"},
     {"title": "CastleVectors.CosAngleBetweenVectors", "text": "  <p><a class=\"normal\" href=\"CastleVectors.html#CosAngleBetweenNormals\">CosAngleBetweenNormals</a> is a little faster, but must receive normalized (length 1) vectors. This avoids expensive Sqrt inside <code>CosAngleBetweenVectors</code>.  <p>     EVectorInvalidOp If V1 or V2 is zero.", "tags": "", "loc": "CastleVectors.html#CosAngleBetweenVectors"},
     {"title": "CastleVectors.CosAngleBetweenNormals", "text": "    ", "tags": "", "loc": "CastleVectors.html#CosAngleBetweenNormals"},
     {"title": "CastleVectors.AngleRadBetweenVectors", "text": " Returns always positive angle, between 0 and Pi.  <p><a class=\"normal\" href=\"CastleVectors.html#AngleRadBetweenNormals\">AngleRadBetweenNormals</a> is a little faster, but must receive normalized (length 1) vectors. This avoids expensive Sqrt. See also <a class=\"normal\" href=\"CastleVectors.html#CosAngleBetweenVectors\">CosAngleBetweenVectors</a> and <a class=\"normal\" href=\"CastleVectors.html#CosAngleBetweenNormals\">CosAngleBetweenNormals</a> to avoid expensive ArcCos.  <p>     EVectorInvalidOp If V1 or V2 is zero.", "tags": "", "loc": "CastleVectors.html#AngleRadBetweenVectors"},
     {"title": "CastleVectors.AngleRadBetweenNormals", "text": "    ", "tags": "", "loc": "CastleVectors.html#AngleRadBetweenNormals"},
     {"title": "CastleVectors.RotationAngleRadBetweenVectors", "text": " As opposed to <a class=\"normal\" href=\"CastleVectors.html#AngleRadBetweenNormals\">AngleRadBetweenNormals</a>, this returns a signed angle, between -Pi and Pi. This is guaranteed to be such angle that rotating V1 around vector cross product (V1 x V2) will produce V2. As you see, the order or arguments is important (just like it's important for vector cross).  <p>Overloaded versions with Cross argument assume the rotation is done around given Cross vector, which <i>must</i> be a cross product or it's negation (in other words, it must be orthogonal to both vectors).  <p>     EVectorInvalidOp If V1 or V2 is zero.", "tags": "", "loc": "CastleVectors.html#RotationAngleRadBetweenVectors"},
     {"title": "CastleVectors.RotationAngleRadBetweenVectors", "text": "    ", "tags": "", "loc": "CastleVectors.html#RotationAngleRadBetweenVectors"},
     {"title": "CastleVectors.RotatePointAroundAxisRad", "text": " Axis does not have to be normalized (it will be normalized internally).  <p>Axis can be an exact zero only if Angle is also an exact zero. This special case is supported to make it easier to initialize stuff. This way by default a vector and an angle can be left filled with zeros (like <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Rotation\">TCastleTransform.Rotation</a>), and this function will accept them (in effect e.g. <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Direction\">TCastleTransform.Direction</a> will be valid). In all other cases, axis must be a non-zero vector.  <p>Note that this is equivalent to constructing a rotation matrix and then using it, like  <p></p>  <pre class=\"longcode\"> M := RotationMatrixRad(Angle, Axis); Result := M.MultPoint(Point);</pre>  <p>  <p>Except this will be a little faster.  <p>Rotations are done in the same direction as <a class=\"normal\" href=\"CastleVectors.html#RotationMatrixRad\">RotationMatrixRad</a>, and as OpenGL.  <p>    ", "tags": "", "loc": "CastleVectors.html#RotatePointAroundAxisRad"},
     {"title": "CastleVectors.RotatePointAroundAxisDeg", "text": "    ", "tags": "", "loc": "CastleVectors.html#RotatePointAroundAxisDeg"},
     {"title": "CastleVectors.RotatePointAroundAxis", "text": " Axis is specified in the first 3 components of AxisAngle, rotation angle (in radians) is specified in the last component of AxisAngle.    ", "tags": "", "loc": "CastleVectors.html#RotatePointAroundAxis"},
     {"title": "CastleVectors.MaxVectorCoord", "text": " When the vector components are equal, the first one &quot;wins&quot;, for example if V[0] = V[1] (and are larger than other vector component) we return 0. <a class=\"normal\" href=\"CastleVectors.html#MaxAbsVectorCoord\">MaxAbsVectorCoord</a> compares the absolute value of components.     ", "tags": "", "loc": "CastleVectors.html#MaxVectorCoord"},
     {"title": "CastleVectors.MaxVectorCoord", "text": "    ", "tags": "", "loc": "CastleVectors.html#MaxVectorCoord"},
     {"title": "CastleVectors.MaxVectorCoord", "text": "    ", "tags": "", "loc": "CastleVectors.html#MaxVectorCoord"},
     {"title": "CastleVectors.MaxAbsVectorCoord", "text": "    ", "tags": "", "loc": "CastleVectors.html#MaxAbsVectorCoord"},
     {"title": "CastleVectors.MaxAbsVectorCoord", "text": "    ", "tags": "", "loc": "CastleVectors.html#MaxAbsVectorCoord"},
     {"title": "CastleVectors.MinVectorCoord", "text": "    ", "tags": "", "loc": "CastleVectors.html#MinVectorCoord"},
     {"title": "CastleVectors.SortAbsVectorCoord", "text": "    ", "tags": "", "loc": "CastleVectors.html#SortAbsVectorCoord"},
     {"title": "CastleVectors.PlaneDirInDirection", "text": "  <p>Given a plane equation (or just the first 3 components of this equation), we have vector orthogonal to the plane (just the first 3 components of plane equation). This returns either this vector, or it's negation. It chooses the one that points in the same 3D half-space as given Direction.  <p>When given Direction is paralell to Plane, returns original plane direction, not it's negation.  <p>This really simply returns the first 3 components of plane equation. possibly negated. So e.g. if the plane direction was normalized, result is normalized too.  <p><a class=\"normal\" href=\"CastleVectors.html#PlaneDirNotInDirection\">PlaneDirNotInDirection</a> chooses the direction opposite to given Direction parameter. So it's like <code><a class=\"normal\" href=\"CastleVectors.html#PlaneDirInDirection\">PlaneDirInDirection</a>(Plane, -Direction)</code>.  <p>    ", "tags": "", "loc": "CastleVectors.html#PlaneDirInDirection"},
     {"title": "CastleVectors.PlaneDirInDirection", "text": "    ", "tags": "", "loc": "CastleVectors.html#PlaneDirInDirection"},
     {"title": "CastleVectors.PlaneDirNotInDirection", "text": "    ", "tags": "", "loc": "CastleVectors.html#PlaneDirNotInDirection"},
     {"title": "CastleVectors.PlaneDirNotInDirection", "text": "    ", "tags": "", "loc": "CastleVectors.html#PlaneDirNotInDirection"},
     {"title": "CastleVectors.SwapEndian", "text": "    ", "tags": "", "loc": "CastleVectors.html#SwapEndian"},
     {"title": "CastleVectors.SwapEndian", "text": "    ", "tags": "", "loc": "CastleVectors.html#SwapEndian"},
     {"title": "CastleVectors.SwapEndian", "text": "    ", "tags": "", "loc": "CastleVectors.html#SwapEndian"},
     {"title": "CastleVectors.LEtoN", "text": "    ", "tags": "", "loc": "CastleVectors.html#LEtoN"},
     {"title": "CastleVectors.LEtoN", "text": "    ", "tags": "", "loc": "CastleVectors.html#LEtoN"},
     {"title": "CastleVectors.LEtoN", "text": "    ", "tags": "", "loc": "CastleVectors.html#LEtoN"},
     {"title": "CastleVectors.BEtoN", "text": "    ", "tags": "", "loc": "CastleVectors.html#BEtoN"},
     {"title": "CastleVectors.BEtoN", "text": "    ", "tags": "", "loc": "CastleVectors.html#BEtoN"},
     {"title": "CastleVectors.BEtoN", "text": "    ", "tags": "", "loc": "CastleVectors.html#BEtoN"},
     {"title": "CastleVectors.NtoLE", "text": "    ", "tags": "", "loc": "CastleVectors.html#NtoLE"},
     {"title": "CastleVectors.NtoLE", "text": "    ", "tags": "", "loc": "CastleVectors.html#NtoLE"},
     {"title": "CastleVectors.NtoLE", "text": "    ", "tags": "", "loc": "CastleVectors.html#NtoLE"},
     {"title": "CastleVectors.NtoBE", "text": "    ", "tags": "", "loc": "CastleVectors.html#NtoBE"},
     {"title": "CastleVectors.NtoBE", "text": "    ", "tags": "", "loc": "CastleVectors.html#NtoBE"},
     {"title": "CastleVectors.NtoBE", "text": "    ", "tags": "", "loc": "CastleVectors.html#NtoBE"},
     {"title": "CastleVectors.SwapValues", "text": "    ", "tags": "", "loc": "CastleVectors.html#SwapValues"},
     {"title": "CastleVectors.SwapValues", "text": "    ", "tags": "", "loc": "CastleVectors.html#SwapValues"},
     {"title": "CastleVectors.SwapValues", "text": "    ", "tags": "", "loc": "CastleVectors.html#SwapValues"},
     {"title": "CastleVectors.NormalizePlaneVar", "text": "  <p>Also, contrary to normal <a class=\"normal\" href=\"CastleVectors.html#NormalizeVar\">NormalizeVar</a> on 3-component vectors, this will fail with some awful error (like floating point overflow) in case length of plane vector is zero. That's because we know that plane vector <i>must</i> be always non-zero.    ", "tags": "", "loc": "CastleVectors.html#NormalizePlaneVar"},
     {"title": "CastleVectors.TwoPlanesIntersectionLine", "text": "      EPlanesParallel If planes are parallel.", "tags": "", "loc": "CastleVectors.html#TwoPlanesIntersectionLine"},
     {"title": "CastleVectors.Lines2DIntersection", "text": " 2D lines are expressed here as a vector of three values (A,B,C), such that Ax+By+C=0 is true for points on the line.      ELinesParallel if lines parallel", "tags": "", "loc": "CastleVectors.html#Lines2DIntersection"},
     {"title": "CastleVectors.ThreePlanesIntersectionPoint", "text": " If the intersection is not a single 3D point, result is undefined, so don't try to use this.     ", "tags": "", "loc": "CastleVectors.html#ThreePlanesIntersectionPoint"},
     {"title": "CastleVectors.PlaneMove", "text": " The first three plane numbers (plane normal vector) don't change (so, in particular, if you used the plane to define the half-space, the half-space gets moved as it should).  <p><a class=\"normal\" href=\"CastleVectors.html#PlaneAntiMove\">PlaneAntiMove</a> work like <code>PlaneMove</code>, but they translate by negated Move So it's like <a class=\"normal\" href=\"CastleVectors.html#PlaneAntiMove\">PlaneAntiMove</a>(Plane, V) := <code>PlaneMove</code>(Plane, -V), but (very slightly) faster.  <p>This works Ok with invalid planes (1st three components = 0), that is after the move the plane remains invalid (1st three components remain = 0).  <p>    ", "tags": "", "loc": "CastleVectors.html#PlaneMove"},
     {"title": "CastleVectors.PlaneMoveVar", "text": "    ", "tags": "", "loc": "CastleVectors.html#PlaneMoveVar"},
     {"title": "CastleVectors.PlaneAntiMove", "text": "    ", "tags": "", "loc": "CastleVectors.html#PlaneAntiMove"},
     {"title": "CastleVectors.VectorsSamePlaneDirections", "text": " If one direction is parallel to the plane, also returns <code>True</code>. You can specify only the first 3 components of plane equation (PlaneDir), since the 4th component would be ignored anyway.     ", "tags": "", "loc": "CastleVectors.html#VectorsSamePlaneDirections"},
     {"title": "CastleVectors.VectorsSamePlaneDirections", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsSamePlaneDirections"},
     {"title": "CastleVectors.PointsSamePlaneSides", "text": " If one of the points is exactly on the plane, also returns <code>True</code>.     ", "tags": "", "loc": "CastleVectors.html#PointsSamePlaneSides"},
     {"title": "CastleVectors.PointsDistance", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointsDistance"},
     {"title": "CastleVectors.PointsDistance", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointsDistance"},
     {"title": "CastleVectors.PointsDistanceSqr", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointsDistanceSqr"},
     {"title": "CastleVectors.PointsDistanceSqr", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointsDistanceSqr"},
     {"title": "CastleVectors.PointsDistance2DSqr", "text": " Projection is done by rejecting IgnoreIndex coordinate (must be 0, 1 or 2).     ", "tags": "", "loc": "CastleVectors.html#PointsDistance2DSqr"},
     {"title": "CastleVectors.VectorsPerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerp"},
     {"title": "CastleVectors.VectorsParallel", "text": " In particular, if one of the vectors is zero, then this is <code>True</code>.     ", "tags": "", "loc": "CastleVectors.html#VectorsParallel"},
     {"title": "CastleVectors.MakeVectorsAngleRadOnTheirPlane", "text": " Vector V1 will be adjusted, such that it has the same length and the 3D plane defined by V1, V2 and (0, 0, 0) is the same.  <p>When vectors are parallel (this includes the case when one of them is zero), we set V1 to ResultWhenParallel.  <p>We make it such that V1 rotated around axis TVector3.CrossProduct(V1, V2) by given angle will result in V2. Note that this means that <code><code>MakeVectorsAngleRadOnTheirPlane</code>(V1, V2, Angle, ...)</code> results in the same (not reversed) relation between vectors as <code><code>MakeVectorsAngleRadOnTheirPlane</code>(V2, V1, Angle, ...)</code>. That's because you change the arguments order, but also TVector3.CrossProduct sign changes.     ", "tags": "", "loc": "CastleVectors.html#MakeVectorsAngleRadOnTheirPlane"},
     {"title": "CastleVectors.MakeVectorsOrthoOnTheirPlane", "text": " When vectors are parallel, we set V1 to be <a class=\"normal\" href=\"CastleVectors.html#AnyOrthogonalVector\">AnyOrthogonalVector</a>(V2).    ", "tags": "", "loc": "CastleVectors.html#MakeVectorsOrthoOnTheirPlane"},
     {"title": "CastleVectors.AnyOrthogonalVector", "text": " When V is non-zero, then the result is non-zero.     ", "tags": "", "loc": "CastleVectors.html#AnyOrthogonalVector"},
     {"title": "CastleVectors.AnyOrthogonalVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#AnyOrthogonalVector"},
     {"title": "CastleVectors.IsLineParallelToPlane", "text": "    ", "tags": "", "loc": "CastleVectors.html#IsLineParallelToPlane"},
     {"title": "CastleVectors.IsLineParallelToSimplePlane", "text": "    ", "tags": "", "loc": "CastleVectors.html#IsLineParallelToSimplePlane"},
     {"title": "CastleVectors.AreParallelVectorsSameDirection", "text": "  <p>This assumes that both vectors are non-zero. If one of the vectors is zero, the result is undefined &mdash; false or true. (but the function will surely not raise some floating point error etc.)    ", "tags": "", "loc": "CastleVectors.html#AreParallelVectorsSameDirection"},
     {"title": "CastleVectors.PointOnPlaneClosestToPoint", "text": "     ", "tags": "", "loc": "CastleVectors.html#PointOnPlaneClosestToPoint"},
     {"title": "CastleVectors.PointToPlaneDistanceSqr", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointToPlaneDistanceSqr"},
     {"title": "CastleVectors.PointToNormalizedPlaneDistance", "text": "  <p>Note: distance of the plane from origin point (0,0,0) may be simply obtained by Abs(Plane[3]) when Plane is Normalized.     ", "tags": "", "loc": "CastleVectors.html#PointToNormalizedPlaneDistance"},
     {"title": "CastleVectors.PointToPlaneDistance", "text": "  <p>Note that calculating this costs you one Sqrt (contrary to <a class=\"normal\" href=\"CastleVectors.html#PointToPlaneDistanceSqr\">PointToPlaneDistanceSqr</a> or <a class=\"normal\" href=\"CastleVectors.html#PointToNormalizedPlaneDistance\">PointToNormalizedPlaneDistance</a>).  <p>    ", "tags": "", "loc": "CastleVectors.html#PointToPlaneDistance"},
     {"title": "CastleVectors.PointToSimplePlaneDistance", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointToSimplePlaneDistance"},
     {"title": "CastleVectors.PointOnLineClosestToPoint", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointOnLineClosestToPoint"},
     {"title": "CastleVectors.PointOnLineClosestToPoint", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointOnLineClosestToPoint"},
     {"title": "CastleVectors.PointToLineDistanceSqr", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointToLineDistanceSqr"},
     {"title": "CastleVectors.TryPlaneLineIntersection", "text": "  <p>Returns <code>False</code> and doesn't modify Intersection or T when the line is parallel to the plane (this includes the case when the line <i>lies on a plane</i>, so theoretically the whole line is an intersection).  <p>Otherwise, returns <code>True</code>, and calculates 3D intersection point, or calculates T such that <code>3D intersection = Line0 + LineVector * T</code>. T is always within [0,1] range.     ", "tags": "", "loc": "CastleVectors.html#TryPlaneLineIntersection"},
     {"title": "CastleVectors.TryPlaneLineIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TryPlaneLineIntersection"},
     {"title": "CastleVectors.TrySimplePlaneRayIntersection", "text": "  <p>Returns <code>False</code> and doesn't modify Intersection or T when the ray is parallel to the plane (this includes the case when the ray <i>lies on a plane</i>. Also returns <code>False</code> when the ray would have to point in the opposite direction to hit the plane.  <p>Otherwise, returns <code>True</code>, and calculates 3D intersection point, or calculates T such that <code>3D intersection = RayOrigin + RayDirection * T</code>. T is always &gt;= 0.     ", "tags": "", "loc": "CastleVectors.html#TrySimplePlaneRayIntersection"},
     {"title": "CastleVectors.TrySimplePlaneRayIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TrySimplePlaneRayIntersection"},
     {"title": "CastleVectors.TrySimplePlaneRayIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TrySimplePlaneRayIntersection"},
     {"title": "CastleVectors.TryPlaneRayIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TryPlaneRayIntersection"},
     {"title": "CastleVectors.TryPlaneRayIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TryPlaneRayIntersection"},
     {"title": "CastleVectors.TrySimplePlaneSegmentIntersection", "text": "  <p>Returns <code>False</code> and doesn't modify Intersection or T when the segment is parallel to the plane (this includes the case when the segment <i>lies on a plane</i>. Also returns <code>False</code> when the segment would have to be longer to hit the plane.  <p>Otherwise, returns <code>True</code>, and calculates 3D intersection point, or calculates T such that <code>3D intersection = Segment0 + SegmentVector * T</code>. T is always in range [0,1].     ", "tags": "", "loc": "CastleVectors.html#TrySimplePlaneSegmentIntersection"},
     {"title": "CastleVectors.TrySimplePlaneSegmentIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TrySimplePlaneSegmentIntersection"},
     {"title": "CastleVectors.TrySimplePlaneSegmentIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TrySimplePlaneSegmentIntersection"},
     {"title": "CastleVectors.TryPlaneSegmentDirIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TryPlaneSegmentDirIntersection"},
     {"title": "CastleVectors.TryPlaneSegmentDirIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TryPlaneSegmentDirIntersection"},
     {"title": "CastleVectors.IsPointOnSegmentLineWithinSegment", "text": "    ", "tags": "", "loc": "CastleVectors.html#IsPointOnSegmentLineWithinSegment"},
     {"title": "CastleVectors.IsPointOnSegmentLineWithinSegment", "text": "    ", "tags": "", "loc": "CastleVectors.html#IsPointOnSegmentLineWithinSegment"},
     {"title": "CastleVectors.LineOfTwoDifferentPoints2d", "text": " When the points are equal, undefined.     ", "tags": "", "loc": "CastleVectors.html#LineOfTwoDifferentPoints2d"},
     {"title": "CastleVectors.PointToSegmentDistanceSqr", "text": "    ", "tags": "", "loc": "CastleVectors.html#PointToSegmentDistanceSqr"},
     {"title": "CastleVectors.PlaneTransform", "text": "  <p>  <p>    ETransformedResultInvalid Raised when matrix will transform some point to a direction, or direction to point, in homogeneous coordinates.", "tags": "", "loc": "CastleVectors.html#PlaneTransform"},
     {"title": "CastleVectors.IsTunnelSphereCollision", "text": "    ", "tags": "", "loc": "CastleVectors.html#IsTunnelSphereCollision"},
     {"title": "CastleVectors.IsSpheresCollision", "text": "    ", "tags": "", "loc": "CastleVectors.html#IsSpheresCollision"},
     {"title": "CastleVectors.IsSegmentSphereCollision", "text": "    ", "tags": "", "loc": "CastleVectors.html#IsSegmentSphereCollision"},
     {"title": "CastleVectors.TrySphereRayIntersection", "text": "    ", "tags": "", "loc": "CastleVectors.html#TrySphereRayIntersection"},
     {"title": "CastleVectors.TryCylinderRayIntersection", "text": "     ", "tags": "", "loc": "CastleVectors.html#TryCylinderRayIntersection"},
     {"title": "CastleVectors.TranslationMatrix", "text": "  <p>These functions generate the same matrices that are made by corresponding OpenGL (gl or glu) functions. So rotations will be generated in the same fashion, etc. For exact specification of what matrices they create see OpenGL specification for routines glTranslate, glScale, glRotate.  <p>Functions named Matrices below generate both normal and inverted matrices. For example, function RotationMatrices returns two matrices that you could calculate separately by  <p></p>  <pre class=\"longcode\">         Matrix: = RotationMatrix( Angle, Axis); InvertedMatrix: = RotationMatrix(-Angle, Axis);</pre>  <p>  <p>This is useful sometimes, and generating them both at the same time allows for some speedup (for example, calling RotationMatrix twice will calculate sincos of Angle twice).  <p>Note that inverse of scaling matrix will not exist if the ScaleFactor has one of the components zero ! Depending on InvertedMatrixIdentityIfNotExists, this will (if <code>False</code>) raise division by zero exception or (if <code>True</code>) cause the matrix to be set to identity.  <p>Note that rotation matrix (both normal and inverse) is always defined, for Axis = zero both normal and inverse matrices are set to identity.  <p>    ", "tags": "", "loc": "CastleVectors.html#TranslationMatrix"},
     {"title": "CastleVectors.TranslationMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#TranslationMatrix"},
     {"title": "CastleVectors.TranslationMatrices", "text": "    ", "tags": "", "loc": "CastleVectors.html#TranslationMatrices"},
     {"title": "CastleVectors.TranslationMatrices", "text": "    ", "tags": "", "loc": "CastleVectors.html#TranslationMatrices"},
     {"title": "CastleVectors.MultMatrixTranslation", "text": "  <p>This is equivalent to M := M * <a class=\"normal\" href=\"CastleVectors.html#TranslationMatrix\">TranslationMatrix</a>(Transl), but it works much faster since <a class=\"normal\" href=\"CastleVectors.html#TranslationMatrix\">TranslationMatrix</a> is a very simple matrix and multiplication by it may be much optimized.  <p>An additional speedup comes from the fact that the result is placed back in M (so on places where M doesn't change (and there's a lot of them for multiplication with translation matrix) there's no useless copying).  <p><a class=\"normal\" href=\"CastleVectors.html#MultMatricesTranslation\">MultMatricesTranslation</a> is analogous to calculating both <a class=\"normal\" href=\"CastleVectors.html#TranslationMatrix\">TranslationMatrix</a>(Transl) and it's inverse, and then  <p></p>  <pre class=\"longcode\"> M := M * translation; MInvert := inverted-translation * MInvert;</pre>  <p>  <p>The idea is that if M represented some translation, and MInvert it's inverse, then after <a class=\"normal\" href=\"CastleVectors.html#MultMatricesTranslation\">MultMatricesTranslation</a> this will still hold.  <p>    ", "tags": "", "loc": "CastleVectors.html#MultMatrixTranslation"},
     {"title": "CastleVectors.MultMatricesTranslation", "text": "    ", "tags": "", "loc": "CastleVectors.html#MultMatricesTranslation"},
     {"title": "CastleVectors.TransformToCoordsMatrix", "text": " Stuff multiplied by this matrix is supplied in other coordinate system.  <p>The &quot;new&quot; coordinate system (you specify it explicitly for <a class=\"normal\" href=\"CastleVectors.html#TransformToCoordsMatrix\">TransformToCoordsMatrix</a>) is the coordinate system in which your 3D stuff is defined. That is, when you supply the points (that will later be multiplied by <a class=\"normal\" href=\"CastleVectors.html#TransformToCoordsMatrix\">TransformToCoordsMatrix</a>) you think in the &quot;new&quot; coordinate system. The &quot;old&quot; coordinate system (you specify it explicitly for <a class=\"normal\" href=\"CastleVectors.html#TransformFromCoordsMatrix\">TransformFromCoordsMatrix</a>) is the coordinate system of stuff <i>after</i> it's multiplied by this matrix.  <p>This may get confusing, so to be more precise:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> <a class=\"normal\" href=\"CastleVectors.html#TransformToCoordsMatrix\">TransformToCoordsMatrix</a> says how the new coords system looks from the point of view of the old coords system. A stuff lying at (0, 0, 0) in new coord system will be seen at NewOrigin after the transformation (in the old coordinate system). Similarly, direction (0, 1, 0) will be seen as NewY after the transformation.</p></li>   <li><p> <a class=\"normal\" href=\"CastleVectors.html#TransformFromCoordsMatrix\">TransformFromCoordsMatrix</a> is the inverse: how the old system is seen from the new one. If before the transformation you are at OldOrigin, then after the transformation you are at (0, 0, 0). This is natural way to implement <a class=\"normal\" href=\"CastleVectors.html#LookAtMatrix\">LookAtMatrix</a>, <a class=\"normal\" href=\"CastleVectors.html#LookDirMatrix\">LookDirMatrix</a>.</p></li> </ul>  <p>  <p>The lengths of directions (New or Old X, Y, Z vectors) are meaningful. These vectors correspond to unit vectors (1, 0, 0), (0, 1, 0) and (0, 0, 1) in the other coordinate system. Supplying here non-normalized vectors will result in scaling.  <p>You can use the &quot;NoScale&quot; versions to have the vectors automatically normalized, thus you waste a little time (on normalizing) but you avoid the scaling.  <p>Overloaded versions without OldOrigin / NewOrigin parameters work like the old/new origin is zero. IOW, the origin of the coordinate system doesn't change in this case.  <p>    ", "tags": "", "loc": "CastleVectors.html#TransformToCoordsMatrix"},
     {"title": "CastleVectors.TransformToCoordsMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#TransformToCoordsMatrix"},
     {"title": "CastleVectors.TransformToCoordsNoScaleMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#TransformToCoordsNoScaleMatrix"},
     {"title": "CastleVectors.TransformFromCoordsMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#TransformFromCoordsMatrix"},
     {"title": "CastleVectors.TransformFromCoordsMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#TransformFromCoordsMatrix"},
     {"title": "CastleVectors.TransformFromCoordsNoScaleMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#TransformFromCoordsNoScaleMatrix"},
     {"title": "CastleVectors.TransformCoordsMatrices", "text": "  <p>    ", "tags": "", "loc": "CastleVectors.html#TransformCoordsMatrices"},
     {"title": "CastleVectors.TransformToCoords", "text": "  <p>Equivalent to <code><a class=\"normal\" href=\"CastleVectors.html#TransformToCoordsMatrix\">TransformToCoordsMatrix</a>(TVector3.Zero, NewX, NewY, NewZ).MultPoint(V)</code>. So the origin of new coordinate system is at the same place. You should pass NewX, NewY, NewZ vectors normalized if you want to preserve vector length.     ", "tags": "", "loc": "CastleVectors.html#TransformToCoords"},
     {"title": "CastleVectors.LookAtMatrix", "text": " Work according to right-handed coordinate system.  <p>When applied to the scene, they transform it, such that a camera standing at (0, 0, 0) (with dir (0, 0, -1) and up vector (0, 1, 0)), was seeing the same view as if it was standing at Eye (with given Dir and Up vectors).  <p>For <code>LookAtMatrix</code>, looking direction is implicitly given as <code>Center - Eye</code>. Just like gluLookAt.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>For the overloaded <a class=\"normal\" href=\"CastleVectors.html#LookDirMatrix\">LookDirMatrix</a> version with Side parameter, we assume that Dir, Side and Up are already normalized and orthogonal to each other.</p></li>   <li><p>For the overloaded version without the Side parameter, Dir and Up do not have to normalized. We'll normalize them if needed, so their lengths do not affect the result (just as the distance between Center and Eye points for <code>LookAtMatrix</code>).  <p>Also, Dir and Up do not have to be perfectly orthogonal (we will eventually adjust Up internally to make it orthogonal to Up).  <p>You still must make sure that Dir and Up are not parallel.</p></li> </ul>  <p>  <p>    ", "tags": "", "loc": "CastleVectors.html#LookAtMatrix"},
     {"title": "CastleVectors.LookDirMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#LookDirMatrix"},
     {"title": "CastleVectors.LookDirMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#LookDirMatrix"},
     {"title": "CastleVectors.FastLookDirMatrix", "text": "  <p>Has some assumptions that make it run fast: </p>  <ul class=\"paragraph_spacing\">   <li><p>It assumes camera position is zero.</p></li>   <li><p>It assumes that Dir and Up are already normalized and orthogonal.</p></li> </ul>  <p>  <p>    ", "tags": "", "loc": "CastleVectors.html#FastLookDirMatrix"},
     {"title": "CastleVectors.InverseFastLookDirMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#InverseFastLookDirMatrix"},
     {"title": "CastleVectors.ModelViewToNormalMatrix", "text": " See e.g. <a  href=\"http://www.lighthouse3d.com/tutorials/glsl-tutorial/the-normal-matrix/\">http://www.lighthouse3d.com/tutorials/glsl-tutorial/the-normal-matrix/</a> for explanation why this is necessary, and how it's done.    ", "tags": "", "loc": "CastleVectors.html#ModelViewToNormalMatrix"},
     {"title": "CastleVectors.VectorMultTransposedSameVector", "text": " For 3d vectors, this results in a 3x3 matrix. To put this inside a 4x4 matrix, we fill the last row and column just like for an identity matrix.  <p>This is useful for calculating rotation matrix.    ", "tags": "", "loc": "CastleVectors.html#VectorMultTransposedSameVector"},
     {"title": "CastleVectors.ScalingMatrix", "text": "    ", "tags": "", "loc": "CastleVectors.html#ScalingMatrix"},
     {"title": "CastleVectors.ScalingMatrices", "text": "    ", "tags": "", "loc": "CastleVectors.html#ScalingMatrices"},
     {"title": "CastleVectors.RotationMatrixRad", "text": "    ", "tags": "", "loc": "CastleVectors.html#RotationMatrixRad"},
     {"title": "CastleVectors.RotationMatrixDeg", "text": "    ", "tags": "", "loc": "CastleVectors.html#RotationMatrixDeg"},
     {"title": "CastleVectors.RotationMatrixRad", "text": "    ", "tags": "", "loc": "CastleVectors.html#RotationMatrixRad"},
     {"title": "CastleVectors.RotationMatrixDeg", "text": "    ", "tags": "", "loc": "CastleVectors.html#RotationMatrixDeg"},
     {"title": "CastleVectors.RotationMatricesRad", "text": "    ", "tags": "", "loc": "CastleVectors.html#RotationMatricesRad"},
     {"title": "CastleVectors.RotationMatricesRad", "text": "    ", "tags": "", "loc": "CastleVectors.html#RotationMatricesRad"},
     {"title": "CastleVectors.RotationNegate", "text": " This simply negates the 4th vector component.    ", "tags": "", "loc": "CastleVectors.html#RotationNegate"},
     {"title": "CastleVectors.RotatePoint2D", "text": " AngleRad is in radians.    ", "tags": "", "loc": "CastleVectors.html#RotatePoint2D"},
     {"title": "CastleVectors.Approximate3DScale", "text": " E.g. if your algorithm cannot handle non-uniform 3D or 2D scale, you have to approximate 3D or 2D scale by a single float.  <p>This is similar to an average of X, Y (and Z, in 3D), but it additionally secures in case some of X, Y, Z are negative and some are positive (like scale (-1, 1), common in 2D to flip horizontally).  <p>    ", "tags": "", "loc": "CastleVectors.html#Approximate3DScale"},
     {"title": "CastleVectors.Approximate3DScale", "text": "    ", "tags": "", "loc": "CastleVectors.html#Approximate3DScale"},
     {"title": "CastleVectors.Approximate2DScale", "text": "    ", "tags": "", "loc": "CastleVectors.html#Approximate2DScale"},
     {"title": "CastleVectors.Approximate2DScale", "text": "    ", "tags": "", "loc": "CastleVectors.html#Approximate2DScale"},
     {"title": "CastleVectors.ThreePlanesIntersectionPointDouble", "text": " If the intersection is not a single 3D point, result is undefined, so don't try to use this.     ", "tags": "", "loc": "CastleVectors.html#ThreePlanesIntersectionPointDouble"},
     {"title": "CastleVectors.Vector2Byte", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2Byte"},
     {"title": "CastleVectors.Vector3Byte", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3Byte"},
     {"title": "CastleVectors.Vector4Byte", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4Byte"},
     {"title": "CastleVectors.Vector2Byte", "text": " Each float component is converted such that float 0.0 (or less) results in byte 0, float 1.0 (or more) results in byte 255. Values between 0.0 and 1.0 are appropriately (linearly) converted into the byte range.     ", "tags": "", "loc": "CastleVectors.html#Vector2Byte"},
     {"title": "CastleVectors.Vector3Byte", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3Byte"},
     {"title": "CastleVectors.Vector4Byte", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4Byte"},
     {"title": "CastleVectors.Vector2", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2"},
     {"title": "CastleVectors.Vector3", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3"},
     {"title": "CastleVectors.Vector4", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Lerp", "text": "    ", "tags": "", "loc": "CastleVectors.html#Lerp"},
     {"title": "CastleVectors.Vector2Integer", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2Integer"},
     {"title": "CastleVectors.Vector3Integer", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3Integer"},
     {"title": "CastleVectors.Vector4Integer", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4Integer"},
     {"title": "CastleVectors.Vector2Cardinal", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2Cardinal"},
     {"title": "CastleVectors.Vector3Cardinal", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3Cardinal"},
     {"title": "CastleVectors.Vector4Cardinal", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4Cardinal"},
     {"title": "CastleVectors.Vector2SmallInt", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2SmallInt"},
     {"title": "CastleVectors.Vector2Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2Single"},
     {"title": "CastleVectors.Vector2Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2Single"},
     {"title": "CastleVectors.Vector3Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3Single"},
     {"title": "CastleVectors.Vector3Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3Single"},
     {"title": "CastleVectors.Vector3Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3Single"},
     {"title": "CastleVectors.Vector4Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4Single"},
     {"title": "CastleVectors.Vector4Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4Single"},
     {"title": "CastleVectors.Vector4Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4Single"},
     {"title": "CastleVectors.FloatsEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#FloatsEqual"},
     {"title": "CastleVectors.FloatsEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#FloatsEqual"},
     {"title": "CastleVectors.FloatToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#FloatToNiceStr"},
     {"title": "CastleVectors.FloatToRawStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#FloatToRawStr"},
     {"title": "CastleVectors.Zero", "text": "    ", "tags": "", "loc": "CastleVectors.html#Zero"},
     {"title": "CastleVectors.VectorAdd", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorAdd"},
     {"title": "CastleVectors.VectorAdd", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorAdd"},
     {"title": "CastleVectors.VectorAdd", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorAdd"},
     {"title": "CastleVectors.VectorSubtract", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorSubtract"},
     {"title": "CastleVectors.VectorSubtract", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorSubtract"},
     {"title": "CastleVectors.VectorSubtract", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorSubtract"},
     {"title": "CastleVectors.VectorMultiplyComponents", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorMultiplyComponents"},
     {"title": "CastleVectors.VectorMultiplyComponents", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorMultiplyComponents"},
     {"title": "CastleVectors.VectorMultiplyComponents", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorMultiplyComponents"},
     {"title": "CastleVectors.VectorProduct", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorProduct"},
     {"title": "CastleVectors.Normalized", "text": "    ", "tags": "", "loc": "CastleVectors.html#Normalized"},
     {"title": "CastleVectors.Normalized", "text": "    ", "tags": "", "loc": "CastleVectors.html#Normalized"},
     {"title": "CastleVectors.NormalizeVar", "text": "    ", "tags": "", "loc": "CastleVectors.html#NormalizeVar"},
     {"title": "CastleVectors.NormalizeVar", "text": "    ", "tags": "", "loc": "CastleVectors.html#NormalizeVar"},
     {"title": "CastleVectors.MatrixMult", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixMult"},
     {"title": "CastleVectors.MatrixMultPoint", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixMultPoint"},
     {"title": "CastleVectors.MatrixMultPoint", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixMultPoint"},
     {"title": "CastleVectors.MatrixMultDirection", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixMultDirection"},
     {"title": "CastleVectors.MatrixMultDirection", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixMultDirection"},
     {"title": "CastleVectors.VectorLenSqr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorLenSqr"},
     {"title": "CastleVectors.VectorLenSqr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorLenSqr"},
     {"title": "CastleVectors.VectorLenSqr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorLenSqr"},
     {"title": "CastleVectors.VectorLen", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorLen"},
     {"title": "CastleVectors.VectorLen", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorLen"},
     {"title": "CastleVectors.VectorLen", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorLen"},
     {"title": "CastleVectors.VectorAverage", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorAverage"},
     {"title": "CastleVectors.VectorToRawStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToRawStr"},
     {"title": "CastleVectors.VectorToRawStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToRawStr"},
     {"title": "CastleVectors.VectorToRawStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToRawStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.VectorToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorToNiceStr"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.ZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#ZeroVector"},
     {"title": "CastleVectors.PerfectlyZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#PerfectlyZeroVector"},
     {"title": "CastleVectors.PerfectlyZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#PerfectlyZeroVector"},
     {"title": "CastleVectors.PerfectlyZeroVector", "text": "    ", "tags": "", "loc": "CastleVectors.html#PerfectlyZeroVector"},
     {"title": "CastleVectors.VectorAdjustToLength", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorAdjustToLength"},
     {"title": "CastleVectors.VectorAdjustToLength", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorAdjustToLength"},
     {"title": "CastleVectors.VectorAdjustToLength", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorAdjustToLength"},
     {"title": "CastleVectors.Vector2SingleFromStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2SingleFromStr"},
     {"title": "CastleVectors.Vector3SingleFromStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3SingleFromStr"},
     {"title": "CastleVectors.Vector4SingleFromStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector4SingleFromStr"},
     {"title": "CastleVectors.VectorDotProduct", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorDotProduct"},
     {"title": "CastleVectors.VectorDotProduct", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorDotProduct"},
     {"title": "CastleVectors.VectorDotProduct", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorDotProduct"},
     {"title": "CastleVectors.VectorsEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsEqual"},
     {"title": "CastleVectors.VectorsEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsEqual"},
     {"title": "CastleVectors.VectorsEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsEqual"},
     {"title": "CastleVectors.VectorsEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsEqual"},
     {"title": "CastleVectors.VectorsEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsEqual"},
     {"title": "CastleVectors.VectorsEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.VectorsPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#VectorsPerfectlyEqual"},
     {"title": "CastleVectors.TryMatrixInverse", "text": "    ", "tags": "", "loc": "CastleVectors.html#TryMatrixInverse"},
     {"title": "CastleVectors.TryMatrixInverse", "text": "    ", "tags": "", "loc": "CastleVectors.html#TryMatrixInverse"},
     {"title": "CastleVectors.TryMatrixInverse", "text": "    ", "tags": "", "loc": "CastleVectors.html#TryMatrixInverse"},
     {"title": "CastleVectors.MatrixToRawStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixToRawStr"},
     {"title": "CastleVectors.MatrixToRawStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixToRawStr"},
     {"title": "CastleVectors.MatrixToRawStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixToRawStr"},
     {"title": "CastleVectors.MatrixToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixToNiceStr"},
     {"title": "CastleVectors.MatrixToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixToNiceStr"},
     {"title": "CastleVectors.MatrixToNiceStr", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixToNiceStr"},
     {"title": "CastleVectors.MatricesPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatricesPerfectlyEqual"},
     {"title": "CastleVectors.MatricesPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatricesPerfectlyEqual"},
     {"title": "CastleVectors.MatricesPerfectlyEqual", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatricesPerfectlyEqual"},
     {"title": "CastleVectors.MatrixRow", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixRow"},
     {"title": "CastleVectors.MatrixRow", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixRow"},
     {"title": "CastleVectors.MatrixRow", "text": "    ", "tags": "", "loc": "CastleVectors.html#MatrixRow"},
     {"title": "CastleVectors.Vector2SingleCut", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector2SingleCut"},
     {"title": "CastleVectors.Vector3SingleCut", "text": "    ", "tags": "", "loc": "CastleVectors.html#Vector3SingleCut"},
     {"title": "CastleVectors.Matrix3Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Matrix3Single"},
     {"title": "CastleVectors.Matrix4Single", "text": "    ", "tags": "", "loc": "CastleVectors.html#Matrix4Single"},
     {"title": "CastleVectors.TVector2", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector2"},
     {"title": "CastleVectors.PVector2", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2"},
     {"title": "CastleVectors.TVector2Double", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector2Double"},
     {"title": "CastleVectors.PVector2Double", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2Double"},
     {"title": "CastleVectors.TVector3", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3"},
     {"title": "CastleVectors.PVector3", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3"},
     {"title": "CastleVectors.TVector3Double", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3Double"},
     {"title": "CastleVectors.PVector3Double", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3Double"},
     {"title": "CastleVectors.TVector4", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector4"},
     {"title": "CastleVectors.PVector4", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4"},
     {"title": "CastleVectors.TVector4Double", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector4Double"},
     {"title": "CastleVectors.PVector4Double", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4Double"},
     {"title": "CastleVectors.TMatrix2", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix2"},
     {"title": "CastleVectors.PMatrix2", "text": " ", "tags": "", "loc": "CastleVectors.html#PMatrix2"},
     {"title": "CastleVectors.TMatrix2Double", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix2Double"},
     {"title": "CastleVectors.PMatrix2Double", "text": " ", "tags": "", "loc": "CastleVectors.html#PMatrix2Double"},
     {"title": "CastleVectors.TMatrix3", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix3"},
     {"title": "CastleVectors.PMatrix3", "text": " ", "tags": "", "loc": "CastleVectors.html#PMatrix3"},
     {"title": "CastleVectors.TMatrix3Double", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix3Double"},
     {"title": "CastleVectors.PMatrix3Double", "text": " ", "tags": "", "loc": "CastleVectors.html#PMatrix3Double"},
     {"title": "CastleVectors.TMatrix4", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix4"},
     {"title": "CastleVectors.PMatrix4", "text": " ", "tags": "", "loc": "CastleVectors.html#PMatrix4"},
     {"title": "CastleVectors.TMatrix4Double", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix4Double"},
     {"title": "CastleVectors.PMatrix4Double", "text": " ", "tags": "", "loc": "CastleVectors.html#PMatrix4Double"},
     {"title": "CastleVectors.TVector2Array", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector2Array"},
     {"title": "CastleVectors.PVector2Array", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2Array"},
     {"title": "CastleVectors.TVector3Array", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3Array"},
     {"title": "CastleVectors.PVector3Array", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3Array"},
     {"title": "CastleVectors.TVector4Array", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector4Array"},
     {"title": "CastleVectors.PVector4Array", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4Array"},
     {"title": "CastleVectors.TGetVertexFromIndexFunc", "text": "    ", "tags": "", "loc": "CastleVectors.html#TGetVertexFromIndexFunc"},
     {"title": "CastleVectors.PVector2Byte", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2Byte"},
     {"title": "CastleVectors.PVector3Byte", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3Byte"},
     {"title": "CastleVectors.PVector4Byte", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4Byte"},
     {"title": "CastleVectors.TVector2ByteArray", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector2ByteArray"},
     {"title": "CastleVectors.PVector2ByteArray", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2ByteArray"},
     {"title": "CastleVectors.TVector3ByteArray", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3ByteArray"},
     {"title": "CastleVectors.PVector3ByteArray", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3ByteArray"},
     {"title": "CastleVectors.TVector4ByteArray", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector4ByteArray"},
     {"title": "CastleVectors.PVector4ByteArray", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4ByteArray"},
     {"title": "CastleVectors.PVector2Integer", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2Integer"},
     {"title": "CastleVectors.PVector3Integer", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3Integer"},
     {"title": "CastleVectors.PVector4Integer", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4Integer"},
     {"title": "CastleVectors.TVector2IntegerArray", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector2IntegerArray"},
     {"title": "CastleVectors.PVector2IntegerArray", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2IntegerArray"},
     {"title": "CastleVectors.TVector3IntegerArray", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3IntegerArray"},
     {"title": "CastleVectors.PVector3IntegerArray", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3IntegerArray"},
     {"title": "CastleVectors.TVector4IntegerArray", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector4IntegerArray"},
     {"title": "CastleVectors.PVector4IntegerArray", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4IntegerArray"},
     {"title": "CastleVectors.PVector2Cardinal", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2Cardinal"},
     {"title": "CastleVectors.PVector3Cardinal", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3Cardinal"},
     {"title": "CastleVectors.PVector4Cardinal", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4Cardinal"},
     {"title": "CastleVectors.TVector2CardinalArray", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector2CardinalArray"},
     {"title": "CastleVectors.PVector2CardinalArray", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2CardinalArray"},
     {"title": "CastleVectors.TVector3CardinalArray", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3CardinalArray"},
     {"title": "CastleVectors.PVector3CardinalArray", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3CardinalArray"},
     {"title": "CastleVectors.TVector4CardinalArray", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector4CardinalArray"},
     {"title": "CastleVectors.PVector4CardinalArray", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4CardinalArray"},
     {"title": "CastleVectors.PVector2SmallInt", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2SmallInt"},
     {"title": "CastleVectors.TVector2SmallIntList", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector2SmallIntList"},
     {"title": "CastleVectors.TVector3CardinalList", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3CardinalList"},
     {"title": "CastleVectors.TVector2Single", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector2Single"},
     {"title": "CastleVectors.TVector3Single", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3Single"},
     {"title": "CastleVectors.TVector4Single", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector4Single"},
     {"title": "CastleVectors.TMatrix2Single", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix2Single"},
     {"title": "CastleVectors.TMatrix3Single", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix3Single"},
     {"title": "CastleVectors.TMatrix4Single", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix4Single"},
     {"title": "CastleVectors.TVector2SingleList", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector2SingleList"},
     {"title": "CastleVectors.TVector3SingleList", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3SingleList"},
     {"title": "CastleVectors.TVector4SingleList", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector4SingleList"},
     {"title": "CastleVectors.TMatrix3SingleList", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix3SingleList"},
     {"title": "CastleVectors.TMatrix4SingleList", "text": " ", "tags": "", "loc": "CastleVectors.html#TMatrix4SingleList"},
     {"title": "CastleVectors.TVector3LongInt", "text": " ", "tags": "", "loc": "CastleVectors.html#TVector3LongInt"},
     {"title": "CastleVectors.PVector2Single", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector2Single"},
     {"title": "CastleVectors.PVector3Single", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3Single"},
     {"title": "CastleVectors.PVector4Single", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector4Single"},
     {"title": "CastleVectors.PMatrix2Single", "text": " ", "tags": "", "loc": "CastleVectors.html#PMatrix2Single"},
     {"title": "CastleVectors.PMatrix3Single", "text": " ", "tags": "", "loc": "CastleVectors.html#PMatrix3Single"},
     {"title": "CastleVectors.PMatrix4Single", "text": " ", "tags": "", "loc": "CastleVectors.html#PMatrix4Single"},
     {"title": "CastleVectors.PVector3LongInt", "text": " ", "tags": "", "loc": "CastleVectors.html#PVector3LongInt"},
     {"title": "CastleVectorsInternalDouble", "text": "  <p>This is an internal unit: do not use this in your code, you do not want to have the types like <a class=\"normal\" href=\"CastleVectorsInternalDouble.html#TGenericScalar\">TGenericScalar</a> or <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector3.html\">TGenericVector3</a> defined.  <p>Instead use the types exposed by <a class=\"normal\" href=\"CastleVectors.html\">CastleVectors</a> unit, like <a class=\"normal\" href=\"CastleVectors.html#TVector3Double\">TVector3Double</a>. ", "tags": "", "loc": "CastleVectorsInternalDouble.html"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2", "text": "  ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Data"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#+"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.*", "text": " This is consistent with GLSL and other vector APIs.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2./", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#/"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Init", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Init"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#ToString"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#ToRawString"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Normalize", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Normalize"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.NormalizeMe", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#NormalizeMe"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Length", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Length"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.LengthSqr", "text": " This is slightly faster than <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector2.html#Length\">Length</a> as it avoids calculating a square root along the way. (But, please remember to not optimize your code without a need. Optimize only parts that are proven bottlenecks, otherwise don't make the code less readable for the sake of speed.)    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#LengthSqr"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.AdjustToLength", "text": " NewLength may be negative, in which case we'll negate the vector and then adjust it's length to <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector2.html#Abs\">Abs</a>(NewLength).    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#AdjustToLength"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.DotProduct", "text": " See <a  href=\"https://en.wikipedia.org/wiki/Dot_product\">https://en.wikipedia.org/wiki/Dot_product</a> .    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#DotProduct"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Abs", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Abs"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#IsZero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#IsZero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.IsPerfectlyZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#IsPerfectlyZero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Lerp", "text": "     ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Lerp"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Zero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Items"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.X", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#X"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.Y", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#Y"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.One", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#One"},
     {"title": "CastleVectorsInternalDouble.TGenericVector2.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector2.html#TIndex"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3", "text": "  <p>This is generic type (although not using &quot;proper&quot; Pascal generics for implementation reasons). In has two actual uses:  <p></p>  <ol class=\"compact_spacing\">   <li value=\"1\"><p><a class=\"normal\" href=\"CastleVectors.html#TVector3\">TVector3</a>, a vector of 3 Single values (floats with single precision),</p></li>   <li value=\"2\"><p><a class=\"normal\" href=\"CastleVectors.html#TVector3Double\">TVector3Double</a>, a vector of 3 Double values (floats with double precision).</p></li> </ol>  <p>  <p>The actual type of <a class=\"normal\" href=\"CastleVectorsInternalDouble.html#TGenericScalar\">TGenericScalar</a> is Single or Double for (respectively) <a class=\"normal\" href=\"CastleVectors.html#TVector3\">TVector3</a> or <a class=\"normal\" href=\"CastleVectors.html#TVector3Double\">TVector3Double</a>. ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Data"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#+"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.*", "text": " This is consistent with GLSL and other vector APIs.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3./", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#/"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Init", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Init"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#ToString"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#ToRawString"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Normalize", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Normalize"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.NormalizeMe", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#NormalizeMe"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Length", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Length"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.LengthSqr", "text": " This is slightly faster than <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector3.html#Length\">Length</a> as it avoids calculating a square root along the way. (But, please remember to not optimize your code without a need. Optimize only parts that are proven bottlenecks, otherwise don't make the code less readable for the sake of speed.)    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#LengthSqr"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.AdjustToLength", "text": " NewLength may be negative, in which case we'll negate the vector and then adjust it's length to <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector3.html#Abs\">Abs</a>(NewLength).    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#AdjustToLength"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.CrossProduct", "text": " See <a  href=\"http://en.wikipedia.org/wiki/Cross_product\">http://en.wikipedia.org/wiki/Cross_product</a> .  <p>Result is a vector orthogonal to both given vectors. Generally there are two such vectors, this method returns the <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector3.html#One\">one</a> following right-hand rule. More precisely, V1, V2 and Product(V1, V2) are in the same relation as basic X, Y, Z axes. Reverse the order of arguments to get negated result.  <p>If you use this to calculate a normal vector of a triangle (P0, P1, P2): note that <code><a class=\"normal\" href=\"CastleVectors.html#VectorProduct\">VectorProduct</a>(P1 - P0, P1 - P2)</code> points out from CCW triangle side in right-handed coordinate system.  <p>When V1 and V2 are parallel (that is, when V1 = V2 multiplied by some scalar), and this includes the case when <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector3.html#One\">one</a> of them is zero, then result is a zero vector.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#CrossProduct"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.DotProduct", "text": " See <a  href=\"https://en.wikipedia.org/wiki/Dot_product\">https://en.wikipedia.org/wiki/Dot_product</a> .    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#DotProduct"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Abs", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Abs"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Min", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Min"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Max", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Max"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Average", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Average"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#IsZero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#IsZero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.IsPerfectlyZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#IsPerfectlyZero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.XY", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#XY"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Lerp", "text": " Returns <code>(1-A) * V1 + A * V2</code>.  <p>So:  <p></p>  <ul class=\"compact_spacing\">   <li><p>A = 0 gives V1,</p></li>   <li><p>A = 1 gives V2,</p></li>   <li><p>values between are interpolated,</p></li>   <li><p>values outside are extrapolated.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Lerp"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Zero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Items"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.X", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#X"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Y", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Y"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.Z", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#Z"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.One", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#One"},
     {"title": "CastleVectorsInternalDouble.TGenericVector3.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector3.html#TIndex"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4", "text": "  ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Data"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#+"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.*", "text": " This is consistent with GLSL and other vector APIs.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4./", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#/"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Init", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Init"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#ToString"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#ToRawString"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Length", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Length"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.LengthSqr", "text": " This is slightly faster than <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector4.html#Length\">Length</a> as it avoids calculating a square root along the way. (But, please remember to not optimize your code without a need. Optimize only parts that are proven bottlenecks, otherwise don't make the code less readable for the sake of speed.)    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#LengthSqr"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.AdjustToLength", "text": " NewLength may be negative, in which case we'll negate the vector and then adjust it's length to <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector4.html#Abs\">Abs</a>(NewLength).    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#AdjustToLength"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.DotProduct", "text": " See <a  href=\"https://en.wikipedia.org/wiki/Dot_product\">https://en.wikipedia.org/wiki/Dot_product</a> .    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#DotProduct"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Abs", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Abs"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#IsZero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#IsZero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.IsPerfectlyZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#IsPerfectlyZero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.ToPosition", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#ToPosition"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.XYZ", "text": " This simply rejects the 4th component.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#XYZ"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Lerp", "text": " Works analogous to <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericVector3.html#Lerp\">TVector3.Lerp</a>    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Lerp"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Zero"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Items"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.X", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#X"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Y", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Y"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.Z", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#Z"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.W", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#W"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.One", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#One"},
     {"title": "CastleVectorsInternalDouble.TGenericVector4.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericVector4.html#TIndex"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2", "text": "  ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Data"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#+"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.*", "text": " Note that this is different from vectors, where vector * vector makes a component-wise multiplication.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#ToString"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#ToRawString"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Determinant", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Determinant"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Inverse", "text": "  <p>This does division by ADeterminant internally, so will raise exception from this float division if the matrix is not reversible. Check Math.IsZero(ADeterminant) first to avoid this, or use <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericMatrix2.html#TryInverse\">TryInverse</a>.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Inverse"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.TryInverse", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#TryInverse"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Transpose", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Transpose"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Lerp", "text": "     ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Lerp"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Zero"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Identity", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Identity"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Items"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Rows", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Rows"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.Columns", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#Columns"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix2.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix2.html#TIndex"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3", "text": " Column-major, just like OpenGL, which means that the first index of <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericMatrix3.html#Data\">Data</a> array should be treated as a column number, the 2nd index is the row number.  <p>This is generic type (although not using &quot;proper&quot; Pascal generics for implementation reasons). In has two actual uses:  <p></p>  <ol class=\"compact_spacing\">   <li value=\"1\"><p><a class=\"normal\" href=\"CastleVectors.html#TMatrix3\">TMatrix3</a>, a matrix of 3 Single values (floats with single precision),</p></li>   <li value=\"2\"><p><a class=\"normal\" href=\"CastleVectors.html#TMatrix3Double\">TMatrix3Double</a>, a matrix of 3 Double values (floats with double precision).</p></li> </ol>  <p>  <p>The type <a class=\"normal\" href=\"CastleVectorsInternalDouble.html#TGenericScalar\">TGenericScalar</a> is, accordingly, Single or Double for <a class=\"normal\" href=\"CastleVectors.html#TMatrix3\">TMatrix3</a> or <a class=\"normal\" href=\"CastleVectors.html#TMatrix3Double\">TMatrix3Double</a>. ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Data"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#+"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.*", "text": " Note that this is different from vectors, where vector * vector makes a component-wise multiplication.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#ToString"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#ToRawString"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Determinant", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Determinant"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Inverse", "text": "  <p>This does division by ADeterminant internally, so will raise exception from this float division if the matrix is not reversible. Check Math.IsZero(ADeterminant) first to avoid this, or use <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericMatrix3.html#TryInverse\">TryInverse</a>.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Inverse"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.TryInverse", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#TryInverse"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Transpose", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Transpose"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Lerp", "text": "     ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Lerp"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Zero"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Identity", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Identity"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Items"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Rows", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Rows"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.Columns", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#Columns"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix3.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix3.html#TIndex"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4", "text": "  ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Data"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#+"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#-"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.*", "text": " Note that this is different from vectors, where vector * vector makes a component-wise multiplication.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#*"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#ToString"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#ToRawString"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Determinant", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Determinant"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Inverse", "text": "  <p>This does division by ADeterminant internally, so will raise exception from this float division if the matrix is not reversible. Check Math.IsZero(ADeterminant) first to avoid this, or use <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericMatrix4.html#TryInverse\">TryInverse</a>.    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Inverse"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.TryInverse", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#TryInverse"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Transpose", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Transpose"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.MultPoint", "text": "  <p>This works by temporarily converting point to 4-component vector (4th component is 1). After multiplying matrix * vector we divide by 4th component. So this works Ok for all matrices, even with last row different than <a class=\"normal\" href=\"CastleVectorsInternalDouble.TGenericMatrix4.html#Identity\">identity</a> (0, 0, 0, 1). E.g. this works for projection matrices too.  <p>  <p>    ETransformedResultInvalid This is raised when matrix will transform point to a direction (vector with 4th component equal zero). In this case we just cannot interpret the result as a point.", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#MultPoint"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.MultPoint", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#MultPoint"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.MultDirection", "text": "  <p>This works by temporarily converting direction to 4-component vector (4th component is 0). After multiplying matrix * vector we check is the 4th component still 0 (eventually raising <a class=\"normal\" href=\"CastleUtils.ETransformedResultInvalid.html\">ETransformedResultInvalid</a>).  <p>  <p>    ETransformedResultInvalid This is raised when matrix will transform direction to a point (vector with 4th component nonzero). In this case we just cannot interpret the result as a direction.", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#MultDirection"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.MultDirection", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#MultDirection"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Equals"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Lerp", "text": "     ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Lerp"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Zero"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Identity", "text": "    ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Identity"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Items"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Rows", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Rows"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.Columns", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#Columns"},
     {"title": "CastleVectorsInternalDouble.TGenericMatrix4.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.TGenericMatrix4.html#TIndex"},
     {"title": "CastleVectorsInternalDouble.TGenericScalar", "text": " ", "tags": "", "loc": "CastleVectorsInternalDouble.html#TGenericScalar"},
     {"title": "CastleVectorsInternalSingle", "text": "  <p>This is an internal unit: do not use this in your code, you do not want to have the types like <a class=\"normal\" href=\"CastleVectorsInternalSingle.html#TGenericScalar\">TGenericScalar</a> or <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html\">TGenericVector3</a> defined.  <p>Instead use the types exposed by NewVectors unit, like <a class=\"normal\" href=\"CastleVectors.html#TVector3\">TVector3</a>. ", "tags": "", "loc": "CastleVectorsInternalSingle.html"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2", "text": "  ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Data"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#+"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.*", "text": " This is consistent with GLSL and other vector APIs.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2./", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#/"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Init", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Init"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#ToString"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#ToRawString"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Normalize", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Normalize"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.NormalizeMe", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#NormalizeMe"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Length", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Length"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.LengthSqr", "text": " This is slightly faster than <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector2.html#Length\">Length</a> as it avoids calculating a square root along the way. (But, please remember to not optimize your code without a need. Optimize only parts that are proven bottlenecks, otherwise don't make the code less readable for the sake of speed.)    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#LengthSqr"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.AdjustToLength", "text": " NewLength may be negative, in which case we'll negate the vector and then adjust it's length to <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector2.html#Abs\">Abs</a>(NewLength).    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#AdjustToLength"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.DotProduct", "text": " See <a  href=\"https://en.wikipedia.org/wiki/Dot_product\">https://en.wikipedia.org/wiki/Dot_product</a> .    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#DotProduct"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Abs", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Abs"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#IsZero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#IsZero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.IsPerfectlyZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#IsPerfectlyZero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Lerp", "text": "     ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Lerp"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Zero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Items"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.X", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#X"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.Y", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#Y"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.One", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#One"},
     {"title": "CastleVectorsInternalSingle.TGenericVector2.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector2.html#TIndex"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3", "text": "  <p>This is generic type (although not using &quot;proper&quot; Pascal generics for implementation reasons). In has two actual uses:  <p></p>  <ol class=\"compact_spacing\">   <li value=\"1\"><p><a class=\"normal\" href=\"CastleVectors.html#TVector3\">TVector3</a>, a vector of 3 Single values (floats with single precision),</p></li>   <li value=\"2\"><p><a class=\"normal\" href=\"CastleVectors.html#TVector3Double\">TVector3Double</a>, a vector of 3 Double values (floats with double precision).</p></li> </ol>  <p>  <p>The actual type of <a class=\"normal\" href=\"CastleVectorsInternalSingle.html#TGenericScalar\">TGenericScalar</a> is Single or Double for (respectively) <a class=\"normal\" href=\"CastleVectors.html#TVector3\">TVector3</a> or <a class=\"normal\" href=\"CastleVectors.html#TVector3Double\">TVector3Double</a>. ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Data"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#+"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.*", "text": " This is consistent with GLSL and other vector APIs.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3./", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#/"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Init", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Init"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#ToString"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#ToRawString"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Normalize", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Normalize"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.NormalizeMe", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#NormalizeMe"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Length", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Length"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.LengthSqr", "text": " This is slightly faster than <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html#Length\">Length</a> as it avoids calculating a square root along the way. (But, please remember to not optimize your code without a need. Optimize only parts that are proven bottlenecks, otherwise don't make the code less readable for the sake of speed.)    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#LengthSqr"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.AdjustToLength", "text": " NewLength may be negative, in which case we'll negate the vector and then adjust it's length to <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html#Abs\">Abs</a>(NewLength).    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#AdjustToLength"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.CrossProduct", "text": " See <a  href=\"http://en.wikipedia.org/wiki/Cross_product\">http://en.wikipedia.org/wiki/Cross_product</a> .  <p>Result is a vector orthogonal to both given vectors. Generally there are two such vectors, this method returns the <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html#One\">one</a> following right-hand rule. More precisely, V1, V2 and Product(V1, V2) are in the same relation as basic X, Y, Z axes. Reverse the order of arguments to get negated result.  <p>If you use this to calculate a normal vector of a triangle (P0, P1, P2): note that <code><a class=\"normal\" href=\"CastleVectors.html#VectorProduct\">VectorProduct</a>(P1 - P0, P1 - P2)</code> points out from CCW triangle side in right-handed coordinate system.  <p>When V1 and V2 are parallel (that is, when V1 = V2 multiplied by some scalar), and this includes the case when <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html#One\">one</a> of them is zero, then result is a zero vector.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#CrossProduct"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.DotProduct", "text": " See <a  href=\"https://en.wikipedia.org/wiki/Dot_product\">https://en.wikipedia.org/wiki/Dot_product</a> .    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#DotProduct"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Abs", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Abs"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Min", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Min"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Max", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Max"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Average", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Average"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#IsZero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#IsZero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.IsPerfectlyZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#IsPerfectlyZero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.XY", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#XY"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Lerp", "text": " Returns <code>(1-A) * V1 + A * V2</code>.  <p>So:  <p></p>  <ul class=\"compact_spacing\">   <li><p>A = 0 gives V1,</p></li>   <li><p>A = 1 gives V2,</p></li>   <li><p>values between are interpolated,</p></li>   <li><p>values outside are extrapolated.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Lerp"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Zero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Items"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.X", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#X"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Y", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Y"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.Z", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#Z"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.One", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#One"},
     {"title": "CastleVectorsInternalSingle.TGenericVector3.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector3.html#TIndex"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4", "text": "  ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Data"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#+"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.*", "text": " This is consistent with GLSL and other vector APIs.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4./", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#/"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Init", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Init"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#ToString"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#ToRawString"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Length", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Length"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.LengthSqr", "text": " This is slightly faster than <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector4.html#Length\">Length</a> as it avoids calculating a square root along the way. (But, please remember to not optimize your code without a need. Optimize only parts that are proven bottlenecks, otherwise don't make the code less readable for the sake of speed.)    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#LengthSqr"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.AdjustToLength", "text": " NewLength may be negative, in which case we'll negate the vector and then adjust it's length to <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector4.html#Abs\">Abs</a>(NewLength).    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#AdjustToLength"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.DotProduct", "text": " See <a  href=\"https://en.wikipedia.org/wiki/Dot_product\">https://en.wikipedia.org/wiki/Dot_product</a> .    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#DotProduct"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Abs", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Abs"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#IsZero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.IsZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#IsZero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.IsPerfectlyZero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#IsPerfectlyZero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.ToPosition", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#ToPosition"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.XYZ", "text": " This simply rejects the 4th component.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#XYZ"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Lerp", "text": " Works analogous to <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericVector3.html#Lerp\">TVector3.Lerp</a>    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Lerp"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Zero"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Items"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.X", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#X"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Y", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Y"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.Z", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#Z"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.W", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#W"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.One", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#One"},
     {"title": "CastleVectorsInternalSingle.TGenericVector4.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericVector4.html#TIndex"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2", "text": "  ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Data"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#+"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.*", "text": " Note that this is different from vectors, where vector * vector makes a component-wise multiplication.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#ToString"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#ToRawString"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Determinant", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Determinant"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Inverse", "text": "  <p>This does division by ADeterminant internally, so will raise exception from this float division if the matrix is not reversible. Check Math.IsZero(ADeterminant) first to avoid this, or use <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericMatrix2.html#TryInverse\">TryInverse</a>.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Inverse"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.TryInverse", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#TryInverse"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Transpose", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Transpose"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Lerp", "text": "     ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Lerp"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Zero"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Identity", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Identity"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Items"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Rows", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Rows"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.Columns", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#Columns"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix2.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix2.html#TIndex"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3", "text": " Column-major, just like OpenGL, which means that the first index of <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericMatrix3.html#Data\">Data</a> array should be treated as a column number, the 2nd index is the row number.  <p>This is generic type (although not using &quot;proper&quot; Pascal generics for implementation reasons). In has two actual uses:  <p></p>  <ol class=\"compact_spacing\">   <li value=\"1\"><p><a class=\"normal\" href=\"CastleVectors.html#TMatrix3\">TMatrix3</a>, a matrix of 3 Single values (floats with single precision),</p></li>   <li value=\"2\"><p><a class=\"normal\" href=\"CastleVectors.html#TMatrix3Double\">TMatrix3Double</a>, a matrix of 3 Double values (floats with double precision).</p></li> </ol>  <p>  <p>The type <a class=\"normal\" href=\"CastleVectorsInternalSingle.html#TGenericScalar\">TGenericScalar</a> is, accordingly, Single or Double for <a class=\"normal\" href=\"CastleVectors.html#TMatrix3\">TMatrix3</a> or <a class=\"normal\" href=\"CastleVectors.html#TMatrix3Double\">TMatrix3Double</a>. ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Data"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#+"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.*", "text": " Note that this is different from vectors, where vector * vector makes a component-wise multiplication.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#ToString"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#ToRawString"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Determinant", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Determinant"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Inverse", "text": "  <p>This does division by ADeterminant internally, so will raise exception from this float division if the matrix is not reversible. Check Math.IsZero(ADeterminant) first to avoid this, or use <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericMatrix3.html#TryInverse\">TryInverse</a>.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Inverse"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.TryInverse", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#TryInverse"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Transpose", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Transpose"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Lerp", "text": "     ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Lerp"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Zero"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Identity", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Identity"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Items"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Rows", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Rows"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.Columns", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#Columns"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix3.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix3.html#TIndex"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4", "text": "  ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Data", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Data"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.+", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#+"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.-", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#-"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.*", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.*", "text": " Note that this is different from vectors, where vector * vector makes a component-wise multiplication.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#*"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.ToString", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#ToString"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.ToRawString", "text": " This may use the exponential (scientific) notation to represent the floating-point value, if needed.  <p>This is suitable for storing the value in a file, with a best precision possible.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#ToRawString"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Determinant", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Determinant"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Inverse", "text": "  <p>This does division by ADeterminant internally, so will raise exception from this float division if the matrix is not reversible. Check Math.IsZero(ADeterminant) first to avoid this, or use <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericMatrix4.html#TryInverse\">TryInverse</a>.    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Inverse"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.TryInverse", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#TryInverse"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Transpose", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Transpose"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.MultPoint", "text": "  <p>This works by temporarily converting point to 4-component vector (4th component is 1). After multiplying matrix * vector we divide by 4th component. So this works Ok for all matrices, even with last row different than <a class=\"normal\" href=\"CastleVectorsInternalSingle.TGenericMatrix4.html#Identity\">identity</a> (0, 0, 0, 1). E.g. this works for projection matrices too.  <p>  <p>    ETransformedResultInvalid This is raised when matrix will transform point to a direction (vector with 4th component equal zero). In this case we just cannot interpret the result as a point.", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#MultPoint"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.MultPoint", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#MultPoint"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.MultDirection", "text": "  <p>This works by temporarily converting direction to 4-component vector (4th component is 0). After multiplying matrix * vector we check is the 4th component still 0 (eventually raising <a class=\"normal\" href=\"CastleUtils.ETransformedResultInvalid.html\">ETransformedResultInvalid</a>).  <p>  <p>    ETransformedResultInvalid This is raised when matrix will transform direction to a point (vector with 4th component nonzero). In this case we just cannot interpret the result as a direction.", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#MultDirection"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.MultDirection", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#MultDirection"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Equals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Equals"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.PerfectlyEquals", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#PerfectlyEquals"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Lerp", "text": "     ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Lerp"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Zero", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Zero"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Identity", "text": "    ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Identity"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Items", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Items"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Rows", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Rows"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.Columns", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#Columns"},
     {"title": "CastleVectorsInternalSingle.TGenericMatrix4.TIndex", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.TGenericMatrix4.html#TIndex"},
     {"title": "CastleVectorsInternalSingle.TGenericScalar", "text": " ", "tags": "", "loc": "CastleVectorsInternalSingle.html#TGenericScalar"},
     {"title": "CastleVideos", "text": " ", "tags": "", "loc": "CastleVideos.html"},
     {"title": "CastleVideos.EInvalidFadeFrames", "text": " ", "tags": "", "loc": "CastleVideos.EInvalidFadeFrames.html"},
     {"title": "CastleVideos.TVideo", "text": "  <p>It can load movie from a sequence of image files. With the help of ffmpeg, it can also load any normal movie file format, like avi (compressed by anything ffmpeg can handle), OggTheora and many others. ffmpeg really handles probably everything you will ever want.  <p>Video is stored simply as a sequence of uncompressed images in memory. This is not good for real movies, so don't even try to open any real, 2 hour, full dvd resolution movie &mdash; loading will take hours and you will clog your memory. This class is <i>not</i> supposed to be used in a real movie player.  <p>However, this simple storage is perfect to load a short movie for some effect in a game, for example a simple movie with flames or smoke to be shown as texture in your 3D game. Memory and loading time is acceptable then, and you want to prepare all your textures before the game starts anyway (for a 3D game, there's no time to decode some movie format while playing...).  <p>See example program <code>castle_game_engine/examples/images_videos/simple_video_editor.lpr</code> in our engine for example of a simple movie player/editor implemented on top of this class. ", "tags": "", "loc": "CastleVideos.TVideo.html"},
     {"title": "CastleVideos.TVideo.Create", "text": "    ", "tags": "", "loc": "CastleVideos.TVideo.html#Create"},
     {"title": "CastleVideos.TVideo.Destroy", "text": "    ", "tags": "", "loc": "CastleVideos.TVideo.html#Destroy"},
     {"title": "CastleVideos.TVideo.Count", "text": " Use these only when <a class=\"normal\" href=\"CastleVideos.TVideo.html#Loaded\">Loaded</a> is <code>True</code>.  <p>Time is supposed to be in seconds. (Actually, we don't care; but when the movie file says to play &quot;25 frames per second&quot;, then we will make 25 frames per this Time unit. So you probably want to count the Time in seconds too.)  <p><a class=\"normal\" href=\"CastleVideos.TVideo.html#Count\">Count</a> is always &gt;= 1 when the video is loaded. That is, we don't allow videos with zero frames (I don't know if any movie format allows this.)  <p>    ", "tags": "", "loc": "CastleVideos.TVideo.html#Count"},
     {"title": "CastleVideos.TVideo.Width", "text": "    ", "tags": "", "loc": "CastleVideos.TVideo.html#Width"},
     {"title": "CastleVideos.TVideo.Height", "text": "    ", "tags": "", "loc": "CastleVideos.TVideo.html#Height"},
     {"title": "CastleVideos.TVideo.IndexFromTime", "text": "    ", "tags": "", "loc": "CastleVideos.TVideo.html#IndexFromTime"},
     {"title": "CastleVideos.TVideo.ImageFromTime", "text": "    ", "tags": "", "loc": "CastleVideos.TVideo.html#ImageFromTime"},
     {"title": "CastleVideos.TVideo.TimeDuration", "text": " In seconds (or, more precisely, in the same time units as for <a class=\"normal\" href=\"CastleVideos.TVideo.html#ImageFromTime\">ImageFromTime</a> and other methods).  <p>Note that this doesn't count the &quot;backwards&quot; running time, so it ignores <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeBackwards\">TimeBackwards</a> and <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeLoop\">TimeLoop</a> values.  <p>Use this only when <a class=\"normal\" href=\"CastleVideos.TVideo.html#Loaded\">Loaded</a>.    ", "tags": "", "loc": "CastleVideos.TVideo.html#TimeDuration"},
     {"title": "CastleVideos.TVideo.LoadFromFile", "text": "  <p>URL is downloaded using <a class=\"normal\" href=\"CastleDownload.html\">CastleDownload</a> unit. As always, if you all you care about is loading normal files, then just pass a normal filename (absolute or relative to the current directory) as the URL parameter.  <p>Supported video formats:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>We recognize video URLs by extension, and then try to load them through ffmpeg. So ffmpeg must be available on $PATH for this. See view3dscene docs for some links.  <p>Internally, for now we just use ffmpeg to decompose the video to single images, and then proceed to load this image sequence. So this takes some time and drains memory for longer movies, and it's not supposed to be really used to load longer movies.  <p>Of course, this may get improved (and some simple video formats may be handled without ffmpeg dependency) in the future, if the need arises. For now, it's enough for me &mdash; all I want is to load some simple texture movies (like smoke or fire or dense fog animations) to use as billboards in games. For such short movies, loading time and memory use are acceptable.</p></li>   <li><p>We can also load a sequence of images with a URL like image@counter(1).png.  <p>We use <a class=\"normal\" href=\"CastleStringUtils.html#FormatNameCounter\">FormatNameCounter</a> to recognize URLs with <code>@counter(*)</code> macro. If it contains <code>@counter(*)</code> macro, then we try to load image sequence starting from counter 1. If not, we just load a single image (and treat it as a movie with only one frame).  <p>Note that this allows you to have alpha channel for the video. Since we just load the sequence of images, they can have alpha channel just like any still image (e.g. PNG) can have it. So your animated texture of fire / smoke etc. will be rendered will all the features of alpha channel (blending or alha testing, depending on alpha channel type). I don't know if any video file format supports any kind of alpha channel, so using image sequence may be actually your only choice for videos with alpha channel.</p></li> </ul>  <p>  <p>Parameters ResizeToX, ResizeToY allow you to resize video frames. If one of them is non-zero, the appropriate video size (width and/or height) will be resized. Resizing quality is controlled by Interpolation parameter.    ", "tags": "", "loc": "CastleVideos.TVideo.html#LoadFromFile"},
     {"title": "CastleVideos.TVideo.SaveToFile", "text": "  <p>Handled formats: just like <a class=\"normal\" href=\"CastleVideos.TVideo.html#LoadFromFile\">LoadFromFile</a>. Also, just like <a class=\"normal\" href=\"CastleVideos.TVideo.html#LoadFromFile\">LoadFromFile</a>, we need ffmpeg on $PATH to save to any single-file movie format.    ", "tags": "", "loc": "CastleVideos.TVideo.html#SaveToFile"},
     {"title": "CastleVideos.TVideo.Resize", "text": "    ", "tags": "", "loc": "CastleVideos.TVideo.html#Resize"},
     {"title": "CastleVideos.TVideo.Close", "text": " <a class=\"normal\" href=\"CastleVideos.TVideo.html#Loaded\">Loaded</a> property changes to <code>False</code> after calling this.  <p>It's safe to call this even if <a class=\"normal\" href=\"CastleVideos.TVideo.html#Loaded\">Loaded</a> is already <code>False</code> &mdash; then this will do nothing.    ", "tags": "", "loc": "CastleVideos.TVideo.html#Close"},
     {"title": "CastleVideos.TVideo.MixWithSelfBackwards", "text": "  <p>This edits the loaded video, such that every frame becomes a mix between itself and the corresponding frame from the second half of the video. This forces any movie to become seamless when played in a loop.  <p>After this, the movie frames count is halved and <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeBackwards\">TimeBackwards</a> is set to <code>True</code>. This is to conserve memory (and running time of this function), since there's no point in keeping both halves of the movie anymore &mdash; they are identical (except reversed in time) after such operation.  <p><i>Unfortunately, this doesn't look perfect, human eye can easily notice the extreme time points (in the middle and at the end), when objects in the video reverse their directions etc. So the video is seamless, and it's a better trick than just setting <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeBackwards\">TimeBackwards</a> := true, but it still doesn't really look good.</i>  <p>If ProgressTitle &lt;&gt; '' this will call Progress.Init/Step/Fini from <a class=\"normal\" href=\"CastleProgress.html\">CastleProgress</a> to indicate progress of operation.    ", "tags": "", "loc": "CastleVideos.TVideo.html#MixWithSelfBackwards"},
     {"title": "CastleVideos.TVideo.FadeWithSelf", "text": "  <p>The idea is to take out last FadeFrames from the video (FadeFrames must be &gt;= 0 and &lt;= Count div 2). And then mix the beginning of the video, such that the beginning FadeFrames frames gradually fade from the original end of video to original begin of the video.  <p>Video must be loaded when using this.  <p>If ProgressTitle &lt;&gt; '' this will call Progress.Init/Step/Fini from <a class=\"normal\" href=\"CastleProgress.html\">CastleProgress</a> to indicate progress of operation.  <p>    EInvalidFadeFrames When FadeFrames is wrong.", "tags": "", "loc": "CastleVideos.TVideo.html#FadeWithSelf"},
     {"title": "CastleVideos.TVideo.FrameIndexFromTime", "text": " (Actually, <a class=\"normal\" href=\"CastleVideos.TVideo.html#IndexFromTime\">IndexFromTime</a> just calls this, but this is implementation detail...).  <p>The idea is that you can reuse the same algorithm in cases when you somehow have the video data but do not have an instance of <a class=\"normal\" href=\"CastleVideos.TVideo.html\">TVideo</a> class.  <p>In particular, this public for <a class=\"normal\" href=\"CastleGLImages.TGLVideo.html#IndexFromTime\">TGLVideo.IndexFromTime</a>, TGLVideo.GLTextureFromTime methods.    ", "tags": "", "loc": "CastleVideos.TVideo.html#FrameIndexFromTime"},
     {"title": "CastleVideos.TVideo.AlphaChannel", "text": " See TCastleImage.AlphaChannel for precise meaning of this. Currently based on the first video image, so it's fast although in some cases possibly inaccurate.    ", "tags": "", "loc": "CastleVideos.TVideo.html#AlphaChannel"},
     {"title": "CastleVideos.TVideo.FlipHorizontal", "text": "    ", "tags": "", "loc": "CastleVideos.TVideo.html#FlipHorizontal"},
     {"title": "CastleVideos.TVideo.FlipVertical", "text": "    ", "tags": "", "loc": "CastleVideos.TVideo.html#FlipVertical"},
     {"title": "CastleVideos.TVideo.Items", "text": " ", "tags": "", "loc": "CastleVideos.TVideo.html#Items"},
     {"title": "CastleVideos.TVideo.FramesPerSecond", "text": "  <p>For formats with varying frame-rate (although we do not support any such format right now), this will be just average frame-rate. The idea is that this property is just to show the user, so (s)he can judge the quality of the video. ", "tags": "", "loc": "CastleVideos.TVideo.html#FramesPerSecond"},
     {"title": "CastleVideos.TVideo.Loaded", "text": " ", "tags": "", "loc": "CastleVideos.TVideo.html#Loaded"},
     {"title": "CastleVideos.TVideo.TimeLoop", "text": "  <p>If <code>True</code> then <a class=\"normal\" href=\"CastleVideos.TVideo.html#IndexFromTime\">IndexFromTime</a> and <a class=\"normal\" href=\"CastleVideos.TVideo.html#ImageFromTime\">ImageFromTime</a> will return information that causes the video to be played in an infinite loop. This cooperates with <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeBackwards\">TimeBackwards</a>: If <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeBackwards\">TimeBackwards</a> is also <code>True</code>, then each loop step will play video once forward, and once backward &mdash; infinitely.  <p>It's Ok to change the value of this property at any time (even when video is not yet loaded), since this doesn't really cause any internal recalculation. It only affects what *FromTime methods return. ", "tags": "", "loc": "CastleVideos.TVideo.html#TimeLoop"},
     {"title": "CastleVideos.TVideo.TimeBackwards", "text": "  <p>This cooperates with <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeLoop\">TimeLoop</a>. If this is <code>True</code> and <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeLoop\">TimeLoop</a> = <code>False</code>, video will be played once forward, once backward, and then stop. If this is <code>True</code> and <a class=\"normal\" href=\"CastleVideos.TVideo.html#TimeLoop\">TimeLoop</a> = also <code>True</code>, then the video will be played forward, then backward, infinitely.  <p>It's Ok to change the value of this property at any time (even when video is not yet loaded), since this doesn't really cause any internal recalculation. It only affects what *FromTime methods return. ", "tags": "", "loc": "CastleVideos.TVideo.html#TimeBackwards"},
     {"title": "CastleVideos.TVideosCache", "text": "  <p>The idea is that instead of creating <a class=\"normal\" href=\"CastleVideos.TVideo.html\">TVideo</a> instance and calling <a class=\"normal\" href=\"CastleVideos.TVideo.html#LoadFromFile\">TVideo.LoadFromFile</a>, you instead call <code>Video := Cache.Video_IncReference(...)</code>. Later, instead of freeing this video, call <code><a class=\"normal\" href=\"CastleVideos.TVideosCache.html#Video_DecReference\">Video_DecReference</a>(Video)</code>. From your point of view, things will work the same. But if you expect to load many videos from the same URL, then you will get a great speed and memory saving, because video will only be actually loaded once. This may happen e.g. if you have a VRML / X3D file with lots of MovieTexture nodes with the same urls.  <p>Notes:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>All passed here URLs must be absolute.</p></li>   <li><p>Note that in case of problems with loading, <a class=\"normal\" href=\"CastleVideos.TVideosCache.html#Video_IncReference\">Video_IncReference</a> may raise an exception, just like normal <a class=\"normal\" href=\"CastleVideos.TVideo.html#LoadFromFile\">TVideo.LoadFromFile</a>. In this case it's guaranteed that no reference will be incremented, of course. If <a class=\"normal\" href=\"CastleVideos.TVideosCache.html#Video_IncReference\">Video_IncReference</a> returns in a normal way, then it will return something non-<code>Nil</code> for sure.</p></li>   <li><p><a class=\"normal\" href=\"CastleVideos.TVideosCache.html#Video_DecReference\">Video_DecReference</a> alwas sets Video to <code>Nil</code>, like FreeAndNil.</p></li>   <li><p>All videos handled here are always loaded. So <a class=\"normal\" href=\"CastleVideos.TVideosCache.html#Video_IncReference\">Video_IncReference</a> always returns <a class=\"normal\" href=\"CastleVideos.TVideo.html\">TVideo</a> with <a class=\"normal\" href=\"CastleVideos.TVideo.html#Loaded\">TVideo.Loaded</a> = <code>True</code>. And you are forbidden from closing this video by <a class=\"normal\" href=\"CastleVideos.TVideo.html#Close\">TVideo.Close</a> yourself.</p></li> </ul>  <p>  <p>Note that before destroying this object you must free all videos, i.e. call <a class=\"normal\" href=\"CastleVideos.TVideosCache.html#Video_DecReference\">Video_DecReference</a> for all videos allocated by <a class=\"normal\" href=\"CastleVideos.TVideosCache.html#Video_IncReference\">Video_IncReference</a>. <i>This class is not a lousy way of avoiding memory leaks</i> &mdash; it would be a bad idea, because it would cause sloppy programming, where memory is unnecessarily allocated for a long time. In fact, this class asserts in destructor that no videos are in cache anymore, so if you compiled with assertions enabled, this class does the job of memory-leak detector. ", "tags": "", "loc": "CastleVideos.TVideosCache.html"},
     {"title": "CastleVideos.TVideosCache.CheckEmpty", "text": " Note that <a class=\"normal\" href=\"CastleVideos.TVideosCache.html#OnEmpty\">OnEmpty</a> may destroy current instance, so call <code>CheckEmpty</code> only when you finished processing &mdash; Self may be invalid afterwards.    ", "tags": "", "loc": "CastleVideos.TVideosCache.html#CheckEmpty"},
     {"title": "CastleVideos.TVideosCache.Create", "text": "    ", "tags": "", "loc": "CastleVideos.TVideosCache.html#Create"},
     {"title": "CastleVideos.TVideosCache.Destroy", "text": "    ", "tags": "", "loc": "CastleVideos.TVideosCache.html#Destroy"},
     {"title": "CastleVideos.TVideosCache.Video_IncReference", "text": "    ", "tags": "", "loc": "CastleVideos.TVideosCache.html#Video_IncReference"},
     {"title": "CastleVideos.TVideosCache.Video_DecReference", "text": "    ", "tags": "", "loc": "CastleVideos.TVideosCache.html#Video_DecReference"},
     {"title": "CastleVideos.TVideosCache.Empty", "text": "    ", "tags": "", "loc": "CastleVideos.TVideosCache.html#Empty"},
     {"title": "CastleVideos.TVideosCache.OnEmpty", "text": " This is only for internal usage by <a class=\"normal\" href=\"X3DNodes.html\">X3DNodes</a> unit for now. ", "tags": "", "loc": "CastleVideos.TVideosCache.html#OnEmpty"},
     {"title": "CastleVideos.DefaultFramesPerSecond", "text": " ", "tags": "", "loc": "CastleVideos.html#DefaultFramesPerSecond"},
     {"title": "CastleVideos.FfmpegVideoMimeType", "text": "  <p>FfmpegOutput = <code>True</code> means that you want to encode this video (use this as output of ffmpeg). FfmpegOutput = <code>False</code> means you want to decode the video, that is use this as an input to ffmpeg.    ", "tags": "", "loc": "CastleVideos.html#FfmpegVideoMimeType"},
     {"title": "CastleVideos.FfmpegExecutable", "text": "  <p>When not found: </p>  <ul class=\"paragraph_spacing\">   <li><p>If ExceptionOnError then we raise an exception.</p></li>   <li><p>If not ExceptionOnError then we simply return ''.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleVideos.html#FfmpegExecutable"},
     {"title": "CastleVideos.FfmpegExecute", "text": " 1st parameter must not be ''. It should usually be calculated by <a class=\"normal\" href=\"CastleVideos.html#FfmpegExecutable\">FfmpegExecutable</a>.    ", "tags": "", "loc": "CastleVideos.html#FfmpegExecute"},
     {"title": "CastleVideos.LoadAnimatedGifs", "text": " Otherwise, we load GIF using <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> as a single (not animated) image.  <p>TODO: When the TFPReaderGif from FPC will support reading all GIF frames, then this variable will be ignored, and we will always read all GIF frames inside <a class=\"normal\" href=\"CastleVideos.TVideo.html\">TVideo</a>, <a class=\"normal\" href=\"CastleGLImages.TGLVideo2D.html\">TGLVideo2D</a>, <a class=\"normal\" href=\"CastleGLImages.TGLVideo3D.html\">TGLVideo3D</a>, and ffmpeg will not be necessary to read GIF animations.  <p>Use <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> if you want to always load GIF as static image (first frame, if case of animated GIF). ", "tags": "", "loc": "CastleVideos.html#LoadAnimatedGifs"},
     {"title": "CastleVideos.MaximumVideoLength", "text": "  <p>This prevents using up all the memory by accidentaly trying to read a long movie. Remember that our current implementation is <b>not</b> suited for long movies, it will load very slowly and consume a lot of memory. See <a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_texturing.php\">http://castle-engine.sourceforge.net/x3d_implementation_texturing.php</a> notes about MovieTexture.  <p>By default this is equal to 1 minute, for 25 frames-per-second movie. Even this can eat 2 GB for 640 x 350 resolution. ", "tags": "", "loc": "CastleVideos.html#MaximumVideoLength"},
     {"title": "CastleVideos.LogVideosCache", "text": " Allows to see how the cache performs, and also how long it takes to load videos (useful, as some videos may be already lengthy).  <p>Meaningful only if you initialized log (see <a class=\"normal\" href=\"CastleLog.html\">CastleLog</a> unit) by <a class=\"normal\" href=\"CastleLog.html#InitializeLog\">InitializeLog</a> first. ", "tags": "", "loc": "CastleVideos.html#LogVideosCache"},
     {"title": "CastleWindow", "text": " Provides a window with OpenGL context that can contain 2D controls and 3D objects defined by our engine. <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> is the base window class, and <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> is a comfortable class that adds a ready scene manager.  <p><a class=\"normal\" href=\"CastleWindow.html#Application\">Application</a> object (instance of class <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html\">TCastleApplication</a>) is a central manager of all open <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> windows.  <p>Using this unit:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Declare and create <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> instance. (Or a descendant like <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a>.)</p></li>   <li value=\"2\"><p>Assign Window properties and callbacks like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">OnRender</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">OnResize</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Caption\">Caption</a>.</p></li>   <li value=\"3\"><p>To initialize your game, you usually want to use <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">Application.OnInitialize</a>.  <p>If you only care about standalone programs (for normal OSes like Linux, Windows, MacOSX, but not Android) you may also just initialize your game in the main program block, although using <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">Application.OnInitialize</a> is still often comfortable.</p></li>   <li value=\"4\"><p>Call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Window.Open</a>, this will actually show the window and it's associated OpenGL context.  <p>The first window open calls <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">Application.OnInitialize</a>. It also calls <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">OnResize</a> callbacks.</p></li>   <li value=\"5\"><p>Call <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#Run\">Application.Run</a>. This will enter message loop that will call appropriate windows' callbacks at appropriate times (OnRender, OnPress, OnRelease, OnResize, OnUpdate and many more). There are also some Application callbacks, like <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnUpdate\">Application.OnUpdate</a>.  <p>For more advanced needs you can use something like  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">while</span> Application.ProcessMessage <span class=\"pascal_keyword\">do</span> &lt;something>;</pre>  <p>  <p>instead of Application.Run.  <p>You can also call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OpenAndRun\">Window.OpenAndRun</a>, this is just a shortcut for Window.Open + Application.Run.</p></li>   <li value=\"6\"><p>Application.Run ends when you call <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#Quit\">Application.Quit</a> or when you close last visible window using <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Close\">Close(true)</a>.  <p>User is also allowed to close a window using WindowManager facilities (clicking on &quot;X&quot; button in the frame corner, pressing Alt+F4 or something like that). By default, such user action will make window close (but you can freely customize what your program does when user tries to close the window using callback <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnCloseQuery\">OnCloseQuery</a>).</p></li> </ol>  <p>  <p>So the simplest example of using this unit can look like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">uses</span> CastleWindow;  <span class=\"pascal_keyword\">var</span>   Window: TCastleWindowCustom;  <span class=\"pascal_keyword\">procedure</span> Render(Sender: TUIContainer); <span class=\"pascal_keyword\">begin</span>  <span class=\"pascal_numeric\"></span>...  <span class=\"pascal_keyword\">end</span>;  <span class=\"pascal_keyword\">procedure</span> Resize(Sender: TUIContainer); <span class=\"pascal_keyword\">begin</span>  <span class=\"pascal_numeric\"></span>...  <span class=\"pascal_keyword\">end</span>;  <span class=\"pascal_keyword\">begin</span>   Window := TCastleWindowCustom.Create(Application);   Window.OnResize := @Resize;   Window.OnRender := @Render;   Window.Caption := <span class=\"pascal_string\">'Simplest CastleWindow example'</span>;   Window.OpenAndRun; <span class=\"pascal_keyword\">end</span>.</pre>  <p>  <p><i>More component-like approach</i>: For larger programs, it makes more sense to divide functionality into controls, which are classes descending from <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a>. You can override <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> methods to render, capture input and so on (see e.g. <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a>, <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Press\">TInputListener.Press</a>, <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">TInputListener.Update</a>.) You can then add your control to the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> list.  <p>Some features list:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#ProcessMessage\">TCastleApplication.ProcessMessage</a> method. This allows you to reimplement event loop handling, which is crucial for implementing things like <a class=\"normal\" href=\"CastleMessages.html#MessageInputQuery\">MessageInputQuery</a> function that does modal GUI dialog box.</p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Pressed\">TCastleWindowCustom.Pressed</a> to easily and reliably check which keys are pressed.</p></li>   <li><p>Application speed, see <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Fps\">TCastleWindowCustom.Fps</a>,</p></li>   <li><p>A menu bar under WinAPI and GTK backends.  <p>You can attach a menu to a window. Menu structure is constructed using various descendants of <a class=\"normal\" href=\"CastleWindow.TMenuEntry.html\">TMenuEntry</a> class. Then you have to assign such menu structure to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MainMenu\">TCastleWindowCustom.MainMenu</a> property. When <code>CastleWindow</code> is implemented on top of GTK_2 or WINAPI or LCL we will show this menu and call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnMenuClick\">TCastleWindowCustom.OnMenuClick</a> when user clicks some menu item. Other backends (XLIB for now) ignore MainMenu.  <p>See <code>castle_game_engine/examples/window/window_menu.lpr</code> for an example how to use the menu.</p></li>   <li><p>Changing screen resolution and bit depth, see <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#VideoChange\">TCastleApplication.VideoChange</a>.</p></li>   <li><p>You can request OpenGL context properties: </p>  <ul class=\"paragraph_spacing\">   <li><p>color buffer</p></li>   <li><p>with alpha channel (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AlphaBits\">AlphaBits</a>),</p></li>   <li><p>stencil buffer (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#StencilBits\">StencilBits</a>),</p></li>   <li><p>double buffer (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#DoubleBuffer\">DoubleBuffer</a>),</p></li>   <li><p>multisampling (full-screen antialiasing) buffers (by <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MultiSampling\">MultiSampling</a> or higher-level <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AntiAliasing\">AntiAliasing</a>)</p></li> </ul>  <p> </p></li>   <li><p>You can use native modal dialogs for things such as file selection. GTK backend will use GTK dialogs, WinAPI backend will use Windows dialog boxes, XLib backend will fall back on <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a> text input.  <p>See <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FileDialog\">TCastleWindowCustom.FileDialog</a> (for opening and saving files) and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ColorDialog\">TCastleWindowCustom.ColorDialog</a> (for choosing RGB colors).</p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ParseParameters\">TCastleWindowCustom.ParseParameters</a> method allows you to easily initialize <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> properties like initial size and position using command-line parameters like <code>--geometry WIDTHxHEIGHT</code>, <code>--display</code> etc.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleWindow.html"},
     {"title": "CastleWindow.TMenuEntry", "text": " This can be a separator, clickable menu item or something that expands to submenu. ", "tags": "", "loc": "CastleWindow.TMenuEntry.html"},
     {"title": "CastleWindow.TMenuEntry.ClearHandles", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuEntry.html#ClearHandles"},
     {"title": "CastleWindow.TMenuEntry.MenuUpdateBegin", "text": " Make sure window is not closed / opened between them.     ", "tags": "", "loc": "CastleWindow.TMenuEntry.html#MenuUpdateBegin"},
     {"title": "CastleWindow.TMenuEntry.MenuUpdateEnd", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuEntry.html#MenuUpdateEnd"},
     {"title": "CastleWindow.TMenuEntry.ParentMenu", "text": " <code>Nil</code> is there is not parent menu yet (e.g. because it's not assigned yet, or because this is the main menu). ", "tags": "", "loc": "CastleWindow.TMenuEntry.html#ParentMenu"},
     {"title": "CastleWindow.TMenuEntry.ParentMenuPosition", "text": " Indexed from 0, so ParentMenu.Entries[<code>ParentMenuPosition</code>] should be always equal to Self (as long as <a class=\"normal\" href=\"CastleWindow.TMenuEntry.html#ParentMenu\">ParentMenu</a> &lt;&gt; <code>Nil</code>. ", "tags": "", "loc": "CastleWindow.TMenuEntry.html#ParentMenuPosition"},
     {"title": "CastleWindow.TMenuEntryWithCaption", "text": " ", "tags": "", "loc": "CastleWindow.TMenuEntryWithCaption.html"},
     {"title": "CastleWindow.TMenuEntryWithCaption.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuEntryWithCaption.html#Create"},
     {"title": "CastleWindow.TMenuEntryWithCaption.Caption", "text": " Will be shown to user.  <p>To indicate that some letter of a caption is a mnemonic for this menu item put '_' (underscore) char before this letter. Depending on <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a>-backend-dependent, mnemonics should allow user to easier activate this menu item with keyboard (e.g. Alt+mnemonic to dropdown item in MainMenu).  <p>You can put two consecutive underscore chars in Caption to indicate that here Caption should display literally one underscore character.  <p>(Convention to mark mnemonics with '_' is just copied from gtk, from gtk_label_new_with_mnemonic. So no, I didn't invent another new convention here.)  <p>It is undefined what will happen if you put underscore chars before *two* or more letters in Caption. I.e. you can't define multiple mnemonics for one menu item. I.e. this will not crash your program, but results may be <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a>-backend-dependent.  <p>Just like in GTK toolkit gtk_label_new_with_mnemonic and gtk_menu_item_new_with_mnemonic. ", "tags": "", "loc": "CastleWindow.TMenuEntryWithCaption.html#Caption"},
     {"title": "CastleWindow.TMenuEntryWithCaption.Enabled", "text": " ", "tags": "", "loc": "CastleWindow.TMenuEntryWithCaption.html#Enabled"},
     {"title": "CastleWindow.TMenu", "text": " This is the basic class to represent a drop-down menu, a submenu etc. ", "tags": "", "loc": "CastleWindow.TMenu.html"},
     {"title": "CastleWindow.TMenu.ClearHandles", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#ClearHandles"},
     {"title": "CastleWindow.TMenu.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#Create"},
     {"title": "CastleWindow.TMenu.Destroy", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#Destroy"},
     {"title": "CastleWindow.TMenu.Count", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#Count"},
     {"title": "CastleWindow.TMenu.Insert", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#Insert"},
     {"title": "CastleWindow.TMenu.Append", "text": " Same as Insert(<a class=\"normal\" href=\"CastleWindow.TMenu.html#Count\">Count</a>, Value).    ", "tags": "", "loc": "CastleWindow.TMenu.html#Append"},
     {"title": "CastleWindow.TMenu.Delete", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#Delete"},
     {"title": "CastleWindow.TMenu.Clear", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#Clear"},
     {"title": "CastleWindow.TMenu.EntriesCount", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#EntriesCount"},
     {"title": "CastleWindow.TMenu.EntryDelete", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#EntryDelete"},
     {"title": "CastleWindow.TMenu.EntriesDeleteAll", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#EntriesDeleteAll"},
     {"title": "CastleWindow.TMenu.DeleteAll", "text": "    ", "tags": "", "loc": "CastleWindow.TMenu.html#DeleteAll"},
     {"title": "CastleWindow.TMenu.AppendRadioGroup", "text": " This is a comfortable shortcut for an often task of adding many <a class=\"normal\" href=\"CastleWindow.TMenuItemRadio.html\">TMenuItemRadio</a> items that create a new radio group (<a class=\"normal\" href=\"CastleWindow.TMenuItemRadioGroup.html\">TMenuItemRadioGroup</a>).  <p>For each item of Items list, we'll add a new <a class=\"normal\" href=\"CastleWindow.TMenuItemRadio.html\">TMenuItemRadio</a> instance.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>TMenuItemRadio.Caption will be set to the Items[I] string. Additionally it will be quoted by <a class=\"normal\" href=\"CastleWindow.html#SQuoteMenuEntryCaption\">SQuoteMenuEntryCaption</a> to avoid interpreting underscore characters (if QuoteCaption).</p></li>   <li><p>TMenuItemRadio.IntData will be set to BaseIntData + the number of this item. (This is usually most comfortable, you can handle this radio group by &quot;case&quot; with a range.)</p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.TMenuItemRadio.html#Group\">TMenuItemRadio.Group</a> will be equal. More precisely: along with creating the first <a class=\"normal\" href=\"CastleWindow.TMenuItemRadio.html\">TMenuItemRadio</a>, we will also create new <a class=\"normal\" href=\"CastleWindow.TMenuItemRadioGroup.html\">TMenuItemRadioGroup</a>. For the rest of <a class=\"normal\" href=\"CastleWindow.TMenuItemRadio.html\">TMenuItemRadio</a>, we'll assign this group.</p></li>   <li><p>TMenuItemRadio.Checked will be set to <code>True</code> on only one item: the one numbered SelectedIndex. Pass SelectedIndex negative (or &gt;= than items count) to have no radio item checked by default.</p></li>   <li><p>TMenuItemRadio.AutoCheckedToggle will be set according to ou parameter AAutoCheckedToggle.</p></li> </ul>  <p>  <p>We return the newly created <a class=\"normal\" href=\"CastleWindow.TMenuItemRadioGroup.html\">TMenuItemRadioGroup</a>. If Items is empty, this does nothing and returns <code>Nil</code>.    ", "tags": "", "loc": "CastleWindow.TMenu.html#AppendRadioGroup"},
     {"title": "CastleWindow.TMenu.Entries", "text": " Items are owned by this menu instance (are automatically freed at destruction, at <a class=\"normal\" href=\"CastleWindow.TMenu.html#Delete\">Delete</a> and such). ", "tags": "", "loc": "CastleWindow.TMenu.html#Entries"},
     {"title": "CastleWindow.TMenuItem", "text": " User expects that something will happend when he clicks on <code>TMenuItem</code>. You can also specify key shortcuts for this menu item. ", "tags": "", "loc": "CastleWindow.TMenuItem.html"},
     {"title": "CastleWindow.TMenuItem.DoClick", "text": "  <p>You can override this and return true if you handled the event. If this will return false, <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> will call EventMenuClick (OnMenuClick).  <p>When entering this method, current OpenGL context is set to the context of the window that the clicked menu belongs to.  <p>Default implementation of this method in this class always returns false.    ", "tags": "", "loc": "CastleWindow.TMenuItem.html#DoClick"},
     {"title": "CastleWindow.TMenuItem.KeyString", "text": " If both <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#CharKey\">CharKey</a> = #0 and Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> then returns false and S is undefined.    ", "tags": "", "loc": "CastleWindow.TMenuItem.html#KeyString"},
     {"title": "CastleWindow.TMenuItem.KeyMatches", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItem.html#KeyMatches"},
     {"title": "CastleWindow.TMenuItem.CaptionWithKey", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItem.html#CaptionWithKey"},
     {"title": "CastleWindow.TMenuItem.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItem.html#Create"},
     {"title": "CastleWindow.TMenuItem.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItem.html#Create"},
     {"title": "CastleWindow.TMenuItem.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItem.html#Create"},
     {"title": "CastleWindow.TMenuItem.Destroy", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItem.html#Destroy"},
     {"title": "CastleWindow.TMenuItem.IntData", "text": " Useful to identify this item in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnMenuClick\">TCastleWindowCustom.OnMenuClick</a> callback. ", "tags": "", "loc": "CastleWindow.TMenuItem.html#IntData"},
     {"title": "CastleWindow.TMenuItem.SmallId", "text": " This is initialized at creation of this object, to be unique among all currently existing (created and not destroyed) <a class=\"normal\" href=\"CastleWindow.TMenuItem.html\">TMenuItem</a> instances.  <p>The intention is that this <code>SmallId</code> should be the smallest possible value &gt;= 0. So it's not something like PtrUInt(Self). This may be useful when you're constructing a menu using some API &mdash; you usually want to identify your menu item by some unique id and you want this id to be small (e.g. under WinAPI menu item's id must fit in 16 bit integer).  <p> ", "tags": "", "loc": "CastleWindow.TMenuItem.html#SmallId"},
     {"title": "CastleWindow.TMenuItem.CharKey", "text": "  <p>When user presses indicated Key (if it's not <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a>) or <code>CharKey</code> (if it's not #0) then <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#DoClick\">DoClick</a> will be called (which results in TCastleWindowCustom.EventMenuClick, and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnMenuClick\">TCastleWindowCustom.OnMenuClick</a>, if <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#DoClick\">DoClick</a> returns false).  <p>Handling of menu key shortcuts is completely within the <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> (usually, it's even done by the underlying backend like GTK or WinAPI). You will not get EventPress (OnPress) messages for keypresses that translate to menu clicks. Although TCastleWindowCustom.Pressed.Keys will be still appropriately updated.  <p>Note that Caption of this object should not contain description of Key or <code>CharKey</code>. The backend will automatically show the key description in an appropriate way.  <p>You should use at most one of these properties, not both. So either use Key or <code>CharKey</code>, and leave the other one at default value (Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a>, <code>CharKey</code> = #0).  <p>The <code>CharKey</code> values within range <a class=\"normal\" href=\"CastleStringUtils.html#CtrlA\">CtrlA</a>..CtrlZ mean that user must press the given letter with Ctrl modfier. This rule includes some special chars like </p>  <ul class=\"paragraph_spacing\">   <li><p><code>CharKey</code> = #8 (equal to <a class=\"normal\" href=\"CastleStringUtils.html#CharBackSpace\">CharBackSpace</a>, also equal to <a class=\"normal\" href=\"CastleStringUtils.html#CtrlH\">CtrlH</a>) or</p></li>   <li><p><code>CharKey</code> = #9 (equal to <a class=\"normal\" href=\"CastleStringUtils.html#CharTab\">CharTab</a>, also equal to <a class=\"normal\" href=\"CastleStringUtils.html#CtrlI\">CtrlI</a>) or</p></li>   <li><p><code>CharKey</code> = #13 (equal to <a class=\"normal\" href=\"CastleStringUtils.html#CharEnter\">CharEnter</a>, also equal to <a class=\"normal\" href=\"CastleStringUtils.html#CtrlM\">CtrlM</a>).</p></li> </ul>  <p> The <code>CharKey</code> values above do <b>not</b> mean the backspace or tab or enter keys, they mean the combination of Ctrl key + respective letter. If you want to have backspace/tab/enter keys to activate the menu item, use Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_BackSpace\">K_BackSpace</a>, Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_Tab\">K_Tab</a> or Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_Enter\">K_Enter</a>.  <p>TODO: for now, this must be assigned before adding this menu item to parent (actually, before the parent menu is added to window MainMenu) to work reliably. Don't change this property afterwards. Usually, you will set this property by an argument to the constructor.  <p> ", "tags": "", "loc": "CastleWindow.TMenuItem.html#CharKey"},
     {"title": "CastleWindow.TMenuItem.Key", "text": " ", "tags": "", "loc": "CastleWindow.TMenuItem.html#Key"},
     {"title": "CastleWindow.TMenuItem.Modifiers", "text": " These have to be pressed along with <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#Key\">Key</a> or <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#CharKey\">CharKey</a>.  <p>Note that <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#CharKey\">CharKey</a> may already indicate some <code>modifiers</code>, if it's one of the <a class=\"normal\" href=\"CastleStringUtils.html#CtrlA\">CtrlA</a> ... <a class=\"normal\" href=\"CastleStringUtils.html#CtrlZ\">CtrlZ</a> then the Ctrl key is required and if it's an uppercase letter then the Shift key is required. There's no need to include this modifier in this property then.  <p>TODO: for now, this must be assigned before adding this menu item to parent (actually, before the parent menu is added to window MainMenu) to work reliably. Don't change this property afterwards. ", "tags": "", "loc": "CastleWindow.TMenuItem.html#Modifiers"},
     {"title": "CastleWindow.TMenuSeparator", "text": " This is not clickable by the user. Separators may be sometimes ignored in toplevel menus (e.g. WinAPI does not allow separator in toplevel menu bar). ", "tags": "", "loc": "CastleWindow.TMenuSeparator.html"},
     {"title": "CastleWindow.TMenuItemChecked", "text": " ", "tags": "", "loc": "CastleWindow.TMenuItemChecked.html"},
     {"title": "CastleWindow.TMenuItemChecked.SetChecked", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemChecked.html#SetChecked"},
     {"title": "CastleWindow.TMenuItemChecked.DoAutoCheckedToggle", "text": " It's supposed to actually implement the <a class=\"normal\" href=\"CastleWindow.TMenuItemChecked.html#AutoCheckedToggle\">AutoCheckedToggle</a> behavior.  <p>Note that this is overriden ina a &quot;dirty&quot; way (i.e. not calling &quot;inherited&quot;) in <a class=\"normal\" href=\"CastleWindow.TMenuItemRadio.html\">TMenuItemRadio</a> descendant.    ", "tags": "", "loc": "CastleWindow.TMenuItemChecked.html#DoAutoCheckedToggle"},
     {"title": "CastleWindow.TMenuItemChecked.DoClick", "text": " In this class, <code>DoClick</code> still returns false (like in ancestor class).    ", "tags": "", "loc": "CastleWindow.TMenuItemChecked.html#DoClick"},
     {"title": "CastleWindow.TMenuItemChecked.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemChecked.html#Create"},
     {"title": "CastleWindow.TMenuItemChecked.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemChecked.html#Create"},
     {"title": "CastleWindow.TMenuItemChecked.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemChecked.html#Create"},
     {"title": "CastleWindow.TMenuItemChecked.Checked", "text": " ", "tags": "", "loc": "CastleWindow.TMenuItemChecked.html#Checked"},
     {"title": "CastleWindow.TMenuItemChecked.AutoCheckedToggle", "text": " ", "tags": "", "loc": "CastleWindow.TMenuItemChecked.html#AutoCheckedToggle"},
     {"title": "CastleWindow.TMenuItemRadio", "text": " Similar to <a class=\"normal\" href=\"CastleWindow.TMenuItemChecked.html\">TMenuItemChecked</a>, but it belongs to a group and within this group only one (or none) radio button can be checked.  <p>Note that <a class=\"normal\" href=\"CastleWindow.TMenuItemChecked.html#AutoCheckedToggle\">AutoCheckedToggle</a> property has a little different meaning in this class: whenever user will click on some item, it will be automatically set to Checked = <code>True</code> and the rest of items within this group will be set to Checked = <code>False</code>.  <p>You can of course operate on Checked property explicitly, setting it to <code>True</code> or <code>False</code>. ", "tags": "", "loc": "CastleWindow.TMenuItemRadio.html"},
     {"title": "CastleWindow.TMenuItemRadio.SetChecked", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemRadio.html#SetChecked"},
     {"title": "CastleWindow.TMenuItemRadio.DoAutoCheckedToggle", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemRadio.html#DoAutoCheckedToggle"},
     {"title": "CastleWindow.TMenuItemRadio.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemRadio.html#Create"},
     {"title": "CastleWindow.TMenuItemRadio.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemRadio.html#Create"},
     {"title": "CastleWindow.TMenuItemRadio.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemRadio.html#Create"},
     {"title": "CastleWindow.TMenuItemRadio.Destroy", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemRadio.html#Destroy"},
     {"title": "CastleWindow.TMenuItemRadio.Group", "text": " This is never <code>Nil</code>.  <p>Assigning this property is equivalent to adding yourself to the wanted group. I.e. <code>Item.Group := NewGroup;</code> is equivalent to NewGroup.Add(Item). ", "tags": "", "loc": "CastleWindow.TMenuItemRadio.html#Group"},
     {"title": "CastleWindow.TMenuItemRadioGroup", "text": "  <p>An instance of this object is always created and destroyed automatically by <a class=\"normal\" href=\"CastleWindow.TMenuItemRadio.html\">TMenuItemRadio</a> objects. All <a class=\"normal\" href=\"CastleWindow.TMenuItemRadio.html\">TMenuItemRadio</a> within the same group share the same <code>TMenuItemRadioGroup</code> instance.  <p>Never modify anything within this group using general TObjectList properties. Instead always use methods defined here. TODO: This should not descend from TObjectList&lt;<a class=\"normal\" href=\"CastleWindow.TMenuItemRadio.html\">TMenuItemRadio</a>&gt; then, it should contain it privately. ", "tags": "", "loc": "CastleWindow.TMenuItemRadioGroup.html"},
     {"title": "CastleWindow.TMenuItemRadioGroup.Add", "text": " After this, Item.Group will point to this group object.  <p>Note that Item.Checked may be changed to <code>False</code> if there already is a selected item in this group. If the added item already has Item.Checked = <code>False</code> then for sure it will not be changed (SelectedIndex can be left as -1).    ", "tags": "", "loc": "CastleWindow.TMenuItemRadioGroup.html#Add"},
     {"title": "CastleWindow.TMenuItemRadioGroup.Remove", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemRadioGroup.html#Remove"},
     {"title": "CastleWindow.TMenuItemRadioGroup.Previous", "text": " If there is no <code>previous</code> item, but still <a class=\"normal\" href=\"CastleWindow.TMenuItemRadioGroup.html#Selected\">Selected</a> &lt;&gt; nil, return <a class=\"normal\" href=\"CastleWindow.TMenuItemRadioGroup.html#Selected\">Selected</a>. Only when there's no <a class=\"normal\" href=\"CastleWindow.TMenuItemRadioGroup.html#Selected\">Selected</a> item, returns <code>False</code>.    ", "tags": "", "loc": "CastleWindow.TMenuItemRadioGroup.html#Previous"},
     {"title": "CastleWindow.TMenuItemRadioGroup.Next", "text": " If there is no <code>next</code> item, but still <a class=\"normal\" href=\"CastleWindow.TMenuItemRadioGroup.html#Selected\">Selected</a> &lt;&gt; nil, return <a class=\"normal\" href=\"CastleWindow.TMenuItemRadioGroup.html#Selected\">Selected</a>. Only when there's no <a class=\"normal\" href=\"CastleWindow.TMenuItemRadioGroup.html#Selected\">Selected</a> item, returns <code>False</code>.    ", "tags": "", "loc": "CastleWindow.TMenuItemRadioGroup.html#Next"},
     {"title": "CastleWindow.TMenuItemRadioGroup.Selected", "text": "  <p>It can be nil if no item is checked currently (this can happen if you added all initial items with Checked = <code>False</code>, or if you later removed the checked item from the group; we need a state to represent this situation, that's why it's allowed for radio group to have none radio item chosen). ", "tags": "", "loc": "CastleWindow.TMenuItemRadioGroup.html#Selected"},
     {"title": "CastleWindow.TMenuItemToggleFullScreen", "text": "  <p>This already has a nice caption, key shortcut (F11 on most platforms, except macOS where it's Command+F11 (on LCL backend) or Ctrl+F11 (on other backends), since the bare F11 is reserved on macOS). And it has a <a class=\"normal\" href=\"CastleWindow.TMenuItemToggleFullScreen.html#DoClick\">DoClick</a> implementation that takes care of the actual job.  <p>So you can just add it to your menu, and forget about it. ", "tags": "", "loc": "CastleWindow.TMenuItemToggleFullScreen.html"},
     {"title": "CastleWindow.TMenuItemToggleFullScreen.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemToggleFullScreen.html#Create"},
     {"title": "CastleWindow.TMenuItemToggleFullScreen.DoClick", "text": "    ", "tags": "", "loc": "CastleWindow.TMenuItemToggleFullScreen.html#DoClick"},
     {"title": "CastleWindow.EGLContextNotPossible", "text": " ", "tags": "", "loc": "CastleWindow.EGLContextNotPossible.html"},
     {"title": "CastleWindow.TWindowContainer", "text": " ", "tags": "", "loc": "CastleWindow.TWindowContainer.html"},
     {"title": "CastleWindow.TWindowContainer.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#Create"},
     {"title": "CastleWindow.TWindowContainer.Invalidate", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#Invalidate"},
     {"title": "CastleWindow.TWindowContainer.GLInitialized", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#GLInitialized"},
     {"title": "CastleWindow.TWindowContainer.Width", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#Width"},
     {"title": "CastleWindow.TWindowContainer.Height", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#Height"},
     {"title": "CastleWindow.TWindowContainer.Rect", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#Rect"},
     {"title": "CastleWindow.TWindowContainer.GetMousePosition", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#GetMousePosition"},
     {"title": "CastleWindow.TWindowContainer.SetMousePosition", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#SetMousePosition"},
     {"title": "CastleWindow.TWindowContainer.Dpi", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#Dpi"},
     {"title": "CastleWindow.TWindowContainer.Focused", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#Focused"},
     {"title": "CastleWindow.TWindowContainer.SetInternalCursor", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#SetInternalCursor"},
     {"title": "CastleWindow.TWindowContainer.GetTouches", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#GetTouches"},
     {"title": "CastleWindow.TWindowContainer.TouchesCount", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#TouchesCount"},
     {"title": "CastleWindow.TWindowContainer.SaveScreen", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowContainer.html#SaveScreen"},
     {"title": "CastleWindow.TCastleWindowCustom", "text": " See <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> unit description for more info and examples of use. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html"},
     {"title": "CastleWindow.TCastleWindowCustom.MakeGLAreaContainer", "text": " When creating gtk window in Open, I'm 1st creating GLArea widget. Then I'm inserting <code>MakeGLAreaContainer</code>(GLArea) inside my window.  <p>This means that you can override <code>MakeGLAreaContainer</code> if you want your window to contain something more than just OpenGL drawing area (and some menu, derived from <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MainMenu\">MainMenu</a> property). You can e.g. create in <code>MakeGLAreaContainer</code> some complex container, put there many various GTK widgets, connect your signals to them, and then put GLArea inside it. This way using this function you can extend window <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> with whatever GTK GUI you like.  <p>The only requirement is that GLArea widget must be placed somewhere inside widget that you return in this function.  <p>Note: if you create here some widgets, remember to show them using gtk_widget_show.  <p>Some notes about using this function: Using this function kills some part of portability of <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> unit, as this function exists only when <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> is implemented on top of GTK, so you will have to always use <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> implemented on top GTK on every OS, e.g. with Windows version of your program you will have to distribute GTK and GtkGLExt/GLArea for Windows. This is not really a problem, since GTK 2.x and GtkGLExt work excellent also under Windows (you know, GTK itself is a library that provides great portability). However this raises a question: what are advantages of using in such situation <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> unit (as opposed to just using directly Gtk and GtkGLExt API without any need for <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> unit): well, my advice is that if your program uses it's OpenGL area as it's central and crucial part (and using some GUI only to e.g. get some input from user about what to display in OpenGL area), than using <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> unit may be more straightforward as you have to write much less code in Gtk.  <p>Example of using this can be found in examples/window/test_window_gtk_mix    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MakeGLAreaContainer"},
     {"title": "CastleWindow.TCastleWindowCustom.CreateContainer", "text": " Override this to use a custom container class, e.g. to override some container methods.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#CreateContainer"},
     {"title": "CastleWindow.TCastleWindowCustom.DoUpdate", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#DoUpdate"},
     {"title": "CastleWindow.TCastleWindowCustom.AllowSuspendForInput", "text": "  <p>Allowing this is a good thing, as it means our process doesn't eat your CPU when it simply waits, doing nothing, for user input. On the other hand, you cannot allow this if you want to do some things continously, regardless of user input.  <p>The default implementation plays it safe, and does not allow suspending if we have <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnUpdate\">OnUpdate</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnTimer\">OnTimer</a> or such callback defined.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#AllowSuspendForInput"},
     {"title": "CastleWindow.TCastleWindowCustom.Rect", "text": " Always (Left,Bottom) are zero, and (Width,Height) correspond to window sizes.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Rect"},
     {"title": "CastleWindow.TCastleWindowCustom.SwapFullScreen", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SwapFullScreen"},
     {"title": "CastleWindow.TCastleWindowCustom.TouchesCount", "text": "     ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#TouchesCount"},
     {"title": "CastleWindow.TCastleWindowCustom.MousePressed", "text": " See <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#MousePressed\">TUIContainer.MousePressed</a> for details.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MousePressed"},
     {"title": "CastleWindow.TCastleWindowCustom.Controls", "text": " See <a class=\"normal\" href=\"CastleUIControls.TUIContainer.html#Controls\">TUIContainer.Controls</a> for details.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Controls"},
     {"title": "CastleWindow.TCastleWindowCustom.GLInitialized", "text": " This is equivalent to <code>not Closed</code>, which means we are between an <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Close\">Close</a> calls.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#GLInitialized"},
     {"title": "CastleWindow.TCastleWindowCustom.Open", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Create window, it's OpenGL area, optionally it's menu.</p></li>   <li><p>Create OpenGL context associated with it's OpenGL area.</p></li>   <li><p>Show the window.</p></li>   <li><p>Call <a class=\"normal\" href=\"CastleGLUtils.html#GLInformationInitialize\">GLInformationInitialize</a> to initialize <a class=\"normal\" href=\"CastleGLVersion.html#GLVersion\">GLVersion</a>, <a class=\"normal\" href=\"CastleGLVersion.html#GLUVersion\">GLUVersion</a>, <a class=\"normal\" href=\"CastleGLUtils.html#GLFeatures\">GLFeatures</a>.</p></li>   <li><p>Initial events called: </p>  <ul class=\"compact_spacing\">   <li><p>Call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MakeCurrent\">MakeCurrent</a>, EventOpen (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a>)</p></li>   <li><p>Call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MakeCurrent\">MakeCurrent</a>, EventResize (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">OnResize</a>)</p></li>   <li><p>Call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MakeCurrent\">MakeCurrent</a> once again, to be sure that after Open active OpenGL context is the one associated with newly created window (in case you would change active OpenGL context inside EventResize (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">OnResize</a>), which is allowed).</p></li> </ul>  <p> </p></li> </ul>  <p>  <p>Call to this method is ignored if the window is already open (if <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Closed\">Closed</a> = <code>False</code>).  <p>    EGLContextNotPossible If it's not possible to obtain OpenGL context with specified attributes. For example, maybe you set <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AlphaBits\">AlphaBits</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#DepthBits\">DepthBits</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#StencilBits\">StencilBits</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AccumBits\">AccumBits</a> properties too high?  <p>It's guaranteed that when <a class=\"normal\" href=\"CastleWindow.EGLContextNotPossible.html\">EGLContextNotPossible</a> is raised, the window remains in correct (closed) state. This means that you can catch <a class=\"normal\" href=\"CastleWindow.EGLContextNotPossible.html\">EGLContextNotPossible</a> and lower some OpenGL buffer requirements and try to open once again. Although it's usually more comfortable to use the overloaded version of <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a> with Retry callback for this purpose.  <p>This parameterless version of Open automatically turns off multi-sampling (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AntiAliasing\">AntiAliasing</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MultiSampling\">MultiSampling</a> properties), and then we turn off stencil buffer (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#StencilBits\">StencilBits</a>), if OpenGL context cannot be initialized. But if it still cannot be initialized, we raise <a class=\"normal\" href=\"CastleWindow.EGLContextNotPossible.html\">EGLContextNotPossible</a>. You can use overloaded Open version with Retry callback to customize this fallback mechanism, to code which OpenGL context features may be turned off.", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Open"},
     {"title": "CastleWindow.TCastleWindowCustom.Open", "text": "  <p>If the OpenGL context cannot be initialized, then <code>Retry</code> callback is called. Inside this callback you should either:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>lower some context requirements (like set <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MultiSampling\">MultiSampling</a> to 1 if it was &gt; 1) if possible, and return <code>True</code> to retry, or</p></li>   <li><p>do not change context requirements and return <code>False</code> to give up.</p></li> </ul>  <p>  <p>Note that the parameterless version of <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a> method actually calls this version, with a default retry callback that turns off <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AntiAliasing\">AntiAliasing</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MultiSampling\">MultiSampling</a>, and then <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#StencilBits\">StencilBits</a> (since all our engine code should be ready that multi-sampling or stencil buffers may not be available). Using your own Retry callback, with this version, allows you to decide which context parameters may be lowered to allow creating a window.  <p>    EGLContextNotPossible If it's not possible to obtain requested OpenGL context, and the <code>Retry</code> callback returned <code>False</code>.", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Open"},
     {"title": "CastleWindow.TCastleWindowCustom.Close", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Calls <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnClose\">OnClose</a>.</p></li>   <li><p>Hides window, destroys it.</p></li>   <li><p> if this was the only open <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> window and QuitWhenLastWindowClosed = true then this calls Application.Quit.</p></li> </ul>  <p>  <p>Note that often there's no need to call Close explicitly in your program, because in destructor of this object we call Close, to be sure that window is closed.  <p>TODO: zrobic param boolean CloseFromDestroyQuitWhenLastWindowClosed? As for now Close from destructor is called always with QuitWhenLastWindowClosed = true.  <p>Call to Close is ignored if window is already Closed.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Close"},
     {"title": "CastleWindow.TCastleWindowCustom.PostRedisplay", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#PostRedisplay"},
     {"title": "CastleWindow.TCastleWindowCustom.Invalidate", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Invalidate"},
     {"title": "CastleWindow.TCastleWindowCustom.MakeCurrent", "text": " Following OpenGL commands will apply to this context, and the <a class=\"normal\" href=\"CastleGLUtils.html#RenderContext\">CastleGLUtils.RenderContext</a> will also refer to this. When the window is opened, and right before calling any window callback, we always automatically call this, so you should not need to call this method yourself in normal circumstances.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MakeCurrent"},
     {"title": "CastleWindow.TCastleWindowCustom.SaveScreen", "text": "  <p>These functions take care of making a redraw before capturing screen contents. That's because you can only reliably capture the screen contents of the back buffer (before swap) using OpenGL. In theory, the single-buffer case could be optimized (do not redraw if not needed, that is: if not invalidated), but it's not worth the complication since noone uses single-buffer for normal applications... And also, there is no reliable way to capture screen contents in case of single-buffer.  <p>Note that only capturing the double-buffered windows (the default) is reliable.     ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SaveScreen"},
     {"title": "CastleWindow.TCastleWindowCustom.SaveScreen", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SaveScreen"},
     {"title": "CastleWindow.TCastleWindowCustom.SaveScreen", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SaveScreen"},
     {"title": "CastleWindow.TCastleWindowCustom.SaveScreenToGL", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SaveScreenToGL"},
     {"title": "CastleWindow.TCastleWindowCustom.SaveScreenToGL", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SaveScreenToGL"},
     {"title": "CastleWindow.TCastleWindowCustom.SaveScreenBuffer", "text": " Use only if you save the screen using low-level <a class=\"normal\" href=\"CastleGLImages.html#SaveScreen_NoFlush\">SaveScreen_NoFlush</a> function. Usually, you should save the screen using the simpler <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#SaveScreen\">SaveScreen</a> method, and then the <code>SaveScreenBuffer</code> is not useful.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SaveScreenBuffer"},
     {"title": "CastleWindow.TCastleWindowCustom.SaveScreenDialog", "text": " Asks user where to save the file (using <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FileDialog\">FileDialog</a>, as default URL taking ProposedURL). If user accepts calls Window.SaveScreen. In case of problems with saving, shows a dialog (doesn't raise exception).    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SaveScreenDialog"},
     {"title": "CastleWindow.TCastleWindowCustom.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Create"},
     {"title": "CastleWindow.TCastleWindowCustom.Destroy", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Destroy"},
     {"title": "CastleWindow.TCastleWindowCustom.Pressed", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Pressed"},
     {"title": "CastleWindow.TCastleWindowCustom.Fps", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Fps"},
     {"title": "CastleWindow.TCastleWindowCustom.OpenAndRun", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OpenAndRun"},
     {"title": "CastleWindow.TCastleWindowCustom.OpenAndRun", "text": "  <p> Deprecated, it is cleaner to just set Caption and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">OnRender</a> as properties, and then use parameterless <code>OpenAndRun</code> version. In many programs, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">OnRender</a> is not even used, as you render your stuff inside various <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> instances.    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OpenAndRun"},
     {"title": "CastleWindow.TCastleWindowCustom.ParseParameters", "text": " AllowedOptions specify which command-line options are handled. See [<a  href=\"http://castle-engine.sourceforge.net/opengl_options.php\">http://castle-engine.sourceforge.net/opengl_options.php</a>] for documentaion what these options actually do from user's point of view.  <p></p>  <dl class=\"paragraph_spacing\">   <dt><a class=\"normal\" href=\"CastleWindow.html#poGeometry\">poGeometry</a></dt>   <dd><p>Handle these command-line options: </p>  <ul class=\"compact_spacing\">   <li><p>--fullscreen: sets FullScreen to <code>True</code>.</p></li>   <li><p>--geometry: sets FullScreen to <code>False</code> and changes <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Left\">Left</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Top\">Top</a> as user wants.</p></li> </ul>  <p> </p></dd>   <dt><a class=\"normal\" href=\"CastleWindow.html#poScreenGeometry\">poScreenGeometry</a></dt>   <dd><p>Handle --fullscreen-custom: sets FullScreen and VideoResize to <code>True</code>, initializes VideResizeWidth and VideResizeHeight and actually tries to change your desktop resolution by VideoChange.</p></dd>   <dt><a class=\"normal\" href=\"CastleWindow.html#poDisplay\">poDisplay</a></dt>   <dd><p>Handle --display: sets Application.XDisplayName under Unix.</p></dd>   <dt><a class=\"normal\" href=\"CastleWindow.html#poMacOsXProcessSerialNumber\">poMacOsXProcessSerialNumber</a></dt>   <dd><p> (Only relevant on macOS) A special parameter -psvn_x_xxx will be found and removed from the <a class=\"normal\" href=\"CastleParameters.html#Parameters\">Parameters</a> list. See <a  href=\"http://forums.macrumors.com/showthread.php?t=207344\">http://forums.macrumors.com/showthread.php?t=207344</a> and <a  href=\"http://stackoverflow.com/questions/10242115/os-x-strange-psn-command-line-parameter-when-launched-from-finder\">http://stackoverflow.com/questions/10242115/os-x-strange-psn-command-line-parameter-when-launched-from-finder</a> . </p></dd>   <dt><a class=\"normal\" href=\"CastleWindow.html#poLimitFps\">poLimitFps</a></dt>   <dd><p>Handle --no-limit-fps: disables <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#LimitFPS\">Application.LimitFps</a>, allows to observe maximum FPS, see <a  href=\"http://castle-engine.sourceforge.io/manual_optimization.php\">http://castle-engine.sourceforge.io/manual_optimization.php</a> </p></dd> </dl>  <p>  <p>Multiple options of the same kind are allowed, for example two options <code>&ndash;fullscreen &ndash;geometry 100x100+0+0</code> are allowed. Each of them will have appropriate effect, in the above example, --fullscreen param will be overridden by following --geometry param. Such overridding is sometimes useful from shell scripts.  <p>Overloaded version with SpecifiedOptions says which command-line options were found and handled. For example, if <a class=\"normal\" href=\"CastleWindow.html#poGeometry\">poGeometry</a>, then you know that user requested some window size.  <p>    EInvalidParams When some of our options have invalid arguments.", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#ParseParameters"},
     {"title": "CastleWindow.TCastleWindowCustom.ParseParameters", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#ParseParameters"},
     {"title": "CastleWindow.TCastleWindowCustom.ParseParametersHelp", "text": " The idea is that if you call <code><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ParseParameters\">ParseParameters</a>(AllowedOptions)</code> in your program then you should also show your users somwhere (e.g. in response to &quot;&ndash;help&quot; option) the list of allowed options obtained by <code><code>ParseParametersHelp</code>(AllowedOptions)</code> (i.e. with the same value of AllowedOptions).  <p>Returned string may be multiline, but it does not contain the trailing newline (newline char after the last line).  <p>Returned help text conforms to rules in <code>castle_game_engine/doc/kambi_command_line_params.txt</code>.  <p>If AddHeader then it adds line saying <code>'Window options:'</code> (and showing backend name, for debug purposes) at the beginning. This allows you to comfortably use the output of this function as a whole paragraph (separated from the rest of your &quot;&ndash;help&quot; text by e.g. empty lines around).    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#ParseParametersHelp"},
     {"title": "CastleWindow.TCastleWindowCustom.FileDialog", "text": " Accepts and returns argument as an URL. Passing a filename as an URL is also allowed (as everywhere), it may be changed into an URL on return.  <p>This dialog may also allow user for some typical file-management operations by the way (create some directories, rename some files etc.).  <p>Returns <code>True</code> and sets URL accordingly if user chooses some file and accepts it. Returns <code>False</code> if user cancels.  <p>  <p>  <p>  <p>  <p>  Title A dialog title. URL Specifies default file as an URL (or simple filename).  <p>In short, things are designed such that for normal file viewers, you can give here the URL of last opened file, or '' if none.  <p>This URL can be absolute or relative, may include a path, may include a name. If you specify only a path (remember to end it with the slash), then it's the default path where to save the file. If you specify the name (component after final slash), then it's the proposed file name for saving (for OpenDialog, this proposed file name is ignored, since that's more natural for open dialogs).  <p>Empty value ('') always means the same as &quot;current directory&quot;, guaranteed. So it's equivalent to <code><a class=\"normal\" href=\"CastleURIUtils.html#URICurrentPath\">URICurrentPath</a></code>.  <p>Note that the path must end with a slash. Otherwise '/tmp/blah' would be ambigous (it could mean either file name 'blah' in the dir '/tmp/' dir, or dir '/tmp/blah' without a proposed file name). OpenDialog Is this an open (<code>True</code>) or save (<code>False</code>) file dialog.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> If OpenDialog = <code>True</code>: force the user to only choose existing (and readable) file. The intention is that you can open file indicated by URL, at least for reading. There is no guarantee about it though (it's not possible to guarantee it on a multi-process OS), the only 100% sure way to know that the file can be opened and read is to actually try to do it.  <p>To directly read a file (as a stream) from the obtained URL you should usually use our <a class=\"normal\" href=\"CastleDownload.html#Download\">CastleDownload.Download</a> function. This way you get a readable stream and you automatically support loading data from the other protocols (http, data etc.) too.</p></li>   <li><p> If OpenDialog = <code>False</code>: a save dialog. Allows user to select a non-existing file. If user chooses an existing file, some backends may show a warning like <i>&quot;Are you sure you want to overwrite this file?&quot;</i>.  <p>The intention is that directory of the returned file should exist, and you should be able to write files there. But, again, there is no 100% guarantee about it. The only way to be sure whether you can save a file is to actually try to do it.  <p>To directly write to a file (as a stream) to the obtained URL you should usually use our <a class=\"normal\" href=\"CastleDownload.html#URLSaveStream\">URLSaveStream</a>.</p></li> </ul>  <p> FileFilters A set of file filters to present to user. Pass <code>Nil</code> (default) if you do not want to use file file filters, so user will just always see everything. An overloaded version allows you to pass file filters encoded in a single string, this may be slightly more comfortable for call, see <a class=\"normal\" href=\"CastleFileFilters.TFileFilterList.html#AddFiltersFromString\">TFileFilterList.AddFiltersFromString</a> for explanation how to encode filters in a string.  Title A dialog title. URL Specifies default file as an URL (or simple filename).  <p>In short, things are designed such that for normal file viewers, you can give here the URL of last opened file, or '' if none.  <p>This URL can be absolute or relative, may include a path, may include a name. If you specify only a path (remember to end it with the slash), then it's the default path where to save the file. If you specify the name (component after final slash), then it's the proposed file name for saving (for OpenDialog, this proposed file name is ignored, since that's more natural for open dialogs).  <p>Empty value ('') always means the same as &quot;current directory&quot;, guaranteed. So it's equivalent to <code><a class=\"normal\" href=\"CastleURIUtils.html#URICurrentPath\">URICurrentPath</a></code>.  <p>Note that the path must end with a slash. Otherwise '/tmp/blah' would be ambigous (it could mean either file name 'blah' in the dir '/tmp/' dir, or dir '/tmp/blah' without a proposed file name). OpenDialog Is this an open (<code>True</code>) or save (<code>False</code>) file dialog.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> If OpenDialog = <code>True</code>: force the user to only choose existing (and readable) file. The intention is that you can open file indicated by URL, at least for reading. There is no guarantee about it though (it's not possible to guarantee it on a multi-process OS), the only 100% sure way to know that the file can be opened and read is to actually try to do it.  <p>To directly read a file (as a stream) from the obtained URL you should usually use our <a class=\"normal\" href=\"CastleDownload.html#Download\">CastleDownload.Download</a> function. This way you get a readable stream and you automatically support loading data from the other protocols (http, data etc.) too.</p></li>   <li><p> If OpenDialog = <code>False</code>: a save dialog. Allows user to select a non-existing file. If user chooses an existing file, some backends may show a warning like <i>&quot;Are you sure you want to overwrite this file?&quot;</i>.  <p>The intention is that directory of the returned file should exist, and you should be able to write files there. But, again, there is no 100% guarantee about it. The only way to be sure whether you can save a file is to actually try to do it.  <p>To directly write to a file (as a stream) to the obtained URL you should usually use our <a class=\"normal\" href=\"CastleDownload.html#URLSaveStream\">URLSaveStream</a>.</p></li> </ul>  <p> FileFilters A set of file filters to present to user. Pass <code>Nil</code> (default) if you do not want to use file file filters, so user will just always see everything. An overloaded version allows you to pass file filters encoded in a single string, this may be slightly more comfortable for call, see <a class=\"normal\" href=\"CastleFileFilters.TFileFilterList.html#AddFiltersFromString\">TFileFilterList.AddFiltersFromString</a> for explanation how to encode filters in a string.", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#FileDialog"},
     {"title": "CastleWindow.TCastleWindowCustom.FileDialog", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#FileDialog"},
     {"title": "CastleWindow.TCastleWindowCustom.ColorDialog", "text": " Initial value of Color specifies initial RGB values proposed to the user. If user accepts, returns true and sets Color accordingly, else returns false (and does not modify Color).  <p>    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#ColorDialog"},
     {"title": "CastleWindow.TCastleWindowCustom.ColorDialog", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#ColorDialog"},
     {"title": "CastleWindow.TCastleWindowCustom.ColorDialog", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#ColorDialog"},
     {"title": "CastleWindow.TCastleWindowCustom.MessageOK", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MessageOK"},
     {"title": "CastleWindow.TCastleWindowCustom.MessageYesNo", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MessageYesNo"},
     {"title": "CastleWindow.TCastleWindowCustom.SetDemoOptions", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SetDemoOptions"},
     {"title": "CastleWindow.TCastleWindowCustom.BorderWidth", "text": " This is the width of border of main GtkWindow that will be created in Open, set with gtk_container_set_border_width. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#BorderWidth"},
     {"title": "CastleWindow.TCastleWindowCustom.Container", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Container"},
     {"title": "CastleWindow.TCastleWindowCustom.Width", "text": " Together with frame and border sizes, and eventually menu bar size, this determines the final window size.  <p>When the window is open, these are read-only (may only change through internal methods, that is: we'll update <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Left\">Left</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Top\">Top</a> to reflect current size and position).  <p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinWidth\">MinWidth</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxWidth\">MaxWidth</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinHeight\">MinHeight</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxHeight\">MaxHeight</a> place constraints on these values (rigorously honored when window is open): always <code><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinWidth\">MinWidth</a> &lt;= Width &lt;= <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxWidth\">MaxWidth</a></code> and <code><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinHeight\">MinHeight</a> &lt;= Height &lt;= <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxHeight\">MaxHeight</a></code>.  <p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">ResizeAllowed</a> places constrains when window manager and user may change window size. In particular, when <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">ResizeAllowed</a> &lt;&gt; <a class=\"normal\" href=\"CastleWindow.html#raAllowed\">raAllowed</a> then window sizes cannot change when window is open.  <p>Note that for some window managers, we cannot always reliably force the size constraints and block resizing on the desktop. If you set rigorous size constraints, or <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">ResizeAllowed</a> &lt;&gt; <a class=\"normal\" href=\"CastleWindow.html#raAllowed\">raAllowed</a>, you may find that window manager still resizes the window. In such cases, we may fake our size a little &mdash; <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a> values may not correspond to actual size as seen on the desktop. This is comfortable, as in such cases you usually want to just ignore window managers limits and just proceed as if your size requirements are satisfied.  <p>Special <a class=\"normal\" href=\"CastleWindow.html#WindowDefaultSize\">WindowDefaultSize</a> value of these properties means: at <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a>, calculate and use some comfortable window size.  ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Width"},
     {"title": "CastleWindow.TCastleWindowCustom.Height", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Height"},
     {"title": "CastleWindow.TCastleWindowCustom.Dpi", "text": " Defaults to 96, so it is recommended to set to correct value on higher density displays. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Dpi"},
     {"title": "CastleWindow.TCastleWindowCustom.Left", "text": " If one (or both) of them is equal to <a class=\"normal\" href=\"CastleWindow.html#WindowPositionCenter\">WindowPositionCenter</a> at the initialization (Open) time, then it will be set to position the window at the screen center.  <p>You cannot change these properties while the window is open now.  <p> ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Left"},
     {"title": "CastleWindow.TCastleWindowCustom.Top", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Top"},
     {"title": "CastleWindow.TCastleWindowCustom.FullScreen", "text": " This forces <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a> and position and window style to fill the whole screen.  <p>Note that we always set fullscreen UI (no border, size matching Application.ScreenWidth and Application.ScreenHeight), ignoring the window size constraints like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinWidth\">MinWidth</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxWidth\">MaxWidth</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinHeight\">MinHeight</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxHeight\">MaxHeight</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">ResizeAllowed</a>. For example we do not check does Application.ScreenWidth fit inside <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinWidth\">MinWidth</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxWidth\">MaxWidth</a>. It's assumed that you really want to set/unset the fullscreen UI if you change this property. However, the sizes known to your application (stored in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a>) are still constrained by <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinWidth\">MinWidth</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxWidth\">MaxWidth</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinHeight\">MinHeight</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxHeight\">MaxHeight</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">ResizeAllowed</a>.  <p>You can change this always, even on already open window. Just note that some backends don't allow to switch this without destroying / recreating the OpenGL context. So be prepared that changing FullScreen may result in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnClose\">OnClose</a> + <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a> sequence, so make sure that closing and opening recreates the whole necessary OpenGL state exactly as it was. This is usually natural, all our <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> automatically work with this, so this is only a concern if you do some direct OpenGL tricks. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#FullScreen"},
     {"title": "CastleWindow.TCastleWindowCustom.DoubleBuffer", "text": " After every draw, we automatically swap buffers (if <code>DoubleBuffer</code>) or call glFlush (if not <code>DoubleBuffer</code>). ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#DoubleBuffer"},
     {"title": "CastleWindow.TCastleWindowCustom.RedBits", "text": " When 0, the default window system color precision will be used.  <p>You can either set them by separate red / green / blue properties. Or you can use <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ColorBits\">ColorBits</a> that reads / writes all three channels bits. Reading <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ColorBits\">ColorBits</a> simply returns the sum of <code><code>RedBits</code> + <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#GreenBits\">GreenBits</a> + <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#BlueBits\">BlueBits</a></code>. Writing <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ColorBits\">ColorBits</a> simply set <code>RedBits</code> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#BlueBits\">BlueBits</a> to <code><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ColorBits\">ColorBits</a> div 3</code>, and sets <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#GreenBits\">GreenBits</a> to the remainder. This way green channel has always the best resolution (as is usual, since it's perceived most), and the sum is always as requested. This way setting <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ColorBits\">ColorBits</a> to values like 16 or 24 works as expected.  <p>Note that it's also possible to change color resolution by changing the whole screen settings. See <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#VideoColorBits\">TCastleApplication.VideoColorBits</a> and <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#VideoChange\">TCastleApplication.VideoChange</a> for this. These properties only request the color resolution for this window, which is less intrusive (you don't change the whole screen) but also may have a smaller chance of success.  <p> ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#RedBits"},
     {"title": "CastleWindow.TCastleWindowCustom.GreenBits", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#GreenBits"},
     {"title": "CastleWindow.TCastleWindowCustom.BlueBits", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#BlueBits"},
     {"title": "CastleWindow.TCastleWindowCustom.ColorBits", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#ColorBits"},
     {"title": "CastleWindow.TCastleWindowCustom.MousePosition", "text": " In case of touch devices, this reports the last known position for FingerIndex = 0, and setting this has no effect.  <p>See <a class=\"normal\" href=\"CastleUIControls.TTouch.html#Position\">TTouch.Position</a> for a documentaion how this is expressed.  <p>In all situations the <code>MousePosition</code> is the latest known mouse position. The only exception is within EventMotion (and so, also in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnMotion\">OnMotion</a> callback): <code>MousePosition</code> is then the previous known mouse position, while new mouse position is provided as NewMousePosition argument to EventMotion (and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnMotion\">OnMotion</a>).  <p><i>About setting the mouse position:</i>  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>There is no guarantee that the position was set exactly to what was requested. Various backends have their limitations, and position may be rounded, and almost everywhere position will be clamped to the current screen space.</p></li>   <li><p>It is undefined whether setting mouse position will generate an <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnMotion\">OnMotion</a> event (just as if the user moved the mouse). Some backends do it, some don't, and there is no way to make it consistent (because backend may report the motion event with delay, so we really don't know whether user moved the mouse or was it caused by code).</p></li>   <li><p>Setting mouse position is always ignored when the window is closed.</p></li> </ul>  <p> ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MousePosition"},
     {"title": "CastleWindow.TCastleWindowCustom.Touches", "text": " This tracks currently pressed fingers, in case of touch devices (mobile, like Android and iOS). In case of desktops, it tracks the current mouse position, regardless if any mouse button is currently pressed.  <p>Indexed from 0 to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#TouchesCount\">TouchesCount</a> - 1.   ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Touches"},
     {"title": "CastleWindow.TCastleWindowCustom.ResizeAllowed", "text": "  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"CastleWindow.html#raNotAllowed\">raNotAllowed</a>  <p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a> can only change to honor <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinWidth\">MinWidth</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxWidth\">MaxWidth</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinHeight\">MinHeight</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxHeight\">MaxHeight</a> constraints. Absolutely nothing else may cause them to change, user cannot resize the window.  <p>Note that setting the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FullScreen\">FullScreen</a> property to <code>True</code> works regardless of this. Just don't change <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FullScreen\">FullScreen</a> property if you don't want to. However, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a> values will be kept unchanged (they will not be updated to Application.ScreenWidth and Application.ScreenHeight), so from the point of view of you code the <a class=\"normal\" href=\"CastleWindow.html#raNotAllowed\">raNotAllowed</a> works always.  <p>You can be sure that EventResize (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">OnResize</a>) will be called only once, when window is opened (right after initial EventOpen (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a>)).</p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.html#raOnlyAtOpen\">raOnlyAtOpen</a>  <p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a> may be adjusted when the window is opened, by <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a> call. For example window manager may decide that the size is too large for the current screen. Or when you request FullScreen window and window size has to be adjusted to match current screen size. Also they will always be adjusted to fit in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinWidth\">MinWidth</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxWidth\">MaxWidth</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MinHeight\">MinHeight</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MaxHeight\">MaxHeight</a> constraints.  <p>After opening, window size cannot change anymore. In particular user cannot resize the window (by dragging border or such). After the first EventOpen (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a>) call, the window size becomes constant. From the first EventResize (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">OnResize</a>) the window size is constant, as long as the window remains open.  <p>You can be sure that EventResize (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">OnResize</a>) will be called only once, when window is opened (right after initial EventOpen (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a>)).</p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.html#raAllowed\">raAllowed</a>  <p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a> may be adjusted at open time, and later user can resize the window too. This is the default value, giving user and window manager the most flexibility.  <p>You have to be prepared for this, handling <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">OnResize</a> and adjusting stuff like OpenGL viewport and projection matrix.</p></li> </ul>  <p>  <p>Note that the we call the first <a class=\"normal\" href=\"CastleGLUtils.html#GLViewport\">glViewport</a> automatically in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a>. So in typical cases, you don't have to call <a class=\"normal\" href=\"CastleGLUtils.html#GLViewport\">glViewport</a> ever yourself, when <code>ResizeAllowed</code> &lt;&gt; <a class=\"normal\" href=\"CastleWindow.html#raAllowed\">raAllowed</a>. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#ResizeAllowed"},
     {"title": "CastleWindow.TCastleWindowCustom.OnOpen", "text": " Often you do not need to use this callback (engine components will automatically create/release OpenGL resource when necessary), unless you deal with lower-level OpenGL resource managing (e.g. using <a class=\"normal\" href=\"CastleGLImages.TGLImageCore.html\">TGLImageCore</a>). You usually will also want to implement Window.OnClose callback that should release stuff you create here.  <p>Often, instead of using this callback, it's cleaner to derive new classes from <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> class or it's descendants, and override their GLContextOpen / GLContextClose methods to react to context being open/closed. Using such <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> classes is usually easier, as you add/remove them from controls whenever you want (e.g. you add them in <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">Application.OnInitialize</a>), and underneath they create/release/create again the OpenGL resources when necessary.  <p><code>OnOpen</code> is always called <b>after</b> <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">Application.OnInitialize</a>. In normal circumstances, for a typical standalone game, the <code>OnOpen</code> will happen only once. But for other targets, it may be necessary to close/reopen the OpenGL context many times, e.g. on mobile platforms it's normal that application may &quot;loose&quot; the OpenGL context and it may need to recreate OpenGL resources when it wakes up. Event called when OpenGL context is initialized.  <p>It's guaranteed that every newly opened window will get EventOpen (<code>OnOpen</code>) first, and then EventResize (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">OnResize</a>), and only then &mdash; the other callbacks, as the user uses the window. This is consistent EventOpen (<code>OnOpen</code>) is always the first executed callback and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnClose\">OnClose</a> is always the last. This allows you to cleanly initialize / finalize OpenGL resources.  <p>During EventOpen (<code>OnOpen</code>) you already have valid Width / Height values, that is those values were already adjusted if <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">ResizeAllowed</a> &lt;&gt; <a class=\"normal\" href=\"CastleWindow.html#raNotAllowed\">raNotAllowed</a>.  <p><b>Be careful what you do in this callback if you want your game to work on Android or other non-standalone platforms.</b> On Android, OpenGL context may be closed and opened at any time, as user can switch from/to your application at any time. You should use <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnInitialize\">Application.OnInitialize</a> for a one-time initialization (it is executed right before the very first <code>OnOpen</code> would be executed). Use this callback only to create OpenGL resources (destroyed in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnClose\">OnClose</a>).  <p> ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnOpen"},
     {"title": "CastleWindow.TCastleWindowCustom.OnOpenObject", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnOpenObject"},
     {"title": "CastleWindow.TCastleWindowCustom.MinWidth", "text": " Always  <p></p>  <pre class=\"preformatted\"> 0 &lt; MinWidth &lt;= MaxWidth and 0 &lt; MinHeight &lt;= MaxHeight</pre>  <p>  <p>We do not allow user to resize the window outside of these constraints.  <p>We also fix window <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a> to fit within these constraints when you <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a> the window. We do it regardless of <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">ResizeAllowed</a> (even when it's <a class=\"normal\" href=\"CastleWindow.html#raNotAllowed\">raNotAllowed</a>).  <p>In other words, these constraints have a higher priority than <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">ResizeAllowed</a> and your desired <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a> and even <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FullScreen\">FullScreen</a> (setting <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FullScreen\">FullScreen</a> property will stil change the visible sizes, but your perceived sizes will be constrained by this min/max). So you can be sure that (as long as window is open) <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Width\">Width</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Height\">Height</a> will always fit in these constraints.  ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MinWidth"},
     {"title": "CastleWindow.TCastleWindowCustom.MinHeight", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MinHeight"},
     {"title": "CastleWindow.TCastleWindowCustom.MaxWidth", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MaxWidth"},
     {"title": "CastleWindow.TCastleWindowCustom.MaxHeight", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MaxHeight"},
     {"title": "CastleWindow.TCastleWindowCustom.DepthBits", "text": " Zero means that we don't need depth buffer at all. We may get depth buffer with more precision than requested (we may even get depth buffer when we set <code>DepthBits</code> = 0), this all depends on graphic card.  <p>Default value is 16 (<a class=\"normal\" href=\"CastleWindow.html#DefaultDepthBits\">DefaultDepthBits</a>), which is a reasonable default for 3D programs that want to work with depth test enabled.  <p><i>Design notes:</i> One may ask why default value is not 0?  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> Most programs using OpenGL use depth testing, so many programs would have to call something like <code>Window.DepthBits := 16</code>.</p></li>   <li value=\"2\"><p> Often graphic cards / window systems / OSes give you an OpenGL context with depth buffer <i>even if you don't need depth buffer</i>. I don't say that it's bad. But it makes very easy to forget about doing <code><code>DepthBits</code> := something-non-zero;</code>. If you're writing 3d program and sitting on some system that always gives you depth buffer (even if <code>DepthBits</code> = 0) then it may happen that you forget to write in your program </p>  <pre class=\"longcode\">Window.DepthBits := <span class=\"pascal_numeric\">16</span>;</pre>  <p>  <p>And while on your system everything will work, you will receive errors on other systems because you forgot to request a depth buffer.</p></li> </ol>  <p>  <p>Of course, if you are writing a program that does not need depth buffer you should set Window.DepthBits := 0. The only advantage of having default <code>DepthBits</code> = 16 is that if you forget to set Window.DepthBits := 0 your programs will still work (most graphic cards will give you some depth buffer anyway). They will just use more resources than they should. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#DepthBits"},
     {"title": "CastleWindow.TCastleWindowCustom.StencilBits", "text": "  <p>Just like with other XxxBits property, we may get more bits than we requested. But we will never get less &mdash; if window system will not be able to provide GL context with requested number of bits, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a> will raise an error.  <p>Note that after initializing OpenGL context (when opening the window), <code>StencilBits</code> is <i>not</i> updated to the current (provided) stencil buffer bit size. For example, if you requested <code>StencilBits</code> := 8, and you got 16-bits buffer: <code>StencilBits</code> value will still remain 8. This is sensible in case you close the window, tweak some settings and try to open it again. Use <code><a class=\"normal\" href=\"CastleGLUtils.html#glGetInteger\">glGetInteger</a>(GL_STENCIL_BITS)</code> when window is open to query current (actual) buffer size. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#StencilBits"},
     {"title": "CastleWindow.TCastleWindowCustom.MultiSampling", "text": " Use <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AntiAliasing\">AntiAliasing</a> instead of this for more comfortable (higher-level) way to turn on multi-sampling (anti-aliasing).  <p>1 means that no multi-sampling is required. Values larger than 1 mean that we require OpenGL context with multi-sampling capabilities. Various GPUs may support various values (it's a trade-off between quality and speed), try typical values 2 or 4.  <p>You can enable/disable anti-aliasing in your program by code like  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">if</span> GLFeatures.Multisample <span class=\"pascal_keyword\">then</span> glEnable(GL_MULTISAMPLE_ARB); <span class=\"pascal_keyword\">if</span> GLFeatures.Multisample <span class=\"pascal_keyword\">then</span> glDisable(GL_MULTISAMPLE_ARB);</pre>  <p>  <p>But usually that's not needed, as it is &quot;on&quot; by default (GL_ARB_multisample spec says so) if you requested multi-sampling context (that is, if this property is &gt; 1). See GL_ARB_multisample spec for details: [<a  href=\"http://opengl.org/registry/specs/ARB/multisample.txt\">http://opengl.org/registry/specs/ARB/multisample.txt</a>].  <p>Just like with other XxxBits property, we may get more samples than we requested (e.g. if you request 3, you will most probably get 4). But we will never get less &mdash; if window system will not be able to provide GL context with requested number of bits, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a> will raise an error. TODO: actually, this may change to be similar to Lazarus TOpenGLControl.MultiSampling, and also be more comfortable &mdash; to retry initialization with no multi-sampling. In this case this property will not be changed, to be nice.  <p>You can always read OpenGL GL_SAMPLE_BUFFERS_ARB and GL_SAMPLES_ARB values after initializing OpenGL context, to know exactly how many samples did you actually get, and did you get multi-sampling at all. Actually, we already initialize global CastleGLUtils.GLCurrentMultiSampling for you, you can use this. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MultiSampling"},
     {"title": "CastleWindow.TCastleWindowCustom.AntiAliasing", "text": "  <p>Setting this property automatically sets also the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MultiSampling\">MultiSampling</a> property. Although it's easy to request multi-sampling by using the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MultiSampling\">MultiSampling</a> property directly, using <code>AntiAliasing</code> is a little more comfortable. You don't have to wonder what are the sensible values of <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MultiSampling\">MultiSampling</a> for common GPUs, and we also automatically use NV_multisample_filter_hint for nicer anti-aliasing when possible. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#AntiAliasing"},
     {"title": "CastleWindow.TCastleWindowCustom.AlphaBits", "text": " Zero means that alpha channel is not needed.  <p>Just like with other XxxBits property, we may get more bits than we requested. But we will never get less &mdash; if window system will not be able to provide GL context with requested number of bits, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a> will raise an error.  <p>It's undefined how I'll treat this variable when indexed color mode will be possible in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a>. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#AlphaBits"},
     {"title": "CastleWindow.TCastleWindowCustom.AccumBits", "text": " Color channel is 0..3: red, green, blue, alpha. Zero means that given channel of accumulation buffer is not needed, so when the vector is all zeros (default value) this means that accumulation buffer is not needed at all.  <p>Just like with other XxxBits property, we may get more bits than we requested. But we will never get less &mdash; if window system will not be able to provide GL context with requested number of bits, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a> will raise an error.  <p> This property is deprecated, since modern OpenGL deprecated accumulation buffer. It may not be supported by some backends (e.g. now LCL backend, the default backend on macOS, doesn't support it). ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#AccumBits"},
     {"title": "CastleWindow.TCastleWindowCustom.GtkIconName", "text": "  <p>This is simply passed to <code>gtk_window_set_icon_name</code>, see [<a  href=\"http://library.gnome.org/devel/gtk/stable/GtkWindow.html#gtk-window-set-icon-name\">http://library.gnome.org/devel/gtk/stable/GtkWindow.html#gtk-window-set-icon-name</a>]. This allows you to use an installed icon (in /usr/share/icons/ or &tilde;/.local/share/icons/) for your program. See [<a  href=\"http://library.gnome.org/devel/integration-guide/stable/icons.html.en\">http://library.gnome.org/devel/integration-guide/stable/icons.html.en</a>] for short information how and where to install your icons.  <p>It's ignored on non-GTK 2 backends. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#GtkIconName"},
     {"title": "CastleWindow.TCastleWindowCustom.Visible", "text": " In all normal programs you want to leave this as <code>True</code>, as the main purpose of the window is to actually be visible and interactive on the desktop.  <p>Setting this to <code>False</code> allows you to get an OpenGL context without showing anything on the desktop. This can be used for rendering and capturing OpenGL stuff without showing it on the desktop. One example is the --screenshot option of view3dscene, see [<a  href=\"http://castle-engine.sourceforge.net/view3dscene.php#section_screenshot\">http://castle-engine.sourceforge.net/view3dscene.php#section_screenshot</a>].  <p>If you implement such thing, remember that you should not render and capture the normal front or back buffer contents. OpenGL makes no guarantee that a hidden window will have any allocated memory, so capturing hidden window contents isn't useful (you may get something valid, or you may get random / blank screen, depending on OS and GPU). However, you can create Framebuffer Object on modern GPUs, and capture it's contents. An example code snippet:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_comment\">{ add CastleGLImages, CastleImages to your uses clause }</span>  <span class=\"pascal_keyword\">var</span>   ScreenshotRender: TGLRenderToTexture;   Image: TRGBImage; <span class=\"pascal_keyword\">begin</span>   ScreenshotRender := TGLRenderToTexture.Create(Width, Height);   <span class=\"pascal_keyword\">try</span>     ScreenshotRender.Buffer := tbNone;     ScreenshotRender.GLContextOpen;     ScreenshotRender.RenderBegin;      <span class=\"pascal_comment\">{ render your stuff here }</span>      <span class=\"pascal_comment\">{ capture the screen }</span>     Image := SaveScreen_NoFlush(Rectangle(<span class=\"pascal_numeric\">0</span>, <span class=\"pascal_numeric\">0</span>, Width, Height),       ScreenshotRender.ColorBuffer);     <span class=\"pascal_keyword\">try</span>       SaveImage(Image, <span class=\"pascal_string\">'aaa.png'</span>);     <span class=\"pascal_keyword\">finally</span> FreeAndNil(Image) <span class=\"pascal_keyword\">end</span>;      ScreenshotRender.RenderEnd;   <span class=\"pascal_keyword\">finally</span> FreeAndNil(ScreenshotRender) <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p> ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Visible"},
     {"title": "CastleWindow.TCastleWindowCustom.Caption", "text": " By default it's initialized to ApplicationName. May be changed even when the window is already open. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Caption"},
     {"title": "CastleWindow.TCastleWindowCustom.OnRender", "text": "  <p>Called when window contents must be redrawn, e.g. after creating a window, after resizing a window, after uncovering the window etc. You can also request yourself a redraw of the window by the Invalidate method, which will cause this event to be called at nearest good time.  <p>Note that calling Invalidate while in EventRender (<code>OnRender</code>) is not ignored. It instructs to call EventRender (<code>OnRender</code>) again, as soon as possible.  <p>When you have some controls on the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">Controls</a> list (in particular, the <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html#SceneManager\">TCastleWindow.SceneManager</a> is also on this list), the <code>OnRender</code> event is done <b>last</b> (at least as long as <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#RenderStyle\">RenderStyle</a> = <a class=\"normal\" href=\"CastleUIControls.html#rs2D\">rs2D</a>, default). So here you can draw on top of the existing controls. To draw something underneath the existing controls, create a new <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> and override it's <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#Render\">TUIControl.Render</a> and insert it to the controls using <code>Controls.InsertBack(MyBackgroundControl);</code>. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnRender"},
     {"title": "CastleWindow.TCastleWindowCustom.OnDraw", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnDraw"},
     {"title": "CastleWindow.TCastleWindowCustom.OnBeforeRender", "text": " These two events, EventBeforeRender (<code>OnBeforeRender</code>) and EventRender (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">OnRender</a>), will be always called sequentially as a pair.  <p>The only difference between these two events is that time spent in EventBeforeRender (<code>OnBeforeRender</code>) is NOT counted as &quot;frame time&quot; by Fps.OnlyRenderFps. This is useful when you have something that needs to be done from time to time right before <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">OnRender</a> and that is very time-consuming. It such cases it is not desirable to put such time-consuming task inside <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">OnRender</a> because this would cause a sudden big change in Fps.OnlyRenderFps value. So you can avoid this by putting this in <code>OnBeforeRender</code>. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnBeforeRender"},
     {"title": "CastleWindow.TCastleWindowCustom.OnResize", "text": " It's also guaranteed to be called during <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a>, right after the EventOpen (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a>) event.  <p>Our OpenGL context is already &quot;current&quot; when this event is called (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MakeCurrent\">MakeCurrent</a> is done right before), like for other events. This is a good place to set OpenGL viewport and projection matrix.  <p>See also <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ResizeAllowed\">ResizeAllowed</a>.  <p>In the usual case, the SceneManager takes care of setting appropriate OpenGL projection, so you don't need to do anything here. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnResize"},
     {"title": "CastleWindow.TCastleWindowCustom.OnClose", "text": " This is your last chance to release OpenGL resources, like textures, shaders, display lists etc. This is a counterpart to <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a> event. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnClose"},
     {"title": "CastleWindow.TCastleWindowCustom.OnCloseObject", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnCloseObject"},
     {"title": "CastleWindow.TCastleWindowCustom.OnPress", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnPress"},
     {"title": "CastleWindow.TCastleWindowCustom.OnRelease", "text": "  <p>It's called right after <code>Pressed[Key]</code> changed from true to false.  <p>The <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html\">TInputPressRelease</a> structure, passed as a parameter to this event, contains the exact information what was released.  <p>Note that reporting characters for &quot;key release&quot; messages is not perfect, as various key combinations (sometimes more than one?) may lead to generating given character. We have some intelligent algorithm for this, used to make Characters table and to detect this C for <code>OnRelease</code> callback. The idea is that a character is released when the key that initially caused the press of this character is also released.  <p>This solves in a determined way problems like &quot;what happens if I press Shift, then X, then release Shift, then release X&quot;. (will &quot;X&quot; be correctly released as pressed and then released? yes. will small &quot;x&quot; be reported as released at the end? no, as it was never pressed.) ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnRelease"},
     {"title": "CastleWindow.TCastleWindowCustom.OnCloseQuery", "text": " This is called when you use window manager features to close the window, like clicking on the &quot;close&quot; icon on the window frame or using Alt+F4 on most desktops. This is <i>not</i> called when you explicitly close the window by calling the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Close\">Close</a> method.  <p>When this callback is not assigned, we will just let the window be closed. When it's assigned, the window will not closed &mdash; you should call here <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Close\">Close</a> explicitly if you want to (for example, after asking user for confirmation &quot;do you really want to quit?&quot;).  <p>When handling this event, you must remember that user may try to close our window at any time. E.g. if you're implementing here somehing like showing user text &quot;You cannot quit now&quot; or asking user &quot;Do you really want to quit&quot; remember that while you display such message to user and you're processing events (e.g. looking for keypress &quot;Yes&quot; or &quot;No&quot;), user may try to close your window again.  <p><a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a> unit offers some nice routines that you can safely use here, e.g. you can use it inside <code>OnCloseQuery</code> like  <p>if <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MessageYesNo\">MessageYesNo</a>(Window, 'Are you sure you want to quit?') then Close;  <p>Inside <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MessageYesNo\">MessageYesNo</a>, when we're processing events, and waiting for user's answer (yes or no), futher <code>OnCloseQuery</code> events will be ignored, so everything will work OK.  <p>This event is also useful if you want to call Close(false) on closing the window (i.e. QuitWhenLastWindowClosed = false). By default, if this event is undefined, we call Close(true) when user tries to close the window. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnCloseQuery"},
     {"title": "CastleWindow.TCastleWindowCustom.OnMotion", "text": "  <p>For a mouse, remember you always have the currently pressed mouse buttons in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MousePressed\">MousePressed</a>. When this is called, the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MousePosition\">MousePosition</a> property records the <i>previous</i> mouse position, while callback parameter NewMousePosition gives the <i>new</i> mouse position. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnMotion"},
     {"title": "CastleWindow.TCastleWindowCustom.OnUpdate", "text": " This event is called at least as regularly as redraw, so it is continously called even when your game is overwhelmed by messages (like mouse moves) and redraws.  <p>Called at the same time when <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnUpdate\">Application.OnUpdate</a> is called.  <p>You should add code to this window's <code>OnUpdate</code> event (not to <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnUpdate\">TCastleApplication.OnUpdate</a>) when you do something related to this window. For example when you check this window's <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Pressed\">Pressed</a> keys state, or animate something displayed on this window. This allows various &quot;modal boxes&quot; and such (see <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a>) to nicely &quot;pause&quot; such processing by temporarily replacing <code>OnUpdate</code> and other events of a window that displays a modal box. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnUpdate"},
     {"title": "CastleWindow.TCastleWindowCustom.OnIdle", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnIdle"},
     {"title": "CastleWindow.TCastleWindowCustom.OnTimer", "text": " See also <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnTimer\">Application.OnTimer</a>.  <p>This is a very simple timer mechanism, as all timers (timers for all windows and the global <a class=\"normal\" href=\"CastleWindow.html#Application\">Application</a> timer) use the same delay: <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#TimerMilisec\">Application.TimerMilisec</a>. We consciously decided to not implement anything more involved here. If you need really flexible timer mechanism, do not use this. Instead use <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnUpdate\">OnUpdate</a> (or <a class=\"normal\" href=\"CastleUIControls.TInputListener.html#Update\">TInputListener.Update</a> in your <a class=\"normal\" href=\"CastleUIControls.TUIControl.html\">TUIControl</a> descendant, or <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Update\">TCastleTransform.Update</a>) and look at it's <code>SecondsPassed</code> value to perform actions (one time or repeated) with a specified delay. The engine source is full of examples of this.  <p>Under Lazarus, you can of course also use LCL timers. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnTimer"},
     {"title": "CastleWindow.TCastleWindowCustom.OnDropFiles", "text": " In case of macOS bundle, this is also called when user opens a document associated with our application by double-clicking. Note: this is currently supported only by CASTLE_WINDOW_LCL backend. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnDropFiles"},
     {"title": "CastleWindow.TCastleWindowCustom.AutoRedisplay", "text": " If <code>True</code> (the default), EventRender (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">OnRender</a>) will called constantly.  <p>If your game may have a still screen (nothing animates), then this approach is a little unoptimal, as we use CPU and GPU for drawing, when it's not needed. In such case, you can set this property to <code>False</code>, and make sure that you call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Invalidate\">Invalidate</a> always when you need to redraw the screen. Note that the engine components always call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Invalidate\">Invalidate</a> when necessary, so usually you should only call it yourself if you provide a custom <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">OnRender</a> implementation. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#AutoRedisplay"},
     {"title": "CastleWindow.TCastleWindowCustom.MainMenu", "text": " When not assigned, we have no menu bar.  <p>Note that MainMenu.Caption will be ignored.  <p>You can change this freely while Closed.  <p>You can change this almost freely while not Closed: you can use various properties of <a class=\"normal\" href=\"CastleWindow.TMenuEntry.html\">TMenuEntry</a> descendants (adding, deleting items from <a class=\"normal\" href=\"CastleWindow.TMenu.html\">TMenu</a>, changing Caption, Key, CharKey, Checked properties &ndash; anything) and you can change value of <code>MainMenu</code> BUT you must not change <code>MainMenu</code> &lt;&gt; nil state when the window is not Closed. I.e. if you called Open with <code>MainMenu</code> = nil, then <code>MainMenu</code> must stay nil unit Close. If you called Open with <code>MainMenu</code> &lt;&gt; nil, then you can assign other <code>MainMenu</code> values while not Closed, but only values &lt;&gt;nil. I.e. you can't set <code>MainMenu</code> to nil if you called Open with <code>MainMenu</code> &lt;&gt; nil. See <code>castle_game_engine/examples/window/window_menu.lpr</code> for demo of changing value of <code>MainMenu</code> while window is not Closed.  <p>Note that MainMenu.Enabled is honoured (as well as Enabled for all menu items inside, of course). You can use this to disallow user from clicking on the whole menu. When MainMenu.Enabled = <code>False</code> then no MenuItem.DoClick, no <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnMenuClick\">OnMenuClick</a> will be called when user presses some menu item. When user presses some keyboard shortcut for some menu item, no MenuItem.DoClick and no <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnMenuClick\">OnMenuClick</a> will be called, but instead normal EventPress (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnPress\">OnPress</a>) will be called.  <p>When it is useful to set this to false? For example hen using <a class=\"normal\" href=\"CastleWindowModes.html\">CastleWindowModes</a>. When you're changing modes (e.g. at the beginning of <a class=\"normal\" href=\"CastleMessages.html#MessageOK\">CastleMessages.MessageOk</a>) you're temporary setting <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnMenuClick\">OnMenuClick</a> to nil, but this doesn't block <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#DoClick\">TMenuItem.DoClick</a> functions. The only way to block menu from triggering ANY event is to set this to MainMenu.Enabled to <code>False</code>. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MainMenu"},
     {"title": "CastleWindow.TCastleWindowCustom.MainMenuVisible", "text": " <code>False</code> means that we do not show main menu bar, but menu key shortcuts should still work. Right now, you can reliably change this only before window is open. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#MainMenuVisible"},
     {"title": "CastleWindow.TCastleWindowCustom.OwnsMainMenu", "text": " Usually this is something useful. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OwnsMainMenu"},
     {"title": "CastleWindow.TCastleWindowCustom.OnMenuClick", "text": " By default, menu item handling is passed to <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#DoClick\">TMenuItem.DoClick</a>. Only when it return <code>False</code> (not handled) then we call this window's event. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnMenuClick"},
     {"title": "CastleWindow.TCastleWindowCustom.OnMenuCommand", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#OnMenuCommand"},
     {"title": "CastleWindow.TCastleWindowCustom.Focused", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Focused"},
     {"title": "CastleWindow.TCastleWindowCustom.UserData", "text": " No code in this unit <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Touches\">touches</a> the value of this field. This is similar to TComponent.Tag property. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#UserData"},
     {"title": "CastleWindow.TCastleWindowCustom.Closed", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Closed"},
     {"title": "CastleWindow.TCastleWindowCustom.Cursor", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Cursor"},
     {"title": "CastleWindow.TCastleWindowCustom.InternalCursor", "text": " See <a class=\"normal\" href=\"CastleKeysMouse.html#TMouseCursor\">TMouseCursor</a> for a list of possible values and their meanings. TODO: for now, <a class=\"normal\" href=\"CastleKeysMouse.html#mcCustom\">mcCustom</a> is not handled anywhere.  <p>Note that this is for internal usage in the engine. In your applications, you should set TUIControl.Cursor, never set this property directly. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#InternalCursor"},
     {"title": "CastleWindow.TCastleWindowCustom.CustomCursor", "text": " We will try hard to use any cursor image as appropriate, but on some platforms cursor size may be limited (16 x 16 seems standard for GTK) and cursor may be forced to monochrome.  <p>Note that you still own the <a class=\"normal\" href=\"CastleImages.TRGBAlphaImage.html\">TRGBAlphaImage</a> instance passed here &mdash; you're responsible for freeing it etc. If this is <code>Nil</code>, and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Cursor\">Cursor</a> = <a class=\"normal\" href=\"CastleKeysMouse.html#mcCustom\">mcCustom</a>, then it will be treated like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Cursor\">Cursor</a> = <a class=\"normal\" href=\"CastleKeysMouse.html#mcDefault\">mcDefault</a>. (I don't raise error in such case, as that would make changing both Cursor and CustomCursor values unnecessarily tricky for the programmer.)  <p>TODO: for now, this is not implemented. <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Cursor\">Cursor</a> ignores <a class=\"normal\" href=\"CastleKeysMouse.html#mcCustom\">mcCustom</a> value, under every <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> backend... sorry, CustomCursor is only a plan. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#CustomCursor"},
     {"title": "CastleWindow.TCastleWindowCustom.RenderStyle", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#RenderStyle"},
     {"title": "CastleWindow.TCastleWindowCustom.NamedParameters", "text": " Right now only meaningful when using NPAPI plugin. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#NamedParameters"},
     {"title": "CastleWindow.TCastleWindowCustom.FpsShowOnCaption", "text": " You can modify this property only <i>before calling <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a>.</i> ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#FpsShowOnCaption"},
     {"title": "CastleWindow.TCastleWindowCustom.SwapFullScreen_Key", "text": " Set to <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> (default) to disable this functionality. Suggested value to enable this functionality is <a class=\"normal\" href=\"CastleKeysMouse.html#K_F11\">K_F11</a>, this is consistent will fullscreen key in other programs. You can freely modify it at any time, even after calling <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a>.  <p>The fullscreen is switched by closing it, changing <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FullScreen\">FullScreen</a> property and opening it again. So be sure to have good <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a> / <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnClose\">OnClose</a> implementations: you have to be able to recreate in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">OnOpen</a> everything that was released in <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnClose\">OnClose</a>. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#SwapFullScreen_Key"},
     {"title": "CastleWindow.TCastleWindowCustom.Close_CharKey", "text": " Set to #0 (default) to disable this functionality. Suggested value to enable this functionality is <a class=\"normal\" href=\"CastleStringUtils.html#CharEscape\">CharEscape</a>. You can freely modify it at any time, even after calling <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">Open</a>. ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#Close_CharKey"},
     {"title": "CastleWindow.TCastleWindowCustom.FpsCaptionUpdateDelay", "text": " Used when <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FpsShowOnCaption\">FpsShowOnCaption</a>.  <p>You probably don't want to change this &ndash; the default value is synchronized with how often the <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html\">TFramesPerSecond</a> actually change. So there's no point in making this smaller (you may cause slowdowns, and you will not see anything better). ", "tags": "", "loc": "CastleWindow.TCastleWindowCustom.html#FpsCaptionUpdateDelay"},
     {"title": "CastleWindow.TCastleWindow", "text": " Add your 3D stuff to the scene manager available in <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html#SceneManager\">SceneManager</a> property. Add your 2D stuff to the <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> property (from ancestor <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a>).  <p>You can directly access the <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html#SceneManager\">SceneManager</a> and configure it however you like.  <p>You have comfortable <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html#Load\">Load</a> method that simply loads a single 3D model to your world.  <p>If you're looking for analogous Lazarus component (that does basically the same, but can be placed on a Lazarus form) see <a class=\"normal\" href=\"CastleControl.TCastleControl.html\">TCastleControl</a> component. ", "tags": "", "loc": "CastleWindow.TCastleWindow.html"},
     {"title": "CastleWindow.TCastleWindow.NavigationInfoChanged", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindow.html#NavigationInfoChanged"},
     {"title": "CastleWindow.TCastleWindow.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindow.html#Create"},
     {"title": "CastleWindow.TCastleWindow.Load", "text": "  <p>This is nice for simple 3D model browsers, but usually for games you don't want to use this method &mdash; it's more flexible to create <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> yourself, and add it to scene manager yourself, see engine examples like scene_manager_basic.lpr.    ", "tags": "", "loc": "CastleWindow.TCastleWindow.html#Load"},
     {"title": "CastleWindow.TCastleWindow.Load", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindow.html#Load"},
     {"title": "CastleWindow.TCastleWindow.MainScene", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleWindow.html#MainScene"},
     {"title": "CastleWindow.TCastleWindow.SceneManager", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindow.html#SceneManager"},
     {"title": "CastleWindow.TCastleWindow.ShadowVolumes", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindow.html#ShadowVolumes"},
     {"title": "CastleWindow.TCastleWindow.ShadowVolumesRender", "text": " ", "tags": "", "loc": "CastleWindow.TCastleWindow.html#ShadowVolumesRender"},
     {"title": "CastleWindow.TCastleWindow.NavigationType", "text": " Note that this may not be the only camera used for rendering, it may not even be used at all (you can do all rendering using <a class=\"normal\" href=\"CastleSceneManager.TCastleAbstractViewport.html\">TCastleAbstractViewport</a>s. So use this property only if you use only a single default viewport. ", "tags": "", "loc": "CastleWindow.TCastleWindow.html#NavigationType"},
     {"title": "CastleWindow.TWindowList", "text": " ", "tags": "", "loc": "CastleWindow.TWindowList.html"},
     {"title": "CastleWindow.TWindowList.Invalidate", "text": "    ", "tags": "", "loc": "CastleWindow.TWindowList.html#Invalidate"},
     {"title": "CastleWindow.TCastleApplication", "text": " This tracks all open instances of <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> and implements message loop. It also handles some global tasks like managing the screen (changing current screen resolution and/or bit depth etc.)  <p>The only instance of this class should be in <a class=\"normal\" href=\"CastleWindow.html#Application\">Application</a> variable. Don't create any other instances of class <code>TCastleApplication</code>, there's no point in doing that. ", "tags": "", "loc": "CastleWindow.TCastleApplication.html"},
     {"title": "CastleWindow.TCastleApplication.VideoResize", "text": " Otherwise, next <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#TryVideoChange\">TryVideoChange</a> and <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#VideoChange\">VideoChange</a> will use default screen size.  ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#VideoResize"},
     {"title": "CastleWindow.TCastleApplication.VideoResizeWidth", "text": " ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#VideoResizeWidth"},
     {"title": "CastleWindow.TCastleApplication.VideoResizeheight", "text": " ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#VideoResizeheight"},
     {"title": "CastleWindow.TCastleApplication.DoLog", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#DoLog"},
     {"title": "CastleWindow.TCastleApplication.DoRun", "text": " TCustomApplication will automatically catch exceptions occuring inside <code>DoRun</code>.    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#DoRun"},
     {"title": "CastleWindow.TCastleApplication.Notification", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#Notification"},
     {"title": "CastleWindow.TCastleApplication.VideoSettingsDescribe", "text": " This is a multiline string, each line is indented by 2 spaces, always ends with <a class=\"normal\" href=\"CastleUtils.html#NL\">CastleUtils.NL</a>.    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#VideoSettingsDescribe"},
     {"title": "CastleWindow.TCastleApplication.TryVideoChange", "text": " Returns <code>True</code> if success.    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#TryVideoChange"},
     {"title": "CastleWindow.TCastleApplication.VideoChange", "text": " This actually just calls <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#TryVideoChange\">TryVideoChange</a> and checks the result.  <p>If not success: if OnErrorWarnUserAndContinue then we'll display a warning and continue. If not OnErrorWarnUserAndContinue then we'll raise an Exception.  <p>    Exception If video mode change failed, and OnErrorWarnUserAndContinue = false.", "tags": "", "loc": "CastleWindow.TCastleApplication.html#VideoChange"},
     {"title": "CastleWindow.TCastleApplication.VideoReset", "text": " If you never called <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#TryVideoChange\">TryVideoChange</a> (with success), then this does nothing. This is automatically called in Application.Destroy, so at finalization of this unit. This way your game nicely restores screen resolution for user.    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#VideoReset"},
     {"title": "CastleWindow.TCastleApplication.ScreenHeight", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#ScreenHeight"},
     {"title": "CastleWindow.TCastleApplication.ScreenWidth", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#ScreenWidth"},
     {"title": "CastleWindow.TCastleApplication.OpenWindowsCount", "text": "     ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#OpenWindowsCount"},
     {"title": "CastleWindow.TCastleApplication.ProcessMessage", "text": " You have to call this repeatedly to process key presses, mouse events, redraws and everything else. Messages are processed and appropriate window callbacks are called, like <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">TCastleWindowCustom.OnRender</a>, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnUpdate\">TCastleWindowCustom.OnUpdate</a>, TCastleWindowCustom.OnKeyPress and many others.  <p>For simple programs calling the <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#Run\">Run</a> method is usually the best solution, <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#Run\">Run</a> just calls <code>ProcessMessage</code> in a loop. Manually using the <code>ProcessMessage</code> method allows you to implement modal dialog boxes (generally any kind of &quot;display something until something happens&quot; behavior). Make your own event loop like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">while</span> <span class=\"pascal_keyword\">not</span> SomethingHappened <span class=\"pascal_keyword\">do</span>   Application.ProcessMessages(<span class=\"pascal_numeric\"></span>...);</pre>  <p>  <p>Often this is used together with <a class=\"normal\" href=\"CastleWindowModes.TGLMode.html\">TGLMode</a>, <a class=\"normal\" href=\"CastleWindowModes.TGLModeFrozenScreen.html\">TGLModeFrozenScreen</a> and similar utilities from <a class=\"normal\" href=\"CastleWindowModes.html\">CastleWindowModes</a> unit. They allow you to temporarily replace window callbacks with new ones, and later restore the original ones. This is useful for behavior similar to modal dialog boxes.  <p>For comfort, returns <code>not Terminated</code>. So it returns <code>True</code> if we should continue, that is if <code>Terminate</code> method was not called (directly or by closing the last window). If you want to check it (if you allow the user at all to close the application during modal box or such) you can do:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">while</span> <span class=\"pascal_keyword\">not</span> SomethingHappened <span class=\"pascal_keyword\">do</span>   <span class=\"pascal_keyword\">if</span> <span class=\"pascal_keyword\">not</span> Application.ProcessMessage(<span class=\"pascal_numeric\"></span>...) <span class=\"pascal_keyword\">then</span>     Break;</pre>  <p>  <p>Do not assume too much about message processing internals. For example, not all <code>ProcessMessage</code> calls cause redraw, even if redraw is requested by Invalidate. When we have messages to process, we generally don't call redraw or even <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnUpdate\">OnUpdate</a>.  <p>  <p>  WaitForMessage If <code>True</code> (and some other conditions are met, for example we do not have to call <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnUpdate\">OnUpdate</a> continuosly) then we can block, waiting for an event to process.  <p>Set this to <code>True</code> whenever you can, that is whenever your program only responds to user inputs (as opposed to making some operations, like animation or loading or ray-tracing something). Generally, when <code>SomethingHappened</code> from the example pseudo-code above can only be changed by user events (e.g. user has to click something; nothing happens if user doesn't click for 5 minutes or 5 hours). This allows to let OS and CPU have some rest, and spend time on other applications, or just sleep and conserve laptop battery power. WaitToLimitFPS If <code>True</code>, then we have backup mechanism for limiting CPU usage. When WaitForMessage mechanism cannot be used (becasue WaitForMessage is <code>False</code> or some other conditions disallow it), and user doesn't throw events at us (we don't want to sleep when user produces many events e.g. by mouse move), then we can do a small sleep to stabilize number of <code>ProcessMessage</code> calls at <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#LimitFPS\">LimitFPS</a> per second.  <p>Set this to <code>True</code> whenever you can, that is whenever you don't need <code>ProcessMessage</code> to return as fast as it can. For example, when you're displaying some animation, then displaying <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#LimitFPS\">LimitFPS</a> frames should be enough. OTOH, if you really do something that should be done as fast as possible (like loading some file or ray-tracing) you probably have to set this to <code>False</code>.  WaitForMessage If <code>True</code> (and some other conditions are met, for example we do not have to call <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OnUpdate\">OnUpdate</a> continuosly) then we can block, waiting for an event to process.  <p>Set this to <code>True</code> whenever you can, that is whenever your program only responds to user inputs (as opposed to making some operations, like animation or loading or ray-tracing something). Generally, when <code>SomethingHappened</code> from the example pseudo-code above can only be changed by user events (e.g. user has to click something; nothing happens if user doesn't click for 5 minutes or 5 hours). This allows to let OS and CPU have some rest, and spend time on other applications, or just sleep and conserve laptop battery power. WaitToLimitFPS If <code>True</code>, then we have backup mechanism for limiting CPU usage. When WaitForMessage mechanism cannot be used (becasue WaitForMessage is <code>False</code> or some other conditions disallow it), and user doesn't throw events at us (we don't want to sleep when user produces many events e.g. by mouse move), then we can do a small sleep to stabilize number of <code>ProcessMessage</code> calls at <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#LimitFPS\">LimitFPS</a> per second.  <p>Set this to <code>True</code> whenever you can, that is whenever you don't need <code>ProcessMessage</code> to return as fast as it can. For example, when you're displaying some animation, then displaying <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#LimitFPS\">LimitFPS</a> frames should be enough. OTOH, if you really do something that should be done as fast as possible (like loading some file or ray-tracing) you probably have to set this to <code>False</code>.", "tags": "", "loc": "CastleWindow.TCastleApplication.html#ProcessMessage"},
     {"title": "CastleWindow.TCastleApplication.ProcessAllMessages", "text": " Do not wait for anything.  <p>Contrast this with <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#ProcessMessage\">ProcessMessage</a> method, that processes only a single event. Or no event at all (when no events were pending and AllowSuspend = <code>False</code>). This means that after calling <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#ProcessMessage\">ProcessMessage</a> once, you may have many messages left in the queue (especially mouse move together with key presses typically makes a lot of events). So it's not good to use if you want to react timely to some user requests, e.g. when you do something time-consuming and allow user to break the task with Escape key.  <p><code>ProcessAllMessages</code> is like calling in a loop <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#ProcessMessage\">ProcessMessage</a>(false, false), ends when <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#ProcessMessage\">ProcessMessage</a>(false, false) didn't process any message or when quit was called (or last window closed).  <p>So <code>ProcessAllMessages</code> makes sure we have processed all pending events, thus we are up-to-date with window system requests.    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#ProcessAllMessages"},
     {"title": "CastleWindow.TCastleApplication.Quit", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#Quit"},
     {"title": "CastleWindow.TCastleApplication.Run", "text": " Think of it as just a shortcut for &quot;while <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#ProcessMessage\">ProcessMessage</a> do ;&quot;.  <p>Note that this does nothing if <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#OpenWindowsCount\">OpenWindowsCount</a> = 0, that is there are no open windows. Besides the obvious reason (you didn't call <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Open\">TCastleWindowCustom.Open</a> on any window...) this may also happen if you called Close (or Application.Quit) from your window OnOpen / OnResize callback. In such case no event would probably reach our program, and user would have no chance to quit, so Run just refuses to work and exits immediately without any error.    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#Run"},
     {"title": "CastleWindow.TCastleApplication.BackendName", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#BackendName"},
     {"title": "CastleWindow.TCastleApplication.Create", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#Create"},
     {"title": "CastleWindow.TCastleApplication.Destroy", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#Destroy"},
     {"title": "CastleWindow.TCastleApplication.HandleException", "text": "    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#HandleException"},
     {"title": "CastleWindow.TCastleApplication.ParseStandardParameters", "text": " Handles: </p>  <ul class=\"paragraph_spacing\">   <li><p><code>-h / &ndash;help</code></p></li>   <li><p><code>-v / &ndash;version</code>, using <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#Version\">Version</a></p></li>   <li><p>All the parameters handled by <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ParseParameters\">TCastleWindowCustom.ParseParameters</a>. Requires <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#MainWindow\">MainWindow</a> to be set.</p></li>   <li><p>All the parameters handled by <a class=\"normal\" href=\"CastleSoundEngine.TSoundEngine.html#ParseParameters\">TSoundEngine.ParseParameters</a>.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#ParseStandardParameters"},
     {"title": "CastleWindow.TCastleApplication.XDisplayName", "text": "  <p>Note that this is exposed by GTK even for non-XWindows platforms, but I don't know what it does there. ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#XDisplayName"},
     {"title": "CastleWindow.TCastleApplication.VideoColorBits", "text": " Zero means that system default is used. ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#VideoColorBits"},
     {"title": "CastleWindow.TCastleApplication.VideoFrequency", "text": " Leave as 0 to use system default. ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#VideoFrequency"},
     {"title": "CastleWindow.TCastleApplication.OpenWindows", "text": " ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#OpenWindows"},
     {"title": "CastleWindow.TCastleApplication.OnInitialize", "text": " Called only once, at the very beginning of the game, when we're ready to load everything and the first OpenGL context is initialized (right before calling <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnOpen\">TCastleWindowCustom.OnOpen</a>).  <p>For targets like Android or iOS or browser plugin, you should not do anything (even reading files) before this callback occurs. Only when this occurs, we know that external process told us &quot;Ok, you're ready&quot;. So you should put all the game initialization in an Application.OnInitialize callback. It will be automatically called by <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> backend when we're really ready (actually, a little later &mdash; when OpenGL context is active, to allow you to display progress bars etc. when loading). ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#OnInitialize"},
     {"title": "CastleWindow.TCastleApplication.OnUpdate", "text": "  ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#OnUpdate"},
     {"title": "CastleWindow.TCastleApplication.OnIdle", "text": " ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#OnIdle"},
     {"title": "CastleWindow.TCastleApplication.OnTimer", "text": " The actual delay may be larger than <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#TimerMilisec\">TimerMilisec</a> miliseconds, depending on how the program (and OS) is busy.  <p>You can of course change <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#TimerMilisec\">TimerMilisec</a> (and <code>OnTimer</code>) even when some windows are already open.  ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#OnTimer"},
     {"title": "CastleWindow.TCastleApplication.TimerMilisec", "text": " ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#TimerMilisec"},
     {"title": "CastleWindow.TCastleApplication.MainWindow", "text": " On targets when only one <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> instance makes sense (like Android or iOS or web plugin), set this to the reference of that window. It is also used by <a class=\"normal\" href=\"CastleWindowProgress.TWindowProgressInterface.html\">TWindowProgressInterface</a> to display progress bar. ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#MainWindow"},
     {"title": "CastleWindow.TCastleApplication.UserAgent", "text": " ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#UserAgent"},
     {"title": "CastleWindow.TCastleApplication.DefaultWindowClass", "text": " In this case, we first try to use <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#MainWindow\">MainWindow</a> (if assigned and not open), otherwise we create new window instance of this class.  <p>For single-window apps (for example, a game that can only be played in one window at a time), you want to set <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#MainWindow\">MainWindow</a> to your <i>real</i> window where game goes on, and set <code>DefaultWindowClass</code> to some simple window informing user to switch to the primary window.  <p>For multi-window apps (games that can be played simultaneously in multiple windows, or things like 3D model browsers that can display different models in different windows) you can leave <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#MainWindow\">MainWindow</a> at <code>Nil</code> and just focus on creating a special window class with your functionality.  <p>By default, this is simple <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> class. ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#DefaultWindowClass"},
     {"title": "CastleWindow.TCastleApplication.LimitFPS", "text": " Set to zero to not limit.  <p>To be more precise, this limits the number of <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#ProcessMessage\">TCastleApplication.ProcessMessage</a> calls per second, in situations when we do not have to process any user input. So we limit not only rendering (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">TCastleWindowCustom.OnRender</a>) but also other animation processing (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnUpdate\">TCastleWindowCustom.OnUpdate</a>) calls per second. See <a class=\"normal\" href=\"CastleWindow.TCastleApplication.html#ProcessMessage\">TCastleApplication.ProcessMessage</a>.  <p>In case of <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> backends when we have to fight with event clogging (right now only LCL backend, used by default only on macOS) this is also the &quot;desired number of FPS&quot;: we make sure that even when application is clogged with events (like when dragging with mouse), we call update (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnUpdate\">TCastleWindowCustom.OnUpdate</a>) and (if necessary) draw (<a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">TCastleWindowCustom.OnRender</a> and related) at least as often. When <code>LimitFPS</code> is used for this purpose (&quot;desired number of FPS&quot;), it is also capped (by MaxDesiredFPS = 100.0). ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#LimitFPS"},
     {"title": "CastleWindow.TCastleApplication.Version", "text": " ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#Version"},
     {"title": "CastleWindow.TCastleApplication.TouchDevice", "text": " ", "tags": "", "loc": "CastleWindow.TCastleApplication.html#TouchDevice"},
     {"title": "CastleWindow.WindowPositionCenter", "text": " ", "tags": "", "loc": "CastleWindow.html#WindowPositionCenter"},
     {"title": "CastleWindow.WindowDefaultSize", "text": " ", "tags": "", "loc": "CastleWindow.html#WindowDefaultSize"},
     {"title": "CastleWindow.StandardParseOptions", "text": "  <p>In other words, most programs calling <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ParseParameters\">TCastleWindowCustom.ParseParameters</a> method can safely pass as the 1st parameter this constant, <code>StandardParseOptions</code>. Or they can simply call overloaded version of <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ParseParameters\">TCastleWindowCustom.ParseParameters</a> that doesn't take any parameters, it is always equivalent to calling <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#ParseParameters\">TCastleWindowCustom.ParseParameters</a>(<code>StandardParseOptions</code>). ", "tags": "", "loc": "CastleWindow.html#StandardParseOptions"},
     {"title": "CastleWindow.DefaultDepthBits", "text": " ", "tags": "", "loc": "CastleWindow.html#DefaultDepthBits"},
     {"title": "CastleWindow.DefaultFpsCaptionUpdateDelay", "text": " ", "tags": "", "loc": "CastleWindow.html#DefaultFpsCaptionUpdateDelay"},
     {"title": "CastleWindow.DefaultLimitFPS", "text": " ", "tags": "", "loc": "CastleWindow.html#DefaultLimitFPS"},
     {"title": "CastleWindow.DefaultAntiAliasing", "text": " ", "tags": "", "loc": "CastleWindow.html#DefaultAntiAliasing"},
     {"title": "CastleWindow.AntiAliasingNames", "text": " ", "tags": "", "loc": "CastleWindow.html#AntiAliasingNames"},
     {"title": "CastleWindow.Application", "text": " Automatically created / destroyed by <a class=\"normal\" href=\"CastleWindow.html\">CastleWindow</a> unit.    ", "tags": "", "loc": "CastleWindow.html#Application"},
     {"title": "CastleWindow.Resize2D", "text": " You can use it like <code>Window.OnResize := <code>Resize2D</code>;</code> or just by calling it directly from your OnResize callback.  <p>It does </p>  <pre class=\"longcode\"> glViewport(Window.Rect); OrthoProjection(<span class=\"pascal_numeric\">0</span>, Window.Width, <span class=\"pascal_numeric\">0</span>, Window.Height);</pre>  <p>    ", "tags": "", "loc": "CastleWindow.html#Resize2D"},
     {"title": "CastleWindow.KeyString", "text": " Key is given as combination of character code (may be #0) and Key code (may be <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a>), and additional required <code>Modifiers</code> (although some modifiers may be already implied by CharKey). See <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#Key\">TMenuItem.Key</a> and <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#CharKey\">TMenuItem.CharKey</a> and <a class=\"normal\" href=\"CastleWindow.TMenuItem.html#Modifiers\">TMenuItem.Modifiers</a>.  <p>Only when both CharKey = #0 and Key = <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> then this combination doesn't describe any key, and we return <code>False</code>. Otherwise we return <code>True</code> and set S.    ", "tags": "", "loc": "CastleWindow.html#KeyString"},
     {"title": "CastleWindow.MenuItemFromSmallId", "text": " SearchSmallId must be a SmallId of some existing (i.e. created and not destroyed yet) <a class=\"normal\" href=\"CastleWindow.TMenuItem.html\">TMenuItem</a>. This function returns this <a class=\"normal\" href=\"CastleWindow.TMenuItem.html\">TMenuItem</a>.    ", "tags": "", "loc": "CastleWindow.html#MenuItemFromSmallId"},
     {"title": "CastleWindow.SRemoveMnemonics", "text": "  <p>In other words: with mnemonics (as defined by <a class=\"normal\" href=\"CastleWindow.TMenuEntryWithCaption.html#Caption\">TMenuEntryWithCaption.Caption</a> removed.    ", "tags": "", "loc": "CastleWindow.html#SRemoveMnemonics"},
     {"title": "CastleWindow.SQuoteMenuEntryCaption", "text": "  <p>In other words: S will not contain any mnemonics. If you will assign S to <a class=\"normal\" href=\"CastleWindow.TMenuEntryWithCaption.html#Caption\">TMenuEntryWithCaption.Caption</a>, then this menu entry caption will display exactly S, without any mnemonics. Single '_' in S will be displayed exactly as single '_'.    ", "tags": "", "loc": "CastleWindow.html#SQuoteMenuEntryCaption"},
     {"title": "CastleWindow.TWindowParseOption", "text": "  poGeometry    poScreenGeometry    poDisplay    poMacOsXProcessSerialNumber    poLimitFps   ", "tags": "", "loc": "CastleWindow.html#TWindowParseOption"},
     {"title": "CastleWindow.TWindowParseOptions", "text": " ", "tags": "", "loc": "CastleWindow.html#TWindowParseOptions"},
     {"title": "CastleWindow.PWindowParseOptions", "text": " ", "tags": "", "loc": "CastleWindow.html#PWindowParseOptions"},
     {"title": "CastleWindow.TAntiAliasing", "text": "  aaNone    aa2SamplesFaster 2 samples, &quot;don't care&quot; hint.   aa2SamplesNicer 2 samples, &quot;nicest&quot; hint (quincunx (5 taps) for NVidia).   aa4SamplesFaster 4 samples, &quot;don't care&quot; hint.   aa4SamplesNicer 4 samples, &quot;nicest&quot; hint (9 taps for NVidia).   aa8SamplesFaster 8 samples, &quot;don't care&quot; hint.   aa8SamplesNicer 8 samples, &quot;nicest&quot; hint.   aa16SamplesFaster 16 samples, &quot;don't care&quot; hint.   aa16SamplesNicer 16 samples, &quot;nicest&quot; hint.  ", "tags": "", "loc": "CastleWindow.html#TAntiAliasing"},
     {"title": "CastleWindow.TUIContainer", "text": " ", "tags": "", "loc": "CastleWindow.html#TUIContainer"},
     {"title": "CastleWindow.TMenuEntryList", "text": " ", "tags": "", "loc": "CastleWindow.html#TMenuEntryList"},
     {"title": "CastleWindow.TWindowMessageType", "text": "  mtInfo    mtWarning    mtQuestion    mtError    mtOther   ", "tags": "", "loc": "CastleWindow.html#TWindowMessageType"},
     {"title": "CastleWindow.TUpdateFunc", "text": "    ", "tags": "", "loc": "CastleWindow.html#TUpdateFunc"},
     {"title": "CastleWindow.TMenuClickFunc", "text": "    ", "tags": "", "loc": "CastleWindow.html#TMenuClickFunc"},
     {"title": "CastleWindow.TDropFilesFunc", "text": "    ", "tags": "", "loc": "CastleWindow.html#TDropFilesFunc"},
     {"title": "CastleWindow.TGLContextRetryOpenFunc", "text": "    ", "tags": "", "loc": "CastleWindow.html#TGLContextRetryOpenFunc"},
     {"title": "CastleWindow.TResizeAllowed", "text": "  raNotAllowed    raOnlyAtOpen    raAllowed   ", "tags": "", "loc": "CastleWindow.html#TResizeAllowed"},
     {"title": "CastleWindow.TCaptionPart", "text": "  cpPublic    cpFps   ", "tags": "", "loc": "CastleWindow.html#TCaptionPart"},
     {"title": "CastleWindow.PGtkGLArea", "text": " But, really, GLAreaGtk could be any gtk widget with CASTLE_WINDOW_GTK_2. ", "tags": "", "loc": "CastleWindow.html#PGtkGLArea"},
     {"title": "CastleWindow.TCastleWindowBase", "text": " In new programs, use <a class=\"normal\" href=\"CastleWindow.html#TUIContainer\">TUIContainer</a> as a parameter for callbacks, and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> or <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> as window class. ", "tags": "", "loc": "CastleWindow.html#TCastleWindowBase"},
     {"title": "CastleWindow.TCastleWindowCustomClass", "text": " ", "tags": "", "loc": "CastleWindow.html#TCastleWindowCustomClass"},
     {"title": "CastleWindow.TGLApplication", "text": " ", "tags": "", "loc": "CastleWindow.html#TGLApplication"},
     {"title": "CastleWindowModes", "text": " They allow to easily save / restore <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> attributes.  <p>This unit is a tool for creating functions like <a class=\"normal\" href=\"CastleMessages.html#MessageOK\">CastleMessages.MessageOK</a>. To make nice &quot;modal&quot; box, you want to temporarily replace <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> callbacks with your own, call Application.ProcessMessage method in a loop until user gives an answer, and restore everything. This way you can implement functions that wait for some keypress, or wait until user inputs some string, or wait until user picks something with mouse, or wait for 10 seconds displaying some animation, etc. ", "tags": "", "loc": "CastleWindowModes.html"},
     {"title": "CastleWindowModes.TGLMode", "text": " Saves/restores the state of <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a>. ", "tags": "", "loc": "CastleWindowModes.TGLMode.html"},
     {"title": "CastleWindowModes.TGLMode.Create", "text": " Destructor will restore them.  <p>Some gory details (that you will usually not care about... the point is: everything works sensibly of the box) :  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>We save/restore window state.</p></li>   <li><p>OpenGL context connected to this window is also made current during constructor and destructor. Also, <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Invalidate\">TCastleWindowCustom.Invalidate</a> is called (since new callbacks, as well as original callbacks, probably want to redraw window contents.)</p></li>   <li><p> All pressed keys and mouse butons are saved and faked to be released, by calling TCastleWindowCustom.EventRelease with original callbacks. This way, if user releases some keys/mouse inside modal box, your original <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> callbacks will not miss this fact. This way e.g. user scripts in VRML/X3D worlds that observe keys work fine.  <p>If <a class=\"normal\" href=\"CastleWindowModes.TGLMode.html#FakeMouseDown\">FakeMouseDown</a> then at destruction (after restoring original callbacks) we will also notify your original callbacks that user pressed these buttons (by sending TCastleWindowCustom.EventMouseDown). Note that <a class=\"normal\" href=\"CastleWindowModes.TGLMode.html#FakeMouseDown\">FakeMouseDown</a> feature turned out to be usually more troublesome than usefull &mdash; too often some unwanted MouseDown event was caused by this mechanism. That's because if original callbacks do something in MouseDown (like e.g. activate some click) then you don't want to generate fake MouseDown by <a class=\"normal\" href=\"CastleWindowModes.TGLMode.html#Destroy\">TGLMode.Destroy</a>. So the default value of <a class=\"normal\" href=\"CastleWindowModes.TGLMode.html#FakeMouseDown\">FakeMouseDown</a> is <code>False</code>. But this means that original callbacks have to be careful and <i>never assume</i> that when some button is pressed (because it's included in MousePressed, or has EventRelease generated for it) then for sure there occurred some MouseDown for it. </p></li>   <li><p>At destructor, we notify original callbacks about size changes by sending TCastleWindowCustom.EventResize. This way your original callbacks know about size changes, and can set OpenGL projection etc.</p></li>   <li><p> We call ZeroNextSecondsPassed at the end, when closing our mode, see <a class=\"normal\" href=\"CastleTimeUtils.TFramesPerSecond.html#ZeroNextSecondsPassed\">TFramesPerSecond.ZeroNextSecondsPassed</a> for comments why this is needed.</p></li>   <li><p>This also performs important optimization to avoid closing / reinitializing window <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> OpenGL resources, see <a class=\"normal\" href=\"CastleUIControls.TUIControl.html#DisableContextOpenClose\">TUIControl.DisableContextOpenClose</a>.</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleWindowModes.TGLMode.html#Create"},
     {"title": "CastleWindowModes.TGLMode.CreateReset", "text": " Destructor will restore saved state.  <p>For most properties, we simply reset them to some sensible default values. For some important properties, we take their value explicitly by parameter.  <p>Window properties resetted:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>All callbacks (OnXxx) are set to <code>Nil</code>.  <p>Except the open/close callbacks (OnOpen and OnClose, OnOpenObject and OnCloseObject). Actually, OnOpenObject and OnCloseObject are changed for internal purposes, but, assuming you use SetStandardState, the orignal ones will still happen. Global <a class=\"normal\" href=\"CastleUIControls.html#OnGLContextOpen\">CastleUIControls.OnGLContextOpen</a>, <a class=\"normal\" href=\"CastleUIControls.html#OnGLContextClose\">CastleUIControls.OnGLContextClose</a> are also untouched.  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>On standalone, we can expect that the window (and OpenGL context) will stay open during the lifetime of a single <a class=\"normal\" href=\"CastleWindowModes.TGLMode.html\">TGLMode</a>. So it doesn't really matter what we do with callbacks OnOpen / OnClose.</p></li>   <li><p>On mobiles (Android) this is not necessarily true. Window may get closed at any time. So be extra careful when implementing OnOpen / OnClose callbacks, remember that they may happen when we're inside a mode (for example inside a modal message in <a class=\"normal\" href=\"CastleMessages.html\">CastleMessages</a> or a progress bar).</p></li> </ul>  <p> </p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Caption\">TCastleWindowCustom.Caption</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#MainMenu\">TCastleWindowCustom.MainMenu</a> are left as they were.</p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Cursor\">TCastleWindowCustom.Cursor</a> is reset to <a class=\"normal\" href=\"CastleKeysMouse.html#mcDefault\">mcDefault</a>.</p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#UserData\">TCastleWindowCustom.UserData</a> is reset to <code>Nil</code>.</p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#AutoRedisplay\">TCastleWindowCustom.AutoRedisplay</a> is reset to <code>False</code>.</p></li>   <li><p><a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#RenderStyle\">TCastleWindowCustom.RenderStyle</a> is reset to <a class=\"normal\" href=\"CastleUIControls.html#rs2D\">rs2D</a>.</p></li>   <li><p>TCastleWindowCustom.MainMenu.Enabled will be reset to <code>False</code> (only if MainMenu &lt;&gt; nil).</p></li>   <li><p>TCastleWindowDemo.SwapFullScreen_Key will be reset to <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a>.</p></li>   <li><p>TCastleWindowDemo.Close_charkey will be reset to #0.</p></li>   <li><p>All <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#Controls\">TCastleWindowCustom.Controls</a> are temporarily removed.</p></li> </ul>  <p>  <p>If you're looking for a suitable callback to pass as NewCloseQuery (new <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnCloseQuery\">TCastleWindowCustom.OnCloseQuery</a>), @<a class=\"normal\" href=\"CastleWindowModes.html#NoClose\">NoClose</a> may be suitable: it's an empty callback, thus using it disables the possibility to close the window by window manager (usually using &quot;close&quot; button in some window corner or Alt+F4).    ", "tags": "", "loc": "CastleWindowModes.TGLMode.html#CreateReset"},
     {"title": "CastleWindowModes.TGLMode.Destroy", "text": "    ", "tags": "", "loc": "CastleWindowModes.TGLMode.html#Destroy"},
     {"title": "CastleWindowModes.TGLMode.FakeMouseDown", "text": " ", "tags": "", "loc": "CastleWindowModes.TGLMode.html#FakeMouseDown"},
     {"title": "CastleWindowModes.TGLModeFrozenScreen", "text": " This is nice if you want to wait for some event (like pressing a key), keeping the same screen displayed.  <p>During this lifetime, we set special <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnRender\">TCastleWindowCustom.OnRender</a> and <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#OnResize\">TCastleWindowCustom.OnResize</a> to draw the saved image in a simplest 2D OpenGL projection. ", "tags": "", "loc": "CastleWindowModes.TGLModeFrozenScreen.html"},
     {"title": "CastleWindowModes.TGLModeFrozenScreen.Create", "text": "    ", "tags": "", "loc": "CastleWindowModes.TGLModeFrozenScreen.html#Create"},
     {"title": "CastleWindowModes.TGLModeFrozenScreen.Destroy", "text": "    ", "tags": "", "loc": "CastleWindowModes.TGLModeFrozenScreen.html#Destroy"},
     {"title": "CastleWindowModes.NoClose", "text": "    ", "tags": "", "loc": "CastleWindowModes.html#NoClose"},
     {"title": "CastleWindowProgress", "text": "  <p>Simply set <code>WindowProgressInterface.Window</code> to your <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html\">TCastleWindowCustom</a> instance, and assign  <p></p>  <pre class=\"longcode\">Progress.UserInterface := WindowProgressInterface;</pre>  <p>  <p>Between Progress.Init and Fini you shouldn't do anything with window set as <code>WindowProgressInterface.Window</code>. It's callbacks will be temporarily swapped and it will be used to render progress bar.  <p>As usual, remember to always call Progress.Fini if you called Progress.Init. Progress.Fini restores original callbacks and OpenGL state of your window. Usually it's best and safest to use try..finally block like  <p></p>  <pre class=\"longcode\">Progress.Init; <span class=\"pascal_keyword\">try</span>.<span class=\"pascal_numeric\"></span>....finally Progress.Fini; <span class=\"pascal_keyword\">end</span>;</pre>  <p> ", "tags": "", "loc": "CastleWindowProgress.html"},
     {"title": "CastleWindowProgress.TWindowProgressInterface", "text": " Uses Application.MainWindow to render the progress bar, so be sure to assign it. If the Application.MainWindow is not assigned, or not open, when progress bar starts &mdash; we gracefully avoid showing any progress. ", "tags": "", "loc": "CastleWindowProgress.TWindowProgressInterface.html"},
     {"title": "CastleWindowProgress.TWindowProgressInterface.Init", "text": "    ", "tags": "", "loc": "CastleWindowProgress.TWindowProgressInterface.html#Init"},
     {"title": "CastleWindowProgress.TWindowProgressInterface.Update", "text": "    ", "tags": "", "loc": "CastleWindowProgress.TWindowProgressInterface.html#Update"},
     {"title": "CastleWindowProgress.TWindowProgressInterface.Fini", "text": "    ", "tags": "", "loc": "CastleWindowProgress.TWindowProgressInterface.html#Fini"},
     {"title": "CastleWindowProgress.TWindowProgressInterface.Window", "text": " ", "tags": "", "loc": "CastleWindowProgress.TWindowProgressInterface.html#Window"},
     {"title": "CastleWindowProgress.WindowProgressInterface", "text": " This instance is created in initialization, freed in finalization. ", "tags": "", "loc": "CastleWindowProgress.html#WindowProgressInterface"},
     {"title": "CastleWindowRecentFiles", "text": " See <a class=\"normal\" href=\"CastleRecentFiles.TRecentFiles.html\">TRecentFiles</a> class. ", "tags": "", "loc": "CastleWindowRecentFiles.html"},
     {"title": "CastleWindowRecentFiles.TWindowRecentFiles", "text": " ", "tags": "", "loc": "CastleWindowRecentFiles.TWindowRecentFiles.html"},
     {"title": "CastleWindowRecentFiles.TWindowRecentFiles.MenuCreate", "text": "    ", "tags": "", "loc": "CastleWindowRecentFiles.TWindowRecentFiles.html#MenuCreate"},
     {"title": "CastleWindowRecentFiles.TWindowRecentFiles.MenuDestroy", "text": " Internal (do not call this directly, it's only called by parent class). Note that it doesn't read <a class=\"normal\" href=\"CastleRecentFiles.TRecentFiles.html#URLs\">URLs</a> list at all, it only depends on FirstSeparator value.    ", "tags": "", "loc": "CastleWindowRecentFiles.TWindowRecentFiles.html#MenuDestroy"},
     {"title": "CastleWindowRecentFiles.TWindowRecentFiles.NextMenuItem", "text": "  <p>If this is not <code>Nil</code> then each update to the recent files list (for example by <a class=\"normal\" href=\"CastleRecentFiles.TRecentFiles.html#Add\">Add</a> method) will result in the menu items right before <code>NextMenuItem</code> to be updated.  <p>Also changing the value of this property will result in one-time update of the menu. Menu at the place of old <code>NextMenuItem</code> will be removed and menu at the place of new <code>NextMenuItem</code> will get created.  <p>Usually <code>NextMenuItem</code> should be the separator that divides the print and properties menu sections and the close menu sections. That's consistent with other GNOME programs, and this is what we usually try to follow. ", "tags": "", "loc": "CastleWindowRecentFiles.TWindowRecentFiles.html#NextMenuItem"},
     {"title": "CastleWindowsFonts", "text": " ", "tags": "", "loc": "CastleWindowsFonts.html"},
     {"title": "CastleWindowsFonts.TWindowsFont", "text": " Create an instance of this class, setup some attributes, and call <a class=\"normal\" href=\"CastleWindowsFonts.TWindowsFont.html#GetHandle\">GetHandle</a>. In the future this class may be extended to something less trivial.  <p>For the meaning of properties see WinAPI documentation for CreateFont function. ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html"},
     {"title": "CastleWindowsFonts.TWindowsFont.GetHandle", "text": " Calls WinAPI CreateFont. Rememeber to free result somewhere by DeleteObject.  <p>Remeber that you may not get the font you asked for. Windows.CreateFont will try to return something as close as possible, but if exact match will not be possible &ndash; it can return something else. E.g. specifying <a class=\"normal\" href=\"CastleWindowsFonts.TWindowsFont.html#FaceName\">FaceName</a> = 'some non-existing font name' will not cause some error (like EOSError). Instead it will result in default Windows font (&quot;MS Sans Serif&quot; usually) being returned.  <p>    EOSError If font cannot be created (when WinAPI CreateFont returned error)", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#GetHandle"},
     {"title": "CastleWindowsFonts.TWindowsFont.Create", "text": " We require the height value to be passed to constructor, simply because there's no &quot;generally sensible&quot; default value for Height.    ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#Create"},
     {"title": "CastleWindowsFonts.TWindowsFont.Height", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#Height"},
     {"title": "CastleWindowsFonts.TWindowsFont.Angle", "text": " The only portable way is to set them both to the same values. ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#Angle"},
     {"title": "CastleWindowsFonts.TWindowsFont.Weight", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#Weight"},
     {"title": "CastleWindowsFonts.TWindowsFont.Italic", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#Italic"},
     {"title": "CastleWindowsFonts.TWindowsFont.Underline", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#Underline"},
     {"title": "CastleWindowsFonts.TWindowsFont.StrikeOut", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#StrikeOut"},
     {"title": "CastleWindowsFonts.TWindowsFont.CharSet", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#CharSet"},
     {"title": "CastleWindowsFonts.TWindowsFont.OutputPrecision", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#OutputPrecision"},
     {"title": "CastleWindowsFonts.TWindowsFont.ClipPrecision", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#ClipPrecision"},
     {"title": "CastleWindowsFonts.TWindowsFont.Quality", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#Quality"},
     {"title": "CastleWindowsFonts.TWindowsFont.Pitch", "text": " They will be combined to create fdwPitchAndFamily param, i.e. fdwPitchAndFamily := Pitch or Family. Pitch is for XXX_PITCH consts, Family is for FF_XXX consts.  ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#Pitch"},
     {"title": "CastleWindowsFonts.TWindowsFont.Family", "text": " ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#Family"},
     {"title": "CastleWindowsFonts.TWindowsFont.FaceName", "text": " Default is ''. ", "tags": "", "loc": "CastleWindowsFonts.TWindowsFont.html#FaceName"},
     {"title": "CastleWindowsFonts.CharSetsNames", "text": " ", "tags": "", "loc": "CastleWindowsFonts.html#CharSetsNames"},
     {"title": "CastleWindowsFonts.IsFontTrueType", "text": "    ", "tags": "", "loc": "CastleWindowsFonts.html#IsFontTrueType"},
     {"title": "CastleWindowsFonts.EnumFontCharsetsObj", "text": " Warning: enumerated values may be repeated.     ", "tags": "", "loc": "CastleWindowsFonts.html#EnumFontCharsetsObj"},
     {"title": "CastleWindowsFonts.EnumFontCharsets", "text": "    ", "tags": "", "loc": "CastleWindowsFonts.html#EnumFontCharsets"},
     {"title": "CastleWindowsFonts.WinCharSetFromName", "text": "    ", "tags": "", "loc": "CastleWindowsFonts.html#WinCharSetFromName"},
     {"title": "CastleWindowsFonts.TWinCharSet", "text": " For each value csXxx below, WinAPI defines constant XXX_CHARSET. Useful for enumerating available charsets, displaying charset name etc.  wcsANSI    wcsDEFAULT    wcsSYMBOL    wcsSHIFTJIS    wcsHANGEUL    wcsGB2312    wcsCHINESEBIG5    wcsOEM    wcsHEBREW    wcsARABIC    wcsGREEK    wcsTURKISH    wcsTHAI    wcsEASTEUROPE    wcsRUSSIAN    wcsBALTIC   ", "tags": "", "loc": "CastleWindowsFonts.html#TWinCharSet"},
     {"title": "CastleWindowsFonts.TEnumFontCharsetsProc_ByObject", "text": "    ", "tags": "", "loc": "CastleWindowsFonts.html#TEnumFontCharsetsProc_ByObject"},
     {"title": "CastleWindowsFonts.TEnumFontCharsetsProc", "text": "    ", "tags": "", "loc": "CastleWindowsFonts.html#TEnumFontCharsetsProc"},
     {"title": "CastleWindowTouch", "text": " ", "tags": "", "loc": "CastleWindowTouch.html"},
     {"title": "CastleWindowTouch.TCastleWindowTouch", "text": "  <p>In addition to all the goodies of the <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html\">TCastleWindow</a> functionality, this class can additionally manage one or two <a class=\"normal\" href=\"CastleControls.TCastleTouchControl.html\">TCastleTouchControl</a> instances. They will be automatically positioned in the bottom-left and bottom-right corners of the screen, and will allow the user to navigate using the default SceneManager.Camera. In the simplest case, just set <a class=\"normal\" href=\"CastleWindowTouch.TCastleWindowTouch.html#AutomaticTouchInterface\">AutomaticTouchInterface</a> to <code>True</code>, and the touch controls will automatically adjust to the current navigation type of the camera (examine, walk, fly...). ", "tags": "", "loc": "CastleWindowTouch.TCastleWindowTouch.html"},
     {"title": "CastleWindowTouch.TCastleWindowTouch.DefaultAutomaticWalkTouchCtl", "text": " ", "tags": "", "loc": "CastleWindowTouch.TCastleWindowTouch.html#DefaultAutomaticWalkTouchCtl"},
     {"title": "CastleWindowTouch.TCastleWindowTouch.Create", "text": "    ", "tags": "", "loc": "CastleWindowTouch.TCastleWindowTouch.html#Create"},
     {"title": "CastleWindowTouch.TCastleWindowTouch.NavigationInfoChanged", "text": "    ", "tags": "", "loc": "CastleWindowTouch.TCastleWindowTouch.html#NavigationInfoChanged"},
     {"title": "CastleWindowTouch.TCastleWindowTouch.DoUpdate", "text": "    ", "tags": "", "loc": "CastleWindowTouch.TCastleWindowTouch.html#DoUpdate"},
     {"title": "CastleWindowTouch.TCastleWindowTouch.TouchInterface", "text": " This automatically manages under the hood 0, 1 or 2 <a class=\"normal\" href=\"CastleControls.TCastleTouchControl.html\">TCastleTouchControl</a> instances, placing them at suitable positions and handling their operations.  <p>Note that you can set <a class=\"normal\" href=\"CastleWindowTouch.TCastleWindowTouch.html#AutomaticTouchInterface\">AutomaticTouchInterface</a> = <code>True</code> to have this property automatically adjusted. (In which case you should not set this directly.) ", "tags": "", "loc": "CastleWindowTouch.TCastleWindowTouch.html#TouchInterface"},
     {"title": "CastleWindowTouch.TCastleWindowTouch.AutomaticTouchInterface", "text": " The navigation type is obtained from the camera of the default viewport, see <a class=\"normal\" href=\"CastleWindow.TCastleWindow.html#NavigationType\">TCastleWindow.NavigationType</a>. ", "tags": "", "loc": "CastleWindowTouch.TCastleWindowTouch.html#AutomaticTouchInterface"},
     {"title": "CastleWindowTouch.TCastleWindowTouch.AutomaticWalkTouchCtl", "text": " Select between <a class=\"normal\" href=\"CastleWindowTouch.html#tiCtlWalkCtlRotate\">tiCtlWalkCtlRotate</a> or <a class=\"normal\" href=\"CastleWindowTouch.html#tiCtlWalkDragRotate\">tiCtlWalkDragRotate</a> (default). ", "tags": "", "loc": "CastleWindowTouch.TCastleWindowTouch.html#AutomaticWalkTouchCtl"},
     {"title": "CastleWindowTouch.etciNone", "text": " ", "tags": "", "loc": "CastleWindowTouch.html#etciNone"},
     {"title": "CastleWindowTouch.etciCtlWalkCtlRotate", "text": " ", "tags": "", "loc": "CastleWindowTouch.html#etciCtlWalkCtlRotate"},
     {"title": "CastleWindowTouch.etciCtlWalkDragRotate", "text": " ", "tags": "", "loc": "CastleWindowTouch.html#etciCtlWalkDragRotate"},
     {"title": "CastleWindowTouch.etciCtlFlyCtlWalkDragRotate", "text": " ", "tags": "", "loc": "CastleWindowTouch.html#etciCtlFlyCtlWalkDragRotate"},
     {"title": "CastleWindowTouch.etciCtlPanXYDragRotate", "text": " ", "tags": "", "loc": "CastleWindowTouch.html#etciCtlPanXYDragRotate"},
     {"title": "CastleWindowTouch.TTouchInterface", "text": "  tiNone    tiCtlWalkCtlRotate    tiCtlWalkDragRotate    tiCtlFlyCtlWalkDragRotate    tiCtlPanXYDragRotate   ", "tags": "", "loc": "CastleWindowTouch.html#TTouchInterface"},
     {"title": "CastleXMLConfig", "text": " ", "tags": "", "loc": "CastleXMLConfig.html"},
     {"title": "CastleXMLConfig.EMissingAttribute", "text": " ", "tags": "", "loc": "CastleXMLConfig.EMissingAttribute.html"},
     {"title": "CastleXMLConfig.TCastleConfigEventList", "text": " ", "tags": "", "loc": "CastleXMLConfig.TCastleConfigEventList.html"},
     {"title": "CastleXMLConfig.TCastleConfigEventList.ExecuteAll", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfigEventList.html#ExecuteAll"},
     {"title": "CastleXMLConfig.TCastleConfig", "text": " Adds various Castle Game Engine extensions to the ancestor TXMLConfig class:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>load/save from an URL or a TStream (not just a filename),</p></li>   <li><p>load/save to the default config file location (for user preferences),</p></li>   <li><p>load/save more types (floats, vectors, colors, URLs, multiline text...),</p></li>   <li><p><a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#PathElement\">PathElement</a> and <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#MakePathElement\">MakePathElement</a> utility, to use powerful DOM functions when needed to process something more complex,</p></li>   <li><p>encrypt/descrypt contents, just use BlowFishKeyPhrase property (this is actually built-in in our modified TXMLConfig).</p></li> </ul>  <p>  <p>See <a  href=\"http://castle-engine.sourceforge.net/tutorial_user_prefs.php\">http://castle-engine.sourceforge.net/tutorial_user_prefs.php</a> for more documentation. ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html"},
     {"title": "CastleXMLConfig.TCastleConfig.Create", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#Create"},
     {"title": "CastleXMLConfig.TCastleConfig.Destroy", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#Destroy"},
     {"title": "CastleXMLConfig.TCastleConfig.GetInteger", "text": "      EMissingAttribute If the attribute is missing or empty. EConvertError If the attribute exists but has invalid format.", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetInteger"},
     {"title": "CastleXMLConfig.TCastleConfig.GetBoolean", "text": "      EMissingAttribute If the attribute is missing or empty. EConvertError If the attribute exists but has invalid format.", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetBoolean"},
     {"title": "CastleXMLConfig.TCastleConfig.GetStringNonEmpty", "text": " Value must exist and cannot be empty in XML file.     EMissingAttribute If value doesn't exist or is empty in XML file.", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetStringNonEmpty"},
     {"title": "CastleXMLConfig.TCastleConfig.GetNonEmptyValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetNonEmptyValue"},
     {"title": "CastleXMLConfig.TCastleConfig.GetFloat", "text": "  <p>Note: for powerful reading of float expressions, consider using <code>GetFloatExpression</code> instead of <code><a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#GetFloat\">GetFloat</a></code>. It can read expressions like <code>&quot;3.0 * 2.0&quot;</code> or <code>&quot;sin(2.0)&quot;</code>. Use <a class=\"normal\" href=\"CastleScriptXML.html\">CastleScriptXML</a> unit to introduce necessary class helper for this, see <a class=\"normal\" href=\"CastleScriptXML.TCastleConfigScriptHelper.html#GetFloatExpression\">TCastleConfigScriptHelper.GetFloatExpression</a>.  <p>  <p>    EMissingAttribute Raised by <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#GetFloat\">GetFloat</a>(string) (overloaded version without the ADefaultValue parameter) if the attribute is missing.", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetFloat"},
     {"title": "CastleXMLConfig.TCastleConfig.GetFloat", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetFloat"},
     {"title": "CastleXMLConfig.TCastleConfig.SetFloat", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetFloat"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteFloat", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteFloat"},
     {"title": "CastleXMLConfig.TCastleConfig.GetInt64", "text": "     EMissingAttribute Raised by <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#GetFloat\">GetFloat</a>(string) (overloaded version without the ADefaultValue parameter) if the attribute is missing.", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetInt64"},
     {"title": "CastleXMLConfig.TCastleConfig.GetInt64", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetInt64"},
     {"title": "CastleXMLConfig.TCastleConfig.SetInt64", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetInt64"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteInt64", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteInt64"},
     {"title": "CastleXMLConfig.TCastleConfig.GetVector2", "text": "  <p>They should be expressed in XML like  <p></p>  <pre class=\"preformatted\">&lt;myVector x=&quot;1&quot; y=&quot;2&quot; z=&quot;3&quot; w=&quot;4&quot; /&gt;</pre>  <p>  <p>You can read such vector by  <p></p>  <pre class=\"longcode\">GetVector(<span class=\"pascal_string\">'example/path/to/myVector'</span>, Vector4(<span class=\"pascal_numeric\">0</span>, <span class=\"pascal_numeric\">0</span>, <span class=\"pascal_numeric\">0</span>, <span class=\"pascal_numeric\">0</span>));</pre>  <p>  <p>    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetVector2"},
     {"title": "CastleXMLConfig.TCastleConfig.GetVector2", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetVector2"},
     {"title": "CastleXMLConfig.TCastleConfig.SetVector2", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetVector2"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteVector2", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteVector2"},
     {"title": "CastleXMLConfig.TCastleConfig.GetVector3", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetVector3"},
     {"title": "CastleXMLConfig.TCastleConfig.GetVector3", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetVector3"},
     {"title": "CastleXMLConfig.TCastleConfig.SetVector3", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetVector3"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteVector3", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteVector3"},
     {"title": "CastleXMLConfig.TCastleConfig.GetVector4", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetVector4"},
     {"title": "CastleXMLConfig.TCastleConfig.GetVector4", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetVector4"},
     {"title": "CastleXMLConfig.TCastleConfig.SetVector4", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetVector4"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteVector4", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteVector4"},
     {"title": "CastleXMLConfig.TCastleConfig.GetValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetValue"},
     {"title": "CastleXMLConfig.TCastleConfig.SetValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetValue"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteValue"},
     {"title": "CastleXMLConfig.TCastleConfig.GetValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetValue"},
     {"title": "CastleXMLConfig.TCastleConfig.SetValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetValue"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteValue"},
     {"title": "CastleXMLConfig.TCastleConfig.GetValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetValue"},
     {"title": "CastleXMLConfig.TCastleConfig.SetValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetValue"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteValue", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteValue"},
     {"title": "CastleXMLConfig.TCastleConfig.GetColorRGB", "text": "  <p>This is very similar to 3D / 4D vector reading/writing to config file, however  <p></p>  <ol class=\"compact_spacing\">   <li value=\"1\"><p>attribute names are better for colors (<i>red, green, blue, alpha</i> instead of <i>x, y, z, w</i>),</p></li>   <li value=\"2\"><p>we allow alternative color specification as hex.</p></li>   <li value=\"3\"><p>and we limit component values to 0..1 range.</p></li> </ol>  <p>  <p>They should be expressed in XML like  <p></p>  <pre class=\"preformatted\"> &lt;myColor red=&quot;1&quot; green=&quot;0.5&quot; blue=&quot;0.25&quot; alpha=&quot;1&quot; /&gt; &lt;myColorRGB red=&quot;1&quot; green=&quot;0.5&quot; blue=&quot;0.25&quot; /&gt;</pre>  <p>  <p>or as hex colors (see <a class=\"normal\" href=\"CastleColors.html#HexToColor\">HexToColor</a>) like  <p></p>  <pre class=\"preformatted\"> &lt;myColor hex=&quot;ff804011&quot; /&gt; &lt;myColorRGB hex=&quot;ff8040&quot; /&gt;</pre>  <p>  <p>You can read such colors by  <p></p>  <pre class=\"longcode\"> Color := GetColor(<span class=\"pascal_string\">'example/path/to/myColor'</span>, Black); ColorRGB := GetColorRGB(<span class=\"pascal_string\">'example/path/to/myColorRGB'</span>, BlackRGB);</pre>  <p>  <p>    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetColorRGB"},
     {"title": "CastleXMLConfig.TCastleConfig.GetColorRGB", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetColorRGB"},
     {"title": "CastleXMLConfig.TCastleConfig.SetColorRGB", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetColorRGB"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteColorRGB", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteColorRGB"},
     {"title": "CastleXMLConfig.TCastleConfig.GetColor", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetColor"},
     {"title": "CastleXMLConfig.TCastleConfig.GetColor", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetColor"},
     {"title": "CastleXMLConfig.TCastleConfig.SetColor", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetColor"},
     {"title": "CastleXMLConfig.TCastleConfig.SetDeleteColor", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SetDeleteColor"},
     {"title": "CastleXMLConfig.TCastleConfig.PathElement", "text": " This is useful if you want to mix XMLConfig style operations on the file and then use some real DOM functions to more directly operate/read on XML document.  <p>Note that for paths that you pass to various <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#SetValue\">SetValue</a> / <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#SetColor\">SetColor</a> / <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#SetFloat\">SetFloat</a> / SetVector versions, the last path component is the attribute name. You do not pass this here. Path passed here should end with the name of final element.  <p>Path passed here may but doesn't have to be terminated by a final slash. In fact, for now the path is just splitted using slash character as a separator, so a path like <code>/some////path/</code> is equivalent to a path like (some/path). But don't depend on this behavior.  <p>If there is no such element: when RaiseExceptionWhenMissing=<code>True</code>, raises exception. when RaiseExceptionWhenMissing=<code>False</code>, returns <code>Nil</code>.  <p>Remember that XMLConfig idea of XML document is limited. That's intentional (XMLConfig is supposed to offer only a simple limited XML access), and this means that some XML trees may confuse XMLConfig. For example, if there are two elements with the same TagName as a children of the same element: XMLConfig will (probably ?) just always ignore the second one. Which means that if you use this method to change some XML content, you should be careful when accessing this content from regular XMLConfig <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#GetValue\">GetValue</a> / <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#SetValue\">SetValue</a> methods.  <p>Note that if you modify the DOM contents this way, you must manually call <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#MarkModified\">MarkModified</a> afterwards, to make sure it will get saved later.    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#PathElement"},
     {"title": "CastleXMLConfig.TCastleConfig.MakePathElement", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#MakePathElement"},
     {"title": "CastleXMLConfig.TCastleConfig.PathChildren", "text": " For example, you have an XML like this:  <p></p>  <pre class=\"preformatted\"> &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;CONFIG&gt;   &lt;game_configuration&gt;     &lt;locations&gt;       &lt;location name=&quot;location_1st&quot;&gt;...&lt;/location&gt;       &lt;location name=&quot;location_2nd&quot;&gt;...&lt;/location&gt;     &lt;/locations&gt;   &lt;/game_configuration&gt; &lt;/CONFIG&gt;</pre>  <p>  <p>You could use <code><a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#PathElement\">PathElement</a>('game_configuration/locations')</code> to get the <code>&lt;locations&gt;</code> DOM element. Or you could use this method <code><code>PathChildren</code>('game_configuration/locations', 'location')</code> to get a list of &lt;location&gt; elements.  <p>Raises exception if element indicated by APath does not exist. (But it is OK if it is empty.) Never returns <code>Nil</code>.    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#PathChildren"},
     {"title": "CastleXMLConfig.TCastleConfig.PathChildrenIterator", "text": "  <p>For example, assume you have an XML like this:  <p></p>  <pre class=\"preformatted\"> &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;CONFIG&gt;   &lt;game_configuration&gt;     &lt;locations&gt;       &lt;location name=&quot;location_1st&quot;&gt;...&lt;/location&gt;       &lt;location name=&quot;location_2nd&quot;&gt;...&lt;/location&gt;     &lt;/locations&gt;   &lt;/game_configuration&gt; &lt;/CONFIG&gt;</pre>  <p>  <p>You can process it like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   I: TXMLElementIterator; <span class=\"pascal_keyword\">begin</span>   I := PathChildrenIterator(<span class=\"pascal_string\">'game_configuration/locations'</span>, <span class=\"pascal_string\">'location'</span>);   <span class=\"pascal_keyword\">try</span>     <span class=\"pascal_keyword\">while</span> I.GetNext <span class=\"pascal_keyword\">do</span>     <span class=\"pascal_keyword\">begin</span>       <span class=\"pascal_comment\">// ... here goes your code to process I.Current ...</span>     <span class=\"pascal_keyword\">end</span>;   <span class=\"pascal_keyword\">finally</span> FreeAndNil(I) <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>Raises exception if element indicated by APath does not exist. (But it is OK if it is empty.) Never returns <code>Nil</code>.    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#PathChildrenIterator"},
     {"title": "CastleXMLConfig.TCastleConfig.GetURL", "text": " The attribute in an XML file may be an absolute or relative URL, (we will look at own TXMLConfig.FileName directory to resolve relative URLs). The returned URL is always an absolute URL.  <p>If EmptyIfNoAttribute, then this will just set URL to '' if appropriate XML attribute not found. Otherwise (when EmptyIfNoAttribute = <code>False</code>, this is default), error will be raised.  <p>    EMissingAttribute If EmptyIfNoAttribute = <code>False</code> and no such attribute.", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetURL"},
     {"title": "CastleXMLConfig.TCastleConfig.GetMultilineText", "text": " The text may be multiline, line endings are guaranteed to be converted to current OS newlines.    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetMultilineText"},
     {"title": "CastleXMLConfig.TCastleConfig.GetMultilineText", "text": " The text may be multiline, line endings are guaranteed to be converted to current OS newlines.    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#GetMultilineText"},
     {"title": "CastleXMLConfig.TCastleConfig.NotModified", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#NotModified"},
     {"title": "CastleXMLConfig.TCastleConfig.MarkModified", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#MarkModified"},
     {"title": "CastleXMLConfig.TCastleConfig.AddLoadListener", "text": "  <p><b>If the config file is already loaded when you call <code>AddLoadListener</code>, then the Listener is called immediately.</b> This is useful to make sure that Listener is always called, regardless of the order. (Regardless if you call Config.Load or Config.AddLoadListener first.)  <p>    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#AddLoadListener"},
     {"title": "CastleXMLConfig.TCastleConfig.AddSaveListener", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#AddSaveListener"},
     {"title": "CastleXMLConfig.TCastleConfig.RemoveLoadListener", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#RemoveLoadListener"},
     {"title": "CastleXMLConfig.TCastleConfig.RemoveSaveListener", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#RemoveSaveListener"},
     {"title": "CastleXMLConfig.TCastleConfig.Load", "text": "  <p>All these methods call the listeners (from <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#AddLoadListener\">AddLoadListener</a>). All these methods update the <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#Loaded\">Loaded</a> property and the URL property. All these methods are secured to never raise exception in case of a currupted config file &ndash; in this case, they silently load an empty config (but keep the new URL, so that following <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#Save\">Save</a> call with overwrite the config location with a good save.)  <p><i>Never call the ancestor load / save methods, like TXMLConfig.LoadFromStream and TXMLConfig.SaveToStream, to be on the safe side. Use the methods below to load / save user config.</i>  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>The overloaded <code>Load</code> parameter-less version chooses a default filename for storing application user preferences.  <p>It uses ApplicationName to pick a filename that is unique to your application. Usually you want to assign <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#ApplicationName\">ApplicationProperties.ApplicationName</a>, unless you're fine with the default name derived from ParamStr(0).  <p>It uses <a class=\"normal\" href=\"CastleFilesUtils.html#ApplicationConfig\">ApplicationConfig</a> to determine location of this file.</p></li>   <li><p>The overloaded <code>Load</code> version with URL sets <code>TXMLConfig.URL</code>, loading the file from given URL. As always, URL may be just a simple filename, to just load a file from the local filesystem. It can also be a full-blown URL, with a '<a  href=\"file://\">file://</a>' protocol, or '<a  href=\"http://\">http://</a>', or other supported protocols, see <a  href=\"http://castle-engine.sourceforge.net/tutorial_network.php\">http://castle-engine.sourceforge.net/tutorial_network.php</a> </p></li>   <li><p>The overloaded <code>Load</code> version with TStream loads from a stream. URL is set to PretendURL (just pass empty string if you don't need to be able to save it back).</p></li> </ul>  <p>  <p>    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#Load"},
     {"title": "CastleXMLConfig.TCastleConfig.Load", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#Load"},
     {"title": "CastleXMLConfig.TCastleConfig.Load", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#Load"},
     {"title": "CastleXMLConfig.TCastleConfig.LoadFromString", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#LoadFromString"},
     {"title": "CastleXMLConfig.TCastleConfig.Save", "text": " Calls all the listeners (registered by <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#AddSaveListener\">AddSaveListener</a>).  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>The overloaded parameter-less version flushes the changes to disk, thus saving them back to the file from which they were read (in <code>TXMLConfig.URL</code> property).</p></li>   <li><p>The overloaded version with TStream parameter saves to a stream. If does not use inherited Flush method, instead it always unconditionally dumps contents to stream.</p></li> </ul>  <p>  <p>    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#Save"},
     {"title": "CastleXMLConfig.TCastleConfig.Save", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#Save"},
     {"title": "CastleXMLConfig.TCastleConfig.SaveToString", "text": "    ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#SaveToString"},
     {"title": "CastleXMLConfig.TCastleConfig.Loaded", "text": " ", "tags": "", "loc": "CastleXMLConfig.TCastleConfig.html#Loaded"},
     {"title": "CastleXMLConfig.Register", "text": "    ", "tags": "", "loc": "CastleXMLConfig.html#Register"},
     {"title": "CastleXMLConfig.TCastleConfigEvent", "text": "    ", "tags": "", "loc": "CastleXMLConfig.html#TCastleConfigEvent"},
     {"title": "CastleXMLUtils", "text": " ", "tags": "", "loc": "CastleXMLUtils.html"},
     {"title": "CastleXMLUtils.EDOMAttributeMissing", "text": " ", "tags": "", "loc": "CastleXMLUtils.EDOMAttributeMissing.html"},
     {"title": "CastleXMLUtils.EDOMChildElementError", "text": " ", "tags": "", "loc": "CastleXMLUtils.EDOMChildElementError.html"},
     {"title": "CastleXMLUtils.TDOMNodeHelper", "text": " ", "tags": "", "loc": "CastleXMLUtils.TDOMNodeHelper.html"},
     {"title": "CastleXMLUtils.TDOMNodeHelper.NodeName8", "text": " Expressed as an 8-bit string (in UTF-8 encoding), contrary to the NodeName from FPC DOM unit that is a WideString (DOMString).    ", "tags": "", "loc": "CastleXMLUtils.TDOMNodeHelper.html#NodeName8"},
     {"title": "CastleXMLUtils.TDOMNodeHelper.NodeValue8", "text": " Expressed as an 8-bit string (in UTF-8 encoding), contrary to the NodeValue from FPC DOM unit that is a WideString (DOMString). ", "tags": "", "loc": "CastleXMLUtils.TDOMNodeHelper.html#NodeValue8"},
     {"title": "CastleXMLUtils.TDOMCharacterDataHelper", "text": " ", "tags": "", "loc": "CastleXMLUtils.TDOMCharacterDataHelper.html"},
     {"title": "CastleXMLUtils.TDOMCharacterDataHelper.Data8", "text": " Expressed as an 8-bit string (in UTF-8 encoding), contrary to the Data from FPC DOM unit that is a WideString (DOMString).    ", "tags": "", "loc": "CastleXMLUtils.TDOMCharacterDataHelper.html#Data8"},
     {"title": "CastleXMLUtils.TDOMElementHelper", "text": " ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeString", "text": " Value is a &quot;var&quot;, not &quot;out&quot; param, because in the latter case it's guaranteed that the old Value will not be cleared.  <p>Note that the returned Value may be empty, even when this returns <code>True</code>, if the value is explicitly set to empty in XML (by <code>xxx=&quot;&quot;</code> in XML).    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeString"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeURL", "text": "  <p>Returned URL is always absolute. The value in file may be a relative URL, it is resolved with respect to BaseUrl, that must be absolute.    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeURL"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeCardinal", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeCardinal"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeInteger", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeInteger"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeInt64", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeInt64"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeSingle", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeSingle"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeFloat", "text": "  <p>Note: for powerful reading of float expressions, consider using <code>AttributeFloatExpression</code> instead of <code><a class=\"normal\" href=\"CastleXMLUtils.TDOMElementHelper.html#AttributeFloat\">AttributeFloat</a></code>. It can read expressions like <code>&quot;3.0 * 2.0&quot;</code> or <code>&quot;sin(2.0)&quot;</code>. Use <a class=\"normal\" href=\"CastleScriptXML.html\">CastleScriptXML</a> unit to introduce necessary class helper for this, see <a class=\"normal\" href=\"CastleScriptXML.TDOMElementScriptHelper.html#AttributeFloatExpression\">TDOMElementScriptHelper.AttributeFloatExpression</a>.    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeFloat"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeBoolean", "text": "  <p>A boolean value is interpreted just like FPC's TXMLConfig objects: true is designated by word <code>true</code>, false by word <code>false</code>, case is ignored. If attribute exists but it's value is not <code>true</code> or <code>false</code>, then returns <code>False</code> and doesn't modify Value paramater. So behaves just like the attribute didn't exist.    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeBoolean"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeColor", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeColor"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeColorRGB", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeColorRGB"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeVector2", "text": "  <p>    EConvertError If the attribute exists in XML, but has invalid format.", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeVector2"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeVector3", "text": "  <p>    EConvertError If the attribute exists in XML, but has invalid format.", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeVector3"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeString", "text": "  <p>Note that the attribute is required, but it's value may still be empty if it's explicitly set to empty in XML (by <code>xxx=&quot;&quot;</code> in XML). This is different than <a class=\"normal\" href=\"CastleXMLConfig.TCastleConfig.html#GetStringNonEmpty\">TCastleConfig.GetStringNonEmpty</a> method, that serves a similar purpose for <a class=\"normal\" href=\"CastleConfig.html#TCastleConfig\">TCastleConfig</a>, but it requires <i>non-empty value</i> exists. Here, we only require that the value exists, but it may still be empty.  <p>    EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeString"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeURL", "text": " Returned URL is always absolute. The value in file may be a relative URL, it is resolved with respect to BaseUrl, that must be absolute.     EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeURL"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeCardinal", "text": "     EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeCardinal"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeInteger", "text": "     EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeInteger"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeInt64", "text": "     EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeInt64"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeSingle", "text": "     EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeSingle"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeFloat", "text": "  <p>Note: for powerful reading of float expressions, consider using <code>AttributeFloatExpression</code> instead of <code><code>AttributeFloat</code></code>. It can read expressions like <code>&quot;3.0 * 2.0&quot;</code> or <code>&quot;sin(2.0)&quot;</code>. Use <a class=\"normal\" href=\"CastleScriptXML.html\">CastleScriptXML</a> unit to introduce necessary class helper for this, see <a class=\"normal\" href=\"CastleScriptXML.TDOMElementScriptHelper.html#AttributeFloatExpression\">TDOMElementScriptHelper.AttributeFloatExpression</a>.  <p>    EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeFloat"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeBoolean", "text": " A boolean value is interpreted just like FPC's TXMLConfig objects: true is designated by word <code>true</code>, false by word <code>false</code>, case is ignored.  <p>If attribute exists but it's value is not <code>true</code> or <code>false</code>, then raises <a class=\"normal\" href=\"CastleXMLUtils.EDOMAttributeMissing.html\">EDOMAttributeMissing</a>. So behaves just like the attribute didn't exist.  <p>    EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeBoolean"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeColor", "text": "     EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeColor"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeColorRGB", "text": "     EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeColorRGB"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeVector2", "text": "     EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeVector2"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeVector3", "text": "     EDOMAttributeMissing ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeVector3"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeStringDef", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeStringDef"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeCardinalDef", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeCardinalDef"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeIntegerDef", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeIntegerDef"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeInt64Def", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeInt64Def"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeSingleDef", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeSingleDef"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeFloatDef", "text": "  <p>Note: for powerful reading of float expressions, consider using <code>AttributeFloatExpressionDef</code> instead of <code><code>AttributeFloatDef</code></code>. It can read expressions like <code>&quot;3.0 * 2.0&quot;</code> or <code>&quot;sin(2.0)&quot;</code>. Use <a class=\"normal\" href=\"CastleScriptXML.html\">CastleScriptXML</a> unit to introduce necessary class helper for this, see <a class=\"normal\" href=\"CastleScriptXML.TDOMElementScriptHelper.html#AttributeFloatExpressionDef\">TDOMElementScriptHelper.AttributeFloatExpressionDef</a>.    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeFloatDef"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeBooleanDef", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeBooleanDef"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeColorDef", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeColorDef"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeColorRGBDef", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeColorRGBDef"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeVector2Def", "text": "     EConvertError If the value exists in XML, but has invalid format.", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeVector2Def"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeVector3Def", "text": "     EConvertError If the value exists in XML, but has invalid format.", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeVector3Def"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeSet", "text": " Equivalent to standard SetAttribute in DOM unit, but provided here for consistency with other <a class=\"normal\" href=\"CastleXMLUtils.TDOMElementHelper.html#AttributeSet\">AttributeSet</a> overloads.    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeSet"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeSet", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeSet"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeSet", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeSet"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeSet", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeSet"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeSet", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeSet"},
     {"title": "CastleXMLUtils.TDOMElementHelper.AttributeSet", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#AttributeSet"},
     {"title": "CastleXMLUtils.TDOMElementHelper.ChildElement", "text": "  <p>For example use <code>LevelElement.ChildElement('items')</code> to get the &lt;items&gt; element within &lt;level&gt; element, as in example below.  <p></p>  <pre class=\"preformatted\"> &lt;level&gt;   &lt;creatures&gt;     ...   &lt;/creatures&gt;   &lt;items&gt;     ...   &lt;/items&gt; &lt;/level&gt;</pre>  <p>  <p>There must be <b>one and only one child element with this name</b>. In case there's zero, or more than one such element, we will raise <a class=\"normal\" href=\"CastleXMLUtils.EDOMChildElementError.html\">EDOMChildElementError</a> (if Required is <code>True</code>, default) or return <code>Nil</code> (if Required is <code>False</code>).  <p>    EDOMChildElementError If child not found (or found more than once), and Required = <code>True</code>.", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#ChildElement"},
     {"title": "CastleXMLUtils.TDOMElementHelper.ChildrenIterator", "text": " Use like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   I: TXMLElementIterator; <span class=\"pascal_keyword\">begin</span>   I := Element.ChildrenIterator;   <span class=\"pascal_keyword\">try</span>     <span class=\"pascal_keyword\">while</span> I.GetNext <span class=\"pascal_keyword\">do</span>     <span class=\"pascal_keyword\">begin</span>       <span class=\"pascal_comment\">// ... here goes your code to process I.Current ...</span>     <span class=\"pascal_keyword\">end</span>;   <span class=\"pascal_keyword\">finally</span> FreeAndNil(I) <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p>    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#ChildrenIterator"},
     {"title": "CastleXMLUtils.TDOMElementHelper.ChildrenIterator", "text": " Use like this:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   I: TXMLElementIterator; <span class=\"pascal_keyword\">begin</span>   I := Element.ChildrenIterator(<span class=\"pascal_string\">'item'</span>);   <span class=\"pascal_keyword\">try</span>     <span class=\"pascal_keyword\">while</span> I.GetNext <span class=\"pascal_keyword\">do</span>     <span class=\"pascal_keyword\">begin</span>       <span class=\"pascal_comment\">// ... here goes your code to process I.Current ...</span>     <span class=\"pascal_keyword\">end</span>;   <span class=\"pascal_keyword\">finally</span> FreeAndNil(I) <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p>    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#ChildrenIterator"},
     {"title": "CastleXMLUtils.TDOMElementHelper.TextData", "text": "  <p>This is suitable if an element is supposed to contain only some text. Like <code>&lt;some_value&gt;This is a text inside.&lt;/some_value&gt;</code>. It raises an error if an element contains anything else as child.  <p>If there are no text data nodes, e.g. if the element is empty, it returns empty string without raising any error.    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#TextData"},
     {"title": "CastleXMLUtils.TDOMElementHelper.TagName8", "text": " Expressed as an 8-bit string (in UTF-8 encoding), contrary to the TagName from FPC DOM unit that is a WideString (DOMString).    ", "tags": "", "loc": "CastleXMLUtils.TDOMElementHelper.html#TagName8"},
     {"title": "CastleXMLUtils.TXMLElementIterator", "text": "  <p>Without this, typical iteration looks like  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   <span class=\"pascal_keyword\">Index</span>: Integer;   ChildrenList: TDOMNodeList;   ChildNode: TDOMNode;   ChildElement: TDOMElement; <span class=\"pascal_keyword\">begin</span>   ChildrenList := Element.ChildNodes;    <span class=\"pascal_keyword\">for</span> <span class=\"pascal_keyword\">Index</span> := <span class=\"pascal_numeric\">0</span> <span class=\"pascal_keyword\">to</span> ChildrenList.Count - <span class=\"pascal_numeric\">1</span> <span class=\"pascal_keyword\">do</span>   <span class=\"pascal_keyword\">begin</span>     ChildNode := ChildrenList.Item[<span class=\"pascal_keyword\">Index</span>];     <span class=\"pascal_keyword\">if</span> ChildNode.NodeType = ELEMENT_NODE <span class=\"pascal_keyword\">then</span>     <span class=\"pascal_keyword\">begin</span>       ChildElement := ChildNode <span class=\"pascal_keyword\">as</span> TDOMElement;       <span class=\"pascal_numeric\"></span>... here goes your code <span class=\"pascal_keyword\">to</span> process ChildElement <span class=\"pascal_numeric\"></span>...     <span class=\"pascal_keyword\">end</span>;   <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>... which is an easy code, but it becomes tiresome to write this over and over again, especially for units that heavily process XML (like X3D XML or Collada readers). So this class allows you to write instead  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   I: TXMLElementIterator; <span class=\"pascal_keyword\">begin</span>   I := Element.ChildrenIterator;   <span class=\"pascal_keyword\">try</span>     <span class=\"pascal_keyword\">while</span> I.GetNext <span class=\"pascal_keyword\">do</span>     <span class=\"pascal_keyword\">begin</span>       <span class=\"pascal_numeric\"></span>... here goes your code <span class=\"pascal_keyword\">to</span> process I.Current <span class=\"pascal_numeric\"></span>...     <span class=\"pascal_keyword\">end</span>;   <span class=\"pascal_keyword\">finally</span> FreeAndNil(I) <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p> ", "tags": "", "loc": "CastleXMLUtils.TXMLElementIterator.html"},
     {"title": "CastleXMLUtils.TXMLElementIterator.Create", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TXMLElementIterator.html#Create"},
     {"title": "CastleXMLUtils.TXMLElementIterator.GetNext", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TXMLElementIterator.html#GetNext"},
     {"title": "CastleXMLUtils.TXMLElementIterator.Rewind", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TXMLElementIterator.html#Rewind"},
     {"title": "CastleXMLUtils.TXMLElementIterator.Count", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TXMLElementIterator.html#Count"},
     {"title": "CastleXMLUtils.TXMLElementIterator.Current", "text": " ", "tags": "", "loc": "CastleXMLUtils.TXMLElementIterator.html#Current"},
     {"title": "CastleXMLUtils.TXMLElementFilteringIterator", "text": " ", "tags": "", "loc": "CastleXMLUtils.TXMLElementFilteringIterator.html"},
     {"title": "CastleXMLUtils.TXMLElementFilteringIterator.Create", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TXMLElementFilteringIterator.html#Create"},
     {"title": "CastleXMLUtils.TXMLElementFilteringIterator.GetNext", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TXMLElementFilteringIterator.html#GetNext"},
     {"title": "CastleXMLUtils.TXMLCDataIterator", "text": "  <p>Simple usage:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">var</span>   I: TXMLCDataIterator; <span class=\"pascal_keyword\">begin</span>   I := TXMLCDataIterator.Create(Element);   <span class=\"pascal_keyword\">try</span>     <span class=\"pascal_keyword\">while</span> I.GetNext <span class=\"pascal_keyword\">do</span>     <span class=\"pascal_keyword\">begin</span>       <span class=\"pascal_numeric\"></span>... here goes your code <span class=\"pascal_keyword\">to</span> process I.Current <span class=\"pascal_numeric\"></span>...     <span class=\"pascal_keyword\">end</span>;   <span class=\"pascal_keyword\">finally</span> FreeAndNil(I) <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p> ", "tags": "", "loc": "CastleXMLUtils.TXMLCDataIterator.html"},
     {"title": "CastleXMLUtils.TXMLCDataIterator.Create", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TXMLCDataIterator.html#Create"},
     {"title": "CastleXMLUtils.TXMLCDataIterator.Destroy", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TXMLCDataIterator.html#Destroy"},
     {"title": "CastleXMLUtils.TXMLCDataIterator.GetNext", "text": "    ", "tags": "", "loc": "CastleXMLUtils.TXMLCDataIterator.html#GetNext"},
     {"title": "CastleXMLUtils.TXMLCDataIterator.Current", "text": " ", "tags": "", "loc": "CastleXMLUtils.TXMLCDataIterator.html#Current"},
     {"title": "CastleXMLUtils.DOMGetAttribute", "text": " Value is a &quot;var&quot;, not &quot;out&quot; param, because in the latter case it's guaranteed that the old Value will not be cleared.  <p> Deprecated, use Element.AttributeString instead.    ", "tags": "", "loc": "CastleXMLUtils.html#DOMGetAttribute"},
     {"title": "CastleXMLUtils.DOMGetCardinalAttribute", "text": "  <p> Deprecated, use Element.AttributeCardinal instead.    ", "tags": "", "loc": "CastleXMLUtils.html#DOMGetCardinalAttribute"},
     {"title": "CastleXMLUtils.DOMGetIntegerAttribute", "text": "  <p> Deprecated, use Element.AttributeInteger instead.    ", "tags": "", "loc": "CastleXMLUtils.html#DOMGetIntegerAttribute"},
     {"title": "CastleXMLUtils.DOMGetSingleAttribute", "text": "  <p> Deprecated, use Element.AttributeSingle instead.    ", "tags": "", "loc": "CastleXMLUtils.html#DOMGetSingleAttribute"},
     {"title": "CastleXMLUtils.DOMGetFloatAttribute", "text": "  <p> Deprecated, use Element.AttributeFloat instead.    ", "tags": "", "loc": "CastleXMLUtils.html#DOMGetFloatAttribute"},
     {"title": "CastleXMLUtils.DOMGetBooleanAttribute", "text": " A boolean value is interpreted just like FPC's TXMLConfig objects: true is designated by word <code>true</code>, false by word <code>false</code>, case is ignored.  <p>If attribute exists but it's value is not <code>true</code> or <code>false</code>, then returns <code>False</code> and doesn't modify Value paramater. So behaves just like the attribute didn't exist.  <p> Deprecated, use Element.AttributeBoolean instead.    ", "tags": "", "loc": "CastleXMLUtils.html#DOMGetBooleanAttribute"},
     {"title": "CastleXMLUtils.DOMGetOneChildElement", "text": " If given Element has none or more than one child elements, returns <code>Nil</code>. This is handy for parsing XML in cases when you know that given element must contain exactly one other element in correct XML file.    ", "tags": "", "loc": "CastleXMLUtils.html#DOMGetOneChildElement"},
     {"title": "CastleXMLUtils.DOMGetChildElement", "text": "    ", "tags": "", "loc": "CastleXMLUtils.html#DOMGetChildElement"},
     {"title": "CastleXMLUtils.DOMGetTextData", "text": "    ", "tags": "", "loc": "CastleXMLUtils.html#DOMGetTextData"},
     {"title": "CastleXMLUtils.DOMGetTextChild", "text": "  <p>This is just a shortcut for <code><a class=\"normal\" href=\"CastleXMLUtils.html#DOMGetTextData\">DOMGetTextData</a>(<a class=\"normal\" href=\"CastleXMLUtils.html#DOMGetChildElement\">DOMGetChildElement</a>(Element, ChildName, true))</code>.  <p>    EDOMChildElementError If child not found or found more than once and RaiseOnError", "tags": "", "loc": "CastleXMLUtils.html#DOMGetTextChild"},
     {"title": "CastleXMLUtils.FreeChildNodes", "text": "  <p>This abstracts FPC DOM unit differences: </p>  <ul class=\"paragraph_spacing\">   <li><p> For FPC &lt;= 2.2.x, it was needed to call ChildNodes.Release when you're done with them.</p></li>   <li><p> In newer FPC, you do not have to free nodes at all (since FPC rev 13143), and their Release method doesn't exist (since rev 13113).</p></li> </ul>  <p>    ", "tags": "", "loc": "CastleXMLUtils.html#FreeChildNodes"},
     {"title": "CastleXMLUtils.URLReadXML", "text": " Optionally they can encrypt / decrypt content using BlowFish.     ", "tags": "", "loc": "CastleXMLUtils.html#URLReadXML"},
     {"title": "CastleXMLUtils.URLReadXML", "text": "    ", "tags": "", "loc": "CastleXMLUtils.html#URLReadXML"},
     {"title": "CastleXMLUtils.URLReadXML", "text": "    ", "tags": "", "loc": "CastleXMLUtils.html#URLReadXML"},
     {"title": "CastleXMLUtils.URLReadXML", "text": "    ", "tags": "", "loc": "CastleXMLUtils.html#URLReadXML"},
     {"title": "CastleXMLUtils.URLWriteXML", "text": "    ", "tags": "", "loc": "CastleXMLUtils.html#URLWriteXML"},
     {"title": "CastleXMLUtils.URLWriteXML", "text": "    ", "tags": "", "loc": "CastleXMLUtils.html#URLWriteXML"},
     {"title": "X3DCameraUtils", "text": "  ", "tags": "", "loc": "X3DCameraUtils.html"},
     {"title": "X3DCameraUtils.DefaultX3DCameraPosition", "text": "  ", "tags": "", "loc": "X3DCameraUtils.html#DefaultX3DCameraPosition"},
     {"title": "X3DCameraUtils.DefaultX3DCameraDirection", "text": " ", "tags": "", "loc": "X3DCameraUtils.html#DefaultX3DCameraDirection"},
     {"title": "X3DCameraUtils.DefaultX3DCameraUp", "text": " ", "tags": "", "loc": "X3DCameraUtils.html#DefaultX3DCameraUp"},
     {"title": "X3DCameraUtils.DefaultX3DGravityUp", "text": " ", "tags": "", "loc": "X3DCameraUtils.html#DefaultX3DGravityUp"},
     {"title": "X3DCameraUtils.MakeCameraStr", "text": "    ", "tags": "", "loc": "X3DCameraUtils.html#MakeCameraStr"},
     {"title": "X3DCameraUtils.MakeCameraNode", "text": "  <p>Overloaded version with ViewpointNode parameter returns the <a class=\"normal\" href=\"X3DNodes.TAbstractViewpointNode.html\">TAbstractViewpointNode</a> descendant that is (somewhere within) the returned node.    ", "tags": "", "loc": "X3DCameraUtils.html#MakeCameraNode"},
     {"title": "X3DCameraUtils.MakeCameraNode", "text": "    ", "tags": "", "loc": "X3DCameraUtils.html#MakeCameraNode"},
     {"title": "X3DCameraUtils.CameraNodeForWholeScene", "text": "    ", "tags": "", "loc": "X3DCameraUtils.html#CameraNodeForWholeScene"},
     {"title": "X3DCameraUtils.MakeCameraNavNode", "text": "    ", "tags": "", "loc": "X3DCameraUtils.html#MakeCameraNavNode"},
     {"title": "X3DCameraUtils.TX3DCameraVersion", "text": "  cvVrml1_Inventor    cvVrml2_X3d   ", "tags": "", "loc": "X3DCameraUtils.html#TX3DCameraVersion"},
     {"title": "X3DCastleScript", "text": " ", "tags": "", "loc": "X3DCastleScript.html"},
     {"title": "X3DCastleScript.TCasScriptX3DValueList", "text": " ", "tags": "", "loc": "X3DCastleScript.TCasScriptX3DValueList.html"},
     {"title": "X3DCastleScript.TCasScriptX3DValueList.Create", "text": "    ", "tags": "", "loc": "X3DCastleScript.TCasScriptX3DValueList.html#Create"},
     {"title": "X3DCastleScript.TCasScriptX3DValueList.Destroy", "text": "    ", "tags": "", "loc": "X3DCastleScript.TCasScriptX3DValueList.html#Destroy"},
     {"title": "X3DCastleScript.TCasScriptX3DValueList.Add", "text": " FieldOrEvent is added to <a class=\"normal\" href=\"X3DCastleScript.TCasScriptX3DValueList.html#FieldOrEvents\">FieldOrEvents</a> list, so we keep all information.    ", "tags": "", "loc": "X3DCastleScript.TCasScriptX3DValueList.html#Add"},
     {"title": "X3DCastleScript.TCasScriptX3DValueList.BeforeExecute", "text": "    ", "tags": "", "loc": "X3DCastleScript.TCasScriptX3DValueList.html#BeforeExecute"},
     {"title": "X3DCastleScript.TCasScriptX3DValueList.AfterExecute", "text": "    ", "tags": "", "loc": "X3DCastleScript.TCasScriptX3DValueList.html#AfterExecute"},
     {"title": "X3DCastleScript.TCasScriptX3DValueList.ResetLastEventTimes", "text": " For each script output-capable field (inputOutput or outputOnly) on this list, we keep track of when it last generated an event.  <p>This is needed to avoid loops.  <p><i>Some background info why this is needed:</i>  <p>X3D spec says (4.4.8.3 Execution model): Nodes that contain output events shall produce at most one event per field per timestamp. [...] This also applies to scripts.  <p>&quot;[...]&quot; above talks about ROUTE breaking rule, we handle this generally in <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html\">TX3DRoute</a>. The trouble with script is that it can make loops even without the help of ROUTEs: script receives it's inputs, and sends it's outputs, so when you send an output that causes your own input you made a loop... The most trivial example of this is when on receiving inputOutput you will set the very same inputOutput field, thus making a loop.  <p>Scripts with directOutput (although not implemented yet) can cause even more trouble, as you can generate input event on another node that will get back to you. If two scripts generate events on each other, this can again make a loop, without the help of ROUTEs.  <p>So we have to secure against this. This is done pretty much like with ROUTEs: we just remember the last timestamp, and ignore sending events again.    ", "tags": "", "loc": "X3DCastleScript.TCasScriptX3DValueList.html#ResetLastEventTimes"},
     {"title": "X3DCastleScript.TCasScriptX3DValueList.FieldOrEvents", "text": " This list is read-only (use <a class=\"normal\" href=\"X3DCastleScript.TCasScriptX3DValueList.html#Add\">Add</a> to add here). It always has the same Count as our own count. ", "tags": "", "loc": "X3DCastleScript.TCasScriptX3DValueList.html#FieldOrEvents"},
     {"title": "X3DCastleScript.X3DCasScriptCreateValue", "text": "    ", "tags": "", "loc": "X3DCastleScript.html#X3DCasScriptCreateValue"},
     {"title": "X3DCastleScript.X3DCasScriptBeforeExecute", "text": " This resets ValueAssigned (will be used in AfterExecute), and sets current variable's value from FieldOrEvent (if this is a field).    ", "tags": "", "loc": "X3DCastleScript.html#X3DCasScriptBeforeExecute"},
     {"title": "X3DCastleScript.X3DCasScriptAfterExecute", "text": " This checks ValueAssigned, and propagates value change to appropriate field/event, sending event/setting field.    ", "tags": "", "loc": "X3DCastleScript.html#X3DCasScriptAfterExecute"},
     {"title": "X3DFields", "text": " ", "tags": "", "loc": "X3DFields.html"},
     {"title": "X3DFields.EX3DError", "text": " ", "tags": "", "loc": "X3DFields.EX3DError.html"},
     {"title": "X3DFields.EX3DFieldAssign", "text": " ", "tags": "", "loc": "X3DFields.EX3DFieldAssign.html"},
     {"title": "X3DFields.EX3DFieldAssignInvalidClass", "text": " ", "tags": "", "loc": "X3DFields.EX3DFieldAssignInvalidClass.html"},
     {"title": "X3DFields.EX3DNotFound", "text": " ", "tags": "", "loc": "X3DFields.EX3DNotFound.html"},
     {"title": "X3DFields.TX3DWriter", "text": " ", "tags": "", "loc": "X3DFields.TX3DWriter.html"},
     {"title": "X3DFields.TX3DWriter.Version", "text": " Read-only after creation. ", "tags": "", "loc": "X3DFields.TX3DWriter.html#Version"},
     {"title": "X3DFields.TX3DWriter.Create", "text": "    ", "tags": "", "loc": "X3DFields.TX3DWriter.html#Create"},
     {"title": "X3DFields.TX3DWriter.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TX3DWriter.html#Destroy"},
     {"title": "X3DFields.TX3DWriter.IncIndent", "text": "    ", "tags": "", "loc": "X3DFields.TX3DWriter.html#IncIndent"},
     {"title": "X3DFields.TX3DWriter.DecIndent", "text": "    ", "tags": "", "loc": "X3DFields.TX3DWriter.html#DecIndent"},
     {"title": "X3DFields.TX3DWriter.Write", "text": "     ", "tags": "", "loc": "X3DFields.TX3DWriter.html#Write"},
     {"title": "X3DFields.TX3DWriter.Writeln", "text": "    ", "tags": "", "loc": "X3DFields.TX3DWriter.html#Writeln"},
     {"title": "X3DFields.TX3DWriter.Writeln", "text": "    ", "tags": "", "loc": "X3DFields.TX3DWriter.html#Writeln"},
     {"title": "X3DFields.TX3DWriter.WriteIndent", "text": "    ", "tags": "", "loc": "X3DFields.TX3DWriter.html#WriteIndent"},
     {"title": "X3DFields.TX3DWriter.WritelnIndent", "text": "    ", "tags": "", "loc": "X3DFields.TX3DWriter.html#WritelnIndent"},
     {"title": "X3DFields.TX3DWriter.DiscardNextIndent", "text": " Useful in some cases to improve readability of generated VRML file.    ", "tags": "", "loc": "X3DFields.TX3DWriter.html#DiscardNextIndent"},
     {"title": "X3DFields.TX3DWriter.Encoding", "text": " ", "tags": "", "loc": "X3DFields.TX3DWriter.html#Encoding"},
     {"title": "X3DFields.TX3DReader", "text": " Common knowledge for both classic and XML reader. <a class=\"normal\" href=\"X3DNodes.html\">X3DNodes</a> unit extends this into <a class=\"normal\" href=\"X3DNodes.TX3DReaderNames.html\">TX3DReaderNames</a>. ", "tags": "", "loc": "X3DFields.TX3DReader.html"},
     {"title": "X3DFields.TX3DReader.LengthConversionFactor", "text": " ", "tags": "", "loc": "X3DFields.TX3DReader.html#LengthConversionFactor"},
     {"title": "X3DFields.TX3DReader.Create", "text": "    ", "tags": "", "loc": "X3DFields.TX3DReader.html#Create"},
     {"title": "X3DFields.TX3DReader.CreateCopy", "text": "    ", "tags": "", "loc": "X3DFields.TX3DReader.html#CreateCopy"},
     {"title": "X3DFields.TX3DReader.UnitConversion", "text": " If this is angle conversion factor, it is stored and used internally. If this is length conversion factor, we update our <a class=\"normal\" href=\"X3DFields.TX3DReader.html#LengthConversionFactor\">LengthConversionFactor</a> property, but it's callers responsibility to make use of it. (You want to use here <a class=\"normal\" href=\"X3DNodes.TX3DRootNode.html#Scale\">TX3DRootNode.Scale</a>.)    ", "tags": "", "loc": "X3DFields.TX3DReader.html#UnitConversion"},
     {"title": "X3DFields.TX3DReader.BaseUrl", "text": " See <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#BaseUrl\">TX3DNode.BaseUrl</a>. ", "tags": "", "loc": "X3DFields.TX3DReader.html#BaseUrl"},
     {"title": "X3DFields.TX3DReader.Version", "text": " For resolving node class names and other stuff. ", "tags": "", "loc": "X3DFields.TX3DReader.html#Version"},
     {"title": "X3DFields.TX3DFileItem", "text": " We need a common base class for all such things to store <a class=\"normal\" href=\"X3DFields.TX3DFileItem.html#PositionInParent\">PositionInParent</a>.  <p>About ancestry: <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html\">TX3DFieldOrEvent</a> make use of Assign mechanism and so need to descend from TPersistent. <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> make use of interfaces and so must descend from something like TNonRefCountedInterfacedXxx. These are the only reasons, for now, why this descends from <a class=\"normal\" href=\"CastleInterfaces.TNonRefCountedInterfacedPersistent.html\">TNonRefCountedInterfacedPersistent</a>. ", "tags": "", "loc": "X3DFields.TX3DFileItem.html"},
     {"title": "X3DFields.TX3DFileItem.Create", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFileItem.html#Create"},
     {"title": "X3DFields.TX3DFileItem.SaveToStream", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFileItem.html#SaveToStream"},
     {"title": "X3DFields.TX3DFileItem.SaveToXml", "text": " This determines when <a class=\"normal\" href=\"X3DFields.TX3DFileItem.html#SaveToStream\">SaveToStream</a> is called. It also cooperates with some <a class=\"normal\" href=\"X3DFields.TX3DFileItem.html#SaveToStream\">SaveToStream</a> implementations, guiding how the item is actually saved. By default it is <a class=\"normal\" href=\"X3DFields.html#sxChildElement\">sxChildElement</a>.    ", "tags": "", "loc": "X3DFields.TX3DFileItem.html#SaveToXml"},
     {"title": "X3DFields.TX3DFileItem.PositionInParent", "text": " Default value -1 means &quot;undefined&quot;.  <p>For normal usage and processing of VRML graph, this is totally not needed. This position doesn't dictate actual meaning of VRML graph. If you're looking to change order of nodes, you probably want to rather look at something like ReplaceItems within <a class=\"normal\" href=\"X3DNodes.TMFNode.html\">TMFNode</a> or such.  <p>This field is purely a hint when encoding VRML file how to order VRML items (nodes, fields, routes, protos) within parent node or the VRML file. Reason: VRML allows non-unique node names. Each DEF XXX overrides all previous (&quot;previous&quot; in lexical sense, i.e. normal order of tokens in the file) DEF XXX with the same XXX, thus hiding previous node name &quot;XXX&quot;. This means that when saving VRML file we have to be very careful about the order of items, such that e.g. all routes are specified when appropriate node names are bound.  <p>This is a relative position, relative to other <code>PositionInParent</code> value of other <a class=\"normal\" href=\"X3DFields.TX3DFileItem.html\">TX3DFileItem</a> items. So it's not necessary to keep all <code>PositionInParent</code> different or successive within some parent. When saving, we will sort everything according to <code>PositionInParent</code>.  <p>See e.g. ../../../demo_models/x3d/tricky_def_use.x3dv for tests of some tricky layout. When reading such file we have to record <code>PositionInParent</code> to be able to save such file correctly. ", "tags": "", "loc": "X3DFields.TX3DFileItem.html#PositionInParent"},
     {"title": "X3DFields.TX3DFileItemList", "text": " ", "tags": "", "loc": "X3DFields.TX3DFileItemList.html"},
     {"title": "X3DFields.TX3DFileItemList.SortPositionInParent", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFileItemList.html#SortPositionInParent"},
     {"title": "X3DFields.TX3DFileItemList.SaveToStream", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFileItemList.html#SaveToStream"},
     {"title": "X3DFields.TX3DFileItemList.Add", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFileItemList.html#Add"},
     {"title": "X3DFields.TX3DFieldOrEvent", "text": " ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html"},
     {"title": "X3DFields.TX3DFieldOrEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#Create"},
     {"title": "X3DFields.TX3DFieldOrEvent.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#Destroy"},
     {"title": "X3DFields.TX3DFieldOrEvent.IsClauseNamesCount", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#IsClauseNamesCount"},
     {"title": "X3DFields.TX3DFieldOrEvent.IsClauseNamesAssign", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#IsClauseNamesAssign"},
     {"title": "X3DFields.TX3DFieldOrEvent.IsClauseNamesAdd", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#IsClauseNamesAdd"},
     {"title": "X3DFields.TX3DFieldOrEvent.ParseIsClause", "text": " For example, for the <a class=\"normal\" href=\"X3DFields.TX3DField.html\">TX3DField</a> descendant, this does not try to parse field value.    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#ParseIsClause"},
     {"title": "X3DFields.TX3DFieldOrEvent.AddAlternativeName", "text": "  <p>When VRML major version is exactly equal X3DMajorVersion, the AlternativeName should be used &mdash; for both reading and writing of this field/event. In some cases, when reading, we may also allow all versions (both original and alternative), but this is mostly for implementation simplicity &mdash; don't count on it.  <p>A special value 0 for X3DMajorVersion means that this is just an alternative name, that should be allowed when reading (as alternative to normal Name), and never used when writing.  <p>Alternative names is a very handy mechanism for cases when the only thing that changed between VRML versions is the field name. Example: Switch node's children/choice, LOD node's children/level, Polyline2D lineSegments/point.  <p>Note that this also works for ExposedEvents with exposed <a class=\"normal\" href=\"X3DFields.TX3DField.html\">TX3DField</a>: if a field has alternative names, then it's exposed events always also have appropriate alternative names.    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#AddAlternativeName"},
     {"title": "X3DFields.TX3DFieldOrEvent.RemoveAlternativeName", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#RemoveAlternativeName"},
     {"title": "X3DFields.TX3DFieldOrEvent.IsName", "text": " Think about it like simple test &quot;Name = S&quot;, but actually this checks also names added by <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#AddAlternativeName\">AddAlternativeName</a> method.    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#IsName"},
     {"title": "X3DFields.TX3DFieldOrEvent.NameForVersion", "text": " In almost all cases, this simply returns current Name. But it can also return a name added by <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#AddAlternativeName\">AddAlternativeName</a> method.    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#NameForVersion"},
     {"title": "X3DFields.TX3DFieldOrEvent.NameForVersion", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#NameForVersion"},
     {"title": "X3DFields.TX3DFieldOrEvent.NiceName", "text": " Describes parent node type, name and field/event's name.    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#NiceName"},
     {"title": "X3DFields.TX3DFieldOrEvent.SaveToStreamClassicIsClauses", "text": " For each IS clause, writeln field/event name followed by &quot;IS&quot; clause.    ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#SaveToStreamClassicIsClauses"},
     {"title": "X3DFields.TX3DFieldOrEvent.X3DName", "text": "  <p>Most fields/events are inside some X3D node, and then they have a non-empty name. But in some special cases we also use temporary fields with an empty name.  <p>Note that you cannot change this after object creation, since Name is used for various purposes (like to generate names for <a class=\"normal\" href=\"X3DFields.TX3DField.html#ExposedEvents\">TX3DField.ExposedEvents</a>).  <p>Note that this property is deliberately not called <code>Name</code>. In the future, this class may descend from the standard TComponent class, that defines a <code>Name</code> field with a special restrictions (it must be a valid Pascal identifier), which cannot apply to X3D node names (that can have quite free names, see <a  href=\"http://www.web3d.org/documents/specifications/19776-2/V3.3/Part02/grammar.html\">http://www.web3d.org/documents/specifications/19776-2/V3.3/Part02/grammar.html</a> ). We don't want to confuse these two properties. ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#X3DName"},
     {"title": "X3DFields.TX3DFieldOrEvent.Name", "text": " ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#Name"},
     {"title": "X3DFields.TX3DFieldOrEvent.ParentNode", "text": " This must always contain an instance of <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> class (although it cannot be declared such, since <a class=\"normal\" href=\"X3DFields.html\">X3DFields</a> unit cannot depend on <a class=\"normal\" href=\"X3DNodes.html\">X3DNodes</a> interface).  <p>It may be <code>Nil</code> for special fields/events when parent node is unknown. ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#ParentNode"},
     {"title": "X3DFields.TX3DFieldOrEvent.IsClauseNames", "text": "  <p>This is an array, as one item may have many &quot;IS&quot; clauses (for a field, only one &quot;IS&quot; clause should refer to another field; but you can have many &quot;IS&quot; clauses connecting events, also exposedField may have &quot;IS&quot; clause that should be interpreted actually as links to it's exposed events). See e.g. <code>demo_models/x3d/proto_events_test_3.x3dv</code>.  <p>Note that having &quot;IS&quot; clauses doesn't mean that the field should be considered &quot;without any value&quot;. This is not a good way of thinking, as an exposed field may have an &quot;IS&quot; clause, but linking it to an event, and thus such field has it's value (default value, if not specified in the file), event though it also has an &quot;IS&quot; clause. Although there is <a class=\"normal\" href=\"X3DFields.TX3DField.html#ValueFromIsClause\">TX3DField.ValueFromIsClause</a>, which indicates whether current value was obtained from &quot;IS&quot; clause.  <p>To be able to significantly optimize memory, we do not expose <code>IsClauseNames</code> as <a class=\"normal\" href=\"CastleStringUtils.TCastleStringList.html\">TCastleStringList</a>. Instead operate on them only using below functions. Note that <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#IsClauseNamesAssign\">IsClauseNamesAssign</a> can also accept <code>Nil</code> as parameter.  <p> ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#IsClauseNames"},
     {"title": "X3DFields.TX3DFieldOrEvent.ParentInterfaceDeclaration", "text": "  <p>This should always be <code>Nil</code> (if the field is normal, standard field, not coming from interface declaration in VRML file) or an instance of <a class=\"normal\" href=\"X3DNodes.TX3DInterfaceDeclaration.html\">TX3DInterfaceDeclaration</a>. (But it cannot be declared such, since <a class=\"normal\" href=\"X3DNodes.TX3DInterfaceDeclaration.html\">TX3DInterfaceDeclaration</a> is not known in this unit). ", "tags": "", "loc": "X3DFields.TX3DFieldOrEvent.html#ParentInterfaceDeclaration"},
     {"title": "X3DFields.TX3DField", "text": "  <p>Common notes for all descendants: most of them expose a field or property &quot;Value&quot;, which specifies the current value of the field. Many of them also expose DefaultValue and DefaultValueExists fields/properties, these should be the default X3D value for this field. You can even change DefaultValue after the object is created.  <p>Most of descendants include constructor that initializes both DefaultValue and Value to the same thing, as this is what you usually want.  <p>Some notes about <code>Assign</code> method (inherited from TPersistent and overridied appropriately in <code>TX3DField</code> descendants):  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>There are some exceptions, but usually assignment is possible only when source and destination field classes are equal.</p></li>   <li value=\"2\"><p>Assignment (by <code>Assign</code>, inherited from TPersistent) tries to copy everything: name (with alternative names), default value, <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#IsClauseNames\">IsClauseNames</a>, <a class=\"normal\" href=\"X3DFields.TX3DField.html#ValueFromIsClause\">ValueFromIsClause</a>, Exposed, and of course current value.  <p>Exceptions are things related to hierarchy of containers: <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#ParentNode\">ParentNode</a>, <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#ParentInterfaceDeclaration\">ParentInterfaceDeclaration</a>. Also <a class=\"normal\" href=\"X3DFields.TX3DField.html#ExposedEventsLinked\">ExposedEventsLinked</a>.  <p>If you want to copy only the current value, use <a class=\"normal\" href=\"X3DFields.TX3DField.html#AssignValue\">AssignValue</a> (or <a class=\"normal\" href=\"X3DFields.TX3DField.html#AssignLerp\">AssignLerp</a>, where available).</p></li> </ol>  <p> ", "tags": "", "loc": "X3DFields.TX3DField.html"},
     {"title": "X3DFields.TX3DField.Create", "text": "  <p><i>Descendants implementors notes:</i> when implementing constructors in descendants, remember that Create in this class actually just calls <a class=\"normal\" href=\"X3DFields.TX3DField.html#CreateUndefined\">CreateUndefined</a>, and <a class=\"normal\" href=\"X3DFields.TX3DField.html#CreateUndefined\">CreateUndefined</a> is virtual. So when calling <code>inherited Create</code>, be aware that actually you may be calling your own overriden <a class=\"normal\" href=\"X3DFields.TX3DField.html#CreateUndefined\">CreateUndefined</a>.  <p>In fact, in descendants you should focus on moving all the work to <a class=\"normal\" href=\"X3DFields.TX3DField.html#CreateUndefined\">CreateUndefined</a> constructor. The Create constructor should be just a comfortable extension of <a class=\"normal\" href=\"X3DFields.TX3DField.html#CreateUndefined\">CreateUndefined</a>, that does the same and addiionally gets parameters that specify default field value.    ", "tags": "", "loc": "X3DFields.TX3DField.html#Create"},
     {"title": "X3DFields.TX3DField.CreateUndefined", "text": "  <p>The idea is that in some cases, you need to create fields using variable like FieldClass: <a class=\"normal\" href=\"X3DFields.html#TX3DFieldClass\">TX3DFieldClass</a>. See e.g. <a class=\"normal\" href=\"X3DNodes.TX3DInterfaceDeclaration.html\">TX3DInterfaceDeclaration</a>, VRML 2.0 feature that simply requires this ability, also implementation of TX3DSimpleMultField.Parse and TX3DSimpleMultField.CreateItemBeforeParse.  <p>Later you can initialize such instance from string using it's Parse method.  <p>Note that some exceptional fields simply cannot work when initialized by this constructor: these are SFEnum and SFBitMask fields. They simply need to know their <a class=\"normal\" href=\"X3DFields.TSFEnum.html#EnumNames\">TSFEnum.EnumNames</a>, or <a class=\"normal\" href=\"X3DFields.TSFBitMask.html#FlagNames\">TSFBitMask.FlagNames</a> + <a class=\"normal\" href=\"X3DFields.TSFBitMask.html#NoneString\">TSFBitMask.NoneString</a> + <a class=\"normal\" href=\"X3DFields.TSFBitMask.html#AllString\">TSFBitMask.AllString</a> before they can be parsed. I guess that's one of the reasons why these field types were entirely removed from VRML 2.0.    ", "tags": "", "loc": "X3DFields.TX3DField.html#CreateUndefined"},
     {"title": "X3DFields.TX3DField.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TX3DField.html#Destroy"},
     {"title": "X3DFields.TX3DField.Parse", "text": "  <p>In this class, Parse only appends to <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#IsClauseNames\">IsClauseNames</a>: if we stand on &quot;IS&quot; clause (see VRML 2.0 spec about &quot;IS&quot; clause) and IsClauseAllowed then we append specified identifier to <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#IsClauseNames\">IsClauseNames</a>.  <p>If &quot;IS&quot; clause not found, we call <a class=\"normal\" href=\"X3DFields.TX3DField.html#ParseValue\">ParseValue</a> which should actually parse field's value. Descendants should override <a class=\"normal\" href=\"X3DFields.TX3DField.html#ParseValue\">ParseValue</a>.    ", "tags": "", "loc": "X3DFields.TX3DField.html#Parse"},
     {"title": "X3DFields.TX3DField.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TX3DField.html#ParseValue"},
     {"title": "X3DFields.TX3DField.ParseXMLAttributeLexer", "text": " Attributes in X3D are generally encoded such that normal <code><a class=\"normal\" href=\"X3DFields.TX3DField.html#ParseValue\">ParseValue</a>(Lexer, nil)</code> call is appropriate, so this is done in this class.    ", "tags": "", "loc": "X3DFields.TX3DField.html#ParseXMLAttributeLexer"},
     {"title": "X3DFields.TX3DField.ParseXMLAttribute", "text": "  <p>Implementation in this class creates a Lexer to parse the string, and calls <a class=\"normal\" href=\"X3DFields.TX3DField.html#ParseXMLAttributeLexer\">ParseXMLAttributeLexer</a>.    ", "tags": "", "loc": "X3DFields.TX3DField.html#ParseXMLAttribute"},
     {"title": "X3DFields.TX3DField.ParseXMLElement", "text": " This is used to read SFNode / MFNode field value inside &lt;field&gt; (for interface declaration default field value) and &lt;fieldValue&gt; inside &lt;ProtoInstance&gt;.    ", "tags": "", "loc": "X3DFields.TX3DField.html#ParseXMLElement"},
     {"title": "X3DFields.TX3DField.FieldSaveToStream", "text": " Field name (if set, omitted if empty) and value are saved. Unless the current field value equals default value and FieldSaveWhenDefault is <code>False</code> (default), then nothing is saved.  <p>IS clauses are not saved here (because they often have to be treated specially anyway, for XML encoding, for prototype declarations etc.).    ", "tags": "", "loc": "X3DFields.TX3DField.html#FieldSaveToStream"},
     {"title": "X3DFields.TX3DField.SaveToStream", "text": "  <p>This simply calls <a class=\"normal\" href=\"X3DFields.TX3DField.html#FieldSaveToStream\">FieldSaveToStream</a>(Writer). See <a class=\"normal\" href=\"X3DFields.TX3DField.html#FieldSaveToStream\">FieldSaveToStream</a> for more comments and when you need control over FieldSaveWhenDefault behavior.  <p>It doesn't actually save anything if field value is defined and equals default value.    ", "tags": "", "loc": "X3DFields.TX3DField.html#SaveToStream"},
     {"title": "X3DFields.TX3DField.SaveToXml", "text": "    ", "tags": "", "loc": "X3DFields.TX3DField.html#SaveToXml"},
     {"title": "X3DFields.TX3DField.EqualsDefaultValue", "text": " Mozesz to przedefiniowac w podklasach aby <a class=\"normal\" href=\"X3DFields.TX3DField.html#SaveToStream\">SaveToStream</a> nie zapisywalo do strumienia pol o wartosci domyslnej.    ", "tags": "", "loc": "X3DFields.TX3DField.html#EqualsDefaultValue"},
     {"title": "X3DFields.TX3DField.Equals", "text": " For this class, this returns just (SecondValue.Name = Name).  <p>All descendants (that add some property that should be compared) should override this like  <p></p>  <pre class=\"longcode\"> Result := (<span class=\"pascal_keyword\">inherited</span> Equals(SecondValue)) <span class=\"pascal_keyword\">and</span>   (SecondValue <span class=\"pascal_keyword\">is</span> TMyType) <span class=\"pascal_keyword\">and</span>   (TMyType(SecondValue)<span class=\"pascal_float\">.</span>MyProperty = MyProperty);</pre>  <p>  <p>The floating-point fields may be compared with a small epsilon tolerance by this method.  <p>Note that this *doesn't* compare the default values of two fields instances. This compares only the current values of two fields instances, and eventually some other properties that affect parsing (like names for <a class=\"normal\" href=\"X3DFields.TSFEnum.html\">TSFEnum</a> and <a class=\"normal\" href=\"X3DFields.TSFBitMask.html\">TSFBitMask</a>) or allowed future values (like <a class=\"normal\" href=\"X3DFields.TSFFloat.html#MustBeNonnegative\">TSFFloat.MustBeNonnegative</a>).    ", "tags": "", "loc": "X3DFields.TX3DField.html#Equals"},
     {"title": "X3DFields.TX3DField.FastEqualsValue", "text": "  <p>This compares only the values of the fields, not other properties (it doesn't care about names of the fields or such, or default values; only current values). In other words, it compares only the things copied by <a class=\"normal\" href=\"X3DFields.TX3DField.html#AssignValue\">AssignValue</a>.  <p>This tries to compare very fast, which means that for large (multi-valued) fields it may give up and answer <code>False</code> even when they are in fact equal. So this is usable only for optimization purposes: when it answers <code>True</code>, it is <code>True</code>. When it answers <code>False</code>, it actually doesn't know.  <p>Default implementation in this class (<code>TX3DField</code>) just returns <code>False</code>.    ", "tags": "", "loc": "X3DFields.TX3DField.html#FastEqualsValue"},
     {"title": "X3DFields.TX3DField.EventIn", "text": " <code>Nil</code> if this field is not exposed. <code>EventIn</code> is always equivalent to <a class=\"normal\" href=\"X3DFields.TX3DField.html#ExposedEvents\">ExposedEvents</a>[true], <a class=\"normal\" href=\"X3DFields.TX3DField.html#EventOut\">EventOut</a> is always equivalent to <a class=\"normal\" href=\"X3DFields.TX3DField.html#ExposedEvents\">ExposedEvents</a>[false].     ", "tags": "", "loc": "X3DFields.TX3DField.html#EventIn"},
     {"title": "X3DFields.TX3DField.EventOut", "text": "    ", "tags": "", "loc": "X3DFields.TX3DField.html#EventOut"},
     {"title": "X3DFields.TX3DField.X3DType", "text": " As for VRML/X3D interface declaration statements. In base <a class=\"normal\" href=\"X3DFields.TX3DField.html\">TX3DField</a> class, this returns <code>XFAny</code> (name indicating any type, used by instantreality and us).    ", "tags": "", "loc": "X3DFields.TX3DField.html#X3DType"},
     {"title": "X3DFields.TX3DField.TypeName", "text": "    ", "tags": "", "loc": "X3DFields.TX3DField.html#TypeName"},
     {"title": "X3DFields.TX3DField.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TX3DField.html#CreateEvent"},
     {"title": "X3DFields.TX3DField.AssignValue", "text": " Contrary to TPersistent.Assign, this doesn't copy the rest of properties.  <p>After setting, our <a class=\"normal\" href=\"X3DFields.TX3DField.html#ValueFromIsClause\">ValueFromIsClause</a> is always changed to <code>False</code>. You can manually change it to <code>True</code>, if this copy indeed was done following &quot;IS&quot; clause.  <p>  <p>  <p><i>Descendants implementors notes</i>:  <p>In this class, implementation takes care of setting our <a class=\"normal\" href=\"X3DFields.TX3DField.html#ValueFromIsClause\">ValueFromIsClause</a> to <code>False</code>. In descendants, you should do like  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">if</span> Source <span class=\"pascal_keyword\">is</span> &lt;appropriate <span class=\"pascal_keyword\">class</span>&gt; <span class=\"pascal_keyword\">then</span> <span class=\"pascal_keyword\">begin</span>   <span class=\"pascal_keyword\">inherited</span>;   Value := Source.value; <span class=\"pascal_keyword\">end</span> <span class=\"pascal_keyword\">else</span>   AssignValueRaiseInvalidClass(Source);</pre>  <p>    EX3DFieldAssignInvalidClass Usually it's required the Source class to be equal to our class, if Source classes cannot be assigned we raise EX3DFieldCannotAssignClass. EX3DFieldAssign Raised in case of any field assignment problem. It's guaranteed that in case of such problem, our value will not be modified before raising the exception.  <p><a class=\"normal\" href=\"X3DFields.EX3DFieldAssignInvalidClass.html\">EX3DFieldAssignInvalidClass</a> inherits from <a class=\"normal\" href=\"X3DFields.EX3DFieldAssign.html\">EX3DFieldAssign</a>, so actually <a class=\"normal\" href=\"X3DFields.EX3DFieldAssignInvalidClass.html\">EX3DFieldAssignInvalidClass</a> is just a special case of this exceptiion.", "tags": "", "loc": "X3DFields.TX3DField.html#AssignValue"},
     {"title": "X3DFields.TX3DField.AssignDefaultValueFromValue", "text": "  <p>Note that for now this doesn't guarantee that every possible field's value can be stored as default value. In case of trouble, it will silently record &quot;no default is known&quot; information, so e.g. <a class=\"normal\" href=\"X3DFields.TX3DField.html#EqualsDefaultValue\">EqualsDefaultValue</a> will always return <code>False</code>. Our default value mechanisms are sometimes limited, not every value can be a default value. For example, for multiple-valued nodes, we usually cannot save arrays longer than one as default value. This is not a problem, since X3D specification doesn't specify too long default values. But it may be a problem for prototypes, since then user can assign any value as default value. May be corrected in the future.    ", "tags": "", "loc": "X3DFields.TX3DField.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TX3DField.AssignLerp", "text": " Just like other lerp functions in our units (like <a class=\"normal\" href=\"CastleVectors.html#Lerp\">CastleVectors.Lerp</a>).  <p>Like <a class=\"normal\" href=\"X3DFields.TX3DField.html#AssignValue\">AssignValue</a>, this copies only the current value. All other properties (like Name, <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#IsClauseNames\">IsClauseNames</a>, <a class=\"normal\" href=\"X3DFields.TX3DField.html#ValueFromIsClause\">ValueFromIsClause</a>, default value) are untouched.  <p>There are some special precautions for this:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>First of all, <code>AssignLerp</code> is defined only for fields where <a class=\"normal\" href=\"X3DFields.TX3DField.html#CanAssignLerp\">CanAssignLerp</a> returns <code>True</code>, so always check <a class=\"normal\" href=\"X3DFields.TX3DField.html#CanAssignLerp\">CanAssignLerp</a> first. All float-based fields should have this implemented.</p></li>   <li><p>Use this only if Value1 and Value2 are equal or descendant of target (Self) class.</p></li>   <li><p>For multiple-value fields, counts of Value1 and Value2 must be equal, or <a class=\"normal\" href=\"CastleUtils.EListsDifferentCount.html\">EListsDifferentCount</a> will be raised.</p></li> </ul>  <p>  <p>    EListsDifferentCount When field is multiple-value field and Value1.Count &lt;&gt; Value2.Count.", "tags": "", "loc": "X3DFields.TX3DField.html#AssignLerp"},
     {"title": "X3DFields.TX3DField.CanAssignLerp", "text": "  <p><i>Descendants implementors notes</i>: In this class, this always returns <code>False</code>.    ", "tags": "", "loc": "X3DFields.TX3DField.html#CanAssignLerp"},
     {"title": "X3DFields.TX3DField.AddAlternativeName", "text": "    ", "tags": "", "loc": "X3DFields.TX3DField.html#AddAlternativeName"},
     {"title": "X3DFields.TX3DField.Changed", "text": "    ", "tags": "", "loc": "X3DFields.TX3DField.html#Changed"},
     {"title": "X3DFields.TX3DField.ExecuteChanges", "text": " This is called, exactly once, by TCastleSceneCore.InternalChangedField to determine what must be done when we know that value of this field changed.  <p>In overridden descendants, this can also do something immediately. Overriding this is similar to registering your callback by <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#AddNotification\">EventOut.AddNotification</a>, with two additional benefits:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>This method may be not called (although no guarantees) when the actual field value did not change. In contrast, the event notification is always fired, even when you send the same value to an exposed field, because VRML/X3D events and routes must be fired anyway.</p></li>   <li value=\"2\"><p>This is useful also for fields that are not exposed, and can be changed only by ObjectPascal code.</p></li> </ol>  <p>  <p>So overridding this is closer to &quot;do something when field value changes&quot; than registering notification by <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#AddNotification\">EventOut.AddNotification</a>.    ", "tags": "", "loc": "X3DFields.TX3DField.html#ExecuteChanges"},
     {"title": "X3DFields.TX3DField.Send", "text": " This sets the value of this field in the nicest possible way for any possible <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> (with events on or off) containing the node with this field.  <p>Precise specification:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>If this is an exposed field and we have events engine working:  <p>We will send this value through it's input event. In this case, this is equivalent to doing <code>EventIn.Send(Value, Scene.Time)</code>. The scenes (including events engine) will be notified correctly by exposed events handler already.</p></li>   <li><p>Otherwise, we will just set the fields value. And then notify the scenes (including events engine).</p></li> </ul>  <p>    ", "tags": "", "loc": "X3DFields.TX3DField.html#Send"},
     {"title": "X3DFields.TX3DField.AddNotification", "text": " Use only for exposed fields. This is simply a shortcut for <code>EventOut.AddNotification</code>, <code>EventOut.RemoveNotification</code>, see <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#AddNotification\">TX3DEvent.AddNotification</a> for details how does this work.  <p>Note that this observes the &quot;out&quot; event (not the &quot;in&quot; event). This way you know inside the handler that the field value is already changed as appropriate. Inside &quot;in&quot; event handlers, you would not know this (it would depend on the order in which handlers are run, one &quot;in&quot; handler sets the field value).  <p>Note that &quot;out&quot; event handlers are executed before Scene is notified about the field value change (before TCastleSceneCore.InternalChangedField is called). This is also usually exactly what you want &mdash; you can change the scene graph inside the event handler (for example, load something on Inline.load or Inline.url changes), and let the <a class=\"normal\" href=\"X3DFields.TX3DField.html#ChangesAlways\">TX3DField.ChangesAlways</a> cause appropriate action on this change.    ", "tags": "", "loc": "X3DFields.TX3DField.html#AddNotification"},
     {"title": "X3DFields.TX3DField.RemoveNotification", "text": "    ", "tags": "", "loc": "X3DFields.TX3DField.html#RemoveNotification"},
     {"title": "X3DFields.TX3DField.ValueFromIsClause", "text": " If yes, then saving this field to stream will only save it's &quot;IS&quot; clauses, never saving actual value. ", "tags": "", "loc": "X3DFields.TX3DField.html#ValueFromIsClause"},
     {"title": "X3DFields.TX3DField.Exposed", "text": " ", "tags": "", "loc": "X3DFields.TX3DField.html#Exposed"},
     {"title": "X3DFields.TX3DField.ExposedEvents", "text": " <code>Nil</code> if Exposed is <code>False</code>. ", "tags": "", "loc": "X3DFields.TX3DField.html#ExposedEvents"},
     {"title": "X3DFields.TX3DField.ExposedEventsLinked", "text": " This means that we will listen on <a class=\"normal\" href=\"X3DFields.TX3DField.html#EventIn\">EventIn</a>, and when something will be received we will set current field's value and produce appropriate <a class=\"normal\" href=\"X3DFields.TX3DField.html#EventOut\">EventOut</a>.  <p>You almost certainly want to leave this as <code>True</code> in all typical situations, as it takes care of implementing required exposed events behavior.  <p>That said, in special cases you may decide to break this. ", "tags": "", "loc": "X3DFields.TX3DField.html#ExposedEventsLinked"},
     {"title": "X3DFields.TX3DField.ChangesAlways", "text": "  <p>This is included in the <a class=\"normal\" href=\"X3DFields.TX3DField.html#ExecuteChanges\">ExecuteChanges</a> method result. So instead of using this property, you could always override <a class=\"normal\" href=\"X3DFields.TX3DField.html#ExecuteChanges\">ExecuteChanges</a> method. But often it's easier to use the property.  <p>By default this is an empty set. This is suitable for things that aren't *directly* an actual content (but only an intermediate value to change other stuff). This includes all metadata fields and nodes, all fields in event utilities, Script node, interpolators...  <p>See <a class=\"normal\" href=\"X3DFields.html#TX3DChange\">TX3DChange</a> for possible values. ", "tags": "", "loc": "X3DFields.TX3DField.html#ChangesAlways"},
     {"title": "X3DFields.TX3DFieldList", "text": " ", "tags": "", "loc": "X3DFields.TX3DFieldList.html"},
     {"title": "X3DFields.TX3DFieldList.IndexOfName", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldList.html#IndexOfName"},
     {"title": "X3DFields.TX3DFieldList.IndexOfExposedEvent", "text": " set_xxx or xxx_changed). If yes, then returns index of event, and the event reference itself (so always <code>Fields[ReturnedIndex].ExposedEvent[ReturnedEvent.InEvent] = ReturnedEvent</code>). Otherwise, returns -1.    ", "tags": "", "loc": "X3DFields.TX3DFieldList.html#IndexOfExposedEvent"},
     {"title": "X3DFields.TX3DFieldList.ByName", "text": " Raises <a class=\"normal\" href=\"X3DFields.EX3DNotFound.html\">EX3DNotFound</a> if the given Name doesn't exist. ", "tags": "", "loc": "X3DFields.TX3DFieldList.html#ByName"},
     {"title": "X3DFields.TX3DEvent", "text": " ", "tags": "", "loc": "X3DFields.TX3DEvent.html"},
     {"title": "X3DFields.TX3DEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#Create"},
     {"title": "X3DFields.TX3DEvent.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#Destroy"},
     {"title": "X3DFields.TX3DEvent.CreateTemp", "text": "    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#CreateTemp"},
     {"title": "X3DFields.TX3DEvent.FreeTemp", "text": "    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#FreeTemp"},
     {"title": "X3DFields.TX3DEvent.Parse", "text": "    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#Parse"},
     {"title": "X3DFields.TX3DEvent.SaveToStream", "text": "    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#SaveToStream"},
     {"title": "X3DFields.TX3DEvent.SaveToXml", "text": "    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#SaveToXml"},
     {"title": "X3DFields.TX3DEvent.Send", "text": " For input fields, this is used by routes, scripts etc. to send an event to a field. For output fields, this is used by node itself to send event to routes, scripts etc.  <p>Field must be non-nil, of class <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#FieldClass\">FieldClass</a>.  <p>The Field instance doesn't become owned in any way by the <a class=\"normal\" href=\"X3DFields.TX3DEvent.html\">TX3DEvent</a>. That is, it's the caller responsibility to free the Field instance at any comfortable time, possibly right after calling Send.  <p>Overloaded versions without explicit Time parameter just take time from ParentNode.Scene.GetTime. If <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#ParentNode\">ParentNode</a> is <code>Nil</code> (which should not happen with normal fields within nodes) or if ParentNode.Scene is <code>Nil</code> (which may happen only if events processing is not turned on, that is <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">TCastleSceneCore.ProcessEvents</a> is <code>False</code>) then event is not send.    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#Send"},
     {"title": "X3DFields.TX3DEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#Send"},
     {"title": "X3DFields.TX3DEvent.AddNotification", "text": " For input events, these are used by node itself to listen to events send to it. For output events, these are used by routes, scripts to listen to events occuring.  <p>When you handle this callback to send another X3D event, you should pass around the same <code>Time</code> value. This makes sure that X3D route loop detection mechanism works fine. For example, here's how handling TimeSensor.elapsedTime_receive event sends fraction_changed event:  <p></p>  <pre class=\"longcode\"> <span class=\"pascal_keyword\">procedure</span> TTimeSensorNode.EventElapsedTimeReceive(   Event: TX3DEvent; Value: TX3DField; <span class=\"pascal_keyword\">const</span> Time: TX3DTime); <span class=\"pascal_keyword\">var</span>   Fraction: Single; <span class=\"pascal_keyword\">begin</span>   <span class=\"pascal_keyword\">if</span> FdEnabled.Value <span class=\"pascal_keyword\">then</span>   <span class=\"pascal_keyword\">begin</span>     Fraction := <span class=\"pascal_numeric\"></span>...; <span class=\"pascal_comment\">// doesn't matter here how this is calculated</span>     <span class=\"pascal_comment\">// Pass &quot;Time&quot; parameter further by a call below</span>     Eventfraction_changed.Send(Fraction, Time);   <span class=\"pascal_keyword\">end</span>; <span class=\"pascal_keyword\">end</span>;</pre>  <p>  <p>All callbacks registered here are simply called by <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#Send\">Send</a> method.    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#AddNotification"},
     {"title": "X3DFields.TX3DEvent.RemoveNotification", "text": "  <p>This is guaranteed to work correctly even if we're right now in the middle of this event's processing (which means that we may be iterating over a list of notifications). The handler may be actually removed a bit later (when it's safe).  <p>Note that adding a notification two-times makes it called two times. Removing a notification removes one copy of a notification, so it should then be removed two-times too.    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#RemoveNotification"},
     {"title": "X3DFields.TX3DEvent.SendNeeded", "text": "  <p>Sometimes, even preparing a value to Send is quite time-consuming (example: CoordinateInterpolator, where a long MFVec3f value has to be computer). Then checking <code>SendNeeded</code> is useful: if <code>SendNeeded</code> = <code>False</code>, you know that there's no point in preparing Value to send, because actually Send will do nothing.  <p>For example, event out to which no ROUTE is connected, and no Script can listen to it.  <p>For now, this simply returns whether any callback is registered by <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#AddNotification\">AddNotification</a>.    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#SendNeeded"},
     {"title": "X3DFields.TX3DEvent.Assign", "text": " The <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#FieldClass\">FieldClass</a> and <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#InEvent\">InEvent</a> is copied.  <p>The notifications (from <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#AddNotification\">AddNotification</a>) and <a class=\"normal\" href=\"X3DFields.TX3DEvent.html#ParentExposedField\">ParentExposedField</a> are not copied, since they shouldn't be copied so easily (<a class=\"normal\" href=\"X3DFields.TX3DEvent.html#ParentExposedField\">ParentExposedField</a> is related to hierarchy of containers, copying notification would be surprising to the notification listener).    ", "tags": "", "loc": "X3DFields.TX3DEvent.html#Assign"},
     {"title": "X3DFields.TX3DEvent.FieldClass", "text": " ", "tags": "", "loc": "X3DFields.TX3DEvent.html#FieldClass"},
     {"title": "X3DFields.TX3DEvent.InEvent", "text": " ", "tags": "", "loc": "X3DFields.TX3DEvent.html#InEvent"},
     {"title": "X3DFields.TX3DEvent.ParentExposedField", "text": " Otherwise it's <code>Nil</code>. ", "tags": "", "loc": "X3DFields.TX3DEvent.html#ParentExposedField"},
     {"title": "X3DFields.TX3DEventList", "text": " ", "tags": "", "loc": "X3DFields.TX3DEventList.html"},
     {"title": "X3DFields.TX3DEventList.IndexOfName", "text": " -1 if not found.    ", "tags": "", "loc": "X3DFields.TX3DEventList.html#IndexOfName"},
     {"title": "X3DFields.TX3DEventList.ByName", "text": " Raises <a class=\"normal\" href=\"X3DFields.EX3DNotFound.html\">EX3DNotFound</a> if the given Name doesn't exist. ", "tags": "", "loc": "X3DFields.TX3DEventList.html#ByName"},
     {"title": "X3DFields.TSFBoolEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFBoolEvent.html"},
     {"title": "X3DFields.TSFBoolEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFBoolEvent.html#Create"},
     {"title": "X3DFields.TSFBoolEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFBoolEvent.html#Send"},
     {"title": "X3DFields.TSFBoolEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFBoolEvent.html#Send"},
     {"title": "X3DFields.TSFDoubleEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFDoubleEvent.html"},
     {"title": "X3DFields.TSFDoubleEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFDoubleEvent.html#Create"},
     {"title": "X3DFields.TSFDoubleEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFDoubleEvent.html#Send"},
     {"title": "X3DFields.TSFDoubleEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFDoubleEvent.html#Send"},
     {"title": "X3DFields.TSFTimeEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFTimeEvent.html"},
     {"title": "X3DFields.TSFTimeEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFTimeEvent.html#Create"},
     {"title": "X3DFields.TSFTimeEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFTimeEvent.html#Send"},
     {"title": "X3DFields.TSFTimeEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFTimeEvent.html#Send"},
     {"title": "X3DFields.TSFFloatEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFFloatEvent.html"},
     {"title": "X3DFields.TSFFloatEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloatEvent.html#Create"},
     {"title": "X3DFields.TSFFloatEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloatEvent.html#Send"},
     {"title": "X3DFields.TSFFloatEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloatEvent.html#Send"},
     {"title": "X3DFields.TSFImageEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFImageEvent.html"},
     {"title": "X3DFields.TSFImageEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFImageEvent.html#Create"},
     {"title": "X3DFields.TSFLongEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFLongEvent.html"},
     {"title": "X3DFields.TSFLongEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFLongEvent.html#Create"},
     {"title": "X3DFields.TSFLongEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFLongEvent.html#Send"},
     {"title": "X3DFields.TSFLongEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFLongEvent.html#Send"},
     {"title": "X3DFields.TSFInt32Event", "text": " ", "tags": "", "loc": "X3DFields.TSFInt32Event.html"},
     {"title": "X3DFields.TSFInt32Event.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFInt32Event.html#Create"},
     {"title": "X3DFields.TSFInt32Event.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFInt32Event.html#Send"},
     {"title": "X3DFields.TSFInt32Event.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFInt32Event.html#Send"},
     {"title": "X3DFields.TSFMatrix3dEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFMatrix3dEvent.html"},
     {"title": "X3DFields.TSFMatrix3dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix3dEvent.html#Create"},
     {"title": "X3DFields.TSFMatrix3dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix3dEvent.html#Send"},
     {"title": "X3DFields.TSFMatrix3dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix3dEvent.html#Send"},
     {"title": "X3DFields.TSFMatrix3fEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFMatrix3fEvent.html"},
     {"title": "X3DFields.TSFMatrix3fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix3fEvent.html#Create"},
     {"title": "X3DFields.TSFMatrix3fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix3fEvent.html#Send"},
     {"title": "X3DFields.TSFMatrix3fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix3fEvent.html#Send"},
     {"title": "X3DFields.TSFMatrix4dEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFMatrix4dEvent.html"},
     {"title": "X3DFields.TSFMatrix4dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix4dEvent.html#Create"},
     {"title": "X3DFields.TSFMatrix4dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix4dEvent.html#Send"},
     {"title": "X3DFields.TSFMatrix4dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix4dEvent.html#Send"},
     {"title": "X3DFields.TSFMatrix4fEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFMatrix4fEvent.html"},
     {"title": "X3DFields.TSFMatrix4fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix4fEvent.html#Create"},
     {"title": "X3DFields.TSFMatrix4fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix4fEvent.html#Send"},
     {"title": "X3DFields.TSFMatrix4fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix4fEvent.html#Send"},
     {"title": "X3DFields.TSFNodeEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFNodeEvent.html"},
     {"title": "X3DFields.TSFNodeEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFNodeEvent.html#Create"},
     {"title": "X3DFields.TSFRotationEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFRotationEvent.html"},
     {"title": "X3DFields.TSFRotationEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotationEvent.html#Create"},
     {"title": "X3DFields.TSFRotationEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotationEvent.html#Send"},
     {"title": "X3DFields.TSFRotationEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotationEvent.html#Send"},
     {"title": "X3DFields.TSFStringEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFStringEvent.html"},
     {"title": "X3DFields.TSFStringEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFStringEvent.html#Create"},
     {"title": "X3DFields.TSFStringEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFStringEvent.html#Send"},
     {"title": "X3DFields.TSFStringEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFStringEvent.html#Send"},
     {"title": "X3DFields.TSFVec2dEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFVec2dEvent.html"},
     {"title": "X3DFields.TSFVec2dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec2dEvent.html#Create"},
     {"title": "X3DFields.TSFVec2dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec2dEvent.html#Send"},
     {"title": "X3DFields.TSFVec2dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec2dEvent.html#Send"},
     {"title": "X3DFields.TSFVec2fEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFVec2fEvent.html"},
     {"title": "X3DFields.TSFVec2fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec2fEvent.html#Create"},
     {"title": "X3DFields.TSFVec2fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec2fEvent.html#Send"},
     {"title": "X3DFields.TSFVec2fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec2fEvent.html#Send"},
     {"title": "X3DFields.TSFVec3dEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFVec3dEvent.html"},
     {"title": "X3DFields.TSFVec3dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec3dEvent.html#Create"},
     {"title": "X3DFields.TSFVec3dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec3dEvent.html#Send"},
     {"title": "X3DFields.TSFVec3dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec3dEvent.html#Send"},
     {"title": "X3DFields.TSFVec3fEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFVec3fEvent.html"},
     {"title": "X3DFields.TSFVec3fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec3fEvent.html#Create"},
     {"title": "X3DFields.TSFVec3fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec3fEvent.html#Send"},
     {"title": "X3DFields.TSFVec3fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec3fEvent.html#Send"},
     {"title": "X3DFields.TSFVec4dEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFVec4dEvent.html"},
     {"title": "X3DFields.TSFVec4dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec4dEvent.html#Create"},
     {"title": "X3DFields.TSFVec4dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec4dEvent.html#Send"},
     {"title": "X3DFields.TSFVec4dEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec4dEvent.html#Send"},
     {"title": "X3DFields.TSFVec4fEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFVec4fEvent.html"},
     {"title": "X3DFields.TSFVec4fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec4fEvent.html#Create"},
     {"title": "X3DFields.TSFVec4fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec4fEvent.html#Send"},
     {"title": "X3DFields.TSFVec4fEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec4fEvent.html#Send"},
     {"title": "X3DFields.TSFColorEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFColorEvent.html"},
     {"title": "X3DFields.TSFColorEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFColorEvent.html#Create"},
     {"title": "X3DFields.TSFColorEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFColorEvent.html#Send"},
     {"title": "X3DFields.TSFColorEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFColorEvent.html#Send"},
     {"title": "X3DFields.TSFColorRGBAEvent", "text": " ", "tags": "", "loc": "X3DFields.TSFColorRGBAEvent.html"},
     {"title": "X3DFields.TSFColorRGBAEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFColorRGBAEvent.html#Create"},
     {"title": "X3DFields.TSFColorRGBAEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFColorRGBAEvent.html#Send"},
     {"title": "X3DFields.TSFColorRGBAEvent.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFColorRGBAEvent.html#Send"},
     {"title": "X3DFields.TXFAnyEvent", "text": " It is used by some InstantReality extensions, like Logger.write. InstantReality calls this event type XFAny. ", "tags": "", "loc": "X3DFields.TXFAnyEvent.html"},
     {"title": "X3DFields.TXFAnyEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TXFAnyEvent.html#Create"},
     {"title": "X3DFields.TMFBoolEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFBoolEvent.html"},
     {"title": "X3DFields.TMFBoolEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFBoolEvent.html#Create"},
     {"title": "X3DFields.TMFDoubleEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFDoubleEvent.html"},
     {"title": "X3DFields.TMFDoubleEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFDoubleEvent.html#Create"},
     {"title": "X3DFields.TMFTimeEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFTimeEvent.html"},
     {"title": "X3DFields.TMFTimeEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFTimeEvent.html#Create"},
     {"title": "X3DFields.TMFFloatEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFFloatEvent.html"},
     {"title": "X3DFields.TMFFloatEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFFloatEvent.html#Create"},
     {"title": "X3DFields.TMFLongEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFLongEvent.html"},
     {"title": "X3DFields.TMFLongEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFLongEvent.html#Create"},
     {"title": "X3DFields.TMFInt32Event", "text": " ", "tags": "", "loc": "X3DFields.TMFInt32Event.html"},
     {"title": "X3DFields.TMFInt32Event.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFInt32Event.html#Create"},
     {"title": "X3DFields.TMFMatrix3dEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFMatrix3dEvent.html"},
     {"title": "X3DFields.TMFMatrix3dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix3dEvent.html#Create"},
     {"title": "X3DFields.TMFMatrix3fEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFMatrix3fEvent.html"},
     {"title": "X3DFields.TMFMatrix3fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix3fEvent.html#Create"},
     {"title": "X3DFields.TMFMatrix4dEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFMatrix4dEvent.html"},
     {"title": "X3DFields.TMFMatrix4dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix4dEvent.html#Create"},
     {"title": "X3DFields.TMFMatrix4fEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFMatrix4fEvent.html"},
     {"title": "X3DFields.TMFMatrix4fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix4fEvent.html#Create"},
     {"title": "X3DFields.TMFNodeEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFNodeEvent.html"},
     {"title": "X3DFields.TMFNodeEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFNodeEvent.html#Create"},
     {"title": "X3DFields.TMFRotationEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFRotationEvent.html"},
     {"title": "X3DFields.TMFRotationEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFRotationEvent.html#Create"},
     {"title": "X3DFields.TMFStringEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFStringEvent.html"},
     {"title": "X3DFields.TMFStringEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFStringEvent.html#Create"},
     {"title": "X3DFields.TMFVec2dEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFVec2dEvent.html"},
     {"title": "X3DFields.TMFVec2dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec2dEvent.html#Create"},
     {"title": "X3DFields.TMFVec2fEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFVec2fEvent.html"},
     {"title": "X3DFields.TMFVec2fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec2fEvent.html#Create"},
     {"title": "X3DFields.TMFVec3dEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFVec3dEvent.html"},
     {"title": "X3DFields.TMFVec3dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec3dEvent.html#Create"},
     {"title": "X3DFields.TMFVec3fEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFVec3fEvent.html"},
     {"title": "X3DFields.TMFVec3fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec3fEvent.html#Create"},
     {"title": "X3DFields.TMFVec4dEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFVec4dEvent.html"},
     {"title": "X3DFields.TMFVec4dEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec4dEvent.html#Create"},
     {"title": "X3DFields.TMFVec4fEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFVec4fEvent.html"},
     {"title": "X3DFields.TMFVec4fEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec4fEvent.html#Create"},
     {"title": "X3DFields.TMFColorEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFColorEvent.html"},
     {"title": "X3DFields.TMFColorEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFColorEvent.html#Create"},
     {"title": "X3DFields.TMFColorRGBAEvent", "text": " ", "tags": "", "loc": "X3DFields.TMFColorRGBAEvent.html"},
     {"title": "X3DFields.TMFColorRGBAEvent.Create", "text": "    ", "tags": "", "loc": "X3DFields.TMFColorRGBAEvent.html#Create"},
     {"title": "X3DFields.TX3DSingleField", "text": "  <p>This file is part of &quot;Castle Game Engine&quot;.  <p>&quot;Castle Game Engine&quot; is free software; see the file COPYING.txt, included in this distribution, for details about the copyright.  <p>&quot;Castle Game Engine&quot; is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  <p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;- ", "tags": "", "loc": "X3DFields.TX3DSingleField.html"},
     {"title": "X3DFields.TSFBitMask", "text": "  This is deprecated, as VRML 1.0 is an ancient format now. ", "tags": "", "loc": "X3DFields.TSFBitMask.html"},
     {"title": "X3DFields.TSFBitMask.FlagsCount", "text": "    ", "tags": "", "loc": "X3DFields.TSFBitMask.html#FlagsCount"},
     {"title": "X3DFields.TSFBitMask.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFBitMask.html#ParseValue"},
     {"title": "X3DFields.TSFBitMask.AreAllFlags", "text": "    ", "tags": "", "loc": "X3DFields.TSFBitMask.html#AreAllFlags"},
     {"title": "X3DFields.TSFBitMask.Create", "text": "  <p>Remember that arrays AFlagNames and AFlags (AFlags is initial value of Flags) must have equal length. Eventually, AFlags may be longer (excessive items will be ignored).    ", "tags": "", "loc": "X3DFields.TSFBitMask.html#Create"},
     {"title": "X3DFields.TSFBitMask.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TSFBitMask.html#Destroy"},
     {"title": "X3DFields.TSFBitMask.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFBitMask.html#Equals"},
     {"title": "X3DFields.TSFBitMask.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFBitMask.html#Assign"},
     {"title": "X3DFields.TSFBitMask.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFBitMask.html#AssignValue"},
     {"title": "X3DFields.TSFBitMask.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFBitMask.html#X3DType"},
     {"title": "X3DFields.TSFBitMask.Flags", "text": " You can use Index from the range 0 .. <a class=\"normal\" href=\"X3DFields.TSFBitMask.html#FlagsCount\">FlagsCount</a> - 1. ", "tags": "", "loc": "X3DFields.TSFBitMask.html#Flags"},
     {"title": "X3DFields.TSFBitMask.FlagNames", "text": " Note that this cannot be initialized by <a class=\"normal\" href=\"X3DFields.TX3DField.html#CreateUndefined\">CreateUndefined</a>, so you always must initialize this field using the <a class=\"normal\" href=\"X3DFields.TSFBitMask.html#Create\">Create</a> overload that takes AFlagNames parameter. ", "tags": "", "loc": "X3DFields.TSFBitMask.html#FlagNames"},
     {"title": "X3DFields.TSFBitMask.AllString", "text": " <code>AllString</code> selects all flags, <a class=\"normal\" href=\"X3DFields.TSFBitMask.html#NoneString\">NoneString</a> selects none. <code>AllString</code> may be '' is there's no such string, <a class=\"normal\" href=\"X3DFields.TSFBitMask.html#NoneString\">NoneString</a> should never be '' (otherwise, user could not be able to specify some SFBitMask values &mdash; <a class=\"normal\" href=\"X3DFields.TSFBitMask.html#NoneString\">NoneString</a> is the only way to specify 0).  <p>There is usually little sense in using them like &quot;ALL | something&quot; (because it means just &quot;ALL&quot;) or &quot;NONE | something&quot; (because it means just &quot;something&quot;). But it's allowed syntactically.  <p> ", "tags": "", "loc": "X3DFields.TSFBitMask.html#AllString"},
     {"title": "X3DFields.TSFBitMask.NoneString", "text": " ", "tags": "", "loc": "X3DFields.TSFBitMask.html#NoneString"},
     {"title": "X3DFields.TSFBool", "text": " ", "tags": "", "loc": "X3DFields.TSFBool.html"},
     {"title": "X3DFields.TSFBool.Value", "text": " ", "tags": "", "loc": "X3DFields.TSFBool.html#Value"},
     {"title": "X3DFields.TSFBool.DefaultValue", "text": " ", "tags": "", "loc": "X3DFields.TSFBool.html#DefaultValue"},
     {"title": "X3DFields.TSFBool.DefaultValueExists", "text": " ", "tags": "", "loc": "X3DFields.TSFBool.html#DefaultValueExists"},
     {"title": "X3DFields.TSFBool.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#Create"},
     {"title": "X3DFields.TSFBool.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#ParseValue"},
     {"title": "X3DFields.TSFBool.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#EqualsDefaultValue"},
     {"title": "X3DFields.TSFBool.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#Equals"},
     {"title": "X3DFields.TSFBool.FastEqualsValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#FastEqualsValue"},
     {"title": "X3DFields.TSFBool.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#Assign"},
     {"title": "X3DFields.TSFBool.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#AssignValue"},
     {"title": "X3DFields.TSFBool.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TSFBool.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#X3DType"},
     {"title": "X3DFields.TSFBool.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#CreateEvent"},
     {"title": "X3DFields.TSFBool.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFBool.html#Send"},
     {"title": "X3DFields.TSFEnum", "text": "  This is deprecated, as VRML 1.0 is an ancient format now. ", "tags": "", "loc": "X3DFields.TSFEnum.html"},
     {"title": "X3DFields.TSFEnum.Value", "text": " EnumCount - 1. By default 0. ", "tags": "", "loc": "X3DFields.TSFEnum.html#Value"},
     {"title": "X3DFields.TSFEnum.DefaultValue", "text": " ", "tags": "", "loc": "X3DFields.TSFEnum.html#DefaultValue"},
     {"title": "X3DFields.TSFEnum.DefaultValueExists", "text": " ", "tags": "", "loc": "X3DFields.TSFEnum.html#DefaultValueExists"},
     {"title": "X3DFields.TSFEnum.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#Create"},
     {"title": "X3DFields.TSFEnum.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#Destroy"},
     {"title": "X3DFields.TSFEnum.EnumNamesCount", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#EnumNamesCount"},
     {"title": "X3DFields.TSFEnum.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#ParseValue"},
     {"title": "X3DFields.TSFEnum.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#EqualsDefaultValue"},
     {"title": "X3DFields.TSFEnum.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#Equals"},
     {"title": "X3DFields.TSFEnum.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#Assign"},
     {"title": "X3DFields.TSFEnum.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#AssignValue"},
     {"title": "X3DFields.TSFEnum.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TSFEnum.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#X3DType"},
     {"title": "X3DFields.TSFEnum.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFEnum.html#Send"},
     {"title": "X3DFields.TSFEnum.EnumNames", "text": " Note that this cannot be initialized by <a class=\"normal\" href=\"X3DFields.TX3DField.html#CreateUndefined\">CreateUndefined</a>, so you always must initialize this field using the <a class=\"normal\" href=\"X3DFields.TSFEnum.html#Create\">Create</a> overload that takes AEnumNames parameter. ", "tags": "", "loc": "X3DFields.TSFEnum.html#EnumNames"},
     {"title": "X3DFields.TSFFloat", "text": " ", "tags": "", "loc": "X3DFields.TSFFloat.html"},
     {"title": "X3DFields.TSFFloat.DefaultValue", "text": " ", "tags": "", "loc": "X3DFields.TSFFloat.html#DefaultValue"},
     {"title": "X3DFields.TSFFloat.DefaultValueExists", "text": " ", "tags": "", "loc": "X3DFields.TSFFloat.html#DefaultValueExists"},
     {"title": "X3DFields.TSFFloat.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#Create"},
     {"title": "X3DFields.TSFFloat.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#ParseValue"},
     {"title": "X3DFields.TSFFloat.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#EqualsDefaultValue"},
     {"title": "X3DFields.TSFFloat.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#Equals"},
     {"title": "X3DFields.TSFFloat.FastEqualsValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#FastEqualsValue"},
     {"title": "X3DFields.TSFFloat.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#AssignLerp"},
     {"title": "X3DFields.TSFFloat.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#CanAssignLerp"},
     {"title": "X3DFields.TSFFloat.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#Assign"},
     {"title": "X3DFields.TSFFloat.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#AssignValue"},
     {"title": "X3DFields.TSFFloat.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TSFFloat.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#X3DType"},
     {"title": "X3DFields.TSFFloat.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#CreateEvent"},
     {"title": "X3DFields.TSFFloat.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFFloat.html#Send"},
     {"title": "X3DFields.TSFFloat.Value", "text": " ", "tags": "", "loc": "X3DFields.TSFFloat.html#Value"},
     {"title": "X3DFields.TSFFloat.MustBeNonnegative", "text": " This is nice e.g. for Sphere.FdRadius field &mdash; some incorrect VRML specify negative sphere radius. ", "tags": "", "loc": "X3DFields.TSFFloat.html#MustBeNonnegative"},
     {"title": "X3DFields.TSFFloat.Angle", "text": " When reading from X3D 3.3 file, we will make sure it's expressed in radians, honoring optional &quot;UNIT angle ...&quot; declaration in X3D file. ", "tags": "", "loc": "X3DFields.TSFFloat.html#Angle"},
     {"title": "X3DFields.TSFDouble", "text": " ", "tags": "", "loc": "X3DFields.TSFDouble.html"},
     {"title": "X3DFields.TSFDouble.DefaultValue", "text": " ", "tags": "", "loc": "X3DFields.TSFDouble.html#DefaultValue"},
     {"title": "X3DFields.TSFDouble.DefaultValueExists", "text": " ", "tags": "", "loc": "X3DFields.TSFDouble.html#DefaultValueExists"},
     {"title": "X3DFields.TSFDouble.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#Create"},
     {"title": "X3DFields.TSFDouble.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#ParseValue"},
     {"title": "X3DFields.TSFDouble.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#EqualsDefaultValue"},
     {"title": "X3DFields.TSFDouble.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#Equals"},
     {"title": "X3DFields.TSFDouble.FastEqualsValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#FastEqualsValue"},
     {"title": "X3DFields.TSFDouble.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#AssignLerp"},
     {"title": "X3DFields.TSFDouble.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#CanAssignLerp"},
     {"title": "X3DFields.TSFDouble.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#Assign"},
     {"title": "X3DFields.TSFDouble.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#AssignValue"},
     {"title": "X3DFields.TSFDouble.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TSFDouble.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#X3DType"},
     {"title": "X3DFields.TSFDouble.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#CreateEvent"},
     {"title": "X3DFields.TSFDouble.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFDouble.html#Send"},
     {"title": "X3DFields.TSFDouble.Value", "text": " ", "tags": "", "loc": "X3DFields.TSFDouble.html#Value"},
     {"title": "X3DFields.TSFDouble.Angle", "text": " When reading from X3D 3.3 file, we will make sure it's expressed in radians, honoring optional &quot;UNIT angle ...&quot; declaration in X3D file. ", "tags": "", "loc": "X3DFields.TSFDouble.html#Angle"},
     {"title": "X3DFields.TSFTime", "text": " ", "tags": "", "loc": "X3DFields.TSFTime.html"},
     {"title": "X3DFields.TSFTime.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFTime.html#X3DType"},
     {"title": "X3DFields.TSFTime.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFTime.html#CreateEvent"},
     {"title": "X3DFields.TSFTime.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFTime.html#Send"},
     {"title": "X3DFields.TSFImage", "text": " ", "tags": "", "loc": "X3DFields.TSFImage.html"},
     {"title": "X3DFields.TSFImage.Create", "text": "  AValue is the initial value for Value.  <p>Note - our constructor COPIES passed reference AValue, not it's contents (I mean, we do Value := AValue, NOT Value := ImageCopy(AValue), so don't Free image given to us (at least, don't do this without clearing our Value field)). You can pass AValue = nil, then Value will be initialized to null image TRGBImage.Create.  AValue is the initial value for Value.  <p>Note - our constructor COPIES passed reference AValue, not it's contents (I mean, we do Value := AValue, NOT Value := ImageCopy(AValue), so don't Free image given to us (at least, don't do this without clearing our Value field)). You can pass AValue = nil, then Value will be initialized to null image TRGBImage.Create.", "tags": "", "loc": "X3DFields.TSFImage.html#Create"},
     {"title": "X3DFields.TSFImage.CreateUndefined", "text": "    ", "tags": "", "loc": "X3DFields.TSFImage.html#CreateUndefined"},
     {"title": "X3DFields.TSFImage.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TSFImage.html#Destroy"},
     {"title": "X3DFields.TSFImage.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFImage.html#ParseValue"},
     {"title": "X3DFields.TSFImage.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFImage.html#Equals"},
     {"title": "X3DFields.TSFImage.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFImage.html#Assign"},
     {"title": "X3DFields.TSFImage.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFImage.html#AssignValue"},
     {"title": "X3DFields.TSFImage.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFImage.html#X3DType"},
     {"title": "X3DFields.TSFImage.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFImage.html#CreateEvent"},
     {"title": "X3DFields.TSFImage.Value", "text": "  <p>The image instance is by default owned by this object, which means that we will free it in destructor or when setting another value.  <p>Value may be IsEmpty, and then we know that there is no image recorded in this field. Value may never be <code>Nil</code>. ", "tags": "", "loc": "X3DFields.TSFImage.html#Value"},
     {"title": "X3DFields.TSFLong", "text": " ", "tags": "", "loc": "X3DFields.TSFLong.html"},
     {"title": "X3DFields.TSFLong.DefaultValue", "text": " ", "tags": "", "loc": "X3DFields.TSFLong.html#DefaultValue"},
     {"title": "X3DFields.TSFLong.DefaultValueExists", "text": " ", "tags": "", "loc": "X3DFields.TSFLong.html#DefaultValueExists"},
     {"title": "X3DFields.TSFLong.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#Create"},
     {"title": "X3DFields.TSFLong.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#ParseValue"},
     {"title": "X3DFields.TSFLong.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#EqualsDefaultValue"},
     {"title": "X3DFields.TSFLong.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#Equals"},
     {"title": "X3DFields.TSFLong.FastEqualsValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#FastEqualsValue"},
     {"title": "X3DFields.TSFLong.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#Assign"},
     {"title": "X3DFields.TSFLong.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#AssignValue"},
     {"title": "X3DFields.TSFLong.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TSFLong.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#X3DType"},
     {"title": "X3DFields.TSFLong.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#CreateEvent"},
     {"title": "X3DFields.TSFLong.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFLong.html#Send"},
     {"title": "X3DFields.TSFLong.Value", "text": " ", "tags": "", "loc": "X3DFields.TSFLong.html#Value"},
     {"title": "X3DFields.TSFLong.MustBeNonnegative", "text": " ", "tags": "", "loc": "X3DFields.TSFLong.html#MustBeNonnegative"},
     {"title": "X3DFields.TSFInt32", "text": " The name SFInt32 is used instead of SFLong in new X3D versions. ", "tags": "", "loc": "X3DFields.TSFInt32.html"},
     {"title": "X3DFields.TSFInt32.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFInt32.html#X3DType"},
     {"title": "X3DFields.TSFInt32.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFInt32.html#CreateEvent"},
     {"title": "X3DFields.TSFInt32.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFInt32.html#Send"},
     {"title": "X3DFields.TSFGenericMatrix", "text": " ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html"},
     {"title": "X3DFields.TSFGenericMatrix.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#Create"},
     {"title": "X3DFields.TSFGenericMatrix.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#ParseValue"},
     {"title": "X3DFields.TSFGenericMatrix.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#EqualsDefaultValue"},
     {"title": "X3DFields.TSFGenericMatrix.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#Equals"},
     {"title": "X3DFields.TSFGenericMatrix.FastEqualsValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#FastEqualsValue"},
     {"title": "X3DFields.TSFGenericMatrix.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#AssignLerp"},
     {"title": "X3DFields.TSFGenericMatrix.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#CanAssignLerp"},
     {"title": "X3DFields.TSFGenericMatrix.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#Assign"},
     {"title": "X3DFields.TSFGenericMatrix.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#AssignValue"},
     {"title": "X3DFields.TSFGenericMatrix.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TSFGenericMatrix.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#Send"},
     {"title": "X3DFields.TSFGenericMatrix.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#CreateEvent"},
     {"title": "X3DFields.TSFGenericMatrix.Value", "text": " ", "tags": "", "loc": "X3DFields.TSFGenericMatrix.html#Value"},
     {"title": "X3DFields.TSFMatrix3f", "text": " ", "tags": "", "loc": "X3DFields.TSFMatrix3f.html"},
     {"title": "X3DFields.TSFMatrix3f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix3f.html#X3DType"},
     {"title": "X3DFields.TSFMatrix3d", "text": " ", "tags": "", "loc": "X3DFields.TSFMatrix3d.html"},
     {"title": "X3DFields.TSFMatrix3d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix3d.html#X3DType"},
     {"title": "X3DFields.TSFMatrix4f", "text": " ", "tags": "", "loc": "X3DFields.TSFMatrix4f.html"},
     {"title": "X3DFields.TSFMatrix4f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix4f.html#X3DType"},
     {"title": "X3DFields.TSFMatrix4f.TransformScale", "text": "  <p>Note that this doesn't correctly extract scale from matrix, as that is too difficcult. Insted it does simple extraction, which will work for identity, translation and scaling matrices (but e.g. will fail miserably (generate nonsense results) when looking at some rotation matrices).    ", "tags": "", "loc": "X3DFields.TSFMatrix4f.html#TransformScale"},
     {"title": "X3DFields.TSFMatrix4d", "text": " ", "tags": "", "loc": "X3DFields.TSFMatrix4d.html"},
     {"title": "X3DFields.TSFMatrix4d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix4d.html#X3DType"},
     {"title": "X3DFields.TSFMatrix", "text": "  This is deprecated, as VRML 1.0 is an ancient format now. ", "tags": "", "loc": "X3DFields.TSFMatrix.html"},
     {"title": "X3DFields.TSFMatrix.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFMatrix.html#X3DType"},
     {"title": "X3DFields.TSFRotation", "text": " ", "tags": "", "loc": "X3DFields.TSFRotation.html"},
     {"title": "X3DFields.TSFRotation.Axis", "text": " ", "tags": "", "loc": "X3DFields.TSFRotation.html#Axis"},
     {"title": "X3DFields.TSFRotation.RotationRad", "text": " ", "tags": "", "loc": "X3DFields.TSFRotation.html#RotationRad"},
     {"title": "X3DFields.TSFRotation.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#Create"},
     {"title": "X3DFields.TSFRotation.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#Create"},
     {"title": "X3DFields.TSFRotation.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#ParseValue"},
     {"title": "X3DFields.TSFRotation.RotatedPoint", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#RotatedPoint"},
     {"title": "X3DFields.TSFRotation.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#Equals"},
     {"title": "X3DFields.TSFRotation.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#EqualsDefaultValue"},
     {"title": "X3DFields.TSFRotation.FastEqualsValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#FastEqualsValue"},
     {"title": "X3DFields.TSFRotation.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#AssignLerp"},
     {"title": "X3DFields.TSFRotation.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#CanAssignLerp"},
     {"title": "X3DFields.TSFRotation.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#Assign"},
     {"title": "X3DFields.TSFRotation.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#AssignValue"},
     {"title": "X3DFields.TSFRotation.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TSFRotation.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#X3DType"},
     {"title": "X3DFields.TSFRotation.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#CreateEvent"},
     {"title": "X3DFields.TSFRotation.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFRotation.html#Send"},
     {"title": "X3DFields.TSFRotation.Value", "text": "  <p>This internally gets / sets values from <a class=\"normal\" href=\"X3DFields.TSFRotation.html#Axis\">Axis</a>, <a class=\"normal\" href=\"X3DFields.TSFRotation.html#RotationRad\">RotationRad</a>, it only presents them to you differently. ", "tags": "", "loc": "X3DFields.TSFRotation.html#Value"},
     {"title": "X3DFields.TSFRotation.ValueDeg", "text": "  <p>So this is just like <a class=\"normal\" href=\"X3DFields.TSFRotation.html#Value\">Value</a>, but last component is in degrees. This internally gets / sets values from <a class=\"normal\" href=\"X3DFields.TSFRotation.html#Axis\">Axis</a>, <a class=\"normal\" href=\"X3DFields.TSFRotation.html#RotationRad\">RotationRad</a>, it only presents them to you differently. ", "tags": "", "loc": "X3DFields.TSFRotation.html#ValueDeg"},
     {"title": "X3DFields.TSFString", "text": " ", "tags": "", "loc": "X3DFields.TSFString.html"},
     {"title": "X3DFields.TSFString.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#Create"},
     {"title": "X3DFields.TSFString.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#ParseValue"},
     {"title": "X3DFields.TSFString.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#EqualsDefaultValue"},
     {"title": "X3DFields.TSFString.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#Equals"},
     {"title": "X3DFields.TSFString.FastEqualsValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#FastEqualsValue"},
     {"title": "X3DFields.TSFString.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#Assign"},
     {"title": "X3DFields.TSFString.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#AssignValue"},
     {"title": "X3DFields.TSFString.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TSFString.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#X3DType"},
     {"title": "X3DFields.TSFString.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#CreateEvent"},
     {"title": "X3DFields.TSFString.ParseXMLAttribute", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#ParseXMLAttribute"},
     {"title": "X3DFields.TSFString.SaveToXmlValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#SaveToXmlValue"},
     {"title": "X3DFields.TSFString.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFString.html#Send"},
     {"title": "X3DFields.TSFString.DefaultValue", "text": " ", "tags": "", "loc": "X3DFields.TSFString.html#DefaultValue"},
     {"title": "X3DFields.TSFString.DefaultValueExists", "text": " ", "tags": "", "loc": "X3DFields.TSFString.html#DefaultValueExists"},
     {"title": "X3DFields.TSFString.Value", "text": " ", "tags": "", "loc": "X3DFields.TSFString.html#Value"},
     {"title": "X3DFields.TSFStringEnum", "text": " This represents a commonly used VRML/X3D construct where SFString field is used to hold values from some limited set, thus emulating an &quot;enumerated&quot; field.  <p>Access the <a class=\"normal\" href=\"X3DFields.TSFStringEnum.html#EnumValue\">EnumValue</a> to get / set the field value as an integer, which is an index to ValueNames array. ", "tags": "", "loc": "X3DFields.TSFStringEnum.html"},
     {"title": "X3DFields.TSFStringEnum.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFStringEnum.html#Create"},
     {"title": "X3DFields.TSFStringEnum.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TSFStringEnum.html#Destroy"},
     {"title": "X3DFields.TSFStringEnum.SendEnumValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFStringEnum.html#SendEnumValue"},
     {"title": "X3DFields.TSFStringEnum.EnumValue", "text": " ", "tags": "", "loc": "X3DFields.TSFStringEnum.html#EnumValue"},
     {"title": "X3DFields.TSFStringEnum.DefaultEnumValue", "text": " ", "tags": "", "loc": "X3DFields.TSFStringEnum.html#DefaultEnumValue"},
     {"title": "X3DFields.TSFGenericVector", "text": " ", "tags": "", "loc": "X3DFields.TSFGenericVector.html"},
     {"title": "X3DFields.TSFGenericVector.Value", "text": " ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#Value"},
     {"title": "X3DFields.TSFGenericVector.DefaultValue", "text": " ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#DefaultValue"},
     {"title": "X3DFields.TSFGenericVector.DefaultValueExists", "text": " ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#DefaultValueExists"},
     {"title": "X3DFields.TSFGenericVector.Create", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#Create"},
     {"title": "X3DFields.TSFGenericVector.ParseValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#ParseValue"},
     {"title": "X3DFields.TSFGenericVector.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#EqualsDefaultValue"},
     {"title": "X3DFields.TSFGenericVector.Equals", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#Equals"},
     {"title": "X3DFields.TSFGenericVector.FastEqualsValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#FastEqualsValue"},
     {"title": "X3DFields.TSFGenericVector.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#AssignLerp"},
     {"title": "X3DFields.TSFGenericVector.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#CanAssignLerp"},
     {"title": "X3DFields.TSFGenericVector.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#Assign"},
     {"title": "X3DFields.TSFGenericVector.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#AssignValue"},
     {"title": "X3DFields.TSFGenericVector.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TSFGenericVector.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#Send"},
     {"title": "X3DFields.TSFGenericVector.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFGenericVector.html#CreateEvent"},
     {"title": "X3DFields.TSFVec2f", "text": " ", "tags": "", "loc": "X3DFields.TSFVec2f.html"},
     {"title": "X3DFields.TSFVec2f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec2f.html#X3DType"},
     {"title": "X3DFields.TSFVec3f", "text": " ", "tags": "", "loc": "X3DFields.TSFVec3f.html"},
     {"title": "X3DFields.TSFVec3f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec3f.html#X3DType"},
     {"title": "X3DFields.TSFVec3f.Send", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec3f.html#Send"},
     {"title": "X3DFields.TSFColor", "text": " ", "tags": "", "loc": "X3DFields.TSFColor.html"},
     {"title": "X3DFields.TSFColor.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFColor.html#X3DType"},
     {"title": "X3DFields.TSFColor.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFColor.html#CreateEvent"},
     {"title": "X3DFields.TSFVec4f", "text": " ", "tags": "", "loc": "X3DFields.TSFVec4f.html"},
     {"title": "X3DFields.TSFVec4f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec4f.html#X3DType"},
     {"title": "X3DFields.TSFColorRGBA", "text": " ", "tags": "", "loc": "X3DFields.TSFColorRGBA.html"},
     {"title": "X3DFields.TSFColorRGBA.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFColorRGBA.html#X3DType"},
     {"title": "X3DFields.TSFColorRGBA.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TSFColorRGBA.html#CreateEvent"},
     {"title": "X3DFields.TSFVec2d", "text": " ", "tags": "", "loc": "X3DFields.TSFVec2d.html"},
     {"title": "X3DFields.TSFVec2d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec2d.html#X3DType"},
     {"title": "X3DFields.TSFVec3d", "text": " ", "tags": "", "loc": "X3DFields.TSFVec3d.html"},
     {"title": "X3DFields.TSFVec3d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec3d.html#X3DType"},
     {"title": "X3DFields.TSFVec4d", "text": " ", "tags": "", "loc": "X3DFields.TSFVec4d.html"},
     {"title": "X3DFields.TSFVec4d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TSFVec4d.html#X3DType"},
     {"title": "X3DFields.TX3DMultField", "text": " ", "tags": "", "loc": "X3DFields.TX3DMultField.html"},
     {"title": "X3DFields.TX3DMultField.Count", "text": "  <p>Remember that increasing this generally sets new items to undefined values (see SetCount documentation of particular descendant for docs). So you usually want to initialize them afterwards to something correct. ", "tags": "", "loc": "X3DFields.TX3DMultField.html#Count"},
     {"title": "X3DFields.TX3DSimpleMultField", "text": " This is an ancestor of most multiple-value X3D fields. ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html"},
     {"title": "X3DFields.TX3DSimpleMultField.Create", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#Create"},
     {"title": "X3DFields.TX3DSimpleMultField.CreateUndefined", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#CreateUndefined"},
     {"title": "X3DFields.TX3DSimpleMultField.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#Destroy"},
     {"title": "X3DFields.TX3DSimpleMultField.Assign", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#Assign"},
     {"title": "X3DFields.TX3DSimpleMultField.AssignValue", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#AssignValue"},
     {"title": "X3DFields.TX3DSimpleMultField.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#AssignDefaultValueFromValue"},
     {"title": "X3DFields.TX3DSimpleMultField.ParseValue", "text": " This class handles parsing fully, usually no need to override this more in descendants. It uses TSingleField.Parse method.    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#ParseValue"},
     {"title": "X3DFields.TX3DSimpleMultField.Equals", "text": " In addition to inherited(Equals), this checks the actual contents of the items. Note that floating-point values are compared with some tolerance for errors by this method.    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#Equals"},
     {"title": "X3DFields.TX3DSimpleMultField.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#EqualsDefaultValue"},
     {"title": "X3DFields.TX3DSimpleMultField.ParseXMLAttributeLexer", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#ParseXMLAttributeLexer"},
     {"title": "X3DFields.TX3DSimpleMultField.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#CreateEvent"},
     {"title": "X3DFields.TX3DSimpleMultField.Send", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#Send"},
     {"title": "X3DFields.TX3DSimpleMultField.Send", "text": "    ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#Send"},
     {"title": "X3DFields.TX3DSimpleMultField.Items", "text": " ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#Items"},
     {"title": "X3DFields.TX3DSimpleMultField.ItemsSafe", "text": " In case of errors, Get will return false, Set will do nothing, and both will produce clear <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>. ", "tags": "", "loc": "X3DFields.TX3DSimpleMultField.html#ItemsSafe"},
     {"title": "X3DFields.TMFBool", "text": " ", "tags": "", "loc": "X3DFields.TMFBool.html"},
     {"title": "X3DFields.TMFBool.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFBool.html#X3DType"},
     {"title": "X3DFields.TMFLong", "text": " ", "tags": "", "loc": "X3DFields.TMFLong.html"},
     {"title": "X3DFields.TMFLong.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFLong.html#X3DType"},
     {"title": "X3DFields.TMFLong.WritelnWarning_WrongVertexIndex", "text": " This simply calls <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> formatting appropriate message.  <p>Additionally this guards us against producing too many warnings from the same field. When a given threshold will be reached, further <code>WritelnWarning_WrongVertexIndex</code> calls for this field instance will be simply ignored. This is a good thing, as some invalid models have really an incredible amount of invalid indexes, and the very amount of lines printed on console makes viewing these invalid files (at least, the valid parts of them) impossible.  <p>Example test cases: content/examples/Basic/HumanoidAnimation/AllenStandShootRifleM24.x3d and content/examples/Basic/HumanoidAnimation/NancyDiving.x3dv from <a  href=\"http://www.web3d.org/\">http://www.web3d.org/</a> example models.    ", "tags": "", "loc": "X3DFields.TMFLong.html#WritelnWarning_WrongVertexIndex"},
     {"title": "X3DFields.TMFLong.SaveToStreamLineUptoNegative", "text": " This makes a nice output for fields like IndexedFaceSet.coordIndex. ", "tags": "", "loc": "X3DFields.TMFLong.html#SaveToStreamLineUptoNegative"},
     {"title": "X3DFields.TMFInt32", "text": " ", "tags": "", "loc": "X3DFields.TMFInt32.html"},
     {"title": "X3DFields.TMFInt32.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFInt32.html#X3DType"},
     {"title": "X3DFields.TMFInt32.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TMFInt32.html#CreateEvent"},
     {"title": "X3DFields.TMFMatrix3f", "text": " ", "tags": "", "loc": "X3DFields.TMFMatrix3f.html"},
     {"title": "X3DFields.TMFMatrix3f.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix3f.html#AssignLerp"},
     {"title": "X3DFields.TMFMatrix3f.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix3f.html#CanAssignLerp"},
     {"title": "X3DFields.TMFMatrix3f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix3f.html#X3DType"},
     {"title": "X3DFields.TMFMatrix3d", "text": " ", "tags": "", "loc": "X3DFields.TMFMatrix3d.html"},
     {"title": "X3DFields.TMFMatrix3d.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix3d.html#AssignLerp"},
     {"title": "X3DFields.TMFMatrix3d.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix3d.html#CanAssignLerp"},
     {"title": "X3DFields.TMFMatrix3d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix3d.html#X3DType"},
     {"title": "X3DFields.TMFMatrix4f", "text": " ", "tags": "", "loc": "X3DFields.TMFMatrix4f.html"},
     {"title": "X3DFields.TMFMatrix4f.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix4f.html#AssignLerp"},
     {"title": "X3DFields.TMFMatrix4f.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix4f.html#CanAssignLerp"},
     {"title": "X3DFields.TMFMatrix4f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix4f.html#X3DType"},
     {"title": "X3DFields.TMFMatrix4d", "text": " ", "tags": "", "loc": "X3DFields.TMFMatrix4d.html"},
     {"title": "X3DFields.TMFMatrix4d.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix4d.html#AssignLerp"},
     {"title": "X3DFields.TMFMatrix4d.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix4d.html#CanAssignLerp"},
     {"title": "X3DFields.TMFMatrix4d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFMatrix4d.html#X3DType"},
     {"title": "X3DFields.TMFVec2f", "text": " ", "tags": "", "loc": "X3DFields.TMFVec2f.html"},
     {"title": "X3DFields.TMFVec2f.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec2f.html#AssignLerp"},
     {"title": "X3DFields.TMFVec2f.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec2f.html#CanAssignLerp"},
     {"title": "X3DFields.TMFVec2f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec2f.html#X3DType"},
     {"title": "X3DFields.TMFVec3f", "text": " ", "tags": "", "loc": "X3DFields.TMFVec3f.html"},
     {"title": "X3DFields.TMFVec3f.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec3f.html#AssignLerp"},
     {"title": "X3DFields.TMFVec3f.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec3f.html#CanAssignLerp"},
     {"title": "X3DFields.TMFVec3f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec3f.html#X3DType"},
     {"title": "X3DFields.TMFColor", "text": " ", "tags": "", "loc": "X3DFields.TMFColor.html"},
     {"title": "X3DFields.TMFColor.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFColor.html#X3DType"},
     {"title": "X3DFields.TMFColor.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TMFColor.html#CreateEvent"},
     {"title": "X3DFields.TMFVec4f", "text": " ", "tags": "", "loc": "X3DFields.TMFVec4f.html"},
     {"title": "X3DFields.TMFVec4f.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec4f.html#AssignLerp"},
     {"title": "X3DFields.TMFVec4f.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec4f.html#CanAssignLerp"},
     {"title": "X3DFields.TMFVec4f.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec4f.html#X3DType"},
     {"title": "X3DFields.TMFColorRGBA", "text": " ", "tags": "", "loc": "X3DFields.TMFColorRGBA.html"},
     {"title": "X3DFields.TMFColorRGBA.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFColorRGBA.html#X3DType"},
     {"title": "X3DFields.TMFColorRGBA.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TMFColorRGBA.html#CreateEvent"},
     {"title": "X3DFields.TMFVec2d", "text": " ", "tags": "", "loc": "X3DFields.TMFVec2d.html"},
     {"title": "X3DFields.TMFVec2d.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec2d.html#AssignLerp"},
     {"title": "X3DFields.TMFVec2d.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec2d.html#CanAssignLerp"},
     {"title": "X3DFields.TMFVec2d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec2d.html#X3DType"},
     {"title": "X3DFields.TMFVec3d", "text": " ", "tags": "", "loc": "X3DFields.TMFVec3d.html"},
     {"title": "X3DFields.TMFVec3d.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec3d.html#AssignLerp"},
     {"title": "X3DFields.TMFVec3d.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec3d.html#CanAssignLerp"},
     {"title": "X3DFields.TMFVec3d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec3d.html#X3DType"},
     {"title": "X3DFields.TMFVec4d", "text": " ", "tags": "", "loc": "X3DFields.TMFVec4d.html"},
     {"title": "X3DFields.TMFVec4d.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec4d.html#AssignLerp"},
     {"title": "X3DFields.TMFVec4d.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec4d.html#CanAssignLerp"},
     {"title": "X3DFields.TMFVec4d.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFVec4d.html#X3DType"},
     {"title": "X3DFields.TMFRotation", "text": " ", "tags": "", "loc": "X3DFields.TMFRotation.html"},
     {"title": "X3DFields.TMFRotation.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFRotation.html#AssignLerp"},
     {"title": "X3DFields.TMFRotation.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFRotation.html#CanAssignLerp"},
     {"title": "X3DFields.TMFRotation.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFRotation.html#X3DType"},
     {"title": "X3DFields.TMFFloat", "text": " ", "tags": "", "loc": "X3DFields.TMFFloat.html"},
     {"title": "X3DFields.TMFFloat.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFFloat.html#AssignLerp"},
     {"title": "X3DFields.TMFFloat.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFFloat.html#CanAssignLerp"},
     {"title": "X3DFields.TMFFloat.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFFloat.html#X3DType"},
     {"title": "X3DFields.TMFFloat.Angle", "text": " When reading from X3D 3.3 file, we will make sure it's expressed in radians, honoring optional &quot;UNIT angle ...&quot; declaration in X3D file. ", "tags": "", "loc": "X3DFields.TMFFloat.html#Angle"},
     {"title": "X3DFields.TMFDouble", "text": " ", "tags": "", "loc": "X3DFields.TMFDouble.html"},
     {"title": "X3DFields.TMFDouble.AssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFDouble.html#AssignLerp"},
     {"title": "X3DFields.TMFDouble.CanAssignLerp", "text": "    ", "tags": "", "loc": "X3DFields.TMFDouble.html#CanAssignLerp"},
     {"title": "X3DFields.TMFDouble.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFDouble.html#X3DType"},
     {"title": "X3DFields.TMFTime", "text": " ", "tags": "", "loc": "X3DFields.TMFTime.html"},
     {"title": "X3DFields.TMFTime.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFTime.html#X3DType"},
     {"title": "X3DFields.TMFTime.CreateEvent", "text": "    ", "tags": "", "loc": "X3DFields.TMFTime.html#CreateEvent"},
     {"title": "X3DFields.TMFString", "text": " ", "tags": "", "loc": "X3DFields.TMFString.html"},
     {"title": "X3DFields.TMFString.X3DType", "text": "    ", "tags": "", "loc": "X3DFields.TMFString.html#X3DType"},
     {"title": "X3DFields.TMFString.ParseXMLAttribute", "text": "    ", "tags": "", "loc": "X3DFields.TMFString.html#ParseXMLAttribute"},
     {"title": "X3DFields.TMFString.SaveToXmlValue", "text": "    ", "tags": "", "loc": "X3DFields.TMFString.html#SaveToXmlValue"},
     {"title": "X3DFields.TX3DFieldsManager", "text": " The only use for now is to make a mapping from VRML/X3D field name to actual class (needed by VRML/X3D interface declarations). ", "tags": "", "loc": "X3DFields.TX3DFieldsManager.html"},
     {"title": "X3DFields.TX3DFieldsManager.Create", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldsManager.html#Create"},
     {"title": "X3DFields.TX3DFieldsManager.Destroy", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldsManager.html#Destroy"},
     {"title": "X3DFields.TX3DFieldsManager.RegisterClass", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldsManager.html#RegisterClass"},
     {"title": "X3DFields.TX3DFieldsManager.RegisterClasses", "text": "    ", "tags": "", "loc": "X3DFields.TX3DFieldsManager.html#RegisterClasses"},
     {"title": "X3DFields.TX3DFieldsManager.X3DTypeToClass", "text": " Returns <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DFields.TX3DFieldsManager.html#X3DTypeToClass"},
     {"title": "X3DFields.X3DChangeToStr", "text": " ", "tags": "", "loc": "X3DFields.html#X3DChangeToStr"},
     {"title": "X3DFields.X3DFieldsManager", "text": "    ", "tags": "", "loc": "X3DFields.html#X3DFieldsManager"},
     {"title": "X3DFields.DecodeX3DColor", "text": "     ", "tags": "", "loc": "X3DFields.html#DecodeX3DColor"},
     {"title": "X3DFields.DecodeX3DColor", "text": "    ", "tags": "", "loc": "X3DFields.html#DecodeX3DColor"},
     {"title": "X3DFields.DecodeX3DColor", "text": "    ", "tags": "", "loc": "X3DFields.html#DecodeX3DColor"},
     {"title": "X3DFields.DecodeX3DColor", "text": "    ", "tags": "", "loc": "X3DFields.html#DecodeX3DColor"},
     {"title": "X3DFields.DecodeX3DColor", "text": "    ", "tags": "", "loc": "X3DFields.html#DecodeX3DColor"},
     {"title": "X3DFields.DecodeX3DColor", "text": "    ", "tags": "", "loc": "X3DFields.html#DecodeX3DColor"},
     {"title": "X3DFields.DecodeX3DColor", "text": "    ", "tags": "", "loc": "X3DFields.html#DecodeX3DColor"},
     {"title": "X3DFields.DecodeX3DColor", "text": "    ", "tags": "", "loc": "X3DFields.html#DecodeX3DColor"},
     {"title": "X3DFields.X3DChangesToStr", "text": "    ", "tags": "", "loc": "X3DFields.html#X3DChangesToStr"},
     {"title": "X3DFields.TSaveToXmlMethod", "text": "  sxNone    sxAttribute    sxAttributeCustomQuotes    sxChildElement   ", "tags": "", "loc": "X3DFields.html#TSaveToXmlMethod"},
     {"title": "X3DFields.TX3DChange", "text": " Used by <a class=\"normal\" href=\"X3DFields.TX3DField.html#ExecuteChanges\">TX3DField.ExecuteChanges</a>.  chVisibleGeometry Something visible in the geometry changed.  See <a class=\"normal\" href=\"Castle3D.html#vcVisibleGeometry\">vcVisibleGeometry</a>. This means that VisibleChangeHere with <a class=\"normal\" href=\"Castle3D.html#vcVisibleGeometry\">vcVisibleGeometry</a> included should be called.  chVisibleNonGeometry Something visible changed, but not geometry.  See <a class=\"normal\" href=\"Castle3D.html#vcVisibleNonGeometry\">vcVisibleNonGeometry</a>. This means that VisibleChangeHere with <a class=\"normal\" href=\"Castle3D.html#vcVisibleNonGeometry\">vcVisibleNonGeometry</a> included should be called.  chRedisplay Call VisibleChangeHere to redisplay the scene.   <p>If you include one of the <a class=\"normal\" href=\"X3DFields.html#chVisibleGeometry\">chVisibleGeometry</a> or <a class=\"normal\" href=\"X3DFields.html#chVisibleNonGeometry\">chVisibleNonGeometry</a> then this flag (<code>chRedisplay</code>) makes no effect. Otherwise, this flag should be used if your change requires redisplay of the 3D view for some other reason.  chTransform Transformation of children of this node changed.   <p>Caller will analyze the scene (your children) to know what this implicates, don't include other flags with this.  chCoordinate Coordinate (both VRML 1.0 and &gt;= 2.0) node &quot;point&quot; field changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chVisibleVRML1State Something visible in VRML 1.0 state node (that may be present in <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#VRML1State\">TX3DGraphTraverseState.VRML1State</a>) changed, but not geometry.  Excluding Coordinate node change (this one should go through <a class=\"normal\" href=\"X3DFields.html#chCoordinate\">chCoordinate</a> only).  <p>This is allowed, and ignored, on nodes that are not part of VRML 1.0 state. (This is useful for alphaChannel field, that is declared in <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a>, and so is part of some VRML 1.0 state nodes but is also part of VRML &gt;= 2.0 nodes.)  <p>Caller will analyze the scene to know what this implicates, don't include other flags with this. Exception: you can (and should) include <a class=\"normal\" href=\"X3DFields.html#chUseBlending\">chUseBlending</a> and <a class=\"normal\" href=\"X3DFields.html#chTextureImage\">chTextureImage</a> for appropriate changes.  chGeometryVRML1State Some visible geometry changed because of VRML 1.0 state node change.  This is for VRML 1.0 state node changes, excluding non-geometry changes (these go to <a class=\"normal\" href=\"X3DFields.html#chVisibleVRML1State\">chVisibleVRML1State</a>) and Coordinate changes (these go to <a class=\"normal\" href=\"X3DFields.html#chCoordinate\">chCoordinate</a>).  <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chMaterial2 Something visible in VRML &gt;= 2.0 Material (or TwoSidedMaterial) changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this. Exception: you can (and should) include <a class=\"normal\" href=\"X3DFields.html#chUseBlending\">chUseBlending</a> for appropriate Material changes.  chUseBlending Something that may affect UseBlending calculation possibly changed.  This is guaranteed to work only when used together with <a class=\"normal\" href=\"X3DFields.html#chVisibleVRML1State\">chVisibleVRML1State</a> and <a class=\"normal\" href=\"X3DFields.html#chMaterial2\">chMaterial2</a>. It's understood that only shapes that use given material need UseBlending recalculated.  chLightInstanceProperty Light property that is also reflected in <a class=\"normal\" href=\"X3DNodes.TLightInstance.html\">TLightInstance</a> structure.  Only allowed on node's descending from <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html\">TAbstractLightNode</a>.  <p>Caller will analyze the scene to know what this implicates, don't include other flags with this. Exception: include also <a class=\"normal\" href=\"X3DFields.html#chLightLocationDirection\">chLightLocationDirection</a> when appropriate.  chLightLocationDirection Light's location and/or direction changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this. Exception: include also <a class=\"normal\" href=\"X3DFields.html#chLightInstanceProperty\">chLightInstanceProperty</a> when appropriate.  chLightForShadowVolumes <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#MainLightForShadows\">TCastleSceneCore.MainLightForShadows</a> possibly changed because of this change.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chSwitch2 Switch.whichChoice changed, for VRML &gt;= 2.0.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chColorNode X3DColorNode colors changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chTextureCoordinate X3DTextureCoordinateNode coords changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chTextureTransform VRML &gt;= 2.0 TextureTransform changed.  Not for multi-texture node changes, only the simple nodes changes.  <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chGeometry Geometry node visible (or collidable) changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chEnvironmentalSensorBounds X3DEnvironmentalSensorNode bounds (size/center) changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chTimeStopStart TimeDependent node is start/stop/pause/resume time changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chViewpointVectors Viewpoint vectors (position, direction, up, gravity up) changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chViewpointProjection Viewpoint projection changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chTextureImage Texture image (data) needs reloading (url or source SFImage data changed).  This is for <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html\">TAbstractTexture2DNode</a>, or <a class=\"normal\" href=\"X3DNodes.TAbstractTexture3DNode.html\">TAbstractTexture3DNode</a>.  <p>Caller will analyze the scene to know what this implicates, don't include other flags with this. Exception: you can mix it with <a class=\"normal\" href=\"X3DFields.html#chVisibleVRML1State\">chVisibleVRML1State</a> or <a class=\"normal\" href=\"X3DFields.html#chTextureRendererProperties\">chTextureRendererProperties</a>.  chTextureRendererProperties Texture properties used by the renderer changed (something other than only the texture data).  This is for fields contained in X3DTextureNode.  <p>Caller will analyze the scene to know what this implicates, don't include other flags with this. Exception: you can mix it with <a class=\"normal\" href=\"X3DFields.html#chTextureImage\">chTextureImage</a>.  chTexturePropertiesNode Texture properties inside TextureProperties node changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chShadowCasters What is considered a shadow caster changed.   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chGeneratedTextureUpdateNeeded Mark the generated texture node (parent of this field) as requiring update (assuming it's &quot;update&quot; field value wants it too).   <p>Caller will analyze the scene to know what this implicates, don't include other flags with this.  chFontStyle VRML &gt;= 2.0 FontStyle changed.  Caller will analyze the scene to know what this implicates, don't include other flags with this.  chHeadLightOn HeadLight on status changed.  Caller will analyze the scene to know what this implicates, don't include other flags with this.  chClipPlane Clip plane visible change (enabled or plane equation).   chDragSensorEnabled Enabled field of the pointing-device drag sensor changed.  Use only for <a class=\"normal\" href=\"X3DFields.TSFBool.html\">TSFBool</a> fields within <a class=\"normal\" href=\"X3DNodes.TAbstractDragSensorNode.html\">TAbstractDragSensorNode</a>.  chNavigationInfo NavigationInfo field value used in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#NavigationTypeFromNavigationInfo\">TCastleSceneCore.NavigationTypeFromNavigationInfo</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#CameraFromNavigationInfo\">TCastleSceneCore.CameraFromNavigationInfo</a> changed.   chScreenEffectEnabled ScreenEffect.enabled changed   chBackground X3DBackgroundNode properties that are stored inside <a class=\"normal\" href=\"CastleBackground.TBackground.html\">TBackground</a> display list have changed.   chEverything Everything changed and needs to be recalculated.  This is needed for changes on stuff internally cached in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>, <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> that cannot be expressed as one of above flags.  <p>Use only as a last resort, as this is very costly! (And in an ideal implementation, should not be needed.)  <p>Don't include other flags with this.  chShadowMaps Higher-level shadow maps fields changed.  They have to be processed to lower-level fields by calling TCastleSceneCore.ProcessShadowMapsReceivers.  <p>Don't include other flags with this.  chWireframe Shading changed from wireframe to non-wireframe.  ", "tags": "", "loc": "X3DFields.html#TX3DChange"},
     {"title": "X3DFields.TX3DChanges", "text": " ", "tags": "", "loc": "X3DFields.html#TX3DChanges"},
     {"title": "X3DFields.TX3DFieldOrEventList", "text": " ", "tags": "", "loc": "X3DFields.html#TX3DFieldOrEventList"},
     {"title": "X3DFields.TX3DFieldClass", "text": " ", "tags": "", "loc": "X3DFields.html#TX3DFieldClass"},
     {"title": "X3DFields.TX3DEventReceive", "text": "    ", "tags": "", "loc": "X3DFields.html#TX3DEventReceive"},
     {"title": "X3DFields.TX3DSingleFieldClass", "text": " ", "tags": "", "loc": "X3DFields.html#TX3DSingleFieldClass"},
     {"title": "X3DFields.TX3DSingleFieldList", "text": " ", "tags": "", "loc": "X3DFields.html#TX3DSingleFieldList"},
     {"title": "X3DLoad", "text": "  <p>Every format except VRML/X3D is handled by converting it into X3D nodes graph. This allows to use our great X3D renderer, tools, saving to X3D and such, on every 3D model.  <p>Basic guide for adding a new 3D format:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> Particular formats are implemented inside various X3DLoadInternalXxx units. Implementation of this unit calls them. In the future, a mechanism that allows you to &quot;register&quot; an importer, without modifying this unit's implementation, may be done &mdash; report if needed.</p></li>   <li><p>3D formats are also listed in the file filters constants: see <a class=\"normal\" href=\"X3DLoad.html#Load3D_FileFilters\">Load3D_FileFilters</a> and <a class=\"normal\" href=\"X3DLoad.html#Load3DSequence_FileFilters\">Load3DSequence_FileFilters</a>. Each format has a file filter to specifically choose this format, and also is added to the &quot;All 3D models&quot; filter.</p></li>   <li><p>Enable view3dscene to associate with this file format on freedesktops (GNOME, and other following freedesktop.org specs). For this,  <p>1. Update view3dscene MIME database. Simply add appopriate element to ../../../view3dscene/desktop/view3dscene.xml. Format of that MIME xml file is self-explanatory. It's good idea to google first to search for standard MIME type for your model format (e.g. wikipedia shows mime types for formats). If none is found, just use application/x-???, where ??? is some short name for your format.  <p>2. After adding to MIME database, you want to also add format to ../../../view3dscene/desktop/view3dscene.desktop, to indicate that view3dscene handles this MIME type.  <p>3. Finally, also add this to ../../../view3dscene/desktop/install_thumbnailer.sh, so that GNOME nautilus thumbnailers for this MIME types can be installed.</p></li>   <li><p>You probably also want to extend documentation. At least ../../../cge-www/htdocs/view3dscene.php, it has a &quot;Features&quot; section that lists all supported 3D formats.</p></li> </ul>  <p> ", "tags": "", "loc": "X3DLoad.html"},
     {"title": "X3DLoad.Load3D_FileFilters", "text": " ", "tags": "", "loc": "X3DLoad.html#Load3D_FileFilters"},
     {"title": "X3DLoad.SaveX3D_FileFilters", "text": " ", "tags": "", "loc": "X3DLoad.html#SaveX3D_FileFilters"},
     {"title": "X3DLoad.Load3DSequence_FileFilters", "text": " ", "tags": "", "loc": "X3DLoad.html#Load3DSequence_FileFilters"},
     {"title": "X3DLoad.DefaultBakedAnimationSmoothness", "text": " ", "tags": "", "loc": "X3DLoad.html#DefaultBakedAnimationSmoothness"},
     {"title": "X3DLoad.Load3D", "text": " Guess model format based on URL extension. VRML/X3D formats are loaded directly, other model formats are converted under the hood to VRML/X3D.  <p>URL is downloaded using <a class=\"normal\" href=\"CastleDownload.html\">CastleDownload</a> unit. If you all you care about is loading normal files, then just pass a normal filename (absolute or relative to the current directory) as the URL parameter.  <p>  AllowStdIn If AllowStdIn and URL = '-' then it will load a VRML/X3D file from <a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a> (using current working directory as BaseUrl).  AllowStdIn If AllowStdIn and URL = '-' then it will load a VRML/X3D file from <a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a> (using current working directory as BaseUrl).", "tags": "", "loc": "X3DLoad.html#Load3D"},
     {"title": "X3DLoad.Load3DSequence", "text": "  <p>For model formats that cannot express animations (like GEO or Wavefront OBJ) or that express animations in a single file (like VRML/X3D &gt;= 2.0) we load them exactly like <a class=\"normal\" href=\"X3DLoad.html#Load3D\">Load3D</a>, adding exactly one item to KeyNodes. So this function handles <i>at least</i> the same model formats as <a class=\"normal\" href=\"X3DLoad.html#Load3D\">Load3D</a>.  <p>Additionally, we load castle-anim-frames and MD3 formats to a sequence of frames.  <p>  <p>  KeyNodes Sequence of root nodes will be stored there. Pass here some created and empty instance of <a class=\"normal\" href=\"X3DNodes.TX3DNodeList.html\">TX3DNodeList</a>. KeyTimes Sequence of time values. Pass here some created and empty instance of <a class=\"normal\" href=\"CastleUtils.TSingleList.html\">TSingleList</a>.  KeyNodes Sequence of root nodes will be stored there. Pass here some created and empty instance of <a class=\"normal\" href=\"X3DNodes.TX3DNodeList.html\">TX3DNodeList</a>. KeyTimes Sequence of time values. Pass here some created and empty instance of <a class=\"normal\" href=\"CastleUtils.TSingleList.html\">TSingleList</a>.", "tags": "", "loc": "X3DLoad.html#Load3DSequence"},
     {"title": "X3DLoad.BakedAnimationSmoothness", "text": " This is multiplied by the scenes_per_time value recorded in castle-anim-frames file (30 by default), and determines the number of extra frames we add to the baked animation (between key frames). ", "tags": "", "loc": "X3DLoad.html#BakedAnimationSmoothness"},
     {"title": "X3DNodes", "text": "  <p>This is the central unit for VRML/X3D processing, as VRML/X3D file is basically just a graph of nodes. We represent whole VRML/X3D file by it's root node. This is what we load, save and process in this unit.  <p>The chapter &quot;Reading, writing, processing VRML scene graph&quot; in the documentation on [<a  href=\"http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/chapter.scene_graph.html\">http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/chapter.scene_graph.html</a>] is almost completely devoted to documenting the design of this single unit.  <p><b>Various uses of this unit:</b>  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Nodes can be loaded or saved from the stream in a classic or XML encoding. For classic encoding we use a lexer in CastleInternalX3DLexer unit. For XML encoding, we use standard FPC DOM unit. Loading and saving of fields (in both encodings) is inside <a class=\"normal\" href=\"X3DFields.html\">X3DFields</a> unit.  <p>When reading VRML/X3D files, we generally do not change the VRML/X3D graph. So we're able to save exactly the same VRML/X3D graph back to another file. See also [<a  href=\"http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/section.writing_vrml.html#section.vrml_preserving\">http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/section.writing_vrml.html#section.vrml_preserving</a>]. This allows writing various VRML/X3D processing tools, that can simply read the file, change whatever they want, and write the file back &mdash; knowing that the &quot;untouched&quot; parts of graph are preserved perfectly.</p></li>   <li><p><a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> class offers a lot of methods to process VRML/X3D graph. See <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">TX3DNode.Traverse</a>, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#EnumerateNodes\">TX3DNode.EnumerateNodes</a> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#FindNode\">TX3DNode.FindNode</a>. <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">TX3DNode.Traverse</a> is especially important, as it walks through VRML/X3D graph just as the specification says (accumulating transformation, visiting only active children of nodes like Switch or LOD), gathering some state (useful especially for VRML 1.0, but also used for various things in later VRML/X3D versions).  <p>When you want to render VRML/X3D graph, you can just traverse the graph and render each geometry node (<a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> instance) knowing it's state (that will contain transformation and such). Alternatively, simple renderer can also use TAbstractGeometryNode.Triangulate.</p></li>   <li><p><a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> is an important descendant of <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a>, as it defines stuff actually visible in the 3D world. It has useful routines for calculating bounding volumes, triangulating and such.  <p>But note that usually it's more comfortable to load your scene to <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> or <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> and then query the shapes list in <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Shapes\">TCastleSceneCore.Shapes</a> &mdash; this is usually more comfortable, also <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> and <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> cache some results for speed.</p></li>   <li><p>This unit doesn't depend on OpenGL, or any other particular rendering method. So it's suitable also for <a class=\"normal\" href=\"CastleRayTracer.html\">CastleRayTracer</a>, and every other possible renderer that will ever get implemented.</p></li>   <li><p>Your own units can define new VRML/X3D nodes, by declaring new classes descending from <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> (or other, more specialized, descendant). You should register your new classes by calling <a class=\"normal\" href=\"X3DNodes.TNodesManager.html#RegisterNodeClasses\">NodesManager.RegisterNodeClasses</a>.  <p>Examples of defining your own VRML/X3D node types (without modifying sources of this unit, or any other unit) are for example in &quot;malfunction&quot; game on <a  href=\"https://github.com/castle-engine/malfunction\">https://github.com/castle-engine/malfunction</a> (see LevelUnit).</p></li> </ul>  <p>  <p><b>Node class names, and inheritance:</b>  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Normal VRML/X3D nodes are defined by classses named like <code>TXxxNode</code>. These nodes can be specified inside the VRML/X3D files. See VRML/X3D specifications, and also our extensions specification, on [<a  href=\"http://castle-engine.sourceforge.net/vrml_x3d.php\">http://castle-engine.sourceforge.net/vrml_x3d.php</a>].  <p>There are also abstract node classes. Their definitions are helpful for handling some functionality common to many descendants, and to declare allowed children in SFNode/MFNode fields. Abstract node classes are named like <code>TAbstractXxxNode</code>. Some of the abstract nodes are also defined by X3D specification, and some of them are just our own inventions.  <p>Finally, there are some special-purpose node classes that play important role in our VRML/X3D organization. They are not abstract, but also their exact instances are not created under normal circumstances. These are named like <code>TX3DXxxNode</code>, currently these are only: <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a>, <a class=\"normal\" href=\"X3DNodes.TX3DRootNode.html\">TX3DRootNode</a>, <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html\">TX3DUnknownNode</a>, <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html\">TX3DPrototypeNode</a>.  <p>All node classes descend from the base <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> class.  <p>Some abstract nodes have also Pascal interfaces, like IAbstractXxxNode. Some ideas of X3D specification (although not many) need multiple inheritance, so interfaces have to be used. They all descend from <a class=\"normal\" href=\"X3DNodes.IX3DNode.html\">IX3DNode</a>.</p></li>   <li><p> Optional suffix _1 or _2 at the node class name indicates that this is only for a specific VRML/X3D standard version. Suffix _1 indicates nodes specific to VRML 1.0. Suffix _2 indicates nodes specific to VRML 2.0 (aka 97), that are not available in X3D. Latest X3D nodes do not have any suffix (to not clutter the source code that simply wants to use the latest and best version of the standard).  <p>For example, we have <a class=\"normal\" href=\"X3DNodes.TIndexedFaceSetNode_1.html\">TIndexedFaceSetNode_1</a> for VRML 1.0 and <a class=\"normal\" href=\"X3DNodes.TIndexedFaceSetNode.html\">TIndexedFaceSetNode</a> for VRML 2.0 and X3D.</p></li> </ul>  <p>  <p><b>VRML/X3D versions handling:</b>  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> We handle VRML 1.0, VRML 2.0 (aka VRML 97) and X3D (aka VRML 3.x).  <p>Every correct VRML / X3D file in classic and XML encoding should be parsed by this unit. See [<a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_status.php\">http://castle-engine.sourceforge.net/x3d_implementation_status.php</a>] for much more detailed information about supported features.</p></li>   <li><p> Also many Inventor 1.0 files are correctly parsed. We handle Inventor 1.0 mostly like VRML 1.0, also some small things and nodes specific for Inventor 1.0 are implemented here, see [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#ext_iv_in_vrml\">http://castle-engine.sourceforge.net/x3d_extensions.php#ext_iv_in_vrml</a>].</p></li>   <li><p> Note that structures in this unit are <i>not</i> focused on either VRML 1.0 or VRML &gt;= 2.0. On the contrary: we try to handle the <i>sum of all VRML and X3D</i>. When reading VRML 1.0, many VRML 2.0 constructs (that do not conflict with anything in VRML 1.0) are allowed, and the other way around too.  <p>Internally, we do not convert VRML 1.0-specific constructs to VRML 2.0/X3D constructs (or the other way around). See [<a  href=\"http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/section.vrml_1_2_sum.html\">http://castle-engine.sourceforge.net/vrml_engine_doc/output/xsl/html/section.vrml_1_2_sum.html</a>] for more in-depth explanation of how, and why, we handle both old-style (Inventor, VRML 1.0) and new-style (VRML 2.0, X3D) syntax.</p></li> </ul>  <p> ", "tags": "", "loc": "X3DNodes.html"},
     {"title": "X3DNodes.TTraversingInfo", "text": " ", "tags": "", "loc": "X3DNodes.TTraversingInfo.html"},
     {"title": "X3DNodes.TTraversingInfo.Node", "text": " ", "tags": "", "loc": "X3DNodes.TTraversingInfo.html#Node"},
     {"title": "X3DNodes.TTraversingInfo.ParentInfo", "text": " ", "tags": "", "loc": "X3DNodes.TTraversingInfo.html#ParentInfo"},
     {"title": "X3DNodes.TVRML1State", "text": " Used for <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#VRML1State\">TX3DGraphTraverseState.VRML1State</a>. These nodes affect some following nodes in the graph, in VRML 1.0.  <p>They are never <code>Nil</code> after a <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">TX3DNode.Traverse</a> operation. the traversing code always takes care to initialize them to default nodes at the beginning.  <p>For all nodes enumerated here: it's guaranteed they don't affect the state (<a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a>) during traversing (that is, they don't do anything special in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#BeforeTraverse\">TX3DNode.BeforeTraverse</a> / <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#MiddleTraverse\">TX3DNode.MiddleTraverse</a> / <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#AfterTraverse\">TX3DNode.AfterTraverse</a>). So it's guaranteed that changing some field's value of a node within <code>TVRML1State</code> affects <i>only</i> the shapes that have given node inside State.VRML1State. TCastleSceneCore.InternalChangedField depends on that. ", "tags": "", "loc": "X3DNodes.TVRML1State.html"},
     {"title": "X3DNodes.TVRML1State.Owned", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#Owned"},
     {"title": "X3DNodes.TVRML1State.Coordinate3", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#Coordinate3"},
     {"title": "X3DNodes.TVRML1State.ShapeHints", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#ShapeHints"},
     {"title": "X3DNodes.TVRML1State.FontStyle", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#FontStyle"},
     {"title": "X3DNodes.TVRML1State.Material", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#Material"},
     {"title": "X3DNodes.TVRML1State.MaterialBinding", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#MaterialBinding"},
     {"title": "X3DNodes.TVRML1State.Normal", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#Normal"},
     {"title": "X3DNodes.TVRML1State.NormalBinding", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#NormalBinding"},
     {"title": "X3DNodes.TVRML1State.Texture2", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#Texture2"},
     {"title": "X3DNodes.TVRML1State.TextureCoordinate2", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#TextureCoordinate2"},
     {"title": "X3DNodes.TVRML1State.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TVRML1State.html#Destroy"},
     {"title": "X3DNodes.TVRML1State.CreateNodes", "text": " All nodes become <a class=\"normal\" href=\"X3DNodes.TVRML1State.html#Owned\">Owned</a>.    ", "tags": "", "loc": "X3DNodes.TVRML1State.html#CreateNodes"},
     {"title": "X3DNodes.TVRML1State.Assign", "text": "  <p>During doing this, old nodes are freed if they were <a class=\"normal\" href=\"X3DNodes.TVRML1State.html#Owned\">owned</a>. New nodes are not <a class=\"normal\" href=\"X3DNodes.TVRML1State.html#Owned\">owned</a>.  <p>This takes care of checking for each <a class=\"normal\" href=\"X3DNodes.html#TVRML1StateNode\">TVRML1StateNode</a> if the old node is equal to new one. If yes, then the node if not freed (regardless of &quot;<a class=\"normal\" href=\"X3DNodes.TVRML1State.html#Owned\">owned</a>&quot; status), and the &quot;<a class=\"normal\" href=\"X3DNodes.TVRML1State.html#Owned\">owned</a>&quot; status is left as-is (not chaned to false). This way calling something like <code>MyState.Assign(MyState)</code> is a valid and harmless operation.    ", "tags": "", "loc": "X3DNodes.TVRML1State.html#Assign"},
     {"title": "X3DNodes.TVRML1State.SetOwnNode", "text": " Contrast this with <code>Nodes[StateNode] := Node</code> that makes the node <i>not</i> <a class=\"normal\" href=\"X3DNodes.TVRML1State.html#Owned\">owned</a>. This is just a shortcut for </p>  <pre class=\"longcode\"> Nodes[StateNode] := Node; Owned[StateNode] := true;</pre>  <p>    ", "tags": "", "loc": "X3DNodes.TVRML1State.html#SetOwnNode"},
     {"title": "X3DNodes.TVRML1State.Nodes", "text": " ", "tags": "", "loc": "X3DNodes.TVRML1State.html#Nodes"},
     {"title": "X3DNodes.TLightInstance", "text": " References VRML/X3D light source node (see <a class=\"normal\" href=\"X3DNodes.TLightInstance.html#Node\">Node</a>), and keeps track of light source transformation in the 3D world. For the sake of speed also stores a couple of light's properties already multiplied by the transformation.  <p>This record may be initialized only by <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#CreateLightInstance\">TAbstractLightNode.CreateLightInstance</a>. Update it (when transform changes) by <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#UpdateLightInstance\">TAbstractLightNode.UpdateLightInstance</a>. ", "tags": "", "loc": "X3DNodes.TLightInstance.html"},
     {"title": "X3DNodes.TLightInstance.Node", "text": " ", "tags": "", "loc": "X3DNodes.TLightInstance.html#Node"},
     {"title": "X3DNodes.TLightInstance.Transform", "text": " ", "tags": "", "loc": "X3DNodes.TLightInstance.html#Transform"},
     {"title": "X3DNodes.TLightInstance.TransformScale", "text": " ", "tags": "", "loc": "X3DNodes.TLightInstance.html#TransformScale"},
     {"title": "X3DNodes.TLightInstance.Location", "text": " For <a class=\"normal\" href=\"X3DNodes.TAbstractPositionalLightNode.html\">TAbstractPositionalLightNode</a> lights. ", "tags": "", "loc": "X3DNodes.TLightInstance.html#Location"},
     {"title": "X3DNodes.TLightInstance.Direction", "text": " For spot and directional lights. ", "tags": "", "loc": "X3DNodes.TLightInstance.html#Direction"},
     {"title": "X3DNodes.TLightInstance.Radius", "text": " For lights with radius (positional lights in VRML &gt;= 2.0, that is <a class=\"normal\" href=\"X3DNodes.TAbstractPositionalLightNode.html\">TAbstractPositionalLightNode</a> with HasRadius = true). ", "tags": "", "loc": "X3DNodes.TLightInstance.html#Radius"},
     {"title": "X3DNodes.TLightInstance.WorldCoordinates", "text": " If not, they are expressed in scene coordinates.  <p>This matters if you render the scene using <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>, and transform it (by wrapping it in <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a>, or by directly changing <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a> transformation properties inherited from <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html\">TCastleTransform</a>). By default (<code>WorldCoordinates</code> = false) we assume that light is defined in scene space, so it will be transformed by the whole modelview matrix (camera matrix with scene transformations). When this is true, during rendering we take care to transform this light only by camera matrix (not additional scene transformation). Useful for example for headlight. ", "tags": "", "loc": "X3DNodes.TLightInstance.html#WorldCoordinates"},
     {"title": "X3DNodes.TLightInstance.Position", "text": " For positional lights, the last component is always 1. For directional lights, the last component is always 0.    ", "tags": "", "loc": "X3DNodes.TLightInstance.html#Position"},
     {"title": "X3DNodes.TLightInstance.Contribution", "text": " This can be used by software renderers (ray-tracers etc.) to calculate pixel color following VRML/X3D specifications. TX3DGraphTraverseState.Emission should be added to <code>TLightInstance.Contribution</code> (for each light), and resulting color should be processed by <a class=\"normal\" href=\"X3DNodes.TFogNode.html#ApplyFog\">TFogNode.ApplyFog</a>.  <p>We do not clamp color components to (0, 1). This would be a waste of time, you should clamp only at the end (or never). This also allows to multiply / accumulate values outside of the (0, 1) range during calculations. OpenGL also clamps only at the end.    ", "tags": "", "loc": "X3DNodes.TLightInstance.html#Contribution"},
     {"title": "X3DNodes.TLightInstance.ContributionCameraIndependent", "text": " We have a 3D vertex, we know it lies on a plane with given normal, and we have light information. Try to calculate VRML/X3D lighting equation as close as possible to the fully correct version (see regular <a class=\"normal\" href=\"X3DNodes.TLightInstance.html#Contribution\">Contribution</a> method) with this information.  <p>The specular lighting part must be simply ignored in this case.    ", "tags": "", "loc": "X3DNodes.TLightInstance.html#ContributionCameraIndependent"},
     {"title": "X3DNodes.TLightInstancesList", "text": " ", "tags": "", "loc": "X3DNodes.TLightInstancesList.html"},
     {"title": "X3DNodes.TLightInstancesList.IndexOfNode", "text": " Return -1 if not found.    ", "tags": "", "loc": "X3DNodes.TLightInstancesList.html#IndexOfNode"},
     {"title": "X3DNodes.TLightInstancesList.FindName", "text": " Return <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DNodes.TLightInstancesList.html#FindName"},
     {"title": "X3DNodes.TLightInstancesList.Equals", "text": "    ", "tags": "", "loc": "X3DNodes.TLightInstancesList.html#Equals"},
     {"title": "X3DNodes.TLightInstancesList.AppendInWorldCoordinates", "text": "    ", "tags": "", "loc": "X3DNodes.TLightInstancesList.html#AppendInWorldCoordinates"},
     {"title": "X3DNodes.TClipPlane", "text": " ", "tags": "", "loc": "X3DNodes.TClipPlane.html"},
     {"title": "X3DNodes.TClipPlane.Node", "text": " ", "tags": "", "loc": "X3DNodes.TClipPlane.html#Node"},
     {"title": "X3DNodes.TClipPlane.Transform", "text": " ", "tags": "", "loc": "X3DNodes.TClipPlane.html#Transform"},
     {"title": "X3DNodes.TClipPlaneList", "text": " ", "tags": "", "loc": "X3DNodes.TClipPlaneList.html"},
     {"title": "X3DNodes.TClipPlaneList.IndexOfNode", "text": "    ", "tags": "", "loc": "X3DNodes.TClipPlaneList.html#IndexOfNode"},
     {"title": "X3DNodes.TClipPlaneList.Equals", "text": "    ", "tags": "", "loc": "X3DNodes.TClipPlaneList.html#Equals"},
     {"title": "X3DNodes.TX3DGraphTraverseState", "text": "  <p>For VRML/X3D &gt;= 2.0 this could be simpler, as VRML/X3D &gt;= 2.0 doesn't need to keep track for example of the <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#VRML1State\">VRML1State</a>. But we want to still handle VRML 1.0, 100% correctly, so here we are: this class contains whole state needed for any VRML/X3D version. ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html"},
     {"title": "X3DNodes.TX3DGraphTraverseState.Lights", "text": "  <p>May be <code>Nil</code> if empty. This way we optimize creation / assignment time, which happen very often with <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a> during VRML/X3D traversing.  <p>Note that VRML &gt;= 2.0 &quot;global&quot; lights are added from <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, not during the traverse pass. ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#Lights"},
     {"title": "X3DNodes.TX3DGraphTraverseState.Transform", "text": " ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#Transform"},
     {"title": "X3DNodes.TX3DGraphTraverseState.InvertedTransform", "text": " This matrix is crucial for some special effects (for example, it's needed for calculating in tangent space for bump mapping).  <p>This is not calculated using any complex matrix inversion algorithms. Instead, this is calculated by updating this along the way, just like we calculate normal <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#Transform\">Transform</a>. So it's simple, quick, and guaranteed to be correct <i>assuming that user didn't use VRML 1.0 MatrixTransform along the way</i>. That's why MatrixTransform node was removed from VRML 2.0, it breaks such things.  <p>Also, any scale with zero component along the way will make this partially invalid (we'll substitute identity in place of inverted scaling matrix). This is unavoidable, there's no reverse matrix for scaling with zero factor, since one resulting point may correpond to infinitely many source points (i.e., it's natural that such scaling function cannot be reversed). ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#InvertedTransform"},
     {"title": "X3DNodes.TX3DGraphTraverseState.TransformScale", "text": " If the matrix causes non-uniform scaling, this value represents an average scale.  <p>This is updated while traversing the VRML graph, just like the <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#Transform\">Transform</a> matrix is updated. This way it's calculated fast and easy &mdash; we do not actually extract it from a matrix (as long as you don't use explicit MatrixTransform in the VRML/X3D file). ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#TransformScale"},
     {"title": "X3DNodes.TX3DGraphTraverseState.TextureTransform", "text": " Usable only for VRML 1.0, in VRML 2.0 texture transformations don't accumulate like modelview transformations. ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#TextureTransform"},
     {"title": "X3DNodes.TX3DGraphTraverseState.ShapeNode", "text": " ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#ShapeNode"},
     {"title": "X3DNodes.TX3DGraphTraverseState.InsideInline", "text": " <code>InsideInline</code> = 0 means you're not inside any inline node, 1 means you're inside one inline, 2 means you're within content inlined from yet another inline node, and so on. Analogous for <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#InsidePrototype\">InsidePrototype</a>.  <p>These are measured from the node where you started <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">TX3DNode.Traverse</a> call, that is they assume that the initial node from where you're traversing is at level 0 (not inside inline or expanded prototype).  <p>These are useful to establish &quot;run-time name scope&quot; of X3D, see X3D spec 4.4.7 (needed e.g. when handling Anchor node with &quot;#Viewpoint&quot; URL). Interpreting this for our implementation, specification says that if you traverse from node X, then all traversed nodes with <code>InsideInline</code> = <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#InsidePrototype\">InsidePrototype</a> = 0 are within the same name scope.  <p>Also this is useful for searching for the first bindable node after loading the file. Specification says to ignore inline content in this case (although prototype content is Ok in this case).  <p>When scriping will be implemented, probably analogous InsideScriptCreatedNode will also be needed, as the spec says that bindable nodes should not be searched within things like &quot;Browser.createX3DFromString()&quot;.  <p> ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#InsideInline"},
     {"title": "X3DNodes.TX3DGraphTraverseState.InsidePrototype", "text": " ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#InsidePrototype"},
     {"title": "X3DNodes.TX3DGraphTraverseState.InsideIgnoreCollision", "text": "  <p>This counts how many times are we inside Collision node that prevents us from colliding. More precise, this is increased when we traverse inside Collision.children with Collision.enabled = FALSE or Collision.proxy &lt;&gt; NULL (since then Collision.children are not collidable). ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#InsideIgnoreCollision"},
     {"title": "X3DNodes.TX3DGraphTraverseState.InsideInvisible", "text": "  <p>This counts how many times are we inside Collision.proxy (with Collision.enabled = TRUE). Collision.proxy is never visible. ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#InsideInvisible"},
     {"title": "X3DNodes.TX3DGraphTraverseState.PointingDeviceSensors", "text": " This can contain only nodes descending from X3DPointingDeviceSensorNode, and additionally an Anchor node.  <p>This list automatically honours VRML / X3D rules for what pointing device sensor is active: pointing device within some group node affects all children in this group node. (And when multiple pointing device sensors are within the same grouping node, they all work.) ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#PointingDeviceSensors"},
     {"title": "X3DNodes.TX3DGraphTraverseState.HumanoidTransform", "text": " ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#HumanoidTransform"},
     {"title": "X3DNodes.TX3DGraphTraverseState.HumanoidInvertedTransform", "text": " ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#HumanoidInvertedTransform"},
     {"title": "X3DNodes.TX3DGraphTraverseState.Humanoid", "text": " ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#Humanoid"},
     {"title": "X3DNodes.TX3DGraphTraverseState.ClipPlanes", "text": "  <p>They are collected here regardless of whether they are enabled or not. This allows efficient implementation of <code>ClipPlane.enabled</code> dynamic changes.  <p>Ordered from the most global to most local ones. So, following the X3D specification, we should consider the first clip planes on this list more important.  <p>Always <code>Nil</code> if empty. This allows us to optimize <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a> processing. ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#ClipPlanes"},
     {"title": "X3DNodes.TX3DGraphTraverseState.LocalFog", "text": " When <code>Nil</code>, it means use global fog (or no fog, if no global fog defined in file). ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#LocalFog"},
     {"title": "X3DNodes.TX3DGraphTraverseState.Effects", "text": " ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#Effects"},
     {"title": "X3DNodes.TX3DGraphTraverseState.AddLight", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#AddLight"},
     {"title": "X3DNodes.TX3DGraphTraverseState.AssignTransform", "text": " Copies <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#Transform\">Transform</a> matrix, along with related information like <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#InvertedTransform\">InvertedTransform</a> and <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#TransformScale\">TransformScale</a>. Copies also the <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#ClipPlanes\">ClipPlanes</a> list, as it contains the transformation information.    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#AssignTransform"},
     {"title": "X3DNodes.TX3DGraphTraverseState.CreateCopy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#CreateCopy"},
     {"title": "X3DNodes.TX3DGraphTraverseState.Create", "text": " Uses global VRML1DefaultState as default nodes for <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#VRML1State\">VRML1State</a>. This makes it fast, and improves cache (more nodes have equal reference).    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#Create"},
     {"title": "X3DNodes.TX3DGraphTraverseState.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#Destroy"},
     {"title": "X3DNodes.TX3DGraphTraverseState.Assign", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#Assign"},
     {"title": "X3DNodes.TX3DGraphTraverseState.Clear", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#Clear"},
     {"title": "X3DNodes.TX3DGraphTraverseState.Equals", "text": " True if these two states, when applied to the same geometry, result in the same <a class=\"normal\" href=\"CastleGeometryArrays.TGeometryArrays.html\">TGeometryArrays</a> output. If IgnoreTransform then we should ignore transformation during comparison (it means that renderer is absolutely sure that different transformation of geometry doesn't affect the generated arrays).    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#Equals"},
     {"title": "X3DNodes.TX3DGraphTraverseState.DiffuseAlphaTexture", "text": " Regardless of VRML/X3D version. May return multi-texture (<a class=\"normal\" href=\"X3DNodes.TMultiTextureNode.html\">TMultiTextureNode</a>), or normal 2D texture (<a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html\">TAbstractTexture2DNode</a>), or some other <a class=\"normal\" href=\"X3DNodes.TAbstractTextureNode.html\">TAbstractTextureNode</a> descendant (cube map, 3d texture).    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#DiffuseAlphaTexture"},
     {"title": "X3DNodes.TX3DGraphTraverseState.BlendMode", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#BlendMode"},
     {"title": "X3DNodes.TX3DGraphTraverseState.AddClipPlane", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#AddClipPlane"},
     {"title": "X3DNodes.TX3DGraphTraverseState.MaterialInfo", "text": " See <a class=\"normal\" href=\"X3DNodes.TMaterialInfo.html\">TMaterialInfo</a> for usage description. Returns <code>Nil</code> when no node determines material properties (which indicates <a class=\"normal\" href=\"CastleColors.html#White\">white</a> unlit look).  <p>Returned <a class=\"normal\" href=\"X3DNodes.TMaterialInfo.html\">TMaterialInfo</a> is valid only as long as the underlying Material or CommonSurfaceShader node exists. Do not free it yourself, it will be automatically freed.    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#MaterialInfo"},
     {"title": "X3DNodes.TX3DGraphTraverseState.VRML1State", "text": " ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#VRML1State"},
     {"title": "X3DNodes.TX3DGraphTraverseState.LastNodes", "text": " ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseState.html#LastNodes"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack", "text": "  <p>Allows you for much faster creation/destruction of <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a> instances. Although you can always construct / destruct <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a> as normal objects, in some cases this is too slow: when traversing VRML/X3D graph (e.g. profile animate_3d_model_by_code_2), merely creating/destroying <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a> instances takes a noticeable amount of time.  <p>This stack allows you to do this faster, first of all by internally using a prepared pool of instances.  <p>Each <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseStateStack.html#PushClear\">PushClear</a> call creates a clear state instance, and places it on the stack. Each Push call creates a copy of current top and places it on the stack. Each Pop removes and destroys the last instance added by Push.  <p>Naturally, you can call Push and Top only when the stack is not empty. In practice, using the stack always starts in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">TX3DNode.Traverse</a>, where we push initial clear state. So the stack passed to various callbacks, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#BeforeTraverse\">TX3DNode.BeforeTraverse</a> and such is always guaranteed non-empty.  <p>Note that for speed purposes all Traverse calls actually share a single stack. That is, to avoid creating <code>TX3DGraphTraverseStateStack</code> instance each time (because even creating <code>TX3DGraphTraverseStateStack</code> takes some time (as it prepares a pool of <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a> instances, to allow fast push/pop)), <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> simply reuses a single global <code>TX3DGraphTraverseStateStack</code> instance. This means that, if you execute Traverse while being inside other Traverse, you must first finish innermost Traverse before continuing with the outer. ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html#Create"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html#Destroy"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack.Clear", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html#Clear"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack.PushClear", "text": " Clear state has everything set like a <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a> right after creating.    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html#PushClear"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack.Push", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html#Push"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack.Push", "text": " We copy by <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html#Assign\">TX3DGraphTraverseState.Assign</a>, we don't copy the reference.    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html#Push"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack.Pop", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html#Pop"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack.Top", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html#Top"},
     {"title": "X3DNodes.TX3DGraphTraverseStateStack.PreviousTop", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DGraphTraverseStateStack.html#PreviousTop"},
     {"title": "X3DNodes.TNodeDestructionNotificationList", "text": " ", "tags": "", "loc": "X3DNodes.TNodeDestructionNotificationList.html"},
     {"title": "X3DNodes.TNodeDestructionNotificationList.ExecuteAll", "text": "    ", "tags": "", "loc": "X3DNodes.TNodeDestructionNotificationList.html#ExecuteAll"},
     {"title": "X3DNodes.TCachedNodeList", "text": " ", "tags": "", "loc": "X3DNodes.TCachedNodeList.html"},
     {"title": "X3DNodes.TCachedNodeList.Pack", "text": "    ", "tags": "", "loc": "X3DNodes.TCachedNodeList.html#Pack"},
     {"title": "X3DNodes.TX3DNodesCache", "text": " Includes all <a class=\"normal\" href=\"CastleTextureImages.TTexturesVideosCache.html\">TTexturesVideosCache</a> resources (texture, movie data) and adds cache for 3D models. ", "tags": "", "loc": "X3DNodes.TX3DNodesCache.html"},
     {"title": "X3DNodes.TX3DNodesCache.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodesCache.html#Create"},
     {"title": "X3DNodes.TX3DNodesCache.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodesCache.html#Destroy"},
     {"title": "X3DNodes.TX3DNodesCache.Load3D", "text": " URL must be absolute (not relative).  <p>Note that this should not be used if you plan to modify the model graph (for example by VRML/X3D events). In such case, the cache should not be used, as it would make all the model instances shared. For example, if you inline the same model multiple times, you could not modify one instance independent from another.    ", "tags": "", "loc": "X3DNodes.TX3DNodesCache.html#Load3D"},
     {"title": "X3DNodes.TX3DNodesCache.Free3D", "text": " Node may be <code>Nil</code> (then it's ignored), or something loaded by <a class=\"normal\" href=\"X3DNodes.TX3DNodesCache.html#Load3D\">Load3D</a> (then it's released and changed to <code>Nil</code>).    ", "tags": "", "loc": "X3DNodes.TX3DNodesCache.html#Free3D"},
     {"title": "X3DNodes.TX3DNodesCache.Empty", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodesCache.html#Empty"},
     {"title": "X3DNodes.TX3DNodeDeepCopyState", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNodeDeepCopyState.html"},
     {"title": "X3DNodes.TX3DNodeDeepCopyState.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeDeepCopyState.html#Create"},
     {"title": "X3DNodes.TX3DNodeDeepCopyState.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeDeepCopyState.html#Destroy"},
     {"title": "X3DNodes.TX3DNodeDeepCopyState.DeepCopy", "text": "  <p>To keep sharing of nodes (DEF/USE mechanism) within the newly created copy, we need a list of already duplicated children. This method uses and updates such list. When called for the first time with OriginalNode, it actually creates a duplicate (by OriginalNode.DeepCopy). Next time, it will just return this copy.    ", "tags": "", "loc": "X3DNodes.TX3DNodeDeepCopyState.html#DeepCopy"},
     {"title": "X3DNodes.IX3DNode", "text": " All other interfaces for X3D nodes descend from this. ", "tags": "", "loc": "X3DNodes.IX3DNode.html"},
     {"title": "X3DNodes.TX3DNode", "text": " Every VRML/X3D node class descends from this. ", "tags": "", "loc": "X3DNodes.TX3DNode.html"},
     {"title": "X3DNodes.TX3DNode.VRML1ChildrenAllowed", "text": " This condition is checked in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1ChildAdd\">VRML1ChildAdd</a>, so it's strictly impossible to add a node that is not allowed.  <p>Note that in some special cases <code>VRML1ChildrenAllowed</code> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1ChildrenParsingAllowed\">VRML1ChildrenParsingAllowed</a> values may be changed during object lifetime. Currently, this may concern <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html\">TX3DUnknownNode</a>.  <p>Default <code>False</code>. ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ChildrenAllowed"},
     {"title": "X3DNodes.TX3DNode.VRML1ChildrenParsingAllowed", "text": " This is used only by *Inline nodes for now, that do not allow reading children during parsing but may get new children in memory. So their <code>VRML1ChildrenParsingAllowed</code> must be empty, but <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1ChildrenAllowed\">VRML1ChildrenAllowed</a> must allow all.  <p>When <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1ChildrenAllowed\">VRML1ChildrenAllowed</a> is <code>False</code> then <code>VRML1ChildrenParsingAllowed</code> should also be <code>False</code>.  <p>Default <code>False</code>. ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ChildrenParsingAllowed"},
     {"title": "X3DNodes.TX3DNode.DeepCopyCore", "text": " You can override this to copy some more properties for descendants.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#DeepCopyCore"},
     {"title": "X3DNodes.TX3DNode.DeepCopyCreate", "text": "  <p>In <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a>, this simply calls default virtual constructor, which is Ok for all normal nodes. But we have some special nodes, like <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html\">TX3DPrototypeNode</a> or <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html\">TX3DUnknownNode</a>, that simply cannot be created by default constructor. They need to override this.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#DeepCopyCreate"},
     {"title": "X3DNodes.TX3DNode.VRML1ChildrenSaveToStream", "text": " In this class default implementation returns <code>True</code>, this is what you will want in 99% of cases. It's useful to set this to false if you use <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Children\">VRML1Children</a> internally, e.g. *Inline nodes.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ChildrenSaveToStream"},
     {"title": "X3DNodes.TX3DNode.DirectEnumerateActive", "text": "  <p>&quot;Active nodes&quot; are the ones affecting current look or collisions, e.g. from Switch node only one child will be enumerated. See <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">Traverse</a> for more precise definition.  <p>&quot;Direct&quot; means that this enumerates only direct descendants, i.e. this is not recursive. See methods like Traverse or <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#EnumerateNodes\">EnumerateNodes</a> if you want recursive behavior.  <p>This can enumerate both <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Children\">VRML1Children</a> nodes and nodes within <a class=\"normal\" href=\"X3DNodes.TSFNode.html\">TSFNode</a> and <a class=\"normal\" href=\"X3DNodes.TMFNode.html\">TMFNode</a> fields.  <p>Default implementation in this class enumerates all Children nodes of VRML 1.0. If you need to remove some children for VRML 1.0 (e.g. for Switch or LOD nodes) or add some children for VRML 2.0 you have to override this. <b>You do not need to call inherited when overriding this &mdash; in fact, you should not, if you want to omit some nodes.</b>  <p>Stops and returns immediately if Func returns non-nil for some child.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TX3DNode.DirectEnumerateActiveForTraverse", "text": " It's used by Traverse.  <p>Default implementation in this class simply calls <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#DirectEnumerateActive\">DirectEnumerateActive</a>, ignoring StateStack, and this is suitable for 99% of nodes. However, for some special nodes (only Collision node for now), they have to modify state during traversing into various children, and then they can override this.  <p>Stops and returns immediately in Func returns non-nil for some child.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#DirectEnumerateActiveForTraverse"},
     {"title": "X3DNodes.TX3DNode.DirectEnumerateAll", "text": " That is, all children in VRML 1.0 style and all nodes in SFNode and MFNode fields. This includes prototype stuff, if this node is expanded from prototype: <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode\">PrototypeInstanceSourceNode</a> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceHelpers\">PrototypeInstanceHelpers</a>.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#DirectEnumerateAll"},
     {"title": "X3DNodes.TX3DNode.DirectEnumerate", "text": " This is equivalent to <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#DirectEnumerateActive\">DirectEnumerateActive</a> or <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#DirectEnumerateAll\">DirectEnumerateAll</a>, depending on value of OnlyActive param.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#DirectEnumerate"},
     {"title": "X3DNodes.TX3DNode.BeforeTraverse", "text": " The main use of this is to operate on <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseStateStack.html\">TX3DGraphTraverseStateStack</a>.  <p>Remember to always call inherited when overriding. In <code>BeforeTraverse</code> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#MiddleTraverse\">MiddleTraverse</a> you should call inherited at the beginning, in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#AfterTraverse\">AfterTraverse</a> inherited should be called at the end.  <p>Besides changing StateStack.Top fields, you can do push/pop on the stack. Remember that if you do StateStack.Push in <code>BeforeTraverse</code>, and then you <i>must call StateStack.Pop in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#AfterTraverse\">AfterTraverse</a></i>.  <p>    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#BeforeTraverse"},
     {"title": "X3DNodes.TX3DNode.MiddleTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#MiddleTraverse"},
     {"title": "X3DNodes.TX3DNode.AfterTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AfterTraverse"},
     {"title": "X3DNodes.TX3DNode.ParseNodeBodyElement", "text": " Usually, this is a field. May also be VRML 1.0 style child node. May also be VRML 2.0 Script node interface declaration, etc. &mdash; see VRML 2.0 grammar spec.  <p>This should be overriden to parse special features within particular nodes. While generally VRML is very clean and there's no need to override this, there's one use for this currently:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>Since we handle a couple of VRML flavors (at least Inventor, VRML 1.0 and VRML 97), sometimes the same node has different fields to express the same things in various VRML flavors. So it may be useful to parse a field and copy it's value into other fields.  <p>Example: <a class=\"normal\" href=\"X3DNodes.TShapeHintsNode_1.html\">TShapeHintsNode_1</a> in Inventor parses &quot;hints&quot; field, and copies it's value to other fields as appropriate. &quot;hints&quot; field is not exposed in <a class=\"normal\" href=\"X3DNodes.TShapeHintsNode_1.html\">TShapeHintsNode_1</a> interface, so everything is clean in the interface, and under the hood <a class=\"normal\" href=\"X3DNodes.TShapeHintsNode_1.html\">TShapeHintsNode_1</a> can &quot;magically&quot; handle &quot;hints&quot; field for Inventor.</p></li> </ol>  <p>  <p>When overriding, always check inherited result first, and exit if inherited handled successfully. Otherwise either read your stuff and return <code>True</code> (Lexer should advance to the position of next &quot;nodeBodyElement&quot;). Or return <code>False</code> without changing Lexer position.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ParseNodeBodyElement"},
     {"title": "X3DNodes.TX3DNode.ParseAfter", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ParseAfter"},
     {"title": "X3DNodes.TX3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#CreateNode"},
     {"title": "X3DNodes.TX3DNode.FieldsCount", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#FieldsCount"},
     {"title": "X3DNodes.TX3DNode.AddField", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AddField"},
     {"title": "X3DNodes.TX3DNode.IndexOfField", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#IndexOfField"},
     {"title": "X3DNodes.TX3DNode.EventsCount", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#EventsCount"},
     {"title": "X3DNodes.TX3DNode.AddEvent", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AddEvent"},
     {"title": "X3DNodes.TX3DNode.IndexOfEvent", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#IndexOfEvent"},
     {"title": "X3DNodes.TX3DNode.Field", "text": " <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Field"},
     {"title": "X3DNodes.TX3DNode.FieldOrEvent", "text": " <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#FieldOrEvent"},
     {"title": "X3DNodes.TX3DNode.AnyEvent", "text": " <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AnyEvent"},
     {"title": "X3DNodes.TX3DNode.VRML1ChildrenCount", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ChildrenCount"},
     {"title": "X3DNodes.TX3DNode.VRML1ChildAdd", "text": " Index (position) must be in [0..VRML1ChildrenCount]. Items at and above Index position are moved to the right, to insert new child at Index position.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ChildAdd"},
     {"title": "X3DNodes.TX3DNode.VRML1ChildAdd", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ChildAdd"},
     {"title": "X3DNodes.TX3DNode.VRML1ChildRemove", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ChildRemove"},
     {"title": "X3DNodes.TX3DNode.VRML1ChildrenClear", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ChildrenClear"},
     {"title": "X3DNodes.TX3DNode.VRML1ChildExtract", "text": " Compare this with VRML1Remove, that removes children I and frees it if it's no longer used by anything.  <p>This removes children I, appropriately adjusting all parent / children links, but even if a node is unused after removing, it is not freed. It's always returned.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ChildExtract"},
     {"title": "X3DNodes.TX3DNode.VRML1ParentsCount", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1ParentsCount"},
     {"title": "X3DNodes.TX3DNode.ParentFieldsCount", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ParentFieldsCount"},
     {"title": "X3DNodes.TX3DNode.FreeRemovingFromAllParents", "text": "  <p>By design, normal destructor (Destroy called by Free) doesn't care about removing references to this object from it's parents. That's because it's the parents that usually initialize freeing of their children, and they free child when it's reference count is 0. So this freeing method is special in this regard.  <p>Use this if you really want to remove all node occurrences from the middle of VRML hierarchy.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#FreeRemovingFromAllParents"},
     {"title": "X3DNodes.TX3DNode.FreeIfUnused", "text": " Takes into account that node may have VRML 1.0 parent nodes and VRML 2.0 / X3D parent fields (SFNode or MFNode). This is a safe way of removing a node that may, but doesn't have to, be part of some VRML/X3D graph. The idea is that if a node is a part of some graph, we don't need to do anything (since you should have a reference to the entine graph somewhere anyway), otherwise node is considered unused and freed.  <p>Analogous to standard TObject.Free, this also works when called on a <code>Nil</code> value (does nothing in this case).  <p>For safety, it's advised to set reference to <code>Nil</code> after calling <code>FreeIfUnused</code>. You can use <a class=\"normal\" href=\"X3DNodes.html#FreeIfUnusedAndNil\">FreeIfUnusedAndNil</a> utility for this (that employs a trick to <code>Nil</code> the visible reference even before freeing, which is even safer). This is analogous to standard FreeAndNil.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#FreeIfUnused"},
     {"title": "X3DNodes.TX3DNode.KeepExistingBegin", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#KeepExistingBegin"},
     {"title": "X3DNodes.TX3DNode.KeepExistingEnd", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#KeepExistingEnd"},
     {"title": "X3DNodes.TX3DNode.PathFromBaseUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#PathFromBaseUrl"},
     {"title": "X3DNodes.TX3DNode.Parse", "text": " This should set values of your fields, VRML 1.0 Children list, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#BaseUrl\">BaseUrl</a>.  <p>In special cases like <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html\">TX3DUnknownNode</a> this may actually initialize whole Fields list (by VRML 1.0 &quot;fields&quot; extensibility feature).    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Parse"},
     {"title": "X3DNodes.TX3DNode.ParseXML", "text": " mainly node's fields.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ParseXML"},
     {"title": "X3DNodes.TX3DNode.Create", "text": " Initializes various properties:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>Name, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#BaseUrl\">BaseUrl</a> are initialized from given parameters.</p></li>   <li><p>The <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Fields\">Fields</a>, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Events\">Events</a> lists are filled in every descendant, to have all the fields/events defined by the specification.</p></li>   <li><p><a class=\"normal\" href=\"X3DNodes.TX3DNode.html#DefaultContainerField\">DefaultContainerField</a>, and other node-specific stuff, is filled in descendants. This is actually implemented in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#CreateNode\">CreateNode</a>, that is called at the end of this constructor.</p></li> </ul>  <p>    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Create"},
     {"title": "X3DNodes.TX3DNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Destroy"},
     {"title": "X3DNodes.TX3DNode.X3DType", "text": " Never empty. Constant for the class lifetime (even for special <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html\">TX3DUnknownNode</a> and <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html\">TX3DPrototypeNode</a>, where this is calculated at runtime).  <p>Note that VRML/X3D is generally case-sensitive, so this property is too.  <p>In <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a>, this returns <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#ClassX3DType\">ClassX3DType</a>, which is suitable for most nodes. See <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#ClassX3DType\">ClassX3DType</a>.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#X3DType"},
     {"title": "X3DNodes.TX3DNode.NodeTypeName", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#NodeTypeName"},
     {"title": "X3DNodes.TX3DNode.ClassX3DType", "text": " Normal VRML/X3D node classes should override this to return something non-empty, and then <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#X3DType\">X3DType</a> automatically will return the same value.  <p>Empty for classes that don't have a hardcoded VRML/X3D node name, like a special <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html\">TX3DUnknownNode</a>. Such special classes should override then <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#X3DType\">X3DType</a> to return actual non-empty name there.  <p>You usually should call <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#X3DType\">X3DType</a>. The only use of this method is that it works on classes (it's &quot;class function&quot;), without needing at actual instance.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TX3DNode.Traverse", "text": "  <p>An &quot;active&quot; part of the VRML graph are the nodes that actually change what the VRML file represents, in terms of geometry, collision detection etc. For example, the Switch node has only one child usually active. Nodes that merely influence the active graph by some events and routes do not have to be active (these nodes may change what the VRML file actually represents, but only by changing other nodes).  <p>For all nodes of NodeClass TraversingFunc will be called. If if returns non-nil for some node, the processing of following nodes (children and siblings) will be aborted and result will be returned.  <p>Traverse not only enumerates these nodes, it also collects all state (transformation, etc &mdash; see <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a>) that affects how given node should be presented.  <p>Also, TraversingInfo is passed to each TraversingFunc call. This allows you to investigate, during TraversingFunc call, the parents hierarchy (you can't use <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Parents\">VRML1Parents</a> / <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#ParentFields\">ParentFields</a> of the current node, since a node may have many parents). Traverse calls are naturally recursive, and so the stack of TraversingInfo structures is naturally build and destroyed by recursive calls. For the root node (the one where you called Traverse without specifying initial TraversingInfo), ParentInfo is simply <code>Nil</code>.  <p>The scheme of how Traverse works:  <p></p>  <pre class=\"preformatted\"> BeforeTraverse;  TraverseIntoChildren := true; if Self is NodeClass then TraversingFunc (Self, State, TraverseIntoChildren);  MiddleTraverse;  if TraverseIntoChildren is still true then   for all children returned by DirectEnumerateActive     call their Traverse(State);  AfterTraverse;  Add Self to State.VRML1State (for VRML 1.0 state nodes);</pre>  <p>  <p>Note: setting <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#TraverseIntoChildren\">TraverseIntoChildren</a> to false means that some part of the tree is explicitly omitted from traversing. Use this only if you know what you're doing, as for some nodes they actually affect their parents too (for example, chilren within VRML 1.0 Group affect other nodes too; global lights within VRML &gt;= 2.0 affect all nodes; and so on...). Usually, you will use this only for separator-like nodes (for VRML &gt;= 2.0, all Group, Transform, Switch etc. act like separators), and only when you will somehow traverse into these nodes anyway.  <p>We guarantee that <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#AfterTraverse\">AfterTraverse</a> will be called if <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#BeforeTraverse\">BeforeTraverse</a> was called and finished (that is, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#AfterTraverse\">AfterTraverse</a> is called in the <code>finally..end</code>).  <p>During traversing, you can only modify the children (direct or not) nodes of the current node.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Traverse"},
     {"title": "X3DNodes.TX3DNode.TraverseInternal", "text": " Not generally useful, use only for special purposes.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#TraverseInternal"},
     {"title": "X3DNodes.TX3DNode.TraverseIntoChildren", "text": " This does the job of Traverse normally omitted if your <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">Traverse</a> callback returns <code>TraverseIntoChildren</code> = <code>False</code>. Using this method, you can traverse into children explicitly from your callback.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#TraverseIntoChildren"},
     {"title": "X3DNodes.TX3DNode.EnumerateNodes", "text": " Recursively. Enumerates also this instance (Self), if it satisfies the NodeClass and SeekNodeName conditions.  <p>This enumerates both VRML 1.0 children (<a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Children\">VRML1Children</a>) as well as VRML &gt;= 2.0 (including X3D) children (nodes in <a class=\"normal\" href=\"X3DNodes.TSFNode.html\">TSFNode</a> and <a class=\"normal\" href=\"X3DNodes.TMFNode.html\">TMFNode</a> fields).  <p>If OnlyActive then it will enumerate only active parts of the graph (&quot;active&quot; as defined by <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">Traverse</a>), so it will work as a simpler version of Traverse (simpler, because it doesn't track any state).  <p>If not OnlyActive then it will simply enumerate all nodes. This will include then also prototype helpers, if this node was expanded from prototype: see <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode\">PrototypeInstanceSourceNode</a> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceHelpers\">PrototypeInstanceHelpers</a>.  <p>If you give SeekNodeName parameter, we'll only look for nodes with <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#X3DName\">X3DName</a> = SeekNodeName. When SeekNodeName = '' it, consistently, looks for unnamed nodes (where <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#X3DName\">X3DName</a> = '').  <p>Enumerates children only after enumerating Self. So you can modify children before enumerating them in the Proc callback. You can only modify your children in the Proc callback.  <p>    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#EnumerateNodes"},
     {"title": "X3DNodes.TX3DNode.EnumerateNodes", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#EnumerateNodes"},
     {"title": "X3DNodes.TX3DNode.EnumerateNodes", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#EnumerateNodes"},
     {"title": "X3DNodes.TX3DNode.SearchNodes", "text": " We search for a node for which Proc(Node) returns something non-nil.  <p>For every node, the given Proc callback is run. If the Proc callback returns something non-nil, the enumeration of the following nodes stops, and we return the callback result.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#SearchNodes"},
     {"title": "X3DNodes.TX3DNode.TryFindNodeByName", "text": " If OnlyActive then they seek among only active nodes (&quot;active&quot; as defined by <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">Traverse</a>), otherwise all nodes.  <p>These functions are quite like <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#EnumerateNodes\">EnumerateNodes</a>, except they stop at the first occurrence and return it.  <p><code>TryFindNodeByName</code> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#TryFindNode\">TryFindNode</a> return <code>Nil</code> if such node is not found. <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#FindNodeByName\">FindNodeByName</a> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#FindNode\">FindNode</a> raise exception <a class=\"normal\" href=\"X3DFields.EX3DNotFound.html\">EX3DNotFound</a> in this case.      EX3DNotFound <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#FindNodeByName\">FindNodeByName</a> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#FindNode\">FindNode</a> raise this exception when node is not found.", "tags": "", "loc": "X3DNodes.TX3DNode.html#TryFindNodeByName"},
     {"title": "X3DNodes.TX3DNode.FindNodeByName", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#FindNodeByName"},
     {"title": "X3DNodes.TX3DNode.TryFindNode", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#TryFindNode"},
     {"title": "X3DNodes.TX3DNode.FindNode", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#FindNode"},
     {"title": "X3DNodes.TX3DNode.TryFindNodeState", "text": " Similar to <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">Traverse</a>, but stops as soon as the given node is found.  <p>Returns <code>False</code> when not found (&quot;out&quot; parametrs Node, State and Transform are undefined then).     ", "tags": "", "loc": "X3DNodes.TX3DNode.html#TryFindNodeState"},
     {"title": "X3DNodes.TX3DNode.TryFindNodeTransform", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#TryFindNodeTransform"},
     {"title": "X3DNodes.TX3DNode.TryFindParentByName", "text": "  <p>In other words, this is similar to TryNodeByName or NodeByName, but it goes &quot;upward&quot; in graph hierarchy. Note that this never restricts itself only to &quot;active&quot; graph part (&quot;active&quot; as defined by <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">Traverse</a>) because you really can't detect what is the &quot;active&quot; part of the graph when going upward.  <p>  <p>    EX3DNotFound <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#FindParentByName\">FindParentByName</a> raises this exception when node is not found.", "tags": "", "loc": "X3DNodes.TX3DNode.html#TryFindParentByName"},
     {"title": "X3DNodes.TX3DNode.FindParentByName", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#FindParentByName"},
     {"title": "X3DNodes.TX3DNode.HasParentNode", "text": " Similar to <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#TryFindParentByName\">TryFindParentByName</a>. Returns <code>True</code> only if found.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#HasParentNode"},
     {"title": "X3DNodes.TX3DNode.TryFindDirectParentByName", "text": " Returns <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#TryFindDirectParentByName"},
     {"title": "X3DNodes.TX3DNode.IsNodePresent", "text": " If OnlyActive, then only active parts are searched (&quot;active&quot; as defined by <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">Traverse</a>).    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#IsNodePresent"},
     {"title": "X3DNodes.TX3DNode.NodesCount", "text": " For example, you can pass NodeClass = <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html\">TAbstractLightNode</a> to count the light sources in the scene.  <p>If CountOnlyActiveNodes, then only active parts are searched (&quot;active&quot; as defined by <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">Traverse</a>).  <p>This traverses both VRML 1.0 children nodes and VRML 2.0 nodes inside SFNode and MFNode fields.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#NodesCount"},
     {"title": "X3DNodes.TX3DNode.SaveToStream", "text": " Saves everything, including node name, node type, and node contents.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#SaveToStream"},
     {"title": "X3DNodes.TX3DNode.VRML1StateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1StateNode"},
     {"title": "X3DNodes.TX3DNode.ForVRMLVersion", "text": " This functions decides it.  <p>For example some nodes can only work in VRML &lt; 2.0, some others only in VRML &gt;= 2.0. There are even some pairs of nodes: for example <a class=\"normal\" href=\"X3DNodes.TConeNode_1.html\">TConeNode_1</a> works with VRML &lt; 2.0, <a class=\"normal\" href=\"X3DNodes.TConeNode.html\">TConeNode</a> works with VRML &gt;= 2.0.  <p><a class=\"normal\" href=\"X3DNodes.html#NodesManager\">NodesManager</a> will use this.  <p>Default implementation of this function returns always <code>True</code>. Generally, I don't try to set this too aggresively &mdash; in other words, for all cases when it's sensible, I allow nodes to be used in every VRML/X3D version, even when official specification doesn't. This means that when reading VRML 1.0 files actually a large part of VRML 2.0 is allowed too, and also while reading VRML 2.0 many constructs from VRML 1.0 (officially no longer present in VRML 2.0) are allowed too. I'm trying to support what I call a &quot;sum of VRML 1.0 and 2.0&quot;.  <p>In practice I only use this function when various VRML/X3D versions specify the same node name but  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>With different fields.  <p>For example Cone and Cylinder have slightly different fields, due to the fact that VRML 2.0 resigned from using <a class=\"normal\" href=\"X3DFields.TSFBitMask.html\">TSFBitMask</a> fields.</p></li>   <li><p>With different behavior.  <p>For example definitions of Sphere for VRML 1.0 and 2.0 are practically equal. However, the behavior from where to take texture and material info is different &mdash; in VRML 1.0 we take last Texture2, Material etc. nodes, while in VRML 2.0 we look in parent Shape's &quot;appearance&quot; field. So once again two different Sphere classes are needed.</p></li> </ul>  <p>    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TX3DNode.EnumerateReplaceChildren", "text": "  <p>So this is something like <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#EnumerateNodes\">EnumerateNodes</a>, except that it allows you to remove the nodes. It always enumerates all nodes, not only active (e.g. it enumerates all Switch node children, not only the chosen one).  <p>Note that (unlike regular <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#EnumerateNodes\">EnumerateNodes</a>) <b>this doesn't report Self to Func !</b>. Which is natural, since this may remove nodes by normal <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1ChildRemove\">VRML1ChildRemove</a> calls, so it needs to know ParentNode of the removed node.  <p>For each node Func will be called, with ParentNode and Node set. If you change the Node to something else, then the old node will be removed and new Node inserted in the same place. If new Node is <code>Nil</code>, then only the old node will be removed.  <p>Nodes are traversed in depth-first search. Node is first reported to Func, and then (if it's not replaced) we descend into this Node.  <p>   The number of removed (and possibly replaced) nodes. ", "tags": "", "loc": "X3DNodes.TX3DNode.html#EnumerateReplaceChildren"},
     {"title": "X3DNodes.TX3DNode.RemoveChildrenWithMatchingName", "text": " You can use * and ? special chars in the Wildcard.    The number of removed nodes. ", "tags": "", "loc": "X3DNodes.TX3DNode.html#RemoveChildrenWithMatchingName"},
     {"title": "X3DNodes.TX3DNode.PrototypesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#PrototypesCount"},
     {"title": "X3DNodes.TX3DNode.AddPrototype", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AddPrototype"},
     {"title": "X3DNodes.TX3DNode.RoutesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#RoutesCount"},
     {"title": "X3DNodes.TX3DNode.AddRoute", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AddRoute"},
     {"title": "X3DNodes.TX3DNode.ImportsCount", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ImportsCount"},
     {"title": "X3DNodes.TX3DNode.AddImport", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AddImport"},
     {"title": "X3DNodes.TX3DNode.ExportsCount", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ExportsCount"},
     {"title": "X3DNodes.TX3DNode.AddExport", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AddExport"},
     {"title": "X3DNodes.TX3DNode.DeepCopy", "text": "  <p>New copy is completely independent from original, having all children nodes (in both VRML 1.0 sense (Children) and VRML &gt;= 2.0 (inside SFNode and MFNode fields)) also duplicated. New copy has protypes, routes, interface declarations and generally everything established like in the original, using copied nodes.  <p>Doesn't copy things which are dependent on container hierarchy. (So copying them would be more dangerous than useful.) This means: DestructionNotifications, Scene, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Parents\">VRML1Parents</a>, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#ParentFields\">ParentFields</a>. <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Parents\">VRML1Parents</a> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#ParentFields\">ParentFields</a> will be set for children anyway (to appropriate copies).  <p>Caller owns this newly created copy &mdash; as returned by this method, it's not linked anywhere.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#DeepCopy"},
     {"title": "X3DNodes.TX3DNode.URNMatching", "text": " This is used when searching for an built-in implementation of a node declared in X3D using the EXTERNPROTO.  <p>Implementors note: in this class, this returns <code>False</code>. You can use constants like <a class=\"normal\" href=\"X3DNodes.html#URNVRML97Nodes\">URNVRML97Nodes</a> and functions like <a class=\"normal\" href=\"X3DNodes.html#URNMatchingCastle\">URNMatchingCastle</a> to implement this easily.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#URNMatching"},
     {"title": "X3DNodes.TX3DNode.AddDestructionNotification", "text": "     ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AddDestructionNotification"},
     {"title": "X3DNodes.TX3DNode.RemoveDestructionNotification", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#RemoveDestructionNotification"},
     {"title": "X3DNodes.TX3DNode.PostAddInterfaceDeclaration", "text": "  <p>In this class, this simply adds IDecl.FieldOrEvent to our normal fields/events by IDecl.AddFieldOrEvent. You may override this in subclasses to react in some special way to new fields/events, for example Script node may register here to receive notification when input event is received.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#PostAddInterfaceDeclaration"},
     {"title": "X3DNodes.TX3DNode.AddCustomField", "text": " Sets the field's exposed to given Exposed parameter, for comfort. This should only be used with nodes having <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#HasInterfaceDeclarations\">HasInterfaceDeclarations</a> = <code>True</code>, like Script or ComposedShader.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AddCustomField"},
     {"title": "X3DNodes.TX3DNode.AddCustomFieldOrEvent", "text": " This should only be used with nodes having <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#HasInterfaceDeclarations\">HasInterfaceDeclarations</a> = <code>True</code>, like Script or ComposedShader.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#AddCustomFieldOrEvent"},
     {"title": "X3DNodes.TX3DNode.NiceName", "text": " Shows node type and name.    ", "tags": "", "loc": "X3DNodes.TX3DNode.html#NiceName"},
     {"title": "X3DNodes.TX3DNode.CDataField", "text": " Used when loading X3D in XML encoding: XML elements may contain CDATA sections, that are added to &quot;url&quot; field. See X3D XML encoding specification about &quot;Encapsulating Script node code&quot; [<a  href=\"http://www.web3d.org/x3d/specifications/ISO-IEC-19776-1.2-X3DEncodings-XML/Part01/concepts.html#EncapsulatingScriptNodeCode\">http://www.web3d.org/x3d/specifications/ISO-IEC-19776-1.2-X3DEncodings-XML/Part01/concepts.html#EncapsulatingScriptNodeCode</a>]. We also allow this for shader nodes (sensible (follows the intention of the spec) and compatible with InstantReality).  <p>When not assigned, then CDATA section for this node is not allowed.  <p>This should be set in descendants constructor. ", "tags": "", "loc": "X3DNodes.TX3DNode.html#CDataField"},
     {"title": "X3DNodes.TX3DNode.Fields", "text": "  <p>For normal nodes, all fields are created and added using <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#AddField\">AddField</a> from the constructor. Fields default values are set, and current field values are set to these defaults. Later, we only modify these fields current values (e.g. when parsing).  <p>However, there are special node classes that set their fields differently. <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html\">TX3DPrototypeNode</a> has their fields set according to it's VRML 2.0 prototype. <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html\">TX3DUnknownNode</a> may have it's fields set by VRML 1.0 &quot;fields&quot; feature (so it's Fields are initialized by parsing it).  <p>Nodes with <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#HasInterfaceDeclarations\">HasInterfaceDeclarations</a> have some Fields and Events added when reading node.  <p>All fields on this list are owned by this instance.  ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Fields"},
     {"title": "X3DNodes.TX3DNode.Events", "text": " For exposed events, see each field's property ExposedEvents.  ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Events"},
     {"title": "X3DNodes.TX3DNode.VRML1Children", "text": " These are nodes directly specified inside a VRML 1.0 node, they don't belong to any node field. (In VRML 1.0, there was no SFNode / MFNode fields.)  <p>In VRML 2.0, this is always empty.  <p>VRML 1.0 nodes may have any number of children. The children nodes refer back to it's parent nodes in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Parents\">VRML1Parents</a> list. When travelling over VRML/X3D graph, remember that cycles are possible, because of DEF/USE. Obviously, they possible when travelling along the <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Parents\">VRML1Parents</a> list. We currently assume that there are no cycles when we treat the graph as directed, but it may change one day (some VRML/X3D models create real cycles).  <p>Adding/removing stuff from the <code>VRML1Children</code> list keeps track of how many times a node is used. If the child node has no parents, it will be freed. Actually, nodes can be children of both nodes (VRML 1.0 style, then <code>VRML1Children</code> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Parents\">VRML1Parents</a> is used) or fields (<a class=\"normal\" href=\"X3DNodes.TMFNode.html\">TMFNode</a> or <a class=\"normal\" href=\"X3DNodes.TSFNode.html\">TSFNode</a>, in VRML 2.0 style; then <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#ParentFields\">ParentFields</a> is used). So the node is freed only when it's not referenced by any node and not referenced by any field. Generally, it's the parent that takes care of reference-counting and freeing the children, not the other way around.  <p>Note that given node instance may be a children of a single node multiple times, through DEF/USE mechanism. The order of children is important and preserved. (On the other hand, the order of <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Parents\">VRML1Parents</a> is not important, as that list is mostly for reference-counting.)  <p>You can replace one children with another like <code><code>VRML1Children</code>[I] := NewChildren;</code>. This works like a shortcut for <code><a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1ChildRemove\">VRML1ChildRemove</a>(I); <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1ChildAdd\">VRML1ChildAdd</a>(I, NewChildren);</code>. But 1. it's more efficient; 2. it's safer &mdash; if Children[I] is already equal to NewChildren, it does nothing.  <p> ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1Children"},
     {"title": "X3DNodes.TX3DNode.VRML1Parents", "text": " <code>VRML1Parents</code> is a reverse of <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Children\">VRML1Children</a> &mdash; it lists all the nodes where we are on <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Children\">VRML1Children</a> list.  <p> ", "tags": "", "loc": "X3DNodes.TX3DNode.html#VRML1Parents"},
     {"title": "X3DNodes.TX3DNode.ParentFields", "text": " This is somewhat analogous for <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Parents\">VRML1Parents</a>, but for VRML 2.0.  <p><a class=\"normal\" href=\"X3DNodes.TX3DNode.html#ParentFieldsNode\">ParentFieldsNode</a> is just for your comfort, it returns always appropriate field's ParentNode property value (i.e. <code>(ParentField[Index] as <a class=\"normal\" href=\"X3DNodes.TSFNode.html\">TSFNode</a>).ParentNode</code> or <code>(ParentField[Index] as <a class=\"normal\" href=\"X3DNodes.TMFNode.html\">TMFNode</a>).ParentNode</code>).  <p> ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ParentFields"},
     {"title": "X3DNodes.TX3DNode.ParentFieldsNode", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ParentFieldsNode"},
     {"title": "X3DNodes.TX3DNode.KeepExisting", "text": " This may be useful in cases when you remove the node from VRML graph hierarchy, but you want to keep a valid reference to it anyway (for example, maybe you'll free it later by hand or add it somewhere else).  <p>Simple methods <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#KeepExistingBegin\">KeepExistingBegin</a> and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#KeepExistingEnd\">KeepExistingEnd</a> simply increase / decrease <code>KeepExisting</code> value by 1. This is the most usual usage.  <p> ", "tags": "", "loc": "X3DNodes.TX3DNode.html#KeepExisting"},
     {"title": "X3DNodes.TX3DNode.X3DName", "text": " When saving/loading, this comes from VRML/X3D &quot;DEF&quot; construct. Empty value means that the name is not defined. Do not change this during loading / saving of the X3D graph, or searching for nodes e.g. by <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#EnumerateNodes\">EnumerateNodes</a>.  <p>Note that this property is deliberately not called <code>Name</code>. In the future, this class may descend from the standard TComponent class, that defines a <code>Name</code> field with a special restrictions (it must be a valid Pascal identifier), which cannot apply to X3D node names (that can have quite free names, see <a  href=\"http://www.web3d.org/documents/specifications/19776-2/V3.3/Part02/grammar.html\">http://www.web3d.org/documents/specifications/19776-2/V3.3/Part02/grammar.html</a> ). We don't want to confuse these two properties. ", "tags": "", "loc": "X3DNodes.TX3DNode.html#X3DName"},
     {"title": "X3DNodes.TX3DNode.NodeName", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#NodeName"},
     {"title": "X3DNodes.TX3DNode.BaseUrl", "text": " Used everywhere as a base for relative URLs, to handle fields that refer to external files like textures, other 3D models (ImageTexture, Inline nodes, many others).  <p>It must be an absolute URL. Currently, it doesn't have to contain a protocol, and is then interpreted as a path on local filesystem (just like it had <a  href=\"file://\">file://</a> prefix). Still, it must be an absolute path.  <p>This is set in constructor, and eventually adjusted by various parsing routines. This way we could, if only we would like to, resolve nodes like Inline or ImageTexture immediately after parsing them. ", "tags": "", "loc": "X3DNodes.TX3DNode.html#BaseUrl"},
     {"title": "X3DNodes.TX3DNode.WWWBasePath", "text": "  ", "tags": "", "loc": "X3DNodes.TX3DNode.html#WWWBasePath"},
     {"title": "X3DNodes.TX3DNode.Prototypes", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Prototypes"},
     {"title": "X3DNodes.TX3DNode.Routes", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Routes"},
     {"title": "X3DNodes.TX3DNode.ImportsList", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ImportsList"},
     {"title": "X3DNodes.TX3DNode.ExportsList", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ExportsList"},
     {"title": "X3DNodes.TX3DNode.PrototypeInstance", "text": "  <p>Then <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode\">PrototypeInstanceSourceNode</a> is non-nil and indicates parsed prototype node (and PrototypeInstanceSourceNode.Prototype gives you even a link to the actual prototype specification).  <p><a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode\">PrototypeInstanceSourceNode</a> is used for events: any ROUTEs specified <i>outside</i> of prototype and leading to/from instantiated prototype should actually lead to <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode\">PrototypeInstanceSourceNode</a> events (not to events of Self). Reason: prototype events may be different than actual expanded node events, and ROUTEs want to lead to prototype events. This is implemented when expanding prototype (<a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html#Instantiate\">TX3DPrototypeNode.Instantiate</a>) and when linking ROUTE (<a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SetSource\">TX3DRoute.SetSource</a>, <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SetDestination\">TX3DRoute.SetDestination</a>).  <p><a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceHelpers\">PrototypeInstanceHelpers</a> may be <code>Nil</code> if empty, or may contain a list of other nodes duplicated along with the main prototype node. From VRML spec:  <p><i>Any other nodes and accompanying scene graphs are not part of the transformation hierarchy, but may be referenced by ROUTE statements or Script nodes in the prototype definition.</i>  <p>Note that for <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html\">TX3DPrototypeNode</a> (within <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode\">PrototypeInstanceSourceNode</a>) these have a little different meaning: they describe the <i>nested prototype</i>, if any, that was used to create this node. This may happen if the node was expanded from one prototype within another. (Usually, you shouldn't be concerned about this; see <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html#Instantiate\">TX3DPrototypeNode.Instantiate</a> implementation comments for gory details about this.)  <p> ", "tags": "", "loc": "X3DNodes.TX3DNode.html#PrototypeInstance"},
     {"title": "X3DNodes.TX3DNode.PrototypeInstanceSourceNode", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode"},
     {"title": "X3DNodes.TX3DNode.PrototypeInstanceHelpers", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#PrototypeInstanceHelpers"},
     {"title": "X3DNodes.TX3DNode.DefaultContainerField", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#DefaultContainerField"},
     {"title": "X3DNodes.TX3DNode.HasInterfaceDeclarations", "text": "  <p>In X3D specification this is marked like  <p></p>  <pre class=\"preformatted\"> # And any number of: fieldType [in]     fieldName fieldType [in,out] fieldName    initialValue fieldType [out]    fieldName fieldType []       fieldName    initialValue</pre>  <p>  <p>If <code>HasInterfaceDeclarations</code> is not [], then <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#InterfaceDeclarations\">InterfaceDeclarations</a> will be non-nil and parser (classic VRML parser in this unit, X3D XML reader too) will read this from VRML files. Moreover, for each interface declaration, also appropriate field/event will be added to the list of <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Fields\">Fields</a> or <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Events\">Events</a>, so fields/events created by interface declarations will function just like other standard fields everywhere.  <p> ", "tags": "", "loc": "X3DNodes.TX3DNode.html#HasInterfaceDeclarations"},
     {"title": "X3DNodes.TX3DNode.InterfaceDeclarations", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#InterfaceDeclarations"},
     {"title": "X3DNodes.TX3DNode.Scene", "text": " This is necessary to allow the scene to properly process VRML/X3D events, and also to react properly to any other changes to the nodes (like when you change some field directly by ObjectPascal code, e.g. by <a class=\"normal\" href=\"X3DFields.TX3DField.html#Send\">TX3DField.Send</a>).  <p>May be <code>Nil</code> if none.  <p>A given <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> may be renderable only by a single renderer. This means it can be placed only within one <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>. ", "tags": "", "loc": "X3DNodes.TX3DNode.html#Scene"},
     {"title": "X3DNodes.TX3DNode.ShapeTrees", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNode.html#ShapeTrees"},
     {"title": "X3DNodes.TX3DNodeList", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNodeList.html"},
     {"title": "X3DNodes.TX3DNodeList.FindName", "text": "  <p>For empty node name, always returns <code>Nil</code>. This follows the definition of <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#X3DName\">TX3DNode.X3DName</a>: empty means that node has no name, so it should not be found by searches by name, ever.  <p>    ", "tags": "", "loc": "X3DNodes.TX3DNodeList.html#FindName"},
     {"title": "X3DNodes.TX3DNodeList.IndexOfName", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeList.html#IndexOfName"},
     {"title": "X3DNodes.TX3DNodeList.AddIfNotExists", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeList.html#AddIfNotExists"},
     {"title": "X3DNodes.TX3DNodeList.Equals", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeList.html#Equals"},
     {"title": "X3DNodes.TX3DNodeList.Assign", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeList.html#Assign"},
     {"title": "X3DNodes.TX3DNodeList.Assign", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeList.html#Assign"},
     {"title": "X3DNodes.TSFTextureUpdate", "text": " ", "tags": "", "loc": "X3DNodes.TSFTextureUpdate.html"},
     {"title": "X3DNodes.TSFTextureUpdate.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TSFTextureUpdate.html#Create"},
     {"title": "X3DNodes.TSFTextureUpdate.ExecuteChanges", "text": "    ", "tags": "", "loc": "X3DNodes.TSFTextureUpdate.html#ExecuteChanges"},
     {"title": "X3DNodes.TSFTextureUpdate.Send", "text": "    ", "tags": "", "loc": "X3DNodes.TSFTextureUpdate.html#Send"},
     {"title": "X3DNodes.TSFTextureUpdate.Value", "text": " Takes care of doing warning if the underlying string value (in VRML/X3D) is invalid. ", "tags": "", "loc": "X3DNodes.TSFTextureUpdate.html#Value"},
     {"title": "X3DNodes.TGeneratedTextureHandler", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedTextureHandler.html"},
     {"title": "X3DNodes.TGeneratedTextureHandler.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TGeneratedTextureHandler.html#Create"},
     {"title": "X3DNodes.TGeneratedTextureHandler.UpdateNeeded", "text": " If not, then you do not have to update the texture &mdash; no point, since it would look exactly like the current one.  <p>Scene classes (<a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>, <a class=\"normal\" href=\"CastleRenderer.TGLRenderer.html\">TGLRenderer</a>) take care to set this field. After each actual update of the texture, it's set to <code>False</code>. Each time something visible affecting the look of this texture possibly changed, it's set to <code>True</code>. ", "tags": "", "loc": "X3DNodes.TGeneratedTextureHandler.html#UpdateNeeded"},
     {"title": "X3DNodes.TGeneratedTextureHandler.Update", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedTextureHandler.html#Update"},
     {"title": "X3DNodes.TX3DNodeClassesList", "text": "  <p>This file is part of &quot;Castle Game Engine&quot;.  <p>&quot;Castle Game Engine&quot; is free software; see the file COPYING.txt, included in this distribution, for details about the copyright.  <p>&quot;Castle Game Engine&quot; is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  <p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;- ", "tags": "", "loc": "X3DNodes.TX3DNodeClassesList.html"},
     {"title": "X3DNodes.TX3DNodeClassesList.AssignArray", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeClassesList.html#AssignArray"},
     {"title": "X3DNodes.TX3DNodeClassesList.IndexOf", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeClassesList.html#IndexOf"},
     {"title": "X3DNodes.TX3DNodeClassesList.IndexOf", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeClassesList.html#IndexOf"},
     {"title": "X3DNodes.TX3DNodeClassesList.IndexOfAnyAncestor", "text": " Contrast this with <a class=\"normal\" href=\"X3DNodes.TX3DNodeClassesList.html#IndexOf\">IndexOf</a> method, which looks only for an exact class match.  <p>Returns -1 if not found.    ", "tags": "", "loc": "X3DNodes.TX3DNodeClassesList.html#IndexOfAnyAncestor"},
     {"title": "X3DNodes.TX3DNodeClassesList.Add", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeClassesList.html#Add"},
     {"title": "X3DNodes.TX3DNodeClassesList.AddRegisteredImplementing", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeClassesList.html#AddRegisteredImplementing"},
     {"title": "X3DNodes.TX3DNodeClassesList.Items", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNodeClassesList.html#Items"},
     {"title": "X3DNodes.TSFNode", "text": " It's defined in this unit, not in <a class=\"normal\" href=\"X3DFields.html\">X3DFields</a>, since it uses <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> definition. NULL value of the field is indicated by Value field = nil.  <p>Note that we store AllowedChildren list, which is a list of classes allowed as a Value (also nil is always allowed). But this is used only to produce warnings for a user. You should never assert that Value actually is one the requested classes. We want to keep here even not allowed items, because we want operation &quot;read from VRML file + write to VRML file&quot; to be as non-destructible as possible. So if user wrote invalid class hierarchy, we will output this invalid class hierarchy. ", "tags": "", "loc": "X3DNodes.TSFNode.html"},
     {"title": "X3DNodes.TSFNode.CreateUndefined", "text": " Suitable only for special cases. For example, in instantiated prototypes, we must initially just allow all children, otherwise valid prototypes with SFNode/MFNode would cause warnings when parsing.    ", "tags": "", "loc": "X3DNodes.TSFNode.html#CreateUndefined"},
     {"title": "X3DNodes.TSFNode.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#Create"},
     {"title": "X3DNodes.TSFNode.Create", "text": " Note that we copy the contents of AAllowedChildrenClasses, not the reference.    ", "tags": "", "loc": "X3DNodes.TSFNode.html#Create"},
     {"title": "X3DNodes.TSFNode.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#Create"},
     {"title": "X3DNodes.TSFNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#Destroy"},
     {"title": "X3DNodes.TSFNode.ParseValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#ParseValue"},
     {"title": "X3DNodes.TSFNode.ParseXMLAttribute", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#ParseXMLAttribute"},
     {"title": "X3DNodes.TSFNode.ParseXMLElement", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#ParseXMLElement"},
     {"title": "X3DNodes.TSFNode.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#EqualsDefaultValue"},
     {"title": "X3DNodes.TSFNode.Equals", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#Equals"},
     {"title": "X3DNodes.TSFNode.Assign", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#Assign"},
     {"title": "X3DNodes.TSFNode.AssignValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#AssignValue"},
     {"title": "X3DNodes.TSFNode.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#AssignDefaultValueFromValue"},
     {"title": "X3DNodes.TSFNode.X3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#X3DType"},
     {"title": "X3DNodes.TSFNode.CreateEvent", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#CreateEvent"},
     {"title": "X3DNodes.TSFNode.WarningIfChildNotAllowed", "text": "  <p>Check is allowed is done looking at AllowedChildrenAll and AllowedChildren properties.  <p>Child must not be <code>Nil</code>.  <p><a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> message will suggest that this Child is used as value of this node. In other words, you should only pass as Child a node that you want to assign as Value to this field, otherwise <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> message will be a little unsensible.    ", "tags": "", "loc": "X3DNodes.TSFNode.html#WarningIfChildNotAllowed"},
     {"title": "X3DNodes.TSFNode.ChildAllowed", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#ChildAllowed"},
     {"title": "X3DNodes.TSFNode.CurrentChildAllowed", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#CurrentChildAllowed"},
     {"title": "X3DNodes.TSFNode.Enumerate", "text": " The main use for this is to simplify implementation of <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#DirectEnumerateActive\">TX3DNode.DirectEnumerateActive</a> overrides in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> descendants.    ", "tags": "", "loc": "X3DNodes.TSFNode.html#Enumerate"},
     {"title": "X3DNodes.TSFNode.Send", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNode.html#Send"},
     {"title": "X3DNodes.TSFNode.DefaultValue", "text": "  <p>While X3D specification says for all SFNode fields that their default value is NULL, this is not necessarily true for PROTO SFNode fiels. So we have to take into account that any <code>DefaultValue</code> is possible.  <p>Note that this doesn't have to be <code>Nil</code>, but will be irrelevant if not <a class=\"normal\" href=\"X3DNodes.TSFNode.html#DefaultValueExists\">DefaultValueExists</a>. (Once I had an idea to automatically set <code>DefaultValue</code> to <code>Nil</code> when <a class=\"normal\" href=\"X3DNodes.TSFNode.html#DefaultValueExists\">DefaultValueExists</a> is set to <code>False</code>, but this was uncomfortable (like &quot;what to do when <code>DefaultValue</code> is assigned non-nil when <a class=\"normal\" href=\"X3DNodes.TSFNode.html#DefaultValueExists\">DefaultValueExists</a> is false?&quot;).)  <p>Freeing of this is automatically managed, just like the normal <a class=\"normal\" href=\"X3DNodes.TSFNode.html#Value\">Value</a> property. This means that you can simply set <code>DefaultValue</code> to <code>Nil</code> or some existing node, and eventual memory deallocation of previous <code>DefaultValue</code> node (if unused) will happen automatically. ", "tags": "", "loc": "X3DNodes.TSFNode.html#DefaultValue"},
     {"title": "X3DNodes.TSFNode.DefaultValueExists", "text": " ", "tags": "", "loc": "X3DNodes.TSFNode.html#DefaultValueExists"},
     {"title": "X3DNodes.TSFNode.Value", "text": " ", "tags": "", "loc": "X3DNodes.TSFNode.html#Value"},
     {"title": "X3DNodes.TSFNode.ParentNode", "text": " May be <code>Nil</code> if unknown, in special cases.  <p>Note that this property is exactly the same as <a class=\"normal\" href=\"X3DFields.TX3DFieldOrEvent.html#ParentNode\">TX3DFieldOrEvent.ParentNode</a>, contains always the same value. But this is declared as <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a>, so it's more comfortable. ", "tags": "", "loc": "X3DNodes.TSFNode.html#ParentNode"},
     {"title": "X3DNodes.TSFNode.WeakLink", "text": "  <p>Marking a field as a <i>weak link</i> can only be done when the field value is empty, right when the field is created, in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#CreateNode\">TX3DNode.CreateNode</a> descendant.  <p>Being a <i>weak link</i> means two things:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>The nodes inside a weak link are not enumerated when traversing the X3D graph in <i>any</i> way. This includes <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#EnumerateNodes\">TX3DNode.EnumerateNodes</a>, <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">TX3DNode.Traverse</a> and all others. Nodes implementing <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#DirectEnumerateActive\">TX3DNode.DirectEnumerateActive</a> should also omit these fields.</p></li>   <li value=\"2\"><p>A weak link does not create a reference count preventing the node from being freed (or freeing it automatically when ref count drops to zero). Instead, weak links merely observe the nodes, and automatically set their value to <code>Nil</code> when the node gets freed.</p></li> </ol>  <p>  <p>If effect, this avoids loops when enumerating (and avoids recursive loops in reference counts, which would cause memory leaks), but use this only when you know that the node must occur somewhere else in the X3D graph anyway (or it's OK to ignore it). For example, this is useful for <a class=\"normal\" href=\"X3DNodes.TGeneratedShadowMapNode.html#Light\">TGeneratedShadowMapNode.Light</a>, as we know that the light must occur somewhere else in the graph anyway to be useful. ", "tags": "", "loc": "X3DNodes.TSFNode.html#WeakLink"},
     {"title": "X3DNodes.TSFNodeEventHelper", "text": " ", "tags": "", "loc": "X3DNodes.TSFNodeEventHelper.html"},
     {"title": "X3DNodes.TSFNodeEventHelper.Send", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNodeEventHelper.html#Send"},
     {"title": "X3DNodes.TSFNodeEventHelper.Send", "text": "    ", "tags": "", "loc": "X3DNodes.TSFNodeEventHelper.html#Send"},
     {"title": "X3DNodes.TMFNode", "text": "  <p>Just like SFNode, it's defined in this unit, as it uses <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a>. Note that items of MFNode <i>cannot</i> be nil (i.e. VRML/X3D doesn't allow to use NULL inside MFNode), contrary to SFNode.  <p>Note that <code>TMFNode</code> implementation doesn't use <a class=\"normal\" href=\"X3DFields.TX3DSimpleMultField.html\">TX3DSimpleMultField</a>. One reason is that we don't want to parse MFNode items by SFNode parser, because MFNode doesn't allow NULL items. (In the past, another argument was that we want to use <a class=\"normal\" href=\"X3DNodes.TX3DNodeList.html\">TX3DNodeList</a> and it wasn't compatible with <a class=\"normal\" href=\"X3DFields.TX3DSimpleMultField.html\">TX3DSimpleMultField</a>. But now <a class=\"normal\" href=\"X3DNodes.TX3DNodeList.html\">TX3DNodeList</a> descends from TFPSList, so it isn't a problem.)  <p>Just like for <a class=\"normal\" href=\"X3DNodes.TSFNode.html\">TSFNode</a>: Note that we store AllowedChildren list, which is a list of classes allowed as Items. But this is used only to produce warnings for a user. You should never assert that every item actually is one the requested classes. ", "tags": "", "loc": "X3DNodes.TMFNode.html"},
     {"title": "X3DNodes.TMFNode.CreateUndefined", "text": " Suitable only for special cases. For example, in instantiated prototypes, we must initially just allow all children, otherwise valid prototypes with SFNode/MFNode would cause warnings when parsing.    ", "tags": "", "loc": "X3DNodes.TMFNode.html#CreateUndefined"},
     {"title": "X3DNodes.TMFNode.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Create"},
     {"title": "X3DNodes.TMFNode.Create", "text": " Note that we copy the contents of AAllowedChildrenClasses, not the reference.    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Create"},
     {"title": "X3DNodes.TMFNode.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Create"},
     {"title": "X3DNodes.TMFNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Destroy"},
     {"title": "X3DNodes.TMFNode.Add", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Add"},
     {"title": "X3DNodes.TMFNode.Add", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Add"},
     {"title": "X3DNodes.TMFNode.Delete", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Delete"},
     {"title": "X3DNodes.TMFNode.Remove", "text": " Returns the index of removed item, or -1 if not found.    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Remove"},
     {"title": "X3DNodes.TMFNode.Extract", "text": " This is analogous to TX3DNode.ExtractChild, see there for more explanation.    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Extract"},
     {"title": "X3DNodes.TMFNode.Clear", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Clear"},
     {"title": "X3DNodes.TMFNode.AssignItems", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#AssignItems"},
     {"title": "X3DNodes.TMFNode.AssignItems", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#AssignItems"},
     {"title": "X3DNodes.TMFNode.Replace", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Replace"},
     {"title": "X3DNodes.TMFNode.ParseValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#ParseValue"},
     {"title": "X3DNodes.TMFNode.ParseXMLAttribute", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#ParseXMLAttribute"},
     {"title": "X3DNodes.TMFNode.ParseXMLElement", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#ParseXMLElement"},
     {"title": "X3DNodes.TMFNode.EqualsDefaultValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#EqualsDefaultValue"},
     {"title": "X3DNodes.TMFNode.Equals", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Equals"},
     {"title": "X3DNodes.TMFNode.Assign", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Assign"},
     {"title": "X3DNodes.TMFNode.AssignValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#AssignValue"},
     {"title": "X3DNodes.TMFNode.AssignDefaultValueFromValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#AssignDefaultValueFromValue"},
     {"title": "X3DNodes.TMFNode.X3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#X3DType"},
     {"title": "X3DNodes.TMFNode.CreateEvent", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#CreateEvent"},
     {"title": "X3DNodes.TMFNode.WarningIfChildNotAllowed", "text": "  <p>Check is allowed is done looking at AllowedChildrenAll and AllowedChildren properties.  <p>Child must not be <code>Nil</code>.  <p><a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> message will suggest that this Child is added to this node. In other words, you should only pass as Child a node that you want to add (e.g. by <a class=\"normal\" href=\"X3DNodes.TMFNode.html#Add\">Add</a>) to this field, otherwise <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> message will be a little unsensible.    ", "tags": "", "loc": "X3DNodes.TMFNode.html#WarningIfChildNotAllowed"},
     {"title": "X3DNodes.TMFNode.ChildAllowed", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#ChildAllowed"},
     {"title": "X3DNodes.TMFNode.AssignDefaultItems", "text": "     ", "tags": "", "loc": "X3DNodes.TMFNode.html#AssignDefaultItems"},
     {"title": "X3DNodes.TMFNode.ClearDefault", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#ClearDefault"},
     {"title": "X3DNodes.TMFNode.Enumerate", "text": " Stops if Func returns something non-nil. The main use for this is to simplify implementation of <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#DirectEnumerateActive\">TX3DNode.DirectEnumerateActive</a> overrides in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> descendants.    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Enumerate"},
     {"title": "X3DNodes.TMFNode.Send", "text": "    ", "tags": "", "loc": "X3DNodes.TMFNode.html#Send"},
     {"title": "X3DNodes.TMFNode.Items", "text": "  <p>Do not modify this list explicitly. Use only methods in this class like <a class=\"normal\" href=\"X3DNodes.TMFNode.html#Add\">Add</a>. They take care of calling appropriate AddParentField / RemoveParentField, otherwise you could break reference-counting of nodes by ParentFields. ", "tags": "", "loc": "X3DNodes.TMFNode.html#Items"},
     {"title": "X3DNodes.TMFNode.ItemsArray", "text": " ", "tags": "", "loc": "X3DNodes.TMFNode.html#ItemsArray"},
     {"title": "X3DNodes.TMFNode.ParentNode", "text": " ", "tags": "", "loc": "X3DNodes.TMFNode.html#ParentNode"},
     {"title": "X3DNodes.TMFNode.DefaultItems", "text": "  <p>Do not modify this list explicitly. Use only methods in this class like <a class=\"normal\" href=\"X3DNodes.TMFNode.html#AssignDefaultItems\">AssignDefaultItems</a> (they take care of calling appropriate AddParentField / RemoveParentField, otherwise you could break reference-counting of nodes by ParentFields). ", "tags": "", "loc": "X3DNodes.TMFNode.html#DefaultItems"},
     {"title": "X3DNodes.TMFNode.DefaultValueExists", "text": " ", "tags": "", "loc": "X3DNodes.TMFNode.html#DefaultValueExists"},
     {"title": "X3DNodes.IAbstractNode", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractNode.html"},
     {"title": "X3DNodes.IAbstractNode.FdMetadata", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractNode.html#FdMetadata"},
     {"title": "X3DNodes.IAbstractMetadataNode", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractMetadataNode.html"},
     {"title": "X3DNodes.IAbstractMetadataNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractMetadataNode.html#FdName"},
     {"title": "X3DNodes.IAbstractMetadataNode.FdReference", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractMetadataNode.html#FdReference"},
     {"title": "X3DNodes.TAbstractNode", "text": "  <p>Almost all X3D nodes inherit from this, with the only exception being the X3DMetadataObject (expressed only as an interface in Pascal, <a class=\"normal\" href=\"X3DNodes.IAbstractMetadataNode.html\">IAbstractMetadataNode</a>). This means that you cannot have metadata inside a metadata. ", "tags": "", "loc": "X3DNodes.TAbstractNode.html"},
     {"title": "X3DNodes.TAbstractNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractNode.FdMetadata", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNode.html#FdMetadata"},
     {"title": "X3DNodes.IAbstractChildNode", "text": " inside <a class=\"normal\" href=\"X3DNodes.TAbstractX3DGroupingNode.html#FdChildren\">TAbstractX3DGroupingNode.FdChildren</a>. ", "tags": "", "loc": "X3DNodes.IAbstractChildNode.html"},
     {"title": "X3DNodes.TAbstractChildNode", "text": " inside <a class=\"normal\" href=\"X3DNodes.TAbstractX3DGroupingNode.html#FdChildren\">TAbstractX3DGroupingNode.FdChildren</a>. ", "tags": "", "loc": "X3DNodes.TAbstractChildNode.html"},
     {"title": "X3DNodes.TAbstractChildNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractChildNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractBindableNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBindableNode.html"},
     {"title": "X3DNodes.TAbstractBindableNode.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBindableNode.html#BeforeTraverse"},
     {"title": "X3DNodes.TAbstractBindableNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBindableNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractBindableNode.EventSet_bind", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBindableNode.html#EventSet_bind"},
     {"title": "X3DNodes.TAbstractBindableNode.EventBindTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBindableNode.html#EventBindTime"},
     {"title": "X3DNodes.TAbstractBindableNode.EventIsBound", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBindableNode.html#EventIsBound"},
     {"title": "X3DNodes.TAbstractBindableNode.Transform", "text": "  <p>Bound nodes cannot be instantiated multiple number of times (this would make simple event like &quot;set_bind&quot; not possible, as it would not be known in what coordinate space the node is bound), so it's perfectly safe and comfortable to just keep their transformation here, a their property.  <p>It is gathered during traversing. Last <a class=\"normal\" href=\"X3DNodes.TAbstractBindableNode.html#BeforeTraverse\">BeforeTraverse</a> call for this node sets Transform properties. By default, these represent identity transformation.  <p>Note that using <a class=\"normal\" href=\"X3DNodes.TAbstractBindableNode.html#TransformScale\">TransformScale</a> for bindable nodes like fog is a little simplification. Theoretically, the scale can be non-uniform, and around an arbitrary axis. So to apply e.g. fog, we should transform the 3D world back into local fog coordinate system, and calculate the distances there. Instead right now we do the opposite: transform stuff like fog VisibilityRange by <a class=\"normal\" href=\"X3DNodes.TAbstractBindableNode.html#TransformScale\">TransformScale</a>, and calculate distances in world coordinate system. This is a simplification, but in practice it's perfect (who uses non-uniform fog scale?) and it can be expressed for renderers (OpenGL) without any problems.  <p> ", "tags": "", "loc": "X3DNodes.TAbstractBindableNode.html#Transform"},
     {"title": "X3DNodes.TAbstractBindableNode.TransformScale", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBindableNode.html#TransformScale"},
     {"title": "X3DNodes.TAbstractInfoNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractInfoNode.html"},
     {"title": "X3DNodes.IAbstractSensorNode", "text": " All sensors implement this (and most, but not all, sensors descend also from <a class=\"normal\" href=\"X3DNodes.TAbstractSensorNode.html\">TAbstractSensorNode</a>.) ", "tags": "", "loc": "X3DNodes.IAbstractSensorNode.html"},
     {"title": "X3DNodes.IAbstractSensorNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractSensorNode.html#FdEnabled"},
     {"title": "X3DNodes.IAbstractSensorNode.EventIsActive", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractSensorNode.html#EventIsActive"},
     {"title": "X3DNodes.TAbstractSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSensorNode.html"},
     {"title": "X3DNodes.TAbstractSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractSensorNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSensorNode.html#FdEnabled"},
     {"title": "X3DNodes.TAbstractSensorNode.EventIsActive", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSensorNode.html#EventIsActive"},
     {"title": "X3DNodes.TAbstractSensorNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSensorNode.html#Enabled"},
     {"title": "X3DNodes.TMetadataBooleanNode", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html"},
     {"title": "X3DNodes.TMetadataBooleanNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#CreateNode"},
     {"title": "X3DNodes.TMetadataBooleanNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMetadataBooleanNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#URNMatching"},
     {"title": "X3DNodes.TMetadataBooleanNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataBooleanNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataBooleanNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#FdName"},
     {"title": "X3DNodes.TMetadataBooleanNode.FdReference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#FdReference"},
     {"title": "X3DNodes.TMetadataBooleanNode.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#FdValue"},
     {"title": "X3DNodes.TMetadataBooleanNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#NameField"},
     {"title": "X3DNodes.TMetadataBooleanNode.Reference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataBooleanNode.html#Reference"},
     {"title": "X3DNodes.TMetadataDoubleNode", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html"},
     {"title": "X3DNodes.TMetadataDoubleNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#CreateNode"},
     {"title": "X3DNodes.TMetadataDoubleNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMetadataDoubleNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#URNMatching"},
     {"title": "X3DNodes.TMetadataDoubleNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataDoubleNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataDoubleNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#FdName"},
     {"title": "X3DNodes.TMetadataDoubleNode.FdReference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#FdReference"},
     {"title": "X3DNodes.TMetadataDoubleNode.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#FdValue"},
     {"title": "X3DNodes.TMetadataDoubleNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#NameField"},
     {"title": "X3DNodes.TMetadataDoubleNode.Reference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataDoubleNode.html#Reference"},
     {"title": "X3DNodes.TMetadataFloatNode", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html"},
     {"title": "X3DNodes.TMetadataFloatNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#CreateNode"},
     {"title": "X3DNodes.TMetadataFloatNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMetadataFloatNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#URNMatching"},
     {"title": "X3DNodes.TMetadataFloatNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataFloatNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataFloatNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#FdName"},
     {"title": "X3DNodes.TMetadataFloatNode.FdReference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#FdReference"},
     {"title": "X3DNodes.TMetadataFloatNode.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#FdValue"},
     {"title": "X3DNodes.TMetadataFloatNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#NameField"},
     {"title": "X3DNodes.TMetadataFloatNode.Reference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataFloatNode.html#Reference"},
     {"title": "X3DNodes.TMetadataIntegerNode", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html"},
     {"title": "X3DNodes.TMetadataIntegerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#CreateNode"},
     {"title": "X3DNodes.TMetadataIntegerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMetadataIntegerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#URNMatching"},
     {"title": "X3DNodes.TMetadataIntegerNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataIntegerNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataIntegerNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#FdName"},
     {"title": "X3DNodes.TMetadataIntegerNode.FdReference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#FdReference"},
     {"title": "X3DNodes.TMetadataIntegerNode.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#FdValue"},
     {"title": "X3DNodes.TMetadataIntegerNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#NameField"},
     {"title": "X3DNodes.TMetadataIntegerNode.Reference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataIntegerNode.html#Reference"},
     {"title": "X3DNodes.TMetadataSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataSetNode.html"},
     {"title": "X3DNodes.TMetadataSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataSetNode.html#CreateNode"},
     {"title": "X3DNodes.TMetadataSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMetadataSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataSetNode.html#URNMatching"},
     {"title": "X3DNodes.TMetadataSetNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataSetNode.html#FdName"},
     {"title": "X3DNodes.TMetadataSetNode.FdReference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataSetNode.html#FdReference"},
     {"title": "X3DNodes.TMetadataSetNode.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataSetNode.html#FdValue"},
     {"title": "X3DNodes.TMetadataSetNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataSetNode.html#NameField"},
     {"title": "X3DNodes.TMetadataSetNode.Reference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataSetNode.html#Reference"},
     {"title": "X3DNodes.TMetadataStringNode", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html"},
     {"title": "X3DNodes.TMetadataStringNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#CreateNode"},
     {"title": "X3DNodes.TMetadataStringNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMetadataStringNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#URNMatching"},
     {"title": "X3DNodes.TMetadataStringNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataStringNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#SetValue"},
     {"title": "X3DNodes.TMetadataStringNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#FdName"},
     {"title": "X3DNodes.TMetadataStringNode.FdReference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#FdReference"},
     {"title": "X3DNodes.TMetadataStringNode.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#FdValue"},
     {"title": "X3DNodes.TMetadataStringNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#NameField"},
     {"title": "X3DNodes.TMetadataStringNode.Reference", "text": " ", "tags": "", "loc": "X3DNodes.TMetadataStringNode.html#Reference"},
     {"title": "X3DNodes.TWorldInfoNode", "text": " This node is strictly for documentation purposes and has no effect on the visual appearance or behaviour of the world. ", "tags": "", "loc": "X3DNodes.TWorldInfoNode.html"},
     {"title": "X3DNodes.TWorldInfoNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TWorldInfoNode.html#CreateNode"},
     {"title": "X3DNodes.TWorldInfoNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TWorldInfoNode.html#ClassX3DType"},
     {"title": "X3DNodes.TWorldInfoNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TWorldInfoNode.html#URNMatching"},
     {"title": "X3DNodes.TWorldInfoNode.SetInfo", "text": "    ", "tags": "", "loc": "X3DNodes.TWorldInfoNode.html#SetInfo"},
     {"title": "X3DNodes.TWorldInfoNode.SetInfo", "text": "    ", "tags": "", "loc": "X3DNodes.TWorldInfoNode.html#SetInfo"},
     {"title": "X3DNodes.TWorldInfoNode.FdInfo", "text": " ", "tags": "", "loc": "X3DNodes.TWorldInfoNode.html#FdInfo"},
     {"title": "X3DNodes.TWorldInfoNode.FdTitle", "text": " ", "tags": "", "loc": "X3DNodes.TWorldInfoNode.html#FdTitle"},
     {"title": "X3DNodes.TWorldInfoNode.Title", "text": " ", "tags": "", "loc": "X3DNodes.TWorldInfoNode.html#Title"},
     {"title": "X3DNodes.IAbstractTimeDependentNode", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractTimeDependentNode.html"},
     {"title": "X3DNodes.IAbstractTimeDependentNode.GetInternalTimeDependentHandler", "text": "    ", "tags": "", "loc": "X3DNodes.IAbstractTimeDependentNode.html#GetInternalTimeDependentHandler"},
     {"title": "X3DNodes.IAbstractTimeDependentNode.GetCycleInterval", "text": " For a looping animation, this is the time it takes to make a single cycle. Should always be &gt; 0.  <p>This is not called <i>&quot;duration&quot;</i>, as that word is reserved to mean <i>&quot;unscaled time length&quot;</i> for X3D AudioClip and MovieTexture nodes. The final length, returned here, is the AudioClip.duration divided by AudioClip.pitch, or MovieTexture.duration / MovieTexture.speed.  <p>On <a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html\">TTimeSensorNode</a> descendants, you can also get and set this by the property <a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html#CycleInterval\">TTimeSensorNode.CycleInterval</a>.    ", "tags": "", "loc": "X3DNodes.IAbstractTimeDependentNode.html#GetCycleInterval"},
     {"title": "X3DNodes.IAbstractTimeDependentNode.IsActive", "text": "  <p>For a precise (and complicated:) specification of how this behaves, see the X3D TimeSensor.isActive specification at <a  href=\"http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor\">http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor</a>    ", "tags": "", "loc": "X3DNodes.IAbstractTimeDependentNode.html#IsActive"},
     {"title": "X3DNodes.IAbstractTimeDependentNode.IsPaused", "text": "  <p>For a precise (and complicated:) specification of how this behaves, see the X3D TimeSensor.isPaused specification at <a  href=\"http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor\">http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor</a>    ", "tags": "", "loc": "X3DNodes.IAbstractTimeDependentNode.html#IsPaused"},
     {"title": "X3DNodes.IAbstractTimeDependentNode.ElapsedTime", "text": "  <p>For non-looping animations, note that the sensor automatically stops when the animation finishes, so <code>ElapsedTime</code> will not grow beyond the &quot;duration&quot;. If you want to observe when the animation ended, you probably do not want to use this property. Instead observe when <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html#IsActive\">IsActive</a> changed to <code>False</code>, by registering a callback on <code>EventIsActive.AddNotification</code>. See the examples/3d_rendering_processing/listen_on_x3d_events.lpr .  <p>BTW, the <i>&quot;duration&quot;</i> mentioned above is usually just <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html#GetCycleInterval\">GetCycleInterval</a>, but sometimes it's a <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html#GetCycleInterval\">GetCycleInterval</a> multiplied by some scaling factor, like in case of <a class=\"normal\" href=\"X3DNodes.TAudioClipNode.html\">TAudioClipNode</a> or <a class=\"normal\" href=\"X3DNodes.TMovieTextureNode.html\">TMovieTextureNode</a>).  <p>For a precise (and complicated:) specification of how this behaves, see the X3D TimeSensor.elapsedTime specification at <a  href=\"http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor\">http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor</a>    ", "tags": "", "loc": "X3DNodes.IAbstractTimeDependentNode.html#ElapsedTime"},
     {"title": "X3DNodes.IAbstractTimeDependentNode.ElapsedTimeInCycle", "text": "  <p>This is like ike <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html#ElapsedTime\">ElapsedTime</a>, but counting only the current cycle. When <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html#GetCycleInterval\">GetCycleInterval</a> = 0, this is always 0. When <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html#GetCycleInterval\">GetCycleInterval</a> &lt;&gt; 0, this is always &gt;= 0 and &lt; CycleInterval .    ", "tags": "", "loc": "X3DNodes.IAbstractTimeDependentNode.html#ElapsedTimeInCycle"},
     {"title": "X3DNodes.IAbstractTimeDependentNode.InternalTimeDependentHandler", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractTimeDependentNode.html#InternalTimeDependentHandler"},
     {"title": "X3DNodes.TInternalTimeDependentHandler", "text": " This includes things descending from interface <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html\">IAbstractTimeDependentNode</a>, in particular (but not only) descending from class <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html\">TAbstractTimeDependentNode</a>.  <p>It would be cleaner to have Node declared as <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html\">IAbstractTimeDependentNode</a>, and have <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html\">IAbstractTimeDependentNode</a> contain common fields. Then a lot of fields of this class would not be needed, as they would be accessible as <a class=\"normal\" href=\"X3DNodes.IAbstractTimeDependentNode.html\">IAbstractTimeDependentNode</a> fields. TODO: maybe in the future. ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.Node", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#Node"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.OnCycleInterval", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#OnCycleInterval"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.FdLoop", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#FdLoop"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.FdPauseTime", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#FdPauseTime"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.FdResumeTime", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#FdResumeTime"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.FdStartTime", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#FdStartTime"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.FdStopTime", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#FdStopTime"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#FdEnabled"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.EventElapsedTime", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#EventElapsedTime"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.EventIsActive", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#EventIsActive"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.EventIsPaused", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#EventIsPaused"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.EventCycleTime", "text": " ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#EventCycleTime"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.CycleInterval", "text": "    ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#CycleInterval"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.SetTime", "text": " This is the most important method of this class, that basically implements time-dependent nodes operations.  <p>NewTime and TimeIncrease are produced by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#SetTime\">TCastleSceneCore.SetTime</a> and friends.  <p>When ResetTime = true, this means that &quot;TimeIncrease value is unknown&quot; (you <i>must</i> pass TimeIncrease = 0 in this case). This can happen only when were called by ResetTime.  <p>In other circumstances, TimeIncrease must be &gt;= 0. (It's allowed to pass TimeIncrease = 0 and ResetTime = false, this doesn't advance the clock, but is a useful trick to force some update, see HandleChangeTimeStopStart in TCastleSceneCore.InternalChangedField implementation.)  <p>References: see X3D specification &quot;Time&quot; component, 8.2 (&quot;concepts&quot;) for logic behind all those start/stop/pause/resumeTime, <a class=\"normal\" href=\"X3DNodes.TInternalTimeDependentHandler.html#CycleInterval\">cycleInterval</a>, loop properties.  <p>   If some state of time-dependent node changed. ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#SetTime"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.IsActive", "text": " Changing this automatically causes appropriate events to be generated. ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#IsActive"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.IsPaused", "text": " Changing this automatically causes appropriate events to be generated. ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#IsPaused"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.ElapsedTime", "text": " Changing this automatically causes appropriate events to be generated. ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#ElapsedTime"},
     {"title": "X3DNodes.TInternalTimeDependentHandler.ElapsedTimeInCycle", "text": " When <a class=\"normal\" href=\"X3DNodes.TInternalTimeDependentHandler.html#CycleInterval\">cycleInterval</a> = 0, this is always 0. When <a class=\"normal\" href=\"X3DNodes.TInternalTimeDependentHandler.html#CycleInterval\">cycleInterval</a> &lt;&gt; 0, this is always &gt;= 0 and &lt; <a class=\"normal\" href=\"X3DNodes.TInternalTimeDependentHandler.html#CycleInterval\">cycleInterval</a> . ", "tags": "", "loc": "X3DNodes.TInternalTimeDependentHandler.html#ElapsedTimeInCycle"},
     {"title": "X3DNodes.TSFTimeIgnoreWhenActive", "text": " ", "tags": "", "loc": "X3DNodes.TSFTimeIgnoreWhenActive.html"},
     {"title": "X3DNodes.TSFTimeIgnoreWhenActive.NeverIgnore", "text": " ", "tags": "", "loc": "X3DNodes.TSFTimeIgnoreWhenActive.html#NeverIgnore"},
     {"title": "X3DNodes.TSFStopTime", "text": " ", "tags": "", "loc": "X3DNodes.TSFStopTime.html"},
     {"title": "X3DNodes.TSFStopTime.NeverIgnore", "text": " ", "tags": "", "loc": "X3DNodes.TSFStopTime.html#NeverIgnore"},
     {"title": "X3DNodes.TAbstractTimeDependentNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.GetInternalTimeDependentHandler", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#GetInternalTimeDependentHandler"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#Destroy"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.GetCycleInterval", "text": " For a looping animation, this is the time it takes to make a single cycle. Should always be &gt; 0.  <p>This is not called <i>&quot;duration&quot;</i>, as that word is reserved to mean <i>&quot;unscaled time length&quot;</i> for X3D AudioClip and MovieTexture nodes. The final length, returned here, is the AudioClip.duration divided by AudioClip.pitch, or MovieTexture.duration / MovieTexture.speed.  <p>On <a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html\">TTimeSensorNode</a> descendants, you can also get and set this by the class helper property <a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html#CycleInterval\">TTimeSensorNode.CycleInterval</a>. The name collision is harmless here, as both ways get the same value.    ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#GetCycleInterval"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.IsActive", "text": "  <p>For a precise (and complicated:) specification of how this behaves, see the X3D TimeSensor.isActive specification at <a  href=\"http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor\">http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor</a>    ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#IsActive"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.IsPaused", "text": "  <p>For a precise (and complicated:) specification of how this behaves, see the X3D TimeSensor.isPaused specification at <a  href=\"http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor\">http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor</a>    ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#IsPaused"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.ElapsedTime", "text": "  <p>For non-looping animations, note that the sensor automatically stops when the animation finishes, so <code>ElapsedTime</code> will not grow beyond the &quot;duration&quot;. If you want to observe when the animation ended, you probably do not want to use this property. Instead observe when <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#IsActive\">IsActive</a> changed to <code>False</code>, by registering a callback on <code>EventIsActive.AddNotification</code>. See the examples/3d_rendering_processing/listen_on_x3d_events.lpr .  <p>BTW, the <i>&quot;duration&quot;</i> mentioned above is usually just <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#GetCycleInterval\">GetCycleInterval</a>, but sometimes it's a <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#GetCycleInterval\">GetCycleInterval</a> multiplied by some scaling factor, like in case of <a class=\"normal\" href=\"X3DNodes.TAudioClipNode.html\">TAudioClipNode</a> or <a class=\"normal\" href=\"X3DNodes.TMovieTextureNode.html\">TMovieTextureNode</a>).  <p>For a precise (and complicated:) specification of how this behaves, see the X3D TimeSensor.elapsedTime specification at <a  href=\"http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor\">http://www.web3d.org/documents/specifications/19775-1/V3.3/Part01/components/time.html#TimeSensor</a>    ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#ElapsedTime"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.ElapsedTimeInCycle", "text": "  <p>This is like ike <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#ElapsedTime\">ElapsedTime</a>, but counting only the current cycle. When <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#GetCycleInterval\">GetCycleInterval</a> = 0, this is always 0. When <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#GetCycleInterval\">GetCycleInterval</a> &lt;&gt; 0, this is always &gt;= 0 and &lt; CycleInterval .    ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#ElapsedTimeInCycle"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.FdLoop", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#FdLoop"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.FdPauseTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#FdPauseTime"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.FdResumeTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#FdResumeTime"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.FdStartTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#FdStartTime"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.FdStopTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#FdStopTime"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.EventElapsedTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#EventElapsedTime"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.EventIsActive", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#EventIsActive"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.EventIsPaused", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#EventIsPaused"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.InternalTimeDependentHandler", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#InternalTimeDependentHandler"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.Loop", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#Loop"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.PauseTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#PauseTime"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.ResumeTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#ResumeTime"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.StartTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#StartTime"},
     {"title": "X3DNodes.TAbstractTimeDependentNode.StopTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTimeDependentNode.html#StopTime"},
     {"title": "X3DNodes.TTimeSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html"},
     {"title": "X3DNodes.TTimeSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TTimeSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTimeSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TTimeSensorNode.GetCycleInterval", "text": "    ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#GetCycleInterval"},
     {"title": "X3DNodes.TTimeSensorNode.FakeTime", "text": "  <p>This is useful in situations when you want the X3D scene state to reflect given time, but you do not want to activate sensor and generally you do not want to initialize anything that would continue animating on it's own.  <p>Using TimeSensor this way is contrary to the VRML/X3D specified behavior. But it's useful when we have VRML/X3D scene inside <a class=\"normal\" href=\"CastleResources.T3DResource.html\">T3DResource</a>, that is shared by many <a class=\"normal\" href=\"Castle3D.html#T3D\">T3D</a> instances (like creatures and items) that want to simultaneusly display different time moments of the same scene within a single frame. In other words, this is useful when a single scene is shared (if you have a 100 creatures in your game using the same 3D model, you don't want to create 100 copies of this 3D model in memory).  <p>We ignore TimeSensor.loop (<a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#FdLoop\">FdLoop</a>) field, instead we follow our own <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#Loop\">Loop</a> parameter. We take into account TimeSensor.cycleInterval (<a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html#FdCycleInterval\">FdCycleInterval</a>) and TimeSensor.enabled (<a class=\"normal\" href=\"X3DNodes.TTimeSensorNode.html#FdEnabled\">FdEnabled</a>) fields, just like normal TimeSensor. We send out <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#IsActive\">isActive</a>:=true, fraction_changed, <a class=\"normal\" href=\"X3DNodes.TAbstractTimeDependentNode.html#ElapsedTime\">elapsedTime</a> and time X3D output events, and they should drive the rest of animation.  <p>    ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#FakeTime"},
     {"title": "X3DNodes.TTimeSensorNode.FakeTime", "text": "    ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#FakeTime"},
     {"title": "X3DNodes.TTimeSensorNode.FdCycleInterval", "text": " ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#FdCycleInterval"},
     {"title": "X3DNodes.TTimeSensorNode.CycleInterval", "text": " ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#CycleInterval"},
     {"title": "X3DNodes.TTimeSensorNode.EventCycleTime", "text": " ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#EventCycleTime"},
     {"title": "X3DNodes.TTimeSensorNode.EventFraction_changed", "text": " ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#EventFraction_changed"},
     {"title": "X3DNodes.TTimeSensorNode.EventTime", "text": " ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#EventTime"},
     {"title": "X3DNodes.TTimeSensorNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#FdEnabled"},
     {"title": "X3DNodes.TTimeSensorNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TTimeSensorNode.html#Enabled"},
     {"title": "X3DNodes.TAbstractGroupingNode", "text": " Note that this descends from <a class=\"normal\" href=\"X3DNodes.TAbstractChildNode.html\">TAbstractChildNode</a>, so it can be inserted as child of another grouping node. So, you can create a hierarchy of nodes with any depth. ", "tags": "", "loc": "X3DNodes.TAbstractGroupingNode.html"},
     {"title": "X3DNodes.TAbstractGroupingNode.SeparateGroup", "text": " If <code>False</code>, this allows everything to &quot;leak out&quot; (transform changes, VRML 1.0 state changes etc.). Possibility useful for VRML 1.0 extension <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_wwwinline_separate\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_wwwinline_separate</a>    ", "tags": "", "loc": "X3DNodes.TAbstractGroupingNode.html#SeparateGroup"},
     {"title": "X3DNodes.TAbstractGroupingNode.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGroupingNode.html#BeforeTraverse"},
     {"title": "X3DNodes.TAbstractGroupingNode.AfterTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGroupingNode.html#AfterTraverse"},
     {"title": "X3DNodes.TAbstractGroupingNode.ApplyTransform", "text": "  <p>This should be done here, not in overriden <a class=\"normal\" href=\"X3DNodes.TAbstractGroupingNode.html#BeforeTraverse\">BeforeTraverse</a>. Reason: for storing ClipPlanes transformations, we need to know transformed matrix inside <a class=\"normal\" href=\"X3DNodes.TAbstractGroupingNode.html#BeforeTraverse\">TAbstractGroupingNode.BeforeTraverse</a> implementation. And we also do StateStack.Push inside <a class=\"normal\" href=\"X3DNodes.TAbstractGroupingNode.html#BeforeTraverse\">TAbstractGroupingNode.BeforeTraverse</a> implementation... So <code>ApplyTransform</code> must happen in the middle of <a class=\"normal\" href=\"X3DNodes.TAbstractGroupingNode.html#BeforeTraverse\">TAbstractGroupingNode.BeforeTraverse</a> call.    ", "tags": "", "loc": "X3DNodes.TAbstractGroupingNode.html#ApplyTransform"},
     {"title": "X3DNodes.IAbstractBoundedObject", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractBoundedObject.html"},
     {"title": "X3DNodes.IAbstractBoundedObject.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractBoundedObject.html#FdBboxCenter"},
     {"title": "X3DNodes.IAbstractBoundedObject.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractBoundedObject.html#FdBboxSize"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.AddChildren", "text": " Adding a node that already exists on the children list is ignored.  <p>Note: This method prevents adding duplicates to the children list. And the X3D specification doesn't allow duplicates on the children list. But our engine allows duplicates on the children list &mdash; you can specify them in the X3D file, or you can add them using <a class=\"normal\" href=\"X3DNodes.TAbstractX3DGroupingNode.html#FdChildren\">FdChildren</a>.Add.  <p>This propagates the changes appropriately to the parent <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, calling <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">TCastleSceneCore.ChangedAll</a> or something similar.    ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#AddChildren"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.AddChildren", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#AddChildren"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.RemoveChildren", "text": " Removing a node that does not exist on the children list is ignored.  <p>If a node exists on the current children list multiple times, then a single occurrence of this node is removed, for each occurrence of this node in the parameters list.  <p>This propagates the changes appropriately to the parent <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, calling <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">TCastleSceneCore.ChangedAll</a> or something similar.    ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#RemoveChildren"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.RemoveChildren", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#RemoveChildren"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.ClearChildren", "text": " This automatically propagates the changes appropriately to the parent <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>.    ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#ClearChildren"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.SetChildren", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#SetChildren"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.EventAddChildren", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#EventAddChildren"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.EventRemoveChildren", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#EventRemoveChildren"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.FdChildren", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#FdChildren"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#FdBboxSize"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.FdRender", "text": " We simply ignore it for now. ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#FdRender"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#BboxCenter"},
     {"title": "X3DNodes.TAbstractX3DGroupingNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DGroupingNode.html#BboxSize"},
     {"title": "X3DNodes.TGroupNode", "text": " It is equivalent to a <a class=\"normal\" href=\"X3DNodes.TTransformNode.html\">TTransformNode</a> containing an identity transform. ", "tags": "", "loc": "X3DNodes.TGroupNode.html"},
     {"title": "X3DNodes.TGroupNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TGroupNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TGroupNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGroupNode.html#CreateNode"},
     {"title": "X3DNodes.TGroupNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGroupNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGroupNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TGroupNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TGroupNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGroupNode.html#URNMatching"},
     {"title": "X3DNodes.TStringLongIntMap", "text": " ", "tags": "", "loc": "X3DNodes.TStringLongIntMap.html"},
     {"title": "X3DNodes.TStringLongIntMap.Assign", "text": "    ", "tags": "", "loc": "X3DNodes.TStringLongIntMap.html#Assign"},
     {"title": "X3DNodes.TStringLongIntMap.Items", "text": " Setting this is allowed regardless if the key previously existed or not, in other words: setting this does AddOrSetValue, contrary to the ancestor TDictionary that only allows setting when the key already exists. ", "tags": "", "loc": "X3DNodes.TStringLongIntMap.html#Items"},
     {"title": "X3DNodes.TX3DRootNode", "text": " This is what you get by loading 3D model from file.  <p>It is declared as a descendant of VRML/X3D &gt;= 2.0 Group node, but it's used with all VRML/X3D versions (including VRML 1.0 and Inventor). This makes things simple (previously we had two separate TX3DRootNode_1 and <code>TX3DRootNode</code>, which was complicating stuff). Children (for all VRML/X3D versions) are inside <a class=\"normal\" href=\"X3DNodes.TAbstractX3DGroupingNode.html#FdChildren\">FdChildren</a> field.  <p>This way VRML/X3D files may have many nodes at the top level (which is a standard feature of VRML/X3D &gt;= 2.0, but we also allow it for VRML 1.0 as a commonly used extension). It may also have prototypes, routes etc. at the root level.  <p>This also allows us to record in one place some information that is returned by the parser. Like parsed VRML/X3D version, X3D profile, some namespace information (exported names and such). ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html"},
     {"title": "X3DNodes.TX3DRootNode.ForceVersion", "text": " ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#ForceVersion"},
     {"title": "X3DNodes.TX3DRootNode.DeepCopyCore", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#DeepCopyCore"},
     {"title": "X3DNodes.TX3DRootNode.SeparateGroup", "text": " This means that all state changes &quot;leak out&quot; from a root node. This is a good thing: if root node isn't used as a final <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#RootNode\">TCastleSceneCore.RootNode</a>, then it is placed inside Inline node, which will do save/restore anyway. And this way VRML 1.0 WWWInline with separate=FALSE may also work too.    ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#SeparateGroup"},
     {"title": "X3DNodes.TX3DRootNode.ApplyTransform", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#ApplyTransform"},
     {"title": "X3DNodes.TX3DRootNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#CreateNode"},
     {"title": "X3DNodes.TX3DRootNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#Destroy"},
     {"title": "X3DNodes.TX3DRootNode.SaveToStream", "text": "  <p>If <a class=\"normal\" href=\"X3DNodes.TX3DRootNode.html#SaveAsRootNode\">SaveAsRootNode</a> then this is saved in a special way, such that only the contents are written, without surrounding braces (for classic encoding) or XML element (for xml encoding). This way, when saving, we hide the fact that everything was wrapped in an artificial <a class=\"normal\" href=\"X3DNodes.TX3DRootNode.html\">TX3DRootNode</a>.    ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#SaveToStream"},
     {"title": "X3DNodes.TX3DRootNode.ForceSaveAsX3D", "text": " If we're already configured to save as X3D (major version &gt;= 3) then do nothing. Otherwise, sets major/minor versions (by default: for X3D 3.2; make sure AMajor is &gt;= 3) and sets X3D profile (default: Interchange).    ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#ForceSaveAsX3D"},
     {"title": "X3DNodes.TX3DRootNode.ManuallyExportNode", "text": " Use if you build X3D graph by hand, and you want do add the EXPORT X3D clause (see X3D specification about EXPORT to know what it does), such that it's not only serializable, but also works (is recognized by models that Inline this one).  <p>    ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#ManuallyExportNode"},
     {"title": "X3DNodes.TX3DRootNode.ManuallyExportNode", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#ManuallyExportNode"},
     {"title": "X3DNodes.TX3DRootNode.SaveAsRootNode", "text": "  <p>If this node isn't a root node, you should set this to <code>False</code> (or saving this node may generate dumb contents). Although, generally, you should avoid using the <a class=\"normal\" href=\"X3DNodes.TX3DRootNode.html\">TX3DRootNode</a> class at all for non-root nodes. ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#SaveAsRootNode"},
     {"title": "X3DNodes.TX3DRootNode.HasForceVersion", "text": " ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#HasForceVersion"},
     {"title": "X3DNodes.TX3DRootNode.Profile", "text": " See X3D spec about profiles. Every X3D file must always define a profile. (However, we use this class also for VRML 1.0 and 2.0 root nodes, where profile is empty.) Relevant only if this node is the root of X3D file. ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#Profile"},
     {"title": "X3DNodes.TX3DRootNode.Components", "text": " Relevant if this node is the root of X3D file. ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#Components"},
     {"title": "X3DNodes.TX3DRootNode.Meta", "text": " Relevant if this node is the root of X3D file. ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#Meta"},
     {"title": "X3DNodes.TX3DRootNode.PrototypeNames", "text": " Useful for things like EXTERNPROTO implementation. ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#PrototypeNames"},
     {"title": "X3DNodes.TX3DRootNode.ExportedNames", "text": " Useful for importing them later, to handle IMPORT/EXPORT X3D mechanism. ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#ExportedNames"},
     {"title": "X3DNodes.TX3DRootNode.ImportedNames", "text": " You may want to take this into account when searching nodes by name, this allows the user to rename nodes from Inlined files. ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#ImportedNames"},
     {"title": "X3DNodes.TX3DRootNode.Scale", "text": " When loading, this is set to honor <code>&quot;UNIT length ...&quot;</code> declaration in X3D 3.3. It scales model such that 1 unit = 1 meter. When one model is inlined inside another (e.g. using X3D Inline node), this is adjusted to the existing scale of the outer model (always to make the resulting complete node graph keep the assumption 1 unit = 1 meter). ", "tags": "", "loc": "X3DNodes.TX3DRootNode.html#Scale"},
     {"title": "X3DNodes.TStaticGroupNode", "text": " StaticGroup children are guaranteed to not change, send events, receive events or contain any USE references outside the StaticGroup. This allows to optimize this content for faster rendering and less memory usage. ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html"},
     {"title": "X3DNodes.TStaticGroupNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TStaticGroupNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#CreateNode"},
     {"title": "X3DNodes.TStaticGroupNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#ClassX3DType"},
     {"title": "X3DNodes.TStaticGroupNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#URNMatching"},
     {"title": "X3DNodes.TStaticGroupNode.SetChildren", "text": "    ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#SetChildren"},
     {"title": "X3DNodes.TStaticGroupNode.FdChildren", "text": " ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#FdChildren"},
     {"title": "X3DNodes.TStaticGroupNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TStaticGroupNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#FdBboxSize"},
     {"title": "X3DNodes.TStaticGroupNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#BboxCenter"},
     {"title": "X3DNodes.TStaticGroupNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TStaticGroupNode.html#BboxSize"},
     {"title": "X3DNodes.TSwitchNode", "text": " This allows to choose between a number of nodes for processing (rendering, collision detection), and/or to hide some nodes.  <p>Compatibility node: this class is used for both VRML 97 and X3D. Although field name changed for X3D (in VRML 97, &quot;children&quot; was called &quot;choice&quot;), this is handled seamlessly using our TX3DFieldOrEvent.AddAlternativeField mechanism. In other words, programmer simply works with <a class=\"normal\" href=\"X3DNodes.TAbstractX3DGroupingNode.html#FdChildren\">FdChildren</a> field, and when reading/writing VRML file we take care to actually use either &quot;children&quot; or &quot;choice&quot; name, depending on used VRML version. ", "tags": "", "loc": "X3DNodes.TSwitchNode.html"},
     {"title": "X3DNodes.TSwitchNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TSwitchNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode.html#CreateNode"},
     {"title": "X3DNodes.TSwitchNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSwitchNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TSwitchNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode.html#URNMatching"},
     {"title": "X3DNodes.TSwitchNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode.html#TransformationChange"},
     {"title": "X3DNodes.TSwitchNode.FdWhichChoice", "text": " ", "tags": "", "loc": "X3DNodes.TSwitchNode.html#FdWhichChoice"},
     {"title": "X3DNodes.TSwitchNode.WhichChoice", "text": " ", "tags": "", "loc": "X3DNodes.TSwitchNode.html#WhichChoice"},
     {"title": "X3DNodes.ITransformNode", "text": " These nodes transform all their children (the ones enumerated by traversing, so all active children).  <p>The transformation change may be signalled by TX3DField.Changes including <a class=\"normal\" href=\"X3DFields.html#chTransform\">chTransform</a> flag. For some special nodes, like Billboard, the transformation changes are automatically managed. ", "tags": "", "loc": "X3DNodes.ITransformNode.html"},
     {"title": "X3DNodes.TTransformNode", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode.html"},
     {"title": "X3DNodes.TTransformNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TTransformNode.ApplyTransform", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode.html#ApplyTransform"},
     {"title": "X3DNodes.TTransformNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode.html#CreateNode"},
     {"title": "X3DNodes.TTransformNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTransformNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode.html#URNMatching"},
     {"title": "X3DNodes.TTransformNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TTransformNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode.html#TransformationChange"},
     {"title": "X3DNodes.TTransformNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode.html#FdCenter"},
     {"title": "X3DNodes.TTransformNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode.html#FdRotation"},
     {"title": "X3DNodes.TTransformNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode.html#FdScale"},
     {"title": "X3DNodes.TTransformNode.FdScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode.html#FdScaleOrientation"},
     {"title": "X3DNodes.TTransformNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode.html#FdTranslation"},
     {"title": "X3DNodes.TTransformNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode.html#Center"},
     {"title": "X3DNodes.TTransformNode.Rotation", "text": " Rotation is done around <a class=\"normal\" href=\"X3DNodes.TTransformNode.html#Center\">Center</a>. ", "tags": "", "loc": "X3DNodes.TTransformNode.html#Rotation"},
     {"title": "X3DNodes.TTransformNode.Scale", "text": " Scaling is done around <a class=\"normal\" href=\"X3DNodes.TTransformNode.html#Center\">Center</a> and with orientation given by <a class=\"normal\" href=\"X3DNodes.TTransformNode.html#ScaleOrientation\">ScaleOrientation</a>.  <p>We do the best we can to work with <i>any</i> scale value, even negative or zero. But usually, it's best to keep the scale positive. See the <a class=\"normal\" href=\"CastleTransform.TCastleTransform.html#Scale\">TCastleTransform.Scale</a> documentation for some good guidelines about the scale. ", "tags": "", "loc": "X3DNodes.TTransformNode.html#Scale"},
     {"title": "X3DNodes.TTransformNode.ScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode.html#ScaleOrientation"},
     {"title": "X3DNodes.TTransformNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode.html#Translation"},
     {"title": "X3DNodes.TAbstractNetworkSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNetworkSensorNode.html"},
     {"title": "X3DNodes.TAbstractNetworkSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNetworkSensorNode.html#CreateNode"},
     {"title": "X3DNodes.IAbstractUrlObject", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractUrlObject.html"},
     {"title": "X3DNodes.IAbstractUrlObject.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractUrlObject.html#FdUrl"},
     {"title": "X3DNodes.TAnchorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAnchorNode.html"},
     {"title": "X3DNodes.TAnchorNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TAnchorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#CreateNode"},
     {"title": "X3DNodes.TAnchorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TAnchorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#URNMatching"},
     {"title": "X3DNodes.TAnchorNode.LoadAnchor", "text": "  <p>This iterates over url field, for each URL trying to load referenced file. If URL specifies viewpoint name within 3D file (or current 3D world), we also search for viewpoint. If it will succeed for some URL, returns <code>True</code>, setting output parameters. Returns <code>False</code> if no loadable URL is found.  <p>Output NewRootNode is the loaded world, or <code>Nil</code> if actually we should stay within the same world. <code>Nil</code> happens for URLs like <code>#ViewpointName</code>, or when URL refers to some non-3D document (that is opened with appropriate application on user system).  <p>NewViewpoint is the new viewpoint that should be bound, or <code>Nil</code> if URL doesn't specify viewpoint name within 3D file. This viewpoint is part of NewRootNode graph, if NewRootNode &lt;&gt; <code>Nil</code>, or is part of CurrentRootNode if we should stay within current world (NewRootNode = <code>Nil</code>).  <p>Note that this means that NewRootNode = nil and NewViewpoint = nil are valid output from this method, and indicate that nothing should be done.  <p>CurrentRootNode is required to detect invalid viewpoint names within current file. An explanation why this is needed follows:  <p>Invalid viewpoint names within newly loaded files are harmless, that is newly loaded file is accepted anyway and invalid viewpoint name is ignored. X3D spec says this explicitly.  <p>But what should happen for invalid viewpoint names within current file? X3D spec doesn't say anything clear here (the part before &quot;#&quot; is valid in this case, since it just indicates current file, so someone could argue that URL is valid, only viewpoint name is wrong and so it should be ignored...). Consider url field like  <p></p>  <pre class=\"preformatted\"> [ &quot;#NotExistingViewpoint&quot;, &quot;#ExistingViewpoint&quot; ]</pre>  <p>  <p>It seems sensible that we detect &quot;#NotExistingViewpoint&quot; as invalid, and move on to the next URL (which may be local or not). That's why we need CurrentRootNode instance. When CurrentRootNode = nil, we understand that no file is currently loaded (at least, you don't have it's X3D graph). It means that any &quot;#Viewpoint&quot; within current model is considered invalid.    ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#LoadAnchor"},
     {"title": "X3DNodes.TAnchorNode.SetParameter", "text": "    ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#SetParameter"},
     {"title": "X3DNodes.TAnchorNode.SetParameter", "text": "    ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#SetParameter"},
     {"title": "X3DNodes.TAnchorNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#SetUrl"},
     {"title": "X3DNodes.TAnchorNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#SetUrl"},
     {"title": "X3DNodes.TAnchorNode.FdDescription", "text": " ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#FdDescription"},
     {"title": "X3DNodes.TAnchorNode.FdParameter", "text": " ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#FdParameter"},
     {"title": "X3DNodes.TAnchorNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#FdUrl"},
     {"title": "X3DNodes.TAnchorNode.Description", "text": " ", "tags": "", "loc": "X3DNodes.TAnchorNode.html#Description"},
     {"title": "X3DNodes.TInlineNode", "text": " ", "tags": "", "loc": "X3DNodes.TInlineNode.html"},
     {"title": "X3DNodes.TInlineNode.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#BeforeTraverse"},
     {"title": "X3DNodes.TInlineNode.AfterTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#AfterTraverse"},
     {"title": "X3DNodes.TInlineNode.AfterLoadInlined", "text": " It's called only after actual loading occurred, e.g. it's not called when <a class=\"normal\" href=\"X3DNodes.TInlineNode.html#LoadInlined\">LoadInlined</a> was called on the already-loaded node with CanReload = <code>False</code>.    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#AfterLoadInlined"},
     {"title": "X3DNodes.TInlineNode.ParseAfter", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#ParseAfter"},
     {"title": "X3DNodes.TInlineNode.DeepCopyCore", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#DeepCopyCore"},
     {"title": "X3DNodes.TInlineNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#CreateNode"},
     {"title": "X3DNodes.TInlineNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#ClassX3DType"},
     {"title": "X3DNodes.TInlineNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#URNMatching"},
     {"title": "X3DNodes.TInlineNode.VRML1ChildrenSaveToStream", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#VRML1ChildrenSaveToStream"},
     {"title": "X3DNodes.TInlineNode.LoadInlined", "text": " If <a class=\"normal\" href=\"X3DNodes.TInlineNode.html#Inlined\">Inlined</a> is already loaded: if CanReload = <code>True</code> then it will be freed and loaded again, else (if CanReload = <code>False</code>) nothing will happen.  <p>Note that this has a really simple support for &quot;load&quot; field (this concerns VRML 97 amendment 1 &quot;InlineLoadControl.load&quot; and X3D (actually used also in VRML 97 handling) &quot;Inline.load&quot; fields). It simply doesn't do any loading when &quot;load&quot; = <code>False</code>.  <p>Note that this doesn't perform setting the &quot;load&quot; field, or sending any notifications to Scene about &quot;load&quot; field. It's the caller's job to keep loaded state synchronized with &quot;load&quot; field value.  <p><code>LoadInlined</code>(false) will be called automatically, to ensure the inlined contents are always loaded. It will be called at the end of Parse (this is needed to handle VRML/X3D IMPORT/EXPORT mechanism), it will also be called in <a class=\"normal\" href=\"X3DNodes.TInlineNode.html#BeforeTraverse\">BeforeTraverse</a> (in case you constructed node by code, not by parsing; this also happens when node was made by expanding a PROTO).  <p>  Exported If non-nil, we will assign here node names exported from the file. Used to handle IMPORT/EXPORT X3D mechanism.  Exported If non-nil, we will assign here node names exported from the file. Used to handle IMPORT/EXPORT X3D mechanism.", "tags": "", "loc": "X3DNodes.TInlineNode.html#LoadInlined"},
     {"title": "X3DNodes.TInlineNode.UnLoadInlined", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#UnLoadInlined"},
     {"title": "X3DNodes.TInlineNode.LoadedInlineDirectly", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#LoadedInlineDirectly"},
     {"title": "X3DNodes.TInlineNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#SetUrl"},
     {"title": "X3DNodes.TInlineNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineNode.html#SetUrl"},
     {"title": "X3DNodes.TInlineNode.FdLoad", "text": " ", "tags": "", "loc": "X3DNodes.TInlineNode.html#FdLoad"},
     {"title": "X3DNodes.TInlineNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TInlineNode.html#FdUrl"},
     {"title": "X3DNodes.TInlineNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TInlineNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TInlineNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TInlineNode.html#FdBboxSize"},
     {"title": "X3DNodes.TInlineNode.Inlined", "text": " <code>Nil</code> if not yet loaded, or no loading was successful.  <p>This is also kept in VRML 1.0 children list as <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#VRML1Children\">VRML1Children</a>[0], but for future it's better to not depend on that. But it will always be enumerated by things like <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#EnumerateNodes\">TX3DNode.EnumerateNodes</a>. ", "tags": "", "loc": "X3DNodes.TInlineNode.html#Inlined"},
     {"title": "X3DNodes.TInlineNode.Load", "text": " ", "tags": "", "loc": "X3DNodes.TInlineNode.html#Load"},
     {"title": "X3DNodes.TInlineNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TInlineNode.html#BboxCenter"},
     {"title": "X3DNodes.TInlineNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TInlineNode.html#BboxSize"},
     {"title": "X3DNodes.TInlineLoadControlNode", "text": "  <p>Note that our <a class=\"normal\" href=\"X3DNodes.TInlineNode.html\">TInlineNode</a> conforms to the newer X3D standard, and so it already has a <a class=\"normal\" href=\"X3DNodes.TInlineNode.html#Load\">TInlineNode.Load</a> property. This node is implemented only for compatibility with VRML 97. It has additional &quot;children&quot; output field. ", "tags": "", "loc": "X3DNodes.TInlineLoadControlNode.html"},
     {"title": "X3DNodes.TInlineLoadControlNode.AfterLoadInlined", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineLoadControlNode.html#AfterLoadInlined"},
     {"title": "X3DNodes.TInlineLoadControlNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineLoadControlNode.html#CreateNode"},
     {"title": "X3DNodes.TInlineLoadControlNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineLoadControlNode.html#ClassX3DType"},
     {"title": "X3DNodes.TInlineLoadControlNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TInlineLoadControlNode.html#URNMatching"},
     {"title": "X3DNodes.TInlineLoadControlNode.EventChildren", "text": " ", "tags": "", "loc": "X3DNodes.TInlineLoadControlNode.html#EventChildren"},
     {"title": "X3DNodes.TLoadSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html"},
     {"title": "X3DNodes.TLoadSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TLoadSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLoadSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TLoadSensorNode.FdTimeOut", "text": " ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html#FdTimeOut"},
     {"title": "X3DNodes.TLoadSensorNode.FdWatchList", "text": " ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html#FdWatchList"},
     {"title": "X3DNodes.TLoadSensorNode.EventIsLoaded", "text": " ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html#EventIsLoaded"},
     {"title": "X3DNodes.TLoadSensorNode.EventLoadTime", "text": " ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html#EventLoadTime"},
     {"title": "X3DNodes.TLoadSensorNode.EventProgress", "text": " ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html#EventProgress"},
     {"title": "X3DNodes.TLoadSensorNode.TimeOut", "text": " ", "tags": "", "loc": "X3DNodes.TLoadSensorNode.html#TimeOut"},
     {"title": "X3DNodes.ENotCoordinateBasedNode", "text": " ", "tags": "", "loc": "X3DNodes.ENotCoordinateBasedNode.html"},
     {"title": "X3DNodes.TAbstractGeometryNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html"},
     {"title": "X3DNodes.TAbstractGeometryNode.InternalCoordRangesCounts", "text": "  <p>When CoordIndex = <code>Nil</code>, then if the node's <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoord\">InternalCoord</a> array can be divided into some &quot;ranges&quot;, we will use this information. This is used (and should be overridden) for X3D non-indexed nodes, like fanCount or stripCount or vertexCount.  <p>What precisely is a &quot;range of coordinates&quot; is not specified here. It may be a line stip, or one triangle strip, etc. &mdash; depending on the descendant.  <p>Returns <code>True</code> if this is available. In this case, RangeCount must be set to something &lt;&gt; nil, and the rest of returned variables are mainly to generate proper warnings by MakeCoordRanges.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#InternalCoordRangesCounts"},
     {"title": "X3DNodes.TAbstractGeometryNode.CreateNode", "text": " Only sets <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#DefaultContainerField\">DefaultContainerField</a> to 'geometry', since this is valid for all X3D nodes descending from <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a>.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractGeometryNode.BoundingBox", "text": " They require State of this node during VRML traverse state &mdash; this is mainly for VRML 1.0 nodes, that depend on such state.  <p><a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#LocalBoundingBox\">LocalBoundingBox</a> gives a bounding box ignoring current transformation (or, equivalently, assuming like Transform = IdentityMatrix). Normal <code>BoundingBox</code> gives a bounding box taking current transformation into account.  <p><i>Notes for descendants implementors:</i>  <p>The default implementations of these methods in <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> try to be smart and cover all common bases, so that you have to do as little work as possible to implement working descendant.  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p> For nodes based on coordinates (when <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoord\">InternalCoord</a> returns <code>True</code>), <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#LocalBoundingBox\">LocalBoundingBox</a> and <code>BoundingBox</code> already have optimal and correct implementation in this class. Using Coord and CoordIndex, no other information is needed.</p></li>   <li value=\"2\"><p> For other nodes, we first check ProxyGeometry and ProxyState. If ProxyGeometry is non-nil, we assume these came from <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#Proxy\">Proxy</a> call and we will use them to calculate bounding boxes, local and not local.  <p>So for nodes with <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#Proxy\">Proxy</a> overridden, you don't have to implement bounding box calculation, instead a ProxyGeometry will be created and provided here by the caller. This will work Ok if <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#Proxy\">Proxy</a> node will have bounding box calculation implemented.  <p>You can always override these methods, if you don't want to use proxy (for example, maybe there exists much faster method to calculate bounding box, or maybe tighter bounding box may be calculated directly).</p></li>   <li value=\"3\"><p> For other nodes (not coordinate-based and without a proxy):  <p>The default implementation of <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#LocalBoundingBox\">LocalBoundingBox</a> just calls <code>BoundingBox</code> with a specially modified State, such that Transform is identity.  <p>The default implementation of <code>BoundingBox</code>, in turn, just calls <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#LocalBoundingBox\">LocalBoundingBox</a> and transforms this bounding box.  <p>So the default implementations call each other, and will loop infinitely... But if you override any one of them (local or not local), the other one will magically work.  <p>Note that the default implementation of <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#LocalBoundingBox\">LocalBoundingBox</a> may be non-optimal as far as time is concerned, as we'll do useless multiplications by identity matrix. And the default implementation of <code>BoundingBox</code> may generate non-optimal bounding box, more direct approach (transforming each vertex) may give much tightier bounding box.  <p>So you only have to override one method &mdash; although if you want the best implementation, fastest and with the best tight bounding boxes, you may need to override both of them for some nodes.</p></li> </ol>  <p>  <p>    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#BoundingBox"},
     {"title": "X3DNodes.TAbstractGeometryNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TAbstractGeometryNode.VerticesCount", "text": "  <p>They require State of this node during VRML traverse state &mdash; this is mainly for VRML 1.0 nodes, that depend on such state. OverTriangulate has the same meaning as for <a class=\"normal\" href=\"CastleShapes.TShape.html#Triangulate\">TShape.Triangulate</a>.  <p>Vertices count calculates number of different vertexes in this node. That is, it doesn't eliminate doubles in cases like Coordinate node with multiple points the same. But if some face is known to use twice the same vertex index, then this counts like a single vertex. The idea is that this indicates rendering speed.  <p>For triangles count, the returned value may be different then actual if some faces were non-convex. Things like <a class=\"normal\" href=\"CastleTriangulate.html#TriangulateFace\">TriangulateFace</a> may remove degenerate triangles, so actual number of triangles may be slightly less. So don't depend on <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#TrianglesCount\">TrianglesCount</a> as a precise measure &mdash; but it's a good fast measure of complexity of given node, how fast it will be rendered, used with collision detection etc.  <p><i>Notes for descendants implementors:</i>  <p>For coordinate-based nodes (when <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoord\">InternalCoord</a> returns <code>True</code>), <code>VerticesCount</code> is already implemented in this class. Using Coord method, no other information is needed.  <p>For other nodes, the default implementation of both <code>VerticesCount</code> and <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#TrianglesCount\">TrianglesCount</a> in this <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> class will use ProxyGeometry and ProxyState to do the work. You should override these methods if <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#Proxy\">Proxy</a> is not available (so caller will always pass ProxyGeometry = <code>Nil</code>) or some faster approach is possible.  <p>    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#VerticesCount"},
     {"title": "X3DNodes.TAbstractGeometryNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#TrianglesCount"},
     {"title": "X3DNodes.TAbstractGeometryNode.InternalCoord", "text": " Returns <code>False</code> if node is not based on coordinates. Returns <code>True</code> and sets ACoord if the node is based on coordinates. Even when returns <code>True</code>, it can set ACoord = <code>Nil</code>, which means that node is based on coordinates but they are empty right now (so for example bounding box may be considered empty).  <p>In base <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> class this always returns <code>False</code>.  <p>Override this for descendants that have some kind of &quot;coord&quot; field, then this should return <code>True</code> and set ACoord to coord.point field, assuming that coord is set and specifies Coordinate node. Override this even if coordinates affect the look indirectly, e.g. NURBS &quot;controlPoint&quot; fields also should be returned here. Otherwise should return <code>True</code> and set ACoord = <code>Nil</code>.  <p>For VRML 1.0, coord may be taken from State, that's why we have to pass current traverse state here.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#InternalCoord"},
     {"title": "X3DNodes.TAbstractGeometryNode.InternalCoordinates", "text": "  <p>This is just like the <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoord\">InternalCoord</a> method, except it simply returns the coordinates, not the boolean result. If virtual <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoord\">InternalCoord</a> returns <code>False</code> (indicating the node is not coordinate-based) this raises <a class=\"normal\" href=\"X3DNodes.ENotCoordinateBasedNode.html\">ENotCoordinateBasedNode</a>.  <p>    ENotCoordinateBasedNode If node is not coordinate-based, that is <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoord\">InternalCoord</a> returns false.", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#InternalCoordinates"},
     {"title": "X3DNodes.TAbstractGeometryNode.CoordIndexField", "text": "  <p>In base <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> class this always returns <code>Nil</code>.  <p>Override this for descendants that have some kind of &quot;coordIndex&quot; or &quot;index&quot; field used to index <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoord\">InternalCoord</a> array.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#CoordIndexField"},
     {"title": "X3DNodes.TAbstractGeometryNode.InternalMakeCoordRanges", "text": "  <p>If CoordIndex is assigned, then a &quot;range of coordinates&quot; is just a range of non-negative indexes within CoordIndex. Otherwise (when CoordIndex = <code>Nil</code>), <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoordRangesCounts\">InternalCoordRangesCounts</a> must return <code>True</code> and we will use RangeCount to split coordinates.  <p>Call this only for nodes with coordinates, that is only when <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoord\">InternalCoord</a> returns <code>True</code>.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#InternalMakeCoordRanges"},
     {"title": "X3DNodes.TAbstractGeometryNode.InternalCoordPolygons", "text": "  <p>Indexes in PolygonHandler point to CoordIndex, if assigned, or directly to Coord. The ordering of generated polygons is correct, so what pointed CCW in the node field, will still point CCW according to generated PolygonHandler indexes.  <p>In this class this does nothing. Some, but not all, coordinate-based nodes (the ones when <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalCoord\">InternalCoord</a> returns <code>True</code>) override this. So currently, whether this is implemented is coordinated with CastleInternalNormals and such internal needs.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TAbstractGeometryNode.InternalTexCoord", "text": " Returns <code>False</code> if node cannot have texture coordinates.  <p>Returns <code>True</code> and sets ATexCoord to a node defining texture coords. ATexCoord may be set to <a class=\"normal\" href=\"X3DNodes.TAbstractTextureCoordinateNode.html\">TAbstractTextureCoordinateNode</a> descendant or to <a class=\"normal\" href=\"X3DNodes.TTextureCoordinate2Node_1.html\">TTextureCoordinate2Node_1</a> (latter one only for VRML &lt;= 1.0). ATexCoord can also be set to <code>Nil</code> in this case, which means that this node has a field for texCoord, but it's empty right now.  <p>In base <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> class this looks at <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#TexCoordField\">TexCoordField</a>, eventually returns <code>False</code>.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#InternalTexCoord"},
     {"title": "X3DNodes.TAbstractGeometryNode.TexCoordField", "text": " Various nodes may have different exact rules about what is allowed here, but everything allows TextureCoordinateGenerator and ProjectedTextureCoordinate instances.  <p>This gives you more possibilities than the <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html#InternalTexCoord\">InternalTexCoord</a> method (as you can assign texCoord using this), however it may be not available in all cases &mdash; for example VRML 1.0 nodes do not have texCoord field, but they may have a texture coordinate node (from the state).    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#TexCoordField"},
     {"title": "X3DNodes.TAbstractGeometryNode.Proxy", "text": "  <p>Typically, converts some complex geometry node (like Extrusion or Teapot) into more common node like IndexedFaceSet or IndexedTriangleSet. <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> class wraps this method into a more comfortable interface, that is <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a> methods simply automatically convert geometry nodes to their proxy versions if needed.  <p>In the base <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> class, returns <code>Nil</code> indicating that no conversion is known.  <p>The resulting node's Name (if the result is not <code>Nil</code>) must be equal to our Name.  <p>Some Proxy implementations (especially for VRML 1.0) will have to create new State (<a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a>) instance along with a new geometry node. You should do this by copying the State into a new <a class=\"normal\" href=\"X3DNodes.TX3DGraphTraverseState.html\">TX3DGraphTraverseState</a> instance, and modyfying the State reference. Simply speaking, do  <p></p>  <pre class=\"longcode\">@(longcode<span class=\"pascal_string\">#</span>         State := TX3DGraphTraverseState.CreateCopy(State);)</pre>  <p> #)  <p>You should <i>not</i> just modify the fields of the provided State instance. (Reasoning: some proxy methods rely on getting the original State, e.g. with original MaterialBinding, not the transformed state, to work correctly. And some proxy methods need to modify the state differently, depending on OverTriangulate value.)  <p>You can modify State variable only when returning non-nil geometry.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#Proxy"},
     {"title": "X3DNodes.TAbstractGeometryNode.ProxyUsesOverTriangulate", "text": " Default implementation in <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> returns safer <code>True</code>. Descendants may override and return <code>False</code>, to allow e.g. more caching in <a class=\"normal\" href=\"CastleShapes.TShape.html\">TShape</a>.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TAbstractGeometryNode.InternalColor", "text": " Otherwise returns <code>Nil</code>.  <p>Note that only one of Color and ColorRGBA may return non-nil, since &quot;color&quot; field may contain only one of them.  <p>    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#InternalColor"},
     {"title": "X3DNodes.TAbstractGeometryNode.InternalColorRGBA", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#InternalColorRGBA"},
     {"title": "X3DNodes.TAbstractGeometryNode.InternalFogCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#InternalFogCoord"},
     {"title": "X3DNodes.TAbstractGeometryNode.AttribField", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#AttribField"},
     {"title": "X3DNodes.TAbstractGeometryNode.ColorField", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#ColorField"},
     {"title": "X3DNodes.TAbstractGeometryNode.SolidField", "text": " <code>Nil</code> if given geometry node doesn't have a field to control it.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#SolidField"},
     {"title": "X3DNodes.TAbstractGeometryNode.ConvexField", "text": " <code>Nil</code> if given geometry node doesn't have a field to control it.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#ConvexField"},
     {"title": "X3DNodes.TAbstractGeometryNode.AutoGenerate3DTexCoords", "text": "  <p>The generated coordinates will follow the X3D specification at &quot;Texturing3D&quot; component: &quot;Texture coordinate generation for primitive objects&quot;. The 3D texture space will be mapped nicely to the shape bounding box.  <p>Implementation in this class (<a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a>) returns always <code>False</code>. Override it for primitives that have no texture coordinates to return <code>True</code>.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TAbstractGeometryNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#TransformationChange"},
     {"title": "X3DNodes.TAbstractGeometryNode.GetTextureBounds2DST", "text": " This mapping is like the default IndexedFaceSet texture mapping, following X3D spec. We also use it for other geometry nodes, and even allow explicitly requesting it by TextureCoordinateGenerator.mode = &quot;BOUNDS2D&quot;.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#GetTextureBounds2DST"},
     {"title": "X3DNodes.TAbstractGeometryNode.Lit", "text": " Default implementation in <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> says <code>True</code>.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#Lit"},
     {"title": "X3DNodes.TAbstractGeometryNode.FontTextureNode", "text": " This is useful for rendering Text nodes, that want to cooperate with normal texturing and shading, and additionally they want to use extra texture determined by font (not by Appearance node).    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#FontTextureNode"},
     {"title": "X3DNodes.TAbstractGeometryNode.CreateWithShape", "text": " This way you get a ready shape that can be used inside the X3D scene graph to show this geometry.  <p>You usually want to add the resulting Shape node to some scene, e.g. like this:  <p></p>  <pre class=\"longcode\"> Box := TBoxNode.CreateWithShape(Shape);  Root := TX3DRootNode.Create; Root.AddChildren(Shape);  Scene := TCastleScene.Create(<span class=\"pascal_keyword\">nil</span>); Scene.Load(Root, true);</pre>  <p>  <p>Remember that once the node is a children of another node, then this node will be automatically freed. So you should not free the resulting geometry node. Instead, free the resulting Shape node, or add it to some scene, as shown above.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#CreateWithShape"},
     {"title": "X3DNodes.TAbstractGeometryNode.CreateShape", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#CreateShape"},
     {"title": "X3DNodes.TAbstractGeometryNode.CreateWithTransform", "text": " This way you get a ready transformation that can be used inside the X3D scene graph to show and transform this geometry.  <p>You usually want to add the resulting Transform node to some scene, e.g. like this:  <p></p>  <pre class=\"longcode\"> Box := TBoxNode.CreateWithTransform(Shape, Transform);  Root := TX3DRootNode.Create; Root.AddChildren(Transform);  Scene := TCastleScene.Create(<span class=\"pascal_keyword\">nil</span>); Scene.Load(Root, true);</pre>  <p>  <p>Remember that once the node is a children of another node, then this node will be automatically freed. So you should not free the resulting geometry node or Shape node. Instead, free the resulting Transform node, or add it to some scene, as shown above.    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#CreateWithTransform"},
     {"title": "X3DNodes.TAbstractGeometryNode.CreateTransform", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#CreateTransform"},
     {"title": "X3DNodes.TAbstractGeometryNode.Convex", "text": " This knowledge is used when calculating normal vectors by CastleInternalNormals. ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#Convex"},
     {"title": "X3DNodes.TAbstractGeometryNode.Solid", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode.html#Solid"},
     {"title": "X3DNodes.TAbstractGeometricPropertyNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractGeometricPropertyNode.html"},
     {"title": "X3DNodes.TAbstractColorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractColorNode.html"},
     {"title": "X3DNodes.TAbstractColorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractColorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.InternalCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#InternalCoord"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.TexCoordField", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#TexCoordField"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.ColorField", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#ColorField"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#SolidField"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.AttribField", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#AttribField"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.InternalFogCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#InternalFogCoord"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.InternalNormal", "text": " The vectors are taken from the Normal node inside our <a class=\"normal\" href=\"X3DNodes.TAbstractComposedGeometryNode.html#FdNormal\">FdNormal</a> field. In case of problems (no Normal node specified, invalid node specified etc.) returns <code>Nil</code>.    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#InternalNormal"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.SetAttrib", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#SetAttrib"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.SetRadianceTransfer", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#SetRadianceTransfer"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.SetRadianceTransfer", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#SetRadianceTransfer"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdAttrib", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdAttrib"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdColor"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdCoord", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdCoord"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdFogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdFogCoord"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdNormal", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdNormal"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdTexCoord"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdCcw", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdCcw"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdColorPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdColorPerVertex"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdNormalPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdNormalPerVertex"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdSolid"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FdRadianceTransfer", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FdRadianceTransfer"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#Color"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.Coord", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#Coord"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.FogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#FogCoord"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.Normal", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#Normal"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.TexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#TexCoord"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.Ccw", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#Ccw"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.ColorPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#ColorPerVertex"},
     {"title": "X3DNodes.TAbstractComposedGeometryNode.NormalPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractComposedGeometryNode.html#NormalPerVertex"},
     {"title": "X3DNodes.TAbstractCoordinateNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractCoordinateNode.html"},
     {"title": "X3DNodes.TAbstractCoordinateNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractCoordinateNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractCoordinateNode.CoordCount", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractCoordinateNode.html#CoordCount"},
     {"title": "X3DNodes.TAbstractNormalNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNormalNode.html"},
     {"title": "X3DNodes.TClipPlaneNode", "text": " ", "tags": "", "loc": "X3DNodes.TClipPlaneNode.html"},
     {"title": "X3DNodes.TClipPlaneNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TClipPlaneNode.html#CreateNode"},
     {"title": "X3DNodes.TClipPlaneNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TClipPlaneNode.html#ClassX3DType"},
     {"title": "X3DNodes.TClipPlaneNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TClipPlaneNode.html#URNMatching"},
     {"title": "X3DNodes.TClipPlaneNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TClipPlaneNode.html#FdEnabled"},
     {"title": "X3DNodes.TClipPlaneNode.FdPlane", "text": " ", "tags": "", "loc": "X3DNodes.TClipPlaneNode.html#FdPlane"},
     {"title": "X3DNodes.TClipPlaneNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TClipPlaneNode.html#Enabled"},
     {"title": "X3DNodes.TClipPlaneNode.Plane", "text": " ", "tags": "", "loc": "X3DNodes.TClipPlaneNode.html#Plane"},
     {"title": "X3DNodes.TColorNode", "text": " ", "tags": "", "loc": "X3DNodes.TColorNode.html"},
     {"title": "X3DNodes.TColorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TColorNode.html#CreateNode"},
     {"title": "X3DNodes.TColorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TColorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TColorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TColorNode.html#URNMatching"},
     {"title": "X3DNodes.TColorNode.SetColor", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TColorNode.html#SetColor"},
     {"title": "X3DNodes.TColorNode.SetColor", "text": "    ", "tags": "", "loc": "X3DNodes.TColorNode.html#SetColor"},
     {"title": "X3DNodes.TColorNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TColorNode.html#FdColor"},
     {"title": "X3DNodes.TColorRGBANode", "text": " ", "tags": "", "loc": "X3DNodes.TColorRGBANode.html"},
     {"title": "X3DNodes.TColorRGBANode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TColorRGBANode.html#CreateNode"},
     {"title": "X3DNodes.TColorRGBANode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TColorRGBANode.html#ClassX3DType"},
     {"title": "X3DNodes.TColorRGBANode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TColorRGBANode.html#URNMatching"},
     {"title": "X3DNodes.TColorRGBANode.SetColor", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TColorRGBANode.html#SetColor"},
     {"title": "X3DNodes.TColorRGBANode.SetColor", "text": "    ", "tags": "", "loc": "X3DNodes.TColorRGBANode.html#SetColor"},
     {"title": "X3DNodes.TColorRGBANode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TColorRGBANode.html#FdColor"},
     {"title": "X3DNodes.TCoordinateNode", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateNode.html"},
     {"title": "X3DNodes.TCoordinateNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateNode.html#CreateNode"},
     {"title": "X3DNodes.TCoordinateNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCoordinateNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateNode.html#URNMatching"},
     {"title": "X3DNodes.TCoordinateNode.CoordCount", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateNode.html#CoordCount"},
     {"title": "X3DNodes.TCoordinateNode.SetPoint", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TCoordinateNode.html#SetPoint"},
     {"title": "X3DNodes.TCoordinateNode.SetPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateNode.html#SetPoint"},
     {"title": "X3DNodes.TCoordinateNode.FdPoint", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateNode.html#FdPoint"},
     {"title": "X3DNodes.TIndexedLineSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html"},
     {"title": "X3DNodes.TIndexedLineSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#CreateNode"},
     {"title": "X3DNodes.TIndexedLineSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TIndexedLineSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#URNMatching"},
     {"title": "X3DNodes.TIndexedLineSetNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TIndexedLineSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TIndexedLineSetNode.Lit", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#Lit"},
     {"title": "X3DNodes.TIndexedLineSetNode.InternalCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#InternalCoord"},
     {"title": "X3DNodes.TIndexedLineSetNode.CoordIndexField", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#CoordIndexField"},
     {"title": "X3DNodes.TIndexedLineSetNode.ColorField", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#ColorField"},
     {"title": "X3DNodes.TIndexedLineSetNode.InternalFogCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#InternalFogCoord"},
     {"title": "X3DNodes.TIndexedLineSetNode.AttribField", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#AttribField"},
     {"title": "X3DNodes.TIndexedLineSetNode.SetAttrib", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#SetAttrib"},
     {"title": "X3DNodes.TIndexedLineSetNode.SetColorIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#SetColorIndex"},
     {"title": "X3DNodes.TIndexedLineSetNode.SetColorIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#SetColorIndex"},
     {"title": "X3DNodes.TIndexedLineSetNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TIndexedLineSetNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TIndexedLineSetNode.EventSet_colorIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#EventSet_colorIndex"},
     {"title": "X3DNodes.TIndexedLineSetNode.EventSet_coordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#EventSet_coordIndex"},
     {"title": "X3DNodes.TIndexedLineSetNode.FdAttrib", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#FdAttrib"},
     {"title": "X3DNodes.TIndexedLineSetNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#FdColor"},
     {"title": "X3DNodes.TIndexedLineSetNode.FdCoord", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#FdCoord"},
     {"title": "X3DNodes.TIndexedLineSetNode.FdFogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#FdFogCoord"},
     {"title": "X3DNodes.TIndexedLineSetNode.FdColorIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#FdColorIndex"},
     {"title": "X3DNodes.TIndexedLineSetNode.FdColorPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#FdColorPerVertex"},
     {"title": "X3DNodes.TIndexedLineSetNode.FdCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#FdCoordIndex"},
     {"title": "X3DNodes.TIndexedLineSetNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#Color"},
     {"title": "X3DNodes.TIndexedLineSetNode.Coord", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#Coord"},
     {"title": "X3DNodes.TIndexedLineSetNode.FogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#FogCoord"},
     {"title": "X3DNodes.TIndexedLineSetNode.ColorPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode.html#ColorPerVertex"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#CreateNode"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#URNMatching"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.CoordIndexField", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#CoordIndexField"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.SetIndex", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#SetIndex"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.SetIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#SetIndex"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.EventSet_index", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#EventSet_index"},
     {"title": "X3DNodes.TIndexedTriangleFanSetNode.FdIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleFanSetNode.html#FdIndex"},
     {"title": "X3DNodes.TIndexedTriangleSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#CreateNode"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#URNMatching"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.CoordIndexField", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#CoordIndexField"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.SetIndex", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#SetIndex"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.SetIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#SetIndex"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.EventSet_index", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#EventSet_index"},
     {"title": "X3DNodes.TIndexedTriangleSetNode.FdIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleSetNode.html#FdIndex"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#CreateNode"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#URNMatching"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.CoordIndexField", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#CoordIndexField"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.SetIndex", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#SetIndex"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.SetIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#SetIndex"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.EventSet_index", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#EventSet_index"},
     {"title": "X3DNodes.TIndexedTriangleStripSetNode.FdIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleStripSetNode.html#FdIndex"},
     {"title": "X3DNodes.TLineSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TLineSetNode.html"},
     {"title": "X3DNodes.TLineSetNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TLineSetNode.InternalCoordRangesCounts", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#InternalCoordRangesCounts"},
     {"title": "X3DNodes.TLineSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#CreateNode"},
     {"title": "X3DNodes.TLineSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLineSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#URNMatching"},
     {"title": "X3DNodes.TLineSetNode.InternalCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#InternalCoord"},
     {"title": "X3DNodes.TLineSetNode.ColorField", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#ColorField"},
     {"title": "X3DNodes.TLineSetNode.InternalFogCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#InternalFogCoord"},
     {"title": "X3DNodes.TLineSetNode.AttribField", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#AttribField"},
     {"title": "X3DNodes.TLineSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TLineSetNode.Lit", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#Lit"},
     {"title": "X3DNodes.TLineSetNode.SetAttrib", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#SetAttrib"},
     {"title": "X3DNodes.TLineSetNode.SetVertexCount", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#SetVertexCount"},
     {"title": "X3DNodes.TLineSetNode.SetVertexCount", "text": "    ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#SetVertexCount"},
     {"title": "X3DNodes.TLineSetNode.FdAttrib", "text": " ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#FdAttrib"},
     {"title": "X3DNodes.TLineSetNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#FdColor"},
     {"title": "X3DNodes.TLineSetNode.FdCoord", "text": " ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#FdCoord"},
     {"title": "X3DNodes.TLineSetNode.FdFogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#FdFogCoord"},
     {"title": "X3DNodes.TLineSetNode.FdVertexCount", "text": " ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#FdVertexCount"},
     {"title": "X3DNodes.TLineSetNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#Color"},
     {"title": "X3DNodes.TLineSetNode.Coord", "text": " ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#Coord"},
     {"title": "X3DNodes.TLineSetNode.FogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TLineSetNode.html#FogCoord"},
     {"title": "X3DNodes.TNormalNode", "text": "  <p>Note: It's identical for all VRML and X3D versions (including ancient VRML 1.0). ", "tags": "", "loc": "X3DNodes.TNormalNode.html"},
     {"title": "X3DNodes.TNormalNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNormalNode.html#CreateNode"},
     {"title": "X3DNodes.TNormalNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNormalNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNormalNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNormalNode.html#URNMatching"},
     {"title": "X3DNodes.TNormalNode.SetVector", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TNormalNode.html#SetVector"},
     {"title": "X3DNodes.TNormalNode.SetVector", "text": "    ", "tags": "", "loc": "X3DNodes.TNormalNode.html#SetVector"},
     {"title": "X3DNodes.TNormalNode.FdVector", "text": " ", "tags": "", "loc": "X3DNodes.TNormalNode.html#FdVector"},
     {"title": "X3DNodes.TPointSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode.html"},
     {"title": "X3DNodes.TPointSetNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TPointSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#CreateNode"},
     {"title": "X3DNodes.TPointSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPointSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#URNMatching"},
     {"title": "X3DNodes.TPointSetNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TPointSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TPointSetNode.Lit", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#Lit"},
     {"title": "X3DNodes.TPointSetNode.InternalCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#InternalCoord"},
     {"title": "X3DNodes.TPointSetNode.ColorField", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#ColorField"},
     {"title": "X3DNodes.TPointSetNode.InternalFogCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#InternalFogCoord"},
     {"title": "X3DNodes.TPointSetNode.AttribField", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#AttribField"},
     {"title": "X3DNodes.TPointSetNode.SetAttrib", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#SetAttrib"},
     {"title": "X3DNodes.TPointSetNode.FdAttrib", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#FdAttrib"},
     {"title": "X3DNodes.TPointSetNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#FdColor"},
     {"title": "X3DNodes.TPointSetNode.FdCoord", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#FdCoord"},
     {"title": "X3DNodes.TPointSetNode.FdFogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#FdFogCoord"},
     {"title": "X3DNodes.TPointSetNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#Color"},
     {"title": "X3DNodes.TPointSetNode.Coord", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#Coord"},
     {"title": "X3DNodes.TPointSetNode.FogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode.html#FogCoord"},
     {"title": "X3DNodes.TTriangleFanSetNode", "text": " In constrast to <a class=\"normal\" href=\"X3DNodes.TIndexedTriangleFanSetNode.html\">TIndexedTriangleFanSetNode</a>, this doesn't use indexes to compose vertexes into triangles. ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html"},
     {"title": "X3DNodes.TTriangleFanSetNode.InternalCoordRangesCounts", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html#InternalCoordRangesCounts"},
     {"title": "X3DNodes.TTriangleFanSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html#CreateNode"},
     {"title": "X3DNodes.TTriangleFanSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTriangleFanSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html#URNMatching"},
     {"title": "X3DNodes.TTriangleFanSetNode.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TTriangleFanSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TTriangleFanSetNode.SetFanCount", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html#SetFanCount"},
     {"title": "X3DNodes.TTriangleFanSetNode.SetFanCount", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html#SetFanCount"},
     {"title": "X3DNodes.TTriangleFanSetNode.FdFanCount", "text": " ", "tags": "", "loc": "X3DNodes.TTriangleFanSetNode.html#FdFanCount"},
     {"title": "X3DNodes.TTriangleSetNode", "text": " In constrast to <a class=\"normal\" href=\"X3DNodes.TIndexedTriangleSetNode.html\">TIndexedTriangleSetNode</a>, this doesn't use indexes to compose vertexes into triangles. ", "tags": "", "loc": "X3DNodes.TTriangleSetNode.html"},
     {"title": "X3DNodes.TTriangleSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSetNode.html#CreateNode"},
     {"title": "X3DNodes.TTriangleSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTriangleSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSetNode.html#URNMatching"},
     {"title": "X3DNodes.TTriangleSetNode.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSetNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TTriangleSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TTriangleStripSetNode", "text": " In constrast to <a class=\"normal\" href=\"X3DNodes.TIndexedTriangleStripSetNode.html\">TIndexedTriangleStripSetNode</a>, this doesn't use indexes to compose vertexes into triangles. ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html"},
     {"title": "X3DNodes.TTriangleStripSetNode.InternalCoordRangesCounts", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html#InternalCoordRangesCounts"},
     {"title": "X3DNodes.TTriangleStripSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html#CreateNode"},
     {"title": "X3DNodes.TTriangleStripSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTriangleStripSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html#URNMatching"},
     {"title": "X3DNodes.TTriangleStripSetNode.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TTriangleStripSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TTriangleStripSetNode.SetStripCount", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html#SetStripCount"},
     {"title": "X3DNodes.TTriangleStripSetNode.SetStripCount", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html#SetStripCount"},
     {"title": "X3DNodes.TTriangleStripSetNode.FdStripCount", "text": " ", "tags": "", "loc": "X3DNodes.TTriangleStripSetNode.html#FdStripCount"},
     {"title": "X3DNodes.TAbstractAppearanceChildNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractAppearanceChildNode.html"},
     {"title": "X3DNodes.TAbstractAppearanceNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractAppearanceNode.html"},
     {"title": "X3DNodes.TAbstractMaterialNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractMaterialNode.html"},
     {"title": "X3DNodes.TAbstractMaterialNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractMaterialNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractShapeNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html"},
     {"title": "X3DNodes.TAbstractShapeNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TAbstractShapeNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractShapeNode.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#BeforeTraverse"},
     {"title": "X3DNodes.TAbstractShapeNode.AfterTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#AfterTraverse"},
     {"title": "X3DNodes.TAbstractShapeNode.CommonSurfaceShader", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#CommonSurfaceShader"},
     {"title": "X3DNodes.TAbstractShapeNode.FdAppearance", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#FdAppearance"},
     {"title": "X3DNodes.TAbstractShapeNode.FdGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#FdGeometry"},
     {"title": "X3DNodes.TAbstractShapeNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TAbstractShapeNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#FdBboxSize"},
     {"title": "X3DNodes.TAbstractShapeNode.FdRender", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#FdRender"},
     {"title": "X3DNodes.TAbstractShapeNode.FdShading", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#FdShading"},
     {"title": "X3DNodes.TAbstractShapeNode.Shading", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#Shading"},
     {"title": "X3DNodes.TAbstractShapeNode.Geometry", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#Geometry"},
     {"title": "X3DNodes.TAbstractShapeNode.Appearance", "text": "  <p>This is a comfortable shortcut for FdAppearance.Value, checking whether it's class is appropriate. ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#Appearance"},
     {"title": "X3DNodes.TAbstractShapeNode.Texture", "text": " This is a shortcut for accessing &quot;texture&quot; field of Apperance, that is <code><a class=\"normal\" href=\"X3DNodes.TAppearanceNode.html\">TAppearanceNode</a>(FdAppearance.Value).FdTexture.Value</code>, checking whether nodes are set to appropriate types along the way.  <p>When setting this to something non-nil, we make sure to also set Appearance to something non-nil. ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#Texture"},
     {"title": "X3DNodes.TAbstractShapeNode.TextureTransform", "text": " Similar to <a class=\"normal\" href=\"X3DNodes.TAbstractShapeNode.html#Texture\">Texture</a>, this is just a comfortable property for getting and setting the appropriate Appearance field, checking class types along the way. ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#TextureTransform"},
     {"title": "X3DNodes.TAbstractShapeNode.Material", "text": " This is a shortcut for accessing &quot;material&quot; field of Apperance, that is <code><a class=\"normal\" href=\"X3DNodes.TAppearanceNode.html\">TAppearanceNode</a>(FdAppearance.Value).FdMaterial.Value</code>, checking whether nodes are set to appropriate types along the way.  <p>When setting this material to something non-nil, we make sure to also set Appearance to something non-nil. ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#Material"},
     {"title": "X3DNodes.TAbstractShapeNode.LineProperties", "text": " This is a clean, type-safe way for accessing Appearance.lineProperties field of this shape. ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#LineProperties"},
     {"title": "X3DNodes.TAbstractShapeNode.FdOctreeTriangles", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#FdOctreeTriangles"},
     {"title": "X3DNodes.TAbstractShapeNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#BboxCenter"},
     {"title": "X3DNodes.TAbstractShapeNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#BboxSize"},
     {"title": "X3DNodes.TAbstractShapeNode.OctreeTriangles", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#OctreeTriangles"},
     {"title": "X3DNodes.TAbstractShapeNode.Render", "text": " See <a  href=\"https://castle-engine.sourceforge.io/x3d_implementation_shape_extensions.php#section_ext_shape_render\">https://castle-engine.sourceforge.io/x3d_implementation_shape_extensions.php#section_ext_shape_render</a> ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.html#Render"},
     {"title": "X3DNodes.TAbstractShapeNode.TSFShading", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.TSFShading.html"},
     {"title": "X3DNodes.TAbstractShapeNode.TSFShading.ExposedEventsFieldClass", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.TSFShading.html#ExposedEventsFieldClass"},
     {"title": "X3DNodes.TAbstractShapeNode.TSFShading.ExposedEventReceive", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.TSFShading.html#ExposedEventReceive"},
     {"title": "X3DNodes.TAbstractShapeNode.TSFShading.ExecuteChanges", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractShapeNode.TSFShading.html#ExecuteChanges"},
     {"title": "X3DNodes.TMFNodeShaders", "text": " ", "tags": "", "loc": "X3DNodes.TMFNodeShaders.html"},
     {"title": "X3DNodes.TMFNodeShaders.GLSLShader", "text": " Otherwise returns <code>Nil</code>. Checks the class of Items[Index] and it's <code>language</code> field.    ", "tags": "", "loc": "X3DNodes.TMFNodeShaders.html#GLSLShader"},
     {"title": "X3DNodes.TAppearanceNode", "text": "  <p>Note that the geometry is unlit (pure <a class=\"normal\" href=\"CastleColors.html#White\">white</a>, regardless of lighting) if no <a class=\"normal\" href=\"X3DNodes.TAppearanceNode.html#Material\">Material</a> is assigned. To make the geometry lit, you can just set there a default material created by <code>TMaterialNode.Create</code>. ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html"},
     {"title": "X3DNodes.TAppearanceNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TAppearanceNode.ParseAfter", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#ParseAfter"},
     {"title": "X3DNodes.TAppearanceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#CreateNode"},
     {"title": "X3DNodes.TAppearanceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TAppearanceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#URNMatching"},
     {"title": "X3DNodes.TAppearanceNode.CommonSurfaceShader", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#CommonSurfaceShader"},
     {"title": "X3DNodes.TAppearanceNode.DiffuseAlphaTexture", "text": " This texture may come from <a class=\"normal\" href=\"X3DNodes.TAppearanceNode.html#Texture\">Texture</a> or from <a class=\"normal\" href=\"X3DNodes.TAppearanceNode.html#CommonSurfaceShader\">CommonSurfaceShader</a>.    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#DiffuseAlphaTexture"},
     {"title": "X3DNodes.TAppearanceNode.InternalMaterialProperty", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#InternalMaterialProperty"},
     {"title": "X3DNodes.TAppearanceNode.MaterialProperty", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#MaterialProperty"},
     {"title": "X3DNodes.TAppearanceNode.SetShaders", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#SetShaders"},
     {"title": "X3DNodes.TAppearanceNode.SetReceiveShadows", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#SetReceiveShadows"},
     {"title": "X3DNodes.TAppearanceNode.SetEffects", "text": "    ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#SetEffects"},
     {"title": "X3DNodes.TAppearanceNode.FdFillProperties", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdFillProperties"},
     {"title": "X3DNodes.TAppearanceNode.FdLineProperties", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdLineProperties"},
     {"title": "X3DNodes.TAppearanceNode.FdMaterial", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdMaterial"},
     {"title": "X3DNodes.TAppearanceNode.FdShaders", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdShaders"},
     {"title": "X3DNodes.TAppearanceNode.FdTexture", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdTexture"},
     {"title": "X3DNodes.TAppearanceNode.FdTextureTransform", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdTextureTransform"},
     {"title": "X3DNodes.TAppearanceNode.FdReceiveShadows", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdReceiveShadows"},
     {"title": "X3DNodes.TAppearanceNode.FdShadowCaster", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdShadowCaster"},
     {"title": "X3DNodes.TAppearanceNode.FdEffects", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdEffects"},
     {"title": "X3DNodes.TAppearanceNode.FdNormalMap", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdNormalMap"},
     {"title": "X3DNodes.TAppearanceNode.FdHeightMap", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdHeightMap"},
     {"title": "X3DNodes.TAppearanceNode.FdHeightMapScale", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdHeightMapScale"},
     {"title": "X3DNodes.TAppearanceNode.FdBlendMode", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FdBlendMode"},
     {"title": "X3DNodes.TAppearanceNode.Texture", "text": "  <p>This is a comfortable property for getting and setting the appropriate X3D field, checking class types along the way and setting the value through X3D events if necessary. ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#Texture"},
     {"title": "X3DNodes.TAppearanceNode.NormalMap", "text": "  <p>See <a  href=\"https://castle-engine.sourceforge.io/x3d_implementation_texturing_extensions.php#section_ext_bump_mapping\">https://castle-engine.sourceforge.io/x3d_implementation_texturing_extensions.php#section_ext_bump_mapping</a> . This is a deprecated method of using bump mapping, a better method is to use <a class=\"normal\" href=\"X3DNodes.TAppearanceNode.html#CommonSurfaceShader\">CommonSurfaceShader</a>: <a  href=\"https://castle-engine.sourceforge.io/x3d_implementation_texturing_extensions.php#section_ext_common_surface_shader\">https://castle-engine.sourceforge.io/x3d_implementation_texturing_extensions.php#section_ext_common_surface_shader</a> .  <p>This is a comfortable property for getting and setting the appropriate X3D field, checking class types along the way and setting the value through X3D events if necessary. ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#NormalMap"},
     {"title": "X3DNodes.TAppearanceNode.Material", "text": " This only sets the simple, one-sided material node.  <p>This is a comfortable property for getting and setting the appropriate X3D field, checking class types along the way and setting the value through X3D events if necessary. ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#Material"},
     {"title": "X3DNodes.TAppearanceNode.FillProperties", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#FillProperties"},
     {"title": "X3DNodes.TAppearanceNode.LineProperties", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#LineProperties"},
     {"title": "X3DNodes.TAppearanceNode.TextureTransform", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#TextureTransform"},
     {"title": "X3DNodes.TAppearanceNode.ShadowCaster", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#ShadowCaster"},
     {"title": "X3DNodes.TAppearanceNode.HeightMapScale", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#HeightMapScale"},
     {"title": "X3DNodes.TAppearanceNode.BlendMode", "text": " ", "tags": "", "loc": "X3DNodes.TAppearanceNode.html#BlendMode"},
     {"title": "X3DNodes.TFillPropertiesNode", "text": " ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html"},
     {"title": "X3DNodes.TFillPropertiesNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#CreateNode"},
     {"title": "X3DNodes.TFillPropertiesNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#ClassX3DType"},
     {"title": "X3DNodes.TFillPropertiesNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#URNMatching"},
     {"title": "X3DNodes.TFillPropertiesNode.FdFilled", "text": " ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#FdFilled"},
     {"title": "X3DNodes.TFillPropertiesNode.FdHatchColor", "text": " ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#FdHatchColor"},
     {"title": "X3DNodes.TFillPropertiesNode.FdHatched", "text": " ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#FdHatched"},
     {"title": "X3DNodes.TFillPropertiesNode.FdHatchStyle", "text": " ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#FdHatchStyle"},
     {"title": "X3DNodes.TFillPropertiesNode.Filled", "text": " ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#Filled"},
     {"title": "X3DNodes.TFillPropertiesNode.HatchColor", "text": " ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#HatchColor"},
     {"title": "X3DNodes.TFillPropertiesNode.Hatched", "text": " ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#Hatched"},
     {"title": "X3DNodes.TFillPropertiesNode.HatchStyle", "text": " ", "tags": "", "loc": "X3DNodes.TFillPropertiesNode.html#HatchStyle"},
     {"title": "X3DNodes.TLinePropertiesNode", "text": " ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html"},
     {"title": "X3DNodes.TLinePropertiesNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html#CreateNode"},
     {"title": "X3DNodes.TLinePropertiesNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLinePropertiesNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html#URNMatching"},
     {"title": "X3DNodes.TLinePropertiesNode.FdApplied", "text": " ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html#FdApplied"},
     {"title": "X3DNodes.TLinePropertiesNode.FdLinetype", "text": " ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html#FdLinetype"},
     {"title": "X3DNodes.TLinePropertiesNode.LineType", "text": " ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html#LineType"},
     {"title": "X3DNodes.TLinePropertiesNode.FdLinewidthScaleFactor", "text": " ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html#FdLinewidthScaleFactor"},
     {"title": "X3DNodes.TLinePropertiesNode.Applied", "text": " ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html#Applied"},
     {"title": "X3DNodes.TLinePropertiesNode.LinewidthScaleFactor", "text": " ", "tags": "", "loc": "X3DNodes.TLinePropertiesNode.html#LinewidthScaleFactor"},
     {"title": "X3DNodes.TMaterialInfo", "text": " This hides differences between VRML 1.0 Material, X3D and VRML 2.0 Material and CommonSurfaceShader. ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html"},
     {"title": "X3DNodes.TMaterialInfo.DefaultAmbientColor", "text": "  <p>They luckily match between all the material-like nodes: </p>  <ul class=\"compact_spacing\">   <li><p>X3D and VRML 2.0: <a class=\"normal\" href=\"X3DNodes.TMaterialNode.html\">TMaterialNode</a></p></li>   <li><p>VRML 1.0: <a class=\"normal\" href=\"X3DNodes.TMaterialNode_1.html\">TMaterialNode_1</a></p></li>   <li><p>CommonSurfaceShader: <a class=\"normal\" href=\"X3DNodes.TCommonSurfaceShaderNode.html\">TCommonSurfaceShaderNode</a></p></li> </ul>  <p>  <p>The <a class=\"normal\" href=\"X3DNodes.TMaterialInfo.html#AmbientColor\">AmbientColor</a> is an exception, the effective <a class=\"normal\" href=\"X3DNodes.TMaterialInfo.html#AmbientColor\">ambientColor</a> for X3D is <code>ambientIntensity * <a class=\"normal\" href=\"X3DNodes.TMaterialInfo.html#DiffuseColor\">diffuseColor</a> = (0.2 * 0.8, 0.2 * 0.8, 0.2 * 0.8)</code>. ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultAmbientColor"},
     {"title": "X3DNodes.TMaterialInfo.DefaultAmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultAmbientIntensity"},
     {"title": "X3DNodes.TMaterialInfo.DefaultDiffuseColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultDiffuseColor"},
     {"title": "X3DNodes.TMaterialInfo.DefaultSpecularColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultSpecularColor"},
     {"title": "X3DNodes.TMaterialInfo.DefaultEmissiveColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultEmissiveColor"},
     {"title": "X3DNodes.TMaterialInfo.DefaultShininess", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultShininess"},
     {"title": "X3DNodes.TMaterialInfo.DefaultShininessExp", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultShininessExp"},
     {"title": "X3DNodes.TMaterialInfo.DefaultTransparency", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultTransparency"},
     {"title": "X3DNodes.TMaterialInfo.DefaultReflectionColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultReflectionColor"},
     {"title": "X3DNodes.TMaterialInfo.DefaultTransmissionColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultTransmissionColor"},
     {"title": "X3DNodes.TMaterialInfo.DefaultReflSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultReflSpecularExp"},
     {"title": "X3DNodes.TMaterialInfo.DefaultTransSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DefaultTransSpecularExp"},
     {"title": "X3DNodes.TMaterialInfo.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#Create"},
     {"title": "X3DNodes.TMaterialInfo.AmbientColor", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#AmbientColor"},
     {"title": "X3DNodes.TMaterialInfo.DiffuseColor", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#DiffuseColor"},
     {"title": "X3DNodes.TMaterialInfo.SpecularColor", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#SpecularColor"},
     {"title": "X3DNodes.TMaterialInfo.EmissiveColor", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#EmissiveColor"},
     {"title": "X3DNodes.TMaterialInfo.PureEmissive", "text": "  <p>This checks that ambient and diffuse and specular colors are all zero. It's an important information about the material sometimes. We can optimize this case when rendering.    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#PureEmissive"},
     {"title": "X3DNodes.TMaterialInfo.Shininess", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#Shininess"},
     {"title": "X3DNodes.TMaterialInfo.ShininessExp", "text": "  <p>Remember that the X3D <a class=\"normal\" href=\"X3DNodes.TMaterialInfo.html#Shininess\">Shininess</a> field is &quot;normalized&quot;, which means that it has to be multiplied by 128.0 to get actual exponent for lighting equations. This function returns the real exponent (already multiplied by 128.0, if necessary).    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#ShininessExp"},
     {"title": "X3DNodes.TMaterialInfo.ReflectionColor", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#ReflectionColor"},
     {"title": "X3DNodes.TMaterialInfo.TransmissionColor", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#TransmissionColor"},
     {"title": "X3DNodes.TMaterialInfo.Transparency", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#Transparency"},
     {"title": "X3DNodes.TMaterialInfo.Opacity", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#Opacity"},
     {"title": "X3DNodes.TMaterialInfo.ReflSpecular", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#ReflSpecular"},
     {"title": "X3DNodes.TMaterialInfo.ReflDiffuse", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#ReflDiffuse"},
     {"title": "X3DNodes.TMaterialInfo.TransSpecular", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#TransSpecular"},
     {"title": "X3DNodes.TMaterialInfo.TransDiffuse", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#TransDiffuse"},
     {"title": "X3DNodes.TMaterialInfo.ReflSpecularExp", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#ReflSpecularExp"},
     {"title": "X3DNodes.TMaterialInfo.TransSpecularExp", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#TransSpecularExp"},
     {"title": "X3DNodes.TMaterialInfo.Node", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialInfo.html#Node"},
     {"title": "X3DNodes.TMaterialNode", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html"},
     {"title": "X3DNodes.TMaterialNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#CreateNode"},
     {"title": "X3DNodes.TMaterialNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#Destroy"},
     {"title": "X3DNodes.TMaterialNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMaterialNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#URNMatching"},
     {"title": "X3DNodes.TMaterialNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TMaterialNode.Opacity", "text": " Defined for your comfort &mdash; for OpenGL you will usually want to pass Opacity, not Transparency.    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#Opacity"},
     {"title": "X3DNodes.TMaterialNode.ShininessExp", "text": " Defined for your comfort &mdash; for any graphic library you will usually want to pass the &quot;real&quot; exponent given by this function, not just value of shininess field.    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#ShininessExp"},
     {"title": "X3DNodes.TMaterialNode.MaterialInfo", "text": " It is automatically updated when properties of this material change. Do not free it yourself, it will be automatically freed when this node is freed.    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#MaterialInfo"},
     {"title": "X3DNodes.TMaterialNode.PureEmissive", "text": "  <p>This checks that ambient and diffuse and specular colors are all zero. It's an important information about the material sometimes. It is similar to the NULL material situation (when &quot;Appearance.material=NULL&quot; case), but the color and transparency are still configurable (using <a class=\"normal\" href=\"X3DNodes.TMaterialNode.html#FdEmissiveColor\">FdEmissiveColor</a> and <a class=\"normal\" href=\"X3DNodes.TMaterialNode.html#FdTransparency\">FdTransparency</a> fields).  <p>We can optimize this case when rendering.    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#PureEmissive"},
     {"title": "X3DNodes.TMaterialNode.ForcePureEmissive", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#ForcePureEmissive"},
     {"title": "X3DNodes.TMaterialNode.SetReflSpecular", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#SetReflSpecular"},
     {"title": "X3DNodes.TMaterialNode.SetReflSpecular", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#SetReflSpecular"},
     {"title": "X3DNodes.TMaterialNode.SetReflDiffuse", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#SetReflDiffuse"},
     {"title": "X3DNodes.TMaterialNode.SetReflDiffuse", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#SetReflDiffuse"},
     {"title": "X3DNodes.TMaterialNode.SetTransSpecular", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#SetTransSpecular"},
     {"title": "X3DNodes.TMaterialNode.SetTransSpecular", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#SetTransSpecular"},
     {"title": "X3DNodes.TMaterialNode.SetTransDiffuse", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#SetTransDiffuse"},
     {"title": "X3DNodes.TMaterialNode.SetTransDiffuse", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#SetTransDiffuse"},
     {"title": "X3DNodes.TMaterialNode.FdAmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdAmbientIntensity"},
     {"title": "X3DNodes.TMaterialNode.FdDiffuseColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdDiffuseColor"},
     {"title": "X3DNodes.TMaterialNode.FdEmissiveColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdEmissiveColor"},
     {"title": "X3DNodes.TMaterialNode.FdShininess", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdShininess"},
     {"title": "X3DNodes.TMaterialNode.FdSpecularColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdSpecularColor"},
     {"title": "X3DNodes.TMaterialNode.FdTransparency", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdTransparency"},
     {"title": "X3DNodes.TMaterialNode.FdFogImmune", "text": " This is a Castle Game Engine extension, not present in X3D standard. ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdFogImmune"},
     {"title": "X3DNodes.TMaterialNode.FdMirror", "text": " Right now used only by the classic ray-tracer, not by interactive renderer. This is a Castle Game Engine extension, not present in X3D standard. ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdMirror"},
     {"title": "X3DNodes.TMaterialNode.FdReflSpecular", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdReflSpecular"},
     {"title": "X3DNodes.TMaterialNode.FdReflDiffuse", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdReflDiffuse"},
     {"title": "X3DNodes.TMaterialNode.FdTransSpecular", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdTransSpecular"},
     {"title": "X3DNodes.TMaterialNode.FdTransDiffuse", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdTransDiffuse"},
     {"title": "X3DNodes.TMaterialNode.FdReflSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdReflSpecularExp"},
     {"title": "X3DNodes.TMaterialNode.FdTransSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#FdTransSpecularExp"},
     {"title": "X3DNodes.TMaterialNode.AmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#AmbientIntensity"},
     {"title": "X3DNodes.TMaterialNode.DiffuseColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#DiffuseColor"},
     {"title": "X3DNodes.TMaterialNode.EmissiveColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#EmissiveColor"},
     {"title": "X3DNodes.TMaterialNode.Shininess", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#Shininess"},
     {"title": "X3DNodes.TMaterialNode.SpecularColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#SpecularColor"},
     {"title": "X3DNodes.TMaterialNode.Transparency", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#Transparency"},
     {"title": "X3DNodes.TMaterialNode.Mirror", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#Mirror"},
     {"title": "X3DNodes.TMaterialNode.ReflSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#ReflSpecularExp"},
     {"title": "X3DNodes.TMaterialNode.TransSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode.html#TransSpecularExp"},
     {"title": "X3DNodes.TShapeNode", "text": " ", "tags": "", "loc": "X3DNodes.TShapeNode.html"},
     {"title": "X3DNodes.TShapeNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TShapeNode.html#CreateNode"},
     {"title": "X3DNodes.TShapeNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TShapeNode.html#ClassX3DType"},
     {"title": "X3DNodes.TShapeNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TShapeNode.html#URNMatching"},
     {"title": "X3DNodes.TTwoSidedMaterialNode", "text": " <b>Not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#CreateNode"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#URNMatching"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdAmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdAmbientIntensity"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdBackAmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdBackAmbientIntensity"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdBackDiffuseColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdBackDiffuseColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdBackEmissiveColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdBackEmissiveColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdBackShininess", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdBackShininess"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdBackSpecularColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdBackSpecularColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdBackTransparency", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdBackTransparency"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdDiffuseColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdDiffuseColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdEmissiveColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdEmissiveColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdShininess", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdShininess"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdSeparateBackColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdSeparateBackColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdSpecularColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdSpecularColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.FdTransparency", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#FdTransparency"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.AmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#AmbientIntensity"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.BackAmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#BackAmbientIntensity"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.BackDiffuseColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#BackDiffuseColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.BackEmissiveColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#BackEmissiveColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.BackShininess", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#BackShininess"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.BackSpecularColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#BackSpecularColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.BackTransparency", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#BackTransparency"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.DiffuseColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#DiffuseColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.EmissiveColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#EmissiveColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.Shininess", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#Shininess"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.SeparateBackColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#SeparateBackColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.SpecularColor", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#SpecularColor"},
     {"title": "X3DNodes.TTwoSidedMaterialNode.Transparency", "text": " ", "tags": "", "loc": "X3DNodes.TTwoSidedMaterialNode.html#Transparency"},
     {"title": "X3DNodes.TBoxNode", "text": " ", "tags": "", "loc": "X3DNodes.TBoxNode.html"},
     {"title": "X3DNodes.TBoxNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#CreateNode"},
     {"title": "X3DNodes.TBoxNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBoxNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#URNMatching"},
     {"title": "X3DNodes.TBoxNode.TexCoordField", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#TexCoordField"},
     {"title": "X3DNodes.TBoxNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#SolidField"},
     {"title": "X3DNodes.TBoxNode.CalculateDivisions", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#CalculateDivisions"},
     {"title": "X3DNodes.TBoxNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#Proxy"},
     {"title": "X3DNodes.TBoxNode.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#BoundingBox"},
     {"title": "X3DNodes.TBoxNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TBoxNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#TrianglesCount"},
     {"title": "X3DNodes.TBoxNode.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TBoxNode.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TBoxNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TBoxNode.html#FdSize"},
     {"title": "X3DNodes.TBoxNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TBoxNode.html#FdSolid"},
     {"title": "X3DNodes.TBoxNode.FdCcw", "text": " ", "tags": "", "loc": "X3DNodes.TBoxNode.html#FdCcw"},
     {"title": "X3DNodes.TBoxNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TBoxNode.html#FdTexCoord"},
     {"title": "X3DNodes.TBoxNode.FdDivisions", "text": " ", "tags": "", "loc": "X3DNodes.TBoxNode.html#FdDivisions"},
     {"title": "X3DNodes.TBoxNode.Size", "text": " ", "tags": "", "loc": "X3DNodes.TBoxNode.html#Size"},
     {"title": "X3DNodes.TBoxNode.Ccw", "text": " ", "tags": "", "loc": "X3DNodes.TBoxNode.html#Ccw"},
     {"title": "X3DNodes.TBoxNode.Divisions", "text": " ", "tags": "", "loc": "X3DNodes.TBoxNode.html#Divisions"},
     {"title": "X3DNodes.TConeNode", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html"},
     {"title": "X3DNodes.TConeNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TConeNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#CreateNode"},
     {"title": "X3DNodes.TConeNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#ClassX3DType"},
     {"title": "X3DNodes.TConeNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#URNMatching"},
     {"title": "X3DNodes.TConeNode.TexCoordField", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#TexCoordField"},
     {"title": "X3DNodes.TConeNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#SolidField"},
     {"title": "X3DNodes.TConeNode.CalculateSlices", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#CalculateSlices"},
     {"title": "X3DNodes.TConeNode.CalculateStacks", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#CalculateStacks"},
     {"title": "X3DNodes.TConeNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TConeNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#Proxy"},
     {"title": "X3DNodes.TConeNode.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#BoundingBox"},
     {"title": "X3DNodes.TConeNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TConeNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#TrianglesCount"},
     {"title": "X3DNodes.TConeNode.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TConeNode.FdBottom", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#FdBottom"},
     {"title": "X3DNodes.TConeNode.FdBottomRadius", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#FdBottomRadius"},
     {"title": "X3DNodes.TConeNode.FdHeight", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#FdHeight"},
     {"title": "X3DNodes.TConeNode.FdSide", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#FdSide"},
     {"title": "X3DNodes.TConeNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#FdSolid"},
     {"title": "X3DNodes.TConeNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#FdTexCoord"},
     {"title": "X3DNodes.TConeNode.FdSlices", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#FdSlices"},
     {"title": "X3DNodes.TConeNode.FdStacks", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#FdStacks"},
     {"title": "X3DNodes.TConeNode.Bottom", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#Bottom"},
     {"title": "X3DNodes.TConeNode.BottomRadius", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#BottomRadius"},
     {"title": "X3DNodes.TConeNode.Height", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#Height"},
     {"title": "X3DNodes.TConeNode.Side", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#Side"},
     {"title": "X3DNodes.TConeNode.Slices", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#Slices"},
     {"title": "X3DNodes.TConeNode.Stacks", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode.html#Stacks"},
     {"title": "X3DNodes.TCylinderNode", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html"},
     {"title": "X3DNodes.TCylinderNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TCylinderNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#CreateNode"},
     {"title": "X3DNodes.TCylinderNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCylinderNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#URNMatching"},
     {"title": "X3DNodes.TCylinderNode.TexCoordField", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#TexCoordField"},
     {"title": "X3DNodes.TCylinderNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#SolidField"},
     {"title": "X3DNodes.TCylinderNode.CalculateSlices", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#CalculateSlices"},
     {"title": "X3DNodes.TCylinderNode.CalculateStacks", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#CalculateStacks"},
     {"title": "X3DNodes.TCylinderNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TCylinderNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#Proxy"},
     {"title": "X3DNodes.TCylinderNode.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#BoundingBox"},
     {"title": "X3DNodes.TCylinderNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TCylinderNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#TrianglesCount"},
     {"title": "X3DNodes.TCylinderNode.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TCylinderNode.FdBottom", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#FdBottom"},
     {"title": "X3DNodes.TCylinderNode.FdHeight", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#FdHeight"},
     {"title": "X3DNodes.TCylinderNode.FdRadius", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#FdRadius"},
     {"title": "X3DNodes.TCylinderNode.FdSide", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#FdSide"},
     {"title": "X3DNodes.TCylinderNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#FdSolid"},
     {"title": "X3DNodes.TCylinderNode.FdTop", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#FdTop"},
     {"title": "X3DNodes.TCylinderNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#FdTexCoord"},
     {"title": "X3DNodes.TCylinderNode.FdSlices", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#FdSlices"},
     {"title": "X3DNodes.TCylinderNode.FdStacks", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#FdStacks"},
     {"title": "X3DNodes.TCylinderNode.Bottom", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#Bottom"},
     {"title": "X3DNodes.TCylinderNode.Height", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#Height"},
     {"title": "X3DNodes.TCylinderNode.Radius", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#Radius"},
     {"title": "X3DNodes.TCylinderNode.Side", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#Side"},
     {"title": "X3DNodes.TCylinderNode.Top", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#Top"},
     {"title": "X3DNodes.TCylinderNode.Slices", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#Slices"},
     {"title": "X3DNodes.TCylinderNode.Stacks", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode.html#Stacks"},
     {"title": "X3DNodes.TElevationGridNode", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html"},
     {"title": "X3DNodes.TElevationGridNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#CreateNode"},
     {"title": "X3DNodes.TElevationGridNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#ClassX3DType"},
     {"title": "X3DNodes.TElevationGridNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#URNMatching"},
     {"title": "X3DNodes.TElevationGridNode.IsNotEmpty", "text": " If this returns <code>False</code> then it is understood that ElevationGrid is not rendered, doesn't have any vertices/triangles etc.    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#IsNotEmpty"},
     {"title": "X3DNodes.TElevationGridNode.ColorField", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#ColorField"},
     {"title": "X3DNodes.TElevationGridNode.InternalFogCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#InternalFogCoord"},
     {"title": "X3DNodes.TElevationGridNode.AttribField", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#AttribField"},
     {"title": "X3DNodes.TElevationGridNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#SolidField"},
     {"title": "X3DNodes.TElevationGridNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#Proxy"},
     {"title": "X3DNodes.TElevationGridNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TElevationGridNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TElevationGridNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#VerticesCount"},
     {"title": "X3DNodes.TElevationGridNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#TrianglesCount"},
     {"title": "X3DNodes.TElevationGridNode.SetAttrib", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#SetAttrib"},
     {"title": "X3DNodes.TElevationGridNode.SetHeight", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#SetHeight"},
     {"title": "X3DNodes.TElevationGridNode.SetHeight", "text": "    ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#SetHeight"},
     {"title": "X3DNodes.TElevationGridNode.EventSet_height", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#EventSet_height"},
     {"title": "X3DNodes.TElevationGridNode.FdAttrib", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdAttrib"},
     {"title": "X3DNodes.TElevationGridNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdColor"},
     {"title": "X3DNodes.TElevationGridNode.FdFogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdFogCoord"},
     {"title": "X3DNodes.TElevationGridNode.FdNormal", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdNormal"},
     {"title": "X3DNodes.TElevationGridNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdTexCoord"},
     {"title": "X3DNodes.TElevationGridNode.FdCcw", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdCcw"},
     {"title": "X3DNodes.TElevationGridNode.FdColorPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdColorPerVertex"},
     {"title": "X3DNodes.TElevationGridNode.FdCreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdCreaseAngle"},
     {"title": "X3DNodes.TElevationGridNode.FdHeight", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdHeight"},
     {"title": "X3DNodes.TElevationGridNode.FdNormalPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdNormalPerVertex"},
     {"title": "X3DNodes.TElevationGridNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdSolid"},
     {"title": "X3DNodes.TElevationGridNode.FdXDimension", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdXDimension"},
     {"title": "X3DNodes.TElevationGridNode.FdXSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdXSpacing"},
     {"title": "X3DNodes.TElevationGridNode.FdZDimension", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdZDimension"},
     {"title": "X3DNodes.TElevationGridNode.FdZSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FdZSpacing"},
     {"title": "X3DNodes.TElevationGridNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#Color"},
     {"title": "X3DNodes.TElevationGridNode.FogCoord", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#FogCoord"},
     {"title": "X3DNodes.TElevationGridNode.Normal", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#Normal"},
     {"title": "X3DNodes.TElevationGridNode.TexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#TexCoord"},
     {"title": "X3DNodes.TElevationGridNode.Ccw", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#Ccw"},
     {"title": "X3DNodes.TElevationGridNode.ColorPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#ColorPerVertex"},
     {"title": "X3DNodes.TElevationGridNode.CreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#CreaseAngle"},
     {"title": "X3DNodes.TElevationGridNode.NormalPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#NormalPerVertex"},
     {"title": "X3DNodes.TElevationGridNode.XDimension", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#XDimension"},
     {"title": "X3DNodes.TElevationGridNode.XSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#XSpacing"},
     {"title": "X3DNodes.TElevationGridNode.ZDimension", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#ZDimension"},
     {"title": "X3DNodes.TElevationGridNode.ZSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TElevationGridNode.html#ZSpacing"},
     {"title": "X3DNodes.TExtrusionNode", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html"},
     {"title": "X3DNodes.TExtrusionNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TExtrusionNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#CreateNode"},
     {"title": "X3DNodes.TExtrusionNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#ClassX3DType"},
     {"title": "X3DNodes.TExtrusionNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#URNMatching"},
     {"title": "X3DNodes.TExtrusionNode.TexCoordField", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#TexCoordField"},
     {"title": "X3DNodes.TExtrusionNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SolidField"},
     {"title": "X3DNodes.TExtrusionNode.ConvexField", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#ConvexField"},
     {"title": "X3DNodes.TExtrusionNode.CrossSection3D", "text": " That is, uses FdCrossIndex values as X, Z of 3D vertex and sets Y = 0 (that's how Extrusion is defined in VRML / X3D).    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#CrossSection3D"},
     {"title": "X3DNodes.TExtrusionNode.SpineClosed", "text": " This happens when &quot;spine&quot; field is non-empty and it's first and last points are equal.    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SpineClosed"},
     {"title": "X3DNodes.TExtrusionNode.CrossSectionClosed", "text": " This happens when &quot;crossSection&quot; field is non-empty and it's first and last points are equal.    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#CrossSectionClosed"},
     {"title": "X3DNodes.TExtrusionNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#Proxy"},
     {"title": "X3DNodes.TExtrusionNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TExtrusionNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TExtrusionNode.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#BoundingBox"},
     {"title": "X3DNodes.TExtrusionNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#TrianglesCount"},
     {"title": "X3DNodes.TExtrusionNode.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TExtrusionNode.SetCrossSection", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SetCrossSection"},
     {"title": "X3DNodes.TExtrusionNode.SetCrossSection", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SetCrossSection"},
     {"title": "X3DNodes.TExtrusionNode.SetOrientation", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SetOrientation"},
     {"title": "X3DNodes.TExtrusionNode.SetOrientation", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SetOrientation"},
     {"title": "X3DNodes.TExtrusionNode.SetScale", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SetScale"},
     {"title": "X3DNodes.TExtrusionNode.SetScale", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SetScale"},
     {"title": "X3DNodes.TExtrusionNode.SetSpine", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SetSpine"},
     {"title": "X3DNodes.TExtrusionNode.SetSpine", "text": "    ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#SetSpine"},
     {"title": "X3DNodes.TExtrusionNode.EventSet_crossSection", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#EventSet_crossSection"},
     {"title": "X3DNodes.TExtrusionNode.EventSet_orientation", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#EventSet_orientation"},
     {"title": "X3DNodes.TExtrusionNode.EventSet_scale", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#EventSet_scale"},
     {"title": "X3DNodes.TExtrusionNode.EventSet_spine", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#EventSet_spine"},
     {"title": "X3DNodes.TExtrusionNode.FdBeginCap", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdBeginCap"},
     {"title": "X3DNodes.TExtrusionNode.FdCcw", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdCcw"},
     {"title": "X3DNodes.TExtrusionNode.FdConvex", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdConvex"},
     {"title": "X3DNodes.TExtrusionNode.FdCreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdCreaseAngle"},
     {"title": "X3DNodes.TExtrusionNode.FdCrossSection", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdCrossSection"},
     {"title": "X3DNodes.TExtrusionNode.FdEndCap", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdEndCap"},
     {"title": "X3DNodes.TExtrusionNode.FdOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdOrientation"},
     {"title": "X3DNodes.TExtrusionNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdScale"},
     {"title": "X3DNodes.TExtrusionNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdSolid"},
     {"title": "X3DNodes.TExtrusionNode.FdSpine", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdSpine"},
     {"title": "X3DNodes.TExtrusionNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#FdTexCoord"},
     {"title": "X3DNodes.TExtrusionNode.BeginCap", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#BeginCap"},
     {"title": "X3DNodes.TExtrusionNode.Ccw", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#Ccw"},
     {"title": "X3DNodes.TExtrusionNode.Convex", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#Convex"},
     {"title": "X3DNodes.TExtrusionNode.CreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#CreaseAngle"},
     {"title": "X3DNodes.TExtrusionNode.EndCap", "text": " ", "tags": "", "loc": "X3DNodes.TExtrusionNode.html#EndCap"},
     {"title": "X3DNodes.TIndexedFaceSetNode", "text": " This is probably the most universal, and most often used, geometry node in X3D. ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html"},
     {"title": "X3DNodes.TIndexedFaceSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#CreateNode"},
     {"title": "X3DNodes.TIndexedFaceSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TIndexedFaceSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#URNMatching"},
     {"title": "X3DNodes.TIndexedFaceSetNode.ConvexField", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#ConvexField"},
     {"title": "X3DNodes.TIndexedFaceSetNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TIndexedFaceSetNode.CoordIndexField", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#CoordIndexField"},
     {"title": "X3DNodes.TIndexedFaceSetNode.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TIndexedFaceSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TIndexedFaceSetNode.SetColorIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#SetColorIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.SetColorIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#SetColorIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.SetNormalIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#SetNormalIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.SetNormalIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#SetNormalIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.SetTexCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#SetTexCoordIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.SetTexCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#SetTexCoordIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.EventSet_colorIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#EventSet_colorIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.EventSet_coordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#EventSet_coordIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.EventSet_normalIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#EventSet_normalIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.EventSet_texCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#EventSet_texCoordIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.FdColorIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#FdColorIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.FdConvex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#FdConvex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.FdCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#FdCoordIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.FdCreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#FdCreaseAngle"},
     {"title": "X3DNodes.TIndexedFaceSetNode.FdNormalIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#FdNormalIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.FdTexCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#FdTexCoordIndex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.Convex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#Convex"},
     {"title": "X3DNodes.TIndexedFaceSetNode.CreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode.html#CreaseAngle"},
     {"title": "X3DNodes.TSphereNode", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode.html"},
     {"title": "X3DNodes.TSphereNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#CreateNode"},
     {"title": "X3DNodes.TSphereNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSphereNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#URNMatching"},
     {"title": "X3DNodes.TSphereNode.TexCoordField", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#TexCoordField"},
     {"title": "X3DNodes.TSphereNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#SolidField"},
     {"title": "X3DNodes.TSphereNode.CalculateSlices", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#CalculateSlices"},
     {"title": "X3DNodes.TSphereNode.CalculateStacks", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#CalculateStacks"},
     {"title": "X3DNodes.TSphereNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TSphereNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#Proxy"},
     {"title": "X3DNodes.TSphereNode.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#BoundingBox"},
     {"title": "X3DNodes.TSphereNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TSphereNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#TrianglesCount"},
     {"title": "X3DNodes.TSphereNode.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TSphereNode.FdRadius", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode.html#FdRadius"},
     {"title": "X3DNodes.TSphereNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode.html#FdSolid"},
     {"title": "X3DNodes.TSphereNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode.html#FdTexCoord"},
     {"title": "X3DNodes.TSphereNode.FdSlices", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode.html#FdSlices"},
     {"title": "X3DNodes.TSphereNode.FdStacks", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode.html#FdStacks"},
     {"title": "X3DNodes.TSphereNode.Radius", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode.html#Radius"},
     {"title": "X3DNodes.TSphereNode.Slices", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode.html#Slices"},
     {"title": "X3DNodes.TSphereNode.Stacks", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode.html#Stacks"},
     {"title": "X3DNodes.TArc2DNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TArc2DNode.html"},
     {"title": "X3DNodes.TArc2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#CreateNode"},
     {"title": "X3DNodes.TArc2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TArc2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#URNMatching"},
     {"title": "X3DNodes.TArc2DNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TArc2DNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#VerticesCount"},
     {"title": "X3DNodes.TArc2DNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#TrianglesCount"},
     {"title": "X3DNodes.TArc2DNode.FdEndAngle", "text": " ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#FdEndAngle"},
     {"title": "X3DNodes.TArc2DNode.FdRadius", "text": " ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#FdRadius"},
     {"title": "X3DNodes.TArc2DNode.FdStartAngle", "text": " ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#FdStartAngle"},
     {"title": "X3DNodes.TArc2DNode.EndAngle", "text": " ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#EndAngle"},
     {"title": "X3DNodes.TArc2DNode.Radius", "text": " ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#Radius"},
     {"title": "X3DNodes.TArc2DNode.StartAngle", "text": " ", "tags": "", "loc": "X3DNodes.TArc2DNode.html#StartAngle"},
     {"title": "X3DNodes.TArcClose2DNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html"},
     {"title": "X3DNodes.TArcClose2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#CreateNode"},
     {"title": "X3DNodes.TArcClose2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TArcClose2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#URNMatching"},
     {"title": "X3DNodes.TArcClose2DNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TArcClose2DNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#VerticesCount"},
     {"title": "X3DNodes.TArcClose2DNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#TrianglesCount"},
     {"title": "X3DNodes.TArcClose2DNode.FdClosureType", "text": " ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#FdClosureType"},
     {"title": "X3DNodes.TArcClose2DNode.FdEndAngle", "text": " ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#FdEndAngle"},
     {"title": "X3DNodes.TArcClose2DNode.FdRadius", "text": " ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#FdRadius"},
     {"title": "X3DNodes.TArcClose2DNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#FdSolid"},
     {"title": "X3DNodes.TArcClose2DNode.FdStartAngle", "text": " ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#FdStartAngle"},
     {"title": "X3DNodes.TArcClose2DNode.EndAngle", "text": " ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#EndAngle"},
     {"title": "X3DNodes.TArcClose2DNode.Radius", "text": " ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#Radius"},
     {"title": "X3DNodes.TArcClose2DNode.StartAngle", "text": " ", "tags": "", "loc": "X3DNodes.TArcClose2DNode.html#StartAngle"},
     {"title": "X3DNodes.TCircle2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html"},
     {"title": "X3DNodes.TCircle2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#CreateNode"},
     {"title": "X3DNodes.TCircle2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCircle2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#URNMatching"},
     {"title": "X3DNodes.TCircle2DNode.CalculateSlices", "text": "    ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#CalculateSlices"},
     {"title": "X3DNodes.TCircle2DNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#Proxy"},
     {"title": "X3DNodes.TCircle2DNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TCircle2DNode.FdRadius", "text": " ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#FdRadius"},
     {"title": "X3DNodes.TCircle2DNode.FdSlices", "text": " ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#FdSlices"},
     {"title": "X3DNodes.TCircle2DNode.Radius", "text": " ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#Radius"},
     {"title": "X3DNodes.TCircle2DNode.Slices", "text": " ", "tags": "", "loc": "X3DNodes.TCircle2DNode.html#Slices"},
     {"title": "X3DNodes.TDisk2DNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html"},
     {"title": "X3DNodes.TDisk2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#CreateNode"},
     {"title": "X3DNodes.TDisk2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TDisk2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#URNMatching"},
     {"title": "X3DNodes.TDisk2DNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TDisk2DNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#VerticesCount"},
     {"title": "X3DNodes.TDisk2DNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#TrianglesCount"},
     {"title": "X3DNodes.TDisk2DNode.FdInnerRadius", "text": " ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#FdInnerRadius"},
     {"title": "X3DNodes.TDisk2DNode.FdOuterRadius", "text": " ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#FdOuterRadius"},
     {"title": "X3DNodes.TDisk2DNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#FdSolid"},
     {"title": "X3DNodes.TDisk2DNode.InnerRadius", "text": " ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#InnerRadius"},
     {"title": "X3DNodes.TDisk2DNode.OuterRadius", "text": " ", "tags": "", "loc": "X3DNodes.TDisk2DNode.html#OuterRadius"},
     {"title": "X3DNodes.TPolyline2DNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html"},
     {"title": "X3DNodes.TPolyline2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html#CreateNode"},
     {"title": "X3DNodes.TPolyline2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPolyline2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html#URNMatching"},
     {"title": "X3DNodes.TPolyline2DNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TPolyline2DNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html#VerticesCount"},
     {"title": "X3DNodes.TPolyline2DNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html#TrianglesCount"},
     {"title": "X3DNodes.TPolyline2DNode.SetLineSegments", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html#SetLineSegments"},
     {"title": "X3DNodes.TPolyline2DNode.SetLineSegments", "text": "    ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html#SetLineSegments"},
     {"title": "X3DNodes.TPolyline2DNode.FdLineSegments", "text": " In VRML 97 it is called &quot;point&quot;, in X3D it is &quot;lineSegments&quot;. ", "tags": "", "loc": "X3DNodes.TPolyline2DNode.html#FdLineSegments"},
     {"title": "X3DNodes.TPolypoint2DNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html"},
     {"title": "X3DNodes.TPolypoint2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html#CreateNode"},
     {"title": "X3DNodes.TPolypoint2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPolypoint2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html#URNMatching"},
     {"title": "X3DNodes.TPolypoint2DNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TPolypoint2DNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html#VerticesCount"},
     {"title": "X3DNodes.TPolypoint2DNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html#TrianglesCount"},
     {"title": "X3DNodes.TPolypoint2DNode.SetPoint", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html#SetPoint"},
     {"title": "X3DNodes.TPolypoint2DNode.SetPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html#SetPoint"},
     {"title": "X3DNodes.TPolypoint2DNode.FdPoint", "text": " ", "tags": "", "loc": "X3DNodes.TPolypoint2DNode.html#FdPoint"},
     {"title": "X3DNodes.TRectangle2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TRectangle2DNode.html"},
     {"title": "X3DNodes.TRectangle2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TRectangle2DNode.html#CreateNode"},
     {"title": "X3DNodes.TRectangle2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TRectangle2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TRectangle2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TRectangle2DNode.html#URNMatching"},
     {"title": "X3DNodes.TRectangle2DNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TRectangle2DNode.html#Proxy"},
     {"title": "X3DNodes.TRectangle2DNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TRectangle2DNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TRectangle2DNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TRectangle2DNode.html#FdSize"},
     {"title": "X3DNodes.TRectangle2DNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TRectangle2DNode.html#FdSolid"},
     {"title": "X3DNodes.TRectangle2DNode.Size", "text": " ", "tags": "", "loc": "X3DNodes.TRectangle2DNode.html#Size"},
     {"title": "X3DNodes.TTriangleSet2DNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html"},
     {"title": "X3DNodes.TTriangleSet2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#CreateNode"},
     {"title": "X3DNodes.TTriangleSet2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTriangleSet2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#URNMatching"},
     {"title": "X3DNodes.TTriangleSet2DNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TTriangleSet2DNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#VerticesCount"},
     {"title": "X3DNodes.TTriangleSet2DNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#TrianglesCount"},
     {"title": "X3DNodes.TTriangleSet2DNode.SetVertices", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#SetVertices"},
     {"title": "X3DNodes.TTriangleSet2DNode.SetVertices", "text": "    ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#SetVertices"},
     {"title": "X3DNodes.TTriangleSet2DNode.FdVertices", "text": " ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#FdVertices"},
     {"title": "X3DNodes.TTriangleSet2DNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TTriangleSet2DNode.html#FdSolid"},
     {"title": "X3DNodes.TAbstractFontStyleNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractFontStyleNode.html"},
     {"title": "X3DNodes.TAbstractFontStyleNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractFontStyleNode.html#CreateNode"},
     {"title": "X3DNodes.TFontStyleNode", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html"},
     {"title": "X3DNodes.TFontStyleNode.DefaultSize", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#DefaultSize"},
     {"title": "X3DNodes.TFontStyleNode.DefaultSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#DefaultSpacing"},
     {"title": "X3DNodes.TFontStyleNode.DefaultFamily", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#DefaultFamily"},
     {"title": "X3DNodes.TFontStyleNode.DefaultBold", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#DefaultBold"},
     {"title": "X3DNodes.TFontStyleNode.DefaultItalic", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#DefaultItalic"},
     {"title": "X3DNodes.TFontStyleNode.DefaultJustify", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#DefaultJustify"},
     {"title": "X3DNodes.TFontStyleNode.DefaultJustifyMinor", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#DefaultJustifyMinor"},
     {"title": "X3DNodes.TFontStyleNode.DefaultBlending", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#DefaultBlending"},
     {"title": "X3DNodes.TFontStyleNode.OnFont", "text": " Assign here a callback which can modify a font. You can look at any font style properties to decide how to adjust the font, like <a class=\"normal\" href=\"X3DNodes.TFontStyleNode.html#Bold\">Bold</a>, <a class=\"normal\" href=\"X3DNodes.TFontStyleNode.html#Italic\">Italic</a>, <a class=\"normal\" href=\"X3DNodes.TFontStyleNode.html#Family\">Family</a>.  <p>You can always decide to leave the given &quot;Font&quot; instance at the default value, or to modify it.  <p>The font instance set here is a <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html\">TTextureFontData</a> instance. You can load it from a TTF file by <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html#Create\">TTextureFontData.Create</a>, or you can assign here a <a class=\"normal\" href=\"CastleTextureFontData.TTextureFontData.html\">TTextureFontData</a> instance defined by a unit generated by texture-font-to-pascal. See <a  href=\"http://castle-engine.sourceforge.net/tutorial_text.php\">http://castle-engine.sourceforge.net/tutorial_text.php</a> about using texture-font-to-pascal. In the first case, remember that it is your resposibility to free this font later, but only after all possible Text nodes using this font are destroyed. ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#OnFont"},
     {"title": "X3DNodes.TFontStyleNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#CreateNode"},
     {"title": "X3DNodes.TFontStyleNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#ClassX3DType"},
     {"title": "X3DNodes.TFontStyleNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#URNMatching"},
     {"title": "X3DNodes.TFontStyleNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TFontStyleNode.FdFamily", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdFamily"},
     {"title": "X3DNodes.TFontStyleNode.Family", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#Family"},
     {"title": "X3DNodes.TFontStyleNode.FdHorizontal", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdHorizontal"},
     {"title": "X3DNodes.TFontStyleNode.FdJustify", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdJustify"},
     {"title": "X3DNodes.TFontStyleNode.Justify", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#Justify"},
     {"title": "X3DNodes.TFontStyleNode.JustifyMinor", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#JustifyMinor"},
     {"title": "X3DNodes.TFontStyleNode.FdLanguage", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdLanguage"},
     {"title": "X3DNodes.TFontStyleNode.FdLeftToRight", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdLeftToRight"},
     {"title": "X3DNodes.TFontStyleNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdSize"},
     {"title": "X3DNodes.TFontStyleNode.FdSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdSpacing"},
     {"title": "X3DNodes.TFontStyleNode.FdStyle", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdStyle"},
     {"title": "X3DNodes.TFontStyleNode.Bold", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#Bold"},
     {"title": "X3DNodes.TFontStyleNode.Italic", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#Italic"},
     {"title": "X3DNodes.TFontStyleNode.FdTopToBottom", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdTopToBottom"},
     {"title": "X3DNodes.TFontStyleNode.FdBlending", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#FdBlending"},
     {"title": "X3DNodes.TFontStyleNode.Blending", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#Blending"},
     {"title": "X3DNodes.TFontStyleNode.Horizontal", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#Horizontal"},
     {"title": "X3DNodes.TFontStyleNode.Language", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#Language"},
     {"title": "X3DNodes.TFontStyleNode.LeftToRight", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#LeftToRight"},
     {"title": "X3DNodes.TFontStyleNode.Size", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#Size"},
     {"title": "X3DNodes.TFontStyleNode.Spacing", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#Spacing"},
     {"title": "X3DNodes.TFontStyleNode.TopToBottom", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#TopToBottom"},
     {"title": "X3DNodes.TFontStyleNode.TFontEvent", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode.html#TFontEvent"},
     {"title": "X3DNodes.TTextNode", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html"},
     {"title": "X3DNodes.TTextNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#CreateNode"},
     {"title": "X3DNodes.TTextNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#Destroy"},
     {"title": "X3DNodes.TTextNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTextNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#URNMatching"},
     {"title": "X3DNodes.TTextNode.TexCoordField", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#TexCoordField"},
     {"title": "X3DNodes.TTextNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#Proxy"},
     {"title": "X3DNodes.TTextNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TTextNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TTextNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#SolidField"},
     {"title": "X3DNodes.TTextNode.FontTextureNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#FontTextureNode"},
     {"title": "X3DNodes.TTextNode.FontChanged", "text": " For now, we don't detect font changes (when <a class=\"normal\" href=\"X3DNodes.TFontStyleNode.html#OnFont\">TFontStyleNode.OnFont</a> returns something different) outselves.    ", "tags": "", "loc": "X3DNodes.TTextNode.html#FontChanged"},
     {"title": "X3DNodes.TTextNode.SetLength", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#SetLength"},
     {"title": "X3DNodes.TTextNode.SetLength", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#SetLength"},
     {"title": "X3DNodes.TTextNode.SetString", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#SetString"},
     {"title": "X3DNodes.TTextNode.SetString", "text": "    ", "tags": "", "loc": "X3DNodes.TTextNode.html#SetString"},
     {"title": "X3DNodes.TTextNode.FdFontStyle", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#FdFontStyle"},
     {"title": "X3DNodes.TTextNode.FdLength", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#FdLength"},
     {"title": "X3DNodes.TTextNode.FdMaxExtent", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#FdMaxExtent"},
     {"title": "X3DNodes.TTextNode.FdString", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#FdString"},
     {"title": "X3DNodes.TTextNode.EventLineBounds", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#EventLineBounds"},
     {"title": "X3DNodes.TTextNode.EventOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#EventOrigin"},
     {"title": "X3DNodes.TTextNode.EventTextBounds", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#EventTextBounds"},
     {"title": "X3DNodes.TTextNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#FdSolid"},
     {"title": "X3DNodes.TTextNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#FdTexCoord"},
     {"title": "X3DNodes.TTextNode.FontStyle", "text": " Returns <code>Nil</code> if not assigned, or if the underlying X3D field has invalid node type assigned. ", "tags": "", "loc": "X3DNodes.TTextNode.html#FontStyle"},
     {"title": "X3DNodes.TTextNode.MaxExtent", "text": " ", "tags": "", "loc": "X3DNodes.TTextNode.html#MaxExtent"},
     {"title": "X3DNodes.TAbstractSoundNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSoundNode.html"},
     {"title": "X3DNodes.TAbstractSoundNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSoundNode.html#CreateNode"},
     {"title": "X3DNodes.IAbstractSoundSourceNode", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractSoundSourceNode.html"},
     {"title": "X3DNodes.IAbstractSoundSourceNode.FdDescription", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractSoundSourceNode.html#FdDescription"},
     {"title": "X3DNodes.IAbstractSoundSourceNode.FdPitch", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractSoundSourceNode.html#FdPitch"},
     {"title": "X3DNodes.IAbstractSoundSourceNode.EventDuration_changed", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractSoundSourceNode.html#EventDuration_changed"},
     {"title": "X3DNodes.TAbstractSoundSourceNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSoundSourceNode.html"},
     {"title": "X3DNodes.TAbstractSoundSourceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSoundSourceNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractSoundSourceNode.SafePitch", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSoundSourceNode.html#SafePitch"},
     {"title": "X3DNodes.TAbstractSoundSourceNode.FdDescription", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSoundSourceNode.html#FdDescription"},
     {"title": "X3DNodes.TAbstractSoundSourceNode.FdPitch", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSoundSourceNode.html#FdPitch"},
     {"title": "X3DNodes.TAbstractSoundSourceNode.EventDuration_changed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSoundSourceNode.html#EventDuration_changed"},
     {"title": "X3DNodes.TAbstractSoundSourceNode.Description", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSoundSourceNode.html#Description"},
     {"title": "X3DNodes.TAbstractSoundSourceNode.Pitch", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSoundSourceNode.html#Pitch"},
     {"title": "X3DNodes.TAudioClipNode", "text": " ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html"},
     {"title": "X3DNodes.TAudioClipNode.ParseAfter", "text": "    ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#ParseAfter"},
     {"title": "X3DNodes.TAudioClipNode.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#BeforeTraverse"},
     {"title": "X3DNodes.TAudioClipNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#CreateNode"},
     {"title": "X3DNodes.TAudioClipNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#Destroy"},
     {"title": "X3DNodes.TAudioClipNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#ClassX3DType"},
     {"title": "X3DNodes.TAudioClipNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#URNMatching"},
     {"title": "X3DNodes.TAudioClipNode.GetCycleInterval", "text": "    ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#GetCycleInterval"},
     {"title": "X3DNodes.TAudioClipNode.SetUrl", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#SetUrl"},
     {"title": "X3DNodes.TAudioClipNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#SetUrl"},
     {"title": "X3DNodes.TAudioClipNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TAudioClipNode.html#FdUrl"},
     {"title": "X3DNodes.TSoundNode", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html"},
     {"title": "X3DNodes.TSoundNode.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TSoundNode.html#BeforeTraverse"},
     {"title": "X3DNodes.TSoundNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TSoundNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TSoundNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSoundNode.html#CreateNode"},
     {"title": "X3DNodes.TSoundNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSoundNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSoundNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSoundNode.html#URNMatching"},
     {"title": "X3DNodes.TSoundNode.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdDirection"},
     {"title": "X3DNodes.TSoundNode.FdIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdIntensity"},
     {"title": "X3DNodes.TSoundNode.FdLocation", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdLocation"},
     {"title": "X3DNodes.TSoundNode.FdMaxBack", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdMaxBack"},
     {"title": "X3DNodes.TSoundNode.FdMaxFront", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdMaxFront"},
     {"title": "X3DNodes.TSoundNode.FdMinBack", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdMinBack"},
     {"title": "X3DNodes.TSoundNode.FdMinFront", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdMinFront"},
     {"title": "X3DNodes.TSoundNode.FdPriority", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdPriority"},
     {"title": "X3DNodes.TSoundNode.FdSource", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdSource"},
     {"title": "X3DNodes.TSoundNode.FdSpatialize", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#FdSpatialize"},
     {"title": "X3DNodes.TSoundNode.Direction", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#Direction"},
     {"title": "X3DNodes.TSoundNode.Intensity", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#Intensity"},
     {"title": "X3DNodes.TSoundNode.Location", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#Location"},
     {"title": "X3DNodes.TSoundNode.MaxBack", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#MaxBack"},
     {"title": "X3DNodes.TSoundNode.MaxFront", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#MaxFront"},
     {"title": "X3DNodes.TSoundNode.MinBack", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#MinBack"},
     {"title": "X3DNodes.TSoundNode.MinFront", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#MinFront"},
     {"title": "X3DNodes.TSoundNode.Priority", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#Priority"},
     {"title": "X3DNodes.TSoundNode.Source", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#Source"},
     {"title": "X3DNodes.TSoundNode.Spatialize", "text": " ", "tags": "", "loc": "X3DNodes.TSoundNode.html#Spatialize"},
     {"title": "X3DNodes.TAbstractLightNode", "text": "  <p>Note that even the old VRML 1.0 light nodes inherit from this. Although they interpret some bits differently (&quot;<a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#AmbientIntensity\">ambientIntensity</a>&quot; &lt; 0 has special meaning). But most of the fields behave identically, they only have different default values. ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html"},
     {"title": "X3DNodes.TAbstractLightNode.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#BeforeTraverse"},
     {"title": "X3DNodes.TAbstractLightNode.MiddleTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#MiddleTraverse"},
     {"title": "X3DNodes.TAbstractLightNode.GetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#GetProjectionLocationLocal"},
     {"title": "X3DNodes.TAbstractLightNode.SetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#SetProjectionLocationLocal"},
     {"title": "X3DNodes.TAbstractLightNode.GetProjectionDirectionLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#GetProjectionDirectionLocal"},
     {"title": "X3DNodes.TAbstractLightNode.SetProjectionDirectionLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#SetProjectionDirectionLocal"},
     {"title": "X3DNodes.TAbstractLightNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractLightNode.ProjectionMatrix", "text": " Identity in this class, override for subclasses able to do shadow mapping.     ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ProjectionMatrix"},
     {"title": "X3DNodes.TAbstractLightNode.ModelviewMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ModelviewMatrix"},
     {"title": "X3DNodes.TAbstractLightNode.ModelviewRotationMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ModelviewRotationMatrix"},
     {"title": "X3DNodes.TAbstractLightNode.GetProjectorMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#GetProjectorMatrix"},
     {"title": "X3DNodes.TAbstractLightNode.GetView", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#GetView"},
     {"title": "X3DNodes.TAbstractLightNode.Box3DDistances", "text": " This is intended to capture the depth distances where the box resides, useful for calculating e.g. depth ranges to capture in the shadow maps. Depending on light source type, various distance measures may be used, appropriate to light sources projection.  <p>Always MinDistance &lt;= MaxDistance. They may be negative when we measure along the light's direction.  <p>    EBox3DEmpty When used with an empty box.", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#Box3DDistances"},
     {"title": "X3DNodes.TAbstractLightNode.CreateLightInstance", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#CreateLightInstance"},
     {"title": "X3DNodes.TAbstractLightNode.UpdateLightInstanceState", "text": " Assumes that LightInstance.Node = Self.  <p>This will set LightInstance.Transform properties, and recalculate all LightInstance properties based on Transform.    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#UpdateLightInstanceState"},
     {"title": "X3DNodes.TAbstractLightNode.UpdateLightInstance", "text": " Assumes that LightInstance.Node = Self.    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#UpdateLightInstance"},
     {"title": "X3DNodes.TAbstractLightNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#TransformationChange"},
     {"title": "X3DNodes.TAbstractLightNode.Scope", "text": " Default implementation returns <a class=\"normal\" href=\"X3DNodes.html#lsGlobal\">lsGlobal</a> or <a class=\"normal\" href=\"X3DNodes.html#lsLocal\">lsLocal</a>, depending on &quot;<a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#Global\">global</a>&quot; field value (this follows VRML/X3D &gt;= 2.0 rules).    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#Scope"},
     {"title": "X3DNodes.TAbstractLightNode.PositionAndDirection", "text": " For positional lights, the last component is always 1. For directional lights, the last component is always 0.  <p>Note that this is expressed in the local light node coordinate system.    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#PositionAndDirection"},
     {"title": "X3DNodes.TAbstractLightNode.SetEffects", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#SetEffects"},
     {"title": "X3DNodes.TAbstractLightNode.FdOn", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdOn"},
     {"title": "X3DNodes.TAbstractLightNode.FdIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdIntensity"},
     {"title": "X3DNodes.TAbstractLightNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdColor"},
     {"title": "X3DNodes.TAbstractLightNode.FdAmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdAmbientIntensity"},
     {"title": "X3DNodes.TAbstractLightNode.FdGlobal", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdGlobal"},
     {"title": "X3DNodes.TAbstractLightNode.FdShadowVolumes", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdShadowVolumes"},
     {"title": "X3DNodes.TAbstractLightNode.FdShadowVolumesMain", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdShadowVolumesMain"},
     {"title": "X3DNodes.TAbstractLightNode.FdShowProxyGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdShowProxyGeometry"},
     {"title": "X3DNodes.TAbstractLightNode.FdProjectionNear", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdProjectionNear"},
     {"title": "X3DNodes.TAbstractLightNode.FdProjectionFar", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdProjectionFar"},
     {"title": "X3DNodes.TAbstractLightNode.FdUp", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdUp"},
     {"title": "X3DNodes.TAbstractLightNode.FdDefaultShadowMap", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdDefaultShadowMap"},
     {"title": "X3DNodes.TAbstractLightNode.FdShadows", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdShadows"},
     {"title": "X3DNodes.TAbstractLightNode.FdEffects", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#FdEffects"},
     {"title": "X3DNodes.TAbstractLightNode.Transform", "text": " Beware: In X3D, light nodes can be instantiated many times within the scene, with different transformations, so <i>this transformation property should not be used in general</i>.  <p>Use this only if you you know that light node occurs only once within the scene (see [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadow_maps\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_shadow_maps</a>]). Or if you're fine with just getting an undefined transformation, for any of the light instances.  <p>This value is calculated during traversing. Last <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#BeforeTraverse\">BeforeTraverse</a> call for this node sets this property. By default, it represents identity transformation.  <p> ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#Transform"},
     {"title": "X3DNodes.TAbstractLightNode.InvertedTransform", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#InvertedTransform"},
     {"title": "X3DNodes.TAbstractLightNode.ProjectionLocationLocal", "text": " Useful when you think of lights as cameras (for shadow maps).  <p><a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#ProjectionDirectionLocal\">ProjectionDirectionLocal</a> will always be exactly zero for a PointLight (that doesn't have a direction).  <p>The <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#GetView\">GetView</a> returns vectors in <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#Global\">global</a> (scene) space. It guarantees that Direction, Side and Up are normalized and orthogonal to each other.  <p> ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ProjectionLocationLocal"},
     {"title": "X3DNodes.TAbstractLightNode.ProjectionDirectionLocal", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ProjectionDirectionLocal"},
     {"title": "X3DNodes.TAbstractLightNode.ProjectionSceneLocation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ProjectionSceneLocation"},
     {"title": "X3DNodes.TAbstractLightNode.ProjectionSceneDirection", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ProjectionSceneDirection"},
     {"title": "X3DNodes.TAbstractLightNode.AmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#AmbientIntensity"},
     {"title": "X3DNodes.TAbstractLightNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#Color"},
     {"title": "X3DNodes.TAbstractLightNode.Global", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#Global"},
     {"title": "X3DNodes.TAbstractLightNode.Intensity", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#Intensity"},
     {"title": "X3DNodes.TAbstractLightNode.IsOn", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#IsOn"},
     {"title": "X3DNodes.TAbstractLightNode.Shadows", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#Shadows"},
     {"title": "X3DNodes.TAbstractLightNode.ShadowVolumes", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ShadowVolumes"},
     {"title": "X3DNodes.TAbstractLightNode.ShadowVolumesMain", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ShadowVolumesMain"},
     {"title": "X3DNodes.TAbstractLightNode.ProjectionNear", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ProjectionNear"},
     {"title": "X3DNodes.TAbstractLightNode.ProjectionFar", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#ProjectionFar"},
     {"title": "X3DNodes.TAbstractLightNode.Up", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#Up"},
     {"title": "X3DNodes.TAbstractLightNode.DefaultShadowMap", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLightNode.html#DefaultShadowMap"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.GetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#GetProjectionLocationLocal"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.SetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#SetProjectionLocationLocal"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.GetProjectionDirectionLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#GetProjectionDirectionLocal"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.SetProjectionDirectionLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#SetProjectionDirectionLocal"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#ClassX3DType"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.UpdateLightInstance", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#UpdateLightInstance"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.ProjectionMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#ProjectionMatrix"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.ModelviewMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#ModelviewMatrix"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.ModelviewRotationMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#ModelviewRotationMatrix"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.Box3DDistances", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#Box3DDistances"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.PositionAndDirection", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#PositionAndDirection"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#FdDirection"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.Direction", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#Direction"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.FdProjectionRectangle", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#FdProjectionRectangle"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.ProjectionRectangle", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#ProjectionRectangle"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.FdProjectionLocation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#FdProjectionLocation"},
     {"title": "X3DNodes.TAbstractDirectionalLightNode.ProjectionLocation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDirectionalLightNode.html#ProjectionLocation"},
     {"title": "X3DNodes.TAbstractPositionalLightNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.DistanceNeededForAttenuation", "text": " This follows the equation <code>1/max( attenuation[0] + ... )</code> from the VRML/X3D specification, it is the same as OpenGL attenuation.  <p>Since calculating the DistanceToLight for the <a class=\"normal\" href=\"X3DNodes.TAbstractPositionalLightNode.html#Attenuation\">Attenuation</a> method may be time-consuming in some situations, you can check <code>DistanceNeededForAttenuation</code> first. When the <code>DistanceNeededForAttenuation</code> returns <code>False</code>, then the value of DistanceToLight parameter is ignored (you can pass anything).  <p>The DistanceToLight should be a distance in the light source local coordinate system. TODO: although our renderers currently ignore this: ray-tracer uses <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#Global\">global</a> coord system, OpenGL (fixed-function and shader) renderer uses eye coord system (should be equal to <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#Global\">global</a> coord system for normal cameras).  <p>    ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#DistanceNeededForAttenuation"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.CalculateAttenuation", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#CalculateAttenuation"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.HasAttenuation", "text": " When <code>False</code>, you know that <a class=\"normal\" href=\"X3DNodes.TAbstractPositionalLightNode.html#Attenuation\">Attenuation</a> function always returns 1, so there's no point in using it at all.    ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#HasAttenuation"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.HasRadius", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#HasRadius"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.UpdateLightInstance", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#UpdateLightInstance"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.PositionAndDirection", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#PositionAndDirection"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.FdAttenuation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#FdAttenuation"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.Attenuation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#Attenuation"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.FdLocation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#FdLocation"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.Location", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#Location"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.SceneLocation", "text": " <i>Do not use this if the light node may be instantiated multiple times in the scene.</i> The same warning as for <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html#Transform\">Transform</a> applies also here. ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#SceneLocation"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.FdRadius", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#FdRadius"},
     {"title": "X3DNodes.TAbstractPositionalLightNode.Radius", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPositionalLightNode.html#Radius"},
     {"title": "X3DNodes.TAbstractPointLightNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPointLightNode.html"},
     {"title": "X3DNodes.TAbstractPointLightNode.GetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPointLightNode.html#GetProjectionLocationLocal"},
     {"title": "X3DNodes.TAbstractPointLightNode.SetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPointLightNode.html#SetProjectionLocationLocal"},
     {"title": "X3DNodes.TAbstractPointLightNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPointLightNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractPointLightNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPointLightNode.html#ClassX3DType"},
     {"title": "X3DNodes.TAbstractPointLightNode.Box3DDistances", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPointLightNode.html#Box3DDistances"},
     {"title": "X3DNodes.TDirectionalLightNode", "text": " ", "tags": "", "loc": "X3DNodes.TDirectionalLightNode.html"},
     {"title": "X3DNodes.TDirectionalLightNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TDirectionalLightNode.html#CreateNode"},
     {"title": "X3DNodes.TDirectionalLightNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TDirectionalLightNode.html#URNMatching"},
     {"title": "X3DNodes.TDirectionalLightNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TDirectionalLightNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TPointLightNode", "text": " ", "tags": "", "loc": "X3DNodes.TPointLightNode.html"},
     {"title": "X3DNodes.TPointLightNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPointLightNode.html#CreateNode"},
     {"title": "X3DNodes.TPointLightNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPointLightNode.html#URNMatching"},
     {"title": "X3DNodes.TPointLightNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TPointLightNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TSpotLightNode", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html"},
     {"title": "X3DNodes.TSpotLightNode.GetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#GetProjectionLocationLocal"},
     {"title": "X3DNodes.TSpotLightNode.SetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#SetProjectionLocationLocal"},
     {"title": "X3DNodes.TSpotLightNode.GetProjectionDirectionLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#GetProjectionDirectionLocal"},
     {"title": "X3DNodes.TSpotLightNode.SetProjectionDirectionLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#SetProjectionDirectionLocal"},
     {"title": "X3DNodes.TSpotLightNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#CreateNode"},
     {"title": "X3DNodes.TSpotLightNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSpotLightNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#URNMatching"},
     {"title": "X3DNodes.TSpotLightNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TSpotLightNode.UpdateLightInstance", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#UpdateLightInstance"},
     {"title": "X3DNodes.TSpotLightNode.ProjectionMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#ProjectionMatrix"},
     {"title": "X3DNodes.TSpotLightNode.ModelviewMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#ModelviewMatrix"},
     {"title": "X3DNodes.TSpotLightNode.ModelviewRotationMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#ModelviewRotationMatrix"},
     {"title": "X3DNodes.TSpotLightNode.Box3DDistances", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#Box3DDistances"},
     {"title": "X3DNodes.TSpotLightNode.SpotCutoffDeg", "text": "  <p>Expressed in degrees, clamped to correct range (since user can input any value in VRML, and also conversion radians -&gt; degrees could accidentally raise value slightly &gt; 90, so <a class=\"normal\" href=\"X3DNodes.TSpotLightNode.html#CutOffAngle\">cutOffAngle</a> = 1.5708 is in degrees 90.0002104591, which would cause OpenGL fixed-function error).    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#SpotCutoffDeg"},
     {"title": "X3DNodes.TSpotLightNode.SpotCosCutoff", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#SpotCosCutoff"},
     {"title": "X3DNodes.TSpotLightNode.SpotExponentApproximate", "text": " Do not use this, unless you really have to. X3D spot light should have a linear fallback, from <a class=\"normal\" href=\"X3DNodes.TSpotLightNode.html#BeamWidth\">beamWidth</a> to <a class=\"normal\" href=\"X3DNodes.TSpotLightNode.html#CutOffAngle\">cutOffAngle</a>, and there is no sensible way to approximate it by an exponent. Use this only if you have to render spot light with exponent, e.g. for OpenGL fixed-function pipeline.    ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#SpotExponentApproximate"},
     {"title": "X3DNodes.TSpotLightNode.FdBeamWidth", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#FdBeamWidth"},
     {"title": "X3DNodes.TSpotLightNode.FdCutOffAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#FdCutOffAngle"},
     {"title": "X3DNodes.TSpotLightNode.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#FdDirection"},
     {"title": "X3DNodes.TSpotLightNode.FdProjectionAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#FdProjectionAngle"},
     {"title": "X3DNodes.TSpotLightNode.Attenuation", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#Attenuation"},
     {"title": "X3DNodes.TSpotLightNode.BeamWidth", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#BeamWidth"},
     {"title": "X3DNodes.TSpotLightNode.CutOffAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#CutOffAngle"},
     {"title": "X3DNodes.TSpotLightNode.Direction", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#Direction"},
     {"title": "X3DNodes.TSpotLightNode.Location", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#Location"},
     {"title": "X3DNodes.TSpotLightNode.Radius", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#Radius"},
     {"title": "X3DNodes.TSpotLightNode.ProjectionAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode.html#ProjectionAngle"},
     {"title": "X3DNodes.TAbstractTextureCoordinateNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTextureCoordinateNode.html"},
     {"title": "X3DNodes.TAbstractTextureCoordinateNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTextureCoordinateNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractTextureNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html"},
     {"title": "X3DNodes.TAbstractTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractTextureNode.TextureDescription", "text": " &quot;none&quot; if it's not defined at all.  <p>Calling this <i>may not</i> cause automatically loading the texture data (for exampe, from file in case of <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html\">TAbstractTexture2DNode</a>). So it cannot describe the actually loaded data.  <p>In this class, simply returns <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#X3DType\">X3DType</a>. Override to say something more descriptive.    ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html#TextureDescription"},
     {"title": "X3DNodes.TAbstractTextureNode.AlphaChannelFinal", "text": " Looks at loaded texture data, and at alphaChannel field (see <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_alpha_channel_detection\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_alpha_channel_detection</a> )    ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html#AlphaChannelFinal"},
     {"title": "X3DNodes.TAbstractTextureNode.SetEffects", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html#SetEffects"},
     {"title": "X3DNodes.TAbstractTextureNode.FdEffects", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html#FdEffects"},
     {"title": "X3DNodes.TAbstractTextureNode.FdCrossOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html#FdCrossOrigin"},
     {"title": "X3DNodes.TAbstractTextureNode.FdAlphaChannel", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html#FdAlphaChannel"},
     {"title": "X3DNodes.TAbstractTextureNode.AlphaChannelField", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html#AlphaChannelField"},
     {"title": "X3DNodes.TAbstractTextureNode.CrossOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTextureNode.html#CrossOrigin"},
     {"title": "X3DNodes.TAbstractTexture2DNode", "text": "  <p>For X3D, this descends from X3DTextureNode and is an ancestor for X3DTexture2DNode, so X3D hierarchy is nicely preserved. ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html"},
     {"title": "X3DNodes.TAbstractTexture2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractTexture2DNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#Destroy"},
     {"title": "X3DNodes.TAbstractTexture2DNode.TextureImage", "text": " <code>TextureImage</code> may come from inline VRML texture or could be loaded from file (including from some URL), this doesn't concern you here.  <p>Calls to <code>TextureImage</code>, <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureVideo\">TextureVideo</a>, <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#IsTextureImage\">IsTextureImage</a>, <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#IsTextureVideo\">IsTextureVideo</a>, <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureComposite\">TextureComposite</a> will automatically load the data, so in simple situations you really don't need to do anything. Just check and use them when you want, and things will just work. See <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#IsTextureLoaded\">IsTextureLoaded</a> for more control about loading / unloading.  <p>Note that either one of <code>TextureImage</code> or <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureVideo\">TextureVideo</a> may be <code>Nil</code>, if the other one is loaded. Or when loading failed (warning will be reported by <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>). <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#IsTextureImage\">IsTextureImage</a> checks that <code>TextureImage</code> is non-nil (so it's successfully loaded) and additionally that texture size is not zero. Similar for <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#IsTextureVideo\">IsTextureVideo</a>.  <p><code>TextureImage</code> may have any class allowed by <a class=\"normal\" href=\"CastleTextureImages.html#LoadTextureImage\">LoadTextureImage</a>.  <p>    ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#TextureImage"},
     {"title": "X3DNodes.TAbstractTexture2DNode.IsTextureImage", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#IsTextureImage"},
     {"title": "X3DNodes.TAbstractTexture2DNode.TextureComposite", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#TextureComposite"},
     {"title": "X3DNodes.TAbstractTexture2DNode.TextureVideo", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#TextureVideo"},
     {"title": "X3DNodes.TAbstractTexture2DNode.IsTextureVideo", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#IsTextureVideo"},
     {"title": "X3DNodes.TAbstractTexture2DNode.IsTextureLoaded", "text": " Since the texture will be loaded automatically, you're usually not interested in this property. You can read it to e.g. predict if next <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureImage\">TextureImage</a> / <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureVideo\">TextureVideo</a> call may take a long time. (You know that if <code>IsTextureLoaded</code> = <code>True</code> then <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureImage\">TextureImage</a> just returns ready image instantly).  <p>You can also set <code>IsTextureLoaded</code>. Setting to <code>True</code> means that you request the texture to be loaded <i>now</i>, if it's not loaded already. Setting to <code>False</code> may be useful if you want to release resources (e.g. when you want to keep TTextureNode instance loaded but you know that you will not need <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureImage\">TextureImage</a> / <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureComposite\">TextureComposite</a> / <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureVideo\">TextureVideo</a> anymore). You can also set it to <code>False</code> and then back to <code>True</code> if you want to request reloading the texture from URL (e.g. if you suspect that the URL contents changed).  <p>Note that <code>IsTextureLoaded</code> is set to <code>True</code>, even if actual loading failed. You still have to check afterwards <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#IsTextureImage\">IsTextureImage</a> and <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#IsTextureVideo\">IsTextureVideo</a> to know if loading was actually successful. This is deliberate &mdash; it means that each call to <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureImage\">TextureImage</a> etc. will not unnecessarily read the disk (or even connect to internet) when the file does not exist. Also, the loading errors reported by <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> will not be repeated &mdash; they will occur only once, when <code>IsTextureLoaded</code> changes from <code>False</code> to <code>True</code>. ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#IsTextureLoaded"},
     {"title": "X3DNodes.TAbstractTexture2DNode.RepeatS", "text": " Getting or setting this is the most comfortable way to change underlying node fields, setting this automatically does all necessary (sends events etc., see TVRMLField.Send).  ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#RepeatS"},
     {"title": "X3DNodes.TAbstractTexture2DNode.RepeatT", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#RepeatT"},
     {"title": "X3DNodes.TAbstractTexture2DNode.TextureUsedFullUrl", "text": " &quot;No URL was used&quot; may mean that no URL was valid, or inlined image was used.  <p>This is always a full, expanded (i.e. not relative) URL.  <p>In case of data: URLs, this doesn't contain actual data (it would be too long then, and <code>TextureUsedFullUrl</code> is mainly for showing to the user), it's cutted. ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#TextureUsedFullUrl"},
     {"title": "X3DNodes.TAbstractTexture2DNode.FdTextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#FdTextureProperties"},
     {"title": "X3DNodes.TAbstractTexture2DNode.TextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture2DNode.html#TextureProperties"},
     {"title": "X3DNodes.TAbstractX3DTexture2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DTexture2DNode.html"},
     {"title": "X3DNodes.TAbstractX3DTexture2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractX3DTexture2DNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractX3DTexture2DNode.FdRepeatS", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DTexture2DNode.html#FdRepeatS"},
     {"title": "X3DNodes.TAbstractX3DTexture2DNode.FdRepeatT", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DTexture2DNode.html#FdRepeatT"},
     {"title": "X3DNodes.TAbstractTextureTransformNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTextureTransformNode.html"},
     {"title": "X3DNodes.TAbstractTextureTransformNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTextureTransformNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractTextureTransformNode.TransformMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTextureTransformNode.html#TransformMatrix"},
     {"title": "X3DNodes.TImageTextureNode", "text": " ", "tags": "", "loc": "X3DNodes.TImageTextureNode.html"},
     {"title": "X3DNodes.TImageTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TImageTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TImageTextureNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TImageTextureNode.html#ClassX3DType"},
     {"title": "X3DNodes.TImageTextureNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TImageTextureNode.html#URNMatching"},
     {"title": "X3DNodes.TImageTextureNode.TextureDescription", "text": "    ", "tags": "", "loc": "X3DNodes.TImageTextureNode.html#TextureDescription"},
     {"title": "X3DNodes.TImageTextureNode.SetUrl", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TImageTextureNode.html#SetUrl"},
     {"title": "X3DNodes.TImageTextureNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TImageTextureNode.html#SetUrl"},
     {"title": "X3DNodes.TImageTextureNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TImageTextureNode.html#FdUrl"},
     {"title": "X3DNodes.TMovieTextureNode", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html"},
     {"title": "X3DNodes.TMovieTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TMovieTextureNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#Destroy"},
     {"title": "X3DNodes.TMovieTextureNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMovieTextureNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#URNMatching"},
     {"title": "X3DNodes.TMovieTextureNode.TextureDescription", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#TextureDescription"},
     {"title": "X3DNodes.TMovieTextureNode.IsActive", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#IsActive"},
     {"title": "X3DNodes.TMovieTextureNode.IsPaused", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#IsPaused"},
     {"title": "X3DNodes.TMovieTextureNode.ElapsedTime", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#ElapsedTime"},
     {"title": "X3DNodes.TMovieTextureNode.ElapsedTimeInCycle", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#ElapsedTimeInCycle"},
     {"title": "X3DNodes.TMovieTextureNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#SetUrl"},
     {"title": "X3DNodes.TMovieTextureNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#SetUrl"},
     {"title": "X3DNodes.TMovieTextureNode.FdDescription", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#FdDescription"},
     {"title": "X3DNodes.TMovieTextureNode.FdLoop", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#FdLoop"},
     {"title": "X3DNodes.TMovieTextureNode.FdPauseTime", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#FdPauseTime"},
     {"title": "X3DNodes.TMovieTextureNode.FdResumeTime", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#FdResumeTime"},
     {"title": "X3DNodes.TMovieTextureNode.FdSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#FdSpeed"},
     {"title": "X3DNodes.TMovieTextureNode.FdStartTime", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#FdStartTime"},
     {"title": "X3DNodes.TMovieTextureNode.FdStopTime", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#FdStopTime"},
     {"title": "X3DNodes.TMovieTextureNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#FdUrl"},
     {"title": "X3DNodes.TMovieTextureNode.EventDuration_changed", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#EventDuration_changed"},
     {"title": "X3DNodes.TMovieTextureNode.EventElapsedTime", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#EventElapsedTime"},
     {"title": "X3DNodes.TMovieTextureNode.EventIsActive", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#EventIsActive"},
     {"title": "X3DNodes.TMovieTextureNode.EventIsPaused", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#EventIsPaused"},
     {"title": "X3DNodes.TMovieTextureNode.InternalTimeDependentHandler", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#InternalTimeDependentHandler"},
     {"title": "X3DNodes.TMovieTextureNode.Duration", "text": " Duration is initialized from loaded video length (default is -1). So it's automatically initialized when you call <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#IsTextureVideo\">IsTextureVideo</a>, <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#TextureVideo\">TextureVideo</a> methods.  <p>cycleInterval is just set to duration scaled by 1/Abs(<a class=\"normal\" href=\"X3DNodes.TMovieTextureNode.html#Speed\">speed</a>), like required by X3D spec.  <p>Duration (and so, also cycleInterval) is not reset when video is freed (like when you set <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html#IsTextureLoaded\">IsTextureLoaded</a> to <code>False</code>, maybe implicitly by calling <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#FreeResources\">TCastleSceneCore.FreeResources</a> with <a class=\"normal\" href=\"CastleSceneCore.html#frTextureDataInNodes\">frTextureDataInNodes</a>). This way this is available even you freed the texture video data to save memory. ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#Duration"},
     {"title": "X3DNodes.TMovieTextureNode.Description", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#Description"},
     {"title": "X3DNodes.TMovieTextureNode.Loop", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#Loop"},
     {"title": "X3DNodes.TMovieTextureNode.PauseTime", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#PauseTime"},
     {"title": "X3DNodes.TMovieTextureNode.ResumeTime", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#ResumeTime"},
     {"title": "X3DNodes.TMovieTextureNode.Speed", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#Speed"},
     {"title": "X3DNodes.TMovieTextureNode.StartTime", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#StartTime"},
     {"title": "X3DNodes.TMovieTextureNode.StopTime", "text": " ", "tags": "", "loc": "X3DNodes.TMovieTextureNode.html#StopTime"},
     {"title": "X3DNodes.TMultiTextureNode", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html"},
     {"title": "X3DNodes.TMultiTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TMultiTextureNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMultiTextureNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#URNMatching"},
     {"title": "X3DNodes.TMultiTextureNode.AlphaChannelData", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#AlphaChannelData"},
     {"title": "X3DNodes.TMultiTextureNode.SetFunction", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#SetFunction"},
     {"title": "X3DNodes.TMultiTextureNode.SetFunction", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#SetFunction"},
     {"title": "X3DNodes.TMultiTextureNode.SetMode", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#SetMode"},
     {"title": "X3DNodes.TMultiTextureNode.SetMode", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#SetMode"},
     {"title": "X3DNodes.TMultiTextureNode.SetSource", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#SetSource"},
     {"title": "X3DNodes.TMultiTextureNode.SetSource", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#SetSource"},
     {"title": "X3DNodes.TMultiTextureNode.SetTexture", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#SetTexture"},
     {"title": "X3DNodes.TMultiTextureNode.FdAlpha", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#FdAlpha"},
     {"title": "X3DNodes.TMultiTextureNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#FdColor"},
     {"title": "X3DNodes.TMultiTextureNode.FdFunction", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#FdFunction"},
     {"title": "X3DNodes.TMultiTextureNode.FdMode", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#FdMode"},
     {"title": "X3DNodes.TMultiTextureNode.FdSource", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#FdSource"},
     {"title": "X3DNodes.TMultiTextureNode.FdTexture", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#FdTexture"},
     {"title": "X3DNodes.TMultiTextureNode.Alpha", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#Alpha"},
     {"title": "X3DNodes.TMultiTextureNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureNode.html#Color"},
     {"title": "X3DNodes.TMultiTextureCoordinateNode", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureCoordinateNode.html"},
     {"title": "X3DNodes.TMultiTextureCoordinateNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureCoordinateNode.html#CreateNode"},
     {"title": "X3DNodes.TMultiTextureCoordinateNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureCoordinateNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMultiTextureCoordinateNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureCoordinateNode.html#URNMatching"},
     {"title": "X3DNodes.TMultiTextureCoordinateNode.SetTexCoord", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TMultiTextureCoordinateNode.html#SetTexCoord"},
     {"title": "X3DNodes.TMultiTextureCoordinateNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureCoordinateNode.html#FdTexCoord"},
     {"title": "X3DNodes.TMultiTextureTransformNode", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureTransformNode.html"},
     {"title": "X3DNodes.TMultiTextureTransformNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureTransformNode.html#CreateNode"},
     {"title": "X3DNodes.TMultiTextureTransformNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureTransformNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMultiTextureTransformNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiTextureTransformNode.html#URNMatching"},
     {"title": "X3DNodes.TMultiTextureTransformNode.TransformMatrix", "text": " Reason: you cannot get single texture transform matrix from MultiTextureTransform.  <p>    EInternalError Always, since this method has no sense for MultiTextureTransform.", "tags": "", "loc": "X3DNodes.TMultiTextureTransformNode.html#TransformMatrix"},
     {"title": "X3DNodes.TMultiTextureTransformNode.SetTextureTransform", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TMultiTextureTransformNode.html#SetTextureTransform"},
     {"title": "X3DNodes.TMultiTextureTransformNode.FdTextureTransform", "text": " ", "tags": "", "loc": "X3DNodes.TMultiTextureTransformNode.html#FdTextureTransform"},
     {"title": "X3DNodes.TPixelTextureNode", "text": "  <p>This is useful when authoring X3D, as you can place texture contents directly inside the X3D file (without the need for any external file).  <p>PixelTexture is also comfortable when using Object Pascal to construct the X3D graph. In this case, it allows to provide an image as a ready <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> instance, by changing the value of the <code>TPixelTextrueNode.FdImage.Value</code>.  <p>An alternative to PixelTexture is to use &quot;data URI&quot;. With &quot;data URI&quot;, you can embed any file contents inside an URL. This way, you can use <a class=\"normal\" href=\"X3DNodes.TImageTextureNode.html\">ImageTexture</a>, and inside <code>ImageTexture.url</code> field you can place an embedded image contents (instead of a normal URL or filename). To convert your image file to a &quot;data URI&quot;, you can our tool &quot;to_data_uri&quot;. The image contents stay compressed this way (although expressed in base64), so it may be more compact than PixelTexture. ", "tags": "", "loc": "X3DNodes.TPixelTextureNode.html"},
     {"title": "X3DNodes.TPixelTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPixelTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TPixelTextureNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPixelTextureNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPixelTextureNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPixelTextureNode.html#URNMatching"},
     {"title": "X3DNodes.TPixelTextureNode.TextureDescription", "text": "    ", "tags": "", "loc": "X3DNodes.TPixelTextureNode.html#TextureDescription"},
     {"title": "X3DNodes.TPixelTextureNode.FdImage", "text": " ", "tags": "", "loc": "X3DNodes.TPixelTextureNode.html#FdImage"},
     {"title": "X3DNodes.TTextureCoordinateNode", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinateNode.html"},
     {"title": "X3DNodes.TTextureCoordinateNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateNode.html#CreateNode"},
     {"title": "X3DNodes.TTextureCoordinateNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTextureCoordinateNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateNode.html#URNMatching"},
     {"title": "X3DNodes.TTextureCoordinateNode.SetPoint", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateNode.html#SetPoint"},
     {"title": "X3DNodes.TTextureCoordinateNode.SetPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateNode.html#SetPoint"},
     {"title": "X3DNodes.TTextureCoordinateNode.FdPoint", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinateNode.html#FdPoint"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html#CreateNode"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html#URNMatching"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode.SetParameter", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html#SetParameter"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode.SetParameter", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html#SetParameter"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode.FdMode", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html#FdMode"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode.FdParameter", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html#FdParameter"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode.FdProjectedLight", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html#FdProjectedLight"},
     {"title": "X3DNodes.TTextureCoordinateGeneratorNode.Mode", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinateGeneratorNode.html#Mode"},
     {"title": "X3DNodes.TTextureCoordGenNode", "text": " See examples from [<a  href=\"http://www.bitmanagement.de/developer/contact/relnotes6.html\">http://www.bitmanagement.de/developer/contact/relnotes6.html</a>] ", "tags": "", "loc": "X3DNodes.TTextureCoordGenNode.html"},
     {"title": "X3DNodes.TTextureCoordGenNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordGenNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTexturePropertiesNode", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html"},
     {"title": "X3DNodes.TTexturePropertiesNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#CreateNode"},
     {"title": "X3DNodes.TTexturePropertiesNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTexturePropertiesNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#URNMatching"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdAnisotropicDegree", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdAnisotropicDegree"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdBorderColor", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdBorderColor"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdBorderWidth", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdBorderWidth"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdBoundaryModeS", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdBoundaryModeS"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdBoundaryModeT", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdBoundaryModeT"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdBoundaryModeR", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdBoundaryModeR"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdMagnificationFilter", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdMagnificationFilter"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdMinificationFilter", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdMinificationFilter"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdTextureCompression", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdTextureCompression"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdTexturePriority", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdTexturePriority"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdGenerateMipMaps", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdGenerateMipMaps"},
     {"title": "X3DNodes.TTexturePropertiesNode.FdGUITexture", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#FdGUITexture"},
     {"title": "X3DNodes.TTexturePropertiesNode.MagnificationFilter", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#MagnificationFilter"},
     {"title": "X3DNodes.TTexturePropertiesNode.MinificationFilter", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#MinificationFilter"},
     {"title": "X3DNodes.TTexturePropertiesNode.AnisotropicDegree", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#AnisotropicDegree"},
     {"title": "X3DNodes.TTexturePropertiesNode.BorderColor", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#BorderColor"},
     {"title": "X3DNodes.TTexturePropertiesNode.BorderWidth", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#BorderWidth"},
     {"title": "X3DNodes.TTexturePropertiesNode.BoundaryModeS", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#BoundaryModeS"},
     {"title": "X3DNodes.TTexturePropertiesNode.BoundaryModeT", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#BoundaryModeT"},
     {"title": "X3DNodes.TTexturePropertiesNode.BoundaryModeR", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#BoundaryModeR"},
     {"title": "X3DNodes.TTexturePropertiesNode.TextureCompression", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#TextureCompression"},
     {"title": "X3DNodes.TTexturePropertiesNode.TexturePriority", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#TexturePriority"},
     {"title": "X3DNodes.TTexturePropertiesNode.GenerateMipMaps", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#GenerateMipMaps"},
     {"title": "X3DNodes.TTexturePropertiesNode.GuiTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTexturePropertiesNode.html#GuiTexture"},
     {"title": "X3DNodes.TTextureTransformNode", "text": " from <a class=\"normal\" href=\"X3DNodes.TTextureCoordinateNode.html\">TTextureCoordinateNode</a>. ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html"},
     {"title": "X3DNodes.TTextureTransformNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#CreateNode"},
     {"title": "X3DNodes.TTextureTransformNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTextureTransformNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#URNMatching"},
     {"title": "X3DNodes.TTextureTransformNode.TransformMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#TransformMatrix"},
     {"title": "X3DNodes.TTextureTransformNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#FdCenter"},
     {"title": "X3DNodes.TTextureTransformNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#FdRotation"},
     {"title": "X3DNodes.TTextureTransformNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#FdScale"},
     {"title": "X3DNodes.TTextureTransformNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#FdTranslation"},
     {"title": "X3DNodes.TTextureTransformNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#Center"},
     {"title": "X3DNodes.TTextureTransformNode.Rotation", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#Rotation"},
     {"title": "X3DNodes.TTextureTransformNode.Scale", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#Scale"},
     {"title": "X3DNodes.TTextureTransformNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformNode.html#Translation"},
     {"title": "X3DNodes.TAbstractInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractInterpolatorNode.html"},
     {"title": "X3DNodes.TAbstractInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractInterpolatorNode.SetKey", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TAbstractInterpolatorNode.html#SetKey"},
     {"title": "X3DNodes.TAbstractInterpolatorNode.SetKey", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractInterpolatorNode.html#SetKey"},
     {"title": "X3DNodes.TAbstractInterpolatorNode.EventSet_fraction", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractInterpolatorNode.html#EventSet_fraction"},
     {"title": "X3DNodes.TAbstractInterpolatorNode.FdKey", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractInterpolatorNode.html#FdKey"},
     {"title": "X3DNodes.TAbstractSingleInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSingleInterpolatorNode.html"},
     {"title": "X3DNodes.TAbstractSingleInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSingleInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractSingleInterpolatorNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSingleInterpolatorNode.html#FdKeyValue"},
     {"title": "X3DNodes.TAbstractSingleInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSingleInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TAbstractArrayInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractArrayInterpolatorNode.html"},
     {"title": "X3DNodes.TAbstractArrayInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractArrayInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractArrayInterpolatorNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractArrayInterpolatorNode.html#FdKeyValue"},
     {"title": "X3DNodes.TAbstractArrayInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractArrayInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TColorInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TColorInterpolatorNode.html"},
     {"title": "X3DNodes.TColorInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TColorInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TColorInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TColorInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TColorInterpolatorNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TColorInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TColorInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TColorInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TColorSetInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TColorSetInterpolatorNode.html"},
     {"title": "X3DNodes.TColorSetInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TColorSetInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TColorSetInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TColorSetInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TColorSetInterpolatorNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TColorSetInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TColorSetInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TColorSetInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TCoordinateInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolatorNode.html"},
     {"title": "X3DNodes.TCoordinateInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCoordinateInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TCoordinateInterpolatorNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TCoordinateInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TCoordinateInterpolator2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolator2DNode.html"},
     {"title": "X3DNodes.TCoordinateInterpolator2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolator2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCoordinateInterpolator2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolator2DNode.html#URNMatching"},
     {"title": "X3DNodes.TCoordinateInterpolator2DNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolator2DNode.html#SetKeyValue"},
     {"title": "X3DNodes.TCoordinateInterpolator2DNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateInterpolator2DNode.html#SetKeyValue"},
     {"title": "X3DNodes.TEaseInEaseOutNode", "text": " <b>Not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html"},
     {"title": "X3DNodes.TEaseInEaseOutNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#CreateNode"},
     {"title": "X3DNodes.TEaseInEaseOutNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#ClassX3DType"},
     {"title": "X3DNodes.TEaseInEaseOutNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#URNMatching"},
     {"title": "X3DNodes.TEaseInEaseOutNode.SetEaseInEaseOut", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#SetEaseInEaseOut"},
     {"title": "X3DNodes.TEaseInEaseOutNode.SetEaseInEaseOut", "text": "    ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#SetEaseInEaseOut"},
     {"title": "X3DNodes.TEaseInEaseOutNode.SetKey", "text": "    ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#SetKey"},
     {"title": "X3DNodes.TEaseInEaseOutNode.SetKey", "text": "    ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#SetKey"},
     {"title": "X3DNodes.TEaseInEaseOutNode.EventSet_fraction", "text": " ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#EventSet_fraction"},
     {"title": "X3DNodes.TEaseInEaseOutNode.FdEaseInEaseOut", "text": " ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#FdEaseInEaseOut"},
     {"title": "X3DNodes.TEaseInEaseOutNode.FdKey", "text": " ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#FdKey"},
     {"title": "X3DNodes.TEaseInEaseOutNode.EventModifiedFraction_changed", "text": " ", "tags": "", "loc": "X3DNodes.TEaseInEaseOutNode.html#EventModifiedFraction_changed"},
     {"title": "X3DNodes.TNormalInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TNormalInterpolatorNode.html"},
     {"title": "X3DNodes.TNormalInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNormalInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNormalInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNormalInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TNormalInterpolatorNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TNormalInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TNormalInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TNormalInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TOrientationInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationInterpolatorNode.html"},
     {"title": "X3DNodes.TOrientationInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TOrientationInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TOrientationInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TOrientationInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TOrientationInterpolatorNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TOrientationInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TOrientationInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TOrientationInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TPositionInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TPositionInterpolatorNode.html"},
     {"title": "X3DNodes.TPositionInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPositionInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TPositionInterpolatorNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TPositionInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TPositionInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TPositionInterpolator2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TPositionInterpolator2DNode.html"},
     {"title": "X3DNodes.TPositionInterpolator2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionInterpolator2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPositionInterpolator2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionInterpolator2DNode.html#URNMatching"},
     {"title": "X3DNodes.TPositionInterpolator2DNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TPositionInterpolator2DNode.html#SetKeyValue"},
     {"title": "X3DNodes.TPositionInterpolator2DNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionInterpolator2DNode.html#SetKeyValue"},
     {"title": "X3DNodes.TScalarInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TScalarInterpolatorNode.html"},
     {"title": "X3DNodes.TScalarInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TScalarInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TScalarInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TScalarInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TScalarInterpolatorNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TScalarInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TScalarInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TScalarInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode", "text": " <b>Not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.SetKeyVelocity", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#SetKeyVelocity"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.SetKeyVelocity", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#SetKeyVelocity"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.FdClosed", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#FdClosed"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#FdKeyValue"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.FdKeyVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#FdKeyVelocity"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.FdNormalizeVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#FdNormalizeVelocity"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.Closed", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#Closed"},
     {"title": "X3DNodes.TSplinePositionInterpolatorNode.NormalizeVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolatorNode.html#NormalizeVelocity"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode", "text": " <b>Not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#CreateNode"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#URNMatching"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#SetKeyValue"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#SetKeyValue"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.SetKeyVelocity", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#SetKeyVelocity"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.SetKeyVelocity", "text": "    ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#SetKeyVelocity"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.FdClosed", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#FdClosed"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#FdKeyValue"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.FdKeyVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#FdKeyVelocity"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.FdNormalizeVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#FdNormalizeVelocity"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#EventValue_changed"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.Closed", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#Closed"},
     {"title": "X3DNodes.TSplinePositionInterpolator2DNode.NormalizeVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSplinePositionInterpolator2DNode.html#NormalizeVelocity"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode", "text": " <b>Not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.SetKeyVelocity", "text": "    ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#SetKeyVelocity"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.SetKeyVelocity", "text": "    ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#SetKeyVelocity"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.FdClosed", "text": " ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#FdClosed"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#FdKeyValue"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.FdKeyVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#FdKeyVelocity"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.FdNormalizeVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#FdNormalizeVelocity"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.Closed", "text": " ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#Closed"},
     {"title": "X3DNodes.TSplineScalarInterpolatorNode.NormalizeVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSplineScalarInterpolatorNode.html#NormalizeVelocity"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode", "text": " <b>Not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html#FdKeyValue"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode.FdNormalizeVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html#FdNormalizeVelocity"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TSquadOrientationInterpolatorNode.NormalizeVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TSquadOrientationInterpolatorNode.html#NormalizeVelocity"},
     {"title": "X3DNodes.TVectorInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TVectorInterpolatorNode.html"},
     {"title": "X3DNodes.TVectorInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TVectorInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TVectorInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TVectorInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TVectorInterpolatorNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TVectorInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TVectorInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TVectorInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TAbstractCubicBezierInterpolatorNode", "text": "  <p>This file is part of &quot;Castle Game Engine&quot;.  <p>&quot;Castle Game Engine&quot; is free software; see the file COPYING.txt, included in this distribution, for details about the copyright.  <p>&quot;Castle Game Engine&quot; is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  <p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;- ", "tags": "", "loc": "X3DNodes.TAbstractCubicBezierInterpolatorNode.html"},
     {"title": "X3DNodes.TAbstractCubicBezierInterpolatorNode.DeepCopyCore", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractCubicBezierInterpolatorNode.html#DeepCopyCore"},
     {"title": "X3DNodes.TAbstractCubicBezierInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractCubicBezierInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractCubicBezierInterpolatorNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractCubicBezierInterpolatorNode.html#Destroy"},
     {"title": "X3DNodes.TAbstractCubicBezierInterpolatorNode.OptimizeControlPoints", "text": " This makes the following interpolation using this node work fast.    ", "tags": "", "loc": "X3DNodes.TAbstractCubicBezierInterpolatorNode.html#OptimizeControlPoints"},
     {"title": "X3DNodes.TAbstractCubicBezierInterpolatorNode.FdControlPoints", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractCubicBezierInterpolatorNode.html#FdControlPoints"},
     {"title": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_interpolation_extensions.php\">http://castle-engine.sourceforge.net/x3d_implementation_interpolation_extensions.php</a> . ", "tags": "", "loc": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.html"},
     {"title": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.html#FdKeyValue"},
     {"title": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.FdAxis", "text": " ", "tags": "", "loc": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.html#FdAxis"},
     {"title": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TCubicBezier2DOrientationInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TCubicBezierPositionInterpolatorNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_interpolation_extensions.php\">http://castle-engine.sourceforge.net/x3d_implementation_interpolation_extensions.php</a> . ", "tags": "", "loc": "X3DNodes.TCubicBezierPositionInterpolatorNode.html"},
     {"title": "X3DNodes.TCubicBezierPositionInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCubicBezierPositionInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TCubicBezierPositionInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCubicBezierPositionInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCubicBezierPositionInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCubicBezierPositionInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TCubicBezierPositionInterpolatorNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TCubicBezierPositionInterpolatorNode.html#FdKeyValue"},
     {"title": "X3DNodes.TCubicBezierPositionInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TCubicBezierPositionInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TPointingDeviceSensorList", "text": " Only nodes descending from X3DPointingDeviceSensorNode, and additionally an Anchor node. ", "tags": "", "loc": "X3DNodes.TPointingDeviceSensorList.html"},
     {"title": "X3DNodes.TPointingDeviceSensorList.Transform", "text": " VRML/X3D specification guarantees that all sensors within a single state have the same transform. ", "tags": "", "loc": "X3DNodes.TPointingDeviceSensorList.html#Transform"},
     {"title": "X3DNodes.TPointingDeviceSensorList.InvertedTransform", "text": " VRML/X3D specification guarantees that all sensors within a single state have the same transform. ", "tags": "", "loc": "X3DNodes.TPointingDeviceSensorList.html#InvertedTransform"},
     {"title": "X3DNodes.TPointingDeviceSensorList.EnabledCount", "text": "    ", "tags": "", "loc": "X3DNodes.TPointingDeviceSensorList.html#EnabledCount"},
     {"title": "X3DNodes.TPointingDeviceSensorList.Enabled", "text": "    ", "tags": "", "loc": "X3DNodes.TPointingDeviceSensorList.html#Enabled"},
     {"title": "X3DNodes.TPointingDeviceSensorList.Assign", "text": "    ", "tags": "", "loc": "X3DNodes.TPointingDeviceSensorList.html#Assign"},
     {"title": "X3DNodes.TAbstractPointingDeviceSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPointingDeviceSensorNode.html"},
     {"title": "X3DNodes.TAbstractPointingDeviceSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPointingDeviceSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractPointingDeviceSensorNode.Activate", "text": " Used by the events engine (like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>) to notify this sensor.  <p>OverPoint indicates 3D point (in global, that is <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, coordinates) pointed by the mouse.  <p>In <a class=\"normal\" href=\"X3DNodes.TAbstractPointingDeviceSensorNode.html\">TAbstractPointingDeviceSensorNode</a> class, this simply sends isActive := TRUE event.    ", "tags": "", "loc": "X3DNodes.TAbstractPointingDeviceSensorNode.html#Activate"},
     {"title": "X3DNodes.TAbstractPointingDeviceSensorNode.Deactivate", "text": " Used by the events engine (like <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>) to notify this sensor.  <p>In <a class=\"normal\" href=\"X3DNodes.TAbstractPointingDeviceSensorNode.html\">TAbstractPointingDeviceSensorNode</a> class, this simply sends isActive := FALSE event.    ", "tags": "", "loc": "X3DNodes.TAbstractPointingDeviceSensorNode.html#Deactivate"},
     {"title": "X3DNodes.TAbstractPointingDeviceSensorNode.FdDescription", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPointingDeviceSensorNode.html#FdDescription"},
     {"title": "X3DNodes.TAbstractPointingDeviceSensorNode.EventIsOver", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPointingDeviceSensorNode.html#EventIsOver"},
     {"title": "X3DNodes.TAbstractPointingDeviceSensorNode.Description", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPointingDeviceSensorNode.html#Description"},
     {"title": "X3DNodes.TAbstractDragSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDragSensorNode.html"},
     {"title": "X3DNodes.TAbstractDragSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDragSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractDragSensorNode.Drag", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDragSensorNode.html#Drag"},
     {"title": "X3DNodes.TAbstractDragSensorNode.FdAutoOffset", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDragSensorNode.html#FdAutoOffset"},
     {"title": "X3DNodes.TAbstractDragSensorNode.EventTrackPoint_changed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDragSensorNode.html#EventTrackPoint_changed"},
     {"title": "X3DNodes.TAbstractDragSensorNode.AutoOffset", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDragSensorNode.html#AutoOffset"},
     {"title": "X3DNodes.TAbstractTouchSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTouchSensorNode.html"},
     {"title": "X3DNodes.TAbstractTouchSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTouchSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractTouchSensorNode.EventTouchTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTouchSensorNode.html#EventTouchTime"},
     {"title": "X3DNodes.TCylinderSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html"},
     {"title": "X3DNodes.TCylinderSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TCylinderSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCylinderSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TCylinderSensorNode.Activate", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#Activate"},
     {"title": "X3DNodes.TCylinderSensorNode.Deactivate", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#Deactivate"},
     {"title": "X3DNodes.TCylinderSensorNode.Drag", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#Drag"},
     {"title": "X3DNodes.TCylinderSensorNode.FdAxisRotation", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#FdAxisRotation"},
     {"title": "X3DNodes.TCylinderSensorNode.FdDiskAngle", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#FdDiskAngle"},
     {"title": "X3DNodes.TCylinderSensorNode.FdMaxAngle", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#FdMaxAngle"},
     {"title": "X3DNodes.TCylinderSensorNode.FdMinAngle", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#FdMinAngle"},
     {"title": "X3DNodes.TCylinderSensorNode.FdOffset", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#FdOffset"},
     {"title": "X3DNodes.TCylinderSensorNode.EventRotation_changed", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#EventRotation_changed"},
     {"title": "X3DNodes.TCylinderSensorNode.AxisRotation", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#AxisRotation"},
     {"title": "X3DNodes.TCylinderSensorNode.DiskAngle", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#DiskAngle"},
     {"title": "X3DNodes.TCylinderSensorNode.MaxAngle", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#MaxAngle"},
     {"title": "X3DNodes.TCylinderSensorNode.MinAngle", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#MinAngle"},
     {"title": "X3DNodes.TCylinderSensorNode.Offset", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderSensorNode.html#Offset"},
     {"title": "X3DNodes.TPlaneSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html"},
     {"title": "X3DNodes.TPlaneSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TPlaneSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPlaneSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TPlaneSensorNode.Activate", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#Activate"},
     {"title": "X3DNodes.TPlaneSensorNode.Deactivate", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#Deactivate"},
     {"title": "X3DNodes.TPlaneSensorNode.Drag", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#Drag"},
     {"title": "X3DNodes.TPlaneSensorNode.FdAxisRotation", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#FdAxisRotation"},
     {"title": "X3DNodes.TPlaneSensorNode.FdMaxPosition", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#FdMaxPosition"},
     {"title": "X3DNodes.TPlaneSensorNode.FdMinPosition", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#FdMinPosition"},
     {"title": "X3DNodes.TPlaneSensorNode.FdOffset", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#FdOffset"},
     {"title": "X3DNodes.TPlaneSensorNode.EventTranslation_changed", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#EventTranslation_changed"},
     {"title": "X3DNodes.TPlaneSensorNode.AxisRotation", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#AxisRotation"},
     {"title": "X3DNodes.TPlaneSensorNode.MaxPosition", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#MaxPosition"},
     {"title": "X3DNodes.TPlaneSensorNode.MinPosition", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#MinPosition"},
     {"title": "X3DNodes.TPlaneSensorNode.Offset", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneSensorNode.html#Offset"},
     {"title": "X3DNodes.TSphereSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html"},
     {"title": "X3DNodes.TSphereSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TSphereSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSphereSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TSphereSensorNode.Activate", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html#Activate"},
     {"title": "X3DNodes.TSphereSensorNode.Deactivate", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html#Deactivate"},
     {"title": "X3DNodes.TSphereSensorNode.Drag", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html#Drag"},
     {"title": "X3DNodes.TSphereSensorNode.FdOffset", "text": " ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html#FdOffset"},
     {"title": "X3DNodes.TSphereSensorNode.EventRotation_changed", "text": " ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html#EventRotation_changed"},
     {"title": "X3DNodes.TSphereSensorNode.Offset", "text": " ", "tags": "", "loc": "X3DNodes.TSphereSensorNode.html#Offset"},
     {"title": "X3DNodes.TTouchSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TTouchSensorNode.html"},
     {"title": "X3DNodes.TTouchSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTouchSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TTouchSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTouchSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTouchSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTouchSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TTouchSensorNode.EventHitNormal_changed", "text": " ", "tags": "", "loc": "X3DNodes.TTouchSensorNode.html#EventHitNormal_changed"},
     {"title": "X3DNodes.TTouchSensorNode.EventHitPoint_changed", "text": " ", "tags": "", "loc": "X3DNodes.TTouchSensorNode.html#EventHitPoint_changed"},
     {"title": "X3DNodes.TTouchSensorNode.EventHitTexCoord_changed", "text": " ", "tags": "", "loc": "X3DNodes.TTouchSensorNode.html#EventHitTexCoord_changed"},
     {"title": "X3DNodes.TAbstractKeyDeviceSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractKeyDeviceSensorNode.html"},
     {"title": "X3DNodes.TAbstractKeyDeviceSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractKeyDeviceSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractKeyDeviceSensorNode.KeyDown", "text": "  <p>This is used by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> to communicate with this key sensor.  <p>Semantics follow <a class=\"normal\" href=\"CastleKeysMouse.TInputPressRelease.html\">TInputPressRelease</a> behavior for EventType = <a class=\"normal\" href=\"CastleKeysMouse.html#itKey\">itKey</a>. This means that Key may be <a class=\"normal\" href=\"CastleKeysMouse.html#K_None\">K_None</a> (if not representable as <a class=\"normal\" href=\"CastleKeysMouse.html#TKey\">TKey</a>) and C may be #0 (if not representable as char), but not both &mdash; at least one of Key or C must contains something useful. Also, key presses are affected by the &quot;key repeat&quot; feature of the OS (windowing system actually), so when user holds down a key &mdash; we get many key down messages.  <p>    ", "tags": "", "loc": "X3DNodes.TAbstractKeyDeviceSensorNode.html#KeyDown"},
     {"title": "X3DNodes.TAbstractKeyDeviceSensorNode.KeyUp", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractKeyDeviceSensorNode.html#KeyUp"},
     {"title": "X3DNodes.TKeySensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html"},
     {"title": "X3DNodes.TKeySensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#CreateNode"},
     {"title": "X3DNodes.TKeySensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TKeySensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#URNMatching"},
     {"title": "X3DNodes.TKeySensorNode.KeyDown", "text": "    ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#KeyDown"},
     {"title": "X3DNodes.TKeySensorNode.KeyUp", "text": "    ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#KeyUp"},
     {"title": "X3DNodes.TKeySensorNode.EventActionKeyPress", "text": " ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#EventActionKeyPress"},
     {"title": "X3DNodes.TKeySensorNode.EventActionKeyRelease", "text": " ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#EventActionKeyRelease"},
     {"title": "X3DNodes.TKeySensorNode.EventAltKey", "text": " ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#EventAltKey"},
     {"title": "X3DNodes.TKeySensorNode.EventControlKey", "text": " ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#EventControlKey"},
     {"title": "X3DNodes.TKeySensorNode.EventKeyPress", "text": " ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#EventKeyPress"},
     {"title": "X3DNodes.TKeySensorNode.EventKeyRelease", "text": " ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#EventKeyRelease"},
     {"title": "X3DNodes.TKeySensorNode.EventShiftKey", "text": " ", "tags": "", "loc": "X3DNodes.TKeySensorNode.html#EventShiftKey"},
     {"title": "X3DNodes.TStringSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TStringSensorNode.html"},
     {"title": "X3DNodes.TStringSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TStringSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TStringSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TStringSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TStringSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TStringSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TStringSensorNode.KeyDown", "text": "    ", "tags": "", "loc": "X3DNodes.TStringSensorNode.html#KeyDown"},
     {"title": "X3DNodes.TStringSensorNode.FdDeletionAllowed", "text": " ", "tags": "", "loc": "X3DNodes.TStringSensorNode.html#FdDeletionAllowed"},
     {"title": "X3DNodes.TStringSensorNode.EventEnteredText", "text": " ", "tags": "", "loc": "X3DNodes.TStringSensorNode.html#EventEnteredText"},
     {"title": "X3DNodes.TStringSensorNode.EventFinalText", "text": " ", "tags": "", "loc": "X3DNodes.TStringSensorNode.html#EventFinalText"},
     {"title": "X3DNodes.TStringSensorNode.DeletionAllowed", "text": " ", "tags": "", "loc": "X3DNodes.TStringSensorNode.html#DeletionAllowed"},
     {"title": "X3DNodes.TAbstractEnvironmentalSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentalSensorNode.html"},
     {"title": "X3DNodes.TAbstractEnvironmentalSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentalSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractEnvironmentalSensorNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentalSensorNode.html#FdCenter"},
     {"title": "X3DNodes.TAbstractEnvironmentalSensorNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentalSensorNode.html#FdSize"},
     {"title": "X3DNodes.TAbstractEnvironmentalSensorNode.EventEnterTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentalSensorNode.html#EventEnterTime"},
     {"title": "X3DNodes.TAbstractEnvironmentalSensorNode.EventExitTime", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentalSensorNode.html#EventExitTime"},
     {"title": "X3DNodes.TAbstractEnvironmentalSensorNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentalSensorNode.html#Center"},
     {"title": "X3DNodes.TAbstractEnvironmentalSensorNode.Size", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentalSensorNode.html#Size"},
     {"title": "X3DNodes.TProximitySensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TProximitySensorNode.html"},
     {"title": "X3DNodes.TProximitySensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TProximitySensorNode.html#CreateNode"},
     {"title": "X3DNodes.TProximitySensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TProximitySensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TProximitySensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TProximitySensorNode.html#URNMatching"},
     {"title": "X3DNodes.TProximitySensorNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TProximitySensorNode.html#TransformationChange"},
     {"title": "X3DNodes.TProximitySensorNode.EventCenterOfRotation_changed", "text": " ", "tags": "", "loc": "X3DNodes.TProximitySensorNode.html#EventCenterOfRotation_changed"},
     {"title": "X3DNodes.TProximitySensorNode.EventOrientation_changed", "text": " ", "tags": "", "loc": "X3DNodes.TProximitySensorNode.html#EventOrientation_changed"},
     {"title": "X3DNodes.TProximitySensorNode.EventPosition_changed", "text": " ", "tags": "", "loc": "X3DNodes.TProximitySensorNode.html#EventPosition_changed"},
     {"title": "X3DNodes.TTransformSensorNode", "text": " <b>Not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TTransformSensorNode.html"},
     {"title": "X3DNodes.TTransformSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TTransformSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTransformSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TTransformSensorNode.FdTargetObject", "text": " ", "tags": "", "loc": "X3DNodes.TTransformSensorNode.html#FdTargetObject"},
     {"title": "X3DNodes.TTransformSensorNode.EventOrientation_changed", "text": " ", "tags": "", "loc": "X3DNodes.TTransformSensorNode.html#EventOrientation_changed"},
     {"title": "X3DNodes.TTransformSensorNode.EventPosition_changed", "text": " ", "tags": "", "loc": "X3DNodes.TTransformSensorNode.html#EventPosition_changed"},
     {"title": "X3DNodes.TVisibilitySensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TVisibilitySensorNode.html"},
     {"title": "X3DNodes.TVisibilitySensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TVisibilitySensorNode.html#CreateNode"},
     {"title": "X3DNodes.TVisibilitySensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TVisibilitySensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TVisibilitySensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TVisibilitySensorNode.html#URNMatching"},
     {"title": "X3DNodes.TVisibilitySensorNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TVisibilitySensorNode.html#TransformationChange"},
     {"title": "X3DNodes.TVisibilitySensorNode.Box", "text": "    ", "tags": "", "loc": "X3DNodes.TVisibilitySensorNode.html#Box"},
     {"title": "X3DNodes.TVisibilitySensorNode.SetIsActive", "text": "    ", "tags": "", "loc": "X3DNodes.TVisibilitySensorNode.html#SetIsActive"},
     {"title": "X3DNodes.TVisibilitySensorNode.IsActive", "text": " ", "tags": "", "loc": "X3DNodes.TVisibilitySensorNode.html#IsActive"},
     {"title": "X3DNodes.TAbstractViewpointNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html"},
     {"title": "X3DNodes.TAbstractViewpointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractViewpointNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#TransformationChange"},
     {"title": "X3DNodes.TAbstractViewpointNode.ProjectionType", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#ProjectionType"},
     {"title": "X3DNodes.TAbstractViewpointNode.GetView", "text": " Follows VRML/X3D specification:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p>position is taken directly from FdPosition field,</p></li>   <li><p>direction and up are (respectively) -Z and +Y rotated by <a class=\"normal\" href=\"X3DNodes.TAbstractViewpointNode.html#FdOrientation\">FdOrientation</a>,</p></li>   <li><p>gravity up is +Y.</p></li> </ul>  <p>  <p>They are all then transformed by the current viewpoint transformation (determined by parent nodes like Transform).  <p>One conclusion from the above is that the only way to change the gravity up vector (this determines in which direction viewer falls down) is to use the Transform node around the viewpoint node.  <p>Additionally, as an extension, we also look at <a class=\"normal\" href=\"X3DNodes.TAbstractViewpointNode.html#FdDirection\">FdDirection</a> and <a class=\"normal\" href=\"X3DNodes.TAbstractViewpointNode.html#FdUp\">FdUp</a> and <a class=\"normal\" href=\"X3DNodes.TAbstractViewpointNode.html#FdGravityUp\">FdGravityUp</a> vectors. See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_cameras_alt_orient\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_cameras_alt_orient</a>  <p>Returned CamDir, CamUp, GravityUp are <i>always normalized</i>.    ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#GetView"},
     {"title": "X3DNodes.TAbstractViewpointNode.SmartDescription", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#SmartDescription"},
     {"title": "X3DNodes.TAbstractViewpointNode.FdOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#FdOrientation"},
     {"title": "X3DNodes.TAbstractViewpointNode.Orientation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#Orientation"},
     {"title": "X3DNodes.TAbstractViewpointNode.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#FdDirection"},
     {"title": "X3DNodes.TAbstractViewpointNode.FdUp", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#FdUp"},
     {"title": "X3DNodes.TAbstractViewpointNode.FdGravityUp", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#FdGravityUp"},
     {"title": "X3DNodes.TAbstractViewpointNode.EventCameraMatrix", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#EventCameraMatrix"},
     {"title": "X3DNodes.TAbstractViewpointNode.EventCameraInverseMatrix", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#EventCameraInverseMatrix"},
     {"title": "X3DNodes.TAbstractViewpointNode.EventCameraRotationMatrix", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#EventCameraRotationMatrix"},
     {"title": "X3DNodes.TAbstractViewpointNode.EventCameraRotationInverseMatrix", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#EventCameraRotationInverseMatrix"},
     {"title": "X3DNodes.TAbstractViewpointNode.FdCameraMatrixSendAlsoOnOffscreenRendering", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#FdCameraMatrixSendAlsoOnOffscreenRendering"},
     {"title": "X3DNodes.TAbstractViewpointNode.Position", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#Position"},
     {"title": "X3DNodes.TAbstractViewpointNode.FdDescription", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewpointNode.html#FdDescription"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.ProjectionMatrix", "text": " Override <code>ProjectionMatrix</code> for subclasses (<a class=\"normal\" href=\"X3DNodes.TAbstractX3DViewpointNode.html#ModelviewMatrix\">ModelviewMatrix</a> is already correctly defined here).     ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#ProjectionMatrix"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.ModelviewMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#ModelviewMatrix"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.GetProjectorMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#GetProjectorMatrix"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.FdCenterOfRotation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#FdCenterOfRotation"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.FdJump", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#FdJump"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.FdRetainUserOffsets", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#FdRetainUserOffsets"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.CenterOfRotation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#CenterOfRotation"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.Description", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#Description"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.Jump", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#Jump"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.RetainUserOffsets", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#RetainUserOffsets"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.CameraMatrixSendAlsoOnOffscreenRendering", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#CameraMatrixSendAlsoOnOffscreenRendering"},
     {"title": "X3DNodes.TAbstractX3DViewpointNode.GravityUp", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_navigation_extensions.php\">http://castle-engine.sourceforge.net/x3d_implementation_navigation_extensions.php</a> .  ", "tags": "", "loc": "X3DNodes.TAbstractX3DViewpointNode.html#GravityUp"},
     {"title": "X3DNodes.TCameraVectors", "text": " ", "tags": "", "loc": "X3DNodes.TCameraVectors.html"},
     {"title": "X3DNodes.TCameraVectors.Position", "text": " ", "tags": "", "loc": "X3DNodes.TCameraVectors.html#Position"},
     {"title": "X3DNodes.TCameraVectors.Direction", "text": " ", "tags": "", "loc": "X3DNodes.TCameraVectors.html#Direction"},
     {"title": "X3DNodes.TCameraVectors.Up", "text": " ", "tags": "", "loc": "X3DNodes.TCameraVectors.html#Up"},
     {"title": "X3DNodes.TBillboardNode", "text": " ", "tags": "", "loc": "X3DNodes.TBillboardNode.html"},
     {"title": "X3DNodes.TBillboardNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TBillboardNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TBillboardNode.ApplyTransform", "text": "    ", "tags": "", "loc": "X3DNodes.TBillboardNode.html#ApplyTransform"},
     {"title": "X3DNodes.TBillboardNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBillboardNode.html#CreateNode"},
     {"title": "X3DNodes.TBillboardNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBillboardNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBillboardNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBillboardNode.html#URNMatching"},
     {"title": "X3DNodes.TBillboardNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TBillboardNode.html#TransformationChange"},
     {"title": "X3DNodes.TBillboardNode.CameraChanged", "text": "    ", "tags": "", "loc": "X3DNodes.TBillboardNode.html#CameraChanged"},
     {"title": "X3DNodes.TBillboardNode.FdAxisOfRotation", "text": " ", "tags": "", "loc": "X3DNodes.TBillboardNode.html#FdAxisOfRotation"},
     {"title": "X3DNodes.TBillboardNode.AxisOfRotation", "text": " ", "tags": "", "loc": "X3DNodes.TBillboardNode.html#AxisOfRotation"},
     {"title": "X3DNodes.TCollisionNode", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionNode.html"},
     {"title": "X3DNodes.TCollisionNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TCollisionNode.DirectEnumerateActiveForTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#DirectEnumerateActiveForTraverse"},
     {"title": "X3DNodes.TCollisionNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#CreateNode"},
     {"title": "X3DNodes.TCollisionNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCollisionNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#URNMatching"},
     {"title": "X3DNodes.TCollisionNode.CollideAsBox", "text": " This sets VisibleNode as the only child of this collision node, and sets the <a class=\"normal\" href=\"X3DNodes.TCollisionNode.html#Proxy\">Proxy</a> field to a simple box with given bounds. The <code><a class=\"normal\" href=\"X3DNodes.TCollisionNode.html#Enabled\">Enabled</a></code> field is unchanged (by default <code>True</code>).  <p>It honors the case of Box being empty correctly. Proxy is then non-nil, but without any geometry. So the collisions are effectively disabled, in a consistent way (without changing the <code><a class=\"normal\" href=\"X3DNodes.TCollisionNode.html#Enabled\">Enabled</a></code> field).    ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#CollideAsBox"},
     {"title": "X3DNodes.TCollisionNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#FdEnabled"},
     {"title": "X3DNodes.TCollisionNode.EventCollideTime", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#EventCollideTime"},
     {"title": "X3DNodes.TCollisionNode.EventIsActive", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#EventIsActive"},
     {"title": "X3DNodes.TCollisionNode.FdProxy", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#FdProxy"},
     {"title": "X3DNodes.TCollisionNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#Enabled"},
     {"title": "X3DNodes.TCollisionNode.Proxy", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionNode.html#Proxy"},
     {"title": "X3DNodes.TAbstractLODNode", "text": "  <p>It's a common ancestor for VRML 2.0 LOD (<a class=\"normal\" href=\"X3DNodes.TLODNode_2.html\">TLODNode_2</a>) and X3D LOD (<a class=\"normal\" href=\"X3DNodes.TLODNode.html\">TLODNode</a>). Unfortunately, we cannot have a simple common class for both VRML 97 and X3D because there would be a name clash for &quot;level_changed&quot; event:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p> For VRML 2.0, main MFNode field was named &quot;level&quot; and so &quot;level_changed&quot; is an event reporting when MFNode changed.</p></li>   <li><p>For X3D, main MFNode field is named &quot;children&quot;, and so &quot;children_changed&quot; reports MFNode changes. &quot;level_changed&quot; is a new field, SFInt32, indicating which child is chosen.</p></li> </ul>  <p>  <p>So level_changed has completely different meanings for VRML 97 and X3D. As an extension we'll add &quot;levelIndex_changed&quot;, SFInt32, to be analogous to X3D &quot;level_changed&quot;. This way both VRML 2.0 and X3D LOD nodes have the same capabilities, and common interface for programmer (programmer should use X3D event/fields names for Pascal property names), but for parser they will use different names. ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html"},
     {"title": "X3DNodes.TAbstractLODNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TAbstractLODNode.GetCenter", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#GetCenter"},
     {"title": "X3DNodes.TAbstractLODNode.SetCenter", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#SetCenter"},
     {"title": "X3DNodes.TAbstractLODNode.GetForceTransitions", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#GetForceTransitions"},
     {"title": "X3DNodes.TAbstractLODNode.SetForceTransitions", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#SetForceTransitions"},
     {"title": "X3DNodes.TAbstractLODNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractLODNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#ClassX3DType"},
     {"title": "X3DNodes.TAbstractLODNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#TransformationChange"},
     {"title": "X3DNodes.TAbstractLODNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#FdCenter"},
     {"title": "X3DNodes.TAbstractLODNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#Center"},
     {"title": "X3DNodes.TAbstractLODNode.FdRange", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#FdRange"},
     {"title": "X3DNodes.TAbstractLODNode.FdForceTransitions", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#FdForceTransitions"},
     {"title": "X3DNodes.TAbstractLODNode.ForceTransitions", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#ForceTransitions"},
     {"title": "X3DNodes.TAbstractLODNode.EventLevel_changed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLODNode.html#EventLevel_changed"},
     {"title": "X3DNodes.TLODNode_2", "text": " ", "tags": "", "loc": "X3DNodes.TLODNode_2.html"},
     {"title": "X3DNodes.TLODNode_2.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLODNode_2.html#CreateNode"},
     {"title": "X3DNodes.TLODNode_2.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TLODNode_2.html#ForVRMLVersion"},
     {"title": "X3DNodes.TLODNode_2.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLODNode_2.html#URNMatching"},
     {"title": "X3DNodes.TLODNode", "text": " ", "tags": "", "loc": "X3DNodes.TLODNode.html"},
     {"title": "X3DNodes.TLODNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TLODNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TLODNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLODNode.html#URNMatching"},
     {"title": "X3DNodes.TNavigationInfoNode", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html"},
     {"title": "X3DNodes.TNavigationInfoNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#CreateNode"},
     {"title": "X3DNodes.TNavigationInfoNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNavigationInfoNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#URNMatching"},
     {"title": "X3DNodes.TNavigationInfoNode.SetAvatarSize", "text": "    ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#SetAvatarSize"},
     {"title": "X3DNodes.TNavigationInfoNode.SetAvatarSize", "text": "    ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#SetAvatarSize"},
     {"title": "X3DNodes.TNavigationInfoNode.SetTransitionType", "text": "    ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#SetTransitionType"},
     {"title": "X3DNodes.TNavigationInfoNode.SetTransitionType", "text": "    ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#SetTransitionType"},
     {"title": "X3DNodes.TNavigationInfoNode.SetType", "text": "    ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#SetType"},
     {"title": "X3DNodes.TNavigationInfoNode.SetType", "text": "    ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#SetType"},
     {"title": "X3DNodes.TNavigationInfoNode.FdAvatarSize", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#FdAvatarSize"},
     {"title": "X3DNodes.TNavigationInfoNode.FdHeadlight", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#FdHeadlight"},
     {"title": "X3DNodes.TNavigationInfoNode.FdSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#FdSpeed"},
     {"title": "X3DNodes.TNavigationInfoNode.FdTransitionTime", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#FdTransitionTime"},
     {"title": "X3DNodes.TNavigationInfoNode.FdTransitionType", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#FdTransitionType"},
     {"title": "X3DNodes.TNavigationInfoNode.FdType", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#FdType"},
     {"title": "X3DNodes.TNavigationInfoNode.FdVisibilityLimit", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#FdVisibilityLimit"},
     {"title": "X3DNodes.TNavigationInfoNode.FdBlendingSort", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#FdBlendingSort"},
     {"title": "X3DNodes.TNavigationInfoNode.BlendingSort", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#BlendingSort"},
     {"title": "X3DNodes.TNavigationInfoNode.EventTransitionComplete", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#EventTransitionComplete"},
     {"title": "X3DNodes.TNavigationInfoNode.Headlight", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#Headlight"},
     {"title": "X3DNodes.TNavigationInfoNode.Speed", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#Speed"},
     {"title": "X3DNodes.TNavigationInfoNode.TransitionTime", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#TransitionTime"},
     {"title": "X3DNodes.TNavigationInfoNode.VisibilityLimit", "text": " ", "tags": "", "loc": "X3DNodes.TNavigationInfoNode.html#VisibilityLimit"},
     {"title": "X3DNodes.TOrthoViewpointNode", "text": " ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html"},
     {"title": "X3DNodes.TOrthoViewpointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#CreateNode"},
     {"title": "X3DNodes.TOrthoViewpointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TOrthoViewpointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#URNMatching"},
     {"title": "X3DNodes.TOrthoViewpointNode.ProjectionType", "text": "    ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#ProjectionType"},
     {"title": "X3DNodes.TOrthoViewpointNode.ProjectionMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#ProjectionMatrix"},
     {"title": "X3DNodes.TOrthoViewpointNode.AspectFieldOfView", "text": " The idea is that OrthoViewpoint.fieldOfView specifies the minimal extents. Depending on your window aspect ratio, you may need to make one extent (vertical or horizontal) larger to adjust.    ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#AspectFieldOfView"},
     {"title": "X3DNodes.TOrthoViewpointNode.SetFieldOfView", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#SetFieldOfView"},
     {"title": "X3DNodes.TOrthoViewpointNode.SetFieldOfView", "text": "    ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#SetFieldOfView"},
     {"title": "X3DNodes.TOrthoViewpointNode.FdFieldOfView", "text": " ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#FdFieldOfView"},
     {"title": "X3DNodes.TOrthoViewpointNode.FieldOfView", "text": " Use this e.g. to zoom in/out.  <p>This property has comfortable getter and setter, you can also get and set the indexes in 0..3 range, where  <p></p>  <ul class=\"compact_spacing\">   <li><p>0 index is &quot;min x&quot; (default value -1)</p></li>   <li><p>1 index is &quot;min y&quot; (default value -1)</p></li>   <li><p>2 index is &quot;max x&quot; (default value 1)</p></li>   <li><p>3 index is &quot;max y&quot; (default value 1)</p></li> </ul>  <p> ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#FieldOfView"},
     {"title": "X3DNodes.TOrthoViewpointNode.FieldOfViewMinX", "text": " -1 by default.  ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#FieldOfViewMinX"},
     {"title": "X3DNodes.TOrthoViewpointNode.FieldOfViewMinY", "text": " -1 by default.  ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#FieldOfViewMinY"},
     {"title": "X3DNodes.TOrthoViewpointNode.FieldOfViewMaxX", "text": " 1 by default.  ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#FieldOfViewMaxX"},
     {"title": "X3DNodes.TOrthoViewpointNode.FieldOfViewMaxY", "text": " 1 by default.  ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#FieldOfViewMaxY"},
     {"title": "X3DNodes.TOrthoViewpointNode.FdPosition", "text": " ", "tags": "", "loc": "X3DNodes.TOrthoViewpointNode.html#FdPosition"},
     {"title": "X3DNodes.TViewpointNode", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointNode.html"},
     {"title": "X3DNodes.TViewpointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#CreateNode"},
     {"title": "X3DNodes.TViewpointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TViewpointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#URNMatching"},
     {"title": "X3DNodes.TViewpointNode.ProjectionType", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#ProjectionType"},
     {"title": "X3DNodes.TViewpointNode.AngleOfView", "text": " Result is in radians (just like <a class=\"normal\" href=\"X3DNodes.TViewpointNode.html#FieldOfView\">fieldOfView</a> X3D field).  <p>If you want to calculate horizontal angle of view then pass as ThisToOtherSizeRatio your window's width / height. If you want to calculate vertical angle of view then pass as ThisToOtherSizeRatio your window's height / width. For this method it doesn't really matter which is horizontal and which is vertical, both are treated the same.  <p>This works following X3D spec. So the angle of view for smaller window size is set to <a class=\"normal\" href=\"X3DNodes.TViewpointNode.html#FieldOfView\">fieldOfView</a>. The other angle can always be calculated by <a class=\"normal\" href=\"CastleProjection.html#AdjustViewAngleRadToAspectRatio\">AdjustViewAngleRadToAspectRatio</a> (this implements the same equation that is mentioned in X3D spec). The larger angle cannot be larger than Pi, and may force the smaller angle to be smaller than <a class=\"normal\" href=\"X3DNodes.TViewpointNode.html#FieldOfView\">fieldOfView</a>.    ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#AngleOfView"},
     {"title": "X3DNodes.TViewpointNode.ViewpointAngleOfView", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#ViewpointAngleOfView"},
     {"title": "X3DNodes.TViewpointNode.ViewpointAngleOfView", "text": "  <p>The result is in radians, like the input <a class=\"normal\" href=\"X3DNodes.TViewpointNode.html#FieldOfView\">FieldOfView</a>.    ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#ViewpointAngleOfView"},
     {"title": "X3DNodes.TViewpointNode.ProjectionMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#ProjectionMatrix"},
     {"title": "X3DNodes.TViewpointNode.FdFieldOfView", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#FdFieldOfView"},
     {"title": "X3DNodes.TViewpointNode.FdFieldOfViewForceVertical", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#FdFieldOfViewForceVertical"},
     {"title": "X3DNodes.TViewpointNode.FdPosition", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#FdPosition"},
     {"title": "X3DNodes.TViewpointNode.FieldOfView", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#FieldOfView"},
     {"title": "X3DNodes.TViewpointNode.FieldOfViewForceVertical", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointNode.html#FieldOfViewForceVertical"},
     {"title": "X3DNodes.TViewpointGroupNode", "text": " You can (optionally) arrange viewpoints in groups to present them nicely in the X3D browser submenus. ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html"},
     {"title": "X3DNodes.TViewpointGroupNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TViewpointGroupNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#CreateNode"},
     {"title": "X3DNodes.TViewpointGroupNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#ClassX3DType"},
     {"title": "X3DNodes.TViewpointGroupNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#URNMatching"},
     {"title": "X3DNodes.TViewpointGroupNode.SmartDescription", "text": "    ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#SmartDescription"},
     {"title": "X3DNodes.TViewpointGroupNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#FdCenter"},
     {"title": "X3DNodes.TViewpointGroupNode.FdChildren", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#FdChildren"},
     {"title": "X3DNodes.TViewpointGroupNode.FdDescription", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#FdDescription"},
     {"title": "X3DNodes.TViewpointGroupNode.FdDisplayed", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#FdDisplayed"},
     {"title": "X3DNodes.TViewpointGroupNode.FdRetainUserOffsets", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#FdRetainUserOffsets"},
     {"title": "X3DNodes.TViewpointGroupNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#FdSize"},
     {"title": "X3DNodes.TViewpointGroupNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#Center"},
     {"title": "X3DNodes.TViewpointGroupNode.Description", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#Description"},
     {"title": "X3DNodes.TViewpointGroupNode.Displayed", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#Displayed"},
     {"title": "X3DNodes.TViewpointGroupNode.RetainUserOffsets", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#RetainUserOffsets"},
     {"title": "X3DNodes.TViewpointGroupNode.Size", "text": " ", "tags": "", "loc": "X3DNodes.TViewpointGroupNode.html#Size"},
     {"title": "X3DNodes.TAbstractBackgroundNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html"},
     {"title": "X3DNodes.TAbstractBackgroundNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TAbstractBackgroundNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractBackgroundNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#TransformationChange"},
     {"title": "X3DNodes.TAbstractBackgroundNode.Texture", "text": " May return <code>Nil</code> if none.  <p>It is the caller's responsibility to take care of freeing the result, but only if it's not otherwise used. In other words, use <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#FreeIfUnused\">TX3DNode.FreeIfUnused</a> (or some routine based on it), unless you're sure that you always make the returned node a child of another node (in this case the returned node is always used, and remains managed by parent node).    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#Texture"},
     {"title": "X3DNodes.TAbstractBackgroundNode.TransformRotation", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#TransformRotation"},
     {"title": "X3DNodes.TAbstractBackgroundNode.SetGroundAngle", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#SetGroundAngle"},
     {"title": "X3DNodes.TAbstractBackgroundNode.SetGroundAngle", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#SetGroundAngle"},
     {"title": "X3DNodes.TAbstractBackgroundNode.SetGroundColor", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#SetGroundColor"},
     {"title": "X3DNodes.TAbstractBackgroundNode.SetGroundColor", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#SetGroundColor"},
     {"title": "X3DNodes.TAbstractBackgroundNode.SetSkyAngle", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#SetSkyAngle"},
     {"title": "X3DNodes.TAbstractBackgroundNode.SetSkyAngle", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#SetSkyAngle"},
     {"title": "X3DNodes.TAbstractBackgroundNode.SetSkyColor", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#SetSkyColor"},
     {"title": "X3DNodes.TAbstractBackgroundNode.SetSkyColor", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#SetSkyColor"},
     {"title": "X3DNodes.TAbstractBackgroundNode.FdGroundAngle", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#FdGroundAngle"},
     {"title": "X3DNodes.TAbstractBackgroundNode.FdGroundColor", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#FdGroundColor"},
     {"title": "X3DNodes.TAbstractBackgroundNode.FdSkyAngle", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#FdSkyAngle"},
     {"title": "X3DNodes.TAbstractBackgroundNode.FdSkyColor", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#FdSkyColor"},
     {"title": "X3DNodes.TAbstractBackgroundNode.FdTransparency", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#FdTransparency"},
     {"title": "X3DNodes.TAbstractBackgroundNode.FdShaders", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#FdShaders"},
     {"title": "X3DNodes.TAbstractBackgroundNode.FdEffects", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#FdEffects"},
     {"title": "X3DNodes.TAbstractBackgroundNode.Transparency", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractBackgroundNode.html#Transparency"},
     {"title": "X3DNodes.IAbstractFogObject", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html"},
     {"title": "X3DNodes.IAbstractFogObject.GetFdcolor", "text": "    ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#GetFdcolor"},
     {"title": "X3DNodes.IAbstractFogObject.GetFdfogType", "text": "    ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#GetFdfogType"},
     {"title": "X3DNodes.IAbstractFogObject.GetFdvisibilityRange", "text": "    ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#GetFdvisibilityRange"},
     {"title": "X3DNodes.IAbstractFogObject.GetFdvolumetric", "text": "    ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#GetFdvolumetric"},
     {"title": "X3DNodes.IAbstractFogObject.GetFdvolumetricDirection", "text": "    ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#GetFdvolumetricDirection"},
     {"title": "X3DNodes.IAbstractFogObject.GetFdvolumetricVisibilityStart", "text": "    ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#GetFdvolumetricVisibilityStart"},
     {"title": "X3DNodes.IAbstractFogObject.GetTransformScale", "text": "    ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#GetTransformScale"},
     {"title": "X3DNodes.IAbstractFogObject.FogType", "text": "    ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#FogType"},
     {"title": "X3DNodes.IAbstractFogObject.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#FdColor"},
     {"title": "X3DNodes.IAbstractFogObject.FdFogType", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#FdFogType"},
     {"title": "X3DNodes.IAbstractFogObject.FdVisibilityRange", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#FdVisibilityRange"},
     {"title": "X3DNodes.IAbstractFogObject.FdVolumetric", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#FdVolumetric"},
     {"title": "X3DNodes.IAbstractFogObject.FdVolumetricDirection", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#FdVolumetricDirection"},
     {"title": "X3DNodes.IAbstractFogObject.FdVolumetricVisibilityStart", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#FdVolumetricVisibilityStart"},
     {"title": "X3DNodes.IAbstractFogObject.TransformScale", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractFogObject.html#TransformScale"},
     {"title": "X3DNodes.TBackgroundNode", "text": " ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html"},
     {"title": "X3DNodes.TBackgroundNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#CreateNode"},
     {"title": "X3DNodes.TBackgroundNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBackgroundNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#URNMatching"},
     {"title": "X3DNodes.TBackgroundNode.Texture", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#Texture"},
     {"title": "X3DNodes.TBackgroundNode.SetBackUrl", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetBackUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetBackUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetBackUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetBottomUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetBottomUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetBottomUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetBottomUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetFrontUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetFrontUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetFrontUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetFrontUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetLeftUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetLeftUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetLeftUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetLeftUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetRightUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetRightUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetRightUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetRightUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetTopUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetTopUrl"},
     {"title": "X3DNodes.TBackgroundNode.SetTopUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#SetTopUrl"},
     {"title": "X3DNodes.TBackgroundNode.FdBackUrl", "text": " ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#FdBackUrl"},
     {"title": "X3DNodes.TBackgroundNode.FdBottomUrl", "text": " ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#FdBottomUrl"},
     {"title": "X3DNodes.TBackgroundNode.FdFrontUrl", "text": " ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#FdFrontUrl"},
     {"title": "X3DNodes.TBackgroundNode.FdLeftUrl", "text": " ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#FdLeftUrl"},
     {"title": "X3DNodes.TBackgroundNode.FdRightUrl", "text": " ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#FdRightUrl"},
     {"title": "X3DNodes.TBackgroundNode.FdTopUrl", "text": " ", "tags": "", "loc": "X3DNodes.TBackgroundNode.html#FdTopUrl"},
     {"title": "X3DNodes.TFogNode", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html"},
     {"title": "X3DNodes.TFogNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TFogNode.html#CreateNode"},
     {"title": "X3DNodes.TFogNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TFogNode.html#ClassX3DType"},
     {"title": "X3DNodes.TFogNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TFogNode.html#URNMatching"},
     {"title": "X3DNodes.TFogNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TFogNode.html#TransformationChange"},
     {"title": "X3DNodes.TFogNode.FogType", "text": "    ", "tags": "", "loc": "X3DNodes.TFogNode.html#FogType"},
     {"title": "X3DNodes.TFogNode.FogTypeOrNone", "text": "    ", "tags": "", "loc": "X3DNodes.TFogNode.html#FogTypeOrNone"},
     {"title": "X3DNodes.TFogNode.ApplyFog", "text": "  <p>This can be used by software renderers (ray-tracers etc.) to calculate pixel color following VRML/X3D specifications. After all the lighting is summed up (see TX3DGraphTraverseState.Emission and <a class=\"normal\" href=\"X3DNodes.TLightInstance.html#Contribution\">TLightInstance.Contribution</a>), process color by this method to apply fog.  <p>Does nothing if AFogType = <a class=\"normal\" href=\"X3DNodes.html#ftNone\">ftNone</a>. In this special case, it's also allowed to call this on <code>Nil</code> instance.    ", "tags": "", "loc": "X3DNodes.TFogNode.html#ApplyFog"},
     {"title": "X3DNodes.TFogNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html#FdColor"},
     {"title": "X3DNodes.TFogNode.FdFogType", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html#FdFogType"},
     {"title": "X3DNodes.TFogNode.FdVisibilityRange", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html#FdVisibilityRange"},
     {"title": "X3DNodes.TFogNode.FdVolumetric", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html#FdVolumetric"},
     {"title": "X3DNodes.TFogNode.FdVolumetricDirection", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html#FdVolumetricDirection"},
     {"title": "X3DNodes.TFogNode.FdVolumetricVisibilityStart", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html#FdVolumetricVisibilityStart"},
     {"title": "X3DNodes.TFogNode.FdAlternative", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html#FdAlternative"},
     {"title": "X3DNodes.TFogNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html#Color"},
     {"title": "X3DNodes.TFogNode.VisibilityRange", "text": " ", "tags": "", "loc": "X3DNodes.TFogNode.html#VisibilityRange"},
     {"title": "X3DNodes.TFogCoordinateNode", "text": " ", "tags": "", "loc": "X3DNodes.TFogCoordinateNode.html"},
     {"title": "X3DNodes.TFogCoordinateNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TFogCoordinateNode.html#CreateNode"},
     {"title": "X3DNodes.TFogCoordinateNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TFogCoordinateNode.html#ClassX3DType"},
     {"title": "X3DNodes.TFogCoordinateNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TFogCoordinateNode.html#URNMatching"},
     {"title": "X3DNodes.TFogCoordinateNode.SetDepth", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TFogCoordinateNode.html#SetDepth"},
     {"title": "X3DNodes.TFogCoordinateNode.SetDepth", "text": "    ", "tags": "", "loc": "X3DNodes.TFogCoordinateNode.html#SetDepth"},
     {"title": "X3DNodes.TFogCoordinateNode.FdDepth", "text": " ", "tags": "", "loc": "X3DNodes.TFogCoordinateNode.html#FdDepth"},
     {"title": "X3DNodes.TLocalFogNode", "text": " This is the &quot;local&quot; version of the <a class=\"normal\" href=\"X3DNodes.TFogNode.html\">TFogNode</a>, this affects only the sibling nodes of the <code>LocalFog</code> node, not the whole scene. ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html"},
     {"title": "X3DNodes.TLocalFogNode.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#BeforeTraverse"},
     {"title": "X3DNodes.TLocalFogNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#CreateNode"},
     {"title": "X3DNodes.TLocalFogNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLocalFogNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#URNMatching"},
     {"title": "X3DNodes.TLocalFogNode.FogType", "text": "    ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#FogType"},
     {"title": "X3DNodes.TLocalFogNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#FdColor"},
     {"title": "X3DNodes.TLocalFogNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#FdEnabled"},
     {"title": "X3DNodes.TLocalFogNode.FdFogType", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#FdFogType"},
     {"title": "X3DNodes.TLocalFogNode.FdVisibilityRange", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#FdVisibilityRange"},
     {"title": "X3DNodes.TLocalFogNode.FdVolumetric", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#FdVolumetric"},
     {"title": "X3DNodes.TLocalFogNode.FdVolumetricDirection", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#FdVolumetricDirection"},
     {"title": "X3DNodes.TLocalFogNode.FdVolumetricVisibilityStart", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#FdVolumetricVisibilityStart"},
     {"title": "X3DNodes.TLocalFogNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#Color"},
     {"title": "X3DNodes.TLocalFogNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#Enabled"},
     {"title": "X3DNodes.TLocalFogNode.VisibilityRange", "text": " ", "tags": "", "loc": "X3DNodes.TLocalFogNode.html#VisibilityRange"},
     {"title": "X3DNodes.TTextureBackgroundNode", "text": " This is somewhat more flexible version of the <a class=\"normal\" href=\"X3DNodes.TBackgroundNode.html\">TBackgroundNode</a>, with this you can use e.g. <a class=\"normal\" href=\"X3DNodes.TMovieTextureNode.html\">TMovieTextureNode</a> as the skybox textures. ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html"},
     {"title": "X3DNodes.TTextureBackgroundNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#CreateNode"},
     {"title": "X3DNodes.TTextureBackgroundNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTextureBackgroundNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#URNMatching"},
     {"title": "X3DNodes.TTextureBackgroundNode.Texture", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#Texture"},
     {"title": "X3DNodes.TTextureBackgroundNode.FdBackTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#FdBackTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.FdBottomTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#FdBottomTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.FdFrontTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#FdFrontTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.FdLeftTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#FdLeftTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.FdRightTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#FdRightTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.FdTopTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#FdTopTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.BackTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#BackTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.BottomTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#BottomTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.FrontTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#FrontTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.LeftTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#LeftTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.RightTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#RightTexture"},
     {"title": "X3DNodes.TTextureBackgroundNode.TopTexture", "text": " ", "tags": "", "loc": "X3DNodes.TTextureBackgroundNode.html#TopTexture"},
     {"title": "X3DNodes.TGeoCoordinateNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html"},
     {"title": "X3DNodes.TGeoCoordinateNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoCoordinateNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoCoordinateNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoCoordinateNode.CoordCount", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#CoordCount"},
     {"title": "X3DNodes.TGeoCoordinateNode.SetPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#SetPoint"},
     {"title": "X3DNodes.TGeoCoordinateNode.SetPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#SetPoint"},
     {"title": "X3DNodes.TGeoCoordinateNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoCoordinateNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoCoordinateNode.FdPoint", "text": " ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#FdPoint"},
     {"title": "X3DNodes.TGeoCoordinateNode.FdGeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#FdGeoOrigin"},
     {"title": "X3DNodes.TGeoCoordinateNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoCoordinateNode.GeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoCoordinateNode.html#GeoOrigin"},
     {"title": "X3DNodes.TGeoElevationGridNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html"},
     {"title": "X3DNodes.TGeoElevationGridNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoElevationGridNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoElevationGridNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoElevationGridNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TGeoElevationGridNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#VerticesCount"},
     {"title": "X3DNodes.TGeoElevationGridNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#TrianglesCount"},
     {"title": "X3DNodes.TGeoElevationGridNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoElevationGridNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoElevationGridNode.SetHeight", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#SetHeight"},
     {"title": "X3DNodes.TGeoElevationGridNode.SetHeight", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#SetHeight"},
     {"title": "X3DNodes.TGeoElevationGridNode.EventSet_height", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#EventSet_height"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdColor"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdNormal", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdNormal"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdTexCoord"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdYScale", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdYScale"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdCcw", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdCcw"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdColorPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdColorPerVertex"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdCreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdCreaseAngle"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdGeoGridOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdGeoGridOrigin"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdGeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdGeoOrigin"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdHeight", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdHeight"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdNormalPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdNormalPerVertex"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdSolid"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdXDimension", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdXDimension"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdXSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdXSpacing"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdZDimension", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdZDimension"},
     {"title": "X3DNodes.TGeoElevationGridNode.FdZSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#FdZSpacing"},
     {"title": "X3DNodes.TGeoElevationGridNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#Color"},
     {"title": "X3DNodes.TGeoElevationGridNode.Normal", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#Normal"},
     {"title": "X3DNodes.TGeoElevationGridNode.TexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#TexCoord"},
     {"title": "X3DNodes.TGeoElevationGridNode.YScale", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#YScale"},
     {"title": "X3DNodes.TGeoElevationGridNode.Ccw", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#Ccw"},
     {"title": "X3DNodes.TGeoElevationGridNode.ColorPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#ColorPerVertex"},
     {"title": "X3DNodes.TGeoElevationGridNode.CreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#CreaseAngle"},
     {"title": "X3DNodes.TGeoElevationGridNode.GeoGridOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#GeoGridOrigin"},
     {"title": "X3DNodes.TGeoElevationGridNode.GeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#GeoOrigin"},
     {"title": "X3DNodes.TGeoElevationGridNode.NormalPerVertex", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#NormalPerVertex"},
     {"title": "X3DNodes.TGeoElevationGridNode.XDimension", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#XDimension"},
     {"title": "X3DNodes.TGeoElevationGridNode.XSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#XSpacing"},
     {"title": "X3DNodes.TGeoElevationGridNode.ZDimension", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#ZDimension"},
     {"title": "X3DNodes.TGeoElevationGridNode.ZSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TGeoElevationGridNode.html#ZSpacing"},
     {"title": "X3DNodes.TGeoLocationNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html"},
     {"title": "X3DNodes.TGeoLocationNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoLocationNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoLocationNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoLocationNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoLocationNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoLocationNode.FdGeoCoords", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#FdGeoCoords"},
     {"title": "X3DNodes.TGeoLocationNode.FdGeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#FdGeoOrigin"},
     {"title": "X3DNodes.TGeoLocationNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoLocationNode.GeoCoords", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#GeoCoords"},
     {"title": "X3DNodes.TGeoLocationNode.GeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLocationNode.html#GeoOrigin"},
     {"title": "X3DNodes.TGeoLODNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html"},
     {"title": "X3DNodes.TGeoLODNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoLODNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoLODNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoLODNode.SetChild1Url", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetChild1Url"},
     {"title": "X3DNodes.TGeoLODNode.SetChild1Url", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetChild1Url"},
     {"title": "X3DNodes.TGeoLODNode.SetChild2Url", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetChild2Url"},
     {"title": "X3DNodes.TGeoLODNode.SetChild2Url", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetChild2Url"},
     {"title": "X3DNodes.TGeoLODNode.SetChild3Url", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetChild3Url"},
     {"title": "X3DNodes.TGeoLODNode.SetChild3Url", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetChild3Url"},
     {"title": "X3DNodes.TGeoLODNode.SetChild4Url", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetChild4Url"},
     {"title": "X3DNodes.TGeoLODNode.SetChild4Url", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetChild4Url"},
     {"title": "X3DNodes.TGeoLODNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoLODNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoLODNode.SetRootUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetRootUrl"},
     {"title": "X3DNodes.TGeoLODNode.SetRootUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetRootUrl"},
     {"title": "X3DNodes.TGeoLODNode.SetRootNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#SetRootNode"},
     {"title": "X3DNodes.TGeoLODNode.EventChildren", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#EventChildren"},
     {"title": "X3DNodes.TGeoLODNode.EventLevel_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#EventLevel_changed"},
     {"title": "X3DNodes.TGeoLODNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdCenter"},
     {"title": "X3DNodes.TGeoLODNode.FdChild1Url", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdChild1Url"},
     {"title": "X3DNodes.TGeoLODNode.FdChild2Url", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdChild2Url"},
     {"title": "X3DNodes.TGeoLODNode.FdChild3Url", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdChild3Url"},
     {"title": "X3DNodes.TGeoLODNode.FdChild4Url", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdChild4Url"},
     {"title": "X3DNodes.TGeoLODNode.FdGeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdGeoOrigin"},
     {"title": "X3DNodes.TGeoLODNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoLODNode.FdRange", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdRange"},
     {"title": "X3DNodes.TGeoLODNode.FdRootUrl", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdRootUrl"},
     {"title": "X3DNodes.TGeoLODNode.FdRootNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdRootNode"},
     {"title": "X3DNodes.TGeoLODNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TGeoLODNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#FdBboxSize"},
     {"title": "X3DNodes.TGeoLODNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#Center"},
     {"title": "X3DNodes.TGeoLODNode.GeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#GeoOrigin"},
     {"title": "X3DNodes.TGeoLODNode.Range", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#Range"},
     {"title": "X3DNodes.TGeoLODNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#BboxCenter"},
     {"title": "X3DNodes.TGeoLODNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TGeoLODNode.html#BboxSize"},
     {"title": "X3DNodes.TGeoMetadataNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html"},
     {"title": "X3DNodes.TGeoMetadataNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoMetadataNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoMetadataNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoMetadataNode.SetSummary", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#SetSummary"},
     {"title": "X3DNodes.TGeoMetadataNode.SetSummary", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#SetSummary"},
     {"title": "X3DNodes.TGeoMetadataNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#SetUrl"},
     {"title": "X3DNodes.TGeoMetadataNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#SetUrl"},
     {"title": "X3DNodes.TGeoMetadataNode.FdData", "text": " ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#FdData"},
     {"title": "X3DNodes.TGeoMetadataNode.FdSummary", "text": " ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#FdSummary"},
     {"title": "X3DNodes.TGeoMetadataNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TGeoMetadataNode.html#FdUrl"},
     {"title": "X3DNodes.TGeoOriginNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html"},
     {"title": "X3DNodes.TGeoOriginNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoOriginNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoOriginNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoOriginNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoOriginNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoOriginNode.FdGeoCoords", "text": " ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#FdGeoCoords"},
     {"title": "X3DNodes.TGeoOriginNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoOriginNode.FdRotateYUp", "text": " ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#FdRotateYUp"},
     {"title": "X3DNodes.TGeoOriginNode.GeoCoords", "text": " ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#GeoCoords"},
     {"title": "X3DNodes.TGeoOriginNode.RotateYUp", "text": " ", "tags": "", "loc": "X3DNodes.TGeoOriginNode.html#RotateYUp"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#SetKeyValue"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#FdKeyValue"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.EventGeovalue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#EventGeovalue_changed"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.FdGeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#FdGeoOrigin"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoPositionInterpolatorNode.GeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoPositionInterpolatorNode.html#GeoOrigin"},
     {"title": "X3DNodes.TGeoProximitySensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html"},
     {"title": "X3DNodes.TGeoProximitySensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoProximitySensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoProximitySensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoProximitySensorNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoProximitySensorNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoProximitySensorNode.FdGeoCenter", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#FdGeoCenter"},
     {"title": "X3DNodes.TGeoProximitySensorNode.EventCenterOfRotation_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#EventCenterOfRotation_changed"},
     {"title": "X3DNodes.TGeoProximitySensorNode.EventGeoCoord_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#EventGeoCoord_changed"},
     {"title": "X3DNodes.TGeoProximitySensorNode.EventOrientation_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#EventOrientation_changed"},
     {"title": "X3DNodes.TGeoProximitySensorNode.EventPosition_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#EventPosition_changed"},
     {"title": "X3DNodes.TGeoProximitySensorNode.FdGeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#FdGeoOrigin"},
     {"title": "X3DNodes.TGeoProximitySensorNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoProximitySensorNode.GeoCenter", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#GeoCenter"},
     {"title": "X3DNodes.TGeoProximitySensorNode.GeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoProximitySensorNode.html#GeoOrigin"},
     {"title": "X3DNodes.TGeoTouchSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html"},
     {"title": "X3DNodes.TGeoTouchSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoTouchSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoTouchSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoTouchSensorNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoTouchSensorNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoTouchSensorNode.EventHitNormal_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#EventHitNormal_changed"},
     {"title": "X3DNodes.TGeoTouchSensorNode.EventHitPoint_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#EventHitPoint_changed"},
     {"title": "X3DNodes.TGeoTouchSensorNode.EventHitTexCoord_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#EventHitTexCoord_changed"},
     {"title": "X3DNodes.TGeoTouchSensorNode.EventHitGeoCoord_changed", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#EventHitGeoCoord_changed"},
     {"title": "X3DNodes.TGeoTouchSensorNode.FdGeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#FdGeoOrigin"},
     {"title": "X3DNodes.TGeoTouchSensorNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoTouchSensorNode.GeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTouchSensorNode.html#GeoOrigin"},
     {"title": "X3DNodes.TGeoTransformNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html"},
     {"title": "X3DNodes.TGeoTransformNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoTransformNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoTransformNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoTransformNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoTransformNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoTransformNode.FdGeoCenter", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#FdGeoCenter"},
     {"title": "X3DNodes.TGeoTransformNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#FdRotation"},
     {"title": "X3DNodes.TGeoTransformNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#FdScale"},
     {"title": "X3DNodes.TGeoTransformNode.FdScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#FdScaleOrientation"},
     {"title": "X3DNodes.TGeoTransformNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#FdTranslation"},
     {"title": "X3DNodes.TGeoTransformNode.FdGeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#FdGeoOrigin"},
     {"title": "X3DNodes.TGeoTransformNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoTransformNode.GeoCenter", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#GeoCenter"},
     {"title": "X3DNodes.TGeoTransformNode.Rotation", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#Rotation"},
     {"title": "X3DNodes.TGeoTransformNode.Scale", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#Scale"},
     {"title": "X3DNodes.TGeoTransformNode.ScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#ScaleOrientation"},
     {"title": "X3DNodes.TGeoTransformNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#Translation"},
     {"title": "X3DNodes.TGeoTransformNode.GeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoTransformNode.html#GeoOrigin"},
     {"title": "X3DNodes.TGeoViewpointNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html"},
     {"title": "X3DNodes.TGeoViewpointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#CreateNode"},
     {"title": "X3DNodes.TGeoViewpointNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#Destroy"},
     {"title": "X3DNodes.TGeoViewpointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeoViewpointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#URNMatching"},
     {"title": "X3DNodes.TGeoViewpointNode.SetNavType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#SetNavType"},
     {"title": "X3DNodes.TGeoViewpointNode.SetNavType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#SetNavType"},
     {"title": "X3DNodes.TGeoViewpointNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoViewpointNode.SetGeoSystem", "text": "    ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#SetGeoSystem"},
     {"title": "X3DNodes.TGeoViewpointNode.EventSet_orientation", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#EventSet_orientation"},
     {"title": "X3DNodes.TGeoViewpointNode.EventSet_position", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#EventSet_position"},
     {"title": "X3DNodes.TGeoViewpointNode.FdFieldOfView", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#FdFieldOfView"},
     {"title": "X3DNodes.TGeoViewpointNode.FdHeadlight", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#FdHeadlight"},
     {"title": "X3DNodes.TGeoViewpointNode.FdNavType", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#FdNavType"},
     {"title": "X3DNodes.TGeoViewpointNode.FdGeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#FdGeoOrigin"},
     {"title": "X3DNodes.TGeoViewpointNode.FdGeoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#FdGeoSystem"},
     {"title": "X3DNodes.TGeoViewpointNode.FdPosition", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#FdPosition"},
     {"title": "X3DNodes.TGeoViewpointNode.FdSpeedFactor", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#FdSpeedFactor"},
     {"title": "X3DNodes.TGeoViewpointNode.FieldOfView", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#FieldOfView"},
     {"title": "X3DNodes.TGeoViewpointNode.Headlight", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#Headlight"},
     {"title": "X3DNodes.TGeoViewpointNode.GeoOrigin", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#GeoOrigin"},
     {"title": "X3DNodes.TGeoViewpointNode.SpeedFactor", "text": " ", "tags": "", "loc": "X3DNodes.TGeoViewpointNode.html#SpeedFactor"},
     {"title": "X3DNodes.THAnimDisplacerNode", "text": " For example, different HAnimDisplacer may be used for each facial expression. ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html"},
     {"title": "X3DNodes.THAnimDisplacerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#CreateNode"},
     {"title": "X3DNodes.THAnimDisplacerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#ClassX3DType"},
     {"title": "X3DNodes.THAnimDisplacerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#URNMatching"},
     {"title": "X3DNodes.THAnimDisplacerNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#SetCoordIndex"},
     {"title": "X3DNodes.THAnimDisplacerNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#SetCoordIndex"},
     {"title": "X3DNodes.THAnimDisplacerNode.SetDisplacements", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#SetDisplacements"},
     {"title": "X3DNodes.THAnimDisplacerNode.SetDisplacements", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#SetDisplacements"},
     {"title": "X3DNodes.THAnimDisplacerNode.FdCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#FdCoordIndex"},
     {"title": "X3DNodes.THAnimDisplacerNode.FdDisplacements", "text": " ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#FdDisplacements"},
     {"title": "X3DNodes.THAnimDisplacerNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#FdName"},
     {"title": "X3DNodes.THAnimDisplacerNode.FdWeight", "text": " ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#FdWeight"},
     {"title": "X3DNodes.THAnimDisplacerNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#NameField"},
     {"title": "X3DNodes.THAnimDisplacerNode.Weight", "text": " ", "tags": "", "loc": "X3DNodes.THAnimDisplacerNode.html#Weight"},
     {"title": "X3DNodes.TVertexJoints", "text": " ", "tags": "", "loc": "X3DNodes.TVertexJoints.html"},
     {"title": "X3DNodes.TVertexJoints.RestPosition", "text": " ", "tags": "", "loc": "X3DNodes.TVertexJoints.html#RestPosition"},
     {"title": "X3DNodes.TVertexJoints.Count", "text": " ", "tags": "", "loc": "X3DNodes.TVertexJoints.html#Count"},
     {"title": "X3DNodes.TVertexJoints.Joints", "text": " ", "tags": "", "loc": "X3DNodes.TVertexJoints.html#Joints"},
     {"title": "X3DNodes.TVertexJoints.Weights", "text": " ", "tags": "", "loc": "X3DNodes.TVertexJoints.html#Weights"},
     {"title": "X3DNodes.TVertexJoints.Add", "text": "    ", "tags": "", "loc": "X3DNodes.TVertexJoints.html#Add"},
     {"title": "X3DNodes.THAnimHumanoidNode", "text": " It contains the skeleton, and other information necessary for animation. ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html"},
     {"title": "X3DNodes.THAnimHumanoidNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.THAnimHumanoidNode.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#BeforeTraverse"},
     {"title": "X3DNodes.THAnimHumanoidNode.AfterTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#AfterTraverse"},
     {"title": "X3DNodes.THAnimHumanoidNode.ParseAfter", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#ParseAfter"},
     {"title": "X3DNodes.THAnimHumanoidNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#CreateNode"},
     {"title": "X3DNodes.THAnimHumanoidNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#Destroy"},
     {"title": "X3DNodes.THAnimHumanoidNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#ClassX3DType"},
     {"title": "X3DNodes.THAnimHumanoidNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#URNMatching"},
     {"title": "X3DNodes.THAnimHumanoidNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#TransformationChange"},
     {"title": "X3DNodes.THAnimHumanoidNode.AnimateSkin", "text": " Joints that changed are assumed to be already traversed by <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Traverse\">TX3DNode.Traverse</a> (this prepares field values for AnimateSkinPoint call).  <p>This method is used by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>. Don't call this yourself.  <p>Returns changed VRML/X3D coordinates field (or <code>Nil</code> if there is no skin). You should call <a class=\"normal\" href=\"X3DFields.TX3DField.html#Changed\">TX3DField.Changed</a> on it (unless you use it from some <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> initialization, when there's no point in notifying about this).    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#AnimateSkin"},
     {"title": "X3DNodes.THAnimHumanoidNode.SetInfo", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#SetInfo"},
     {"title": "X3DNodes.THAnimHumanoidNode.SetInfo", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#SetInfo"},
     {"title": "X3DNodes.THAnimHumanoidNode.SetJoints", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#SetJoints"},
     {"title": "X3DNodes.THAnimHumanoidNode.SetSegments", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#SetSegments"},
     {"title": "X3DNodes.THAnimHumanoidNode.SetSites", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#SetSites"},
     {"title": "X3DNodes.THAnimHumanoidNode.SetSkin", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#SetSkin"},
     {"title": "X3DNodes.THAnimHumanoidNode.SetViewpoints", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#SetViewpoints"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdCenter"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdInfo", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdInfo"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdJoints", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdJoints"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdName"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdRotation"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdScale"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdScaleOrientation"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdSegments", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdSegments"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdSites", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdSites"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdSkeleton", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdSkeleton"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdSkin", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdSkin"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdSkinCoord", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdSkinCoord"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdSkinNormal", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdSkinNormal"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdTranslation"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdVersion", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdVersion"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdViewpoints", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdViewpoints"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdBboxCenter"},
     {"title": "X3DNodes.THAnimHumanoidNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#FdBboxSize"},
     {"title": "X3DNodes.THAnimHumanoidNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#Center"},
     {"title": "X3DNodes.THAnimHumanoidNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#NameField"},
     {"title": "X3DNodes.THAnimHumanoidNode.Rotation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#Rotation"},
     {"title": "X3DNodes.THAnimHumanoidNode.Scale", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#Scale"},
     {"title": "X3DNodes.THAnimHumanoidNode.ScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#ScaleOrientation"},
     {"title": "X3DNodes.THAnimHumanoidNode.SkinNormal", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#SkinNormal"},
     {"title": "X3DNodes.THAnimHumanoidNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#Translation"},
     {"title": "X3DNodes.THAnimHumanoidNode.Version", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#Version"},
     {"title": "X3DNodes.THAnimHumanoidNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#BboxCenter"},
     {"title": "X3DNodes.THAnimHumanoidNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.THAnimHumanoidNode.html#BboxSize"},
     {"title": "X3DNodes.THAnimJointNode", "text": " Joints are organized in a hierarchy, like bones. ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html"},
     {"title": "X3DNodes.THAnimJointNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.THAnimJointNode.ApplyTransform", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#ApplyTransform"},
     {"title": "X3DNodes.THAnimJointNode.ParseAfter", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#ParseAfter"},
     {"title": "X3DNodes.THAnimJointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#CreateNode"},
     {"title": "X3DNodes.THAnimJointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#ClassX3DType"},
     {"title": "X3DNodes.THAnimJointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#URNMatching"},
     {"title": "X3DNodes.THAnimJointNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#TransformationChange"},
     {"title": "X3DNodes.THAnimJointNode.SetDisplacers", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetDisplacers"},
     {"title": "X3DNodes.THAnimJointNode.SetLlimit", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetLlimit"},
     {"title": "X3DNodes.THAnimJointNode.SetLlimit", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetLlimit"},
     {"title": "X3DNodes.THAnimJointNode.SetSkinCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetSkinCoordIndex"},
     {"title": "X3DNodes.THAnimJointNode.SetSkinCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetSkinCoordIndex"},
     {"title": "X3DNodes.THAnimJointNode.SetSkinCoordWeight", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetSkinCoordWeight"},
     {"title": "X3DNodes.THAnimJointNode.SetSkinCoordWeight", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetSkinCoordWeight"},
     {"title": "X3DNodes.THAnimJointNode.SetStiffness", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetStiffness"},
     {"title": "X3DNodes.THAnimJointNode.SetStiffness", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetStiffness"},
     {"title": "X3DNodes.THAnimJointNode.SetUlimit", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetUlimit"},
     {"title": "X3DNodes.THAnimJointNode.SetUlimit", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#SetUlimit"},
     {"title": "X3DNodes.THAnimJointNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdCenter"},
     {"title": "X3DNodes.THAnimJointNode.FdDisplacers", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdDisplacers"},
     {"title": "X3DNodes.THAnimJointNode.FdLimitOrientation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdLimitOrientation"},
     {"title": "X3DNodes.THAnimJointNode.FdLlimit", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdLlimit"},
     {"title": "X3DNodes.THAnimJointNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdName"},
     {"title": "X3DNodes.THAnimJointNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdRotation"},
     {"title": "X3DNodes.THAnimJointNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdScale"},
     {"title": "X3DNodes.THAnimJointNode.FdScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdScaleOrientation"},
     {"title": "X3DNodes.THAnimJointNode.FdSkinCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdSkinCoordIndex"},
     {"title": "X3DNodes.THAnimJointNode.FdSkinCoordWeight", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdSkinCoordWeight"},
     {"title": "X3DNodes.THAnimJointNode.FdStiffness", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdStiffness"},
     {"title": "X3DNodes.THAnimJointNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdTranslation"},
     {"title": "X3DNodes.THAnimJointNode.FdUlimit", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#FdUlimit"},
     {"title": "X3DNodes.THAnimJointNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#Center"},
     {"title": "X3DNodes.THAnimJointNode.LimitOrientation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#LimitOrientation"},
     {"title": "X3DNodes.THAnimJointNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#NameField"},
     {"title": "X3DNodes.THAnimJointNode.Rotation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#Rotation"},
     {"title": "X3DNodes.THAnimJointNode.Scale", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#Scale"},
     {"title": "X3DNodes.THAnimJointNode.ScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#ScaleOrientation"},
     {"title": "X3DNodes.THAnimJointNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimJointNode.html#Translation"},
     {"title": "X3DNodes.THAnimSegmentNode", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html"},
     {"title": "X3DNodes.THAnimSegmentNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.THAnimSegmentNode.ApplyTransform", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#ApplyTransform"},
     {"title": "X3DNodes.THAnimSegmentNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#CreateNode"},
     {"title": "X3DNodes.THAnimSegmentNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#ClassX3DType"},
     {"title": "X3DNodes.THAnimSegmentNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#URNMatching"},
     {"title": "X3DNodes.THAnimSegmentNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#TransformationChange"},
     {"title": "X3DNodes.THAnimSegmentNode.SetDisplacers", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#SetDisplacers"},
     {"title": "X3DNodes.THAnimSegmentNode.SetMomentsOfInertia", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#SetMomentsOfInertia"},
     {"title": "X3DNodes.THAnimSegmentNode.SetMomentsOfInertia", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#SetMomentsOfInertia"},
     {"title": "X3DNodes.THAnimSegmentNode.FdCenterOfMass", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#FdCenterOfMass"},
     {"title": "X3DNodes.THAnimSegmentNode.FdCoord", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#FdCoord"},
     {"title": "X3DNodes.THAnimSegmentNode.FdDisplacers", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#FdDisplacers"},
     {"title": "X3DNodes.THAnimSegmentNode.FdMass", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#FdMass"},
     {"title": "X3DNodes.THAnimSegmentNode.FdMomentsOfInertia", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#FdMomentsOfInertia"},
     {"title": "X3DNodes.THAnimSegmentNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#FdName"},
     {"title": "X3DNodes.THAnimSegmentNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#FdRotation"},
     {"title": "X3DNodes.THAnimSegmentNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#FdScale"},
     {"title": "X3DNodes.THAnimSegmentNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#FdTranslation"},
     {"title": "X3DNodes.THAnimSegmentNode.CenterOfMass", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#CenterOfMass"},
     {"title": "X3DNodes.THAnimSegmentNode.Coord", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#Coord"},
     {"title": "X3DNodes.THAnimSegmentNode.Mass", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#Mass"},
     {"title": "X3DNodes.THAnimSegmentNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSegmentNode.html#NameField"},
     {"title": "X3DNodes.THAnimSiteNode", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html"},
     {"title": "X3DNodes.THAnimSiteNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.THAnimSiteNode.ApplyTransform", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#ApplyTransform"},
     {"title": "X3DNodes.THAnimSiteNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#CreateNode"},
     {"title": "X3DNodes.THAnimSiteNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#ClassX3DType"},
     {"title": "X3DNodes.THAnimSiteNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#URNMatching"},
     {"title": "X3DNodes.THAnimSiteNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#TransformationChange"},
     {"title": "X3DNodes.THAnimSiteNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#FdCenter"},
     {"title": "X3DNodes.THAnimSiteNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#FdName"},
     {"title": "X3DNodes.THAnimSiteNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#FdRotation"},
     {"title": "X3DNodes.THAnimSiteNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#FdScale"},
     {"title": "X3DNodes.THAnimSiteNode.FdScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#FdScaleOrientation"},
     {"title": "X3DNodes.THAnimSiteNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#FdTranslation"},
     {"title": "X3DNodes.THAnimSiteNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#Center"},
     {"title": "X3DNodes.THAnimSiteNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#NameField"},
     {"title": "X3DNodes.THAnimSiteNode.Rotation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#Rotation"},
     {"title": "X3DNodes.THAnimSiteNode.Scale", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#Scale"},
     {"title": "X3DNodes.THAnimSiteNode.ScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#ScaleOrientation"},
     {"title": "X3DNodes.THAnimSiteNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.THAnimSiteNode.html#Translation"},
     {"title": "X3DNodes.TAbstractNurbsControlCurveNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsControlCurveNode.html"},
     {"title": "X3DNodes.TAbstractNurbsControlCurveNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsControlCurveNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractNurbsControlCurveNode.SetControlPoint", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsControlCurveNode.html#SetControlPoint"},
     {"title": "X3DNodes.TAbstractNurbsControlCurveNode.SetControlPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsControlCurveNode.html#SetControlPoint"},
     {"title": "X3DNodes.TAbstractNurbsControlCurveNode.FdControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsControlCurveNode.html#FdControlPoint"},
     {"title": "X3DNodes.TAbstractParametricGeometryNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParametricGeometryNode.html"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#Proxy"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#BoundingBox"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#TrianglesCount"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.InternalCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#InternalCoord"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#SolidField"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#SetWeight"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#SetWeight"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.SetUKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#SetUKnot"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.SetUKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#SetUKnot"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.SetVKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#SetVKnot"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.SetVKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#SetVKnot"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdControlPoint"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdTexCoord"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdUTessellation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdUTessellation"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdVTessellation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdVTessellation"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdWeight", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdWeight"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdSolid"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdUClosed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdUClosed"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdUDimension", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdUDimension"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdUKnot", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdUKnot"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdUOrder", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdUOrder"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdVClosed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdVClosed"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdVDimension", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdVDimension"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdVKnot", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdVKnot"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.FdVOrder", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#FdVOrder"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.ControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#ControlPoint"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.UTessellation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#UTessellation"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.VTessellation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#VTessellation"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.UClosed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#UClosed"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.UDimension", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#UDimension"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.UOrder", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#UOrder"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.VClosed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#VClosed"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.VDimension", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#VDimension"},
     {"title": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.VOrder", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNurbsSurfaceGeometryNode.html#VOrder"},
     {"title": "X3DNodes.TContour2DNode", "text": "  <p>X3D cannot share implementation with VRML 2.0 version (<a class=\"normal\" href=\"X3DNodes.TContour2DNode_2.html\">TContour2DNode_2</a>), since for VRML 2.0 this is a valid geometry node (<a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a> descendant). ", "tags": "", "loc": "X3DNodes.TContour2DNode.html"},
     {"title": "X3DNodes.TContour2DNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TContour2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode.html#CreateNode"},
     {"title": "X3DNodes.TContour2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TContour2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode.html#URNMatching"},
     {"title": "X3DNodes.TContour2DNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TContour2DNode.EventAddChildren", "text": " ", "tags": "", "loc": "X3DNodes.TContour2DNode.html#EventAddChildren"},
     {"title": "X3DNodes.TContour2DNode.EventRemoveChildren", "text": " ", "tags": "", "loc": "X3DNodes.TContour2DNode.html#EventRemoveChildren"},
     {"title": "X3DNodes.TContour2DNode.FdChildren", "text": " ", "tags": "", "loc": "X3DNodes.TContour2DNode.html#FdChildren"},
     {"title": "X3DNodes.TContourPolyline2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TContourPolyline2DNode.html"},
     {"title": "X3DNodes.TContourPolyline2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TContourPolyline2DNode.html#CreateNode"},
     {"title": "X3DNodes.TContourPolyline2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TContourPolyline2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TContourPolyline2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TContourPolyline2DNode.html#URNMatching"},
     {"title": "X3DNodes.TCoordinateDoubleNode", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDoubleNode.html"},
     {"title": "X3DNodes.TCoordinateDoubleNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDoubleNode.html#CreateNode"},
     {"title": "X3DNodes.TCoordinateDoubleNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDoubleNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCoordinateDoubleNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDoubleNode.html#URNMatching"},
     {"title": "X3DNodes.TCoordinateDoubleNode.CoordCount", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDoubleNode.html#CoordCount"},
     {"title": "X3DNodes.TCoordinateDoubleNode.SetPoint", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TCoordinateDoubleNode.html#SetPoint"},
     {"title": "X3DNodes.TCoordinateDoubleNode.SetPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDoubleNode.html#SetPoint"},
     {"title": "X3DNodes.TCoordinateDoubleNode.FdPoint", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDoubleNode.html#FdPoint"},
     {"title": "X3DNodes.TNurbsCurveNode", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html"},
     {"title": "X3DNodes.TNurbsCurveNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TNurbsCurveNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsCurveNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsCurveNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsCurveNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TNurbsCurveNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#Proxy"},
     {"title": "X3DNodes.TNurbsCurveNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TNurbsCurveNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TNurbsCurveNode.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#BoundingBox"},
     {"title": "X3DNodes.TNurbsCurveNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#TrianglesCount"},
     {"title": "X3DNodes.TNurbsCurveNode.InternalCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#InternalCoord"},
     {"title": "X3DNodes.TNurbsCurveNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsCurveNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsCurveNode.SetKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#SetKnot"},
     {"title": "X3DNodes.TNurbsCurveNode.SetKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#SetKnot"},
     {"title": "X3DNodes.TNurbsCurveNode.FdControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#FdControlPoint"},
     {"title": "X3DNodes.TNurbsCurveNode.FdTessellation", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#FdTessellation"},
     {"title": "X3DNodes.TNurbsCurveNode.FdWeight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#FdWeight"},
     {"title": "X3DNodes.TNurbsCurveNode.FdClosed", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#FdClosed"},
     {"title": "X3DNodes.TNurbsCurveNode.FdKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#FdKnot"},
     {"title": "X3DNodes.TNurbsCurveNode.FdOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#FdOrder"},
     {"title": "X3DNodes.TNurbsCurveNode.ControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#ControlPoint"},
     {"title": "X3DNodes.TNurbsCurveNode.Tessellation", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#Tessellation"},
     {"title": "X3DNodes.TNurbsCurveNode.Closed", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#Closed"},
     {"title": "X3DNodes.TNurbsCurveNode.Order", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode.html#Order"},
     {"title": "X3DNodes.TNurbsCurve2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html"},
     {"title": "X3DNodes.TNurbsCurve2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsCurve2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsCurve2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsCurve2DNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsCurve2DNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsCurve2DNode.SetKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#SetKnot"},
     {"title": "X3DNodes.TNurbsCurve2DNode.SetKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#SetKnot"},
     {"title": "X3DNodes.TNurbsCurve2DNode.FdTessellation", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#FdTessellation"},
     {"title": "X3DNodes.TNurbsCurve2DNode.FdWeight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#FdWeight"},
     {"title": "X3DNodes.TNurbsCurve2DNode.FdClosed", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#FdClosed"},
     {"title": "X3DNodes.TNurbsCurve2DNode.FdKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#FdKnot"},
     {"title": "X3DNodes.TNurbsCurve2DNode.FdOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#FdOrder"},
     {"title": "X3DNodes.TNurbsCurve2DNode.Tessellation", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#Tessellation"},
     {"title": "X3DNodes.TNurbsCurve2DNode.Closed", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#Closed"},
     {"title": "X3DNodes.TNurbsCurve2DNode.Order", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurve2DNode.html#Order"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.SetKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#SetKnot"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.SetKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#SetKnot"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.EventSet_fraction", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#EventSet_fraction"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.FdControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#FdControlPoint"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.FdKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#FdKnot"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.FdOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#FdOrder"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.FdWeight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#FdWeight"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.ControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#ControlPoint"},
     {"title": "X3DNodes.TNurbsOrientationInterpolatorNode.Order", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsOrientationInterpolatorNode.html#Order"},
     {"title": "X3DNodes.TNurbsPatchSurfaceNode", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPatchSurfaceNode.html"},
     {"title": "X3DNodes.TNurbsPatchSurfaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPatchSurfaceNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsPatchSurfaceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPatchSurfaceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsPatchSurfaceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPatchSurfaceNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.SetKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#SetKnot"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.SetKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#SetKnot"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.EventSet_fraction", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#EventSet_fraction"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.FdControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#FdControlPoint"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.FdKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#FdKnot"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.FdOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#FdOrder"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.FdWeight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#FdWeight"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#EventValue_changed"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.ControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#ControlPoint"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode.Order", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode.html#Order"},
     {"title": "X3DNodes.TNurbsSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html"},
     {"title": "X3DNodes.TNurbsSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsSetNode.SetGeometry", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#SetGeometry"},
     {"title": "X3DNodes.TNurbsSetNode.EventAddGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#EventAddGeometry"},
     {"title": "X3DNodes.TNurbsSetNode.EventRemoveGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#EventRemoveGeometry"},
     {"title": "X3DNodes.TNurbsSetNode.FdGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#FdGeometry"},
     {"title": "X3DNodes.TNurbsSetNode.FdTessellationScale", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#FdTessellationScale"},
     {"title": "X3DNodes.TNurbsSetNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TNurbsSetNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#FdBboxSize"},
     {"title": "X3DNodes.TNurbsSetNode.TessellationScale", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#TessellationScale"},
     {"title": "X3DNodes.TNurbsSetNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#BboxCenter"},
     {"title": "X3DNodes.TNurbsSetNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSetNode.html#BboxSize"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.SetUKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#SetUKnot"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.SetUKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#SetUKnot"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.SetVKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#SetVKnot"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.SetVKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#SetVKnot"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.EventSet_fraction", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#EventSet_fraction"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.FdControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#FdControlPoint"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.FdWeight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#FdWeight"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.EventPosition_changed", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#EventPosition_changed"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.EventNormal_changed", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#EventNormal_changed"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.FdUDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#FdUDimension"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.FdUKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#FdUKnot"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.FdUOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#FdUOrder"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.FdVDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#FdVDimension"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.FdVKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#FdVKnot"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.FdVOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#FdVOrder"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.ControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#ControlPoint"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.UDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#UDimension"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.UOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#UOrder"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.VDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#VDimension"},
     {"title": "X3DNodes.TNurbsSurfaceInterpolatorNode.VOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceInterpolatorNode.html#VOrder"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#SolidField"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#VerticesCount"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#TrianglesCount"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.FdCrossSectionCurve", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#FdCrossSectionCurve"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.FdTrajectoryCurve", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#FdTrajectoryCurve"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.FdCcw", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#FdCcw"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#FdSolid"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.CrossSectionCurve", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#CrossSectionCurve"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.TrajectoryCurve", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#TrajectoryCurve"},
     {"title": "X3DNodes.TNurbsSweptSurfaceNode.Ccw", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSweptSurfaceNode.html#Ccw"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#SolidField"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#VerticesCount"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#TrianglesCount"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.FdProfileCurve", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#FdProfileCurve"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.FdTrajectoryCurve", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#FdTrajectoryCurve"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.FdCcw", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#FdCcw"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#FdSolid"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.ProfileCurve", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#ProfileCurve"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.TrajectoryCurve", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#TrajectoryCurve"},
     {"title": "X3DNodes.TNurbsSwungSurfaceNode.Ccw", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSwungSurfaceNode.html#Ccw"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode", "text": " <b>Not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.SetControlPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#SetControlPoint"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.SetControlPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#SetControlPoint"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.SetWeight", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#SetWeight"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.SetUKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#SetUKnot"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.SetUKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#SetUKnot"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.SetVKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#SetVKnot"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.SetVKnot", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#SetVKnot"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.FdControlPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#FdControlPoint"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.FdWeight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#FdWeight"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.FdUDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#FdUDimension"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.FdUKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#FdUKnot"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.FdUOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#FdUOrder"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.FdVDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#FdVDimension"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.FdVKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#FdVKnot"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.FdVOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#FdVOrder"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.UDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#UDimension"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.UOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#UOrder"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.VDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#VDimension"},
     {"title": "X3DNodes.TNurbsTextureCoordinateNode.VOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureCoordinateNode.html#VOrder"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode", "text": "  <p><b>The trimming is not implemented yet. This is rendered exactly like the normal <a class=\"normal\" href=\"X3DNodes.TNurbsPatchSurfaceNode.html\">TNurbsPatchSurfaceNode</a>.</b> ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html#Proxy"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode.SetTrimmingContour", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html#SetTrimmingContour"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode.EventAddTrimmingContour", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html#EventAddTrimmingContour"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode.EventRemoveTrimmingContour", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html#EventRemoveTrimmingContour"},
     {"title": "X3DNodes.TNurbsTrimmedSurfaceNode.FdTrimmingContour", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTrimmedSurfaceNode.html#FdTrimmingContour"},
     {"title": "X3DNodes.TDISEntityManagerNode", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html"},
     {"title": "X3DNodes.TDISEntityManagerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#CreateNode"},
     {"title": "X3DNodes.TDISEntityManagerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TDISEntityManagerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#URNMatching"},
     {"title": "X3DNodes.TDISEntityManagerNode.SetMapping", "text": "    ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#SetMapping"},
     {"title": "X3DNodes.TDISEntityManagerNode.FdAddress", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#FdAddress"},
     {"title": "X3DNodes.TDISEntityManagerNode.FdApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#FdApplicationID"},
     {"title": "X3DNodes.TDISEntityManagerNode.FdMapping", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#FdMapping"},
     {"title": "X3DNodes.TDISEntityManagerNode.FdPort", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#FdPort"},
     {"title": "X3DNodes.TDISEntityManagerNode.FdSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#FdSiteID"},
     {"title": "X3DNodes.TDISEntityManagerNode.EventAddedEntities", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#EventAddedEntities"},
     {"title": "X3DNodes.TDISEntityManagerNode.EventRemovedEntities", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#EventRemovedEntities"},
     {"title": "X3DNodes.TDISEntityManagerNode.Address", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#Address"},
     {"title": "X3DNodes.TDISEntityManagerNode.ApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#ApplicationID"},
     {"title": "X3DNodes.TDISEntityManagerNode.Port", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#Port"},
     {"title": "X3DNodes.TDISEntityManagerNode.SiteID", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityManagerNode.html#SiteID"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#CreateNode"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#ClassX3DType"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#URNMatching"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#SetUrl"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#SetUrl"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#FdUrl"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.FdCategory", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#FdCategory"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.FdCountry", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#FdCountry"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.FdDomain", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#FdDomain"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.FdExtra", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#FdExtra"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.FdKind", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#FdKind"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.FdSpecific", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#FdSpecific"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.FdSubcategory", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#FdSubcategory"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.Category", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#Category"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.Country", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#Country"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.Domain", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#Domain"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.Extra", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#Extra"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.Kind", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#Kind"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.Specific", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#Specific"},
     {"title": "X3DNodes.TDISEntityTypeMappingNode.Subcategory", "text": " ", "tags": "", "loc": "X3DNodes.TDISEntityTypeMappingNode.html#Subcategory"},
     {"title": "X3DNodes.TEspduTransformNode", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html"},
     {"title": "X3DNodes.TEspduTransformNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#CreateNode"},
     {"title": "X3DNodes.TEspduTransformNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#ClassX3DType"},
     {"title": "X3DNodes.TEspduTransformNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#URNMatching"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterDesignatorArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterDesignatorArray"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterDesignatorArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterDesignatorArray"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterChangeIndicatorArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterChangeIndicatorArray"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterChangeIndicatorArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterChangeIndicatorArray"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterIdPartAttachedToArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterIdPartAttachedToArray"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterIdPartAttachedToArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterIdPartAttachedToArray"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterTypeArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterTypeArray"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterTypeArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterTypeArray"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterArray"},
     {"title": "X3DNodes.TEspduTransformNode.SetArticulationParameterArray", "text": "    ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SetArticulationParameterArray"},
     {"title": "X3DNodes.TEspduTransformNode.EventSet_articulationParameterValue0", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventSet_articulationParameterValue0"},
     {"title": "X3DNodes.TEspduTransformNode.EventSet_articulationParameterValue1", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventSet_articulationParameterValue1"},
     {"title": "X3DNodes.TEspduTransformNode.EventSet_articulationParameterValue2", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventSet_articulationParameterValue2"},
     {"title": "X3DNodes.TEspduTransformNode.EventSet_articulationParameterValue3", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventSet_articulationParameterValue3"},
     {"title": "X3DNodes.TEspduTransformNode.EventSet_articulationParameterValue4", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventSet_articulationParameterValue4"},
     {"title": "X3DNodes.TEspduTransformNode.EventSet_articulationParameterValue5", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventSet_articulationParameterValue5"},
     {"title": "X3DNodes.TEspduTransformNode.EventSet_articulationParameterValue6", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventSet_articulationParameterValue6"},
     {"title": "X3DNodes.TEspduTransformNode.EventSet_articulationParameterValue7", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventSet_articulationParameterValue7"},
     {"title": "X3DNodes.TEspduTransformNode.FdAddress", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdAddress"},
     {"title": "X3DNodes.TEspduTransformNode.FdApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdApplicationID"},
     {"title": "X3DNodes.TEspduTransformNode.FdArticulationParameterCount", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdArticulationParameterCount"},
     {"title": "X3DNodes.TEspduTransformNode.FdArticulationParameterDesignatorArray", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdArticulationParameterDesignatorArray"},
     {"title": "X3DNodes.TEspduTransformNode.FdArticulationParameterChangeIndicatorArray", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdArticulationParameterChangeIndicatorArray"},
     {"title": "X3DNodes.TEspduTransformNode.FdArticulationParameterIdPartAttachedToArray", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdArticulationParameterIdPartAttachedToArray"},
     {"title": "X3DNodes.TEspduTransformNode.FdArticulationParameterTypeArray", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdArticulationParameterTypeArray"},
     {"title": "X3DNodes.TEspduTransformNode.FdArticulationParameterArray", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdArticulationParameterArray"},
     {"title": "X3DNodes.TEspduTransformNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdCenter"},
     {"title": "X3DNodes.TEspduTransformNode.FdCollisionType", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdCollisionType"},
     {"title": "X3DNodes.TEspduTransformNode.FdDeadReckoning", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdDeadReckoning"},
     {"title": "X3DNodes.TEspduTransformNode.FdDetonationLocation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdDetonationLocation"},
     {"title": "X3DNodes.TEspduTransformNode.FdDetonationRelativeLocation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdDetonationRelativeLocation"},
     {"title": "X3DNodes.TEspduTransformNode.FdDetonationResult", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdDetonationResult"},
     {"title": "X3DNodes.TEspduTransformNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEnabled"},
     {"title": "X3DNodes.TEspduTransformNode.FdEntityCategory", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEntityCategory"},
     {"title": "X3DNodes.TEspduTransformNode.FdEntityCountry", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEntityCountry"},
     {"title": "X3DNodes.TEspduTransformNode.FdEntityDomain", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEntityDomain"},
     {"title": "X3DNodes.TEspduTransformNode.FdEntityExtra", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEntityExtra"},
     {"title": "X3DNodes.TEspduTransformNode.FdEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEntityID"},
     {"title": "X3DNodes.TEspduTransformNode.FdEntityKind", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEntityKind"},
     {"title": "X3DNodes.TEspduTransformNode.FdEntitySpecific", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEntitySpecific"},
     {"title": "X3DNodes.TEspduTransformNode.FdEntitySubCategory", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEntitySubCategory"},
     {"title": "X3DNodes.TEspduTransformNode.FdEventApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEventApplicationID"},
     {"title": "X3DNodes.TEspduTransformNode.FdEventEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEventEntityID"},
     {"title": "X3DNodes.TEspduTransformNode.FdEventNumber", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEventNumber"},
     {"title": "X3DNodes.TEspduTransformNode.FdEventSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdEventSiteID"},
     {"title": "X3DNodes.TEspduTransformNode.FdFired1", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdFired1"},
     {"title": "X3DNodes.TEspduTransformNode.FdFired2", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdFired2"},
     {"title": "X3DNodes.TEspduTransformNode.FdFireMissionIndex", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdFireMissionIndex"},
     {"title": "X3DNodes.TEspduTransformNode.FdFiringRange", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdFiringRange"},
     {"title": "X3DNodes.TEspduTransformNode.FdFiringRate", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdFiringRate"},
     {"title": "X3DNodes.TEspduTransformNode.FdForceID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdForceID"},
     {"title": "X3DNodes.TEspduTransformNode.FdFuse", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdFuse"},
     {"title": "X3DNodes.TEspduTransformNode.FdLinearVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdLinearVelocity"},
     {"title": "X3DNodes.TEspduTransformNode.FdLinearAcceleration", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdLinearAcceleration"},
     {"title": "X3DNodes.TEspduTransformNode.FdMarking", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdMarking"},
     {"title": "X3DNodes.TEspduTransformNode.FdMulticastRelayHost", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdMulticastRelayHost"},
     {"title": "X3DNodes.TEspduTransformNode.FdMulticastRelayPort", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdMulticastRelayPort"},
     {"title": "X3DNodes.TEspduTransformNode.FdMunitionApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdMunitionApplicationID"},
     {"title": "X3DNodes.TEspduTransformNode.FdMunitionEndPoint", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdMunitionEndPoint"},
     {"title": "X3DNodes.TEspduTransformNode.FdMunitionEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdMunitionEntityID"},
     {"title": "X3DNodes.TEspduTransformNode.FdMunitionQuantity", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdMunitionQuantity"},
     {"title": "X3DNodes.TEspduTransformNode.FdMunitionSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdMunitionSiteID"},
     {"title": "X3DNodes.TEspduTransformNode.FdMunitionStartPoint", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdMunitionStartPoint"},
     {"title": "X3DNodes.TEspduTransformNode.FdNetworkMode", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdNetworkMode"},
     {"title": "X3DNodes.TEspduTransformNode.FdPort", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdPort"},
     {"title": "X3DNodes.TEspduTransformNode.FdReadInterval", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdReadInterval"},
     {"title": "X3DNodes.TEspduTransformNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdRotation"},
     {"title": "X3DNodes.TEspduTransformNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdScale"},
     {"title": "X3DNodes.TEspduTransformNode.FdScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdScaleOrientation"},
     {"title": "X3DNodes.TEspduTransformNode.FdSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdSiteID"},
     {"title": "X3DNodes.TEspduTransformNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdTranslation"},
     {"title": "X3DNodes.TEspduTransformNode.FdWarhead", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdWarhead"},
     {"title": "X3DNodes.TEspduTransformNode.FdWriteInterval", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdWriteInterval"},
     {"title": "X3DNodes.TEspduTransformNode.EventArticulationParameterValue0_changed", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventArticulationParameterValue0_changed"},
     {"title": "X3DNodes.TEspduTransformNode.EventArticulationParameterValue1_changed", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventArticulationParameterValue1_changed"},
     {"title": "X3DNodes.TEspduTransformNode.EventArticulationParameterValue2_changed", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventArticulationParameterValue2_changed"},
     {"title": "X3DNodes.TEspduTransformNode.EventArticulationParameterValue3_changed", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventArticulationParameterValue3_changed"},
     {"title": "X3DNodes.TEspduTransformNode.EventArticulationParameterValue4_changed", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventArticulationParameterValue4_changed"},
     {"title": "X3DNodes.TEspduTransformNode.EventArticulationParameterValue5_changed", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventArticulationParameterValue5_changed"},
     {"title": "X3DNodes.TEspduTransformNode.EventArticulationParameterValue6_changed", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventArticulationParameterValue6_changed"},
     {"title": "X3DNodes.TEspduTransformNode.EventArticulationParameterValue7_changed", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventArticulationParameterValue7_changed"},
     {"title": "X3DNodes.TEspduTransformNode.EventCollideTime", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventCollideTime"},
     {"title": "X3DNodes.TEspduTransformNode.EventDetonateTime", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventDetonateTime"},
     {"title": "X3DNodes.TEspduTransformNode.EventFiredTime", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventFiredTime"},
     {"title": "X3DNodes.TEspduTransformNode.EventIsActive", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventIsActive"},
     {"title": "X3DNodes.TEspduTransformNode.EventIsCollided", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventIsCollided"},
     {"title": "X3DNodes.TEspduTransformNode.EventIsDetonated", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventIsDetonated"},
     {"title": "X3DNodes.TEspduTransformNode.EventIsNetworkReader", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventIsNetworkReader"},
     {"title": "X3DNodes.TEspduTransformNode.EventIsNetworkWriter", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventIsNetworkWriter"},
     {"title": "X3DNodes.TEspduTransformNode.EventIsRtpHeaderHeard", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventIsRtpHeaderHeard"},
     {"title": "X3DNodes.TEspduTransformNode.EventIsStandAlone", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventIsStandAlone"},
     {"title": "X3DNodes.TEspduTransformNode.EventTimestamp", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventTimestamp"},
     {"title": "X3DNodes.TEspduTransformNode.FdRtpHeaderExpected", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FdRtpHeaderExpected"},
     {"title": "X3DNodes.TEspduTransformNode.Address", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Address"},
     {"title": "X3DNodes.TEspduTransformNode.ApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#ApplicationID"},
     {"title": "X3DNodes.TEspduTransformNode.ArticulationParameterCount", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#ArticulationParameterCount"},
     {"title": "X3DNodes.TEspduTransformNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Center"},
     {"title": "X3DNodes.TEspduTransformNode.CollisionType", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#CollisionType"},
     {"title": "X3DNodes.TEspduTransformNode.DeadReckoning", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#DeadReckoning"},
     {"title": "X3DNodes.TEspduTransformNode.DetonationLocation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#DetonationLocation"},
     {"title": "X3DNodes.TEspduTransformNode.DetonationRelativeLocation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#DetonationRelativeLocation"},
     {"title": "X3DNodes.TEspduTransformNode.DetonationResult", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#DetonationResult"},
     {"title": "X3DNodes.TEspduTransformNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Enabled"},
     {"title": "X3DNodes.TEspduTransformNode.EntityCategory", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EntityCategory"},
     {"title": "X3DNodes.TEspduTransformNode.EntityCountry", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EntityCountry"},
     {"title": "X3DNodes.TEspduTransformNode.EntityDomain", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EntityDomain"},
     {"title": "X3DNodes.TEspduTransformNode.EntityExtra", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EntityExtra"},
     {"title": "X3DNodes.TEspduTransformNode.EntityID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EntityID"},
     {"title": "X3DNodes.TEspduTransformNode.EntityKind", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EntityKind"},
     {"title": "X3DNodes.TEspduTransformNode.EntitySpecific", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EntitySpecific"},
     {"title": "X3DNodes.TEspduTransformNode.EntitySubCategory", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EntitySubCategory"},
     {"title": "X3DNodes.TEspduTransformNode.EventApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventApplicationID"},
     {"title": "X3DNodes.TEspduTransformNode.EventEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventEntityID"},
     {"title": "X3DNodes.TEspduTransformNode.EventNumber", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventNumber"},
     {"title": "X3DNodes.TEspduTransformNode.EventSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#EventSiteID"},
     {"title": "X3DNodes.TEspduTransformNode.Fired1", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Fired1"},
     {"title": "X3DNodes.TEspduTransformNode.Fired2", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Fired2"},
     {"title": "X3DNodes.TEspduTransformNode.FireMissionIndex", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FireMissionIndex"},
     {"title": "X3DNodes.TEspduTransformNode.FiringRange", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FiringRange"},
     {"title": "X3DNodes.TEspduTransformNode.FiringRate", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#FiringRate"},
     {"title": "X3DNodes.TEspduTransformNode.ForceID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#ForceID"},
     {"title": "X3DNodes.TEspduTransformNode.Fuse", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Fuse"},
     {"title": "X3DNodes.TEspduTransformNode.LinearVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#LinearVelocity"},
     {"title": "X3DNodes.TEspduTransformNode.LinearAcceleration", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#LinearAcceleration"},
     {"title": "X3DNodes.TEspduTransformNode.Marking", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Marking"},
     {"title": "X3DNodes.TEspduTransformNode.MulticastRelayHost", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#MulticastRelayHost"},
     {"title": "X3DNodes.TEspduTransformNode.MulticastRelayPort", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#MulticastRelayPort"},
     {"title": "X3DNodes.TEspduTransformNode.MunitionApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#MunitionApplicationID"},
     {"title": "X3DNodes.TEspduTransformNode.MunitionEndPoint", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#MunitionEndPoint"},
     {"title": "X3DNodes.TEspduTransformNode.MunitionEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#MunitionEntityID"},
     {"title": "X3DNodes.TEspduTransformNode.MunitionQuantity", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#MunitionQuantity"},
     {"title": "X3DNodes.TEspduTransformNode.MunitionSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#MunitionSiteID"},
     {"title": "X3DNodes.TEspduTransformNode.MunitionStartPoint", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#MunitionStartPoint"},
     {"title": "X3DNodes.TEspduTransformNode.Port", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Port"},
     {"title": "X3DNodes.TEspduTransformNode.ReadInterval", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#ReadInterval"},
     {"title": "X3DNodes.TEspduTransformNode.Rotation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Rotation"},
     {"title": "X3DNodes.TEspduTransformNode.Scale", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Scale"},
     {"title": "X3DNodes.TEspduTransformNode.ScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#ScaleOrientation"},
     {"title": "X3DNodes.TEspduTransformNode.SiteID", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#SiteID"},
     {"title": "X3DNodes.TEspduTransformNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Translation"},
     {"title": "X3DNodes.TEspduTransformNode.Warhead", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#Warhead"},
     {"title": "X3DNodes.TEspduTransformNode.WriteInterval", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#WriteInterval"},
     {"title": "X3DNodes.TEspduTransformNode.RtpHeaderExpected", "text": " ", "tags": "", "loc": "X3DNodes.TEspduTransformNode.html#RtpHeaderExpected"},
     {"title": "X3DNodes.TReceiverPduNode", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html"},
     {"title": "X3DNodes.TReceiverPduNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#CreateNode"},
     {"title": "X3DNodes.TReceiverPduNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#ClassX3DType"},
     {"title": "X3DNodes.TReceiverPduNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#URNMatching"},
     {"title": "X3DNodes.TReceiverPduNode.FdAddress", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdAddress"},
     {"title": "X3DNodes.TReceiverPduNode.FdApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdApplicationID"},
     {"title": "X3DNodes.TReceiverPduNode.FdEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdEntityID"},
     {"title": "X3DNodes.TReceiverPduNode.FdMulticastRelayHost", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdMulticastRelayHost"},
     {"title": "X3DNodes.TReceiverPduNode.FdMulticastRelayPort", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdMulticastRelayPort"},
     {"title": "X3DNodes.TReceiverPduNode.FdNetworkMode", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdNetworkMode"},
     {"title": "X3DNodes.TReceiverPduNode.FdPort", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdPort"},
     {"title": "X3DNodes.TReceiverPduNode.FdRadioID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdRadioID"},
     {"title": "X3DNodes.TReceiverPduNode.FdReadInterval", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdReadInterval"},
     {"title": "X3DNodes.TReceiverPduNode.FdReceivedPower", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdReceivedPower"},
     {"title": "X3DNodes.TReceiverPduNode.FdReceiverState", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdReceiverState"},
     {"title": "X3DNodes.TReceiverPduNode.FdRtpHeaderExpected", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdRtpHeaderExpected"},
     {"title": "X3DNodes.TReceiverPduNode.FdSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdSiteID"},
     {"title": "X3DNodes.TReceiverPduNode.FdTransmitterApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdTransmitterApplicationID"},
     {"title": "X3DNodes.TReceiverPduNode.FdTransmitterEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdTransmitterEntityID"},
     {"title": "X3DNodes.TReceiverPduNode.FdTransmitterRadioID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdTransmitterRadioID"},
     {"title": "X3DNodes.TReceiverPduNode.FdTransmitterSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdTransmitterSiteID"},
     {"title": "X3DNodes.TReceiverPduNode.FdWhichGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdWhichGeometry"},
     {"title": "X3DNodes.TReceiverPduNode.FdWriteInterval", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdWriteInterval"},
     {"title": "X3DNodes.TReceiverPduNode.EventIsNetworkReader", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#EventIsNetworkReader"},
     {"title": "X3DNodes.TReceiverPduNode.EventIsNetworkWriter", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#EventIsNetworkWriter"},
     {"title": "X3DNodes.TReceiverPduNode.EventIsRtpHeaderHeard", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#EventIsRtpHeaderHeard"},
     {"title": "X3DNodes.TReceiverPduNode.EventIsStandAlone", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#EventIsStandAlone"},
     {"title": "X3DNodes.TReceiverPduNode.EventTimestamp", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#EventTimestamp"},
     {"title": "X3DNodes.TReceiverPduNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TReceiverPduNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#FdBboxSize"},
     {"title": "X3DNodes.TReceiverPduNode.Address", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#Address"},
     {"title": "X3DNodes.TReceiverPduNode.ApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#ApplicationID"},
     {"title": "X3DNodes.TReceiverPduNode.EntityID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#EntityID"},
     {"title": "X3DNodes.TReceiverPduNode.MulticastRelayHost", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#MulticastRelayHost"},
     {"title": "X3DNodes.TReceiverPduNode.MulticastRelayPort", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#MulticastRelayPort"},
     {"title": "X3DNodes.TReceiverPduNode.Port", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#Port"},
     {"title": "X3DNodes.TReceiverPduNode.RadioID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#RadioID"},
     {"title": "X3DNodes.TReceiverPduNode.ReadInterval", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#ReadInterval"},
     {"title": "X3DNodes.TReceiverPduNode.ReceivedPower", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#ReceivedPower"},
     {"title": "X3DNodes.TReceiverPduNode.ReceiverState", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#ReceiverState"},
     {"title": "X3DNodes.TReceiverPduNode.RtpHeaderExpected", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#RtpHeaderExpected"},
     {"title": "X3DNodes.TReceiverPduNode.SiteID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#SiteID"},
     {"title": "X3DNodes.TReceiverPduNode.TransmitterApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#TransmitterApplicationID"},
     {"title": "X3DNodes.TReceiverPduNode.TransmitterEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#TransmitterEntityID"},
     {"title": "X3DNodes.TReceiverPduNode.TransmitterRadioID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#TransmitterRadioID"},
     {"title": "X3DNodes.TReceiverPduNode.TransmitterSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#TransmitterSiteID"},
     {"title": "X3DNodes.TReceiverPduNode.WhichGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#WhichGeometry"},
     {"title": "X3DNodes.TReceiverPduNode.WriteInterval", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#WriteInterval"},
     {"title": "X3DNodes.TReceiverPduNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#BboxCenter"},
     {"title": "X3DNodes.TReceiverPduNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TReceiverPduNode.html#BboxSize"},
     {"title": "X3DNodes.TSignalPduNode", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html"},
     {"title": "X3DNodes.TSignalPduNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#CreateNode"},
     {"title": "X3DNodes.TSignalPduNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSignalPduNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#URNMatching"},
     {"title": "X3DNodes.TSignalPduNode.SetData", "text": "    ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#SetData"},
     {"title": "X3DNodes.TSignalPduNode.SetData", "text": "    ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#SetData"},
     {"title": "X3DNodes.TSignalPduNode.FdAddress", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdAddress"},
     {"title": "X3DNodes.TSignalPduNode.FdApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdApplicationID"},
     {"title": "X3DNodes.TSignalPduNode.FdData", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdData"},
     {"title": "X3DNodes.TSignalPduNode.FdDataLength", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdDataLength"},
     {"title": "X3DNodes.TSignalPduNode.FdEncodingScheme", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdEncodingScheme"},
     {"title": "X3DNodes.TSignalPduNode.FdEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdEntityID"},
     {"title": "X3DNodes.TSignalPduNode.FdMulticastRelayHost", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdMulticastRelayHost"},
     {"title": "X3DNodes.TSignalPduNode.FdMulticastRelayPort", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdMulticastRelayPort"},
     {"title": "X3DNodes.TSignalPduNode.FdNetworkMode", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdNetworkMode"},
     {"title": "X3DNodes.TSignalPduNode.FdPort", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdPort"},
     {"title": "X3DNodes.TSignalPduNode.FdRadioID", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdRadioID"},
     {"title": "X3DNodes.TSignalPduNode.FdReadInterval", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdReadInterval"},
     {"title": "X3DNodes.TSignalPduNode.FdRtpHeaderExpected", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdRtpHeaderExpected"},
     {"title": "X3DNodes.TSignalPduNode.FdSampleRate", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdSampleRate"},
     {"title": "X3DNodes.TSignalPduNode.FdSamples", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdSamples"},
     {"title": "X3DNodes.TSignalPduNode.FdSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdSiteID"},
     {"title": "X3DNodes.TSignalPduNode.FdTdlType", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdTdlType"},
     {"title": "X3DNodes.TSignalPduNode.FdWhichGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdWhichGeometry"},
     {"title": "X3DNodes.TSignalPduNode.FdWriteInterval", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdWriteInterval"},
     {"title": "X3DNodes.TSignalPduNode.EventIsNetworkReader", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#EventIsNetworkReader"},
     {"title": "X3DNodes.TSignalPduNode.EventIsNetworkWriter", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#EventIsNetworkWriter"},
     {"title": "X3DNodes.TSignalPduNode.EventIsRtpHeaderHeard", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#EventIsRtpHeaderHeard"},
     {"title": "X3DNodes.TSignalPduNode.EventIsStandAlone", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#EventIsStandAlone"},
     {"title": "X3DNodes.TSignalPduNode.EventTimestamp", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#EventTimestamp"},
     {"title": "X3DNodes.TSignalPduNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TSignalPduNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#FdBboxSize"},
     {"title": "X3DNodes.TSignalPduNode.Address", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#Address"},
     {"title": "X3DNodes.TSignalPduNode.ApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#ApplicationID"},
     {"title": "X3DNodes.TSignalPduNode.DataLength", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#DataLength"},
     {"title": "X3DNodes.TSignalPduNode.EncodingScheme", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#EncodingScheme"},
     {"title": "X3DNodes.TSignalPduNode.EntityID", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#EntityID"},
     {"title": "X3DNodes.TSignalPduNode.MulticastRelayHost", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#MulticastRelayHost"},
     {"title": "X3DNodes.TSignalPduNode.MulticastRelayPort", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#MulticastRelayPort"},
     {"title": "X3DNodes.TSignalPduNode.Port", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#Port"},
     {"title": "X3DNodes.TSignalPduNode.RadioID", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#RadioID"},
     {"title": "X3DNodes.TSignalPduNode.ReadInterval", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#ReadInterval"},
     {"title": "X3DNodes.TSignalPduNode.RtpHeaderExpected", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#RtpHeaderExpected"},
     {"title": "X3DNodes.TSignalPduNode.SampleRate", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#SampleRate"},
     {"title": "X3DNodes.TSignalPduNode.Samples", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#Samples"},
     {"title": "X3DNodes.TSignalPduNode.SiteID", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#SiteID"},
     {"title": "X3DNodes.TSignalPduNode.TdlType", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#TdlType"},
     {"title": "X3DNodes.TSignalPduNode.WhichGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#WhichGeometry"},
     {"title": "X3DNodes.TSignalPduNode.WriteInterval", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#WriteInterval"},
     {"title": "X3DNodes.TSignalPduNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#BboxCenter"},
     {"title": "X3DNodes.TSignalPduNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TSignalPduNode.html#BboxSize"},
     {"title": "X3DNodes.TTransmitterPduNode", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html"},
     {"title": "X3DNodes.TTransmitterPduNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#CreateNode"},
     {"title": "X3DNodes.TTransmitterPduNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTransmitterPduNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#URNMatching"},
     {"title": "X3DNodes.TTransmitterPduNode.FdAddress", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdAddress"},
     {"title": "X3DNodes.TTransmitterPduNode.FdAntennaLocation", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdAntennaLocation"},
     {"title": "X3DNodes.TTransmitterPduNode.FdAntennaPatternLength", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdAntennaPatternLength"},
     {"title": "X3DNodes.TTransmitterPduNode.FdAntennaPatternType", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdAntennaPatternType"},
     {"title": "X3DNodes.TTransmitterPduNode.FdApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdApplicationID"},
     {"title": "X3DNodes.TTransmitterPduNode.FdCryptoKeyID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdCryptoKeyID"},
     {"title": "X3DNodes.TTransmitterPduNode.FdCryptoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdCryptoSystem"},
     {"title": "X3DNodes.TTransmitterPduNode.FdEntityID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdEntityID"},
     {"title": "X3DNodes.TTransmitterPduNode.FdFrequency", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdFrequency"},
     {"title": "X3DNodes.TTransmitterPduNode.FdInputSource", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdInputSource"},
     {"title": "X3DNodes.TTransmitterPduNode.FdLengthOfModulationParameters", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdLengthOfModulationParameters"},
     {"title": "X3DNodes.TTransmitterPduNode.FdModulationTypeDetail", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdModulationTypeDetail"},
     {"title": "X3DNodes.TTransmitterPduNode.FdModulationTypeMajor", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdModulationTypeMajor"},
     {"title": "X3DNodes.TTransmitterPduNode.FdModulationTypeSpreadSpectrum", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdModulationTypeSpreadSpectrum"},
     {"title": "X3DNodes.TTransmitterPduNode.FdModulationTypeSystem", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdModulationTypeSystem"},
     {"title": "X3DNodes.TTransmitterPduNode.FdMulticastRelayHost", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdMulticastRelayHost"},
     {"title": "X3DNodes.TTransmitterPduNode.FdMulticastRelayPort", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdMulticastRelayPort"},
     {"title": "X3DNodes.TTransmitterPduNode.FdNetworkMode", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdNetworkMode"},
     {"title": "X3DNodes.TTransmitterPduNode.FdPort", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdPort"},
     {"title": "X3DNodes.TTransmitterPduNode.FdPower", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdPower"},
     {"title": "X3DNodes.TTransmitterPduNode.FdRadioEntityTypeCategory", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdRadioEntityTypeCategory"},
     {"title": "X3DNodes.TTransmitterPduNode.FdRadioEntityTypeCountry", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdRadioEntityTypeCountry"},
     {"title": "X3DNodes.TTransmitterPduNode.FdRadioEntityTypeDomain", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdRadioEntityTypeDomain"},
     {"title": "X3DNodes.TTransmitterPduNode.FdRadioEntityTypeKind", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdRadioEntityTypeKind"},
     {"title": "X3DNodes.TTransmitterPduNode.FdRadioEntityTypeNomenclature", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdRadioEntityTypeNomenclature"},
     {"title": "X3DNodes.TTransmitterPduNode.FdRadioEntityTypeNomenclatureVersion", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdRadioEntityTypeNomenclatureVersion"},
     {"title": "X3DNodes.TTransmitterPduNode.FdRadioID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdRadioID"},
     {"title": "X3DNodes.TTransmitterPduNode.FdReadInterval", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdReadInterval"},
     {"title": "X3DNodes.TTransmitterPduNode.FdRelativeAntennaLocation", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdRelativeAntennaLocation"},
     {"title": "X3DNodes.TTransmitterPduNode.FdRtpHeaderExpected", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdRtpHeaderExpected"},
     {"title": "X3DNodes.TTransmitterPduNode.FdSiteID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdSiteID"},
     {"title": "X3DNodes.TTransmitterPduNode.FdTransmitFrequencyBandwidth", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdTransmitFrequencyBandwidth"},
     {"title": "X3DNodes.TTransmitterPduNode.FdTransmitState", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdTransmitState"},
     {"title": "X3DNodes.TTransmitterPduNode.FdWhichGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdWhichGeometry"},
     {"title": "X3DNodes.TTransmitterPduNode.FdWriteInterval", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdWriteInterval"},
     {"title": "X3DNodes.TTransmitterPduNode.EventIsNetworkReader", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#EventIsNetworkReader"},
     {"title": "X3DNodes.TTransmitterPduNode.EventIsNetworkWriter", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#EventIsNetworkWriter"},
     {"title": "X3DNodes.TTransmitterPduNode.EventIsRtpHeaderHeard", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#EventIsRtpHeaderHeard"},
     {"title": "X3DNodes.TTransmitterPduNode.EventIsStandAlone", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#EventIsStandAlone"},
     {"title": "X3DNodes.TTransmitterPduNode.EventTimestamp", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#EventTimestamp"},
     {"title": "X3DNodes.TTransmitterPduNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TTransmitterPduNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#FdBboxSize"},
     {"title": "X3DNodes.TTransmitterPduNode.Address", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#Address"},
     {"title": "X3DNodes.TTransmitterPduNode.AntennaLocation", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#AntennaLocation"},
     {"title": "X3DNodes.TTransmitterPduNode.AntennaPatternLength", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#AntennaPatternLength"},
     {"title": "X3DNodes.TTransmitterPduNode.AntennaPatternType", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#AntennaPatternType"},
     {"title": "X3DNodes.TTransmitterPduNode.ApplicationID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#ApplicationID"},
     {"title": "X3DNodes.TTransmitterPduNode.CryptoKeyID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#CryptoKeyID"},
     {"title": "X3DNodes.TTransmitterPduNode.CryptoSystem", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#CryptoSystem"},
     {"title": "X3DNodes.TTransmitterPduNode.EntityID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#EntityID"},
     {"title": "X3DNodes.TTransmitterPduNode.Frequency", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#Frequency"},
     {"title": "X3DNodes.TTransmitterPduNode.InputSource", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#InputSource"},
     {"title": "X3DNodes.TTransmitterPduNode.LengthOfModulationParameters", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#LengthOfModulationParameters"},
     {"title": "X3DNodes.TTransmitterPduNode.ModulationTypeDetail", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#ModulationTypeDetail"},
     {"title": "X3DNodes.TTransmitterPduNode.ModulationTypeMajor", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#ModulationTypeMajor"},
     {"title": "X3DNodes.TTransmitterPduNode.ModulationTypeSpreadSpectrum", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#ModulationTypeSpreadSpectrum"},
     {"title": "X3DNodes.TTransmitterPduNode.ModulationTypeSystem", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#ModulationTypeSystem"},
     {"title": "X3DNodes.TTransmitterPduNode.MulticastRelayHost", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#MulticastRelayHost"},
     {"title": "X3DNodes.TTransmitterPduNode.MulticastRelayPort", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#MulticastRelayPort"},
     {"title": "X3DNodes.TTransmitterPduNode.Port", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#Port"},
     {"title": "X3DNodes.TTransmitterPduNode.Power", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#Power"},
     {"title": "X3DNodes.TTransmitterPduNode.RadioEntityTypeCategory", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#RadioEntityTypeCategory"},
     {"title": "X3DNodes.TTransmitterPduNode.RadioEntityTypeCountry", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#RadioEntityTypeCountry"},
     {"title": "X3DNodes.TTransmitterPduNode.RadioEntityTypeDomain", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#RadioEntityTypeDomain"},
     {"title": "X3DNodes.TTransmitterPduNode.RadioEntityTypeKind", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#RadioEntityTypeKind"},
     {"title": "X3DNodes.TTransmitterPduNode.RadioEntityTypeNomenclature", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#RadioEntityTypeNomenclature"},
     {"title": "X3DNodes.TTransmitterPduNode.RadioEntityTypeNomenclatureVersion", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#RadioEntityTypeNomenclatureVersion"},
     {"title": "X3DNodes.TTransmitterPduNode.RadioID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#RadioID"},
     {"title": "X3DNodes.TTransmitterPduNode.ReadInterval", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#ReadInterval"},
     {"title": "X3DNodes.TTransmitterPduNode.RelativeAntennaLocation", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#RelativeAntennaLocation"},
     {"title": "X3DNodes.TTransmitterPduNode.RtpHeaderExpected", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#RtpHeaderExpected"},
     {"title": "X3DNodes.TTransmitterPduNode.SiteID", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#SiteID"},
     {"title": "X3DNodes.TTransmitterPduNode.TransmitFrequencyBandwidth", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#TransmitFrequencyBandwidth"},
     {"title": "X3DNodes.TTransmitterPduNode.TransmitState", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#TransmitState"},
     {"title": "X3DNodes.TTransmitterPduNode.WhichGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#WhichGeometry"},
     {"title": "X3DNodes.TTransmitterPduNode.WriteInterval", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#WriteInterval"},
     {"title": "X3DNodes.TTransmitterPduNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#BboxCenter"},
     {"title": "X3DNodes.TTransmitterPduNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TTransmitterPduNode.html#BboxSize"},
     {"title": "X3DNodes.TAbstractScriptNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractScriptNode.html"},
     {"title": "X3DNodes.TAbstractScriptNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractScriptNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractScriptNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractScriptNode.html#Destroy"},
     {"title": "X3DNodes.TAbstractScriptNode.ResetLastEventTimes", "text": "  <p> TCasScriptVRMLValuesList.ResetLastEventTimes    ", "tags": "", "loc": "X3DNodes.TAbstractScriptNode.html#ResetLastEventTimes"},
     {"title": "X3DNodes.TAbstractScriptNode.SetUrl", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TAbstractScriptNode.html#SetUrl"},
     {"title": "X3DNodes.TAbstractScriptNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractScriptNode.html#SetUrl"},
     {"title": "X3DNodes.TAbstractScriptNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractScriptNode.html#FdUrl"},
     {"title": "X3DNodes.TAbstractScriptNode.Initialized", "text": " Read this to know current script state, write this is to actually initialize/shutdown if needed.  <p>Note that the script node doesn't initialize itself at any point. Reason: there's no comfortable moment to do this: 1. in constructor some routes and such are not initialized yet, and we should initialize script after whole VRML graph is loaded. 2. tricks with <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#BeforeTraverse\">BeforeTraverse</a>, like used for <a class=\"normal\" href=\"X3DNodes.TInlineNode.html\">TInlineNode</a>, are not Ok, since scripts must work even when they are in the inactive part of VRML graph.  <p>If you want scripts to work, you have to initialize them yourself. If you use <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, this will be done for you automatically when you change <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ProcessEvents\">TCastleSceneCore.ProcessEvents</a>, so it's not a problem in practice. ", "tags": "", "loc": "X3DNodes.TAbstractScriptNode.html#Initialized"},
     {"title": "X3DNodes.TScriptNode", "text": " ", "tags": "", "loc": "X3DNodes.TScriptNode.html"},
     {"title": "X3DNodes.TScriptNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TScriptNode.html#CreateNode"},
     {"title": "X3DNodes.TScriptNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TScriptNode.html#ClassX3DType"},
     {"title": "X3DNodes.TScriptNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TScriptNode.html#URNMatching"},
     {"title": "X3DNodes.TScriptNode.PostAddInterfaceDeclaration", "text": "    ", "tags": "", "loc": "X3DNodes.TScriptNode.html#PostAddInterfaceDeclaration"},
     {"title": "X3DNodes.TScriptNode.FdDirectOutput", "text": " ", "tags": "", "loc": "X3DNodes.TScriptNode.html#FdDirectOutput"},
     {"title": "X3DNodes.TScriptNode.FdMustEvaluate", "text": " ", "tags": "", "loc": "X3DNodes.TScriptNode.html#FdMustEvaluate"},
     {"title": "X3DNodes.TScriptNode.DirectOutput", "text": " ", "tags": "", "loc": "X3DNodes.TScriptNode.html#DirectOutput"},
     {"title": "X3DNodes.TScriptNode.MustEvaluate", "text": " ", "tags": "", "loc": "X3DNodes.TScriptNode.html#MustEvaluate"},
     {"title": "X3DNodes.TAbstractSequencerNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSequencerNode.html"},
     {"title": "X3DNodes.TAbstractSequencerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSequencerNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractSequencerNode.SetKey", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TAbstractSequencerNode.html#SetKey"},
     {"title": "X3DNodes.TAbstractSequencerNode.SetKey", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSequencerNode.html#SetKey"},
     {"title": "X3DNodes.TAbstractSequencerNode.EventNext", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSequencerNode.html#EventNext"},
     {"title": "X3DNodes.TAbstractSequencerNode.EventPrevious", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSequencerNode.html#EventPrevious"},
     {"title": "X3DNodes.TAbstractSequencerNode.EventSet_fraction", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSequencerNode.html#EventSet_fraction"},
     {"title": "X3DNodes.TAbstractSequencerNode.FdKey", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSequencerNode.html#FdKey"},
     {"title": "X3DNodes.TAbstractSequencerNode.FdForceContinousValue_Changed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractSequencerNode.html#FdForceContinousValue_Changed"},
     {"title": "X3DNodes.TAbstractTriggerNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTriggerNode.html"},
     {"title": "X3DNodes.TAbstractTriggerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTriggerNode.html#CreateNode"},
     {"title": "X3DNodes.TBooleanFilterNode", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanFilterNode.html"},
     {"title": "X3DNodes.TBooleanFilterNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanFilterNode.html#CreateNode"},
     {"title": "X3DNodes.TBooleanFilterNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanFilterNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBooleanFilterNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanFilterNode.html#URNMatching"},
     {"title": "X3DNodes.TBooleanFilterNode.EventSet_boolean", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanFilterNode.html#EventSet_boolean"},
     {"title": "X3DNodes.TBooleanFilterNode.EventInputFalse", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanFilterNode.html#EventInputFalse"},
     {"title": "X3DNodes.TBooleanFilterNode.EventInputNegate", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanFilterNode.html#EventInputNegate"},
     {"title": "X3DNodes.TBooleanFilterNode.EventInputTrue", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanFilterNode.html#EventInputTrue"},
     {"title": "X3DNodes.TBooleanSequencerNode", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanSequencerNode.html"},
     {"title": "X3DNodes.TBooleanSequencerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanSequencerNode.html#CreateNode"},
     {"title": "X3DNodes.TBooleanSequencerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanSequencerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBooleanSequencerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanSequencerNode.html#URNMatching"},
     {"title": "X3DNodes.TBooleanSequencerNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TBooleanSequencerNode.html#SetKeyValue"},
     {"title": "X3DNodes.TBooleanSequencerNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanSequencerNode.html#SetKeyValue"},
     {"title": "X3DNodes.TBooleanSequencerNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanSequencerNode.html#FdKeyValue"},
     {"title": "X3DNodes.TBooleanSequencerNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanSequencerNode.html#EventValue_changed"},
     {"title": "X3DNodes.TBooleanToggleNode", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanToggleNode.html"},
     {"title": "X3DNodes.TBooleanToggleNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanToggleNode.html#CreateNode"},
     {"title": "X3DNodes.TBooleanToggleNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanToggleNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBooleanToggleNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanToggleNode.html#URNMatching"},
     {"title": "X3DNodes.TBooleanToggleNode.EventSet_boolean", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanToggleNode.html#EventSet_boolean"},
     {"title": "X3DNodes.TBooleanToggleNode.FdToggle", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanToggleNode.html#FdToggle"},
     {"title": "X3DNodes.TBooleanToggleNode.Toggle", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanToggleNode.html#Toggle"},
     {"title": "X3DNodes.TBooleanTriggerNode", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanTriggerNode.html"},
     {"title": "X3DNodes.TBooleanTriggerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanTriggerNode.html#CreateNode"},
     {"title": "X3DNodes.TBooleanTriggerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanTriggerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBooleanTriggerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBooleanTriggerNode.html#URNMatching"},
     {"title": "X3DNodes.TBooleanTriggerNode.EventSet_triggerTime", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanTriggerNode.html#EventSet_triggerTime"},
     {"title": "X3DNodes.TBooleanTriggerNode.EventTriggerTrue", "text": " ", "tags": "", "loc": "X3DNodes.TBooleanTriggerNode.html#EventTriggerTrue"},
     {"title": "X3DNodes.TIntegerSequencerNode", "text": " For example, it can be driven by a TimeSensor and iterate over a series of nodes by animating Switch.whichChoice. ", "tags": "", "loc": "X3DNodes.TIntegerSequencerNode.html"},
     {"title": "X3DNodes.TIntegerSequencerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TIntegerSequencerNode.html#CreateNode"},
     {"title": "X3DNodes.TIntegerSequencerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIntegerSequencerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TIntegerSequencerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TIntegerSequencerNode.html#URNMatching"},
     {"title": "X3DNodes.TIntegerSequencerNode.SetKeyValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TIntegerSequencerNode.html#SetKeyValue"},
     {"title": "X3DNodes.TIntegerSequencerNode.SetKeyValue", "text": "    ", "tags": "", "loc": "X3DNodes.TIntegerSequencerNode.html#SetKeyValue"},
     {"title": "X3DNodes.TIntegerSequencerNode.FdKeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TIntegerSequencerNode.html#FdKeyValue"},
     {"title": "X3DNodes.TIntegerSequencerNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TIntegerSequencerNode.html#EventValue_changed"},
     {"title": "X3DNodes.TIntegerTriggerNode", "text": " ", "tags": "", "loc": "X3DNodes.TIntegerTriggerNode.html"},
     {"title": "X3DNodes.TIntegerTriggerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TIntegerTriggerNode.html#CreateNode"},
     {"title": "X3DNodes.TIntegerTriggerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIntegerTriggerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TIntegerTriggerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TIntegerTriggerNode.html#URNMatching"},
     {"title": "X3DNodes.TIntegerTriggerNode.EventSet_boolean", "text": " ", "tags": "", "loc": "X3DNodes.TIntegerTriggerNode.html#EventSet_boolean"},
     {"title": "X3DNodes.TIntegerTriggerNode.FdIntegerKey", "text": " ", "tags": "", "loc": "X3DNodes.TIntegerTriggerNode.html#FdIntegerKey"},
     {"title": "X3DNodes.TIntegerTriggerNode.EventTriggerValue", "text": " ", "tags": "", "loc": "X3DNodes.TIntegerTriggerNode.html#EventTriggerValue"},
     {"title": "X3DNodes.TIntegerTriggerNode.IntegerKey", "text": " ", "tags": "", "loc": "X3DNodes.TIntegerTriggerNode.html#IntegerKey"},
     {"title": "X3DNodes.TTimeTriggerNode", "text": " ", "tags": "", "loc": "X3DNodes.TTimeTriggerNode.html"},
     {"title": "X3DNodes.TTimeTriggerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTimeTriggerNode.html#CreateNode"},
     {"title": "X3DNodes.TTimeTriggerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTimeTriggerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTimeTriggerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTimeTriggerNode.html#URNMatching"},
     {"title": "X3DNodes.TTimeTriggerNode.EventSet_boolean", "text": " ", "tags": "", "loc": "X3DNodes.TTimeTriggerNode.html#EventSet_boolean"},
     {"title": "X3DNodes.TTimeTriggerNode.EventTriggerTime", "text": " ", "tags": "", "loc": "X3DNodes.TTimeTriggerNode.html#EventTriggerTime"},
     {"title": "X3DNodes.TAbstractShaderNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShaderNode.html"},
     {"title": "X3DNodes.TAbstractShaderNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractShaderNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractShaderNode.EventActivate", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShaderNode.html#EventActivate"},
     {"title": "X3DNodes.TAbstractShaderNode.EventIsSelected", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShaderNode.html#EventIsSelected"},
     {"title": "X3DNodes.TAbstractShaderNode.EventIsValid", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShaderNode.html#EventIsValid"},
     {"title": "X3DNodes.TAbstractShaderNode.FdLanguage", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShaderNode.html#FdLanguage"},
     {"title": "X3DNodes.TAbstractShaderNode.Language", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractShaderNode.html#Language"},
     {"title": "X3DNodes.TAbstractVertexAttributeNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractVertexAttributeNode.html"},
     {"title": "X3DNodes.TAbstractVertexAttributeNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractVertexAttributeNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractVertexAttributeNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractVertexAttributeNode.html#FdName"},
     {"title": "X3DNodes.TAbstractVertexAttributeNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractVertexAttributeNode.html#NameField"},
     {"title": "X3DNodes.IAbstractProgrammableShaderObject", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractProgrammableShaderObject.html"},
     {"title": "X3DNodes.TComposedShaderNode", "text": " ", "tags": "", "loc": "X3DNodes.TComposedShaderNode.html"},
     {"title": "X3DNodes.TComposedShaderNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedShaderNode.html#CreateNode"},
     {"title": "X3DNodes.TComposedShaderNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedShaderNode.html#ClassX3DType"},
     {"title": "X3DNodes.TComposedShaderNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedShaderNode.html#URNMatching"},
     {"title": "X3DNodes.TComposedShaderNode.SetParts", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TComposedShaderNode.html#SetParts"},
     {"title": "X3DNodes.TComposedShaderNode.FdParts", "text": " ", "tags": "", "loc": "X3DNodes.TComposedShaderNode.html#FdParts"},
     {"title": "X3DNodes.TFloatVertexAttributeNode", "text": " ", "tags": "", "loc": "X3DNodes.TFloatVertexAttributeNode.html"},
     {"title": "X3DNodes.TFloatVertexAttributeNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TFloatVertexAttributeNode.html#CreateNode"},
     {"title": "X3DNodes.TFloatVertexAttributeNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TFloatVertexAttributeNode.html#ClassX3DType"},
     {"title": "X3DNodes.TFloatVertexAttributeNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TFloatVertexAttributeNode.html#URNMatching"},
     {"title": "X3DNodes.TFloatVertexAttributeNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TFloatVertexAttributeNode.html#SetValue"},
     {"title": "X3DNodes.TFloatVertexAttributeNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TFloatVertexAttributeNode.html#SetValue"},
     {"title": "X3DNodes.TFloatVertexAttributeNode.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TFloatVertexAttributeNode.html#FdValue"},
     {"title": "X3DNodes.TFloatVertexAttributeNode.FdNumComponents", "text": " ", "tags": "", "loc": "X3DNodes.TFloatVertexAttributeNode.html#FdNumComponents"},
     {"title": "X3DNodes.TFloatVertexAttributeNode.NumComponents", "text": " ", "tags": "", "loc": "X3DNodes.TFloatVertexAttributeNode.html#NumComponents"},
     {"title": "X3DNodes.TMatrix3VertexAttributeNode", "text": " ", "tags": "", "loc": "X3DNodes.TMatrix3VertexAttributeNode.html"},
     {"title": "X3DNodes.TMatrix3VertexAttributeNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrix3VertexAttributeNode.html#CreateNode"},
     {"title": "X3DNodes.TMatrix3VertexAttributeNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrix3VertexAttributeNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMatrix3VertexAttributeNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrix3VertexAttributeNode.html#URNMatching"},
     {"title": "X3DNodes.TMatrix3VertexAttributeNode.SetValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TMatrix3VertexAttributeNode.html#SetValue"},
     {"title": "X3DNodes.TMatrix3VertexAttributeNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrix3VertexAttributeNode.html#SetValue"},
     {"title": "X3DNodes.TMatrix3VertexAttributeNode.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TMatrix3VertexAttributeNode.html#FdValue"},
     {"title": "X3DNodes.TMatrix4VertexAttributeNode", "text": " ", "tags": "", "loc": "X3DNodes.TMatrix4VertexAttributeNode.html"},
     {"title": "X3DNodes.TMatrix4VertexAttributeNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrix4VertexAttributeNode.html#CreateNode"},
     {"title": "X3DNodes.TMatrix4VertexAttributeNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrix4VertexAttributeNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMatrix4VertexAttributeNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrix4VertexAttributeNode.html#URNMatching"},
     {"title": "X3DNodes.TMatrix4VertexAttributeNode.SetValue", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TMatrix4VertexAttributeNode.html#SetValue"},
     {"title": "X3DNodes.TMatrix4VertexAttributeNode.SetValue", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrix4VertexAttributeNode.html#SetValue"},
     {"title": "X3DNodes.TMatrix4VertexAttributeNode.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TMatrix4VertexAttributeNode.html#FdValue"},
     {"title": "X3DNodes.TPackagedShaderNode", "text": " <b>Not implemented.</b> ", "tags": "", "loc": "X3DNodes.TPackagedShaderNode.html"},
     {"title": "X3DNodes.TPackagedShaderNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPackagedShaderNode.html#CreateNode"},
     {"title": "X3DNodes.TPackagedShaderNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPackagedShaderNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPackagedShaderNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPackagedShaderNode.html#URNMatching"},
     {"title": "X3DNodes.TPackagedShaderNode.SetUrl", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TPackagedShaderNode.html#SetUrl"},
     {"title": "X3DNodes.TPackagedShaderNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TPackagedShaderNode.html#SetUrl"},
     {"title": "X3DNodes.TPackagedShaderNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TPackagedShaderNode.html#FdUrl"},
     {"title": "X3DNodes.TProgramShaderNode", "text": " <b>Not implemented.</b> ", "tags": "", "loc": "X3DNodes.TProgramShaderNode.html"},
     {"title": "X3DNodes.TProgramShaderNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TProgramShaderNode.html#CreateNode"},
     {"title": "X3DNodes.TProgramShaderNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TProgramShaderNode.html#ClassX3DType"},
     {"title": "X3DNodes.TProgramShaderNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TProgramShaderNode.html#URNMatching"},
     {"title": "X3DNodes.TProgramShaderNode.SetPrograms", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TProgramShaderNode.html#SetPrograms"},
     {"title": "X3DNodes.TProgramShaderNode.FdPrograms", "text": " ", "tags": "", "loc": "X3DNodes.TProgramShaderNode.html#FdPrograms"},
     {"title": "X3DNodes.TShaderPartNode", "text": " ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html"},
     {"title": "X3DNodes.TShaderPartNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html#CreateNode"},
     {"title": "X3DNodes.TShaderPartNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html#ClassX3DType"},
     {"title": "X3DNodes.TShaderPartNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html#URNMatching"},
     {"title": "X3DNodes.TShaderPartNode.SetUrl", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html#SetUrl"},
     {"title": "X3DNodes.TShaderPartNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html#SetUrl"},
     {"title": "X3DNodes.TShaderPartNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html#FdUrl"},
     {"title": "X3DNodes.TShaderPartNode.FdType", "text": " ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html#FdType"},
     {"title": "X3DNodes.TShaderPartNode.ShaderType", "text": " ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html#ShaderType"},
     {"title": "X3DNodes.TShaderPartNode.Contents", "text": "  <p>Getting this automatically loads the shader code pointed by the URL field of this node. The shader code may be specified in an external file, or inline using &quot;data URI&quot;, see <a  href=\"https://castle-engine.sourceforge.io/manual_network.php\">https://castle-engine.sourceforge.io/manual_network.php</a> . The shader code may also be specified using the XML &quot;CDATA&quot; in X3D XML encoding. Returns '' of no valid URLs are present (loading errors are reported to <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>).  <p>Setting this overrides the URL field, to specify only the given shader code. ", "tags": "", "loc": "X3DNodes.TShaderPartNode.html#Contents"},
     {"title": "X3DNodes.TShaderProgramNode", "text": " <b>Not implemented.</b> ", "tags": "", "loc": "X3DNodes.TShaderProgramNode.html"},
     {"title": "X3DNodes.TShaderProgramNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderProgramNode.html#CreateNode"},
     {"title": "X3DNodes.TShaderProgramNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderProgramNode.html#ClassX3DType"},
     {"title": "X3DNodes.TShaderProgramNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderProgramNode.html#URNMatching"},
     {"title": "X3DNodes.TShaderProgramNode.SetUrl", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TShaderProgramNode.html#SetUrl"},
     {"title": "X3DNodes.TShaderProgramNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderProgramNode.html#SetUrl"},
     {"title": "X3DNodes.TShaderProgramNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TShaderProgramNode.html#FdUrl"},
     {"title": "X3DNodes.TShaderProgramNode.FdType", "text": " ", "tags": "", "loc": "X3DNodes.TShaderProgramNode.html#FdType"},
     {"title": "X3DNodes.IAbstractX3DProductStructureChildNode", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractX3DProductStructureChildNode.html"},
     {"title": "X3DNodes.IAbstractX3DProductStructureChildNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractX3DProductStructureChildNode.html#FdName"},
     {"title": "X3DNodes.TAbstractProductStructureChildNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractProductStructureChildNode.html"},
     {"title": "X3DNodes.TAbstractProductStructureChildNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractProductStructureChildNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractProductStructureChildNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractProductStructureChildNode.html#FdName"},
     {"title": "X3DNodes.TAbstractProductStructureChildNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractProductStructureChildNode.html#NameField"},
     {"title": "X3DNodes.TCADAssemblyNode", "text": " ", "tags": "", "loc": "X3DNodes.TCADAssemblyNode.html"},
     {"title": "X3DNodes.TCADAssemblyNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TCADAssemblyNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TCADAssemblyNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCADAssemblyNode.html#CreateNode"},
     {"title": "X3DNodes.TCADAssemblyNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCADAssemblyNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCADAssemblyNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCADAssemblyNode.html#URNMatching"},
     {"title": "X3DNodes.TCADAssemblyNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TCADAssemblyNode.html#FdName"},
     {"title": "X3DNodes.TCADAssemblyNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TCADAssemblyNode.html#NameField"},
     {"title": "X3DNodes.TCADFaceNode", "text": " ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html"},
     {"title": "X3DNodes.TCADFaceNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TCADFaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html#CreateNode"},
     {"title": "X3DNodes.TCADFaceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCADFaceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html#URNMatching"},
     {"title": "X3DNodes.TCADFaceNode.FdShape", "text": " ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html#FdShape"},
     {"title": "X3DNodes.TCADFaceNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TCADFaceNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html#FdBboxSize"},
     {"title": "X3DNodes.TCADFaceNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html#BboxCenter"},
     {"title": "X3DNodes.TCADFaceNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TCADFaceNode.html#BboxSize"},
     {"title": "X3DNodes.TCADLayerNode", "text": " ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html"},
     {"title": "X3DNodes.TCADLayerNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TCADLayerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html#CreateNode"},
     {"title": "X3DNodes.TCADLayerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCADLayerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html#URNMatching"},
     {"title": "X3DNodes.TCADLayerNode.SetVisible", "text": "    ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html#SetVisible"},
     {"title": "X3DNodes.TCADLayerNode.SetVisible", "text": "    ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html#SetVisible"},
     {"title": "X3DNodes.TCADLayerNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html#FdName"},
     {"title": "X3DNodes.TCADLayerNode.FdVisible", "text": " ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html#FdVisible"},
     {"title": "X3DNodes.TCADLayerNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TCADLayerNode.html#NameField"},
     {"title": "X3DNodes.TCADPartNode", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html"},
     {"title": "X3DNodes.TCADPartNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TCADPartNode.ApplyTransform", "text": "    ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#ApplyTransform"},
     {"title": "X3DNodes.TCADPartNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#CreateNode"},
     {"title": "X3DNodes.TCADPartNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCADPartNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#URNMatching"},
     {"title": "X3DNodes.TCADPartNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#TransformationChange"},
     {"title": "X3DNodes.TCADPartNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#FdCenter"},
     {"title": "X3DNodes.TCADPartNode.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#FdName"},
     {"title": "X3DNodes.TCADPartNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#FdRotation"},
     {"title": "X3DNodes.TCADPartNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#FdScale"},
     {"title": "X3DNodes.TCADPartNode.FdScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#FdScaleOrientation"},
     {"title": "X3DNodes.TCADPartNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#FdTranslation"},
     {"title": "X3DNodes.TCADPartNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#Center"},
     {"title": "X3DNodes.TCADPartNode.NameField", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#NameField"},
     {"title": "X3DNodes.TCADPartNode.Rotation", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#Rotation"},
     {"title": "X3DNodes.TCADPartNode.Scale", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#Scale"},
     {"title": "X3DNodes.TCADPartNode.ScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#ScaleOrientation"},
     {"title": "X3DNodes.TCADPartNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.TCADPartNode.html#Translation"},
     {"title": "X3DNodes.TIndexedQuadSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html"},
     {"title": "X3DNodes.TIndexedQuadSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#CreateNode"},
     {"title": "X3DNodes.TIndexedQuadSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TIndexedQuadSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#URNMatching"},
     {"title": "X3DNodes.TIndexedQuadSetNode.CoordIndexField", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#CoordIndexField"},
     {"title": "X3DNodes.TIndexedQuadSetNode.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TIndexedQuadSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TIndexedQuadSetNode.SetIndex", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#SetIndex"},
     {"title": "X3DNodes.TIndexedQuadSetNode.SetIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#SetIndex"},
     {"title": "X3DNodes.TIndexedQuadSetNode.EventSet_index", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#EventSet_index"},
     {"title": "X3DNodes.TIndexedQuadSetNode.FdIndex", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedQuadSetNode.html#FdIndex"},
     {"title": "X3DNodes.TQuadSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TQuadSetNode.html"},
     {"title": "X3DNodes.TQuadSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TQuadSetNode.html#CreateNode"},
     {"title": "X3DNodes.TQuadSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TQuadSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TQuadSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TQuadSetNode.html#URNMatching"},
     {"title": "X3DNodes.TQuadSetNode.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TQuadSetNode.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TQuadSetNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TQuadSetNode.html#TrianglesCount"},
     {"title": "X3DNodes.TAbstractTexture3DNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html"},
     {"title": "X3DNodes.TAbstractTexture3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractTexture3DNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#Destroy"},
     {"title": "X3DNodes.TAbstractTexture3DNode.FdRepeatS", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#FdRepeatS"},
     {"title": "X3DNodes.TAbstractTexture3DNode.FdRepeatT", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#FdRepeatT"},
     {"title": "X3DNodes.TAbstractTexture3DNode.FdRepeatR", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#FdRepeatR"},
     {"title": "X3DNodes.TAbstractTexture3DNode.FdTextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#FdTextureProperties"},
     {"title": "X3DNodes.TAbstractTexture3DNode.TextureLoaded", "text": "  <p>When loading, we will try to set <a class=\"normal\" href=\"X3DNodes.TAbstractTexture3DNode.html#TextureImage\">TextureImage</a> and <a class=\"normal\" href=\"X3DNodes.TAbstractTexture3DNode.html#TextureComposite\">TextureComposite</a>. If loading is successful, <a class=\"normal\" href=\"X3DNodes.TAbstractTexture3DNode.html#TextureImage\">TextureImage</a> will be always set to non-nil (<a class=\"normal\" href=\"X3DNodes.TAbstractTexture3DNode.html#TextureComposite\">TextureComposite</a> will be set to non-nil only if image came from some composite (DDS, KTX...) image). If loading failed, both <a class=\"normal\" href=\"X3DNodes.TAbstractTexture3DNode.html#TextureImage\">TextureImage</a> and <a class=\"normal\" href=\"X3DNodes.TAbstractTexture3DNode.html#TextureComposite\">TextureComposite</a> will be <code>Nil</code>.  <p>Note that even when loading failed (<a class=\"normal\" href=\"X3DNodes.TAbstractTexture3DNode.html#TextureImage\">TextureImage</a> remained <code>Nil</code>), <code>TextureLoaded</code> value still changes to <code>True</code>. This is good &mdash; it makes assignment <code><code>TextureLoaded</code> := true</code> always work, and (more important) it prevents trying to load (and displaying uselessly the same <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>) again at successful <code><code>TextureLoaded</code> := true</code>.  <p>In case of problems (for example when some URL cannot be loaded), we will make <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>. ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#TextureLoaded"},
     {"title": "X3DNodes.TAbstractTexture3DNode.TextureImage", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#TextureImage"},
     {"title": "X3DNodes.TAbstractTexture3DNode.TextureComposite", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#TextureComposite"},
     {"title": "X3DNodes.TAbstractTexture3DNode.RepeatR", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#RepeatR"},
     {"title": "X3DNodes.TAbstractTexture3DNode.TextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractTexture3DNode.html#TextureProperties"},
     {"title": "X3DNodes.TComposedTexture3DNode", "text": " ", "tags": "", "loc": "X3DNodes.TComposedTexture3DNode.html"},
     {"title": "X3DNodes.TComposedTexture3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedTexture3DNode.html#CreateNode"},
     {"title": "X3DNodes.TComposedTexture3DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedTexture3DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TComposedTexture3DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedTexture3DNode.html#URNMatching"},
     {"title": "X3DNodes.TComposedTexture3DNode.LoadTextureData", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedTexture3DNode.html#LoadTextureData"},
     {"title": "X3DNodes.TComposedTexture3DNode.SetTexture", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TComposedTexture3DNode.html#SetTexture"},
     {"title": "X3DNodes.TComposedTexture3DNode.FdTexture", "text": " ", "tags": "", "loc": "X3DNodes.TComposedTexture3DNode.html#FdTexture"},
     {"title": "X3DNodes.TImageTexture3DNode", "text": " ", "tags": "", "loc": "X3DNodes.TImageTexture3DNode.html"},
     {"title": "X3DNodes.TImageTexture3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TImageTexture3DNode.html#CreateNode"},
     {"title": "X3DNodes.TImageTexture3DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TImageTexture3DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TImageTexture3DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TImageTexture3DNode.html#URNMatching"},
     {"title": "X3DNodes.TImageTexture3DNode.SetUrl", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TImageTexture3DNode.html#SetUrl"},
     {"title": "X3DNodes.TImageTexture3DNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TImageTexture3DNode.html#SetUrl"},
     {"title": "X3DNodes.TImageTexture3DNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TImageTexture3DNode.html#FdUrl"},
     {"title": "X3DNodes.TPixelTexture3DNode", "text": " ", "tags": "", "loc": "X3DNodes.TPixelTexture3DNode.html"},
     {"title": "X3DNodes.TPixelTexture3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPixelTexture3DNode.html#CreateNode"},
     {"title": "X3DNodes.TPixelTexture3DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPixelTexture3DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPixelTexture3DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPixelTexture3DNode.html#URNMatching"},
     {"title": "X3DNodes.TPixelTexture3DNode.LoadTextureData", "text": "    ", "tags": "", "loc": "X3DNodes.TPixelTexture3DNode.html#LoadTextureData"},
     {"title": "X3DNodes.TPixelTexture3DNode.SetImage", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TPixelTexture3DNode.html#SetImage"},
     {"title": "X3DNodes.TPixelTexture3DNode.SetImage", "text": "    ", "tags": "", "loc": "X3DNodes.TPixelTexture3DNode.html#SetImage"},
     {"title": "X3DNodes.TPixelTexture3DNode.FdImage", "text": " ", "tags": "", "loc": "X3DNodes.TPixelTexture3DNode.html#FdImage"},
     {"title": "X3DNodes.TTextureCoordinate3DNode", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinate3DNode.html"},
     {"title": "X3DNodes.TTextureCoordinate3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate3DNode.html#CreateNode"},
     {"title": "X3DNodes.TTextureCoordinate3DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate3DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTextureCoordinate3DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate3DNode.html#URNMatching"},
     {"title": "X3DNodes.TTextureCoordinate3DNode.SetPoint", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate3DNode.html#SetPoint"},
     {"title": "X3DNodes.TTextureCoordinate3DNode.SetPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate3DNode.html#SetPoint"},
     {"title": "X3DNodes.TTextureCoordinate3DNode.FdPoint", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinate3DNode.html#FdPoint"},
     {"title": "X3DNodes.TTextureCoordinate4DNode", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinate4DNode.html"},
     {"title": "X3DNodes.TTextureCoordinate4DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate4DNode.html#CreateNode"},
     {"title": "X3DNodes.TTextureCoordinate4DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate4DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTextureCoordinate4DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate4DNode.html#URNMatching"},
     {"title": "X3DNodes.TTextureCoordinate4DNode.SetPoint", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate4DNode.html#SetPoint"},
     {"title": "X3DNodes.TTextureCoordinate4DNode.SetPoint", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate4DNode.html#SetPoint"},
     {"title": "X3DNodes.TTextureCoordinate4DNode.FdPoint", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinate4DNode.html#FdPoint"},
     {"title": "X3DNodes.TTextureTransformMatrix3DNode", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformMatrix3DNode.html"},
     {"title": "X3DNodes.TTextureTransformMatrix3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransformMatrix3DNode.html#CreateNode"},
     {"title": "X3DNodes.TTextureTransformMatrix3DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransformMatrix3DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTextureTransformMatrix3DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransformMatrix3DNode.html#URNMatching"},
     {"title": "X3DNodes.TTextureTransformMatrix3DNode.TransformMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransformMatrix3DNode.html#TransformMatrix"},
     {"title": "X3DNodes.TTextureTransformMatrix3DNode.FdMatrix", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformMatrix3DNode.html#FdMatrix"},
     {"title": "X3DNodes.TTextureTransformMatrix3DNode.Matrix", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransformMatrix3DNode.html#Matrix"},
     {"title": "X3DNodes.TTextureTransform3DNode", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html"},
     {"title": "X3DNodes.TTextureTransform3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#CreateNode"},
     {"title": "X3DNodes.TTextureTransform3DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTextureTransform3DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#URNMatching"},
     {"title": "X3DNodes.TTextureTransform3DNode.TransformMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#TransformMatrix"},
     {"title": "X3DNodes.TTextureTransform3DNode.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#FdCenter"},
     {"title": "X3DNodes.TTextureTransform3DNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#FdRotation"},
     {"title": "X3DNodes.TTextureTransform3DNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#FdScale"},
     {"title": "X3DNodes.TTextureTransform3DNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#FdTranslation"},
     {"title": "X3DNodes.TTextureTransform3DNode.Center", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#Center"},
     {"title": "X3DNodes.TTextureTransform3DNode.Rotation", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#Rotation"},
     {"title": "X3DNodes.TTextureTransform3DNode.Scale", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#Scale"},
     {"title": "X3DNodes.TTextureTransform3DNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.TTextureTransform3DNode.html#Translation"},
     {"title": "X3DNodes.TAbstractEnvironmentTextureNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentTextureNode.html"},
     {"title": "X3DNodes.TAbstractEnvironmentTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractEnvironmentTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#ClassX3DType"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#URNMatching"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.LoadSides", "text": " Make sure that all 6 fields for each cube map side are assigned, are <a class=\"normal\" href=\"X3DNodes.TAbstractTexture2DNode.html\">TAbstractTexture2DNode</a> instance (X3D spec requires it), load them, and check are they <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a> (we cannot suport <a class=\"normal\" href=\"CastleImages.TGPUCompressedImage.html\">TGPUCompressedImage</a> when loading cubemaps this way, as we have to rotate images from ComposedCubeMapTextureNode when passing them to GPU, which is only possible for <a class=\"normal\" href=\"CastleImages.TCastleImage.html\">TCastleImage</a>).  <p>Also calculate AlphaChannel for the whole cube map. Our AlphaChannel method will reflect the state from last call of this.    ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#LoadSides"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.FdBack", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#FdBack"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.FdBottom", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#FdBottom"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.FdFront", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#FdFront"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.FdLeft", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#FdLeft"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.FdRight", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#FdRight"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.FdTop", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#FdTop"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.FdTextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#FdTextureProperties"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.Back", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#Back"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.Bottom", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#Bottom"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.Front", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#Front"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.Left", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#Left"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.Right", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#Right"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.Top", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#Top"},
     {"title": "X3DNodes.TComposedCubeMapTextureNode.TextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TComposedCubeMapTextureNode.html#TextureProperties"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#Destroy"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#URNMatching"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.FdUpdate", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#FdUpdate"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.Update", "text": " Changing this automatically marks the field as changed. ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#Update"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#FdSize"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.FdTextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#FdTextureProperties"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.FdBias", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#FdBias"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.GeneratedTextureHandler", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#GeneratedTextureHandler"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.Size", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#Size"},
     {"title": "X3DNodes.TGeneratedCubeMapTextureNode.TextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedCubeMapTextureNode.html#TextureProperties"},
     {"title": "X3DNodes.TImageCubeMapTextureNode", "text": " ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html"},
     {"title": "X3DNodes.TImageCubeMapTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TImageCubeMapTextureNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html#ClassX3DType"},
     {"title": "X3DNodes.TImageCubeMapTextureNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html#URNMatching"},
     {"title": "X3DNodes.TImageCubeMapTextureNode.LoadImage", "text": "  <p>In case of problems, will make <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>. This includes situations when url cannot be loaded for whatever reason. Also problems when url contains valid Composite image, but not describing cube map with all 6 sides.  <p>If all URLs failed, will return <code>Nil</code>.  <p>Although the loaded image is not saved here, we do save the AlphaChannel type. Our AlphaChannel method will reflect last loaded image.    ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html#LoadImage"},
     {"title": "X3DNodes.TImageCubeMapTextureNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html#SetUrl"},
     {"title": "X3DNodes.TImageCubeMapTextureNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html#SetUrl"},
     {"title": "X3DNodes.TImageCubeMapTextureNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html#FdUrl"},
     {"title": "X3DNodes.TImageCubeMapTextureNode.FdTextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html#FdTextureProperties"},
     {"title": "X3DNodes.TImageCubeMapTextureNode.TextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TImageCubeMapTextureNode.html#TextureProperties"},
     {"title": "X3DNodes.TAbstractLayerNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLayerNode.html"},
     {"title": "X3DNodes.TAbstractLayerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLayerNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractLayerNode.FdIsPickable", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLayerNode.html#FdIsPickable"},
     {"title": "X3DNodes.TAbstractLayerNode.FdViewport", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLayerNode.html#FdViewport"},
     {"title": "X3DNodes.TAbstractLayerNode.IsPickable", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLayerNode.html#IsPickable"},
     {"title": "X3DNodes.TAbstractLayerNode.Viewport", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLayerNode.html#Viewport"},
     {"title": "X3DNodes.TAbstractViewportNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractViewportNode.html"},
     {"title": "X3DNodes.TAbstractViewportNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractViewportNode.html#CreateNode"},
     {"title": "X3DNodes.TLayerNode", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.TLayerNode.html"},
     {"title": "X3DNodes.TLayerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLayerNode.html#CreateNode"},
     {"title": "X3DNodes.TLayerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLayerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLayerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLayerNode.html#URNMatching"},
     {"title": "X3DNodes.TLayerNode.SetChildren", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TLayerNode.html#SetChildren"},
     {"title": "X3DNodes.TLayerNode.EventAddChildren", "text": " ", "tags": "", "loc": "X3DNodes.TLayerNode.html#EventAddChildren"},
     {"title": "X3DNodes.TLayerNode.EventRemoveChildren", "text": " ", "tags": "", "loc": "X3DNodes.TLayerNode.html#EventRemoveChildren"},
     {"title": "X3DNodes.TLayerNode.FdChildren", "text": " ", "tags": "", "loc": "X3DNodes.TLayerNode.html#FdChildren"},
     {"title": "X3DNodes.TLayerSetNode", "text": " ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html"},
     {"title": "X3DNodes.TLayerSetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#CreateNode"},
     {"title": "X3DNodes.TLayerSetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLayerSetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#URNMatching"},
     {"title": "X3DNodes.TLayerSetNode.SetLayers", "text": "    ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#SetLayers"},
     {"title": "X3DNodes.TLayerSetNode.SetOrder", "text": "    ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#SetOrder"},
     {"title": "X3DNodes.TLayerSetNode.SetOrder", "text": "    ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#SetOrder"},
     {"title": "X3DNodes.TLayerSetNode.FdActiveLayer", "text": " ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#FdActiveLayer"},
     {"title": "X3DNodes.TLayerSetNode.FdLayers", "text": " ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#FdLayers"},
     {"title": "X3DNodes.TLayerSetNode.FdOrder", "text": " ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#FdOrder"},
     {"title": "X3DNodes.TLayerSetNode.ActiveLayer", "text": " ", "tags": "", "loc": "X3DNodes.TLayerSetNode.html#ActiveLayer"},
     {"title": "X3DNodes.TViewportNode", "text": " ", "tags": "", "loc": "X3DNodes.TViewportNode.html"},
     {"title": "X3DNodes.TViewportNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TViewportNode.html#CreateNode"},
     {"title": "X3DNodes.TViewportNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TViewportNode.html#ClassX3DType"},
     {"title": "X3DNodes.TViewportNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TViewportNode.html#URNMatching"},
     {"title": "X3DNodes.TViewportNode.SetClipBoundary", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TViewportNode.html#SetClipBoundary"},
     {"title": "X3DNodes.TViewportNode.SetClipBoundary", "text": "    ", "tags": "", "loc": "X3DNodes.TViewportNode.html#SetClipBoundary"},
     {"title": "X3DNodes.TViewportNode.FdClipBoundary", "text": " ", "tags": "", "loc": "X3DNodes.TViewportNode.html#FdClipBoundary"},
     {"title": "X3DNodes.TAbstractLayoutNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractLayoutNode.html"},
     {"title": "X3DNodes.TAbstractLayoutNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractLayoutNode.html#CreateNode"},
     {"title": "X3DNodes.TLayoutNode", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.TLayoutNode.html"},
     {"title": "X3DNodes.TLayoutNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#CreateNode"},
     {"title": "X3DNodes.TLayoutNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLayoutNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#URNMatching"},
     {"title": "X3DNodes.TLayoutNode.SetAlign", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetAlign"},
     {"title": "X3DNodes.TLayoutNode.SetAlign", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetAlign"},
     {"title": "X3DNodes.TLayoutNode.SetOffset", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetOffset"},
     {"title": "X3DNodes.TLayoutNode.SetOffset", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetOffset"},
     {"title": "X3DNodes.TLayoutNode.SetOffsetUnits", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetOffsetUnits"},
     {"title": "X3DNodes.TLayoutNode.SetOffsetUnits", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetOffsetUnits"},
     {"title": "X3DNodes.TLayoutNode.SetScaleMode", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetScaleMode"},
     {"title": "X3DNodes.TLayoutNode.SetScaleMode", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetScaleMode"},
     {"title": "X3DNodes.TLayoutNode.SetSize", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetSize"},
     {"title": "X3DNodes.TLayoutNode.SetSize", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetSize"},
     {"title": "X3DNodes.TLayoutNode.SetSizeUnits", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetSizeUnits"},
     {"title": "X3DNodes.TLayoutNode.SetSizeUnits", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#SetSizeUnits"},
     {"title": "X3DNodes.TLayoutNode.FdAlign", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#FdAlign"},
     {"title": "X3DNodes.TLayoutNode.FdOffset", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#FdOffset"},
     {"title": "X3DNodes.TLayoutNode.FdOffsetUnits", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#FdOffsetUnits"},
     {"title": "X3DNodes.TLayoutNode.FdScaleMode", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#FdScaleMode"},
     {"title": "X3DNodes.TLayoutNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#FdSize"},
     {"title": "X3DNodes.TLayoutNode.FdSizeUnits", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutNode.html#FdSizeUnits"},
     {"title": "X3DNodes.TLayoutGroupNode", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutGroupNode.html"},
     {"title": "X3DNodes.TLayoutGroupNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutGroupNode.html#CreateNode"},
     {"title": "X3DNodes.TLayoutGroupNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutGroupNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLayoutGroupNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutGroupNode.html#URNMatching"},
     {"title": "X3DNodes.TLayoutGroupNode.FdLayout", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutGroupNode.html#FdLayout"},
     {"title": "X3DNodes.TLayoutGroupNode.FdViewport", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutGroupNode.html#FdViewport"},
     {"title": "X3DNodes.TLayoutGroupNode.Layout", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutGroupNode.html#Layout"},
     {"title": "X3DNodes.TLayoutGroupNode.Viewport", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutGroupNode.html#Viewport"},
     {"title": "X3DNodes.TLayoutLayerNode", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html"},
     {"title": "X3DNodes.TLayoutLayerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html#CreateNode"},
     {"title": "X3DNodes.TLayoutLayerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLayoutLayerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html#URNMatching"},
     {"title": "X3DNodes.TLayoutLayerNode.SetChildren", "text": "    ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html#SetChildren"},
     {"title": "X3DNodes.TLayoutLayerNode.EventAddChildren", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html#EventAddChildren"},
     {"title": "X3DNodes.TLayoutLayerNode.EventRemoveChildren", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html#EventRemoveChildren"},
     {"title": "X3DNodes.TLayoutLayerNode.FdChildren", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html#FdChildren"},
     {"title": "X3DNodes.TLayoutLayerNode.FdLayout", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html#FdLayout"},
     {"title": "X3DNodes.TLayoutLayerNode.Layout", "text": " ", "tags": "", "loc": "X3DNodes.TLayoutLayerNode.html#Layout"},
     {"title": "X3DNodes.TScreenFontStyleNode", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html"},
     {"title": "X3DNodes.TScreenFontStyleNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#CreateNode"},
     {"title": "X3DNodes.TScreenFontStyleNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#ClassX3DType"},
     {"title": "X3DNodes.TScreenFontStyleNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#URNMatching"},
     {"title": "X3DNodes.TScreenFontStyleNode.FdFamily", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#FdFamily"},
     {"title": "X3DNodes.TScreenFontStyleNode.FdHorizontal", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#FdHorizontal"},
     {"title": "X3DNodes.TScreenFontStyleNode.FdJustify", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#FdJustify"},
     {"title": "X3DNodes.TScreenFontStyleNode.FdLanguage", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#FdLanguage"},
     {"title": "X3DNodes.TScreenFontStyleNode.FdLeftToRight", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#FdLeftToRight"},
     {"title": "X3DNodes.TScreenFontStyleNode.FdPointSize", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#FdPointSize"},
     {"title": "X3DNodes.TScreenFontStyleNode.FdSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#FdSpacing"},
     {"title": "X3DNodes.TScreenFontStyleNode.FdStyle", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#FdStyle"},
     {"title": "X3DNodes.TScreenFontStyleNode.FdTopToBottom", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#FdTopToBottom"},
     {"title": "X3DNodes.TScreenFontStyleNode.Horizontal", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#Horizontal"},
     {"title": "X3DNodes.TScreenFontStyleNode.Language", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#Language"},
     {"title": "X3DNodes.TScreenFontStyleNode.LeftToRight", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#LeftToRight"},
     {"title": "X3DNodes.TScreenFontStyleNode.PointSize", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#PointSize"},
     {"title": "X3DNodes.TScreenFontStyleNode.Spacing", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#Spacing"},
     {"title": "X3DNodes.TScreenFontStyleNode.TopToBottom", "text": " ", "tags": "", "loc": "X3DNodes.TScreenFontStyleNode.html#TopToBottom"},
     {"title": "X3DNodes.TScreenGroupNode", "text": " ", "tags": "", "loc": "X3DNodes.TScreenGroupNode.html"},
     {"title": "X3DNodes.TScreenGroupNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenGroupNode.html#CreateNode"},
     {"title": "X3DNodes.TScreenGroupNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenGroupNode.html#ClassX3DType"},
     {"title": "X3DNodes.TScreenGroupNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenGroupNode.html#URNMatching"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#FdEnabled"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#FdRotation"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#FdTranslation"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#FdBboxSize"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#Enabled"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.Rotation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#Rotation"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.Translation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#Translation"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#BboxCenter"},
     {"title": "X3DNodes.TAbstractNBodyCollidableNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollidableNode.html#BboxSize"},
     {"title": "X3DNodes.TAbstractNBodyCollisionSpaceNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollisionSpaceNode.html"},
     {"title": "X3DNodes.TAbstractNBodyCollisionSpaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollisionSpaceNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractNBodyCollisionSpaceNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollisionSpaceNode.html#FdEnabled"},
     {"title": "X3DNodes.TAbstractNBodyCollisionSpaceNode.FdBboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollisionSpaceNode.html#FdBboxCenter"},
     {"title": "X3DNodes.TAbstractNBodyCollisionSpaceNode.FdBboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollisionSpaceNode.html#FdBboxSize"},
     {"title": "X3DNodes.TAbstractNBodyCollisionSpaceNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollisionSpaceNode.html#Enabled"},
     {"title": "X3DNodes.TAbstractNBodyCollisionSpaceNode.BboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollisionSpaceNode.html#BboxCenter"},
     {"title": "X3DNodes.TAbstractNBodyCollisionSpaceNode.BboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractNBodyCollisionSpaceNode.html#BboxSize"},
     {"title": "X3DNodes.TAbstractRigidJointNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractRigidJointNode.html"},
     {"title": "X3DNodes.TAbstractRigidJointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractRigidJointNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractRigidJointNode.SetForceOutput", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractRigidJointNode.html#SetForceOutput"},
     {"title": "X3DNodes.TAbstractRigidJointNode.SetForceOutput", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractRigidJointNode.html#SetForceOutput"},
     {"title": "X3DNodes.TAbstractRigidJointNode.FdBody1", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractRigidJointNode.html#FdBody1"},
     {"title": "X3DNodes.TAbstractRigidJointNode.FdBody2", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractRigidJointNode.html#FdBody2"},
     {"title": "X3DNodes.TAbstractRigidJointNode.FdForceOutput", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractRigidJointNode.html#FdForceOutput"},
     {"title": "X3DNodes.TAbstractRigidJointNode.Body1", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractRigidJointNode.html#Body1"},
     {"title": "X3DNodes.TAbstractRigidJointNode.Body2", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractRigidJointNode.html#Body2"},
     {"title": "X3DNodes.TBallJointNode", "text": " ", "tags": "", "loc": "X3DNodes.TBallJointNode.html"},
     {"title": "X3DNodes.TBallJointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBallJointNode.html#CreateNode"},
     {"title": "X3DNodes.TBallJointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBallJointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBallJointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBallJointNode.html#URNMatching"},
     {"title": "X3DNodes.TBallJointNode.FdAnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TBallJointNode.html#FdAnchorPoint"},
     {"title": "X3DNodes.TBallJointNode.EventBody1AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TBallJointNode.html#EventBody1AnchorPoint"},
     {"title": "X3DNodes.TBallJointNode.EventBody2AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TBallJointNode.html#EventBody2AnchorPoint"},
     {"title": "X3DNodes.TBallJointNode.AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TBallJointNode.html#AnchorPoint"},
     {"title": "X3DNodes.TCollidableOffsetNode", "text": " ", "tags": "", "loc": "X3DNodes.TCollidableOffsetNode.html"},
     {"title": "X3DNodes.TCollidableOffsetNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCollidableOffsetNode.html#CreateNode"},
     {"title": "X3DNodes.TCollidableOffsetNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCollidableOffsetNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCollidableOffsetNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCollidableOffsetNode.html#URNMatching"},
     {"title": "X3DNodes.TCollidableOffsetNode.FdCollidable", "text": " ", "tags": "", "loc": "X3DNodes.TCollidableOffsetNode.html#FdCollidable"},
     {"title": "X3DNodes.TCollidableOffsetNode.Collidable", "text": " ", "tags": "", "loc": "X3DNodes.TCollidableOffsetNode.html#Collidable"},
     {"title": "X3DNodes.TCollidableShapeNode", "text": " ", "tags": "", "loc": "X3DNodes.TCollidableShapeNode.html"},
     {"title": "X3DNodes.TCollidableShapeNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCollidableShapeNode.html#CreateNode"},
     {"title": "X3DNodes.TCollidableShapeNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCollidableShapeNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCollidableShapeNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCollidableShapeNode.html#URNMatching"},
     {"title": "X3DNodes.TCollidableShapeNode.FdShape", "text": " ", "tags": "", "loc": "X3DNodes.TCollidableShapeNode.html#FdShape"},
     {"title": "X3DNodes.TCollidableShapeNode.Shape", "text": " ", "tags": "", "loc": "X3DNodes.TCollidableShapeNode.html#Shape"},
     {"title": "X3DNodes.TCollisionCollectionNode", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html"},
     {"title": "X3DNodes.TCollisionCollectionNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#CreateNode"},
     {"title": "X3DNodes.TCollisionCollectionNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCollisionCollectionNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#URNMatching"},
     {"title": "X3DNodes.TCollisionCollectionNode.SetAppliedParameters", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#SetAppliedParameters"},
     {"title": "X3DNodes.TCollisionCollectionNode.SetAppliedParameters", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#SetAppliedParameters"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdAppliedParameters", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdAppliedParameters"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdBounce", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdBounce"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdCollidables", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdCollidables"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdEnabled"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdFrictionCoefficients", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdFrictionCoefficients"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdMinBounceSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdMinBounceSpeed"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdSlipFactors", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdSlipFactors"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdSoftnessConstantForceMix", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdSoftnessConstantForceMix"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdSoftnessErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdSoftnessErrorCorrection"},
     {"title": "X3DNodes.TCollisionCollectionNode.FdSurfaceSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FdSurfaceSpeed"},
     {"title": "X3DNodes.TCollisionCollectionNode.Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#Bounce"},
     {"title": "X3DNodes.TCollisionCollectionNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#Enabled"},
     {"title": "X3DNodes.TCollisionCollectionNode.FrictionCoefficients", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#FrictionCoefficients"},
     {"title": "X3DNodes.TCollisionCollectionNode.MinBounceSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#MinBounceSpeed"},
     {"title": "X3DNodes.TCollisionCollectionNode.SlipFactors", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#SlipFactors"},
     {"title": "X3DNodes.TCollisionCollectionNode.SoftnessConstantForceMix", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#SoftnessConstantForceMix"},
     {"title": "X3DNodes.TCollisionCollectionNode.SoftnessErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#SoftnessErrorCorrection"},
     {"title": "X3DNodes.TCollisionCollectionNode.SurfaceSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionCollectionNode.html#SurfaceSpeed"},
     {"title": "X3DNodes.TCollisionSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionSensorNode.html"},
     {"title": "X3DNodes.TCollisionSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TCollisionSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCollisionSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TCollisionSensorNode.FdCollider", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionSensorNode.html#FdCollider"},
     {"title": "X3DNodes.TCollisionSensorNode.EventIntersections", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionSensorNode.html#EventIntersections"},
     {"title": "X3DNodes.TCollisionSensorNode.EventContacts", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionSensorNode.html#EventContacts"},
     {"title": "X3DNodes.TCollisionSensorNode.Collider", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionSensorNode.html#Collider"},
     {"title": "X3DNodes.TCollisionSpaceNode", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionSpaceNode.html"},
     {"title": "X3DNodes.TCollisionSpaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionSpaceNode.html#CreateNode"},
     {"title": "X3DNodes.TCollisionSpaceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionSpaceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCollisionSpaceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCollisionSpaceNode.html#URNMatching"},
     {"title": "X3DNodes.TCollisionSpaceNode.FdCollidables", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionSpaceNode.html#FdCollidables"},
     {"title": "X3DNodes.TCollisionSpaceNode.FdUseGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionSpaceNode.html#FdUseGeometry"},
     {"title": "X3DNodes.TCollisionSpaceNode.UseGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TCollisionSpaceNode.html#UseGeometry"},
     {"title": "X3DNodes.TContactNode", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html"},
     {"title": "X3DNodes.TContactNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TContactNode.html#CreateNode"},
     {"title": "X3DNodes.TContactNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TContactNode.html#ClassX3DType"},
     {"title": "X3DNodes.TContactNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TContactNode.html#URNMatching"},
     {"title": "X3DNodes.TContactNode.SetAppliedParameters", "text": "    ", "tags": "", "loc": "X3DNodes.TContactNode.html#SetAppliedParameters"},
     {"title": "X3DNodes.TContactNode.SetAppliedParameters", "text": "    ", "tags": "", "loc": "X3DNodes.TContactNode.html#SetAppliedParameters"},
     {"title": "X3DNodes.TContactNode.FdAppliedParameters", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdAppliedParameters"},
     {"title": "X3DNodes.TContactNode.FdBody1", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdBody1"},
     {"title": "X3DNodes.TContactNode.FdBody2", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdBody2"},
     {"title": "X3DNodes.TContactNode.FdBounce", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdBounce"},
     {"title": "X3DNodes.TContactNode.FdContactNormal", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdContactNormal"},
     {"title": "X3DNodes.TContactNode.FdDepth", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdDepth"},
     {"title": "X3DNodes.TContactNode.FdFrictionCoefficients", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdFrictionCoefficients"},
     {"title": "X3DNodes.TContactNode.FdFrictionDirection", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdFrictionDirection"},
     {"title": "X3DNodes.TContactNode.FdGeometry1", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdGeometry1"},
     {"title": "X3DNodes.TContactNode.FdGeometry2", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdGeometry2"},
     {"title": "X3DNodes.TContactNode.FdMinbounceSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdMinbounceSpeed"},
     {"title": "X3DNodes.TContactNode.FdPosition", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdPosition"},
     {"title": "X3DNodes.TContactNode.FdSlipCoefficients", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdSlipCoefficients"},
     {"title": "X3DNodes.TContactNode.FdSoftnessConstantForceMix", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdSoftnessConstantForceMix"},
     {"title": "X3DNodes.TContactNode.FdSoftnessErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdSoftnessErrorCorrection"},
     {"title": "X3DNodes.TContactNode.FdSurfaceSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FdSurfaceSpeed"},
     {"title": "X3DNodes.TContactNode.Body1", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#Body1"},
     {"title": "X3DNodes.TContactNode.Body2", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#Body2"},
     {"title": "X3DNodes.TContactNode.Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#Bounce"},
     {"title": "X3DNodes.TContactNode.ContactNormal", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#ContactNormal"},
     {"title": "X3DNodes.TContactNode.Depth", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#Depth"},
     {"title": "X3DNodes.TContactNode.FrictionCoefficients", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FrictionCoefficients"},
     {"title": "X3DNodes.TContactNode.FrictionDirection", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#FrictionDirection"},
     {"title": "X3DNodes.TContactNode.Geometry1", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#Geometry1"},
     {"title": "X3DNodes.TContactNode.Geometry2", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#Geometry2"},
     {"title": "X3DNodes.TContactNode.MinbounceSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#MinbounceSpeed"},
     {"title": "X3DNodes.TContactNode.Position", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#Position"},
     {"title": "X3DNodes.TContactNode.SlipCoefficients", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#SlipCoefficients"},
     {"title": "X3DNodes.TContactNode.SoftnessConstantForceMix", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#SoftnessConstantForceMix"},
     {"title": "X3DNodes.TContactNode.SoftnessErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#SoftnessErrorCorrection"},
     {"title": "X3DNodes.TContactNode.SurfaceSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TContactNode.html#SurfaceSpeed"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#CreateNode"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#URNMatching"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdAnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdAnchorPoint"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdAxis1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdAxis1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdAxis2", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdAxis2"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdDesiredAngularVelocity1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdDesiredAngularVelocity1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdDesiredAngularVelocity2", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdDesiredAngularVelocity2"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdMaxAngle1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdMaxAngle1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdMaxTorque1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdMaxTorque1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdMaxTorque2", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdMaxTorque2"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdMinAngle1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdMinAngle1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdStopBounce1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdStopBounce1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdStopConstantForceMix1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdStopConstantForceMix1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdStopErrorCorrection1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdStopErrorCorrection1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdSuspensionErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdSuspensionErrorCorrection"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.FdSuspensionForce", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#FdSuspensionForce"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.EventBody1AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#EventBody1AnchorPoint"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.EventBody1Axis", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#EventBody1Axis"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.EventBody2AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#EventBody2AnchorPoint"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.EventBody2Axis", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#EventBody2Axis"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.EventHinge1Angle", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#EventHinge1Angle"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.EventHinge1AngleRate", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#EventHinge1AngleRate"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.EventHinge2Angle", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#EventHinge2Angle"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.EventHinge2AngleRate", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#EventHinge2AngleRate"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#AnchorPoint"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.Axis1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#Axis1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.Axis2", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#Axis2"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.DesiredAngularVelocity1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#DesiredAngularVelocity1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.DesiredAngularVelocity2", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#DesiredAngularVelocity2"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.MaxAngle1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#MaxAngle1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.MaxTorque1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#MaxTorque1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.MaxTorque2", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#MaxTorque2"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.MinAngle1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#MinAngle1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.StopBounce1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#StopBounce1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.StopConstantForceMix1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#StopConstantForceMix1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.StopErrorCorrection1", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#StopErrorCorrection1"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.SuspensionErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#SuspensionErrorCorrection"},
     {"title": "X3DNodes.TDoubleAxisHingeJointNode.SuspensionForce", "text": " ", "tags": "", "loc": "X3DNodes.TDoubleAxisHingeJointNode.html#SuspensionForce"},
     {"title": "X3DNodes.TMotorJointNode", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html"},
     {"title": "X3DNodes.TMotorJointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#CreateNode"},
     {"title": "X3DNodes.TMotorJointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMotorJointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#URNMatching"},
     {"title": "X3DNodes.TMotorJointNode.FdAxis1Angle", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdAxis1Angle"},
     {"title": "X3DNodes.TMotorJointNode.FdAxis1Torque", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdAxis1Torque"},
     {"title": "X3DNodes.TMotorJointNode.FdAxis2Angle", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdAxis2Angle"},
     {"title": "X3DNodes.TMotorJointNode.FdAxis2Torque", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdAxis2Torque"},
     {"title": "X3DNodes.TMotorJointNode.FdAxis3Angle", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdAxis3Angle"},
     {"title": "X3DNodes.TMotorJointNode.FdAxis3Torque", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdAxis3Torque"},
     {"title": "X3DNodes.TMotorJointNode.FdEnabledAxes", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdEnabledAxes"},
     {"title": "X3DNodes.TMotorJointNode.FdMotor1Axis", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdMotor1Axis"},
     {"title": "X3DNodes.TMotorJointNode.FdMotor2Axis", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdMotor2Axis"},
     {"title": "X3DNodes.TMotorJointNode.FdMotor3Axis", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdMotor3Axis"},
     {"title": "X3DNodes.TMotorJointNode.FdStop1Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdStop1Bounce"},
     {"title": "X3DNodes.TMotorJointNode.FdStop1ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdStop1ErrorCorrection"},
     {"title": "X3DNodes.TMotorJointNode.FdStop2Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdStop2Bounce"},
     {"title": "X3DNodes.TMotorJointNode.FdStop2ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdStop2ErrorCorrection"},
     {"title": "X3DNodes.TMotorJointNode.FdStop3Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdStop3Bounce"},
     {"title": "X3DNodes.TMotorJointNode.FdStop3ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdStop3ErrorCorrection"},
     {"title": "X3DNodes.TMotorJointNode.EventMotor1Angle", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#EventMotor1Angle"},
     {"title": "X3DNodes.TMotorJointNode.EventMotor1AngleRate", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#EventMotor1AngleRate"},
     {"title": "X3DNodes.TMotorJointNode.EventMotor2Angle", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#EventMotor2Angle"},
     {"title": "X3DNodes.TMotorJointNode.EventMotor2AngleRate", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#EventMotor2AngleRate"},
     {"title": "X3DNodes.TMotorJointNode.EventMotor3Angle", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#EventMotor3Angle"},
     {"title": "X3DNodes.TMotorJointNode.EventMotor3AngleRate", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#EventMotor3AngleRate"},
     {"title": "X3DNodes.TMotorJointNode.FdAutoCalc", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#FdAutoCalc"},
     {"title": "X3DNodes.TMotorJointNode.Axis1Angle", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Axis1Angle"},
     {"title": "X3DNodes.TMotorJointNode.Axis1Torque", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Axis1Torque"},
     {"title": "X3DNodes.TMotorJointNode.Axis2Angle", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Axis2Angle"},
     {"title": "X3DNodes.TMotorJointNode.Axis2Torque", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Axis2Torque"},
     {"title": "X3DNodes.TMotorJointNode.Axis3Angle", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Axis3Angle"},
     {"title": "X3DNodes.TMotorJointNode.Axis3Torque", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Axis3Torque"},
     {"title": "X3DNodes.TMotorJointNode.EnabledAxes", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#EnabledAxes"},
     {"title": "X3DNodes.TMotorJointNode.Motor1Axis", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Motor1Axis"},
     {"title": "X3DNodes.TMotorJointNode.Motor2Axis", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Motor2Axis"},
     {"title": "X3DNodes.TMotorJointNode.Motor3Axis", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Motor3Axis"},
     {"title": "X3DNodes.TMotorJointNode.Stop1Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Stop1Bounce"},
     {"title": "X3DNodes.TMotorJointNode.Stop1ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Stop1ErrorCorrection"},
     {"title": "X3DNodes.TMotorJointNode.Stop2Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Stop2Bounce"},
     {"title": "X3DNodes.TMotorJointNode.Stop2ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Stop2ErrorCorrection"},
     {"title": "X3DNodes.TMotorJointNode.Stop3Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Stop3Bounce"},
     {"title": "X3DNodes.TMotorJointNode.Stop3ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#Stop3ErrorCorrection"},
     {"title": "X3DNodes.TMotorJointNode.AutoCalc", "text": " ", "tags": "", "loc": "X3DNodes.TMotorJointNode.html#AutoCalc"},
     {"title": "X3DNodes.TRigidBodyNode", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html"},
     {"title": "X3DNodes.TRigidBodyNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#CreateNode"},
     {"title": "X3DNodes.TRigidBodyNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#ClassX3DType"},
     {"title": "X3DNodes.TRigidBodyNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#URNMatching"},
     {"title": "X3DNodes.TRigidBodyNode.SetForces", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#SetForces"},
     {"title": "X3DNodes.TRigidBodyNode.SetForces", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#SetForces"},
     {"title": "X3DNodes.TRigidBodyNode.SetGeometry", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#SetGeometry"},
     {"title": "X3DNodes.TRigidBodyNode.SetTorques", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#SetTorques"},
     {"title": "X3DNodes.TRigidBodyNode.SetTorques", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#SetTorques"},
     {"title": "X3DNodes.TRigidBodyNode.FdAngularDampingFactor", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdAngularDampingFactor"},
     {"title": "X3DNodes.TRigidBodyNode.FdAngularVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdAngularVelocity"},
     {"title": "X3DNodes.TRigidBodyNode.FdAutoDamp", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdAutoDamp"},
     {"title": "X3DNodes.TRigidBodyNode.FdAutoDisable", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdAutoDisable"},
     {"title": "X3DNodes.TRigidBodyNode.FdCenterOfMass", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdCenterOfMass"},
     {"title": "X3DNodes.TRigidBodyNode.FdDisableAngularSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdDisableAngularSpeed"},
     {"title": "X3DNodes.TRigidBodyNode.FdDisableLinearSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdDisableLinearSpeed"},
     {"title": "X3DNodes.TRigidBodyNode.FdDisableTime", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdDisableTime"},
     {"title": "X3DNodes.TRigidBodyNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdEnabled"},
     {"title": "X3DNodes.TRigidBodyNode.FdFiniteRotationAxis", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdFiniteRotationAxis"},
     {"title": "X3DNodes.TRigidBodyNode.FdFixed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdFixed"},
     {"title": "X3DNodes.TRigidBodyNode.FdForces", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdForces"},
     {"title": "X3DNodes.TRigidBodyNode.FdGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdGeometry"},
     {"title": "X3DNodes.TRigidBodyNode.FdInertia", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdInertia"},
     {"title": "X3DNodes.TRigidBodyNode.FdLinearDampingFactor", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdLinearDampingFactor"},
     {"title": "X3DNodes.TRigidBodyNode.FdLinearVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdLinearVelocity"},
     {"title": "X3DNodes.TRigidBodyNode.FdMass", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdMass"},
     {"title": "X3DNodes.TRigidBodyNode.FdMassDensityModel", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdMassDensityModel"},
     {"title": "X3DNodes.TRigidBodyNode.FdOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdOrientation"},
     {"title": "X3DNodes.TRigidBodyNode.FdPosition", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdPosition"},
     {"title": "X3DNodes.TRigidBodyNode.FdTorques", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdTorques"},
     {"title": "X3DNodes.TRigidBodyNode.FdUseFiniteRotation", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdUseFiniteRotation"},
     {"title": "X3DNodes.TRigidBodyNode.FdUseGlobalGravity", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FdUseGlobalGravity"},
     {"title": "X3DNodes.TRigidBodyNode.AngularDampingFactor", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#AngularDampingFactor"},
     {"title": "X3DNodes.TRigidBodyNode.AngularVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#AngularVelocity"},
     {"title": "X3DNodes.TRigidBodyNode.AutoDamp", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#AutoDamp"},
     {"title": "X3DNodes.TRigidBodyNode.AutoDisable", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#AutoDisable"},
     {"title": "X3DNodes.TRigidBodyNode.CenterOfMass", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#CenterOfMass"},
     {"title": "X3DNodes.TRigidBodyNode.DisableAngularSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#DisableAngularSpeed"},
     {"title": "X3DNodes.TRigidBodyNode.DisableLinearSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#DisableLinearSpeed"},
     {"title": "X3DNodes.TRigidBodyNode.DisableTime", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#DisableTime"},
     {"title": "X3DNodes.TRigidBodyNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#Enabled"},
     {"title": "X3DNodes.TRigidBodyNode.FiniteRotationAxis", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#FiniteRotationAxis"},
     {"title": "X3DNodes.TRigidBodyNode.Fixed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#Fixed"},
     {"title": "X3DNodes.TRigidBodyNode.Inertia", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#Inertia"},
     {"title": "X3DNodes.TRigidBodyNode.LinearDampingFactor", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#LinearDampingFactor"},
     {"title": "X3DNodes.TRigidBodyNode.LinearVelocity", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#LinearVelocity"},
     {"title": "X3DNodes.TRigidBodyNode.Mass", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#Mass"},
     {"title": "X3DNodes.TRigidBodyNode.Orientation", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#Orientation"},
     {"title": "X3DNodes.TRigidBodyNode.Position", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#Position"},
     {"title": "X3DNodes.TRigidBodyNode.UseFiniteRotation", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#UseFiniteRotation"},
     {"title": "X3DNodes.TRigidBodyNode.UseGlobalGravity", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyNode.html#UseGlobalGravity"},
     {"title": "X3DNodes.TRigidBodyCollectionNode", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#CreateNode"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#ClassX3DType"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#URNMatching"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.SetBodies", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#SetBodies"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.SetJoints", "text": "    ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#SetJoints"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.EventSet_contacts", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#EventSet_contacts"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdAutoDisable", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdAutoDisable"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdBodies", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdBodies"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdConstantForceMix", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdConstantForceMix"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdContactSurfaceThickness", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdContactSurfaceThickness"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdDisableAngularSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdDisableAngularSpeed"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdDisableLinearSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdDisableLinearSpeed"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdDisableTime", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdDisableTime"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdEnabled"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdErrorCorrection"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdGravity", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdGravity"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdIterations", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdIterations"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdJoints", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdJoints"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdMaxCorrectionSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdMaxCorrectionSpeed"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdPreferAccuracy", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdPreferAccuracy"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.FdCollider", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#FdCollider"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.AutoDisable", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#AutoDisable"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.ConstantForceMix", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#ConstantForceMix"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.ContactSurfaceThickness", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#ContactSurfaceThickness"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.DisableAngularSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#DisableAngularSpeed"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.DisableLinearSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#DisableLinearSpeed"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.DisableTime", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#DisableTime"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#Enabled"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#ErrorCorrection"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.Gravity", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#Gravity"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.Iterations", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#Iterations"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.MaxCorrectionSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#MaxCorrectionSpeed"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.PreferAccuracy", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#PreferAccuracy"},
     {"title": "X3DNodes.TRigidBodyCollectionNode.Collider", "text": " ", "tags": "", "loc": "X3DNodes.TRigidBodyCollectionNode.html#Collider"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#CreateNode"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#URNMatching"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.FdAnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#FdAnchorPoint"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.FdAxis", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#FdAxis"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.FdMaxAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#FdMaxAngle"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.FdMinAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#FdMinAngle"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.FdStopBounce", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#FdStopBounce"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.FdStopErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#FdStopErrorCorrection"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.EventAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#EventAngle"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.EventAngleRate", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#EventAngleRate"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.EventBody1AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#EventBody1AnchorPoint"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.EventBody2AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#EventBody2AnchorPoint"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#AnchorPoint"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.Axis", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#Axis"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.MaxAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#MaxAngle"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.MinAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#MinAngle"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.StopBounce", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#StopBounce"},
     {"title": "X3DNodes.TSingleAxisHingeJointNode.StopErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TSingleAxisHingeJointNode.html#StopErrorCorrection"},
     {"title": "X3DNodes.TSliderJointNode", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html"},
     {"title": "X3DNodes.TSliderJointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#CreateNode"},
     {"title": "X3DNodes.TSliderJointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSliderJointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#URNMatching"},
     {"title": "X3DNodes.TSliderJointNode.FdAxis", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#FdAxis"},
     {"title": "X3DNodes.TSliderJointNode.FdMaxSeparation", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#FdMaxSeparation"},
     {"title": "X3DNodes.TSliderJointNode.FdMinSeparation", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#FdMinSeparation"},
     {"title": "X3DNodes.TSliderJointNode.FdSliderForce", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#FdSliderForce"},
     {"title": "X3DNodes.TSliderJointNode.FdStopBounce", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#FdStopBounce"},
     {"title": "X3DNodes.TSliderJointNode.FdStopErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#FdStopErrorCorrection"},
     {"title": "X3DNodes.TSliderJointNode.EventSeparation", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#EventSeparation"},
     {"title": "X3DNodes.TSliderJointNode.EventSeparationRate", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#EventSeparationRate"},
     {"title": "X3DNodes.TSliderJointNode.Axis", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#Axis"},
     {"title": "X3DNodes.TSliderJointNode.MaxSeparation", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#MaxSeparation"},
     {"title": "X3DNodes.TSliderJointNode.MinSeparation", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#MinSeparation"},
     {"title": "X3DNodes.TSliderJointNode.StopBounce", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#StopBounce"},
     {"title": "X3DNodes.TSliderJointNode.StopErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TSliderJointNode.html#StopErrorCorrection"},
     {"title": "X3DNodes.TUniversalJointNode", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html"},
     {"title": "X3DNodes.TUniversalJointNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#CreateNode"},
     {"title": "X3DNodes.TUniversalJointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TUniversalJointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#URNMatching"},
     {"title": "X3DNodes.TUniversalJointNode.FdAnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#FdAnchorPoint"},
     {"title": "X3DNodes.TUniversalJointNode.FdAxis1", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#FdAxis1"},
     {"title": "X3DNodes.TUniversalJointNode.FdAxis2", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#FdAxis2"},
     {"title": "X3DNodes.TUniversalJointNode.FdStopBounce1", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#FdStopBounce1"},
     {"title": "X3DNodes.TUniversalJointNode.FdStop1ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#FdStop1ErrorCorrection"},
     {"title": "X3DNodes.TUniversalJointNode.FdStop2Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#FdStop2Bounce"},
     {"title": "X3DNodes.TUniversalJointNode.FdStop2ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#FdStop2ErrorCorrection"},
     {"title": "X3DNodes.TUniversalJointNode.EventBody1AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#EventBody1AnchorPoint"},
     {"title": "X3DNodes.TUniversalJointNode.EventBody1Axis", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#EventBody1Axis"},
     {"title": "X3DNodes.TUniversalJointNode.EventBody2AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#EventBody2AnchorPoint"},
     {"title": "X3DNodes.TUniversalJointNode.EventBody2Axis", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#EventBody2Axis"},
     {"title": "X3DNodes.TUniversalJointNode.AnchorPoint", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#AnchorPoint"},
     {"title": "X3DNodes.TUniversalJointNode.Axis1", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#Axis1"},
     {"title": "X3DNodes.TUniversalJointNode.Axis2", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#Axis2"},
     {"title": "X3DNodes.TUniversalJointNode.StopBounce1", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#StopBounce1"},
     {"title": "X3DNodes.TUniversalJointNode.Stop1ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#Stop1ErrorCorrection"},
     {"title": "X3DNodes.TUniversalJointNode.Stop2Bounce", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#Stop2Bounce"},
     {"title": "X3DNodes.TUniversalJointNode.Stop2ErrorCorrection", "text": " ", "tags": "", "loc": "X3DNodes.TUniversalJointNode.html#Stop2ErrorCorrection"},
     {"title": "X3DNodes.IAbstractPickableObject", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractPickableObject.html"},
     {"title": "X3DNodes.IAbstractPickableObject.FdObjectType", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractPickableObject.html#FdObjectType"},
     {"title": "X3DNodes.IAbstractPickableObject.FdPickable", "text": " ", "tags": "", "loc": "X3DNodes.IAbstractPickableObject.html#FdPickable"},
     {"title": "X3DNodes.TAbstractPickSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html"},
     {"title": "X3DNodes.TAbstractPickSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractPickSensorNode.SetObjectType", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#SetObjectType"},
     {"title": "X3DNodes.TAbstractPickSensorNode.SetObjectType", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#SetObjectType"},
     {"title": "X3DNodes.TAbstractPickSensorNode.FdObjectType", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#FdObjectType"},
     {"title": "X3DNodes.TAbstractPickSensorNode.FdPickingGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#FdPickingGeometry"},
     {"title": "X3DNodes.TAbstractPickSensorNode.FdPickTarget", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#FdPickTarget"},
     {"title": "X3DNodes.TAbstractPickSensorNode.EventPickedGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#EventPickedGeometry"},
     {"title": "X3DNodes.TAbstractPickSensorNode.FdIntersectionType", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#FdIntersectionType"},
     {"title": "X3DNodes.TAbstractPickSensorNode.FdSortOrder", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#FdSortOrder"},
     {"title": "X3DNodes.TAbstractPickSensorNode.PickingGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractPickSensorNode.html#PickingGeometry"},
     {"title": "X3DNodes.TLinePickSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TLinePickSensorNode.html"},
     {"title": "X3DNodes.TLinePickSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLinePickSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TLinePickSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLinePickSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLinePickSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLinePickSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TLinePickSensorNode.EventPickedNormal", "text": " ", "tags": "", "loc": "X3DNodes.TLinePickSensorNode.html#EventPickedNormal"},
     {"title": "X3DNodes.TLinePickSensorNode.EventPickedPoint", "text": " ", "tags": "", "loc": "X3DNodes.TLinePickSensorNode.html#EventPickedPoint"},
     {"title": "X3DNodes.TLinePickSensorNode.EventPickedTextureCoordinate", "text": " ", "tags": "", "loc": "X3DNodes.TLinePickSensorNode.html#EventPickedTextureCoordinate"},
     {"title": "X3DNodes.TPickableGroupNode", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.TPickableGroupNode.html"},
     {"title": "X3DNodes.TPickableGroupNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPickableGroupNode.html#CreateNode"},
     {"title": "X3DNodes.TPickableGroupNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPickableGroupNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPickableGroupNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPickableGroupNode.html#URNMatching"},
     {"title": "X3DNodes.TPickableGroupNode.SetObjectType", "text": "    ", "tags": "", "loc": "X3DNodes.TPickableGroupNode.html#SetObjectType"},
     {"title": "X3DNodes.TPickableGroupNode.SetObjectType", "text": "    ", "tags": "", "loc": "X3DNodes.TPickableGroupNode.html#SetObjectType"},
     {"title": "X3DNodes.TPickableGroupNode.FdObjectType", "text": " ", "tags": "", "loc": "X3DNodes.TPickableGroupNode.html#FdObjectType"},
     {"title": "X3DNodes.TPickableGroupNode.FdPickable", "text": " ", "tags": "", "loc": "X3DNodes.TPickableGroupNode.html#FdPickable"},
     {"title": "X3DNodes.TPickableGroupNode.Pickable", "text": " ", "tags": "", "loc": "X3DNodes.TPickableGroupNode.html#Pickable"},
     {"title": "X3DNodes.TPointPickSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TPointPickSensorNode.html"},
     {"title": "X3DNodes.TPointPickSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPointPickSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TPointPickSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPointPickSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPointPickSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPointPickSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TPointPickSensorNode.EventPickedPoint", "text": " ", "tags": "", "loc": "X3DNodes.TPointPickSensorNode.html#EventPickedPoint"},
     {"title": "X3DNodes.TPrimitivePickSensorNode", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.TPrimitivePickSensorNode.html"},
     {"title": "X3DNodes.TPrimitivePickSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPrimitivePickSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TPrimitivePickSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPrimitivePickSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPrimitivePickSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPrimitivePickSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TVolumePickSensorNode", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.TVolumePickSensorNode.html"},
     {"title": "X3DNodes.TVolumePickSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TVolumePickSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TVolumePickSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TVolumePickSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TVolumePickSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TVolumePickSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TAbstractFollowerNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractFollowerNode.html"},
     {"title": "X3DNodes.TAbstractFollowerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractFollowerNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractFollowerNode.EventIsActive", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractFollowerNode.html#EventIsActive"},
     {"title": "X3DNodes.TAbstractDamperNode", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.TAbstractDamperNode.html"},
     {"title": "X3DNodes.TAbstractDamperNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractDamperNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractDamperNode.FdTau", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDamperNode.html#FdTau"},
     {"title": "X3DNodes.TAbstractDamperNode.FdTolerance", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDamperNode.html#FdTolerance"},
     {"title": "X3DNodes.TAbstractDamperNode.FdOrder", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDamperNode.html#FdOrder"},
     {"title": "X3DNodes.TAbstractDamperNode.Tau", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDamperNode.html#Tau"},
     {"title": "X3DNodes.TAbstractDamperNode.Tolerance", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDamperNode.html#Tolerance"},
     {"title": "X3DNodes.TAbstractDamperNode.Order", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractDamperNode.html#Order"},
     {"title": "X3DNodes.TAbstractChaserNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractChaserNode.html"},
     {"title": "X3DNodes.TAbstractChaserNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractChaserNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractChaserNode.FdDuration", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractChaserNode.html#FdDuration"},
     {"title": "X3DNodes.TAbstractChaserNode.Duration", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractChaserNode.html#Duration"},
     {"title": "X3DNodes.TColorDamperNode", "text": " ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html"},
     {"title": "X3DNodes.TColorDamperNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#CreateNode"},
     {"title": "X3DNodes.TColorDamperNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#ClassX3DType"},
     {"title": "X3DNodes.TColorDamperNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#URNMatching"},
     {"title": "X3DNodes.TColorDamperNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#EventSet_destination"},
     {"title": "X3DNodes.TColorDamperNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#EventSet_value"},
     {"title": "X3DNodes.TColorDamperNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#EventValue_changed"},
     {"title": "X3DNodes.TColorDamperNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TColorDamperNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#FdInitialValue"},
     {"title": "X3DNodes.TColorDamperNode.InitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#InitialDestination"},
     {"title": "X3DNodes.TColorDamperNode.InitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TColorDamperNode.html#InitialValue"},
     {"title": "X3DNodes.TCoordinateDamperNode", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html"},
     {"title": "X3DNodes.TCoordinateDamperNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#CreateNode"},
     {"title": "X3DNodes.TCoordinateDamperNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCoordinateDamperNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#URNMatching"},
     {"title": "X3DNodes.TCoordinateDamperNode.SetInitialDestination", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#SetInitialDestination"},
     {"title": "X3DNodes.TCoordinateDamperNode.SetInitialDestination", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#SetInitialDestination"},
     {"title": "X3DNodes.TCoordinateDamperNode.SetInitialValue", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#SetInitialValue"},
     {"title": "X3DNodes.TCoordinateDamperNode.SetInitialValue", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#SetInitialValue"},
     {"title": "X3DNodes.TCoordinateDamperNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#EventSet_destination"},
     {"title": "X3DNodes.TCoordinateDamperNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#EventSet_value"},
     {"title": "X3DNodes.TCoordinateDamperNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#EventValue_changed"},
     {"title": "X3DNodes.TCoordinateDamperNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TCoordinateDamperNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDamperNode.html#FdInitialValue"},
     {"title": "X3DNodes.TOrientationChaserNode", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html"},
     {"title": "X3DNodes.TOrientationChaserNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#CreateNode"},
     {"title": "X3DNodes.TOrientationChaserNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#ClassX3DType"},
     {"title": "X3DNodes.TOrientationChaserNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#URNMatching"},
     {"title": "X3DNodes.TOrientationChaserNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#EventSet_destination"},
     {"title": "X3DNodes.TOrientationChaserNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#EventSet_value"},
     {"title": "X3DNodes.TOrientationChaserNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#EventValue_changed"},
     {"title": "X3DNodes.TOrientationChaserNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TOrientationChaserNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#FdInitialValue"},
     {"title": "X3DNodes.TOrientationChaserNode.InitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#InitialDestination"},
     {"title": "X3DNodes.TOrientationChaserNode.InitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationChaserNode.html#InitialValue"},
     {"title": "X3DNodes.TOrientationDamperNode", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html"},
     {"title": "X3DNodes.TOrientationDamperNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#CreateNode"},
     {"title": "X3DNodes.TOrientationDamperNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#ClassX3DType"},
     {"title": "X3DNodes.TOrientationDamperNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#URNMatching"},
     {"title": "X3DNodes.TOrientationDamperNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#EventSet_destination"},
     {"title": "X3DNodes.TOrientationDamperNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#EventSet_value"},
     {"title": "X3DNodes.TOrientationDamperNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#EventValue_changed"},
     {"title": "X3DNodes.TOrientationDamperNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TOrientationDamperNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#FdInitialValue"},
     {"title": "X3DNodes.TOrientationDamperNode.InitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#InitialDestination"},
     {"title": "X3DNodes.TOrientationDamperNode.InitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TOrientationDamperNode.html#InitialValue"},
     {"title": "X3DNodes.TPositionChaserNode", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html"},
     {"title": "X3DNodes.TPositionChaserNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#CreateNode"},
     {"title": "X3DNodes.TPositionChaserNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPositionChaserNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#URNMatching"},
     {"title": "X3DNodes.TPositionChaserNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#EventSet_destination"},
     {"title": "X3DNodes.TPositionChaserNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#EventSet_value"},
     {"title": "X3DNodes.TPositionChaserNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#EventValue_changed"},
     {"title": "X3DNodes.TPositionChaserNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TPositionChaserNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#FdInitialValue"},
     {"title": "X3DNodes.TPositionChaserNode.InitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#InitialDestination"},
     {"title": "X3DNodes.TPositionChaserNode.InitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaserNode.html#InitialValue"},
     {"title": "X3DNodes.TPositionChaser2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html"},
     {"title": "X3DNodes.TPositionChaser2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#CreateNode"},
     {"title": "X3DNodes.TPositionChaser2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPositionChaser2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#URNMatching"},
     {"title": "X3DNodes.TPositionChaser2DNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#EventSet_destination"},
     {"title": "X3DNodes.TPositionChaser2DNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#EventSet_value"},
     {"title": "X3DNodes.TPositionChaser2DNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#EventValue_changed"},
     {"title": "X3DNodes.TPositionChaser2DNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TPositionChaser2DNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#FdInitialValue"},
     {"title": "X3DNodes.TPositionChaser2DNode.InitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#InitialDestination"},
     {"title": "X3DNodes.TPositionChaser2DNode.InitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TPositionChaser2DNode.html#InitialValue"},
     {"title": "X3DNodes.TPositionDamperNode", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html"},
     {"title": "X3DNodes.TPositionDamperNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#CreateNode"},
     {"title": "X3DNodes.TPositionDamperNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPositionDamperNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#URNMatching"},
     {"title": "X3DNodes.TPositionDamperNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#EventSet_destination"},
     {"title": "X3DNodes.TPositionDamperNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#EventSet_value"},
     {"title": "X3DNodes.TPositionDamperNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#EventValue_changed"},
     {"title": "X3DNodes.TPositionDamperNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TPositionDamperNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#FdInitialValue"},
     {"title": "X3DNodes.TPositionDamperNode.InitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#InitialDestination"},
     {"title": "X3DNodes.TPositionDamperNode.InitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamperNode.html#InitialValue"},
     {"title": "X3DNodes.TPositionDamper2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html"},
     {"title": "X3DNodes.TPositionDamper2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#CreateNode"},
     {"title": "X3DNodes.TPositionDamper2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPositionDamper2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#URNMatching"},
     {"title": "X3DNodes.TPositionDamper2DNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#EventSet_destination"},
     {"title": "X3DNodes.TPositionDamper2DNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#EventSet_value"},
     {"title": "X3DNodes.TPositionDamper2DNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#EventValue_changed"},
     {"title": "X3DNodes.TPositionDamper2DNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TPositionDamper2DNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#FdInitialValue"},
     {"title": "X3DNodes.TPositionDamper2DNode.InitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#InitialDestination"},
     {"title": "X3DNodes.TPositionDamper2DNode.InitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TPositionDamper2DNode.html#InitialValue"},
     {"title": "X3DNodes.TScalarChaserNode", "text": " ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html"},
     {"title": "X3DNodes.TScalarChaserNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#CreateNode"},
     {"title": "X3DNodes.TScalarChaserNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#ClassX3DType"},
     {"title": "X3DNodes.TScalarChaserNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#URNMatching"},
     {"title": "X3DNodes.TScalarChaserNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#EventSet_destination"},
     {"title": "X3DNodes.TScalarChaserNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#EventSet_value"},
     {"title": "X3DNodes.TScalarChaserNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#EventValue_changed"},
     {"title": "X3DNodes.TScalarChaserNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TScalarChaserNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#FdInitialValue"},
     {"title": "X3DNodes.TScalarChaserNode.InitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#InitialDestination"},
     {"title": "X3DNodes.TScalarChaserNode.InitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TScalarChaserNode.html#InitialValue"},
     {"title": "X3DNodes.TTexCoordDamper2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#CreateNode"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#URNMatching"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.SetInitialDestination", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#SetInitialDestination"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.SetInitialDestination", "text": "    ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#SetInitialDestination"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.SetInitialValue", "text": "    ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#SetInitialValue"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.SetInitialValue", "text": "    ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#SetInitialValue"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.EventSet_destination", "text": " ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#EventSet_destination"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.EventSet_value", "text": " ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#EventSet_value"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.EventValue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#EventValue_changed"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.FdInitialDestination", "text": " ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#FdInitialDestination"},
     {"title": "X3DNodes.TTexCoordDamper2DNode.FdInitialValue", "text": " ", "tags": "", "loc": "X3DNodes.TTexCoordDamper2DNode.html#FdInitialValue"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode.FdSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html#FdSpeed"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode.FdVariation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html#FdVariation"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode.FdMass", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html#FdMass"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode.FdSurfaceArea", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html#FdSurfaceArea"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode.Speed", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html#Speed"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode.Variation", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html#Variation"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode.Mass", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html#Mass"},
     {"title": "X3DNodes.TAbstractParticleEmitterNode.SurfaceArea", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticleEmitterNode.html#SurfaceArea"},
     {"title": "X3DNodes.TAbstractParticlePhysicsModelNode", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticlePhysicsModelNode.html"},
     {"title": "X3DNodes.TAbstractParticlePhysicsModelNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractParticlePhysicsModelNode.html#CreateNode"},
     {"title": "X3DNodes.TAbstractParticlePhysicsModelNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticlePhysicsModelNode.html#FdEnabled"},
     {"title": "X3DNodes.TAbstractParticlePhysicsModelNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractParticlePhysicsModelNode.html#Enabled"},
     {"title": "X3DNodes.TBoundedPhysicsModelNode", "text": " ", "tags": "", "loc": "X3DNodes.TBoundedPhysicsModelNode.html"},
     {"title": "X3DNodes.TBoundedPhysicsModelNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBoundedPhysicsModelNode.html#CreateNode"},
     {"title": "X3DNodes.TBoundedPhysicsModelNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBoundedPhysicsModelNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBoundedPhysicsModelNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBoundedPhysicsModelNode.html#URNMatching"},
     {"title": "X3DNodes.TBoundedPhysicsModelNode.FdGeometry", "text": " ", "tags": "", "loc": "X3DNodes.TBoundedPhysicsModelNode.html#FdGeometry"},
     {"title": "X3DNodes.TBoundedPhysicsModelNode.Geometry", "text": " ", "tags": "", "loc": "X3DNodes.TBoundedPhysicsModelNode.html#Geometry"},
     {"title": "X3DNodes.TConeEmitterNode", "text": " ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html"},
     {"title": "X3DNodes.TConeEmitterNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html#CreateNode"},
     {"title": "X3DNodes.TConeEmitterNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html#ClassX3DType"},
     {"title": "X3DNodes.TConeEmitterNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html#URNMatching"},
     {"title": "X3DNodes.TConeEmitterNode.FdAngle", "text": " ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html#FdAngle"},
     {"title": "X3DNodes.TConeEmitterNode.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html#FdDirection"},
     {"title": "X3DNodes.TConeEmitterNode.FdPosition", "text": " ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html#FdPosition"},
     {"title": "X3DNodes.TConeEmitterNode.Angle", "text": " ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html#Angle"},
     {"title": "X3DNodes.TConeEmitterNode.Direction", "text": " ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html#Direction"},
     {"title": "X3DNodes.TConeEmitterNode.Position", "text": " ", "tags": "", "loc": "X3DNodes.TConeEmitterNode.html#Position"},
     {"title": "X3DNodes.TExplosionEmitterNode", "text": " ", "tags": "", "loc": "X3DNodes.TExplosionEmitterNode.html"},
     {"title": "X3DNodes.TExplosionEmitterNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TExplosionEmitterNode.html#CreateNode"},
     {"title": "X3DNodes.TExplosionEmitterNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TExplosionEmitterNode.html#ClassX3DType"},
     {"title": "X3DNodes.TExplosionEmitterNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TExplosionEmitterNode.html#URNMatching"},
     {"title": "X3DNodes.TExplosionEmitterNode.FdPosition", "text": " ", "tags": "", "loc": "X3DNodes.TExplosionEmitterNode.html#FdPosition"},
     {"title": "X3DNodes.TExplosionEmitterNode.Position", "text": " ", "tags": "", "loc": "X3DNodes.TExplosionEmitterNode.html#Position"},
     {"title": "X3DNodes.TForcePhysicsModelNode", "text": " ", "tags": "", "loc": "X3DNodes.TForcePhysicsModelNode.html"},
     {"title": "X3DNodes.TForcePhysicsModelNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TForcePhysicsModelNode.html#CreateNode"},
     {"title": "X3DNodes.TForcePhysicsModelNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TForcePhysicsModelNode.html#ClassX3DType"},
     {"title": "X3DNodes.TForcePhysicsModelNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TForcePhysicsModelNode.html#URNMatching"},
     {"title": "X3DNodes.TForcePhysicsModelNode.FdForce", "text": " ", "tags": "", "loc": "X3DNodes.TForcePhysicsModelNode.html#FdForce"},
     {"title": "X3DNodes.TForcePhysicsModelNode.Force", "text": " ", "tags": "", "loc": "X3DNodes.TForcePhysicsModelNode.html#Force"},
     {"title": "X3DNodes.TParticleSystemNode", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html"},
     {"title": "X3DNodes.TParticleSystemNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#CreateNode"},
     {"title": "X3DNodes.TParticleSystemNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#ClassX3DType"},
     {"title": "X3DNodes.TParticleSystemNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#URNMatching"},
     {"title": "X3DNodes.TParticleSystemNode.SetColorKey", "text": "    ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#SetColorKey"},
     {"title": "X3DNodes.TParticleSystemNode.SetColorKey", "text": "    ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#SetColorKey"},
     {"title": "X3DNodes.TParticleSystemNode.SetPhysics", "text": "    ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#SetPhysics"},
     {"title": "X3DNodes.TParticleSystemNode.SetTexCoordKey", "text": "    ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#SetTexCoordKey"},
     {"title": "X3DNodes.TParticleSystemNode.SetTexCoordKey", "text": "    ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#SetTexCoordKey"},
     {"title": "X3DNodes.TParticleSystemNode.FdCreateParticles", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdCreateParticles"},
     {"title": "X3DNodes.TParticleSystemNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdEnabled"},
     {"title": "X3DNodes.TParticleSystemNode.FdLifetimeVariation", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdLifetimeVariation"},
     {"title": "X3DNodes.TParticleSystemNode.FdMaxParticles", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdMaxParticles"},
     {"title": "X3DNodes.TParticleSystemNode.FdParticleLifetime", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdParticleLifetime"},
     {"title": "X3DNodes.TParticleSystemNode.FdParticleSize", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdParticleSize"},
     {"title": "X3DNodes.TParticleSystemNode.EventIsActive", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#EventIsActive"},
     {"title": "X3DNodes.TParticleSystemNode.FdColorRamp", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdColorRamp"},
     {"title": "X3DNodes.TParticleSystemNode.FdColorKey", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdColorKey"},
     {"title": "X3DNodes.TParticleSystemNode.FdEmitter", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdEmitter"},
     {"title": "X3DNodes.TParticleSystemNode.FdGeometryType", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdGeometryType"},
     {"title": "X3DNodes.TParticleSystemNode.FdPhysics", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdPhysics"},
     {"title": "X3DNodes.TParticleSystemNode.FdTexCoordRamp", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdTexCoordRamp"},
     {"title": "X3DNodes.TParticleSystemNode.FdTexCoordKey", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#FdTexCoordKey"},
     {"title": "X3DNodes.TParticleSystemNode.CreateParticles", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#CreateParticles"},
     {"title": "X3DNodes.TParticleSystemNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#Enabled"},
     {"title": "X3DNodes.TParticleSystemNode.LifetimeVariation", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#LifetimeVariation"},
     {"title": "X3DNodes.TParticleSystemNode.MaxParticles", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#MaxParticles"},
     {"title": "X3DNodes.TParticleSystemNode.ParticleLifetime", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#ParticleLifetime"},
     {"title": "X3DNodes.TParticleSystemNode.ParticleSize", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#ParticleSize"},
     {"title": "X3DNodes.TParticleSystemNode.ColorRamp", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#ColorRamp"},
     {"title": "X3DNodes.TParticleSystemNode.Emitter", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#Emitter"},
     {"title": "X3DNodes.TParticleSystemNode.TexCoordRamp", "text": " ", "tags": "", "loc": "X3DNodes.TParticleSystemNode.html#TexCoordRamp"},
     {"title": "X3DNodes.TPointEmitterNode", "text": " ", "tags": "", "loc": "X3DNodes.TPointEmitterNode.html"},
     {"title": "X3DNodes.TPointEmitterNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPointEmitterNode.html#CreateNode"},
     {"title": "X3DNodes.TPointEmitterNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPointEmitterNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPointEmitterNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPointEmitterNode.html#URNMatching"},
     {"title": "X3DNodes.TPointEmitterNode.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TPointEmitterNode.html#FdDirection"},
     {"title": "X3DNodes.TPointEmitterNode.FdPosition", "text": " ", "tags": "", "loc": "X3DNodes.TPointEmitterNode.html#FdPosition"},
     {"title": "X3DNodes.TPointEmitterNode.Direction", "text": " ", "tags": "", "loc": "X3DNodes.TPointEmitterNode.html#Direction"},
     {"title": "X3DNodes.TPointEmitterNode.Position", "text": " ", "tags": "", "loc": "X3DNodes.TPointEmitterNode.html#Position"},
     {"title": "X3DNodes.TPolylineEmitterNode", "text": " ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html"},
     {"title": "X3DNodes.TPolylineEmitterNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#CreateNode"},
     {"title": "X3DNodes.TPolylineEmitterNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPolylineEmitterNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#URNMatching"},
     {"title": "X3DNodes.TPolylineEmitterNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TPolylineEmitterNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TPolylineEmitterNode.EventSet_coordinate", "text": " ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#EventSet_coordinate"},
     {"title": "X3DNodes.TPolylineEmitterNode.FdCoord", "text": " ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#FdCoord"},
     {"title": "X3DNodes.TPolylineEmitterNode.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#FdDirection"},
     {"title": "X3DNodes.TPolylineEmitterNode.FdCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#FdCoordIndex"},
     {"title": "X3DNodes.TPolylineEmitterNode.Coord", "text": " ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#Coord"},
     {"title": "X3DNodes.TPolylineEmitterNode.Direction", "text": " ", "tags": "", "loc": "X3DNodes.TPolylineEmitterNode.html#Direction"},
     {"title": "X3DNodes.TSurfaceEmitterNode", "text": " ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html"},
     {"title": "X3DNodes.TSurfaceEmitterNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html#CreateNode"},
     {"title": "X3DNodes.TSurfaceEmitterNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSurfaceEmitterNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html#URNMatching"},
     {"title": "X3DNodes.TSurfaceEmitterNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TSurfaceEmitterNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TSurfaceEmitterNode.EventSet_coordinate", "text": " ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html#EventSet_coordinate"},
     {"title": "X3DNodes.TSurfaceEmitterNode.FdCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html#FdCoordIndex"},
     {"title": "X3DNodes.TSurfaceEmitterNode.FdSurface", "text": " ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html#FdSurface"},
     {"title": "X3DNodes.TSurfaceEmitterNode.Surface", "text": " ", "tags": "", "loc": "X3DNodes.TSurfaceEmitterNode.html#Surface"},
     {"title": "X3DNodes.TVolumeEmitterNode", "text": " ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html"},
     {"title": "X3DNodes.TVolumeEmitterNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#CreateNode"},
     {"title": "X3DNodes.TVolumeEmitterNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#ClassX3DType"},
     {"title": "X3DNodes.TVolumeEmitterNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#URNMatching"},
     {"title": "X3DNodes.TVolumeEmitterNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TVolumeEmitterNode.SetCoordIndex", "text": "    ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#SetCoordIndex"},
     {"title": "X3DNodes.TVolumeEmitterNode.EventSet_coordinate", "text": " ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#EventSet_coordinate"},
     {"title": "X3DNodes.TVolumeEmitterNode.FdCoord", "text": " ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#FdCoord"},
     {"title": "X3DNodes.TVolumeEmitterNode.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#FdDirection"},
     {"title": "X3DNodes.TVolumeEmitterNode.FdCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#FdCoordIndex"},
     {"title": "X3DNodes.TVolumeEmitterNode.FdInternal", "text": " ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#FdInternal"},
     {"title": "X3DNodes.TVolumeEmitterNode.Coord", "text": " ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#Coord"},
     {"title": "X3DNodes.TVolumeEmitterNode.Direction", "text": " ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#Direction"},
     {"title": "X3DNodes.TVolumeEmitterNode.Internal", "text": " ", "tags": "", "loc": "X3DNodes.TVolumeEmitterNode.html#Internal"},
     {"title": "X3DNodes.TWindPhysicsModelNode", "text": " ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html"},
     {"title": "X3DNodes.TWindPhysicsModelNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#CreateNode"},
     {"title": "X3DNodes.TWindPhysicsModelNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#ClassX3DType"},
     {"title": "X3DNodes.TWindPhysicsModelNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#URNMatching"},
     {"title": "X3DNodes.TWindPhysicsModelNode.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#FdDirection"},
     {"title": "X3DNodes.TWindPhysicsModelNode.FdGustiness", "text": " ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#FdGustiness"},
     {"title": "X3DNodes.TWindPhysicsModelNode.FdSpeed", "text": " ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#FdSpeed"},
     {"title": "X3DNodes.TWindPhysicsModelNode.FdTurbulence", "text": " ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#FdTurbulence"},
     {"title": "X3DNodes.TWindPhysicsModelNode.Direction", "text": " ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#Direction"},
     {"title": "X3DNodes.TWindPhysicsModelNode.Gustiness", "text": " ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#Gustiness"},
     {"title": "X3DNodes.TWindPhysicsModelNode.Speed", "text": " ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#Speed"},
     {"title": "X3DNodes.TWindPhysicsModelNode.Turbulence", "text": " ", "tags": "", "loc": "X3DNodes.TWindPhysicsModelNode.html#Turbulence"},
     {"title": "X3DNodes.TAbstractGeometryNode_1", "text": "  <p>In VRML 1.0 shape nodes are allowed pretty everywhere, while VRML 2.0 has different idea of how shapes are handled (they must be inside Shape node), so no shape node is suitable at the same time for VRML 1.0 and VRML 2.0. ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode_1.html"},
     {"title": "X3DNodes.TAbstractGeometryNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractGeometryNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TAsciiTextNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html"},
     {"title": "X3DNodes.TAsciiTextNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#CreateNode"},
     {"title": "X3DNodes.TAsciiTextNode_1.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#Destroy"},
     {"title": "X3DNodes.TAsciiTextNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TAsciiTextNode_1.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#Proxy"},
     {"title": "X3DNodes.TAsciiTextNode_1.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TAsciiTextNode_1.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#LocalBoundingBox"},
     {"title": "X3DNodes.TAsciiTextNode_1.FontTextureNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#FontTextureNode"},
     {"title": "X3DNodes.TAsciiTextNode_1.FontChanged", "text": " For now, we don't detect font changes (when <a class=\"normal\" href=\"X3DNodes.TFontStyleNode.html#OnFont\">TFontStyleNode.OnFont</a> returns something different) outselves.    ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#FontChanged"},
     {"title": "X3DNodes.TAsciiTextNode_1.Justify", "text": "    ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#Justify"},
     {"title": "X3DNodes.TAsciiTextNode_1.FdString", "text": " ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#FdString"},
     {"title": "X3DNodes.TAsciiTextNode_1.FdSpacing", "text": " ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#FdSpacing"},
     {"title": "X3DNodes.TAsciiTextNode_1.FdJustification", "text": " ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#FdJustification"},
     {"title": "X3DNodes.TAsciiTextNode_1.FdWidth", "text": " ", "tags": "", "loc": "X3DNodes.TAsciiTextNode_1.html#FdWidth"},
     {"title": "X3DNodes.TConeNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode_1.html"},
     {"title": "X3DNodes.TConeNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#CreateNode"},
     {"title": "X3DNodes.TConeNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TConeNode_1.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#Proxy"},
     {"title": "X3DNodes.TConeNode_1.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#BoundingBox"},
     {"title": "X3DNodes.TConeNode_1.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#LocalBoundingBox"},
     {"title": "X3DNodes.TConeNode_1.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#TrianglesCount"},
     {"title": "X3DNodes.TConeNode_1.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TConeNode_1.FdParts", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#FdParts"},
     {"title": "X3DNodes.TConeNode_1.FdBottomRadius", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#FdBottomRadius"},
     {"title": "X3DNodes.TConeNode_1.FdHeight", "text": " ", "tags": "", "loc": "X3DNodes.TConeNode_1.html#FdHeight"},
     {"title": "X3DNodes.TCubeNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html"},
     {"title": "X3DNodes.TCubeNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#CreateNode"},
     {"title": "X3DNodes.TCubeNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TCubeNode_1.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#Proxy"},
     {"title": "X3DNodes.TCubeNode_1.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#BoundingBox"},
     {"title": "X3DNodes.TCubeNode_1.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#LocalBoundingBox"},
     {"title": "X3DNodes.TCubeNode_1.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#TrianglesCount"},
     {"title": "X3DNodes.TCubeNode_1.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TCubeNode_1.FdWidth", "text": " ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#FdWidth"},
     {"title": "X3DNodes.TCubeNode_1.FdHeight", "text": " ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#FdHeight"},
     {"title": "X3DNodes.TCubeNode_1.FdDepth", "text": " ", "tags": "", "loc": "X3DNodes.TCubeNode_1.html#FdDepth"},
     {"title": "X3DNodes.TCylinderNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html"},
     {"title": "X3DNodes.TCylinderNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#CreateNode"},
     {"title": "X3DNodes.TCylinderNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TCylinderNode_1.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#Proxy"},
     {"title": "X3DNodes.TCylinderNode_1.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#BoundingBox"},
     {"title": "X3DNodes.TCylinderNode_1.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#LocalBoundingBox"},
     {"title": "X3DNodes.TCylinderNode_1.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#TrianglesCount"},
     {"title": "X3DNodes.TCylinderNode_1.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TCylinderNode_1.FdParts", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#FdParts"},
     {"title": "X3DNodes.TCylinderNode_1.FdRadius", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#FdRadius"},
     {"title": "X3DNodes.TCylinderNode_1.FdHeight", "text": " ", "tags": "", "loc": "X3DNodes.TCylinderNode_1.html#FdHeight"},
     {"title": "X3DNodes.TAbstractIndexedNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractIndexedNode_1.html"},
     {"title": "X3DNodes.TAbstractIndexedNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractIndexedNode_1.html#CreateNode"},
     {"title": "X3DNodes.TAbstractIndexedNode_1.InternalCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractIndexedNode_1.html#InternalCoord"},
     {"title": "X3DNodes.TAbstractIndexedNode_1.CoordIndexField", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractIndexedNode_1.html#CoordIndexField"},
     {"title": "X3DNodes.TAbstractIndexedNode_1.FdCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractIndexedNode_1.html#FdCoordIndex"},
     {"title": "X3DNodes.TAbstractIndexedNode_1.FdMaterialIndex", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractIndexedNode_1.html#FdMaterialIndex"},
     {"title": "X3DNodes.TAbstractIndexedNode_1.FdNormalIndex", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractIndexedNode_1.html#FdNormalIndex"},
     {"title": "X3DNodes.TAbstractIndexedNode_1.FdTextureCoordIndex", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractIndexedNode_1.html#FdTextureCoordIndex"},
     {"title": "X3DNodes.TIndexedFacesOrTrianglesNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFacesOrTrianglesNode_1.html"},
     {"title": "X3DNodes.TIndexedFacesOrTrianglesNode_1.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFacesOrTrianglesNode_1.html#TrianglesCount"},
     {"title": "X3DNodes.TIndexedFaceSetNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode_1.html"},
     {"title": "X3DNodes.TIndexedFaceSetNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode_1.html#CreateNode"},
     {"title": "X3DNodes.TIndexedFaceSetNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TIndexedFaceSetNode_1.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode_1.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TIndexedFaceSetNode_1.InternalTexCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode_1.html#InternalTexCoord"},
     {"title": "X3DNodes.TIndexedFaceSetNode_1.FdRadianceTransfer", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedFaceSetNode_1.html#FdRadianceTransfer"},
     {"title": "X3DNodes.TIndexedLineSetNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode_1.html"},
     {"title": "X3DNodes.TIndexedLineSetNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TIndexedLineSetNode_1.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode_1.html#TrianglesCount"},
     {"title": "X3DNodes.TIndexedLineSetNode_1.InternalTexCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode_1.html#InternalTexCoord"},
     {"title": "X3DNodes.TIndexedLineSetNode_1.Lit", "text": " VRML 1.0 specification explicitly mentions that IndexedLineSet is treated specially: it's unlit if there are not enough normals specified.    ", "tags": "", "loc": "X3DNodes.TIndexedLineSetNode_1.html#Lit"},
     {"title": "X3DNodes.TPointSetNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode_1.html"},
     {"title": "X3DNodes.TPointSetNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode_1.html#CreateNode"},
     {"title": "X3DNodes.TPointSetNode_1.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode_1.html#Destroy"},
     {"title": "X3DNodes.TPointSetNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TPointSetNode_1.InternalCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode_1.html#InternalCoord"},
     {"title": "X3DNodes.TPointSetNode_1.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode_1.html#TrianglesCount"},
     {"title": "X3DNodes.TPointSetNode_1.Lit", "text": "    ", "tags": "", "loc": "X3DNodes.TPointSetNode_1.html#Lit"},
     {"title": "X3DNodes.TPointSetNode_1.FdStartIndex", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode_1.html#FdStartIndex"},
     {"title": "X3DNodes.TPointSetNode_1.FdNumPoints", "text": " ", "tags": "", "loc": "X3DNodes.TPointSetNode_1.html#FdNumPoints"},
     {"title": "X3DNodes.TSphereNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode_1.html"},
     {"title": "X3DNodes.TSphereNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode_1.html#CreateNode"},
     {"title": "X3DNodes.TSphereNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TSphereNode_1.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode_1.html#Proxy"},
     {"title": "X3DNodes.TSphereNode_1.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode_1.html#BoundingBox"},
     {"title": "X3DNodes.TSphereNode_1.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode_1.html#LocalBoundingBox"},
     {"title": "X3DNodes.TSphereNode_1.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode_1.html#TrianglesCount"},
     {"title": "X3DNodes.TSphereNode_1.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TSphereNode_1.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TSphereNode_1.FdRadius", "text": " ", "tags": "", "loc": "X3DNodes.TSphereNode_1.html#FdRadius"},
     {"title": "X3DNodes.TCoordinate3Node_1", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinate3Node_1.html"},
     {"title": "X3DNodes.TCoordinate3Node_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinate3Node_1.html#CreateNode"},
     {"title": "X3DNodes.TCoordinate3Node_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinate3Node_1.html#ClassX3DType"},
     {"title": "X3DNodes.TCoordinate3Node_1.FdPoint", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinate3Node_1.html#FdPoint"},
     {"title": "X3DNodes.TFontStyleNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html"},
     {"title": "X3DNodes.TFontStyleNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#CreateNode"},
     {"title": "X3DNodes.TFontStyleNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TFontStyleNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TFontStyleNode_1.Family", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#Family"},
     {"title": "X3DNodes.TFontStyleNode_1.Bold", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#Bold"},
     {"title": "X3DNodes.TFontStyleNode_1.Italic", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#Italic"},
     {"title": "X3DNodes.TFontStyleNode_1.Font", "text": "    ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#Font"},
     {"title": "X3DNodes.TFontStyleNode_1.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#FdSize"},
     {"title": "X3DNodes.TFontStyleNode_1.FdFamily", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#FdFamily"},
     {"title": "X3DNodes.TFontStyleNode_1.FdStyle", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#FdStyle"},
     {"title": "X3DNodes.TFontStyleNode_1.FdBlending", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#FdBlending"},
     {"title": "X3DNodes.TFontStyleNode_1.Blending", "text": " ", "tags": "", "loc": "X3DNodes.TFontStyleNode_1.html#Blending"},
     {"title": "X3DNodes.TInfoNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TInfoNode_1.html"},
     {"title": "X3DNodes.TInfoNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TInfoNode_1.html#CreateNode"},
     {"title": "X3DNodes.TInfoNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TInfoNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TInfoNode_1.FdString", "text": " ", "tags": "", "loc": "X3DNodes.TInfoNode_1.html#FdString"},
     {"title": "X3DNodes.TLODNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TLODNode_1.html"},
     {"title": "X3DNodes.TLODNode_1.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TLODNode_1.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TLODNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLODNode_1.html#CreateNode"},
     {"title": "X3DNodes.TLODNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLODNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TLODNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TLODNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TLODNode_1.FdRange", "text": " ", "tags": "", "loc": "X3DNodes.TLODNode_1.html#FdRange"},
     {"title": "X3DNodes.TLODNode_1.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TLODNode_1.html#FdCenter"},
     {"title": "X3DNodes.TMaterialNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html"},
     {"title": "X3DNodes.TMaterialNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#CreateNode"},
     {"title": "X3DNodes.TMaterialNode_1.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#Destroy"},
     {"title": "X3DNodes.TMaterialNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TMaterialNode_1.PureEmissive", "text": " This detects a special case described in VRML 1.0 specification: when ambient, diffuse and specular are all empty (no values), then emissiveColor should be used at the final color and shape should be unlit.  <p>You should use the EmissiveColor4Single in this case.    ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#PureEmissive"},
     {"title": "X3DNodes.TMaterialNode_1.ForcePureEmissive", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#ForcePureEmissive"},
     {"title": "X3DNodes.TMaterialNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TMaterialNode_1.MaterialInfo", "text": " It is automatically updated when properties of this material change. Do not free it yourself, it will be automatically freed when this node is freed.    ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#MaterialInfo"},
     {"title": "X3DNodes.TMaterialNode_1.FdAmbientColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdAmbientColor"},
     {"title": "X3DNodes.TMaterialNode_1.FdDiffuseColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdDiffuseColor"},
     {"title": "X3DNodes.TMaterialNode_1.FdSpecularColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdSpecularColor"},
     {"title": "X3DNodes.TMaterialNode_1.FdEmissiveColor", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdEmissiveColor"},
     {"title": "X3DNodes.TMaterialNode_1.FdShininess", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdShininess"},
     {"title": "X3DNodes.TMaterialNode_1.FdTransparency", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdTransparency"},
     {"title": "X3DNodes.TMaterialNode_1.FdMirror", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdMirror"},
     {"title": "X3DNodes.TMaterialNode_1.FdReflSpecular", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdReflSpecular"},
     {"title": "X3DNodes.TMaterialNode_1.FdReflDiffuse", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdReflDiffuse"},
     {"title": "X3DNodes.TMaterialNode_1.FdTransSpecular", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdTransSpecular"},
     {"title": "X3DNodes.TMaterialNode_1.FdTransDiffuse", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdTransDiffuse"},
     {"title": "X3DNodes.TMaterialNode_1.FdReflSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdReflSpecularExp"},
     {"title": "X3DNodes.TMaterialNode_1.FdTransSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdTransSpecularExp"},
     {"title": "X3DNodes.TMaterialNode_1.FdFogImmune", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialNode_1.html#FdFogImmune"},
     {"title": "X3DNodes.TMaterialBindingNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialBindingNode_1.html"},
     {"title": "X3DNodes.TMaterialBindingNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialBindingNode_1.html#CreateNode"},
     {"title": "X3DNodes.TMaterialBindingNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMaterialBindingNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TMaterialBindingNode_1.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TMaterialBindingNode_1.html#FdValue"},
     {"title": "X3DNodes.TNormalBindingNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TNormalBindingNode_1.html"},
     {"title": "X3DNodes.TNormalBindingNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNormalBindingNode_1.html#CreateNode"},
     {"title": "X3DNodes.TNormalBindingNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNormalBindingNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TNormalBindingNode_1.FdValue", "text": " ", "tags": "", "loc": "X3DNodes.TNormalBindingNode_1.html#FdValue"},
     {"title": "X3DNodes.TTexture2Node_1", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html"},
     {"title": "X3DNodes.TTexture2Node_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html#CreateNode"},
     {"title": "X3DNodes.TTexture2Node_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html#ClassX3DType"},
     {"title": "X3DNodes.TTexture2Node_1.TextureDescription", "text": "    ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html#TextureDescription"},
     {"title": "X3DNodes.TTexture2Node_1.FdFilename", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html#FdFilename"},
     {"title": "X3DNodes.TTexture2Node_1.FdImage", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html#FdImage"},
     {"title": "X3DNodes.TTexture2Node_1.FdWrapS", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html#FdWrapS"},
     {"title": "X3DNodes.TTexture2Node_1.FdWrapT", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html#FdWrapT"},
     {"title": "X3DNodes.TTexture2Node_1.FdModel", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html#FdModel"},
     {"title": "X3DNodes.TTexture2Node_1.FdBlendColor", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2Node_1.html#FdBlendColor"},
     {"title": "X3DNodes.TTexture2TransformNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2TransformNode_1.html"},
     {"title": "X3DNodes.TTexture2TransformNode_1.MiddleTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TTexture2TransformNode_1.html#MiddleTraverse"},
     {"title": "X3DNodes.TTexture2TransformNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTexture2TransformNode_1.html#CreateNode"},
     {"title": "X3DNodes.TTexture2TransformNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTexture2TransformNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TTexture2TransformNode_1.TextureMatrixTransformation", "text": "    ", "tags": "", "loc": "X3DNodes.TTexture2TransformNode_1.html#TextureMatrixTransformation"},
     {"title": "X3DNodes.TTexture2TransformNode_1.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2TransformNode_1.html#FdTranslation"},
     {"title": "X3DNodes.TTexture2TransformNode_1.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2TransformNode_1.html#FdRotation"},
     {"title": "X3DNodes.TTexture2TransformNode_1.FdScaleFactor", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2TransformNode_1.html#FdScaleFactor"},
     {"title": "X3DNodes.TTexture2TransformNode_1.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TTexture2TransformNode_1.html#FdCenter"},
     {"title": "X3DNodes.TTextureCoordinate2Node_1", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinate2Node_1.html"},
     {"title": "X3DNodes.TTextureCoordinate2Node_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate2Node_1.html#CreateNode"},
     {"title": "X3DNodes.TTextureCoordinate2Node_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTextureCoordinate2Node_1.html#ClassX3DType"},
     {"title": "X3DNodes.TTextureCoordinate2Node_1.FdPoint", "text": " ", "tags": "", "loc": "X3DNodes.TTextureCoordinate2Node_1.html#FdPoint"},
     {"title": "X3DNodes.TShapeHintsNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TShapeHintsNode_1.html"},
     {"title": "X3DNodes.TShapeHintsNode_1.ParseNodeBodyElement", "text": "    ", "tags": "", "loc": "X3DNodes.TShapeHintsNode_1.html#ParseNodeBodyElement"},
     {"title": "X3DNodes.TShapeHintsNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TShapeHintsNode_1.html#CreateNode"},
     {"title": "X3DNodes.TShapeHintsNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TShapeHintsNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TShapeHintsNode_1.FdVertexOrdering", "text": " ", "tags": "", "loc": "X3DNodes.TShapeHintsNode_1.html#FdVertexOrdering"},
     {"title": "X3DNodes.TShapeHintsNode_1.FdShapeType", "text": " ", "tags": "", "loc": "X3DNodes.TShapeHintsNode_1.html#FdShapeType"},
     {"title": "X3DNodes.TShapeHintsNode_1.FdFaceType", "text": " ", "tags": "", "loc": "X3DNodes.TShapeHintsNode_1.html#FdFaceType"},
     {"title": "X3DNodes.TShapeHintsNode_1.FdCreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.TShapeHintsNode_1.html#FdCreaseAngle"},
     {"title": "X3DNodes.TAbstractTransformationNode_1", "text": " In descendants you only have to override the MatrixTransform method. ", "tags": "", "loc": "X3DNodes.TAbstractTransformationNode_1.html"},
     {"title": "X3DNodes.TAbstractTransformationNode_1.MiddleTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTransformationNode_1.html#MiddleTraverse"},
     {"title": "X3DNodes.TAbstractTransformationNode_1.Transformation", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTransformationNode_1.html#Transformation"},
     {"title": "X3DNodes.TAbstractTransformationNode_1.TransformScale", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractTransformationNode_1.html#TransformScale"},
     {"title": "X3DNodes.TMatrixTransformNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode_1.html"},
     {"title": "X3DNodes.TMatrixTransformNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode_1.html#CreateNode"},
     {"title": "X3DNodes.TMatrixTransformNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TMatrixTransformNode_1.Transformation", "text": " Inverse is also calculated (if matrix is invertible at all, otherwise identity is returned).    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode_1.html#Transformation"},
     {"title": "X3DNodes.TMatrixTransformNode_1.TransformScale", "text": "  <p>Note that this doesn't correctly extract scale from <a class=\"normal\" href=\"X3DNodes.TMatrixTransformNode_1.html#FdMatrix\">FdMatrix</a>, as that is too difficcult. Insted it does simple extraction, which will work for identity, translation and scaling matrices (but e.g. will fail miserably (generate nonsense results) when looking at some rotation matrices).  <p>Ultimately, this is the reason why VRML 2.0 removed this node from specification: extracting some features from arbitrary given 4x4 matrix is very difficult.    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode_1.html#TransformScale"},
     {"title": "X3DNodes.TMatrixTransformNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TMatrixTransformNode_1.FdMatrix", "text": " ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode_1.html#FdMatrix"},
     {"title": "X3DNodes.TRotationNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TRotationNode_1.html"},
     {"title": "X3DNodes.TRotationNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TRotationNode_1.html#CreateNode"},
     {"title": "X3DNodes.TRotationNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TRotationNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TRotationNode_1.Transformation", "text": "    ", "tags": "", "loc": "X3DNodes.TRotationNode_1.html#Transformation"},
     {"title": "X3DNodes.TRotationNode_1.TransformScale", "text": "    ", "tags": "", "loc": "X3DNodes.TRotationNode_1.html#TransformScale"},
     {"title": "X3DNodes.TRotationNode_1.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TRotationNode_1.html#FdRotation"},
     {"title": "X3DNodes.TScaleNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TScaleNode_1.html"},
     {"title": "X3DNodes.TScaleNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TScaleNode_1.html#CreateNode"},
     {"title": "X3DNodes.TScaleNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TScaleNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TScaleNode_1.Transformation", "text": "    ", "tags": "", "loc": "X3DNodes.TScaleNode_1.html#Transformation"},
     {"title": "X3DNodes.TScaleNode_1.TransformScale", "text": "    ", "tags": "", "loc": "X3DNodes.TScaleNode_1.html#TransformScale"},
     {"title": "X3DNodes.TScaleNode_1.FdScaleFactor", "text": " ", "tags": "", "loc": "X3DNodes.TScaleNode_1.html#FdScaleFactor"},
     {"title": "X3DNodes.TTransformNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html"},
     {"title": "X3DNodes.TTransformNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#CreateNode"},
     {"title": "X3DNodes.TTransformNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TTransformNode_1.Transformation", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#Transformation"},
     {"title": "X3DNodes.TTransformNode_1.TransformScale", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#TransformScale"},
     {"title": "X3DNodes.TTransformNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TTransformNode_1.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#FdTranslation"},
     {"title": "X3DNodes.TTransformNode_1.FdRotation", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#FdRotation"},
     {"title": "X3DNodes.TTransformNode_1.FdScaleFactor", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#FdScaleFactor"},
     {"title": "X3DNodes.TTransformNode_1.FdScaleOrientation", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#FdScaleOrientation"},
     {"title": "X3DNodes.TTransformNode_1.FdCenter", "text": " ", "tags": "", "loc": "X3DNodes.TTransformNode_1.html#FdCenter"},
     {"title": "X3DNodes.TTranslationNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TTranslationNode_1.html"},
     {"title": "X3DNodes.TTranslationNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTranslationNode_1.html#CreateNode"},
     {"title": "X3DNodes.TTranslationNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTranslationNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TTranslationNode_1.Transformation", "text": "    ", "tags": "", "loc": "X3DNodes.TTranslationNode_1.html#Transformation"},
     {"title": "X3DNodes.TTranslationNode_1.TransformScale", "text": "    ", "tags": "", "loc": "X3DNodes.TTranslationNode_1.html#TransformScale"},
     {"title": "X3DNodes.TTranslationNode_1.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TTranslationNode_1.html#FdTranslation"},
     {"title": "X3DNodes.TAbstractCameraNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractCameraNode_1.html"},
     {"title": "X3DNodes.TAbstractCameraNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractCameraNode_1.html#CreateNode"},
     {"title": "X3DNodes.TAbstractCameraNode_1.FdPosition", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractCameraNode_1.html#FdPosition"},
     {"title": "X3DNodes.TAbstractCameraNode_1.FdFocalDistance", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractCameraNode_1.html#FdFocalDistance"},
     {"title": "X3DNodes.TAbstractCameraNode_1.FdNearDistance", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractCameraNode_1.html#FdNearDistance"},
     {"title": "X3DNodes.TAbstractCameraNode_1.FdFarDistance", "text": " ", "tags": "", "loc": "X3DNodes.TAbstractCameraNode_1.html#FdFarDistance"},
     {"title": "X3DNodes.TOrthographicCameraNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TOrthographicCameraNode_1.html"},
     {"title": "X3DNodes.TOrthographicCameraNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TOrthographicCameraNode_1.html#CreateNode"},
     {"title": "X3DNodes.TOrthographicCameraNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TOrthographicCameraNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TOrthographicCameraNode_1.ProjectionType", "text": "    ", "tags": "", "loc": "X3DNodes.TOrthographicCameraNode_1.html#ProjectionType"},
     {"title": "X3DNodes.TOrthographicCameraNode_1.FdHeight", "text": " ", "tags": "", "loc": "X3DNodes.TOrthographicCameraNode_1.html#FdHeight"},
     {"title": "X3DNodes.TPerspectiveCameraNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TPerspectiveCameraNode_1.html"},
     {"title": "X3DNodes.TPerspectiveCameraNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPerspectiveCameraNode_1.html#CreateNode"},
     {"title": "X3DNodes.TPerspectiveCameraNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPerspectiveCameraNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TPerspectiveCameraNode_1.ProjectionType", "text": "    ", "tags": "", "loc": "X3DNodes.TPerspectiveCameraNode_1.html#ProjectionType"},
     {"title": "X3DNodes.TPerspectiveCameraNode_1.FdHeightAngle", "text": " ", "tags": "", "loc": "X3DNodes.TPerspectiveCameraNode_1.html#FdHeightAngle"},
     {"title": "X3DNodes.TDirectionalLightNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TDirectionalLightNode_1.html"},
     {"title": "X3DNodes.TDirectionalLightNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TDirectionalLightNode_1.html#CreateNode"},
     {"title": "X3DNodes.TDirectionalLightNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TDirectionalLightNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TDirectionalLightNode_1.Scope", "text": "    ", "tags": "", "loc": "X3DNodes.TDirectionalLightNode_1.html#Scope"},
     {"title": "X3DNodes.TPointLightNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TPointLightNode_1.html"},
     {"title": "X3DNodes.TPointLightNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPointLightNode_1.html#CreateNode"},
     {"title": "X3DNodes.TPointLightNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TPointLightNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TPointLightNode_1.HasRadius", "text": "    ", "tags": "", "loc": "X3DNodes.TPointLightNode_1.html#HasRadius"},
     {"title": "X3DNodes.TPointLightNode_1.Scope", "text": "    ", "tags": "", "loc": "X3DNodes.TPointLightNode_1.html#Scope"},
     {"title": "X3DNodes.TSpotLightNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html"},
     {"title": "X3DNodes.TSpotLightNode_1.GetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#GetProjectionLocationLocal"},
     {"title": "X3DNodes.TSpotLightNode_1.SetProjectionLocationLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#SetProjectionLocationLocal"},
     {"title": "X3DNodes.TSpotLightNode_1.GetProjectionDirectionLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#GetProjectionDirectionLocal"},
     {"title": "X3DNodes.TSpotLightNode_1.SetProjectionDirectionLocal", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#SetProjectionDirectionLocal"},
     {"title": "X3DNodes.TSpotLightNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#CreateNode"},
     {"title": "X3DNodes.TSpotLightNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TSpotLightNode_1.SpotExponent", "text": " Not normalized (i.e. is a real exponent, in VRML 1.0 expresses in [0..1] range to mean exponents [0..128]). Clamp to correct range.    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#SpotExponent"},
     {"title": "X3DNodes.TSpotLightNode_1.SpotCutoffDeg", "text": "  <p>Expressed in degrees, clamped to correct range (see <a class=\"normal\" href=\"X3DNodes.TSpotLightNode.html#SpotCutoffDeg\">TSpotLightNode.SpotCutoffDeg</a> for reasons). (since user can input any value in VRML, and also conversion radians -&gt; degrees could accidentally raise value slightly &gt; 90, so cutOffAngle = 1.5708 is in degrees 90.0002104591, which would cause OpenGL fixed-function error).    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#SpotCutoffDeg"},
     {"title": "X3DNodes.TSpotLightNode_1.SpotCosCutoff", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#SpotCosCutoff"},
     {"title": "X3DNodes.TSpotLightNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TSpotLightNode_1.UpdateLightInstance", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#UpdateLightInstance"},
     {"title": "X3DNodes.TSpotLightNode_1.ProjectionMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#ProjectionMatrix"},
     {"title": "X3DNodes.TSpotLightNode_1.ModelviewMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#ModelviewMatrix"},
     {"title": "X3DNodes.TSpotLightNode_1.ModelviewRotationMatrix", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#ModelviewRotationMatrix"},
     {"title": "X3DNodes.TSpotLightNode_1.Box3DDistances", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#Box3DDistances"},
     {"title": "X3DNodes.TSpotLightNode_1.HasRadius", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#HasRadius"},
     {"title": "X3DNodes.TSpotLightNode_1.Scope", "text": "    ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#Scope"},
     {"title": "X3DNodes.TSpotLightNode_1.FdDirection", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#FdDirection"},
     {"title": "X3DNodes.TSpotLightNode_1.FdDropOffRate", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#FdDropOffRate"},
     {"title": "X3DNodes.TSpotLightNode_1.FdCutOffAngle", "text": " ", "tags": "", "loc": "X3DNodes.TSpotLightNode_1.html#FdCutOffAngle"},
     {"title": "X3DNodes.TGroupNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TGroupNode_1.html"},
     {"title": "X3DNodes.TGroupNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGroupNode_1.html#CreateNode"},
     {"title": "X3DNodes.TGroupNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGroupNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TGroupNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TGroupNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TAbstractSeparatorNode_1", "text": " It is used in implementation of VRML 1.0 Separator and WWWAnchor. Also WWWInline does the same work, when it's &quot;separate&quot; field is true. ", "tags": "", "loc": "X3DNodes.TAbstractSeparatorNode_1.html"},
     {"title": "X3DNodes.TAbstractSeparatorNode_1.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSeparatorNode_1.html#BeforeTraverse"},
     {"title": "X3DNodes.TAbstractSeparatorNode_1.AfterTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSeparatorNode_1.html#AfterTraverse"},
     {"title": "X3DNodes.TAbstractSeparatorNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TAbstractSeparatorNode_1.html#CreateNode"},
     {"title": "X3DNodes.TSeparatorNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TSeparatorNode_1.html"},
     {"title": "X3DNodes.TSeparatorNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSeparatorNode_1.html#CreateNode"},
     {"title": "X3DNodes.TSeparatorNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSeparatorNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TSeparatorNode_1.FdRenderCulling", "text": " ", "tags": "", "loc": "X3DNodes.TSeparatorNode_1.html#FdRenderCulling"},
     {"title": "X3DNodes.TSwitchNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TSwitchNode_1.html"},
     {"title": "X3DNodes.TSwitchNode_1.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode_1.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TSwitchNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode_1.html#CreateNode"},
     {"title": "X3DNodes.TSwitchNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TSwitchNode_1.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TSwitchNode_1.html#ForVRMLVersion"},
     {"title": "X3DNodes.TSwitchNode_1.FdWhichChild", "text": " ", "tags": "", "loc": "X3DNodes.TSwitchNode_1.html#FdWhichChild"},
     {"title": "X3DNodes.TTransformSeparatorNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TTransformSeparatorNode_1.html"},
     {"title": "X3DNodes.TTransformSeparatorNode_1.BeforeTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformSeparatorNode_1.html#BeforeTraverse"},
     {"title": "X3DNodes.TTransformSeparatorNode_1.AfterTraverse", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformSeparatorNode_1.html#AfterTraverse"},
     {"title": "X3DNodes.TTransformSeparatorNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformSeparatorNode_1.html#CreateNode"},
     {"title": "X3DNodes.TTransformSeparatorNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTransformSeparatorNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TWWWAnchorNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TWWWAnchorNode_1.html"},
     {"title": "X3DNodes.TWWWAnchorNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TWWWAnchorNode_1.html#CreateNode"},
     {"title": "X3DNodes.TWWWAnchorNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TWWWAnchorNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TWWWAnchorNode_1.FdName", "text": " ", "tags": "", "loc": "X3DNodes.TWWWAnchorNode_1.html#FdName"},
     {"title": "X3DNodes.TWWWAnchorNode_1.FdDescription", "text": " ", "tags": "", "loc": "X3DNodes.TWWWAnchorNode_1.html#FdDescription"},
     {"title": "X3DNodes.TWWWAnchorNode_1.FdMap", "text": " ", "tags": "", "loc": "X3DNodes.TWWWAnchorNode_1.html#FdMap"},
     {"title": "X3DNodes.TWWWInlineNode_1", "text": "  <p>Implemented as a descendant of VRML 2.0/X3D Inline node class. This way VRML 1.0 actually gets a couple of VRML 2.0/X3D extensions. The VRML 2.0/X3D field &quot;url&quot; is renamed here to VRML 1.0 field &quot;name&quot;. (Note that this means that WWWInline.name is actually MFString, not just SFString like VRML 1.0 spec says.) ", "tags": "", "loc": "X3DNodes.TWWWInlineNode_1.html"},
     {"title": "X3DNodes.TWWWInlineNode_1.SeparateGroup", "text": "    ", "tags": "", "loc": "X3DNodes.TWWWInlineNode_1.html#SeparateGroup"},
     {"title": "X3DNodes.TWWWInlineNode_1.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TWWWInlineNode_1.html#CreateNode"},
     {"title": "X3DNodes.TWWWInlineNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TWWWInlineNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TWWWInlineNode_1.FdSeparate", "text": " ", "tags": "", "loc": "X3DNodes.TWWWInlineNode_1.html#FdSeparate"},
     {"title": "X3DNodes.TIndexedTriangleMeshNode_1", "text": " ", "tags": "", "loc": "X3DNodes.TIndexedTriangleMeshNode_1.html"},
     {"title": "X3DNodes.TIndexedTriangleMeshNode_1.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleMeshNode_1.html#ClassX3DType"},
     {"title": "X3DNodes.TIndexedTriangleMeshNode_1.InternalCoordPolygons", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleMeshNode_1.html#InternalCoordPolygons"},
     {"title": "X3DNodes.TIndexedTriangleMeshNode_1.InternalTexCoord", "text": "    ", "tags": "", "loc": "X3DNodes.TIndexedTriangleMeshNode_1.html#InternalTexCoord"},
     {"title": "X3DNodes.TRotationXYZNode", "text": " It's not in VRML 1.0 spec. But some invalid VRML 1.0 models use it, e.g. [<a  href=\"http://www-vrl.umich.edu/sel_prj/EECS498/\">http://www-vrl.umich.edu/sel_prj/EECS498/</a>]. ", "tags": "", "loc": "X3DNodes.TRotationXYZNode.html"},
     {"title": "X3DNodes.TRotationXYZNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TRotationXYZNode.html#CreateNode"},
     {"title": "X3DNodes.TRotationXYZNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TRotationXYZNode.html#ClassX3DType"},
     {"title": "X3DNodes.TRotationXYZNode.Transformation", "text": "    ", "tags": "", "loc": "X3DNodes.TRotationXYZNode.html#Transformation"},
     {"title": "X3DNodes.TRotationXYZNode.TransformScale", "text": "    ", "tags": "", "loc": "X3DNodes.TRotationXYZNode.html#TransformScale"},
     {"title": "X3DNodes.TRotationXYZNode.FdAxis", "text": " ", "tags": "", "loc": "X3DNodes.TRotationXYZNode.html#FdAxis"},
     {"title": "X3DNodes.TRotationXYZNode.FdAngle", "text": " ", "tags": "", "loc": "X3DNodes.TRotationXYZNode.html#FdAngle"},
     {"title": "X3DNodes.TDisplacerNode", "text": " ", "tags": "", "loc": "X3DNodes.TDisplacerNode.html"},
     {"title": "X3DNodes.TDisplacerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TDisplacerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TDisplacerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TDisplacerNode.html#URNMatching"},
     {"title": "X3DNodes.THumanoidNode", "text": " ", "tags": "", "loc": "X3DNodes.THumanoidNode.html"},
     {"title": "X3DNodes.THumanoidNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.THumanoidNode.html#ClassX3DType"},
     {"title": "X3DNodes.THumanoidNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.THumanoidNode.html#URNMatching"},
     {"title": "X3DNodes.TJointNode", "text": " ", "tags": "", "loc": "X3DNodes.TJointNode.html"},
     {"title": "X3DNodes.TJointNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TJointNode.html#ClassX3DType"},
     {"title": "X3DNodes.TJointNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TJointNode.html#URNMatching"},
     {"title": "X3DNodes.TSegmentNode", "text": " ", "tags": "", "loc": "X3DNodes.TSegmentNode.html"},
     {"title": "X3DNodes.TSegmentNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSegmentNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSegmentNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSegmentNode.html#URNMatching"},
     {"title": "X3DNodes.TSiteNode", "text": " ", "tags": "", "loc": "X3DNodes.TSiteNode.html"},
     {"title": "X3DNodes.TSiteNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TSiteNode.html#ClassX3DType"},
     {"title": "X3DNodes.TSiteNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TSiteNode.html#URNMatching"},
     {"title": "X3DNodes.TCoordinateDeformerNode", "text": " <b>Not implemented.</b> ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html"},
     {"title": "X3DNodes.TCoordinateDeformerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#CreateNode"},
     {"title": "X3DNodes.TCoordinateDeformerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCoordinateDeformerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#URNMatching"},
     {"title": "X3DNodes.TCoordinateDeformerNode.EventaddChildren", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#EventaddChildren"},
     {"title": "X3DNodes.TCoordinateDeformerNode.EventremoveChildren", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#EventremoveChildren"},
     {"title": "X3DNodes.TCoordinateDeformerNode.Fdchildren", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#Fdchildren"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdcontrolPoint", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdcontrolPoint"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdinputCoord", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdinputCoord"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdinputTransform", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdinputTransform"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdoutputCoord", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdoutputCoord"},
     {"title": "X3DNodes.TCoordinateDeformerNode.Fdweight", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#Fdweight"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdbboxCenter", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdbboxCenter"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdbboxSize", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdbboxSize"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FduDimension", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FduDimension"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FduKnot", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FduKnot"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FduOrder", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FduOrder"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdvDimension", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdvDimension"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdvKnot", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdvKnot"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdvOrder", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdvOrder"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdwDimension", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdwDimension"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdwKnot", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdwKnot"},
     {"title": "X3DNodes.TCoordinateDeformerNode.FdwOrder", "text": " ", "tags": "", "loc": "X3DNodes.TCoordinateDeformerNode.html#FdwOrder"},
     {"title": "X3DNodes.TNurbsCurveNode_2", "text": " <b>Not implemented.</b> ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html"},
     {"title": "X3DNodes.TNurbsCurveNode_2.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#CreateNode"},
     {"title": "X3DNodes.TNurbsCurveNode_2.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsCurveNode_2.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#URNMatching"},
     {"title": "X3DNodes.TNurbsCurveNode_2.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#ForVRMLVersion"},
     {"title": "X3DNodes.TNurbsCurveNode_2.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#Proxy"},
     {"title": "X3DNodes.TNurbsCurveNode_2.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TNurbsCurveNode_2.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#LocalBoundingBox"},
     {"title": "X3DNodes.TNurbsCurveNode_2.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#BoundingBox"},
     {"title": "X3DNodes.TNurbsCurveNode_2.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#TrianglesCount"},
     {"title": "X3DNodes.TNurbsCurveNode_2.FdcontrolPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#FdcontrolPoint"},
     {"title": "X3DNodes.TNurbsCurveNode_2.Fdweight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#Fdweight"},
     {"title": "X3DNodes.TNurbsCurveNode_2.Fdtessellation", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#Fdtessellation"},
     {"title": "X3DNodes.TNurbsCurveNode_2.Fdknot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#Fdknot"},
     {"title": "X3DNodes.TNurbsCurveNode_2.Fdorder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsCurveNode_2.html#Fdorder"},
     {"title": "X3DNodes.TNurbsGroupNode", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsGroupNode.html"},
     {"title": "X3DNodes.TNurbsGroupNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsGroupNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsGroupNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsGroupNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsGroupNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsGroupNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsGroupNode.FdtessellationScale", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsGroupNode.html#FdtessellationScale"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#CreateNode"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#URNMatching"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#ForVRMLVersion"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.Eventset_fraction", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#Eventset_fraction"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.Fddimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#Fddimension"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.FdkeyValue", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#FdkeyValue"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.FdkeyWeight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#FdkeyWeight"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.Fdknot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#Fdknot"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.Fdorder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#Fdorder"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_2.Eventvalue_changed", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsPositionInterpolatorNode_2.html#Eventvalue_changed"},
     {"title": "X3DNodes.TNurbsSurfaceNode", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html"},
     {"title": "X3DNodes.TNurbsSurfaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsSurfaceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsSurfaceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsSurfaceNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#Proxy"},
     {"title": "X3DNodes.TNurbsSurfaceNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TNurbsSurfaceNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TNurbsSurfaceNode.BoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#BoundingBox"},
     {"title": "X3DNodes.TNurbsSurfaceNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#TrianglesCount"},
     {"title": "X3DNodes.TNurbsSurfaceNode.SolidField", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#SolidField"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FdcontrolPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FdcontrolPoint"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FdtexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FdtexCoord"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FduTessellation", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FduTessellation"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FdvTessellation", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FdvTessellation"},
     {"title": "X3DNodes.TNurbsSurfaceNode.Fdweight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#Fdweight"},
     {"title": "X3DNodes.TNurbsSurfaceNode.Fdccw", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#Fdccw"},
     {"title": "X3DNodes.TNurbsSurfaceNode.Fdsolid", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#Fdsolid"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FduDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FduDimension"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FduKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FduKnot"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FduOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FduOrder"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FdvDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FdvDimension"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FdvKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FdvKnot"},
     {"title": "X3DNodes.TNurbsSurfaceNode.FdvOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsSurfaceNode.html#FdvOrder"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode", "text": " <b>Not implemented.</b> ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#CreateNode"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#URNMatching"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.FdcontrolPoint", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#FdcontrolPoint"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.Fdweight", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#Fdweight"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.FduDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#FduDimension"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.FduKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#FduKnot"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.FduOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#FduOrder"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.FdvDimension", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#FdvDimension"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.FdvKnot", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#FdvKnot"},
     {"title": "X3DNodes.TNurbsTextureSurfaceNode.FdvOrder", "text": " ", "tags": "", "loc": "X3DNodes.TNurbsTextureSurfaceNode.html#FdvOrder"},
     {"title": "X3DNodes.TTrimmedSurfaceNode", "text": " <b>Rendering of this node is not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#CreateNode"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#URNMatching"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#LocalBoundingBox"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#VerticesCount"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#TrianglesCount"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.EventaddTrimmingContour", "text": " ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#EventaddTrimmingContour"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.EventremoveTrimmingContour", "text": " ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#EventremoveTrimmingContour"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.FdtrimmingContour", "text": " ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#FdtrimmingContour"},
     {"title": "X3DNodes.TTrimmedSurfaceNode.Fdsurface", "text": " ", "tags": "", "loc": "X3DNodes.TTrimmedSurfaceNode.html#Fdsurface"},
     {"title": "X3DNodes.TContour2DNode_2", "text": " <b>Not implemented yet.</b> ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html"},
     {"title": "X3DNodes.TContour2DNode_2.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TContour2DNode_2.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#CreateNode"},
     {"title": "X3DNodes.TContour2DNode_2.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#ClassX3DType"},
     {"title": "X3DNodes.TContour2DNode_2.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#URNMatching"},
     {"title": "X3DNodes.TContour2DNode_2.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#ForVRMLVersion"},
     {"title": "X3DNodes.TContour2DNode_2.LocalBoundingBox", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#LocalBoundingBox"},
     {"title": "X3DNodes.TContour2DNode_2.VerticesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#VerticesCount"},
     {"title": "X3DNodes.TContour2DNode_2.TrianglesCount", "text": "    ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#TrianglesCount"},
     {"title": "X3DNodes.TContour2DNode_2.EventAddChildren", "text": " ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#EventAddChildren"},
     {"title": "X3DNodes.TContour2DNode_2.EventRemoveChildren", "text": " ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#EventRemoveChildren"},
     {"title": "X3DNodes.TContour2DNode_2.FdChildren", "text": " ", "tags": "", "loc": "X3DNodes.TContour2DNode_2.html#FdChildren"},
     {"title": "X3DNodes.TKambiHeadLightNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_navigation_extensions.php#section_ext_headlight\">http://castle-engine.sourceforge.net/x3d_implementation_navigation_extensions.php#section_ext_headlight</a> . ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html"},
     {"title": "X3DNodes.TKambiHeadLightNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#CreateNode"},
     {"title": "X3DNodes.TKambiHeadLightNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#ClassX3DType"},
     {"title": "X3DNodes.TKambiHeadLightNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#URNMatching"},
     {"title": "X3DNodes.TKambiHeadLightNode.FdAmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#FdAmbientIntensity"},
     {"title": "X3DNodes.TKambiHeadLightNode.FdAttenuation", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#FdAttenuation"},
     {"title": "X3DNodes.TKambiHeadLightNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#FdColor"},
     {"title": "X3DNodes.TKambiHeadLightNode.FdIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#FdIntensity"},
     {"title": "X3DNodes.TKambiHeadLightNode.FdSpot", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#FdSpot"},
     {"title": "X3DNodes.TKambiHeadLightNode.FdSpotCutOffAngle", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#FdSpotCutOffAngle"},
     {"title": "X3DNodes.TKambiHeadLightNode.FdSpotDropOffRate", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#FdSpotDropOffRate"},
     {"title": "X3DNodes.TKambiHeadLightNode.AmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#AmbientIntensity"},
     {"title": "X3DNodes.TKambiHeadLightNode.Attenuation", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#Attenuation"},
     {"title": "X3DNodes.TKambiHeadLightNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#Color"},
     {"title": "X3DNodes.TKambiHeadLightNode.Intensity", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#Intensity"},
     {"title": "X3DNodes.TKambiHeadLightNode.Spot", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#Spot"},
     {"title": "X3DNodes.TKambiHeadLightNode.SpotDropOffRate", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#SpotDropOffRate"},
     {"title": "X3DNodes.TKambiHeadLightNode.SpotCutOffAngle", "text": " ", "tags": "", "loc": "X3DNodes.TKambiHeadLightNode.html#SpotCutOffAngle"},
     {"title": "X3DNodes.TText3DNode", "text": " <b>The depth is not implemented now &ndash; this is equivalent to <a class=\"normal\" href=\"X3DNodes.TTextNode.html\">TTextNode</a> now.</b> ", "tags": "", "loc": "X3DNodes.TText3DNode.html"},
     {"title": "X3DNodes.TText3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TText3DNode.html#CreateNode"},
     {"title": "X3DNodes.TText3DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TText3DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TText3DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TText3DNode.html#URNMatching"},
     {"title": "X3DNodes.TText3DNode.SetString", "text": "    ", "tags": "", "loc": "X3DNodes.TText3DNode.html#SetString"},
     {"title": "X3DNodes.TText3DNode.SetString", "text": "    ", "tags": "", "loc": "X3DNodes.TText3DNode.html#SetString"},
     {"title": "X3DNodes.TText3DNode.SetLength", "text": "    ", "tags": "", "loc": "X3DNodes.TText3DNode.html#SetLength"},
     {"title": "X3DNodes.TText3DNode.SetLength", "text": "    ", "tags": "", "loc": "X3DNodes.TText3DNode.html#SetLength"},
     {"title": "X3DNodes.TText3DNode.FdDepth", "text": " ", "tags": "", "loc": "X3DNodes.TText3DNode.html#FdDepth"},
     {"title": "X3DNodes.TText3DNode.MaxExtent", "text": " ", "tags": "", "loc": "X3DNodes.TText3DNode.html#MaxExtent"},
     {"title": "X3DNodes.TText3DNode.Depth", "text": " ", "tags": "", "loc": "X3DNodes.TText3DNode.html#Depth"},
     {"title": "X3DNodes.TBlendModeNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_blending\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_blending</a> .  <p>This is an extension, not present in standard X3D. It is compatible with modelled after, and compatible with, and InstantReality extension &ndash; see [<a  href=\"http://www.instantreality.org/documentation/nodetype/ManagedAppearance/\">http://www.instantreality.org/documentation/nodetype/ManagedAppearance/</a>] and [<a  href=\"http://www.instantreality.org/documentation/nodetype/BlendMode/\">http://www.instantreality.org/documentation/nodetype/BlendMode/</a>]. ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html"},
     {"title": "X3DNodes.TBlendModeNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#CreateNode"},
     {"title": "X3DNodes.TBlendModeNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#ClassX3DType"},
     {"title": "X3DNodes.TBlendModeNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#URNMatching"},
     {"title": "X3DNodes.TBlendModeNode.FdSrcFactor", "text": " ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#FdSrcFactor"},
     {"title": "X3DNodes.TBlendModeNode.FdDestFactor", "text": " ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#FdDestFactor"},
     {"title": "X3DNodes.TBlendModeNode.FdColor", "text": " ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#FdColor"},
     {"title": "X3DNodes.TBlendModeNode.FdColorTransparency", "text": " ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#FdColorTransparency"},
     {"title": "X3DNodes.TBlendModeNode.SrcFactor", "text": " ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#SrcFactor"},
     {"title": "X3DNodes.TBlendModeNode.DestFactor", "text": " ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#DestFactor"},
     {"title": "X3DNodes.TBlendModeNode.Color", "text": " ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#Color"},
     {"title": "X3DNodes.TBlendModeNode.ColorTransparency", "text": " ", "tags": "", "loc": "X3DNodes.TBlendModeNode.html#ColorTransparency"},
     {"title": "X3DNodes.TKambiAppearanceNode", "text": " Useful if you want to use EXTERNPROTO to declare Castle Game Engine extensions the Appearance in a clean way. ", "tags": "", "loc": "X3DNodes.TKambiAppearanceNode.html"},
     {"title": "X3DNodes.TKambiAppearanceNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiAppearanceNode.html#CreateNode"},
     {"title": "X3DNodes.TKambiAppearanceNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiAppearanceNode.html#ClassX3DType"},
     {"title": "X3DNodes.TKambiAppearanceNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiAppearanceNode.html#URNMatching"},
     {"title": "X3DNodes.TKambiInlineNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_kambi_inline\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_kambi_inline</a> . ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html"},
     {"title": "X3DNodes.TKambiInlineNode.AfterLoadInlined", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html#AfterLoadInlined"},
     {"title": "X3DNodes.TKambiInlineNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html#CreateNode"},
     {"title": "X3DNodes.TKambiInlineNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html#ClassX3DType"},
     {"title": "X3DNodes.TKambiInlineNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html#URNMatching"},
     {"title": "X3DNodes.TKambiInlineNode.SetReplaceNames", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html#SetReplaceNames"},
     {"title": "X3DNodes.TKambiInlineNode.SetReplaceNames", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html#SetReplaceNames"},
     {"title": "X3DNodes.TKambiInlineNode.SetReplaceNodes", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html#SetReplaceNodes"},
     {"title": "X3DNodes.TKambiInlineNode.FdReplaceNames", "text": " ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html#FdReplaceNames"},
     {"title": "X3DNodes.TKambiInlineNode.FdReplaceNodes", "text": " ", "tags": "", "loc": "X3DNodes.TKambiInlineNode.html#FdReplaceNodes"},
     {"title": "X3DNodes.TKambiNavigationInfoNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_navigation_extensions.php\">http://castle-engine.sourceforge.net/x3d_implementation_navigation_extensions.php</a> . ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#CreateNode"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#ClassX3DType"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#URNMatching"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.OctreeProperties", "text": " Returns <code>Nil</code> if the field doesn't have allowed (<a class=\"normal\" href=\"X3DNodes.TKambiOctreePropertiesNode.html\">TKambiOctreePropertiesNode</a>) value (or if the field is actually <code>Nil</code>, naturally).    ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#OctreeProperties"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.FdTimeOriginAtLoad", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#FdTimeOriginAtLoad"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.FdOctreeRendering", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#FdOctreeRendering"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.FdOctreeDynamicCollisions", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#FdOctreeDynamicCollisions"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.FdOctreeVisibleTriangles", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#FdOctreeVisibleTriangles"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.FdOctreeStaticCollisions", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#FdOctreeStaticCollisions"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.FdHeadBobbing", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#FdHeadBobbing"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.FdHeadBobbingTime", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#FdHeadBobbingTime"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.FdHeadlightNode", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#FdHeadlightNode"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.TimeOriginAtLoad", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#TimeOriginAtLoad"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.OctreeRendering", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#OctreeRendering"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.OctreeDynamicCollisions", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#OctreeDynamicCollisions"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.OctreeVisibleTriangles", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#OctreeVisibleTriangles"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.OctreeStaticCollisions", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#OctreeStaticCollisions"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.HeadBobbing", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#HeadBobbing"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.HeadBobbingTime", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#HeadBobbingTime"},
     {"title": "X3DNodes.TKambiNavigationInfoNode.HeadlightNode", "text": " ", "tags": "", "loc": "X3DNodes.TKambiNavigationInfoNode.html#HeadlightNode"},
     {"title": "X3DNodes.TKambiOctreePropertiesNode", "text": " ", "tags": "", "loc": "X3DNodes.TKambiOctreePropertiesNode.html"},
     {"title": "X3DNodes.TKambiOctreePropertiesNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiOctreePropertiesNode.html#CreateNode"},
     {"title": "X3DNodes.TKambiOctreePropertiesNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiOctreePropertiesNode.html#ClassX3DType"},
     {"title": "X3DNodes.TKambiOctreePropertiesNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiOctreePropertiesNode.html#URNMatching"},
     {"title": "X3DNodes.TKambiOctreePropertiesNode.OverrideLimits", "text": "    ", "tags": "", "loc": "X3DNodes.TKambiOctreePropertiesNode.html#OverrideLimits"},
     {"title": "X3DNodes.TKambiOctreePropertiesNode.FdMaxDepth", "text": " ", "tags": "", "loc": "X3DNodes.TKambiOctreePropertiesNode.html#FdMaxDepth"},
     {"title": "X3DNodes.TKambiOctreePropertiesNode.FdLeafCapacity", "text": " ", "tags": "", "loc": "X3DNodes.TKambiOctreePropertiesNode.html#FdLeafCapacity"},
     {"title": "X3DNodes.TKambiOctreePropertiesNode.MaxDepth", "text": " ", "tags": "", "loc": "X3DNodes.TKambiOctreePropertiesNode.html#MaxDepth"},
     {"title": "X3DNodes.TKambiOctreePropertiesNode.LeafCapacity", "text": " ", "tags": "", "loc": "X3DNodes.TKambiOctreePropertiesNode.html#LeafCapacity"},
     {"title": "X3DNodes.TGeneratedShadowMapNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions_shadow_maps.php\">http://castle-engine.sourceforge.net/x3d_extensions_shadow_maps.php</a> ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.DefaultSize", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#DefaultSize"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.DefaultScale", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#DefaultScale"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.DefaultBias", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#DefaultBias"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#CreateNode"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#Destroy"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#ClassX3DType"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#URNMatching"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.GeneratedTextureHandler", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#GeneratedTextureHandler"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.FdUpdate", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#FdUpdate"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#FdSize"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.FdLight", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#FdLight"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.FdScale", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#FdScale"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.FdBias", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#FdBias"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.FdCompareMode", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#FdCompareMode"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.Size", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#Size"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.Light", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#Light"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.Scale", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#Scale"},
     {"title": "X3DNodes.TGeneratedShadowMapNode.Bias", "text": " ", "tags": "", "loc": "X3DNodes.TGeneratedShadowMapNode.html#Bias"},
     {"title": "X3DNodes.TProjectedTextureCoordinateNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions_shadow_maps.php\">http://castle-engine.sourceforge.net/x3d_extensions_shadow_maps.php</a> ", "tags": "", "loc": "X3DNodes.TProjectedTextureCoordinateNode.html"},
     {"title": "X3DNodes.TProjectedTextureCoordinateNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TProjectedTextureCoordinateNode.html#CreateNode"},
     {"title": "X3DNodes.TProjectedTextureCoordinateNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TProjectedTextureCoordinateNode.html#ClassX3DType"},
     {"title": "X3DNodes.TProjectedTextureCoordinateNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TProjectedTextureCoordinateNode.html#URNMatching"},
     {"title": "X3DNodes.TProjectedTextureCoordinateNode.FdProjector", "text": " ", "tags": "", "loc": "X3DNodes.TProjectedTextureCoordinateNode.html#FdProjector"},
     {"title": "X3DNodes.TScreenEffectNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions_screen_effects.php\">http://castle-engine.sourceforge.net/x3d_extensions_screen_effects.php</a> . ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html"},
     {"title": "X3DNodes.TScreenEffectNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TScreenEffectNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#CreateNode"},
     {"title": "X3DNodes.TScreenEffectNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#Destroy"},
     {"title": "X3DNodes.TScreenEffectNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#ClassX3DType"},
     {"title": "X3DNodes.TScreenEffectNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#URNMatching"},
     {"title": "X3DNodes.TScreenEffectNode.SetShaders", "text": "    ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#SetShaders"},
     {"title": "X3DNodes.TScreenEffectNode.FdShaders", "text": " ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#FdShaders"},
     {"title": "X3DNodes.TScreenEffectNode.FdNeedsDepth", "text": " ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#FdNeedsDepth"},
     {"title": "X3DNodes.TScreenEffectNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#FdEnabled"},
     {"title": "X3DNodes.TScreenEffectNode.Shader", "text": " Right now, this means <a class=\"normal\" href=\"CastleScene.TCastleScene.html\">TCastleScene</a>. Always when <a class=\"normal\" href=\"X3DNodes.TScreenEffectNode.html#ShaderLoaded\">ShaderLoaded</a> = <code>False</code> then Shader is <code>Nil</code>. When <a class=\"normal\" href=\"X3DNodes.TScreenEffectNode.html#ShaderLoaded\">ShaderLoaded</a> = <code>True</code>, the Shader may be non-nil (if was <a class=\"normal\" href=\"X3DNodes.TScreenEffectNode.html#Enabled\">enabled</a> and loaded successfully) or not.  ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#Shader"},
     {"title": "X3DNodes.TScreenEffectNode.ShaderLoaded", "text": " ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#ShaderLoaded"},
     {"title": "X3DNodes.TScreenEffectNode.StateForShaderPrepare", "text": " ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#StateForShaderPrepare"},
     {"title": "X3DNodes.TScreenEffectNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#Enabled"},
     {"title": "X3DNodes.TScreenEffectNode.NeedsDepth", "text": " ", "tags": "", "loc": "X3DNodes.TScreenEffectNode.html#NeedsDepth"},
     {"title": "X3DNodes.TMultiGeneratedTextureCoordinateNode", "text": " See [<a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_tex_coord\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_tex_coord</a>]. ", "tags": "", "loc": "X3DNodes.TMultiGeneratedTextureCoordinateNode.html"},
     {"title": "X3DNodes.TMultiGeneratedTextureCoordinateNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiGeneratedTextureCoordinateNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMultiGeneratedTextureCoordinateNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMultiGeneratedTextureCoordinateNode.html#URNMatching"},
     {"title": "X3DNodes.TEffectNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/compositing_shaders.php\">http://castle-engine.sourceforge.net/compositing_shaders.php</a> . ", "tags": "", "loc": "X3DNodes.TEffectNode.html"},
     {"title": "X3DNodes.TEffectNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TEffectNode.html#CreateNode"},
     {"title": "X3DNodes.TEffectNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TEffectNode.html#ClassX3DType"},
     {"title": "X3DNodes.TEffectNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TEffectNode.html#URNMatching"},
     {"title": "X3DNodes.TEffectNode.SetParts", "text": "    ", "tags": "", "loc": "X3DNodes.TEffectNode.html#SetParts"},
     {"title": "X3DNodes.TEffectNode.FdLanguage", "text": " ", "tags": "", "loc": "X3DNodes.TEffectNode.html#FdLanguage"},
     {"title": "X3DNodes.TEffectNode.Language", "text": " ", "tags": "", "loc": "X3DNodes.TEffectNode.html#Language"},
     {"title": "X3DNodes.TEffectNode.FdParts", "text": " ", "tags": "", "loc": "X3DNodes.TEffectNode.html#FdParts"},
     {"title": "X3DNodes.TEffectNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TEffectNode.html#FdEnabled"},
     {"title": "X3DNodes.TEffectNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TEffectNode.html#Enabled"},
     {"title": "X3DNodes.TEffectPartNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/compositing_shaders.php\">http://castle-engine.sourceforge.net/compositing_shaders.php</a> . ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html"},
     {"title": "X3DNodes.TEffectPartNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html#CreateNode"},
     {"title": "X3DNodes.TEffectPartNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html#ClassX3DType"},
     {"title": "X3DNodes.TEffectPartNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html#URNMatching"},
     {"title": "X3DNodes.TEffectPartNode.SetUrl", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html#SetUrl"},
     {"title": "X3DNodes.TEffectPartNode.SetUrl", "text": "    ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html#SetUrl"},
     {"title": "X3DNodes.TEffectPartNode.FdType", "text": " ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html#FdType"},
     {"title": "X3DNodes.TEffectPartNode.ShaderType", "text": " ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html#ShaderType"},
     {"title": "X3DNodes.TEffectPartNode.FdUrl", "text": " ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html#FdUrl"},
     {"title": "X3DNodes.TEffectPartNode.Contents", "text": "  <p>Getting this automatically loads the shader code pointed by the URL field of this node. The shader code may be specified in an external file, or inline using &quot;data URI&quot;, see <a  href=\"https://castle-engine.sourceforge.io/manual_network.php\">https://castle-engine.sourceforge.io/manual_network.php</a> . The shader code may also be specified using the XML &quot;CDATA&quot; in X3D XML encoding. Returns '' of no valid URLs are present (loading errors are reported to <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>).  <p>Setting this overrides the URL field, to specify only the given shader code. ", "tags": "", "loc": "X3DNodes.TEffectPartNode.html#Contents"},
     {"title": "X3DNodes.TShaderTextureNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/compositing_shaders.php\">http://castle-engine.sourceforge.net/compositing_shaders.php</a> . ", "tags": "", "loc": "X3DNodes.TShaderTextureNode.html"},
     {"title": "X3DNodes.TShaderTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TShaderTextureNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderTextureNode.html#ClassX3DType"},
     {"title": "X3DNodes.TShaderTextureNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TShaderTextureNode.html#URNMatching"},
     {"title": "X3DNodes.TShaderTextureNode.SetEffects", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt .    ", "tags": "", "loc": "X3DNodes.TShaderTextureNode.html#SetEffects"},
     {"title": "X3DNodes.TShaderTextureNode.FdDefaultTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TShaderTextureNode.html#FdDefaultTexCoord"},
     {"title": "X3DNodes.TMatrixTransformNode", "text": "  <p>This is an extension, not present in the X3D standard. See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_matrix_transform\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_matrix_transform</a> . It is compatible with InstantReality, see <a  href=\"http://instant-reality.com/documentation/nodetype/MatrixTransform/\">http://instant-reality.com/documentation/nodetype/MatrixTransform/</a> . ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html"},
     {"title": "X3DNodes.TMatrixTransformNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TMatrixTransformNode.ApplyTransform", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html#ApplyTransform"},
     {"title": "X3DNodes.TMatrixTransformNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html#CreateNode"},
     {"title": "X3DNodes.TMatrixTransformNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMatrixTransformNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html#URNMatching"},
     {"title": "X3DNodes.TMatrixTransformNode.ForVRMLVersion", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html#ForVRMLVersion"},
     {"title": "X3DNodes.TMatrixTransformNode.TransformationChange", "text": "    ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html#TransformationChange"},
     {"title": "X3DNodes.TMatrixTransformNode.FdMatrix", "text": " ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html#FdMatrix"},
     {"title": "X3DNodes.TMatrixTransformNode.Matrix", "text": " ", "tags": "", "loc": "X3DNodes.TMatrixTransformNode.html#Matrix"},
     {"title": "X3DNodes.TTeapotNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_teapot\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_teapot</a> . ", "tags": "", "loc": "X3DNodes.TTeapotNode.html"},
     {"title": "X3DNodes.TTeapotNode.DirectEnumerateActive", "text": "    ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#DirectEnumerateActive"},
     {"title": "X3DNodes.TTeapotNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#CreateNode"},
     {"title": "X3DNodes.TTeapotNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTeapotNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#URNMatching"},
     {"title": "X3DNodes.TTeapotNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#Proxy"},
     {"title": "X3DNodes.TTeapotNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TTeapotNode.TexCoordField", "text": "    ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#TexCoordField"},
     {"title": "X3DNodes.TTeapotNode.AutoGenerate3DTexCoords", "text": "    ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#AutoGenerate3DTexCoords"},
     {"title": "X3DNodes.TTeapotNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#FdSize"},
     {"title": "X3DNodes.TTeapotNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#FdSolid"},
     {"title": "X3DNodes.TTeapotNode.FdManifold", "text": " ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#FdManifold"},
     {"title": "X3DNodes.TTeapotNode.FdTexCoord", "text": " ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#FdTexCoord"},
     {"title": "X3DNodes.TTeapotNode.Size", "text": " ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#Size"},
     {"title": "X3DNodes.TTeapotNode.Manifold", "text": " ", "tags": "", "loc": "X3DNodes.TTeapotNode.html#Manifold"},
     {"title": "X3DNodes.TLoggerNode", "text": " See <a  href=\"http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_logger\">http://castle-engine.sourceforge.net/x3d_extensions.php#section_ext_logger</a> . ", "tags": "", "loc": "X3DNodes.TLoggerNode.html"},
     {"title": "X3DNodes.TLoggerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#CreateNode"},
     {"title": "X3DNodes.TLoggerNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#Destroy"},
     {"title": "X3DNodes.TLoggerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLoggerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#URNMatching"},
     {"title": "X3DNodes.TLoggerNode.FdLevel", "text": " ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#FdLevel"},
     {"title": "X3DNodes.TLoggerNode.FdLogFile", "text": " ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#FdLogFile"},
     {"title": "X3DNodes.TLoggerNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#FdEnabled"},
     {"title": "X3DNodes.TLoggerNode.EventWrite", "text": " ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#EventWrite"},
     {"title": "X3DNodes.TLoggerNode.Level", "text": " ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#Level"},
     {"title": "X3DNodes.TLoggerNode.LogFile", "text": " ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#LogFile"},
     {"title": "X3DNodes.TLoggerNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TLoggerNode.html#Enabled"},
     {"title": "X3DNodes.TConverterNode", "text": " ", "tags": "", "loc": "X3DNodes.TConverterNode.html"},
     {"title": "X3DNodes.TConverterNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TConverterNode.html#CreateNode"},
     {"title": "X3DNodes.TConverterNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TConverterNode.html#ClassX3DType"},
     {"title": "X3DNodes.TConverterNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TConverterNode.html#URNMatching"},
     {"title": "X3DNodes.TConverterNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TConverterNode.html#FdEnabled"},
     {"title": "X3DNodes.TConverterNode.EventIn", "text": " ", "tags": "", "loc": "X3DNodes.TConverterNode.html#EventIn"},
     {"title": "X3DNodes.TConverterNode.EventOut", "text": " ", "tags": "", "loc": "X3DNodes.TConverterNode.html#EventOut"},
     {"title": "X3DNodes.TRenderedTextureNode", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html"},
     {"title": "X3DNodes.TRenderedTextureNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#CreateNode"},
     {"title": "X3DNodes.TRenderedTextureNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#Destroy"},
     {"title": "X3DNodes.TRenderedTextureNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#ClassX3DType"},
     {"title": "X3DNodes.TRenderedTextureNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#URNMatching"},
     {"title": "X3DNodes.TRenderedTextureNode.SetDimensions", "text": "    ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#SetDimensions"},
     {"title": "X3DNodes.TRenderedTextureNode.SetDimensions", "text": "    ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#SetDimensions"},
     {"title": "X3DNodes.TRenderedTextureNode.SetDepthMap", "text": "    ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#SetDepthMap"},
     {"title": "X3DNodes.TRenderedTextureNode.SetDepthMap", "text": "    ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#SetDepthMap"},
     {"title": "X3DNodes.TRenderedTextureNode.GeneratedTextureHandler", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#GeneratedTextureHandler"},
     {"title": "X3DNodes.TRenderedTextureNode.FdViewpoint", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdViewpoint"},
     {"title": "X3DNodes.TRenderedTextureNode.FdBackground", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdBackground"},
     {"title": "X3DNodes.TRenderedTextureNode.FdFog", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdFog"},
     {"title": "X3DNodes.TRenderedTextureNode.FdEnvironment", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdEnvironment"},
     {"title": "X3DNodes.TRenderedTextureNode.FdScene", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdScene"},
     {"title": "X3DNodes.TRenderedTextureNode.FdDimensions", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdDimensions"},
     {"title": "X3DNodes.TRenderedTextureNode.FdDepthMap", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdDepthMap"},
     {"title": "X3DNodes.TRenderedTextureNode.FdForeground", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdForeground"},
     {"title": "X3DNodes.TRenderedTextureNode.FdZOffset", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdZOffset"},
     {"title": "X3DNodes.TRenderedTextureNode.FdTargets", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdTargets"},
     {"title": "X3DNodes.TRenderedTextureNode.FdDescription", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdDescription"},
     {"title": "X3DNodes.TRenderedTextureNode.EventViewing", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#EventViewing"},
     {"title": "X3DNodes.TRenderedTextureNode.EventProjection", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#EventProjection"},
     {"title": "X3DNodes.TRenderedTextureNode.FdUpdate", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdUpdate"},
     {"title": "X3DNodes.TRenderedTextureNode.FdFrameBufferMode", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdFrameBufferMode"},
     {"title": "X3DNodes.TRenderedTextureNode.FdExcludeNodes", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdExcludeNodes"},
     {"title": "X3DNodes.TRenderedTextureNode.FdTriggerName", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdTriggerName"},
     {"title": "X3DNodes.TRenderedTextureNode.EventTriggerSlot", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#EventTriggerSlot"},
     {"title": "X3DNodes.TRenderedTextureNode.EventImage_changed", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#EventImage_changed"},
     {"title": "X3DNodes.TRenderedTextureNode.FdTextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdTextureProperties"},
     {"title": "X3DNodes.TRenderedTextureNode.FdRepeatS", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdRepeatS"},
     {"title": "X3DNodes.TRenderedTextureNode.FdRepeatT", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdRepeatT"},
     {"title": "X3DNodes.TRenderedTextureNode.FdRepeatR", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#FdRepeatR"},
     {"title": "X3DNodes.TRenderedTextureNode.EventRendering", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#EventRendering"},
     {"title": "X3DNodes.TRenderedTextureNode.Viewpoint", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#Viewpoint"},
     {"title": "X3DNodes.TRenderedTextureNode.TextureProperties", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#TextureProperties"},
     {"title": "X3DNodes.TRenderedTextureNode.RepeatR", "text": " ", "tags": "", "loc": "X3DNodes.TRenderedTextureNode.html#RepeatR"},
     {"title": "X3DNodes.TPlaneNode", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneNode.html"},
     {"title": "X3DNodes.TPlaneNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneNode.html#CreateNode"},
     {"title": "X3DNodes.TPlaneNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneNode.html#ClassX3DType"},
     {"title": "X3DNodes.TPlaneNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneNode.html#URNMatching"},
     {"title": "X3DNodes.TPlaneNode.Proxy", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneNode.html#Proxy"},
     {"title": "X3DNodes.TPlaneNode.ProxyUsesOverTriangulate", "text": "    ", "tags": "", "loc": "X3DNodes.TPlaneNode.html#ProxyUsesOverTriangulate"},
     {"title": "X3DNodes.TPlaneNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneNode.html#FdSize"},
     {"title": "X3DNodes.TPlaneNode.FdSolid", "text": " ", "tags": "", "loc": "X3DNodes.TPlaneNode.html#FdSolid"},
     {"title": "X3DNodes.TTogglerNode", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html"},
     {"title": "X3DNodes.TTogglerNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#CreateNode"},
     {"title": "X3DNodes.TTogglerNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#ClassX3DType"},
     {"title": "X3DNodes.TTogglerNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#URNMatching"},
     {"title": "X3DNodes.TTogglerNode.FdStatus", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#FdStatus"},
     {"title": "X3DNodes.TTogglerNode.FdNotStatus", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#FdNotStatus"},
     {"title": "X3DNodes.TTogglerNode.EventToggle", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#EventToggle"},
     {"title": "X3DNodes.TTogglerNode.EventSet", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#EventSet"},
     {"title": "X3DNodes.TTogglerNode.EventReset", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#EventReset"},
     {"title": "X3DNodes.TTogglerNode.EventChanged", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#EventChanged"},
     {"title": "X3DNodes.TTogglerNode.EventOn", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#EventOn"},
     {"title": "X3DNodes.TTogglerNode.EventOff", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#EventOff"},
     {"title": "X3DNodes.TTogglerNode.FdEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#FdEnabled"},
     {"title": "X3DNodes.TTogglerNode.Status", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#Status"},
     {"title": "X3DNodes.TTogglerNode.NotStatus", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#NotStatus"},
     {"title": "X3DNodes.TTogglerNode.Enabled", "text": " ", "tags": "", "loc": "X3DNodes.TTogglerNode.html#Enabled"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#CreateNode"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#Destroy"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#URNMatching"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ShininessFactorExp", "text": " This is just <a class=\"normal\" href=\"X3DNodes.TCommonSurfaceShaderNode.html#ShininessFactor\">ShininessFactor</a> * 128.    ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ShininessFactorExp"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.Transparency", "text": " This is just 1 - <a class=\"normal\" href=\"X3DNodes.TCommonSurfaceShaderNode.html#AlphaFactor\">AlphaFactor</a>.    ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#Transparency"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.MaterialInfo", "text": " It is automatically updated when properties of this material change. Do not free it yourself, it will be automatically freed when this node is freed.    ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#MaterialInfo"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.SetTextureTransformEnabled", "text": "    ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#SetTextureTransformEnabled"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.SetTextureTransformEnabled", "text": "    ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#SetTextureTransformEnabled"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAlphaFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAlphaFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAlphaTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAlphaTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAlphaTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAlphaTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAlphaTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAlphaTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAlphaTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAlphaTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAmbientFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAmbientFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAmbientTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAmbientTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAmbientTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAmbientTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAmbientTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAmbientTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdAmbientTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdAmbientTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDiffuseFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDiffuseFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDiffuseTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDiffuseTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDiffuseTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDiffuseTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDiffuseTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDiffuseTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDiffuseTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDiffuseTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDiffuseDisplacementTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDiffuseDisplacementTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDisplacementAxis", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDisplacementAxis"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDisplacementFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDisplacementFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDisplacementTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDisplacementTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDisplacementTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDisplacementTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdDisplacementTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdDisplacementTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEmissiveFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEmissiveFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEmissiveTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEmissiveTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEmissiveTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEmissiveTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEmissiveTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEmissiveTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEmissiveTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEmissiveTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEnvironmentFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEnvironmentFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEnvironmentTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEnvironmentTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEnvironmentTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEnvironmentTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEnvironmentTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEnvironmentTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdEnvironmentTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdEnvironmentTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdMultiDiffuseAlphaTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdMultiDiffuseAlphaTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdMultiEmmisiveAmbientIntensityTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdMultiEmmisiveAmbientIntensityTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdMultiSpecularShininessTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdMultiSpecularShininessTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdMultiVisibilityTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdMultiVisibilityTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdNormalFormat", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdNormalFormat"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdNormalSpace", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdNormalSpace"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdNormalTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdNormalTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdNormalTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdNormalTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdNormalTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdNormalTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdNormalScale", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdNormalScale"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdNormalBias", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdNormalBias"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdNormalTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdNormalTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdNormalTextureParallaxHeight", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdNormalTextureParallaxHeight"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdReflectionFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdReflectionFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdReflectionTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdReflectionTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdReflectionTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdReflectionTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdReflectionTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdReflectionTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdReflectionTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdReflectionTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdShininessFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdShininessFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdShininessTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdShininessTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdShininessTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdShininessTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdShininessTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdShininessTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdShininessTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdShininessTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdSpecularFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdSpecularFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdSpecularTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdSpecularTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdSpecularTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdSpecularTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdSpecularTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdSpecularTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdSpecularTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdSpecularTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdTransmissionFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdTransmissionFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdTransmissionTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdTransmissionTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdTransmissionTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdTransmissionTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdTransmissionTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdTransmissionTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdTransmissionTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdTransmissionTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdTangentTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdTangentTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdBinormalTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdBinormalTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdInvertAlphaTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdInvertAlphaTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdRelativeIndexOfRefraction", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdRelativeIndexOfRefraction"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdFresnelBlend", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdFresnelBlend"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FdTextureTransformEnabled", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FdTextureTransformEnabled"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AlphaFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AlphaFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AlphaTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AlphaTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AlphaTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AlphaTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AlphaTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AlphaTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AlphaTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AlphaTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AmbientFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AmbientFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AmbientTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AmbientTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AmbientTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AmbientTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AmbientTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AmbientTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.AmbientTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#AmbientTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DiffuseFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DiffuseFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DiffuseTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DiffuseTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DiffuseTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DiffuseTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DiffuseTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DiffuseTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DiffuseTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DiffuseTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DiffuseDisplacementTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DiffuseDisplacementTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DisplacementAxis", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DisplacementAxis"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DisplacementFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DisplacementFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DisplacementTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DisplacementTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DisplacementTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DisplacementTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.DisplacementTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#DisplacementTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EmissiveFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EmissiveFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EmissiveTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EmissiveTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EmissiveTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EmissiveTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EmissiveTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EmissiveTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EmissiveTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EmissiveTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EnvironmentFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EnvironmentFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EnvironmentTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EnvironmentTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EnvironmentTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EnvironmentTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EnvironmentTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EnvironmentTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.EnvironmentTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#EnvironmentTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.MultiDiffuseAlphaTexture", "text": " Diffuse color is multiplied by <a class=\"normal\" href=\"X3DNodes.TCommonSurfaceShaderNode.html#DiffuseFactor\">DiffuseFactor</a>, alpha is (or rather: should be) multiplied by <a class=\"normal\" href=\"X3DNodes.TCommonSurfaceShaderNode.html#AlphaFactor\">AlphaFactor</a>. ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#MultiDiffuseAlphaTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.MultiEmmisiveAmbientIntensityTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#MultiEmmisiveAmbientIntensityTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.MultiSpecularShininessTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#MultiSpecularShininessTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.MultiVisibilityTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#MultiVisibilityTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.NormalTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#NormalTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.NormalTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#NormalTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.NormalTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#NormalTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.NormalScale", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#NormalScale"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.NormalBias", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#NormalBias"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.NormalTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#NormalTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.NormalTextureParallaxHeight", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#NormalTextureParallaxHeight"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ReflectionFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ReflectionFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ReflectionTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ReflectionTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ReflectionTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ReflectionTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ReflectionTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ReflectionTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ReflectionTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ReflectionTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ShininessFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ShininessFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ShininessTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ShininessTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ShininessTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ShininessTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ShininessTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ShininessTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.ShininessTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#ShininessTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.SpecularFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#SpecularFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.SpecularTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#SpecularTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.SpecularTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#SpecularTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.SpecularTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#SpecularTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.SpecularTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#SpecularTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.TransmissionFactor", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#TransmissionFactor"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.TransmissionTextureId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#TransmissionTextureId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.TransmissionTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#TransmissionTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.TransmissionTextureChannelMask", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#TransmissionTextureChannelMask"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.TransmissionTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#TransmissionTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.TangentTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#TangentTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.BinormalTextureCoordinatesId", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#BinormalTextureCoordinatesId"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.InvertAlphaTexture", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#InvertAlphaTexture"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.RelativeIndexOfRefraction", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#RelativeIndexOfRefraction"},
     {"title": "X3DNodes.TCommonSurfaceShaderNode.FresnelBlend", "text": " ", "tags": "", "loc": "X3DNodes.TCommonSurfaceShaderNode.html#FresnelBlend"},
     {"title": "X3DNodes.TCircleNode", "text": " See - <a  href=\"http://www.blaxxun.es/pdf/BS_Contact_VRML.en.pdf\">http://www.blaxxun.es/pdf/BS_Contact_VRML.en.pdf</a> for some description (unfortunately, no precise spec), - <a  href=\"http://www.bitmanagement.com/developer/contact/examples/layer/index.html\">http://www.bitmanagement.com/developer/contact/examples/layer/index.html</a> for Layer2D / Layer3D specs. ", "tags": "", "loc": "X3DNodes.TCircleNode.html"},
     {"title": "X3DNodes.TCircleNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TCircleNode.html#ClassX3DType"},
     {"title": "X3DNodes.TCircleNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TCircleNode.html#URNMatching"},
     {"title": "X3DNodes.TLayer2DNode", "text": " ", "tags": "", "loc": "X3DNodes.TLayer2DNode.html"},
     {"title": "X3DNodes.TLayer2DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLayer2DNode.html#CreateNode"},
     {"title": "X3DNodes.TLayer2DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLayer2DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLayer2DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLayer2DNode.html#URNMatching"},
     {"title": "X3DNodes.TLayer2DNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TLayer2DNode.html#FdTranslation"},
     {"title": "X3DNodes.TLayer2DNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TLayer2DNode.html#FdSize"},
     {"title": "X3DNodes.TLayer2DNode.FdBackground", "text": " ", "tags": "", "loc": "X3DNodes.TLayer2DNode.html#FdBackground"},
     {"title": "X3DNodes.TLayer2DNode.FdViewport", "text": " ", "tags": "", "loc": "X3DNodes.TLayer2DNode.html#FdViewport"},
     {"title": "X3DNodes.TLayer3DNode", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html"},
     {"title": "X3DNodes.TLayer3DNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#CreateNode"},
     {"title": "X3DNodes.TLayer3DNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#ClassX3DType"},
     {"title": "X3DNodes.TLayer3DNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#URNMatching"},
     {"title": "X3DNodes.TLayer3DNode.EventAddChildrenLayer", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#EventAddChildrenLayer"},
     {"title": "X3DNodes.TLayer3DNode.EventRemoveChildrenLayer", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#EventRemoveChildrenLayer"},
     {"title": "X3DNodes.TLayer3DNode.FdChildrenLayer", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#FdChildrenLayer"},
     {"title": "X3DNodes.TLayer3DNode.FdTranslation", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#FdTranslation"},
     {"title": "X3DNodes.TLayer3DNode.FdDepth", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#FdDepth"},
     {"title": "X3DNodes.TLayer3DNode.FdSize", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#FdSize"},
     {"title": "X3DNodes.TLayer3DNode.FdBackground", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#FdBackground"},
     {"title": "X3DNodes.TLayer3DNode.FdFog", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#FdFog"},
     {"title": "X3DNodes.TLayer3DNode.FdNavigationInfo", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#FdNavigationInfo"},
     {"title": "X3DNodes.TLayer3DNode.FdViewpoint", "text": " ", "tags": "", "loc": "X3DNodes.TLayer3DNode.html#FdViewpoint"},
     {"title": "X3DNodes.TMouseSensorNode", "text": " ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html"},
     {"title": "X3DNodes.TMouseSensorNode.CreateNode", "text": "    ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#CreateNode"},
     {"title": "X3DNodes.TMouseSensorNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#ClassX3DType"},
     {"title": "X3DNodes.TMouseSensorNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#URNMatching"},
     {"title": "X3DNodes.TMouseSensorNode.FdEventsProcessed", "text": " ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#FdEventsProcessed"},
     {"title": "X3DNodes.TMouseSensorNode.EventClient", "text": " ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#EventClient"},
     {"title": "X3DNodes.TMouseSensorNode.EventPosition", "text": " ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#EventPosition"},
     {"title": "X3DNodes.TMouseSensorNode.EventLButton", "text": " ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#EventLButton"},
     {"title": "X3DNodes.TMouseSensorNode.EventMButton", "text": " ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#EventMButton"},
     {"title": "X3DNodes.TMouseSensorNode.EventRButton", "text": " ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#EventRButton"},
     {"title": "X3DNodes.TMouseSensorNode.EventMouseWheel", "text": " ", "tags": "", "loc": "X3DNodes.TMouseSensorNode.html#EventMouseWheel"},
     {"title": "X3DNodes.TOrderedGroupNode", "text": " ", "tags": "", "loc": "X3DNodes.TOrderedGroupNode.html"},
     {"title": "X3DNodes.TOrderedGroupNode.ClassX3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TOrderedGroupNode.html#ClassX3DType"},
     {"title": "X3DNodes.TOrderedGroupNode.URNMatching", "text": "    ", "tags": "", "loc": "X3DNodes.TOrderedGroupNode.html#URNMatching"},
     {"title": "X3DNodes.TX3DUnknownNode", "text": " Used for nodes found when parsing VRML/X3D file that are not implemented.  <p><code>TX3DUnknownNode</code> is parsed (in classic VRML encoding) in a special way, to be able to omit it gracefully. While such &quot;unknown&quot; node doesn't really do match in our graph, it works correctly with VRML/X3D DEF/USE mechanism.  <p>Never instantiate this class by a standard constructor. Always use <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html#CreateUnknown\">CreateUnknown</a> constructor, this way we can safely assume that <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html#X3DType\">X3DType</a> is always correctly set. ", "tags": "", "loc": "X3DNodes.TX3DUnknownNode.html"},
     {"title": "X3DNodes.TX3DUnknownNode.DeepCopyCreate", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DUnknownNode.html#DeepCopyCreate"},
     {"title": "X3DNodes.TX3DUnknownNode.X3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DUnknownNode.html#X3DType"},
     {"title": "X3DNodes.TX3DUnknownNode.Parse", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DUnknownNode.html#Parse"},
     {"title": "X3DNodes.TX3DUnknownNode.Create", "text": " Always use <a class=\"normal\" href=\"X3DNodes.TX3DUnknownNode.html#CreateUnknown\">CreateUnknown</a>*    ", "tags": "", "loc": "X3DNodes.TX3DUnknownNode.html#Create"},
     {"title": "X3DNodes.TX3DUnknownNode.CreateUnknown", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DUnknownNode.html#CreateUnknown"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration", "text": " See VRML 2.0 and X3D specs.  <p>Each interface specification is a field or an event, stored in <a class=\"normal\" href=\"X3DNodes.TX3DInterfaceDeclaration.html#FieldOrEvent\">FieldOrEvent</a>. <a class=\"normal\" href=\"X3DNodes.TX3DInterfaceDeclaration.html#FieldOrEvent\">FieldOrEvent</a> is <code>Nil</code> before parsing.  <p>Field value is not initialized if you passed FieldValue = <code>False</code> to <a class=\"normal\" href=\"X3DNodes.TX3DInterfaceDeclaration.html#Parse\">Parse</a> (although IsClauseNames will always be initialized). FieldValue = <code>True</code> is used for prototype (not external) declarations and nodes with interface declarations (Script, ComposedShader etc.). In the future maybe some property like FieldValueInitialized will be exposed here, if needed at some point.  <p>Interface declaration doesn't have much properties, since all the information is contained within <a class=\"normal\" href=\"X3DNodes.TX3DInterfaceDeclaration.html#FieldOrEvent\">FieldOrEvent</a> instance, like Name, field class type, out or in (in case of event), exposed or not (in case of field), IsClauseNames. ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#Create"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#Destroy"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.CopyFieldOrEvent", "text": " Sets NewParentNode as Result.ParentNode. Note the new copy will not have ParentIntefaceDeclaration set (as the idea is that you own created copy, not this <a class=\"normal\" href=\"X3DNodes.TX3DInterfaceDeclaration.html\">TX3DInterfaceDeclaration</a> instance).    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#CopyFieldOrEvent"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.CopyAndAddFieldOrEvent", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#CopyAndAddFieldOrEvent"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.AddFieldOrEvent", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#AddFieldOrEvent"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.Parse", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#Parse"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.ParseXML", "text": "  <p>Note that classic VRML parser has here IsClauseAllowed: boolean parameter, this was set to <code>True</code> when parsing InterfaceDeclarations of special nodes (Script, ComposedShader etc.), since they could have IS clause (at least, as far as I understood the spec). But for X3D XML encoding, it's not available, since (AFAI understand the X3D XML encoding spec) the &lt;IS&gt; element inside node body may point from nodeField to any interface field of this node, including InterfaceDeclarations. So ParseISStatement handles this.    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#ParseXML"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.IDeclSaveToStream", "text": " This assumes that it starts at the beginning of the line, and at the end always writes <a class=\"normal\" href=\"CastleUtils.html#NL\">NL</a>, so at the end it's also at the beginning of some line.  <p>For XML encoding, IS clauses are not saved here. They must be saved by containing node.  <p>  FieldValue If <code>True</code> then we will always save Field value or (if classic encoding) IS clauses to stream, along with this interface declaration (if this interface declaration has the Field set). Otherwise, field's value will not be saved, only IS clauses if present.  FieldValue If <code>True</code> then we will always save Field value or (if classic encoding) IS clauses to stream, along with this interface declaration (if this interface declaration has the Field set). Otherwise, field's value will not be saved, only IS clauses if present.", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#IDeclSaveToStream"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.SaveToStream", "text": "     ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#SaveToStream"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.AccessType", "text": "  <p>Result is undefined if both Event and Field are <code>Nil</code> (which may happen when it's not initialized (e.g. parsed) yet) or when both are non-nil (which should never happen).    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#AccessType"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.DeepCopy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#DeepCopy"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.ParentNode", "text": " This must also be set to FieldOrEvent.ParentNode created for this interface declaration. ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#ParentNode"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.FieldOrEvent", "text": " Is non-nil after parsing.  <p>You can assign to this property, to constructs interface declarations (and so also prototypes) in your own code (e.g. this is used X3D XML reader). Just be careful, and remember that this object owns <code>FieldOrEvent</code> (that is, will free it at destruction). ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#FieldOrEvent"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.Field", "text": " <code>Nil</code> if such cast is not possible, for example when <a class=\"normal\" href=\"X3DNodes.TX3DInterfaceDeclaration.html#FieldOrEvent\">FieldOrEvent</a> is an event and you try to use Field method.  ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#Field"},
     {"title": "X3DNodes.TX3DInterfaceDeclaration.Event", "text": " ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclaration.html#Event"},
     {"title": "X3DNodes.TX3DInterfaceDeclarationList", "text": " ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclarationList.html"},
     {"title": "X3DNodes.TX3DInterfaceDeclarationList.TryFindName", "text": " <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclarationList.html#TryFindName"},
     {"title": "X3DNodes.TX3DInterfaceDeclarationList.TryFindFieldName", "text": " <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclarationList.html#TryFindFieldName"},
     {"title": "X3DNodes.TX3DInterfaceDeclarationList.TryFindEventName", "text": " <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DNodes.TX3DInterfaceDeclarationList.html#TryFindEventName"},
     {"title": "X3DNodes.EX3DPrototypeInstantiateError", "text": "  <p>User code usually doesn't see this exception, unless you call <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html#Instantiate\">TX3DPrototypeNode.Instantiate</a> explicitly (but you usually don't). In normal circumstances, the engine calls <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html#Instantiate\">TX3DPrototypeNode.Instantiate</a> when necessary, and converts eventual <code>EX3DPrototypeInstantiateError</code> exceptions into warnings (reported by <a class=\"normal\" href=\"CastleApplicationProperties.TCastleApplicationProperties.html#OnWarning\">ApplicationProperties.OnWarning</a>). ", "tags": "", "loc": "X3DNodes.EX3DPrototypeInstantiateError.html"},
     {"title": "X3DNodes.TX3DPrototypeNode", "text": "  <p>This node will have fields initialized according to associated Prototype.InterfaceDeclarations. This way you can simply parse this node (just like any other node) to parse prototype instance.  <p>The prototype may be instantiated. After parsing you can do it by <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html#Instantiate\">Instantiate</a> method. In case of non-external prototype, this should always be possible (for a valid VRML files, that is), in case of external prototype this may requite loading the external prototype file.  <p>This node cannot be created by standard Create method, always use <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html#CreatePrototypeNode\">CreatePrototypeNode</a>. ", "tags": "", "loc": "X3DNodes.TX3DPrototypeNode.html"},
     {"title": "X3DNodes.TX3DPrototypeNode.DeepCopyCreate", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototypeNode.html#DeepCopyCreate"},
     {"title": "X3DNodes.TX3DPrototypeNode.Create", "text": " Always use <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html#CreatePrototypeNode\">CreatePrototypeNode</a> for this node class.    ", "tags": "", "loc": "X3DNodes.TX3DPrototypeNode.html#Create"},
     {"title": "X3DNodes.TX3DPrototypeNode.CreatePrototypeNode", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototypeNode.html#CreatePrototypeNode"},
     {"title": "X3DNodes.TX3DPrototypeNode.X3DType", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototypeNode.html#X3DType"},
     {"title": "X3DNodes.TX3DPrototypeNode.Instantiate", "text": "  <p>For non-external prototype, in essense it just takes Prototype.Node and returns it's copy. For external prototype it first loads external file, and then uses non-external prototype there. Eventually, for external prototype we may also use build-in node (if URN will indicate so).  <p>Actually, the process is a little more involved (see below for details), but the idea is that returned node can be simply inserted into VRML hierarchy and works just like a normal node. The important feature is that returned instance class is the same that was specified as a first prototype node. For example, if the prototype should expand to Material node, then this returns <a class=\"normal\" href=\"X3DNodes.TMaterialNode.html\">TMaterialNode</a>. Just like Material node would be normally specified, not created by some prototype.  <p>Note that this <a class=\"normal\" href=\"X3DNodes.TX3DPrototypeNode.html\">TX3DPrototypeNode</a> becomes &quot;owned&quot; by returned node instance, in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode\">PrototypeInstanceSourceNode</a>. (that's needed for returned node's <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#SaveToStream\">SaveToStream</a> to work correctly).  <p>Details: </p>  <ul class=\"paragraph_spacing\">   <li><p> Prototype.Node may be just a wrapper, i.e. <a class=\"normal\" href=\"X3DNodes.TX3DRootNode.html\">TX3DRootNode</a>.  <p>In this case the first children of Prototype.Node is used to create instance. The rest of the wrapper (with this first children removed, to not cause cycles) is also duplicated and set as new node's <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceHelpers\">PrototypeInstanceHelpers</a>.</p></li>   <li><p> Returned Node (with all it's helpers in <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceHelpers\">PrototypeInstanceHelpers</a>) has &quot;IS&quot; clauses everywhere filled, according to our field values.</p></li>   <li><p>Name of returned node is copied from our Name.</p></li>   <li><p> For <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#SaveToStream\">SaveToStream</a> to work, returned Node has <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstance\">PrototypeInstance</a> = <code>True</code>, and <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode\">PrototypeInstanceSourceNode</a> set to Self. This allows <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#SaveToStream\">SaveToStream</a> to correctly save using <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#PrototypeInstanceSourceNode\">PrototypeInstanceSourceNode</a>, instead of writing actual node contents.</p></li> </ul>  <p>  <p>    EX3DPrototypeInstantiateError If for some reason the prototype cannot be instantiated. Outside code should catch this and replace with ApplicationProperties.OnWarning, if possible.", "tags": "", "loc": "X3DNodes.TX3DPrototypeNode.html#Instantiate"},
     {"title": "X3DNodes.TX3DPrototypeNode.Prototype", "text": " ", "tags": "", "loc": "X3DNodes.TX3DPrototypeNode.html#Prototype"},
     {"title": "X3DNodes.TX3DPrototypeBase", "text": " ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBase.html"},
     {"title": "X3DNodes.TX3DPrototypeBase.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBase.html#Create"},
     {"title": "X3DNodes.TX3DPrototypeBase.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBase.html#Destroy"},
     {"title": "X3DNodes.TX3DPrototypeBase.Parse", "text": " Adds to <code>Names</code> by <code>Names.Prototypes.Bind(Self)</code>.     ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBase.html#Parse"},
     {"title": "X3DNodes.TX3DPrototypeBase.ParseXML", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBase.html#ParseXML"},
     {"title": "X3DNodes.TX3DPrototypeBase.X3DName", "text": " ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBase.html#X3DName"},
     {"title": "X3DNodes.TX3DPrototypeBase.Name", "text": " ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBase.html#Name"},
     {"title": "X3DNodes.TX3DPrototypeBase.InterfaceDeclarations", "text": " ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBase.html#InterfaceDeclarations"},
     {"title": "X3DNodes.TX3DPrototypeBase.BaseUrl", "text": " For now, used by EXTERNPROTO urls. See <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#BaseUrl\">TX3DNode.BaseUrl</a> for more comments. ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBase.html#BaseUrl"},
     {"title": "X3DNodes.TX3DPrototypeBaseList", "text": " ", "tags": "", "loc": "X3DNodes.TX3DPrototypeBaseList.html"},
     {"title": "X3DNodes.TX3DPrototype", "text": " ", "tags": "", "loc": "X3DNodes.TX3DPrototype.html"},
     {"title": "X3DNodes.TX3DPrototype.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototype.html#Destroy"},
     {"title": "X3DNodes.TX3DPrototype.Parse", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototype.html#Parse"},
     {"title": "X3DNodes.TX3DPrototype.ParseXML", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototype.html#ParseXML"},
     {"title": "X3DNodes.TX3DPrototype.SaveToStream", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototype.html#SaveToStream"},
     {"title": "X3DNodes.TX3DPrototype.Node", "text": " ", "tags": "", "loc": "X3DNodes.TX3DPrototype.html#Node"},
     {"title": "X3DNodes.TX3DExternalPrototype", "text": " ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html"},
     {"title": "X3DNodes.TX3DExternalPrototype.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#Create"},
     {"title": "X3DNodes.TX3DExternalPrototype.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#Destroy"},
     {"title": "X3DNodes.TX3DExternalPrototype.Parse", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#Parse"},
     {"title": "X3DNodes.TX3DExternalPrototype.ParseXML", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#ParseXML"},
     {"title": "X3DNodes.TX3DExternalPrototype.SaveToStream", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#SaveToStream"},
     {"title": "X3DNodes.TX3DExternalPrototype.LoadReferenced", "text": " Sets either <a class=\"normal\" href=\"X3DNodes.TX3DExternalPrototype.html#ReferencedClass\">ReferencedClass</a> to non-nil (if it's built-in node) or <a class=\"normal\" href=\"X3DNodes.TX3DExternalPrototype.html#ReferencedPrototype\">ReferencedPrototype</a> (if prototype expansion found in external file).    ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#LoadReferenced"},
     {"title": "X3DNodes.TX3DExternalPrototype.UnloadReferenced", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#UnloadReferenced"},
     {"title": "X3DNodes.TX3DExternalPrototype.URLList", "text": " ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#URLList"},
     {"title": "X3DNodes.TX3DExternalPrototype.ReferencedPrototype", "text": " ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#ReferencedPrototype"},
     {"title": "X3DNodes.TX3DExternalPrototype.ReferencedClass", "text": " ", "tags": "", "loc": "X3DNodes.TX3DExternalPrototype.html#ReferencedClass"},
     {"title": "X3DNodes.TX3DRoute", "text": " ", "tags": "", "loc": "X3DNodes.TX3DRoute.html"},
     {"title": "X3DNodes.TX3DRoute.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#Create"},
     {"title": "X3DNodes.TX3DRoute.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#Destroy"},
     {"title": "X3DNodes.TX3DRoute.SetSource", "text": "  <p>This does everything that VRML parser should do when parsed VRML route. It looks for given node name (in Names.Nodes, then Names.Imported), then it looks for field/event within this node, and if everything is successful &mdash; sets route properties.  <p>If something goes wrong, <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> is generated and route ending is left unset.  <p>    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#SetSource"},
     {"title": "X3DNodes.TX3DRoute.SetDestination", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#SetDestination"},
     {"title": "X3DNodes.TX3DRoute.SetSourceDirectly", "text": "  <p>FieldOrEvent is used to set <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceEvent\">SourceEvent</a> (or <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#DestinationEvent\">DestinationEvent</a>). FieldOrEvent may be the actual event to set, or exposed field containing this event.  <p>You specify explictly NewNode, which is not checked in any way. We don't check whether it exists, whether it contains given FieldOrEvent, etc. &mdash; you have to guarantee this yourself. Also, remember that normal <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SetSource\">SetSource</a> actually look for events inside PrototypeInstanceSourceNode, if exists &mdash; if you want this, you have to do this yourself when using these SetXxxDirectly. It is used to set <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceNode\">SourceNode</a> (or <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#DestinationNode\">DestinationNode</a>). Overloaded versions that don't take NewNode parameter just assume that NewNode can be taken from FieldOrEvent.ParentNode.  <p>    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#SetSourceDirectly"},
     {"title": "X3DNodes.TX3DRoute.SetDestinationDirectly", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#SetDestinationDirectly"},
     {"title": "X3DNodes.TX3DRoute.SetSourceDirectly", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#SetSourceDirectly"},
     {"title": "X3DNodes.TX3DRoute.SetDestinationDirectly", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#SetDestinationDirectly"},
     {"title": "X3DNodes.TX3DRoute.Parse", "text": " Implementation should be able to safely assume that current token is ROUTE.    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#Parse"},
     {"title": "X3DNodes.TX3DRoute.ParseXML", "text": " Given Element here must have TagName = 'ROUTE'.    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#ParseXML"},
     {"title": "X3DNodes.TX3DRoute.SaveToStream", "text": "  <p>Will generate <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a> when route cannot be saved. This can happen when <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceNode\">SourceNode</a> or <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceEvent\">SourceEvent</a> or <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#DestinationNode\">DestinationNode</a> or <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#DestinationEvent\">DestinationEvent</a> are <code>Nil</code>. Also, if <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceNode\">SourceNode</a> and <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#DestinationNode\">DestinationNode</a> are without a name, or the name is not currently bound in Writer.NodeNames.    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#SaveToStream"},
     {"title": "X3DNodes.TX3DRoute.ResetLastEventTime", "text": " Route must remember such thing, to avoid loops in routes. This is following VRML 2.0 / X3D specifications, that explicitly say that only one event per ROUTE per timestamp is allowed.  <p>Use <code>ResetLastEventTime</code> when you really want to reset this memory. In practice, this should be used only by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ResetTime\">TCastleSceneCore.ResetTime</a> implementation.    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#ResetLastEventTime"},
     {"title": "X3DNodes.TX3DRoute.DeepCopy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#DeepCopy"},
     {"title": "X3DNodes.TX3DRoute.SourceNode", "text": " Either all three are <code>Nil</code>, or:  <p></p>  <ul class=\"paragraph_spacing\">   <li><p><a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceEvent\">SourceEvent</a> is assigned, meaning is self-explanatory.  <p>Note: if you want to get it's exposed field, remember this is available in SourceEvent.ParentExposedField.</p></li>   <li><p><code>SourceNode</code> must also be assigned and this must be the node enclosing <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceEvent\">SourceEvent</a>. That is, the node that has <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceEvent\">SourceEvent</a> as one of explicit (on <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Events\">TX3DNode.Events</a> list) or implicit (exposed by some field) event.</p></li> </ul>  <p>  <p> ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#SourceNode"},
     {"title": "X3DNodes.TX3DRoute.SourceEvent", "text": " ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#SourceEvent"},
     {"title": "X3DNodes.TX3DRoute.DestinationNode", "text": " Analogous to <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceEvent\">SourceEvent</a>, <a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SourceNode\">SourceNode</a>.  <p> ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#DestinationNode"},
     {"title": "X3DNodes.TX3DRoute.DestinationEvent", "text": " ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#DestinationEvent"},
     {"title": "X3DNodes.TX3DRoute.Internal", "text": "  <p>These routes work exactly like normal routes, except: </p>  <ul class=\"paragraph_spacing\">   <li><p>They are not saved to file (<a class=\"normal\" href=\"X3DNodes.TX3DRoute.html#SaveToStream\">SaveToStream</a> will ignore internal route).</p></li>   <li><p>It's allowed (in fact, this will always happen for current internal routes) to route one input event to another input event.</p></li> </ul>  <p> ", "tags": "", "loc": "X3DNodes.TX3DRoute.html#Internal"},
     {"title": "X3DNodes.TX3DRouteList", "text": " ", "tags": "", "loc": "X3DNodes.TX3DRouteList.html"},
     {"title": "X3DNodes.TX3DImport", "text": "  <p>This file is part of &quot;Castle Game Engine&quot;.  <p>&quot;Castle Game Engine&quot; is free software; see the file COPYING.txt, included in this distribution, for details about the copyright.  <p>&quot;Castle Game Engine&quot; is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  <p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;- ", "tags": "", "loc": "X3DNodes.TX3DImport.html"},
     {"title": "X3DNodes.TX3DImport.InlineNodeName", "text": " ", "tags": "", "loc": "X3DNodes.TX3DImport.html#InlineNodeName"},
     {"title": "X3DNodes.TX3DImport.ImportedNodeName", "text": " ", "tags": "", "loc": "X3DNodes.TX3DImport.html#ImportedNodeName"},
     {"title": "X3DNodes.TX3DImport.ImportedNodeAlias", "text": " ", "tags": "", "loc": "X3DNodes.TX3DImport.html#ImportedNodeAlias"},
     {"title": "X3DNodes.TX3DImport.Parse", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DImport.html#Parse"},
     {"title": "X3DNodes.TX3DImport.ParseXML", "text": " Given Element here must have TagName = 'IMPORT'.    ", "tags": "", "loc": "X3DNodes.TX3DImport.html#ParseXML"},
     {"title": "X3DNodes.TX3DImport.SaveToStream", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DImport.html#SaveToStream"},
     {"title": "X3DNodes.TX3DImport.DeepCopy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DImport.html#DeepCopy"},
     {"title": "X3DNodes.TX3DExport", "text": " ", "tags": "", "loc": "X3DNodes.TX3DExport.html"},
     {"title": "X3DNodes.TX3DExport.ExportedNodeName", "text": " ", "tags": "", "loc": "X3DNodes.TX3DExport.html#ExportedNodeName"},
     {"title": "X3DNodes.TX3DExport.ExportedNodeAlias", "text": " ", "tags": "", "loc": "X3DNodes.TX3DExport.html#ExportedNodeAlias"},
     {"title": "X3DNodes.TX3DExport.Parse", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DExport.html#Parse"},
     {"title": "X3DNodes.TX3DExport.ParseXML", "text": " Given Element here must have TagName = 'EXPORT'.    ", "tags": "", "loc": "X3DNodes.TX3DExport.html#ParseXML"},
     {"title": "X3DNodes.TX3DExport.SaveToStream", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DExport.html#SaveToStream"},
     {"title": "X3DNodes.TX3DExport.DeepCopy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DExport.html#DeepCopy"},
     {"title": "X3DNodes.TX3DBindableStackBasic", "text": " ", "tags": "", "loc": "X3DNodes.TX3DBindableStackBasic.html"},
     {"title": "X3DNodes.TX3DBindableStackBasic.Set_Bind", "text": " This always generates appropriate events.    ", "tags": "", "loc": "X3DNodes.TX3DBindableStackBasic.html#Set_Bind"},
     {"title": "X3DNodes.TX3DEventsEngine", "text": " Is also notified about changes to VRML/X3D nodes/fields.  <p>See <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> for documentation of these methods, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> is the only implementation of this interface in practice. ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html"},
     {"title": "X3DNodes.TX3DEventsEngine.ExecuteCompiledScript", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#ExecuteCompiledScript"},
     {"title": "X3DNodes.TX3DEventsEngine.GetBackgroundStack", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#GetBackgroundStack"},
     {"title": "X3DNodes.TX3DEventsEngine.GetFogStack", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#GetFogStack"},
     {"title": "X3DNodes.TX3DEventsEngine.GetNavigationInfoStack", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#GetNavigationInfoStack"},
     {"title": "X3DNodes.TX3DEventsEngine.GetViewpointStack", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#GetViewpointStack"},
     {"title": "X3DNodes.TX3DEventsEngine.Time", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#Time"},
     {"title": "X3DNodes.TX3DEventsEngine.NextEventTime", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#NextEventTime"},
     {"title": "X3DNodes.TX3DEventsEngine.ChangedAll", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#ChangedAll"},
     {"title": "X3DNodes.TX3DEventsEngine.BeforeNodesFree", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#BeforeNodesFree"},
     {"title": "X3DNodes.TX3DEventsEngine.InternalChangedField", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngine.html#InternalChangedField"},
     {"title": "X3DNodes.TX3DEventsEngineList", "text": " ", "tags": "", "loc": "X3DNodes.TX3DEventsEngineList.html"},
     {"title": "X3DNodes.TX3DEventsEngineList.InternalChangedField", "text": " See TCastleSceneCore.InternalChangedField for exact specification.    ", "tags": "", "loc": "X3DNodes.TX3DEventsEngineList.html#InternalChangedField"},
     {"title": "X3DNodes.TX3DNodeNameRec", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNodeNameRec.html"},
     {"title": "X3DNodes.TX3DNodeNameRec.Node", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNodeNameRec.html#Node"},
     {"title": "X3DNodes.TX3DNodeNameRec.Name", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNodeNameRec.html#Name"},
     {"title": "X3DNodes.TX3DNodeNameRec.Finished", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNodeNameRec.html#Finished"},
     {"title": "X3DNodes.TX3DNodeNameRec.DeepCopy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeNameRec.html#DeepCopy"},
     {"title": "X3DNodes.TX3DNodeNames", "text": " ", "tags": "", "loc": "X3DNodes.TX3DNodeNames.html"},
     {"title": "X3DNodes.TX3DNodeNames.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeNames.html#Create"},
     {"title": "X3DNodes.TX3DNodeNames.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeNames.html#Destroy"},
     {"title": "X3DNodes.TX3DNodeNames.Bind", "text": "  <p>If not NodeFinished, then we understand that we're parsing / saving the node's contents now. If NodeFinished, then we know the node contents are fully parsed / saved now. This information helps us to detect cycles in VRML/X3D DEF/USE graph. For now, we just disallow such cycles. Still, we allow ROUTEs from inside the node, so calling with NodeFinished = false is still useful for parsing.    ", "tags": "", "loc": "X3DNodes.TX3DNodeNames.html#Bind"},
     {"title": "X3DNodes.TX3DNodeNames.Bind", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeNames.html#Bind"},
     {"title": "X3DNodes.TX3DNodeNames.Bound", "text": " <code>Nil</code> if none.    ", "tags": "", "loc": "X3DNodes.TX3DNodeNames.html#Bound"},
     {"title": "X3DNodes.TX3DNodeNames.Bound", "text": " <code>False</code> means that node is not within this namespace, possibly it's name was hidden by other node with the same name.  <p>Doesn't check is Node bound to it's name (Node.Name) or something else. So this assumes that node can only be bound (if at all) only to it's own name, which is true during parsing (when nothing can change in the middle of parsing).    ", "tags": "", "loc": "X3DNodes.TX3DNodeNames.html#Bound"},
     {"title": "X3DNodes.TX3DNodeNames.DeepCopy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DNodeNames.html#DeepCopy"},
     {"title": "X3DNodes.TX3DNodeNames.AutoRemove", "text": " This allows you to safely destroy node instances during this objects lifetime, without worrying that some dangling pointers remain on this list.  <p>Internally, this is done by registering itself for <a class=\"normal\" href=\"X3DNodes.html#AnyNodeDestructionNotifications\">AnyNodeDestructionNotifications</a>. ", "tags": "", "loc": "X3DNodes.TX3DNodeNames.html#AutoRemove"},
     {"title": "X3DNodes.TX3DPrototypeNames", "text": " ", "tags": "", "loc": "X3DNodes.TX3DPrototypeNames.html"},
     {"title": "X3DNodes.TX3DPrototypeNames.Bind", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DPrototypeNames.html#Bind"},
     {"title": "X3DNodes.TX3DPrototypeNames.Bound", "text": " <code>Nil</code> if none.    ", "tags": "", "loc": "X3DNodes.TX3DPrototypeNames.html#Bound"},
     {"title": "X3DNodes.TX3DImportableNames", "text": " ", "tags": "", "loc": "X3DNodes.TX3DImportableNames.html"},
     {"title": "X3DNodes.TX3DImportableNames.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DImportableNames.html#Destroy"},
     {"title": "X3DNodes.TX3DImportableNames.Bind", "text": " Exported instance becomes owner by this <a class=\"normal\" href=\"X3DNodes.TX3DImportableNames.html\">TX3DImportableNames</a> instance. InlineName must be &lt;&gt; '' here.    ", "tags": "", "loc": "X3DNodes.TX3DImportableNames.html#Bind"},
     {"title": "X3DNodes.TX3DReaderNames", "text": " Used by both classic and XML VRML/X3D readers. ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html"},
     {"title": "X3DNodes.TX3DReaderNames.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#Create"},
     {"title": "X3DNodes.TX3DReaderNames.CreateCopy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#CreateCopy"},
     {"title": "X3DNodes.TX3DReaderNames.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#Destroy"},
     {"title": "X3DNodes.TX3DReaderNames.ExtractNames", "text": " This method can be used only right before calling the destructor. It copies the prototype, exported, <a class=\"normal\" href=\"X3DNodes.TX3DReaderNames.html#Imported\">imported</a> names list (names visible from the outside), and sets them to <code>Nil</code> (to avoid releasing them at destruction).    ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#ExtractNames"},
     {"title": "X3DNodes.TX3DReaderNames.DoExport", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#DoExport"},
     {"title": "X3DNodes.TX3DReaderNames.DoImport", "text": "    ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#DoImport"},
     {"title": "X3DNodes.TX3DReaderNames.Nodes", "text": "  <p>This is a list without duplicates with all currently known node names. Objects[] of this list point to actual <a class=\"normal\" href=\"X3DNodes.TX3DNode.html\">TX3DNode</a> instances. If many instances had the same NodeName, only the last instance will be referenced here, following VRML spec (last DEF takes precedence).  <p>Internal notes: ParseNode doesn't modify this, only <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#Parse\">TX3DNode.Parse</a> can do this. ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#Nodes"},
     {"title": "X3DNodes.TX3DReaderNames.Prototypes", "text": " ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#Prototypes"},
     {"title": "X3DNodes.TX3DReaderNames.Imported", "text": "  <p>The nodes on this list are &quot;bound&quot; to their aliases, as this is the name under which they are visible in the current namespace. Alias is the identifier after the &quot;AS&quot; keyword in the &quot;IMPORT&quot; declaration (or, if no &quot;AS xxx&quot; clause was present, then alias is just the name under which node was exported). ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#Imported"},
     {"title": "X3DNodes.TX3DReaderNames.Exported", "text": "  <p>The nodes on this list are &quot;bound&quot; to their aliases, as this is the name under which they are visible for the outside VRML scenes (that can import these nodes). Alias is the identifier after the &quot;AS&quot; keyword in &quot;EXPORT&quot; declaration (or, if no &quot;AS xxx&quot; clause, then alias is just normal node name). ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#Exported"},
     {"title": "X3DNodes.TX3DReaderNames.Importable", "text": "  <p>The mechanism is that when you load an Inline node, the resulting &quot;Exported&quot; nodes (from the namespace within the Inline) get added to this &quot;Importable&quot; list. Then the &quot;IMPORT&quot; clause in this namespace can make &quot;Importable&quot; nodes into actually &quot;<a class=\"normal\" href=\"X3DNodes.TX3DReaderNames.html#Imported\">Imported</a>&quot;.  <p>This is a list with strings representing Inline node names (there's no way to IMPORT from unnamed Inline nodes). Objects[] of this list are instances of <a class=\"normal\" href=\"X3DNodes.TX3DNodeNames.html\">TX3DNodeNames</a> corresponding to exported names within the inline. ", "tags": "", "loc": "X3DNodes.TX3DReaderNames.html#Importable"},
     {"title": "X3DNodes.ENodesManagerError", "text": " ", "tags": "", "loc": "X3DNodes.ENodesManagerError.html"},
     {"title": "X3DNodes.ENodeClassRegisterError", "text": " ", "tags": "", "loc": "X3DNodes.ENodeClassRegisterError.html"},
     {"title": "X3DNodes.TNodesManager", "text": " ", "tags": "", "loc": "X3DNodes.TNodesManager.html"},
     {"title": "X3DNodes.TNodesManager.Create", "text": "    ", "tags": "", "loc": "X3DNodes.TNodesManager.html#Create"},
     {"title": "X3DNodes.TNodesManager.Destroy", "text": "    ", "tags": "", "loc": "X3DNodes.TNodesManager.html#Destroy"},
     {"title": "X3DNodes.TNodesManager.RegisterNodeClass", "text": " We associate the node class with it's <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#ClassX3DType\">TX3DNode.ClassX3DType</a> (make sure it's not empty).  <p>It is OK to register two different node classes with the same node. For example, VRML 1.0 <a class=\"normal\" href=\"X3DNodes.TConeNode_1.html\">TConeNode_1</a> class and VRML 2.0/X3D <a class=\"normal\" href=\"X3DNodes.html#TConeNode_2\">TConeNode_2</a> class both have a name 'Cone' (and will be correctly chosen during parsing). But you cannot register two times the same NodeClass.  <p>    ", "tags": "", "loc": "X3DNodes.TNodesManager.html#RegisterNodeClass"},
     {"title": "X3DNodes.TNodesManager.RegisterNodeClasses", "text": "    ", "tags": "", "loc": "X3DNodes.TNodesManager.html#RegisterNodeClasses"},
     {"title": "X3DNodes.TNodesManager.UnRegisterNodeClass", "text": "  <p>    ENodesManagerError if NodeClass.ClassX3DType = '' (so it cannot be even registered), or if ((NodeClass was not registered) and ErrorIfNotRegistered)", "tags": "", "loc": "X3DNodes.TNodesManager.html#UnRegisterNodeClass"},
     {"title": "X3DNodes.TNodesManager.X3DTypeToClass", "text": " This method is the main purpose of <a class=\"normal\" href=\"X3DNodes.TNodesManager.html\">TNodesManager</a>: to map node names into node classes.  <p>Searches in nodes registered by <a class=\"normal\" href=\"X3DNodes.TNodesManager.html#RegisterNodeClass\">RegisterNodeClass</a> and such. During searching, looks not only for matching node name, but also at matching VRML/X3D version, checking <code>ForVRMLVersion(Version)</code>.  <p>Returns <code>Nil</code> when not found.    ", "tags": "", "loc": "X3DNodes.TNodesManager.html#X3DTypeToClass"},
     {"title": "X3DNodes.TNodesManager.URNToClass", "text": " This is useful for EXTERNROTOs. Returns <code>Nil</code> if not found.    ", "tags": "", "loc": "X3DNodes.TNodesManager.html#URNToClass"},
     {"title": "X3DNodes.TNodesManager.RegisteredCount", "text": "    ", "tags": "", "loc": "X3DNodes.TNodesManager.html#RegisteredCount"},
     {"title": "X3DNodes.TNodesManager.Registered", "text": "  <p> ", "tags": "", "loc": "X3DNodes.TNodesManager.html#Registered"},
     {"title": "X3DNodes.LoadX3DClassic_FileFilters", "text": " Suitable for <a class=\"normal\" href=\"CastleWindow.TCastleWindowCustom.html#FileDialog\">TCastleWindowCustom.FileDialog</a> and such. ", "tags": "", "loc": "X3DNodes.html#LoadX3DClassic_FileFilters"},
     {"title": "X3DNodes.LoadX3DXml_FileFilters", "text": " ", "tags": "", "loc": "X3DNodes.html#LoadX3DXml_FileFilters"},
     {"title": "X3DNodes.ProjectionTypeToStr", "text": "  <p>This file is part of &quot;Castle Game Engine&quot;.  <p>&quot;Castle Game Engine&quot; is free software; see the file COPYING.txt, included in this distribution, for details about the copyright.  <p>&quot;Castle Game Engine&quot; is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  <p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;- ", "tags": "", "loc": "X3DNodes.html#ProjectionTypeToStr"},
     {"title": "X3DNodes.DefaultMaterial_1AmbientColor", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterial_1AmbientColor"},
     {"title": "X3DNodes.DefaultMaterialAmbientIntensity", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterialAmbientIntensity"},
     {"title": "X3DNodes.DefaultMaterialDiffuseColor", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterialDiffuseColor"},
     {"title": "X3DNodes.DefaultMaterialSpecularColor", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterialSpecularColor"},
     {"title": "X3DNodes.DefaultMaterialEmissiveColor", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterialEmissiveColor"},
     {"title": "X3DNodes.DefaultMaterialShininess", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterialShininess"},
     {"title": "X3DNodes.DefaultMaterialTransparency", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterialTransparency"},
     {"title": "X3DNodes.DefaultMaterialMirror", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterialMirror"},
     {"title": "X3DNodes.DefaultMaterialReflSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterialReflSpecularExp"},
     {"title": "X3DNodes.DefaultMaterialTransSpecularExp", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultMaterialTransSpecularExp"},
     {"title": "X3DNodes.JUSTIFICATION_LEFT", "text": "  ", "tags": "", "loc": "X3DNodes.html#JUSTIFICATION_LEFT"},
     {"title": "X3DNodes.JUSTIFICATION_CENTER", "text": " ", "tags": "", "loc": "X3DNodes.html#JUSTIFICATION_CENTER"},
     {"title": "X3DNodes.JUSTIFICATION_RIGHT", "text": " ", "tags": "", "loc": "X3DNodes.html#JUSTIFICATION_RIGHT"},
     {"title": "X3DNodes.BIND_DEFAULT", "text": "  ", "tags": "", "loc": "X3DNodes.html#BIND_DEFAULT"},
     {"title": "X3DNodes.BIND_OVERALL", "text": " ", "tags": "", "loc": "X3DNodes.html#BIND_OVERALL"},
     {"title": "X3DNodes.BIND_PER_PART", "text": " ", "tags": "", "loc": "X3DNodes.html#BIND_PER_PART"},
     {"title": "X3DNodes.BIND_PER_PART_INDEXED", "text": " ", "tags": "", "loc": "X3DNodes.html#BIND_PER_PART_INDEXED"},
     {"title": "X3DNodes.BIND_PER_FACE", "text": " ", "tags": "", "loc": "X3DNodes.html#BIND_PER_FACE"},
     {"title": "X3DNodes.BIND_PER_FACE_INDEXED", "text": " ", "tags": "", "loc": "X3DNodes.html#BIND_PER_FACE_INDEXED"},
     {"title": "X3DNodes.BIND_PER_VERTEX", "text": " ", "tags": "", "loc": "X3DNodes.html#BIND_PER_VERTEX"},
     {"title": "X3DNodes.BIND_PER_VERTEX_INDEXED", "text": " ", "tags": "", "loc": "X3DNodes.html#BIND_PER_VERTEX_INDEXED"},
     {"title": "X3DNodes.VERTORDER_UNKNOWN", "text": "  ", "tags": "", "loc": "X3DNodes.html#VERTORDER_UNKNOWN"},
     {"title": "X3DNodes.VERTORDER_CLOCKWISE", "text": " ", "tags": "", "loc": "X3DNodes.html#VERTORDER_CLOCKWISE"},
     {"title": "X3DNodes.VERTORDER_COUNTERCLOCKWISE", "text": " ", "tags": "", "loc": "X3DNodes.html#VERTORDER_COUNTERCLOCKWISE"},
     {"title": "X3DNodes.SHTYPE_UNKNOWN", "text": "  ", "tags": "", "loc": "X3DNodes.html#SHTYPE_UNKNOWN"},
     {"title": "X3DNodes.SHTYPE_SOLID", "text": " ", "tags": "", "loc": "X3DNodes.html#SHTYPE_SOLID"},
     {"title": "X3DNodes.FACETYPE_UNKNOWN", "text": "  ", "tags": "", "loc": "X3DNodes.html#FACETYPE_UNKNOWN"},
     {"title": "X3DNodes.FACETYPE_CONVEX", "text": " ", "tags": "", "loc": "X3DNodes.html#FACETYPE_CONVEX"},
     {"title": "X3DNodes.FSFAMILY_SERIF", "text": "  ", "tags": "", "loc": "X3DNodes.html#FSFAMILY_SERIF"},
     {"title": "X3DNodes.FSFAMILY_SANS", "text": " ", "tags": "", "loc": "X3DNodes.html#FSFAMILY_SANS"},
     {"title": "X3DNodes.FSFAMILY_TYPEWRITER", "text": " ", "tags": "", "loc": "X3DNodes.html#FSFAMILY_TYPEWRITER"},
     {"title": "X3DNodes.FSSTYLE_BOLD", "text": "  ", "tags": "", "loc": "X3DNodes.html#FSSTYLE_BOLD"},
     {"title": "X3DNodes.FSSTYLE_ITALIC", "text": " ", "tags": "", "loc": "X3DNodes.html#FSSTYLE_ITALIC"},
     {"title": "X3DNodes.CONE_PARTS_SIDES", "text": "  ", "tags": "", "loc": "X3DNodes.html#CONE_PARTS_SIDES"},
     {"title": "X3DNodes.CONE_PARTS_BOTTOM", "text": " ", "tags": "", "loc": "X3DNodes.html#CONE_PARTS_BOTTOM"},
     {"title": "X3DNodes.CYLINDER_PARTS_SIDES", "text": "  ", "tags": "", "loc": "X3DNodes.html#CYLINDER_PARTS_SIDES"},
     {"title": "X3DNodes.CYLINDER_PARTS_TOP", "text": " ", "tags": "", "loc": "X3DNodes.html#CYLINDER_PARTS_TOP"},
     {"title": "X3DNodes.CYLINDER_PARTS_BOTTOM", "text": " ", "tags": "", "loc": "X3DNodes.html#CYLINDER_PARTS_BOTTOM"},
     {"title": "X3DNodes.TEXWRAP_REPEAT", "text": "  ", "tags": "", "loc": "X3DNodes.html#TEXWRAP_REPEAT"},
     {"title": "X3DNodes.TEXWRAP_CLAMP", "text": " ", "tags": "", "loc": "X3DNodes.html#TEXWRAP_CLAMP"},
     {"title": "X3DNodes.DefaultHeightMapScale", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultHeightMapScale"},
     {"title": "X3DNodes.DefaultVRML1CreaseAngle", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultVRML1CreaseAngle"},
     {"title": "X3DNodes.DefaultViewpointFieldOfView", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultViewpointFieldOfView"},
     {"title": "X3DNodes.DefaultNavigationInfoHeadlight", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultNavigationInfoHeadlight"},
     {"title": "X3DNodes.DefaultRenderedTextureWidth", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultRenderedTextureWidth"},
     {"title": "X3DNodes.DefaultRenderedTextureHeight", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultRenderedTextureHeight"},
     {"title": "X3DNodes.VRML1Version", "text": " ", "tags": "", "loc": "X3DNodes.html#VRML1Version"},
     {"title": "X3DNodes.VRML2Version", "text": " ", "tags": "", "loc": "X3DNodes.html#VRML2Version"},
     {"title": "X3DNodes.X3DVersion", "text": " ", "tags": "", "loc": "X3DNodes.html#X3DVersion"},
     {"title": "X3DNodes.xeClassic", "text": " ", "tags": "", "loc": "X3DNodes.html#xeClassic"},
     {"title": "X3DNodes.xeXML", "text": " ", "tags": "", "loc": "X3DNodes.html#xeXML"},
     {"title": "X3DNodes.MinTriangulationSlices", "text": "  <p>Note that <code>MinTriangulationSlices</code> can be lower (2), it works, but the result isn't really sensible.  ", "tags": "", "loc": "X3DNodes.html#MinTriangulationSlices"},
     {"title": "X3DNodes.MinTriangulationStacks", "text": " ", "tags": "", "loc": "X3DNodes.html#MinTriangulationStacks"},
     {"title": "X3DNodes.MinTriangulationDivisions", "text": " ", "tags": "", "loc": "X3DNodes.html#MinTriangulationDivisions"},
     {"title": "X3DNodes.VRML1StateClasses", "text": " ", "tags": "", "loc": "X3DNodes.html#VRML1StateClasses"},
     {"title": "X3DNodes.URNVRML97Nodes", "text": "  <p>Funny thing, I actually didn't found anywhere a definite official statement that they are using such-and-such URNs.  <p>X3D specification refers to RFC [<a  href=\"http://www.ietf.org/rfc/rfc3541.txt?number=3541\">http://www.ietf.org/rfc/rfc3541.txt?number=3541</a>] which, basically, just says &quot;we like URNs and we'll use them&quot; and nothing more. Same thing for VRML 97 spec [<a  href=\"http://www.web3d.org/x3d/specifications/vrml/ISO-IEC-14772-VRML97/part1/extensions.html\">http://www.web3d.org/x3d/specifications/vrml/ISO-IEC-14772-VRML97/part1/extensions.html</a>]. There is no precise answer e.g. what URN should be used to Indicate some standard VRML 97 / X3D node.  <p>I constructed URNs below looking at examples in the RFC, annotated by a funny line &quot;The following examples are not guaranteed to be real. They are presented for pedagogical reasons only.&quot;  <p> ", "tags": "", "loc": "X3DNodes.html#URNVRML97Nodes"},
     {"title": "X3DNodes.URNX3DNodes", "text": " ", "tags": "", "loc": "X3DNodes.html#URNX3DNodes"},
     {"title": "X3DNodes.URNBitManagementNodes", "text": " This should work, according to <a  href=\"http://www.bitmanagement.com/developer/contact/examples/layer/index.html\">http://www.bitmanagement.com/developer/contact/examples/layer/index.html</a> example EXTERNPROTO. ", "tags": "", "loc": "X3DNodes.html#URNBitManagementNodes"},
     {"title": "X3DNodes.DefaultAnimationPrefix", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultAnimationPrefix"},
     {"title": "X3DNodes.AllAccessTypes", "text": " ", "tags": "", "loc": "X3DNodes.html#AllAccessTypes"},
     {"title": "X3DNodes.RestrictedAccessTypes", "text": " ", "tags": "", "loc": "X3DNodes.html#RestrictedAccessTypes"},
     {"title": "X3DNodes.LoadX3DClassicInternal", "text": " Return it's root node.  <p>Note that you must pass here <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html\">TPeekCharStream</a> class, not just any generic TStream class. But it's not a problem, really, because you can wrap any class inside <a class=\"normal\" href=\"CastleClassUtils.TPeekCharStream.html\">TPeekCharStream</a> descendant. E.g. do </p>  <pre class=\"longcode\"> LoadX3DClassicInternal(TBufferedReadStream.Create(MyStream, false), BaseUrl)</pre>  <p>  <p>Note that this function can't handle compressed data (X3D files are sometimes compressed with gzip). You should pass here a stream with an already uncompressed text data.  <p>    EX3DGzipCompressed If the Stream starts with gzip file header.", "tags": "", "loc": "X3DNodes.html#LoadX3DClassicInternal"},
     {"title": "X3DNodes.LoadX3DClassicFromString", "text": " Return it's root node.     EX3DGzipCompressed If the Stream is compressed with gzip.", "tags": "", "loc": "X3DNodes.html#LoadX3DClassicFromString"},
     {"title": "X3DNodes.LoadX3DClassic", "text": "  <p>Automatically handles VRML/X3D files compressed with gzip, uncompressing them on the fly.  <p>URL without any protocol is treated as a filename (absolute or relative to current dir). We can also load network URLs using <a class=\"normal\" href=\"CastleDownload.html\">CastleDownload</a>.  <p>If AllowStdIn then URL = '-' is understood as &quot;standard input&quot; (<a class=\"normal\" href=\"CastleClassUtils.html#StdInStream\">StdInStream</a>). Base for resolving relative URLs in this case is the current working directory.  <p>If Gzipped then we can be relatively sure that stream is gzipped. Otherwise, it can still be gzipped (.wrl files are sometimes gzipped without extension indicating it).    ", "tags": "", "loc": "X3DNodes.html#LoadX3DClassic"},
     {"title": "X3DNodes.LoadX3DXml", "text": "  <p>Overloaded version that takes Stream as a parameter expects that reading the stream returns the uncompressed content (no longer gzip compressed). This version also takes URL as a parameter, but it is not used to load contents (these are inside Stream), it it only used to resolve relative URLs inside content and for error messages.  <p>    ", "tags": "", "loc": "X3DNodes.html#LoadX3DXml"},
     {"title": "X3DNodes.LoadX3DXml", "text": "    ", "tags": "", "loc": "X3DNodes.html#LoadX3DXml"},
     {"title": "X3DNodes.LoadX3DXml", "text": "    ", "tags": "", "loc": "X3DNodes.html#LoadX3DXml"},
     {"title": "X3DNodes.Save3DVersion", "text": "    ", "tags": "", "loc": "X3DNodes.html#Save3DVersion"},
     {"title": "X3DNodes.Save3D", "text": " Generates a complete file, with header lines (XML headers, or #VRML / #X3D in classic encoding) and everything.  <p>Overloaded version that takes an URL will automatically compress the file with gzip if an extension indicating gzip compression is present (like .x3dv.gz, or .x3d.gz).  <p>Generator and Source, if not empty, will be used to set appropriate META values of X3D root file node. This way you can indicate inside X3D file the generator (your program) name and source (original 3D model file name). If this is not an X3D root file node, we will record it inside a comment.  <p><b>Conversion to X3D:</b>  <p>When ForceConvertingToX3D or when Encoding &lt;&gt; <a class=\"normal\" href=\"X3DNodes.html#xeClassic\">xeClassic</a>, the node graph will be converted to X3D (if it isn't X3D already). This can be used to convert VRML 2.0 to X3D.  <p>This should not be used if the original file version (recorded in Node) indicates that it's an old VRML 1.0 or Inventor file, as we have not implemented convertion from VRML 1.0/Inventor to X3D. So it wil result in VRML 1.0/Inventor nodes saved using the X3D (XML or classic) encoding, which is not a format supported by any X3D reader (even our own).  <p>Note that converting VRML 2.0 to X3D will change the nodes graph in-place, possibly removing some nodes. If you use <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, you should call <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#BeforeNodesFree\">TCastleSceneCore.BeforeNodesFree</a> before such operation, and <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#ChangedAll\">TCastleSceneCore.ChangedAll</a> afterwards. (You can easily test whether they will be needed by <a class=\"normal\" href=\"X3DNodes.html#Save3DWillConvertToX3D\">Save3DWillConvertToX3D</a>).  <p>If you use Encoding=<a class=\"normal\" href=\"X3DNodes.html#xeClassic\">xeClassic</a> and ForceConvertingToX3D=false, no conversion will ever happen.  <p>  <p>  Version Which VRML/X3D specification version should be used to encode. It should be calculated by <a class=\"normal\" href=\"X3DNodes.html#Save3DVersion\">Save3DVersion</a>(Node). You often want to calculate it yourself, before calling <a class=\"normal\" href=\"X3DNodes.html#Save3D\">Save3D</a>, this way you can propose a sensible saved model extension for user (.wrl for VRML &lt;= 2.0 in classic encoding, .x3dv for X3D in classic encoding).  <p>Note that <i>this parameter is <b>not</b> a mechanism to convert between various VRML/X3D versions</i>. This procedure does not convert VRML/X3D nodes/fields inside. For example, you can't just change Version.Major value from 1 to 3 to convert VRML 1.0 to X3D. It would cause some information to be encoded in X3D style (e.g. generated file will have X3D header and PROFILE information), but the nodes would stil have VRML 1.0 names and fields. Which means that you would not generate correct X3D file.  <p>So this should really be calculated based on model contents, usually by <a class=\"normal\" href=\"X3DNodes.html#Save3DVersion\">Save3DVersion</a>(Node).  <p>A limited VRML 2.0 conversion is possible by ForceConvertingToX3D = true. In this case, Version will be automatically changed to X3D anyway.  Version Which VRML/X3D specification version should be used to encode. It should be calculated by <a class=\"normal\" href=\"X3DNodes.html#Save3DVersion\">Save3DVersion</a>(Node). You often want to calculate it yourself, before calling <a class=\"normal\" href=\"X3DNodes.html#Save3D\">Save3D</a>, this way you can propose a sensible saved model extension for user (.wrl for VRML &lt;= 2.0 in classic encoding, .x3dv for X3D in classic encoding).  <p>Note that <i>this parameter is <b>not</b> a mechanism to convert between various VRML/X3D versions</i>. This procedure does not convert VRML/X3D nodes/fields inside. For example, you can't just change Version.Major value from 1 to 3 to convert VRML 1.0 to X3D. It would cause some information to be encoded in X3D style (e.g. generated file will have X3D header and PROFILE information), but the nodes would stil have VRML 1.0 names and fields. Which means that you would not generate correct X3D file.  <p>So this should really be calculated based on model contents, usually by <a class=\"normal\" href=\"X3DNodes.html#Save3DVersion\">Save3DVersion</a>(Node).  <p>A limited VRML 2.0 conversion is possible by ForceConvertingToX3D = true. In this case, Version will be automatically changed to X3D anyway.", "tags": "", "loc": "X3DNodes.html#Save3D"},
     {"title": "X3DNodes.Save3D", "text": "    ", "tags": "", "loc": "X3DNodes.html#Save3D"},
     {"title": "X3DNodes.Save3D", "text": "    ", "tags": "", "loc": "X3DNodes.html#Save3D"},
     {"title": "X3DNodes.Save3D", "text": "    ", "tags": "", "loc": "X3DNodes.html#Save3D"},
     {"title": "X3DNodes.Save3D", "text": "    ", "tags": "", "loc": "X3DNodes.html#Save3D"},
     {"title": "X3DNodes.Save3DWillConvertToX3D", "text": "    ", "tags": "", "loc": "X3DNodes.html#Save3DWillConvertToX3D"},
     {"title": "X3DNodes.X3DNodeList_FreeUnusedAndNil", "text": "    ", "tags": "", "loc": "X3DNodes.html#X3DNodeList_FreeUnusedAndNil"},
     {"title": "X3DNodes.KeyRange", "text": " Returns the index of <b>right</b> range delimiter. So for normal ranges (between two values of &quot;key&quot; field) it's always between 1 and FdKey.Count - 1. Result 0 indicates we're before the left limit, and result equal FdKey.Count indicates we're after right limit.  <p>Result is always between 0 and FdKey.Count.  <p>Output T is the value between 0..1 indicating where within the range we are. It's undefined when Result is 0 or Key.Count (indicating we're outside limits).  <p>Call this only when FdKey.Count &gt; 0.  <p>This is useful to interpreting TAbstractInterpolatorNode.KeyRange and such fields.    ", "tags": "", "loc": "X3DNodes.html#KeyRange"},
     {"title": "X3DNodes.FreeIfUnusedAndNil", "text": " Analogous to standard FreeAndNil, but checks if node is used first.    ", "tags": "", "loc": "X3DNodes.html#FreeIfUnusedAndNil"},
     {"title": "X3DNodes.URNMatchingCastle", "text": " This is a helper for implementing <a class=\"normal\" href=\"X3DNodes.TX3DNode.html#URNMatching\">TX3DNode.URNMatching</a>.    ", "tags": "", "loc": "X3DNodes.html#URNMatchingCastle"},
     {"title": "X3DNodes.TX3DNodeClass", "text": " ", "tags": "", "loc": "X3DNodes.html#TX3DNodeClass"},
     {"title": "X3DNodes.TX3DNodeProc", "text": "    ", "tags": "", "loc": "X3DNodes.html#TX3DNodeProc"},
     {"title": "X3DNodes.TX3DNodeSearchProc", "text": "    ", "tags": "", "loc": "X3DNodes.html#TX3DNodeSearchProc"},
     {"title": "X3DNodes.PTraversingInfo", "text": " ", "tags": "", "loc": "X3DNodes.html#PTraversingInfo"},
     {"title": "X3DNodes.TTraversingFunc", "text": "    ", "tags": "", "loc": "X3DNodes.html#TTraversingFunc"},
     {"title": "X3DNodes.TTraversingAfterFunc", "text": "    ", "tags": "", "loc": "X3DNodes.html#TTraversingAfterFunc"},
     {"title": "X3DNodes.TEnumerateChildrenFunction", "text": "    ", "tags": "", "loc": "X3DNodes.html#TEnumerateChildrenFunction"},
     {"title": "X3DNodes.TEnumerateReplaceNodesFunction", "text": "    ", "tags": "", "loc": "X3DNodes.html#TEnumerateReplaceNodesFunction"},
     {"title": "X3DNodes.TX3DAccessType", "text": "  atInputOnly    atOutputOnly    atInitializeOnly    atInputOutput   ", "tags": "", "loc": "X3DNodes.html#TX3DAccessType"},
     {"title": "X3DNodes.TX3DAccessTypes", "text": " ", "tags": "", "loc": "X3DNodes.html#TX3DAccessTypes"},
     {"title": "X3DNodes.TNodeTransformationChange", "text": "  ntcNone    ntcSwitch <a class=\"normal\" href=\"X3DNodes.TSwitchNode.html\">TSwitchNode</a>   ntcLOD <a class=\"normal\" href=\"X3DNodes.TAbstractLODNode.html\">TAbstractLODNode</a>   ntcTransform <a class=\"normal\" href=\"X3DNodes.ITransformNode.html\">ITransformNode</a>   ntcGeometry <a class=\"normal\" href=\"X3DNodes.TAbstractGeometryNode.html\">TAbstractGeometryNode</a>   ntcBackground <a class=\"normal\" href=\"X3DNodes.TAbstractBackgroundNode.html\">TAbstractBackgroundNode</a>   ntcFog <a class=\"normal\" href=\"X3DNodes.TFogNode.html\">TFogNode</a>   ntcViewpoint <a class=\"normal\" href=\"X3DNodes.TAbstractViewpointNode.html\">TAbstractViewpointNode</a>   ntcLight <a class=\"normal\" href=\"X3DNodes.TAbstractLightNode.html\">TAbstractLightNode</a>   ntcProximitySensor <a class=\"normal\" href=\"X3DNodes.TProximitySensorNode.html\">TProximitySensorNode</a>   ntcVisibilitySensor <a class=\"normal\" href=\"X3DNodes.TVisibilitySensorNode.html\">TVisibilitySensorNode</a>  ", "tags": "", "loc": "X3DNodes.html#TNodeTransformationChange"},
     {"title": "X3DNodes.TX3DVersion", "text": " ", "tags": "", "loc": "X3DNodes.html#TX3DVersion"},
     {"title": "X3DNodes.TX3DEncoding", "text": " ", "tags": "", "loc": "X3DNodes.html#TX3DEncoding"},
     {"title": "X3DNodes.TVRML1StateNode", "text": "  vsCoordinate3    vsShapeHints    vsFontStyle    vsMaterial    vsMaterialBinding    vsNormal    vsNormalBinding    vsTexture2    vsTextureCoordinate2   ", "tags": "", "loc": "X3DNodes.html#TVRML1StateNode"},
     {"title": "X3DNodes.PLightInstance", "text": " ", "tags": "", "loc": "X3DNodes.html#PLightInstance"},
     {"title": "X3DNodes.PClipPlane", "text": " ", "tags": "", "loc": "X3DNodes.html#PClipPlane"},
     {"title": "X3DNodes.TNodeDestructionNotification", "text": "  <p>This file is part of &quot;Castle Game Engine&quot;.  <p>&quot;Castle Game Engine&quot; is free software; see the file COPYING.txt, included in this distribution, for details about the copyright.  <p>&quot;Castle Game Engine&quot; is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  <p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;-    ", "tags": "", "loc": "X3DNodes.html#TNodeDestructionNotification"},
     {"title": "X3DNodes.TTextureUpdate", "text": "  upNone    upNextFrameOnly    upAlways   ", "tags": "", "loc": "X3DNodes.html#TTextureUpdate"},
     {"title": "X3DNodes.TAllowedChildren", "text": "  <p>This file is part of &quot;Castle Game Engine&quot;.  <p>&quot;Castle Game Engine&quot; is free software; see the file COPYING.txt, included in this distribution, for details about the copyright.  <p>&quot;Castle Game Engine&quot; is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  <p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;-  acAll    acClasses    acInterface   ", "tags": "", "loc": "X3DNodes.html#TAllowedChildren"},
     {"title": "X3DNodes.TTimeFunction", "text": "    ", "tags": "", "loc": "X3DNodes.html#TTimeFunction"},
     {"title": "X3DNodes.TGroupNode_2", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.html#TGroupNode_2"},
     {"title": "X3DNodes.TSwitchNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TSwitchNode_2"},
     {"title": "X3DNodes.TTransformNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TTransformNode_2"},
     {"title": "X3DNodes.TCoordRangeHandler", "text": "    ", "tags": "", "loc": "X3DNodes.html#TCoordRangeHandler"},
     {"title": "X3DNodes.TIndexedPolygonHandler", "text": "    ", "tags": "", "loc": "X3DNodes.html#TIndexedPolygonHandler"},
     {"title": "X3DNodes.TAbstractX3DGeometryNode", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.html#TAbstractX3DGeometryNode"},
     {"title": "X3DNodes.TIndexedLineSetNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TIndexedLineSetNode_2"},
     {"title": "X3DNodes.TPointSetNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TPointSetNode_2"},
     {"title": "X3DNodes.TShading", "text": "  shDefault    shGouraud    shPhong    shWireframe   ", "tags": "", "loc": "X3DNodes.html#TShading"},
     {"title": "X3DNodes.TLineType", "text": "  ltSolid    ltDashed    ltDotted    ltDashedDotted    ltDashDotDot   ", "tags": "", "loc": "X3DNodes.html#TLineType"},
     {"title": "X3DNodes.TX3DMaterialInfoAbstract", "text": " ", "tags": "", "loc": "X3DNodes.html#TX3DMaterialInfoAbstract"},
     {"title": "X3DNodes.TMaterialNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TMaterialNode_2"},
     {"title": "X3DNodes.TConeNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TConeNode_2"},
     {"title": "X3DNodes.TCylinderNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TCylinderNode_2"},
     {"title": "X3DNodes.TIndexedFaceSetNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TIndexedFaceSetNode_2"},
     {"title": "X3DNodes.TSphereNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TSphereNode_2"},
     {"title": "X3DNodes.TX3DFontFamily", "text": "  ffSerif    ffSans    ffTypeWriter   ", "tags": "", "loc": "X3DNodes.html#TX3DFontFamily"},
     {"title": "X3DNodes.TX3DFontJustify", "text": "  fjFirst    fjBegin    fjMiddle    fjEnd   ", "tags": "", "loc": "X3DNodes.html#TX3DFontJustify"},
     {"title": "X3DNodes.TFontStyleNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TFontStyleNode_2"},
     {"title": "X3DNodes.TLightScope", "text": "  lsGlobal Light shines everywhere.  VRML/X3D &gt;= 2 calls these lights global.  lsLocal Light shines only within it's VRML/X3D grouping node.  VRML/X3D &gt;= 2 calls these lights not global.  lsLocalVRML1 Light shines only on the following shapes within it's VRML/X3D grouping node.  This is used by VRML 1.0 (and Inventor) light sources. ", "tags": "", "loc": "X3DNodes.html#TLightScope"},
     {"title": "X3DNodes.TDirectionalLightNode_2", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.html#TDirectionalLightNode_2"},
     {"title": "X3DNodes.TPointLightNode_2", "text": "  <p>Do not edit this file manually! To add new properties: - add them to the text files in nodes_specification/components/ , - and regenerate include files by running nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr .  <p>The documentation for properties should go to x3dnodes_documentation.txt . ", "tags": "", "loc": "X3DNodes.html#TPointLightNode_2"},
     {"title": "X3DNodes.TSpotLightNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TSpotLightNode_2"},
     {"title": "X3DNodes.TX3DViewpointClassNode", "text": " ", "tags": "", "loc": "X3DNodes.html#TX3DViewpointClassNode"},
     {"title": "X3DNodes.TLODNode_3", "text": " ", "tags": "", "loc": "X3DNodes.html#TLODNode_3"},
     {"title": "X3DNodes.TOptionalBlendingSort", "text": "  obsDefault    obsNone    obs2D    obs3D   ", "tags": "", "loc": "X3DNodes.html#TOptionalBlendingSort"},
     {"title": "X3DNodes.TBackgroundSide", "text": "  bsBack    bsBottom    bsFront    bsLeft    bsRight    bsTop   ", "tags": "", "loc": "X3DNodes.html#TBackgroundSide"},
     {"title": "X3DNodes.TFogTypeOrNone", "text": "  ftLinear    ftExp    ftNone   ", "tags": "", "loc": "X3DNodes.html#TFogTypeOrNone"},
     {"title": "X3DNodes.TFogType", "text": " ", "tags": "", "loc": "X3DNodes.html#TFogType"},
     {"title": "X3DNodes.PVertexJoints", "text": " ", "tags": "", "loc": "X3DNodes.html#PVertexJoints"},
     {"title": "X3DNodes.TVertexJointsList", "text": " ", "tags": "", "loc": "X3DNodes.html#TVertexJointsList"},
     {"title": "X3DNodes.TNurbsCurveNode_3", "text": " ", "tags": "", "loc": "X3DNodes.html#TNurbsCurveNode_3"},
     {"title": "X3DNodes.TNurbsPositionInterpolatorNode_3", "text": " ", "tags": "", "loc": "X3DNodes.html#TNurbsPositionInterpolatorNode_3"},
     {"title": "X3DNodes.TScriptType", "text": "  stCompiled    stCastleScript   ", "tags": "", "loc": "X3DNodes.html#TScriptType"},
     {"title": "X3DNodes.TShaderLanguage", "text": "  slDefault    slCG    slGLSL    slHLSL   ", "tags": "", "loc": "X3DNodes.html#TShaderLanguage"},
     {"title": "X3DNodes.TSceneOctreeProperties", "text": "  opRendering    opDynamicCollisions    opVisibleTriangles    opStaticCollisions   ", "tags": "", "loc": "X3DNodes.html#TSceneOctreeProperties"},
     {"title": "X3DNodes.TMatrixTransformNode_2", "text": " ", "tags": "", "loc": "X3DNodes.html#TMatrixTransformNode_2"},
     {"title": "X3DNodes.PX3DNodeNameRec", "text": " ", "tags": "", "loc": "X3DNodes.html#PX3DNodeNameRec"},
     {"title": "X3DNodes.EX3DGzipCompressed", "text": " ", "tags": "", "loc": "X3DNodes.html#EX3DGzipCompressed"},
     {"title": "X3DNodes.NodesManager", "text": " In normal circumstances, this is the only instance of <a class=\"normal\" href=\"X3DNodes.TNodesManager.html\">TNodesManager</a> class ever created. It is created / destroyed in this unit's initialization / finalization. ", "tags": "", "loc": "X3DNodes.html#NodesManager"},
     {"title": "X3DNodes.DefaultTriangulationSlices", "text": "  <p>&quot;Slices&quot; divide the circumference of the circle, like the slices of a pizza. &quot;Stacks&quot; divide the height of the object, like the stacks of a cake or tower. These are used for quadrics - cylinder, cone, sphere and disk.  <p>&quot;Divisions&quot; divide the cube side. This is beneficial for better Gouraud shading.  <p>You can change these variables only <i>before using anything</i> from this module. If you want to change them inside VRML/X3D file (for example, to affect only part of the scene), use the Triangulation node, see <a  href=\"http://castle-engine.sourceforge.net/x3d_implementation_geometry3d_extensions.php#section_triangulation\">http://castle-engine.sourceforge.net/x3d_implementation_geometry3d_extensions.php#section_triangulation</a>  <p>These variables <i>must</i> always honour <a class=\"normal\" href=\"X3DNodes.html#MinTriangulationSlices\">MinTriangulationSlices</a>, <a class=\"normal\" href=\"X3DNodes.html#MinTriangulationStacks\">MinTriangulationStacks</a>, <a class=\"normal\" href=\"X3DNodes.html#MinTriangulationDivisions\">MinTriangulationDivisions</a> limits.  <p> ", "tags": "", "loc": "X3DNodes.html#DefaultTriangulationSlices"},
     {"title": "X3DNodes.DefaultTriangulationStacks", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultTriangulationStacks"},
     {"title": "X3DNodes.DefaultTriangulationDivisions", "text": " ", "tags": "", "loc": "X3DNodes.html#DefaultTriangulationDivisions"},
     {"title": "X3DNodes.AnyNodeDestructionNotifications", "text": " ", "tags": "", "loc": "X3DNodes.html#AnyNodeDestructionNotifications"},
     {"title": "X3DNodes.X3DCache", "text": " ", "tags": "", "loc": "X3DNodes.html#X3DCache"},
     {"title": "X3DNodes.WarnAboutAbsoluteFilenames", "text": " The warning is emitted using <a class=\"normal\" href=\"CastleLog.html#WritelnWarning\">WritelnWarning</a>. This is quite useful, as usually you want to avoid using such URIs, as they will probably not work on any other system than your own (and they prevent you from easily moving the files to some other system/location).  <p>In your data (X3D, VRML, Collada, OBJ materials...), you should always use relative paths. ", "tags": "", "loc": "X3DNodes.html#WarnAboutAbsoluteFilenames"},
     {"title": "X3DTime", "text": " ", "tags": "", "loc": "X3DTime.html"},
     {"title": "X3DTime.TX3DTime", "text": " For most purposes, you're interested only in it's <a class=\"normal\" href=\"X3DTime.TX3DTime.html#Seconds\">Seconds</a> field, this is the amount of continous time that passed (in double-precision seconds).  <p>More precisely, timestamp is actually a sum of <i>Seconds + <a class=\"normal\" href=\"X3DTime.TX3DTime.html#PlusTicks\">PlusTicks</a> ticks</i>. <a class=\"normal\" href=\"X3DTime.TX3DTime.html#PlusTicks\">PlusTicks</a> is the number of discrete &quot;ticks&quot; that occurred with the same Seconds value. A tick is, conceptually, an infinitely small amount of time.  <p>Ticks are used when comparing time values: when two timestamps have the same <a class=\"normal\" href=\"X3DTime.TX3DTime.html#Seconds\">Seconds</a> value, then we can compare the <a class=\"normal\" href=\"X3DTime.TX3DTime.html#PlusTicks\">PlusTicks</a> field. Timestamps are equal only when both Seconds and <a class=\"normal\" href=\"X3DTime.TX3DTime.html#PlusTicks\">PlusTicks</a> values are exactly equal.  <p>The practical justification of <a class=\"normal\" href=\"X3DTime.TX3DTime.html#PlusTicks\">PlusTicks</a> usage:  <p></p>  <ol class=\"paragraph_spacing\">   <li value=\"1\"><p>First, note that X3D standard defines that within one timestamp, only one event may pass through one route. This mechanism allows to avoid loops in routes.</p></li>   <li value=\"2\"><p>Now note that when using <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a>, Seconds is increased by <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#IncreaseTime\">TCastleSceneCore.IncreaseTime</a>. <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> doesn't require how often should IncreaseTime be called, in particular you can call multiple times <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Press\">TCastleSceneCore.Press</a>, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Release\">TCastleSceneCore.Release</a>, <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#PointingDeviceMove\">TCastleSceneCore.PointingDeviceMove</a> without continously updating time. You can even not update time at all, and still call <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Press\">TCastleSceneCore.Press</a> and such.  <p>This is a good thing &mdash; it allows <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html\">TCastleSceneCore</a> to be very flexible. The idea is that sensors are activated when user interface reports some event. You don't have to update time before every <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Press\">TCastleSceneCore.Press</a> and such.</p></li>   <li value=\"3\"><p>The potential problem here is that when you call <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Press\">TCastleSceneCore.Press</a> twice, without the <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#IncreaseTime\">TCastleSceneCore.IncreaseTime</a> in between, then the second <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Press\">TCastleSceneCore.Press</a> events will have &quot;clogged&quot; routes. Events send from the second <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Press\">TCastleSceneCore.Press</a> may be blocked on routes, since they will be detected as occuring within the same timestamp, so (following VRML/X3D standard) they'll have to be ignored.</p></li>   <li value=\"4\"><p>Using &quot;Seconds seconds + <a class=\"normal\" href=\"X3DTime.TX3DTime.html#PlusTicks\">PlusTicks</a> ticks&quot; allows to avoid this. Each <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Press\">TCastleSceneCore.Press</a> and such increases world time by 1 tick &ndash; this way, the second <a class=\"normal\" href=\"CastleSceneCore.TCastleSceneCore.html#Press\">TCastleSceneCore.Press</a> will have one more tick, so will always be considered later, and things will work Ok.</p></li> </ol>  <p> ", "tags": "", "loc": "X3DTime.TX3DTime.html"},
     {"title": "X3DTime.TX3DTime.Seconds", "text": " ", "tags": "", "loc": "X3DTime.TX3DTime.html#Seconds"},
     {"title": "X3DTime.TX3DTime.PlusTicks", "text": " ", "tags": "", "loc": "X3DTime.TX3DTime.html#PlusTicks"},
     {"title": "X3DTime.TX3DTime.Oldest", "text": "    ", "tags": "", "loc": "X3DTime.TX3DTime.html#Oldest"},
     {"title": "X3DTime.TX3DTime.>", "text": "    ", "tags": "", "loc": "X3DTime.TX3DTime.html#>"},
     {"title": "X3DTime.TX3DTime.>=", "text": "    ", "tags": "", "loc": "X3DTime.TX3DTime.html#>="},
     {"title": "X3DTime.TX3DTime.<", "text": "    ", "tags": "", "loc": "X3DTime.TX3DTime.html#<"},
     {"title": "X3DTime.TX3DTime.<=", "text": "    ", "tags": "", "loc": "X3DTime.TX3DTime.html#<="},
     {"title": "X3DTime.OldestX3DTime", "text": " ", "tags": "", "loc": "X3DTime.html#OldestX3DTime"},
     {"title": "X3DTime.PX3DTime", "text": " ", "tags": "", "loc": "X3DTime.html#PX3DTime"},
     {"title": "X3DTime.TFloatTime", "text": " ", "tags": "", "loc": "X3DTime.html#TFloatTime"},
     {"title": "X3DTime.TX3DTimeList", "text": " ", "tags": "", "loc": "X3DTime.html#TX3DTimeList"},
     {"title": "X3DTriangles", "text": " ", "tags": "", "loc": "X3DTriangles.html"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode", "text": " ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonSphere", "text": " They take care of traversing down the non-leaf nodes, you only have to override the CommonXxxLeaf versions where you handle the leaves (and you have to call CommonXxx from normal Xxx routines).    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonSphere"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonSphereLeaf", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonSphereLeaf"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonSphere2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonSphere2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonSphere2DLeaf", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonSphere2DLeaf"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonPoint2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonPoint2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonPoint2DLeaf", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonPoint2DLeaf"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonBox", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonBox"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonBoxLeaf", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonBoxLeaf"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonSegment", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonSegment"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonSegmentLeaf", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonSegmentLeaf"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonRay", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonRay"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.CommonRayLeaf", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#CommonRayLeaf"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.SphereCollision", "text": "  <p>Note that methods here do not try to limit detected intersections to their boxes. If you will insert a large triangle into a node, that is partially inside and partially outside of this node, the collision methods may find an intersection outside of this node.  <p>This is not be a problem for a root node, since the root node has a box such that every triangle is completely inside. But it is important to remember when you implement recursive *Collision calls in nodes: if you want to query your subnodes in some particular order (for example to honour ReturnClosestIntersection = <code>True</code>), then remember that one subnode may detect a collision that in fact happened in other subnode.  <p>    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#SphereCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.IsSphereCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#IsSphereCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.SphereCollision2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#SphereCollision2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.IsSphereCollision2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#IsSphereCollision2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.PointCollision2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#PointCollision2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.IsPointCollision2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#IsPointCollision2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.BoxCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#BoxCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.IsBoxCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#IsBoxCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.SegmentCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#SegmentCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.IsSegmentCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#IsSegmentCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.RayCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#RayCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctreeNode.IsRayCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctreeNode.html#IsRayCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree", "text": "  <p>Octree node class used by this must be a <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctreeNode.html\">TBaseTrianglesOctreeNode</a> descendant.  <p>In a simple case, this is an ancestor of TTriangleOctree, that is just an octree storing <a class=\"normal\" href=\"CastleTriangles.TTriangle.html\">TTriangle</a>. But it's also an ancestor of TShapeOctree, since each shape has also a triangle octree. This way, TShapeOctree can calculate collisions with <a class=\"normal\" href=\"CastleTriangles.TTriangle.html\">TTriangle</a>, even though it doesn't directly store <a class=\"normal\" href=\"CastleTriangles.TTriangle.html\">TTriangle</a> items. ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.SegmentCollision", "text": "  <p><a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision\">SegmentCollision</a> checks for collision between a line segment and tree items.  <p><a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SphereCollision\">SphereCollision</a> checks for collision with a sphere.  <p><a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#BoxCollision\">BoxCollision</a> checks for collision with a box (axis-aligned, <a class=\"normal\" href=\"CastleBoxes.TBox3D.html\">TBox3D</a> type).  <p><a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a> checks for collision with a ray.  <p>All there methods return nil if there is no collision, or a pointer to colliding item.  <p>  <p>  <p>  <p>  <p>  <p>  ReturnClosestIntersection <p>If <code>False</code>, then any collision detected is returned. For routines that don't have ReturnClosestIntersection parameter (<a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SphereCollision\">SphereCollision</a>, <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#BoxCollision\">BoxCollision</a>) always any collision is returned.  <p>If this is <code>True</code>, then the collision closest to RayOrigin (for <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a>) or Pos1 (for <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision\">SegmentCollision</a>) is returned. This makes the collision somewhat slower (as we have to check all collisions, while for ReturnClosestIntersection = <code>False</code> we can terminate at first collision found.)  <p>The versions that return boolean value (IsXxxCollision) don't take this parameter, as they are naturally interested in existence of <i>any</i> intersection. TriangleToIgnore <p>If this is non-nil, then Segment/<a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a> assume that there is <i>never</i> a collision with this octree item. It's never returned as collidable item.  <p>This is useful for recursive ray-tracer, when you start tracing from some existing face (octree item). In this case, you don't want to &quot;hit&quot; the starting face. So you can pass this face as TriangleToIgnore.  <p>Note that IgnoreMarginAtStart helps with the same problem, although a little differently. TrianglesToIgnoreFunc <p>If assigned, then items for which TrianglesToIgnoreFunc returns <code>True</code> will be ignored. This is a more general mechanism than TriangleToIgnore, as you can ignore many items, you can also make some condition to ignore &mdash; for example, you can ignore partially transparent items. IgnoreMarginAtStart <p>If <code>True</code>, then collisions that happen very very close to RayOrigin (or Pos1 for <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision\">SegmentCollision</a>) will be ignored.  <p>This is another thing helpful for recursive ray-tracers: you don't want to hit the starting face, or any coplanar faces, when tracing reflected/refracted/shadow ray.  <p>Note that if you know actual pointer of your face, it's better to use TriangleToIgnore &mdash; TriangleToIgnore is a 100% guaranteed stable solution, while IgnoreMarginAtStart necessarily has some &quot;epsilon&quot; constant that determines which items are ignored. This epsilon may be too large, or too small, in some cases.  <p>In practice, recursive ray-tracers should use both TriangleToIgnore (to avoid collisions with starting face) and IgnoreMarginAtStart = <code>True</code> (to avoid collisions with faces coplanar with starting face). IntersectionDistance For <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a>: Returned IntersectionDistance is the distance along the RayDirection: smaller IntersectionDistance, closer to RayOrigin. IntersectionDistance is always &gt;= 0. Intersection is always equal to RayOrigin + RayDirection * IntersectionDistance.  <p>For <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision\">SegmentCollision</a>: analogously, IntersectionDistance is along Pos2 - Pos1. IntersectionDistance is always in 0...1. Intersectio is always equal to Pos1 + (Pos2 - Pos1) * IntersectionDistance.  ReturnClosestIntersection <p>If <code>False</code>, then any collision detected is returned. For routines that don't have ReturnClosestIntersection parameter (<a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SphereCollision\">SphereCollision</a>, <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#BoxCollision\">BoxCollision</a>) always any collision is returned.  <p>If this is <code>True</code>, then the collision closest to RayOrigin (for <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a>) or Pos1 (for <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision\">SegmentCollision</a>) is returned. This makes the collision somewhat slower (as we have to check all collisions, while for ReturnClosestIntersection = <code>False</code> we can terminate at first collision found.)  <p>The versions that return boolean value (IsXxxCollision) don't take this parameter, as they are naturally interested in existence of <i>any</i> intersection. TriangleToIgnore <p>If this is non-nil, then Segment/<a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a> assume that there is <i>never</i> a collision with this octree item. It's never returned as collidable item.  <p>This is useful for recursive ray-tracer, when you start tracing from some existing face (octree item). In this case, you don't want to &quot;hit&quot; the starting face. So you can pass this face as TriangleToIgnore.  <p>Note that IgnoreMarginAtStart helps with the same problem, although a little differently. TrianglesToIgnoreFunc <p>If assigned, then items for which TrianglesToIgnoreFunc returns <code>True</code> will be ignored. This is a more general mechanism than TriangleToIgnore, as you can ignore many items, you can also make some condition to ignore &mdash; for example, you can ignore partially transparent items. IgnoreMarginAtStart <p>If <code>True</code>, then collisions that happen very very close to RayOrigin (or Pos1 for <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision\">SegmentCollision</a>) will be ignored.  <p>This is another thing helpful for recursive ray-tracers: you don't want to hit the starting face, or any coplanar faces, when tracing reflected/refracted/shadow ray.  <p>Note that if you know actual pointer of your face, it's better to use TriangleToIgnore &mdash; TriangleToIgnore is a 100% guaranteed stable solution, while IgnoreMarginAtStart necessarily has some &quot;epsilon&quot; constant that determines which items are ignored. This epsilon may be too large, or too small, in some cases.  <p>In practice, recursive ray-tracers should use both TriangleToIgnore (to avoid collisions with starting face) and IgnoreMarginAtStart = <code>True</code> (to avoid collisions with faces coplanar with starting face). IntersectionDistance For <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a>: Returned IntersectionDistance is the distance along the RayDirection: smaller IntersectionDistance, closer to RayOrigin. IntersectionDistance is always &gt;= 0. Intersection is always equal to RayOrigin + RayDirection * IntersectionDistance.  <p>For <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision\">SegmentCollision</a>: analogously, IntersectionDistance is along Pos2 - Pos1. IntersectionDistance is always in 0...1. Intersectio is always equal to Pos1 + (Pos2 - Pos1) * IntersectionDistance.", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.SegmentCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.SegmentCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.SegmentCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.IsSegmentCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#IsSegmentCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.SphereCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#SphereCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.IsSphereCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#IsSphereCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.SphereCollision2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#SphereCollision2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.IsSphereCollision2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#IsSphereCollision2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.PointCollision2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#PointCollision2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.IsPointCollision2D", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#IsPointCollision2D"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.BoxCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#BoxCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.IsBoxCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#IsBoxCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.RayCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#RayCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.RayCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#RayCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.RayCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#RayCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.RayCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#RayCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.IsRayCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#IsRayCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.MoveCollision", "text": " This is the perfect (precise, using triangle mesh, and fast) implementation of T3D.MoveCollision interface.  <p>TriangleToIgnore and TrianglesToIgnoreFunc meaning is just like for <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a>. This can be used to allow camera to walk thorugh some surfaces (e.g. through water surface, or to allow player to walk through some &quot;fake wall&quot; and discover secret room in game etc.).    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#MoveCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.MoveCollision", "text": "    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#MoveCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.HeightCollision", "text": " This is comfortable for cooperation with <a class=\"normal\" href=\"CastleCameras.TWalkCamera.html#OnHeight\">TWalkCamera.OnHeight</a>.  <p>See T3D.Height for specification.  <p>TriangleToIgnore and TrianglesToIgnoreFunc meaning is just like for <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a>.    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#HeightCollision"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.IgnoreTransparentItem", "text": "  <p>This is suitable for <a class=\"normal\" href=\"CastleTriangles.html#TTriangleIgnoreFunc\">TTriangleIgnoreFunc</a> function, you can pass this to <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a> and such.    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#IgnoreTransparentItem"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.IgnoreForShadowRays", "text": "  <p>This is suitable for <a class=\"normal\" href=\"CastleTriangles.html#TTriangleIgnoreFunc\">TTriangleIgnoreFunc</a> function, you can pass this to <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#RayCollision\">RayCollision</a> and such.    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#IgnoreForShadowRays"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.LightNotBlocked", "text": "  <p>&quot;Lights at scene&quot; means that the light is turned on (field &quot;on&quot; is <code>True</code>) and between light source and a LightedPoint nothing blocks the light (we check it by querying collisions using the octree, ignoring transparent and non-shadow-casting triangles), and the light source is on the same side of LightedPointPlane as RenderDir.  <p>TriangleToIgnore and IgnoreMarginAtStart work just like for <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#SegmentCollision\">SegmentCollision</a>. You should usually set TriangleToIgnore to the triangle containing your LightedPoint and IgnoreMarginAtStart to <code>True</code>, to avoid detecting point as shadowing itself.    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#LightNotBlocked"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.EnumerateTriangles", "text": "  <p>It passes to EnumerateTriangleFunc callback a Triangle. Triangle is passed as a pointer (never <code>Nil</code>) &mdash; these are guaranteed to be &quot;stable&quot; pointers stored inside octrees' lists (so they will be valid as long as octree (and eventual children octrees for TShapeOctree)).  <p>Every triangle is guaranteed to have it's World coordinates updated (to put it simply, when this is used on TShapeOctree, then we call UpdateWorld on each triangle).    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#EnumerateTriangles"},
     {"title": "X3DTriangles.TBaseTrianglesOctree.TrianglesCount", "text": " This counts all triangles returned by <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html#EnumerateTriangles\">EnumerateTriangles</a>.    ", "tags": "", "loc": "X3DTriangles.TBaseTrianglesOctree.html#TrianglesCount"},
     {"title": "X3DTriangles.TOctreeIgnoreForShadowRaysAndOneItem", "text": " Useful for TrianglesToIgnoreFunc parameters of various <a class=\"normal\" href=\"X3DTriangles.TBaseTrianglesOctree.html\">TBaseTrianglesOctree</a> methods. ", "tags": "", "loc": "X3DTriangles.TOctreeIgnoreForShadowRaysAndOneItem.html"},
     {"title": "X3DTriangles.TOctreeIgnoreForShadowRaysAndOneItem.OneItem", "text": " ", "tags": "", "loc": "X3DTriangles.TOctreeIgnoreForShadowRaysAndOneItem.html#OneItem"},
     {"title": "X3DTriangles.TOctreeIgnoreForShadowRaysAndOneItem.IgnoreItem", "text": "    ", "tags": "", "loc": "X3DTriangles.TOctreeIgnoreForShadowRaysAndOneItem.html#IgnoreItem"},
     {"title": "X3DTriangles.TOctreeIgnoreForShadowRaysAndOneItem.Create", "text": "    ", "tags": "", "loc": "X3DTriangles.TOctreeIgnoreForShadowRaysAndOneItem.html#Create"},
     {"title": "X3DTriangles.TCollisionCount", "text": " ", "tags": "", "loc": "X3DTriangles.html#TCollisionCount"},
     {"title": "X3DTriangles.TEnumerateTriangleFunc", "text": "    ", "tags": "", "loc": "X3DTriangles.html#TEnumerateTriangleFunc"}
]};
